require({cache:{
'epi-cms/layers/cms-widgets':function(){
﻿define([
    "dijit/form/ValidationTextBox",
    "epi-cms/_ContentContextMixin",
    "epi-cms/ApplicationSettings",
    "epi-cms/CMSModule",
    "epi-cms/component/ContextHistory",
    "epi-cms/component/GlobalToolbar",
    "epi-cms/component/MainNavigationComponent",
    "epi-cms/component/Media",
    "epi-cms/component/PageNavigationTree",
    "epi-cms/component/RecentlyChanged",
    "epi-cms/component/SharedBlocks",
    "epi-cms/component/SiteTree",
    "epi-cms/component/Tasks",
    "epi-cms/component/Trash",
    "epi-cms/component/Versions",
    "epi-cms/contentediting/_Renderer",
    "epi-cms/contentediting/ContentDetails",
    "epi-cms/contentediting/CreateContent",
    "epi-cms/contentediting/CreateLanguageBranch",
    "epi-cms/contentediting/DateTimeNowEditor",
    "epi-cms/contentediting/DialogEditorWrapper",
    "epi-cms/contentediting/EditActionPanel",
    "epi-cms/contentediting/EditingBase",
    "epi-cms/contentediting/editors/CheckBoxListEditor",
    "epi-cms/contentediting/editors/CollectionEditor",
    "epi-cms/contentediting/editors/ContentAreaEditor",
    "epi-cms/contentediting/editors/ItemCollectionEditor",
    "epi-cms/contentediting/editors/PreviewableDateTimeEditor",
    "epi-cms/contentediting/editors/PreviewableTextEditor",
    "epi-cms/contentediting/editors/SelectionEditor",
    "epi-cms/contentediting/editors/ShortcutEditor",
    "epi-cms/contentediting/editors/TinyMCEEditor",
    "epi-cms/contentediting/editors/TinyMCEInlineEditor",
    "epi-cms/contentediting/EditToolbar",
    "epi-cms/contentediting/FloatingEditorWrapper",
    "epi-cms/contentediting/FlyoutEditorWrapper",
    "epi-cms/contentediting/FormEditing",
    "epi-cms/contentediting/InlineEditorWrapper",
    "epi-cms/contentediting/NotificationBar",
    "epi-cms/contentediting/OnPageEditing",
    "epi-cms/contentediting/PageDataController",
    "epi-cms/contentediting/PropertyRenderer",
    "epi-cms/contentediting/PublishMenu",
    "epi-cms/contentediting/SettingsPanel",
    "epi-cms/contentediting/ValidationTextboxWithWarning",
    "epi-cms/contentediting/viewmodel/ContentDetailsViewModel",
    "epi-cms/conversion/PropertyContentAreaConverter",
    "epi-cms/conversion/PropertyDateConverter",
    "epi-cms/core/ContentReference",
    "epi-cms/layout/CreateContentGroupContainer",
    "epi-cms/layout/EditLayoutContainer",
    "epi-cms/legacy/LegacyDialogPopup",
    "epi-cms/legacy/LegacyFormEditor",
    "epi-cms/widget/_GridWidgetBase",
    "epi-cms/widget/CategorySelector",
    "epi-cms/widget/ContentSelector",
    "epi-cms/widget/HyperLinkSelector",
    "epi-cms/widget/NotificationStatusBar",
    "epi-cms/widget/NotificationStatusZone",
    "epi-cms/widget/overlay/Block",
    "epi-cms/widget/overlay/ContentArea",
    "epi-cms/widget/overlay/ItemCollection",
    "epi-cms/widget/overlay/overlayFactory",
    "epi-cms/widget/ReadOnlyDateTimeEditor",
    "epi-cms/widget/TooltipDialog",
    "epi-cms/widget/UrlContentSelector",
    "epi-cms/widget/UrlSelector",
    "epi-cms/widget/XFormEditor"
], 1);

},
'epi-cms/_ContentContextMixin':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",

    "dojo/Deferred",
    "dojo/when",

    "dijit/Destroyable",

// epi
    "epi/dependency",
    "epi/UriParser",

    "epi/shell/_ContextMixin",

    "epi-cms/core/ContentReference"
],

function (
// dojo
    declare,
    lang,
    aspect,

    Deferred,
    when,

    Destroyable,

// epi
    dependency,
    UriParser,

    _ContextMixin,

    ContentReference
) {

    // summary:
    //      Helps keeping up to date with the current context. Mixing this into a class gives access to current context and other useful features.
    // tags:
    //      abstract

    return declare([_ContextMixin, Destroyable], {

        ignoreVersionWhenComparingLinks: false,

        contentDataStore: null,

        _currentContentContext: null,

        postscript: function() {
            this.inherited(arguments);

            this.own(aspect.after(this.getContentDataStore(), "onItemChanged", lang.hitch(this, this.itemChanged)));
        },


        getContentDataStore: function() {
            // summary:
            //      Gets the content data store from store registry if it's not already cached

            if (!this.contentDataStore)
            {
                var registry = dependency.resolve("epi.storeregistry");
                this.contentDataStore = registry.get("epi.cms.contentdata");
            }
            return this.contentDataStore;
        },

        getCurrentContent: function () {
            // summary:
            //      Returns either the current content or a deferred which will resolve a content data as soon as it becomes available.
            // example:
            //      dojo.when(this.getCurrentContent(), function(content) {
            //          console.log("now we know we've got ", content); 
            //      });
            // tags:
            //      protected

            var deferred = new Deferred();

            when(this.getCurrentContext(), lang.hitch(this, function (ctx) {
                if (!this._isContentContext(ctx)) {
                    deferred.reject({ message: "Not a content data", context: ctx });
                    return;
                }

                when(this.getContentDataStore().get(ctx.id), function (contentData) {
                    deferred.resolve(contentData);
                });
            }));

            return deferred;
        },

        contextChanged: function (ctx, callerData) {
            this.inherited(arguments);

            if (!this._isContentContext(ctx)) {
                this._currentContentContext = null;
                return;
            }

            var forceChange = (callerData && callerData.forceContextChange ? callerData.forceContextChange : false);

            if (!forceChange && this._isSameAsCurrentContentContext(ctx)) {
                // already loaded
                return;
            }

            this._currentContentContext = ctx;

            this.contentContextChanged(ctx, callerData);
        },

        contextUpdated: function (ctx, callerData) {

            if (!this._isContentContext(ctx)) {
                this._currentContentContext = null;
                return;
            }

            this._currentContentContext = ctx;

            this.contentContextUpdated(ctx, callerData);
        },

        contentContextChanged: function (ctx, callerData) {
            // summary:
            //      Called when the currently loaded content changes. I.e. a new content data object is loaded into the preview area.
            // tags:
            //      protected
        },

        contentContextUpdated: function (ctx, callerData) {
            // summary:
            //      Called when the currently loaded content updated.
            // tags:
            //      protected
        },

        itemChanged: function (id, item) {
            // summary:
            //      Notification event when an item has been patched or reloaded.
            // object: id
            //      The id of the updated item.
            // object: item
            //      The updated item.
            // tags:
            //      public
        },

        _isContentContext: function (ctx) {
            // summary:
            //      Verifies that the context has content data
            // ctx: context
            //      The context to check
            // tags:
            //      protected

            return ctx && ctx.type === "epi.cms.contentdata";
        },

        _isSameAsCurrentContentContext: function (ctx) {
            // summary:
            //      Checks if the content context has Id and PreferredLanguage the same as the already loaded current content context.
            // ctx: Object
            //      The content context to compare with current content context.
            // tags:
            //      protected

            if (this._currentContentContext && ctx) {
                return this._currentContentContext.id === ctx.id
                        && (this._currentContentContext.languageContext && ctx.languageContext
                            && this._currentContentContext.languageContext.preferredLanguage === ctx.languageContext.preferredLanguage);
            } else {
                return false;
            }
        },

        _isSameAsCurrentContext: function (uri) {
            // summary:
            //      Checks if the URI is the same as the already loaded context.
            // object: uri
            //      The uri of the contect to compare with current.
            // tags:
            //      protected

            if (this._currentContext) {
                return this._compareUris(uri, this._currentContext.uri);
            } else {
                return false;
            }
        },

        _compareUris: function (obj1, obj2) {
            // summary:
            //      Checks if the URI:s are equal
            // object: obj1
            //      First object to compare.
            // object: obj2
            //      Second object to compare.
            // tags:
            //      protected

            var uri1 = new UriParser(obj1),
                uri2 = new UriParser(obj2);

            if (this.ignoreVersionWhenComparingLinks &&
                uri1.getType() === "epi.cms.contentdata" &&
                uri2.getType() === "epi.cms.contentdata" &&
                ContentReference.compareIgnoreVersion(uri1.getId(), uri2.getId())) {
                return true;
            } else if (obj1 === obj2) {
                return true;
            }

            return false;
        }

    });

});
},
'epi-cms/core/ContentReference':function(){
﻿define(["dojo/_base/declare", "epi/epi"], function (declare, epi) {

    var ContentReference = declare(null, {
        // summary:
        //    An object uniquely identifying a CMS content item.
        // 
        // example:
        //  Create a content reference from an object with properties
        //  |   var contentReference = new epi.cms.core.ContentReference({ id:3, workId:4, providerName: ""});
        //
        // example:
        //  Create a content reference from its serialized string representation
        //  |   var contentReference = new epi.cms.core.ContentReference("3__providerName");

        // id: [public] Integer
        //    The id number of an item
        id: 0,

        // workId: [public] Integer
        //    The version id of an item.
        workId: 0,

        // providerName: [public] String
        //    A string that identifies a if an external provider serves the item.
        providerName: null,

        // isSelfReference: [public] Boolean
        //    Denotes if the reference is a self reference
        isSelfReference: false,

        constructor: function (value) {
            // summary:
            //    Creates a new content reference instance from the provided value
            //
            // value: Object|String|epi.cms.core.ContentReference
            //     Can be either an object in the format   
            //
            //
            if (value) {
                this._parse(value);
            }
        },

        _parse: function (value) {
            // summary:
            //    Parses an object or a string describing a content reference int this object
            //
            // value: Object|String
            //    The value to parse as a content reference
            //
            // tags:
            //    public

            if (typeof value === "object") {
                // Assume it's an object serialized by the server or an instance of this class
                this.id = parseInt(value.ID || value.id || value.iD || value.Id, 10);
                this.workId = parseInt(value.WorkID || value.workId || 0, 10);
                this.providerName = value.ProviderName || value.providerName || null;
            }
            else if (typeof value === "string") {
                if (value === '-') {
                    this.isSelfReference = true;
                    this.id = 0;
                    this.workId = -1;
                }
                else {
                    this.isSelfReference = false;
                    var v = String();
                    v.split("_");
                    var segments = value.split("_");
                    this.id = parseInt(segments[0], 10);
                    this.workId = parseInt(segments[1], 10) || 0;
                    this.providerName = segments[2] || "";
                }
            }
            if (typeof value === "number") {
                this.id = value;
                this.workId = 0;
                this.providerName = "";
            }

            // validate data
            if (typeof this.id !== "number") {
                throw new Error("The id parameter of a content reference must be an integer");
            }

            if (typeof this.workId !== "number" && !this.isSelfReference) {
                throw new Error("The workId of a content reference must be an integer");
            }
        },

        toString: function () {
            // summary:
            //    Returns a serialized version of this content reference in the format id[_workId][_providerName]
            //
            // tags:
            //    public

            if (this.isSelfReference) {
                return '-';
            }

            var contentReference = String(this.id);
            if (this.workId !== 0) {
                contentReference += "_" + this.workId;
            }
            if (this.providerName) {
                contentReference += (this.workId === 0 ? "__" : "_") + this.providerName;
            }
            return contentReference;
        },

        createVersionUnspecificReference: function () {
            // summary:
            //    Creates a content link that ignores the work id
            //
            // tags:
            //    public

            return new ContentReference({ id: this.id, providerName: this.providerName });
        }
    });

    ContentReference.toContentReference = function (obj) {
        if (obj instanceof ContentReference) {
            return obj;
        } else if (typeof obj === "string" || typeof obj === "number") {
            return new ContentReference(obj);
        }

        return ContentReference.emptyContentReference;
    };

    ContentReference.compareIgnoreVersion = function (object1, object2) {

        var c1 = ContentReference.toContentReference(object1);
        var c2 = ContentReference.toContentReference(object2);

        var pub1 = c1.createVersionUnspecificReference();
        var pub2 = c2.createVersionUnspecificReference();

        return epi.areEqual(pub1, pub2);
    };

    ContentReference.emptyContentReference = new ContentReference({ id: -1, workId: -1 });

    return ContentReference;
});
},
'epi-cms/ApplicationSettings':function(){
﻿define("epi-cms/ApplicationSettings", [
],

function (
) {
    // module:
    //      epi-cms/ApplicationSettings
    // description:
    //      Application settings for CMS.
    // tags:
    //      public

    return {
    };
});
},
'epi-cms/CMSModule':function(){
﻿define("epi-cms/CMSModule", [
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
// epi
    "epi",
    "epi/_Module",
    "epi/dependency",
    "epi/routes",

    "epi/shell/conversion/ObjectConverterRegistry",
    "epi/shell/store/JsonRest",
    "epi/shell/store/Throttle",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/ViewSettings",

    "epi-cms/ApplicationSettings",
    "epi-cms/BackContextHistory",
    "epi-cms/ContextSynchronizer",

    "epi-cms/conversion/ContentLightUriConverter",
    "epi-cms/conversion/ContentReferenceConverter",
    "epi-cms/conversion/PropertyDateConverter",

    "epi-cms/core/ContentReference",

    "epi-cms/store/CustomQueryEngine",
    "epi-cms/store/PageVersionQueryEngine",

    "epi-cms/component/command/GlobalToolbarCommandProvider",

    "epi-cms/contentediting/EditorFactory",
    "epi-cms/contentediting/InUseNotificationManager",
    "epi-cms/contentediting/ViewSettingsManager",

    "epi-cms/contentediting/command/Editing",

    "epi-cms/contentediting/commandproviders/ContentDetails",
    "epi-cms/contentediting/commandproviders/PublishMenu",
    "epi-cms/contentediting/commandproviders/PublishMenuGlobal",

    "epi-cms/contentediting/viewsettings/ChannelViewSetting",
    "epi-cms/contentediting/viewsettings/ResolutionViewSetting",
    "epi-cms/contentediting/viewsettings/ViewLanguageViewSetting",
    "epi-cms/contentediting/viewsettings/VisitorGroupViewSetting",

    "epi-cms/Profile"
],

function (
// dojo
    array,
    declare,
    lang,
    when,
// epi
    epi,
    _Module,
    dependency,
    routes,

    ObjectConverterRegistry,
    JsonRest,
    Throttle,
    TypeDescriptorManager,
    ViewSettings,

    ApplicationSettings,
    BackContextHistory,
    ContextSynchronizer,

    ContentLightConverter,
    ContentReferenceConverter,
    PropertyDateConverter,

    ContentReference,

    CustomQueryEngine,
    PageVersionQueryEngine,

    GlobalToolbarCommandProvider,

    EditorFactory,
    InUseNotificationManager,
    ViewSettingsManager,

    Editing,

    ContentDetailsCommandProvider,
    PublishMenuCommandProvider,
    PublishMenuGlobalCommandProvider,

    ChannelViewSetting,
    ResolutionViewSetting,
    ViewLanguageViewSetting,
    VisitorGroupViewSetting,

    Profile
) {

    return declare([_Module], {

        _settings: null,

        // _hashWrapper: Object
        //    HashWrapper instance, which will be used to manipulate hash.
        _hashWrapper: null,

        _firstTimeHashUpdated: false,

        constructor: function (settings) {
            this._settings = settings;
        },

        initialize: function () {
            // summary:
            //		Initialize module
            //
            // description:

            this.inherited(arguments);

            declare.safeMixin(ApplicationSettings, this._settings);

            this.registerDependency("epi.cms.BackContextHistory", new BackContextHistory());
            this.registerDependency("epi.cms.ContextSynchronizer", new ContextSynchronizer(), undefined, function (value) { value.destroy(); });
            this.registerDependency("epi.cms.contentEditing.command.Editing", Editing);
            this._hashWrapper = dependency.resolve("epi.shell.HashWrapper");

            var commandregistry = dependency.resolve("epi.globalcommandregistry");
            var publishCommandProvider = new PublishMenuGlobalCommandProvider();

            commandregistry.registerProvider("epi.cms.publishmenu", publishCommandProvider);

            var contextService = this.resolveDependency("epi.shell.ContextService");

            this.registerDependency("epi.cms.contentRepositoryDescriptors", this._settings.contentRepositoryDescriptors);

            // register route for redirecting page.
            // Consider: the second param (callback) might be replace to an object, which has "redirect" function, so we can extend it.
            contextService.registerRoute("epi.cms.contentdata", lang.hitch(this, this._redirectContentDataContext));

            //initialize editor factory
            this._initializeEditorFactory();

            // Initialize stores
            this._initializeStores();

            this._setupConverters(dependency);
            this._setupViewSettings(contextService);

            //We need to wait for the viewsettings to initialized before creating the global toolbar command provider
            commandregistry.registerProvider("epi.cms.globalToolbar", new GlobalToolbarCommandProvider());

            this._setupInUseNotificationManager(commandregistry);

            var profile = dependency.resolve("epi.shell.Profile");

            var def = profile.getContentLanguage();
            when(def, function(language){
                //Set the current edit language on the profile object (this property has the same life-cycle as the application)
                //This property is used by the xhrwrapper
                ApplicationSettings.currentContentLanguage = profile.contentLanguage = language;
            });

            return def;
        },

        _redirectContentDataContext: function (context, callerData, uri) {
            // summary:
            //      Process redirect action for content data context.
            //
            // context: Object
            //      Context from context service
            //
            // callerData: Object
            //      Sources that fire the event
            //
            // uri: Object
            //      Content Uri
            //
            // tags:
            //      Private

            if (ViewSettings.viewName == "/episerver/dashboard") { // we are in Dashboard mode
                // in Dashboard mode, we need to redirect to the cms editorial view.
                var homeUrl = routes.getActionPath({ moduleArea: "CMS", controller: "Home", action: "" });
                // remove last '/', which is unnecessary.
                homeUrl = homeUrl.substring(0, homeUrl.length - 1);
                var editPage = homeUrl + "#" + this._hashWrapper.extractHash(context, callerData);
                this._redirect(editPage);
            } else {
                if (context.hasSiteChanged) {
                    //we need to reload ui when a content from a different site has been requested.
                    var urlToPageOnOtherSite = context.fullHomeUrl + "#" + this._hashWrapper.extractHash(context, callerData);
                    this._redirect(urlToPageOnOtherSite);
                } else {
                    // currently in Home mode, need to update Hash only, instead of redirecting
                    // Not update hash in case of internal trigger and hash has been updated
                    if (callerData && callerData.trigger == "internal" && this._firstTimeHashUpdated) {
                        return;
                    }
                    this._firstTimeHashUpdated = true;
                    this._hashWrapper.onContextChange(context, callerData);
                }
            }
        },

        _redirect: function (url) {
            // summary:
            //      Redirect to another page (url).
            //
            // url: String
            //      Page url to navigate to.
            //
            // tags:
            //      Private

            window.location = url;
        },

        _setupConverters: function (dependency) {

            var contentLightConverter = new ContentLightConverter(),
                contentReferenceConverter = new ContentReferenceConverter(),
                propertyDateConverter = new PropertyDateConverter(),
                repositoryDescriptors = this.resolveDependency("epi.cms.contentRepositoryDescriptors"),
                key;

            // Register converters for all linkable types known
            for (key in repositoryDescriptors) {
                var repo = repositoryDescriptors[key];
                if (repo.linkableTypes) {
                    repo.linkableTypes.forEach(function(type) {
                        ObjectConverterRegistry.registerConverter(type, type + ".link", contentLightConverter);
                        // Non specific type to link conversion
                        ObjectConverterRegistry.registerConverter(type, "link", contentLightConverter);
                    });
                }
            }

            for (key in TypeDescriptorManager._uiDescriptors) {
                //Currently we are registering converters for all types. Since uiDescriptors does not have to be content this might be a potential problem
                //but we ignore this until we need to fix this.
                var descriptor = TypeDescriptorManager._uiDescriptors[key];
                ObjectConverterRegistry.registerConverter(descriptor.typeIdentifier, descriptor.typeIdentifier + ".reference", contentReferenceConverter);
                ObjectConverterRegistry.registerConverter(descriptor.typeIdentifier, descriptor.typeIdentifier + ".light", contentLightConverter);
            }

            contentLightConverter.registerDefaultConverters(ObjectConverterRegistry);
            propertyDateConverter.registerDefaultConverters(ObjectConverterRegistry);
        },

        _setupViewSettings: function (contextService) {
            var languageSetting = new ViewLanguageViewSetting();
            languageSetting.initialize(contextService);

            var viewSettingsManager = new ViewSettingsManager({ viewSettings: [
                new ResolutionViewSetting(),
                new VisitorGroupViewSetting(),
                new ChannelViewSetting(),
                languageSetting
            ]
            });

            this.registerDependency("epi.viewsettingsmanager", viewSettingsManager);
        },

        _initializeStores: function () {

            var registry = this.resolveDependency("epi.storeregistry"),
                authority,
                light,
                version;
            
            // Create complete page data store. This is the authority store.
            authority = registry.create("epi.cms.contentdata", this._getRestPath("contentdata"), { idProperty: "contentLink" });

            // Create content structure store
            light = registry.create("epi.cms.content.light", this._getRestPath("contentstructure"), { idProperty: "contentLink", queryEngine: CustomQueryEngine });

            // Create page version store
            version = registry.create("epi.cms.contentversion", this._getRestPath("contentversion"), { idProperty: "contentLink", queryEngine: PageVersionQueryEngine });
            
            // Create display options store
            registry.create("epi.cms.displayoptions", this._getRestPath("displayoptions"));

            // Create category store
            registry.create("epi.cms.category", this._getRestPath("categories"));

            // Create page editing session store
            registry.create("epi.cms.inusenotification", this._getRestPath("inusenotification"))
                .addDependentStore(authority);

            // Create visitor group store
            registry.create("epi.cms.visitorgroup", this._getRestPath("visitorgroup"));

            // Create language store
            registry.create("epi.cms.language", this._getRestPath("language"), { idProperty: "languageId" });

            // Create a site structure store
            registry.create("epi.cms.sitestructure", this._getRestPath("sitestructure"), { idProperty: 'url' });

            // Create a display channel store.
            registry.create("epi.cms.displaychannels", this._getRestPath("channel"));

            // Create a content provider store.
            registry.create("epi.cms.wastebasket", this._getRestPath("wastebasket"));

            // Create a xform store
            registry.create("epi.cms.xform", this._getRestPath("xform"));

            // Create workflow task store
            registry.create("epi.cms.workflowtask", this._getRestPath("workflowtask"), { idProperty: "taskId" });

            // Create content type store, and fill it
            registry.create("epi.cms.contenttype", this._getRestPath("contenttype"), { preventCache: false }).query();

            // Create content references store
            registry.add("epi.cms.contentreferences",
                new Throttle(
                    new JsonRest({
                        target: this._getRestPath("contentreferences"),
                        idProperty: "contentLink"
                    })
                )
            );

            // Create non-cached content structure store
            registry.add("epi.cms.content.search",
                new Throttle(
                    new JsonRest({
                        target: this._getRestPath("contentstructure"),
                        idProperty: "contentLink"
                    })
                )
            );

            authority.addDependentStore(light, {
                refreshOnPatch: true,
                refresh: function (patchObject) {
                    // The lightweight page store should only get updates for the published page
                    var id = authority.getIdentity(patchObject);
                    var versionAgnosticId = new ContentReference(id).createVersionUnspecificReference().toString();
                    light.refresh(versionAgnosticId);
                }
            });

            authority.addDependentStore(version, {
                transformDelegate: function (patchObject) {

                    //TODO: This is temporary until we have implemented dependant store capabilities checks
                    if (patchObject.capabilities && !patchObject.capabilities.versionable) {
                        return null;
                    }
                    // remap properties from the pagedata store to match the page version store
                    // source name : target name
                    if (!patchObject.properties) {
                        return null;
                    }

                    var propMap = {
                        "pageChangedBy": "savedBy",
                        "pageSaved": "savedDate",
                        "pageLanguageBranch": "language",
                        "pageName": "name",
                        "name": "name",
                        "icontent_name": "name"
                    };
                    var transformed = lang.mixin({}, patchObject);
                    for (var p in propMap) {
                        if (p in transformed.properties) {
                            transformed[propMap[p]] = transformed.properties[p];
                        }
                    }
                    return transformed;
                }
            });
        },

        _getRestPath: function (name) {
            return routes.getRestPath({ moduleArea: "cms", storeName: name });
        },

        _initializeEditorFactory: function () {
            // summary:
            //		Initialize editor bridge factory
            //

            this.registerDependency("epi.cms.contentediting.EditorFactory", function () {

                var editorFactory = new EditorFactory();

                // Inline
                editorFactory.registerEditorWrapper('inline', 'epi-cms.contentediting.InlineEditorWrapper', function (wrapper, initParams) {
                });

                // Rich text inline editor wrapper
                editorFactory.registerEditorWrapper("richtextinline", "epi-cms.contentediting.RichTextInlineEditorWrapper", function (wrapper, initParams) {

                });

                // Flyout
                editorFactory.registerEditorWrapper('flyout', 'epi-cms.contentediting.FlyoutEditorWrapper', function (wrapper, initParams) {
                });

                // Floating editor wrapper
                editorFactory.registerEditorWrapper('floating', 'epi-cms.contentediting.FloatingEditorWrapper', function (wrapper, initParams) {
                });

                // Inline content editable
                editorFactory.registerEditorWrapper('contenteditable', 'epi-cms.contentediting.ContentEditableWrapper', function (wrapper, initParams) {
                });

                // Legacy
                editorFactory.registerEditorWrapper('legacyProperty', 'epi-cms.contentediting.DialogEditorWrapper', function (wrapper, initParams) {
                    // summary:
                    //
                    // wrapper:
                    //
                    // initParams:
                    //     { propertyName, propertyType, .... }

                    wrapper.closeOnChange = true;
                    wrapper.showButtons = false;
                });

                return editorFactory;
            });
        },

        _setupInUseNotificationManager: function (commandregistry) {
            var notificationManager = new InUseNotificationManager();
            this.registerDependency("epi.cms.contentediting.inUseNotificationManager", notificationManager);
            commandregistry.registerProvider("epi.cms.publishmenu", new PublishMenuCommandProvider());
            commandregistry.registerProvider("epi.cms.contentdetailsmenu", new ContentDetailsCommandProvider());
        }
    });
});
},
'epi-cms/BackContextHistory':function(){
﻿define("epi-cms/BackContextHistory", [
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/store/Memory",

    "epi/shell/ContextHistory"
],
function (
    declare,
    lang,

    Memory,

    ContextHistory
) {
    // summary:
    //      Context history for back only action
    // tags:
    //      public
    return declare([ContextHistory], {

        createStore: function () {
            // summary:
            //      Create new store
            // tags:
            //      override

            return new Memory({
                data: [],
                idProperty: "index"
            });
        },

        onContextChanged: function (response, callerData, request) {
            // summary:
            // tags:
            //      override

            if (callerData && callerData.trigger === "back") {
                this._removeLastItem();
                return;
            }

            this.inherited(arguments);
        },

        getPrevious: function () {
            // summary:
            //      Return previous content of currently loaded content.
            // tags:
            //      public

            var results = this.store.query({}, {
                count: 2, // Get current content and previous content
                sort: [{
                    attribute: "dateAdded",
                    descending: true
                }]
            });

            // Get previous content from sorted descending array.
            return (results && results.length > 1) ? results[1] : null;
        },

        _updateStore: function(response) {
            var lastItem = this._getLastItem();
            if (lastItem && lastItem.uri === response.versionAgnosticUri) {
                return;
            }

            this.inherited(arguments);
        },

        _getLastItem: function () {
            // summary:
            //     Returns the just previously added item from the store
            // tags:
            //      protected

            if (this.store && this.store.data && this.store.data.length > 0) {
                return this.store.data[this.store.data.length - 1];
            }

            return null;
        },

        _removeLastItem: function () {
            // summary:
            //     Removes the last added item from the store
            // tags:
            //      protected

            var lastItem = this._getLastItem();
            if (lastItem) {
                this.store.remove(this.store.getIdentity(lastItem));
            }
        }
    });
});
},
'epi-cms/ContextSynchronizer':function(){
﻿define("epi-cms/ContextSynchronizer", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "dojo/when",
    "epi/shell/_ContextMixin",
    "epi-cms/core/ContentReference"],
function (
    declare,
    lang,
    connect,
    when,
    _ContextMixin,
    ContentReference) {

    return declare([_ContextMixin], {
        // summary:
        //      A _ContextMixin that synchronizes content changes with the context

        _subscribeHandle: null,

        constructor: function () {
            this._subscribeHandle = connect.subscribe("/epi/cms/contentdata/updated", this, this._updateCurrentContext);
        },

        _updateCurrentContext: function (updatedContent) {
            //When the content is updated, also update the context.

            var contentLink = updatedContent.contentLink;

            //if it's the current context that has been changed, tell the context service to update the context
            when(this.getCurrentContext(), function (currentContext) {
                if (currentContext && ContentReference.compareIgnoreVersion(currentContext.id, contentLink)) {
                    var data = {
                        uri: "epi.cms.contentdata:///" + contentLink
                    };

                    //only append the epslanguage if the content supports languages
                    if (currentContext.languageContext) {
                        data.epslanguage = currentContext.languageContext.preferredLanguage;
                    }
                    connect.publish("/epi/shell/context/updateRequest", data);
                }
            });
        },

        destroy: function () {
            connect.unsubscribe(this._subscribeHandle);
        }

    });
});

},
'epi-cms/conversion/ContentLightUriConverter':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "epi/dependency",
    "epi/UriParser",
    "epi-cms/core/ContentReference",
    "epi-cms/core/PermanentLinkHelper"
], function (declare, lang, when, dependency, UriParser, ContentReference, PermanentLinkHelper) {

    return declare(null, {
        // summary:
        //    Converts data between light weight content types containing an URI as a specifyer and other types.
        //
        // tags:
        //    public

        _contentStore: null,

        constructor: function(params) {
            // summary:
            //    The constructor function
            //
            // params: Object
            //    The parameters that define the object.
            // tags:
            //    public

            lang.mixin(this, params);

            this._contentStore = this._contentStore || dependency.resolve("epi.storeregistry").get("epi.cms.content.light");
        },

        registerDefaultConverters: function(/*Object*/registry) {
            // summary:
            //    Registers the type conversions that this class supports to the given registry.
            //
            // registry: Object
            //    The converter registry to add mappings to.
        },

        convert: function(/*String*/sourceDataType, /*String*/targetDataType, /*Object*/data) {
            // summary:
            //    Converts data between two types.
            //
            // sourceDataType: String
            //    The source data type.
            //
            // targetDataType: String
            //    The target data type.
            //
            // data: Object
            //    The data to convert.
            // tags:
            //    public

            if (!data || (!data.contentLink && !data.uri)) {
                return null;
            }

            var contentLink = data.contentLink || new UriParser(data.uri).getId();

            if (!contentLink) {
                return null;
            }

            contentLink = new ContentReference(contentLink).createVersionUnspecificReference().toString();

            return when(this._contentStore.get(contentLink), function(content) {
                return {
                    url: content.publicUrl,
                    previewUrl: content.previewUrl,
                    permanentUrl: PermanentLinkHelper.toPermanentLink(content),
                    text: content.name,
                    typeIdentifier: content.typeIdentifier
                };
            });
        }
    });
});
},
'epi-cms/core/PermanentLinkHelper':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",

    "dojo/store/Memory",
    "dojo/when",

// epi
    "epi/dependency",
    "epi/Url",
    "epi-cms/ApplicationSettings",
    "epi-cms/core/ContentReference"
],

function (
// dojo
    declare,
    Deferred,
    lang,

    Memory,
    when,

// epi
    dependency,
    Url,
    ApplicationSettings,
    ContentReference
) {
    // summary:
    //      Upgrade permanent link from simple string to object
    // tags:
    //      public
    var PermanentLinkHelper = {

        // _cacheStore: dojo/store/Memory
        //      Store contents that already got before.
        _cacheStore: new Memory({ idAttribute: "id", data: [] }),

        _storeCache: function (/*Object*/content) {
            // summary:
            //      Store the content in to cache.
            // tags:
            //      private

            if (!content) {
                return;
            }

            // If already exist, return immediately
            var cachedObj = this._cacheStore.get(content.contentLink);
            if (cachedObj) {
                return;
            }

            // Store mapping (contentlink, internalLink) into cache
            this._cacheStore.put({
                id: content.contentLink,
                internalLink: this._toInternal(content)
            });
        },

        _tryGetContentLink: function(/*String*/link) {
            // summary:
            //      Try get content link from the link. Its maybe:
            //          + Uri with id in query ("/HeadAlloy/ProductPageTemplate.aspx?id=1")
            //          + ContentReference ("192_168")
            // tags:
            //      private

            if (!link) {
                return null;
            }

            // Try get id from query first
            var url = new Url(link),
                contentLink = url.query["id"];
            if (!contentLink) {
                try {
                    contentLink = ContentReference.toContentReference(link);
                    if (isNaN(contentLink.id)) {
                        return null;
                    }
                    return contentLink.toString();

                } catch (e) {
                    // Don't need to log the error
                    return null;
                }
            }

            return contentLink;
        },

        _toInternal: function (/*Object*/content) {
            // summary:
            //      Return a link with friendly URL (without id)
            // tags:
            //      private

            var permanentLink,
                applicationVirtualPath = ApplicationSettings.applicationVirtualPath || "";

            if (content) {
                permanentLink = applicationVirtualPath + "/link/" + content.contentGuid.replace(/-/g, "") + ".aspx";
                // In case we don't have application virtual path name, replace "//" to "/"
                // ex:
                //      before: "//link/{contentGuid}.aspx"
                //      after: "/link/{contentGuid}.aspx"
                permanentLink = permanentLink.replace(/\/\//g, "\/");
            }

            return permanentLink;
        },

        toPermanentLink : function (/*Object*/content, /*String*/mode) {
            // summary:
            //      Converts a content data object to it's permanent link form.
            // description:
            //      The link created will be in the format "/link/{contentGuid}.aspx". Since everything
            //      is now content all links can be resolved with the .aspx extension.
            // tags:
            //      public

            // try creat a mapping
            this._storeCache(content);

            // return value
            return this._toInternal(content);
        },

        isPermanentLink: function (/*String*/link) {
            // summary:
            //      Test whether given string is in permanent link format
            // tags:
            //      public

            // If the link contains "/link/" and follow with "<guid>.aspx" then true otherwise false
            return (/(\/link\/)(?=([0-9a-z]{32})(\.aspx))/i).test(link);
        },

        getContent: function (/*String*/link, /*Object*/options) {
            // summary:
            //      Get linked content data with the permanent link
            // tags:
            //      public

            if (!link) {
                return null;
            }

            var dfd = new Deferred(),
                registry = dependency.resolve("epi.storeregistry"),
                store = registry.get("epi.cms.content.light"),
                query = lang.mixin({
                    "query": "getcontentbypermanentlink",
                    "permanentLink": link
                }, options || {}),
                results;

            var cachedObjects = this._cacheStore.query({ internalLink: link }),
                isCached = cachedObjects && cachedObjects.length > 0,
                isPermanentLink = this.isPermanentLink(link),
                // Try get content link incase it's not valid permanentlink format.
                // Should remove this after release 7.5, because the link with id in query string is no longer suppored.
                contentLink = isPermanentLink ? null : this._tryGetContentLink(link);

            // Give a chance to get content from cache by get method which is to increase performance
            results = isCached || contentLink ? store.get(contentLink || cachedObjects[0].id) : store.query(query);
            when(results, lang.hitch(this, function (contents) {

                var content = contents && contents instanceof Array ? contents[0] : contents;
                if (!isCached) {
                    this._storeCache(content);
                }

                dfd.resolve(content);

            }));

            return dfd;
        }
    };

    return PermanentLinkHelper;
});
},
'epi-cms/conversion/ContentReferenceConverter':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "epi/dependency",
    "epi/UriParser",
    "epi-cms/core/ContentReference"
], function (declare, lang, when, dependency, UriParser, ContentReference) {

        return declare(null, {
            // summary:
            //    Converts data between default content containing an URI as a specifyer and a version unspecific content reference.
            //
            // tags:
            //    public

            convert: function(/*String*/sourceDataType, /*String*/targetDataType, /*Object*/data) {
                // summary:
                //    Converts data between two types.
                //
                // sourceDataType: String
                //    The source data type.
                //
                // targetDataType: String
                //    The target data type.
                //
                // converter: Object
                //    The class that performs the actual conversion.
                // tags:
                //    public
                if (!data) {
                    return null;
                }

                var uri = new UriParser(data.uri);
                var link = uri.getId();
                var versionAgnosticId = new ContentReference(link).createVersionUnspecificReference().toString();

                return versionAgnosticId;
            }
        });
    });
},
'epi-cms/conversion/PropertyDateConverter':function(){
﻿define([ 
    "dojo/_base/declare",
    "dojo/date/locale",
    "epi/datetime"
    ],
    function (declare, locale, datetime) {

        return declare(null, {
            // summary:
            //    Converts PropertyDate value to runtime Date accroding to epi/datetime rules
            //
            // tags:
            //    public

            sourceDataType: "epi.cms.propertydate",
            targetDataType: "runtimeType",

            registerDefaultConverters: function (/*Object*/registry) {
                // summary:
                //    Registers the type conversions that this class supports to the given registry.
                //
                // registry: Object
                //    The converter registry to add mappings to.
                registry.registerConverter(this.sourceDataType, this.targetDataType, this);
            },

            convert: function (/*String*/sourceDataType, /*String*/targetDataType, /*Object*/data) {
                // summary:
                //    Converts data between two types.
                //
                // sourceDataType: String
                //    The source data type.
                //
                // targetDataType: String
                //    The target data type.
                //
                // converter: Object
                //    The class that performs the actual conversion.
                // tags:
                //    public

                if (data && sourceDataType === this.sourceDataType && targetDataType === this.targetDataType) {
                    var value = datetime.deserialize(data);

                    // Make sure that the converted value are the same the value which is handled by DateTimeTextBox
                    var localeString = locale.format(value, {});
                    return locale.parse(localeString, {});
                }

                return null;
            }
        });
    }
);
},
'epi-cms/store/CustomQueryEngine':function(){
﻿define(["dojo/_base/array"], function (arrayUtil) {

    // module:
    //		epi-cms/store/CustomQueryEngine
    // summary:
    //		The module defines a filtering query engine that can be passed an array of ignore
    //		parameters enabling specific query parameters to be ignored when analyzing the query.

    return function (query, options) {
        // summary:
        //		Simple query engine that matches using filter functions, named filter
        //		functions or objects by name-value on a query object hash.

        // create our matching query function
        switch (typeof query) {
            case "object": case "undefined":
                var queryObject = query;
                query = function (object) {
                    for (var key in queryObject) {
                        if (options && options.ignore) {
                            var skipKey;
                            for (var ignoreKey in options.ignore) {
                                if (key == options.ignore[ignoreKey]) {
                                    skipKey = true;
                                    break;
                                }
                            }
                            if (skipKey) {
                                skipKey = false;
                                continue;
                            }
                        }
                        var required = queryObject[key];
                        // check if we have external property comparer to use it.
                        // For example: comparer for typeIdentifiers, which is array.
                        // Only return false if the comparer returns false, otherwise, let the loop continue. Do NOT return true
                        if (options && options.comparers && options.comparers[key]) {
                            if (!options.comparers[key](required, object)) {
                                return false;
                            }
                        } else if (required && required.test) {
                            if (!required.test(object[key])) {
                                return false;
                            }
                        } else if (required && required != object[key]) {
                            return false;
                        }
                    }
                    return true;
                };
                break;
            case "string":
                // named query
                if (!this[query]) {
                    throw new Error("No filter function " + query + " was found in store");
                }
                query = this[query];
                break;
            case "function":
                break;
            default:
                throw new Error("Can not query with a " + typeof query);
        }
        function execute(array) {
            // execute the whole query, first we filter
            var results = arrayUtil.filter(array, query);
            // next we sort
            if (options && options.sort) {
                results.sort(function (a, b) {
                    for (var sort, i = 0; sort = options.sort[i]; i++) {
                        var aValue = a[sort.attribute];
                        var bValue = b[sort.attribute];
                        
                        if (typeof aValue === "string" && typeof bValue === "string") {
                            aValue = aValue.toLowerCase();
                            bValue = bValue.toLowerCase();
                        }
                        
                        if (aValue != bValue) {
                            return sort.descending == (aValue > bValue) ? -1 : 1;
                        }
                    }
                    return 0;
                });
            }
            // now we paginate
            if (options && (options.start || options.count)) {
                var total = results.length;
                results = results.slice(options.start || 0, (options.start || 0) + (options.count || Infinity));
                results.total = total;
            }
            return results;
        }
        execute.matches = query;
        return execute;
    };
});

},
'epi-cms/store/PageVersionQueryEngine':function(){
﻿define(["dojo/_base/array", "epi-cms/core/ContentReference"], function (arrayUtil, ContentReference) {

    //  module:
    //		epi/cms/store/PageVersionQueryEngine

    return function (query, options) {

        // Create our matching query function
        switch (typeof query) {
            case "object": case "undefined":
                var queryObject = query;
                query = function (object) {
                    for (var key in queryObject) {
                        var reference,
                            required = queryObject[key],
                            original = required.toString();

                        if (original.indexOf("_") >= 0) {
                            reference = new ContentReference(original);
                            required = RegExp("^" + reference.id + "_.*$"); // NOTE: Test with XML page provider.
                        }

                        if (required && required.test) {
                            if (!required.test(object[key])) {
                                return false;
                            }
                        } else if (required != object[key]) {
                            return false;
                        }
                    }
                    return true;
                };
                break;
            case "string":
                // named query
                if (!this[query]) {
                    throw new Error("No filter function " + query + " was found in store");
                }
                query = this[query];
                break;
            case "function":
                break;
            default:
                throw new Error("Can not query with a " + typeof query);
        }
        function execute(array) {
            // execute the whole query, first we filter
            var results = arrayUtil.filter(array, query);
            // next we sort
            if (options && options.sort) {
                results.sort(function (a, b) {
                    for (var sort, i = 0; sort = options.sort[i]; i++) {
                        var aValue = a[sort.attribute];
                        var bValue = b[sort.attribute];
                        if (aValue != bValue) {
                            return sort.descending == (aValue > bValue) ? -1 : 1;
                        }
                    }
                    return 0;
                });
            }
            // now we paginate
            if (options && (options.start || options.count)) {
                var total = results.length;
                results = results.slice(options.start || 0, (options.start || 0) + (options.count || Infinity));
                results.total = total;
            }
            return results;
        }
        execute.matches = query;
        return execute;
    };
});
},
'epi-cms/component/command/GlobalToolbarCommandProvider':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",

    "dijit/form/ToggleButton",
    "dijit/layout/ContentPane",

    "epi/dependency",
    "epi/shell/ViewSettings",
    "epi/shell/command/_Command",
    "epi/shell/command/ToggleCommand",

    "epi/shell/ViewSettings",

    "epi/shell/widget/ExpandoButton",

    "epi-cms/widget/ViewSettingsExpandoButton",
    "epi-cms/widget/VisitorGroupButton",
    "epi-cms/widget/ChannelsButton",
    "epi-cms/widget/ViewLanguageButton",
    "epi-cms/widget/command/CreateContentFromSelector",

    "epi-cms/component/command/_GlobalToolbarCommandProvider",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting"

],

function (
    array,
    declare,
    Deferred,
    lang,
    topic,
    when,

    ToggleButton,
    ContentPane,

    dependency,
    viewSettings,
    _Command,
    ToggleCommand,

    ViewSettings,

    ExpandoButton,

    ViewSettingsExpandoButton,
    VisitorGroupButton,
    ChannelsButton,
    ViewLanguageButton,
    CreateContentFromSelector,

    _GlobalToolbarCommandProvider,

    resources
) {

    var _ToggleNavigationPaneCommand = declare([ToggleCommand], {
        iconClass: "epi-iconTree",
        tooltip: resources.toolbar.buttons.togglenavigationpane,
        label: resources.toolbar.buttons.togglenavigationpane,
        canExecute: true,
        constructor: function () {
            topic.subscribe("/epi/layout/pinnable/navigation/visibilitychanged", lang.hitch(this, function (visible) {
                this.set("active", visible);
            }));
        },
        _execute: function () {
            topic.publish("/epi/layout/pinnable/navigation/toggle");
        }

    });

    var _ToggleAssetsPaneCommand = declare([ToggleCommand], {
        iconClass: "epi-iconFolder",
        tooltip: resources.toolbar.buttons.toggleassetspane,
        label: resources.toolbar.buttons.toggleassetspane,
        canExecute: true,
        constructor: function () {
            topic.subscribe("/epi/layout/pinnable/tools/visibilitychanged", lang.hitch(this, function (visible) {
                this.set("active", visible);
            }));
        },
        _execute: function () {
            topic.publish("/epi/layout/pinnable/tools/toggle");
        }
    });

    var _ViewSettingCommand = declare([_Command], {
        iconClass: "epi-iconEye",
        canExecute: true,
        label: resources.toolbar.buttons.viewsetting.viewsettingbutton,

        constructor: function () {
            // Hide the button if the current view component is not "epi-cms/contentediting/PageDataController"
            // In other words, it will be hidden when creating new content or viewing Trash page
            topic.subscribe("/epi/shell/action/viewchanged", lang.hitch(this, function (view) {
                // NOTE: This needs to be revised when changing the view loading.
                this.set("isAvailable", typeof view != "string" || view == "epi-cms/contentediting/PageDataController");
            }));
        }
    });

    var _TogglePreviewModeCommand = declare([ToggleCommand], {
        iconClass: "epi-iconPreview",
        tooltip: resources.toolbar.buttons.togglepreviewmode.label,
        label: resources.toolbar.buttons.togglepreviewmode.label,
        canExecute: true,

        constructor: function () {
            this._profile = dependency.resolve("epi.shell.Profile");
            this._setPanelSettings();

            // Deactivate the option if we recieve a disable topic.
            topic.subscribe("/epi/cms/action/disablepreview", lang.hitch(this, function () {
                this.set("active", false);
                this._restoreSidePanels();
            }));

            // Hide the button if the current view component is not "epi-cms/contentediting/PageDataController"
            // In other words, it will be hidden when creating new content or viewing Trash page
            topic.subscribe("/epi/shell/action/viewchanged", lang.hitch(this, function (view) {
                // NOTE: This needs to be revised when changing the view loading.
                var enable = typeof view != "string" || view == "epi-cms/contentediting/PageDataController";
                if(!enable && this.active) {
                    this.execute();
                }
                this.set("isAvailable", enable);
            }));
        },

        _restoreSidePanels: function () {
            topic.publish("/epi/layout/pinnable/navigation/toggle", this.get("isNavigationVisible"));
            topic.publish("/epi/layout/pinnable/tools/toggle", this.get("isToolsVisible"));
        },

        _hideSidePanels: function(){
            this._setPanelSettings();
            topic.publish("/epi/layout/pinnable/navigation/toggle", false);
            topic.publish("/epi/layout/pinnable/tools/toggle", false);
        },

        _setPanelSettings: function(){
            when(this._profile.get("navigation"), lang.hitch(this, function(navigationSetting){
                this.set("isNavigationVisible", navigationSetting.visible);
            }));
            when(this._profile.get("tools"), lang.hitch(this, function(toolsSetting){
                this.set("isToolsVisible", toolsSetting.visible);
            }));
        },

        _execute: function () {
            this.set("active", !this.active);

            if (this.active) {
                this._hideSidePanels();
                topic.publish("/epi/shell/action/changeview", "view");
            } else {
                this._restoreSidePanels();
                topic.publish("/epi/shell/action/changeview/back", true);
            }
        }
    });

    // module:
    //      epi-cms/component/command/GlobalToolbarCommandProvider
    // summary:
    //      Default command provider for the epi-cms/component/GlobalToolbar
    // tags:
    //      private
    return declare([_GlobalToolbarCommandProvider], {

        contentRepositoryDescriptors: null,
        viewName: null,

        postscript: function () {
            // summary:
            //      Ensure that an array of commands has been initialized.
            // tags:
            //      public
            this.inherited(arguments);

            this.contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");
            this.viewName = this.viewName || viewSettings.viewName;
            this._addLeadingCommands();

            this._addCreateCommands();

            this._addViewCommands();

            this._addTrailingCommands();
        },

        _addLeadingCommands: function () {
            this.addToLeading(new _ToggleNavigationPaneCommand(), {
                widget: ToggleButton,
                "class": "epi-leadingToggleButton epi-mediumButton"
            });
        },

        _addCreateCommands: function () {

            var currentView = this.viewName;
            var descriptorsForCurrentView = [];
            var isCurrentView = function(view){
                return view == currentView;
            };

            for(var index in this.contentRepositoryDescriptors){
                var descriptor = this.contentRepositoryDescriptors[index];
                if (array.some(descriptor.mainViews, isCurrentView)){
                    descriptorsForCurrentView.push(descriptor);
                }
            }

            array.forEach(descriptorsForCurrentView, function(descriptor){
                array.forEach(descriptor.creatableTypes, function(type){
                    this.addCommand(this._createCommand(type), {category: "create"});
                },this);
            },this);
        },

        _createCommand: function(type){
            return new CreateContentFromSelector({
                creatingTypeIdentifier: type
            });
        },

        _addViewCommands: function () {
            // View settings expando button
            this.addCommand(new _ViewSettingCommand(), {
                widget: ViewSettingsExpandoButton,
                showInGroup: true,
                buttons: [new ViewLanguageButton(), new VisitorGroupButton(), new ChannelsButton()],
                category: "view"
            });

            // Preview expando button
            this.addCommand(new _TogglePreviewModeCommand(), {
                widget: ExpandoButton,
                showInGroup: true,
                hasToggleableChildren: false,
                buttons: [new ContentPane({
                    iconClass: "",
                    "class": "epi-expandoButtonActiveNode",
                    content: "<span>" + resources.toolbar.buttons.togglepreviewmode.message + "</span>"
                })],
                category: "view"
            });
        },

        _addTrailingCommands: function () {
            this.addToTrailing(new _ToggleAssetsPaneCommand(), {
                widget: ToggleButton,
                "class": "epi-trailingToggleButton epi-mediumButton"
            });
        }
    });
});

},
'epi/shell/command/ToggleCommand':function(){
﻿define("epi/shell/command/ToggleCommand", [
    "dojo/_base/declare",
    "epi/shell/command/_Command"
], function (declare, _Command) {

    // module:
    //		epi/shell/command/ToggleCommand
    // summary:
    //		A base class implementation for commands which toggles the value of a property on the model.

    return declare([_Command], {

        // property: [public] String
        //		The name of the property on the model which this command will toggle.
        property: null,

        // active: [readonly] Boolean
        //		Flag which indicates whether this command is active. Value is true if command is active; otherwise false.
        active: false,

        _execute: function () {
            // summary:
            //		Toggles the value of the given property on the model.
            // tags:
            //		protected

            var name = this.property,
                value = !this.active;

            this.model.set(name, value);
            this.set("active", value);
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var model = this.model,
                active = model && model[this.property],
                canExecute = typeof active == "boolean";

            this.set("canExecute", canExecute);
            this.set("active", canExecute && active);
        }
    });
});
},
'epi-cms/widget/ViewSettingsExpandoButton':function(){
﻿define([
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/_base/array",
        "dojo/dom-style",
        "dojo/topic",

        "epi/dependency",

        "epi/shell/widget/ExpandoButton"
],
function (
    declare,
    lang,
    array,
    domStyle,
    topic,

    dependency,

    ExpandoButton) {
    return declare([ExpandoButton], {
        _toggleStateInitialized: null,

        postCreate: function () {
            this.inherited(arguments);

            //We need to get the view settings manager to figure out if the button should be expanded
            var viewSettingsManager = dependency.resolve("epi.viewsettingsmanager");
            var setting = array.filter(viewSettingsManager.viewSettingsHashValue, function (item) {
                return item.type == "active";
            })[0];

            this.isExpand = setting ? setting.id === "true" : false;
            
            // Expand and calculate width of expando button
            array.forEach(this.containerNode.getChildren(), lang.hitch(this, function (child) {
                this.connect(child.childWidget, "onResize", "_onChildResize");
            }));
        },

        onChange: function (value) {
            if (this._toggleStateInitialized) {
                topic.publish("/epi/cms/action/eyetoggle", value);
                return;
            } 

            this._toggleStateInitialized = true;
        },

        _onChildResize: function () {
            // summary
            //      Calculate width of expando button
            // tags
            //      Private

            if (this.isExpanded()) {
                this._expand();
            }
        }
    });
});
},
'epi-cms/widget/VisitorGroupButton':function(){
﻿define([
// dojo
    "dojo",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "dojo/_base/Deferred",
    "dojo/dom-class",
// dijit
    "dijit/DropDownMenu",
    "dijit/form/DropDownButton",
    "dijit/focus",
// epi
    "epi",
    "epi/dependency",
    "epi-cms/widget/VisitorGroupsSelector",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.visitorgroupsbutton"],
function (
// dojo
    dojo,
    declare,
    lang,
    connect,
    Deferred,
    domClass,
// dijit
    DropDownMenu,
    DropDownButton,
    focusUtil,
// epi
    epi,
    dependency,
    VisitorGroupsSelector,
    resources) {
    return declare([DropDownButton], {

        // _contextMenu: [private] dijit.DropDownMenu
        //    The context menu for the button.
        _contextMenu: null,

        // baseClass: [public] String
        //    CSS base classes for the button.
        baseClass: "epi-mediumButton epi-chromelessButton",

        // iconClass: [public] String
        //    CSS class that adds the button icon.
        iconClass: "epi-iconUsers",

        // contextMenuProperties [public] Object
        //    Context menu properties.
        contextMenuProperties: {},

        // _visitorGroupsSelector: [private] Object
        //    The visitor groups selector widget.
        _visitorGroupsSelector: null,

        // _viewSettingsManager: [private] Object
        //    The view manager
        _viewSettingsManager: null,

        postMixInProperties: function () {
            // summary:
            //    Mixin the widget properties.
            //
            // tags:
            //    protected
            this.inherited(arguments);

            lang.mixin(this.contextMenuProperties, {
                "class": "epi-DropDownMenu"
            });
        },

        postCreate: function () {
            // summary:
            //    Raised after the widget is created. It will create
            //    the widget's context menu and add its children.
            //
            // tags:
            //    protected
            this.inherited(arguments);

            this._viewSettingsManager = dependency.resolve("epi.viewsettingsmanager");
            var viewSettingVisitorGroup = this._viewSettingsManager.getSettingProperty("visitorgroup");

            if (!this.dropDown) {

                this.dropDown = dijit.DropDownMenu(this.contextMenuProperties);

                this._visitorGroupsSelector = new VisitorGroupsSelector({ checkedItem: viewSettingVisitorGroup });
                connect.connect(this._visitorGroupsSelector, "onItemSelected", this, this._onVisitorGroupSelected);

                this._addChildren(this._visitorGroupsSelector);

                Deferred.when(this._visitorGroupsSelector.isSetupFinished(), lang.hitch(this, function (result) {
                    this._activeButton(!this._isDefaultSelection());
                    this._updateTooltip();
                }));
            }

            connect.connect(this.dropDown, "onOpen", this, function (e) {
                focusUtil.focus(this._visitorGroupsSelector.menuNode.domNode);
            });
        },

        _updateTooltip: function () {

            var tooltiptext = null;

            if (this._isDefaultSelection()) {
              tooltiptext = resources.defaulttooltip;
            }
            else {
                var selectedItem = this._visitorGroupsSelector.currentSelectedItem;
                tooltiptext = lang.replace(resources.tooltip, { visitorgroup: selectedItem.name });
            }
            this.set("title", tooltiptext);
        },

        _isDefaultSelection: function () {
            // summary:
            //    Checks if the selected items on both widgets are the default items.
            //
            // tags:
            //    private
            return this._visitorGroupsSelector.isDefaultItemSelected();
        },

        _onVisitorGroupSelected: function (/*Object*/visitorGroup) {
            // summary:
            //    Raised when a visitor group is selected.
            //
            // visitorGroup:
            //   The selected visitor group
            //
            // tags:
            //    private event
            this._changeView(visitorGroup);
        },

        _changeView: function (/*Object*/visitorGroup) {
            // summary:
            //    Change the view to the given resolution.
            //
            // visitorGroup:
            //    Visitor group object
            //
            // tags:
            //    private
            if (visitorGroup) {
                if (visitorGroup.name == this._visitorGroupsSelector.defaultItem.name) {
                    connect.publish("/epi/cms/action/viewsettingvaluechanged", ["visitorgroup", null]);
                } else {
                    connect.publish("/epi/cms/action/viewsettingvaluechanged", ["visitorgroup", visitorGroup.id]);
                }
            }
            this._activeButton(!this._isDefaultSelection());
            this._updateTooltip();
        },

        _addChildren: function (/*Object*/item) {
            // summary:
            //    Populate the context menu with the configured items.
            //
            // item:
            //    The item that will be added to the dropdown
            //
            // tags:
            //    private
            this.dropDown.addChild(item);
        },

        _activeButton: function (/*Boolean*/active) {
            // summary:
            //      Set active state for button widget
            //
            // active:
            //    States if the button will be checked or not.
            //
            // tags:
            //      private
            if (!this.dropDown) { return; }
            if (active) {
                domClass.add(this.domNode, "dijitChecked");
            } else {
                domClass.remove(this.domNode, "dijitChecked");
            }
        }
    });

});
},
'epi-cms/widget/VisitorGroupsSelector':function(){
﻿define([
// dojo
    "dojo",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/Deferred",
// epi
    "epi",
    "epi/dependency",
    "epi-cms/widget/_ItemSelectorBase",
    "epi-cms/widget/_DropDownWidgetItemMixin",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.visitorgroupselector"],
function (
// dojo
    dojo,
    lang,
    array,
    Deferred,
// epi
    epi,
    dependency,
    _ItemSelectorBase,
    _DropDownWidgetItemMixin,
// resources
    res) {
    return dojo.declare([_ItemSelectorBase, _DropDownWidgetItemMixin], {

        // defaultItem: [public] Object
        //    The widget's default item to be added to the menu.
        defaultItem: {
            id: -1,
            name: res.defaultitem
        },

        // _visitorGroupsHash: [private] Object
        //    Map the group GUID with its name
        _visitorGroupsHash: {},

        // _isFinished: [private] dojo.Deferred
        //    Deferred to indicate when widget finished its setup process.
        _isFinished: null,

        postMixInProperties: function () {
            // summary:
            //    Sets up the data store
            //
            // tags:
            //    protected
            this.inherited(arguments);
            var registry = dependency.resolve("epi.storeregistry");
            this._store = registry.get("epi.cms.visitorgroup");
        },

        postCreate: function () {
            // summary:
            //    Raised after the widget creating, sets the header and
            //    load the items to be added to the menu.
            //
            // tags:
            //    protected
            this._isFinished = new Deferred();
            this.inherited(arguments);
            this.set("header", res.header);
            dojo.when(this._store.query(), lang.hitch(this, function (visitorGroups) {
                this._createHashMap(visitorGroups);
                this.checkedItem = (this.checkedItem ? this._visitorGroupsHash[this.checkedItem] : this.defaultItem.name);
                visitorGroups.unshift(this.defaultItem);
                this.set("items", visitorGroups);
                this._isFinished.resolve({ status: true });
            }));
        },

        isSetupFinished: function () {
            // summary:
            //    Return a deferred indicating when the widget finished
            //    its setup process.
            //
            // tags:
            //    public
            return this._isFinished;
        },

        _createHashMap: function (items) {
            // summary:
            //    Creates a map with the visitor group GUID and its name
            array.forEach(items, lang.hitch(this, function (item) {
                this._visitorGroupsHash[item.id] = item.name;
            }));
        }
    });
});
},
'epi-cms/widget/_ItemSelectorBase':function(){
﻿define([
// dojo
    "dojo",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/Deferred",
// dojox
    "dojox/html/entities",
// dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/Menu",
// epi
    "epi",
    "epi/dependency",
     "epi/shell/widget/RadioMenuItem",
// template
    "dojo/text!./templates/_ItemSelector.html"],
function (
// dojo
    dojo,
    lang,
    array,
    Deferred,
// dojox
    htmlEntities,
// dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
     Menu,
// epi
    epi,
    dependency,
    RadioMenuItem,
// template
    template) {
    return dojo.declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin], {

        // templateString: [protected] String
        //    The widget template.
        templateString: template,

        // templateString: [protected] String
        //    The widget template.
        baseClass: "epi-invertedTooltip",

        // _store: [private] Object
        //    The widget data store.
        _store: null,

        // currentSelectedItem: [public] Object
        //    The current selected item.
        currentSelectedItem: null,

        // checkedItem: [public] String
        //    The name of the item that should be checked.
        checkedItem: null,

        // defaultItem: [protected] String
        //    The default item on the menu.
        defaultItem: null,

        // _items: [private] Array
        //    Items to be added on the menu.
        _items: [],

        isDefaultItemSelected: function () {
            // summary:
            //    Verify is the current selected item is the default item.
            //
            // tags:
            //    public
            return (this.currentSelectedItem && this.defaultItem && this.currentSelectedItem.name == this.defaultItem.name);
        },

        postCreate: function () {
            this.inherited(arguments);
            dojo.connect(this.menuNode, "onItemHover", this, function (item) {
                this.menuNode.focusChild(item);
            });
        },

        checkItem: function (/*Object*/item) {
            // summary:
            //    Mark a specific item as checked.
            //
            // item:
            //    The item to be selected. If not specified
            //    all the radio buttons will be unchecked.
            //
            // tags:
            //    public
            array.forEach(this.menuNode.getChildren(), lang.hitch(this, function (child) {
                child.set('checked', false);
                var itemvalue = child.value;
                if (item != null && itemvalue.name == item.name) {
                    child.set('checked', true);
                    this.currentSelectedItem = child.value;
                }
            }));
        },

        _setupUI: function () {
            // summary:
            //    Setup the UI loading the items on the menu.
            //
            // tags:
            //    private

            // Remove all child before addnew
            array.forEach(this.menuNode.getChildren(), lang.hitch(this, function (child) {
                this.menuNode.removeChild(child);
            }));

            var items = this.get("items");
            array.forEach(items, lang.hitch(this, function (item) {
                this.menuNode.addChild(this._createMenuItem(item));
            }));
        },

        _onItemSelected: function (item) {
            // summary:
            //   Raised when a item is selected, it will fire the view setting change.
            //
            // tags:
            //    event
            this.currentSelectedItem = item.value;
            this.onItemSelected(item.value);
        },

        onItemSelected: function (item) {
            // summary:
            //   Raised when a item is selected, it will fire the view setting change.
            //
            // tags:
            //    event
        },

        _createMenuItem: function (/*Object*/item) {
            // summary:
            //    Create a RadioMenuItem
            //
            // item:
            //    The item to create the radio button from.
            //
            // tags:
            //    private
            var menuItem = new RadioMenuItem({
                checked: (item.name == this.checkedItem),
                label: htmlEntities.encode(item.name),
                value: item,
                onClick: lang.hitch(this, function () {
                    this._onItemSelected(menuItem);
                })
            });

            if (menuItem.checked) {
                this.currentSelectedItem = menuItem.value;
            }

            return menuItem;
        },

        _setItemsAttr: function (/*Array*/value) {
            // summary:
            //    Sets the _item property
            //
            // value:
            //    The value to be set to the property.
            this._set("_items", value);
            this._setupUI();
        },

        _getItemsAttr: function () {
            // summary:
            //    Gets the _item property
            return this.get("_items");
        },

        // summary:
        //    Setter for the widget's header.
        _setHeaderAttr: { node: "header", type: "innerHTML" }

    });

});
},
'epi/shell/widget/RadioMenuItem':function(){
require({cache:{
'url:epi/shell/widget/templates/RadioMenuItem.htm':"﻿<tr class=\"dijitReset dijitMenuItem\" data-dojo-attach-point=\"focusNode\" role=\"menuitemradio\" tabIndex=\"-1\">\n\t<td class=\"dijitReset dijitMenuItemIconCell\" role=\"presentation\">\n\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitMenuItemIcon dijitCheckedMenuItemIcon\" data-dojo-attach-point=\"iconNode\"/>\n\t\t<span class=\"dijitCheckedMenuItemIconChar\">&#10003;</span>\n\t</td>\n\t<td class=\"dijitReset dijitMenuItemLabel\" colspan=\"2\"><span class=\"dijitInline dijitReset dijitIcon\" data-dojo-attach-point=\"labelIconNode\"></span> <span data-dojo-attach-point=\"containerNode, labelNode\"></span></td>\n\t<td class=\"dijitReset dijitMenuItemAccelKey\" style=\"display: none\" data-dojo-attach-point=\"accelKeyNode\"></td>\n\t<td class=\"dijitReset dijitMenuArrowCell\" role=\"presentation\">&#160;</td>\n</tr>"}});
﻿define("epi/shell/widget/RadioMenuItem", [
"dojo/_base/declare",
"dojo/_base/array",
"dojo/dom-class",
"dijit/CheckedMenuItem",
"dojo/text!./templates/RadioMenuItem.htm"], 
function (declare, array, domClass, CheckedMenuItem, template) {
    return declare([CheckedMenuItem], {
        // summary:
        //		Override CheckedMenuItem type to RadioButton type.
        // tags:
        //		Public
        
        // baseClass: [protected] String
        //    The root className to be placed on this widget's domNode.
        baseClass: "dijitMenuItem epi-radioMenuItem",
        iconClass: null,

        templateString: template,

        _onClick: function (/*Event*/e) {
            // summary:
            //		Clicking this item, clear all state, toggles its state
            // tags:
            //		private

            this._resetState();
            this.inherited(arguments);
        },

        _resetState: function () {
            // summary:
            //		Clicking this item, clear all state, toggles its state
            // tags:
            //		private

            // reset children state to false

            array.forEach(this._getChildren(), function (child, index) {
                child.set("checked", false);
            });
        },

        _getChildren: function () {
            // summary:
            //		Get all menu items.
            // tags:
            //		private

            return this.getParent().getChildren();
        },

        _setIconClassAttr: function (iconClass) {
            this._set("iconClass", iconClass);
            domClass.add(this.labelIconNode, iconClass);
        }
    });
});
},
'url:epi/shell/widget/templates/RadioMenuItem.htm':"﻿<tr class=\"dijitReset dijitMenuItem\" data-dojo-attach-point=\"focusNode\" role=\"menuitemradio\" tabIndex=\"-1\">\n\t<td class=\"dijitReset dijitMenuItemIconCell\" role=\"presentation\">\n\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitMenuItemIcon dijitCheckedMenuItemIcon\" data-dojo-attach-point=\"iconNode\"/>\n\t\t<span class=\"dijitCheckedMenuItemIconChar\">&#10003;</span>\n\t</td>\n\t<td class=\"dijitReset dijitMenuItemLabel\" colspan=\"2\"><span class=\"dijitInline dijitReset dijitIcon\" data-dojo-attach-point=\"labelIconNode\"></span> <span data-dojo-attach-point=\"containerNode, labelNode\"></span></td>\n\t<td class=\"dijitReset dijitMenuItemAccelKey\" style=\"display: none\" data-dojo-attach-point=\"accelKeyNode\"></td>\n\t<td class=\"dijitReset dijitMenuArrowCell\" role=\"presentation\">&#160;</td>\n</tr>",
'url:epi-cms/widget/templates/_ItemSelector.html':"﻿<div>\r\n    <div class=\"epi-tooltipDialogTop\">\r\n        <span data-dojo-attach-point=\"header\"></span>\r\n        <div data-dojo-attach-point=\"lastPublishedIcon\" class=\"dijitTooltipConnector\"></div>\r\n    </div>\r\n    <div class=\"epi-dropdownMenuContainer\">\r\n        <div data-dojo-type=\"dijit/Menu\" data-dojo-attach-point=\"menuNode\" contextMenuForWindow=\"false\" class=\"epi-DropDownMenu\"></div>\r\n    </div>\r\n</div>",
'epi-cms/widget/_DropDownWidgetItemMixin':function(){
﻿define([
//"epi",
//"dojo",
"dojo/dom-construct"],
//"dijit"],
function (DomConstruct) {
    return dojo.declare(null, {
        // summary:
        //    Mixin for a dropdown item.
        //
        // description:
        //    Used to wrap an widget into a <tr><th></tr></th> so it can be added
        //    to a dropdown button.
        //
        // tags:
        //    public
        buildRendering: function () {
            this.inherited(arguments);
            this.domNode = this._wrapItem(this);
        },

        _wrapItem: function (/*Object*/item) {
            // summary:
            //    Returns the widget domNode wrapped into a <tr><td> elements.
            //
            // item:
            //    The widget to be wrapped.
            //
            // tags:
            //    private
            var tr = DomConstruct.create("tr");
            var td = DomConstruct.create("th", null, tr);
            item.placeAt(td, "first");
            return tr;
        }

    });
});
},
'epi-cms/widget/ChannelsButton':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/Deferred",
    "dojo/dom-class",
// dijit
    "dijit/DropDownMenu",
    "dijit/form/DropDownButton",
    "dijit/focus",
// epi
    "epi",
    "epi/dependency",
    "epi-cms/widget/ChannelSelector",
    "epi-cms/widget/ResolutionSelector",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.channelbutton"],
function (
// dojo
    declare,
    lang,
    array,
    connect,
    Deferred,
    domClass,
// dijit
    DropDownMenu,
    DropDownButton,
    focusUtil,
// epi
    epi,
    dependency,
    ChannelSelector,
    ResolutionSelector,
    resources) {
    return declare([DropDownButton], {

        // _contextMenu: [private] dijit.DropDownMenu
        //    The context menu for the button.
        _contextMenu: null,

        // baseClass: [public] String
        //    CSS base classes for the button.
        baseClass: "epi-mediumButton epi-chromelessButton",

        // iconClass: [public] String
        //    CSS class that adds the button icon.
        iconClass: "epi-iconDevice",

        // contextMenuProperties [public] Object
        //    Context menu properties.
        contextMenuProperties: {},

        // _channelSelector: [private] Object
        //    the channel selector widget.
        _channelSelector: null,

        // _resolutionSelector: [private] Object
        //    the resolution selector widget.
        _resolutionSelector: null,

        // _viewSettingsManager: [private] Object
        //    The view manager
        _viewSettingsManager: null,

        postMixInProperties: function () {
            // summary:
            //    Mixin the widget properties.
            //
            // tags:
            //    protected
            this.inherited(arguments);

            lang.mixin(this.contextMenuProperties, {
                "class": "epi-DropDownMenu"
            });
        },

        postCreate: function () {
            // summary:
            //    Raised after the widget is created. It will create
            //    the widget's context menu and add its children.
            //
            // tags:
            //    protected
            this.inherited(arguments);

            this._viewSettingsManager = dependency.resolve("epi.viewsettingsmanager");

            var viewSettingResolution = this._viewSettingsManager.getSettingProperty("resolution");
            var viewSettingChannel = this._viewSettingsManager.getSettingProperty("epichannel");

            if (!this.dropDown) {

                this.dropDown = dijit.DropDownMenu(this.contextMenuProperties);

                this._channelSelector = new ChannelSelector({ checkedItem: viewSettingChannel });
                connect.connect(this._channelSelector, "onItemSelected", this, this._onChannelSelected);

                this._resolutionSelector = new ResolutionSelector({ checkedItem: viewSettingResolution });
                connect.connect(this._resolutionSelector, "onItemSelected", this, this._onResolutionSelected);

                this._addChildren(this._channelSelector);
                this._addChildren(this._resolutionSelector);

                Deferred.when(this._channelSelector.isSetupFinished(), lang.hitch(this, function (result) {
                    this._activeButton(!this._isDefaultSelection());
                    this._updateTooltip();

                    this._setupKeyboardNav();
                }));
            }
        },

        _setupKeyboardNav: function () {
            /// summary: Setup to support keyboard navigation to select chanel

            // put menu items into an array to proccess
            var focusItems = [];
            array.forEach([this._channelSelector, this._resolutionSelector], function (menu) {
                focusItems = focusItems.concat(
                    array.map(menu.menuNode.getChildren(), function (item) {
                        return {
                            menuItem: item,
                            menu: menu.menuNode
                        };
                    })
                );
            });

            // handler for focusNext, focusPrev action
            var focusItemIndex = 0;
            var focusHandler = lang.hitch(this, function (action) {
                focusItemIndex += action === "next" ? 1 : -1;
                focusItemIndex = focusItemIndex >= focusItems.length ? 0 : focusItemIndex;
                focusItemIndex = focusItemIndex < 0 ? focusItems.length - 1 : focusItemIndex;

                var focusItem = focusItems[focusItemIndex];
                focusItem.menu.focusChild(focusItem.menuItem);
            });
            var focusNextHandler = function () { focusHandler("next"); };
            var focusPrevHandler = function () { focusHandler("prev"); };

            // Connects
            connect.connect(this.dropDown, "onOpen", this, function (e) {
                focusUtil.focus(this._channelSelector.menuNode.domNode);
            });
            this._channelSelector.menuNode.focusNext = this._resolutionSelector.menuNode.focusNext = focusNextHandler;
            this._channelSelector.menuNode.focusPrev = this._resolutionSelector.menuNode.focusPrev = focusPrevHandler;
        },


        _updateTooltip: function () {

            var tooltiptext = null;

            if (this._isDefaultSelection()) {
                tooltiptext = resources.defaulttooltip;
            }
            else {
                var selectedChannel = this._channelSelector.currentSelectedItem;
                var selectedResolution = this._resolutionSelector.currentSelectedItem;
                tooltiptext = lang.replace(resources.tooltip, {
                    channel: selectedChannel.name,
                    resolution: selectedResolution.name
                });
            }
            this.set("title", tooltiptext);
        },

        _isDefaultSelection: function () {
            // summary:
            //    Checks if the selected items on both widgets are the default items.
            //
            // tags:
            //    private
            return (this._channelSelector.isDefaultItemSelected() && this._resolutionSelector.isDefaultItemSelected());
        },

        _onChannelSelected: function (/*Object*/channel) {
            // summary:
            //    Raised when a channel is selected.
            //
            // channel:
            //   The selected channel
            //
            // tags:
            //    private event
            var defaultResolution = this._resolutionSelector.getDefaultResolution(channel);

            // if the current resolution is diferent from the channel's default resolution
            // update the resolution selector widget.
            if (!this._resolutionSelector.currentSelectedItem ||
               (this._resolutionSelector.currentSelectedItem && this._resolutionSelector.currentSelectedItem.name != defaultResolution.name)) {
                this._resolutionSelector.checkItem(defaultResolution);
            }

            this._changeView(defaultResolution, channel);

        },

        _onResolutionSelected: function (/*Object*/resolution) {
            // summary:
            //    Raised when a resolution is selected.
            //
            // resolution:
            //   The selected resolution
            //
            // tags:
            //    private event
            this._changeView(resolution);

        },

        _changeView: function (/*Object*/resolution, /*Object*/channel) {
            // summary:
            //    Change the view to the given resolution.
            //
            // resolution:
            //    Resolution information
            //
            // channel:
            //    Channel information.
            //
            // tags:
            //    private

            var messageData = [],
                value;

            if (resolution) {
                value = resolution.name === this._resolutionSelector.defaultItem.name ?
                    null :
                    resolution.width + "x" + resolution.height;

                messageData.push({ key: "resolution", value: value });
            }

            if (channel) {
                value = channel.name === this._channelSelector.defaultItem.name ?
                    null :
                    channel.channelName;

                messageData.push({ key: "epichannel", value: value });
            }

            if (messageData.length) {
                connect.publish("/epi/cms/action/viewsettingvaluechanged", [messageData]);
            }


            this._activeButton(!this._isDefaultSelection());
            this._updateTooltip();
        },

        _addChildren: function (/*Object*/item) {
            // summary:
            //    Populate the context menu with the configured items.
            //
            // item:
            //    The item that will be added to the dropdown
            //
            // tags:
            //    private
            this.dropDown.addChild(item);
        },

        _activeButton: function (/*Boolean*/active) {
            // summary:
            //      Set active state for button widget
            //
            // active:
            //    States if the button will be checked or not.
            //
            // tags:
            //      private
            if (!this.dropDown) { return; }
            if (active) {
                domClass.add(this.domNode, "dijitChecked");
            } else {
                domClass.remove(this.domNode, "dijitChecked");
            }
        }
    });

});
},
'epi-cms/widget/ChannelSelector':function(){
﻿define([
// dojo
    "dojo",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/Deferred",
// epi
    "epi",
    "epi/dependency",
    "epi-cms/widget/_ItemSelectorBase",
    "epi-cms/widget/_DropDownWidgetItemMixin",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.channelselector"],
function (
// dojo
    dojo,
    lang,
    array,
    Deferred,
// epi
    epi,
    dependency,
    _ItemSelectorBase,
    _DropDownWidgetItemMixin,
// resources
    res) {
    return dojo.declare([_ItemSelectorBase, _DropDownWidgetItemMixin], {

        // defaultItem: [public] Object
        //    The widget's default item to be added to the menu.
        defaultItem: {
            name: res.defaultitem,
            resolutionName: res.defaultitem
        },

        // _isFinished: [private] dojo.Deferred
        //    Deferred to indicate when widget finished its setup process.
        _isFinished: null,

        // _channelHashMap: [private] Object
        //     Map the channel display name (localized) and its name.
        _channelHashMap: {},

        postMixInProperties: function () {
            // summary:
            //    Sets up the data store
            //
            // tags:
            //    protected
            this.inherited(arguments);
            var registry = dependency.resolve("epi.storeregistry");
            this._store = registry.get("epi.cms.displaychannels");
        },

        postCreate: function () {
            // summary:
            //    Raised after the widget creating, sets the header and
            //    load the items to be added to the menu.
            //
            // tags:
            //    protected
            this._isFinished = new Deferred();
            this.inherited(arguments);
            this.set("header", res.header);
            dojo.when(this._store.query({ query: "getallregistered" }), lang.hitch(this, function (registeredChannels) {
                this._createHashMap(registeredChannels);
                this.checkedItem = (this.checkedItem ? this._channelHashMap[this.checkedItem] : this.defaultItem.name);
                registeredChannels.unshift(this.defaultItem);
                this.set("items", registeredChannels);
                this._isFinished.resolve({ status: true });
            }));
        },

        isSetupFinished: function () {
            // summary:
            //    Return a deferred indicating when the widget finished
            //    its setup process.
            //
            // tags:
            //    public
            return this._isFinished;
        },

        _createHashMap: function (items) {
            // summary:
            //    Creates a map with the channel display name and its name.
            array.forEach(items, lang.hitch(this, function (item) {
                this._channelHashMap[item.channelName] = item.name;
            }));
        }
    });
});
},
'epi-cms/widget/ResolutionSelector':function(){
﻿define([
// dojo
    "dojo",
    "dojo/_base/lang",
    "dojo/_base/array",
// epi
    "epi",
    "epi/dependency",

    "epi-cms/ApplicationSettings",
    "epi-cms/widget/_ItemSelectorBase",
    "epi-cms/widget/_DropDownWidgetItemMixin",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.resolutionselector"],
function (
// dojo
    dojo,
    lang,
    array,
// epi
    epi,
    dependency,

    ApplicationSettings,
    _ItemSelectorBase,
    _DropDownWidgetItemMixin,
//template
    res) {
    return dojo.declare([_ItemSelectorBase, _DropDownWidgetItemMixin], {

        // _resolutionHash: [private] Object
        //    Map the URL resolution name (ex. 1024x768) with the
        //    resolution name (ex. iPad Horizontal 1024x768)
        _resolutionHash: {},

        // defaultItem: [public] Object
        //    The widget's default item to be added to the menu.
        defaultItem: {
            name: res.defaultitem,
            width: 1,
            height: 1
        },

        postMixInProperties: function () {
            // summary:
            //    Sets up the data store.
            //
            // tags:
            //    protected
            this.inherited(arguments);

            // To get correctly the displayResolutions for other ApplicationSetting. 
            this._availableResolutions = lang.clone(ApplicationSettings.displayResolutions);

            this._availableResolutions.unshift(this.defaultItem);

            array.forEach(this._availableResolutions, lang.hitch(this, function (resolution) {
                var urlName = resolution.width + "x" + resolution.height;
                this._resolutionHash[urlName] = resolution.name;
            }));

            this.checkedItem  = (this.checkedItem ? this._resolutionHash[this.checkedItem] : this.defaultItem.name);
        },

        postCreate: function () {
            // summary:
            //    Raised when after the widget creating, it calls
            //    the setup function.
            //
            // tags:
            //    protected
            this.inherited(arguments);
            this.set("header", res.header);
            this.set("items", this._availableResolutions);
        },

        getDefaultResolution: function (/*Object*/channel) {
            // summary:
            //    Get the default resolution given a channel.
            //
            // channel:
            //    DisplayChannel to get the resolution.
            //
            // tags:
            //    private
            var defaultResolution = this.defaultItem;

            var resolutions = dojo.filter(this._availableResolutions, function (resolution) {
                if (resolution.id == channel.resolutionId) {
                    return resolution;
                }
            });
            if (resolutions != null && lang.isArray(resolutions) && resolutions.length >= 1) {
                defaultResolution = resolutions[0];
            }
            return defaultResolution;
        }

    });
});
},
'epi-cms/widget/ViewLanguageButton':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/topic",
    "dojo/when",
    "dojo/dom-class",

// dijit
    "dijit/DropDownMenu",
    "dijit/form/DropDownButton",
    "dijit/focus",

// epi
    "epi/dependency",
    "epi-cms/widget/ViewLanguageSelector",

// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.viewlanguagebutton"
], function (
    declare,
    lang,
    aspect,
    topic,
    when,
    domClass,

// dijit
    DropDownMenu,
    DropDownButton,
    focusUtil,

// epi
    dependency,
    ViewLanguageSelector,

// resources
    resources
) {
    return declare([DropDownButton], {

        // _contextMenu: [private] dijit.DropDownMenu
        //    The context menu for the button.
        _contextMenu: null,

        // baseClass: [public] String
        //    CSS base classes for the button.
        baseClass: "epi-mediumButton epi-chromelessButton",

        // iconClass: [public] String
        //    CSS class that adds the button icon.
        iconClass: "",

        // contextMenuProperties [public] Object
        //    Context menu properties.
        contextMenuProperties: {},

        // _viewLanguageSelector: [private] Object
        //    The preview language selector widget.
        _viewLanguageSelector: null,

        // _viewSettingsManager: [private] Object
        //    The view manager
        _viewSettingsManager: null,

        postMixInProperties: function () {
            // summary:
            //    Mixin the widget properties.
            //
            // tags:
            //    protected

            this.inherited(arguments);

            lang.mixin(this.contextMenuProperties, {
                "class": "epi-DropDownMenu"
            });

            this.profile = this.profile || dependency.resolve("epi.shell.Profile");
        },

        postCreate: function () {
            // summary:
            //    Raised after the widget is created. It will create
            //    the widget's context menu and add its children.
            //
            // tags:
            //    protected

            this.inherited(arguments);

            //Get the content language
            when(this.profile.getContentLanguage(), lang.hitch(this, function(language) {

                this._viewSettingsManager = dependency.resolve("epi.viewsettingsmanager");
                var defaultItem = {
                    languageId: language
                },
                checkedItem = this._viewSettingsManager.getSettingProperty("viewlanguage") || defaultItem.languageId;

                if (!this.dropDown) {

                    this.dropDown = DropDownMenu(this.contextMenuProperties);

                    this.own(this.dropDown);

                    this._viewLanguageSelector = new ViewLanguageSelector({
                        defaultItem: defaultItem,
                        checkedItem: checkedItem
                    });
                    this.own(aspect.after(this._viewLanguageSelector, "onItemSelected", lang.hitch(this, "_onViewLanguageSelected"), true));

                    this._addChildren(this._viewLanguageSelector);

                    when(this._viewLanguageSelector.fetchData(), lang.hitch(this, function(result) {
                        if (this._viewLanguageSelector.get("items").length === 0) {
                            domClass.add(this.domNode, "dijitHidden");
                            return;
                        }
                        this._changeView();
                    }));
                }

                this.own(aspect.after(this.dropDown, "onOpen", lang.hitch(this, function(e) {
                    focusUtil.focus(this._viewLanguageSelector.menuNode.domNode);
                }), true));

                this.own(topic.subscribe("/epi/cms/contentdata/updated", lang.hitch(this, function() {
                    //when the language settings dialog is closed, get the current site
                    this._languageSettingsChanged();
                })));
            }));
        },

        _languageSettingsChanged: function () {
            // summary:
            //      Update available languages for button
            // tags:
            //      private

            when(this._viewLanguageSelector.fetchData(), lang.hitch(this, function (result) {
                var selectedItem = this._viewLanguageSelector.get("currentSelectedItem");
                this._changeView(selectedItem || this._viewLanguageSelector.defaultItem);
            }));
        },

        _updateButton: function (/*Object*/languageItem) {
            // summary:
            //      Update button display text.
            // tags:
            //      private

            var selectedItem = languageItem || this._viewLanguageSelector.get("currentSelectedItem") || this._viewLanguageSelector.defaultItem;
            var tooltiptext = lang.replace(resources.tooltip, { viewlanguage: selectedItem ? selectedItem.name : null });
            var labeltext = selectedItem && selectedItem.urlSegment ? selectedItem.urlSegment.toUpperCase() : null;
            var oldLabelText = this.get("label");
            this.set("title", tooltiptext);
            this.set("label", labeltext);

            if (oldLabelText != labeltext) {
                // Resize view settings menu's expando button
                this.onResize();
            }
        },

        onResize: function () {
            // summary:
            //    Raised when a item change.
            //
            // tags:
            //    protected event
        },

        _isDefaultSelection: function () {
            // summary:
            //    Checks if the selected items on both widgets are the default items.
            //
            // tags:
            //    private

            if (this._viewLanguageSelector.get("currentSelectedItem")) {
                return this._viewLanguageSelector.isDefaultItemSelected();
            }

            return true;
        },

        _onViewLanguageSelected: function (/*Object*/language) {
            // summary:
            //    Raised when a preview language is selected.
            //
            // language:
            //   The selected preview language
            //
            // tags:
            //    private event

            this._changeView(language);

            // Close alway view language menu when item has selected
            this.closeDropDown();
        },

        _changeView: function (/*Object*/language) {
            // summary:
            //    Change the view to the given resolution.
            //
            // language:
            //    preview language object
            //
            // tags:
            //    private

            if (language) {
                topic.publish("/epi/cms/action/viewsettingvaluechanged", "viewlanguage", language.languageId);
            }

            this._viewLanguageSelector.checkItem(language);
            this._activeButton(!this._isDefaultSelection());
            this._updateButton(language);
        },

        _addChildren: function (/*Object*/item) {
            // summary:
            //    Populate the context menu with the configured items.
            //
            // item:
            //    The item that will be added to the dropdown
            //
            // tags:
            //    private

            this.dropDown.addChild(item);
        },

        _activeButton: function (/*Boolean*/active) {
            // summary:
            //      Set active state for button widget
            //
            // active:
            //    States if the button will be checked or not.
            //
            // tags:
            //      private
            if (!this.dropDown) {
                return;
            }

            domClass.toggle(this.domNode, "dijitChecked", active);
            domClass.toggle(this.domNode, "epi-expandoButtonLangSelected", active);
        }
    });
});
},
'epi-cms/widget/ViewLanguageSelector':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/when",
// epi
    "epi/dependency",
    "epi-cms/widget/_ItemSelectorBase",
    "epi-cms/widget/_DropDownWidgetItemMixin",
    "epi-cms/component/SiteTreeModel",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.viewlanguageselector"
], function (
    declare,
    lang,
    array,
    Deferred,
    when,
// epi
    dependency,
    _ItemSelectorBase,
    _DropDownWidgetItemMixin,
    SiteTreeModel,
// resources
    resources
) {
    return declare([_ItemSelectorBase, _DropDownWidgetItemMixin], {

        // _viewLanguageHash: [private] Object
        //    Map the int id with its name
        _viewLanguageHash: {},

        // _isFinished: [private] dojo.Deferred
        //    Deferred to indicate when widget finished its setup process.
        _isFinished: null,

        // _siteTreeModel: Object
        //      Instance of SiteTreeModel
        _siteTreeModel: null,

        postCreate: function () {
            // summary:
            //    Raised after the widget creating, sets the header and
            //    load the items to be added to the menu.
            //
            // tags:
            //    protected

            this.inherited(arguments);
            this.set("header", resources.header);

            if (!this._siteTreeModel) {
                var registry = dependency.resolve("epi.storeregistry"),
                    siteStructureStore = registry.get("epi.cms.sitestructure");
                this._siteTreeModel = new SiteTreeModel({store: siteStructureStore});
            }
        },

        fetchData: function () {
            // summary:
            //      Load all available languages of current site
            // tags:
            //      protected

            var deferred = new Deferred();

            when(this._siteTreeModel.getCurrentSite(), lang.hitch(this, function (site) {
                if (site) {
                    when(this._siteTreeModel.getChildren({ url: site.currentSite }, lang.hitch(this, function (languages) {
                        this._createHashMap(languages);

                        // manually update defaultItem name
                        if (this.defaultItem) {
                            this.defaultItem.name = this._viewLanguageHash[this.defaultItem.languageId] || this.defaultItem.name;
                        }

                        this.set("items", languages);

                        deferred.resolve({ status: true });
                    })));
                }
            }));

            return deferred.promise;
        },

        checkItem: function (/*Object*/item) {
            // summary:
            //    Mark a specific item as checked.
            //
            // item:
            //    The item to be selected. If not specified
            //    all the radio buttons will be unchecked.
            //
            // tags:
            //    public

            if (!item || !this._viewLanguageHash[item.languageId]) {
                item = this.get("currentSelectedItem");
            }

            this.inherited(arguments);
        },

        _getCurrentSelectedItemAttr: function () {
            // summary:
            //      Custom get currentSelectedItem method, loop through all candidates, check exist or not
            // tags:
            //      Public

            var foundCandidate = null;
            array.some([this.currentSelectedItem, this.checkedItem, this.defaultItem], lang.hitch(this, function (candidate) {
                if (candidate && (this._viewLanguageHash[candidate.languageId || candidate])) {
                    foundCandidate = candidate.languageId ? candidate : { languageId: candidate, name: this._viewLanguageHash[candidate] };
                    return true;
                }

                return false;
            }));

            return foundCandidate;
        },

        _createHashMap: function (items) {
            // summary:
            //      Creates a map with the language id and its name
            // tags:
            //      Private

            // Clear hash
            this._viewLanguageHash = {};

            // Create has mapping
            array.forEach(items, lang.hitch(this, function (item) {
                this._viewLanguageHash[item.languageId] = item.name;
            }));
        }
    });
});
},
'epi-cms/component/SiteTreeModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/Stateful",
    "dojo/Deferred",
    "dojo/when",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "dojo/cookie",
    "epi/dependency",
    "epi/string"
], function (array, declare, Stateful, Deferred, when, lang, connect, cookie, dependency, epiString) {

    // Review: Do we need proper documentation and unit tests?.
        return declare([Stateful], {

        query: null,

        // name: [public] Boolean
        //		A flag indicating whether all languages should be shown in the site tree.
        showAllLanguages: true,
        
        location: document.location,

        profile: null,

        store: null,

        constructor: function(){
            this.query = { allLanguages: this.showAllLanguages };
        },

        postscript: function () {
            this.inherited(arguments);
            
            this.profile = this.profile || dependency.resolve("epi.shell.Profile");
            
            connect.subscribe("/epi/cms/contentdata/updated", lang.hitch(this, function () {
                //when the language settings dialog is closed, get the current site
                when(this.getCurrentSite(), lang.hitch(this, function (config) {
                    //reload the children for the current site
                    this.onItemChildrenReload({ siteUrl: config.currentSite });
                }));
            }));
        },

        // Methods for traversing hierarchy
        getRoot: function (onItem, onError) {
            // summary:
            //		Calls onItem with the root item for the tree, possibly a fabricated item.

            // Do dummy call to onItem. We won't actually show the root, we just want to call getchildren with an empty object.
            onItem({});
        },

        getIdentity: function (item) {
            // summary:
            //		Gets the identity for the specified item

            var id = this.store.getIdentity(item);

            // We need to have an id for our dummy root node
            if (!id && !item.isLanguageNode) {
                id = 'root';
            }

            return id;
        },

        onItemChildrenReload: function (/*Object*/parent) {
            // summary:
            //  Raised when the children of an item must be reloaded.
            //  The subscriber needs to call getChildren to get the updated children collection
        },

        mayHaveChildren: function (item) {
            // summary:
            //		Tells if an item has or may have children.  Implementing logic here
            //		avoids showing +/- expando icon for nodes that we know don't have children.
            //		(For efficiency reasons we may not want to check if an element actually
            //		has children until user clicks the expando node)

            if (!item.isLanguageNode) {
                return true;
            }

            return false;
        },

        getLabel: function (item) {
            // summary:
            //		Gets the label for the specified item.
            //      This is the text that will be visible in the tree.

            return item.name;
        },

        getChildren: function (parentItem, onComplete) {
            // summary:
            //		Gets the children for the specified item.
            //      The children of a site, identified by the url, is the enabled languages for that site.

            when(this.store.query(lang.mixin({ siteUrl: parentItem.url }, this.query)), onComplete);
        },

        _setQuery: function (q) {
            // summary:
            //  Updates the query of the model and raises the onItemChildrenReload event.

            this.query = q;
            this.onItemChildrenReload({});
        },

        _showAllLanguagesSetter: function (value) {
            this.showAllLanguages = value;
            this._setQuery({ allLanguages: value });
        },

        getCurrentSite: function () {

            var def = new Deferred();

            when(this.profile.getContentLanguage(), lang.hitch(this, function(languageBranch) {
                if (languageBranch) {
                    when(this.store.get(), lang.hitch(this, function(sites) {
                        var returnValue = null;
                        var wildcardSite = null;

                        // Find the site with the wildcard mapping
                        array.some(sites, function(site){
                            return array.some(site.hosts, function(host){
                                if(host === "*"){
                                    wildcardSite = site;
                                    return true;
                                }
                            });
                        });

                        var currentHost = this.location.host.toLowerCase();
                        var wasSiteFound = array.some(sites, function(site) {
                            return array.some(site.hosts, function(host) {
                                //Check if the HostUrl is a part of the documentHref
                                if(currentHost == host.toLowerCase()){
                                    returnValue = {
                                        currentSite: site.url,
                                        currentEditLanguageId: site.url + languageBranch
                                    };
                                    return true;
                                }
                            });
                        });

                        // if the site wasn't found and we have a wildcard site return that one
                        if(!wasSiteFound && wildcardSite){
                            returnValue = {
                                currentSite: wildcardSite.url,
                                currentEditLanguageId: wildcardSite.url + languageBranch
                            };
                        }

                        if (returnValue) {
                            // Success, found the site
                            def.resolve(returnValue);
                        } else {
                            // No matching found
                            def.cancel();
                        }
                    }),

                    function() {
                        // Error while getting
                        def.reject(null);
                    });

                } else {
                    // No cookie
                    def.reject(null);
                }
            }));

            return def;
        },

        getAllLanguagesForSite: function (siteUrl) {

            var def = new Deferred();

            when(this.store.query({ siteUrl: siteUrl, allLanguages: true }), function (items) {
                def.resolve(items);
            });

            return def;
        },

        getAllLanguagesForCurrentSite: function () {

            var def = new Deferred();

            when(
                this.getCurrentSite(),

                lang.hitch(this, function (config) {

                    this.getAllLanguagesForSite(config.currentSite).then(function (items) {
                        def.resolve(items);
                    });

                }),

                function (result) {
                    def.reject(result);
                }
            );

            return def;
        }
    });
});

},
'epi-cms/widget/command/CreateContentFromSelector':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/on",
    "dojo/topic",
    "dojo/when",

// Shell
    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/dialog/Dialog",

// CMS
    "epi-cms/core/ContentReference",
    "epi-cms/ApplicationSettings",
    "epi-cms/_ContentContextMixin",
    "epi-cms/contentediting/_ContextualContentContextMixin",
    "epi-cms/widget/ContentSelectorDialog",
    "epi-cms/widget/ContentForestStoreModel",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.createcontentselector"
],

function (
    array,
    declare,
    lang,
    aspect,
    on,
    topic,
    when,

// Shell
    dependency,
    _Command,
    TypeDescriptorManager,
    Dialog,

// CMS
    ContentReference,
    ApplicationSettings,
    _ContentContextMixin,
    _ContextualContentContextMixin,
    ContentSelector,
    ContentForestStoreModel,
    ContentActionSupport,
    createcontentselectorresources
) {

    // module:
    //      epi-cms/widget/command/CreateContentFromSelector
    // summary:
    //      ...

    return declare([_Command, _ContentContextMixin, _ContextualContentContextMixin], {

        // canExecute: [Boolean]
        //      Default value indicate that command can execute
        canExecute: true,

        // canSelectOwnerContent:
        //      Indicate that command can select owner content
        canSelectOwnerContent: false,

        // showButtons:
        //      Indicate that command show buttons
        showButtons: false,

        // value: [String]
        //      Default select content
        value: null,

        // showRoot: [Boolean]
        //      True if show root on dialog, otherwise don't show root
        showRoot: false,

        // roots: [Array]
        //      The roots to show in the selector.
        roots: null,

        // creatingTypeIdentifier: [String]
        //      Type identifier of the content which is being created.
        creatingTypeIdentifier: null,

        // containerTypeIdentifiers: [Array]
        //      Type identifiers of content
        containerTypeIdentifiers: null,

        // modelContent: [Widget]
        //      That model selector dialog
        modelContent: null,

        // destroyOnHide:
        //      Indicate that dialog destroy on hide
        destroyOnHide: true,

        // confirmActionText: [String]
        //      Confirm action text in dialog
        confirmActionText: createcontentselectorresources.buttons.confirmation,

        // description: [String]
        //      Description in dialog
        description: null,

        // title: [String]
        //      Title in dialog
        title: null,

        // createAsLocalAsset: [Boolean]
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        // canChangeLocalAssetName: [public] Boolean
        //      In case "createAsLocalAsset" is TRUE, indicates we can change the name when create a new local asset
        canChangeLocalAssetName: true,

        // addToParentsAssetsFolder: [Boolean]
        //      Indicate if the command should attach content to the parent's assets folder.
        addToParentsAssetsFolder: false,

        typeDescriptorManager: null,

        contentRepositoryDescriptors: null,

        postscript: function () {
            // summary:
            //    Initial settings value.
            //
            // tags:
            //    public

            this.inherited(arguments);
            this._initialize();
        },

        _initialize: function () {
            // summary:
            //    Initial application setting
            //
            // tags:
            //    private
            if (!this.creatingTypeIdentifier) {
                throw "You need to specify a creatingTypeIdentifier";
            }

            if (this._initialized) {
                return;
            }
            var registry = dependency.resolve("epi.storeregistry");
            this.contentStore = this.contentStore || registry.get("epi.cms.content.light");
            this.contextStore = this.contextStore || registry.get("epi.shell.context");
            this.contentTypeStore = this.contentTypeStore || registry.get("epi.cms.contenttype");

            this.contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");

            var repositoryDescriptor,
                matchType = function (type) {
                    return type == this.creatingTypeIdentifier;
                };
            for (var index in this.contentRepositoryDescriptors) {
                var descriptor = this.contentRepositoryDescriptors[index];
                //use the first descriptor that matches the creating type identifier.
                if (array.some(descriptor.containedTypes, matchType, this)) {
                    repositoryDescriptor = descriptor;
                    break;
                }
            }
            if (repositoryDescriptor) {
                var containerTypeIdentifiers = TypeDescriptorManager.getValue(this.creatingTypeIdentifier, "containerTypes");
                this.containerTypeIdentifiers = containerTypeIdentifiers ?
                    containerTypeIdentifiers :
                    [this.creatingTypeIdentifier];
                this.roots = this.roots || repositoryDescriptor.roots;
            }

            this.modelContent = new ContentForestStoreModel({
                roots: this.roots,
                additionalQueryOptions: {
                    sort: [{ attribute: "name", descending: false }]
                }
            });

            this.preventContextualContentFor = repositoryDescriptor.preventContextualContentFor;

            this.label = this.label || TypeDescriptorManager.getResourceValue(this.creatingTypeIdentifier, "create");
            this.title = this.title || TypeDescriptorManager.getResourceValue(this.creatingTypeIdentifier, "selectparent");
            this.description = this.description || TypeDescriptorManager.getResourceValue(this.creatingTypeIdentifier, "createdescription");
            this.iconClass = this.iconClass || TypeDescriptorManager.getValue(this.creatingTypeIdentifier, "commandIconClass");
            this._initialized = true;
        },

        _execute: function () {
            // summary:
            //		Executes this command; ...
            // tags:
            //		protected

            when(this.getCurrentContent(), lang.hitch(this, function (currentContent) {
                if (!currentContent) {
                    return;
                }

                // Get the context store for more information about the model
                // We need to append the ?uri= because the request chain can not handle URI's in URI's
                when(this.contextStore.get("?uri=epi.cms.contentdata:///" + currentContent.contentLink), lang.hitch(this, function (context) {
                    if (!context) {
                        return;
                    }
                    var languageContext = context.languageContext;

                    // languageContext is null if the content or content provider does not have multi language support
                    // in this case allow creating a new page no matter which language is active
                    var hasAccessToLanguage = !languageContext || (languageContext.hasTranslationAccess && languageContext.isPreferredLanguageAvailable);

                    var isWastebasket = ContentReference.compareIgnoreVersion(currentContent.contentLink, ApplicationSettings.wastebasketPage);

                    var isEnableMenu = !(isWastebasket || currentContent.isDeleted) && hasAccessToLanguage &&
                    ContentActionSupport.isActionAvailable(currentContent, ContentActionSupport.action.Create, ContentActionSupport.providerCapabilities.Create, true);

                    when(this._getAvailableContentTypes(currentContent.contentLink), lang.hitch(this, function (availableContentTypes) {

                        var contentTypeCanBeChildToCurrentContext = this._isContentTypeAllowedAsChildToCurrentContext(availableContentTypes, currentContent);

                        // Show location selector dialog when current context is a valid location to store the one we are about to create.
                        if ((!contentTypeCanBeChildToCurrentContext && !this.createAsLocalAsset) ||
                            !isEnableMenu) {

                            this._createDialog();
                            this._setDialogButtonState(this.selector.get("value"));
                        } else {
                            this._switchView(currentContent);
                        }
                    }));
                }));
            }));
        },

        _getAvailableContentTypes: function (contentLink) {
            return this.contentTypeStore.query({
                query: "getavailablecontenttypes",
                parentReference: contentLink
            });
        },

        _isContentTypeAllowedAsChildToCurrentContext: function (availableContentTypes, currentContent) {
            var anyAvailableContentTypeOfCorrectType = array.some(availableContentTypes, function (contentType) {
                return TypeDescriptorManager.isBaseTypeIdentifier(contentType.typeIdentifier, this.creatingTypeIdentifier);
            }, this);

            var currentContentIsAValidContainerType = array.some(this.containerTypeIdentifiers, function (type) {
                return TypeDescriptorManager.isBaseTypeIdentifier(currentContent.typeIdentifier, type);
            });

            return anyAvailableContentTypeOfCorrectType && currentContentIsAValidContainerType;
        },

        _createDialog: function () {
            // summary:
            //    Create selector dialog.
            //
            // tags:
            //    protected

            this.selector = new ContentSelector({
                canSelectOwnerContent: this.canSelectOwnerContent,
                showButtons: this.showButtons,
                value: this.value,
                showRoot: this.showRoot,
                multiRootsMode: true,
                allowedTypes: this.containerTypeIdentifiers,
                model: this.modelContent,
                showContextualContent: true,
                preventContextualContentFor: this.preventContextualContentFor
            });

            this.dialog = new Dialog({
                destroyOnHide: this.destroyOnHide,
                confirmActionText: this.confirmActionText,
                description: this.description,
                title: this.title,
                content: this.selector
            });

            on(this.selector, "change", lang.hitch(this, this._setDialogButtonState));
            aspect.after(this.dialog, "hide", lang.hitch(this, function (result) {
                this.hideDeferred = result;
            }));
            this.dialog.on("execute", lang.hitch(this, this._onContentSelected));

            this.dialog.show();
        },

        _onContentSelected: function () {
            // summary:
            //    When selected parent content, it should be hide dialog and change view.
            //
            // tags:
            //    protected

            var contentLink = this.selector.get("value");

            when(this.hideDeferred, lang.hitch(this, function () {
                when(this.contentStore.get(contentLink), lang.hitch(this, function (content) {
                    this._switchView(content);
                }));
            }));
        },

        _switchView: function (content) {
            // summary:
            //    Change view to Create Content with parent content
            //
            // tags:
            //    protected

            when(this.getCurrentContent(), lang.hitch(this, function (contextContent) {
                var createAsLocalAsset = this.isPseudoContextualRoot(content) || this.createAsLocalAsset;

                topic.publish("/epi/shell/action/changeview", "epi-cms/contentediting/CreateContent", null, {
                    requestedType: this.creatingTypeIdentifier,
                    parent: createAsLocalAsset ? contextContent : content,
                    editAllPropertiesOnCreate: this.editAllPropertiesOnCreate,
                    addToDestination: this.model,
                    createAsLocalAsset: createAsLocalAsset,
                    canChangeLocalAssetName: this.canChangeLocalAssetName,
                    treatAsSecondaryView: this.createAsLocalAsset,
                    view: TypeDescriptorManager.getValue(this.creatingTypeIdentifier, "createView")
                });
            }));
        },

        _setDialogButtonState: function (contentLink) {
            // summary:
            //    Set state of dialog button.
            //
            // tags:
            //    protected

            if (!contentLink) {
                this.dialog.definitionConsumer.setItemProperty(this.dialog._okButtonName, "disabled", true);
                return;
            }

            when(this.contentStore.get(contentLink), lang.hitch(this, function (content) {
                when(this.isPseudoContextualRoot(content) ? this.contextStore.get("?uri=epi.cms.contentdata:///" + this._currentContext.id) : content, lang.hitch(this, function (target) {
                    // language is null if the content or content provider does not have multi language support
                    // in this case allow creating a new block no matter which language is active
                    var hasAccessToLanguage = ContentActionSupport.hasLanguageAccess(target),
                        canCreate = hasAccessToLanguage && ContentActionSupport.hasAccess(content.accessMask, ContentActionSupport.accessLevel.Create);

                    this.dialog.definitionConsumer.setItemProperty(this.dialog._okButtonName, "disabled", !canCreate);
                }));
            }));
        }

    });

});
},
'epi-cms/contentediting/_ContextualContentContextMixin':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/when",
// epi
    "epi/shell/_ContextMixin",
    "epi/shell/TypeDescriptorManager",

    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/PseudoContextualCommandDecorator",
    "epi-cms/core/ContentReference",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.hierachicallist.roots"
],

function (
// dojo
    array,
    declare,
    lang,

    when,
// epi
    _ContextMixin,
    TypeDescriptorManager,

// EPi CMS
    ApplicationSettings,
    PseudoContextualCommandDecorator,
    ContentReference,
// resources
    resources
) {

    // module:
    //      epi-cms/contentediting/_ContextualContentContextMixin
    // description:
    //      Provides stubs to interacts with contextual content of the current context.
    // tags:
    //      public

    return declare([_ContextMixin], {

        // contextRootLabel: [public] String
        //      Overrides label of the contextual root node.
        contextRootLabel: null,

        // _commandDecorator: [private] "epi-cms/contentediting/PseudoContextualCommandDecorator"
        //      Decorates commands for a pseudo contextual content
        _commandDecorator: null,

        // =======================================================================
        // Public overrided functions

        postscript: function () {

            this.inherited(arguments);

            this.contextRootLabel = this.contextRootLabel || resources.contextualroot.label;

            this._commandDecorator = this._commandDecorator || new PseudoContextualCommandDecorator();
        },

        destroy: function () {

            this._commandDecorator && this._commandDecorator.destroy();

            this.inherited(arguments);
        },

        // =======================================================================
        // Public functions

        isTypeOfRoot: function (/*dojo.data.Item*/contentItem) {
            // summary:
            //      Checks to see if the item is type of root node such as: root, sub root, context root
            // contentItem: [dojo.data.Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public, extension

            var inherited = this.inherited(arguments),
                isContextualRoot = this.isContextualContent(contentItem);

            return inherited != null ? !!(inherited || isContextualRoot) : !!(contentItem && isContextualRoot);
        },

        isContextualContent: function (/*dojo.data.Item*/contentItem) {
            // summary:
            //      Verifies the given content item data is contextual or not
            // contentItem: [dojo.data.Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public

            return this.isContextualRoot(contentItem) || this.isPseudoContextualRoot(contentItem);
        },

        isContextualRoot: function (/*dojo.data.Item*/contentItem) {
            // summary:
            //      Checks to see the given data item object is contextual root or not
            // contentItem: [dojo.data.Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public

            return contentItem.parentLink == this._getPseudoContextualContent();
        },

        isPseudoContextualRoot: function (/*dojo.data.Item*/contentItem) {
            // summary:
            //      Checks to see if the item is a pseudo contextual content
            // contentItem: [dojo.data.Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public

            var contentReference = ContentReference.toContentReference(contentItem.contentLink);
            return !contentReference.providerName && contentReference.id == this._getPseudoContextualContent();
        },

        hasContextual: function (/*Array*/contentAncestors) {
            // summary:
            //      Verifies the given tree node has a ancestor is contextual or not
            // contentAncestors: [Array]
            //      A collection of "dijit._TreeNode" item object (dojo.data.Item) that are ancestors of the given selected content
            // returns: [Boolean]
            // tags:
            //      public

            if (!(contentAncestors instanceof Array) || contentAncestors.length <= 0) {
                return false;
            }

            return array.some(contentAncestors, this.isContextualContent, this);
        },

        canHaveContextualContent: function (/*dojo.data.Item*/contentItem) {
            // summary:
            //      Verifies the given object allowed to show contextual content or not
            // contentItem: [dojo.data.Item]
            //      Content item data object
            // returns: [Boolean]
            // tags:
            //      public

            var contentReference = ContentReference.toContentReference(contentItem.contentLink);
            return !array.some(this.notSupportContextualContents, function (id) {
                return !contentReference.providerName && contentReference.id == id;
            });
        },

        getContextualRoot: function (/*dojo.data.Item*/contentItem) {
            // summary:
            //      Get contextual content from the given content item data
            // contentItem: [dojo.data.Item]
            //      Content item data object
            // returns: [dojo.data.Item]
            //      A clone object that acts as a contextual content (local content assets folder for the current content context)
            // tags:
            //      public

            if (typeof contentItem !== "object") {
                return null;
            }

            var modifiedItem = lang.clone(contentItem);

            // Change the original name of the content (in this case is "Content Assets" root folder) based on the current content context's type identifier
            // Will be (core content data types):
            //      "For This Page" for the "episerver.core.pagedata" type identifier
            //      "For This Block" for the "episerver.core.blockdata" type identifier
            //      "For This {0}" if the given type identifier not found
            modifiedItem.name = this.getContextualRootName(modifiedItem);

            // Set "hasChildren" property to FALSE in order to hides collapsed icon for pseudo contextual content.
            if (this.isPseudoContextualRoot(modifiedItem)) {
                modifiedItem.hasChildren = false;
            }

            return modifiedItem;
        },

        getContextualRootName: function (/*dojo.data.Item?*/contentItem) {
            // summary:
            //      Get contextual root name based on the current content context data type.
            // contentItem: [dojo.data.Item?]
            //      Content item data object
            // returns: [String]
            //      "For This Page" for the "episerver.core.pagedata" type
            //      "For This Block" for the "episerver.core.blockdata" type
            //      "For This {0}" if the given type identifier not found
            // tags:
            //      public

            var name = this.contextRootLabel || (this._currentContext && this._currentContext.name) || "",
                ownerTypeIdentifier = contentItem && contentItem.ownerTypeIdentifier,
                typeName = TypeDescriptorManager.getResourceValue(ownerTypeIdentifier || (this._currentContext && this._currentContext.dataType) || "", "name", true);

            return typeName ? lang.replace(name, [typeName]) : name;
        },

        decoratePseudoContextualCommands: function (/*Arrays*/commands) {
            // summary:
            //      Converts the given commands to work in case pseudo contextual content
            // commands: [Array]
            //      A collection of object that is instance of "epi.shell.command._Command" class
            // tags:
            //      public

            when(this.getCurrentContent(), lang.hitch(this, function (contentItem) {
                this._commandDecorator.decorateCommands(commands, contentItem, /*pseudoContextualRootFilter*/lang.hitch(this, this.isPseudoContextualRoot));
            }));
        },

        // =======================================================================
        // Protected functions

        _getPseudoContextualContent: function () {
            // summary:
            //      Get pseudo contextual content
            // returns: [Integer]
            //      The content link
            // tags:
            //      protected

            return ApplicationSettings.contentAssetsFolder;
        }

    });

});
},
'epi-cms/contentediting/PseudoContextualCommandDecorator':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
// epi
    "epi/shell/command/_Command",
    "epi/shell/command/_ClipboardCommandMixin",
    "epi/shell/command/_SelectionCommandMixin"
],

function (
// dojo
    array,
    declare,
    lang,

    aspect,
// epi
    _Command,
    _ClipboardCommandMixin,
    _SelectionCommandMixin
) {

    // module:
    //      epi-cms/contentediting/PseudoContextualCommandDecorator
    // summary:
    //      Decorates commands for a pseudo contextual content
    // tags:
    //      pulbic

    return declare(null, {

        // =======================================================================
        // Public functions

        destroy: function () {

            this._clearContextualCommandHandlers();
        },

        decorateCommands: function (/*Arrays*/commands, /*dojo.data.Item*/newModel, /*Function?*/pseudoContextualRootFilter) {
            // summary:
            //      Converts the given commands to work in case pseudo contextual content
            // commands: [Array]
            //      A collection of object that is instance of "epi.shell.command._Command" class
            // newModel: [dojo.data.Item]
            // pseudoContextualRootFilter: [Function?]
            //      Command filter function
            // tags:
            //      public

            this._clearContextualCommandHandlers();

            if (!(commands instanceof Array) || commands.length <= 0 || typeof newModel !== "object") {
                return;
            }

            this._decorateCommands(commands, newModel, pseudoContextualRootFilter);
        },

        // =======================================================================
        // Private functions

        _decorateCommands: function (/*Arrays*/commands, /*dojo.data.Item*/newModel, /*Function?*/pseudoContextualRootFilter) {
            // summary:
            //      Converts the given commands to work in case pseudo contextual content
            // commands: [Array]
            //      A collection of object that is instance of "epi.shell.command._Command" class
            // newModel: [dojo.data.Item]
            // pseudoContextualRootFilter: [Function?]
            //      Command filter function
            // tags:
            //      public

            array.forEach(commands, function (command) {
                if (!this._isValidCommand(command)) {
                    return;
                }

                // Do nothing if the current selected item is a real contextual content
                if (typeof pseudoContextualRootFilter === "function" && !pseudoContextualRootFilter(this._isNormalCommand(command) ? command.model : command.get("selectionData"))) {
                    return;
                }

                this._onAroundCommandExecute(command, newModel);
            }, this);
        },

        _onAroundCommandExecute: function (/*Object*/command, /*Object*/newModel) {
            // summary:
            //      Stub to do something before and after the execution of the given command object
            // command: [Object]
            //      An instance of "epi.shell.command._Command"
            // newModel: [Object]
            //      An instance of "dojo.data.Item"
            // tags:
            //      private

            var self = this;
            self._contextualCommandHandlers.push(aspect.around(command, "execute", function (originalFunction) {
                return function () {
                    var originalData = self._decorateCommandBeforeExecute(command, newModel);

                    originalFunction.apply(command, arguments);

                    self._restoreCommandAfterExecute(command, originalData);
                };
            }));
        },

        _decorateCommandBeforeExecute: function (/*Object*/command, /*Object*/newModel) {
            // summary:
            //      Stub to do something before execution of the given command object
            // command: [Object]
            //      An instance of "epi.shell.command._Command"
            // newModel: [Object]
            //      An instance of "dojo.data.Item"
            // returns: [Object] original command data
            //      Default data:
            //          canExecute: [Boolean]
            //          isAvailable: [Boolean]
            //          createAsLocalAsset: [Boolean]
            //      Optional data:
            //          model: [Object]
            //          data: [Object]
            // tags:
            //      private

            var originalData = {};
            lang.mixin(originalData, this._decorateCommand(command));

            if (this._isNormalCommand(command)) {
                lang.mixin(originalData, this._decorateNormalCommand(command, newModel));

                return originalData;
            }

            // _SelectionCommandMixin
            if (command.isInstanceOf(_SelectionCommandMixin)) {
                lang.mixin(originalData, this._decorateSelectionCommand(command, newModel));
            }

            return originalData;
        },

        _decorateCommand: function (/*Object*/command) {
            // summary:
            //      Decorates the given command: marks it always TRUE for "canExecute", "isAvailable" and "createAsLocalAsset" flags
            // command: [Object]
            //      An instance of "epi.shell.command._Command"
            // returns: [Object] original command data
            //      canExecute: [Boolean]
            //      isAvailable: [Boolean]
            //      createAsLocalAsset: [Boolean]
            // tags:
            //      private

            var originalData = {
                "canExecute": command.get("canExecute"),
                "isAvailable": command.get("isAvailable"),
                "createAsLocalAsset": command.get("createAsLocalAsset"),
                "canChangeLocalAssetName": command.get("canChangeLocalAssetName")
            };

            command.isInstanceOf(_Command) && command.unwatchModelChange();
            command.isInstanceOf(_ClipboardCommandMixin) && command.unwatchClipboardChange();
            command.isInstanceOf(_SelectionCommandMixin) && command.unwatchSelectionChange();

            command.set("canExecute", true);
            command.set("isAvailable", true);
            command.set("createAsLocalAsset", true);
            command.set("canChangeLocalAssetName", true);

            return originalData;
        },

        _decorateNormalCommand: function (/*Object*/command, /*Object*/newModel) {
            // summary:
            //      Decorates the given command in order to make it work fine with pseudo contextual content
            // command: [Object]
            //      An instance of "epi.shell.command._Command"
            // newModel: [Object]
            //      An instance of "dojo.data.Item"
            // returns: [Object] original command data
            //      model: [Object]
            // tags:
            //      private

            var originalData = {
                "model": command.get("model")
            };

            // Normal command case
            // If the given command object is instance of "epi/shell/command/_Command" only
            command.set("model", newModel);

            return originalData;
        },

        _decorateSelectionCommand: function (/*Object*/command, /*Object*/newModel) {
            // summary:
            //      Decorates the given command in order to make it work fine with pseudo contextual content
            // command: [Object]
            //      An instance of "epi.shell.command._SelectionCommandMixin"
            // newModel: [Object]
            //      An instance of "dojo.data.Item"
            // returns: [Object] original command data
            //      data: [Object]
            // tags:
            //      private

            var originalData = {
                "data": command.get("selectionData")
            };

            // Selection command case
            // If the given command object is instance of "epi/shell/command/_Command" and had mixed-in "epi/shell/command/_SelectionCommandMixin"
            var model = command.get("model");
            if (model && typeof model.refreshRoots == "function") {
                command.onRefreshSelection = function () {
                    return model.refreshRoots();
                };
            }

            command.selection.set("data", [{
                "data": newModel,
                "type": command.get("selectionType")
            }]);

            return originalData;
        },

        _restoreCommandAfterExecute: function (/*Object*/command, /*Object*/originalData) {
            // summary:
            //      Stub to do something after execution of the given command object
            // command: [Object]
            //      An instance of "epi/shell/command/_Command"
            // originalData: [Object]
            // tags:
            //      private

            this._restoreCommand(command, originalData);

            if (this._isNormalCommand(command)) {
                this._restoreNormalCommand(command, originalData);

                return;
            }

            // _SelectionCommandMixin
            if (command.isInstanceOf(_SelectionCommandMixin)) {
                this._restoreSelectionCommand(command, originalData);
            }
        },

        _restoreCommand: function (/*Object*/command, /*Object*/originalData) {
            // summary:
            //      Restores the given command to its original states
            // command: [Object]
            //      An instance of "epi/shell/command/_Command"
            // originalData: [Object]
            // tags:
            //      private

            command.set("canExecute", originalData.canExecute);
            command.set("isAvailable", originalData.isAvailable);
            command.set("createAsLocalAsset", originalData.createAsLocalAsset);
            command.set("canChangeLocalAssetName", originalData.canChangeLocalAssetName);

            command.isInstanceOf(_Command) && command.watchModelChange();
            command.isInstanceOf(_ClipboardCommandMixin) && command.watchClipboardChange();
            command.isInstanceOf(_SelectionCommandMixin) && command.watchSelectionChange();
        },

        _restoreNormalCommand: function (/*Object*/command, /*Object*/originalData) {
            // summary:
            //      Restores the given normal command to its original states
            // command: [Object]
            //      An instance of "epi/shell/command/_Command"
            // originalData: [Object]
            // tags:
            //      private

            command.set("model", originalData.model);
        },

        _restoreSelectionCommand: function (/*Object*/command, /*Object*/originalData) {
            // summary:
            //      Restores the given selection command to its original states
            // command: [Object]
            //      An instance of "epi/shell/command/_SelectionCommandMixin"
            // originalData: [Object]
            // tags:
            //      private

            command.selection.set("data", originalData.data);
        },

        _clearContextualCommandHandlers: function () {
            // summary:
            //      Clear all handlers for pseudo contextual content commands
            // tags:
            //      private

            if (this._contextualCommandHandlers instanceof Array && this._contextualCommandHandlers.length > 0) {
                array.forEach(this._contextualCommandHandlers, function (handler) {
                    typeof handler.remove === "function" && handler.remove();
                });
            }

            this._contextualCommandHandlers = [];
        },

        _isNormalCommand: function (/*Object*/command) {
            // summary:
            //      Verifies the given command object is normal command or not
            //      The given command must be an instance of "epi/shell/command/_Command" only
            // command: [Object]
            //      The given object to verifies
            // returns: [Boolean]
            // tags:
            //      private

            return !(command.isInstanceOf(_SelectionCommandMixin) || command.isInstanceOf(_ClipboardCommandMixin));
        },

        _isValidCommand: function (/*Object*/command) {
            // summary:
            //      Verifies the given object is instance of "epi.shell.command._Command" class or not.
            //      In additional, the given command must have its model.
            // command: [Object]
            //      The given object to verifies
            // returns: [Boolean]
            // tags:
            //      private

            return !!(command && command.isInstanceOf(_Command) && command.model);
        }

    });

});
},
'epi/shell/command/_ClipboardCommandMixin':function(){
﻿define("epi/shell/command/_ClipboardCommandMixin", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang"
],

function (
// dojo
    declare,
    lang
) {

    // module:
    //      epi/shell/command/_ClipboardCommandMixin
    // summary:
    //      Stub to handles content copy/paste for an instance of "epi.shell.command._Command" object
    // tags:
    //      public, mixin

    return declare(null, {

        // clipboard: [public] Object
        //      Hold information about copy/paste content
        clipboard: null,

        // =======================================================================
        // Public overrided functions

        postscript: function () {
            // summary:
            //      Register a watch hanlder when the command change its model
            //      Watch model and initialize model dependent properties.
            // tags:
            //      public, overrides

            this.inherited(arguments);

            this.watchClipboardChange();
        },

        // =======================================================================
        // Public functions

        onRefreshClipboard: function () {
            // summary:
            //      Stub to do somethings when clipboard refreshed
            // tags:
            //      public, callback
        },

        watchClipboardChange: function () {
            // summary:
            //      Register a watch hanlder when the command change its model
            // tags:
            //      public

            this._clipboardChangeWatcher = this.clipboard.watch("data", lang.hitch(this, this._onModelChange));
        },

        unwatchClipboardChange: function () {
            // summary:
            //      Clear the registered watch handler for command model change
            // tags:
            //      public

            this._clipboardChangeWatcher && this._clipboardChangeWatcher.unwatch();
        },

        // =======================================================================
        // Protected functions

        _clipboardDataGetter: function () {
            // summary:
            //      Return clipboard content item data
            // tags:
            //      protected

            return this._getClipboardData();
        },

        _clipboardTypeGetter: function () {
            // summary:
            //      Return clipboard content type
            // tags:
            //      protected

            return this._getClipboardData().type;
        },

        // =======================================================================
        // Private functions

        _getClipboardData: function () {
            // summary:
            //      Return clipboard data
            // tags:
            //      private

            if (!this.clipboard || !(this.clipboard.data instanceof Array)) {
                return null;
            }

            return this.clipboard.data;
        }

    });

});
},
'epi/shell/command/_SelectionCommandMixin':function(){
﻿define("epi/shell/command/_SelectionCommandMixin", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang"
],

function (
// dojo
    declare,
    lang
) {

    // module:
    //      epi/shell/command/_SelectionCommandMixin
    // summary:
    //      Stub to hanldes selection content for an instance of "epi.shell.command._Command" object
    // tags:
    //      public, mixin

    return declare(null, {

        // selection: [public] Object
        //      Hold information about selected content
        selection: null,

        // =======================================================================
        // Public overrided functions

        postscript: function () {
            // summary:
            //      Register a watch hanlder when the command change its model
            //      Watch model and initialize model dependent properties.
            // tags:
            //      public, overrides

            this.inherited(arguments);

            this.watchSelectionChange();
        },

        // =======================================================================
        // Public functions

        onRefreshSelection: function () {
            // summary:
            //      Stub to do somethings when selection refreshed
            // tags:
            //      public, callback
        },

        watchSelectionChange: function () {
            // summary:
            //      Register a watch hanlder when the command change its model
            // tags:
            //      public

            this._selectionChangeWatcher = this.selection.watch("data", lang.hitch(this, this._onModelChange));
        },

        unwatchSelectionChange: function () {
            // summary:
            //      Clear the registered watch handler for command model change
            // tags:
            //      public

            this._selectionChangeWatcher && this._selectionChangeWatcher.unwatch();
        },

        // =======================================================================
        // Protected functions

        _selectionDataGetter: function () {
            // summary:
            //      Return selection content item data
            // tags:
            //      protected

            var selectionData = this._getSelectionData();
            return selectionData != null && selectionData.type == "epi.cms.contentdata" ? selectionData.data : null;
        },

        _selectionTypeGetter: function () {
            // summary:
            //      Return selection type
            // tags:
            //      protected

            return this._getSelectionData().type;
        },

        // =======================================================================
        // Private functions

        _getSelectionData: function () {
            // summary:
            //      Return selection data
            // tags:
            //      private

            if (!this.selection || !(this.selection.data instanceof Array)) {
                return null;
            }

            return this.selection.data[0];
        }

    });

});
},
'epi-cms/widget/ContentSelectorDialog':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

// Dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",

// EPi
    "epi",
    "epi/shell/TypeDescriptorManager",

    "epi-cms/ApplicationSettings",
    "epi-cms/widget/ContentTree",
    "epi-cms/widget/ContextualContentForestStoreModel",

// EPi Framework
    "epi/shell/widget/_ActionProviderWidget",
    "epi/dependency",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentselectordialog"
],

function (
// Dojo
    array,
    declare,
    lang,
    when,

// Dijit
    _TemplatedMixin,
    _Widget,

// EPi
    epi,
    TypeDescriptorManager,

    ApplicationSettings,
    ContentTree,
    ContextualContentForestStoreModel,

// EPi Framework
    _ActionProviderWidget,
    dependency,

// Resources
    localization
) {

    // module:
    //      epi-cms/widget/ContentSelectorDialog
    // summary:
    //    Content selector widget.
    //
    // description:
    //    Used for editing PropertyPage properties in flyout editor.
    //
    // tags:
    //    public

    return declare([_Widget, _TemplatedMixin, _ActionProviderWidget], {

        // _contentRef: [private] epi.cms.core.ContentReference
        //    Reference to the currently selected content.
        _contentRef: null,

        // res: [private] Object
        //    Resource bundle.
        res: localization,

        // roots: [public] Array
        //    A list of references to the root contents.
        roots: null,

        // typeIdentifiers: [public] Array | String
        //    Type identifiers to filter.
        typeIdentifiers: null,

        showButtons: true,

        model: null,

        // canSelectOwnerContent: [private] Boolean
        //    Indicates whether select current owner content button should be available.
        canSelectOwnerContent: true,

        // multiRootsMode: [public] Boolean
        //      Indicate that multiple roots enabled in the tree or not
        multiRootsMode: false,

        // templateString: [protected] String
        //    Widget's template string.
        templateString: '<div><div data-dojo-attach-point="_treeNode"></div></div>',

        _typesToDisplay: null,

        // showAllLanguages: Boolean
        //      Flags to indicate that the content tree should show all content in multiple languages or not.
        showAllLanguages: false,

        // selectedContentType: String
        //      The content type which is selected. (used when restore content for instance)
        selectedContentType: null,

        buildRendering: function () {
            this.inherited(arguments);

            var typeIdentifiers = this._getTypesToDisplay(),
                model = this.model,
                roots = this.roots || (model && model.roots);

            this.preventContextualContentFor = this.preventContextualContentFor || this._getSettingFromContentType();
            if (!model || this.showContextualContent) {
                model = new ContextualContentForestStoreModel({
                    roots: roots,
                    typeIdentifiers: typeIdentifiers,
                    notSupportContextualContents: this.preventContextualContentFor,
                    showAllLanguages: this.showAllLanguages
                });
            }

            model.set("view", "contentselector");

            this.tree = new ContentTree({
                roots: roots,
                typeIdentifiers: typeIdentifiers,
                allowManipulation: false,
                model: model,
                expandExtraNodeItems: ApplicationSettings.startPage // Set extra node items to expand when the given tree loaded
            }, this._treeNode);

            this.connect(this.tree, "onClick", "_onTreeNodeClick");
        },

        _getSettingFromContentType: function () {
            // summary:
            //      Get preventContextualContentFor settings form selected content type
            // tags:
            //      private

            if (!this.selectedContentType) {
                return null;
            }
            var contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");

            var repositoryDescriptor,
                matchType = function (type) {
                    return TypeDescriptorManager.isBaseTypeIdentifier(this.selectedContentType, type);
                };
            for (var index in contentRepositoryDescriptors) {
                var descriptor = contentRepositoryDescriptors[index];
                if (array.some(descriptor.containedTypes, matchType, this)) {
                    repositoryDescriptor = descriptor;
                    break;
                }
            }

            return repositoryDescriptor.preventContextualContentFor;
        },
        
        _getTypesToDisplay: function () {
            if (!this._typesToDisplay) {

                var typesToDisplay = [];
                this._getContainerTypesRecursive(this.allowedTypes, typesToDisplay);
                this._typesToDisplay = typesToDisplay;
            }

            return this._typesToDisplay;
        },

        _getContainerTypesRecursive: function (types, results, checkedTypes) {
            if (!checkedTypes) {
                checkedTypes = [];
            }

            array.forEach(types, lang.hitch(this, function (type) {
                // To avoid infinite recursion, check if this type is already processed
                if (array.indexOf(checkedTypes, type) === -1) {
                    // Mark as checked
                    checkedTypes.push(type);

                    // Add the type itself if it isn't added already
                    if (array.indexOf(results, type) === -1) {
                        results.push(type);
                    }

                    // If there are any container types, process them as well
                    var containerTypesForType = TypeDescriptorManager.getValue(type, "containerTypes");

                    if (containerTypesForType) {
                        this._getContainerTypesRecursive(containerTypesForType, results, checkedTypes);
                    }
                }
            }));
        },

        _setValueAttr: function (value) {
            //summary:
            //    Value's setter.
            //
            // value: String
            //    Value to be set.
            //
            // tags:
            //    protected

            //construct ContentReference object
            if (value) {
                this._contentRef = value;
                var contentLinkToSelect = this._contentRef === '-' ? null : this._contentRef;

                if (this.multiRootsMode) {
                    // We need to wait until tree load top level children and then fire onLoad() event
                    when(this.tree.onLoadDeferred, lang.hitch(this, function() {
                        this.tree.selectContent(contentLinkToSelect);
                    }));
                } else {
                    if (!epi.isEmpty(contentLinkToSelect)) {
                        this.tree.selectContent(contentLinkToSelect);
                    }
                }
            }
            else {
                this._contentRef = null;
                this._clearSelectedContent();
            }
        },

        _getValueAttr: function () {
            //summary:
            //    Value's getter
            // tags:
            //    protected

            this.inherited(arguments);

            if (this._contentRef) {
                return this._contentRef.toString();
            }
            else {
                return '';
            }
        },

        _clearSelectedContent: function () {
            // summary:
            //      Clear selected node(s) in tree
            // tags:
            //      private

            this.tree.set("selectedNodes", []);
            this.tree.set("selectedItems", []);
        },

        getActions: function () {
            // summary:
            //      Overridden from _ActionProvider to get the select current owner content action added to the containing widget
            //
            // returns:
            //      An array contining a select page action definition, if it is not a shared block

            return this.canSelectOwnerContent ? [
                {
                    name: "selectpage",
                    label: localization.currentpage,
                    settings: { type: "submit" },
                    action: lang.hitch(this, function () {
                        this._setValueOwnerContent();
                    })
                }
            ]
            : [];
        },

        _onTreeNodeClick: function (content) {
            // summary:
            //    Handle the inner tree's content change event.
            //
            // content: Object
            //    The content object.
            //
            // tags:
            //    private

            var value = content.contentLink;

            var acceptedType = array.indexOf(this.allowedTypes, content.typeIdentifier) !== -1;

            if (!acceptedType) {
                //If it's not a direct match, check if the type inherits an accepted type.
                acceptedType = array.some(this.allowedTypes, function (type) {
                    return TypeDescriptorManager.isBaseTypeIdentifier(content.typeIdentifier, type);
                });
            }

            if(!acceptedType){
                this.tree.lastFocused.setSelected(false);
                value = null;
            }

            this.set('value', value);
            this.onChange(this.get('value'));
        },

        _setValueOwnerContent: function () {
            this.set('value', '-');
        },

        onChange: function (contentLink) {
            // summary:
            //    Fired when value is changed.
            //
            // contentLink:
            //    The content link
            // tags:
            //    public, callback
        },

        focus: function () {
            this.tree.focus();
        }

    });

});
},
'epi-cms/widget/ContentTree':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/connect", // To use isCopyKey()
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-style",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/Evented",

    "dojo/keys",
    "dojo/promise/all",
    "dojo/query",
    "dojo/sniff",
    "dojo/when",
// epi
    "epi/dependency",
    "epi/shell/dnd/tree/dndSource",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/Tree",

    "epi-cms/core/ContentReference",

    "epi-cms/widget/_ContentTreeNode",
    "epi-cms/widget/ContentTreeModelConfirmation",
    "epi-cms/widget/ContentForestStoreModel"
],

function (
// dojo
    array,
    connect, // To use isCopyKey()
    declare,
    lang,

    domClass,
    domStyle,

    aspect,
    Deferred,
    Evented,

    keys,
    promiseAll,
    query,
    sniff,
    when,
// epi
    dependency,
    dndSource,
    TypeDescriptorManager,
    Tree,

    ContentReference,

    _ContentTreeNode,
    ContentTreeModelConfirmation,
    ContentForestStoreModel
) {

    // module:
    //      epi-cms/widget/ContentTree
    // summary:
    //      The EPiServer content tree.
    // description:
    //      The page tree shows the EPiServer CMS page tree using a REST store to fetch the data.
    // tags:
    //      public

    return declare([Tree, Evented], {

        // roots: Array
        //      A list of references to the root nodes.
        roots: null,

        // expandExtraNodeItems: [public] Array|Integer
        //      A collection of content item id or one content item id need to expand by default.
        expandExtraNodeItems: null,

        // nodeConstructor: Function
        //      Tree node constructor. It should be a sub class of dijit.Tree._TreeNode
        nodeConstructor: null,

        // typeIdentifiers: String | Array
        //      Type identifier  filter.
        typeIdentifiers: null,

        // allowManipulation: Boolean
        //      Denotes if node manipulation is allowed.
        allowManipulation: true,

        // persist: Boolean
        //      Enables/disables use of cookies for state saving.
        persist: false,

        // expandOnDnd: [public] Boolean
        //      Enables/disables expand on a tree node when Dnd over it.
        expandOnDnd: true,

        // showRoot: [public] Boolean
        //      Flag that indicates whether the the root node should be displayed.
        showRoot: false,

        // handleSelection: [public] Boolean
        //      Flag that indicates this tree need to reset selection each time it had refresh
        handleSelection: false,

        postMixInProperties: function () {
            // summary:
            //      Post mixin initializations.
            // tags:
            //      protected

            this.inherited(arguments);

            if (!this.model) {
                this.model = this._createTreeModel();
            }

            if (this.allowManipulation) {
                this.dndController = dndSource;

                this.dndParams.push("accept");
                this.accept = this.model.containedTypes || this.containedTypes;//We allow dropping all types contained in the content repository, even if it's not displayed in the tree.
            }

            // make sure these get called with this class as context
            // otherwise context will be the dndController for the tree
            this.checkItemAcceptance = lang.hitch(this, this.checkItemAcceptance);

            this.nodeConstructor = this.nodeConstructor || _ContentTreeNode;
        },

        getItemType: function (item) {
            // summary:
            //      Resolve the type for each item. Called by the dnd source.

            return TypeDescriptorManager.getAndConcatenateValues(item.typeIdentifier, "dndTypes");
        },

        buildRendering: function () {
            // Wrap the model before build rendering
            this.model = this._wrapModel(this.model);

            this.inherited(arguments);
        },

        _wrapModel: function(model) {
            // summary:
            //      Wraps the model with a confirmation
            // tags:
            //      protected
            return ContentTreeModelConfirmation(this.model);
        },

        postCreate: function () {
            this.inherited(arguments);

            this.own(
                this.connect(this.model, "onSelect", lang.hitch(this, this._onSelect)),
                aspect.before(this.model, "onToggleContentDisplay", lang.hitch(this, function (/*String*/target, /*Boolean*/display) {
                    var targetContent = this.getNodesByItem(target)[0];
                    if (targetContent) {
                        domStyle.set(targetContent.domNode, {
                            "display": display === true ? "" : "none"
                        });
                    }
                }))
            );
        },

        onLoad: function () {
            // summary:
            //      Called when tree has finished loading and expanding.
            // tags:
            //      protected

            this.inherited(arguments);

            return when(this._expandRootNodes(), lang.hitch(this, this._expandExtraNodes));
        },

        _expandRootNodes: function () {
            // summary:
            //      Expand the root nodes by default
            // tags:
            //      private

            // Expand the root nodes by default.
            var nodes = this.showRoot ? [this.rootNode] : this.rootNode.getChildren();
            return promiseAll(array.map(nodes, this.tree._expandNode, this));
        },

        _expandExtraNodes: function () {
            // summary:
            //      Expand the given extra nodes by default
            // tags:
            //      private

            if (!this.expandExtraNodeItems) {
                return;
            }

            var expandExtraNodeItems = this.expandExtraNodeItems instanceof Array ? this.expandExtraNodeItems : [this.expandExtraNodeItems];

            var extraNodes = array.map(expandExtraNodeItems, function (item) {
                return this.tree.getNodesByItem(item)[0];
            }, this);

            // Filter out empty node from the given array.
            extraNodes = array.filter(extraNodes, Boolean);

            return promiseAll(array.map(extraNodes, this.tree._expandNode, this));
        },

        // gets propagated to dndSource
        checkItemAcceptance: function (targetNode, source, position) {
            // summary:
            //      Called from DnD to check if a specific target can accept the items in source

            var accept = true;

            var targetTreeNode = dijit.getEnclosingWidget(targetNode),
                target = targetTreeNode && targetTreeNode.item;

            if (!target) {
                return false;
            }

            source.forInSelectedItems(function (item) {
                // leave if we already found an item that failed
                if (!accept) {
                    return;
                }

                var data = item.data;
                if (data.dndData) {
                    data = data.dndData;
                }

                accept = this.model.canPaste(data, target);
            }, this);

            return accept;
        },

        _setAllowManipulationAttr: function (value) {
            // summary:
            //      setter of allowManipulation property.
            // tags:
            //      private

            this._set("allowManipulation", value);

            if (value) {
                this.dndController = dndSource;
            }
        },

        _createTreeModel: function () {
            // summary:
            //      Create content tree model
            // tags:
            //      protected

            return new ContentForestStoreModel({
                roots: this.roots,
                typeIdentifiers: this.typeIdentifiers
            });
        },

        _onItemDelete: function (/*Item*/item, /*boolean*/deleteChildren) {
            // summary:
            //      Override of dijit.Tree._onItemDelete to enable cleaning
            //      of the itemsNodeMap from children of the item being deleted.
            // tags:
            //      protected, override

            function flattenChildHierarchy(node, children) {
                array.forEach(node.getChildren(), function (child) {
                    children.push(child.item);
                    flattenChildHierarchy(child, children);
                });

                return children;
            }

            if (deleteChildren) {
                var treeNodes = this._itemNodesMap[this.model.getIdentity(item)];
                if (treeNodes) {
                    array.forEach(treeNodes, function (treeNode) {
                        array.forEach(flattenChildHierarchy(treeNode, []).reverse(), function (childItem) {
                            this._onItemDelete(childItem);
                        }, this);
                    }, this);
                }
            }

            this.inherited(arguments);
        },

        _setTypeIdentifiersAttr: function (value) {
            this._set("typeIdentifiers", value);

            if (this.model) {
                this.model.typeIdentifiers = value;
            }
        },

        buildNodeFromTemplate: function (args) {
            // summary:
            //      Build tree node from the given template.
            // args: Object
            //      Tree node creation arguments
            // tags:
            //      extension

            return new this.nodeConstructor(args);
        },

        _createTreeNode: function (/*Object*/args) {
            // summary:
            //      Overridable function to make tree node draggable after creation
            // args: Object
            //      Tree node creation arguments
            // tags:
            //      extension

            var params = lang.mixin({}, args, {
                dndData: args.item
            });

            return this.buildNodeFromTemplate(params);
        },

        getIconClass: function (/*dojo.data.Item*/item, /*Boolean*/opened) {
            // summary:
            //      Overridable function to return CSS class name to display icon
            // tags:
            //      extension

            if (!item) {
                return this.inherited(arguments);
            }

            var iconNodeClass = TypeDescriptorManager.getValue(item.typeIdentifier, "iconClass");
            if (this.model.isTypeOfRoot(item)) {
                return this.model.getObjectIconClass(item, iconNodeClass);
            }

            var supportsOpenCssClass = TypeDescriptorManager.getValue(item.typeIdentifier, "supportsOpenCssClass");

            if (opened && !item.isSubRoot && supportsOpenCssClass) {
                iconNodeClass = iconNodeClass + "Open";
            }

            return iconNodeClass;
        },

        focus: function () {
            // summary:
            //      Set focus to the widget.
            // tags:
            //      public

            this.focusNode(this.get("selectedNode") || this.rootNode);
        },

        _getTargetPath: function (/*String*/targetContent) {
            // summary:
            //      Get target content path
            // targetContent:
            //      Target content identity
            // tags:
            //      private

            var model = this.model,
                deferred = new Deferred();

            model.getAncestors(targetContent, function (ancestors) {
                // Path should include the target content, so push it onto the array for conversion.
                ancestors.push(targetContent);

                var targetPath = array.map(ancestors, function (item) {
                    return model.getIdentity(item).toString();
                });

                if (typeof model.filterAncestors === "function") {
                    targetPath = model.filterAncestors(targetPath);
                }

                deferred.resolve(targetPath);
            });

            return deferred.promise;
        },

        _isValidTargetContent: function (/*String*/content) {
            // summary:
            //      Validate target content before using
            // tags:
            //      private

            if (!content) {
                return false;
            }

            return !content.isDeleted && !content.isWastebasket;
        },

        _onSelect: function (id, setFocus, onComplete) {
            // summary:
            //      Raise event to set an item as selected
            // tags:
            //      private

            var selectedNode = this.get("selectedNode");
            this.tree.model.set("previousContextualSelection", {
                "selectedContent": selectedNode
            });

            this.selectContent(id, setFocus, true, onComplete).then(lang.hitch(this, function () {
                selectedNode = this.get("selectedNode");
                if (selectedNode && selectedNode.item && selectedNode.item.contentLink) {
                    this.emit("select", selectedNode.item, selectedNode);
                }
            }));
        },

        selectContent: function (contentReferenceAsString, setFocus, needParentRefresh, onComplete) {
            // summary:
            //      Select a given page.
            // return: a <c href="dojo.Deferred" /> object which when it resolves will return pageName
            // tags:
            //      public

            var self = this,
                model = self.model,
                deferred = new Deferred(),
                setPaths = function (paths) {
                    self._preparePathNodes(paths);
                    self._setRecursivePaths(paths, deferred, setFocus, onComplete);
                };

            when(model.store.get(contentReferenceAsString), function (content) {
                if (!self._isValidTargetContent(content)) {
                    // Remark: Is this needed any more?
                    self.set("paths", []);
                    deferred.resolve(null);
                } else {
                    self._getTargetPath(content).then(function (targetPath) {
                        self._onSetTargetPath();
                        setPaths(targetPath);
                    });
                }
            });

            return deferred.promise;
        },

        _onSetTargetPath: function () {
            // summary:
            //      Handles selection when set target path for the tree.
            // tags:
            //      private

            this.model.set("handleSelection", this.handleSelection);
            if (!this.handleSelection) {
                return;
            }

            var selectedNode = this.get("selectedNode");
            if (selectedNode) {
                // Get selected node one more time by getNodesByItem() function
                // in order to ensures that the node is existing in the tree.
                selectedNode = this.getNodesByItem(selectedNode.item)[0];
                if (selectedNode) {
                    this.model.set("previousSelection", {
                        selectedContent: selectedNode,
                        selectedAncestors: selectedNode.getTreePath()
                    });
                }
            }
        },

        _preparePathNodes: function (paths) {
            // summary:
            //      Prepare steps before node selection in the tree
            // tags:
            //      protected, extension
        },

        _setRecursivePaths: function (paths, deferred, setFocus, onComplete) {
            if (!paths || paths.length === 0) {
                return;
            }

            this.set("paths", [paths]).then(lang.hitch(this, function () {
                var selectedNode = this.get("selectedNode");
                if (!selectedNode) {
                    // We didn't find a node to select. Remove the last node in the path and try again.
                    this._setRecursivePaths(paths.slice(0, -1), deferred, setFocus, onComplete);

                    return;
                }

                if (setFocus) {
                    this.focus();
                }

                if (onComplete) {
                    onComplete(selectedNode);
                }

                deferred.resolve(selectedNode);
            }, deferred.reject));
        },

        _onKeyDown: function (item, e) {
            // summary:
            //      Handles onKeyDown event to process cut, copy, paste, delete action (non-printable characters).
            // e:
            //      Event object
            // tags:
            //      private

            this.inherited(arguments);

            if (!this.allowManipulation) {
                return;
            }

            if (connect.isCopyKey(e)) {
                var character = e.keyCode ? String.fromCharCode(e.keyCode).toLowerCase() : "";
                switch (character) {
                    case "c":
                        this.emit("copyOrCut", true);
                        break;
                    case "x":
                        this.emit("copyOrCut", false);
                        break;
                    case "v":
                        this.emit("paste");
                        break;
                    default:
                        break;
                }
            }

            // Catch DELETE key
            if (e.altKey || e.ctrlKey || e.shiftKey || e.metaKey) { return; }
            if (e.keyCode == keys.DELETE) {
                this.emit("delete");
            }
        },

        _onNodeMouseLeave: function (/* Tree._TreeNode */node, evt) {
            // summary:
            //      Handles mouse leave event on a node
            // tags:
            //      private

            this.inherited(arguments);

            // Remove dijitTreeRowHover class for all tree nodes when mouse leave on a node (in IE browser, dijitTreeRowHover css class added by _CssStateMixin did not removed)
            if (sniff("ie")) {
                array.forEach(query(".dijitTreeRow.dijitTreeRowHover", this.tree.domNode), function (node) {
                    domClass.remove(node, "dijitTreeRowHover");
                });
            }
        }

    });

});
},
'epi/shell/dnd/tree/dndSource':function(){
﻿define("epi/shell/dnd/tree/dndSource", [
	"dojo/_base/array", // array.forEach array.indexOf array.map
	"dojo/_base/connect", // isCopyKey
	"dojo/_base/declare", // declare
	"dojo/dom-class", // domClass.add
	"dojo/dom-geometry", // domGeometry.position
	"dojo/_base/lang", // lang.mixin lang.hitch
	"dojo/on", // subscribe
	"dojo/touch",
	"dojo/topic",
	"dojo/dnd/Manager",
    "dojo/when",
    "dijit/tree/dndSource",
    "../_DndDataMixin"
], function (array, connect, declare, domClass, domGeometry, lang, on, touch, topic, dndManager, when, dndSource, _DndDataMixin) {
    return declare([dndSource, _DndDataMixin], {
        // Summary:
        generateText: false,

        //	singular: Boolean
        //      Allows selection of only one element, if true.
        //      Tree hasn't been tested in singular=true mode, unclear if it works.
        singular: true,

        deleteSelectedNodes: function () {
            // Method needed to interact with other sources but should not do anyting
        },

        userSelect: function (node) {
            // Override CTRL and SHIFT key press parameters since we don't support multiple selection.
            this.inherited(arguments, [node, false, false]);
        },

        onDndDrop: function (source, nodes, copy, target) {
            // summary:
            //      Topic event processor for /dnd/drop, called to finish the DnD operation.
            // description:
            //      Updates data store items according to where node was dragged from and dropped
            //      to.   The tree will then respond to those data store updates and redraw itself.
            // source: Object
            //      The dijit.tree.dndSource / dojo.dnd.Source which is providing the items
            // nodes: DomNode[]
            //      The list of transferred items, dndTreeNode nodes if dragging from a Tree
            // copy: Boolean
            //      Copy items, if true, move items otherwise
            // tags:
            //      protected

            if (this.containerState == "Over") {
                var tree = this.tree,
                    model = tree.model,
                    targetAnchor = this.targetAnchor;

                this.isDragging = false;

                // Compute the new parent item
                var insertIndex;
                var newParentItem = (targetAnchor && targetAnchor.item) || tree.item;
                if (this.dropPosition == "Before" || this.dropPosition == "After") {
                    // Actually this should be checked during onMouseMove too, to make the drag icon red.
                    newParentItem = (targetAnchor.getParent() && targetAnchor.getParent().item) || tree.item;
                    // Compute the insert index for reordering
                    insertIndex = targetAnchor.getIndexInParent();
                    if (this.dropPosition == "After") {
                        insertIndex = targetAnchor.getIndexInParent() + 1;
                    }
                }

                // Get the hash to pass to model.newItem() / pasteItem().  A single call to
                // itemCreator() returns an array of hashes, one for each drag source node.
                var items = this.itemCreator(nodes, targetAnchor.rowNode, source, target);
                if (source == this) {
                    // This is a node from my own tree, and we are moving it, not copying.
                    // Remove item from old parent's children attribute.
                    // and this code should go there.

                    if (model.pasteItems) {
                        model.pasteItems(items, newParentItem, copy, insertIndex);
                    } else {
                        array.forEach(items, function(item) {
                            if (item.dndData) {
                                var options = item.dndData.options;
                                var oldParentItem = options ? options.oldParentItem : null;
                                var indexInParent = options ? options.indexInParent : 0;

                                if (typeof insertIndex == "number") {
                                    if (newParentItem == oldParentItem && indexInParent < insertIndex) {
                                        insertIndex -= 1;
                                    }
                                }

                                model.pasteItem(item.dndData.data, oldParentItem, newParentItem, copy, insertIndex);
                            }
                        });
                    }
                } else {
                    // Create new items in the tree, based on the drag source.
                    if (model.newItems) {
                        model.newItems(items, newParentItem, insertIndex);
                    } else {
                        array.forEach(items, function(item){
                            model.newItem(item, newParentItem, insertIndex);
                        });
                    }
                }

                // If both source and target have completed there event chains raise an onDndEnd.
                if (!source.isDragging && !target.isDragging) {
                    this.onDndEnd();
                }
            }

            //If the nodes has been droped in another target and copy is set to false, raise the onDndItemRemoved on the source if it supports it
            if (source !== target && !copy && source.onDndItemRemoved) {
                var dndData = array.map(nodes, function (node) {
                    return this._getDndData(source.getItem(node.id), this.accept, this === source);
                }, this);
                source.onDndItemRemoved(dndData, source, nodes, copy, target);
            }

            this.onDndCancel();
        },

        onMouseOut: function () {
            // summary:
            //      Event processor for when mouse is moved away from a TreeNode
            // tags:
            //      private

            this.inherited(arguments);

            if (this._expandOnDndTimeout) {
                clearTimeout(this._expandOnDndTimeout);
            }
        },

        _onDragMouse: function (e, firstTime) {
            // summary:
            //      Helper method for processing onmousemove/onmouseover events while drag is in progress.
            //      Keeps track of current drop target.
            // e: Event
            //      The mousemove event.
            // firstTime: Boolean?
            //      If this flag is set, this is the first mouse move event of the drag, so call m.canDrop() etc.
            //      even if newTarget == null because the user quickly dragged a node in the Tree to a position
            //      over Tree.containerNode but not over any TreeNode (#7971)

            this.inherited(arguments);

            // Double check for dropable ability in case checkItemAcceptance() returns deferred,
            // because base _onDragMouse() only works correctly with checkItemAcceptance() that returns boolean.
            var m = dndManager.manager();
            if (m.canDropFlag) {
                when(this.checkItemAcceptance(this.current.rowNode, m.source, null), function (accepted) {
                    m.canDrop(accepted);
                });
            }

            if (this._expandOnDndTimeout) {
                clearTimeout(this._expandOnDndTimeout);
            }

            // Expand the targetAnchor node (if it's currently collapsed) so the user can see
            // where their node was dropped.   In particular since that node is still selected.
            if (this.tree && this.tree.expandOnDnd === true && this.targetAnchor) {
                this._expandOnDndTimeout = setTimeout(lang.hitch(this, function () {
                    // Only try to expand target node when still dragging
                    this.isDragging && this.tree._expandNode(this.targetAnchor);
                }), 500);
            }
        },

        onDndEnd: function () {
            // summary:
            //      Event raised when both source and target have completed their drag events.
            // tags:
            //      callback
        },

        onDndItemRemoved: function (dndData, source, nodes, copy, target) {
            // summary:
            //      Called when the nodes has been removed from the source, i.e. droped in another target
            //
            // dndData:
            //    Dnd data extracted from the dragging items which have the same data type to the current target
            //
            // source:
            //    The dnd source.
            //
            // nodes:
            //    The dragging nodes.
            //
            // copy:
            //    Denote that the drag is copy.
            //
            // tags:
            //    public, event
        },

        itemCreator: function (nodes, targetNode, source, target) {
            // summary:
            //      Returns objects passed to `Tree.model.newItem()` based on DnD nodes
            //      dropped onto the tree.
            // description:
            //      For each node in nodes[], which came from source, create a hash of name/value
            //      pairs to be passed to Tree.model.newItem().  Returns array of those hashes.
            // nodes: DomNode[]
            // targetNode: DomNode
            // source: dojo/dnd/Source
            // target: dojo/dnd/Source
            // returns: __Item[]
            //      Array of name/value hashes for each new item to be added to the Tree
            // tags:
            //      extension
            return array.map(nodes, function (node) {
                return {
                    id: node.id,
                    name: node.textContent || node.innerText || "",
                    dndData: this._getDndData(source.getItem(node.id), this.accept, this === source)
                };
            }, this);
        },

        getItem: function (/*String*/key) {
            // summary:
            //      Returns the dojo.dnd.Item (representing a dragged node) by it's key (id).
            //      Called by dojo.dnd.Source.checkAcceptance().
            // tags:
            //      protected
            var item = this.inherited(arguments);

            // change drag type for the tree
            if (this.tree.getItemType && item && item.data && item.data.item) {
                item.type = this.tree.getItemType(item.data.item);
            }

            // add other options
            item.options = this.getItemOptions(item);

            return item;
        },

        getItemOptions: function (item) {
            // summary:
            //      Add options for each item. Called by getItem.

            var opts = {};
            if (item.data) {
                if (item.data.getParent) {
                    var oldParent = item.data.getParent();
                    opts.oldParentItem = oldParent ? oldParent.item : null;
                }

                if (item.data.getIndexInParent) {
                    opts.indexInParent = item.data.getIndexInParent();
                }
            }
            return opts;
        },

        onMouseDown: function (e) {
            // summary:
            //      Event processor for onmousedown/ontouchstart.
            //      Override this to prevent dnd when user mouses down on scroll bar.
            // e: Event
            //      onmousedown/ontouchend event
            // tags:
            //      protected override

            // Prevent drag/drop from happening when user mouses down on scrollbar.
            var isContainer = domClass.contains(e.target, "dojoDndContainerOver");
            if (isContainer) {
                return;
            }

            this.inherited(arguments);
        },

        checkAcceptance: function (source, nodes) {
            // summary:
            //		Checks if the target can accept nodes from this source.
            // source: Object
            //		The source which provides items.
            // nodes: Array
            //		The list of transferred items.

            if (this.readOnly) {
                return false;
            }

            var items = array.map(nodes, function (node) {
                return source.getItem(node.id);
            });

            return this._checkAcceptanceForItems(items, this.accept);
        }
    });
});
},
'dijit/tree/dndSource':function(){
define("dijit/tree/dndSource", [
	"dojo/_base/array", // array.forEach array.indexOf array.map
	"dojo/_base/connect", // isCopyKey
	"dojo/_base/declare", // declare
	"dojo/dom-class", // domClass.add
	"dojo/dom-geometry", // domGeometry.position
	"dojo/_base/lang", // lang.mixin lang.hitch
	"dojo/on", // subscribe
	"dojo/touch",
	"dojo/topic",
	"dojo/dnd/Manager", // DNDManager.manager
	"./_dndSelector"
], function(array, connect, declare, domClass, domGeometry, lang, on, touch, topic, DNDManager, _dndSelector){

// module:
//		dijit/tree/dndSource
// summary:
//		Handles drag and drop operations (as a source or a target) for `dijit.Tree`

/*=====
var __Item = {
	// summary:
	//		New item to be added to the Tree, like:
	// id: Anything
	id: "",
	// name: String
	name: ""
};
=====*/

var dndSource = declare("dijit.tree.dndSource", _dndSelector, {
	// summary:
	//		Handles drag and drop operations (as a source or a target) for `dijit.Tree`

	// isSource: Boolean
	//		Can be used as a DnD source.
	isSource: true,

	// accept: String[]
	//		List of accepted types (text strings) for the Tree; defaults to
	//		["text"]
	accept: ["text", "treeNode"],

	// copyOnly: [private] Boolean
	//		Copy items, if true, use a state of Ctrl key otherwise
	copyOnly: false,

	// dragThreshold: Number
	//		The move delay in pixels before detecting a drag; 5 by default
	dragThreshold: 5,

	// betweenThreshold: Integer
	//		Distance from upper/lower edge of node to allow drop to reorder nodes
	betweenThreshold: 0,

	// Flag used by Avatar.js to signal to generate text node when dragging
	generateText: true,

	constructor: function(/*dijit/Tree*/ tree, /*dijit/tree/dndSource*/ params){
		// summary:
		//		a constructor of the Tree DnD Source
		// tags:
		//		private
		if(!params){ params = {}; }
		lang.mixin(this, params);
		var type = params.accept instanceof Array ? params.accept : ["text", "treeNode"];
		this.accept = null;
		if(type.length){
			this.accept = {};
			for(var i = 0; i < type.length; ++i){
				this.accept[type[i]] = 1;
			}
		}

		// class-specific variables
		this.isDragging = false;
		this.mouseDown = false;
		this.targetAnchor = null;	// DOMNode corresponding to the currently moused over TreeNode
		this.targetBox = null;	// coordinates of this.targetAnchor
		this.dropPosition = "";	// whether mouse is over/after/before this.targetAnchor
		this._lastX = 0;
		this._lastY = 0;

		// states
		this.sourceState = "";
		if(this.isSource){
			domClass.add(this.node, "dojoDndSource");
		}
		this.targetState = "";
		if(this.accept){
			domClass.add(this.node, "dojoDndTarget");
		}

		// set up events
		this.topics = [
			topic.subscribe("/dnd/source/over", lang.hitch(this, "onDndSourceOver")),
			topic.subscribe("/dnd/start", lang.hitch(this, "onDndStart")),
			topic.subscribe("/dnd/drop", lang.hitch(this, "onDndDrop")),
			topic.subscribe("/dnd/cancel", lang.hitch(this, "onDndCancel"))
		];
	},

	// methods
	checkAcceptance: function(/*===== source, nodes =====*/){
		// summary:
		//		Checks if the target can accept nodes from this source
		// source: dijit/tree/dndSource
		//		The source which provides items
		// nodes: DOMNode[]
		//		Array of DOM nodes corresponding to nodes being dropped, dijitTreeRow nodes if
		//		source is a dijit/Tree.
		// tags:
		//		extension
		return true;	// Boolean
	},

	copyState: function(keyPressed){
		// summary:
		//		Returns true, if we need to copy items, false to move.
		//		It is separated to be overwritten dynamically, if needed.
		// keyPressed: Boolean
		//		The "copy" control key was pressed
		// tags:
		//		protected
		return this.copyOnly || keyPressed;	// Boolean
	},
	destroy: function(){
		// summary:
		//		Prepares the object to be garbage-collected.
		this.inherited(arguments);
		var h;
		while(h = this.topics.pop()){ h.remove(); }
		this.targetAnchor = null;
	},

	_onDragMouse: function(e, firstTime){
		// summary:
		//		Helper method for processing onmousemove/onmouseover events while drag is in progress.
		//		Keeps track of current drop target.
		// e: Event
		//		The mousemove event.
		// firstTime: Boolean?
		//		If this flag is set, this is the first mouse move event of the drag, so call m.canDrop() etc.
		//		even if newTarget == null because the user quickly dragged a node in the Tree to a position
		//		over Tree.containerNode but not over any TreeNode (#7971)

		var m = DNDManager.manager(),
			oldTarget = this.targetAnchor,			// the TreeNode corresponding to TreeNode mouse was previously over
			newTarget = this.current,				// TreeNode corresponding to TreeNode mouse is currently over
			oldDropPosition = this.dropPosition;	// the previous drop position (over/before/after)

		// calculate if user is indicating to drop the dragged node before, after, or over
		// (i.e., to become a child of) the target node
		var newDropPosition = "Over";
		if(newTarget && this.betweenThreshold > 0){
			// If mouse is over a new TreeNode, then get new TreeNode's position and size
			if(!this.targetBox || oldTarget != newTarget){
				this.targetBox = domGeometry.position(newTarget.rowNode, true);
			}
			if((e.pageY - this.targetBox.y) <= this.betweenThreshold){
				newDropPosition = "Before";
			}else if((e.pageY - this.targetBox.y) >= (this.targetBox.h - this.betweenThreshold)){
				newDropPosition = "After";
			}
		}

		if(firstTime || newTarget != oldTarget || newDropPosition != oldDropPosition){
			if(oldTarget){
				this._removeItemClass(oldTarget.rowNode, oldDropPosition);
			}
			if(newTarget){
				this._addItemClass(newTarget.rowNode, newDropPosition);
			}

			// Check if it's ok to drop the dragged node on/before/after the target node.
			if(!newTarget){
				m.canDrop(false);
			}else if(newTarget == this.tree.rootNode && newDropPosition != "Over"){
				// Can't drop before or after tree's root node; the dropped node would just disappear (at least visually)
				m.canDrop(false);
			}else{
				// Guard against dropping onto yourself (TODO: guard against dropping onto your descendant, #7140)
				var sameId = false;
				if(m.source == this){
					for(var dragId in this.selection){
						var dragNode = this.selection[dragId];
						if(dragNode.item === newTarget.item){
							sameId = true;
							break;
						}
					}
				}
				if(sameId){
					m.canDrop(false);
				}else if(this.checkItemAcceptance(newTarget.rowNode, m.source, newDropPosition.toLowerCase())
						&& !this._isParentChildDrop(m.source, newTarget.rowNode)){
					m.canDrop(true);
				}else{
					m.canDrop(false);
				}
			}

			this.targetAnchor = newTarget;
			this.dropPosition = newDropPosition;
		}
	},

	onMouseMove: function(e){
		// summary:
		//		Called for any onmousemove/ontouchmove events over the Tree
		// e: Event
		//		onmousemouse/ontouchmove event
		// tags:
		//		private
		if(this.isDragging && this.targetState == "Disabled"){ return; }
		this.inherited(arguments);
		var m = DNDManager.manager();
		if(this.isDragging){
			this._onDragMouse(e);
		}else{
			if(this.mouseDown && this.isSource &&
				 (Math.abs(e.pageX-this._lastX)>=this.dragThreshold || Math.abs(e.pageY-this._lastY)>=this.dragThreshold)){
				var nodes = this.getSelectedTreeNodes();
				if(nodes.length){
					if(nodes.length > 1){
						//filter out all selected items which has one of their ancestor selected as well
						var seen = this.selection, i = 0, r = [], n, p;
						nextitem: while((n = nodes[i++])){
							for(p = n.getParent(); p && p !== this.tree; p = p.getParent()){
								if(seen[p.id]){ //parent is already selected, skip this node
									continue nextitem;
								}
							}
							//this node does not have any ancestors selected, add it
							r.push(n);
						}
						nodes = r;
					}
					nodes = array.map(nodes, function(n){return n.domNode});
					m.startDrag(this, nodes, this.copyState(connect.isCopyKey(e)));
					this._onDragMouse(e, true);	// because this may be the only mousemove event we get before the drop
				}
			}
		}
	},

	onMouseDown: function(e){
		// summary:
		//		Event processor for onmousedown/ontouchstart
		// e: Event
		//		onmousedown/ontouchend event
		// tags:
		//		private
		this.mouseDown = true;
		this.mouseButton = e.button;
		this._lastX = e.pageX;
		this._lastY = e.pageY;
		this.inherited(arguments);
	},

	onMouseUp: function(e){
		// summary:
		//		Event processor for onmouseup/ontouchend
		// e: Event
		//		onmouseup/ontouchend event
		// tags:
		//		private
		if(this.mouseDown){
			this.mouseDown = false;
			this.inherited(arguments);
		}
	},

	onMouseOut: function(){
		// summary:
		//		Event processor for when mouse is moved away from a TreeNode
		// tags:
		//		private
		this.inherited(arguments);
		this._unmarkTargetAnchor();
	},

	checkItemAcceptance: function(/*===== target, source, position =====*/){
		// summary:
		//		Stub function to be overridden if one wants to check for the ability to drop at the node/item level
		// description:
		//		In the base case, this is called to check if target can become a child of source.
		//		When betweenThreshold is set, position="before" or "after" means that we
		//		are asking if the source node can be dropped before/after the target node.
		// target: DOMNode
		//		The dijitTreeRoot DOM node inside of the TreeNode that we are dropping on to
		//		Use dijit.getEnclosingWidget(target) to get the TreeNode.
		// source: dijit/tree/dndSource
		//		The (set of) nodes we are dropping
		// position: String
		//		"over", "before", or "after"
		// tags:
		//		extension
		return true;
	},

	// topic event processors
	onDndSourceOver: function(source){
		// summary:
		//		Topic event processor for /dnd/source/over, called when detected a current source.
		// source: Object
		//		The dijit/tree/dndSource / dojo/dnd/Source which has the mouse over it
		// tags:
		//		private
		if(this != source){
			this.mouseDown = false;
			this._unmarkTargetAnchor();
		}else if(this.isDragging){
			var m = DNDManager.manager();
			m.canDrop(false);
		}
	},
	onDndStart: function(source, nodes, copy){
		// summary:
		//		Topic event processor for /dnd/start, called to initiate the DnD operation
		// source: Object
		//		The dijit/tree/dndSource / dojo/dnd/Source which is providing the items
		// nodes: DomNode[]
		//		The list of transferred items, dndTreeNode nodes if dragging from a Tree
		// copy: Boolean
		//		Copy items, if true, move items otherwise
		// tags:
		//		private

		if(this.isSource){
			this._changeState("Source", this == source ? (copy ? "Copied" : "Moved") : "");
		}
		var accepted = this.checkAcceptance(source, nodes);

		this._changeState("Target", accepted ? "" : "Disabled");

		if(this == source){
			DNDManager.manager().overSource(this);
		}

		this.isDragging = true;
	},

	itemCreator: function(nodes /*===== , target, source =====*/){
		// summary:
		//		Returns objects passed to `Tree.model.newItem()` based on DnD nodes
		//		dropped onto the tree.   Developer must override this method to enable
		//		dropping from external sources onto this Tree, unless the Tree.model's items
		//		happen to look like {id: 123, name: "Apple" } with no other attributes.
		// description:
		//		For each node in nodes[], which came from source, create a hash of name/value
		//		pairs to be passed to Tree.model.newItem().  Returns array of those hashes.
		// nodes: DomNode[]
		// target: DomNode
		// source: dojo/dnd/Source
		// returns: __Item[]
		//		Array of name/value hashes for each new item to be added to the Tree
		// tags:
		//		extension

		// TODO: for 2.0 refactor so itemCreator() is called once per drag node, and
		// make signature itemCreator(sourceItem, node, target) (or similar).

		return array.map(nodes, function(node){
			return {
				"id": node.id,
				"name": node.textContent || node.innerText || ""
			};
		}); // Object[]
	},

	onDndDrop: function(source, nodes, copy){
		// summary:
		//		Topic event processor for /dnd/drop, called to finish the DnD operation.
		// description:
		//		Updates data store items according to where node was dragged from and dropped
		//		to.   The tree will then respond to those data store updates and redraw itself.
		// source: Object
		//		The dijit/tree/dndSource / dojo/dnd/Source which is providing the items
		// nodes: DomNode[]
		//		The list of transferred items, dndTreeNode nodes if dragging from a Tree
		// copy: Boolean
		//		Copy items, if true, move items otherwise
		// tags:
		//		protected
		if(this.containerState == "Over"){
			var tree = this.tree,
				model = tree.model,
				target = this.targetAnchor;

			this.isDragging = false;

			// Compute the new parent item
			var newParentItem;
			var insertIndex;
			var before;		// drop source before (aka previous sibling) of target
			newParentItem = (target && target.item) || tree.item;
			if(this.dropPosition == "Before" || this.dropPosition == "After"){
				// TODO: if there is no parent item then disallow the drop.
				// Actually this should be checked during onMouseMove too, to make the drag icon red.
				newParentItem = (target.getParent() && target.getParent().item) || tree.item;
				// Compute the insert index for reordering
				insertIndex = target.getIndexInParent();
				if(this.dropPosition == "After"){
					insertIndex = target.getIndexInParent() + 1;
					before = target.getNextSibling() && target.getNextSibling().item;
				}else{
					before = target.item;
				}
			}else{
				newParentItem = (target && target.item) || tree.item;
			}

			// If necessary, use this variable to hold array of hashes to pass to model.newItem()
			// (one entry in the array for each dragged node).
			var newItemsParams;

			array.forEach(nodes, function(node, idx){
				// dojo/dnd/Item representing the thing being dropped.
				// Don't confuse the use of item here (meaning a DnD item) with the
				// uses below where item means dojo.data item.
				var sourceItem = source.getItem(node.id);

				// Information that's available if the source is another Tree
				// (possibly but not necessarily this tree, possibly but not
				// necessarily the same model as this Tree)
				if(array.indexOf(sourceItem.type, "treeNode") != -1){
					var childTreeNode = sourceItem.data,
						childItem = childTreeNode.item,
						oldParentItem = childTreeNode.getParent().item;
				}

				if(source == this){
					// This is a node from my own tree, and we are moving it, not copying.
					// Remove item from old parent's children attribute.
					// TODO: dijit/tree/dndSelector should implement deleteSelectedNodes()
					// and this code should go there.

					if(typeof insertIndex == "number"){
						if(newParentItem == oldParentItem && childTreeNode.getIndexInParent() < insertIndex){
							insertIndex -= 1;
						}
					}
					model.pasteItem(childItem, oldParentItem, newParentItem, copy, insertIndex, before);
				}else if(model.isItem(childItem)){
					// Item from same model
					// (maybe we should only do this branch if the source is a tree?)
					model.pasteItem(childItem, oldParentItem, newParentItem, copy, insertIndex, before);
				}else{
					// Get the hash to pass to model.newItem().  A single call to
					// itemCreator() returns an array of hashes, one for each drag source node.
					if(!newItemsParams){
						newItemsParams = this.itemCreator(nodes, target.rowNode, source);
					}

					// Create new item in the tree, based on the drag source.
					model.newItem(newItemsParams[idx], newParentItem, insertIndex, before);
				}
			}, this);

			// Expand the target node (if it's currently collapsed) so the user can see
			// where their node was dropped.   In particular since that node is still selected.
			this.tree._expandNode(target);
		}
		this.onDndCancel();
	},

	onDndCancel: function(){
		// summary:
		//		Topic event processor for /dnd/cancel, called to cancel the DnD operation
		// tags:
		//		private
		this._unmarkTargetAnchor();
		this.isDragging = false;
		this.mouseDown = false;
		delete this.mouseButton;
		this._changeState("Source", "");
		this._changeState("Target", "");
	},

	// When focus moves in/out of the entire Tree
	onOverEvent: function(){
		// summary:
		//		This method is called when mouse is moved over our container (like onmouseenter)
		// tags:
		//		private
		this.inherited(arguments);
		DNDManager.manager().overSource(this);
	},
	onOutEvent: function(){
		// summary:
		//		This method is called when mouse is moved out of our container (like onmouseleave)
		// tags:
		//		private
		this._unmarkTargetAnchor();
		var m = DNDManager.manager();
		if(this.isDragging){
			m.canDrop(false);
		}
		m.outSource(this);

		this.inherited(arguments);
	},

	_isParentChildDrop: function(source, targetRow){
		// summary:
		//		Checks whether the dragged items are parent rows in the tree which are being
		//		dragged into their own children.
		//
		// source:
		//		The DragSource object.
		//
		// targetRow:
		//		The tree row onto which the dragged nodes are being dropped.
		//
		// tags:
		//		private

		// If the dragged object is not coming from the tree this widget belongs to,
		// it cannot be invalid.
		if(!source.tree || source.tree != this.tree){
			return false;
		}


		var root = source.tree.domNode;
		var ids = source.selection;

		var node = targetRow.parentNode;

		// Iterate up the DOM hierarchy from the target drop row,
		// checking of any of the dragged nodes have the same ID.
		while(node != root && !ids[node.id]){
			node = node.parentNode;
		}

		return node.id && ids[node.id];
	},

	_unmarkTargetAnchor: function(){
		// summary:
		//		Removes hover class of the current target anchor
		// tags:
		//		private
		if(!this.targetAnchor){ return; }
		this._removeItemClass(this.targetAnchor.rowNode, this.dropPosition);
		this.targetAnchor = null;
		this.targetBox = null;
		this.dropPosition = null;
	},

	_markDndStatus: function(copy){
		// summary:
		//		Changes source's state based on "copy" status
		this._changeState("Source", copy ? "Copied" : "Moved");
	}
});

/*=====
dndSource.__Item = __Item;
=====*/

return dndSource;
});

},
'epi/shell/widget/Tree':function(){
﻿define("epi/shell/widget/Tree", [
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom",

// Dijit
    "dijit/focus",
    "dijit/Tree"
],

function (
// Dojo
    array,
    declare,
    lang,
    dom,

// Dijit
    focus,
    Tree
) {

    // summary:
    //  Extends dijit.Tree with support for reloading expanded nodes
    //  by listening to the onItemChildrenReload event of the model.
    //  The subscriber needs to call getChildren to get the updated children collection

    return declare( Tree, {

        postCreate: function () {
            this.inherited(arguments);
            this.connect(this.model, "onItemChildrenReload", "_onChildrenReload");
        },

        _onChildrenReload: function (/*dojo.data.Item*/parent) {
            // summary:
            //      Processes notification of a change to an item's children
            // tags:
            //      private

            var identity = this.model.getIdentity(parent),
                parentNodes = this._itemNodesMap[identity];

            if (parentNodes) {
                if (array.some(parentNodes, function (node) { return node.state === "LOADED"; })) {
                    this.model.getChildren(parent, lang.hitch(this, function (newChildrenList) {
                        array.forEach(parentNodes, function (parentNode) {
                            parentNode.setChildItems(newChildrenList);
                        });

                        array.forEach(newChildrenList, function (child) {
                            // Update node's item
                            this.model.onChange(child);
                            // Recursive reload
                            this._onChildrenReload(child);
                        }, this);
                    }));
                } else {
                    // Maybe we process more than makeExpandable method
                    array.forEach(parentNodes, function (node) {
                        node.isExpandable = this.model.mayHaveChildren(node.item);
                        node._setExpando(false);
                    }, this);
                }
            }
        },

        _onItemChildrenChange: function() {
            // summary:
            //      Overridden in an effort to keep focus in the tree when the children changes.
            //      Since the tree detaches the nodes from the dom when refreshing children the
            //      focus will be lost

            var currentFocus = null;

            // Do we currently have focus
            if (focus.curNode && dom.isDescendant(focus.curNode, this.domNode))
            {
                currentFocus = focus.curNode;
            }

            this.inherited(arguments);

            // Try to restore focus to the tree
            if (currentFocus) {
                if (dom.isDescendant(currentFocus, this.domNode))
                {
                    currentFocus.focus();
                }else{
                    // We had focus but the previously focused node is not alive.
                    var node = this._getRootOrFirstNode();
                    if(node){
                        this.focusNode(node);
                    }
                }
            }
        }
    });

});
},
'epi-cms/widget/_ContentTreeNode':function(){
﻿define([
// dojo
    "dojo/_base/declare",

    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/string",

// dijit
    "dijit/Tree",
    "dijit/_TemplatedMixin",
// dojox
    "dojox/html/ellipsis",
// epi
    "epi-cms/widget/_ContentTreeNodeMixin",
// template
    "dojo/text!./templates/_ContentTreeNode.html"
],

function (
// dojo
    declare,
    domClass,
    domConstruct,
    string,

// dijit
    Tree,
    _TemplatedMixin,
// dojox
    htmlEllipsis,
// epi
    _ContentTreeNodeMixin,
// template
    templateString
) {

    // summary:
    //      A customized treenode for page tree
    // description:
    //      Redefine template string. Use <a> tag to be able to drag in IE
    // tags:
    //      protected

    return declare([Tree._TreeNode, _TemplatedMixin, _ContentTreeNodeMixin], {

        templateString: templateString,

        buildRendering: function () {
            this.inherited(arguments);

            domClass.add(this.labelNode, "dojoxEllipsis");
        },

        _setItemAttr: function (item) {

            this._set("item", item);
            this.set("dndData", item);

            if (item && item.thumbnailUrl) {
                var image = domConstruct.create("img", {
                    src: item.thumbnailUrl + string.substitute("?${0}", [new Date().getTime()]),
                    "class": "epi-thumbnail"
                });
                this.thumbnailNode.appendChild(image);
                domClass.add(this.contentNode, "epi-mediaContent");
            }

            this.inherited(arguments);
        }

    });

});
},
'dojox/html/ellipsis':function(){
define("dojox/html/ellipsis",["dojo/_base/kernel", "dojo/_base/lang", "dojo/_base/array", "dojo/_base/Color", "dojo/colors"], function(d){
	/*=====
	return {
		// summary:
		//		offers cross-browser support for text-overflow: ellipsis
		// description:
		//		Add "dojoxEllipsis" on any node that you want to ellipsis-ize. In order to function properly,
		//		the node with the dojoxEllipsis class set on it should be a child of a node with a defined width.
		//		It should also be a block-level element (i.e. `<div>`) - it will not work on td elements.
		//		NOTE: When using the dojoxEllipsis class within tables, the table needs to have the table-layout: fixed style
	};
	=====*/
	
	if(d.isFF < 7){ //TODO: feature detect text-overflow in computed style?
		// The delay (in ms) to wait so that we don't keep querying when many
		// changes happen at once - set config "dojoxFFEllipsisDelay" if you
		// want a different value
		var delay = 1;
		if("dojoxFFEllipsisDelay" in d.config){
			delay = Number(d.config.dojoxFFEllipsisDelay);
			if(isNaN(delay)){
				delay = 1;
			}
		}
		try{
			var createXULEllipsis = (function(){
				// Create our stub XUL elements for cloning later
				// NOTE: this no longer works as of FF 4.0:
				// https://developer.mozilla.org/En/Firefox_4_for_developers#Remote_XUL_support_removed
				var sNS = 'http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul';
				var xml = document.createElementNS(sNS, 'window');
				var label = document.createElementNS(sNS, 'description');
				label.setAttribute('crop', 'end');
				xml.appendChild(label);

				return function(/* Node */ n){
					// Summary:
					//		Given a node, it creates the XUL and sets its
					//		content so that it will have an ellipsis
					var x = xml.cloneNode(true);
					x.firstChild.setAttribute('value', n.textContent);
					n.innerHTML = '';
					n.appendChild(x);
				};
			})();
		}catch(e){}
		
		// Create our iframe elements for cloning later
		var create = d.create;
		var dd = d.doc;
		var dp = d.place;
		var iFrame = create("iframe", {className: "dojoxEllipsisIFrame",
					src: "javascript:'<html><head><script>if(\"loadFirebugConsole\" in window){window.loadFirebugConsole();}</script></head><body></body></html>'", style: {display: "none"}});
		var rollRange = function(/* W3C Range */ r, /* int? */ cnt){
			// summary:
			//		Rolls the given range back one character from the end
			// r: W3C Range
			//		The range to roll back
			// cnt: int?
			//		An optional number of times to roll back (defaults 1)
			if(r.collapsed){
				// Do nothing - we are already collapsed
				return;
			}
			if(cnt > 0){
				do{
					rollRange(r);
					cnt--;
				}while(cnt);
				return;
			}
			if(r.endContainer.nodeType == 3 && r.endOffset > 0){
				r.setEnd(r.endContainer, r.endOffset - 1);
			}else if(r.endContainer.nodeType == 3){
				r.setEndBefore(r.endContainer);
				rollRange(r);
				return;
			}else if(r.endOffset && r.endContainer.childNodes.length >= r.endOffset){
				var nCont = r.endContainer.childNodes[r.endOffset - 1];
				if(nCont.nodeType == 3){
					r.setEnd(nCont, nCont.length - 1);
				}else if(nCont.childNodes.length){
					r.setEnd(nCont, nCont.childNodes.length);
					rollRange(r);
					return;
				}else{
					r.setEndBefore(nCont);
					rollRange(r);
					return;
				}
			}else{
				r.setEndBefore(r.endContainer);
				rollRange(r);
				return;
			}
		};
		var createIFrameEllipsis = function(/* Node */ n){
			// summary:
			//		Given a node, it creates an iframe and and ellipsis div and
			//		sets up the connections so that they will work correctly.
			//		This function is used when createXULEllipsis is not able
			//		to be used (because there is markup within the node) - it's
			//		a bit slower, but does the trick
			var c = create("div", {className: "dojoxEllipsisContainer"});
			var e = create("div", {className: "dojoxEllipsisShown", style: {display: "none"}});
			n.parentNode.replaceChild(c, n);
			c.appendChild(n);
			c.appendChild(e);
			var i = iFrame.cloneNode(true);
			var ns = n.style;
			var es = e.style;
			var ranges;
			var resizeNode = function(){
				ns.display = "";
				es.display = "none";
				if(n.scrollWidth <= n.offsetWidth){ return; }
				var r = dd.createRange();
				r.selectNodeContents(n);
				ns.display = "none";
				es.display = "";
				var done = false;
				do{
					var numRolls = 1;
					dp(r.cloneContents(), e, "only");
					var sw = e.scrollWidth, ow = e.offsetWidth;
					done = (sw <= ow);
					var pct = (1 - ((ow * 1) / sw));
					if(pct > 0){
						numRolls = Math.max(Math.round(e.textContent.length * pct) - 1, 1);
					}
					rollRange(r, numRolls);
				}while(!r.collapsed && !done);
			};
			i.onload = function(){
				i.contentWindow.onresize = resizeNode;
				resizeNode();
			};
			c.appendChild(i);
		};

		// Function for updating the ellipsis
		var hc = d.hasClass;
		var doc = d.doc;
		var s, fn, opt;
		if(doc.querySelectorAll){
			s = doc;
			fn = "querySelectorAll";
			opt = ".dojoxEllipsis";
		}else if(doc.getElementsByClassName){
			s = doc;
			fn = "getElementsByClassName";
			opt = "dojoxEllipsis";
		}else{
			s = d;
			fn = "query";
			opt = ".dojoxEllipsis";
		}
		fx = function(){
			d.forEach(s[fn].apply(s, [opt]), function(n){
				if(!n || n._djx_ellipsis_done){ return; }
				n._djx_ellipsis_done = true;
				if(createXULEllipsis && n.textContent == n.innerHTML && !hc(n, "dojoxEllipsisSelectable")){
					// We can do the faster XUL version, instead of calculating
					createXULEllipsis(n);
				}else{
					createIFrameEllipsis(n);
				}
			});
		};
		
		d.addOnLoad(function(){
			// Apply our initial stuff
			var t = null;
			var c = null;
			var connFx = function(){
				if(c){
					// disconnect us - so we don't fire anymore
					d.disconnect(c);
					c = null;
				}
				if(t){ clearTimeout(t); }
				t = setTimeout(function(){
					t = null;
					fx();
					// Connect to the modified function so that we can catch
					// our next change
					c = d.connect(d.body(), "DOMSubtreeModified", connFx);
				}, delay);
			};
			connFx();
		});
	}
});

},
'dojo/colors':function(){
define("dojo/colors", ["./_base/kernel", "./_base/lang", "./_base/Color", "./_base/array"], function(dojo, lang, Color, ArrayUtil){
	// module:
	//		dojo/colors

	/*=====
	return {
		// summary:
		//		Color utilities, extending Base dojo.Color
	};
	=====*/

	var ColorExt = {};
	lang.setObject("dojo.colors", ColorExt);

//TODO: this module appears to break naming conventions

	// this is a standard conversion prescribed by the CSS3 Color Module
	var hue2rgb = function(m1, m2, h){
		if(h < 0){ ++h; }
		if(h > 1){ --h; }
		var h6 = 6 * h;
		if(h6 < 1){ return m1 + (m2 - m1) * h6; }
		if(2 * h < 1){ return m2; }
		if(3 * h < 2){ return m1 + (m2 - m1) * (2 / 3 - h) * 6; }
		return m1;
	};
	// Override base Color.fromRgb with the impl in this module
	dojo.colorFromRgb = Color.fromRgb = function(/*String*/ color, /*dojo/_base/Color?*/ obj){
		// summary:
		//		get rgb(a) array from css-style color declarations
		// description:
		//		this function can handle all 4 CSS3 Color Module formats: rgb,
		//		rgba, hsl, hsla, including rgb(a) with percentage values.
		var m = color.toLowerCase().match(/^(rgba?|hsla?)\(([\s\.\-,%0-9]+)\)/);
		if(m){
			var c = m[2].split(/\s*,\s*/), l = c.length, t = m[1], a;
			if((t == "rgb" && l == 3) || (t == "rgba" && l == 4)){
				var r = c[0];
				if(r.charAt(r.length - 1) == "%"){
					// 3 rgb percentage values
					a = ArrayUtil.map(c, function(x){
						return parseFloat(x) * 2.56;
					});
					if(l == 4){ a[3] = c[3]; }
					return Color.fromArray(a, obj); // dojo/_base/Color
				}
				return Color.fromArray(c, obj); // dojo/_base/Color
			}
			if((t == "hsl" && l == 3) || (t == "hsla" && l == 4)){
				// normalize hsl values
				var H = ((parseFloat(c[0]) % 360) + 360) % 360 / 360,
					S = parseFloat(c[1]) / 100,
					L = parseFloat(c[2]) / 100,
					// calculate rgb according to the algorithm
					// recommended by the CSS3 Color Module
					m2 = L <= 0.5 ? L * (S + 1) : L + S - L * S,
					m1 = 2 * L - m2;
				a = [
					hue2rgb(m1, m2, H + 1 / 3) * 256,
					hue2rgb(m1, m2, H) * 256,
					hue2rgb(m1, m2, H - 1 / 3) * 256,
					1
				];
				if(l == 4){ a[3] = c[3]; }
				return Color.fromArray(a, obj); // dojo/_base/Color
			}
		}
		return null;	// dojo/_base/Color
	};

	var confine = function(c, low, high){
		// summary:
		//		sanitize a color component by making sure it is a number,
		//		and clamping it to valid values
		c = Number(c);
		return isNaN(c) ? high : c < low ? low : c > high ? high : c;	// Number
	};

	Color.prototype.sanitize = function(){
		// summary:
		//		makes sure that the object has correct attributes
		var t = this;
		t.r = Math.round(confine(t.r, 0, 255));
		t.g = Math.round(confine(t.g, 0, 255));
		t.b = Math.round(confine(t.b, 0, 255));
		t.a = confine(t.a, 0, 1);
		return this;	// dojo/_base/Color
	};

	ColorExt.makeGrey = Color.makeGrey = function(/*Number*/ g, /*Number?*/ a){
		// summary:
		//		creates a greyscale color with an optional alpha
		return Color.fromArray([g, g, g, a]);	// dojo/_base/Color
	};

	// mixin all CSS3 named colors not already in _base, along with SVG 1.0 variant spellings
	lang.mixin(Color.named, {
		"aliceblue":	[240,248,255],
		"antiquewhite": [250,235,215],
		"aquamarine":	[127,255,212],
		"azure":	[240,255,255],
		"beige":	[245,245,220],
		"bisque":	[255,228,196],
		"blanchedalmond":	[255,235,205],
		"blueviolet":	[138,43,226],
		"brown":	[165,42,42],
		"burlywood":	[222,184,135],
		"cadetblue":	[95,158,160],
		"chartreuse":	[127,255,0],
		"chocolate":	[210,105,30],
		"coral":	[255,127,80],
		"cornflowerblue":	[100,149,237],
		"cornsilk": [255,248,220],
		"crimson":	[220,20,60],
		"cyan": [0,255,255],
		"darkblue": [0,0,139],
		"darkcyan": [0,139,139],
		"darkgoldenrod":	[184,134,11],
		"darkgray": [169,169,169],
		"darkgreen":	[0,100,0],
		"darkgrey": [169,169,169],
		"darkkhaki":	[189,183,107],
		"darkmagenta":	[139,0,139],
		"darkolivegreen":	[85,107,47],
		"darkorange":	[255,140,0],
		"darkorchid":	[153,50,204],
		"darkred":	[139,0,0],
		"darksalmon":	[233,150,122],
		"darkseagreen": [143,188,143],
		"darkslateblue":	[72,61,139],
		"darkslategray":	[47,79,79],
		"darkslategrey":	[47,79,79],
		"darkturquoise":	[0,206,209],
		"darkviolet":	[148,0,211],
		"deeppink": [255,20,147],
		"deepskyblue":	[0,191,255],
		"dimgray":	[105,105,105],
		"dimgrey":	[105,105,105],
		"dodgerblue":	[30,144,255],
		"firebrick":	[178,34,34],
		"floralwhite":	[255,250,240],
		"forestgreen":	[34,139,34],
		"gainsboro":	[220,220,220],
		"ghostwhite":	[248,248,255],
		"gold": [255,215,0],
		"goldenrod":	[218,165,32],
		"greenyellow":	[173,255,47],
		"grey": [128,128,128],
		"honeydew": [240,255,240],
		"hotpink":	[255,105,180],
		"indianred":	[205,92,92],
		"indigo":	[75,0,130],
		"ivory":	[255,255,240],
		"khaki":	[240,230,140],
		"lavender": [230,230,250],
		"lavenderblush":	[255,240,245],
		"lawngreen":	[124,252,0],
		"lemonchiffon": [255,250,205],
		"lightblue":	[173,216,230],
		"lightcoral":	[240,128,128],
		"lightcyan":	[224,255,255],
		"lightgoldenrodyellow": [250,250,210],
		"lightgray":	[211,211,211],
		"lightgreen":	[144,238,144],
		"lightgrey":	[211,211,211],
		"lightpink":	[255,182,193],
		"lightsalmon":	[255,160,122],
		"lightseagreen":	[32,178,170],
		"lightskyblue": [135,206,250],
		"lightslategray":	[119,136,153],
		"lightslategrey":	[119,136,153],
		"lightsteelblue":	[176,196,222],
		"lightyellow":	[255,255,224],
		"limegreen":	[50,205,50],
		"linen":	[250,240,230],
		"magenta":	[255,0,255],
		"mediumaquamarine": [102,205,170],
		"mediumblue":	[0,0,205],
		"mediumorchid": [186,85,211],
		"mediumpurple": [147,112,219],
		"mediumseagreen":	[60,179,113],
		"mediumslateblue":	[123,104,238],
		"mediumspringgreen":	[0,250,154],
		"mediumturquoise":	[72,209,204],
		"mediumvioletred":	[199,21,133],
		"midnightblue": [25,25,112],
		"mintcream":	[245,255,250],
		"mistyrose":	[255,228,225],
		"moccasin": [255,228,181],
		"navajowhite":	[255,222,173],
		"oldlace":	[253,245,230],
		"olivedrab":	[107,142,35],
		"orange":	[255,165,0],
		"orangered":	[255,69,0],
		"orchid":	[218,112,214],
		"palegoldenrod":	[238,232,170],
		"palegreen":	[152,251,152],
		"paleturquoise":	[175,238,238],
		"palevioletred":	[219,112,147],
		"papayawhip":	[255,239,213],
		"peachpuff":	[255,218,185],
		"peru": [205,133,63],
		"pink": [255,192,203],
		"plum": [221,160,221],
		"powderblue":	[176,224,230],
		"rosybrown":	[188,143,143],
		"royalblue":	[65,105,225],
		"saddlebrown":	[139,69,19],
		"salmon":	[250,128,114],
		"sandybrown":	[244,164,96],
		"seagreen": [46,139,87],
		"seashell": [255,245,238],
		"sienna":	[160,82,45],
		"skyblue":	[135,206,235],
		"slateblue":	[106,90,205],
		"slategray":	[112,128,144],
		"slategrey":	[112,128,144],
		"snow": [255,250,250],
		"springgreen":	[0,255,127],
		"steelblue":	[70,130,180],
		"tan":	[210,180,140],
		"thistle":	[216,191,216],
		"tomato":	[255,99,71],
		"turquoise":	[64,224,208],
		"violet":	[238,130,238],
		"wheat":	[245,222,179],
		"whitesmoke":	[245,245,245],
		"yellowgreen":	[154,205,50]
	});

	return Color;	// TODO: return ColorExt, not Color
});

},
'epi-cms/widget/_ContentTreeNodeMixin':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",

    "epi-cms/ContentLanguageHelper"
],

function (
    declare,
    lang,
    when,

    domAttr,
    domClass,
    domConstruct,

    ContentLanguageHelper
) {

    // module:
    //      epi-cms/widget/_ContentTreeNodeMixin
    // summary:
    //      Stubs to handler common functions for tree
    // tags:
    //      public

    return declare(null, {

        _missingLanguageCssClass: "epi-ct-missingLanguageRow",

        // =======================================================================
        // Protected overrided functions

        _updateItemClasses: function ( /*Item*/item) {
            // summary:
            //      Override dijit._TreeNode._updateItemClasses function
            //
            //      Set appropriate CSS classes for icon and label dom node
            //      (used to allow for item updates to change respective CSS)
            // tags:
            //      protected, override

            this.inherited(arguments);

            this._updateLayout();
        },

        _updateLayout: function () {
            // summary:
            //      Override dijit._TreeNode._updateLayout function
            //
            //      Set appropriate CSS classes for this.domNode
            // tags:
            //      protected, override

            this.inherited(arguments);

            this._updateLanguageIndicator();
            this._updateIndividualLayout();
        },

        // =======================================================================
        // Protected functions

        _updateIndividualLayout: function () {
            // summary:
            //      Update tree node layout for individual case
            // tags:
            //      protected, extension
        },

        _addLanguageIndicator: function () {
            // summary:
            //      Setup missing language branch indicator UI
            // tags:
            //      protected

            var missingLanguageBranch = this.item.missingLanguageBranch;

            if (this.iconNodeLanguage) {
                this.iconNodeLanguage.innerHTML = missingLanguageBranch.language || "";
                when(ContentLanguageHelper.getMissingLanguageMessage(this.item), lang.hitch(this, function (message) {
                    domAttr.set(this.iconNodeLanguage, "title", message || "");
                }));
            }

            domClass.add(this.rowNode, this._missingLanguageCssClass);
        },

        _removeLanguageIndicator: function () {
            // summary:
            //      Remove all settings for language indicator
            // tags:
            //      protected

            if (this.iconNodeLanguage) {
                domConstruct.empty(this.iconNodeLanguage);
                domAttr.remove(this.iconNodeLanguage, "title");
            }
            domClass.remove(this.rowNode, this._missingLanguageCssClass);
        },

        _updateLanguageIndicator: function () {
            // summary:
            //      Set language indicator for the tree node
            // tags:
            //      protected

            if (!this._isTypeOfRoot() && this.item.missingLanguageBranch) {
                this._addLanguageIndicator();
            } else {
                this._removeLanguageIndicator();
            }

        },

        _isTypeOfRoot: function () {
            // summary:
            //      Verifies the current tree node item data object is type of root or not
            // returns: [Boolean]
            // tags:
            //      protected

            if (!this.tree.model || typeof this.tree.model.isTypeOfRoot !== "function") {
                return false;
            }

            return this.tree.model.isTypeOfRoot(this.item);
        }

    });

});
},
'epi-cms/ContentLanguageHelper':function(){
define("epi-cms/ContentLanguageHelper", [
    "dojo/_base/lang",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/promise/all",

    "epi/dependency",
    "epi/shell/TypeDescriptorManager"
], function(lang, declare, Deferred, all, dependency, TypeDescriptorManager) {

    // module:
    //      epi-cms/ContentLanguageHelper
    // summary:
    //      Helper methods for working with content languages
    return {
        getMissingLanguageMessage: function (contentItem) {
            // summary:
            //      Gets a user friendly message explaining why the language is missing
            // contentItem: Object
            //      The content item to read the missing language information from
            // tags:
            //      public
            if (!contentItem || !contentItem.missingLanguageBranch) {
                return "";
            }

            this._languageStore = this._languageStore || dependency.resolve("epi.storeregistry").get("epi.cms.language");

            var def = new Deferred();

            var missingLanguageBranch = contentItem.missingLanguageBranch;

            all([this._languageStore.get(missingLanguageBranch.preferredLanguage),
                this._languageStore.get(missingLanguageBranch.language)
            ]).then(lang.hitch(this, function(languages) {

                var reason = missingLanguageBranch.reason;
                var resourceKey = "languagenotifications.";
                if (reason === 6) {
                    // None
                    resourceKey += "missing";
                } else if (reason === 3 || reason === 5) {
                    //Replacement or ReplacementFallback
                    resourceKey += "replacement";
                } else if (reason === 4) {
                    //Fallback
                    resourceKey += "fallback";
                }

                var resourceValue = TypeDescriptorManager.getResourceValue(contentItem.typeIdentifier, resourceKey);
                resourceValue = lang.replace(resourceValue, [languages[0].name, languages[1].name]);

                def.resolve(resourceValue);

            }), function() {
                def.resolve("");
            });
            return def;
        }
    };
});
},
'url:epi-cms/widget/templates/_ContentTreeNode.html':"﻿<div class=\"dijitTreeNode\" role=\"presentation\">\r\n    <a href=\"#\" tabindex=\"-1\" data-dojo-attach-point=\"rowNode\" class=\"dijitTreeRow\" role=\"presentation\">\r\n        <div data-dojo-attach-point=\"indentNode\" class=\"dijitInline\"></div>\r\n        <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n            <span data-dojo-attach-point=\"expandoNode\" class=\"dijitTreeExpando\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"expandoNodeText\" class=\"dijitExpandoText\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon\" role=\"presentation\"></span>            \r\n            <span data-dojo-attach-point=\"thumbnailNode\" class=\"epi-thumbnailIcon\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-extraIconsContainer\" role=\"presentation\">\r\n                <span data-dojo-attach-point=\"iconNodeLanguage\" class=\"epi-extraIcon epi-pt-currentLanguageMissing\" role=\"presentation\">&nbsp;</span>\r\n            </span>\r\n            <span data-dojo-attach-point=\"labelNode\" class=\"dijitTreeLabel\" role=\"treeitem\" tabindex=\"-1\" aria-selected=\"false\"></span>\r\n        </span>\r\n    </a>\r\n    <div data-dojo-attach-point=\"containerNode\" class=\"dijitTreeContainer\" role=\"presentation\" style=\"display: none;\"></div>\r\n</div>",
'epi-cms/widget/ContentTreeModelConfirmation':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/string",
    "dojo/when",
    "dojo/_base/json",

// dojox
    "dojox/html/entities",

// epi
    "epi/dependency",
    "epi/string",

    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/dialog/Alert",
    "epi/shell/widget/dialog/Confirmation",

    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/widget/sharedContentDialogHandler",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.pagetree"
],

function (
// dojo
    declare,
    lang,

    aspect,
    Deferred,
    string,
    when,
    json,

// dojox
    htmlEntities,

// epi
    dependency,
    epistring,

    TypeDescriptorManager,
    Alert,
    Confirmation,

    ContentActionSupport,
    sharedContentDialogHandler,
    res
) {

    return function (model) {
        // summary:
        //      Attaches confirmation to the pasteItem method of a dijit.tree.model instance.
        //      Looks at the paste parameters to show a confirmation before delting or moving items.

        // NOTE: This pattern isn't really that nice, since it alters the aspect.around actually alters the underlying store.
        //      It's probably a better idea to use delegation, but that requires us to -implement set() and _set() to get
        //      model property changes updated on the underlying model and not the delegating facade.

        var _isFunction = function (object) {
            return object && typeof object == "function";
        };

        var _showNotification = function (message, callback) {
            // summary:
            //      Uses the alert dialog implementation to notify with the supplied message
            var dialog = new Alert({
                destroyOnHide: true,
                description: epistring.toHTML(message),
                onAction: function () {
                    if (_isFunction(callback)) {
                        callback();
                    }
                }
            });

            dialog.show();
        };

        var _showConfirmation = function (title, confirmationMessage) {
            // summary:
            //      Wrap epi.shell.widget.dialog.Confirmation for short type
            //      and return deferred object
            // confirmQuestion:
            //      String / Deferred : Text to display on dialog
            // tags:
            //		private
            var deferred = new Deferred();

            when(confirmationMessage, function (message) {
                var dialog = new Confirmation({
                    destroyOnHide: true,
                    description: epistring.toHTML(message),
                    title: title,
                    onAction: function (confirmed) {
                        confirmed ? deferred.resolve() : deferred.cancel();
                    }
                });
                dialog.show();
            });

            return deferred;
        };

        var onResponse = function (result, callback) {
            // Checks the result of a call to pasteItem and shows error messages if result indicates a failure
            when(result,
                function (serverResponse) {
                    if (serverResponse && (serverResponse.message || serverResponse.statusDescription)) {
                        var message = serverResponse.message || serverResponse.statusDescription;
                        _showNotification(message, callback);
                    } else {
                        if (_isFunction(callback)) {
                            callback();
                        }
                    }
                },
                function (e) {
                    _showNotification(htmlEntities.encode(json.fromJson(e.xhr.responseText)));
                });
            return result;
        };

        aspect.around(model, "pasteItem", function (originalMethod) {
            return function (source, oldParent, newParent, copy, sortIndex) {

                var moveTitle = TypeDescriptorManager.getResourceValue(source.typeIdentifier, "move");
                // Defaulting confirmation to an affirmative response in case we don't need a confirmation
                var confirmation = true;

                if (newParent.isWastebasket) {
                    confirmation = sharedContentDialogHandler({ contentData: source });
                }
                else if (sortIndex !== undefined && (newParent.properties.pageChildOrderRule !== ContentActionSupport.sortOrder.Index)) {

                    // Page is copied/moved and sorted and the new parent sorting rule must be changed
                    var message = string.substitute(res.changepeerorderconfirmation, [model.getLabel(newParent)]);
                    confirmation = _showConfirmation(moveTitle, message);
                }
                else if (!copy) {
                    if (!model.canCut(source)) {
                        _showNotification(TypeDescriptorManager.getResourceValue(source.typeIdentifier, "moverequiresdeleteaccess"), function () {
                            return false;
                        });
                        return;
                    }

                    // Plain move
                    confirmation = _showConfirmation(moveTitle, TypeDescriptorManager.getResourceValue(source.typeIdentifier, "moveconfirmation"));
                } else if (!model.canCopy(source)) {
                    _showNotification(TypeDescriptorManager.getResourceValue(source.typeIdentifier, "copynotsupported"));
                    return;
                }

                var pasteArguments = arguments;
                return when(confirmation, function () {
                    // Call pasteItem of the model
                    return originalMethod.apply(model, pasteArguments);
                }, function () { return false; });
            };
        });

        aspect.after(model, "pasteItem", function (result) {
            return result && onResponse(result);
        });

        aspect.after(model, "remove", function (result) {
            return result && onResponse(result);
        });

        return model;
    };

});
},
'epi-cms/contentediting/ContentActionSupport':function(){
﻿define([
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.versionstatus"
],

function (
// resources
    res
) {

    var versionLocalizations = [];

    if (res) {
        versionLocalizations = [
            res.notcreated,
            res.rejected,
            res.checkedout,
            res.checkedin,
            res.published,
            res.previouslypublished,
            res.delayedpublish,
            res.expired
        ];
    }

    var actionSupport = {
        // summary:
        //    This class helps dealing with the content data structure:
        //      * decode the access level mask provided by content data store
        //      * determine if an action is supported for a given version statuse
        // tags:
        //    public static

        // versionStatus: Object
        //      Version status codes used in contentContext.status
        versionStatus: {
            NotCreated: 0,
            Rejected: 1,
            CheckedOut: 2,
            CheckedIn: 3,
            Published: 4,
            PreviouslyPublished: 5,
            DelayedPublish: 6,
            Expired: 7
        },

        versionLocalizations: versionLocalizations,

        getVersionStatus: function (status) {
            return this.versionLocalizations[status];
        },

        // action: Object
        //      Known actions on a contentData object
        action: {
            Create: "Create",
            Edit: "Edit",
            Delete: "Delete",
            CheckIn: "CheckIn",
            Save: "Save",
            Reject: "Reject",
            Publish: "Publish",
            Administer: "Administer"
        },

        // accessLevel: Object
        //      Access level components of the contentContext.accessMask bitmask.
        accessLevel: {
            NoAccess: 0,
            Read: 1,
            Create: 2,
            Edit: 4,
            CheckIn: 4,
            Delete: 8,
            Publish: 16,
            Administer: 32,
            FullAccess: 63
        },

        // saveAction: Object
        //      Options available when saving content
        saveAction: {
            /// Do not save data.
            None: 0x0,
            /// Save a page, leaving it in a checked out state.
            Save: 0x1,
            /// Save and check in page, creating a new version only if necessary.
            CheckIn: 0x2,
            /// Publish page, creating a new version only if necessary.
            Publish: 0x3,
            /// Reject a checked-in page.
            Reject: 0x4,
            /// Flag that is used to force the creation of a new version.
            ForceNewVersion: 0x80,
            /// Save and check in page, always updating the current version
            ForceCurrentVersion: 0x100,
            /// Does not validate the data against <see cref:"EPiServer.Validation.IValidationService"/>
            SkipValidation: 0x200,
            /// Save and check in page, creating a new version only if necessary and sets the content as delayed publish.
            DelayedPublish: 0x400
        },

        // sortOrder: Object
        //      Sort order of contentData, need to verify when change
        sortOrder: {
            None: 0,
            CreatedDescending: 1,
            CreatedAscending: 2,
            Alphabetical: 3,
            Index: 4,
            ChangedDescending: 5,
            Rank: 6,
            PublishedAscending: 7,
            PublishedDescending: 8
        },

        // providerCapabilities: Object
        //      Capabilities bitmask of a content provider
        providerCapabilities: {
            None: 0,
            Create: 1,
            Edit: 2,
            Delete: 4,
            Move: 8,
            Copy: 16,
            MultiLanguage: 32,
            Security: 64,
            Search: 128,
            PageFolder: 256,
            Wastebasket: 512
        },

        isActionAvailable: function (contentData, actionType, providerCapabilityType, skipMissingLanguageCheck, skipLanguageAccess) {
            // summary:
            //    Returns true if the given action type is authorized and represents an allowed state transition for the given contentData context.
            //    This also checks for the capability of content provider whether is configured to allow the action.
            //    If the specified contentData has the missingLanguageBranch property set it will return false.
            // tags:
            //    public

            if (!contentData) {
                return false;
            }

            if (!skipMissingLanguageCheck && contentData.capabilities && contentData.capabilities.language && contentData.missingLanguageBranch && contentData.missingLanguageBranch.isTranslationNeeded) {
                return false;
            }

            var access = skipLanguageAccess ? contentData.accessRights : contentData.accessMask;
            var actionAvailable = actionSupport.hasAccess(access, actionSupport.accessLevel[actionType]) &&
                                  actionSupport.canPerformAction(contentData, actionType);

            if (providerCapabilityType) {
                actionAvailable = actionAvailable && actionSupport.hasProviderCapability(contentData.providerCapabilityMask, providerCapabilityType);
            }

            return actionAvailable;
        },

        canPerformAction: function (contentContext, actionType) {
            // summary:
            //    Returns true if the action represents an allowed state transition.
            // tags:
            //    public

            // If the content is scheduled for published, we considered it locked for edit.
            if (contentContext.status === actionSupport.versionStatus.DelayedPublish &&
               (actionType === actionSupport.action.Edit || actionType === actionSupport.action.Publish)) {
                return false;
            }

            if (actionType === actionSupport.action.Publish) {
                // we can publish everything that's not already published or expired
                return !(contentContext.status === actionSupport.versionStatus.Published ||
                    contentContext.status === actionSupport.versionStatus.Expired);
            }
            if (actionType === actionSupport.action.CheckIn) {
                // we can make "not ready" (checkedout) or rejected content "ready to publish" (checkedin)
                return contentContext.status === actionSupport.versionStatus.CheckedOut ||
                    contentContext.status === actionSupport.versionStatus.Rejected;
            }
            if (actionType === actionSupport.action.Edit) {
                var readonlyVersion =
                    (contentContext.status === actionSupport.versionStatus.Published && !contentContext.isCommonDraft) ||
                    (contentContext.status === actionSupport.versionStatus.Expired && !contentContext.isCommonDraft) ||
                    contentContext.status === actionSupport.versionStatus.PreviouslyPublished ||
                    contentContext.status === actionSupport.versionStatus.CheckedIn ||
                    contentContext.status === actionSupport.versionStatus.DelayedPublish;

                return !(readonlyVersion || contentContext.isDeleted || contentContext.isWastebasket);
            }
            return true;
        },

        hasAccess: function (accesLevelMask, requiredAccessLevel) {
            // summary:
            //    Returs true if the required access is part of the given access mask.
            //    The access mask can be accessed from a contentData context or lightweight contentData object.
            // tags:
            //    public
            return (accesLevelMask & requiredAccessLevel) == requiredAccessLevel;
        },

        hasLanguageAccess: function (item) {
            // summary:
            //      Verify the current content have access with the given language or not
            // context: Object
            //      A content data or context object
            // tags:
            //      public

            if (!item) {
                return false;
            }

            // Get the language information from either the context or the content data since we don't know what type we have.
            var language = item.languageContext || item.missingLanguageBranch || item;

            return !language || (language.hasTranslationAccess && language.isPreferredLanguageAvailable); // Boolean
        },

        getPermissionMap: function (accesLevelMask) {
            // summary:
            //    Maps the given access mask onto an object, for example:
            //    { Read:true, Edit:true, Delete:false, Publish:false, Administer:false }
            // tags:
            //    public

            var map = {};
            for (var al in actionSupport.accessLevel) {
                map[al] = actionSupport.hasAccess(accesLevelMask, actionSupport.accessLevel[al]);
            }
            return map;
        },

        hasProviderCapability: function (providerCapabilityMask, requiredCapability) {
            // summary:
            //     Returs true if the required capabilty is part of the given content provider capability mask.
            // tags:
            //    public

            return (providerCapabilityMask & requiredCapability) == requiredCapability;
        }
    };
    return actionSupport;
});
},
'epi-cms/widget/sharedContentDialogHandler':function(){
﻿define([
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/when",
    "dojox/html/entities",
    "epi",
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/dialog/Dialog",
    "epi/shell/widget/DelayableStandby",
    "epi-cms/widget/ContentReferences",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentreferences"
], function(
    lang,
    Deferred,
    when,
    entities,
    epi,
    dependency,
    TypeDescriptorManager,
    Dialog,
    Standby,
    ContentReferences,
    // Resources
    resources
) {

    var handler = function(settings) {

        var deferred = new Deferred(),
            contentLink = settings.contentData.contentLink,
            registry = dependency.resolve("epi.storeregistry"),
            store = registry.get("epi.cms.content.search"),
            standby = new Standby({ target: document.body, zIndex: 999 }).placeAt(document.body);

        // Display a the standby widget in case the content references takes a long time to query the store.
        standby.show(50, 0);

        when(store.get(contentLink), function(contentData) {

            var mode = settings.mode || handler.mode.confirm,
                isConfirm = mode === handler.mode.confirm,
                content = new ContentReferences({
                    model: {
                        contentData: contentData,
                        mode: mode
                    }
                });

            var watch = content.watch("numberOfReferences", function(propertyName, oldValue, newValue) {

                // Remove the watch so we don't leak memory or create additional dialogs on refresh.
                watch.remove();

                var description;

                if (isConfirm) {
                    // The description is determined by whether the content being deleted has children.
                    var key = contentData.hasChildren ? "movetotrashwithsubcontentdescription" : "movetotrashdescription";
                    description = TypeDescriptorManager.getResourceValue(contentData.typeIdentifier, key);
                } else {
                    description = TypeDescriptorManager.getResourceValue(contentData.typeIdentifier, "referencesdescription");
                }

                description = lang.replace(description, [entities.encode(contentData.name)]);

                // If not passed with settings, then the heading is determined by the dialog mode.
                var title = settings.title;
                if (!title) {
                    var translationKey = isConfirm ? "movetotrash" : "references";
                    title = TypeDescriptorManager.getResourceValue(contentData.typeIdentifier, translationKey);
                }

                var dialog = new Dialog({
                    focusActionsOnLoad: true,
                    destroyOnHide: true,
                    defaultActionsVisible: isConfirm,
                    dialogClass: "epi-dialog-contentReferences",
                    title: title,
                    description: description,
                    cancelActionText: epi.resources.action.cancel,
                    confirmActionText: newValue === 0 ? resources.buttons.movetotrash : resources.buttons.movetotrashanyway,
                    setFocusOnConfirmButton: newValue === 0
                });

                if (!isConfirm) {
                    dialog.definitionConsumer.add({
                        name: "close",
                        label: epi.resources.action.close,
                        action: dialog.onCancel
                    });
                }

                dialog.connect(dialog, "onExecute", deferred.resolve);
                dialog.connect(dialog, "onCancel", deferred.cancel);

                dialog.set("content", content);

                // Hide the dialog when a reference is viewed.
                var handle = content.on("viewReference", function() {
                    dialog.hide();
                    handle.remove();
                });

                standby.hide();

                dialog.show();
            });

            content.startup();
        });

        return deferred.promise;
    };

    handler.mode = {
        confirm: "confirm",
        show: "show"
    };

    return handler;
});
},
'epi-cms/widget/ContentReferences':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/keys",
    "dojo/when",
    "epi-cms/dgrid/formatters",
    "epi/shell/TypeDescriptorManager",
    // Base class and mixins
    "./_GridWidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/Evented",
    // Resources
    "dojo/text!./templates/ContentReferences.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentreferences",
    // Widgets used in the template
    "dijit/form/Button"
], function(
    declare,
    lang,
    domClass,
    domConstruct,
    domStyle,
    keys,
    when,
    formatters,
    TypeDescriptorManager,
    // Base class and mixins
    _GridWidgetBase,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    Evented,
    // Resources
    template,
    resources
) {

    return declare([_GridWidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, Evented], {

        // widget resources
        res: resources,

        // templateString: String
        //  Template for the widget
        templateString: template,

        storeKeyName: "epi.cms.contentreferences",

        contextChangeEvent: "dblclick",

        // trackActiveItem: [public] Boolean
        //      A flag indicating whether the item matching the current context should be highlight. The default value is false.
        trackActiveItem: false,

        // ignoreVersionWhenComparingLinks: [public] Boolean
        //      A flag indicating whether the version should be ignored when comparing content references.
        ignoreVersionWhenComparingLinks: false,

        _setTotalLinksAttr: { node: "totalLinksNode", type: "innerText" },

        _setNotificationAttr: { node: "contentReferencesNotificationNode", type: "innerText" },

        _setNotificationBarStyleAttr: function (value) {
            // summary:
            //      Sets the color for notification bar. 1 for green, 2 for orange and yellow for everything else
            // tags:
            //      protected
            switch(value) {
                case 1:          // green
                    domClass.add(this.contentReferencesNotificationBar, "epi-statusIndicator epi-statusIndicatorOk");
                    break;
                case 2:      // orange
                    domClass.add(this.contentReferencesNotificationBar, "epi-statusIndicator epi-statusIndicatorWarning");
                    break;
            }
        },

        _setNumberOfReferencesAttr: function (number) {
            // summary:
            //      sets the number of references, and widget notification, styles based on the number.
            // tags:
            //      protected

            var contentData = this.model.contentData,
                hasReferences = number > 0;

            var setNotificationStyleAndMessage = lang.hitch(this, function(resourceKey, styleType) {
                var text = TypeDescriptorManager.getResourceValue(contentData.typeIdentifier, resourceKey);

                this.set("notification", text);
                this.set("notificationBarStyle", styleType);
            });

            if (hasReferences) {
                if (contentData.hasChildren) {
                    setNotificationStyleAndMessage("referenceswithsubcontentwarning", 2);
                } else {
                    setNotificationStyleAndMessage("referenceswarning", 2);
                }
            } else {
                if (contentData.hasChildren) {
                    setNotificationStyleAndMessage("noreferenceswithsubcontentwarning", null);
                } else if (contentData.publicUrl) {
                    setNotificationStyleAndMessage("publicreferencesnote", null);
                } else {
                    setNotificationStyleAndMessage("noreferencesnote", 1);
                }
            }

            // build number of links text
            if (hasReferences) {
                var resourceText = number === 1 ? resources.totallink : resources.totallinks;
                var numberOfLinks = lang.replace(resourceText, [number]);
                this.set("totalLinks", numberOfLinks);
            }

            this._set("numberOfReferences", number);
        },

        _setShowToolbarAttr: function (value) {
            domStyle.set(this.captionPanelNode, "display", value ? "" : "none");
        },

        buildRendering: function () {
            // summary:
            //      Construct the UI for this widget. this.gridNode is initialized as a dGrid.
            // tags:
            //      protected
            var linkTemplate = this._getLinkTemplate();

            var gridSettings = lang.mixin({
                columns: {
                    name: {
                        renderCell: lang.hitch(this, "_renderContentItem")
                    },
                    treePath: {
                        className: "epi-width50",
                        get: function(item) {
                            return item.treePath.join('<span class="epi-breadCrumbsSeparator">&gt;</span>');
                        },
                        ellipsisNoTooltip: true
                    },
                    view: {
                        className: "epi-width10",
                        label: " ",
                        formatter: function() { return linkTemplate; },
                        sortable: false
                    }
                },
                store: this.store,
                query: { id: this.model.contentData.contentLink },
                showHeader: false
            }, this.defaultGridMixin);

            this.inherited(arguments);

            this.grid = new this._gridClass(gridSettings, this.gridNode);

            // Hide the notification box if in show mode.
            domClass.toggle(this.contentReferencesNotificationBar, "dijitHidden", this.model.mode == "show");
        },

        startup: function () {
            this.inherited(arguments);

            // Setup event handling for click on the view link.
            this.grid.on(".dgrid-column-view a:click", lang.hitch(this, "_onChangeContext"));

            // Setup event handling for data fetching and do initial fetch.
            this.grid.on("dgrid-refresh-complete", lang.hitch(this, "_afterDataFetched"));
        },

        fetchData: function () {
            // summary:
            //      Fetches data by setting a query on the grid. A get children query will be performed on the store.
            // tags:
            //      protected

            this.grid.refresh();
        },

        _afterDataFetched: function (e) {
            when(e.results.total, lang.hitch(this, function(total) {
                this.set("numberOfReferences", total);
                this.set("showToolbar", total > 0);
                domStyle.set(this.grid.domNode, "visibility", (total > 0) ? "visible" : "hidden");
            }));
        },

        _onChangeContext: function(e) {
            // summary:
            //      Change the context to the content associated with the given row.
            // tags:
            //      private
            var row = this.grid.row(e),
                newContext = { uri: row.data.uri };

            this._requestNewContext(newContext, { sender: this });

            this.emit("viewReference");
        },

        _getLinkTemplate: function() {
            // summary:
            //      Returns an HTML string representing the view link.
            // tags:
            //      private
            var node = domConstruct.create("a", {
                "class": "epi-visibleLink",
                innerHTML: resources.view.label,
                title: resources.view.tooltip
            });

            return node.outerHTML;
        }
    });
});
},
'epi-cms/dgrid/formatters':function(){
﻿define([
// dojo
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/string",

// epi
    "epi/datetime",
    "epi/dependency",
    "epi/username",

    "epi/shell/dgrid/Formatter",
    "epi/shell/dgrid/util/misc",
    "epi/shell/TypeDescriptorManager",

    "epi-cms/contentediting/ContentActionSupport"
],
function (
// dojo
    lang,
    domClass,
    string,

// epi
    epiDate,
    dependency,
    username,

    Formatter,
    misc,
    TypeDescriptorManager,

    ContentActionSupport
) {
    var module = {
        // summary:
        //      Static module that defines miscellaneous formatter methods
        //      for use with the dgrid.
        // tags:
        //      public

        defaultIconClass: "epi-iconObjectUnknown",

        thumbnail: function (thumbnailUrl) {
            var template = "<image src=\"{0}?{1}\" class=\"epi-floatLeft epi-thumbnail\"/>";
            return thumbnailUrl ? lang.replace(template, [thumbnailUrl, new Date().getTime()]) : "";
        },

        contentIcon: function (typeIdentifier) {
            // summary:
            //      Adds an icon as specified for the type or a default object icon
            // typeIdentifier:
            //      key for the type
            // tags:
            //      public

            var iconNodeClass = TypeDescriptorManager.getValue(typeIdentifier, "iconClass");

            return misc.icon(iconNodeClass + " epi-objectIcon");
        },

        languageBranch: function (languageBranch) {
            // summary:
            //      Adds an indicator of the true langauge for the content object
            // languageBranch:
            //      Languagebranch object.
            // tags:
            //      public
            return languageBranch ? '<span class="epi-missingLanguageIndicator">' + languageBranch.language + '</span>' : "";
        },

        menu: function (/*Object*/settings) {
            // summary:
            //      Adds a menu icon
            // settings:
            //      Settings information for menu
            // tags:
            //      public

            return lang.replace("<span class=\"dijitInline dijitIcon epi-iconContextMenu epi-floatRight\" title=\"{title}\">&nbsp;</span>", settings);
        },

        userName: function (userName) {
            // summary:
            //      Shim for the epi/username/toUserFriendlyHtml function
            // userName:
            //      The user name.
            // tags:
            //      public
            return username.toUserFriendlyHtml(userName);
        },

        localizedDate: function (date) {
            // summary:
            //      Shim for the epi/date/toUserFriendlyHtml function
            // date:
            //      The date to format.
            // tags:
            //      public
            return epiDate.toUserFriendlyHtml(date);
        },

        friendlyBoolean: function (value) {
            // summary:
            //      Creates a div with a "checked/not checked" css class.
            // tags:
            //      public
            var cssClass = value ? "epi-iconCheckmark" : "epi-iconStop";
            return '<div class="' + cssClass + '" />';
        },

        versionStatus: function (versionId) {
            // summary:
            //      Shim for the epi-cms/contentediting/ContentActionSupport.getVersionStatus function
            // versionId:
            //      The value to format.
            // tags:
            //      public
            return ContentActionSupport.getVersionStatus(versionId);
        },

        visibleLink: function (value, valueIsHtml) {
            // summary:
            //      Wrappes the value with a span with the 'epi-visibleLink' css class
            // valueIsHtml:
            //      Pass true to skip html encoding of the value. The default is to encode the value.
            // tags:
            //      public

            if (!value) {
                return "";
            }

            var text = !valueIsHtml ? misc.htmlEncode(value) : value;

            return '<span class="epi-visibleLink">' + text + '</span>';
        },

        secondaryText: function (value, valueIsHtml) {
            // summary:
            //      Wrappes the value with a span with the 'epi-secondaryText' css class
            // valueIsHtml:
            //      Pass true to skip html encoding of the value. The default is to encode the value.
            // tags:
            //      public

            if (!value) {
                return "";
            }

            var text = !valueIsHtml ? misc.htmlEncode(value) : value;

            return '<span class="epi-secondaryText">' + text + '</span>';
        },

        contentItemFactory: function (textSelector, titleSelector, iconSelector, menuSettings, thumbnailSelector, languageSelector, isEncoded) {
            // summary:
            //      Factory function for configuring the contentItem formatter
            // textSelector:
            //      Selector function or property key of content object
            // titleSelector:
            //      Selector function or property key of content object
            // iconSelector:
            //      Selector function or property key of content object
            // menuSettings:
            //      Settings information for menu
            // isEncoded: Boolean
            //      Flags which is used to enabled/disable encode mode. (default true)
            // tags:
            //      public

            return function (value, object, node, options) {
                var returnValue,
                    typeIdentifier,
                    text,
                    title,
                    missingLanguageBranch,
                    valueIsString,
                    thumbnailUrl;

                function get(name) {
                    if (typeof object.get === "function") {
                        return object.get(name);
                    }
                    return object[name];
                }

                function selectorExecutor(selector) {
                    if (selector) {
                        if (typeof selector === "function") {
                            return selector(object);
                        } else {
                            return get(selector);
                        }
                    }
                    return value;
                }

                valueIsString = typeof value === "string";
                typeIdentifier = selectorExecutor(iconSelector || (valueIsString ? false : "typeIdentifier"));
                text = selectorExecutor(textSelector || (valueIsString ? false : "text"));
                title = selectorExecutor(titleSelector || (valueIsString ? false : "title"));
                missingLanguageBranch = (languageSelector && selectorExecutor(languageSelector)) || object.missingLanguageBranch;
                thumbnailUrl = thumbnailSelector && selectorExecutor(thumbnailSelector);

                returnValue = module.contentItem(typeIdentifier, missingLanguageBranch, text, title, menuSettings, thumbnailUrl, isEncoded);

                node.innerHTML = returnValue;

                //If in a list add css-class for the row as well
                if (node.nodeName !== "TD" && missingLanguageBranch) {
                    domClass.add(node, "epi-ct-missingLanguageRow");
                }

                return returnValue;
            };
        },

        contentItem: function (typeIdentifier, missingLanguageBranch, text, title, menuSettings, thumbnailUrl, isEncoded) {
            // summary:
            //      Formats a content object with icon missing language indicator and an optional menu
            // typeIdentifier:
            //      content type key for selecting the icon
            // missingLanguageBranch:
            //      Content items language information
            // text:
            //      The name or description of the content
            // title:
            //      The name or description of the content used for the title attribute.
            //      If not specified, the text value will be used
            // menuSettings:
            //      Settings information for menu
            // thumbnailUrl:
            //      The image public url of content
            // isEncoded: Boolean
            //      The flag which is used to enale/disable encode mode. (default true)
            // tags:
            //      public

            var menu = (menuSettings && menuSettings.hasMenu) ? module.menu(menuSettings.settings) : "",
                languageBranch = module.languageBranch(missingLanguageBranch);

            isEncoded = (isEncoded === null || isEncoded === undefined) ? true : isEncoded;
            title = isEncoded ? misc.attributeEncode(title || text) : (title || text);
            text = isEncoded ? misc.htmlEncode(text) : text;

            return (thumbnailUrl ? module.thumbnail(thumbnailUrl) : module.contentIcon(typeIdentifier)) + menu + languageBranch + misc.ellipsis(text, title);
        }
    };

    Formatter.addFormatter("contentIcon", module.contentIcon);
    Formatter.addFormatter("userName", module.userName);
    Formatter.addFormatter("versionStatus", module.versionStatus);
    Formatter.addFormatter("localizedDate", module.localizedDate);
    Formatter.addFormatter("contentItem", module.contentItemFactory, true);

    return module;
});
},
'epi/username':function(){
﻿define("epi/username", [
    "dojo/_base/declare",
    "dojox/html/entities",
    "epi/dependency"
],

function (
    declare,
    entities,
    dependency
) {

    var username = {
        toUserFriendlyString: function (/*string*/username, /*string*/currentUsername, /*boolean*/capitalizeUsername, /*boolean*/keepEmptyUsername) {
            // summary:
            //      Get friendly username: if the username to be displayed is the same 
            //      as the current username, this will returns "you".
            // username:
            //    The username to be displayed.
            // currentUsername:
            //    The username to compare with (optional) to see if it's the current user.
            // capitalizeUsername:
            //    If the first character should be in upper case.
            // keepEmptyUsername:
            //    If the empty username should be kept or replaced by "Installer".
            // tag:
            //    public

            if (!currentUsername) {
                currentUsername = this._getCurrentUsername();
            }

            var emtyUsername = keepEmptyUsername ? "" : epi.resources.text.installer,
                friendlyUsername = username && currentUsername.toLowerCase() === username.toLowerCase() ? epi.resources.text.you : username || emtyUsername;
            if (capitalizeUsername) {
                friendlyUsername = friendlyUsername.charAt(0).toUpperCase() + friendlyUsername.slice(1);
            }
            return friendlyUsername;
        },

        toUserFriendlyHtml: function (/*string*/username, /*string*/currentUsername, /*boolean*/capitalizeUsername, /*boolean*/keepEmptyUsername) {
            // summary:
            //    Creates a friendly version of the username and wraps it inside a span tagged with a given class for styling purposes.
            //
            // username:
            //    The username to be displayed.
            // currentUsername:
            //    The username to compare with (optional) to see if it's the current user.
            // capitalizeUsername:
            //    If the first character should be in upper case.
            // keepEmptyUsername:
            //    If the empty username should be kept or replaced by "Installer".
            // tags:
            //    public

            var formattedUserName = this.toUserFriendlyString(username, currentUsername, capitalizeUsername, keepEmptyUsername);
            if (formattedUserName === "") {
                return formattedUserName;
            }
            return "<span class='epi-username'>" + entities.encode(formattedUserName) + "</span>";
        },

        _getCurrentUsername: function () {
            if (!this.currentUsername) {
                var profile = dependency.resolve("epi.shell.Profile");
		//TODO: Make this Async
                this.currentUsername = profile.get("userName");
            }
            return this.currentUsername;
        }
    };

    return username;
});
},
'epi/shell/dgrid/Formatter':function(){
﻿define("epi/shell/dgrid/Formatter", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/when",

// DGrid
    "dgrid/Grid",

// epi
    "epi/shell/dgrid/TemplateColumn"
], function (
// dojo
    declare,
    array,
    when,
//
    Grid,
// epi
    TemplateColumn
) {
    var module = declare(null, {
        // summary:
        //      Add formating capability for dgrid column cell.
        // tags:
        //      public

        _isGrid: false,

        configStructure: function () {
            // summary:
            //      Setup templated column(s)
            // tags:
            //      public

            this.inherited(arguments);

            this._isGrid = this instanceof Grid;

            if (this._isGrid) {
                this._setupTemplateColumns();
            } else {
                this._setupList();
            }
        },

        _setupTemplateColumns: function () {
            // summary:
            //      Loop all dgrid columns, check each is able to template column, convert each.
            // tags:
            //      private

            if (!this.subRows) { return; }

            var formatters;
            array.forEach(this.subRows, function (columns) {
                array.forEach(columns, function (column) {
                    formatters = [];

                    array.forEach(module.shorthands, function (shorthand) {
                        var formatterActive = column[shorthand],
                            formatter = module.formatters[shorthand];

                        if (!!formatterActive) {
                            if (formatter) {
                                // If not a bool value, execute formatterFunc with value that should be a factory method
                                formatters.push(formatter.isFactory ?
                                        formatter.handler(formatterActive) :
                                        formatter.handler);
                            } else {
                                throw new Error("Formatter with key " + shorthand + " not found");
                            }

                        }
                    });

                    // Add custom formatters
                    if (column.formatters) {
                        this._findFormatters(column.formatters, formatters);
                    }

                    if (formatters.length > 0) {
                        column = TemplateColumn(column, formatters);
                    }
                }, this);
            }, this);
        },

        _setupList: function () {
            // summary:
            //      Add configured formatters when used with dgrid list.
            // tags:
            //      private

            if (this.formatters) {
                this._resolvedFormatters = this._findFormatters(this.formatters);
            } else if (this.field) {
                this._resolvedFormatters = [function (data, object, row) { return data; } ];
            }
        },

        renderRow: function (object, options) {
            // summary:
            //      Override of default implementation to add formatter execution.
            // tags:
            //      public

            if (this._isGrid) {
                return this.inherited(arguments);
            }

            var row = this.inherited(arguments, ["", options]),
                data = this.field ? object[this.field] : object,
                formatters = this._resolvedFormatters,
                i = -1;

            function executeFormatter(value) {
                var formatter = formatters[i],
                    result;

                if (formatter) {
                    row.innerHTML = value;
                    data = value;
                }

                i++;

                if (formatters.length > i) {
                    formatter = formatters[i];
                    result = formatter(data, object, row);
                    when(result, executeFormatter);
                }
            }

            if (formatters.length > 0) {
                executeFormatter();
            }

            return row;

        },

        _findFormatters: function (formatterConfig, formatters) {
            // summary:
            //      Loops throgh an array that can consist of either formatter functions
            //      or formatter keys as strings. When a string is found it is replaced
            //      by a matching formatter function from the registered formatters.
            // tags:
            //      private

            formatters = formatters || [];

            array.forEach(formatterConfig, function (formatterKey) {
                var type = typeof formatterKey,
                    item, formatter;

                if (type === "string") {
                    item = module.formatters[formatterKey];

                    if (item) {
                        formatter = item.isFactory ? item.handler() : item.handler;
                        formatter.allParameters = item.allParameters;
                    }
                }
                else if (type === "function") {
                    formatter = formatterKey;
                }

                if (formatter) {
                    formatters.push(formatter);
                } else {
                    throw new Error("Formatter with key " + formatterKey + "not found");
                }
            });

            return formatters;
        }
    });

    module.formatters = {};
    module.shorthands = [];

    module.addFormatter = function (name, formatter, isFactory, addShortHand) {
        // summary:
        //      Adds formatter to the formatter registry.
        // tags:
        //      private

        module.formatters[name] = { handler: formatter, isFactory: !!isFactory };
        if (addShortHand) {
            module.shorthands.push(name);
        }
    };

    return module;
});
},
'epi/shell/dgrid/TemplateColumn':function(){
﻿define("epi/shell/dgrid/TemplateColumn", [
// dojo
    "dojo/_base/array"
],
function (
// dojo
    array
) {
    return function (/*object*/column, /*array*/formatters) {
        // summary:
        //      Dgrid template column plugin
        // column: [object]
        //      Column definition
        // formatters: [array]
        //      Array of callback function(s)
        // tags:
        //      public

        var originalRenderCell = column.renderCell;

        // accept arguments as parameters to template function, or from column def,
        // but normalize to column def.
        column.formatters = formatters || column.formatters;

        if (column.formatters && column.formatters.length > 0) {
            column.renderCell = function (object, value, cell, options) {
                // Get each formatter and run it.
                array.forEach(column.formatters, function (formatter) {
                    value = formatter(value, object, cell, options);
                });

                if (value) {
                    cell.innerHTML = value;
                }
            };
        }

        return originalRenderCell ? originalRenderCell.call(column, object, value, cell, options) : column;
    };
});
},
'epi/shell/dgrid/util/misc':function(){
require({cache:{
'url:dojox/html/resources/ellipsis.css':".dojoxEllipsis,.dojoxEllipsisShown {white-space: nowrap; width: 100%; overflow: hidden; text-overflow: ellipsis; -o-text-overflow: ellipsis; -webkit-text-overflow: ellipsis;}.dojoxEllipsis window {width:100%; -moz-user-focus:normal; -moz-user-select:text;}.dojoxEllipsis description{-moz-user-focus:normal; -moz-user-select:text;}.dojoxEllipsisIFrame{white-space: normal; border: none; width: 100%; display: block; height: 1px; margin-top: -1px; clear: both;}.dojoxEllipsisContainer{width: 100%;}.dojoxEllipsisShown:after{content: \"\\2026\"}"}});
﻿define("epi/shell/dgrid/util/misc", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
// dojox
    "dojox/html/entities",

// EPi
    "epi/shell/dgrid/Formatter",

// resources
    "dojo/text!dojox/html/resources/ellipsis.css"
],
function (
// dojo
    declare,
    lang,
// dojox
    htmlEntities,
// EPi
    Formatter,
// resources
    ellipsisCss
) {

    var module = {
        // summary:
        //      This static module defines miscellaneous utility methods.
        // tags:
        //      public
        
        _attributeEncodeMap: [["&","amp"], ["\"","quot"]],

        htmlEncode: function (text) {
            // summary:
            //      Make html encode for the given value
            // text:
            //      The text you want to apply html encode
            // tags:
            //      public

            return htmlEntities.encode(text);
        },
        
        attributeEncode: function(text) {
            return htmlEntities.encode(text, module._attributeEncodeMap);
        },

        ellipsis: function (text, title) {
            // summary:
            //      Make ellipsis for the given text
            // text:
            //      The text you want to apply html ellipsis
            // tags:
            //      public

            if(!title || !lang.isString(title)) {
                title = text;
            }

            return lang.replace("<div class=\"dojoxEllipsis\" title=\"{0}\">{1}</div>", [title, text]);
        },

        ellipsisNoTooltip: function (text) {
            // summary:
            //      Make ellipsis for the given text
            // text:
            //      The text you want to apply html ellipsis
            // tags:
            //      public

            return lang.replace("<div class=\"dojoxEllipsis\">{0}</div>", [text]);
        },

        icon: function (icon, text) {
            // summary:
            //      Add an icon span to the front of the given text
            // text:
            //      The text you want to add an icon in front
            // tags:
            //      public

            text = text || "";

            return lang.replace('<span class="dijitInline dijitIcon {0}"></span>{1}', [icon, text]);
        }
    };

    Formatter.addFormatter("htmlEncode", module.htmlEncode, false, true);
    Formatter.addFormatter("icon", function (icon) { return function(value) { return module.icon(icon, value); }; }, true, true);
    Formatter.addFormatter("ellipsis", module.ellipsis, false, true);
    Formatter.addFormatter("ellipsisNoTooltip", module.ellipsisNoTooltip, false, true);

    return module;

});
},
'url:dojox/html/resources/ellipsis.css':".dojoxEllipsis,.dojoxEllipsisShown {white-space: nowrap; width: 100%; overflow: hidden; text-overflow: ellipsis; -o-text-overflow: ellipsis; -webkit-text-overflow: ellipsis;}.dojoxEllipsis window {width:100%; -moz-user-focus:normal; -moz-user-select:text;}.dojoxEllipsis description{-moz-user-focus:normal; -moz-user-select:text;}.dojoxEllipsisIFrame{white-space: normal; border: none; width: 100%; display: block; height: 1px; margin-top: -1px; clear: both;}.dojoxEllipsisContainer{width: 100%;}.dojoxEllipsisShown:after{content: \"\\2026\"}",
'epi-cms/widget/_GridWidgetBase':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-construct",
    "dojo/keys",
    "dojo/topic",
    "dojo/when",

    "dgrid/Keyboard",
    "dgrid/OnDemandGrid",
    "dgrid/Selection",

    "dijit/layout/_LayoutWidget",

    "epi",
    "epi/datetime",
    "epi/UriParser",
    "epi/username",

    "epi/shell/dgrid/Formatter",
    "epi/shell/TypeDescriptorManager",

    "epi-cms/_ContentContextMixin",
    "epi-cms/core/ContentReference",
    "epi-cms/dgrid/DnD",
    "epi-cms/dgrid/formatters",
    "epi-cms/dgrid/WithContextMenu",
    "epi/dependency"
], function(
    declare,
    lang,
    aspect,
    domConstruct,
    keys,
    topic,
    when,

    Keyboard,
    OnDemandGrid,
    Selection,

    _LayoutWidget,

    epi,
    epiDate,
    UriParser,
    username,

    Formatter,
    TypeDescriptorManager,

    _ContentContextMixin,
    ContentReference,
    DnD,
    formatters,
    WithContextMenu,
    dependency
) {

    return declare([_LayoutWidget, _ContentContextMixin], {

        // _gridClass: [protected] Object
        //		The class to construct the grid with.
        _gridClass: declare([OnDemandGrid, Formatter, Selection, DnD, Keyboard, WithContextMenu]),

        // storeKeyName: [public] string
        //		The key of the store used to retrieve the store from the store registry.
        storeKeyName: null,

        // grid: [public] dgrid
        //		The grid that is used to display information.
        grid: null,

        // store: [public] dojo/store
        //		The store that contains the data.
        store: null,

        // ignoreVersionWhenComparingLinks: [public] boolean
        //		If item comparison should consider versions or not.
        ignoreVersionWhenComparingLinks: true,

        // trackActiveItem: [public] boolean
        //		If comparison should be done to highlight the currently active context item.
        trackActiveItem: true,

        // defaultGridMixin: [protected] object
        //		An object with default settings for dnd to mixin to the grid class.
        defaultGridMixin: null,

        currentItem: null,

        // contextChangeEvent: [public] String
        //      Set the event that will cause a context change (i.e. click or dblclick). Default value is "click".
        contextChangeEvent: "click",

        postMixInProperties: function () {
            // summary:
            //		Called after constructor parameters have been mixed-in; sets default values for parameters that have not been initialized.
            // tags:
            //		protected

            this.inherited(arguments);

            this.defaultGridMixin = {
                selectionMode: "single",
                dndParams: {
                    creator: lang.hitch(this, this._dndNodeCreator),
                    copyOnly: true,
                    selfAccept: false
                }
            };

            if (!this.store && this.storeKeyName) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get(this.storeKeyName);
            }
        },

        startup: function () {
            // summary:
            //		Connects event handlers to common grid events.
            // tags:
            //		protected

            this.inherited(arguments);

            if (this.contextChangeEvent) {
                var callback = lang.hitch(this, "_onChangeContext");
                this.grid.on(".dgrid-row:" + this.contextChangeEvent, callback);

                // Setup the default keyboard handling for changing context if the Keyboard mixin is supported.
                if (typeof this.grid.addKeyHandler == "function") {
                    this.grid.addKeyHandler(keys.ENTER, callback);
                    this.grid.addKeyHandler(keys.SPACE, callback);
                }
            }

            this.grid.on("dgrid-select", lang.hitch(this, "_onSelect"));
            this.grid.on("dgrid-error", lang.hitch(this, "_onError"));

            if (this.trackActiveItem) {
                this.own(aspect.after(this.grid, "insertRow", lang.hitch(this, this._selectActiveItem)));
            }

            this.own(this.connect(this, "layout", lang.hitch(this, function () {
                this.grid.resize();
            })));

            this.grid.startup();
        },

        destroy: function () {
            if (this.grid) {
                this.grid.destroy();
            }

            this.inherited(arguments);
        },

        select: function (/*Object*/item) {
            // summary:
            //      Select a grid row from the given item
            // item: [Object]
            // tags:
            //      public

            this.grid.clearSelection();
            if (item) {
                // using .toString() instead of item.id to get the full content link, which contains provider name
                var contentLink = (item instanceof ContentReference ? item : new ContentReference(item.id)).createVersionUnspecificReference().toString();
                this.grid.select(contentLink);
            }
        },

        _forceKeepContext: function (/*String*/uri) {
            // summary:
            //
            // uri: [String]
            //
            // tags:
            //      protected, extension

            return this._isSameAsCurrentContext(uri);
        },

        _onChangeContext: function(e) {
            // summary:
            //      Publish a context request when a version is selected in the list.
            // tags:
            //      protected, extension
            var row = this.grid.row(e),
                uri = row.data.uri,
                newContext = { uri: uri };

            if (this._forceKeepContext(uri)) {
                return;
            }

            this._requestNewContext(newContext, { sender: this });
        },

        _onSelect: function(e) {
            // summary:
            //		Publish a context request when a version is selected in the list.
            // tags:
            //		protected, extension
        },

        _onError: function (error) {
            // summary:
            //		Shows an error message to the user when failing to load data.
            // tags:
            //		protected, extension
            var errorMessage = this.grid.errorMessage;
            if (error.status && error.status === 403) {
                errorMessage = epi.resources.messages.nopermissiontoviewdata;
            }
            this._showErrorMessage(errorMessage);
        },

        _requestNewContext: function(contextParameters, callerData) {
            topic.publish("/epi/shell/context/request", contextParameters, callerData);
        },

        restore: function () {
            // summary: Restore component visuals
            this.resize();
        },

        _isActiveItem: function (/*dgrid row*/row) {
            // summary
            //      Compare uri current dgrid row with current context
            // tags
            //      Private

            return when(this.getCurrentContext(), lang.hitch(this, function (context) {
                var rowUri = row.data.uri;
                return context && this._compareUris(rowUri, context.uri);
            }));
        },

        _selectActiveItem: function (node) {
            // summary:
            //		Called 'after' the insertRow method in order to select the active version.
            // tags:
            //		private

            var row = this.grid.row(node);

            if (!row) {
                //Note: We don't know why row is null in some cases. Is something wrong?
                return node;
            }

            when(this._isActiveItem(row), lang.hitch(this, function (isActive) {
                if (isActive) {
                    if (this.grid.selectionMode === "single") {
                        this.grid.clearSelection();
                    }
                    this.grid.select(row, null);
                }
            }));

            return node;
        },

        contextChanged: function (context, callerData) {
            this.inherited(arguments);

            if (context.type !== "epi.cms.contentdata") {
                return;
            }

            if (!callerData || callerData.sender != this) {
                // the context changed, probably because we navigated or published something
                this.onContextChanged(context);
            }
        },

        onContextChanged: function (context) {
            this.fetchData();
        },

        fetchData: function () {
            // summary:
            //      Override this method to implement your logic to bind data to the grid.
            //
            // tags:
            //    protected
        },

        _showErrorMessage: function (errorMessage) {
            this.grid.cleanup();

            // There is no public method for setting messages, so use the same style as dgrid.
            this.grid.contentNode.innerHTML = errorMessage  || "";
        },

        contextChangeFailed: function (oldContext, requestContextParams, callerData) {
            // summary:
            //    Subcriptions to /epi/shell/context/requestfailed topic to sync page tree selection
            //
            // tags:
            //    private

            this.inherited(arguments);

            // select old page link
            if (callerData && callerData.sender === this) {
                this._selectActiveItem();
            }
        },

        _renderContentItem: function (object, value, node, options) {
            node.innerHTML = formatters.contentItem(object.typeIdentifier, object.missingLanguageBranch, value);
        },

        _localizeDate: function (value) {
            return formatters.localizedDate(value);
        },

        _createUserFriendlyUsername: function (name) {
            return formatters.userName(name);
        },

        _dndNodeCreator: function (item, hint) {
            // summary:
            //      Custom DnD avatar creator method

            var dndTypes = TypeDescriptorManager.getAndConcatenateValues(item.typeIdentifier, "dndTypes");

            if (!dndTypes && this.dndTypes) {
                dndTypes = this.dndTypes;
            }

            var node = domConstruct.create("div").appendChild(document.createTextNode(item.name));
            return {
                "node": node,
                "type": dndTypes,
                "data": item
            };
        },

        _aroundInsertRow: function (original) {
            // summary:
            //      Called 'around' the insertRow method to fix the grids less than perfect selection.
            // tags:
            //      protected

            return lang.hitch(this, function (object, parent, beforeNode, i, options) {

                // Call original method
                var row = original.apply(this.grid, arguments);

                var currentItem = this.get("currentItem");
                if (currentItem) {
                    // using .toString() instead of currentItem.id to get the full content link, which contains provider name
                    var contentLink = (currentItem instanceof ContentReference ? currentItem : new ContentReference(currentItem.id)).createVersionUnspecificReference().toString();
                    if (contentLink === object.contentLink) {
                        this.select(currentItem);
                    }
                }

                return row;
            });
        },

        _getCurrentItem: function () {
            // summary:
            //      Get current context row based on current context
            // returns: [Promise]
            //      An instance of dgrid row
            // tags:
            //      protected
            return when(this.getCurrentContext(), function (context) {
                return {
                    "id": (new ContentReference(context.id)).id
                };
            });
        }
    });

});
},
'epi-cms/dgrid/DnD':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/NodeList",
    "epi/shell/dnd/Source",
    "dojo/dom-construct",

    "epi/dependency",
    "epi/shell/TypeDescriptorManager",

    "put-selector/put"

], function (
    declare,
    lang,
    NodeList,
    DnDSource,
    domConstruct,

    dependency,
    TypeDescriptorManager,

    put) {

    var GridSource = declare(DnDSource, {
        _legalMouseDown: function (evt) {
            // Fix _legalMouseDown to only allow starting drag from an item
            // (not from bodyNode outside contentNode).
            var legal = this.inherited(arguments);
            return legal && evt.target != this.grid.bodyNode;
        },

        getSelectedNodes: function () {
            
            // If dgrid's Selection mixin is in use, synchronize with it, using a
            // map of node references (updated on dgrid-[de]select events).
            var nodes = this.inherited(arguments);
            if (!this.grid.selection || Object.keys(this.grid.selection).length === 0) {
                this.grid.select(nodes[0]);
                return nodes;
            }

            var isGridSelection = false;
            var gridSelectionNodes = new NodeList();

            //isGridSelection when exist any selection in nodes
            for (var id in this.grid.selection) {
                if (this.grid.row(id).element != nodes[0])
                    gridSelectionNodes.push(this.grid.row(id).element);
                else {
                    isGridSelection = true;
                    gridSelectionNodes.push(nodes[0]);
                }
            }
            if (isGridSelection) {
                return gridSelectionNodes;
            }
            else {
                this.grid.clearSelection();
                this.grid.select(nodes[0]);
                return nodes;
            }
        }
    });

    return declare([], {

        // dndSourceTypes: Array
        //      Specifies the types which will be set for DnD items in the grid.
        dndSourceTypes: null,

        // dndParams: Object
        //      Object containing params to be passed to the DnD Source constructor.
        dndParams: null,

        // dndConstructor: Function
        //      Constructor from which to instantiate the DnD Source.
        dndConstructor: GridSource,

        // dndDisabled: Booleaen
        //      Set to true to disable the dnd support.
        dndDisabled: false,

        postCreate: function () {
            this.inherited(arguments);

            if (!this.dndDisabled) {
                this._setupDnD();
            }
        },

        insertRow: function (object) {
            // override to add dojoDndItem class to make the rows draggable
            var row = this.inherited(arguments);

            if (this.dndDisabled) {
                return row;
            }
            put(row, ".dojoDndItem");

            // setup the source if it hasn't been done yet
            this._setupDnD();

            var opts = {};
            if (this.query) {
                opts.oldParentItem = { contentLink: this.query.referenceId };
            }

            this.dndSource.setItem(row.id, { data: object, type: this._getDndType(object), options: opts });
            return row;
        },

        _getDndType: function (object) {
            // Get a custom dnd type array from the specific object or a general type array from the source.
            var dndTypes = TypeDescriptorManager.getAndConcatenateValues(object.typeIdentifier, "dndTypes");
            if ((!dndTypes || dndTypes.length <= 0) && this.dndSourceTypes) {
                dndTypes = this.dndSourceTypes;
            }
            return dndTypes;
        },

        _setupDnD: function () {

            if (this.dndSource) {
                return;
            }

            if (!this.dndParams.creator) {
                this.dndParams.creator = lang.hitch(this, this._dndNodeCreator);
            }

            this.dndSource = new (this.dndConstructor)(
                this.bodyNode,
                lang.mixin(this.dndParams, {
                    // add cross-reference to grid for potential use in inter-grid drop logic
                    grid: this,
                    dropParent: this.contentNode
                })
            );
            // Allows selection of only one element
            this.dndSource.singular = true;
        },

        _dndNodeCreator: function (item, hint) {
            // summary:
            //      Custom DnD avatar creator method

            var dndTypes, node;

            if (item.typeIdentifier) {
                dndTypes = TypeDescriptorManager.getAndConcatenateValues(item.typeIdentifier, "dndTypes");
            }
            if (!dndTypes && this.dndTypes) {
                dndTypes = this.dndTypes;
            }

            node = domConstruct.create("div").appendChild(document.createTextNode(item.name));
            return {
                "node": node,
                "type": dndTypes,
                "data": item
            };
        }
    });
});
},
'epi-cms/dgrid/WithContextMenu':function(){
﻿define([
    // Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "epi/shell/widget/ContextMenu",
    "epi/shell/DestroyableByKey"
], function(
    declare,
    lang,
    domClass,
    ContextMenu,
    DestroyableByKey) {
    // module: 
    //      epi-cms/dgrid/WithContextMenu
    // summary:
    //      Extension for dgrid that adds an context menu and events.

    return declare([DestroyableByKey], {

        contextMenu: null,

        postCreate: function() {
            this.inherited(arguments);
            this.contextMenu = this.contextMenu || new ContextMenu({ category: "context" });
            this.ownByKey(this.contextMenu, this.contextMenu);
            this._setupGridEvents();
        },

        startup: function () {
            this.inherited(arguments);
            this.contextMenu.startup();
        },

        _setupGridEvents: function() {
            // summary:
            //      Initialization of events on the grid.
            // tags:
            //      private

            this.ownByKey("contextMenuClick", this.on(".epi-iconContextMenu:click", lang.hitch(this, this.onContextMenuClick)));
        },

        onContextMenuClick: function(e) {
            // summary:
            //      Triggered when a click on the grids context menu is registered.
            // remarks: 
            //      It will open the context menu.
            // tags:
            //      protected

            this.contextMenu.scheduleOpen(this, null, {
                x: e.pageX,
                y: e.pageY
            });
        }
    });

});
},
'epi/shell/widget/ContextMenu':function(){
﻿define("epi/shell/widget/ContextMenu", [
    "dojo/_base/declare",
    "dijit/Menu",
        
    "epi/shell/command/_CommandConsumerMixin",
    "epi/shell/command/builder/MenuAssembler",
    "epi/shell/command/builder/MenuBuilder",
        
    "epi/shell/command/builder/MenuWithSeparatorBuilder"
], function (
    declare,
    Menu,
    
    _CommandConsumerMixin,
    MenuAssembler,
    MenuBuilder,
    MenuWithSeparatorBuilder
) {

    // module:
    //		epi-cms/widget/ContextMenu
    // summary:
    //		A context menu that can display context commands for an item.
    return declare([Menu, _CommandConsumerMixin], {

        // category: string
        //		If set the menu will be filtered on the category.
        category: null,

        // leftClickToOpen: [readonly] Boolean
        //		Menu will open on left click instead of right click.
        leftClickToOpen: true,

        postCreate: function () {

            this.inherited(arguments);

            var defaultConfiguration = { builder: new MenuBuilder(), target: this, category: this.category },
                configuration,
                assembler;

            configuration = [defaultConfiguration, { builder: new MenuWithSeparatorBuilder(), target: this, category: "menuWithSeparator" }, { builder: new MenuBuilder(), target: this, category: "popup" }],
            assembler = new MenuAssembler({ configuration: configuration, commandSource: this });

            assembler.build();
        },

        scheduleOpen: function (/*DomNode?*/target, /*DomNode?*/iframe, /*Object?*/coords) {
            // summary:
            //      Display the menu
            // remarks:
            //      See more details in the base class(Dijit/Menu)
            // tag:
            //      public

            this._scheduleOpen(target, iframe, coords);
        }
    });
});

},
'epi/shell/command/builder/MenuWithSeparatorBuilder':function(){
﻿define("epi/shell/command/builder/MenuWithSeparatorBuilder", [
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",

    "dijit/MenuSeparator",
    "./MenuBuilder"
], function (array, declare, lang, on, MenuSeparator, MenuBuilder) {

    // module:
    //		epi-cms/contentediting/command/builder/MenuWithSeparatorBuilder
    // summary:
    //		Builds a context menu with separator.

    return declare([MenuBuilder], {

        _addToContainer: function (widget, container) {
            // summary:
            //		Adds the widget to the container.
            // tags:
            //		protected

            var separator = new MenuSeparator();
            container.addChild(widget);
            container.addChild(separator);
        }
    });
});
},
'url:epi-cms/widget/templates/ContentReferences.html':"﻿<div class=\"epi-contentReferences\">\r\n    <div data-dojo-attach-point=\"contentReferencesNotificationBar\" class=\"epi-notificationBar epi-notificationBarWithBorders epi-notificationBarItem\">\r\n        <div data-dojo-attach-point=\"contentReferencesNotificationNode\" class=\"epi-notificationBarText\" ></div>\r\n    </div>\r\n    <div class=\"epi-captionPanel\" data-dojo-attach-point=\"captionPanelNode\">\r\n        <strong data-dojo-attach-point=\"totalLinksNode\"></strong>\r\n        <div class=\"epi-floatRight\">\r\n            <button class=\"epi-chromelessButton\"\r\n                    data-dojo-type=\"dijit/form/Button\"\r\n                    data-dojo-attach-event=\"onClick:fetchData\"\r\n                    data-dojo-props=\"iconClass:'epi-iconReload'\">${res.buttons.refresh}</button>\r\n        </div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"gridNode\"></div>\r\n</div>\r\n",
'epi-cms/widget/ContentForestStoreModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/when",
    "epi-cms/widget/ContentTreeStoreModel"
], function(
    array,
    declare,
    lang,
    promiseAll,
    when,
    ContentTreeStoreModel
) {

    // module:
    //      epi-cms/widget/ContentForestStoreModel
    // summary:
    //      A store model for tree widgets that must support content with multiple roots.
    // description:
    //      The model creates a fabricated root item in order to support a store that has
    //      content with multiple roots. It is expected that the root will never be displayed
    //      in the tree.
    return declare([ContentTreeStoreModel], {

        // root: [readonly] Object
        //      The fabricated root item for the model.
        root: null,

        constructor: function() {
            this.root = {
                id: "0",
                name: "ROOT"
            };
        },

        // =======================================================================
        // Methods for traversing hierarchy

        isRoot: function (/*dojo.data.Item*/contentItem) {
            // summary:
            //		Checks to see if the item is a root node in the content forest
            // contentItem: [dojo.data.Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public

            var inherited = this.inherited(arguments);
            return inherited || !!(contentItem && this.roots && (array.indexOf(this.roots, this.getIdentity(contentItem)) >= 0));
        },

        getRoot: function(/*Function*/ onItem) {
            // summary:
            //      Calls onItem with the fake root item for the tree.
            onItem(this.root);
        },

        mayHaveChildren: function(item) {
            // summary:
            //      Tells if an item has or may have children.
            // item: Object
            //      Item from the dojo/store
            return item === this.root || this.inherited(arguments); // Boolean
        },

        getChildren: function(parentItem, /*Function*/ onComplete, /*Function*/ onError) {
            // summary:
            //      Calls onComplete() with an array of child items of given parent item.
            // parentItem: Object
            //      Item from the dojo/store
            if(parentItem === this.root) {
                var deferreds = array.map(this.roots, function(item) {
                    return this.store.get(item);
                }, this);

                when(promiseAll(deferreds), onComplete, onError);
            } else {
                this.inherited(arguments);
            }
        },

        getAncestors: function(item, /*Function*/ onComplete) {
            // summary:
            //      Calls onComplete() with an array of ancestors of the given item.
            // item: Object
            //      Item from the dojo/store

            // Return root if item is subroot
            if (this.roots.some(function (subRoot) { return this.getIdentity(item) === subRoot; }, this)) {
                onComplete([this.root]);
                return;
            }
            
            var root = this.root,
                callback = lang.hitch(this, function (results) {
                    if (array.some(this.roots, function(subRoot) { return this.getIdentity(results[0]) === subRoot; }, this)) {
                        results.unshift(root);
                    }
                    onComplete(results);
                });

            this.inherited(arguments, [item, callback]);
        },

        // =======================================================================
        // Inspecting items

        getIdentity: function(item) {
            // summary:
            //      Returns identity for an item.
            // item: Object
            //      Item from the dojo/store
            return (item === this.root) ? this.root.id : this.inherited(arguments); // String
        },

        canCopy: function (item) {
            // summary:
            //      Determine whether the copy action is supported for an item.
            // item: Object
            //      Item from the dojo/store
            return !this.isRoot(item) && this.inherited(arguments);
        },

        canCut: function (item) {
            // summary:
            //      Determine whether the cut action is supported for an item.
            // item: Object
            //      Item from the dojo/store
            return !this.isRoot(item) && this.inherited(arguments);
        },

        canDelete: function (item) {
            // summary:
            //      Determine whether the delete action is supported for an item.
            // item: Object
            //      Item from the dojo/store
            return !this.isTypeOfRoot(item) && this.inherited(arguments);
        },

        canEdit: function (item) {
            // summary:
            //      Determine whether the edit action is supported for an item.
            // item: Object
            //      Item from the dojo/store
            return !this.isRoot(item) && this.inherited(arguments);
        }
    });
});
},
'epi-cms/widget/ContentTreeStoreModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/when",
    "dojo/topic",
// epi
    "epi/dependency",
    "epi/shell/_StatefulGetterSetterMixin",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/_ContextMixin",
    "epi/shell/ViewSettings",
// EPi CMS
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/_HierarchicalModelMixin",
    "epi-cms/widget/viewmodel/_UpdateableStoreModelMixin"
],

function (
// dojo
    array,
    connect,
    declare,
    lang,

    aspect,
    Deferred,
    promiseAll,
    when,
    topic,
// epi
    dependency,
    _StatefulGetterSetterMixin,
    TypeDescriptorManager,
    _ContextMixin,
    ViewSettings,
// EPi CMS
    ApplicationSettings,
    ContentActionSupport,
    ContentReference,
    _HierarchicalModelMixin,
    _UpdateableStoreModelMixin
) {
    // module:
    //		epi-cms/widget/ContentTreeStoreModel
    // summary:
    //      A store model for tree widgets that only support content with a single root.
    return declare([_StatefulGetterSetterMixin, _HierarchicalModelMixin, _UpdateableStoreModelMixin, _ContextMixin], {
        // store: [protected] dojo.store.api.Store
        //		Underlying store that will be queried for page tree items.
        store: null,

        // root: [public] ContentReference|String
        //		Id of the root content
        root: null,

        // notAllowToDelete: [public] List of item that we don't allow to delete. For example: Waste basket, start, root folder,...
        //		Id of the root content
        notAllowToDelete: null,

        // notAllowToCopy: [public] List of item that we don't allow to copy. For example: Waste basket, root folder,...
        //		Id of the root content
        notAllowToCopy: null,

        // typeIdentifiers: [protected] Array | String
        //		The set of type identifiers to be taken into account. Can either be an array or a comma separated string.
        typeIdentifiers: null,

        showAllLanguages: true,

        getChildrenQuery: "getchildren",

        getRootChildrenQuery: null,

        // _observers: [protected] Array
        //		Collection to store all the listeners from observed queries.
        _observers: null,

        // _defaultDataStoreName: [protected] String
        //		Default data store name to get from registry, if store is null.
        _defaultDataStoreName: "epi.cms.content.light",

        // additionalQueryOptions: [protected] Object
        //		Additional query options added when getting children. Set by inherited model.
        additionalQueryOptions: {},

        // createAsLocalAsset: [public] Boolean
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        constructor: function (args) {
            // summary:
            //		Construct the ContentTreeStoreModel object.

            declare.safeMixin(this, args);

            this._observers = {};
            this.store = this.store || dependency.resolve("epi.storeregistry").get(this._defaultDataStoreName);

            this._queryOptions = lang.mixin({
                ignore: ["query"],
                comparers: {
                    "typeIdentifiers": lang.hitch(this, function (queryValue, instance) {
                        return array.some(queryValue, lang.hitch(this, function (item) {
                            return item === instance.typeIdentifier || TypeDescriptorManager.isBaseTypeIdentifier(instance.typeIdentifier, item);
                        }));
                    }),
                    "referenceId": function (queryValue, instance) {
                        return ContentReference.compareIgnoreVersion(queryValue, instance.parentLink);
                    },
                    "allLanguages": function (queryValue, instance) {
                        if (queryValue || !instance.currentLanguageBranch) {
                            return true;
                        }

                        return epi.areEqual(ApplicationSettings.currentContentLanguage, instance.currentLanguageBranch.languageId);
                    }
                },
                sort: this._getSortSettings(this.typeIdentifiers)
            }, this.additionalQueryOptions);

            var updateHandle = connect.subscribe("/epi/cms/contentdata/updated", this, function (updatedContent) {
                this.store.refresh(updatedContent.contentLink).then(lang.hitch(this, function () {
                    if (updatedContent.recursive) {
                        this.onItemChildrenReload(updatedContent);
                    }
                }));
            });

            //publish command has been executed: update children
            var childrenChangeHandle = connect.subscribe("/epi/cms/contentdata/childrenchanged", lang.hitch(this, this._childrenChanged));

            // To avoid tree not update when restored content to destination where haven't children before.
            var contentRestoreHandle = connect.subscribe("/epi/cms/contentdata/restored", this, function (restoredContent) {
                this._childrenChanged(restoredContent);
            });

            //when the store is refreshed, update the item
            var itemChangeHandle = aspect.after(this.store, "onItemChanged", lang.hitch(this, function (id, item) {
                this.onChange(item);
            }), true);

            this._handles = [updateHandle, childrenChangeHandle, contentRestoreHandle, itemChangeHandle];
        },

        destroy: function () {
            // summary:
            //		Destroy the object.

            for (var id in this._observers) {
                this._observers[id].cancel();

                this._observers[id] = null;
            }
            if (this._handles) {
                array.forEach(this._handles, function (handle) {
                    handle.remove();
                });

                this._handles = null;
            }
        },

        isSupportedType: function (dataType) {
            // summary:
            //      Check the supported type of data type selected.
            // dataType: [String]
            //      The type of data selected
            // tags:
            //      public

            return array.some(this.typeIdentifiers, function (type) {
                return type === dataType || TypeDescriptorManager.isBaseTypeIdentifier(dataType, type);
            });
        },

        _setShowAllLanguagesAttr: function (value) {
            this._set("showAllLanguages", value);
            this.onItemChildrenReload(this.root);
        },

        // =======================================================================
        // Methods for traversing hierarchy

        getRoot: function (onItem, onError) {
            // summary:
            //		Calls onItem with the root item for the tree, possibly a fabricated item.

            if (lang.isArray(this.root)) {
                onItem({});
            }
            else {
                when(this.store.get(this.root), onItem, onError);
            }
        },

        mayHaveChildren: function (item) {
            // summary:
            //		Tells if an item has or may have children.  Implementing logic here
            //		avoids showing +/- expando icon for nodes that we know don't have children.
            //		(For efficiency reasons we may not want to check if an element actually
            //		has children until user clicks the expando node)

            return item.hasChildren;
        },

        getChildren: function (parentItem, onComplete) {
            // summary:
            //		Calls onComplete() with array of child items of given parent item, all loaded.

            var id = this.getIdentity(parentItem),
                isRoot = id == this.root,
                queryType = isRoot && this.getRootChildrenQuery ? this.getRootChildrenQuery : this.getChildrenQuery,
                query = this._createQuery({ referenceId: id, query: queryType }),
                results = this.store.query(query, this._queryOptions),

                listener = lang.hitch(this, function (item) {
                    this.onChange(item);

                    when(this.store.query(query, this._queryOptions), lang.hitch(this, function (children) {
                        this.onChildrenChange(parentItem, children);
                    }));
                });

            var observer = this._observers[id];
            if (observer) {
                observer.cancel();
                delete this._observers[id];
            }

            // Observe the query result to update the parent node when have changes.
            this._observers[id] = results.observe(listener, true);

            when(results, onComplete);
        },

        _getSortSettings: function (/*String || Array*/typeIdentifiers) {
            // summary:
            //      Get sort settings by typeIdentifiers.
            // tags:
            //      protected virtual

            if (!typeIdentifiers) {
                return {};
            }

            if (typeIdentifiers instanceof String) {
                typeIdentifiers = [typeIdentifiers];
            }

            var self = this,
                sortColumn,
                sortSettings = [];

            typeIdentifiers.map(function (type) {
                sortColumn = TypeDescriptorManager.getValue(type, "sortKey");
                if (sortColumn) {
                    sortSettings.push(sortColumn.sortDescending ?
                            { attribute: sortColumn.columnName, descending: true } :
                            { attribute: sortColumn.columnName });
                }
            });

            return sortSettings;
        },

        _createQuery: function (queryBase, excludeType) {
            var typeIdentifiers = this.typeIdentifiers &&
                    (lang.isArray(this.typeIdentifiers) ? this.typeIdentifiers : this.typeIdentifiers.split(","));

            var language = this.showAllLanguages ? { allLanguages: true } : {},
                requestType = excludeType ? {} : { typeIdentifiers: typeIdentifiers };

            var query = lang.mixin(queryBase, requestType, language);

            return query;
        },

        _createChildrenQuery: function (queryBase, excludeType) {
            var childrenQuery = lang.mixin(queryBase, { query: "getchildren" });
            return this._createQuery(childrenQuery, excludeType);
        },

        move: function (source, target) {
            // summary:
            //      Move source item to target

            if (!target.contentLink) {
                target = this.store.get(target);
            }

            var deferreds = array.map(source, function (item) {

                return when(this.store.get(item.data.parentLink), lang.hitch(this, function (oldParent) {
                    return this.pasteItem(item.data, oldParent, target, false);
                }));
            }, this);

            return promiseAll(deferreds).then(lang.hitch(this, function (results) {
                if (target.contentLink === ApplicationSettings.wastebasketPage) {
                    // Filter the source array based on the results so that onDeleted is only called
                    // for items which were actually deleted.
                    var items = source.filter(function (i, index) { return !!results[index]; });
                    if (items.length) {
                        this.onDeleted(items);
                    }
                }
            }));
        },

        remove: function (items) {
            // summary
            //      Removes (deletes) the source

            var deferreds = items.map(function (item) {
                return this.store.remove(item.data.contentLink);
            }, this);

            return promiseAll(deferreds).then(lang.hitch(this, function () {
                this.onDeleted(items);
            }));
        },

        copy: function (source, target) {
            // summary:
            //      Copy source to target
            var deferreds = array.map(source, function (item) {

                return when(this.store.get(item.data.parentLink), lang.hitch(this, function (oldParent) {
                    return this.pasteItem(item.data, oldParent, target, true);
                }));
            }, this);

            return promiseAll(deferreds);
        },

        pasteItem: function (childItem, oldParentItem, newParentItem, copy, sortIndex) {
            // summary:
            //		Move or copy an item from one parent item to another.
            // childItem: Item
            //      A reference to the item that should be moved or copied
            // oldParentItem: Item
            //      The curent parent item
            // newParentItem: Item
            //      The target item for the operation
            // copy: Boolean
            //      If true the childItem will be copied; otherwise it will be moved.
            // sortIndex: integer
            //      Optional sortIndex in the child collection of the new parent
            // returns: object
            //      An object indicating the result of the operation
            //
            // tags: public
            //

            // Having copy/paste/delete call pasteItem may seem a bit backwards, but since the drag & drop
            // is calling pasteItem() with all required arguments it becomes a bit messy to drop some arguments
            // here (i.e. old/new parent) and then do the lookup again.
            // Those methods also have to duplicate the notification logic

            var id = this.getIdentity(childItem),
                isDeleted = newParentItem && newParentItem.isWastebasket,
                method = copy ? this.store.copy : this.store.move,
                params = {
                    targetId: this.getIdentity(newParentItem),
                    createAsLocalAsset: this.createAsLocalAsset,
                    sortIndex: sortIndex
                };

            // Call move or copy on the store with arguments
            return method.call(this.store, id, params).then(lang.hitch(this, function (response) {
                // NOTE: The order of these reload notifications are important for the tree to properly re-select the current item.

                // if newParentItem is a wastebasket, which means that we are moving a content into a wastebasket,
                // let's trigger the onDelete event, so the Tree (or the widget that uses this model) will delete the node from _itemNodesMap,
                // to avoid caching problem when restoring content.
                if (isDeleted) {
                    this.onDelete(childItem, true/*deleteChildren*/);
                } else {
                    // Publish a children changed event for the new parent to ensure that the new parent node is updated if it exists in other tree structures.
                    // For example: Blocks tree and Media tree when copy/move items.
                    topic.publish("/epi/cms/contentdata/childrenchanged", newParentItem.contentLink);
                }

                var itemId = copy ? response.extraInformation : childItem.contentLink;

                var contentLink = ContentReference.toContentReference(itemId).createVersionUnspecificReference().toString();

                // Update child item due to in some case the content of it may change after moving(e.g. parent field)
                return when(this.store.refresh(contentLink), lang.hitch(this, function (item) {
                    this._onPasteComplete(item, copy, isDeleted, oldParentItem, newParentItem);
                    return response;
                }));
            }));
        },

        onPasteComplete: function () {
            // summary:
            //      Stub to do somethings when paste process complete
            // tags:
            //      public, callback
        },

        _onPasteComplete: function (item, copy, isDeleted, oldParentItem, newParentItem) {
            // summary:
            //		Executed after a paste operation has completed
            // item: Item
            //      The target item of the operation
            // copy: boolean
            //      If it was a copy operation or not
            // isDeleted: boolean
            //      If the operation resulted in the item being deleted, i.e. moved to the trash
            // oldParentItem: Item
            //      The curent parent item
            // newParentItem: Item
            //      The target item for the operation
            // tags: protected

            this.onPasteComplete();

            this._selectItemOnPasteComplete(item, copy, isDeleted, oldParentItem, newParentItem);

            this.inherited(arguments);
        },

        _selectItemOnPasteComplete: function (item, copy, isDeleted, oldParentItem, newParentItem) {
            // summary:
            //		Select an item after a paste operation has completed
            // item: Item
            //      The target item of the operation
            // copy: boolean
            //      If it was a copy operation or not
            // isDeleted: boolean
            //      If the operation resulted in the item being deleted, i.e. moved to the trash
            // oldParentItem: Item
            //      The curent parent item
            // newParentItem: Item
            //      The target item for the operation
            // tags: protected

            if (item && item.contentLink && !isDeleted) {
                this.onSelect(item.contentLink, true);
            }
        },

        newItem: function (args, newParentItem) {
            // summary:
            //		Called when an item that's accepted in the tree is added by an external source, for instance by dragging an item from a listing to the tree.
            if (args.dndData && args.dndData.data) {
                var oldParentItem = this.getParentItem(args.dndData);
                this._pasteNewItem(args.dndData.data, oldParentItem, newParentItem);
            }
        },

        getParentItem: function (dndData) {
            if (dndData && dndData.data) {
                var parentLink = dndData.data["parentLink"];
                if (parentLink) {
                    parentLink = new ContentReference(parentLink).createVersionUnspecificReference().toString();
                }
                return { contentLink: parentLink };
            }
        },

        _pasteNewItem: function (childItem, oldParentItem, newParentItem) {
            //Right now we only support move actions when moving items from an external source to the tree. Might be changed in the future.
            this.pasteItem(childItem, oldParentItem, newParentItem, false/*copy*/);
        },

        _updateItemChanged: function (parentContentLink) {
            // update the parent cause of in some case its properties changed
            when(this.store.refresh(parentContentLink), lang.hitch(this, function (updatedItem) {
                // then update its children
                this._childrenChanged(updatedItem);
            }));
        },

        _childrenChanged: function (parent) {
            var dfd = new Deferred();

            this.getChildren(parent, lang.hitch(this, function (children) {
                this.onChildrenChange(parent, children);
                dfd.resolve(children);
            }));

            return dfd;
        },

        // =======================================================================
        // Inspecting items

        getIdentity: function (item) {
            // summary:
            //		Returns identity for an item

            if (lang.isObject(item)) {
                return this.store.getIdentity(item);
            }
            return item;
        },

        getObjectIconClass: function (/*Object*/item, /*String*/fallbackIconClass) {
            // summary:
            //      Get icon class for content based on its content link
            // item: [Object]
            //      Content item data
            // fallbackIconClass: [String]
            //      Default icon class in case nothing returned
            // tags:
            //      public, extension

            var defaultIconClass = TypeDescriptorManager.getValue(item.typeIdentifier, "iconClass");
            if (!defaultIconClass) {
                return fallbackIconClass;
            }

            var suffix = "";
            switch (parseInt(item.contentLink, 10)) {
                case ApplicationSettings.globalAssetsFolder:
                    suffix = "AllSites";
                    break;

                case ApplicationSettings.siteAssetsFolder:
                    suffix = "ThisSite";
                    break;

                default:
                    break;
            }

            return (suffix === "" && defaultIconClass === fallbackIconClass) ? defaultIconClass : (fallbackIconClass + " " + defaultIconClass + suffix);
        },

        getLabel: function (item) {
            // summary:
            //		Get the label for an item

            return item.name;
        },

        canExpandTo: function (item) {
            // summary:
            //		Test if the tree can expand to an item
            // item: Object
            //      The item
            // returns:
            //       A promise which resolves to true if the item can be reached, otherwise false.

            var deferred = new Deferred();

            this.getAncestors(item, lang.hitch(this, function (ancestors) {
                deferred.resolve(this.getIdentity(ancestors[0]) === this.root.id);
            }));

            return deferred.promise;
        },

        canCopy: function (item) {
            // summary:
            //		Determine whether the given item is able to be copied by the current user.
            // remarks:
            //      Override to implement additional check.
            // tags:
            //		public

            if (!item) {
                return false;
            }

            var reference = item.contentLink,
                isSystemPage = reference === this.root || (array.indexOf(this.notAllowToCopy, reference) >= 0);

            return !isSystemPage &&
                ContentActionSupport.hasAccess(item.accessMask, ContentActionSupport.accessLevel.Read) &&
                ContentActionSupport.hasProviderCapability(item.providerCapabilityMask, ContentActionSupport.providerCapabilities.Copy);
        },

        canCut: function (item) {
            // summary:
            //		Determine whether the given item is able to be cut by the current user.
            // tags:
            //		public

            if (!item) {
                return false;
            }

            var reference = item.contentLink,
                isSystemPage = reference === this.root || (array.indexOf(this.notAllowToDelete, reference) >= 0);

            return !isSystemPage &&
                ContentActionSupport.isActionAvailable(item, ContentActionSupport.action.Delete, ContentActionSupport.providerCapabilities.Move, true);
        },

        canDelete: function (item) {
            // summary:
            //		Determine whether the given item is able to be deleted by the current user.
            // tags:
            //		public

            if (!item) {
                return false;
            }

            var reference = item.contentLink,
                isSystemPage = reference === this.root || (array.indexOf(this.notAllowToDelete, reference) >= 0);

            return !isSystemPage &&
                ContentActionSupport.isActionAvailable(item, ContentActionSupport.action.Delete, ContentActionSupport.providerCapabilities.Delete, true);
        },

        canPaste: function (item, target, isCopy) {
            // summary:
            //      Determines whether the given item can be moved or copied from its current parent to a new location
            //      Primarily used when validating drag & drop operations.
            // tags:
            //      public

            if (!item || !target) {
                return false;
            }

            var isCopyToWastebasket = isCopy && target.isWastebasket,
                isCutToTheSameItem = !isCopy && (this.getIdentity(item) === this.getIdentity(target)),
                isCutToTheSameParent = !isCopy && (item.parentLink === this.getIdentity(target)),
                hasAccess = ContentActionSupport.isActionAvailable(target, ContentActionSupport.action.Create, ContentActionSupport.providerCapabilities.Create, true);

            return !target.isDeleted && !isCopyToWastebasket && !isCutToTheSameItem && !isCutToTheSameParent && hasAccess;
        },

        canEdit: function (item) {
            // summary:
            //		Determine whether the given item is able to be edit by the current user.
            // tags:
            //		public

            if (!item) {
                return false;
            }

            var reference = item.contentLink,
                isSystemPage = reference === this.root;

            return !isSystemPage && ContentActionSupport.hasAccess(item.accessMask, ContentActionSupport.accessLevel.Edit);
        },

        // =======================================================================
        // Callbacks

        onItemChildrenReload: function (/*Object*/parent) {
            // summary:
            //  Raised when the children of an item must be reloaded.
            //  The subscriber needs to call getChildren to get the updated children collection
        },

        onChange: function (/*dojo.data.Item*/ /*===== item =====*/) {
            // summary:
            //		Callback whenever an item has changed, so that Tree
            //		can update the label, icon, etc.   Note that changes
            //		to an item's children or parent(s) will trigger an
            //		onChildrenChange() so you can ignore those changes here.
            // tags:
            //		callback
        },

        onChildrenChange: function (/*===== parent, newChildrenList =====*/) {
            // summary:
            //		Callback to do notifications about new, updated, or deleted items.
            // parent: dojo.data.Item
            // newChildrenList: dojo.data.Item[]
            // tags:
            //		callback
        },

        onDelete: function (/*dojo.data.Item*/ /*===== item =====*/) {
            // summary:
            //		Callback when an item has been deleted.
            // description:
            //		Note that there will also be an onChildrenChange() callback for the parent
            //		of this item.
            // tags:
            //		callback
        },

        onDeleted: function (deletedItems) {
            // summary:
            //      Callback when an item has been deleted to set the parent folder as selected
            // item:
            //      item deleted
            // tags:
            //      public callback
            var item = deletedItems[0].data;

            // TODO: How to handle context change when the current context is in the array or deleted items.
            if (item) {
                when(this.getCurrentContext(), lang.hitch(this, function (ctx) {
                    var isPage = item.capabilities.isPage,
                        isCurrentEditingContent = ContentReference.compareIgnoreVersion(item.contentLink, ctx.id);

                    if (isPage && !isCurrentEditingContent) {
                        // Keep current editing page
                        return;
                    }

                    if (!isPage && isCurrentEditingContent) {
                        //Delete an asset (block/folder/media,..) that are currently editing the default context for the view should be selected
                        topic.publish("/epi/shell/context/request", { uri: ViewSettings.settings.defaultContext });
                        return;
                    }

                    // Select parent node
                    this.onSelect(item.parentLink, true);
                }));
            }
        },

        onSelect: function (item, setFocus, onComplete) {
            // summary:
            //      Raise event to set an item as selected
            // tags:
            //      callback
        }
    });
});
},
'epi-cms/widget/_HierarchicalModelMixin':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
// epi
    "epi/shell/_HierarchicalModelMixin"
],

function (
// dojo
    declare,
    lang,
// epi
    _HierarchicalModelMixin
) {

    // module:
    //      epi-cms/widget/_HierarchicalModelMixin
    // description:
    //      Decorate model for epi/shell/_HierarchicalModelMixin
    // tags:
    //      public

    return declare([_HierarchicalModelMixin], {

        isTypeOfRoot: function (/*dojo.data.Item*/contentItem) {
            // summary:
            //      Checks to see if the item is type of root node such as: root, sub root
            // contentItem: [dojo.data.Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public, extension

            return !!(contentItem && (this.isRoot(contentItem) || contentItem.isSubRoot));
        },

        isRoot: function (/*dojo.data.Item*/contentItem) {
            // summary:
            //      Checks to see if the item is a root node in the content tree
            // contentItem: [dojo.data.Item]
            //      The given data item object that wanted to verify
            // returns: [Boolean]
            // tags:
            //      public

            return !!(contentItem && this.root && contentItem === this.root);
        }

    });

});
},
'epi/shell/_HierarchicalModelMixin':function(){
﻿define("epi/shell/_HierarchicalModelMixin", [
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/when"
], function (
    array,
    declare,
    lang,
    Deferred,
    all,
    when
) {

    // summary:
    //		A mixin that adds Hierarchical support for a model
    return declare([], {

        // parentProperty: [public] string
        //      The name of the property that indentifies the parent (e.g. parentLink)
        parentProperty: "parentLink",

        // store: [public] dojo/store/JsonRest
        //      The store that is used to get the ancestors
        store: null,

        constructor: function (options) {
            declare.safeMixin(this, options);
        },

        getParentIdentity: function (item) {
            // summary:
            //		Get the identity of the parent
            //
            //  item:
            //      The item to get the parent identity for
            //
            //  tags:
            //      public

            return lang.getObject(this.parentProperty, false, item);
        },

        isAncestor: function (source, target) {
            // summary:
            //		Checks to see if the source is an ancestor of the target.
            //
            //  source:
            //      The item to check if ancestor
            //
            //  target:
            //      The item to check the source against
            //
            //  tags:
            //      public

            var sourceId = this.store.getIdentity(source),
                targetId = this.store.getIdentity(target),
                targetParentId = this.getParentIdentity(target);

            if (sourceId == targetId || (target.parentLink && source.contentLink == target.parentLink)) {
                return true;
            }

            if (targetParentId) {
                return false;
            }

            return when(this.store.get(targetParentId), lang.hitch(this, function (parent) {
                return this.isAncestor(source, parent);
            }));
        },

        getAncestors: function (item, onComplete) {
            // summary:
            //		Get the ancestors for the item
            //
            //  item: Object
            //      The item to get the ancestors for, or the identity of the item
            //
            //  onComplete: callback function
            //      Function that will be invoked when the getAncestors has completed
            //
            //  tags:
            //      public

            if (!this.store) {
                onComplete([]);
                return;
            }

            var obj = typeof item === "object" ? item : this.store.get(item);
            when(obj, lang.hitch(this, function (storeItem) {
                when(this._getAncestors([storeItem]), onComplete);
            }));
        },

        _getAncestors: function(items) {
            // If the first item is a root then stop the recursion.
            if(this._hasRoot(items)) {
                return items.slice(0, -1);
            }

            var parentId = this.getParentIdentity(items[0]);
            if (!parentId) {
                return items.slice(0, -1);
            }

            return when(this.store.get(parentId), lang.hitch(this, function (parent) {
                if (parent) {
                    items.unshift(parent);
                    return this._getAncestors(items);
                }
                return items.slice(0, -1);
            }));
        },

        _hasRoot: function(items) {
            // summary:
            //      Checks to see if the first item is a root item.
            // tags:
            //      private
            var roots = this.roots || [this.root];

            if (!items.length || !roots.length || typeof this.getIdentity !== "function") {
                return false;
            }

            var identity = this.getIdentity(items[0]);

            return array.some(roots, function(root) {
                return root == identity;
            }, this);
        },

        refreshAncestors: function (item, filter) {
            // summary:
            //      Refreshes the data for each ancester. If a filter function is specified
            //      only ancestors matching the filter will be refreshed.
            //
            //  item: Object
            //      The item or the identity to refresh the ancestors for
            //
            //  filter: function
            //      Filter function used to select which ancestors to refresh. Optional
            //
            // tags:
            //      public

            var store = this.store,
                deferred = new Deferred(),
                refreshDeferreds = [],
                refreshed = [];

            this.getAncestors(item, function (ancestors) {

                array.forEach(ancestors, function (ancestor) {
                    if (!filter || filter(ancestor)) {
                        refreshDeferreds.push(when(store.refresh(store.getIdentity(ancestor)), function (item) { refreshed.push(item); }));
                    }
                });

                all(refreshDeferreds).then(function () {
                    deferred.resolve(refreshed);
                });

            });

            return deferred.promise;
        }
    });
});
},
'epi-cms/widget/viewmodel/_UpdateableStoreModelMixin':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/Deferred",
    "dojo/Evented",
    "dojo/json",
    "dojo/topic",
    "dojo/when",
// epi
    "epi/dependency",

    "epi-cms/ApplicationSettings",
    "epi-cms/_ContentContextMixin",
    "epi-cms/core/ContentReference"
],

function (
// dojo
    array,
    declare,
    lang,

    Deferred,
    Evented,
    json,
    topic,
    when,
// epi
    dependency,

    ApplicationSettings,
    _ContentContextMixin,
    ContentReference
) {

    // module:
    //      epi-cms/widget/viewmodel/_UpdateableStoreModelMixin
    // tags:
    //      public, mixin

    return declare(Evented, {

        // updateableStore: [private] dojo.store
        //      Underlying store that will be post data to server for items.
        updateableStore: null,

        // updateableStoreKey: [public] string
        //      Dependency key to resolve the updateableStore
        updateableStoreKey: "epi.cms.contentdata",

        // currentContentService: [public] Object
        //      Instance of _ContentContextMixin because we can not mixin _ContentContextMixin directly.
        currentContentService: null,

        // propertyNames: [public] Object
        //      Maps between client side property names and their server side counterparts
        propertyNames: {
            name: "icontent_name",
            nameInUrl: "iroutable_routesegment"
        },

        // refreshTranslatedAncestors: [public] boolean
        //      If true ancestors of the changed node will be refreshed
        refreshTranslatedAncestors: true,

        // onAddDelegate: [public] function
        //      Will be executed after add
        onAddDelegate: null,

        postscript: function () {
            this._setupStore();
            this.currentContentService = new _ContentContextMixin();
        },

        _setupStore: function () {
            if (!this.updateableStore && this.updateableStoreKey) {
                this.updateableStore = dependency.resolve("epi.storeregistry").get(this.updateableStoreKey);
            }
        },

        rename: function (id, name) {
            // summary:
            //      Renames an item
            // tags:
            //      public

            var self = this,
                deferred = new Deferred();

            when(self.patch(id, { name: name, nameInUrl: null }), function (item) {
                when(self.refreshTranslated(id), function () {
                    deferred.resolve(item);
                }, function (e) { deferred.reject(e); });
            }, function (e) { deferred.reject(e); });

            return deferred;
        },

        translate: function (item) {
            // summary:
            //      Creates a version translated into the current language
            // item: Item
            //      Item to translate
            // tags:
            //      public

            var self = this,
                id = self.getIdentity(item),
                model = {
                    masterLanguageVersionId: id,
                    name: item.name,
                    contentTypeId: item.contentTypeID
                };

            return when(self.updateableStore.put(model), function () {
                when(self.store.refresh(id), function () {
                    when(self.refreshTranslated(id), function () {
                        // Select and start edit UI of the translated node
                        self.onSelect(id, true, self.onAddDelegate);
                    });
                });
            });
        },

        add: function (/*Object*/item, /*Function?*/onComplete) {
            // summary:
            //      Add new item
            // item: [Object]
            //      New item data
            // onComplete: [Function?]
            //      Callback function to do something when new content created
            // tags:
            //      Public

            var self = this;

            var def = new Deferred();

            when(self.updateableStore.add(item), function (response) {
                var id = self.getContentId(response),
                    parentId = self.getParentIdentity(item),
                    refreshDeferred = null;

                when(self.updateableStore.get(id), function (/*dojo.data.Item*/addedItem) {
                    if (self.getParentIdentity(addedItem) != parentId) {
                        refreshDeferred = typeof onComplete == "function" && onComplete();
                    }

                    when(refreshDeferred, function () {
                        when(self._childrenChanged(parentId), function () {
                            when(self.refreshTranslated(id), function () {
                                self.onSelect(id, true, self.onAddDelegate);
                                def.resolve(addedItem);
                            });
                        });
                    });
                });
            });

            return def.promise;
        },

        patch: function (id, properties) {
            // summary:
            //      Patches the item with the submitted id and updates cache on success
            // id:
            //      Identity of the item to patch
            // properties:
            //      Properties to patch for the item
            // tags:
            //      public

            var self = this,
                deferred = new Deferred(),
                patchData = { id: id, properties: {} };

            //Fix the properties and change the names if needed
            for (var key in properties) {
                if (properties.hasOwnProperty(key)) {
                    patchData.properties[this._convertPropertyName(key)] = json.stringify(properties[key]);
                }
            }

            when(self.updateableStore.patch(patchData, { id: patchData.id }), function (item) {
                if (item && item.successful) {
                    var cacheData = {
                        contentLink: id,
                        properties: patchData.properties,
                        capabilities: { supportsVersions: false } // TODO: This is temporary until we have implemented dependant store capabilities checks
                    };
                    lang.mixin(cacheData, properties);

                    when(self.updateableStore.patchCache(cacheData), deferred.resolve, deferred.reject);
                }
                else {
                    return deferred.reject(item && item.validationErrors);
                }
            });

            return deferred;
        },

        _convertPropertyName: function (name) {
            return this.propertyNames[name] || name;
        },

        refreshTranslated: function (/*String*/contentId) {
            // summary:
            //      Refresh translated ancestor contents
            // tags:
            //      public

            var self = this,
                deferred = new Deferred(),
                failed;

            // Used to filter which ancestors to refresh
            function filter(item) {
                var id = self.getIdentity(item),
                    parentId = self.getParentIdentity(item);

                if (parentId == self.root || // is subroot
                    id == self.root || // is root
                    !item.missingLanguageBranch) { // already translated
                    return false;
                }

                return true;
            }

            if (!self.refreshTranslatedAncestors) {
                return deferred.resolve();
            }

            // Then refresh the ancestors
            when(self.refreshAncestors(contentId, filter), function (refreshedItems) {
                if (!(refreshedItems instanceof Array) || refreshedItems.length === 0) {
                    deferred.resolve();
                    return;
                }

                // Reverse array in order to get nearest ancestor
                refreshedItems.reverse();

                var hadAnyUntranslatedAncestor = array.some(refreshedItems, function (item) {
                        if (!!item.missingLanguageBranch) {
                            failed = self.getLabel(item);
                            return true;
                        }

                        return false;
                    });

                // Check if any ancestors were not translated, in that case show notification of this
                when(self.store.get(contentId), function (contentItem) {
                    if (hadAnyUntranslatedAncestor && contentItem && !contentItem.missingLanguageBranch) {
                        self.emit("translationFailed", failed);
                    }

                    deferred.resolve();
                });
            });

            return deferred;
        },

        getContentId: function (/*String*/contentLink) {
            // summary:
            //      Get content link without its work version
            // tags:
            //      private

            return ContentReference.toContentReference(contentLink).id.toString();
        },

        _onPasteComplete: function (item, copy, isDeleted, oldParentItem, newParentItem) {
            // summary:
            //      Executed after a paste operation has completed
            // item: Item
            //      The target item of the operation
            // copy: boolean
            //      If it was a copy operation or not
            // isDeleted: boolean
            //      If the operation resulted in the item being deleted, i.e. moved to the trash
            // oldParentItem: Item
            //      The curent parent item
            // newParentItem: Item
            //      The target item for the operation
            // tags: protected

            if (!item) {
                return;
            }

            if (!isDeleted) {
                this.refreshTranslated(this.getIdentity(item));
            } else {
                this.currentContentService.getCurrentContent().then(lang.hitch(this, function (currentContent) {
                    var isSameAsCurrentContent = ContentReference.compareIgnoreVersion(item, currentContent) && currentContent.isDeleted;
                    // Do nothing if it's not belong to our repository.
                    if (!isSameAsCurrentContent) {
                        return;
                    }

                    var query = this._createQuery({ referenceId: this.getIdentity(oldParentItem), query: this.getChildrenQuery }, true);
                    when(this.store.query(query, this._queryOptions), lang.hitch(this, function (children) {
                        var newContextId = oldParentItem ? oldParentItem.contentLink : null;
                        // Show start page if our parent is poor.
                        if (!children || !(children instanceof Array) || children.length <= 0) {
                            newContextId = ApplicationSettings.startPage;
                        }
                        if (newContextId) {
                            var contextParameters = { uri: "epi.cms.contentdata:///" + newContextId };
                            topic.publish("/epi/shell/context/request", contextParameters);
                        }
                    }));
                }));
            }
        }

    });

});
},
'epi-cms/widget/ContextualContentForestStoreModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/topic",
    "dojo/when",
// epi
    "epi/shell/TypeDescriptorManager",
    "epi-cms/_ContentContextMixin",
    "epi-cms/contentediting/_ContextualContentContextMixin",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/ContentForestStoreModel"
],

function (
// dojo
    array,
    declare,
    lang,

    aspect,
    Deferred,
    promiseAll,
    topic,
    when,
// epi
    TypeDescriptorManager,
    _ContentContextMixin,
    _ContextualContentContextMixin,
    ContentReference,
    ContentForestStoreModel
) {

    // module:
    //      epi-cms/widget/ContextualContentForestStoreModel
    // description:
    //      Adds a contextual root node to the tree.
    // tags:
    //      public

    return declare([ContentForestStoreModel, _ContentContextMixin, _ContextualContentContextMixin], {

        // handleSelection: [public] Boolean
        //      Flag indicates that we should handle selection on the given tree when it had refresh
        handleSelection: null,

        // previousSelection: [public] Object
        //      Holds information about previous selection in the tree
        //      Object's properties:
        //          selectedContent: [public] Object
        //              An instance of the "dijit._TreeNode"
        //              Holds the previous selected content of the given tree
        //          selectedAncestors: [public] Array
        //              Holds the ancestors of the previous selected content of the given tree
        previousSelection: null,

        // =======================================================================
        // Public overrided functions

        postscript: function () {

            this.inherited(arguments);

            this._handles.push(topic.subscribe("/epi/cms/action/createlocalasset", lang.hitch(this, this.refreshRoots)));
            this._handles.push(topic.subscribe("/epi/cms/action/togglecreatemode", lang.hitch(this, this._toggleContextualContent)));

            this._handles.push(aspect.around(this, "pasteItem", lang.hitch(this, this._aroundPasteItem)));
            this._handles.push(aspect.after(this.store, "get", lang.hitch(this, this._afterStoreGet)));
        },

        contentContextChanged: function (context, callerData) {
            // summary:
            //    Called when the currently loaded content changes. I.e. a new content data object is loaded into the preview area.
            // tags:
            //    protected

            this.inherited(arguments);

            // When the context changed, update the tree roots with the ordinary roots and the new context root.
            this.refreshRoots();
        },

        getChildren: function (parentItem, onComplete, onError) {
            // summary:
            //      Calls onComplete() with array of child items of given parent item.
            // parentItem: Object
            //      Item from the dojo/store
            // tags:
            //      public

            if (parentItem === this.root) {
                when(this._getRootItems(), onComplete, onError);
            } else {
                // Overrides onComplete callback function in order to return an empty array of child content for pseudo contextual root
                if (this.isPseudoContextualRoot(parentItem)) {
                    onComplete([]);
                    return;
                }

                this.inherited(arguments);
            }
        },

        // TODO: The getAncestors method should be generalized to support multiple roots and moved to the _HierarchicalModelMixin. (bemc)
        getAncestors: function (item, /*Function*/ onComplete) {
            // summary:
            //      Calls onComplete() with an array of ancestors of the given item.
            // item: Object
            //      Item from the dojo/store

            var inherited = this.getInherited(arguments);

            // Get the contextual root ID and concatenate it with the roots array.
            when(this.getCurrentContent(), lang.hitch(this, function (currentContent) {

                var roots = this.roots.concat(currentContent.assetsFolderLink),
                    callback = lang.hitch(this, function (results) {
                        // Loop through the results from the end to find the first item that is a
                        // root. If a root is found then append the virtual root as the first item and resolve.
                        var ancestor;
                        for (var i = results.length - 1; i >= 0; i--) {
                            ancestor = results[i];

                            // Update as contextual root
                            if (this.isContextualRoot(ancestor)) {
                                results[i] = this.getContextualRoot(ancestor);
                            }

                            if (array.indexOf(roots, this.getIdentity(ancestor)) >= 0) {
                                results = results.slice(i);
                                results.unshift(this.root);
                                onComplete(results);
                                return;
                            }
                        }

                        // Otherwise if no root item is found resolve with only the virtual root.
                        onComplete([this.root]);
                    });

                // If the given item is a root node then resolve with only the virtual root.
                if (array.indexOf(roots, this.getIdentity(item)) >= 0) {
                    onComplete([this.root]);
                }

                inherited.apply(this, [item, callback]);
            }));
        },

        getObjectIconClass: function (/*dojo.data.Item*/contentItem, /*String*/fallbackIconClass) {
            // summary:
            //      Get icon class for content based on its content link
            // contentItem: [dojo.data.Item]
            //      Content item data
            // fallbackIconClass: [String]
            //      Default icon class in case nothing returned
            // tags:
            //      public, extension

            var dataType = this._currentContext && this._currentContext.dataType;

            if (!dataType) {
                return this.inherited(arguments);
            }

            var contentIconClass = TypeDescriptorManager.getValue(dataType, "iconClass");

            return this.isContextualContent(contentItem)
                ? (contentIconClass
                    ? fallbackIconClass + " " + contentIconClass + "Contextual"
                    : fallbackIconClass
                )
                : this.inherited(arguments);
        },

        // =======================================================================
        // Public functions

        onToggleContentDisplay: function (/*String*/target, /*Boolean*/display) {
            // summary:
            //      Callback whenever widget switcher changed
            // target: [String]
            //      Assets folder content item that want to show/hide
            // display: [Boolean]
            // tags:
            //      public, callback
        },

        onRefreshRoots: function (/*dojo.data.Item*/refreshItem) {
            // summary:
            //      Callback whenever context changed
            // refreshItem: [dojo.data.Item]
            //      Assets folder content item that want to refresh
            // tags:
            //      public, callback
        },

        refreshRoots: function (sender) {
            // summary:
            //      Refresh root contents
            // sender: Object
            //      The instance that published the topic
            // tags:
            //      public

            //If the topic was published from this model do not react on it.
            if (sender === this) {
                return true;
            }

            var self = this;
            return self._refreshPromise = when(self._refreshPromise, function () {
                return when(self._getRootItems(), function (children) {
                    self.onChildrenChange(self.root, children);
                    if (self.get("handleSelection") === true) {
                        return self._setSelection(lang.clone(children).pop());
                    }
                });
            });
        },

        canCopy: function (item) {
            // summary:
            //      Determine whether the copy action is supported for an item.
            // item: Object
            //      Item from the dojo/store
            // tags:
            //      public, override

            // Do not allow to copy the current contextual folder
            return this.isContextualContent(item) ? false : this.inherited(arguments);
        },

        canCut: function (/*dojo.data.Item*/item) {
            // summary:
            //      Determine whether the given item is able to be cut by the current user.
            // item: [dojo.data.Item]
            //      The source content item data that is being copied/cut
            // tags:
            //      public, override

            // Do not allow to cut the current contextual folder
            return this.isContextualContent(item) ? false : this.inherited(arguments);
        },

        canPaste: function (item, target, isCopy) {
            // summary:
            //      Determines whether the given item can be moved or copied from its current parent to a new location
            //      Primarily used when validating drag & drop operations.
            // item: [dojo.data.Item]
            //      The source content item data that is being copied/cut
            // target: [dojo.data.Item]
            //      The destination content item data
            // isCopy: Boolean
            //      If true, action is copy, otherwise is cut
            // tags:
            //      public, override

            var self = this,
                inherited = self.getInherited(arguments),
                deferred = new Deferred();

            if (isCopy) {
                deferred.resolve(inherited.apply(self, [item, target, isCopy]));
            } else {
                when(self.getCurrentContent(), function (currentContent) {
                    self.getAncestors(target, function (ancestors) {

                        // If we paste into current contextual folder or one of its children
                        var isPastingToContextualContent = self.isContextualContent(target) || self.hasContextual(ancestors);
                        if (isPastingToContextualContent) {

                            // and cut content is the current context
                            if (ContentReference.compareIgnoreVersion(item.contentLink, currentContent.contentLink)) {
                                deferred.resolve(false);
                            } else {
                                // or cut content is an ancestor of the current context
                                self.getAncestors(currentContent.contentLink, function (ancestors) {
                                    deferred.resolve(array.some(ancestors, function (ancestor) {
                                        return item.contentLink === ancestor.contentLink;
                                    }, this)
                                    ? false
                                    : inherited.apply(self, [item, target, isCopy]));
                                });
                            }
                        } else {
                            deferred.resolve(inherited.apply(self, [item, target, isCopy]));
                        }
                    });
                });
            }

            return deferred;
        },

        filterAncestors: function (ancestors) {
            // summary:
            //      Filter out the pseudo contextual content from the given ancestor list incase pseudo content is not the deepest ancestor.
            // ancestors: [Array]
            //      Collection of ancestor content
            // tags:
            //      public

            if (!(ancestors instanceof Array)) {
                return ancestors;
            }

            var pseudoIndex = ancestors.indexOf(this._getPseudoContextualContent().toString());
            if (pseudoIndex !== -1 && pseudoIndex < ancestors.length - 1) {
                ancestors.splice(pseudoIndex, 1);
            }

            return ancestors;
        },

        // =======================================================================
        // Private functions

        _toggleContextualContent: function (/*Boolean*/createMode) {
            // summary:
            //      Show/Hide contextual content (local asset folder)
            // createMode: [Boolean]
            //      Flag indicates that the current mode is create new content or not
            // tags:
            //      private

            when(this.getCurrentContent(), lang.hitch(this, function (currentContent) {
                this.onToggleContentDisplay(currentContent.assetsFolderLink, !createMode);
                this._setSelection(null); // Pass 'null' value in order to set selection to the default target on the tree
            }));
        },

        _setSelection: function (/*Object*/targetItem) {
            // summary:
            //      Set selection tree node by the given content link string
            // targetItem: [Object]
            //      An instance of "dojo.data.Item"
            // tags:
            //      private

            var defaultTarget = this.roots[0].toString(),
                target = targetItem != null ? targetItem.contentLink : defaultTarget,
                previousSelection = this.get("previousSelection"),
                previousContextualSelection = this.get("previousContextualSelection"),
                selectDeferred = new Deferred();

            if (!(target && previousSelection)) {
                selectDeferred.resolve();
                return selectDeferred;
            }

            var focusTarget = false, // Set focus to the target is FALSE to prevent steal focus of the others
                previousSelectedContent = previousSelection.selectedContent,
                previousSelectedAncestors = previousSelection.selectedAncestors,
                previousIsVirtualRoot = previousSelectedContent.item && !previousSelectedContent.item.contentLink;

            var onComplete = function (target) {
                selectDeferred.resolve();
            };

            if (previousIsVirtualRoot || this.hasContextual(previousSelectedAncestors)) {
                this.onSelect(target, focusTarget, onComplete);
            } else if (previousSelectedContent.item.contentLink == defaultTarget
                    && previousContextualSelection
                    && previousContextualSelection.selectedContent
                    && previousContextualSelection.selectedContent.item
                    && previousContextualSelection.selectedContent.item.contentLink) {
                this.onSelect(previousContextualSelection.selectedContent.item.contentLink, focusTarget, onComplete);
            } else {
                selectDeferred.resolve();
            }

            return selectDeferred;
        },

        _getRootItems: function () {
            // summary:
            //      Resolves the root items, including the contextual root.
            // tags:
            //      private

            var self = this,
                currentStore = self.store,
                // Load all ordinary roots
                rootLoads = array.map(self.roots, function (item) {
                    return currentStore.get(item);
                });

            var contextRootLoad =
                // REMARK: This is not a longterm solution. We should push the currentContent to the model instead of getting it from the ContentContextMixin.
                // this model could be use when we do not have a editing context. E.g. an addon that just want's to pick a page/image etc.
                when(promiseAll([self.getCurrentContent(), self.getCurrentContext()]), function (result) {

                    var currentContent = result[0],
                        currentContext = result.length > 1 ? result[1] : null;

                    var currentContentWithoutVersion = new ContentReference(currentContent.contentLink).createVersionUnspecificReference().toString();
                    return when(currentStore.get(currentContentWithoutVersion), function (content) {
                        var inCreateMode = currentContext && currentContext.currentMode === "create";
                        if ((inCreateMode && self.get("view") === "contentselector") || !self.canHaveContextualContent(content)) {
                            return null;
                        }

                        // If the current context provided a context root, load it
                        var assetsFolderLink = content.assetsFolderLink;
                        if (assetsFolderLink) {
                            var getContextualContent = function (localFolderLink) {

                                // We need to call refresh local folder here in order to set its selection on the folder tree and refresh its icon and label.
                                return when(currentStore.get(localFolderLink), function (contextualContent) {
                                    // Take query in order to filters properly children that are allowed.
                                    // So that, we will show the expanded/collapsed icon for the root node correctly.
                                    var query = {
                                        "id": contextualContent.contentLink,
                                        "typeIdentifiers": self.typeIdentifiers,
                                        "allLanguages": self.showAllLanguages
                                    };

                                    return when(currentStore.query(query), function (refreshedContent) {
                                        // Only show contextual content in the container that supports its type identifier
                                        if (typeof self.isSupportedType === "function" && !self.isSupportedType(refreshedContent.typeIdentifier)) {
                                            return null;
                                        }

                                        if (!self.isPseudoContextualRoot(refreshedContent)) {
                                            return self.getContextualRoot(refreshedContent);
                                        } else {
                                            return when(self.onRefreshRoots(refreshedContent), function () {
                                                return self._modifyContentAccess(refreshedContent, content);
                                            });
                                        }
                                    });
                                });
                            };

                            if (assetsFolderLink == self._getPseudoContextualContent()) {
                                return when(currentStore.refresh(currentContentWithoutVersion), function (refreshedContent) {
                                    return getContextualContent(refreshedContent.assetsFolderLink);
                                });
                            } else {
                                return getContextualContent(assetsFolderLink);
                            }
                        }

                        return null;
                    });
                },
                //We want a return even when the content without version fails due to improper context handling.
                function (error) {
                    console.debug("Could not get current content", error);
                    return null;
                });

            // Add context root load to the ordinary root loads
            rootLoads.push(contextRootLoad);

            return when(promiseAll(rootLoads), function (rootItems) {
                // When loads are done, filter the ones that resolve null
                return array.filter(rootItems, Boolean);
            });
        },

        _aroundPasteItem: function (originalFunction) {
            // summary:
            //      Stubs to do somethings before pasteItem processing
            // tags:
            //      private

            var self = this;

            return function (/*dojo.data.Item*/childItem, /*dojo.data.Item*/oldParentItem, /*dojo.data.Item*/newParentItem, /*Boolean*/copy, /*Integer?*/sortIndex) {
                var targetItem = newParentItem,
                    createAsLocalAsset = self.get("createAsLocalAsset");

                // If the new parent item is pseudo contextual content, get current content context item insteads
                // In additional, change the value of the "createAsLocalAsset" to TRUE if its value is FALSE, otherwise do nothing
                return when(self.getCurrentContent(), function (contextContentItem) {

                    if (!createAsLocalAsset) {
                        createAsLocalAsset = self.isPseudoContextualRoot(targetItem);
                        self.set("createAsLocalAsset", createAsLocalAsset);
                    }

                    createAsLocalAsset && (targetItem = contextContentItem);

                    return when(originalFunction.apply(self, [childItem, oldParentItem, targetItem, copy, sortIndex]), function (response) {
                        if (createAsLocalAsset) {
                            self.set("createAsLocalAsset", false);
                            return when(self.refreshRoots(), function () {

                                // REMARK: This is not a very good place to do this, but when we can't rely on the
                                // store notfications for the contextual content we need to do this
                                // If the item got a new parent, publish the local asset created topic
                                topic.publish("/epi/cms/action/createlocalasset", self);

                                return response;
                            });
                        } else {
                            return response;
                        }
                    });
                });
            };
        },

        _afterStoreGet: function (/*Object*/promise) {
            // summary:
            //      Decorates result before send it back
            // promise: [Object]
            //      Store get() result
            // tags:
            //      private

            var self = this;
            return when(promise, function (result) {
                return when(self.getCurrentContent(), function (currentContent) {
                    return self._modifyContentAccess(result, currentContent);
                }, function (error) {
                    //If we fail to load the current content return the value from the store
                    return result;
                });
            });
        },

        _modifyContentAccess: function (/*dojo.data.Item*/targetContent, /*dojo.data.Item*/sourceContent) {
            // summary:
            //      Modify access marks for the given pseudo contextual content
            // targetContent: [dojo.data.Item]
            //      Pseudo contextual content asset folder that needed to overrides access marks
            // sourceContent: [dojo.data.Item]
            //      Source content that used to copy access marks from
            // tags:
            //      private

            // Only modify the content item name if it is a contextual content
            if (this.isContextualContent(targetContent)) {
                var contextualRoot = this.getContextualRoot(targetContent);
                // Only modify the access maske if its the fake folder
                return this.isPseudoContextualRoot(targetContent)
                    ? lang.mixin(contextualRoot, {
                        isPreferredLanguageAvailable: sourceContent.isPreferredLanguageAvailable,
                        accessMask: sourceContent.accessRights // Mix on the access rights that does not include language access rights
                    })
                    : contextualRoot;
            }

            return targetContent;
        }

    });

});
},
'epi-cms/component/command/_GlobalToolbarCommandProvider':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dijit/form/Button",
    
    "epi/shell/command/_CommandProviderMixin"
], function (
    declare,
    lang,
    
    Button,

    _CommandProviderMixin) {

    return declare([_CommandProviderMixin], {
        // module:
        //		epi-cms/component/command/_GlobalToolbarCommandProvider
        // summary:
        //		Base class for command providers that adds command to the epi-cms/component/GlobalToolbar
        // tags:
        //      abstract

        addToLeading: function (command, settings) {
            // summary:
            //      Append the given command to the command list
            // command:
            //      The command to append
            // settings:
            //      The settings to use when creating the menu item for the command
            // tags:
            //      protected
            this.addCommand(command, settings);
        },

        addToCenter: function (command, settings) {
            // summary:
            //      Append the given command to the command list
            // command:
            //      The command to append
            // settings:
            //      The settings to use when creating the menu item for the command
            // tags:
            //      protected
            settings = lang.mixin({
                category: "center"
            }, settings);

            this.addCommand(command, settings);
        },

        addToTrailing: function (command, settings) {
            // summary:
            //      Append the given command to the command list
            // command:
            //      The command to append
            // settings:
            //      The settings to use when creating the menu item for the command
            // tags:
            //      protected
            settings = lang.mixin({
                category: "trailing"
            }, settings);

            this.addCommand(command, settings);
        },

        addCommand: function (/*_Command*/command, /*Object*/settings) {
            // summary:
            //      Append the given command to the command list, uncategorized commands will be added to the "leading" category
            // command:
            //      The command to append
            // settings:
            //      The settings to use when creating the menu item for the command
            // tags:
            //      protected
            settings = lang.mixin({
                "class": "epi-mediumButton",
                iconClass: command.iconClass,
                category: "leading",
                label: command.label,
                tooltip: command.tooltip,
                showLabel: false,
                widget: Button,
                model: command
            }, settings);


            //Create a delagate for the command
            command = lang.delegate(command, { settings: settings });

            //Add to the command list
            this.add("commands", command);
        }
    });
});

},
'epi-cms/contentediting/EditorFactory':function(){
﻿define([
"dojo/_base/declare",
"dojo/_base/Deferred",
"dojo/_base/lang",
"epi/string"],

function (declare, Deferred, lang, epiString) {

    return declare(null, {
        // summary:
        //		Factory class, responsible for creating appropriate editor wrapper.

        // defaultWrapperType: [public] String
        //      Default wrappert type
        defaultWrapperType: "flyout",

        // _registeredEditorWrappers: [private] Array
        //      Registered editors array
        _registeredEditorWrappers: null,

        onEditorCreated: function (/*dijit._Widget*/editorWidget) {
            // summary:
            //    Triggered when the editor widget is created
            // editorWidget: 
            //    The newly created widget
            // tags:
            //    public callback
        },

        onEditorResolved: function (/*Object*/data, /*Object*/property) {
            // summary:
            //		Set this handler to be notified when editing and editor wrapper has been resolved.
            //      This might be used to change editor or editor wrapper before the actual instantiation.
            // data: 
            //      The resolved settings. Can be changed by listener.
            // property: 
            //		The settings for the property that is to be edited.
            // tags:
            //		callback
        },

        constructor: function () {
            // summary:
            //		Sets up private arrays etc.
            // tags:
            //		private
            this._registeredEditorWrappers = {};
        },

        registerEditorWrapper: function (/*String*/wrapperType, /*Function|String*/wrapperClassType, initializer) {
            // summary:
            //		Create the property editor.
            // wrapperType:
            //      The way the editor is shown: inline or dialog
            // wrapper:
            //      Can either be wrapper class or wrapper class name. Wrapper class must implement epi.cms.contentediting._EditorWrapperBase
            // tags:
            //		public

            this._registeredEditorWrappers[wrapperType] = {
                wrapperClassType: wrapperClassType,
                initializer: initializer
            };
        },

        _getWrapperAndEditor: function (/*Object*/property) {
            // summary:
            //		Get wrapper and editor parameter based on the property settings
            // property: 
            //      Property object
            // tags:
            //		private

            var type = property.type;
            var name = property.name;
            var wrapperType = property.wrapperType;
            var editorParams = property.editorParams || {};
            var editorWidgetType = property.editorWidgetType;

            if (!wrapperType) {
                if (property.metadata.customEditorSettings && property.metadata.customEditorSettings.uiWrapperType) {
                    wrapperType = property.metadata.customEditorSettings.uiWrapperType;
                } else {
                    //Fallback to default wrapper type.
                    wrapperType = this.defaultWrapperType;
                }
            }

            if (!editorWidgetType) {
                if (property.metadata.customEditorSettings && property.metadata.customEditorSettings.uiType) {
                    editorWidgetType = property.metadata.customEditorSettings.uiType;
                } else if (property.metadata.uiType) {
                    editorWidgetType = property.metadata.uiType;
                }
                else {
                    editorWidgetType = "epi/shell/widget/FormContainer";
                    //var nameBase = property.metadata.name ? epiString.pascalToCamel(property.metadata.name) + "." : "";
                    lang.mixin(editorParams, {
                        metadata: property.metadata,
                        onFieldCreated: function (fieldName, widget) {
                            //correct propertyName
                            //widget.set("propertyName", nameBase + fieldName);
                        }
                    });
                }
            }
            if (!editorWidgetType) {
                throw ("Could not resolve editor widget for property: " + property.name);
            }

            if (property.metadata.customEditorSettings && property.metadata.customEditorSettings.uiParams) {
                lang.mixin(editorParams, property.metadata.customEditorSettings.uiParams);
            }

            // get the registered item
            var registeredItem = this._registeredEditorWrappers[wrapperType];

            if (!registeredItem) {
                throw ('No suitable editor wrapper found for type: ' + wrapperType);
            }

            var data = {
                wrapperInitializer: registeredItem.initializer,
                wrapperType: registeredItem.wrapperClassType,
                editorWidgetType: editorWidgetType,
                editorParams: editorParams
            };

            this.onEditorResolved(data, property);

            if (wrapperType) {
                return data;
            }
            throw ('No suitable editor found');
        },

        createEditor: function (/*Object*/property, /*DomNode*/node, /*String|Object*/value, /*Object*/options) {
            // summary:
            //		Create the property editor.
            // property: 
            //      The property 
            // node: 
            //      The source node to attach to
            // value:
            //      Value to edit in the editor
            // tags:
            //		public
            var def = new Deferred();

            var wrapperAndEditor = this._getWrapperAndEditor(property);

            var wrapperType = epiString.slashName(wrapperAndEditor.wrapperType);
            var editorWidgetType = epiString.slashName(wrapperAndEditor.editorWidgetType);
            require([wrapperType, editorWidgetType], lang.hitch(this, function (wrapperClass) {
                
                var editorParams = options || {};

                if (property.metadata) {
                    lang.mixin(editorParams, property.metadata.settings);
                    lang.mixin(editorParams, wrapperAndEditor.editorParams);
                    editorParams.selections = property.metadata.selections;
                }

                var initParams = {
                    wrapperType: wrapperAndEditor.wrapperType,
                    editorWidgetType: wrapperAndEditor.editorWidgetType,
                    editorParams: editorParams,
                    blockDisplayNode: node,
                    overlayItem: editorParams.overlayItem,
                    property: property,
                    propertyName: property.name,
                    propertyDisplayName: property.metadata.displayName,
                    value: value,
                    contentModel: property.contentModel
                };

                var wrapper = new wrapperClass(initParams);

                // call initializer function for wrapper, adding any additional settings
                var initializer = wrapperAndEditor.wrapperInitializer;
                if (initializer) {
                    lang.mixin(initParams.editorParams, { parent: wrapper });
                    initializer(wrapper, initParams);
                }

                this.onEditorCreated(wrapper.getEditorWidget());

                def.resolve(wrapper);
            }));

            return def;
        }
    });

});
},
'epi-cms/contentediting/InUseNotificationManager':function(){
﻿define([
"dojo/_base/lang",
"dojo/_base/array",
"dojo/_base/declare",
"dojo/when",
"dojo/date",
"dojo/aspect",
"epi",
"epi/dependency",
"epi/datetime",

"epi-cms/ApplicationSettings",
"epi-cms/core/ContentReference",
"epi/i18n!epi/cms/nls/episerver.cms.contentediting.permanenteditindication"],

function (lang, array, declare, when, dojoDate, aspect, epi, dependency, epiDate, ApplicationSettings, ContentReference, res) {
    return declare([], {
        // summary:
        //    Helper class to work with in use notifications.
        // tags:
        //    public

        contextTypeName: "",

        _postFlag: false,

        _inUseNotificationStore: null,

        _currentUsername: null,

        _messageService: null,

        currentModel: null,

        _eventHandlers: null,

        // ignoreOthersNotifications: Boolean
        //      Set to true will make the getOtherUsersInUseNotifications return nothing.
        ignoreOthersNotifications: null,

        constructor: function (params) {
            // summary:
            //	    Creates a new in use notification manager.
            // tags:
            //      public

            this.inherited(arguments);

            lang.mixin(this, params);

            this._inUseNotificationStore = this.store || dependency.resolve("epi.storeregistry").get("epi.cms.inusenotification");
            this._currentUsername = this.username || ApplicationSettings.userName;
            this._messageService = this.messageService || dependency.resolve("epi.shell.MessageService");

            this._eventHandlers = [];
        },

        updateCommandModel: function (model) {
            // summary:
            //	    Creates a new in use notification manager.
            // tags:
            //      public
            this.inherited(arguments);

            // reset ignore flag if the new content is taking over.
            if (this.currentModel &&
                !ContentReference.compareIgnoreVersion(this.currentModel.contentData.contentLink, model.contentData.contentLink)) {
                this.ignoreOthersNotifications = false;
            }

            this.currentModel = model;

            //Disconnect the event handlers for the previous model object.
            array.forEach(this._eventHandlers, function(eventHandler) {
                eventHandler.remove();
            });

            this.updateMessageService(this.currentModel.contentData);

            this._eventHandlers = [
                aspect.after(model, "suspend", lang.hitch(this, this._onViewModelSuspended)),
                aspect.after(model, "destroyed", lang.hitch(this, this._onViewModelSuspended)),
                aspect.after(model, "onPropertyEdited", lang.hitch(this, this._onPropertyEdited)),
                aspect.around(model, "canChangeContent", lang.hitch(this, this._canChangeContentAdvisor))
            ];
        },

        _canChangeContentAdvisor: function (originalMethod) {
            return lang.hitch(this, function () {
                if (!this.ignoreOthersNotifications) {
                    var othersInUseNotifications = this.getOtherUsersInUseNotifications(this.currentModel.contentData.inUseNotifications);
                    if (othersInUseNotifications && othersInUseNotifications.length) {
                        return false;
                    }
                }

                return originalMethod.apply(this.currentModel, arguments);
            });
        },

        _onViewModelSuspended: function () {
            // summary:
            //	    Removed any automatic in use notifications for the suspended model.
            // tags:
            //      private

            var model = this.currentModel.contentData;
            this.removeAutomaticInUseNotification(model);
        },

        _onPropertyEdited: function () {
            // summary:
            //	    Ensures that we have a in use notification for the current view model or creates one.
            // tags:
            //      private

            var model = this.currentModel.contentData;
            this.ensureAutomaticInUseNotification(model);
        },

        ensureAutomaticInUseNotification: function (model) {
            // summary:
            //		Adds a new automatically created notification if the model does not currently have any notifications for the current user.
            // model:
            //      The model to add the notification for.
            // tags:
            //    public

            var existingNotification;
            array.some(model.inUseNotifications, function (item) {
                if (item.userName.toLowerCase() === this._currentUsername.toLowerCase()) {
                    existingNotification = item;
                    return true;
                }
            }, this);

            if (!existingNotification) {
                return this.put(this._createNotification(model, false), model.inUseNotifications);
            }
            else if (existingNotification.addedManually) {
                //We don't have to update manual notifications.
                return;
            }
            else {
                var modifiedDate = epiDate.deserialize(existingNotification.modified);
                if (dojoDate.difference(modifiedDate, new Date(), "minute") > 30) {
                    return this.put(existingNotification, model.inUseNotifications);
                }
            }
        },

        removeAutomaticInUseNotification: function (model) {
            // summary:
            //		Removes any automatically creates notifications for the given model.
            // notification:
            //      The model to add the notification for.
            // tags:
            //    public
            array.forEach(model.inUseNotifications, function (item) {
                if (item.userName.toLowerCase() === this._currentUsername.toLowerCase() && !item.addedManually) {
                    this.remove(item, model.inUseNotifications);
                }
            }, this);
        },

        _createNotification: function (model, addedManually) {
            var currentDate = epiDate.serialize(new Date());
            return {
                userName: this._currentUsername,
                contentLink: model.contentLink,
                languageBranch: model.currentLanguageBranch && model.currentLanguageBranch.languageId,
                addedManually: addedManually,
                created: currentDate,
                modified: currentDate
            };
        },

        put: function (notification, inUseNotifications) {
            // summary:
            //		Adds or updates an in use notification object to the specified page.
            // notification:
            //      The notification to save.
            // tags:
            //    public

            //Update the modified date on the client.
            notification.modified = epiDate.serialize(new Date());

            // Setup flag to ensure that inusenotification post to server until received response.
            if (!this._postFlag) {
                this._postFlag = true;

                return when(this._inUseNotificationStore.put(notification), lang.hitch(this, function (newId) {
                    var indexOfItem = array.indexOf(inUseNotifications, notification);
                    if (indexOfItem >= 0) {
                        inUseNotifications[indexOfItem] = notification;
                    }
                    else {
                        inUseNotifications.push(notification);
                    }
                    this._updateDependentStores(notification.contentLink, inUseNotifications);
                    this._postFlag = false;
                }));
            }
        },

        remove: function (notification, inUseNotifications) {
            // summary:
            //		Deletes a notification.
            // inUseNotifications:
            //      The list of current notifications.
            // sync: boolean
            //      A boolean to determine if the XHR call should be synchronous or asynchronous. True will cause the browser to stop the chain of execution until the data is returned
            // tags:
            //		public

            return when(this._inUseNotificationStore.remove(notification.id), lang.hitch(this, function () {
                var index = array.indexOf(inUseNotifications, notification);
                inUseNotifications.splice(index, 1);
                this._updateDependentStores(notification.contentLink, inUseNotifications);
            }));
        },

        _updateDependentStores: function (contentLink, inUseNotifications) {
            var patchObject = { contentLink: contentLink, inUseNotifications: inUseNotifications };
            this._inUseNotificationStore.updateDependentStores(patchObject);
        },

        togglePermanentEditIndication: function (model, convertExistingIndication) {
            // summary:
            //      Adds or removes a permanent editing notification.
            // model:
            //      The model object to the notification for.
            // convertExistingIndication:
            //      If the toggle should convert to non permanent indications to/from permanent notifications.
            // tags:
            //		public

            var existingNotification;
            var manualNotificationExists = array.some(model.inUseNotifications, function (item) {
                if (item.userName.toLowerCase() === this._currentUsername.toLowerCase()) {
                    existingNotification = item;
                    if (item.addedManually) {
                        return true;
                    }
                }
            }, this);

            if (manualNotificationExists) {
                if (convertExistingIndication && existingNotification.convertedFromAutomaticNotification) {
                    existingNotification.addedManually = false;
                    return this.put(existingNotification, model.inUseNotifications);
                }
                else {
                    return this.remove(existingNotification, model.inUseNotifications);
                }
            }
            else {
                if (existingNotification && convertExistingIndication) {
                    existingNotification.convertedFromAutomaticNotification = true;
                    existingNotification.addedManually = true;
                }
                else {
                    existingNotification = this._createNotification(model, true);
                }
                return this.put(existingNotification, model.inUseNotifications);
            }
        },

        updateMessageService: function (model) {
            // summary:
            //    Removes any displaying page lock notification, and displays a new notification message when manual lock has been turned on.
            // inUseNotifications: array
            //    The in use notifications for the current object.
            // tags:
            //    private

            var itemKey = model.contentLink + "_permanentEdit";
            this._messageService.remove({ externalItemId: itemKey });
            var notification = this._getManualInUseNotification(model.inUseNotifications);
            if (notification) {
                this._notificationHandlerId = this._messageService.put("note", res.permanenteditison, this.contextTypeName, model.contentLink, itemKey, null);
            }
        },

        _getManualInUseNotification: function (inUseNotifications) {
            var manualIndication;
            var index = array.forEach(inUseNotifications, function (item) {
                if (item.userName.toLowerCase() === this._currentUsername.toLowerCase() && item.addedManually) {
                    manualIndication = item;
                }
            }, this);
            return manualIndication;
        },

        currentUserHasInUseNotification: function (inUseNotifications, onlyCheckManual) {
            return array.some(inUseNotifications, function (item) {
                return item.userName.toLowerCase() === this._currentUsername.toLowerCase()
                    && (!onlyCheckManual || item.addedManually);
            }, this);
        },

        getOtherUsersInUseNotifications: function (inUseNotifications) {
            // summary
            //      Return list of users rather than the current user who have in use notification on the given list.

            var result = [];

            array.forEach(inUseNotifications, function (item) {
                if (item.userName.toLowerCase() !== this._currentUsername.toLowerCase()) {
                    result.push(item.userName);
                }
            }, this);

            return result;
        },

        hasInUseNotificationWarning: function (inUseNotifications) {
            if (this.ignoreOthersNotifications) {
                return false;
            }

            return this.getOtherUsersInUseNotifications(inUseNotifications).length;
        }
    });
});

},
'epi-cms/contentediting/ViewSettingsManager':function(){
﻿define([
    // Dojo
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/Stateful",

    // EPi Framework
    "epi/epi",
    "epi/dependency",
    "epi/UriParser"
], function (
    // Dojo
    declare,
    array,
    lang,
    topic,
    Stateful,

    // EPi Framework
    epi,
    dependency,
    UriParser
) {
    return declare([Stateful], {
        // summary:
        //      This class to manage view settings by manipulating a list of concrete view settings objects (for example: resolution, visitor group, ...).
        //      The class is responsible for updating URL hash to keep view settings state.
        //      onViewSettingChanged event is raised when one or more view settings are applied.

        // _hashWrapper: epi.shell.HashWrapper
        //    The hash wrapper instance.
        _hashWrapper: null,

        // viewSettings: Array
        //    List of registered view setting items.
        viewSettings: null,

        // _viewSettingsMap: Hashtable
        //    Map of registered view setting items by their key.
        _viewSettingsMap: null,

        // viewSettingsHashValue: Array
        //    All view settings value which are parsed from or persisted to URL hash.
        viewSettingsHashValue: null,

        // _activeKey: String
        //      Key name for active state
        _activeKey: "active",

        // enabled: [Boolean]
        //      State of eye toggle button. True if it is expanded.
        enabled: false,

        previewParams: null,

        postscript: function () {
            // summary:
            //		Set up the instance after creation.

            this.inherited(arguments);

            this._hashWrapper = this._hashWrapper || dependency.resolve("epi.shell.HashWrapper");
            this.previewParams = {};
            this.viewSettingsHashValue = [];

            // Create _viewSettingsMap.
            this._viewSettingsMap = {};
            array.forEach(this.viewSettings, lang.hitch(this, function (viewSetting) {
                if (!this._viewSettingsMap[viewSetting.key]) {
                    this._viewSettingsMap[viewSetting.key] = viewSetting;
                } else {
                    throw "Duplicated view settings key.";
                }
            }));

            // Listen changed view setting, to apply view setting.
            topic.subscribe("/epi/cms/action/viewsettingvaluechanged", lang.hitch(this, this._viewSettingChanged));

            // Listen changed eye toggle button, to enable/disable view setting.
            topic.subscribe("/epi/cms/action/eyetoggle", lang.hitch(this, this._viewSettingEnabledChanged));

            // Parse url hash.
            var obj = this._hashWrapper.getHash();
            if (obj && obj.viewsetting) {
                this.viewSettingsHashValue = this._toObjects(obj.viewsetting);
            }

            this.enabled = this._loadProperty(this._activeKey) === "true";

            // Pass values to every view setting items and get previewParams.
            array.forEach(this.viewSettingsHashValue, lang.hitch(this, function (item) {
                var viewSetting = this._viewSettingsMap[item.type];
                if (viewSetting) {
                    viewSetting.set("enabled", this.get("enabled"));
                    viewSetting.value = item.id;
                    viewSetting.beforePreviewLoad(this.previewParams, this.get("enabled"));
                }
            }));
        },

        onPreviewReady: function (preview) {
            this._preview = preview;

            // Apply all the view setting.
            array.forEach(this.viewSettings, lang.hitch(this, function (viewSetting) {
                viewSetting.afterPreviewLoad(preview, this.get("enabled"));
            }));
        },

        getSettingProperty: function ( /*String*/ property) {
            // summary:
            //      Get value of property from view setting object array.
            //
            // property:
            //    The property to get the value.
            //
            // tags:
            //      private
            var setting = array.filter(this.viewSettingsHashValue, function (dataItem) {
                return dataItem.type == property;
            });

            return setting.length > 0 ? setting[0].id : null;
        },

        hasVisitorGroup: function () {
            // summary:
            //      Indicates that in current view setting has visitor group or not
            // tags:
            //      Public

            return this.getSettingProperty("visitorgroup") !== null && this.getSettingProperty("visitorgroup").id !== null;
        },

        _enabledGetter: function () {
            // summary:
            //      Return the current status (Enable or Disable)

            return this.enabled;
        },

        _enabledSetter: function (value) {
            // summary:
            //		Enable or disable all view settings.
            //  value: Boolean
            //      If true, all view setting will be applied. Otherwise, none of them makes any effect.

            this.enabled = value;

            // If there are view settings, all of them are apply or removed accordingly.
            // reset preview params
            var previewParams = {};

            // Apply all the view setting.
            array.forEach(this.viewSettings, lang.hitch(this, function (viewSetting) {
                viewSetting.set("enabled", value);
                viewSetting.beforePreviewLoad(previewParams, value);
            }));

            if (!epi.areEqual(this.previewParams, previewParams)) {
                this.previewParams = previewParams;
            } else {
                array.forEach(this.viewSettings, lang.hitch(this, function (viewSetting) {
                    viewSetting.afterPreviewLoad(this._preview, value);
                }));
            }
        },

        _applyViewSettingValue: function (key, value) {
            // summary:
            //		Apply a view setting.
            // value: Boolean
            //      If true, all view setting will be applied. Otherwise, none of them makes any effect.

            var previewParams,
                viewSetting = this._viewSettingsMap[key];

            if (viewSetting) {
                previewParams = lang.clone(this.previewParams);

                // Assign setting value
                viewSetting.value = value;
                viewSetting.beforePreviewLoad(previewParams, true);

                if (!epi.areEqual(this.previewParams, previewParams)) {
                    this.previewParams = previewParams;
                } else {
                    viewSetting.afterPreviewLoad(this._preview, true);
                }
            }
        },

        _viewSettingChanged: function (key, value) {
            // summary:
            //		Apply view setting when option view setting changed.
            //
            // tags:
            //		private

            var self = this;

            // commit all changes to the hash in one go.
            this._commitToHash(function () {

                var settings = key;

                if (!(key instanceof Array)) {
                    settings = [{ key: key, value: value }];
                }

                settings.forEach(function (setting) {
                    self._saveProperty(setting.key, setting.value);
                    self._applyViewSettingValue(setting.key, setting.value);
                });
            });
        },

        _viewSettingEnabledChanged: function (enabled) {
            // summary:
            //		Apply a preview resolution. If resolution null set size to full screen.
            //
            // enabled: [Boolean]
            //      True if eye button is expanded, a.k.a view setting is enabled.
            // tags:
            //		private

            var self = this;

            this._commitToHash(function () {

                var hasSetting = self._hasSetting();

                if (enabled) {
                    self._saveProperty(self._activeKey, "true");
                } else {
                    // If haven't any view settings, it should be delete viewsetting URL when collapse eye toggle button.
                    self._saveProperty(self._activeKey, hasSetting ? false : null);
                }

                self.set("enabled", enabled);
            });
        },

        _addProperty: function (property, value) {
            // summary:
            //      Adds view setting property.
            //
            // property: String.
            //      Name of view setting property.
            // value: String
            //      Value of view setting property.
            // tags:
            //      Private
            this.viewSettingsHashValue.push({
                type: property,
                id: value
            });
        },

        _updateProperty: function (property, value) {
            // summary:
            //      Updates an existing view setting property.
            //
            // property: String.
            //      Name of view setting property.
            // value: String
            //      Value of view setting property.
            // tags:
            //      Private

            // Get index of property
            var position = -1;
            array.forEach(this.viewSettingsHashValue, function (item, index) {
                if (item.type == property) {
                    position = index;
                    return;
                }
            });

            // Update if property exists
            if (position > -1) {
                this.viewSettingsHashValue[position].id = value;
            } else {
                // Otherwise add new property
                this._addProperty(property, value);
            }
        },

        _toObjects: function (url) {
            // summary:
            //      Cast url view settings to URI object.
            //
            // url: String
            //      This is view setting url.
            // tags:
            //      Private

            var uriObjects = [];

            array.forEach(url.split("|"), function (item, index) {
                var uri = new UriParser(item);
                uriObjects.push({
                    type: uri.getType(),
                    id: uri.getId()
                });
            });

            return uriObjects;
        },

        _deleteProperty: function (property) {
            // summary:
            //      Delete view setting property.
            //
            // property: String.
            //      Name of view setting property.
            // tags:
            //      Private
            var position = -1;

            array.forEach(this.viewSettingsHashValue, function (item, index) {
                if (item.type == property) {
                    position = index;
                    return;
                }
            });

            if (position > -1) {
                this.viewSettingsHashValue.splice(position, 1);
            }
        },

        _commitToHash: function (/*function*/unitOfWork) {
            // summary:
            //      Updates hash to reflect view setting changes.
            //
            // tags:
            //      Private

            var obj = this._hashWrapper.getHash();
            var settings = [];

            // Update the local hash value to what is set in the browser
            if (obj && obj.viewsetting) {
                this.set("viewSettingsHashValue", this._toObjects(obj.viewsetting));
            } else {
                this.set("viewSettingsHashValue", []);
            }

            // Make the necessary changes to the hash value
            unitOfWork();

            // Convert object settings to uri
            array.forEach(this.viewSettingsHashValue, function (item, index) {
                settings.push(item.type + ":///" + item.id);
            });

            // Join all settings if have, otherwise delete viewsetting in hash.
            if (settings.length > 0) {
                obj.viewsetting = settings.join("|");
            } else {
                delete obj.viewsetting;
            }

            this._hashWrapper.setHash(obj);
        },

        _saveProperty: function (property, value) {
            // summary:
            //      Save view setting property.
            //
            // property: String
            //      Name of setting property
            // value: String
            //      Value of setting property
            // tags:
            //      private

            if (this.get("viewSettingsHashValue")) {
                if (value != null) {
                    // Update view setting property
                    this._updateProperty(property, value);
                } else {
                    // Delete setting property default or invalid
                    this._deleteProperty(property);
                }
            } else {
                if (value != null) {
                    this._updateProperty(property, value);
                }
            }
        },

        _loadProperty: function (property) {
            // summary:
            //      Get id of view setting property from hash.
            //
            // property: String
            //      Name of setting property
            // tags:
            //      private
            var obj = this._hashWrapper.getHash();
            var value = null;

            if (obj && obj.viewsetting) {
                var viewSettings = this._toObjects(obj.viewsetting);

                var setting = array.filter(viewSettings, function (item) {
                    return item.type == property;
                })[0];

                if (setting) {
                    value = setting.id;
                }
            }
            return value;
        },

        _hasSetting: function () {
            // summary:
            //      Check have any view setting. Not include "active" property.
            //
            // tags:
            //      private
            var obj = this._hashWrapper.getHash();

            if (obj && obj.viewsetting) {
                if (obj.viewsetting.split("|").length > 1) {
                    return true;
                }
            }
            return false;
        },

        getRenderingViewSettings: function () {
            return array.filter(this.viewSettings, lang.hitch(this, function (viewSetting) {
                return viewSetting.usedForRendering;
            }));
        }
    });
});
},
'epi-cms/contentediting/command/Editing':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    "epi",
    "epi/shell/_StatefulGetterSetterMixin",
    "epi-cms/command/TranslateContent",
    "epi-cms/contentediting/command/RevertToPublished",
    "epi-cms/contentediting/command/Reject",
    "epi-cms/contentediting/command/SendForReview",
    "epi-cms/contentediting/command/Publish",
    "epi-cms/contentediting/command/CreateDraft",
    "epi-cms/contentediting/command/Withdraw",
    "epi-cms/contentediting/command/ManageExpiration"
],

function (
    declare, 
    lang,
    Stateful, 
    epi,
    _StatefulGetterSetterMixin,
    TranslateContentCommand,
    RevertToPublishedCommand, 
    RejectCommand, 
    SendForReviewCommand, 
    PublishCommand, 
    CreateDraftCommand, 
    WithdrawCommand,
    ManageExpiration) {
    //Shared instance
    var Editing = declare([Stateful, _StatefulGetterSetterMixin], {
        // summary:
        //      Exposes all available editing commands

        model: null,

        revertToPublished: null,
        reject: null,
        translate: null,
        createDraft: null,
        sendForReview: null,
        publish: null,
        withdraw: null,
        manageExpiration: null,

        constructor: function (settings) {
            lang.mixin(this, settings);

            //Create the command
            this.revertToPublished = new RevertToPublishedCommand();
            this.reject = new RejectCommand();
            this.translate = new TranslateContentCommand();
            this.createDraft = new CreateDraftCommand();
            this.sendForReview = new SendForReviewCommand();
            this.publish = new PublishCommand();
            this.withdraw = new WithdrawCommand();
            this.manageExpiration = new ManageExpiration();
        },

        _setModelAttr: function (model) {
            this._set("model", model);

            //Update the model on the commands
            this.revertToPublished.set("model", model);
            this.reject.set("model", model);
            this.translate.set("model", model);
            this.createDraft.set("model", model);
            this.sendForReview.set("model", model);
            this.publish.set("model", model);
            this.withdraw.set("model", model);
            this.manageExpiration.set("model", model);
        }
    });

    return new Editing();
});

},
'epi-cms/command/TranslateContent':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/topic",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons.translate",
    "epi/shell/command/_Command"
], function(declare, topic, resources, _Command) {

    // module:
    //      epi-cms/command/TranslateContent
    // summary:
    //      A command that starts the create new content process when executed.
    return declare([_Command], {

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: resources.label,

        // executingLabel: [public] String
        //      The action text of the command when executing to be used in visual elements.
        executingLabel: resources.executinglabel,

        // tooltip: [public] String
        //      The description text of the command to be used in visual elements.
        tooltip: resources.title,

        // category: [const] String
        //      A category which provides a hint about how the command could be displayed.
        category: "context",

        _execute: function() {
            // summary:
            //      Publishes a change view request to change to the create language branch view.
            // tags:
            //      protected
            var model = this._getNormalizedModel();

            if (typeof this.executeDelegate === "function") {
                this.executeDelegate(this.model);
            } else {
                var data = {
                    contentData: model.content,
                    languageBranch: model.language.preferredLanguage
                };

                topic.publish("/epi/shell/action/changeview", "epi-cms/contentediting/CreateLanguageBranch", null, data);
            }
        },

        _onModelChange: function() {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected
            var model = this._getNormalizedModel(),
                language = model && model.language, // Null if multiple languages are not supported by the content provider on the server.
                isDeleted = model && model.content.isDeleted,
                isAvailable = language && language.isTranslationNeeded && !isDeleted,
                canExecute = isAvailable && language.hasTranslationAccess && language.isPreferredLanguageAvailable;

            if (model && typeof model.content.canTranslateContent === "function") {
                // Check if the model allows the current content to be translated.
                var canTranslate = model.content.canTranslateContent();

                isAvailable = isAvailable && canTranslate;
                canExecute = canExecute && canTranslate;
            }

            // Command is available if there is a translation needed.
            this.set("isAvailable", !!isAvailable);

            // Command is executable if the current user has sufficient privilege to translate and
            // that the preferred language is configured to be available for the current content.
            this.set("canExecute", !!canExecute);
        },

        _getNormalizedModel: function() {
            // summary:
            //      Gets a normalized model in order to handle the different possible inputs.
            // tags:
            //      private
            var model = this.model;
            if (model) {
                return {
                    content: model.contentData || model,
                    language: model.languageContext || model.missingLanguageBranch
                };
            }
        }
    });

});

},
'epi-cms/contentediting/command/RevertToPublished':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi-cms/contentediting/command/_ContentCommandBase",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
    declare,
    lang,
    _ContentCommandBase,
    ContentActionSupport,
    resource
) {

    return declare([_ContentCommandBase], {
        // summary:
        //      Revert back to published version
        name: "reverttopublished",

        tooltip: resource.reverttopublished.title,
        label: resource.reverttopublished.label,
        iconClass: "epi-iconRevert",

        _hasPendingChangeWatch: null,

        _execute: function () {
            // summary:
            //		Executes this command; publishes a change view request to change to the create content view.
            // tags:
            //		protected

            this.model.revertToPublished();
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            this.inherited(arguments);

            var contentData = this.model.contentData,
                status = contentData.status,
                versionStatus = ContentActionSupport.versionStatus;

            //Available when content is a draft
            var isAvailable = (status === versionStatus.CheckedOut) ||
                (status === versionStatus.Rejected) ||
                ((status === versionStatus.Published || status === versionStatus.Expired) && contentData.isCommonDraft);
            this.set("isAvailable", isAvailable);

            //If the models has pending changes, disable the command
            if (this._hasPendingChangeWatch) {
                this._hasPendingChangeWatch.unwatch();
            }
            this._hasPendingChangeWatch = this.model.watch("hasPendingChanges", lang.hitch(this, function (name, oldValue, newValue) {
                var originalCanExecute = this._getCanExecute(contentData, versionStatus);
                this.set("canExecute", !newValue && originalCanExecute);
            }));

            //Executable when available and not published, have published version and have edit access right
            this.set("canExecute", isAvailable && this._getCanExecute(contentData, versionStatus));
        },

        _getCanExecute: function (contentData, versionStatus) {
            return contentData.publishedBy !== null && contentData.publishedBy !== undefined && // This condition indicates that the content has published version.
                contentData.status !== versionStatus.Published &&
                contentData.status !== versionStatus.Expired &&     // Expired content is basically Published content with a expireDate set to the past
                this.model.canChangeContent() &&
                ContentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel.Delete); // Ensure has delete action to the user
        }
    });

});
},
'epi-cms/contentediting/command/_ContentCommandBase':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi/shell/command/_Command"
],

function (
    declare,
    lang,
    _Command
) {

    return declare([_Command], {
        // summary:
        //      Base class for any content manupulation command, like: Reject, Publish, ...
        //      canExecute is updated to false if the content is changing its status, and restore when done.
        // tag: abstract

        _isChangingContentStatusHandle: null,

        // checkDeleted: [Boolean]
        //      Indicated that need check content is deleted or not before execute command
        // tags:
        //      public
        checkDeleted: true,

        destroy: function () {
            if (this._isChangingContentStatusHandle) {
                this._isChangingContentStatusHandle.unwatch();
            }
            this.inherited(arguments);
        },

        _canExecuteGetter: function () {
            // summary:
            //      Check content is deleted or not
            // tags:
            //      protected

            if (!this.model || !this.model.contentData) {
                return false;
            }

            var contentData = this.model.contentData;
            return this.canExecute && (!this.checkDeleted || (contentData && !contentData.isDeleted));
        },

        _onModelChange: function () {
            this.inherited(arguments);

            if (this._isChangingContentStatusHandle) {
                this._isChangingContentStatusHandle.unwatch();
            }

            var originalValue;

            this._isChangingContentStatusHandle = this.model.watch("isChangingContentStatus", lang.hitch(this, function (name, oldValue, value) {
                if (value) {
                    originalValue = this.canExecute;
                    this.set("canExecute", false);
                } else {
                    this.set("canExecute", originalValue);
                }
            }));
        }
    });
});
},
'epi-cms/contentediting/command/Reject':function(){
﻿define([
    "dojo/_base/declare",
    "epi/shell/command/_Command",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_ChangeContentStatus",

//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
    declare,
    _Command,
    ContentActionSupport,
    _ChangeContentStatus,
    resources
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //      Reject current content changes.

        name: "reject",
        label: resources.reject.label,
        tooltip: resources.reject.title,
        iconClass: "epi-iconStop",

        action: ContentActionSupport.action.Reject,

        _execute: function () {
            // summary:
            //		Executes this command. Reject content sent for review.
            // tags:
            //		protected

            return this.inherited(arguments);
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            this.inherited(arguments);

            var contentData = this.model.contentData,
                status = contentData.status,
                versionStatus = ContentActionSupport.versionStatus,
                canExecute = (status == versionStatus.CheckedIn) && this.model.canChangeContent(ContentActionSupport.action.Publish);

            this.set("canExecute", canExecute);
            this.set("isAvailable", canExecute);
        }
    });

});
},
'epi-cms/contentediting/command/_ChangeContentStatus':function(){
﻿define([
//Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/Deferred",
    "dojo/topic",
        
//EPi
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/command/_ContentCommandBase"
],

function (
//Dojo
    declare,
    lang,
    Deferred,
    topic,

//EPi
    ContentReference,
    _ContentCommandBase
) {

    return declare([_ContentCommandBase], {
        // summary:
        //      Base class for any Change content status commands, like: Reject, Publish, ...
        // tag: abstract

        // action: [public] String
        //      Action to perform when changing content status. For example: publish, checkin, checkout, ...
        action: null,

        // viewName: [public] String
        //      Represents the view that will be display after changing content status. It might be null or empty.
        viewName: null,

        _execute: function () {
            // summary:
            //    Executes this command
            //     
            // tags:
            //		protected

            return this._changeContentStatus();
        },
        
        _changeContentStatus: function () {
            // summary:
            //    Ask the model to change content status then request a context change.
            //     
            // tags:
            //		protected

            var def = new Deferred(),
                onSuccess = lang.hitch(this, function (result) {                   
                    this._requestContextChange(result.id, true);
                    def.resolve(result);
                }),

                onError = function () {
                    def.cancel();
                };

            Deferred.when(this.model.changeContentStatus(this.action), onSuccess, onError);

            return def;
        },

        _requestContextChange: function (id, forceContextChange) {
            // id: String
            //      The published version.
            // forceContextChange: Boolean
            //      The flags to force context change or not.
            // tags:
            //      protected virtual.

            id = new ContentReference(id).createVersionUnspecificReference().toString();
            var contextParameters = { uri: "epi.cms.contentdata:///" +  id};
            var callerData = {
                sender: this,
                trigger: "internal",
                forceContextChange: forceContextChange
            };
            if (this.viewName) {
                lang.mixin(callerData, { viewName: this.viewName });
            }

            topic.publish("/epi/shell/context/request", contextParameters, callerData);
        }
    });

});
},
'epi-cms/contentediting/command/SendForReview':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/topic",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_ChangeContentStatus",

//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
    declare,
    topic,
    ContentActionSupport,
    _ChangeContentStatus,
    resources
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //      Send for review command.

        name: "sendforreview",
        label: resources.sendforreview.label,
        executingLabel: resources.sendforreview.executinglabel,
        tooltip: resources.sendforreview.title,
        iconClass: "epi-iconCheckmark",

        action: ContentActionSupport.action.CheckIn,

        _execute: function () {
            // summary:
            //    Executes this command. Send the current content for review.
            //     
            // tags:
            //		protected
            
            // Disable Undo & Redo actions.
            topic.publish("/epi/cms/action/disableundoredoactions");

            return this.inherited(arguments);
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected
            
            this.inherited(arguments);

            var contentData = this.model.contentData,
                isAvailable = ((contentData.status === ContentActionSupport.versionStatus.CheckedOut) ||
                    (contentData.status === ContentActionSupport.versionStatus.Rejected) ||
                    (contentData.status === ContentActionSupport.versionStatus.Published && contentData.isCommonDraft)) 
                    && this.model.canChangeContent(this.action),
                canExecute = isAvailable && (contentData.status !== ContentActionSupport.versionStatus.Published);

            this.set("canExecute", canExecute);
            this.set("isAvailable", isAvailable);
        }
    });

});
},
'epi-cms/contentediting/command/Publish':function(){
﻿define([
//Dojo
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/topic",

//EPi
    "epi/datetime",
    "epi/shell/command/_Command",
    "epi/shell/TypeDescriptorManager",

    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_ChangeContentStatus",

//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
//Dojo
    declare,
    Deferred,
    topic,

//EPi
    epiDate,
    _Command,
    TypeDescriptorManager,

    ContentReference,
    ContentActionSupport,
    _ChangeContentStatus,

//Resources
    resources
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //      Publish content command.

        name: "publish",
        label: resources.publish.label,
        executingLabel: resources.publish.executinglabel,
        tooltip: resources.publish.title,

        action: ContentActionSupport.action.Publish,

        _execute: function () {
            // summary:
            //    Executes this command; publish the current content
            //
            // tags:
            //		protected

            var def = new Deferred();

            // Execute base to change content status
            Deferred.when(this.inherited(arguments), function (result) {
                // Update tree children nodes
                //TODO: Compare if children sort order has changed before triggering on children changed message.
                //TODO: Compare if the sort order property has changed to see if children changed should be triggered on the parent page
                //if this has sorting by sort order.
                var versionAgnosticId = new ContentReference(result.oldId).createVersionUnspecificReference().toString();
                topic.publish("/epi/cms/contentdata/childrenchanged", versionAgnosticId);
                def.resolve();
            }, function () {
                def.reject();
            });

            return def;
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            this.inherited(arguments);

            var contentData = this.model.contentData,
                versionStatus = contentData.status,
                isAvailable = this.model.canChangeContent(ContentActionSupport.action.Publish),
                canExecute = isAvailable && !(versionStatus === ContentActionSupport.versionStatus.Published && !contentData.isCommonDraft),
                res = null;

            switch (versionStatus) {
                case ContentActionSupport.versionStatus.CheckedIn:
                    res = resources.approveandpublish;
                    break;
                case ContentActionSupport.versionStatus.PreviouslyPublished:
                    res = resources.republish;
                    break;
                case ContentActionSupport.versionStatus.CheckedOut:
                    if (contentData.isMasterVersion) {
                        res = resources.publish;
                    } else {
                        res = resources.publishchanges;
                    }
                    break;
                default:
                    res = resources.publishchanges;
            }

            var publishView = TypeDescriptorManager.getValue(contentData.typeIdentifier, "publishView");

            this.set("label", res.label);
            this.set("title", res.title);
            this.set("executingLabel", res.executinglabel);
            this.set("canExecute", canExecute);
            this.set("isAvailable", isAvailable);
            this.set("viewName", publishView);
        }
    });

});

},
'epi-cms/contentediting/command/CreateDraft':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/contentediting/command/_ContentCommandBase",
    "epi-cms/contentediting/ContentActionSupport",

//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
    declare,
    _ContentCommandBase,
    ContentActionSupport,
    resources
) {

    return declare([_ContentCommandBase], {
        // summary:
        //      Create a draft version out of the current content

        name: "createdraft",
        label: resources.createdraft.label,
        tooltip: resources.createdraft.title,
        iconClass: "epi-iconPage",

        contentActionSupport: null,

        postscript: function () {
            this.inherited(arguments);
            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;
        },

        _execute: function () {
            // summary:
            //    Executes this command; create a new draft version out of the current content
            //
            // tags:
            //		protected

            this.model.createDraft();
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            this.inherited(arguments);

            var contentData = this.model.contentData,
                status = contentData.status,
                versionStatus = ContentActionSupport.versionStatus,
                hasAccessRights = this.contentActionSupport.isActionAvailable(contentData, ContentActionSupport.action.Create, ContentActionSupport.providerCapabilities.Create) &&
                                  this.contentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel[ContentActionSupport.action.Edit]);

            var canExecute = hasAccessRights && // The user has to have sufficient access rights AND
                    (((status == versionStatus.Published || status == versionStatus.PreviouslyPublished) && !contentData.isCommonDraft) || // The status is publish or previously published, and it's the common draft OR
                    status == versionStatus.DelayedPublish); // The status is delayed publish

            this.set("canExecute", canExecute);
            this.set("isAvailable", canExecute);
        }
    });

});
},
'epi-cms/contentediting/command/Withdraw':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_ChangeContentStatus",
//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
    declare,
    ContentActionSupport,
    _ChangeContentStatus,
    resources
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //    Withdraw a ready to publish version to edit command.

        name: "withdraw",
        label: resources.withdraw.label,
        tooltip: resources.withdraw.title,
        iconClass: "epi-iconPen",

        action: ContentActionSupport.action.Save,

        contentActionSupport: null,

        postscript: function () {
            this.inherited(arguments);
            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;
        },

        _execute: function () {
            // summary:
            //    Executes this command; save a content that has been sent for approval.
            //
            // tags:
            //    protected

            return this.inherited(arguments);
        },

        _onModelChange: function () {
            // summary:
            //    Updates canExecute after the model has been updated.
            // tags:
            //    protected

            this.inherited(arguments);

            var contentData = this.model.contentData,
                status = contentData.status,
                versionStatus = ContentActionSupport.versionStatus,
                hasAccessRights = this.contentActionSupport.isActionAvailable(contentData, ContentActionSupport.action.Create) &&
                                  !this.contentActionSupport.isActionAvailable(contentData, ContentActionSupport.action.Publish),
                canExecute = hasAccessRights && (status == versionStatus.CheckedIn);

            this.set("canExecute", canExecute);
            this.set("isAvailable", canExecute);
        }
    });

});
},
'epi-cms/contentediting/command/ManageExpiration':function(){
﻿define([

// Dojo
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",

// EPi CMS    
    "epi",
    "epi/datetime",
    "epi-cms/contentediting/ExpirationDialog",
    "epi-cms/contentediting/viewmodel/ExpirationDialogViewModel",    
    "epi-cms/contentediting/ContentActionSupport",

// EPi Framework
    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/shell/widget/dialog/Dialog",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.expirationeditor",
    "epi/i18n!epi/nls/episerver.shared"
], function (

// Dojo
    connect,
    declare,
    Deferred,
    lang,

// EPi CMS    
    epi,
    epiDatetime,
    ExpirationDialog,
    ExpirationDialogViewModel,
    ContentActionSupport,

// EPi Framework
    dependency,
    _Command,
    Dialog,

// Resources
    resources,
    sharedResources
    ) {

    // module:
    //		epi/cms/contentediting/command/ManageExpiration
    // summary:
    //		Displays the manage expiration dialog for the current content.

    return declare([_Command], {

        label: resources.dialogtitle,

        tooltip: resources.dialogtitle,

        viewModel: null,

        cssClass: "epi-chromelessButton epi-visibleLink",

        constructor: function () {
            this._metadataManager = dependency.resolve("epi.shell.MetadataManager");
        },

        _execute: function () {
            // summary:
            //		Toggles the value of the given property on the model.
            // tags:
            //		protected

            if (!this._metadata) {
                return;
            }
            var viewModel = this.get("viewModel");
            var content = new ExpirationDialog({ metadata: this._metadata, value: viewModel.get("value"), model: viewModel });
            var dialog = new Dialog({
                destroyOnHide: true,
                defaultActionsVisible: false,
                confirmActionText: sharedResources.action.save,
                content: content,
                title: resources.dialogtitle
            });
            dialog.connect(dialog, "onExecute", lang.hitch(this, function () {
                this._onSave(dialog);
            }));
            dialog.connect(dialog, "onCancel", lang.hitch(this, function () {
                this._onCancel(dialog);
            }));

            dialog.show();
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var model = this.get("model");
            if (!model || !model.contentData) {
                this.set("canExecute", false);
                return;
            }

            var properties = model.contentData.properties,
                expireBlock = properties.iversionable_expire;

            this.set("viewModel", new ExpirationDialogViewModel({
                contentLink: model.contentLink,
                contentName: model.contentData.name,
                value: expireBlock,
                minimumExpireDate: properties.iversionable_startpublish
            }));

            var canExecute = model.canChangeContent() &&
                             ContentActionSupport.hasAccess(model.contentData.accessMask, ContentActionSupport.accessLevel.Publish); // Ensure the user has Publish access right

            Deferred.when(model.getPropertyMetaData("iversionable_expire"), lang.hitch(this, function (metadata) {
                this._metadata = metadata;
            }));

            this.set("canExecute", canExecute);
        },

        _onSave: function (dialog) {
            var dialogModel = dialog.content.model,
                value = dialogModel.get("intermediateValue");
            dialogModel.set("value", value);

            var model = this.get("model");            
            model.publishProperty("iversionable_expire", value);
            
        },

        _onCancel: function (dialog) {
            var dialogModel = dialog.content.model;
            dialogModel.set("intermediateValue", dialogModel.get("value"));
        }
    });
});

},
'epi-cms/contentediting/ExpirationDialog':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dijit/_CssStateMixin",
    "epi-cms/widget/Breadcrumb",
    "epi/shell/widget/dialog/_DialogContentMixin",
    "epi/shell/widget/FormContainer",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/_ActionProviderWidget",
    "dojo/text!./templates/ExpirationDialog.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.expirationeditor",
    "epi/i18n!epi/nls/episerver.shared"
],
function (declare, lang, domStyle, _CssStateMixin, Breadcrumb, _DialogContentMixin, FormContainer, _ModelBindingMixin, _ActionProviderWidget, template, res, sharedResources) {
    return declare([FormContainer, _ActionProviderWidget, _DialogContentMixin, _CssStateMixin, _ModelBindingMixin], {
        templateString: template,

        res: res,

        contentLink: null,

        contentName: null,

        baseClass: "epi-statusIndicator",

        modelBindingMap: {
            "contentLink": ["contentLink"],
            "contentName": ["contentName"],
            "infoText": ["infoText"],
            "state": ["state"],
            "enableSaveButton": ["enableSaveButton"],
            "showRemoveButton": ["showRemoveButton"]
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            // This form container is used inside a dialog without any size constraints because the dialog allow its content to overflow.
            // Therefore, we should not layout the form's top layout container.
            this.doLayout = false;
        },

        _archiveLinkSelector: null,

        _setContentLinkAttr: function (value) {
            this.breadcrumb.set("contentLink", value);
        },

        _setContentNameAttr: {
            node: "contentNameNode",
            type: "innerText"
        },

        _setInfoTextAttr: {
            node: "infoTextNode",
            type: "innerText"
        },

        _setEnableSaveButtonAttr: function (value) {
            if (this._actions && this._actions.length) {
                this.setActionProperty("save", "disabled", !value);
            }
        },

        _setShowRemoveButtonAttr: function (value) {
            domStyle.set(this.removeButton.domNode, "display", value ? "" : "none");
        },

        _onRemoveButtonClick: function () {
            var resetValue = {
                stopPublish: null,
                archiveLink: null
            };
            this.set("value", resetValue);
            this.onChange(resetValue);
        },

        onFieldCreated: function (fieldName, widget) {
            // summary:
            //     Raised when a field editor widget is created.
            // description:
            //     Override the FormContainer method to catch and keep reference to archiveLink widget
            // fieldName: String
            //     The field name
            // widget: dijit._Widget
            //     The widget
            // tag:
            //     callback

            if (fieldName === "stopPublish") {
                widget.set("minimumValue", this.model.get("minimumExpireDate"));
                widget.set("minimumValueMessage", this.model.get("minimumExpireDateMessage"));
            } else if (fieldName === "archiveLink") {

                // TODO: remove link on destroy?

                this._archiveLinkSelector = widget;
                if (this._archiveLinkSelector.readOnly){
                    //if the widget is already read only is because the property is not language specific and we're not the master language.
                    this._archiveLinkSelector._keepReadOnly = true;
                }

                this._archiveLinkSelector.set("contentLink", this.model.get("contentLink"));
            }
        },

        onChange: function (value) {
            this.inherited(arguments);
            this.model.set("intermediateValue", value);
        },

        getActions: function () {
            // summary:
            //      Overridden from _ActionProvider to get the select current content action added to the containing widget
            //
            // returns:
            //      An array containing a select page action definition, if it is not a shared block

            this._actions = [
                {
                    name: "save",
                    label: sharedResources.action.save,
                    settings: { type: "button", disabled: true },
                    action: lang.hitch(this, function () {
                        if (this.validate()) {
                            this.executeDialog();
                        }
                    })
                },
                {
                    name: "cancel",
                    label: sharedResources.action.cancel,
                    settings: { type: "button" },
                    action: lang.hitch(this, function () {
                        this.cancelDialog();
                    })
                }
            ];

            return this._actions;
        }
    });
});
},
'epi-cms/widget/Breadcrumb':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/on",
    "dojo/when",

    "dojo/query",
    "dojo/NodeList-manipulate",
    "dojo/topic",

// dijit
    "dijit/_Widget",
    "dijit/layout/_LayoutWidget",

// epi
    "epi/dependency",

    "epi-cms/core/ContentReference",
    "epi-cms/_ContentContextMixin",
    "epi-cms/contentediting/_ContextualContentContextMixin",
    "epi-cms/widget/_HierarchicalModelMixin"
],

function (
// dojo
    array,
    declare,
    lang,

    aspect,
    Deferred,
    domClass,
    domConstruct,
    domGeometry,
    domStyle,
    on,
    when,

    query,
    NodeList,
    topic,

// dijit
    _Widget,
    _LayoutWidget,

// epi
    dependency,

    ContentReference,
    _ContentContextMixin,
    _ContextualContentContextMixin,
    _HierarchicalModelMixin
) {

    // summary:
    //    Wiget used to show the content's path on a tree struture.

    return declare([_LayoutWidget, _HierarchicalModelMixin, _ContentContextMixin, _ContextualContentContextMixin], {

        // contentLink: [public] String
        //    The current content link.
        contentLink: null,

        // store: [public] epi.cms.pagedata.light
        //    The widget data store.
        store: null,

        // showOnlyAncestors: [public] Boolean
        //    Flag indicating is the current node will be shown.
        showCurrentNode: true,

        // showLastBracket: [public] Boolean
        //    Flag indicating is the last bracket will be shown.
        showLastBracket: false,

        // displayAsText: [public] Boolean
        //    States if the path will be displayed as links or simple text.
        displayAsText: true,

        // minimumItemCount: [public] Number
        //    If set, when laying out, the widget wouldn't truncate if there is less than this number of item visible.
        minimumItemCount: null,

        baseClass: "epi-breadCrumbs",

        _resizeListener: null,
        _visibleItems: [],

        _currentContent: null,
        _ancestors: null,

        postMixInProperties: function () {
            // summary:
            //    Post mixin properties handler.

            var registry = dependency.resolve("epi.storeregistry");
            this.store = this.store || registry.get("epi.cms.content.light");

            this.minimumItemCount = this.minimumItemCount || 2;
        },

        buildRendering: function () {
            // summary:
            //      Constructs the base DOM node for this widget and sets it to this.domNode.
            // tags:
            //      protected
            this.domNode = this.ownerDocument.createElement("ul");

            this.inherited(arguments);
        },

        startup: function () {
            // summary:
            //      Start the widget up.

            this._addResizeListener();
        },

        destroy: function () {
            // summary:
            //      Destroy the widget.

            if (this._resizeListener) {
                this._resizeListener.remove();
            }

            this.destroyDescendants();

            this.inherited(arguments);
        },

        _addResizeListener: function () {
            // summary:
            //      Add a listener to the closest ancestor which is a layout container to be able to react to resize event.
            // remark:
            //      Since this widget might not be a direct child of a layout widget, it would unlikely know when it got resized.
            //      The dijit layout system relies on layout() and layoutChildren() methods in cases that resizing is caused by a layout container rather than a window resize.
            //      Therefore, we have to actively connect to the closest ancestor's layout method.

            if (this._resizeListener) {
                return;
            }

            var parent = this.getParent(),
                resizeContainer = parent;

            while (resizeContainer && !resizeContainer.isLayoutContainer && resizeContainer.getParent()) {
                resizeContainer = resizeContainer.getParent();
            }

            if (resizeContainer && resizeContainer !== parent) {
                this._resizeListener = aspect.after(resizeContainer, "resize", lang.hitch(this, function () {
                    var changeSize = domGeometry.getMarginBox(this.domNode);
                    this.resize(changeSize);
                }));
            }
        },

        resize: function (changeSize) {
            if (!changeSize && this._resizeListener) {
                return; // The window is resized. If we have a resize container, we will get resize request from resize container later.
            } else {
                // We need to re-layout all the time the sizing container resized
                this.layout();
            }
        },

        layout: function () {
            // summary:
            //      Layout the breadcrums items.

            this._visibleItems = [];

            when(this._buildPath(), lang.hitch(this, function () {
                //if still overflow.
                var actualWidth = domGeometry.getContentBox(this.domNode).w;
                if (actualWidth > this._availableWidth) {
                    var leadingItemWidth = this._leadingItem ? domGeometry.getMarginBox(this._leadingItem.domNode).w : 0;
                    var availableWidthToEllipsis = this._availableWidth - leadingItemWidth;
                    this._ellipsisize(0, availableWidthToEllipsis);
                }
            }));
        },

        _setContentLinkAttr: function (/*Integer*/value) {
            // summary:
            //   The value on the content property
            //
            // value:
            //    The content object.
            //
            // tags:
            //    private

            this._set("contentLink", value);
            this._currentContent = null;
            this._ancestors = null;
            this.layout();
        },

        _buildPath: function () {
            // summary:
            //    Helper function to build the content's path.
            //
            // tags:
            //    private

            var contentLink = this.get("contentLink"),
                def = new Deferred(),
                path = "";

            if (this._currentContent && this._ancestors) {
                this._createAllItems();
                def.resolve(path);
            } else if (contentLink) {
                var contentReference = new ContentReference(contentLink);
                var contentId = contentReference.createVersionUnspecificReference().toString();

                when(this.getCurrentContext(), lang.hitch(this, function (ctx) {

                    when(this.store.get(contentId), lang.hitch(this, function (currentContent) {

                        this.getAncestors(contentId, lang.hitch(this, function (ancestors) {

                            this._currentContent = currentContent;

                            this._ancestors = ancestors;

                            this._createAllItems();

                            def.resolve(path);
                        }));
                    }));
                }));
            } else {
                def.resolve(path);
            }

            return def.promise; // Promise
        },

        _createAllItems: function () {

            // Cleanup first
            this._cleanUp();

            if (!this.isTypeOfRoot(this._currentContent)) {
                var filteredItems = [],
                    ancestor = null;

                // Remove all but first sub root
                for (var i = this._ancestors.length - 1; i >= 0; i--) {
                    // Modify context root name
                    ancestor = this._ancestors[i];

                    // Do not add root node
                    if (!ancestor.parentLink) {
                        continue;
                    }

                    // Push item
                    filteredItems.push(ancestor);

                    // Break after first sub root or context root
                    if (this.isTypeOfRoot(ancestor)) {
                        break;
                    }
                }

                // Reverse the list
                filteredItems.reverse();

                var maxWidth = domGeometry.getContentBox(this.domNode).w;
                this._availableWidth = maxWidth >= 0 ? maxWidth : 0;

                array.forEach(filteredItems, lang.hitch(this, function (content) {
                    this._createItem(content, true);
                }));
            }

            if (this.showCurrentNode) {
                this._createItem(this._currentContent, this.showLastBracket);
            }
        },

        _cleanUp: function () {
            this.destroyDescendants();
            this._leadingItem = null;
            this._visibleItems = [];
        },

        _createItem: function (content, withSeparator) {
            // summary:
            //      Add a link to the content.
            // content: Object
            //      The content object.
            // withSeparator: Boolean
            //      Flag indicating whether a separator should be created after the new breadcrumb item.
            // tags:
            //      private

            var node,
                listNode = domConstruct.create("li"),
                isTextNode = this.displayAsText || !content.hasTemplate;

            if (isTextNode) {
                node = domConstruct.create("span", null, listNode);
            } else {
                node = domConstruct.create("a", { href: "#" }, listNode);

                this.own(on(node, "click", lang.hitch(this, function (e) {
                    this.onNodeClick(e, content);
                })));
            }

            node.textContent = this.isContextualContent(content) ? this.getContextualRootName(content) : content.name;

            if (withSeparator) {
                domConstruct.create("span", { innerHTML: "&gt;", "class": "epi-breadCrumbsSeparator" }, listNode);
            }

            this._addAndLayout(listNode);
        },

        onNodeClick: function (e, content) {
            // summary:
            //      Click on a node on breadcrumb, load new context .
            // e: Object
            //      The mouse event object.
            // content: Object
            //      The content object.
            // tags:
            //      protected

            e.preventDefault();
            topic.publish("/epi/shell/context/request", { uri: content.uri }, { sender: this });
        },

        _addAndLayout: function (node) {
            // summary:
            //      Add an item and do layout.
            // remark:
            //      If there was not space, the items on the left would be hidden.

            var toAdd = new _Widget({}, node);

            this._visibleItems.push(toAdd);
            this.addChild(toAdd);

            var newWidth = this._getTotalVisibleItemsSize(); //domGeometry.getContentBox(this.domNode).w;

            if (newWidth > this._availableWidth) {
                this._ensureLeadingItem();

                while (newWidth > this._availableWidth && this._visibleItems.length > this.minimumItemCount) {
                    var firstItem = this._visibleItems.splice(0, 1)[0];

                    domStyle.set(firstItem.domNode, "display", "none");
                    newWidth = this._getTotalVisibleItemsSize();
                }
            }
        },

        _getTotalVisibleItemsSize: function () {
            var width = 0;

            if (this._leadingItem) {
                width += domGeometry.getMarginBox(this._leadingItem.domNode).w;
            }

            array.forEach(this._visibleItems, function (item) {
                width += domGeometry.getMarginBox(item.domNode).w;
            });

            return width;
        },

        _ensureLeadingItem: function () {
            // summary:
            //      Make sure that we have an elipssis item at the beginning if some items is truncated.

            if (this._leadingItem) {
                return;
            }

            var leadingItemNode = domConstruct.create("li"),
                ellipsisNode = domConstruct.create("span", { innerHTML: "..." }),
                separator = domConstruct.create("span", { innerHTML: " &gt; ", "class": "epi-breadCrumbsSeparator" });

            domConstruct.place(ellipsisNode, leadingItemNode, "last");
            domConstruct.place(separator, leadingItemNode, "last");

            this._leadingItem = new _Widget({}, leadingItemNode);
            this.addChild(this._leadingItem, 0); //add to the first index
        },

        _ellipsisize: function (startIndex, availableWidth) {
            // summary:
            //      Ellipsisize a set of items.
            // startIndex: Number
            //      The index of item to start with.
            // availableWidth: Number
            //      Total available width in pixels.

            if (startIndex >= this._visibleItems.length) {
                return;
            }

            var noOfItems = this._visibleItems.length - startIndex,
                maxItemWidth = Math.floor(availableWidth / noOfItems),
                item = this._visibleItems[startIndex],
                actualItemWidth = domGeometry.getMarginBox(item.domNode).w;

            if (actualItemWidth <= maxItemWidth) {
                this._ellipsisize(startIndex + 1, availableWidth - actualItemWidth);
            } else {
                var nodeToEllipsis = query(this.displayAsText ? "span" : "a", item.domNode)[0],
                    separator = query("span.epi-breadCrumbsSeparator", item.domNode)[0],
                    itemWidth = maxItemWidth - domGeometry.getMarginBox(separator).w;

                if (itemWidth < 0) {
                    itemWidth = 0;
                }

                domStyle.set(nodeToEllipsis, "width", itemWidth + "px");
                domClass.add(nodeToEllipsis, "dojoxEllipsis");

                this._ellipsisize(startIndex + 1, availableWidth - maxItemWidth);
            }
        }

    });

});

},
'dojo/NodeList-manipulate':function(){
define("dojo/NodeList-manipulate", ["./query", "./_base/lang", "./_base/array", "./dom-construct", "./NodeList-dom"], function(dquery, lang, array, construct){
	// module:
	//		dojo/NodeList-manipulate

	/*=====
	return function(){
		// summary:
		//		Adds chainable methods to dojo.query() / NodeList instances for manipulating HTML
		//		and DOM nodes and their properties.
	};
	=====*/

	var NodeList = dquery.NodeList;

	//TODO: add a way to parse for widgets in the injected markup?

	function getText(/*DOMNode*/node){
		// summary:
		//		recursion method for text() to use. Gets text value for a node.
		// description:
		//		Juse uses nodedValue so things like <br/> tags do not end up in
		//		the text as any sort of line return.
		var text = "", ch = node.childNodes;
		for(var i = 0, n; n = ch[i]; i++){
			//Skip comments.
			if(n.nodeType != 8){
				if(n.nodeType == 1){
					text += getText(n);
				}else{
					text += n.nodeValue;
				}
			}
		}
		return text;
	}

	function getWrapInsertion(/*DOMNode*/node){
		// summary:
		//		finds the innermost element to use for wrap insertion.

		//Make it easy, assume single nesting, no siblings.
		while(node.childNodes[0] && node.childNodes[0].nodeType == 1){
			node = node.childNodes[0];
		}
		return node; //DOMNode
	}

	function makeWrapNode(/*DOMNode||String*/html, /*DOMNode*/refNode){
		// summary:
		//		convert HTML into nodes if it is not already a node.
		if(typeof html == "string"){
			html = construct.toDom(html, (refNode && refNode.ownerDocument));
			if(html.nodeType == 11){
				//DocumentFragment cannot handle cloneNode, so choose first child.
				html = html.childNodes[0];
			}
		}else if(html.nodeType == 1 && html.parentNode){
			//This element is already in the DOM clone it, but not its children.
			html = html.cloneNode(false);
		}
		return html; /*DOMNode*/
	}

	lang.extend(NodeList, {
		_placeMultiple: function(/*String||Node||NodeList*/query, /*String*/position){
			// summary:
			//		private method for inserting queried nodes into all nodes in this NodeList
			//		at different positions. Differs from NodeList.place because it will clone
			//		the nodes in this NodeList if the query matches more than one element.
			var nl2 = typeof query == "string" || query.nodeType ? dquery(query) : query;
			var toAdd = [];
			for(var i = 0; i < nl2.length; i++){
				//Go backwards in DOM to make dom insertions easier via insertBefore
				var refNode = nl2[i];
				var length = this.length;
				for(var j = length - 1, item; item = this[j]; j--){
					if(i > 0){
						//Need to clone the item. This also means
						//it needs to be added to the current NodeList
						//so it can also be the target of other chaining operations.
						item = this._cloneNode(item);
						toAdd.unshift(item);
					}
					if(j == length - 1){
						construct.place(item, refNode, position);
					}else{
						refNode.parentNode.insertBefore(item, refNode);
					}
					refNode = item;
				}
			}

			if(toAdd.length){
				//Add the toAdd items to the current NodeList. Build up list of args
				//to pass to splice.
				toAdd.unshift(0);
				toAdd.unshift(this.length - 1);
				Array.prototype.splice.apply(this, toAdd);
			}

			return this; // dojo/NodeList
		},

		innerHTML: function(/*String|DOMNode|NodeList?*/ value){
			// summary:
			//		allows setting the innerHTML of each node in the NodeList,
			//		if there is a value passed in, otherwise, reads the innerHTML value of the first node.
			// description:
			//		This method is simpler than the dojo/NodeList.html() method provided by
			//		`dojo/NodeList-html`. This method just does proper innerHTML insertion of HTML fragments,
			//		and it allows for the innerHTML to be read for the first node in the node list.
			//		Since dojo/NodeList-html already took the "html" name, this method is called
			//		"innerHTML". However, if dojo/NodeList-html has not been loaded yet, this
			//		module will define an "html" method that can be used instead. Be careful if you
			//		are working in an environment where it is possible that dojo/NodeList-html could
			//		have been loaded, since its definition of "html" will take precedence.
			//		The nodes represented by the value argument will be cloned if more than one
			//		node is in this NodeList. The nodes in this NodeList are returned in the "set"
			//		usage of this method, not the HTML that was inserted.
			// returns:
			//		if no value is passed, the result is String, the innerHTML of the first node.
			//		If a value is passed, the return is this dojo/NodeList
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"></div>
			//	|	<div id="bar"></div>
			//		This code inserts `<p>Hello World</p>` into both divs:
			//	|	dojo.query("div").innerHTML("<p>Hello World</p>");
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"><p>Hello Mars</p></div>
			//	|	<div id="bar"><p>Hello World</p></div>
			//		This code returns `<p>Hello Mars</p>`:
			//	|	var message = dojo.query("div").innerHTML();
			if(arguments.length){
				return this.addContent(value, "only"); // dojo/NodeList
			}else{
				return this[0].innerHTML; //String
			}
		},

		/*=====
		html: function(value){
			// summary:
			//		see the information for "innerHTML". "html" is an alias for "innerHTML", but is
			//		only defined if dojo/NodeList-html has not been loaded.
			// description:
			//		An alias for the "innerHTML" method, but only defined if there is not an existing
			//		"html" method on dojo/NodeList. Be careful if you are working in an environment
			//		where it is possible that dojo/NodeList-html could have been loaded, since its
			//		definition of "html" will take precedence. If you are not sure if dojo/NodeList-html
			//		could be loaded, use the "innerHTML" method.
			// value: String|DOMNode|NodeList?
			//		The HTML fragment to use as innerHTML. If value is not passed, then the innerHTML
			//		of the first element in this NodeList is returned.
			// returns:
			//		if no value is passed, the result is String, the innerHTML of the first node.
			//		If a value is passed, the return is this dojo/NodeList
			return; // dojo/NodeList|String
		},
		=====*/

		text: function(/*String*/value){
			// summary:
			//		allows setting the text value of each node in the NodeList,
			//		if there is a value passed in, otherwise, returns the text value for all the
			//		nodes in the NodeList in one string.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"></div>
			//	|	<div id="bar"></div>
			//		This code inserts "Hello World" into both divs:
			//	|	dojo.query("div").text("Hello World");
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"><p>Hello Mars <span>today</span></p></div>
			//	|	<div id="bar"><p>Hello World</p></div>
			//		This code returns "Hello Mars today":
			//	|	var message = dojo.query("div").text();
			// returns:
			//		if no value is passed, the result is String, the text value of the first node.
			//		If a value is passed, the return is this dojo/NodeList
			if(arguments.length){
				for(var i = 0, node; node = this[i]; i++){
					if(node.nodeType == 1){
						construct.empty(node);
						node.appendChild(node.ownerDocument.createTextNode(value));
					}
				}
				return this; // dojo/NodeList
			}else{
				var result = "";
				for(i = 0; node = this[i]; i++){
					result += getText(node);
				}
				return result; //String
			}
		},

		val: function(/*String||Array*/value){
			// summary:
			//		If a value is passed, allows seting the value property of form elements in this
			//		NodeList, or properly selecting/checking the right value for radio/checkbox/select
			//		elements. If no value is passed, the value of the first node in this NodeList
			//		is returned.
			// returns:
			//		if no value is passed, the result is String or an Array, for the value of the
			//		first node.
			//		If a value is passed, the return is this dojo/NodeList
			// example:
			//		assume a DOM created by this markup:
			//	|	<input type="text" value="foo">
			//	|	<select multiple>
			//	|		<option value="red" selected>Red</option>
			//	|		<option value="blue">Blue</option>
			//	|		<option value="yellow" selected>Yellow</option>
			//	|	</select>
			//		This code gets and sets the values for the form fields above:
			//	|	dojo.query('[type="text"]').val(); //gets value foo
			//	|	dojo.query('[type="text"]').val("bar"); //sets the input's value to "bar"
			// 	|	dojo.query("select").val() //gets array value ["red", "yellow"]
			// 	|	dojo.query("select").val(["blue", "yellow"]) //Sets the blue and yellow options to selected.

			//Special work for input elements.
			if(arguments.length){
				var isArray = lang.isArray(value);
				for(var index = 0, node; node = this[index]; index++){
					var name = node.nodeName.toUpperCase();
					var type = node.type;
					var newValue = isArray ? value[index] : value;

					if(name == "SELECT"){
						var opts = node.options;
						for(var i = 0; i < opts.length; i++){
							var opt = opts[i];
							if(node.multiple){
								opt.selected = (array.indexOf(value, opt.value) != -1);
							}else{
								opt.selected = (opt.value == newValue);
							}
						}
					}else if(type == "checkbox" || type == "radio"){
						node.checked = (node.value == newValue);
					}else{
						node.value = newValue;
					}
				}
				return this; // dojo/NodeList
			}else{
				//node already declared above.
				node = this[0];
				if(!node || node.nodeType != 1){
					return undefined;
				}
				value = node.value || "";
				if(node.nodeName.toUpperCase() == "SELECT" && node.multiple){
					//A multivalued selectbox. Do the pain.
					value = [];
					//opts declared above in if block.
					opts = node.options;
					//i declared above in if block;
					for(i = 0; i < opts.length; i++){
						//opt declared above in if block
						opt = opts[i];
						if(opt.selected){
							value.push(opt.value);
						}
					}
					if(!value.length){
						value = null;
					}
				}
				return value; //String||Array
			}
		},

		append: function(/*String||DOMNode||NodeList*/content){
			// summary:
			//		appends the content to every node in the NodeList.
			// description:
			//		The content will be cloned if the length of NodeList
			//		is greater than 1. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the appended content.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"><p>Hello Mars</p></div>
			//	|	<div id="bar"><p>Hello World</p></div>
			//		Running this code:
			//	|	dojo.query("div").append("<span>append</span>");
			//		Results in this DOM structure:
			//	|	<div id="foo"><p>Hello Mars</p><span>append</span></div>
			//	|	<div id="bar"><p>Hello World</p><span>append</span></div>
			return this.addContent(content, "last"); // dojo/NodeList
		},

		appendTo: function(/*String*/query){
			// summary:
			//		appends nodes in this NodeList to the nodes matched by
			//		the query passed to appendTo.
			// description:
			//		The nodes in this NodeList will be cloned if the query
			//		matches more than one element. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the matched nodes from the query.
			// example:
			//		assume a DOM created by this markup:
			//	|	<span>append</span>
			//	|	<p>Hello Mars</p>
			//	|	<p>Hello World</p>
			//		Running this code:
			//	|	dojo.query("span").appendTo("p");
			//		Results in this DOM structure:
			//	|	<p>Hello Mars<span>append</span></p>
			//	|	<p>Hello World<span>append</span></p>
			return this._placeMultiple(query, "last"); // dojo/NodeList
		},

		prepend: function(/*String||DOMNode||NodeList*/content){
			// summary:
			//		prepends the content to every node in the NodeList.
			// description:
			//		The content will be cloned if the length of NodeList
			//		is greater than 1. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the appended content.
			//		assume a DOM created by this markup:
			//	|	<div id="foo"><p>Hello Mars</p></div>
			//	|	<div id="bar"><p>Hello World</p></div>
			//		Running this code:
			//	|	dojo.query("div").prepend("<span>prepend</span>");
			//		Results in this DOM structure:
			//	|	<div id="foo"><span>prepend</span><p>Hello Mars</p></div>
			//	|	<div id="bar"><span>prepend</span><p>Hello World</p></div>
			return this.addContent(content, "first"); // dojo/NodeList
		},

		prependTo: function(/*String*/query){
			// summary:
			//		prepends nodes in this NodeList to the nodes matched by
			//		the query passed to prependTo.
			// description:
			//		The nodes in this NodeList will be cloned if the query
			//		matches more than one element. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the matched nodes from the query.
			// example:
			//		assume a DOM created by this markup:
			//	|	<span>prepend</span>
			//	|	<p>Hello Mars</p>
			//	|	<p>Hello World</p>
			//		Running this code:
			//	|	dojo.query("span").prependTo("p");
			//		Results in this DOM structure:
			//	|	<p><span>prepend</span>Hello Mars</p>
			//	|	<p><span>prepend</span>Hello World</p>
			return this._placeMultiple(query, "first"); // dojo/NodeList
		},

		after: function(/*String||Element||NodeList*/content){
			// summary:
			//		Places the content after every node in the NodeList.
			// description:
			//		The content will be cloned if the length of NodeList
			//		is greater than 1. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the appended content.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"><p>Hello Mars</p></div>
			//	|	<div id="bar"><p>Hello World</p></div>
			//		Running this code:
			//	|	dojo.query("div").after("<span>after</span>");
			//		Results in this DOM structure:
			//	|	<div id="foo"><p>Hello Mars</p></div><span>after</span>
			//	|	<div id="bar"><p>Hello World</p></div><span>after</span>
			return this.addContent(content, "after"); // dojo/NodeList
		},

		insertAfter: function(/*String*/query){
			// summary:
			//		The nodes in this NodeList will be placed after the nodes
			//		matched by the query passed to insertAfter.
			// description:
			//		The nodes in this NodeList will be cloned if the query
			//		matches more than one element. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the matched nodes from the query.
			// example:
			//		assume a DOM created by this markup:
			//	|	<span>after</span>
			//	|	<p>Hello Mars</p>
			//	|	<p>Hello World</p>
			//		Running this code:
			//	|	dojo.query("span").insertAfter("p");
			//		Results in this DOM structure:
			//	|	<p>Hello Mars</p><span>after</span>
			//	|	<p>Hello World</p><span>after</span>
			return this._placeMultiple(query, "after"); // dojo/NodeList
		},

		before: function(/*String||DOMNode||NodeList*/content){
			// summary:
			//		Places the content before every node in the NodeList.
			// description:
			//		The content will be cloned if the length of NodeList
			//		is greater than 1. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the appended content.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div id="foo"><p>Hello Mars</p></div>
			//	|	<div id="bar"><p>Hello World</p></div>
			//		Running this code:
			//	|	dojo.query("div").before("<span>before</span>");
			//		Results in this DOM structure:
			//	|	<span>before</span><div id="foo"><p>Hello Mars</p></div>
			//	|	<span>before</span><div id="bar"><p>Hello World</p></div>
			return this.addContent(content, "before"); // dojo/NodeList
		},

		insertBefore: function(/*String*/query){
			// summary:
			//		The nodes in this NodeList will be placed after the nodes
			//		matched by the query passed to insertAfter.
			// description:
			//		The nodes in this NodeList will be cloned if the query
			//		matches more than one element. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		dojo/NodeList, the nodes currently in this NodeList will be returned,
			//		not the matched nodes from the query.
			// example:
			//		assume a DOM created by this markup:
			//	|	<span>before</span>
			//	|	<p>Hello Mars</p>
			//	|	<p>Hello World</p>
			//		Running this code:
			//	|	dojo.query("span").insertBefore("p");
			//		Results in this DOM structure:
			//	|	<span>before</span><p>Hello Mars</p>
			//	|	<span>before</span><p>Hello World</p>
			return this._placeMultiple(query, "before"); // dojo/NodeList
		},

		/*=====
		remove: function(simpleFilter){
			// summary:
			//		alias for dojo/NodeList's orphan method. Removes elements
			//		in this list that match the simple filter from their parents
			//		and returns them as a new NodeList.
			// simpleFilter: String
			//		single-expression CSS rule. For example, ".thinger" or
			//		"#someId[attrName='value']" but not "div > span". In short,
			//		anything which does not invoke a descent to evaluate but
			//		can instead be used to test a single node is acceptable.

			return; // dojo/NodeList
		},
		=====*/
		remove: NodeList.prototype.orphan,

		wrap: function(/*String||DOMNode*/html){
			// summary:
			//		Wrap each node in the NodeList with html passed to wrap.
			// description:
			//		html will be cloned if the NodeList has more than one
			//		element. Only DOM nodes are cloned, not any attached
			//		event handlers.
			// returns:
			//		the nodes in the current NodeList will be returned,
			//		not the nodes from html argument.
			// example:
			//		assume a DOM created by this markup:
			//	|	<b>one</b>
			//	|	<b>two</b>
			//		Running this code:
			//	|	dojo.query("b").wrap("<div><span></span></div>");
			//		Results in this DOM structure:
			//	|	<div><span><b>one</b></span></div>
			//	|	<div><span><b>two</b></span></div>
			if(this[0]){
				html = makeWrapNode(html, this[0]);

				//Now cycle through the elements and do the insertion.
				for(var i = 0, node; node = this[i]; i++){
					//Always clone because if html is used to hold one of
					//the "this" nodes, then on the clone of html it will contain
					//that "this" node, and that would be bad.
					var clone = this._cloneNode(html);
					if(node.parentNode){
						node.parentNode.replaceChild(clone, node);
					}
					//Find deepest element and insert old node in it.
					var insertion = getWrapInsertion(clone);
					insertion.appendChild(node);
				}
			}
			return this; // dojo/NodeList
		},

		wrapAll: function(/*String||DOMNode*/html){
			// summary:
			//		Insert html where the first node in this NodeList lives, then place all
			//		nodes in this NodeList as the child of the html.
			// returns:
			//		the nodes in the current NodeList will be returned,
			//		not the nodes from html argument.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div class="container">
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			//		Running this code:
			//	|	dojo.query(".red").wrapAll('<div class="allRed"></div>');
			//		Results in this DOM structure:
			//	|	<div class="container">
			// 	|		<div class="allRed">
			// 	|			<div class="red">Red One</div>
			// 	|			<div class="red">Red Two</div>
			// 	|		</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			if(this[0]){
				html = makeWrapNode(html, this[0]);

				//Place the wrap HTML in place of the first node.
				this[0].parentNode.replaceChild(html, this[0]);

				//Now cycle through the elements and move them inside
				//the wrap.
				var insertion = getWrapInsertion(html);
				for(var i = 0, node; node = this[i]; i++){
					insertion.appendChild(node);
				}
			}
			return this; // dojo/NodeList
		},

		wrapInner: function(/*String||DOMNode*/html){
			// summary:
			//		For each node in the NodeList, wrap all its children with the passed in html.
			// description:
			//		html will be cloned if the NodeList has more than one
			//		element. Only DOM nodes are cloned, not any attached
			//		event handlers.
			// returns:
			//		the nodes in the current NodeList will be returned,
			//		not the nodes from html argument.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div class="container">
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			//		Running this code:
			//	|	dojo.query(".red").wrapInner('<span class="special"></span>');
			//		Results in this DOM structure:
			//	|	<div class="container">
			// 	|		<div class="red"><span class="special">Red One</span></div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="red"><span class="special">Red Two</span></div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			if(this[0]){
				html = makeWrapNode(html, this[0]);
				for(var i = 0; i < this.length; i++){
					//Always clone because if html is used to hold one of
					//the "this" nodes, then on the clone of html it will contain
					//that "this" node, and that would be bad.
					var clone = this._cloneNode(html);

					//Need to convert the childNodes to an array since wrapAll modifies the
					//DOM and can change the live childNodes NodeList.
					this._wrap(lang._toArray(this[i].childNodes), null, this._NodeListCtor).wrapAll(clone);
				}
			}
			return this; // dojo/NodeList
		},

		replaceWith: function(/*String||DOMNode||NodeList*/content){
			// summary:
			//		Replaces each node in ths NodeList with the content passed to replaceWith.
			// description:
			//		The content will be cloned if the length of NodeList
			//		is greater than 1. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		The nodes currently in this NodeList will be returned, not the replacing content.
			//		Note that the returned nodes have been removed from the DOM.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div class="container">
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			//		Running this code:
			//	|	dojo.query(".red").replaceWith('<div class="green">Green</div>');
			//		Results in this DOM structure:
			//	|	<div class="container">
			// 	|		<div class="green">Green</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="green">Green</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			content = this._normalize(content, this[0]);
			for(var i = 0, node; node = this[i]; i++){
				this._place(content, node, "before", i > 0);
				node.parentNode.removeChild(node);
			}
			return this; // dojo/NodeList
		},

		replaceAll: function(/*String*/query){
			// summary:
			//		replaces nodes matched by the query passed to replaceAll with the nodes
			//		in this NodeList.
			// description:
			//		The nodes in this NodeList will be cloned if the query
			//		matches more than one element. Only the DOM nodes are cloned, not
			//		any attached event handlers.
			// returns:
			//		The nodes currently in this NodeList will be returned, not the matched nodes
			//		from the query. The nodes currently in this NodeLIst could have
			//		been cloned, so the returned NodeList will include the cloned nodes.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div class="container">
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			//		Running this code:
			//	|	dojo.query(".red").replaceAll(".blue");
			//		Results in this DOM structure:
			//	|	<div class="container">
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="spacer">___</div>
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="red">Red Two</div>
			//	|	</div>
			var nl = dquery(query);
			var content = this._normalize(this, this[0]);
			for(var i = 0, node; node = nl[i]; i++){
				this._place(content, node, "before", i > 0);
				node.parentNode.removeChild(node);
			}
			return this; // dojo/NodeList
		},

		clone: function(){
			// summary:
			//		Clones all the nodes in this NodeList and returns them as a new NodeList.
			// description:
			//		Only the DOM nodes are cloned, not any attached event handlers.
			// returns:
			//		a cloned set of the original nodes.
			// example:
			//		assume a DOM created by this markup:
			//	|	<div class="container">
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="blue">Blue Two</div>
			//	|	</div>
			//		Running this code:
			//	|	dojo.query(".red").clone().appendTo(".container");
			//		Results in this DOM structure:
			//	|	<div class="container">
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="blue">Blue One</div>
			// 	|		<div class="red">Red Two</div>
			// 	|		<div class="blue">Blue Two</div>
			// 	|		<div class="red">Red One</div>
			// 	|		<div class="red">Red Two</div>
			//	|	</div>

			//TODO: need option to clone events?
			var ary = [];
			for(var i = 0; i < this.length; i++){
				ary.push(this._cloneNode(this[i]));
			}
			return this._wrap(ary, this, this._NodeListCtor); // dojo/NodeList
		}
	});

	//set up html method if one does not exist
	if(!NodeList.prototype.html){
		NodeList.prototype.html = NodeList.prototype.innerHTML;
	}

	return NodeList;
});

},
'epi/shell/widget/dialog/_DialogContentMixin':function(){
﻿define("epi/shell/widget/dialog/_DialogContentMixin", [
    "dojo/_base/declare"
], function (declare) {

    return dojo.declare(null, {
        // summary:
        //    Mixin which provides widgets capability to tell the container dialog to execute or cancel.
        // tags:
        //    public

        executeDialog: function () {
			// summary:
			//	    Call this method to ask the container dialog to execute.
			// tag:
			//		protected
        },

        cancelDialog: function () {
			// summary:
			//	    Call this method to ask the container dialog to cancel.
			// tag:
			//		protected
        }

    });
});

},
'url:epi-cms/contentediting/templates/ExpirationDialog.html':"﻿<div class=\"epi-formContainer\">\r\n    <div data-dojo-type=\"epi-cms/widget/Breadcrumb\" data-dojo-attach-point=\"breadcrumb\" data-dojo-props=\"showCurrentNode: false\"></div>\r\n    <h1 data-dojo-attach-point=\"contentNameNode\" class=\"epi-breadCrumbsCurrentItem dijitInline dojoxEllipsis\"></h1>\r\n    <div data-dojo-attach-point=\"stateNode\" class=\"epi-notificationBar epi-notificationBarItem\">\r\n        <div class=\"epi-notificationBarText\" data-dojo-attach-point=\"infoTextNode\"></div>\r\n        <div class=\"epi-notificationBarButtonContainer\">\r\n            <button data-dojo-type=\"dijit/form/Button\" data-dojo-attach-point=\"removeButton\" data-dojo-attach-event=\"onClick: _onRemoveButtonClick\">${res.removebutton}</button>\r\n        </div>\r\n    </div>\r\n    <div data-dojo-type=\"dijit/form/Form\" class=\"epi-formArea\" data-dojo-attach-point=\"form\"></div>\r\n</div>",
'epi-cms/contentediting/viewmodel/ExpirationDialogViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/Stateful",
    "dojo/string",

//EPi
    "epi/epi",
    "epi/datetime",
    "epi/shell/_StatefulGetterSetterMixin",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.expirationeditor",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.versionstatus"
],

function (
// Dojo
    declare,
    Stateful,
    dojoString,

// EPi
    epi,
    epiDatetime,
    _StatefulGetterSetterMixin,

// Resources
    expirationeditorResources,
    versionstatusResources
    ) {

    return declare([Stateful, _StatefulGetterSetterMixin], {
        value: null,

        intermediateValue: null,

        contentLink: null,

        contentName: null,

        // View model binding properties
        enableSaveButton: null,

        showRemoveButton: null,

        infoText: null,

        state: null,

        postscript: function () {
            this.inherited(arguments);

            this.set("intermediateValue", this.value);
            this.set("minimumExpireDate", this.minimumExpireDate);
        },

        _setIntermediateValueAttr: function (value) {
            this._set("intermediateValue", value);

            this.set("enableSaveButton", !epi.areEqual(this.intermediateValue, this.value));

            if (value && value.stopPublish) {
                // TODO: Remove deserialize call when the content data is deserialized into a strongly typed object
                var stopPublish = value.stopPublish instanceof Date ? value.stopPublish : epiDatetime.deserialize(value.stopPublish);

                this.set("showRemoveButton", true);

                this.set("infoText", stopPublish < epiDatetime.serverTime() ?
                    versionstatusResources.expired :
                    dojoString.substitute(expirationeditorResources.expiretimetext, [epiDatetime.timeToGo(stopPublish)]));

                this.set("state", "Expiring");

            } else {
                this.set("showRemoveButton", false);
                this.set("infoText", expirationeditorResources.neverexpiretext);
                this.set("state", "NotExpiring");
            }
        },

        _setValueAttr: function (value) {
            this._set("value", value);

            this.set("enableSaveButton", false);

        },

        _setMinimumExpireDateAttr: function (value) {
            var date = new Date(value);
            this._set("minimumExpireDate", epiDatetime.isDateValid(date) ? date : null);
            this._set("minimumExpireDateMessage", expirationeditorResources.minimumdatevalidation);
        },

        save: function () {
            this.set("value", this.intermediateValue);
        }
    });
});
},
'epi-cms/contentediting/commandproviders/ContentDetails':function(){
﻿define([
    "dojo",
    "dojo/_base/declare",

    "epi/shell/command/_CommandProviderMixin",

    "../command/PermanentInUseToggle",
    "../command/StartWorkflow"
], function (
    dojo,
    declare,

    _CommandProviderMixin,
    PermanentInUseToggle,
    StartWorkflow) {

    // module:
    //		epi-cms/contentediting/commandproviders/ContentDetails
    // summary:
    //		Command provider, which adds in use notification related commands to content detail area.

    return declare([_CommandProviderMixin], {

        constructor: function () {
            // summary:
            //		Ensure that an array of commands has been initialized.
            // tags:
            //		public            
            this.inherited(arguments);

            // permanent inuse notification toggle
            this.add("commands", new PermanentInUseToggle());
            this.add("commands", new StartWorkflow());
        }
    });
});

},
'epi-cms/contentediting/command/PermanentInUseToggle':function(){
﻿define([
    "dojo/_base/declare",
    "epi/dependency",
    "epi/shell/command/ToggleCommand",

//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.permanenteditindication"
],

function (declare, dependency, ToggleCommand, resources) {

    return declare([ToggleCommand], {
        // summary:
        //      Toggles permanent in use notification on/off.

        name: "PermanentInUseNotification",
        label: resources.title,
        tooltip: resources.tooltip,

        inUseNotificationManager: null,

        postscript: function () {
            this.inherited(arguments);

            if (this.inUseNotificationManager === null) {
                this.inUseNotificationManager = dependency.resolve("epi.cms.contentediting.inUseNotificationManager");
            }

            this.set("canExecute", true);
            this.set("isAvailable", true);
        },

        _execute: function () {
            // summary:
            //		Toggles permanent editing indication on/off.
            // tags:
            //		protected

            this.inherited(arguments);

            var contentData = this.model.contentData;
            this.inUseNotificationManager.togglePermanentEditIndication(contentData, true);

            this._updateCanExecute();
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute and isAvailable after the model has been updated.
            // tags:
            //		protected

            var contentData = this.model.contentData,
                canChangeContent = this.model.canChangeContent(),
                active = this.inUseNotificationManager.currentUserHasInUseNotification(contentData.inUseNotifications, true);

            this.set("active", active);

            this._updateCanExecute();
        },

        _updateCanExecute: function () {
            this.set("canExecute", this.active || this.model.canChangeContent());
        }
    });
});
},
'epi-cms/contentediting/command/StartWorkflow':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",

// epi
    "epi-cms/contentediting/command/_LegacyDialogCommandBase",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.command.startworkflow"
// resources
], function (
// dojo
    declare,
    lang,

    domClass,

// epi
    _LegacyDialogCommandBase,
// resources
    resources
) {

    // summary:
    //      A command for starting a new workflow using the StartWorkflow plug-in from the legacy CMS UI.
    //      When executed, a dialog showing the start workflow ui is opened.
    // tags:
    //      public
    return declare([_LegacyDialogCommandBase], {

        label: resources.label,

        dialogPath: "Edit/StartWorkflow.aspx",

        raiseCloseEvent: true,

        getRouteParams: function () {
            // summary:
            //      Override to customize the parameters used for getting the route url for the opened dialog

            return lang.mixin(this.inherited(arguments), { "id": this.getContentReference(true) });
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute and isAvailable after the model has been updated.
            // tags:
            //      protected

            var isPage = lang.getObject("model.contentData.capabilities.isPage", false, this);
            this.set("canExecute", !!isPage);
        },

        getDialogParams: function() {
            return {
                dialogTitle: resources.label,
                // Custom query to get the legacy buttons
                legacyButtonQuery: "div.epi-buttonContainer span.epi-cmsButton, span.epi-cmsButton>input.epi-cmsButton-Cancel",
                onMapDialogButton: function (/*DOM*/legacyButton) {
                    // All buttons except the cancel button should show up in the wrapping chrome
                    return !(legacyButton && domClass.contains(legacyButton, "epi-cmsButton-Cancel"));
                },
                showCloseButton: true
            };
        }
    });
});
},
'epi-cms/contentediting/command/_LegacyDialogCommandBase':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",

    "dojo/topic",
// epi
    "epi/routes",
    "epi/shell/command/_Command",
    "epi/UriParser",

    "epi-cms/core/ContentReference",
    "epi-cms/legacy/LegacyDialogPopup"
],

function (
// dojo
    declare,
    lang,
    whenAll,

    topic,
// epi
    routes,
    _Command,
    UriParser,

    ContentReference,
    LegacyDialogPopup
) {

    // summary:
    //      Base class for any command that needs to open a dialogs from the legacy user interface
    //      canExecute is updated to false if the content is changing its status, and restore when done.
    // tag:
    //      abstract

    return declare([_Command], {

        dialogPath: null,
        raiseCloseEvent: null,
        routeParams: null,
        dialogParams: null,
        canExecute: true,

        getContentReference: function (/*Boolean*/withVersion) {
            // summary: 
            //      Returns a content reference used when assembling the route parameters.

            var contentLink = lang.getObject("model.contentData.contentLink", false, this),
                contentReference = contentLink ? new ContentReference(contentLink) : null;

            if (contentReference) {
                contentReference = withVersion ? contentReference.toString() : contentReference.createVersionUnspecificReference().toString();
            }
            return contentReference;
        },

        getRouteParams: function () {
            // summary:
            //  Override to customize the parameters used for getting the route url for the opened dialog

            return {
                "id": this.getContentReference(),
                path: this.dialogPath,
                moduleArea: "LegacyCMS",
                IsInLegacyWrapper: true
            };
        },

        getDialogParams: function () {
            // summary:
            //  Override to supply custom parameters to to the dialog.
            //
            // returns:
            //  An empty object
            return {};
        },

        _createDialog: function (/*object*/dialogParams, /*object*/routeParams) {
            // summary:
            //      Creates and returns a new LegacyDialogPopup 
            //
            // dialogParams:
            //      An object containing parameters overriding any default dialog constructor arguments
            //
            // routeParams:
            //      An object with properties used for constructing the dialog url.
            //
            // tags: private
            var standardDialogParams = {
                url: routes.getActionPath(routeParams),
                dialogArguments: window.document,
                autoFit: true,
                destroyOnHide: true,
                onClose: lang.hitch(this, function () {
                    var contentReference = this.getContentReference();
                    if (this.raiseCloseEvent && contentReference) {
                        //update context
                        topic.publish("/epi/cms/contentdata/updated", {
                            contentLink: contentReference,
                            recursive: true
                        });
                    }
                })
            };

            return new LegacyDialogPopup(lang.mixin({}, standardDialogParams, dialogParams));
        },

        _execute: function () {
            whenAll([this.getDialogParams(), this.getRouteParams()]).then(lang.hitch(this, function(params) { 
                var dialog = this._createDialog.apply(this, params);
                dialog.show();
            }));
        }

    });

});
},
'epi-cms/legacy/LegacyDialogPopup':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-construct",

    "dojo/Deferred",
    "dojo/DeferredList",
// epi
    "epi",
    "epi/shell/widget/dialog/Dialog"
],

function (
// dojo
    declare,
    lang,

    domClass,
    domConstruct,

    Deferred,
    DeferredList,
// epi
    epi,
    Dialog
) {

    // summary:
    //    For directly open a legacy dialog in a popup dialog.
    //    Act as a thin wrapper of the epi.cms.legacy.LegacyDialogWrapper widget

    return declare([Dialog], {

        // url: [public] String
        //      Legacy dialog's url.
        url: null,

        // dialogArguments: [public] Object
        //      Legacy dialog's arguments.
        dialogArguments: null,

        // callbackArguments: [public] Object
        //      Legacy dialog's callback arguments.
        callbackArguments: null,

        // features: [public] Object
        //      Popup window features. Some (width, height, left, top) will be used to style the iframe. The others will be ignored.
        features: null,

        // autoFit: [public] Boolean
        //      Specify if the dialog should be resized to fit its inner content.
        autoFit: false,

        // showLoadingOverlay: [public] Boolean
        //      Specify if the dialog should show the loading overlay when reload the IFrame.
        showLoadingOverlay: false,

        // legacyDialogObject: [public] Object
        //      Keep the legacy dialog object.
        legacyDialogObject: null,

        // Overridden from Dialog
        defaultActionsVisible: false,

        // legacyButtonQuery: [public] String
        //      Custom query to find all the legacy buttons
        legacyButtonQuery: null,

        // contentClass: [protected] String
        //      Class to apply to the container DOMNode of the dialog so that the
        //      content takes the full width of the dialog.
        contentClass: "epi-dialog-fullWidth",

        dialogClass: "",

        // dialogTitle: [public] String
        //      Title of the dialog
        dialogTitle: null,

        _legacyDialogContainer: null,
        _legacyDialogLoadDeferred: null,
        wrapper: null,

        buildRendering: function () {
            // summary:
            //      Add the epi-legacyDialog class to the domNode during rendering.
            // tags:
            //      protected
            this.inherited(arguments);
            domClass.add(this.domNode, "epi-legacyDialog");
        },

        postCreate: function () {
            // summary:
            //    Load the wrapped legacy dialog widget as the dialog's content.
            //
            // tags:
            //    private

            this.inherited(arguments);

            this._legacyDialogContainer = domConstruct.create("div");
            this.set("content", this._legacyDialogContainer);
        },

        onCallback: function (returnValue, callbackArgs) {
            // summary:
            //    Called when the legacy dialog do a callback
            //
            // returnValue: Object
            //     return value from the wrapped dialog
            //
            // tags:
            //    public callback
        },

        onClose: function () {
            // summary:
            //    Called when the legacy dialog is closed
            //
            // tags:
            //    public
        },

        onLoad: function (wrapper) {
            // summary:
            //    Called when the legacy dialog is loaded
            //
            // tags:
            //    public
        },

        onMapDialogButton: function (/*DOM*/button) {
            // summary:
            //      Called when a button inside a legacy dialog is mapped into the dialog chrome.
            //      Override this method to control whether a button is mapped or not
            // returns:
            //      true to mape the button; otherwise false.
            // tags:
            //      public, callback

            return true;
        },

        onBeforePerformAction: function (action) {
            // summary:
            //    Called before the legacy dialog perform an action.
            //
            // tags:
            //    public
        },

        show: function () {
            // summary:
            //    Show the wrapped legacy dialog in a popup dialog.
            //
            // returns: dojo.Deferred
            //		Deferred object that resolves when the show animation is complete
            //
            // tags:
            //    public

            var defList = new DeferredList([this._loadLegacyDialog(), this.inherited(arguments)]);

            return defList.then(lang.hitch(this, function (result) {
                var showResult = result[1]; //0: loadResult, 1: showResult

                if (this.features && this.features.left && this.features.top) {
                    this.dialog._relativePosition = {
                        x: this.features.left,
                        y: this.features.top
                    };
                }

                return showResult;
            }));
        },

        _loadLegacyDialog: function () {
            // summary:
            //    Load legacy dialog to the dialog content.
            //
            // returns: dojo.Deferred
            //		Deferred object that resolves when the epi.cms.legacy.LegacyDialogWrapper class is loaded, and the legacy dialog starts loading.
            //
            // tags:
            //    private

            if (this._legacyDialogLoadDeferred) {
                return this._legacyDialogLoadDeferred;
            }

            this._legacyDialogLoadDeferred = new Deferred();

            require(["epi-cms/legacy/LegacyDialogWrapper"], lang.hitch(this, function (LegacyDialogWrapper) {
                var wrapper = new LegacyDialogWrapper({
                    url: this.url,
                    dialogArguments: this.dialogArguments,
                    callbackArguments: this.callbackArguments,
                    features: this.features,
                    autoFit: this.autoFit,
                    showLoadingOverlay: this.showLoadingOverlay,
                    dialogTitle: this.dialogTitle,
                    legacyButtonQuery: this.legacyButtonQuery,
                    showCloseButton: this.showCloseButton
                }, this._legacyDialogContainer);

                // The very first time a legacy dialog is opened, this line takes a little while to be reached so we miss the dialog startup event and the dialog is not positioned and buttons are not mapped.
                // Therefore, make sure it is always started up before adding to dialog.
                if (this._started && !wrapper._started) {
                    wrapper.startup();
                }

                this.legacyDialogObject = wrapper.getLegacyDialog();

                this.connect(wrapper, "onMapDialogButton", this.onMapDialogButton);

                this.connect(wrapper, "onBeforePerformAction", this.onBeforePerformAction);

                this.connect(wrapper, "onCallback", function (returnValue, callbackArgs) {
                    this.onCallback(returnValue, callbackArgs);
                    // In legacy dialog, callback functions are often called onload event. We have to wait until all the load handlers finish to destroy the dialog.
                    // Refer to EPiServerScriptManager.js, line 528 for more detailed on how are load event handled in legacy dialogs.
                    setTimeout(lang.hitch(this, function () {
                        this.hide();
                    }), 1);
                });

                this.connect(wrapper, "onLoad", function () {
                    this.set("title", wrapper.title);
                    this.onLoad(wrapper);
                });

                this.connect(wrapper, "onCancel", function () {
                    this.hide();
                });

                this.connect(wrapper, "onResize", function () {
                    this.resize();
                });

                this.connect(this, "onHide", function () {
                    this.onClose();
                });

                this.wrapper = wrapper;
                this._legacyDialogLoadDeferred.resolve();
            }));

            return this._legacyDialogLoadDeferred;
        }

    });

});
},
'epi-cms/contentediting/commandproviders/PublishMenu':function(){
﻿define([
    "dojo",
    "dojo/_base/declare",

    "epi/shell/command/_CommandProviderMixin",
    "epi-cms/contentediting/command/ForPublishMenu",
    "epi-cms/contentediting/command/IgnoreInUseNotification"
], function (
    dojo,
    declare,

    _CommandProviderMixin,
    ForPublishMenu,
    IgnoreInUseNotification) {

    // module:
    //		epi-cms/contentediting/commandproviders/PublishMenu
    // summary:
    //		Command provider, which adds in use notification related commands to publish menu.

    return declare([_CommandProviderMixin], {

        constructor: function () {
            // summary:
            //		Ensure that an array of commands has been initialized.
            // tags:
            //		public            
            this.inherited(arguments);

            // ignore inuse notification
            this.add("commands", ForPublishMenu(new IgnoreInUseNotification(), {
                priority: 10000
            }));
        }
    });
});

},
'epi-cms/contentediting/command/ForPublishMenu':function(){
﻿define([
    "dojo/_base/lang"
],
function (lang) {
    // module:
    //		epi/cms/contentediting/command/ForPublishMenu
    // summary:
    //		Adds some decorations for the command to be used in publish menu.

    return function(command, options) {
        // summary:
        //      Adds some decorations for the command to be used in publish menu.
        // command: epi.shell.command._Command
        //      The command
        // options: Object
        //      The options. Available options are:
        //          isMain: Indicate if the command can be the main command.
        //          priority: The command priority.
        //          mainButtonClass: CSS class applied to main button if command is main command.
        //          keepMenuOpen: Keep publish menu open after command executed.
        //          successStatus: The text to display when the command successfully executed.

        // TODO: Use lang.delegate and return a new command instance, to avoid messing up the original command.
        // Temporarily set the options to the original command because lang.delegate doesn't work well with Stateful objects.

        options = lang.mixin({
            isMain: false,
            priority: 0,
            resetLabelAfterExecution: true,
            mainButtonClass: null,
            keepMenuOpen: false,
            successStatus: null
        }, options);

        command.options = options;

        return command;
    };
});
},
'epi-cms/contentediting/command/IgnoreInUseNotification':function(){
﻿define([
    "dojo/_base/declare",
    "epi/dependency",
    "epi/shell/command/_Command",

//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (declare, dependency, _Command, resource) {

    return declare([_Command], {
        // summary:
        //      Ignore in use notification and edit.

        name: "IgnoreInUseNotification",
        label: resource.ignoreinusenotification.label,
        tooltip: resource.ignoreinusenotification.title,
        iconClass: "epi-iconPen",

        inUseNotificationManager: null,

        postscript: function () {
            this.inherited(arguments);

            if (this.inUseNotificationManager === null) {
                this.inUseNotificationManager = dependency.resolve("epi.cms.contentediting.inUseNotificationManager");
            }

            this.set("canExecute", true);
            this.set("isAvailable", true);
        },

        _execute: function () {
            // summary:
            //		Toggles permanent editing indication on/off.
            // tags:
            //		protected

            this.inUseNotificationManager.ignoreOthersNotifications = true;

            // reset view name to have the PageDataController load the correct view.
            this.model.viewName = null;

            this._requestContextChange(this.model.contentData.uri, true);
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute and isAvailable after the model has been updated.
            // tags:
            //		protected

            var contentData = this.model.contentData,               
                hasInUseNotificationWarning = this.inUseNotificationManager.hasInUseNotificationWarning(contentData.inUseNotifications),
                ignoreFlag,
                originallyEditable;

            // Temporarily ignore inuse notification warning to check original editable status
            ignoreFlag = this.inUseNotificationManager.ignoreOthersNotifications;
            this.inUseNotificationManager.ignoreOthersNotifications = true;
            originallyEditable = this.model.canChangeContent();
            this.inUseNotificationManager.ignoreOthersNotifications = ignoreFlag;

            // Available when the content is originally editable but is locked by notification warning
            this.set("isAvailable", hasInUseNotificationWarning && originallyEditable);
        },

        _requestContextChange: function (uri, forceContextChange) {
            var contextParameters = { uri: uri };
            var callerData = {
                sender: this,
                forceContextChange: forceContextChange
            };

            dojo.publish("/epi/shell/context/request", [contextParameters, callerData]);
        }
    });
});
},
'epi-cms/contentediting/commandproviders/PublishMenuGlobal':function(){
﻿define([
    "dojo",
    "dojo/_base/declare",

    "epi/shell/command/withConfirmation",
    "epi/shell/command/_CommandProviderMixin",

    "epi-cms/command/TranslateContent",
    "epi-cms/contentediting/command/ForPublishMenu",
    "epi-cms/contentediting/command/RevertToPublished",
    "epi-cms/contentediting/command/Reject",
    "epi-cms/contentediting/command/SendForReview",
    "epi-cms/contentediting/command/Publish",
    "epi-cms/contentediting/command/CreateDraft",
    "epi-cms/contentediting/command/EditCommonDraft",
    "epi-cms/contentediting/command/Withdraw",
    "epi-cms/contentediting/command/ScheduleForPublish",
    "epi-cms/contentediting/command/CancelAndEdit",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel.publishactionmenu"
], function (
    dojo,
    declare,

    withConfirmation,
    _CommandProviderMixin,

    TranslateContentCommand,
    ForPublishMenu,
    RevertToPublishedCommand,
    RejectCommand,
    SendForReviewCommand,
    PublishCommand,
    CreateDraftCommand,
    EditCommonDraft,
    WithdrawCommand,
    ScheduleForPublishCommand,
    CancelAndEditCommand,

    res) {

    // module:
    //		epi-cms/contentediting/commandproviders/PublishMenuGlobal
    // summary:
    //		Builtin Command provider for publish menu.

    return declare([_CommandProviderMixin], {

        constructor: function () {
            // summary:
            //		Ensure that an array of commands has been initialized.
            // tags:
            //		public            
            this.inherited(arguments);

            // Adds builtin commands

            // publish
            this.add("commands", ForPublishMenu(new PublishCommand(), { 
                resetLabelAfterExecution: true,
                isMain: true, 
                priority: 9000, 
                mainButtonClass: "Sweet", 
                keepMenuOpen: true, 
                successStatus: res.successfullypublished
            }));
            
            // translate
            this.add("commands", ForPublishMenu(new TranslateContentCommand(), { 
                isMain: true, 
                priority: 10000, 
                mainButtonClass: "Salt" 
            }));
            
            // schedule for publish
            this.add("commands", ForPublishMenu(new ScheduleForPublishCommand()));

            // cancel and edit
            this.add("commands", ForPublishMenu(new CancelAndEditCommand()));
            
            this.add("commands", ForPublishMenu(new SendForReviewCommand(),{ 
                isMain: true, 
                priority: 8000, 
                mainButtonClass: "Sweet", 
                keepMenuOpen: true 
            }));
                       
            // reject
            this.add("commands", ForPublishMenu(new RejectCommand(), {
                resetLabelAfterExecution: false,
                keepMenuOpen: true 
            }));
            
            // withdraw
            this.add("commands", ForPublishMenu(new WithdrawCommand(), {
                resetLabelAfterExecution: false,
                keepMenuOpen: true
            }));

            // edit common draft
            this.add("commands", ForPublishMenu(new EditCommonDraft()));
            
            // create draft
            this.add("commands", ForPublishMenu(new CreateDraftCommand()));

            // revert to publish
            this.add("commands", ForPublishMenu(withConfirmation(
                new RevertToPublishedCommand(), null, {
                    title: res.reverttopublishconfirmation.dialogtitle,
                    heading: res.reverttopublishconfirmation.confirmquestion,
                    description: res.reverttopublishconfirmation.description
                }
            )));
        }
    });
});

},
'epi/shell/command/withConfirmation':function(){
﻿define("epi/shell/command/withConfirmation", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/Deferred",
    "epi/shell/widget/dialog/Confirmation"
],
function (declare, lang, Deferred, Confirmation) {
    // module:
    //		epi/shell/command/withConfirmation
    // summary:
    //		Adds confirmation before executing a command.


    function defaultConfirmationHandler(settings) {

        var deferred = new Deferred(),
            dialog = new Confirmation(settings);

        dialog.connect(dialog, "onAction", function (confirm) {
            if (confirm) {
                deferred.resolve();
            } else {
                deferred.cancel();
            }
        });

        dialog.show();

        return deferred;
    }

    return function (command, /* function */confirmationHandler, /* Object */settings) {

        // keep original method.
        var originalExecute = command._execute;

        // wrap with a confirmation dialog and return a deferred.
        command._execute = function () {

            function executioner() {
                Deferred.when(originalExecute.apply(command, arguments),
                    commandDeferred.resolve,
                    commandDeferred.cancel);
            }

            var commandDeferred = new Deferred();

            confirmationHandler = confirmationHandler || defaultConfirmationHandler;
            Deferred.when(confirmationHandler(settings), executioner, commandDeferred.cancel);
            return commandDeferred;
        };

        // return the wrapped command.
        return command;
    };
});
},
'epi-cms/contentediting/command/EditCommonDraft':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/contentediting/command/_ContentCommandBase",
    "epi-cms/contentediting/ContentActionSupport",

//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
    declare,
    _ContentCommandBase,
    ContentActionSupport,
    resources
) {

    return declare([_ContentCommandBase], {
        // summary:
        //      Edit the common draft version.

        name: "editcommondraft",
        label: resources.editcommondraft.label,
        tooltip: resources.editcommondraft.title,
        iconClass: "epi-iconPen",

        contentActionSupport: null,

        postscript: function () {
            this.inherited(arguments);
            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;
        },

        _execute: function () {
            // summary:
            //    Executes this command; edit the common draft version.
            //
            // tags:
            //		protected

            this.model.editCommonDraft();
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            this.inherited(arguments);

            var contentData = this.model.contentData,
                status = contentData.status,
                versionStatus = ContentActionSupport.versionStatus,
                hasAccessRights = this.contentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel.Edit),
                canExecute = (status == versionStatus.Published || status == versionStatus.PreviouslyPublished) && !contentData.isCommonDraft &&
                    hasAccessRights &&  this.contentActionSupport.hasProviderCapability(contentData.providerCapabilityMask, ContentActionSupport.providerCapabilities.Edit);

            // The status is publish or previously published, and it is not the common draft and user must have sufficient access rights.
            this.set("canExecute", canExecute && this.model.canEditCurrentLanguage());
            this.set("isAvailable", canExecute);
        }
    });

});
},
'epi-cms/contentediting/command/ScheduleForPublish':function(){
﻿define([
//Dojo
    "dojo/_base/declare",
    "dojo/aspect",
    "dojo/on",
    "dojo/topic",

//EPi shell
    "epi/shell/widget/dialog/Dialog",
//EPi cms
    "epi-cms/contentediting/command/_ChangeContentStatus",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/ScheduledPublishSelector",
    "epi-cms/contentediting/ScheduledPublishSelectorViewModel",

//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.scheduledpublishselector"
],

function (
//Dojo
    declare,
    aspect,
    on,
    topic,

//EPi
    Dialog,
    _ChangeContentStatus,
    ContentActionSupport,
    ScheduledPublishSelector,
    ScheduledPublishSelectorViewModel,

//Resources
    buttonResources,
    widgetResources
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //      Schedule publish command.

        name: "reject",
        label: buttonResources.scheduleforpublish.label,
        tooltip: buttonResources.scheduleforpublish.title,
        iconClass: "epi-iconClock",

        _execute: function () {
            // summary:
            //		Executes this command. Reject content sent for review.
            // tags:
            //		protected
            var viewModel = new ScheduledPublishSelectorViewModel();
            viewModel.set("contentData", this.model.contentData);
            var widget = new ScheduledPublishSelector({ model: viewModel });

            var self = this,
                saveAction = ContentActionSupport.saveAction;
            self.set("action", saveAction.CheckIn | saveAction.DelayedPublish | saveAction.ForceCurrentVersion);

            var dateSelectorDialog = new Dialog({ content: widget, title: widgetResources.title, defaultActionsVisible: false });
            on(dateSelectorDialog, "execute", function () {
                // Update the "StartPublish" metadata property
                self.model.setProperty("iversionable_startpublish", viewModel.dateValue);

                // We cannot call self.inherited(arguments) here because we're in the ScheduledPublishSelector dialog
                self._changeContentStatus();
            });

            dateSelectorDialog.show(true);

            // Disable Undo & Redo actions.
            aspect.after(dateSelectorDialog, "_onSubmit", function () {
                topic.publish("/epi/cms/action/disableundoredoactions");
            });

        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            this.inherited(arguments);

            var contentData = this.model.contentData,
                isVisible = (contentData.status === ContentActionSupport.versionStatus.CheckedOut) ||
                    (contentData.status === ContentActionSupport.versionStatus.Rejected) ||
                    (contentData.status === ContentActionSupport.versionStatus.Published && contentData.isCommonDraft),
                canExecute = isVisible && this.model.canChangeContent(ContentActionSupport.action.Publish);

            this.set("canExecute", canExecute);
            this.set("isAvailable", isVisible);
        }
    });

});
},
'epi-cms/contentediting/ScheduledPublishSelector':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

// Dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

//EPi
    "epi/shell/widget/_ActionProviderWidget",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/DateTimeSelectorDropDown",
    "epi/shell/widget/dialog/_DialogContentMixin",
    "epi-cms/widget/Breadcrumb",
    "./ScheduledPublishSelectorViewModel",

// Resources
    "dojo/text!./templates/ScheduledPublishSelector.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.scheduledpublishselector",
    "epi/i18n!epi/nls/episerver.shared"
],

function (
// Dojo
    declare,
    lang,

// Dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

// EPi
    _ActionProviderWidget,
    _ModelBindingMixin,
    DateTimeSelectorDropDown,
    _DialogContentMixin,
    Breadcrumb,
    ScheduledPublishSelectorViewModel,

// Resources
    template,
    resources,
    sharedResources
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin, _ActionProviderWidget, _DialogContentMixin], {
        // summary:
        //    A widget for selecting date when doing a scheduled publish.
        //
        // tags:
        //    public

        templateString: template,

        modelData: null,

        _setTitleAttr: {
            node: "contentNameNode",
            type: "innerText"
        },

        _setDateLabelAttr: {
            node: "publishChangesCaptionNode",
            type: "innerHTML"
        },

        _setDateValueAttr: function (date) {
            this.dateTimeSelector.set("value", date);
        },

        _setBreadcrumbModelAttr: function (breadcrumbModel) {
            this.breadcrumbNode.set("contentLink", breadcrumbModel);
        },

        _setScheduleButtonEnabledAttr: function (enabled) {
            if (this._actions && this._actions.length) {
                this.setActionProperty("save", "disabled", !enabled);
            }
        },

        modelBindingMap: {
            "title": ["title"],
            "dateLabel": ["dateLabel"],
            "dateValue": ["dateValue"],
            "breadcrumbModel": ["breadcrumbModel"],
            "scheduleButtonEnabled": ["scheduleButtonEnabled"]
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            this.model = this.model || new ScheduledPublishSelectorViewModel(this.modelData);
        },

        postCreate: function () {
            // summary:
            //
            // tags:
            //      protected
            this.inherited(arguments);

            this.connect(this.dateTimeSelector, "onChange", "dateTimeSelectorChanged");
        },

        dateTimeSelectorChanged: function (value) {
            this.model.set("dateValue", value);
        },

        getActions: function () {
            // summary:
            //      Overridden from _ActionProvider to get the select current content action added to the containing widget
            //
            // returns:
            //      An array containing a select page action definition, if it is not a shared block

            this._actions = [
                {
                    name: "save",
                    label: resources.confirmtext,
                    settings: { type: "button", "class": "Salt", disabled: true },
                    action: lang.hitch(this, function () {
                        if (this.dateTimeSelector.validate()) {
                            this.executeDialog();
                        }
                    })
                },
                {
                    name: "cancel",
                    label: sharedResources.action.cancel,
                    settings: { type: "button" },
                    action: lang.hitch(this, function () {
                        this.cancelDialog();
                    })
                }
            ];

            return this._actions;
        }
    });
});
},
'epi-cms/contentediting/ScheduledPublishSelectorViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/Stateful",

//EPi
    "epi/shell/_StatefulGetterSetterMixin",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.scheduledpublishselector"
],

function (
// Dojo
    declare,
    Stateful,

// EPi
    _StatefulGetterSetterMixin,

// Resources
    resources
    ) {

    return declare([Stateful, _StatefulGetterSetterMixin], {

        breadcrumbModel: null,

        title: "",

        dateLabel: "",

        dateValue: null,

        scheduleButtonEnabled: false,

        constructor: function () {
            // Create a default date. Set it to noon tomorrow.
            var noonTomorrow = new Date();
            noonTomorrow.setDate(noonTomorrow.getDate() + 1);
            noonTomorrow.setHours(12, 0, 0, 0);

            this.set("dateValue", noonTomorrow);
        },

        _setIsPublishedAttr: function (isPublished) {
            this.set("dateLabel", isPublished ? resources.publishchangeson : resources.publishon);
        },

        _setContentDataAttr: function (contentData) {
            this.set("title", contentData.name);
            this.set("isPublished", !contentData.isPendingPublish);
            this.set("breadcrumbModel", contentData.contentLink);
        },

        _setDateValueAttr: function (value) {
            this._set("dateValue", value);

            this.set("scheduleButtonEnabled", !!value);
        }
    });
});
},
'url:epi-cms/contentediting/templates/ScheduledPublishSelector.html':"﻿<div>\r\n    <div data-dojo-type=\"epi-cms/widget/Breadcrumb\" data-dojo-attach-point=\"breadcrumbNode\" data-dojo-props=\"showCurrentNode: false\"></div>\r\n    <h1 data-dojo-attach-point=\"contentNameNode\" class=\"epi-breadCrumbsCurrentItem dijitInline dojoxEllipsis\"></h1>\r\n    <div data-dojo-attach-point=\"publishChangesCaptionNode\"></div>\r\n    <div data-dojo-type=\"epi/shell/widget/DateTimeSelectorDropDown\" data-dojo-attach-point=\"dateTimeSelector\" data-dojo-props=\"required:true\"></div>\r\n</div>",
'epi-cms/contentediting/command/CancelAndEdit':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/date",

    "epi/shell/command/_Command",

    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_ChangeContentStatus",

//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons.cancelandedit"
],

function (
    declare,
    Deferred,
    lang,
    dojoDate,

    _Command,

    ContentReference,
    ContentActionSupport,
    _ChangeContentStatus,

    resources
) {

    return declare([_ChangeContentStatus], {
        // summary:
        //      Cancel and edit content command. Available for any delayed published content, and puts the content to rejected when executed.

        name: "cancelAndEdit",
        label: resources.label,
        tooltip: resources.title,
        iconClass: "epi-iconPen",

        action: ContentActionSupport.action.Reject,

        _execute: function () {
            // summary:
            //    Executes this command; publish the current content
            //     
            // tags:
            //		protected

            this.inherited(arguments).then(lang.hitch(this, function () {
                // Reset start publish date: if content hasn't been published yet, use Created date, otherwise use Published date.
                var contentData = this.model.contentData;
                this.model.setProperty("iversionable_startpublish", contentData.isPendingPublish ? contentData.created : contentData.lastPublished);
            }));
        },

        _onModelChange: function () {
            // summary:
            //		Updates state after the model has been updated.
            // tags:
            //		protected

            this.inherited(arguments);

            var contentData = this.model.contentData,
                versionStatus = contentData.status,
                hasEditAccess = ContentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel.Edit),
                canExecute = hasEditAccess && (versionStatus === ContentActionSupport.versionStatus.DelayedPublish);

            this.set("canExecute", canExecute);
            this.set("isAvailable", canExecute);
        }
    });

});
},
'epi-cms/contentediting/viewsettings/ChannelViewSetting':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi-cms/contentediting/_ViewSetting"
], function(declare, lang, _ViewSetting) {

    return declare([_ViewSetting], {

        key: "epichannel",

        usedForRendering: true,

        isTagItem: false,

        beforePreviewLoad: function(previewParams, enabled) {
            this.inherited(arguments);

            if (enabled && this.value) {
                previewParams.epichannel = this.value;
            } else {
                delete previewParams.epichannel;
            }
        }
    });
});
},
'epi-cms/contentediting/_ViewSetting':function(){
﻿define([
    "dojo/_base/declare", 
    "epi/shell/_StatefulGetterSetterMixin"
],
function (declare, _StatefulGetterSetterMixin) {
    return declare(_StatefulGetterSetterMixin, {
        // summary:
        //		Abstract view setting class.
        //		Concreate view setting classes define a key to get setting value from URL hash, and an apply method.
        //		On applying settings, "/epi/cms/action/viewsettingchanged" will be published.
        // tags:
        //		abstract, public

        key: null,

        value: null,

        enabled: null,

        beforePreviewLoad: function (previewParams, enabled) {
            // summary:
            //		Before the preview is loaded. The view setting implementation can modify preview parameters it concerns.
            //      In most of the cases, previewParams contains Url parameter to load the preview iframe.
            // previewParams: Hashtable
            //		The current preview parameters.
            // enabled: Boolean
            //		Indicate that this view setting should be enabled or disabled when apply.
            // tags:
            //		public
        },

        afterPreviewLoad: function (preview, enabled) {
            // summary:
            //		After the preview is loaded. The view setting implementation can modify preview parameters it concerns
            //		Concrete implementation should either make changes to the preview or return set of preview parameters if changes require the preview to reload.
            // preview: Object
            //		The preview widget. For CMS contents, preview widget is usually an IframeWithOverlay.
            // enabled: Boolean
            //		Indicate that this view setting should be enabled or disabled when apply.
            //  return: Hashtable
            //		Preview parameters added when the preview is reloaded.
            // tags:
            //		public
        }
    });
});

},
'epi-cms/contentediting/viewsettings/ResolutionViewSetting':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/contentediting/_ViewSetting"
],
function (declare, _ViewSetting) {
    return declare([_ViewSetting], {
        key: "resolution",
        usedForRendering: false,

        afterPreviewLoad: function (preview, enabled) {
            this.inherited(arguments);

            if (preview) {
                var size = enabled ? this._getPreviewResolution() : null;
                preview.set("previewSize", size);
                preview.set("devicePreviewClass", this.value ? "epi-editorViewport--device-preview epi-viewPort-" + this.value : "");
            }

            return null; //Don't need to reload
        },

        _getPreviewResolution: function () {
            // summary:
            //		Gets preview resolution view setting.
            //
            // tags:
            //		private

            var size = null;

            // Get preview resolution.
            var resolution = this.value;

            if (resolution) {
                var screenSize = resolution.split("x");
                if (screenSize.length == 2) {
                    size = { "w": screenSize[0], "h": screenSize[1] };
                }
            }

            return size;
        }
    });
});

},
'epi-cms/contentediting/viewsettings/ViewLanguageViewSetting':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "epi-cms/contentediting/_ViewSetting"
],
function (declare, lang, Deferred, _ViewSetting) {
    return declare([_ViewSetting], {
        key: "viewlanguage",
        usedForRendering: true,
        isTagItem: false,

        initialize: function (contextService) {
            contextService.registerRequestInterceptor(lang.hitch(this, this._onContextChange));
        },

        _onContextChange: function (contextParams, callerData) {
            var dfd = new Deferred();
            dfd.resolve();
            if (this.get("enabled") && this.value) {
                contextParams.epslanguage = this.value;                
            }

            return dfd;
        }
    });
});
},
'epi-cms/contentediting/viewsettings/VisitorGroupViewSetting':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi-cms/contentediting/_ViewSetting"
], function(declare, lang, _ViewSetting) {

    return declare([_ViewSetting], {

        key: "visitorgroup",

        usedForRendering: true,

        isTagItem: false,

        beforePreviewLoad: function(previewParams, enabled) {
            this.inherited(arguments);

            if (enabled && this.value) {
                previewParams.visitorgroupsByID = this.value;
            } else {
                delete previewParams.visitorgroupsByID;
            }
        }
    });
});
},
'epi-cms/Profile':function(){
﻿define("epi-cms/Profile", [
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/when",
    "epi/dependency",
    "epi/shell/Profile",

    "epi-cms/ApplicationSettings"
], function (lang, Deferred, when, dependency, Profile, ApplicationSettings) {
        
        var safeHostName = function(host) {
            return "editlanguage_" + host.replace(":", "");
        };

        lang.extend(Profile, {
            getContentLanguage: function(host) {
                // summary:
                //      Get the content language for the host
                // host: String?
                //      The host to get the content language for, defaults to window.location.host if not defined
                host = host || window.location.host;

                return when(this.get(safeHostName(host)), function (currentLanguage) {

                    //If the user hasn't selected any preferred language yet use the current content language configured in the application settings
                    return currentLanguage || ApplicationSettings.currentContentLanguage; 
                });
            },
            setContentLanguage: function(languageId, host) {
                // summary:
                //      Set the language for a specific host (stored on the server)
                //
                // languageId: String
                //      The id of the language to set
                // host: String
                //      The host for which the language should be set
                return this.set(safeHostName(host), languageId, {location: "server"});
            }
        });

        return Profile;
});
},
'epi-cms/component/ContextHistory':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",

// EPi Framework
    "epi/dependency",
    "epi/UriParser",

// EPi CMS
    "epi-cms/ApplicationSettings",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/_GridWidgetBase"
], function (
// Dojo
    array,
    declare,
    lang,
    topic,

// EPi Framework
    dependency,
    UriParser,

// EPi CMS
    ApplicationSettings,
    ContentReference,
    _GridWidgetBase
) {

    return declare([_GridWidgetBase], {
        // summary: This component will list the latest changed pages for the web site.
        //          This is currently bound to handle only "content" but could be generalized to handle any content that has a name and an URI.

        // ignoreVersionWhenComparingLinks: [public] Boolean
        //      Use version when comapre uris or not. That inherited from _ContentContextMixin.
        ignoreVersionWhenComparingLinks: false,

        postMixInProperties: function () {
            // summary: 
            //
            // tags:
            //    protected
            this.inherited(arguments);

            this.store = this.store || dependency.resolve("epi.shell.ContextHistory").store;
        },

        buildRendering: function () {
            // summary:
            //		Construct the UI for this widget with this.domNode initialized as a dgrid.
            // tags:
            //		protected

            this.inherited(arguments);

            var gridSettings = lang.mixin({
                columns: {
                    name: {
                        renderCell: lang.hitch(this, this._renderContentItem)
                    }
                },
                store: this.store,
                selectionMode: "single"
            }, this.defaultGridMixin);

            this.grid = new this._gridClass(gridSettings, this.domNode);

            this.grid.set("showHeader", false);
        },

        postCreate: function () {
            // summary:
            //      The widget ready, listen event or do something
            // tags:
            //      public virtual

            this.inherited(arguments);

            // Listen event when trash is empty
            topic.subscribe("/epi/cms/trash/empty", lang.hitch(this, function (deletedContents) {
                if (deletedContents) {
                    deletedContents.forEach(function (contentRef) {
                        this.store.remove("epi.cms.contentdata:///" + contentRef);
                    }, this);
                }
            }));
        },

        startup: function () {
            // summary: Overridden to connect a store to a DataGrid.

            this.inherited(arguments);
            this.fetchData();
        },

        _dndNodeCreator: function (item, hint) {
            // summary:
            //      Custom DnD avatar creator method

            var originalResults = this.inherited(arguments);

            //Since we currently only handle content data we can add an additional contentLink property
            //to the data since it specifies type to be content data.
            originalResults.data.contentLink = new UriParser(originalResults.data.uri).getId();

            return originalResults;
        },

        contextChanged: function () {
            // summary:
            //      Override base in order to call set everytime we get a context change.

            this.inherited(arguments);
            this.grid.set("sort", "dateAdded", true);
        },

        fetchData: function () {
            var wasteBasketId = ApplicationSettings.wastebasketPage;

            // We need to filter the wastebasket. We do so by adding a regex to ignore it. The regex says the following:
            // uri must start with epi.cms.contentdata:///
            // followed by either any single digit except the waste basket id, or two or more digits.
            this.grid.set("query", { uri: new RegExp("epi\\.cms\\.contentdata:///([^" + wasteBasketId + "]|\\d{2,})") });
            this.grid.set("sort", "dateAdded", true);
        }
    });
});
},
'epi-cms/component/GlobalToolbar':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-style",

    "dojo/store/Memory",

// Dijit
    "dijit/registry",
    "dijit/Toolbar",

// EPi CMS
    "epi/shell/command/_CommandModelBindingMixin",
    "epi/shell/command/_WidgetCommandConsumerMixin",
    "epi/shell/command/builder/_Builder",
    "epi/shell/command/builder/GroupedButtonBuilder",
    "epi/shell/command/builder/MenuAssembler",
    "epi/shell/command/builder/DropDownButtonBuilder",

//Template
    "dojo/text!./templates/GlobalToolbar.html",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons"
],

function (
// Dojo
    declare,
    lang,

    domStyle,

    Memory,

// Dijit
    registry,
    Toolbar,

// EPi CMS
    _CommandModelBindingMixin,
    _WidgetCommandConsumerMixin,
    _Builder,
    GroupedButtonBuilder,
    MenuAssembler,
    DropDownButtonBuilder,

    template,
    resources
) {

    var _MenuBuilder = declare([_Builder], {
        _create: function (command) {
            //Declare a new widget and add the _CommandModelBindingMixin
            var widgetPrototype = declare([command.settings.widget, _CommandModelBindingMixin]),
            //Create the new widget
                widget = new widgetPrototype(command.settings);

            return widget;
        },

        _addToContainer: function (widget, container) {
            widget.placeAt(container);

            //Startup the widget
            widget.startup();
        }
    });

    var _MenuAssembler = declare([MenuAssembler], {
        _getBuildInfo: function (command) {
            // summary:
            //      Return the builder information for a specific command based on its category property
            // tags: private

            //Get the category from the settings object instead of the command
            if (command.settings.category) {

                var i = this.configuration.length - 1;
                for (; i > 0; i--) {
                    if (this.configuration[i].category == command.settings.category) {
                        return this.configuration[i];
                    }
                }
            }

            return this.configuration[0];
        }
    });

    return declare([Toolbar, _WidgetCommandConsumerMixin], {
        // summary:
        //      A component providing the global toolbar.

        templateString: template,

        commandKey: "epi.cms.globalToolbar",

        postCreate: function () {
            // summary: Overridden to add buttons to the tool bar once the toolbar itself has been created.

            this.inherited(arguments);

            //Assemble the menu for the available commands
            var builder = new _MenuBuilder();

            var dropDownBuilder = new DropDownButtonBuilder({
                settings: {
                    title: resources.createcontent.title,
                    "class": "epi-mediumButton epi-disabledDropdownArrow",
                    iconClass: "epi-iconPlus",
                    showLabel: false
                }
            });

            var groupedButtonBuilder = new GroupedButtonBuilder({
                settings: {
                    baseClass: "epi-mediumButton epi-expandoButton"
                }
            });

            var assemblerConfig = [
                { category: "leading", builder: builder, target: this.leadingContainerNode },
                { category: "view", builder: groupedButtonBuilder, target: this.leadingContainerNode },
                { category: "center", builder: builder, target: this.centerContainerNode },
                { category: "trailing", builder: builder, target: this.trailingContainerNode },
                { category: "create", builder: dropDownBuilder, target: this.leadingContainerNode }
            ];

            var assembler = new _MenuAssembler({ configuration: assemblerConfig, commandSource: this });
            assembler.build();
        },

        _getNextFocusableChild: function (child, dir) {
            // summary:
            //      Returns the next or previous focusable child, compared
            //      to "child"
            // child: Widget
            //      The current widget
            // dir: Integer
            //      * 1 = after
            //      * -1 = before

            var children = this.getChildren();
            var index = children.indexOf(child);

            index = (dir > 0) ? index + 1 : index - 1;
            if (index < 0)
                index = children.length - 1;
            else if (index >= children.length)
                index = 0;

            return children[index];
        }
    });
});
},
'epi/shell/command/_WidgetCommandConsumerMixin':function(){
﻿define("epi/shell/command/_WidgetCommandConsumerMixin", [
    "dojo/_base/declare",

    "epi/shell/command/_CommandConsumerMixin",
    "epi/shell/command/_WidgetCommandProviderMixin"
], function (declare, _CommandConsumerMixin, _WidgetCommandProviderMixin) {

    // module:
    //		epi/shell/command/_WidgetCommandConsumerMixin
    // summary:
    //		A mixin for objects that will consume and provide commands from widgets and the global command provider

    return declare([_CommandConsumerMixin, _WidgetCommandProviderMixin], {

    });
});
},
'epi/shell/command/_WidgetCommandProviderMixin':function(){
﻿define("epi/shell/command/_WidgetCommandProviderMixin", [
    "dojo/_base/declare",
    "epi/shell/command/_WidgetCommandBinderMixin",
    "epi/shell/command/_GlobalCommandProviderMixin"
], function (declare, _WidgetCommandBinderMixin, _GlobalCommandProviderMixin) {

    // module:
    //		epi/shell/command/_WidgetCommandProviderMixin
    // summary:
    //		A mixin for widgets that will automatically provide commands to the closest parent widget which is a consumer.
    return declare([_GlobalCommandProviderMixin, _WidgetCommandBinderMixin], {

        postMixInProperties: function () {
            this.inherited(arguments);

            this.commandProvider = this.commandProvider || this;
        }

    });
});

},
'epi/shell/command/_WidgetCommandBinderMixin':function(){
﻿define("epi/shell/command/_WidgetCommandBinderMixin", [
    "dojo/_base/declare",
    "epi/shell/command/_CommandConsumerMixin"
], function (declare, _CommandConsumerMixin) {

    // module:
    //		epi/shell/command/_WidgetCommandBinderMixin
    // summary:
    //		A mixin for widgets that will automatically push commands from a provider(view model) to the closest parent widget which is a consumer.

    return declare(null, {

        commandProvider: null,

        _consumerHandle: null,

        startup: function () {
            // summary:
            //		Adds this provider to the closest parent widget which is a consumer.
            // tags:
            //		protected

            if (this._started) {
                return;
            }

            this.inherited(arguments);

            var consumer = this.getConsumer();
            if (!consumer) {
                return;
            }

            this._consumerHandle = consumer.addProvider(this.commandProvider || this);

            this.commandProvider.initializeCommandProviders && this.commandProvider.initializeCommandProviders();
        },

        getConsumer: function () {
            // summary:
            //		Gets the closest command consumer in the hierarchy.
            // tags:
            //		protected

            if (this.isInstanceOf(_CommandConsumerMixin)) {
                return this;
            }

            var parent = this.getParent();
            while (parent) {
                if (parent.isInstanceOf(_CommandConsumerMixin)) {
                    return parent;
                }
                parent = parent.getParent();
            }
        },

        destroy: function () {
            // summary:
            //		Remove the provider from any consumers.
            // tags:
            //		public

            this._consumerHandle && this._consumerHandle.removeProvider();

            this.inherited(arguments);            
        }
    });
});
},
'epi/shell/command/_GlobalCommandProviderMixin':function(){
﻿define("epi/shell/command/_GlobalCommandProviderMixin", [
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi/shell/command/_CommandProviderMixin",
    "epi/dependency"
], function (array, declare, lang, _CommandProviderMixin, dependency) {

    // module:
    //		epi/shell/command/_GlobalCommandProviderMixin
    // summary:
    //		A mixin that will add command providers from the global command registry.
    //      It requires a _CommandProviderMixin or _CommandConsumerMixin on the same object when used

    return declare([_CommandProviderMixin], {

        commandKey: null,

        commandProviders: null,

        _consumer: null,

        _currentCommandModel: null,

        _providerWatch: null,

        _initialized: false,

        initializeCommandProviders: function () {
            // summary:
            //		Gets the providers for the given command key and registers them with a consumer.
            // tags:
            //		protected

            if (this.initialized || !this.commandKey || !this.getConsumer) {
                return;
            }

            this._consumer = this.getConsumer();

            if (!this._consumer) {
                return;
            }

            this.commandRegistry = this.commandRegistry || dependency.resolve("epi.globalcommandregistry");
            this.commandProviders = this.commandRegistry.get(this.commandKey, true);
            array.forEach(this.commandProviders.providers, function (provider) {
                this._consumer.addProvider(provider);
            }, this);

            this._providerWatch = this.commandProviders.watch("providers", lang.hitch(this, this.onProvidersChanged));

            this.initialized = true;
        },

        updateCommandModel: function (model) {
            // summary:
            //		Calls the updateCommandModel method for all provider that implements it.
            // tags:
            //		public

            this._currentCommandModel = model;
            array.forEach(this.commandProviders.providers, function (provider) {
                if (provider.updateCommandModel) {
                    provider.updateCommandModel(model);
                }
            }, this);
        },

        onProvidersChanged: function (name, removed, added) {
            // summary:
            //		Adds or removes the added/removed provider from any consumers.
            // tags:
            //		public
            if (removed) {
                array.forEach(removed, this._consumer.removeProvider, this._consumer);
            }
            if (added) {
                array.forEach(added, function (item) {
                    this._consumer.addProvider(item);
                    if (item.updateCommandModel) {
                        item.updateCommandModel(this._currentCommandModel);
                    }
                }, this);
            }
        },

        destroy: function () {
            // summary:
            //		Remove the provider from any consumers.
            // tags:
            //		public

            if (this._consumer && this.commandProviders) {
                array.forEach(this.commandProviders.providers, this._consumer.removeProvider, this);
            }

            this._providerWatch && this._providerWatch.unwatch();

            this.inherited(arguments);
        }
    });
});

},
'epi/shell/command/builder/GroupedButtonBuilder':function(){
﻿define("epi/shell/command/builder/GroupedButtonBuilder", [
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",

    "epi/shell/command/_CommandModelBindingMixin",
    "epi/shell/command/builder/_Builder",

    "epi/shell/widget/ListContainer",
    "epi/shell/widget/ExpandoButton"
],

function (
    declare,
    lang,

    domClass,

    _CommandModelBindingMixin,
    _Builder,

    ListContainer,
    ExpandoButton
) {

    return declare([_Builder], {

        _create: function (/*Object*/command) {
            // tags:
            //      protected, override

            // Intermediate storage in d is intended to shake the doc parser 
            // off since it cannot resolve dynamic dependencies.
            var d = { declare: declare }; 
            var widgetPrototype = d["declare"]([command.settings.widget, _CommandModelBindingMixin]),
                widget = new widgetPrototype(lang.mixin(command.settings, this.itemSettings));

            return widget;
        },

        _addToContainer: function (/*Object*/widget, /*Object*/container) {
            // tags:
            //      protected, override

            this._createListContainer(widget, container);

            if (this._containerAdded) {
                if (widget.model) {
                    // Watch available of each child item in list in order to hide list container when its all children not visible
                    widget.model.watch("isAvailable", lang.hitch(this, function () {
                        if (this._listContainer.updateVisibility) {
                            this._listContainer.updateVisibility();
                        }
                    }));
                }
            }

            this.inherited(arguments, [widget, this._listContainer]);

            if (this._listContainer.getChildren().length > 1) {
                domClass.add(widget.getParent().domNode, "epi-leftSeparator");
            }
        },

        _createListContainer: function (/*Object*/widget, /*Object*/container) {
            // tags:
            //      private

            if (this._containerAdded) {
                return;
            }

            this._listContainer = new ListContainer(this.settings);
            this._listContainer._commandCategory = widget._commandCategory;

            if (container.addChild) {
                container.addChild(this._listContainer);
            } else {
                this._listContainer.placeAt(container);
                this._listContainer.startup();
            }

            this._containerAdded = true;
        }
    });
});
},
'url:epi-cms/component/templates/GlobalToolbar.html':"﻿<div class=\"dijit epi-globalToolbar\" role=\"toolbar\" tabIndex=\"${tabIndex}\" data-dojo-attach-point=\"containerNode\">\r\n    <div class=\"epi-toolbarGroupContainer\">\r\n        <div data-dojo-attach-point=\"leadingContainerNode\" class=\"epi-toolbarLeading epi-toolbarGroup\"></div>\r\n        <div data-dojo-attach-point=\"centerContainerNode\" class=\"epi-toolbarCenter epi-toolbarGroup\"></div>\r\n        <div data-dojo-attach-point=\"trailingContainerNode\" class=\"epi-toolbarTrailing epi-toolbarGroup\"></div>\r\n    </div>\r\n</div>",
'epi-cms/component/MainNavigationComponent':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-geometry",
    "dijit/layout/_LayoutWidget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "epi/dependency",
    "epi-cms/widget/SearchBox"
], function (
    array,
    declare,
    lang,
    domGeometry,
    _LayoutWidget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    dependency,
    PageNavigationTree,
    ContentSearchBox
) {

    // module:
    //		epi-cms/component/PageTreeComponent
    // summary:
    //		Component for displaying the navigation panel with a search area and a pluggable page selection widget.

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin], {

        // templateString: [protected] String
        //		A string that represents the widget template.
        templateString: '<div>\
                            <div data-dojo-type="epi-cms/widget/SearchBox" data-dojo-attach-point="search" class="epi-gadgetInnerToolbar"></div>\
                            <div data-dojo-attach-point="navigation" style="overflow:auto;">\
                            </div>\
                        </div>',

        contentRepositoryDescriptors: null,

        postCreate: function () {
            this.inherited(arguments);

            this.contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");
            var settings = this.contentRepositoryDescriptors[this.repositoryKey];

            var roots = this.roots ? this.roots : settings.roots;

            this.search.set("area", settings.searchArea);
            this.search.set("searchRoots", roots);

            var componentType = settings.customNavigationWidget || "epi-cms/component/ContentNavigationTree";

            require([componentType], lang.hitch(this, function (innerComponentClass) {
                var innerComponent = new innerComponentClass(
                    {
                        typeIdentifiers: settings.mainNavigationTypes ? settings.mainNavigationTypes : settings.containedTypes,
                        containedTypes: settings.containedTypes,
                        settings: settings,
                        roots: roots,
                        repositoryKey: this.repositoryKey
                    }
                );
                innerComponent.placeAt(this.navigation);
                this.tree = innerComponent;

                this.own(this.tree.watch("showAllLanguages", lang.hitch(this, function () {
                    this.search.set("filterOnCulture", !this.tree.get("showAllLanguages"));
                })));
            }));

            //TODO: Fix issue with searches returning deleted content.
        },

        layout: function () {
            // summary:
            //		Resize and layout the search box and page selector widget.
            // tags:
            //		protected

            var cb = this._contentBox,
                sb = domGeometry.getMarginBox(this.search.domNode);
            
            domGeometry.setMarginBox(this.navigation, {
                w: cb.w,
                h: cb.h - sb.h
            });
            if (this.tree) {
                this.tree.resize();
            }
        }
    });
});
},
'epi-cms/widget/SearchBox':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/connect",
    "dojo/_base/json",
    "dojo/_base/lang",

    "dojo/dom-construct",

// Dijit
    "dijit/_Widget",

// EPi Framework
    "epi/shell/SearchManager",

// EPi CMS
    "epi-cms/widget/ContentSearchBox"
],

function (
// Dojo
    declare,
    Deferred,
    connect,
    json,
    lang,

    domConstruct,

// Dijit
    _Widget,

// EPi Framework
    SearchManager,

// EPi CMS
    ContentSearchBox
) {

    return declare([_Widget], {
        // summary:
        //    A composite widget, which wrap the ContentSearchBox, for setting up the search box.
        //
        // tags:
        //    public

        // area: [protected] String
        //      Search area to search.
        area: null,

        // searchRoots: [protected] String
        //      Optional comma separated list of roots to search.
        searchRoots: null,

        // filterOnCulture: [protected] Boolean
        //      Flag to set if search results should be filtered on culture. Default value is true.
        filterOnCulture: null,

        // triggerContextChange: [public] Boolean
        //      If [true] will cause a contextChange topic to be published.
        triggerContextChange: true,

        // _searchBox: [private] ContentSearchBox
        //      Content search box widget.
        _searchBox: null,

        // _searchManager: [private] SearchManager
        //      Content search manager.
        _searchManager: null,

        postCreate: function () {
            // summary:
            //      Add and setup search box
            // tags:
            //      protected
            this.inherited(arguments);

            this._searchManager = new SearchManager();
            Deferred.when(this._searchManager.getStore(), lang.hitch(this, function (store) {
                this._searchBox = new ContentSearchBox({
                    "searchAttr": "searchQuery",
                    "store": store
                });

                var parameters = { filterOnDeleted: true };
                lang.mixin(this._searchBox.query, { parameters: json.toJson(parameters) });

                // Event onSelect of search box
                this._searchBox.on("select", lang.hitch(this, function (value) {
                    // Set blank value for textbox
                    this._searchBox.set("value", "");
                    this._searchBox.focus();
                    this._searchBox.toggleClearButton();
                    this.onItemAction(value);
                }));
                //search results show contents in all languages
                this.set("filterOnCulture", false);
                // add search box to DOM
                domConstruct.place(this._searchBox.domNode, this.domNode);
            }));
        },

        _setAreaAttr: function (value) {
            this._set("area", value);
            if (this._searchBox) {
                // get query for current search area
                Deferred.when(this._searchManager.getProviderQuery(value), lang.hitch(this, function (query) {
                    lang.mixin(this._searchBox.query, query);
                }));
            }
        },

        _setSearchRootsAttr: function (value) {
            this._set("searchRoots", value);
            if (this._searchBox) {
                lang.mixin(this._searchBox.query, { searchRoots: value });
            }
        },

        _setFilterOnCultureAttr: function (value) {
            this._set("filterOnCulture", value);
            if (this._searchBox) {
                lang.mixin(this._searchBox.query, { filterOnCulture: value });
            }
        },

        onItemAction: function (item) {
            // summary:
            //      Trigger the context change event when an item has been selected in search box.
            // tags:
            //      callback

            if (this.triggerContextChange) {
                var contextParameters = { uri: "epi.cms.contentdata:///" + item.metadata.id };
                if (item.metadata.isUntranslatedContent == "false") {
                    contextParameters.epslanguage = item.metadata.languageBranch;
                }
                connect.publish("/epi/shell/context/request", [contextParameters, { sender: null }]);
            }
        }
    });
});

},
'epi/shell/SearchManager':function(){
﻿define("epi/shell/SearchManager", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/DeferredList",
// epi
    "epi/dependency"
],
function (
// dojo
    declare,
    Deferred,
    array,
    lang,
    DeferredList,
// epi
    dependency
) {
    return declare( null, {
        // summary:
        //      Search component that provides search provider stores and search results store
        //      to make searching by conditions and take searching results.
        // tags:
        //      public

        // _providersStore: [epi.shell.searchproviders] object
        _providersStore: null,
        // _resultsStore: [epi.shell.searchresults] object
        _resultsStore: null,

        constructor: function () {
            // summary:
            //      Setup search provider stores and search results store.
            // tags:
            //      public

            this._setupStores();
        },

        getProviderQuery: function (/*string*/area) {
            // summary:
            //      Return provider query parameter(s) that used as input parameter(s) for search results store.
            // area: string
            //      The area of the search provider(s).
            //      E.g: "cms/blocks" area, will return all search provider(s) that have area is "cms/blocks".
            //          Will return all search providers if passed blank area.
            // return:
            //      Deferred object that holds provider query parameters JSON object.
            // tags:
            //      public

            var deferred = new Deferred();

            Deferred.when(this.getProviders(area), dojo.hitch(this, function (providers) {
                if (providers && providers.length > 0) {
                    deferred.resolve(this._getQuery(providers[0], {}));
                } else {
                    deferred.resolve();
                }
            }));

            return deferred;
        },

        getProviders: function (/*string*/area) {
            // summary:
            //      Return all search provider in the given area.
            //      If passed blank value will return all providers.
            // area: string
            //      The area that search provider(s) belong to.
            // return:
            //      Deferred object that holds an array of search provider objects.
            // tags:
            //      public

            var deferred = new Deferred();

            Deferred.when(this._providersStore.query({ searchArea: area }), function (providers) {
                if (providers && providers.length > 0) {
                    deferred.resolve(providers);
                } else {
                    deferred.resolve();
                }
            });

            return deferred;
        },

        getStore: function () {
            // summary:
            //      Return search results store object.
            // tags:
            //      public

            return this._resultsStore;
        },

        search: function (/*string*/area, /*object*/queryParams) {
            // summary:
            //      Get all results from search results by passing search provider area and query parameter(s).
            // area: string
            //      The area that search provider(s) belong to.
            // queryParams: JSON object
            //      Query that used to search.
            // return:
            //      Deferred object that contains an array of search result data items.
            // tags:
            //      public

            var deferred = new Deferred();

            // Get all search provider stores from search providers store
            Deferred.when(this.getProviders(area), lang.hitch(this, function (providers) {
                if (providers && providers.length > 0) {
                    var deferredArray = [];

                    // Query each search provider store to get its results
                    array.forEach(providers, function (provider, index) {
                        deferredArray.push(this._getData(provider, queryParams));
                    }, this);

                    var deferredList = new DeferredList(deferredArray),
                        data = [];

                    // Put all data together
                    deferredList.then(function (items) {
                        array.forEach(items, function (item) {
                            if (lang.isArray(item[1])) {
                                data = data.concat(item[1]);
                            }
                        });
                        deferred.resolve(data);
                    });
                }
            }));

            return deferred;
        },

        _setupStores: function () {
            // summary:
            //      Get search providers store and search results store from registry.
            // tags:
            //      private

            var registry = dependency.resolve("epi.storeregistry");
            this._providersStore = registry.get("epi.shell.searchproviders");
            this._resultsStore = registry.get("epi.shell.searchresults");
        },

        _getQuery: function (/*object*/provider, /*object*/queryParams) {
            // summary:
            //      Build search query.
            // provider: object
            //      Search provider store object.
            // queryParams: JSON object
            //      Query that used to search.
            // return:
            //      Query JSON object.
            // tags:
            //      private

            var query = { providerId: provider.id };

            lang.mixin(query, queryParams || {});

            return query;
        },

        _getData: function (/*object*/provider, /*object*/queryParams) {
            // summary:
            //      Get search results from search results store by the given search provider and query.
            // provider: object
            //      Search provider store object.
            // queryParams: JSON object
            //      Query that used to search.
            // return:
            //      Deferred object that contains an array of search result items.
            // tags:
            //      private

            var deferred = new Deferred();

            // Query by search results store
            Deferred.when(this._resultsStore.query(this._getQuery(provider, queryParams)), function (items) {
                if (items && items.length > 0) {
                    deferred.resolve(items);
                } else {
                    deferred.resolve();
                }
            });

            return deferred;
        }
    });
});
},
'epi-cms/widget/ContentSearchBox':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/event",

    "dojo/aspect",
    "dojo/Evented",
    "dojo/keys",

    "dojo/dom-attr",
    "dojo/dom-style",
// EPi Framework
    "epi/shell/widget/SuggestionBox",
    "epi-cms/widget/SearchResultList",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentlist"
],

function (
// Dojo
    declare,
    lang,
    event,

    aspect,
    Evented,
    keys,

    domAttr,
    domStyle,
// EPi Framework
    SuggestionBox,
    SearchResultList,

// Resources
    resources
) {

    return declare([SuggestionBox, Evented], {
        // summary:
        //    A Search box to search for content.
        //
        // tags:
        //    public

        // res: Object
        //      Resource object, for getting text.
        //  tags:
        //      Protected
        res: resources,

        // autoComplete: Boolean
        //      If user types in a partial string, and then tab out of the `<input>` box,
        //      automatically copy the first entry displayed in the drop down list to
        //      the `<input>` field
        autoComplete: false,

        // dropDownClass: [protected extension] Function String
        //      Dropdown widget class, which would be used to create a widget, to show the search result.
        //      Subclasses should specify this.
        dropDownClass: SearchResultList,

        // queryExpr: String
        //      This specifies what query ComboBox/FilteringSelect sends to the data store,
        //      based on what the user has typed.  Changing this expression will modify
        //      whether the drop down shows only exact matches, a "starting with" match,
        //      etc.  Use it in conjunction with highlightMatch.
        //      dojo.data query expression pattern.
        //      `${0}` will be substituted for the user text.
        //      `*` is used for wildcards.
        //      `${0}*` means "starts with", `*${0}*` means "contains", `${0}` means "is"
        queryExpr: "${0}",

        // minimumNumberOfChar: Integer
        //      The minimum number of character that is valid for search.
        //  tags:
        //      Protected
        minimumNumberOfChar: 1,

        postCreate: function () {
            // summary: Override to:
            //      - mixin additional query params into query before _startSearch
            //      - connect to onSelect event of dropDown, to forward it to ContentSearchBox after _startSearch
            // tags:
            //      protected
            this.inherited(arguments);

            // Delay in milliseconds between when user types something and we start
            // searching based on that value.
            this.searchDelay = this.defaultDelay;
            this.on("beforeSearch", lang.hitch(this, function () {
                // display dropdown with standby
                if (this.dropDown) {
                    this.dropDown.showStandby(true);
                }
            }));

            this.on("searchComplete", lang.hitch(this, function (results) {
                // hide dropdown's standby
                if (this.dropDown) {
                    this.dropDown.showStandby(false);
                }
            }));

            aspect.before(this, "_startSearch", function (method, args) {
                // doing something before the original call
                this.emit("beforeSearch", {});

                return [method, args];
            });
        },

        _openResultList: function (/*Object*/results, /*Object*/query, /*Object*/options) {
            // summary:
            //		Callback when a search completes.
            // description:
            //		Generates drop-down list and calls _showResultList() to display it

            this.emit("searchComplete", results);

            this._fetchHandle = null;
            this.dropDown.clearResultList();

            var dataAvailable = results.length > 0 || options.start !== 0;
            // display the empty text if data is not available
            this.dropDown.showErrorMessage(!dataAvailable, this.res.contentnotfound);
            this.dropDown.showGrid(dataAvailable);

            if (dataAvailable) {
                this.dropDown.createOptions(results, options, lang.hitch(this, "_getMenuLabelFromItem"));
            }

            // show our list
            this._showResultList();
        },

        _onDropDownMouseDown: function (/*Event*/e) {
            // summary:
            //		Callback when the user mousedown's on the arrow icon.
            //  tags:
            //      Private, override

            // Do nothing, to prevent start search on click to textbox

            // Enable mouse clickable when pinnable pane in un-pinned state.
            e.stopPropagation();
        },

        _onKey: function (/*Event*/evt) {
            // summary:
            //		Listen for Enter key, to start search request.
            // tags:
            //      private, override

            switch (evt.keyCode) {
                case keys.ENTER:
                    if (this.dropDown && this.dropDown.selected) {
                        this.dropDown.handleKey(evt);
                        this.closeDropDown();
                    } else if(!this._fetchHandle) {
                        this._startSearchFromInput();
                        event.stop(evt);
                    }
                    break;
                case keys.PAGE_DOWN:
                case keys.DOWN_ARROW:
                case keys.PAGE_UP:
                case keys.UP_ARROW:
                    // let the dropdown handle these keystrokes for navigating between item
                    if (this.dropDown) {
                        this.dropDown.handleKey(evt);
                    }
                    event.stop(evt);
                    break;
                case keys.LEFT_ARROW:
                case keys.RIGHT_ARROW:
                    // do nothing when navigating, selecting text
                    break;
                default:
                    this.inherited(arguments);
            }
        },

        _startSearchFromInput: function () {
            // summary:
            //      Start the search action
            // tags:
            //      private, override

            var key = this.focusNode.value;

            // start the search action only if input text length is more than minimum number
            if (!key || key.length < this.minimumNumberOfChar) {
                this.closeDropDown();
                return;
            }

            if (!this.dropDown) {
                var popupId = this.id + "_popup",
                    dropDownConstructor = lang.isString(this.dropDownClass) ? lang.getObject(this.dropDownClass, false) : this.dropDownClass;

                this.dropDown = new dropDownConstructor({
                    id: popupId,
                    dir: this.dir,
                    textDir: this.textDir
                });

                domAttr.remove(this.textbox, "aria-activedescendant");
                domAttr.set(this.textbox, "area-owns", popupId); // associate popup with textbox

                this.dropDown.on("select", lang.hitch(this, function (value) {
                    this.closeDropDown();
                    this.emit("select", value);
                }));

                // Set dropdown width belong to input text width
                domStyle.set(this.dropDown.domNode, "width", this.textbox.clientWidth + "px");
            }
            this._showResultList();
            var isError = key.replace(new RegExp("\\W+"), "").length === 0;

            // Check if have only special characters then show error message.
            this.dropDown.showErrorMessage(isError, this.res.notsearchspecialcharacter);

            if (!isError) {
                // We do not want to call the inherited method here since it will escape wild card characters (* and ?),
                // which will break any searches with wild card.
                this._startSearch(key);
            }
        },

        _startSearchAll: function () {
            // disable search with empty string
        }
    });
});
},
'epi/shell/widget/SuggestionBox':function(){
﻿define("epi/shell/widget/SuggestionBox", [
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-attr",

// Dijit
    "dijit/_HasDropDown",
    "dijit/form/_ComboBoxMenu",
    "dijit/form/_AutoCompleterMixin",

// EPi Framework
    "epi/shell/widget/SearchBox"
],

function (
// Dojo
    declare,
    lang,

    domAttr,

// Dijit
    _HasDropDown,
    _ComboBoxMenu,
    _AutoCompleterMixin,

// EPi Framework
    SearchBox
) {

    return declare([SearchBox, _HasDropDown, _AutoCompleterMixin], {
        // summary:
        //    A suggestion box, which will drop a list down when user input a string to a textbox to filter item in a pre-defined list.
        //
        // tags:
        //    public

        // dropDownClass: [protected extension] Function String
        //      Dropdown widget class, which would be used to create a widget, to show the search result.
        //      Subclasses should specify this.
        dropDownClass: _ComboBoxMenu,

        buildRendering: function () {
            this.inherited(arguments);

            domAttr.set(this.textbox, "autocomplete", "off");
            domAttr.set(this.textbox, "aria-haspopup", "true");
        },

        postCreate: function () {
            // summary:
            //      Post widget creation. Initialize event for buttons
            // tags:
            //      Protected

            this.inherited(arguments);

            // clear textbox value when clicking on clear button
            this.connect(this.clearButton, "onclick", lang.hitch(this, function () {
                this.closeDropDown();
            }));
        }
    });
});
},
'dijit/form/_ComboBoxMenu':function(){
define("dijit/form/_ComboBoxMenu", [
	"dojo/_base/declare", // declare
	"dojo/dom-class", // domClass.add domClass.remove
	"dojo/dom-style", // domStyle.get
	"dojo/keys", // keys.DOWN_ARROW keys.PAGE_DOWN keys.PAGE_UP keys.UP_ARROW
	"../_WidgetBase",
	"../_TemplatedMixin",
	"./_ComboBoxMenuMixin",
	"./_ListMouseMixin"
], function(declare, domClass, domStyle, keys,
			_WidgetBase, _TemplatedMixin, _ComboBoxMenuMixin, _ListMouseMixin){


	// module:
	//		dijit/form/_ComboBoxMenu

	return declare("dijit.form._ComboBoxMenu",[_WidgetBase, _TemplatedMixin, _ListMouseMixin, _ComboBoxMenuMixin], {
		// summary:
		//		Focus-less menu for internal use in `dijit/form/ComboBox`
		//		Abstract methods that must be defined externally:
		//
		//		- onChange: item was explicitly chosen (mousedown somewhere on the menu and mouseup somewhere on the menu)
		//		- onPage: next(1) or previous(-1) button pressed
		// tags:
		//		private

		templateString: "<div class='dijitReset dijitMenu' data-dojo-attach-point='containerNode' style='overflow: auto; overflow-x: hidden;' role='listbox'>"
				+"<div class='dijitMenuItem dijitMenuPreviousButton' data-dojo-attach-point='previousButton' role='option'></div>"
				+"<div class='dijitMenuItem dijitMenuNextButton' data-dojo-attach-point='nextButton' role='option'></div>"
				+"</div>",

		baseClass: "dijitComboBoxMenu",

		postCreate: function(){
			this.inherited(arguments);
			if(!this.isLeftToRight()){
				domClass.add(this.previousButton, "dijitMenuItemRtl");
				domClass.add(this.nextButton, "dijitMenuItemRtl");
			}
		},

		_createMenuItem: function(){
			// note: not using domConstruct.create() because need to specify document
			var item = this.ownerDocument.createElement("div");
			item.className = "dijitReset dijitMenuItem" +(this.isLeftToRight() ? "" : " dijitMenuItemRtl");
			item.setAttribute("role", "option");
			return item;
		},

		onHover: function(/*DomNode*/ node){
			// summary:
			//		Add hover CSS
			domClass.add(node, "dijitMenuItemHover");
		},

		onUnhover: function(/*DomNode*/ node){
			// summary:
			//		Remove hover CSS
			domClass.remove(node, "dijitMenuItemHover");
		},

		onSelect: function(/*DomNode*/ node){
			// summary:
			//		Add selected CSS
			domClass.add(node, "dijitMenuItemSelected");
		},

		onDeselect: function(/*DomNode*/ node){
			// summary:
			//		Remove selected CSS
			domClass.remove(node, "dijitMenuItemSelected");
		},

		_page: function(/*Boolean*/ up){
			// summary:
			//		Handles page-up and page-down keypresses

			var scrollamount = 0;
			var oldscroll = this.domNode.scrollTop;
			var height = domStyle.get(this.domNode, "height");
			// if no item is highlighted, highlight the first option
			if(!this.getHighlightedOption()){
				this.selectNextNode();
			}
			while(scrollamount<height){
				var highlighted_option = this.getHighlightedOption();
				if(up){
					// stop at option 1
					if(!highlighted_option.previousSibling ||
						highlighted_option.previousSibling.style.display == "none"){
						break;
					}
					this.selectPreviousNode();
				}else{
					// stop at last option
					if(!highlighted_option.nextSibling ||
						highlighted_option.nextSibling.style.display == "none"){
						break;
					}
					this.selectNextNode();
				}
				// going backwards
				var newscroll = this.domNode.scrollTop;
				scrollamount += (newscroll-oldscroll)*(up ? -1:1);
				oldscroll = newscroll;
			}
		},

		handleKey: function(evt){
			// summary:
			//		Handle keystroke event forwarded from ComboBox, returning false if it's
			//		a keystroke I recognize and process, true otherwise.
			switch(evt.keyCode){
				case keys.DOWN_ARROW:
					this.selectNextNode();
					return false;
				case keys.PAGE_DOWN:
					this._page(false);
					return false;
				case keys.UP_ARROW:
					this.selectPreviousNode();
					return false;
				case keys.PAGE_UP:
					this._page(true);
					return false;
				default:
					return true;
			}
		}
	});
});

},
'dijit/form/_ComboBoxMenuMixin':function(){
define("dijit/form/_ComboBoxMenuMixin", [
	"dojo/_base/array", // array.forEach
	"dojo/_base/declare", // declare
	"dojo/dom-attr", // domAttr.set
	"dojo/i18n", // i18n.getLocalization
	"dojo/i18n!./nls/ComboBox"
], function(array, declare, domAttr, i18n){

// module:
//		dijit/form/_ComboBoxMenuMixin

return declare( "dijit.form._ComboBoxMenuMixin", null, {
	// summary:
	//		Focus-less menu for internal use in `dijit/form/ComboBox`
	// tags:
	//		private

	// _messages: Object
	//		Holds "next" and "previous" text for paging buttons on drop down
	_messages: null,

	postMixInProperties: function(){
		this.inherited(arguments);
		this._messages = i18n.getLocalization("dijit.form", "ComboBox", this.lang);
	},

	buildRendering: function(){
		this.inherited(arguments);

		// fill in template with i18n messages
		this.previousButton.innerHTML = this._messages["previousMessage"];
		this.nextButton.innerHTML = this._messages["nextMessage"];
	},

	_setValueAttr: function(/*Object*/ value){
		this.value = value;
		this.onChange(value);
	},

	onClick: function(/*DomNode*/ node){
		if(node == this.previousButton){
			this._setSelectedAttr(null);
			this.onPage(-1);
		}else if(node == this.nextButton){
			this._setSelectedAttr(null);
			this.onPage(1);
		}else{
			this.onChange(node);
		}
	},

	// stubs
	onChange: function(/*Number*/ /*===== direction =====*/){
		// summary:
		//		Notifies ComboBox/FilteringSelect that user selected an option.
		// tags:
		//		callback
	},

	onPage: function(/*Number*/ /*===== direction =====*/){
		// summary:
		//		Notifies ComboBox/FilteringSelect that user clicked to advance to next/previous page.
		// tags:
		//		callback
	},

	onClose: function(){
		// summary:
		//		Callback from dijit.popup code to this widget, notifying it that it closed
		// tags:
		//		private
		this._setSelectedAttr(null);
	},

	_createOption: function(/*Object*/ item, labelFunc){
		// summary:
		//		Creates an option to appear on the popup menu subclassed by
		//		`dijit/form/FilteringSelect`.

		var menuitem = this._createMenuItem();
		var labelObject = labelFunc(item);
		if(labelObject.html){
			menuitem.innerHTML = labelObject.label;
		}else{
			menuitem.appendChild(
				menuitem.ownerDocument.createTextNode(labelObject.label)
			);
		}
		// #3250: in blank options, assign a normal height
		if(menuitem.innerHTML == ""){
			menuitem.innerHTML = "&#160;";	// &nbsp;
		}

		// update menuitem.dir if BidiSupport was required
		this.applyTextDir(menuitem, (menuitem.innerText || menuitem.textContent || ""));

		return menuitem;
	},

	createOptions: function(results, options, labelFunc){
		// summary:
		//		Fills in the items in the drop down list
		// results:
		//		Array of items
		// options:
		//		The options to the query function of the store
		//
		// labelFunc:
		//		Function to produce a label in the drop down list from a dojo.data item

		this.items = results;

		// display "Previous . . ." button
		this.previousButton.style.display = (options.start == 0) ? "none" : "";
		domAttr.set(this.previousButton, "id", this.id + "_prev");
		// create options using _createOption function defined by parent
		// ComboBox (or FilteringSelect) class
		// #2309:
		//		iterate over cache nondestructively
		array.forEach(results, function(item, i){
			var menuitem = this._createOption(item, labelFunc);
			menuitem.setAttribute("item", i);	// index to this.items; use indirection to avoid mem leak
			domAttr.set(menuitem, "id", this.id + i);
			this.nextButton.parentNode.insertBefore(menuitem, this.nextButton);
		}, this);
		// display "Next . . ." button
		var displayMore = false;
		// Try to determine if we should show 'more'...
		if(results.total && !results.total.then && results.total != -1){
			if((options.start + options.count) < results.total){
				displayMore = true;
			}else if((options.start + options.count) > results.total && options.count == results.length){
				// Weird return from a data store, where a start + count > maxOptions
				// implies maxOptions isn't really valid and we have to go into faking it.
				// And more or less assume more if count == results.length
				displayMore = true;
			}
		}else if(options.count == results.length){
			//Don't know the size, so we do the best we can based off count alone.
			//So, if we have an exact match to count, assume more.
			displayMore = true;
		}

		this.nextButton.style.display = displayMore ? "" : "none";
		domAttr.set(this.nextButton,"id", this.id + "_next");
	},

	clearResultList: function(){
		// summary:
		//		Clears the entries in the drop down list, but of course keeps the previous and next buttons.
		var container = this.containerNode;
		while(container.childNodes.length > 2){
			container.removeChild(container.childNodes[container.childNodes.length-2]);
		}
		this._setSelectedAttr(null);
	},

	highlightFirstOption: function(){
		// summary:
		//		Highlight the first real item in the list (not Previous Choices).
		this.selectFirstNode();
	},

	highlightLastOption: function(){
		// summary:
		//		Highlight the last real item in the list (not More Choices).
		this.selectLastNode();
	},

	selectFirstNode: function(){
		this.inherited(arguments);
		if(this.getHighlightedOption() == this.previousButton){
			this.selectNextNode();
		}
	},

	selectLastNode: function(){
		this.inherited(arguments);
		if(this.getHighlightedOption() == this.nextButton){
			this.selectPreviousNode();
		}
	},

	getHighlightedOption: function(){
		return this.selected;
	}
});

});

},
'dijit/form/_ListMouseMixin':function(){
define("dijit/form/_ListMouseMixin", [
	"dojo/_base/declare", // declare
	"dojo/mouse",
	"dojo/on",
	"dojo/touch",
	"./_ListBase"
], function(declare, mouse, on, touch, _ListBase){

// module:
//		dijit/form/_ListMouseMixin

return declare( "dijit.form._ListMouseMixin", _ListBase, {
	// summary:
	//		a Mixin to handle mouse or touch events for a focus-less menu
	//		Abstract methods that must be defined externally:
	//
	//		- onClick: item was chosen (mousedown somewhere on the menu and mouseup somewhere on the menu)
	// tags:
	//		private

	postCreate: function(){
		this.inherited(arguments);

		this.own(on(this.domNode, touch.press, function(evt){ evt.preventDefault(); })); // prevent focus shift on list scrollbar press

		this._listConnect(touch.press, "_onMouseDown");
		this._listConnect(touch.release, "_onMouseUp");
		this._listConnect(mouse.enter, "_onMouseOver");
		this._listConnect(mouse.leave, "_onMouseOut");
	},

	_onMouseDown: function(/*Event*/ evt, /*DomNode*/ target){
		if(this._hoveredNode){
			this.onUnhover(this._hoveredNode);
			this._hoveredNode = null;
		}
		this._isDragging = true;
		this._setSelectedAttr(target);
	},

	_onMouseUp: function(/*Event*/ evt, /*DomNode*/ target){
		this._isDragging = false;
		var selectedNode = this.selected;
		var hoveredNode = this._hoveredNode;
		if(selectedNode && target == selectedNode){
			this.onClick(selectedNode);
		}else if(hoveredNode && target == hoveredNode){ // drag to select
			this._setSelectedAttr(hoveredNode);
			this.onClick(hoveredNode);
		}
	},

	_onMouseOut: function(/*Event*/ evt, /*DomNode*/ target){
		if(this._hoveredNode){
			this.onUnhover(this._hoveredNode);
			this._hoveredNode = null;
		}
		if(this._isDragging){
			this._cancelDrag = (new Date()).getTime() + 1000; // cancel in 1 second if no _onMouseOver fires
		}
	},

	_onMouseOver: function(/*Event*/ evt, /*DomNode*/ target){
		if(this._cancelDrag){
			var time = (new Date()).getTime();
			if(time > this._cancelDrag){
				this._isDragging = false;
			}
			this._cancelDrag = null;
		}
		this._hoveredNode = target;
		this.onHover(target);
		if(this._isDragging){
			this._setSelectedAttr(target);
		}
	}
});

});

},
'dijit/form/_ListBase':function(){
define("dijit/form/_ListBase", [
	"dojo/_base/declare",	// declare
	"dojo/on",
	"dojo/window" // winUtils.scrollIntoView
], function(declare, on, winUtils){

// module:
//		dijit/form/_ListBase

return declare( "dijit.form._ListBase", null, {
	// summary:
	//		Focus-less menu to handle UI events consistently
	//		Abstract methods that must be defined externally:
	//
	//		- onSelect: item is active (mousedown but not yet mouseup, or keyboard arrow selected but no Enter)
	//		- onDeselect:  cancels onSelect
	// tags:
	//		private

	// selected: DOMNode
	//		currently selected node
	selected: null,

	_listConnect: function(/*String|Function*/ eventType, /*String*/ callbackFuncName){
		// summary:
		//		Connects 'containerNode' to specified method of this object
		//		and automatically registers for 'disconnect' on widget destroy.
		// description:
		//		Provide widget-specific analog to 'connect'.
		//		The callback function is called with the normal event object,
		//		but also a second parameter is passed that indicates which list item
		//		actually received the event.
		// returns:
		//		A handle that can be passed to `disconnect` in order to disconnect
		//		before the widget is destroyed.
		// tags:
		//		private

		var self = this;
		return self.own(on(self.containerNode,
			on.selector(
				function(eventTarget, selector, target){
					return eventTarget.parentNode == target;
				},
				eventType
			),
			function(evt){
				evt.preventDefault();
				self[callbackFuncName](evt, this);
			}
		));
	},

	selectFirstNode: function(){
		// summary:
		//		Select the first displayed item in the list.
		var first = this.containerNode.firstChild;
		while(first && first.style.display == "none"){
			first = first.nextSibling;
		}
		this._setSelectedAttr(first);
	},

	selectLastNode: function(){
		// summary:
		//		Select the last displayed item in the list
		var last = this.containerNode.lastChild;
		while(last && last.style.display == "none"){
			last = last.previousSibling;
		}
		this._setSelectedAttr(last);
	},

	selectNextNode: function(){
		// summary:
		//		Select the item just below the current selection.
		//		If nothing selected, select first node.
		var selectedNode = this.selected;
		if(!selectedNode){
			this.selectFirstNode();
		}else{
			var next = selectedNode.nextSibling;
			while(next && next.style.display == "none"){
				next = next.nextSibling;
			}
			if(!next){
				this.selectFirstNode();
			}else{
				this._setSelectedAttr(next);
			}
		}
	},

	selectPreviousNode: function(){
		// summary:
		//		Select the item just above the current selection.
		//		If nothing selected, select last node (if
		//		you select Previous and try to keep scrolling up the list).
		var selectedNode = this.selected;
		if(!selectedNode){
			this.selectLastNode();
		}else{
			var prev = selectedNode.previousSibling;
			while(prev && prev.style.display == "none"){
				prev = prev.previousSibling;
			}
			if(!prev){
				this.selectLastNode();
			}else{
				this._setSelectedAttr(prev);
			}
		}
	},

	_setSelectedAttr: function(/*DomNode*/ node){
		// summary:
		//		Does the actual select.
		if(this.selected != node){
			var selectedNode = this.selected;
			if(selectedNode){
				this.onDeselect(selectedNode);
				this.selected = null;
			}
			if(node){
				this.selected = node;
				winUtils.scrollIntoView(node);
				this.onSelect(node);
			}
		}else if(node){
			this.onSelect(node);
		}
	}
});

});

},
'dijit/form/_AutoCompleterMixin':function(){
define("dijit/form/_AutoCompleterMixin", [
	"dojo/data/util/filter", // patternToRegExp
	"dojo/_base/declare", // declare
	"dojo/dom-attr", // domAttr.get
	"dojo/_base/event", // event.stop
	"dojo/keys",
	"dojo/_base/lang", // lang.clone lang.hitch
	"dojo/query", // query
	"dojo/regexp", // regexp.escapeString
	"dojo/sniff", // has("ie")
	"dojo/string", // string.substitute
	"./DataList",
	"../registry",	// registry.byId
	"./_TextBoxMixin",	// defines _TextBoxMixin.selectInputText
	"./_SearchMixin"
], function(filter, declare, domAttr, event, keys, lang, query, regexp, has, string,
			DataList, registry, _TextBoxMixin, SearchMixin){

	// module:
	//		dijit/form/_AutoCompleterMixin

	return declare("dijit.form._AutoCompleterMixin", SearchMixin, {
		// summary:
		//		A mixin that implements the base functionality for `dijit/form/ComboBox`/`dijit/form/FilteringSelect`
		// description:
		//		All widgets that mix in dijit/form/_AutoCompleterMixin must extend `dijit/form/_FormValueWidget`.
		// tags:
		//		protected

		// item: Object
		//		This is the item returned by the dojo/store/api/Store implementation that
		//		provides the data for this ComboBox, it's the currently selected item.
		item: null,

		// autoComplete: Boolean
		//		If user types in a partial string, and then tab out of the `<input>` box,
		//		automatically copy the first entry displayed in the drop down list to
		//		the `<input>` field
		autoComplete: true,

		// highlightMatch: String
		//		One of: "first", "all" or "none".
		//
		//		If the ComboBox/FilteringSelect opens with the search results and the searched
		//		string can be found, it will be highlighted.  If set to "all"
		//		then will probably want to change `queryExpr` parameter to '*${0}*'
		//
		//		Highlighting is only performed when `labelType` is "text", so as to not
		//		interfere with any HTML markup an HTML label might contain.
		highlightMatch: "first",

		// labelAttr: String?
		//		The entries in the drop down list come from this attribute in the
		//		dojo.data items.
		//		If not specified, the searchAttr attribute is used instead.
		labelAttr: "",

		// labelType: String
		//		Specifies how to interpret the labelAttr in the data store items.
		//		Can be "html" or "text".
		labelType: "text",

		// Flags to _HasDropDown to limit height of drop down to make it fit in viewport
		maxHeight: -1,

		// For backwards compatibility let onClick events propagate, even clicks on the down arrow button
		_stopClickEvents: false,

		_getCaretPos: function(/*DomNode*/ element){
			// khtml 3.5.2 has selection* methods as does webkit nightlies from 2005-06-22
			var pos = 0;
			if(typeof(element.selectionStart) == "number"){
				// FIXME: this is totally borked on Moz < 1.3. Any recourse?
				pos = element.selectionStart;
			}else if(has("ie")){
				// in the case of a mouse click in a popup being handled,
				// then the win.doc.selection is not the textarea, but the popup
				// var r = win.doc.selection.createRange();
				// hack to get IE 6 to play nice. What a POS browser.
				var tr = element.ownerDocument.selection.createRange().duplicate();
				var ntr = element.createTextRange();
				tr.move("character",0);
				ntr.move("character",0);
				try{
					// If control doesn't have focus, you get an exception.
					// Seems to happen on reverse-tab, but can also happen on tab (seems to be a race condition - only happens sometimes).
					// There appears to be no workaround for this - googled for quite a while.
					ntr.setEndPoint("EndToEnd", tr);
					pos = String(ntr.text).replace(/\r/g,"").length;
				}catch(e){
					// If focus has shifted, 0 is fine for caret pos.
				}
			}
			return pos;
		},

		_setCaretPos: function(/*DomNode*/ element, /*Number*/ location){
			location = parseInt(location);
			_TextBoxMixin.selectInputText(element, location, location);
		},

		_setDisabledAttr: function(/*Boolean*/ value){
			// Additional code to set disabled state of ComboBox node.
			// Overrides _FormValueWidget._setDisabledAttr() or ValidationTextBox._setDisabledAttr().
			this.inherited(arguments);
			this.domNode.setAttribute("aria-disabled", value ? "true" : "false");
		},

		_onKey: function(/*Event*/ evt){
			// summary:
			//		Handles keyboard events

			if(evt.charCode >= 32){ return; } // alphanumeric reserved for searching

			var key = evt.charCode || evt.keyCode;

			// except for cutting/pasting case - ctrl + x/v
			if(key == keys.ALT || key == keys.CTRL || key == keys.META || key == keys.SHIFT){
				return; // throw out spurious events
			}

			var pw = this.dropDown;
			var highlighted = null;
			this._abortQuery();

			// _HasDropDown will do some of the work:
			//
			//	1. when drop down is not yet shown:
			//		- if user presses the down arrow key, call loadDropDown()
			//	2. when drop down is already displayed:
			//		- on ESC key, call closeDropDown()
			//		- otherwise, call dropDown.handleKey() to process the keystroke
			this.inherited(arguments);

			if(evt.altKey || evt.ctrlKey || evt.metaKey){ return; } // don't process keys with modifiers  - but we want shift+TAB

			if(this._opened){
				highlighted = pw.getHighlightedOption();
			}
			switch(key){
				case keys.PAGE_DOWN:
				case keys.DOWN_ARROW:
				case keys.PAGE_UP:
				case keys.UP_ARROW:
					// Keystroke caused ComboBox_menu to move to a different item.
					// Copy new item to <input> box.
					if(this._opened){
						this._announceOption(highlighted);
					}
					event.stop(evt);
					break;

				case keys.ENTER:
					// prevent submitting form if user presses enter. Also
					// prevent accepting the value if either Next or Previous
					// are selected
					if(highlighted){
						// only stop event on prev/next
						if(highlighted == pw.nextButton){
							this._nextSearch(1);
							event.stop(evt); // prevent submit
							break;
						}else if(highlighted == pw.previousButton){
							this._nextSearch(-1);
							event.stop(evt); // prevent submit
							break;
						}
						event.stop(evt); // prevent submit if ENTER was to choose an item
					}else{
						// Update 'value' (ex: KY) according to currently displayed text
						this._setBlurValue(); // set value if needed
						this._setCaretPos(this.focusNode, this.focusNode.value.length); // move cursor to end and cancel highlighting
					}
					// fall through

				case keys.TAB:
					var newvalue = this.get('displayedValue');
					//	if the user had More Choices selected fall into the
					//	_onBlur handler
					if(pw && (
						newvalue == pw._messages["previousMessage"] ||
						newvalue == pw._messages["nextMessage"])
					){
						break;
					}
					if(highlighted){
						this._selectOption(highlighted);
					}
					// fall through

				case keys.ESCAPE:
					if(this._opened){
						this._lastQuery = null; // in case results come back later
						this.closeDropDown();
					}
					break;
			}
		},

		_autoCompleteText: function(/*String*/ text){
			// summary:
			//		Fill in the textbox with the first item from the drop down
			//		list, and highlight the characters that were
			//		auto-completed. For example, if user typed "CA" and the
			//		drop down list appeared, the textbox would be changed to
			//		"California" and "ifornia" would be highlighted.

			var fn = this.focusNode;

			// IE7: clear selection so next highlight works all the time
			_TextBoxMixin.selectInputText(fn, fn.value.length);
			// does text autoComplete the value in the textbox?
			var caseFilter = this.ignoreCase? 'toLowerCase' : 'substr';
			if(text[caseFilter](0).indexOf(this.focusNode.value[caseFilter](0)) == 0){
				var cpos = this.autoComplete ? this._getCaretPos(fn) : fn.value.length;
				// only try to extend if we added the last character at the end of the input
				if((cpos+1) > fn.value.length){
					// only add to input node as we would overwrite Capitalisation of chars
					// actually, that is ok
					fn.value = text;//.substr(cpos);
					// visually highlight the autocompleted characters
					_TextBoxMixin.selectInputText(fn, cpos);
				}
			}else{
				// text does not autoComplete; replace the whole value and highlight
				fn.value = text;
				_TextBoxMixin.selectInputText(fn);
			}
		},

		_openResultList: function(/*Object*/ results, /*Object*/ query, /*Object*/ options){
			// summary:
			//		Callback when a search completes.
			// description:
			//		1. generates drop-down list and calls _showResultList() to display it
			//		2. if this result list is from user pressing "more choices"/"previous choices"
			//			then tell screen reader to announce new option
			var wasSelected = this.dropDown.getHighlightedOption();
			this.dropDown.clearResultList();
			if(!results.length && options.start == 0){ // if no results and not just the previous choices button
				this.closeDropDown();
				return;
			}
			this._nextSearch = this.dropDown.onPage = lang.hitch(this, function(direction){
				results.nextPage(direction !== -1);
				this.focus();
			});

			// Fill in the textbox with the first item from the drop down list,
			// and highlight the characters that were auto-completed. For
			// example, if user typed "CA" and the drop down list appeared, the
			// textbox would be changed to "California" and "ifornia" would be
			// highlighted.

			this.dropDown.createOptions(
				results,
				options,
				lang.hitch(this, "_getMenuLabelFromItem")
			);

			// show our list (only if we have content, else nothing)
			this._showResultList();

			// #4091:
			//		tell the screen reader that the paging callback finished by
			//		shouting the next choice
			if("direction" in options){
				if(options.direction){
					this.dropDown.highlightFirstOption();
				}else if(!options.direction){
					this.dropDown.highlightLastOption();
				}
				if(wasSelected){
					this._announceOption(this.dropDown.getHighlightedOption());
				}
			}else if(this.autoComplete && !this._prev_key_backspace
				// when the user clicks the arrow button to show the full list,
				// startSearch looks for "*".
				// it does not make sense to autocomplete
				// if they are just previewing the options available.
				&& !/^[*]+$/.test(query[this.searchAttr].toString())){
					this._announceOption(this.dropDown.containerNode.firstChild.nextSibling); // 1st real item
			}
		},

		_showResultList: function(){
			// summary:
			//		Display the drop down if not already displayed, or if it is displayed, then
			//		reposition it if necessary (reposition may be necessary if drop down's height changed).
			this.closeDropDown(true);
			this.openDropDown();
			this.domNode.setAttribute("aria-expanded", "true");
		},

		loadDropDown: function(/*Function*/ /*===== callback =====*/){
			// Overrides _HasDropDown.loadDropDown().
			// This is called when user has pressed button icon or pressed the down arrow key
			// to open the drop down.
			this._startSearchAll();
		},

		isLoaded: function(){
			// signal to _HasDropDown that it needs to call loadDropDown() to load the
			// drop down asynchronously before displaying it
			return false;
		},

		closeDropDown: function(){
			// Overrides _HasDropDown.closeDropDown().  Closes the drop down (assuming that it's open).
			// This method is the callback when the user types ESC or clicking
			// the button icon while the drop down is open.  It's also called by other code.
			this._abortQuery();
			if(this._opened){
				this.inherited(arguments);
				this.domNode.setAttribute("aria-expanded", "false");
				this.focusNode.removeAttribute("aria-activedescendant");
			}
		},

		_setBlurValue: function(){
			// if the user clicks away from the textbox OR tabs away, set the
			// value to the textbox value
			// #4617:
			//		if value is now more choices or previous choices, revert
			//		the value
			var newvalue = this.get('displayedValue');
			var pw = this.dropDown;
			if(pw && (
				newvalue == pw._messages["previousMessage"] ||
				newvalue == pw._messages["nextMessage"]
				)
			){
				this._setValueAttr(this._lastValueReported, true);
			}else if(typeof this.item == "undefined"){
				// Update 'value' (ex: KY) according to currently displayed text
				this.item = null;
				this.set('displayedValue', newvalue);
			}else{
				if(this.value != this._lastValueReported){
					this._handleOnChange(this.value, true);
				}
				this._refreshState();
			}
		},

		_setItemAttr: function(/*item*/ item, /*Boolean?*/ priorityChange, /*String?*/ displayedValue){
			// summary:
			//		Set the displayed valued in the input box, and the hidden value
			//		that gets submitted, based on a dojo.data store item.
			// description:
			//		Users shouldn't call this function; they should be calling
			//		set('item', value)
			// tags:
			//		private
			var value = '';
			if(item){
				if(!displayedValue){
					displayedValue = this.store._oldAPI ?	// remove getValue() for 2.0 (old dojo.data API)
						this.store.getValue(item, this.searchAttr) : item[this.searchAttr];
				}
				value = this._getValueField() != this.searchAttr ? this.store.getIdentity(item) : displayedValue;
			}
			this.set('value', value, priorityChange, displayedValue, item);
		},

		_announceOption: function(/*Node*/ node){
			// summary:
			//		a11y code that puts the highlighted option in the textbox.
			//		This way screen readers will know what is happening in the
			//		menu.

			if(!node){
				return;
			}
			// pull the text value from the item attached to the DOM node
			var newValue;
			if(node == this.dropDown.nextButton ||
				node == this.dropDown.previousButton){
				newValue = node.innerHTML;
				this.item = undefined;
				this.value = '';
			}else{
				var item = this.dropDown.items[node.getAttribute("item")];
				newValue = (this.store._oldAPI ?	// remove getValue() for 2.0 (old dojo.data API)
					this.store.getValue(item, this.searchAttr) : item[this.searchAttr]).toString();
				this.set('item', item, false, newValue);
			}
			// get the text that the user manually entered (cut off autocompleted text)
			this.focusNode.value = this.focusNode.value.substring(0, this._lastInput.length);
			// set up ARIA activedescendant
			this.focusNode.setAttribute("aria-activedescendant", domAttr.get(node, "id"));
			// autocomplete the rest of the option to announce change
			this._autoCompleteText(newValue);
		},

		_selectOption: function(/*DomNode*/ target){
			// summary:
			//		Menu callback function, called when an item in the menu is selected.
			this.closeDropDown();
			if(target){
				this._announceOption(target);
			}
			this._setCaretPos(this.focusNode, this.focusNode.value.length);
			this._handleOnChange(this.value, true);
		},

		_startSearchAll: function(){
			this._startSearch('');
		},

		_startSearchFromInput: function(){
			this.item = undefined; // undefined means item needs to be set
			this.inherited(arguments);
		},

		_startSearch: function(/*String*/ key){
			// summary:
			//		Starts a search for elements matching key (key=="" means to return all items),
			//		and calls _openResultList() when the search completes, to display the results.
			if(!this.dropDown){
				var popupId = this.id + "_popup",
					dropDownConstructor = lang.isString(this.dropDownClass) ?
						lang.getObject(this.dropDownClass, false) : this.dropDownClass;
				this.dropDown = new dropDownConstructor({
					onChange: lang.hitch(this, this._selectOption),
					id: popupId,
					dir: this.dir,
					textDir: this.textDir
				});
				this.focusNode.removeAttribute("aria-activedescendant");
				this.textbox.setAttribute("aria-owns",popupId); // associate popup with textbox
			}
			this._lastInput = key; // Store exactly what was entered by the user.
			this.inherited(arguments);
		},

		_getValueField: function(){
			// summary:
			//		Helper for postMixInProperties() to set this.value based on data inlined into the markup.
			//		Returns the attribute name in the item (in dijit/form/_ComboBoxDataStore) to use as the value.
			return this.searchAttr;
		},

		//////////// INITIALIZATION METHODS ///////////////////////////////////////

		postMixInProperties: function(){
			this.inherited(arguments);
			if(!this.store){
				var srcNodeRef = this.srcNodeRef;
				// if user didn't specify store, then assume there are option tags
				this.store = new DataList({}, srcNodeRef);

				// if there is no value set and there is an option list, set
				// the value to the first value to be consistent with native Select
				// Firefox and Safari set value
				// IE6 and Opera set selectedIndex, which is automatically set
				// by the selected attribute of an option tag
				// IE6 does not set value, Opera sets value = selectedIndex
				if(!("value" in this.params)){
					var item = (this.item = this.store.fetchSelectedItem());
					if(item){
						var valueField = this._getValueField();
						// remove getValue() for 2.0 (old dojo.data API)
						this.value = this.store._oldAPI ? this.store.getValue(item, valueField) : item[valueField];
					}
				}
			}
		},

		postCreate: function(){
			// summary:
			//		Subclasses must call this method from their postCreate() methods
			// tags:
			//		protected

			// find any associated label element and add to ComboBox node.
			var label=query('label[for="'+this.id+'"]');
			if(label.length){
				if(!label[0].id){ label[0].id = this.id + "_label"; }
				this.domNode.setAttribute("aria-labelledby", label[0].id);

			}
			this.inherited(arguments);
			this.connect(this, "onSearch", "_openResultList");
		},

		_getMenuLabelFromItem: function(/*Item*/ item){
			var label = this.labelFunc(item, this.store),
				labelType = this.labelType;
			// If labelType is not "text" we don't want to screw any markup ot whatever.
			if(this.highlightMatch != "none" && this.labelType == "text" && this._lastInput){
				label = this.doHighlight(label, this._lastInput);
				labelType = "html";
			}
			return {html: labelType == "html", label: label};
		},

		doHighlight: function(/*String*/ label, /*String*/ find){
			// summary:
			//		Highlights the string entered by the user in the menu.  By default this
			//		highlights the first occurrence found. Override this method
			//		to implement your custom highlighting.
			// tags:
			//		protected

			var
				// Add (g)lobal modifier when this.highlightMatch == "all" and (i)gnorecase when this.ignoreCase == true
				modifiers = (this.ignoreCase ? "i" : "") + (this.highlightMatch == "all" ? "g" : ""),
				i = this.queryExpr.indexOf("${0}");
			find = regexp.escapeString(find); // escape regexp special chars
			//If < appears in label, and user presses t, we don't want to highlight the t in the escaped "&lt;"
			//first find out every occurences of "find", wrap each occurence in a pair of "\uFFFF" characters (which
			//should not appear in any string). then html escape the whole string, and replace '\uFFFF" with the
			//HTML highlight markup. 
			return this._escapeHtml(label.replace(
				new RegExp((i == 0 ? "^" : "") + "("+ find +")" + (i == (this.queryExpr.length - 4) ? "$" : ""), modifiers),
				'\uFFFF$1\uFFFF')).replace(
					/\uFFFF([^\uFFFF]+)\uFFFF/g, '<span class="dijitComboBoxHighlightMatch">$1</span>'
			); // returns String, (almost) valid HTML (entities encoded)
		},

		_escapeHtml: function(/*String*/ str){
			// TODO Should become dojo.html.entities(), when exists use instead
			// summary:
			//		Adds escape sequences for special characters in XML: `&<>"'`
			str = String(str).replace(/&/gm, "&amp;").replace(/</gm, "&lt;")
				.replace(/>/gm, "&gt;").replace(/"/gm, "&quot;"); //balance"
			return str; // string
		},

		reset: function(){
			// Overrides the _FormWidget.reset().
			// Additionally reset the .item (to clean up).
			this.item = null;
			this.inherited(arguments);
		},

		labelFunc: function(item, store){
			// summary:
			//		Computes the label to display based on the dojo.data store item.
			// item: Object
			//		The item from the store
			// store: dojo/store/api/Store
			//		The store.
			// returns:
			//		The label that the ComboBox should display
			// tags:
			//		private

			// Use toString() because XMLStore returns an XMLItem whereas this
			// method is expected to return a String (#9354).
			// Remove getValue() for 2.0 (old dojo.data API)
			return (store._oldAPI ? store.getValue(item, this.labelAttr || this.searchAttr) :
				item[this.labelAttr || this.searchAttr]).toString(); // String
		},

		_setValueAttr: function(/*String*/ value, /*Boolean?*/ priorityChange, /*String?*/ displayedValue, /*item?*/ item){
			// summary:
			//		Hook so set('value', value) works.
			// description:
			//		Sets the value of the select.
			this._set("item", item||null); // value not looked up in store
			if(value == null /* or undefined */){ value = ''; } // null translates to blank
			this.inherited(arguments);
		},
		_setTextDirAttr: function(/*String*/ textDir){
			// summary:
			//		Setter for textDir, needed for the dropDown's textDir update.
			// description:
			//		Users shouldn't call this function; they should be calling
			//		set('textDir', value)
			// tags:
			//		private
			this.inherited(arguments);
			// update the drop down also (_ComboBoxMenuMixin)
			if(this.dropDown){
				this.dropDown._set("textDir", textDir);
			}
		}
	});
});

},
'dojo/data/util/filter':function(){
define("dojo/data/util/filter", ["../../_base/lang"], function(lang){
	// module:
	//		dojo/data/util/filter
	// summary:
	//		TODOC

var filter = {};
lang.setObject("dojo.data.util.filter", filter);

filter.patternToRegExp = function(/*String*/pattern, /*boolean?*/ ignoreCase){
	// summary:
	//		Helper function to convert a simple pattern to a regular expression for matching.
	// description:
	//		Returns a regular expression object that conforms to the defined conversion rules.
	//		For example:
	//
	//		- ca*   -> /^ca.*$/
	//		- *ca*  -> /^.*ca.*$/
	//		- *c\*a*  -> /^.*c\*a.*$/
	//		- *c\*a?*  -> /^.*c\*a..*$/
	//
	//		and so on.
	// pattern: string
	//		A simple matching pattern to convert that follows basic rules:
	//
	//		- * Means match anything, so ca* means match anything starting with ca
	//		- ? Means match single character.  So, b?b will match to bob and bab, and so on.
	//		- \ is an escape character.  So for example, \* means do not treat * as a match, but literal character *.
	//
	//		To use a \ as a character in the string, it must be escaped.  So in the pattern it should be
	//		represented by \\ to be treated as an ordinary \ character instead of an escape.
	// ignoreCase:
	//		An optional flag to indicate if the pattern matching should be treated as case-sensitive or not when comparing
	//		By default, it is assumed case sensitive.

	var rxp = "^";
	var c = null;
	for(var i = 0; i < pattern.length; i++){
		c = pattern.charAt(i);
		switch(c){
			case '\\':
				rxp += c;
				i++;
				rxp += pattern.charAt(i);
				break;
			case '*':
				rxp += ".*"; break;
			case '?':
				rxp += "."; break;
			case '$':
			case '^':
			case '/':
			case '+':
			case '.':
			case '|':
			case '(':
			case ')':
			case '{':
			case '}':
			case '[':
			case ']':
				rxp += "\\"; //fallthrough
			default:
				rxp += c;
		}
	}
	rxp += "$";
	if(ignoreCase){
		return new RegExp(rxp,"mi"); //RegExp
	}else{
		return new RegExp(rxp,"m"); //RegExp
	}

};

return filter;
});

},
'dijit/form/DataList':function(){
define("dijit/form/DataList", [
	"dojo/_base/declare", // declare
	"dojo/dom", // dom.byId
	"dojo/_base/lang", // lang.trim
	"dojo/query", // query
	"dojo/store/Memory",
	"../registry"	// registry.add registry.remove
], function(declare, dom, lang, query, MemoryStore, registry){

	// module:
	//		dijit/form/DataList

	function toItem(/*DOMNode*/ option){
		// summary:
		//		Convert `<option>` node to hash
		return {
			id: option.value,
			value: option.value,
			name: lang.trim(option.innerText || option.textContent || '')
		};
	}

	return declare("dijit.form.DataList", MemoryStore, {
		// summary:
		//		Inefficient but small data store specialized for inlined data via OPTION tags
		//
		// description:
		//		Provides a store for inlined data like:
		//
		//	|	<datalist>
		//	|		<option value="AL">Alabama</option>
		//	|		...

		constructor: function(params, srcNodeRef){
			// summary:
			//		Create the widget.
			// params: Object|null
			//		Hash of initialization parameters for widget, including scalar values (like title, duration etc.)
			//		and functions, typically callbacks like onClick.
			//		The hash can contain any of the widget's properties, excluding read-only properties.
			// srcNodeRef: DOMNode|String
			//		Attach widget to this DOM node.

			// store pointer to original DOM tree
			this.domNode = dom.byId(srcNodeRef);

			lang.mixin(this, params);
			if(this.id){
				registry.add(this); // add to registry so it can be easily found by id
			}
			this.domNode.style.display = "none";

			this.inherited(arguments, [{
				data: query("option", this.domNode).map(toItem)
			}]);
		},

		destroy: function(){
			registry.remove(this.id);
		},

		fetchSelectedItem: function(){
			// summary:
			//		Get the option marked as selected, like `<option selected>`.
			//		Not part of dojo.data API.
			var option = query("> option[selected]", this.domNode)[0] || query("> option", this.domNode)[0];
			return option && toItem(option);
		}
	});
});

},
'dijit/form/_SearchMixin':function(){
define("dijit/form/_SearchMixin", [
	"dojo/data/util/filter", // patternToRegExp
	"dojo/_base/declare", // declare
	"dojo/_base/event", // event.stop
	"dojo/keys", // keys
	"dojo/_base/lang", // lang.clone lang.hitch
	"dojo/query", // query
	"dojo/sniff", // has("ie")
	"dojo/string", // string.substitute
	"dojo/when",
	"../registry"	// registry.byId
], function(filter, declare, event, keys, lang, query, has, string, when, registry){

	// module:
	//		dijit/form/_SearchMixin


	return declare("dijit.form._SearchMixin", null, {
		// summary:
		//		A mixin that implements the base functionality to search a store based upon user-entered text such as
		//		with `dijit/form/ComboBox` or `dijit/form/FilteringSelect`
		// tags:
		//		protected

		// pageSize: Integer
		//		Argument to data provider.
		//		Specifies maximum number of search results to return per query
		pageSize: Infinity,

		// store: [const] dojo/store/api/Store
		//		Reference to data provider object used by this ComboBox.
		//		The store must accept an object hash of properties for its query. See `query` and `queryExpr` for details.
		store: null,

		// fetchProperties: Object
		//		Mixin to the store's fetch.
		//		For example, to set the sort order of the ComboBox menu, pass:
		//	|	{ sort: [{attribute:"name",descending: true}] }
		//		To override the default queryOptions so that deep=false, do:
		//	|	{ queryOptions: {ignoreCase: true, deep: false} }
		fetchProperties:{},

		// query: Object
		//		A query that can be passed to `store` to initially filter the items.
		//		ComboBox overwrites any reference to the `searchAttr` and sets it to the `queryExpr` with the user's input substituted.
		query: {},

		// searchDelay: Integer
		//		Delay in milliseconds between when user types something and we start
		//		searching based on that value
		searchDelay: 200,

		// searchAttr: String
		//		Search for items in the data store where this attribute (in the item)
		//		matches what the user typed
		searchAttr: "name",

		// queryExpr: String
		//		This specifies what query is sent to the data store,
		//		based on what the user has typed.  Changing this expression will modify
		//		whether the results are only exact matches, a "starting with" match,
		//		etc.
		//		dojo.data query expression pattern.
		//		`${0}` will be substituted for the user text.
		//		`*` is used for wildcards.
		//		`${0}*` means "starts with", `*${0}*` means "contains", `${0}` means "is"
		queryExpr: "${0}*",

		// ignoreCase: Boolean
		//		Set true if the query should ignore case when matching possible items
		ignoreCase: true,

		_abortQuery: function(){
			// stop in-progress query
			if(this.searchTimer){
				this.searchTimer = this.searchTimer.remove();
			}
			if(this._queryDeferHandle){
				this._queryDeferHandle = this._queryDeferHandle.remove();
			}
			if(this._fetchHandle){
				if(this._fetchHandle.abort){
					this._cancelingQuery = true;
					this._fetchHandle.abort();
					this._cancelingQuery = false;
				}
				if(this._fetchHandle.cancel){
					this._cancelingQuery = true;
					this._fetchHandle.cancel();
					this._cancelingQuery = false;
				}
				this._fetchHandle = null;
			}
		},

		_processInput: function(/*Event*/ evt){
			// summary:
			//		Handles input (keyboard/paste) events
			if(this.disabled || this.readOnly){ return; }
			var key = evt.charOrCode;

			// except for cutting/pasting case - ctrl + x/v
			if(evt.altKey || ((evt.ctrlKey || evt.metaKey) && (key != 'x' && key != 'v')) || key == keys.SHIFT){
				return; // throw out weird key combinations and spurious events
			}

			var doSearch = false;
			this._prev_key_backspace = false;

			switch(key){
				case keys.DELETE:
				case keys.BACKSPACE:
					this._prev_key_backspace = true;
					this._maskValidSubsetError = true;
					doSearch = true;
					break;

				default:
					// Non char keys (F1-F12 etc..) shouldn't start a search..
					// Ascii characters and IME input (Chinese, Japanese etc.) should.
					//IME input produces keycode == 229.
					doSearch = typeof key == 'string' || key == 229;
			}
			if(doSearch){
				// need to wait a tad before start search so that the event
				// bubbles through DOM and we have value visible
				if(!this.store){
					this.onSearch();
				}else{
					this.searchTimer = this.defer("_startSearchFromInput", 1);
				}
			}
		},

		onSearch: function(/*===== results, query, options =====*/){
			// summary:
			//		Callback when a search completes.
			//
			// results: Object
			//		An array of items from the originating _SearchMixin's store.
			//
			// query: Object
			//		A copy of the originating _SearchMixin's query property.
			//
			// options: Object
			//		The additional parameters sent to the originating _SearchMixin's store, including: start, count, queryOptions.
			//
			// tags:
			//		callback
		},

		_startSearchFromInput: function(){
			this._startSearch(this.focusNode.value.replace(/([\\\*\?])/g, "\\$1"));
		},

		_startSearch: function(/*String*/ text){
			// summary:
			//		Starts a search for elements matching text (text=="" means to return all items),
			//		and calls onSearch(...) when the search completes, to display the results.

			this._abortQuery();
			var
				_this = this,
				// Setup parameters to be passed to store.query().
				// Create a new query to prevent accidentally querying for a hidden
				// value from FilteringSelect's keyField
				query = lang.clone(this.query), // #5970
				options = {
					start: 0,
					count: this.pageSize,
					queryOptions: {		// remove for 2.0
						ignoreCase: this.ignoreCase,
						deep: true
					}
				},
				qs = string.substitute(this.queryExpr, [text]),
				q,
				startQuery = function(){
					var resPromise = _this._fetchHandle = _this.store.query(query, options);
					if(_this.disabled || _this.readOnly || (q !== _this._lastQuery)){
						return;
					} // avoid getting unwanted notify
					when(resPromise, function(res){
						_this._fetchHandle = null;
						if(!_this.disabled && !_this.readOnly && (q === _this._lastQuery)){ // avoid getting unwanted notify
							when(resPromise.total, function(total){
								res.total = total;
								var pageSize = _this.pageSize;
								if(isNaN(pageSize) || pageSize > res.total){ pageSize = res.total; }
								// Setup method to fetching the next page of results
								res.nextPage = function(direction){
									//	tell callback the direction of the paging so the screen
									//	reader knows which menu option to shout
									options.direction = direction = direction !== false;
									options.count = pageSize;
									if(direction){
										options.start += res.length;
										if(options.start >= res.total){
											options.count = 0;
										}
									}else{
										options.start -= pageSize;
										if(options.start < 0){
											options.count = Math.max(pageSize + options.start, 0);
											options.start = 0;
										}
									}
									if(options.count <= 0){
										res.length = 0;
										_this.onSearch(res, query, options);
									}else{
										startQuery();
									}
								};
								_this.onSearch(res, query, options);
							});
						}
					}, function(err){
						_this._fetchHandle = null;
						if(!_this._cancelingQuery){	// don't treat canceled query as an error
							console.error(_this.declaredClass + ' ' + err.toString());
						}
					});
				};

			lang.mixin(options, this.fetchProperties);

			// Generate query
			if(this.store._oldAPI){
				// remove this branch for 2.0
				q = qs;
			}else{
				// Query on searchAttr is a regex for benefit of dojo/store/Memory,
				// but with a toString() method to help dojo/store/JsonRest.
				// Search string like "Co*" converted to regex like /^Co.*$/i.
				q = filter.patternToRegExp(qs, this.ignoreCase);
				q.toString = function(){ return qs; };
			}

			// set _lastQuery, *then* start the timeout
			// otherwise, if the user types and the last query returns before the timeout,
			// _lastQuery won't be set and their input gets rewritten
			this._lastQuery = query[this.searchAttr] = q;
			this._queryDeferHandle = this.defer(startQuery, this.searchDelay);
		},

		//////////// INITIALIZATION METHODS ///////////////////////////////////////

		constructor: function(){
			this.query={};
			this.fetchProperties={};
		},

		postMixInProperties: function(){
			if(!this.store){
				var list = this.list;
				if(list){
					this.store = registry.byId(list);
				}
			}
			this.inherited(arguments);
		}
	});
});

},
'epi/shell/widget/SearchBox':function(){
require({cache:{
'url:epi/shell/widget/templates/SearchBox.html':"﻿<div class=\"dijit dijitReset dijitInline dijitLeft dijitTextBox epi-searchInput epi-contentSearchBox\" id=\"widget_${id}\">\r\n    <span data-dojo-attach-point=\"clearButton\" class=\"dijitReset dijitRight epi-clearButton\" role=\"presentation\"></span>\r\n    <div class=\"dijitReset dijitInputField dijitInputContainer\">\r\n        <input data-dojo-attach-point=\"textbox,focusNode\" type=\"text\" class=\"dijitReset dijitInputInner\" role=\"textbox\" />\r\n        <span class=\"dijitPlaceHolder dijitInputField\" data-dojo-attach-point=\"_phspan,placeHolderNode\"></span>\r\n    </div>\r\n</div>"}});
﻿define("epi/shell/widget/SearchBox", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-style",

    "dojo/Evented",
    "dojo/keys",
// dijit
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",

    "dijit/focus",
    "dijit/form/TextBox",
// dojox
    "dojox/html/entities",
// dgrid
    "dgrid/util/misc",
// Templates
    "dojo/text!./templates/SearchBox.html",
// Resources
    "epi/i18n!epi/shell/ui/nls/EPiServer.Shell.UI.Resources.SearchBox"
],
function (
// dojo
    declare,
    lang,

    domAttr,
    domClass,
    domStyle,

    Evented,
    keys,
// dijit
    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,

    focusManager,
    TextBox,
// dojox
    htmlEntities,
// dgrid
    miscUtil,
// Templates
    template,
// Resources
    resources
) {
    return declare([TextBox, Evented], {
        // summary:
        //      Widget for 
        //
        // tags:
        //      public

        templateString: template,

        // placeHolder: String
        //      Defines a hint to help users fill out the input field (as defined in HTML 5).
        //      This should only contain plain text (no html markup).
        placeHolder: epi.resources.action.search,

        // commonRes: [private] Object
        //    Common localization resources,
        commonRes: epi.resources,

        // defaultDelay: [Integer]
        //      Delay in milliseconds between when user types something and we start
        //      searching based on that value.
        // tags:
        //      protected
        defaultDelay: 500,

        // encodeSearchText: [public] Boolean
        //      Indicated that need to encode search text or not.
        encodeSearchText: false,

        postCreate: function () {
            // summary:
            //		Post widget creation. Initialize event for buttons
            // tags:
            //      Protected

            this.inherited(arguments);

            domAttr.set(this.clearButton, "title", resources.clear);

            // clear textbox value when clicking on clear button
            this.connect(this.clearButton, "onclick", lang.hitch(this, function () {
                this.set("value", "");
                this.focus();
                this.toggleClearButton();
                this._valueChanged();
            }));

            this.toggleClearButton();

            this.connect(this, "_onInput",
                miscUtil.debounce(lang.hitch(this, function (event) {
                    this.toggleClearButton();
                    this._valueChanged(event);
                }), null, this.defaultDelay));
        },

        toggleClearButton: function () {
            // summary:
            //      Set visibility for clear button
            // tags:
            //      private

            // show clear button only if textbox has value
            domStyle.set(this.clearButton, "visibility", this.textbox.value ? "visible" : "hidden");
        },

        focus: function () {
            // summary:
            //      Set focus for textbox
            // tags:
            //      public

            focusManager.focus(this.textbox);
        },

        _setValueAttr: function (value) {
            // summary:
            //      Set value for textbox
            // tags:
            //      private

            this.textbox.value = value;
        },

        _valueChanged: function (/* Event */event) {
            // summary:
            //      Trigger when textbox value has been changed
            // tags:
            //      private

            if (event && event.keyCode) {
                switch (event.keyCode) {
                    case keys.PAGE_DOWN:
                    case keys.DOWN_ARROW:
                    case keys.PAGE_UP:
                    case keys.UP_ARROW:
                    case keys.LEFT_ARROW:
                    case keys.RIGHT_ARROW:
                        // do nothing when navigating, selecting text
                        return;
                }
            }

            this.emit("searchBoxChange", this.encodeSearchText ? htmlEntities.encode(this.textbox.value) : this.textbox.value);
        }
    });
});
},
'url:epi/shell/widget/templates/SearchBox.html':"﻿<div class=\"dijit dijitReset dijitInline dijitLeft dijitTextBox epi-searchInput epi-contentSearchBox\" id=\"widget_${id}\">\r\n    <span data-dojo-attach-point=\"clearButton\" class=\"dijitReset dijitRight epi-clearButton\" role=\"presentation\"></span>\r\n    <div class=\"dijitReset dijitInputField dijitInputContainer\">\r\n        <input data-dojo-attach-point=\"textbox,focusNode\" type=\"text\" class=\"dijitReset dijitInputInner\" role=\"textbox\" />\r\n        <span class=\"dijitPlaceHolder dijitInputField\" data-dojo-attach-point=\"_phspan,placeHolderNode\"></span>\r\n    </div>\r\n</div>",
'epi-cms/widget/SearchResultList':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Evented",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-style",

// Dojox
    "dojox/widget/Standby",

// Dijit
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/form/_ListMouseMixin",
    "dijit/form/_ComboBoxMenuMixin",

// EPi Framework
    "epi/dependency",
    "epi-cms/widget/_ContentListKeyMixin",
    "epi-cms/widget/_ContentListMouseMixin",
    "epi-cms/dgrid/formatters",
    "epi/shell/dgrid/Formatter",

// DGrid
    "dgrid/OnDemandList",
    "dgrid/Selection",
    "dgrid/Keyboard",

// Templates
    "dojo/text!./templates/SearchResultList.html"
],

function (
// Dojo
    declare,
    lang,
    Evented,
    domConstruct,
    domClass,
    domStyle,

// Dojox
    Standby,

// Dijit
    _WidgetBase,
    _TemplatedMixin,
    _ListMouseMixin,
    _ComboBoxMenuMixin,

// EPi Framework
    dependency,
    _ContentListKeyMixin,
    _ContentListMouseMixin,
    formatters,
    Formatter,
// DGrid
    OnDemandList,
    Selection,
    Keyboard,

// Templates
    template
    ) {

    return declare([_WidgetBase, _TemplatedMixin, Evented, _ListMouseMixin, _ComboBoxMenuMixin, _ContentListKeyMixin, _ContentListMouseMixin], {
        // summary:
        //    A grid to display content list.
        //
        // tags:
        //    public

        templateString: template,

        // _standby: Standby
        //      The standby object to indicate the loading process for grid.
        //  tags:
        //      Protected
        _standby: null,

        // _messages: Object
        //		Holds "next" and "previous" text for paging buttons on drop down.
        _messages: { nextMessage: "", previousMessage: "" },

        postCreate: function () {
            // summary:
            //		Initialize grid for displaying content list.
            // tags:
            //      Protected
            this.inherited(arguments);

            var self = this,
                profile = dependency.resolve("epi.shell.Profile"),
                gridClass = declare([OnDemandList, Selection, Keyboard, Formatter]),
                // Get item's title
                titleSelector = function (item) { return item.title; },
                // Get item's typeIdentifier
                iconSelector = function (item) { return item.metadata.typeIdentifier; },
                // Get item's thumbnail url
                thumbnailSelector = function (item) {
                    var container = self.grid.domNode,
                        thumbnailClass = "epi-thumbnailContentList";

                    (item.metadata.thumbnailUrl && !domClass.contains(container, thumbnailClass)) && domClass.add(container, thumbnailClass);

                    return item.metadata.thumbnailUrl;
                },
                languageSelector = function (item) {
                    if (item.metadata && item.metadata.languageBranch != profile.contentLanguage) {
                        return { language: item.metadata.languageBranch };
                    }
                };

            this.grid = new gridClass({
                formatters: [formatters.contentItemFactory("title", titleSelector, iconSelector, null, thumbnailSelector, languageSelector, false)],
                selectionMode: "single", // for Selection; only select a single row at a time
                cellNavigation: false // for Keyboard; allow only row-level keyboard navigation
            });

            // Hide header of the grid
            this.grid.set("showHeader", false);

            domConstruct.place(this.grid.domNode, this.containerNode);

            // trigger onSelect event when clicking on grid row
            this.grid.on(".dgrid-row:click", lang.hitch(this, function (event) {
                var row = this.grid.row(event);
                if (row) {
                    this._onSelect(row.data);
                }
            }));

            this._standby = new Standby({ target: this.domNode, color: "#fff" }).placeAt(document.body);
            this.own(this._standby);

            // assign the grid container as containerNode, so _ListMouseMixin and _ComboBoxMenuMixin can get the properly container
            this.containerNode = this._getGridContainer();
        },

        startup: function () {
            // summary:
            //		handle processing after any DOM fragments have been actually added to the document.
            // tags:
            //      Protected
            this.inherited(arguments);
            this._standby.startup();
        },

        showStandby: function (show) {
            // summary:
            //		Set standby visibility.
            // tags:
            //      Protected

            if (!this._standby) {
                return;
            }
            if (show) {
                if (!this._standby.isVisible()) {
                    this._standby.show();
                }
            } else {
                this._standby.hide();
            }
        },

        showGrid: function (show) {
            // summary:
            //		Set grid visibility.
            // tags:
            //      Protected
            domStyle.set(this.grid.domNode, "display", show ? "block" : "none");
        },

        _onSelect: function (value) {
            // summary:
            //		Emit onSelect event when an item has been selected.
            // tags:
            //      Private
            this.emit("select", value);
        },

        _getGridContainer: function () {
            // summary:
            //		Returns the grid container, which contains grid rows.
            // tags:
            //      Private
            return this.grid.contentNode;
        },

        createOptions: function (results, options, labelFunc) {
            // summary:
            //		Fills in the items in the list
            // results:
            //		Array of items
            // options:
            //		The options to the query function of the store
            //
            // labelFunc:
            //		Function to produce a label in the drop down list from a dojo.data item

            this.grid.renderArray(results);
            return this.containerNode.childNodes;
        },

        clearResultList: function () {
            // summary:
            //		Clears the entries in the list.

            this.grid.refresh();
        },

        getHighlightedOption: function () {
            // summary:
            //		This will be used to highlight the text in the textbox, to allow screen readers to know what is happening in the menu.
            //      Return null since we don't want this feature.

            return null;
        },

        showErrorMessage: function (show, message) {
            // summary:
            //		Set error message visibility.
            // tags:
            //      Protected

            this.clearResultList();
            this.showStandby(false);
            if (show && message) {
                this.errorMessage.innerHTML = message;
            }
            domStyle.set(this.errorMessage, "display", show ? "block" : "none");
        }
    });
});

},
'epi-cms/widget/_ContentListKeyMixin':function(){
﻿define([
// Dojo
"dojo/_base/declare",
"dojo/keys"
],

function (
// Dojo
    declare,
    keys
    ) {

    return declare(null, {
        // summary:
        //    A Mixin to handle key event for ContentList.
        //
        // tags:
        //    protected

        handleKey: function (evt) {
            // summary:
            //		Handle keystroke event forwarded from ComboBox, returning false if it's
            //		a keystroke I recognize and process, true otherwise.
            // tags:
            //      Protected

            switch (evt.keyCode) {
                case keys.DOWN_ARROW:
                    this.selectNextNode();
                    return false;
                case keys.UP_ARROW:
                    this.selectPreviousNode();
                    return false;
                case keys.ENTER:
                    // select item on pressing Enter
                    if (this.selected && this.grid.row(this.selected)) {
                        this._onSelect(this.grid.row(this.selected).data);
                    }
                    return false;
                default:
                    return true;
            }
        }
    });
});
},
'epi-cms/widget/_ContentListMouseMixin':function(){
﻿define([
// Dojo
"dojo/_base/declare",
"dojo/dom-class"
],

function (
// Dojo
    declare,
    domClass
    ) {

    return declare(null, {
        // summary:
        //    A Mixin to handle mouse event for ContentList.
        //
        // tags:
        //    protected

        onHover: function (/*DomNode*/node) {
            // summary:
            //		Add hover CSS
        },

        onUnhover: function (/*DomNode*/node) {
            // summary:
            //		Remove hover CSS
        },

        onSelect: function (/*DomNode*/node) {
            // summary:
            //		Add selected CSS

            domClass.add(node, "dgrid-selected ui-state-active dgrid-focus");
        },

        onDeselect: function (/*DomNode*/node) {
            // summary:
            //		Remove selected CSS
            domClass.remove(node, "dgrid-selected ui-state-active dgrid-focus");
        }
    });
});
},
'url:epi-cms/widget/templates/SearchResultList.html':"﻿<div class=\"epi-searchResultList\">\r\n    <div data-dojo-attach-point=\"containerNode\">\r\n        <div data-dojo-attach-point=\"errorMessage\" class=\"epi-searchResultListEmptyMessage\"></div>\r\n    </div>\r\n    <div class=\"dijitReset epi-searchResultListNavigation\">\r\n        <div data-dojo-attach-point=\"previousButton\" role=\"option\"></div>\r\n        <div data-dojo-attach-point=\"nextButton\" role=\"option\"></div>\r\n    </div>\r\n</div>",
'epi-cms/component/Media':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-style",

    "dojo/on",
    "dojo/topic",
// epi-cms
    "epi-cms/component/MediaViewModel",
    "epi-cms/widget/HierarchicalList",
// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.hierachicallist",
    "epi/i18n!epi/cms/nls/episerver.cms.components.media"
],

function (
// dojo
    declare,
    lang,

    domClass,
    domStyle,

    on,
    topic,
// epi
    MediaViewModel,
    HierarchicalList,
// Resources
    hierarchicalListResources,
    resources
) {

    // module:
    //      epi-cms/component/Media
    // summary:
    //      Media management component
    // tags:
    //      public

    return declare([HierarchicalList], {

        res: resources,

        // enableDndFileDropZone: [public] Boolean
        //      Flag to indicate this widget allowed to show drop zone widget ("epi-cms/widget/FilesUploadDropZone" that care about native DnD files from browser) or not.
        enableDndFileDropZone: true,

        // showCreateContentArea: [public] Boolean
        //      Flag to indicate this widget allowed to show create content area by default or not.
        showCreateContentArea: true,

        modelClassName: MediaViewModel,

        noDataMessage: resources.nocontent,

        // hierarchicalListClass: [readonly] String
        //      The CSS class to be used on the content list.
        hierarchicalListClass: "epi-mediaList",

        // createContentText: [public] String
        //      Upload file text
        createContentText: resources.dropareatitle,

        postCreate: function () {

            this.inherited(arguments);

            this.list.set("noDataMessage", this.res.nocontent);

            this.own(
                this.model.getCommand("upload").watch("canExecute", lang.hitch(this, function (name, oldValue, newValue) {
                    this._toggleCreateContentArea(newValue);
                }))
            );
        },

        // =======================================================================
        // List setup

        _setupList: function () {
            // summary:
            //      List setup
            // tags:
            //      protected

            this.inherited(arguments);

            domClass.add(this.list.grid.domNode, "epi-thumbnailContentList");

            this.own(
                on(this.list, "createItemAction", lang.hitch(this, function () {
                    this.model._commandRegistry.uploadDefault.command.execute();
                })),
                on(this.list, "itemAction", lang.hitch(this, function (item) {
                    topic.publish("/epi/shell/context/request", { uri: item.uri }, { sender: this });
                }))
            );
        }

    });

});
},
'epi-cms/component/MediaViewModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",

    "dojo/when",
// epi
    "epi",
    "epi/shell/widget/dialog/Dialog",

    "epi-cms/core/ContentReference",

    "epi-cms/widget/ContextualContentForestStoreModel",
    "epi-cms/widget/viewmodel/HierarchicalListViewModel",
    "epi-cms/widget/viewmodel/MultipleFileUploadViewModel",
    "epi-cms/widget/MultipleFileUpload",
    "epi-cms/widget/UploadUtil",

    "epi-cms/command/UploadContent",
    "epi-cms/command/EditImage",
    "epi-cms/command/DownloadMedia",
// resource
    "epi/i18n!epi/cms/nls/episerver.cms.components.media"
],

function (
// dojo
    array,
    declare,
    lang,

    domClass,

    when,
// epi
    epi,
    Dialog,

    ContentReference,

    ContextualContentForestStoreModel,
    HierarchicalListViewModel,
    MultipleFileUploadViewModel,
    MultipleFileUpload,
    UploadUtil,

    UploadContentCommand,
    EditImageCommand,
    DownloadCommand,
// resources
    resources
) {

    // module:
    //      epi-cms/component/viewmodel/MediaViewModel
    // summary:
    //      Handles search and tree to list browsing widgets.
    // tags:
    //      public

    return declare([HierarchicalListViewModel], {

        // treeStoreModelClass: [const] Function
        //      Class to use as model for the tree.
        treeStoreModelClass: ContextualContentForestStoreModel,

        // Dialog widget for uploading new media
        _dialog: null,

        _getTypesToCreate: function () {
            // No create commands for media since upload is used instead.
            return [];
        },

        _setupCommands: function () {
            // summary:
            //      Creates and registers the commands used.
            // tags:
            //      protected

            this.inherited(arguments);

            var settings = {
                selection: this.selection,
                model: this
            };

            var customCommands = {
                uploadDefault: {
                    command: new UploadContentCommand(lang.mixin({
                        iconClass: "epi-iconPlus",
                        label: resources.command.label,
                        resources: resources,
                        viewModel: this
                    }, settings))
                },
                upload: {
                    command: new UploadContentCommand(lang.mixin({
                        category: "context",
                        iconClass: "epi-iconUpload",
                        label: resources.linktocreateitem,
                        viewModel: this
                    }, settings)),
                    isAvailable: this.menuType.ROOT | this.menuType.TREE,
                    order: 2
                },
                editImage: {
                    command: new EditImageCommand(lang.mixin({
                        category: "context",
                        forceContextChange: true,
                        label: resources.command.openineditor
                    }, settings)),
                    isAvailable: this.menuType.LIST,
                    order: 3
                },
                download: {
                    command: new DownloadCommand(lang.mixin({
                        category: "context",
                        label: resources.command.download
                    }, settings)),
                    isAvailable: this.menuType.LIST,
                    order: 4
                }
            };

            this._commandRegistry = lang.mixin(this._commandRegistry, customCommands);

            this.pseudoContextualCommands.push(this._commandRegistry.uploadDefault.command);
            this.pseudoContextualCommands.push(this._commandRegistry.upload.command);
        },

        _updateTreeContextCommandModels: function (model) {
            // summary:
            //      Update model of commands in case selected content is folder
            // tags:
            //      private

            this.inherited(arguments);

            this._commandRegistry.uploadDefault.command.set("model", model);
            this._commandRegistry.upload.command.set("model", model);
        },

        upload: function (/*Array*/fileList, /*String?*/targetId, /*Boolean?*/createAsLocalAsset) {
            // summary:
            //      Upload multiple files.
            // fileList: [Array]
            //      List files to upload.
            //      When null, only show upload form to select files for uploading.
            //      Otherwise, upload files in list.
            // targetId: [String?]
            //      Parent content id
            // createAsLocalAsset: [Boolean?]
            // tags:
            //      protected

            // only create diaglog if it is not available, otherwise, re-use it.
            var uploader = new MultipleFileUpload({
                model: new MultipleFileUploadViewModel({
                    store: this.get("store"),
                    query: this.get("listQuery")
                })
            });

            uploader.on("beforeUploaderChange", lang.hitch(this, function () {
                this._uploading = true;
            }));

            // close multiple files upload dialog when stop uploading
            uploader.on("close", lang.hitch(this, function (uploading) {
                this._dialog && (uploading ? this._dialog.hide() : this._dialog.destroy());
            }));

            // Reload current folder of tree, to reflect changes
            uploader.on("uploadComplete", lang.hitch(this, function (/*Array*/uploadFiles) {
                // Set current tree item again to reload items in list.
                if (uploader.createAsLocalAsset) {
                    when(this.treeStoreModel && typeof this.treeStoreModel.refreshRoots === "function" && this.treeStoreModel.refreshRoots(this), lang.hitch(this, function () {
                        // Turn-off createAsLocalAsset
                        uploader.set("createAsLocalAsset", false);
                        // Update uploading directory after create a new real one local asset folder for the given content
                        uploader.set("uploadDirectory", this.get("currentTreeItem").id);
                        // Update content list query after create a new real one local asset folder for the given content
                        uploader.model.set("query", this.get("listQuery"));
                    }));
                } else {
                    this.onListItemUpdated(uploadFiles);
                    this.set("currentTreeItem", this.get("currentTreeItem"));
                }

                if (this._dialog && !this._dialog.open) {
                    this._dialog.destroy();
                }

                this._uploading = false;
            }));

            this._dialog = new Dialog({
                title: resources.linktocreateitem,
                content: uploader,
                autofocus: UploadUtil.supportNativeDndFiles(), // Only autofocus if not using flash.
                defaultActionsVisible: false,
                closeIconVisible: false
            });

            domClass.add(this._dialog.domNode, "epi-multiFileUploadDialog");

            // only show close button for multiple files upload dialog
            this._dialog.definitionConsumer.add({
                name: "close",
                label: epi.resources.action.close,
                action: function () {
                    uploader.close();
                }
            });

            this._dialog.resize({ w: 700 });
            this._dialog.show();

            var selectedContent = createAsLocalAsset ? this.selection.data[0].data : this.store.get(targetId);
            when(selectedContent, lang.hitch(this, function (content) {
                // Update breadcumb on upload dialog.
                this._buildBreadcrumb(content, uploader);

                // Set destination is current tree item.
                uploader.set("uploadDirectory", targetId || this.get("currentTreeItem").id);
                uploader.set("createAsLocalAsset", createAsLocalAsset);

                uploader.upload(fileList);
            }));
        },

        onListItemUpdated: function (updatedItems) {
            // summary:
            //      Refresh the editing media if it have a new version
            // updatedItems: [Array]
            //      Collection of the updated item. In this case, they are files.
            // tags:
            //      public, extension

            var store = this.store;

            return when(this.getCurrentContext(), function (currentContext) {
                var contentWithoutVersion = (new ContentReference(currentContext.id)).createVersionUnspecificReference().toString();

                return when(store.get(contentWithoutVersion), function (currentContent) {
                    var editingMedia = array.filter(updatedItems, function (updatedItem) {
                        return currentContent.name.toLowerCase() === updatedItem.fileName.toLowerCase();
                    })[0];
                    return editingMedia ? currentContent : null;
                });
            });
        },

        _buildBreadcrumb: function (contentItem, uploader) {
            // summary:
            //      Build breadcrumb for the provided content
            // contentItem: Object
            //      The provided content
            // uploader: Object
            //      The multiple file upload control
            // tags:
            //      private

            if (!uploader) {
                return;
            }

            // Do not add more items when current content is sub root
            if (this.treeStoreModel.isTypeOfRoot(contentItem)) {
                uploader.set("breadcrumb", [contentItem]);
                return;
            }

            this.treeStoreModel.getAncestors(contentItem.contentLink, lang.hitch(this, function (ancestors) {
                var ancestor,
                    paths = [contentItem];

                for (var i = ancestors.length - 1; i >= 0; i--) {
                    ancestor = ancestors[i];
                    paths.unshift(ancestor);

                    // Break after first sub root or context root
                    if (this.treeStoreModel.isTypeOfRoot(ancestor)) {
                        break;
                    }
                }

                uploader.set("breadcrumb", paths);
            }));
        }

    });

});
},
'epi-cms/widget/viewmodel/HierarchicalListViewModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",

    "dojo/Stateful",
    "dojo/when",
//epi
    "epi",
    "epi/dependency",

    "epi/shell/ClipboardManager",
    "epi/shell/command/_CommandProviderMixin",
    "epi/shell/selection",
    "epi/shell/TypeDescriptorManager",
//epi-cms
    "epi-cms/_ContentContextMixin",
    "epi-cms/_MultilingualMixin",
    "epi-cms/contentediting/_ContextualContentContextMixin",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/ContentForestStoreModel",
//command
    "epi-cms/widget/command/NewFolder",
    "epi-cms/command/RenameFolder",
    "epi-cms/widget/CreateCommandsMixin",
    "epi-cms/command/NewContent",
    "epi-cms/command/CopyContent",
    "epi-cms/command/CutContent",
    "epi-cms/command/DeleteContent",
    "epi-cms/command/PasteContent",
    "epi-cms/command/TranslateContent",
    "epi-cms/component/command/ViewTrash",
    "epi-cms/component/command/ChangeContext"
],

function (
// dojo
    array,
    declare,
    lang,
    topic,

    Stateful,
    when,
// epi
    epi,
    dependency,

    ClipboardManager,
    _CommandProviderMixin,
    Selection,
    TypeDescriptorManager,
//epi-cms
    _ContentContextMixin,
    _MultilingualMixin,
    _ContextualContentContextMixin,
    ContentReference,
    ContentForestStoreModel,
//command
    NewFolderCommand,
    RenameFolderCommand,
    CreateCommandsMixin,
    NewContentCommand,
    CopyContentCommand,
    CutContentCommand,
    DeleteContentCommand,
    PasteContentCommand,
    TranslateContentCommand,
    ViewTrashCommand,
    ChangeContextCommand
) {

    // module:
    //      epi-cms/widget/viewmodel/HierarchicalListViewModel
    // summary:
    //      Handles search and tree to list browsing widgets.

    return declare([Stateful, _ContentContextMixin, _ContextualContentContextMixin, _MultilingualMixin, CreateCommandsMixin], {

        // menuType: [readonly] Object
        //      Enum used with commands to set in what context they should be available.
        menuType: { ROOT: 1, TREE: 2, LIST: 4 },

        // searchArea: [readonly] String
        //      Used with the search component when querying to scope the search.
        searchArea: "",
        // searchRoots: [readonly] String
        //      Used with the search component to set the roots to search in.
        searchRoots: "",

        // clipboardManager: [const] ClipboardManager
        //      Used to handle copy-paste operations with the commands.
        clipboardManager: null,

        // selection: [const] Selection
        //      Used to handle currently selected items for the commands.
        selection: null,

        // commands: [readonly] _Command[]
        //      Used to handle currently selected items for the commands.
        commands: null,

        // createCommands: [readonly] _Command[]
        //      Used to handle currently selected items for the commands.
        createCommands: null,

        // createHierarchyCommands: [readonly] _Command[]
        //      Used to handle currently selected items for the commands.
        createHierarchyCommands: null,

        // pseudoContextualCommands: [readonly] _Command[]
        //      Used to handle currently selected items for the commands.
        pseudoContextualCommands: null,

        // currentTreeItem:  ContentReference
        //      The currently selected tree item.
        currentTreeItem: null,

        // currentListItem:  ContentReference
        //      The currently selected list item.
        currentListItem: null,

        // listQuery: Query
        //      Query object holding parameters to get the children.
        //      of the current tree item
        listQuery: null,

        // listQueryOptions: Object
        //      Extra paramaters needed to query the store for the list items.
        listQueryOptions: null,

        // showAllLanguages: Boolean
        //      Indicates if to query for items only in current language context or not.
        showAllLanguages: true,

        // treeStoreModelClass: [const] Function
        //      Class to use as model for the tree.
        treeStoreModelClass: ContentForestStoreModel,

        // treeStoreModel: [const] TreeStoreModel
        //      TreeStoreModel instance.
        treeStoreModel: null,

        // store: [const] Dojo/Store
        //      Store instance used for all server queries.
        store: null,

        // storeKey: [const] String
        //      Key to resolve store from dependency.
        storeKey: "epi.cms.content.light",

        // mainNavigationTypes: String[]
        //      Which types to filter for tree queries. Also used with trash command.
        mainNavigationTypes: null,

        // containedTypes: [const] String[]
        //       Which types to filter for list queries.
        containedTypes: null,

        _showAllLanguagesSetter: function (value) {
            this.showAllLanguages = value;
            this._updateListQuery(this.currentTreeItem);
            this.treeStoreModel.set("showAllLanguages", value);
        },

        _currentTreeItemSetter: function (value) {
            this.currentTreeItem = value;
            this._updateListQuery(value);
        },

        postscript: function (args) {
            this.inherited(arguments);
            this.contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");

            declare.safeMixin(this, this.contentRepositoryDescriptors[args.repositoryKey]);

            this.clipboardManager = this.clipboardManager || new ClipboardManager();
            this.selection = this.selection || new Selection();
            this.store = this.store || dependency.resolve("epi.storeregistry").get(this.storeKey);

            this._setupTreeStoreModel();

            this._setupCommands();
            this.set("commands", this._commandRegistry.toArray());

            this._setupSearchRoots();

            this.set("listQueryOptions", this.treeStoreModel._queryOptions);
        },

        startup: function () {
            // summary:
            //      Allows the view model to start reacting to external input.
            // tags:
            //      protected

            this.inherited(arguments);

            this._setupSelection();
        },

        getCommand: function (commandName) {
            // summary:
            //      Gets a command by command name
            // tags:
            //      protected

            return this._commandRegistry[commandName] ? this._commandRegistry[commandName].command : null;
        },

        contentContextChanged: function (context, callerData) {
            // summary:
            //      Called when the currently loaded content changes. I.e. a new content data object is loaded into the preview area.
            //      Override _ContextContextMixin.contentContextChanged
            // tags:
            //      protected

            this._setupSearchRoots();

            if (!this._isSupportedContent(context)) {
                return;
            }

            var self = this,
                oldListRef = self.get("currentListItem"),
                previousSelection = self.treeStoreModel.get("previousSelection"),
                listRef = ContentReference.toContentReference(context.id);

            when(self.store.get(listRef.createVersionUnspecificReference()), function (currentContent) {
                var contextParentLink = previousSelection && self.hasContextual(previousSelection.selectedAncestors) ? currentContent.assetsFolderLink : context.parentLink,
                    treeRef = ContentReference.toContentReference(previousSelection ? contextParentLink : self.roots[0]);

                // Just want to store the current selected content when the context changed.
                // So that, do not need to wait any action from the store.
                self.set("editingListItem", listRef);

                if (callerData && callerData.forceReload || !ContentReference.compareIgnoreVersion(oldListRef, listRef)) {
                    when(self.store.get(treeRef.createVersionUnspecificReference()), function (model) {
                        self.treeStoreModel && when(self.treeStoreModel.canExpandTo(model), function (canExpand) {
                            if (canExpand) {
                                self.set("currentTreeItem", treeRef);
                                self.set("currentListItem", listRef);

                                self._updateCommands(model, self.menuType.LIST);
                            }
                        });
                    });
                }
            });
        },

        onSearch: function (metadata) {
            // summary:
            //      Handles changes as a result of a user search
            // metadata:
            //      Seatch result
            // tags:
            //      public

            when(this.store.get(metadata.id), lang.hitch(this, function (model) {
                var currentListItem = ContentReference.toContentReference(model.contentLink);
                this.set("editingListItem", currentListItem);
                this.set("currentListItem", currentListItem);
                this.set("currentTreeItem", ContentReference.toContentReference(model.parentLink));
                this._updateCommands(model, this.menuType.LIST);
            }));
        },

        onTreeItemSelected: function (model, isRoot) {
            // summary:
            //      Handles changes to the slection in the tree and updates the viev model
            // tags:
            //      public

            var oldRef = this.get("currentTreeItem"),
                newRef = ContentReference.toContentReference(model.contentLink),
                menuType = isRoot ? this.menuType.ROOT : this.menuType.TREE;

            this._updateCommands(model, menuType);

            if (!ContentReference.compareIgnoreVersion(oldRef, newRef) && ContentReference.emptyContentReference != newRef) {
                this.set("currentTreeItem", newRef);
            }
        },

        onListItemSelected: function (model) {
            // summary:
            //      Handles changes to the slection in the list and updates the viev model
            // tags:
            //      public

            var oldRef = this.get("currentListItem"),
                newRef = ContentReference.toContentReference(model.contentLink);

            this._updateCommands(model, this.menuType.LIST);

            if (!ContentReference.compareIgnoreVersion(oldRef, newRef)) {
                this.set("currentListItem", newRef);
            }
        },

        onListItemUpdated: function (updatedItems) {
            // summary:
            //      Refresh the editing media if it have a new version
            // updatedItems: [Array]
            //      Collection of the updated item
            // tags:
            //      public, extension
        },

        _isSupportedContent: function (/*Object*/content) {
            // summary:
            //      Indicates whether the given content is a type contained by this widget.
            // content:
            //      Object to validate
            // tags:
            //      private
            return !!(content && content.id) && this.containedTypes.some(function (type) {
                return TypeDescriptorManager.isBaseTypeIdentifier(content.dataType, type);
            });
        },

        _setupSelection: function () {
            // summary:
            //      Get target tree item and list item for selection
            // tags:
            //      protected

            when(this.getCurrentContext(), lang.hitch(this, function (ctx) {

                var rootId;

                if (!this._isContentContext(ctx) || !this._isSupportedContent(ctx)) {
                    // TODO: Fix this hack of always using the first item in roots
                    rootId = ContentReference.toContentReference(this.roots[0]).toString();
                    when(this.store.get(rootId), lang.hitch(this, function (model) {
                        this.onTreeItemSelected(model, true);
                    }));
                } else {
                    this.contentContextChanged(ctx, null);
                }
            }));
        },

        _setupTreeStoreModel: function () {
            // summary:
            //      Creates an configures the treeStoreModel.
            // tags:
            //      protected

            var treeModel = new this.treeStoreModelClass({
                store: this.store,
                roots: this.roots,
                typeIdentifiers: this.mainNavigationTypes,
                containedTypes: this.containedTypes,
                notAllowToCopy: this.preventCopyingFor,
                notAllowToDelete: this.preventDeletionFor,
                notSupportContextualContents: this.preventContextualContentFor,
                onAddDelegate: lang.hitch(this, function (node) {
                    var targetNode = dijit.getEnclosingWidget(node.domNode),
                        target = targetNode && targetNode.item,
                        canExecute = (typeof (this.treeStoreModel.canEdit) === "function") && this.treeStoreModel.canEdit(target);

                    if (canExecute) {
                        node.edit();


                        // Publish the children change AFTER the user has change the name of the new folder or canceled the editor
                        // REMARK: We need to do this after the change otherwise the editing will be canceled because the children change replaced the child items in the tree
                        // TODO: This should be handled by the tree model
                        var publish = function () {
                            topic.publish("/epi/cms/contentdata/childrenchanged", target.parentLink);
                        };

                        var handle = node.on("rename", function () {
                            handle.remove();

                            publish();
                        });

                        var cancelHandle = node.on("cancelEdit", function () {
                            cancelHandle.remove();

                            publish();
                        });

                    }
                }),
                onRefreshRoots: lang.hitch(this, this._setupSearchRoots),
                additionalQueryOptions: {
                    sort: this._getSortSettings()
                }
            });

            this.set("treeStoreModel", treeModel);
        },

        _getSortSettings: function () {
            // summary:
            //      Returns the list of sort criteria.
            // tags:
            //      protected

            return [{ attribute: "name", descending: false }];
        },

        _setupSearchRoots: function () {
            // summary:
            //      Creates and configures the treeStoreModel.
            // tags:
            //      protected

            when(this.getCurrentContent(), lang.hitch(this, function (currentContentItem) {
                var roots = this.roots instanceof Array && this.roots.length > 0 ? lang.clone(this.roots) : [],
                    assetsFolderLink = currentContentItem && currentContentItem.assetsFolderLink;

                if (assetsFolderLink && typeof this._getPseudoContextualContent === "function" && assetsFolderLink != this._getPseudoContextualContent()) {
                    roots.push(assetsFolderLink);
                }

                this.set("searchRoots", roots.join(","));
            }));
        },

        _setupCommands: function () {
            // summary:
            //      Creates and registers the commands used.
            // tags:
            //      protected

            var menuType = this.menuType;

            var settings = {
                category: "context",
                model: this.treeStoreModel,
                selection: this.selection,
                clipboard: this.clipboardManager
            };

            this.createHierarchyCommands = {};
            var index = 1;

            // Create commands for the navigation types.
            array.forEach(this.mainNavigationTypes, function (type) {
                this.createHierarchyCommands[type] = {
                    command: new NewFolderCommand(lang.mixin({ typeIdentifier: type }, settings)),
                    isAvailable: menuType.ROOT | menuType.TREE,
                    order: index
                };
                index = index + 1;
            }, this);

            this.createCommands = this.getCreateCommands(index);

            var commands = {
                rename: {
                    command: new RenameFolderCommand({ category: "context" }),
                    isAvailable: menuType.TREE,
                    order: 10
                },
                cut: {
                    command: new CutContentCommand(settings),
                    isAvailable: menuType.TREE | menuType.LIST,
                    order: 20
                },
                copy: {
                    command: new CopyContentCommand(settings),
                    isAvailable: menuType.TREE | menuType.LIST,
                    order: 30
                },
                paste: {
                    command: new PasteContentCommand(settings),
                    isAvailable: menuType.ROOT | menuType.TREE,
                    order: 40
                },
                edit: {
                    command: new ChangeContextCommand({
                        category: "context",
                        forceContextChange: true
                    }),
                    isAvailable: this.menuType.LIST,
                    order: 3
                },
                translate: {
                    command: new TranslateContentCommand(),
                    isAvailable: this.menuType.TREE | this.menuType.LIST
                },
                "delete": {
                    command: new DeleteContentCommand(settings),
                    isAvailable: menuType.TREE | menuType.LIST,
                    order: 50
                },
                trash: {
                    command: new ViewTrashCommand({ typeIdentifiers: this.mainNavigationTypes }),
                    order: 60
                },
                sort: function () {
                    var commands = [];
                    for (var key in this) {
                        if (key !== "toArray" && key !== "sort" && this.hasOwnProperty(key)) {
                            var index = this[key].order;
                            if (!index) {
                                index = 100;
                            }
                            commands.push([index, this[key].command]);
                        }
                    }

                    commands.sort(function (a, b) {
                        return a[0] - b[0];
                    });

                    return commands;
                },
                toArray: function () {
                    var sortedCommand = this.sort();
                    var commands = [];
                    array.forEach(sortedCommand, function (key) {
                        commands.push(key[1]);
                    });

                    return commands;
                }
            };

            this._commandRegistry = lang.mixin(this._commandRegistry, this.createHierarchyCommands, this.createCommands, commands);

            this.pseudoContextualCommands = this._getPseudoContextualCommands();
        },

        _updateListQuery: function (itemRef) {
            // summary:
            //      Creates a new query and updates the listQuery property.
            // tags:
            //      protected

            var id,
                query = null;

            // remove all mainNavigationTypes from containedTypes, to avoid of displaying Folder in Content List
            var contentTypes = array.filter(this.containedTypes, function (item) {
                return this.mainNavigationTypes.indexOf(item) < 0;
            }, this);

            if (itemRef) {
                id = itemRef.toString(),
                query = this._createListChildrenQuery(id, this.showAllLanguages, contentTypes);
            }

            this.set("listQuery", query);
        },

        _createListChildrenQuery: function (id, showAllLanguages, contentTypes) {
            return { referenceId: id, query: "getchildren", allLanguages: showAllLanguages, typeIdentifiers: contentTypes };
        },

        _updateSelection: function (model) {
            // summary:
            //      Updates the selection manager to the current model. Used when commands execute.
            // tags:
            //      protected

            this.selection.set("data", model ? [{ type: "epi.cms.contentdata", data: model }] : []);
        },

        _updateCommands: function (model, menuType) {
            // summary:
            //      Updates the current model for all commands needing this.
            // tags:
            //      protected

            this._updateSelection(model);

            if (typeof this.treeStoreModel.isSupportedType === "function" && this.treeStoreModel.isSupportedType(model.typeIdentifier)) {
                this._updateTreeContextCommandModels(model);
                this.decoratePseudoContextualCommands(this.pseudoContextualCommands);
            }

            this._commandRegistry.translate.command.set("model", model);
            this._commandRegistry.translate.command.set("executeDelegate", null);
            this._commandRegistry.edit.command.set("model", model);

            // Set custom availability last in case the command has
            // default logic for changing this in the model change handling
            this._updateCommandAvailability(menuType);
        },

        _updateTreeContextCommandModels: function (model) {
            // summary:
            //      Update model of commands in case selected content is a navigation node.
            // tags:
            //      private

            this._updateCreateCommandModels(model);

            this._commandRegistry.rename.command.set("model", model);
        },

        _updateCreateCommandModels: function (model) {
            // summary:
            //      Update model of create commands.
            // tags:
            //      protected

            var commands = this.createCommands;
            for (var key in commands) {
                commands[key].command.set("model", model);
            }
        },

        _getPseudoContextualCommands: function () {
            // summary:
            //      Get commands to decorates
            // returns: [Array]
            //      Array of command object that each is instance of "epi.shell.command._Command" class
            // tags:
            //      private

            var key,
                commands = [];

            for (key in this.createCommands) {
                commands.push(this.createCommands[key].command);
            }

            for (key in this.createHierarchyCommands) {
                commands.push(this.createHierarchyCommands[key].command);
            }

            commands.push(this._commandRegistry.paste.command);

            return commands;
        },

        _updateCommandAvailability: function (menuType) {
            // summary:
            //      Updates the availability of the command dependant on which menu types it is registered for.
            // tags:
            //      protected

            var registry = this._commandRegistry,
                isAvailableFlags;

            for (var key in registry) {
                if (key !== "toArray" && registry.hasOwnProperty(key)) {
                    isAvailableFlags = registry[key].isAvailable;
                    if (isAvailableFlags) {
                        var command = registry[key].command;
                        this._updateAvailabilityForSpecificCommand(command, menuType, isAvailableFlags);
                    }
                }
            }
        },

        _updateAvailabilityForSpecificCommand: function (command, menuType, isAvailableFlags) {
            // we don't want to update availability of TranslateCommand because her model knows better when to be available
            if (!command.isInstanceOf(TranslateContentCommand)) {
                command.set("isAvailable", !!(isAvailableFlags & menuType));
            }
        },

        upload: function (fileList) {
            // summary:
            //      Implementation needs to overwrite this to process upload files action.
            // fileList:
            //      List files to upload.
            //      When null, only show upload form to select files for uploading.
            //      Otherwise, upload files in list.
            // tags:
            //      protected
        }

    });

});
},
'epi/shell/ClipboardManager':function(){
﻿define("epi/shell/ClipboardManager", ["dojo/_base/declare", "dojo/Stateful"], function (declare, Stateful) {

    return declare(Stateful, {
        // summary:
        //    The clipboard object that stores copy and cut data.
        // tags:
        //    public

        copy: true,

        data: null,

        constructor: function() {
            this.data = [];
        },

        clear: function () {
            // summary:
            //    Clears the clipboard.
            // tags:
            //    public

            this.set("data", null);
        },

        isCopy: function () {
            // summary:
            //    Determines if the last action is copy or not.
            // tags:
            //    public

            return this.get("copy");
        },

        setDataObject: function (object, copy) {
            // summary:
            //    Set data object that is copied or cut to clipboard.
            // copy: 
            //    Indicates the mode is copy or cut.
            // tags:
            //    public

            this.set("copy", copy);
            this.set("data", object);
        },

        getDataObject: function () {
            // summary:
            //    Get the data object from the clipboard.
            // tags:
            //    public

            return this.data;
        },

        containsData: function () {
            // summary:
            //    Determines if clipboard contains any data or not.
            // tags:
            //    public

            return !!this.data;
        }
    });

});
},
'epi/shell/selection':function(){
﻿define("epi/shell/selection", ["dojo/_base/declare", "./StatefulArray"], function (declare, StatefulArray) {
   
    return declare(StatefulArray, {
        // summary:
        //      A Stateful object for keeping track of currently selected items

        // data: []
        //      An array of currently selected items.
        data: null,

        constructor: function () {
            // summary:
            //      Initializes the selection with an empty array
            this.data = [];
        }
    });
});
},
'epi-cms/_MultilingualMixin':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/when",
    "dojo/_base/lang",

// Epi
    "epi/dependency",
    "epi-cms/ApplicationSettings",
    "epi-cms/component/SiteTreeModel"
],

function (
// Dojo
    declare,
    Deferred,
    when,
    lang,

// Epi
    dependency,
    ApplicationSettings,
    SiteTreeModel
) {

    // summary:
    //    A Mixin to check for Multilingual capability
    // tags:
    //    protected

    return declare([], {
        // isMultilingual: [readonly] Boolean
        //      Flag which indicates whether to support multi-languages
        isMultilingual: false,

        // _application: Object
        //      Instance of CMS application
        _application: null,

        // _siteTreeModel: Object
        //      Instance of SiteTreeModel
        _siteTreeModel: null,

        // _cachedValue: Object
        //      A cached value for the _isSiteMultilingualQuery
        _cachedValue: undefined,

        constructor: function (options) {
            // summary:
            //      Mixin properties of the object for injection later.
            // tags:
            //      protected

            lang.mixin(this, options);
        },

        _isSiteMultilingual: function () {
            // summary:
            //      Check whether current site allows multilingual
            // tags:
            //      protected
            var deferred = new Deferred();

            if (this._cachedValue !== undefined) {
                deferred.resolve(this._cachedValue);
            }

            if (!this._siteTreeModel) {
                var registry = dependency.resolve("epi.storeregistry"),
                    siteStructureStore = registry.get("epi.cms.sitestructure");
                this._siteTreeModel = new SiteTreeModel({store: siteStructureStore});
            }

            when(this._siteTreeModel.getAllLanguagesForCurrentSite(), lang.hitch(this, function (items) {
                this._cachedValue = items.length >= 2;
                deferred.resolve(this._cachedValue);
            }));

            return deferred;
        },

        _contentExistsInCurrentLanguage: function (/*Object*/contentItem) {
            // summary:
            //      Check if the language branch for the current content differs from the current content language for the application.
            // contentItem:
            //      Content item.
            // tags:
            //      protected

            if(!contentItem) {
                return false;
            }

            //If the content does not support languages then the content exists for the current language
            if(contentItem.capabilities && !contentItem.capabilities.language)
            {
                return true;
            }

            if (!contentItem.currentLanguageBranch) {
                return false;
            }

            return ApplicationSettings.currentContentLanguage === contentItem.currentLanguageBranch.languageId;
        }
    });
});
},
'epi-cms/widget/command/NewFolder':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/topic",

    "dojo/when",
// epi
    "epi/shell/command/_Command",
    "epi/shell/command/_SelectionCommandMixin",
    "epi/shell/TypeDescriptorManager",

    "epi-cms/core/ContentReference",

    "epi-cms/contentediting/ContentActionSupport"
],

function (
// dojo)
    array,
    declare,
    lang,

    topic,

    when,
// epi
    _Command,
    _SelectionCommandMixin,
    TypeDescriptorManager,

    ContentReference,

    ContentActionSupport
) {

    // module:
    //      epi-cms/widget/command/NewFolder
    // summary:
    //      A command that creates a new folder under the current selection.
    // tags:
    //      public

    return declare([_Command, _SelectionCommandMixin], {

        iconClass: "epi-iconFolder",

        // typeIdentifier: [public] String
        //      The identifier for the type to be created.
        typeIdentifier: null,

        // createAsLocalAsset: [public] Boolean
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        // _defaultName: [private] String
        //      Manages settings for different content classes like css class for the item types.
        _defaultName: null,

        postscript: function () {
            this.inherited(arguments);

            var identifier = this.typeIdentifier;

            this._defaultName = TypeDescriptorManager.getResourceValue(identifier, "newitemdefaultname");

            var translatedLabel = TypeDescriptorManager.getResourceValue(identifier, "create");
            this.set("label", translatedLabel);
            this.set("tooltip", translatedLabel);
        },

        _execute: function () {
            // summary:
            //      Executes this command; publishes a context change request to change to the model item.
            // tags:
            //      protected

            var self = this,
                parentItem = self.get("selectionData"),
                parentLink = (new ContentReference(parentItem.contentLink)).createVersionUnspecificReference().toString(),
                createAsLocalAsset = self.createAsLocalAsset;

            var addNewFolder = function (parentItem) {
                self.model.getChildren(parentItem, function (childs) {
                    // Add new folder
                    when(self.model.add({
                        parentLink: parentLink,
                        name: self._getUniqueFolderName(childs, self._defaultName),
                        contentTypeIdentifier: self.typeIdentifier,
                        createAsLocalAsset: createAsLocalAsset
                    }, self.onRefreshSelection), function(newItem) {

                        // REMARK: This is not a very good place to do this, but when we can't rely on the
                        // store notfications for the contextual content we need to do this
                        // If the item got a new parent, publish the local asset created topic
                        if(newItem.parentLink != parentLink) {
                            topic.publish("/epi/cms/action/createlocalasset");
                        }
                    });
                });
            };

            if (createAsLocalAsset) {
                when(self.model.store.refresh(parentLink), function (parentItem) {
                    when(self.model.store.get(parentItem.assetsFolderLink), addNewFolder);
                });
            } else {
                addNewFolder(parentItem);
            }
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            var target = this.get("selectionData"),
                createAction = ContentActionSupport.action.Create,
                createProviderCapability = ContentActionSupport.providerCapabilities.Create,
                canExecute = this.model &&  // Ensure that there is a model available.
                             target &&  // Ensure there is something selected.
                             ContentActionSupport.isActionAvailable(target, createAction, createProviderCapability, true);  // Ensure the action is available to the user.

            this.set("canExecute", !!canExecute);
        },

        _getUniqueFolderName: function (arr, defaultName) {
            // summary:
            //      Return the unique folder name for create
            // arr: [Array]
            //      List of object
            // defaultName: [String]
            //      The default folder name
            // tags:
            //      private

            var constructName = function (times) {
                var name = times > 0 ? lang.replace(defaultName + " {0}", [times]) : defaultName;
                if (times > 1000) {
                    return name;
                }

                // Check exists with the name
                var isExisted = array.some(arr, function (child) {
                    return lang.trim(child.name).toLowerCase() === lang.trim(name).toLowerCase();
                });

                // If there are any the same name, call recursive
                if (isExisted) {
                    times = times + 1;
                    return constructName(times);
                }

                return name;
            };

            // Return unique folder name get
            return constructName(0);
        }

    });

});
},
'epi-cms/command/RenameFolder':function(){
﻿define([
    "dojo/_base/declare",

    "epi",
    "epi-cms/_MultilingualMixin",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/shell/command/_Command"
],

function (
    declare,

    epi,
    _MultilingualMixin,
    ContentActionSupport,
    _Command
) {

    // module:
    //      epi/cms/command/RenameFolder
    // summary:
    //      A command that causes the model to switch to an edit mode.

    return declare([_Command, _MultilingualMixin], {

        label: epi.resources.action.rename,

        contentActionSupport: null,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconRename",

        renameDelegate: null,

        typeIdentifier: "episerver.core.contentfolder",

        postscript: function () {
            this.inherited(arguments);

            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;
        },

        _execute: function () {
            // summary:
            //      Executes this command; publishes a context change request to change to the model item.
            // tags:
            //      protected

            this.renameDelegate(this.model);
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            // The model is the folder tree node, which has a label widget for editing the name.

            var canExecute = this.renameDelegate && this.model && 
                this.model.typeIdentifier === this.typeIdentifier &&
                this.contentActionSupport.hasAccess(this.model.accessMask, ContentActionSupport.accessLevel[ContentActionSupport.action.Edit]) &&
                this._contentExistsInCurrentLanguage(this.model);

            this.set("canExecute", canExecute);
        }
    });
});
},
'epi-cms/widget/CreateCommandsMixin':function(){
﻿define([
//dojo
"dojo/_base/array",
"dojo/_base/declare",
"dojo/_base/lang",
//epi
"epi/dependency",
//epi-cms
"../command/PopupCommand",
"../command/NewContent",
//resources
"epi/i18n!epi/nls/episerver.shared"
],

function(
//dojo
array,
declare,
lang,
//epi
dependency,
//epi-cms
PopupCommand,
NewContent,
//resources
sharedResources
) {
    return declare([], {

        contentRepositoryDescriptors: null,

        typeDescriptorManager: null,

        createCommandClass: NewContent,

        repositoryKey: null,

        category: null,

        isAvailableFlags: null,

        postscript: function() {
            this.inherited(arguments);
            if (!this.repositoryKey){
                throw "You need to specify the repositoryKey field";
            }

            this.contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");
            declare.safeMixin(this, this.contentRepositoryDescriptors[this.repositoryKey]);

            this.commandCategory = this.commandCategory || "context";

            //TODO: This should be specified elsewhere, its now duplicated from hierarchicallistviewmodel
            var menuType = { ROOT: 1, TREE: 2, LIST: 4 };

            this.isAvailableFlags = this.isAvailableFlags || menuType.ROOT | menuType.TREE;
        },

        getCreateCommands: function(index) {
            var createCommands = {};
            var commandIndex = index || 1;
            if (!this.creatableTypes) return createCommands;
            // Create commands for the types to create.
            array.forEach(this.creatableTypes, function (type) {
                createCommands[type] = {
                    command: this._createCommand(type),
                    isAvailable: this.isAvailableFlags,
                    order: commandIndex
                };
                commandIndex = commandIndex + 1;
            }, this);

            if (this.creatableTypes.length < 2){
                return createCommands;
            }

            var popupCommand = new PopupCommand({
                label: sharedResources.action["new"],
                commands: createCommands
            });

            return {
                popupCommand: {
                    command: popupCommand,
                    order: index
                }
            };
        },

        _createCommand: function(type) {
            return new this.createCommandClass({
                contentType: type,
                category : this.commandCategory
            });
        }

    });
});
},
'epi-cms/command/PopupCommand':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/Stateful",
    "epi/shell/command/_Command",
    "epi/shell/command/_CommandProviderMixin",
    "epi/shell/widget/ContextMenu"
], function(
    array,
    declare,
    Stateful,
    _Command,
    _CommandProviderMixin,
    ContextMenu
){
    return declare([_Command, _CommandProviderMixin], {

        category: "popup",

        canExecute: true,

        popup: null,

        popupClass: ContextMenu,

        popupCategory: "context",

        _commandsSetter: function(value) {
            if (!value) return;

            var commands = [];
            if (value instanceof Array){
                commands = value;
            } else {
                for(var index in value){
                    commands.push(value[index].command);
                }
            }

            this.commands = commands;

            this._updateIsAvailable();
        },

        _popupSetter: function (popup) {
            this.popup = popup;

            popup.addProvider(this);
        },

        _updateIsAvailable: function(){
            var isAvailable = array.some(this.get("commands"), function(command){ return command.get("isAvailable"); });
            this.set("isAvailable",isAvailable);
        },

        _onModelChange: function() {
            //set the model on the contained commands
            this.updateCommandModel(this.model);
            this._updateIsAvailable();
        }
    });
});
},
'epi-cms/command/NewContent':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/topic",
    "dojo/when",
    "dojo/promise/all",

    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/contentediting/ContentActionSupport"
],

function (
    array,
    declare,
    lang,
    Deferred,
    topic,
    when,
    all,

    dependency,
    _Command,
    TypeDescriptorManager,
    ContentActionSupport
) {

    // module:
    //      epi-cms/command/NewContent
    // summary:
    //      A command that starts the create new content process when executed.

    return declare([_Command], {

        // contentType: [public] String
        //      The type of the content that the create content view should display.
        contentType: null,

        // createAsLocalAsset: [public] Boolean
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        // canChangeLocalAssetName: [public] Boolean
        //      Indicates that we can change the name of a new local asset content when create a new instance.
        canChangeLocalAssetName: true,

        postscript: function () {
            this.inherited(arguments);

            var identifier = this.contentType;

            this.label = this.label || TypeDescriptorManager.getResourceValue(identifier, "create");
            this.tooltip = this.tooltip || TypeDescriptorManager.getResourceValue(identifier, "createdescription");
            this.iconClass = this.iconClass || TypeDescriptorManager.getValue(identifier, "commandIconClass");

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.contenttype");
            }
        },

        _execute: function () {
            // summary:
            //      Executes this command; publishes a change view request to change to the create content view.
            // tags:
            //      protected

            topic.publish("/epi/shell/action/changeview", "epi-cms/contentediting/CreateContent", null, {
                requestedType: this.contentType,
                parent: this.model,
                createAsLocalAsset: this.createAsLocalAsset,
                canChangeLocalAssetName: this.canChangeLocalAssetName,
                view: TypeDescriptorManager.getValue(this.contentType, "createView")
            });
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            // the model can be an array of content, cause we can cut, copy or delete multiple items.
            // but creating new content accepts one content only, so we just get the first data if the input model is an array.
            if (this.model && this.model instanceof Array) {
                if (this.model.length == 1) {
                    this.model = this.model[0];
                } else { // model is an array that has more than one item, or empty.
                    this.model = null;
                }
            }

            var model = this.model,
                createAction = ContentActionSupport.action.Create,
                createProviderCapability = ContentActionSupport.providerCapabilities.Create,
                canExecute = model && !(model.isWastebasket || model.isDeleted) &&  // Ensure a model is available and it isn't deleted
                             ContentActionSupport.hasLanguageAccess(model) &&  // Ensure the user has access in the current language.
                             ContentActionSupport.isActionAvailable(model, createAction, createProviderCapability, true);  // Ensure the action is available to the user.

            this.set("canExecute", !!canExecute);

            if (!model) {
                return;
            }

            when(this._getContentType(model), lang.hitch(this, function (contentType) {

                if (!contentType) {
                    this.set("isAvailable", false);
                    return;
                }

                when(this._checkAvailability(contentType.availableContentTypes), lang.hitch(this, function (isAvailable) {
                    this.set("isAvailable", isAvailable);
                }));
            }));
        },

        _getContentType: function (model) {
            // summary:
            //      Query for available content types based on the type.
            // tags:
            //      private

            if (!model) return null;

            return this.store.get(model.contentTypeID);
        },

        _checkAvailability: function (availableContentTypes) {

            if (availableContentTypes.length === 0) {
                return false;
            }

            var deferred = new Deferred();

            var getRequests = array.map(availableContentTypes, lang.hitch(this, function (contentTypeID) {
                return this.store.get(contentTypeID);
            }));

            when(all(getRequests), lang.hitch(this, function (contentTypes) {
                var isAvailable = array.some(contentTypes, lang.hitch(this, function (contentType) {
                    return TypeDescriptorManager.isBaseTypeIdentifier(contentType.typeIdentifier, this.contentType);
                }));
                deferred.resolve(isAvailable);
            }));

            return deferred;
        }

    });

});
},
'epi-cms/command/CopyContent':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "epi",
    "epi/shell/command/_Command",
    "epi/shell/command/_ClipboardCommandMixin",
    "epi/shell/command/_SelectionCommandMixin"
], function (declare, array, epi, _Command, _ClipboardCommandMixin, _SelectionCommandMixin) {

    // module:
    //		epi-cms/command/NewContent
    // summary:
    //		A command that starts the create new content process when executed.

    return declare([_Command, _ClipboardCommandMixin, _SelectionCommandMixin], {

        // label: [readonly] String
        //		The action text of the command to be used in visual elements.
        label: epi.resources.action.copy,

        // iconClass: [readonly] String
        //		The icon class of the command to be used in visual elements.
        iconClass: "epi-iconCopy",

        _execute: function () {
            // summary:
            //		Copies the currently selected items to the clipboard and sets the clipboard copy flag.
            // tags:
            //		protected

            this.clipboard.set("copy", true);
            this.clipboard.set("data", this.selection.data.concat());
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var model = this.model,
               selection = this.selection.data,
               canExecute = false;

            if (model && selection.length) {
                canExecute = array.every(selection, function (item) {
                    return model.canCopy(item.data);
                });
            }

            this.set("canExecute", canExecute);
        }
    });
});
},
'epi-cms/command/CutContent':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "epi",
    "epi/shell/command/_Command",
    "epi/shell/command/_ClipboardCommandMixin",
    "epi/shell/command/_SelectionCommandMixin"
], function (array, declare, epi, _Command, _ClipboardCommandMixin, _SelectionCommandMixin) {

    // module:
    //		epi-cms/command/CutContent
    // summary:
    //		Copies the currently selected items to the clipboard.

    return declare([_Command, _ClipboardCommandMixin, _SelectionCommandMixin], {

        // label: [readonly] String
        //		The action text of the command to be used in visual elements.
        label: epi.resources.action.cut,

        // iconClass: [readonly] String
        //		The icon class of the command to be used in visual elements.
        iconClass: "epi-iconCut",

        _execute: function () {
            // summary:
            //		Copies the selection to the clipboard.
            // tags:
            //		protected

            this.clipboard.set("copy", false);
            this.clipboard.set("data", this.selection.data.concat());
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var model = this.model,
                selection = this.selection.data,
                canExecute = false;

            if (model && selection.length) {
                canExecute = array.every(selection, function (item) {
                    return model.canCut(item.data);
                });
            }

            this.set("canExecute", canExecute);
        }
    });
});
},
'epi-cms/command/DeleteContent':function(){
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/topic",
    "dojo/when",
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/ContentActionSupport",

    // Parent class and mixins
    "epi/shell/command/_Command",
    "epi/shell/command/_ClipboardCommandMixin",
    "epi/shell/command/_SelectionCommandMixin",

    // Localization
    "epi/i18n!epi/cms/nls/episerver.cms.command",
    "epi/i18n!epi/nls/episerver.shared"
], function (
    declare,
    lang,
    promiseAll,
    topic,
    when,
    ApplicationSettings,
    ContentActionSupport,
    _Command,
    _ClipboardCommandMixin,
    _SelectionCommandMixin,
    resources,
    sharedResources
) {
    // module:
    //      epi-cms/command/DeleteContent
    // summary:
    //      This command deletes the content in the selection. The actual operation that is executed depends on whether the selected content has a wastebasket. If the
    //      content has a wastebasket then a move operation is performed with the wastebasket as destination, otherwise if the content doesn't have a wastebasket then
    //      it will be removed permanently.
    return declare([_Command, _ClipboardCommandMixin, _SelectionCommandMixin], {

        // label: [readonly] String
        //      The action text of the command to be used in visual elements.
        label: resources.movetotrash,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconTrash",

        // hasWastebasket: [readonly] Boolean
        //      Flag indicating whether the provider of current content has a wastebasket. This is set internally on model change.
        hasWastebasket: true,

        _execute: function() {
            // summary:
            //      Executes the move or remove method on the model depending on whether the wastebasket is supported. Also clears the clipboard
            //      if it contains one of the deleted items.
            // tags:
            //      protected

            var model = this.model,
                clipboard = this.clipboard,
                selection = this.selection.data,
                operation = this.hasWastebasket ? model.move(selection, { contentLink: ApplicationSettings.wastebasketPage, isWastebasket: true }) : model.remove(selection);

            return when(operation, lang.hitch(this, function() {
                var promises = [];

                // Check to see if any of the items that were removed are in the clipboard or are ancestors of items in the clipboard.
                if (clipboard && clipboard.data) {
                    selection.forEach(function (selectionItem) {
                        var map = clipboard.data.map(function (clipboardItem) {
                            return model.isAncestor(selectionItem.data, clipboardItem.data);
                        });

                        promises = promises.concat(map);
                    });
                }

                when(promiseAll(promises), function(results) {
                    var containedInClipboard = results.every(function(result) {
                        return result;
                    });

                    if (containedInClipboard) {
                        clipboard.clear();
                    }
                });
            }), lang.hitch(this, function () {
                topic.publish("/epi/cms/action/delete/error");
            }));
        },

        _hasWastebasketSetter: function (hasWastebasket) {
            // summary:
            //      Sets the hasWastebasket property as well as updating the label and iconClass properties to
            //      reflect the available action.
            // tags:
            //      protected
            this.hasWastebasket = hasWastebasket;

            this.set("iconClass", hasWastebasket ? "epi-iconTrash" : "epi-iconClose");
            this.set("label", hasWastebasket ? resources.movetotrash : sharedResources.action.deletelabel);
        },

        _onModelChange: function() {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected
            var model = this.model,
                selection = this.selection.data,
                canDelete = function(item) {
                    var content = item.data;
                    return content && !content.isDeleted && model.canDelete(content);
                },
                supportsWastebasket = function(item) {
                    var content = item.data;
                    return content && ContentActionSupport.hasProviderCapability(content.providerCapabilityMask, ContentActionSupport.providerCapabilities.Wastebasket);
                };

            // hasWastebasket is true when the selection is not empty and each item has a content provider which supports the wastebasket.
            this.set("hasWastebasket", !!selection.length && selection.every(supportsWastebasket));

            // canExecute is true when a model is set, the selection is not empty, and each item can be deleted, and all the selected items either support wastebasket or don't support wastebasket.
            this.set("canExecute", !!(model && selection.length) && selection.every(canDelete) && (this.hasWastebasket || !selection.some(supportsWastebasket)));
        }
    });
});
},
'epi-cms/command/PasteContent':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/when",
// epi
    "epi",

    "epi/shell/command/_Command",
    "epi/shell/command/_ClipboardCommandMixin",
    "epi/shell/command/_SelectionCommandMixin"
],

function (
// dojo
    array,
    declare,
    lang,
    promiseAll,
    when,
// epi
    epi,

    _Command,
    _ClipboardCommandMixin,
    _SelectionCommandMixin
) {

    // module:
    //      epi-cms/command/PasteContent
    // summary:
    //      A command that pastes whats in the clip board onto the current selection.
    // tags:
    //      public

    return declare([_Command, _ClipboardCommandMixin, _SelectionCommandMixin], {

        // label: [readonly] String
        //      The action text of the command to be used in visual elements.
        label: epi.resources.action.paste,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconPaste",

        // createAsLocalAsset: [public] Boolean
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        _execute: function () {
            // summary:
            //      Executes this command; publishes a change view request to change to the create content view.
            // tags:
            //      protected

            var source = this.get("clipboardData"),
               target = this.get("selectionData");

            this.model.set("createAsLocalAsset", this.createAsLocalAsset);

            if (this.clipboard.copy) {
                return this.model.copy(source, target);
            } else {
                return when(this.model.move(source, target), lang.hitch(this, function () {
                    // Clear clipboard after successfully moving
                    this.clipboard.clear();
                }));
            }
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            var self = this,
                model = self.model,
                source = self.get("clipboardData"),
                target = self.get("selectionData");

            // Set to false by default in case there are any timing delays in the deferred.
            self.set("canExecute", false);

            if (model && source && source.length && target) {
                var deferreds = array.map(source, function (item) {
                    return model.canPaste(item.data, target, self.clipboard.copy);
                });

                when(promiseAll(deferreds), function (results) {
                    var canExecute = array.every(results, function (result) { return result; });

                    if (self.clipboard.copy) {
                        self.set("canExecute", canExecute);
                        return;
                    }

                    // Check to make sure the target is not a descendant of the source.
                    model.getAncestors(target, function (ancestors) {
                        var isDescendant = array.some(source, function (item) {
                            return array.indexOf(ancestors, item.data) >= 0;
                        });
                        self.set("canExecute", canExecute && !isDescendant);
                    });
                });
            }
        }

    });

});
},
'epi-cms/component/command/ViewTrash':function(){
﻿define([
// Dojo base
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/Deferred",
    "dojo/topic",

// Epi Framework
    "epi/dependency",
    "epi/shell/command/_Command",

// EPi CMS
    "epi-cms/ApplicationSettings",

// Resource
    "epi/i18n!epi/cms/nls/episerver.cms.command"
], function (
// Dojo base
    declare,
    lang,
    Deferred,
    topic,

// Epi Framework
    dependency,
    _Command,

// EPi CMS
    ApplicationSettings,

// Resource
    resources

    ) {

    // module:
    //		epi/cms/component/command/ViewTrash
    // summary:
    //		A command that opens the trash.

    return declare([_Command], {

        // label: [public] String
        //		The action text of the command to be used in visual elements.
        label: resources.viewtrash,

        // category: [readonly] String
        //		A category which provides a hint about how the command could be displayed.
        category: "setting",

        _wasteBasketId: null,

        typeIdentifiers: null,

        postscript: function () {
            this.inherited(arguments);

            // Set default cannot execute for view trash command
            this.set("canExecute", false);

            this._wasteBasketId = ApplicationSettings.wastebasketPage;
            var store = dependency.resolve("epi.storeregistry").get("epi.cms.content.light");

            // this should be able to be execute when user have READ access right for trash
            Deferred.when(store.get(this._wasteBasketId), lang.hitch(this, function (response) {
                this.set("canExecute", (response.statusCode != "401"));
            }));
        },

        _execute: function () {
            // summary:
            //		Executes this command; publishes a change view request to change to the view trash view.
            // tags:
            //		protected

            topic.publish("/epi/shell/context/request", { uri: "epi.cms.contentdata:///" + this._wasteBasketId }, 
                {sender: this, typeIdentifiers: this.typeIdentifiers });
        }
    });
});

},
'epi-cms/component/command/ChangeContext':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/topic",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/shell/command/_Command",
    "epi/i18n!epi/cms/nls/episerver.shared.action"
], function (declare, topic, ContentActionSupport, _Command, actionStrings) {

    // module:
    //		epi-cms/component/command/ChangeContext
    // summary:
    //		A command that issues a request to change the context to the model.

    return declare([_Command], {

        contentActionSupport: null,

        // Force reload context if current contentLink are the same contentLink.
        // tags:
        //		protected
        forceContextChange: false,

        // viewType: [public] String
        //      Optional parameter if there is a specific view type that should be requested
        viewType: null,

        // viewType: [public] String
        //      Optional parameter if there is a specific view name that should be requested
        viewName: null,

        postscript: function () {
            this.inherited(arguments);
            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;
        },

        _execute: function () {
            // summary:
            //		Executes this command; publishes a context change request to change to the model item.
            // tags:
            //		protected

            topic.publish("/epi/shell/context/request", { uri: this.model.uri }, { sender: null, forceContextChange: this.forceContextChange, viewType: this.viewType, viewName: this.viewName });
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            // In case when input model is an array. Can excute command only when array model have only 1 item
            // Command is not support for multiple items.
            if (this.model && this.model.length == 1) {
                this.model = this.model[0];
            }

            var model = this.model && this.model.contentLink;

            this.set("canExecute", !!model);

            if (model && this.model.accessMask) {
                if (this.contentActionSupport.hasAccess(this.model.accessMask, this.contentActionSupport.accessLevel[this.contentActionSupport.action.Edit])) {
                    this.set("label", actionStrings.edit);
                    this.set("iconClass", "epi-iconPen");
                }
                else {
                    this.set("label", actionStrings.view);
                    this.set("iconClass", "epi-iconSearch");
                }
            }
        }
    });
});

},
'epi-cms/widget/viewmodel/MultipleFileUploadViewModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",

    "dojo/when",

    "dojo/Stateful",
// epi
    "epi/shell/_StatefulGetterSetterMixin"
],

function (
// dojo
    array,
    declare,

    when,

    Stateful,
// epi
    _StatefulGetterSetterMixin
) {

    // module:
    //      epi-cms/widget/viewmodel/MultipleFileUploadViewModel
    // summary:
    //      View model for multiple file upload widget.
    // tags:
    //      public

    return declare([Stateful, _StatefulGetterSetterMixin], {

        upload: function (/*Array*/uploadingFiles) {
            // summary:
            //      Upload selected file(s) to server.
            //      It will show confirmation dialog that ask for replace/skip existing files.
            //      The filter condition is a file name and a content name.
            // uploadingFiles: [Array]
            //      Selected file(s) to upload
            // returns: [dojo.Deferred]
            //      An instance of Array for filtered file list to upload to server.
            //      This list can be the whole original selected file(s) or just the new file(s) that not existed on the server.
            // tags:
            //      public

            return when(this._filterUploadingFiles(uploadingFiles), function (/*Object*/filteredResult) {
                // filteredResult: [Object]
                //      existingContents: [Array]
                //          Existing content list
                //      newFiles: [Array]
                //          New uploading file list

                if (!filteredResult || !(filteredResult.existingContents instanceof Array) || filteredResult.existingContents.length === 0) {
                    return {
                        showConfirmation: false,
                        uploadingFiles: uploadingFiles
                    };
                }

                // Show confirmation dialog for replace/skip file(s) if it got any existing contents (have the same name) from server
                return {
                    showConfirmation: true,
                    uploadingFiles: uploadingFiles,
                    newFiles: filteredResult.newFiles,
                    existingContents: filteredResult.existingContents
                };
            });
        },

        _filterUploadingFiles: function (/*Array*/uploadingFiles) {
            // summary:
            //      Filters the given uploading files, check to see the list contains existing files on the server or not.
            //      It will return an existing content list and a list of new files.
            //      The filter condition is a file name and a content name.
            // uploadingFiles: [Array]
            //      Selected file(s) to upload
            // returns: [Object]
            //      filteredResult: [Object]
            //          existingContents: [Array]
            //              Existing content list
            //          newFiles: [Array]
            //              New uploading file list
            // tags:
            //      private

            var self = this;
            // If no store given, just return the whole original uploading file list
            if (!self.store) {
                return null;
            }

            return when(self.store.query(self.get("query")), function (/*Array*/contentList) {

                // Get existing content list
                var existingContents = array.filter(contentList, function (content) {
                    return array.some(uploadingFiles, function (file) {
                        return file.name.toLowerCase() === content.name.toLowerCase();
                    });
                });

                // Get new file list (that not existed on the server)
                var newFiles = array.filter(uploadingFiles, function (file) {
                    return array.every(contentList, function (content) {
                        return file.name.toLowerCase() !== content.name.toLowerCase();
                    });
                });

                return {
                    existingContents: existingContents,
                    newFiles: newFiles
                };
            });
        }

    });

});
},
'epi-cms/widget/MultipleFileUpload':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/dom-style",

    "dojo/aspect",
    "dojo/when",

    "dojo/Evented",
// dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

    "dijit/Toolbar",
// dojox
    "dojox/form/Uploader",
    "dojox/form/uploader/plugins/Flash",
// epi
    "epi/routes",

    "epi/shell/widget/dialog/Alert",

    "epi-cms/widget/Breadcrumb",
    "epi-cms/widget/FileList",
    "epi-cms/widget/MultipleFileUploadConfirmation",
    "epi-cms/widget/UploadUtil",

    "epi-cms/widget/viewmodel/FileListViewModel",
// templates
    "dojo/text!./templates/MultipleFileUpload.html",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.uploadmultiplefiles"
],

function (
// dojo
    array,
    declare,
    lang,

    domClass,
    domGeometry,
    domStyle,

    aspect,
    when,

    Evented,
// dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

    Toolbar,
// dojox
    Uploader,
    Flash,
// epi
    routes,

    Alert,

    Breadcrumb,
    FileList,
    MultipleFileUploadConfirmation,
    UploadUtil,

    FileListModel,
// templates
    template,
// resources
    resources
) {

    // module:
    //      epi-cms/widget/MultipleFileUpload
    // summary:
    //      Multiple file upload dialog widget. Use HTML5 native Dnd file(s) in Chrome, Firefox and Flash upload component in IE.
    // tags:
    //      public

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, Evented], {

        // widget resources
        res: resources,

        // _isCompleted: [private] Boolean
        //      Status of upload files progress
        _isCompleted: true,

        // Upload failed exception list
        _uploadStatus: [],

        // templateString: String
        //  Template for the widget
        templateString: template,

        // =======================================================================
        // Public overrided functions

        postCreate: function () {

            this.inherited(arguments);

            this._setupUploader();
            this._setupFileList();

            this._confirmationDialog = this._confirmationDialog || new MultipleFileUploadConfirmation();
        },

        // =======================================================================
        // Public functions

        upload: function (/*Array*/uploadingFiles) {
            // summary:
            //      Upload files to a directory.
            // uploadingFiles: [Array]
            //      Collection of file to upload
            // tags:
            //      public

            var self = this,
                uploader = self.uploaderInput,
                uploadSettings = self._getUploadSettings();

            when(self.model.upload(uploadingFiles), function (/*Object*/result) {

                when(self._confirm(result), function (confirmedFiles) {
                    self._resetUploader();

                    if (!(confirmedFiles instanceof Array) || confirmedFiles.length === 0) {
                        return;
                    }

                    self._fileListModel.set("uploadFiles", confirmedFiles);
                    uploader._files = confirmedFiles;

                    // Call uploader plugin upload(/*Object?*/formData) function
                    uploader.upload(uploadSettings);
                });
            });
        },

        close: function () {
            // summary:
            //      Close upload mutiple files dialog.
            // tags:
            //      public

            var self = this,
                files = self.uploaderInput._files,
                releaseDialog = function (uploading) {
                    // Inactive layer overlay toolbar
                    self.emit("close", uploading);
                    self.set("disableToolbar", false);
                };

            if (self._isCompleted || !files || files.length <= 0) {
                releaseDialog(false);
            } else {
                // Confirm dialog to verify if stopping the upload files.
                var dialog = new Alert({
                    description: resources.confirmdialog.description,
                    onAction: function () {
                        releaseDialog(true);
                    }
                });

                dialog.show();
            }
        },

        // =======================================================================
        // Protected functions

        _setUploadStatusAttr: function (/*Integer*/scope, /*String*/fileName, /*String*/errorMessage) {
            // summary:
            //      Append upload status to list.
            // tags:
            //      protected

            this._uploadStatus = UploadUtil.addStatus(this._uploadStatus, scope, fileName, errorMessage);
        },

        _getUploadStatusAttr: function () {
            // summary:
            //      Return upload status data.
            // tags:
            //      protected

            return this._uploadStatus;
        },

        _setBreadcrumbAttr: function (/*Array*/parts) {
            // summary:
            //      Build breadcrumb
            // tags:
            //      protected

            // Display server path of files directory.
            this.breadcrumbBar._cleanUp();
            this.breadcrumbBar._availableWidth = domGeometry.getContentBox(this.breadcrumbBar.domNode).w;

            var i = 0,
                length = parts ? parts.length : 0;

            if (length > 0) {
                for (i; i < length - 1; i++) {
                    this.breadcrumbBar._createItem(parts[i], true);
                }

                this.breadcrumbBar._createItem(parts[length - 1], false);
            }
        },

        _setDisableToolbarAttr: function (/*Boolean*/disabled) {
            // summary:
            //      Active/Inactive upload button.
            // tags:
            //      protected

            var uploader = this.uploaderInput;

            if (UploadUtil.supportNativeDndFiles()) {
                uploader.set("disabled", disabled);

                // Have to reset tabIndex since the uploader implementation doesn't do this when it's enabled again
                !disabled && uploader.set("tabindex", 0);
            } else {
                domClass.toggle(this.toolbarDisableLayer, "epi-uploadToolbarOverlay", disabled);
                UploadUtil.toggleVisibility(this.toolbarDisableLayer, disabled);

                // Have to reset tabIndex since the uploader implementation doesn't do this when it's enabled again.
                // Otherwise, disable mouse enter to open selecte file(s) dialog when uploading
                uploader.flashMovie && (disabled === false ? uploader.flashMovie.focus() : uploader.flashMovie.blur());

                if (disabled === true && !this._toolbarSize) {
                    this._toolbarSize = domGeometry.position(this.uploadToolbar);
                    domStyle.set(this.toolbarDisableLayer, {
                        "width": this._toolbarSize.w + "px",
                        "height": this._toolbarSize.h + "px"
                    });
                }
            }
        },

        // =======================================================================
        // Private functions

        _setupUploader: function () {
            // summary:
            //      Settings for uploader
            // tags:
            //      private

            this._setupUploaderDefault();
            this._setupUploaderHtml5Plugin();
            this._setupUploaderFlashPlugin();
        },

        _setupUploaderDefault: function () {
            // summary:
            //      Default custom settings for uploader
            // tags:
            //      private

            var self = this,
                uploader = self.uploaderInput;

            // set the action path for upload form
            uploader.uploadUrl = routes.getActionPath({
                moduleArea: "CMS",
                controller: "FileUpload",
                action: "Upload"
            });

            // To pass uploadDirectory to this.onChange delegate, in order to indicate the folder to upload files into.
            self.own(
                aspect.before(uploader, "onChange", function (/*Array*/fileArray) {
                    self._isCompleted = false;
                    self.set("disableToolbar", true);

                    return [self._getUploadSettings()];
                })
            );
        },

        _setupUploaderHtml5Plugin: function () {
            // summary:
            //      Custom setting for native html5 uploader
            // tags:
            //      private

            if (!UploadUtil.supportNativeDndFiles()) {
                return;
            }

            var self = this;
            // To catch error, for example: over max size limit exception, or server not found error.
            self.own(
                self.uploaderInput.on("error", function (err) {
                    self.set("uploadStatus", UploadUtil.StatusScope.All, "", resources.uploadform.errormessage);
                    self._onUploadComplete();
                })
            );
        },

        _setupUploaderFlashPlugin: function () {
            // summary:
            //      Custom settings for flash uploader
            // tags:
            //      private)

            if (UploadUtil.supportNativeDndFiles()) {
                return;
            }

            var self = this;
            // To catch error, for example: over max size limit exception, or server not found error.
            self.own(
                self.uploaderInput.on("error", function (err) {
                    self.set("uploadStatus", UploadUtil.StatusScope.Single, err.target && err.target.name, resources.uploadform.errormessage);
                })
            );

            self._setFlashUploaderSize();
            self._setFocusOnFlash();
        },

        _setFlashUploaderSize: function () {
            // summary:
            //      Set flash uploader size fill fully its containers
            // tags:
            //      private

            this.own(
                aspect.around(this.uploaderInput, "_createInput", function (original) {
                    return function () {
                        var originalSize = lang.clone(this.btnSize);
                        this.btnSize.w += 10;
                        this.btnSize.h += 10;

                        original.apply(this, arguments);

                        this.btnSize = originalSize;
                    };
                })
            );
        },

        _setFocusOnFlash: function () {
            // summary:
            //      Set focus on flash uploader
            // tags:
            //      private

            var uploader = this.uploaderInput;
            // manually focus swf object
            ["focus", "load"].forEach(function (event) {
                uploader.on(event, function () {
                    setTimeout(function () {
                        var swf = uploader.flashMovie;
                        if (swf) {
                            swf.focus();
                        }

                        return;
                    }, 1);
                });
            }, this);
        },

        _getUploadSettings: function () {
            // summary:
            //      Get uploading settings
            // returns: [Object]
            //      Object's properties
            //          useFlash: [Boolean]
            //          uploadDirectory: [String]
            //          createAsLocalAsset: [Boolean]
            // tags:
            //      private

            return {
                "useFlash": !UploadUtil.supportNativeDndFiles(),
                "uploadDirectory": this.get("uploadDirectory"),
                "createAsLocalAsset": this.get("createAsLocalAsset")
            };
        },

        _setupFileList: function () {
            // summary:
            //      Listen on uploader events to controls file list
            // tags:
            //      private

            var self = this,
                uploader = this.uploaderInput;

            self._fileListModel = new FileListModel();
            self.fileList.set("model", self._fileListModel);

            // Reset file list
            this.own(
                // Show progress bar
                uploader.on("begin", function (files) {
                    if (files && files.length > 0) {
                        self._fileListModel.set("showProgressBar", true);
                    }
                }),
                // Show uploading progress
                uploader.on("progress", function (customEvent) {
                    self._fileListModel.set("progress", customEvent);
                }),
                uploader.on("complete", lang.hitch(self, self._onUploadComplete)),

                aspect.after(uploader, "reset", lang.hitch(self, self._fileListModel.clear)),

                // Set upload files to file list model
                aspect.around(uploader, "onChange", function (original) {

                    return function (/*Array*/fileArray) {

                        var uploadingFiles = uploader._files;

                        return when(self.model.upload(uploadingFiles), function (/*Object*/result) {

                            return when(self._confirm(result), function (confirmedFiles) {
                                self._clearUploadStatus();

                                confirmedFiles = UploadUtil.getFileArray(confirmedFiles);

                                if (!(confirmedFiles instanceof Array) || confirmedFiles.length === 0) {
                                    self._resetUploader();
                                    return original.apply(uploader, [fileArray]);
                                }

                                self._fileListModel.set("uploadFiles", confirmedFiles);
                                uploader._files = confirmedFiles;
                                uploader.upload(self._getUploadSettings());

                                return original.apply(uploader, [fileArray]);
                            });
                        });
                    };
                })
            );
        },

        _confirm: function (/*Object*/result) {
            // summary:
            //      Get confirmed file collection to upload to server
            // result: [Object]
            //      Filtered result information
            // returns: [dojo.Deferred]
            //      File collection to upload to server
            // tags:
            //      private

            return result.showConfirmation === true
                ? this._confirmationDialog.showConfirmation(result.existingContents, result.uploadingFiles, result.newFiles)
                : result.uploadingFiles;
        },

        _clearUploadStatus: function () {
            // summary:
            //      Clear upload status data.
            // tags:
            //      private

            this._uploadStatus = [];
        },

        _clearUploadFiles: function () {
            // summary:
            //      Clear uploaded files data.
            // tags:
            //      private

            this.uploaderInput._files = [];
        },

        _resetUploader: function () {
            // summary:
            //      Hide uploading progress bar.
            //      Call dojox uploader reset function.
            // tags:
            //      private

            var self = this,
                uploader = self.uploaderInput,
                resetUploader = function () {
                    self._fileListModel.set("showProgressBar", false);

                    // make sure the file list is empty, to set new files
                    uploader.reset();
                    self.set("disableToolbar", false);
                };

            if (UploadUtil.supportNativeDndFiles()) {
                resetUploader();
                return;
            }

            // Check flashMovie exists before call reset() in Flash.js widget.
            (uploader.flashMovie && uploader.flashMovie["reset"]) && resetUploader();
        },

        _onUploadComplete: function (evt) {
            // summary:
            //      Fires when all files have uploaded.
            //      Event is an array of all files.
            // tags:
            //      private

            this._isCompleted = true;

            // update upload status for file list:
            if (evt) {
                if (evt instanceof Array) {
                    var message = "";
                    array.forEach(evt, function (item) {
                        // Special case in flash upload, based on its default timeout setting (2 seconds)
                        message = item.errorMessage || item.error; // item.error property here returned by flash uploader
                        if (message !== "server timeout") {
                            if (!UploadUtil.supportNativeDndFiles() && item.additionalParams && item.additionalParams.replaceChar) {
                                UploadUtil.setAltCommaChar(item.additionalParams.replaceChar);
                            }

                            this.set("uploadStatus", item.index ? UploadUtil.StatusScope.Single : UploadUtil.StatusScope.All, item.fileName || item.name, message);
                        }
                    }, this);
                } else if (evt.isValid === false && evt.saved === false) {
                    this.set("uploadStatus", UploadUtil.StatusScope.All, "", evt.errorMessage);
                }
            }

            this._fileListModel.set("uploadStatus", this.get("uploadStatus"));

            this.set("disableToolbar", false);
            this._clearUploadFiles();
            this.emit("uploadComplete", !this._fileListModel.uploadStatus ? this._fileListModel.uploadFiles : null);
        }

    });

});
},
'dojox/form/uploader/plugins/Flash':function(){
define("dojox/form/uploader/plugins/Flash", [
	"dojo/dom-form",
	"dojo/dom-style",
	"dojo/dom-construct",
	"dojo/dom-attr",
	"dojo/_base/declare",
	"dojo/_base/config",
	"dojo/_base/connect",
	"dojo/_base/lang",
	"dojo/_base/array",
	"dojox/form/uploader/plugins/HTML5",
	"dojox/embed/Flash"
],function(domForm, domStyle, domConstruct, domAttr, declare, config, connect, lang, array, formUploaderPluginsHTML5, embedFlash){


var pluginsFlash = declare("dojox.form.uploader.plugins.Flash", [], {
	// summary:
	//		A plugin for dojox.form.Uploader that utilizes a Flash SWF for handling to upload in IE.
	//		All other browsers will use the HTML5 plugin, unless force="flash" is used, then Flash
	//		will be used in all browsers. force="flash"	is provided because Flash has some features
	//		that HTML5 does not yet have. But it is still not recommended because of the many problems
	//		that Firefox and Webkit have with the Flash plugin.
	//
	// description:
	//		Inherits all properties from dojox.form.Uploader and formUploaderPluginsHTML5.
	//		All properties and methods listed here are specific to the Flash plugin only.
	//
	//		Version: 1.6

	
	// swfPath:String
	//		Path to SWF. Can be overwritten or provided in djConfig.
	swfPath:config.uploaderPath || require.toUrl("dojox/form/resources/uploader.swf"),

	// skipServerCheck: Boolean
	//		If true, will not verify that the server was sent the correct format.
	//		This can be safely set to true. The purpose of the server side check
	//		is mainly to show the dev if they've implemented the different returns
	//		correctly.
	skipServerCheck:true,

	// serverTimeout:Number (milliseconds)
	//		The amount of time given to the uploaded file
	//		to wait for a server response. After this amount
	//		of time, the onComplete is fired but with a 'server timeout'
	//		error in the returned item.
	serverTimeout: 2000,

	// isDebug: Boolean
	//		If true, outputs traces from the SWF to console. What exactly gets passed
	//		is very relative, and depends upon what traces have been left in the DEFT SWF.
	isDebug:false,

	// devMode: Boolean.
	//		Re-implemented. devMode increases the logging, adding style tracing from the SWF.
	devMode:false,

	// deferredUploading: Number (1 - X)
	//		(Flash only) throttles the upload to a certain amount of files at a time.
	//		By default, Flash uploads file one at a time to the server, but in parallel.
	//		Firefox will try to queue all files at once, leading to problems. Set this
	//		to the amount to upload in parallel at a time.
	//		Generally, 1 should work fine, but you can experiment with queuing more than
	//		one at a time.
	//		This is of course ignored if selectMultipleFiles equals false.
	deferredUploading:0,

	// force: String
	//		Use "flash" to always use Flash (and hopefully force the user to download the plugin
	//		if they don't have it).
	force:"",

	postMixInProperties: function(){
		if(!this.supports("multiple")){
			// Flash will only be used in IE6-8 unless force="flash"
			this.uploadType = "flash";
			this._files = [];
			this._fileMap = {};
			this._createInput = this._createFlashUploader;
			this.getFileList = this.getFlashFileList;
			this.reset = this.flashReset;
			this.upload = this.uploadFlash;
			this.fieldname = "flashUploadFiles"; ///////////////////// this.name
		}
		this.inherited(arguments);
	},

	/*************************
	 *	   Public Events	 *
	 *************************/

	onReady: function(/*dojox/form/FileUploader*/ uploader){
		// summary:
		//		Stub - Fired when embedFlash has created the
		//		Flash object, but it has not necessarilly finished
		//		downloading, and is ready to be communicated with.
	},

	onLoad: function(/*dojox/form/FileUploader*/ uploader){
		// summary:
		//		Stub - SWF has been downloaded 100%.
	},

	onFileChange: function(fileArray){
		// summary:
		//		Stub - Flash-specific event. Fires on each selection of files
		//		and only provides the files selected on that event - not all files
		//		selected, as with HTML5
	},

	onFileProgress: function(fileArray){
		// summary:
		//		Stub - Flash-specific event. Fires on progress of upload
		//		and only provides a file-specific event
	},


	/*************************
	 *	   Public Methods	 *
	 *************************/

	getFlashFileList: function(){
		// summary:
		//		Returns list of currently selected files
		return this._files; // Array
	},

	flashReset: function(){
		this.flashMovie.reset();
		this._files = [];
	},

	/*************************
	 *	   Private Methods	 *
	 *************************/

	uploadFlash: function(/*Object ? */ formData){
		// summary:
		//		Uploads selected files. Alias "upload()" should be used instead.
		// tags:
		//		private
		this.onBegin(this.getFileList());
		formData.returnType = "F";
		this.flashMovie.doUpload(formData);
	},

	_change: function(fileArray){
		this._files = this._files.concat(fileArray);
		array.forEach(fileArray, function(f){
			f.bytesLoaded = 0;
			f.bytesTotal = f.size;
			this._fileMap[f.name+"_"+f.size] = f;
		}, this);
		this.onChange(this._files);
		this.onFileChange(fileArray);
	},
	_complete: function(fileArray){
		var o = this._getCustomEvent();
		o.type = "load";
		this.onComplete(fileArray);
	},
	_progress: function(f){
		this._fileMap[f.name+"_"+f.bytesTotal].bytesLoaded = f.bytesLoaded;
		var o = this._getCustomEvent();
		this.onFileProgress(f);
		this.onProgress(o);
	},
	_error: function(err){
		this.onError(err);
	},
	_onFlashBlur: function(fileArray){
		//console.log("UploaderFlash._onFlashBlur");
	},

	_getCustomEvent: function(){
		var o = {
			bytesLoaded:0,
			bytesTotal:0,
			type:"progress",
			timeStamp:new Date().getTime()
		};


		for(var nm in this._fileMap){
			o.bytesTotal += this._fileMap[nm].bytesTotal;
			o.bytesLoaded += this._fileMap[nm].bytesLoaded;
		}
		o.decimal = o.bytesLoaded / o.bytesTotal;
		o.percent = Math.ceil((o.bytesLoaded / o.bytesTotal)*100)+"%";
		return o; // Object
	},

	_connectFlash: function(){
		// summary:
		//		Subscribing to published topics coming from the
		//		Flash uploader.

		// Sacrificing some readability for compactness. this.id
		// will be on the beginning of the topic, so more than
		// one uploader can be on a page and can have unique calls.

		this._subs = [];
		this._cons = [];

		var doSub = lang.hitch(this, function(s, funcStr){
			this._subs.push(connect.subscribe(this.id + s, this, funcStr));
		});

		doSub("/filesSelected", "_change");
		doSub("/filesUploaded", "_complete");
		doSub("/filesProgress", "_progress");
		doSub("/filesError", "_error");
		doSub("/filesCanceled", "onCancel");
		doSub("/stageBlur", "_onFlashBlur");

		this.connect(this.domNode, "focus", function(){
			// TODO: some kind of indicator that the Flash button is in focus
			this.flashMovie.focus();
			this.flashMovie.doFocus();
		});
		if(this.tabIndex>=0){
			domAttr.set(this.domNode, "tabIndex", this.tabIndex);
		}
	},
	_createFlashUploader: function(){
		// summary:
		//		Internal. Creates Flash Uploader

		var w = this.btnSize.w;
		var h = this.btnSize.h;
		if(!w){
			// FIXME: Commit this
			setTimeout(dojo.hitch(this, function(){
				this._getButtonStyle(this.domNode);
				this._createFlashUploader();
			}), 200);
			return;
		}
		var url = this.getUrl();
		if(url){
			if(url.toLowerCase().indexOf("http")<0 && url.indexOf("/")!=0){
				// Appears to be a relative path. Attempt to
				// convert it to absolute, so it will better
				// target the SWF.
				var loc = window.location.href.split("/");
				loc.pop();
				loc = loc.join("/")+"/";
				url = loc+url;
			}
		}else{
			console.warn("Warning: no uploadUrl provided.");
		}

		this.inputNode = domConstruct.create("div", {className:"dojoxFlashNode"}, this.domNode, "first");
		domStyle.set(this.inputNode, {
			position:"absolute",
			top:"-2px",
			width:w+"px",
			height:h+"px",
			opacity:0
		});



		var args = {
			expressInstall:true,
			path: (this.swfPath.uri || this.swfPath) + "?cb_" + (new Date().getTime()),
			width: w,
			height: h,
			allowScriptAccess:"always",
			allowNetworking:"all",
			vars: {
				uploadDataFieldName: this.flashFieldName || this.name+"Flash",
				uploadUrl: url,
				uploadOnSelect: this.uploadOnSelect,
				deferredUploading:this.deferredUploading || 0,
				selectMultipleFiles: this.multiple,
				id: this.id,
				isDebug: this.isDebug,
				noReturnCheck: this.skipServerCheck,
				serverTimeout:this.serverTimeout
			},
			params: {
				scale:"noscale",
				wmode:"transparent",
				wmode:"opaque",
				allowScriptAccess:"always",
				allowNetworking:"all"
			}

		};

		this.flashObject = new embedFlash(args, this.inputNode);
		this.flashObject.onError = lang.hitch(function(msg){
			console.error("Flash Error: " + msg);
		});
		this.flashObject.onReady = lang.hitch(this, function(){
			this.onReady(this);
		});
		this.flashObject.onLoad = lang.hitch(this, function(mov){
			this.flashMovie = mov;
			this.flashReady = true;

			this.onLoad(this);
		});
		this._connectFlash();
	}
});
dojox.form.addUploaderPlugin(pluginsFlash);


return pluginsFlash;
});

},
'dojox/embed/Flash':function(){
define("dojox/embed/Flash", ["dojo"], function(dojo) {

	// module:
	//		dojox/embed/Flash
	// summary:
	//		Base functionality to insert a flash movie into
	//		a document on the fly.
	// example:
	//	|	var movie=new Flash({ args }, containerNode);


	var fMarkup, fVersion;
	var minimumVersion = 9; // anything below this will throw an error (may overwrite)
	var keyBase = "dojox-embed-flash-", keyCount=0;
	var _baseKwArgs = {
		expressInstall: false,
		width: 320,
		height: 240,
		swLiveConnect: "true",
		allowScriptAccess: "sameDomain",
		allowNetworking:"all",
		style: null,
		redirect: null
	};

	function prep(kwArgs){
		kwArgs = dojo.delegate(_baseKwArgs, kwArgs);

		if(!("path" in kwArgs)){
			console.error("dojox.embed.Flash(ctor):: no path reference to a Flash movie was provided.");
			return null;
		}

		if(!("id" in kwArgs)){
			kwArgs.id = (keyBase + keyCount++);
		}
		return kwArgs;
	}

	if(dojo.isIE){
		fMarkup = function(kwArgs){
			kwArgs = prep(kwArgs);
			if(!kwArgs){ return null; }

			var p;
			var path = kwArgs.path;
			if(kwArgs.vars){
				var a = [];
				for(p in kwArgs.vars){
					a.push(p + '=' + kwArgs.vars[p]);
				}
				kwArgs.params.FlashVars = a.join("&");
				delete kwArgs.vars;
			}
			var s = '<object id="' + kwArgs.id + '" '
				+ 'classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" '
				+ 'width="' + kwArgs.width + '" '
				+ 'height="' + kwArgs.height + '"'
				+ ((kwArgs.style)?' style="' + kwArgs.style + '"':'')
				+ '>'
				+ '<param name="movie" value="' + path + '" />';
			if(kwArgs.params){
				for(p in kwArgs.params){
					s += '<param name="' + p + '" value="' + kwArgs.params[p] + '" />';
				}
			}
			s += '</object>';
			return { id: kwArgs.id, markup: s };
		};

		fVersion = (function(){
			var testVersion = 10, testObj = null;
			while(!testObj && testVersion > 7){
				try {
					testObj = new ActiveXObject("ShockwaveFlash.ShockwaveFlash." + testVersion--);
				}catch(e){ }
			}
			if(testObj){
				var v = testObj.GetVariable("$version").split(" ")[1].split(",");
				return {
					major: (v[0]!=null) ? parseInt(v[0]) : 0,
					minor: (v[1]!=null) ? parseInt(v[1]) : 0,
					rev: (v[2]!=null) ? parseInt(v[2]) : 0
				};
			}
			return { major: 0, minor: 0, rev: 0 };
		})();

		//	attach some cleanup for IE, thanks to deconcept :)
		dojo.addOnUnload(function(){
			var dummy = function(){};
			var objs = dojo.query("object").
				reverse().
				style("display", "none").
				forEach(function(i){
					for(var p in i){
						if((p != "FlashVars") && dojo.isFunction(i[p])){
							try{
								i[p] = dummy;
							}catch(e){}
						}
					}
				});
		});

	} else {
		//	*** Sane browsers branch ******************************************************************
		fMarkup = function(kwArgs){
			kwArgs = prep(kwArgs);
			if(!kwArgs){ return null; }

			var p;
			var path = kwArgs.path;
			if(kwArgs.vars){
				var a = [];
				for(p in kwArgs.vars){
					a.push(p + '=' + kwArgs.vars[p]);
				}
				kwArgs.params.flashVars = a.join("&");
				delete kwArgs.vars;
			}
			var s = '<embed type="application/x-shockwave-flash" '
				+ 'src="' + path + '" '
				+ 'id="' + kwArgs.id + '" '
				+ 'width="' + kwArgs.width + '" '
				+ 'height="' + kwArgs.height + '"'
				+ ((kwArgs.style)?' style="' + kwArgs.style + '" ':'')

				+ 'pluginspage="' + window.location.protocol + '//www.adobe.com/go/getflashplayer" ';
			if(kwArgs.params){
				for(p in kwArgs.params){
					s += ' ' + p + '="' + kwArgs.params[p] + '"';
				}
			}
			s += ' />';
			return { id: kwArgs.id, markup: s };
		};

		fVersion=(function(){
			var plugin = navigator.plugins["Shockwave Flash"];
			if(plugin && plugin.description){
				var v = plugin.description.replace(/([a-zA-Z]|\s)+/, "").replace(/(\s+r|\s+b[0-9]+)/, ".").split(".");
				return {
					major: (v[0]!=null) ? parseInt(v[0]) : 0,
					minor: (v[1]!=null) ? parseInt(v[1]) : 0,
					rev: (v[2]!=null) ? parseInt(v[2]) : 0
				};
			}
			return { major: 0, minor: 0, rev: 0 };
		})();
	}


/*=====
var __flashArgs = {
	// path: String
	//		The URL of the movie to embed.
	// id: String?
	//		A unique key that will be used as the id of the created markup.  If you don't
	//		provide this, a unique key will be generated.
	// width: Number?
	//		The width of the embedded movie; the default value is 320px.
	// height: Number?
	//		The height of the embedded movie; the default value is 240px
	// minimumVersion: Number?
	//		The minimum targeted version of the Flash Player (defaults to 9)
	// style: String?
	//		Any CSS style information (i.e. style="background-color:transparent") you want
	//		to define on the markup.
	// params: Object?
	//		A set of key/value pairs that you want to define in the resultant markup.
	// vars: Object?
	//		A set of key/value pairs that the Flash movie will interpret as FlashVars.
	// expressInstall: Boolean?
	//		Whether or not to include any kind of expressInstall info. Default is false.
	// redirect: String?
	//		A url to redirect the browser to if the current Flash version is not supported.
};
=====*/

	//	the main entry point
	var Flash = function(/*__flashArgs*/ kwArgs, /*DOMNode*/ node){
		// summary:
		//		Create a wrapper object around a Flash movie; this is the DojoX equivilent
		//		to SWFObject.
		//
		// description:
		//		Creates a wrapper object around a Flash movie.  Wrapper object will
		//		insert the movie reference in node; when the browser first starts
		//		grabbing the movie, onReady will be fired; when the movie has finished
		//		loading, it will fire onLoad.
		//
		//		If your movie uses ExternalInterface, you should use the onLoad event
		//		to do any kind of proxy setup (see dojox.embed.Flash.proxy); this seems
		//		to be the only consistent time calling EI methods are stable (since the
		//		Flash movie will shoot several methods into the window object before
		//		EI callbacks can be used properly).
		//
		// kwArgs: __flashArgs
		//		The various arguments that will be used to help define the Flash movie.
		// node: DomNode
		//		The node where the embed object will be placed
		//
		// example:
		//		Embed a flash movie in a document using the new operator, and get a reference to it.
		//	|	var movie = new dojox.embed.Flash({
		//	|		path: "path/to/my/movie.swf",
		//	|		width: 400,
		//	|		height: 300
		//	|	}, myWrapperNode, "testLoaded");
		//
		// example:
		//		Embed a flash movie in a document without using the new operator.
		//	|	var movie = dojox.embed.Flash({
		//	|		path: "path/to/my/movie.swf",
		//	|		width: 400,
		//	|		height: 300,
		//	|		style: "position:absolute;top:0;left:0"
		//	|	}, myWrapperNode, "testLoaded");

		// File can only be run from a server, due to SWF dependency.
		if(location.href.toLowerCase().indexOf("file://")>-1){
			throw new Error("dojox.embed.Flash can't be run directly from a file. To instatiate the required SWF correctly it must be run from a server, like localHost.");
		}

		// available: Number
		//		If there is a flash player available, and if so what version.
		this.available = dojox.embed.Flash.available;

		// minimumVersion: Number
		//		The minimum version of Flash required to run this movie.
		this.minimumVersion = kwArgs.minimumVersion || minimumVersion;

		// id: String
		//		The id of the DOMNode to be used for this movie.  Can be used with dojo.byId to get a reference.
		this.id = null;

		// movie: FlashObject
		//		A reference to the movie itself.
		this.movie = null;

		// domNode: DOMNode
		//		A reference to the DOMNode that contains this movie.
		this.domNode = null;
		if(node){
			node = dojo.byId(node);
		}
		// setTimeout Fixes #8743 - creating double SWFs
		// also allows time for code to attach to onError
		setTimeout(dojo.hitch(this, function(){
			if(kwArgs.expressInstall || this.available && this.available >= this.minimumVersion){
				if(kwArgs && node){
					this.init(kwArgs, node);
				}else{
					this.onError("embed.Flash was not provided with the proper arguments.");
				}
			}else{
				if(!this.available){
					this.onError("Flash is not installed.");
				}else{
					this.onError("Flash version detected: "+this.available+" is out of date. Minimum required: "+this.minimumVersion);
				}
			}
		}), 100);
	};

	dojo.extend(Flash, {
		onReady: function(/*HTMLObject*/ movie){
			// summary:
			//		Stub function for you to attach to when the movie reference is first
			//		pushed into the document.
		},
		onLoad: function(/*HTMLObject*/ movie){
			// summary:
			//		Stub function for you to attach to when the movie has finished downloading
			//		and is ready to be manipulated.
		},
		onError: function(msg){

		},
		_onload: function(){
			// summary:
			//	Internal. Cleans up before calling onLoad.
			clearInterval(this._poller);
			delete this._poller;
			delete this._pollCount;
			delete this._pollMax;
			this.onLoad(this.movie);
		},
		init: function(/*__flashArgs*/ kwArgs, /*DOMNode?*/ node){
			// summary:
			//		Initialize (i.e. place and load) the movie based on kwArgs.
			this.destroy();		//	ensure we are clean first.
			node = dojo.byId(node || this.domNode);
			if(!node){ throw new Error("dojox.embed.Flash: no domNode reference has been passed."); }

			// vars to help determine load status
			var p = 0, testLoaded=false;
			this._poller = null; this._pollCount = 0; this._pollMax = 15; this.pollTime = 100;

			if(dojox.embed.Flash.initialized){

				this.id = dojox.embed.Flash.place(kwArgs, node);
				this.domNode = node;

				setTimeout(dojo.hitch(this, function(){
					this.movie = this.byId(this.id, kwArgs.doc);
					this.onReady(this.movie);

					this._poller = setInterval(dojo.hitch(this, function(){

						// catch errors if not quite ready.
						try{
							p = this.movie.PercentLoaded();
						}catch(e){
							console.warn("this.movie.PercentLoaded() failed", e, this.movie);
						}

						if(p == 100){
							// if percent = 100, movie is fully loaded and we're communicating
							this._onload();

						}else if(p==0 && this._pollCount++ > this._pollMax){
							// after several attempts, we're not past zero.
							clearInterval(this._poller);
							throw new Error("Building SWF failed.");
						}
					}), this.pollTime);
				}), 1);
			}
		},
		_destroy: function(){
			// summary:
			//		Kill the movie and reset all the properties of this object.
			try{
				this.domNode.removeChild(this.movie);
			}catch(e){}
			this.id = this.movie = this.domNode = null;
		},
		destroy: function(){
			// summary:
			//		Public interface for destroying all the properties in this object.
			//		Will also clean all proxied methods.
			if(!this.movie){ return; }

			//	remove any proxy functions
			var test = dojo.delegate({
				id: true,
				movie: true,
				domNode: true,
				onReady: true,
				onLoad: true
			});
			for(var p in this){
				if(!test[p]){
					delete this[p];
				}
			}

			//	poll the movie
			if(this._poller){
				//	wait until onLoad to destroy
				dojo.connect(this, "onLoad", this, "_destroy");
			} else {
				this._destroy();
			}
		},
		byId: function (movieName, doc){
			// summary:
			//		Gets Flash movie by id.
			// description:
			//		Probably includes methods for outdated
			//		browsers, but this should catch all cases.
			// movieName: String
			//		The name of the SWF
			// doc: Object
			//		The document, if not current window
			//		(not fully supported)
			// example:
			//	|	var movie = dojox.embed.Flash.byId("myId");

			doc = doc || document;
			if(doc.embeds[movieName]){
				return doc.embeds[movieName];
			}
			if(doc[movieName]){
				return doc[movieName];
			}
			if(window[movieName]){
				return window[movieName];
			}
			if(document[movieName]){
				return document[movieName];
			}
			return null;
		}
	});

	//	expose information through the constructor function itself.
	dojo.mixin(Flash, {
		// summary:
		//		A singleton object used internally to get information
		//		about the Flash player available in a browser, and
		//		as the factory for generating and placing markup in a
		//		document.
		//
		// minSupported: Number
		//		The minimum supported version of the Flash Player, defaults to 8.
		// available: Number
		//		Used as both a detection (i.e. if(dojox.embed.Flash.available){ })
		//		and as a variable holding the major version of the player installed.
		// supported: Boolean
		//		Whether or not the Flash Player installed is supported by dojox.embed.
		// version: Object
		//		The version of the installed Flash Player; takes the form of
		//		{ major, minor, rev }.  To get the major version, you'd do this:
		//		var v=dojox.embed.Flash.version.major;
		// initialized: Boolean
		//		Whether or not the Flash engine is available for use.
		// onInitialize: Function
		//		A stub you can connect to if you are looking to fire code when the
		//		engine becomes available.  A note: DO NOT use this event to
		//		place a movie in a document; it will usually fire before DOMContentLoaded
		//		is fired, and you will get an error.  Use dojo.addOnLoad instead.
		minSupported : 8,
		available: fVersion.major,
		supported: (fVersion.major >= fVersion.required),
		minimumRequired: fVersion.required,
		version: fVersion,
		initialized: false,
		onInitialize: function(){
			Flash.initialized = true;
		},
		__ie_markup__: function(kwArgs){
			return fMarkup(kwArgs);
		},
		proxy: function(/*Flash*/ obj, /*Array|String*/ methods){
			// summary:
			//		Create the set of passed methods on the Flash object
			//		so that you can call that object directly, as opposed to having to
			//		delve into the internal movie to do this.  Intended to make working
			//		with Flash movies that use ExternalInterface much easier to use.
			//
			// example:
			//		Create "setMessage" and "getMessage" methods on foo.
			//	|	var foo = new Flash(args, someNode);
			//	|	dojo.connect(foo, "onLoad", dojo.hitch(foo, function(){
			//	|		Flash.proxy(this, [ "setMessage", "getMessage" ]);
			//	|		this.setMessage("Flash.proxy is pretty cool...");
			//	|		console.log(this.getMessage());
			//	|	}));
			dojo.forEach((dojo.isArray(methods) ? methods : [ methods ]), function(item){
				this[item] = dojo.hitch(this, function(){
					return (function(){
						return eval(this.movie.CallFunction(
							'<invoke name="' + item + '" returntype="javascript">'
							+ '<arguments>'
							+ dojo.map(arguments, function(item){
								// FIXME:
								//		investigate if __flash__toXML will
								//		accept direct application via map()
								//		(e.g., does it ignore args past the
								//		first? or does it blow up?)
								return __flash__toXML(item);
							}).join("")
							+ '</arguments>'
							+ '</invoke>'
						));
					}).apply(this, arguments||[]);
				});
			}, obj);
		}
	});

	Flash.place = function(kwArgs, node){
		var o = fMarkup(kwArgs);
		node = dojo.byId(node);
		if(!node){
			node = dojo.doc.createElement("div");
			node.id = o.id+"-container";
			dojo.body().appendChild(node);
		}
		if(o){
			node.innerHTML = o.markup;
			return o.id;
		}
		return null;
	}
	Flash.onInitialize();

	dojo.setObject("dojox.embed.Flash", Flash);

	return Flash;
});

},
'epi-cms/widget/FileList':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-style",
// dojox
    "dojox/form/uploader/Base",
// dgrid
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    "dgrid/Keyboard",
// dijit
    "dijit/ProgressBar",
// epi
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/dgrid/Formatter",

    "epi-cms/widget/UploadUtil",
//resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.uploadmultiplefiles.uploadform",
// template
    "dojo/text!./templates/FileList.html"
],
function (
// dojo
    declare,
    lang,

    domAttr,
    domConstruct,
    domClass,
    domStyle,
// dojox
    formUploaderBase,
// dgrid
    OnDemandGrid,
    dgridSelection,
    Keyboard,
// dijit
    ProgressBar,
// epi
    _ModelBindingMixin,
    Formatter,

    UploadUtil,
// resources
    resources,
// template
    template
) {
    return declare([formUploaderBase, _ModelBindingMixin], {
        // summary:
        //      Widget to show uploading file(s).
        // tags:
        //      public

        templateString: template,

        // Map property name in view model to a list of properties in this widget
        modelBindingMap: {
            "showProgressBar": ["showProgressBar"],
            "progress": ["progress"],
            "uploadFiles": ["uploadFiles"]
        },

        postCreate: function () {
            this.inherited(arguments);

            this._buildGrid();
        },

        _setUploadFilesAttr: function (/* Array */files) {
            // summary:
            //      Give new data (upload files) for grid
            // tags:
            //      private

            this._bindData(files);
        },

        _setShowProgressBarAttr: function (/* Boolean */show) {
            // summary:
            //      Toggle visibility of progress bar
            // tags:
            //      private

            UploadUtil.toggleVisibility(this.progressBar.domNode, show);
        },

        _setProgressAttr: function (/* Object */progressObject) {
            // summary:
            //      Update uploading progress of progress bar
            // tags:
            //      private

            if (!progressObject) {
                return;
            }

            // update upload progress, by updating progress bar.
            this.progressBar.update({ progress: progressObject.percent.replace("%", "") });
        },

        _bindData: function (data) {
            // summary:
            //      Refresh and bind new data to grid
            // tags:
            //      private

            data = data || [];

            this._grid.refresh();
            this._grid.renderArray(data);
        },

        _buildGrid: function () {
            // summary:
            //      Build file(s) upload grid and append it to container
            // tags:
            //      private

            var gridClass = declare([OnDemandGrid, Keyboard, Formatter]);
            this._grid = new gridClass({
                columns: {
                    fileName: {
                        label: resources.uploadfilename,
                        field: "fileName",
                        htmlEncode: true
                    },
                    size: {
                        label: resources.uploadfilesize,
                        field: "size",
                        get: lang.hitch(this, function (file) {
                            var fileSizeValue = this.convertBytes(file.size).value;

                            if (isNaN(fileSizeValue)) {
                                return fileSizeValue;
                            }

                            var byteText = fileSizeValue === 0 ? resources.bytetext : resources.bytestext;
                            return lang.replace("{0} {1}", [fileSizeValue, byteText]);
                        })
                    },
                    status: {
                        label: resources.uploadfilestatus,
                        field: "status",
                        renderCell: lang.hitch(this, function (item, value, node, options) {
                            domAttr.set(node, "title", item.statusMessage ? item.statusMessage : "");
                            domClass.toggle(node, "epi-failedStatus", item.status === resources.failed);
                            node.innerHTML = item.status;
                        })
                    }
                }
            });

            this.own(this._grid);
            domConstruct.place(this._grid.domNode, this.domNode);
        }
    });
});

},
'dijit/ProgressBar':function(){
require({cache:{
'url:dijit/templates/ProgressBar.html':"<div class=\"dijitProgressBar dijitProgressBarEmpty\" role=\"progressbar\"\n\t><div  data-dojo-attach-point=\"internalProgress\" class=\"dijitProgressBarFull\"\n\t\t><div class=\"dijitProgressBarTile\" role=\"presentation\"></div\n\t\t><span style=\"visibility:hidden\">&#160;</span\n\t></div\n\t><div data-dojo-attach-point=\"labelNode\" class=\"dijitProgressBarLabel\" id=\"${id}_label\"></div\n\t><img data-dojo-attach-point=\"indeterminateHighContrastImage\" class=\"dijitProgressBarIndeterminateHighContrastImage\" alt=\"\"\n/></div>\n"}});
define("dijit/ProgressBar", [
	"require",			// require.toUrl
	"dojo/_base/declare", // declare
	"dojo/dom-class", // domClass.toggle
	"dojo/_base/lang", // lang.mixin
	"dojo/number", // number.format
	"./_Widget",
	"./_TemplatedMixin",
	"dojo/text!./templates/ProgressBar.html"
], function(require, declare, domClass, lang, number, _Widget, _TemplatedMixin, template){

// module:
//		dijit/ProgressBar


return declare("dijit.ProgressBar", [_Widget, _TemplatedMixin], {
	// summary:
	//		A progress indication widget, showing the amount completed
	//		(often the percentage completed) of a task.
	//
	// example:
	// |	<div data-dojo-type="ProgressBar"
	// |		 places="0"
	// |		 value="..." maximum="...">
	// |	</div>

	// progress: [const] String (Percentage or Number)
	//		Number or percentage indicating amount of task completed.
	//		Deprecated.   Use "value" instead.
	progress: "0",

	// value: String (Percentage or Number)
	//		Number or percentage indicating amount of task completed.
	//		With "%": percentage value, 0% <= progress <= 100%, or
	//		without "%": absolute value, 0 <= progress <= maximum.
	//		Infinity means that the progress bar is indeterminate.
	value: "",

	// maximum: [const] Float
	//		Max sample number
	maximum: 100,

	// places: [const] Number
	//		Number of places to show in values; 0 by default
	places: 0,

	// indeterminate: [const] Boolean
	//		If false: show progress value (number or percentage).
	//		If true: show that a process is underway but that the amount completed is unknown.
	//		Deprecated.   Use "value" instead.
	indeterminate: false,

	// label: String?
	//		Label on progress bar.   Defaults to percentage for determinate progress bar and
	//		blank for indeterminate progress bar.
	label:"",

	// name: String
	//		this is the field name (for a form) if set. This needs to be set if you want to use
	//		this widget in a dijit/form/Form widget (such as dijit/Dialog)
	name: '',

	templateString: template,

	// _indeterminateHighContrastImagePath: [private] URL
	//		URL to image to use for indeterminate progress bar when display is in high contrast mode
	_indeterminateHighContrastImagePath:
		require.toUrl("./themes/a11y/indeterminate_progress.gif"),

	postMixInProperties: function(){
		this.inherited(arguments);

		// Back-compat for when constructor specifies indeterminate or progress, rather than value.   Remove for 2.0.
		if(!(this.params && "value" in this.params)){
			this.value = this.indeterminate ? Infinity : this.progress;
		}
	},

	buildRendering: function(){
		this.inherited(arguments);
		this.indeterminateHighContrastImage.setAttribute("src",
			this._indeterminateHighContrastImagePath.toString());
		this.update();
	},

	update: function(/*Object?*/attributes){
		// summary:
		//		Internal method to change attributes of ProgressBar, similar to set(hash).  Users should call
		//		set("value", ...) rather than calling this method directly.
		// attributes:
		//		May provide progress and/or maximum properties on this parameter;
		//		see attribute specs for details.
		// example:
		//	|	myProgressBar.update({'indeterminate': true});
		//	|	myProgressBar.update({'progress': 80});
		//	|	myProgressBar.update({'indeterminate': true, label:"Loading ..." })
		// tags:
		//		private

		// TODO: deprecate this method and use set() instead

		lang.mixin(this, attributes || {});
		var tip = this.internalProgress, ap = this.domNode;
		var percent = 1;
		if(this.indeterminate){
			ap.removeAttribute("aria-valuenow");
		}else{
			if(String(this.progress).indexOf("%") != -1){
				percent = Math.min(parseFloat(this.progress)/100, 1);
				this.progress = percent * this.maximum;
			}else{
				this.progress = Math.min(this.progress, this.maximum);
				percent = this.maximum ? this.progress / this.maximum : 0;
			}
			ap.setAttribute("aria-valuenow", this.progress);
		}

		// Even indeterminate ProgressBars should have these attributes
		ap.setAttribute("aria-describedby", this.labelNode.id);
		ap.setAttribute("aria-valuemin", 0);
		ap.setAttribute("aria-valuemax", this.maximum);
		
		this.labelNode.innerHTML = this.report(percent);

		domClass.toggle(this.domNode, "dijitProgressBarIndeterminate", this.indeterminate);
		tip.style.width = (percent * 100) + "%";
		this.onChange();
	},

	_setValueAttr: function(v){
		this._set("value", v);
		if(v == Infinity){
			this.update({indeterminate:true});
		}else{
			this.update({indeterminate:false, progress:v});
		}
	},

	_setLabelAttr: function(label){
		this._set("label", label);
		this.update();
	},

	_setIndeterminateAttr: function(indeterminate){
		// Deprecated, use set("value", ...) instead
		this.indeterminate = indeterminate;
		this.update();
	},

	report: function(/*float*/percent){
		// summary:
		//		Generates message to show inside progress bar (normally indicating amount of task completed).
		//		May be overridden.
		// tags:
		//		extension

		return this.label ? this.label :
				(this.indeterminate ? "&#160;" : number.format(percent, { type: "percent", places: this.places, locale: this.lang }));
	},

	onChange: function(){
		// summary:
		//		Callback fired when progress updates.
		// tags:
		//		extension
	}
});

});

},
'url:dijit/templates/ProgressBar.html':"<div class=\"dijitProgressBar dijitProgressBarEmpty\" role=\"progressbar\"\n\t><div  data-dojo-attach-point=\"internalProgress\" class=\"dijitProgressBarFull\"\n\t\t><div class=\"dijitProgressBarTile\" role=\"presentation\"></div\n\t\t><span style=\"visibility:hidden\">&#160;</span\n\t></div\n\t><div data-dojo-attach-point=\"labelNode\" class=\"dijitProgressBarLabel\" id=\"${id}_label\"></div\n\t><img data-dojo-attach-point=\"indeterminateHighContrastImage\" class=\"dijitProgressBarIndeterminateHighContrastImage\" alt=\"\"\n/></div>\n",
'epi-cms/widget/UploadUtil':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/lang",

    "dojo/dom-style"
],

function (
// dojo
    array,
    lang,

    domStyle
) {

    // module:
    //      epi-cms/widget/UploadUtil
    // summary:
    //      Utility for multiple file upload.
    // tags:
    //      public

    return {

        // _altCommaChar: [private] String
        //      Special character for folder name or file name
        _altCommaChar: null,

        StatusScope: {
            // summary:
            //      Upload file status scope
            //          Single: will be apply for only one row
            //          All: will be apply for all rows
            // tags:
            //      public

            Single: 0,
            All: 1
        },

        setAltCommaChar: function (altCommaChar) {
            // summary:
            //      Set alternative comma character
            // tags:
            //      public

            this._altCommaChar = altCommaChar;
        },

        getAltCommaChar: function () {
            // summary:
            //      Get alternative comma character
            // tags:
            //      public

            return this._altCommaChar;
        },

        validUploadFiles: function (/*Array*/files) {
            // summary:
            //      Validate input upload file array
            // tags:
            //      public

            if (!files || !(files instanceof Array) || files.length === 0) {
                return false;
            }

            return !array.some(files, function (item) {
                return (item.name == null || item.size == null);
            });
        },

        addStatus: function (/*Array*/store, /*Integer*/scope, /*String*/itemName, /*String*/message) {
            // summary:
            //      Append new one status message to the given store
            // store: [Array]
            //      
            // scope: [Integer]
            //      
            // itemName: [String]
            //      
            // message: [String]
            //      
            // tags:
            //      public

            var newStore = [];

            if (store instanceof Array) {
                newStore = lang.clone(store);
            }

            if (!this.supportNativeDndFiles()) {
                message = this.replaceComma(message);
            }

            var existed = array.some(newStore, function (item) {
                return (item.scope === scope && item.itemName === itemName && item.message === message);
            });

            if (!existed) {
                newStore.push({ scope: scope, itemName: itemName, message: message });
            }

            return newStore;
        },

        supportNativeDndFiles: function () {
            // summary:
            //      Check browser supports Html5 Drag and Drop files
            // tags:
            //      public

            return !!window.FileReader;
        },

        filterFileOnly: function (/*Array*/files) {
            // summary:
            //      Returns list of file only, not directory
            // tags:
            //      public

            return array.filter(files, function (file) {
                if (file.type === "" && (file.size === 0 || file.size % 4096 === 0)) {
                    return false;
                }

                return true;
            });
        },

        replaceComma: function (/*String*/data) {
            // summary:
            //      Replace special character "\" or "/" to "," in result flash string
            // tags:
            //      public

            return data.replace(new RegExp("\\" + this.getAltCommaChar(), "gim"), ",");
        },

        toggleVisibility: function (/*DOM*/domNode, /*Boolean*/display) {
            // summary:
            //      Toogle visibility of the given dom node
            // domNode: [DOM]
            //      
            // display: [Boolean]
            //      
            // tags:
            //      public

            domStyle.set(domNode, "display", (display ? "block" : "none"));
        },

        getFileArray: function (/*Object*/inputList) {
            // summary:
            //      Get Array object from the given object list
            // inputList: [Object]
            //      Object list that wants to convert to Array
            // returns: [Array]
            //      Collection of uploading files in Array
            // tags:
            //      public

            if (!inputList) {
                return null;
            }

            if (inputList instanceof Array) {
                return inputList;
            }

            if (typeof inputList.item !== "function") {
                return null;
            }

            var i = 0,
                total = inputList.length,
                fileArray = [];

            for (i; i < total; i++) {
                fileArray.push(inputList.item(i));
            }

            return fileArray;
        }

    };

});
},
'url:epi-cms/widget/templates/FileList.html':"﻿<div class=\"epi-multiFileUpload-list\">\r\n    <div data-dojo-type=\"dijit/ProgressBar\" data-dojo-attach-point=\"progressBar\" data-dojo-props=\"maximum:100\"></div>\r\n</div>",
'epi-cms/widget/MultipleFileUploadConfirmation':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/when",
// epi
    "epi/string",

    "epi/shell/widget/dialog/Dialog",

    "epi-cms/widget/ReadOnlyContentList",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.uploadmultiplefiles.replaceconfirmdialog"
],

function (
// dojo
    array,
    declare,
    lang,

    domClass,

    aspect,
    Deferred,
    when,
// epi
    epiString,

    Dialog,

    ReadOnlyContentList,
// resources
    resources
) {

    // module:
    //      epi-cms/widget/MultipleFileUploadConfirmation
    // summary:
    //      Confirmation dialog for multiple file upload widget
    // tags:
    //      public

    return declare(null, {

        // =======================================================================
        // Public functions

        showConfirmation: function (/*Array*/existingContents, /*Array*/uploadingFiles, /*Array*/newFiles) {
            // summary:
            //      Show confirmation dialog to replace/skip the existing contents when uploading file(s) by multiple file upload widget.
            // existingContents: [Array]
            //      Filtered existing content(s) on the server
            // uploadingFiles: [Array]
            //      The uploading file(s) given from multiple file upload widget
            // newFiles: [Array]
            //      Filtered new file(s) that are not existing on the server
            // returns: [dojo.Deferred]
            //      An instance of Array for filtered file list to upload to server.
            //      This list can be the whole original selected file(s) or just the new file(s) that not existed on the server.
            // tags:
            //      public

            var deferred = new Deferred(),
                dialog = this._getDialog(existingContents.length),
                content = this._getContentList();

            dialog.set("content", content);
            dialog.set("onAction", function (replace) {
                deferred.resolve(replace ? uploadingFiles : newFiles);
            });

            when(dialog.show(), function () {
                content.grid.renderArray(existingContents);
            });

            return deferred;
        },

        // =======================================================================
        // Private functions

        _getDialog: function (/*Integer*/totalExistingFiles) {
            // summary:
            //      Get confirmation dialog
            // totalExistingFiles: [Integer]
            //      Total filtered existing files on the server
            // returns: [epi.shell.widget.dialog.Dialog]
            //      Confirmation dialog that included existing file list grid
            // tags:
            //      private

            var self = this,
                heading = epiString.toHTML(totalExistingFiles > 1 ? lang.replace(resources.multiple.heading, [totalExistingFiles]) : resources.single.heading),
                description = epiString.toHTML(totalExistingFiles > 1 ? resources.multiple.description : resources.single.description);

            var dialog = new Dialog({
                closeIconVisible: false,
                destroyOnHide: true,
                title: resources.title,
                heading: heading,
                description: description,
                getActions: function () {
                    return self._getActions(this, totalExistingFiles === 1);
                }
            });

            domClass.add(dialog.domNode, "epi-readOnlyContentListDialog");

            return dialog;
        },

        _getActions: function (/*epi.shell.widget.dialog.Dialog*/dialog, /*Boolean*/single) {
            // summary:
            //      Overridden from Dialog base to assemble the action collection
            // dialog: [epi.shell.widget.dialog.Dialog]
            //      Confirmation dialog
            // single: [Boolean]
            //      Indicates that we must show text for single item or multiple items
            // returns:
            //      A collection of action definitions that can be added to the action pane.
            // tags:
            //      private

            return [
                {
                    name: "replaceFiles",
                    label: single ? resources.single.buttons.replace : resources.multiple.buttons.replace,
                    title: null,
                    action: function () {
                        when(dialog.hide(), function () {
                            return dialog.onAction(true);
                        });
                    }
                },
                {
                    name: "skipFiles",
                    label: single ? resources.single.buttons.skip : resources.multiple.buttons.skip,
                    title: null,
                    action: function () {
                        when(dialog.hide(), function () {
                            return dialog.onAction(false);
                        });
                    }
                }
            ];
        },

        _getContentList: function () {
            // summary:
            //      Get readonly thumbnail grid for existing contents on the server
            // returns: [epi-cms.widget.ReadOnlyContentList]
            //      Readonly grid with thumbnail enabled
            // tags:
            //      private

            var readOnlyList = new ReadOnlyContentList();
            domClass.add(readOnlyList.domNode, "epi-thumbnailContentList");

            return readOnlyList;
        }

    });

});
},
'epi-cms/widget/ReadOnlyContentList':function(){
﻿define([
// dojo
    "dojo/_base/declare",
// dgrid
    "dgrid/OnDemandList",
// epi
    "epi/shell/dgrid/Formatter",

    "epi-cms/core/ContentReference",
    "epi-cms/dgrid/formatters",
    "epi-cms/widget/_ContentListBase",

    "epi/i18n!epi-cms/nls/episerver.shared.header"
],

function (
// dojo
    declare,
// dgrid
    OnDemandList,
// epi
    Formatter,

    ContentReference,
    formatters,
    _ContentListBase,

    headingResources
) {

    // module:
    //      epi-cms/widget/ReadOnlyContentList
    // summary:
    //      Widget to show a read only content list
    // tags:
    //      public

    return declare([_ContentListBase], {

        // _gridClass: [protected]
        //      Declaration for dgrid
        _gridClass: declare([OnDemandList, Formatter]),

        // query: [public] Object
        //      Grid query object
        query: null,

        // queryOptions: [public] Object
        //      Grid query options object
        queryOptions: null,

        // =======================================================================
        // Public functions

        onPostCreateSettings: function () {

        },

        // =======================================================================
        // Public overrided functions

        postCreate: function () {

            this.inherited(arguments);

            this.onPostCreateSettings();
        },

        destroy: function () {

            if (this.grid) {
                this.grid.destroy();
                this.grid = null;
            }

            this.inherited(arguments);
        },

        getContextMenu: function () {
            // summary:
            //      
            // tags:
            //      public, extension

            // Do not create a contextMenu if it's not been specified.
        },

        createList: function () {
            // summary:
            //      Hides grid header by default
            // tags:
            //      public, extension

            this.inherited(arguments);

            this.grid.set("showHeader", false);
        },

        getListSettings: function () {
            // summary:
            //      Initialization a list.
            // tags:
            //      public, extension

            return this._getBaseSettings();
        },

        // =======================================================================
        // Protected functions

        _setQueryAttr: function (/*Object*/value) {
            // summary:
            //      
            // value: [Object]
            //      
            // tags:
            //      protected

            this._set("query", value);
            this._updateQuery(value);
        },

        _getBaseSettings: function (/*Object?*/contextMenu) {
            // summary:
            //      
            // contextMenu: [Object?]
            //      
            // tags:
            //      protected

            var titleSelector = function (item) {
                var reference = new ContentReference(item.contentLink);
                var title = item.name +
                    ", " + headingResources.id + ": " + reference.id +
                    " (" + headingResources.type + ": " + item.contentTypeName + ")";
                return title;
            };

            var thumbnailSelector = function (item) {
                return item.thumbnailUrl;
            };

            // Init content list
            return {
                store: this.store,
                queryOptions: this.queryOptions,
                formatters: [formatters.contentItemFactory("name", titleSelector, null, contextMenu, thumbnailSelector)],
                deselectOnRefresh: true
            };
        },

        // =======================================================================
        // Private functions

        _updateQuery: function (/*Object*/query) {
            // summary:
            //      
            // query: [Object]
            //      
            // tags:
            //      private

            if (query) {
                this.grid.set("query", query);
            } else {
                this.grid.cleanup();
            }
        }

    });

});
},
'epi-cms/widget/_ContentListBase':function(){
﻿define([
    // Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/when",
    // epi
    "epi/shell/widget/ContextMenu",
    // epi-cms
    "./_GridWidgetBase"
], function (
    // Dojo
    declare,
    lang,
    domClass,
    when,
    //epi
    ContextMenu,
    // epi-cms
    _GridWidgetBase) {
    return declare([_GridWidgetBase], {

        storeKeyName: "epi.cms.content.search",

        trackActiveItem: false,

        gridAttachNode: null,

        // contextChangeEvent: [public] String
        //      Configure double click on a row to cause a context change.
        contextChangeEvent: "dblclick",

        postMixInProperties: function () {
            this.inherited(arguments);
            this.model = this.model || this.createModel();
        },

        postCreate: function () {
            // summary:
            //      Construct the UI for this widget.
            // tags:
            //      protected

            this.inherited(arguments);
            this.createList();
        },

        createModel: function () {
            // summary:
            //      Override to construct the default model for the list and context menu.
            // tags:
            //      protected
        },

        createList: function () {
            // summary:
            //      Creates the list for this widget.
            // tags:
            //      protected

            var settings = this.getListSettings();
            settings = lang.mixin(settings, this.defaultGridMixin);
            this.grid = new this._gridClass(settings, this.gridAttachNode || this.domNode);
            var hasModelWithCommands = this.model && this.model.commands && this.model.commands.length > 0;
            if (hasModelWithCommands) {
                this.grid.contextMenu.addProvider(this.model);
            }
            if (this.contextMenu) {
                this.grid.contextMenu = this.contextMenu;
            }

            this.own(this.grid);
            this.setupEvents();
        },

        getListSettings: function () {
            // summary:
            //      Override to specify the settings used to create the list.
            // tags:
            //      protected

            return {};
        },

        setupEvents: function () {
            // summary:
            //      Initialization of events on the list.
            // tags:
            //      protected, extension
        },

        onContextChanged: function () {
            //Disable default triggering of fetchData.
        },

        _onSelect: function (e) {

            when(this.getCurrentContext(), lang.hitch(this, function (currentContext) {

                var grid = this.grid;
                var model = {
                    contextId: currentContext.id,
                    data: []
                };

                if (this.model) {
                    for (var id in grid.selection) {
                        if (grid.selection[id]) {
                            var row = grid.row(id);
                            model.data.push(row.data);
                        }
                    }

                    this.model.set("model", model);
                }
            }));
        }
    });
});
},
'epi-cms/widget/viewmodel/FileListViewModel':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",

    "dojo/Stateful",
// epi
    "epi/shell/_StatefulGetterSetterMixin",

    "epi-cms/widget/UploadUtil",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.uploadmultiplefiles"
],

function (
// dojo
    declare,
    array,
    lang,

    Stateful,
// epi
    _StatefulGetterSetterMixin,

    UploadUtil,
// resources
    resources
) {
    return declare([Stateful, _StatefulGetterSetterMixin], {
        // summary:
        //      The view model for multiple file upload widget

        // progress: [Object]
        //      Progress of uploading files
        progress: null,

        // uploadFiles: [Array]
        //      List of uploading files
        uploadFiles: null,

        // uploadStatus: [Array]
        //      List of uploading status
        uploadStatus: null,

        // showProgressBar: [Boolean]
        //      Indicates that progress bar should show or hide
        showProgressBar: false,

        _setUploadFilesAttr: function (/* Array */files) {
            // summary:
            //      Uploading files need to send to server
            // tags:
            //      private

            if (!UploadUtil.validUploadFiles(files)) {
                return;
            }

            var fileList = [];
            array.forEach(files, function (file) {
                fileList.push({ fileName: file.name, size: file.size, status: resources.uploadform.uploading });
            }, this);

            this._set("uploadFiles", fileList);
        },

        _setUploadStatusAttr: function (/* Array */statusList) {
            // summary:
            //      Status indicates that file uploaded or not
            // tags:
            //      private

            var files = this.get("uploadFiles");

            // Do nothing on next upload time if not any files dropped or selected
            if (array.some(files, function (item) { return item.status !== resources.uploadform.uploading; })) {
                return;
            }

            array.forEach(files, function (item) {
                if (!statusList || statusList.length <= 0) {
                    item.status = resources.uploadform.uploaded;
                    return false;
                }

                // Set file upload is failed when there are exception occured
                if (statusList[0] && statusList[0].scope === UploadUtil.StatusScope.All && statusList[0].itemName === "") {
                    item.status = resources.uploadform.failed;
                    item.statusMessage = statusList[0].message;
                    return false;
                }

                // Find file upload in exception list
                var failedFiles = array.filter(statusList, function (status) {
                    return item.fileName === status.itemName;
                });

                // Update status of file upload
                if (failedFiles && failedFiles.length > 0) {
                    item.status = resources.uploadform.failed;
                    item.statusMessage = failedFiles[0].message;
                }
                else {
                    item.status = resources.uploadform.uploaded;
                }
            }, this);

            this._set("uploadFiles", files);
        },

        clear: function () {
            // summary:
            //      Clear all temporaries upload file information before
            // tags:
            //      private

            this._set("uploadFiles", null);
        }
    });
});
},
'url:epi-cms/widget/templates/MultipleFileUpload.html':"﻿<div class=\"epi-multiFileUpload\">\r\n    <form method=\"post\" action=\"\" enctype=\"multipart/form-data\">\r\n        <div data-dojo-attach-point=\"breadcrumbBar\" data-dojo-type=\"epi-cms/widget/Breadcrumb\"></div>\r\n        <div data-dojo-attach-point=\"uploadToolbar\" class=\"epi-toolbar-unwrapped\">\r\n            <span title=\"${res.uploadform.addfiles}\" >\r\n                <input type=\"file\" multiple=\"multiple\" data-dojo-type=\"dojox.form.Uploader\" data-dojo-attach-point=\"uploaderInput\" \r\n                    data-dojo-props=\"iconClass:'epi-iconPlus', showLabel: false, multiple: true\" />\r\n            </span>\r\n            <div data-dojo-attach-point=\"toolbarDisableLayer\"></div>\r\n        </div>\r\n        <div data-dojo-attach-point=\"fileList\" data-dojo-type=\"epi-cms/widget/FileList\"></div>\r\n    </form>\r\n</div>",
'epi-cms/command/UploadContent':function(){
﻿define([
    "dojo/_base/declare",
    "epi/shell/command/_Command",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/core/ContentReference"
], function(
    declare,
    _Command,
    ContentActionSupport,
    ContentReference
) {

    // module:
    //      epi-cms/command/UploadContent
    // summary:
    //      A command that starts the upload new content process when executed.
    // tags:
    //      public
    return declare([_Command], {

        // fileList: [public] Array
        //      A array of files to upload. When null, only show upload form to
        //      select files for uploading; otherwise, upload files in list.
        fileList: null,

        // createAsLocalAsset: [public] Boolean
        //      Indicate if the content should be created as local asset of its parent.
        createAsLocalAsset: false,

        _execute: function() {
            // summary:
            //      Executes this command; call upload method from model.
            // tags:
            //      protected

            var contentLinkWithoutWorkId = ContentReference.toContentReference(this.model.contentLink).createVersionUnspecificReference();

            this.viewModel.upload(this.fileList, contentLinkWithoutWorkId.toString(), this.createAsLocalAsset);

            this.fileList = null; // clear fileList after uploading, to avoid of displaying last uploaded item on upload dialog.
        },

        _onModelChange: function() {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected
            var model = this.model,
                canExecute = model && ContentActionSupport.hasProviderCapability(model.providerCapabilityMask, ContentActionSupport.providerCapabilities.Create) &&
                             ContentActionSupport.hasAccess(model.accessMask, ContentActionSupport.accessLevel.Create);

            this.set("canExecute", !!(canExecute && this.viewModel));
        }
    });
});
},
'epi-cms/command/EditImage':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/topic",
    // epi
    "epi/dependency",
    "epi/routes",
    "epi/Url",
    "epi/shell/TypeDescriptorManager",

    // EPi CMS
    "epi-cms/ApplicationSettings",
    "epi-cms/core/ContentReference",
    "epi-cms/core/PermanentLinkHelper",
    "epi-cms/legacy/LegacyDialogPopup",
    "epi-cms/contentediting/command/_LegacyDialogCommandBase",
    "epi/shell/command/_SelectionCommandMixin",
    "epi-cms/contentediting/ContentActionSupport"
], function(
    // dojo
    declare,
    lang,
    when,
    topic,
    // epi
    dependency,
    routes,
    Url,
    TypeDescriptorManager,

    // EPi CMS
    ApplicationSettings,
    ContentReference,
    PermanentLinkHelper,
    LegacyDialogPopup,
    _LegacyDialogCommandBase,
    _SelectionCommandMixin,
    ContentActionSupport
) {

    return declare([_LegacyDialogCommandBase, _SelectionCommandMixin], {

        // canExecute: [readonly] Boolean
        //      Flag which indicates whether this command is able to be executed.
        canExecute: false,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconNewWindow",

        // _segmentIdSeperator: [readonly] String
        //      Default id seperator string.
        _segmentIdSeperator: ",,",

        getRouteParams: function() {
            // summary:
            //      Gets the parameters for creating a route to the legacy content.
            var target = this._getTarget();

            return {
                moduleArea: "LegacyCMS",
                path: "Edit/ImageEditor/ImageEditor.aspx",
                IsInLegacyWrapper: false,
                imageId: target ? target.contentLink : ""
            };
        },

        _createDialog: function(dialogParams, routeParams) {
            // summary:
            //      Creates and returns a new LegacyDialogPopup
            //
            // dialogParams: Object
            //      An object containing parameters overriding any default dialog constructor arguments
            //
            // routeParams: Object
            //      An object with properties used for constructing the dialog url.
            // tags:
            //      private

            var content = this._getTarget(),
                model = this.model;

            if (content) {
                var onCallback = function(returnValue) {
                    if (returnValue) {
                        // Request context change when save or save as asset image
                        topic.publish("/epi/shell/context/request", { url: returnValue.src }, { forceReload: true });
                    }
                };

                lang.mixin(dialogParams, {
                    url: routes.getActionPath(routeParams),
                    dialogArguments: {
                        src: PermanentLinkHelper.toPermanentLink(content)
                    },
                    destroyOnHide: true,
                    onCallback: onCallback
                });
            }

            return new LegacyDialogPopup(dialogParams);
        },

        _onModelChange: function() {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            if (!ApplicationSettings.imageEditorEnabled) {
                if (this.get("isAvailable")) {
                    this.set("isAvailable", false);
                }
                return;
            }

            var target = this._getTarget(),
                canExecute = this.model &&  // Ensure that there is a model available.
                             target &&  // Ensure there is something selected.
                             TypeDescriptorManager.isBaseTypeIdentifier(target.typeIdentifier, "episerver.core.icontentimage");  // Check that it is image content.

            this.set("canExecute", !!canExecute);
            
        },

        _getTarget: function() {
            // summary:
            //      Returns the target for the file operation from the current selection.
            // tags:
            //      protected
            var selection = this.selection && this.selection.data,
                target = selection && selection.length == 1 && selection[0];

            return target && (target.type == "epi.cms.contentdata") ? target.data : null;
        }
    });
});
},
'epi-cms/command/DownloadMedia':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/dom-construct",
    "dojo/has",
    "dojo/sniff",
    "dojo/when",

// EPi Framework
    "epi/shell/Downloader",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/command/_Command",
    "epi/shell/command/_SelectionCommandMixin",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.command"
],
function (
// Dojo
    declare,
    Deferred,
    domConstruct,
    has,
    sniff,
    when,

// EPi Framework
    Downloader,
    TypeDescriptorManager,
    _Command,
    _SelectionCommandMixin,

// Resources
    resources
) {
    return declare([_Command, _SelectionCommandMixin], {
        // summary:
        //      Download command that used to force download media file from browser by javascript.
        // module:
        //      epi-cms/command/DownloadMedia

        label: resources.download,

        tooltip: resources.download,

        iconClass: "epi-iconDownload",

        _execute: function () {
            var contentData = this._getContentData();
            if (!contentData) {
                return;
            }

            Downloader.download(contentData.downloadUrl, contentData.name);
        },

        _onModelChange: function () {
            var contentData = this._getContentData(),
                isDowloadLinkAvaiable = contentData && contentData.downloadUrl,
                typeIdentifier = contentData && contentData.typeIdentifier,
                typeShouldActAsAsset = typeIdentifier && TypeDescriptorManager.getValue(typeIdentifier, "actAsAnAsset");

            this.set("canExecute", !!(typeShouldActAsAsset && isDowloadLinkAvaiable));
        },

        _getContentData: function () {
            // summary:
            //      Get current selected content data by selection
            // tags:
            //      private

            var selectionData = null;
            if (this.selection && this.selection.data && this.selection.data instanceof Array && this.selection.data.length === 1) {
                selectionData = this.selection.data[0].data;
            }

            return selectionData;
        }
    });
});
},
'epi/shell/Downloader':function(){
﻿define("epi/shell/Downloader", [
// Dojo
    "dojo/_base/lang",
    "dojo/dom-construct"
],
function (
// Dojo
    lang,
    domConstruct
) {
    return {
        // summary:
        //      Downloader static class that used to force download media file from browser by javascript.
        // module:
        //      "epi/shell/Downloader"

        _classicalDownload: function (/*String*/url, /*String*/name) {
            // summary:
            //      Classical method to download file by direct url.
            // tags:
            //      private

            // Create a temporary anchor link, trigger click event and then destroy it!
            var bodyNode = document.getElementsByTagName("body")[0],
                dowloadLinkAttributes = {
                    href: url,
                    download: name,
                    target: "_blank",
                    style: { display: "none;" }
                },
                downloadLinkNode = domConstruct.create("a", dowloadLinkAttributes, bodyNode, "last");

            downloadLinkNode.click();
            domConstruct.destroy(downloadLinkNode);
        },

        download: function (/*String*/url, /*String*/name) {
            // summary:
            //      Download and save a blob content to local device.
            // tags:
            //      public virtual

            if (url) {
                return this._classicalDownload(url, name);
            }
        }
    };
});
},
'epi-cms/widget/HierarchicalList':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/on",
    "dojo/when",

// dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/_LayoutWidget",
    "dijit/layout/BorderContainer", // Used in template

// dojox
    "dojox/html/entities",

// epi
    "epi/string",
    "epi/shell/command/_WidgetCommandBinderMixin",
    "epi/shell/widget/_FocusableMixin",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/dialog/Alert",

    "epi/shell/widget/ContextMenu",
    "epi-cms/widget/SearchBox",
    "epi-cms/widget/FolderTree",
    "epi-cms/widget/ContentList",
    "epi-cms/widget/FilesUploadDropZone",
    "epi-cms/widget/UploadUtil",
    "epi-cms/widget/viewmodel/HierarchicalListViewModel",

// template
    "dojo/text!./templates/HierarchicalList.html",
    "dojo/text!./templates/AssetsDropZone.html",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.hierachicallist"
],

function (
// dojo
    array,
    declare,
    lang,
    aspect,
    domClass,
    domConstruct,
    domGeometry,
    domStyle,
    on,
    when,

// dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _LayoutWidget,
    BorderContainer,

//dojox
    htmlEntities,

// epi
    epistring,

    _WidgetCommandBinderMixin,
    _FocusableMixin,
    _ModelBindingMixin,
    Alert,

    ContextMenu,
    SearchBox,
    FolderTree,
    ContentList,
    DropZone,
    UploadUtil,
    HierarchicalListViewModel,

// template
    template,
    dropZoneTemplate,

// Resources
    res
) {

    // module:
    //      epi-cms/widget/HierarchicalList
    // summary:
    //      Abstract widget for displaying the panel with tree on top and list for displaying leaf's items, as well as the search box on very top.
    // tags:
    //      abstract

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin, _WidgetCommandBinderMixin], {

        contextMenu: null,

        templateString: template,

        showRoot: false,

        // enableDndFileDropZone: [public] Boolean
        //      Flag to indicate this widget allowed to show drop zone widget ("epi-cms/widget/FilesUploadDropZone" that care about native DnD files from browser) or not.
        enableDndFileDropZone: false,

        // showCreateContentArea: [public] Boolean
        //      Flag to indicate this widget allowed to show create content area by default or not.
        showCreateContentArea: false,

        triggerContextChange: false,

        res: res,

        modelClassName: HierarchicalListViewModel,

        // hierarchicalListClass: [readonly] String
        //      The CSS class to be used on the hierarchical list.
        hierarchicalListClass: "",

        // noDataMessage: [public] String
        //      No data message for list widget
        noDataMessage: "",

        // createContentIcon: [public] String
        //      The icon class to be used in the create content area of the list.
        createContentIcon: "",

        // createContentText: [public] String
        createContentText: "",

        // _dropZoneCreated: boolean
        //      Flag to indicate whether Drop Zone has been created and added, to avoid of create it twice.
        _dropZoneCreated: false,

        modelBindingMap: {
            "searchRoots": ["searchRoots"],
            "searchArea": ["searchArea"],
            "listQuery": ["listQuery"],
            "currentTreeItem": ["currentTreeItem"],
            "currentListItem": ["currentListItem"],
            "editingListItem": ["editingListItem"],
            "showAllLanguages": ["showAllLanguages"]
        },

        _setSearchAreaAttr: function (value) {
            this.searchBox.set("area", value);
        },

        _setSearchRootsAttr: function (value) {
            this.searchBox.set("searchRoots", value);
        },

        _setListQueryAttr: function (value) {
            this.list.set("query", value);
        },

        _setShowAllLanguagesAttr: function (value) {
            this.searchBox.set("filterOnCulture", !value);
        },

        _setCurrentTreeItemAttr: function (value) {
            if (value) {
                this._toggleActive(this.tree, this.list);

                when(this.tree.selectContent(value.toString()), lang.hitch(this, function () {
                    var selectedNode = this.tree.getNodesByItem(value.toString())[0];
                    if (selectedNode) {
                        this.tree.model.set("previousSelection", {
                            selectedContent: selectedNode,
                            selectedAncestors: selectedNode.getTreePath()
                        });
                    }
                }));
            }
        },

        _setCurrentListItemAttr: function (value) {
            this.list.set("currentItem", value);
            this._toggleActive(this.list, this.tree);
        },

        _setEditingListItemAttr: function (value) {
            this.list.set("editingItem", value);
        },

        _setShowRootAttr: function (value) {
            this.tree.set("showRoot", value);
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            if (!this.model && !this.commandProvider && this.modelClassName) {
                var modelClass = declare(this.modelClassName);
                this.model = this.commandProvider = new modelClass({ repositoryKey: this.repositoryKey });
            }
            this.setupContextMenu();
        },

        setupContextMenu: function () {
            // summary: set up the context menu
            //      
            // tag:
            //      public
            this.own(this.contextMenu = new ContextMenu({ category: "context" }));
            this.contextMenu.addProvider(this.model);
        },

        postCreate: function () {
            this.inherited(arguments);

            domClass.add(this.domNode, this.hierarchicalListClass);

            this._setupTree();
            this._setupCreateContentArea();
            this._setupList();

            if (this.enableDndFileDropZone) {
                this._setupDropZone();
            }

            this._toggleCreateContentArea(this.showCreateContentArea);

            this.model.startup();

            // Watching instead of binding since we need the old value as well
            this.own(
                this.model.clipboardManager.watch("data", lang.hitch(this, this._updateClipboardIndicators))
            );
        },

        startup: function () {
            this.inherited(arguments);

            if (this.contextMenu) {
                this.contextMenu.startup();
            }
        },

        destroy: function () {
            this.model.destroy();

            this.inherited(arguments);
        },

        layout: function () {

            // Add class to show drop area
            if (this.enableDndFileDropZone) {
                var grid = this.list.grid;
                if (grid) {
                    domClass.add(grid.bodyNode, "epi-drop-area");
                }
            }

            var listSize = domGeometry.getMarginBox(this.list.domNode),
                searchBoxSize = domGeometry.getMarginBox(this.searchBox.domNode),
                appropriatedHeight = this._contentBox.h - searchBoxSize.h - 32;

            // Re-calculate the height for BlockList to prevent it from taking 100% height
            // "32px" is an appropriate height to show a folder tree node
            if (listSize.h > appropriatedHeight) {
                this.list.resize({ h: appropriatedHeight });
            }

            this.container.resize(this._contentBox);
        },

        _toggleCreateContentArea: function (display) {
            // summary:
            //      Toggle display of the create content area
            // display: [Boolean]
            // tags:
            //      protected

            domStyle.set(this.createContentArea, {
                "display": display ? "" : "none"
            });
        },

        _toggleActive: function (activeWidget, inactiveWidget) {
            // summary:
            //      Toggle visual indication between tree and list
            //
            // activeWidget:
            //      The widget to enable active visuals for
            //
            // inactiveWidget:
            //      The widget to disabe active visuals for

            domClass.remove(inactiveWidget.domNode, "epi-focused");
            domClass.add(activeWidget.domNode, "epi-focused");
        },

        _showNotification: function (message) {
            // summary:
            //      Uses the alert dialog implementation to show notification with the supplied message
            //
            // message:
            //      html encoded string to show in notification dialog
            //
            // tags:
            //      public callback

            var dialog = new Alert({
                destroyOnHide: true,
                description: epistring.toHTML(message)
            });

            dialog.show();
        },

        _onDrop: function (evt, fileList) {
            fileList = UploadUtil.filterFileOnly(fileList);
            if (!fileList || fileList.length <= 0) { // ignore folder dropping
                return;
            }

            var uploadCommand = this.model.getCommand("uploadDefault");
            if (!uploadCommand) {
                return;
            }

            uploadCommand.set("fileList", fileList);
            uploadCommand.execute();
        },

        _setupDropZone: function () {
            // summary:
            //      Setup drop zone for entire widget.
            // tags:
            //      private

            if (!(UploadUtil.supportNativeDndFiles() && !this._dropZoneCreated)) {
                return;
            }

            // Create drop zone if it has not been created)
            var dropZone = new DropZone({ "templateString": dropZoneTemplate, "res": res, "outsideDomNode": this.container.domNode });
            domConstruct.place(dropZone.domNode, this.domNode, "first");

            this.connect(dropZone, "onDrop", this._onDrop);
            this._dropZoneCreated = true;

            var uploadCommand = this.model.getCommand("uploadDefault");
            if (uploadCommand) {
                this.own(
                    uploadCommand.watch("canExecute", function (name, oldValues, newValues) {
                        dropZone.set("enabled", newValues); // disable drop zone in case does not have permission to upload.
                    })
                );
            }
        },

        _setupTree: function () {
            // summary:
            //      Implementation should implement this, to setup the content tree. For example, command binding.
            //
            // tags:
            //      protected

            var registry = this.model._commandRegistry;

            function treeClickHandler(item, node, e) {
                this.model.onTreeItemSelected(item, this.tree.model.isTypeOfRoot(item));
            }

            function copyOrCuthandler(copy) {
                copy ? registry.copy.command.execute() : registry.cut.command.execute();
            }

            this.own(
                on(this.tree, "copyOrCut", copyOrCuthandler),
                on(this.tree, "select", lang.hitch(this, treeClickHandler)),
                on(this.tree, "paste", function () { registry.paste.command.execute(); }),
                on(this.tree, "delete", function () { registry["delete"].command.execute(); }),
                aspect.after(this.tree, "onClick", lang.hitch(this, treeClickHandler), true)
            );

            this.model._commandRegistry.rename.command.set("renameDelegate", lang.hitch(this, function (model) {
                this.tree.getNodesByItem(model)[0].edit();
            }));
        },

        _setupCreateContentArea: function () {
            // summary:
            //      Setup create content area for list widget
            // tags:
            //      protected

            domClass.add(this.createContentAreaIcon, this.createContentIcon);
            this.createContentAreaText.innerHTML = this.createContentText;

            this.list.set("noDataMessage", this.noDataMessage);
        },

        _setupList: function () {
            // summary:
            //      Implementation should implement this, to setup the content list. For example, command binding.
            //
            // tags:
            //      protected

            this.own(
                on(this.list, "itemSelected", lang.hitch(this.model, this.model.onListItemSelected)),
                aspect.after(this.model, "onListItemUpdated", lang.hitch(this.list, function (deferred) {
                    when(deferred, lang.hitch(this, this.editContent));
                }))
            );
        },

        _onSearchAction: function (value) {
            // summary:
            //      Implementation should implement this, to process search action.
            //
            // value:
            //      Search string
            //
            // tags:
            //      protected

            this.model.onSearch(value.metadata);
        },

        // =======================================================================
        // Clipboard handling

        _updateClipboardIndicators: function (name, oldValues, newValues) {

            var isCopy = this.model.clipboardManager.isCopy();

            if (oldValues instanceof Array) {
                array.forEach(oldValues, function (clip) {
                    this.tree.toggleCut(clip.data, false);
                    this.list.toggleCut(clip.data, false);
                }, this);
            }

            if (!isCopy && newValues instanceof Array) {
                array.forEach(newValues, function (clip) {
                    this.tree.toggleCut(clip.data, true);
                    this.list.toggleCut(clip.data, true);
                }, this);
            }
        }

    });

});
},
'epi-cms/widget/FolderTree':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-attr",
    "dojo/dom-class",

    "dojo/aspect",
    "dojo/json",
    "dojo/when",
// dojox
    "dojox/html/entities",
// dijit
    "dijit/tree/_dndSelector",
// epi
    "epi/dependency",
    "epi/string",

    "epi-cms/widget/_FolderTreeNode",
    "epi-cms/widget/ContentTree",
    "epi-cms/widget/ContentTreeStoreModel"
],

function (
// dojo
    array,
    declare,
    lang,

    domAttr,
    domClass,

    aspect,
    json,
    when,
// dojox
    htmlEntities,
// dijit
    _dndSelector,
// epi
    dependency,
    epiString,

    _FolderTreeNode,
    ContentTree,
    ContentTreeStoreModel
) {

    // summary:
    //      The EPiServer block folder tree.
    // description:
    //      The block folder tree shows the EPiServer CMS block folder tree using a REST store to fetch the data.
    // tags:
    //      public

    return declare([ContentTree], {

        // handleSelection: [public] Boolean
        //      Flag that indicates this tree need to reset selection each time it had refresh
        handleSelection: true,

        postCreate: function () {

            var self = this;

            self.inherited(arguments);

            self.own(
                self.connect(self.model, "onDeleted", lang.hitch(self, self._onDeleted)),
                aspect.around(self.model, "onRefreshRoots", function (original) {
                    return function (refreshItem) {
                        if (refreshItem && typeof self._onItemDelete === "function") {
                            self._onItemDelete(refreshItem);
                        }

                        return original.apply(self.model, [refreshItem]);
                    };
                })
            );
        },

        toggleCut: function (/*Object*/item, /*Boolean*/isCut) {
            // summary
            //      Mark folder is cutting
            // item:
            //      Object are cutting and save on clipboard
            // tags
            //      public

            var node = this.tree.getNodesByItem(item)[0];
            if (node) {
                domClass.toggle(node.rowNode, "epi-opacity50", isCut);
            }
        },

        _createTreeModel: function () {
            // summary:
            //      Create content tree model
            // tags:
            //      protected override

            return new ContentTreeStoreModel({
                store: this.store
            });
        },

        _updateItemDeletedHierachy: function (/* Folder tree node */node) {
            // summary:
            //      Manualy mark node's item is deleted descendant (recursive)
            // node: Tree node
            //      The deleted node
            // tags:
            //      Private

            if (!node) {
                return;
            }

            array.forEach(node.getChildren(), function (childNode) {
                childNode.set({ item: lang.mixin(childNode.item, { isDeleted: true }) });
                this._updateItemDeletedHierachy(childNode); // call recursive
            }, this);
        },

        _onDeleted: function (/* Model's item */item) {
            // summary:
            //      Handler onDeleted event that is raised after folder is deleted
            // item: Folder item
            //      The folder was deleted
            // tags:
            //      Private

            var nodes = this.getNodesByItem(item);

            array.forEach(nodes, function (node) {
                this._updateItemDeletedHierachy(node);
            }, this);
        },

        _renameFolder: function (item, name) {
            var newName = lang.trim(name),
                treeNode = this.getNodesByItem(item)[0];

            if (newName) {
                when(this.model.rename(item.contentLink, newName),
                    function (item) {
                        // set title to show tooltip as new name of the node
                        domAttr.set(treeNode.contentNode, "title", item.name);
                    },
                    function (ex) {
                        treeNode.rollbackLabel(item.name, ex);
                        treeNode.edit();
                    });

            } else {
                treeNode.rollbackLabel(item.name);
            }
        },

        buildNodeFromTemplate: function (/*Object*/args) {
            // summary:
            //      Build tree node from the given template.
            // args:
            //      Tree node creation arguments
            // tags:
            //      extension

            var treeNode = new _FolderTreeNode(args);

            treeNode.bindContextMenu(this.contextMenu);

            this.own(
                treeNode.on("rename", lang.hitch(this, function (val) {
                    this._renameFolder(treeNode.item, val);
                }))
            );

            return treeNode;
        },

        _onNodeMouseEnter: function (/* Tree._TreeNode */node, evt) {
            // summary:
            //      Handles mouse enter event on a node
            // tags:
            //      private

            this.inherited(arguments);
            node._handleMouseEnter();
        },

        _onNodeMouseLeave: function (/* Tree._TreeNode */node, evt) {
            // summary:
            //      Handles mouse leave event on a node
            // tags:
            //      private

            this.inherited(arguments);
            node._handleMouseLeave();
        },

        _onClick: function (/* Tree._TreeNode */node, evt) {
            // summary:
            //      Handles mouse leave event on a node
            // tags:
            //      private

            this.inherited(arguments);
            node._onClick();
        }

    });

});
},
'epi-cms/widget/_FolderTreeNode':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/dom-style",

    "dojo/Evented",
    "dojo/Deferred",
    "dojo/keys",
    "dojo/on",
    "dojo/when",

    "dojox/html/entities",

// template
    "dojo/text!./templates/_FolderTreeNode.html",
// dijit
    "dijit/form/TextBox",
    "dijit/form/ValidationTextBox",

    "dijit/InlineEditBox",
// epi
    "epi",
    "epi-cms/widget/_ContentTreeNode"
],

function (
// dojo
    declare,
    lang,

    domAttr,
    domClass,
    domGeom,
    domStyle,

    Evented,
    Deferred,
    keys,
    on,
    when,
    htmlEntities,
// template
    template,
// dijit
    TextBox,
    ValidationTextBox,

    InlineEditBox,
// epi
    epi,
    _ContentTreeNode
) {

    declare("_TreeInlineEditor", [dijit._InlineEditor], {

        postCreate: function () {
            this.inherited(arguments);

            this.own(
                on(this.domNode, "mousedown, mouseup, click, keydown, keypress, selectstart", function (e) {
                    e.stopPropagation();
                })
            );
        }
    });

    var LinkTypes = {
        normal: 0,
        root: 1
    };

    // summary:
    //      A customized treenode for block folder tree
    // tags:
    //      public

    return declare([_ContentTreeNode, Evented], {
        templateString: template,

        _blockFolderMenu: 'epi-iconContextMenu',

        _blockFolderDnDIcon: 'epi-iconDnD',

        _blockFolderExpand: 'epi-iconObjectFolderOpen',

        _blockFolderCollapse: 'epi-iconObjectFolder',

        _isResetValue: false,

        _menuTooltip: undefined,

        contextMenu: null,

        _editWidget: null,

        // _rowStates: Enum flag
        _rowStates: {
            NORMAL: 1,
            EXPANDED: 2,
            ENTERED: 4,
            SELECTED: 8
        },

        _currentRowState: 1, /* NORMAL row state by default */

        postMixInProperties: function () {
            this.inherited(arguments);
            this._menuTooltip = epi.resources.action.options;
        },

        postCreate: function () {
            this.inherited(arguments);

            domStyle.set(this.iconNodeMenu, "zIndex", domGeom.position(this.rowNode).zIndex + 1);
            this._updateStyle();
        },

        buildRendering: function () {
            this.inherited(arguments);

            this.labelWidget = new InlineEditBox({
                value: this.label,
                editorWrapper: "_TreeInlineEditor",
                editor: "dijit/form/ValidationTextBox",
                width: "auto",
                editorParams: { maxLength: 255 },
                _onMouseOver: function () { /* disable style hover*/ },
                _onClick: function () { /* disable default onclick on editor*/ },
                onChange: lang.hitch(this, this._onChangeLabelValue),
                onCancel: lang.hitch(this, function () {
                    this.emit("cancelEdit", this.item.contentLink);
                    this._resetValue();
                    this._setEditorState();
                })
            }, this.labelNode);

        },

        edit: function () {
            //We need to specificly make sure that the value is updated since the model might have changed and dijit.Tree only updates the value
            //for the dom node, thus making the visual value and the value of the label widget out of sync.
            this.labelWidget.value = this.label;

            this.labelWidget.edit();
            this._editWidget = this.labelWidget.wrapperWidget.editWidget;
            this.own(
                on(this._editWidget.domNode, "keydown", lang.hitch(this, function (e) {
                    if (!this._editWidget.isValid() && e.keyCode != keys.ENTER) {
                        this._setEditorState();
                    }
                }))
            );
        },

        _resetValue: function (val) {
            // summary:
            //      Reset value of folder name
            // val: [String]
            //      The name of folder
            // tags:
            //      private

            this._isResetValue = true;
            this.labelWidget.set("value", val || this.label);
        },

        _onChangeLabelValue: function (val) {
            // summary:
            // tags:
            //      private

            if (!val) {
                this._resetValue();
                return;
            }

            if (!this._isResetValue) {
                this.emit("rename", val);
            }

            // reset flag to default
            this._isResetValue = false;
        },

        _onClick: function (evt) {
            this.inherited(arguments);

            domClass.remove(this.labelNode, "dijitInlineEditBoxDisplayModeHover");
            this.emit("nodeSelected", this);
        },

        rollbackLabel: function (val, error) {
            // summary:
            //      Set error for editor and reset value
            // val: [String]
            //      The value rollback
            // error: [Object]
            //      The error object
            // tags:
            //      public

            // Reset if value is null
            if (!this.labelWidget.value) {
                this._resetValue(val);
            }

            // Show error message 
            if (error && error.length > 0) {
                this._setEditorState(error[0].errorMessage);
            }
        },

        bindContextMenu: function (menu) {
            this.contextMenu = menu;
            this.connect(this.iconNodeMenu, "onclick", "_onIconNodeMenuClick");
        },

        collapse: function () {
            var self = this,
                def = new Deferred();

            when(self.inherited(arguments), function () {
                self._currentRowState = self._currentRowState ^ self._rowStates.EXPANDED;
                self._updateStyle();
                // collapse successful trigger event here
                def.resolve(true);
            });

            return def;
        },

        expand: function () {
            var self = this,
                def = new Deferred();

            when(self.inherited(arguments), function () {
                self._currentRowState = self._currentRowState | self._rowStates.EXPANDED;
                self._updateStyle();
                // expand successful trigger event here
                def.resolve();
            });

            return def;
        },

        setSelected: function (/*Boolean*/selected) {

            // If the current item data object is not existing, do nothing
            if (!this.tree.getNodesByItem(this.item)[0]) {
                return;
            }

            this.inherited(arguments);

            var oldState = this._currentRowState;
            this._currentRowState = selected ?
                (this._currentRowState | this._rowStates.SELECTED) :
                parseInt(this._currentRowState & this._rowStates.SELECTED, 10) > 0 ? (this._currentRowState ^ this._rowStates.SELECTED) : oldState;
            this._updateStyle();

            if (selected) {
                this.emit("nodeSelected", this);
            }
        },

        _updateIndividualLayout: function () {
            // summary:
            //      update folder icon is expanded or not
            // tags:
            //      private

            domAttr.set(this.contentNode, "title", this.label);

            this._updateStyleBySingleState();

            if (this.item && this.item.contentLink) {
                this.emit("nodeRefreshed", this.item.contentLink);
            }
        },

        _updateBlockFolderTypeIcon: function () {
            // summary:
            //      Set page type icon for the tree node
            // tags:
            //      private

            if (this._isTypeOfRoot()) {
                this._iconNodeClass = this.tree.model.getObjectIconClass(this.item, this._blockFolderCollapse);
            } else {
                this._iconNodeClass = this.isExpanded ? this._blockFolderExpand : this._blockFolderCollapse;
            }

            // Add new class
            domClass.add(this.iconNode, this._iconNodeClass);
        },

        _handleMouseEnter: function () {
            this._currentRowState = this._currentRowState | this._rowStates.ENTERED;
            this._updateStyle();

            domClass.remove(this.labelNode, "dijitInlineEditBoxDisplayModeHover");
        },

        _handleMouseLeave: function () {
            this._currentRowState = this._currentRowState ^ this._rowStates.ENTERED;
            this._updateStyle();
        },

        _onIconNodeMenuClick: function (evt) {
            this.contextMenu && this.contextMenu.scheduleOpen(evt.target, null, { x: evt.pageX, y: evt.pageY });
            this.emit("nodeSelected", this);
        },

        _updateStyleBySingleState: function (singleRowState) {
            // summary:
            //      Update style for single state
            // singleRowState: Flag
            //      Single (basic) state of the row node
            // tags:
            //      Private

            var states = this._rowStates;
            switch (singleRowState) {
                case states.SELECTED:
                case states.ENTERED:
                    if (this.contextMenu) {
                        domClass.add(this.iconNodeMenu, this._blockFolderMenu);
                    }
                    break;
                default:
                    /* Clear all style */
                    if (this.contextMenu) {
                        domClass.remove(this.iconNodeMenu, this._blockFolderMenu);
                    }
                    domClass.remove(this.iconNode, this._blockFolderExpand);
                    domClass.remove(this.iconNode, this._blockFolderCollapse);

                    /* Re-apply neccessary styles */
                    var nodeClass = this.isExpanded && this.hasChildren() ? this._blockFolderExpand : this._blockFolderCollapse;
                    domClass.add(this.iconNode, this._isTypeOfRoot() ? this.tree.model.getObjectIconClass(this.item, this._blockFolderCollapse) : nodeClass);

                    if (this.contextMenu && parseInt(this._currentRowState & this._rowStates.SELECTED, 10) > 0) {
                        domClass.add(this.iconNodeMenu, this._blockFolderMenu);
                    }

                    break;
            }
        },

        _updateStyle: function () {
            // summary:
            //      Update the style by the current state
            // tags:
            //      Private

            for (var singleRowState in this._rowStates) {
                if (parseInt(this._currentRowState & this._rowStates[singleRowState], 10) > 0) {
                    this._updateStyleBySingleState(this._rowStates[singleRowState]);
                }
            }
        },

        _addLanguageIndicator: function () {
            // summary:
            //      Setup missing language branch indicator UI
            // tags:
            //      protected override

            this.inherited(arguments);

            domAttr.remove(this.iconNodeLanguage, "title");
        },

        _setEditorState: function (/*String*/ errorMessage) {
            // summary:
            //      Set state error for editor widget if there are error message, otherwise reset state
            // errorMessage: [String]
            //      The error message
            // tags:
            //      private

            if (this._editWidget) {
                errorMessage = htmlEntities.encode(errorMessage);
                this._editWidget.invalidMessage = errorMessage || "";
                this._editWidget.set("state", errorMessage ? "Error" : "");
                this._editWidget.isValid = function () {
                    return !errorMessage;
                };
                this._editWidget.validate();
            }
        }

    });

});
},
'url:epi-cms/widget/templates/_FolderTreeNode.html':"﻿<div class=\"dijitTreeNode epi-folderTreeNode\" role=\"presentation\">\r\n    <div tabindex=\"-1\" data-dojo-attach-point=\"rowNode\" class=\"dijitTreeRow\" role=\"presentation\">\r\n        <div data-dojo-attach-point=\"indentNode\" class=\"dijitInline\"></div>\r\n        <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n            <span data-dojo-attach-point=\"expandoNode\" class=\"dijitTreeExpando\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"expandoNodeText\" class=\"dijitExpandoText\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-extraIconsContainer\" role=\"presentation\">\r\n                <span data-dojo-attach-point=\"iconNodeMenu\" class=\"epi-extraIcon dijitTreeIcon\" role=\"presentation\" title=\"${_menuTooltip}\">&nbsp;</span>\r\n                <span data-dojo-attach-point=\"iconNodeLanguage\" class=\"epi-extraIcon epi-ft-currentLanguageMissing\" role=\"presentation\">&nbsp;</span>\r\n            </span>\r\n            <span data-dojo-attach-point=\"labelNode\" class=\"dijitTreeLabel\" role=\"treeitem\" tabindex=\"-1\" aria-selected=\"false\"></span>\r\n        </span>\r\n    </div>\r\n    <div data-dojo-attach-point=\"containerNode\" class=\"dijitTreeContainer\" role=\"presentation\" style=\"display: none;\"></div>\r\n</div>",
'epi-cms/widget/ContentList':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-construct",

    "dojo/aspect",
    "dojo/Evented",
// dgrid
    "dgrid/Keyboard",
    "dgrid/OnDemandList",
    "dgrid/Selection",
// dojox
    "dojox/html/entities",
// epi
    "epi",

    "epi/shell/dgrid/Formatter",
    "epi/shell/TypeDescriptorManager",

    "epi-cms/core/ContentReference",

    "epi-cms/dgrid/formatters",
    "epi-cms/dgrid/DnD",
    "epi-cms/dgrid/WithContextMenu",

    "epi-cms/widget/ReadOnlyContentList"
],

function (
// dojo
    declare,
    lang,

    domClass,
    domConstruct,

    aspect,
    Evented,
// dgrid
    Keyboard,
    OnDemandList,
    Selection,
// dojox
    htmlEntities,
// epi
    epi,

    Formatter,
    TypeDescriptorManager,

    ContentReference,

    formatters,
    DnD,
    WithContextMenu,

    ReadOnlyContentList
) {

    // module:
    //      epi-cms/widget/ContentList
    // summary:
    //      Base class for lists for different content.
    // description:
    //      This is a base class that can be used to quickly create a list.
    // tags:
    //      public

    return declare([ReadOnlyContentList, Evented], {

        // _gridClass: [private] Object
        //      Content grid class declaration
        _gridClass: declare([OnDemandList, Formatter, Selection, DnD, Keyboard, WithContextMenu]),

        // resources: [public] Object
        //      Public resources for grid content list
        resources: "",

        // noDataMessage: [public] String
        //      No data message text for grid content list incase it has no data to display
        noDataMessage: null,

        // editingItem: [public] dojo.data.Item
        //      Keeps the selected content information
        editingItem: null,

        postCreate: function () {

            this.inherited(arguments);

            domClass.add(this.domNode, "epi-contentList");
        },

        _setCurrentItemAttr: function (/*dojo.data.Item*/value) {
            // summary:
            //      Store the selected content information on the first load
            // value: [dojo.data.Item]
            // tags:
            //      protected

            if (!this.get("editingItem")) {
                this.set("editingItem", value);
            }

            this._set("currentItem", value);
            this.select(value);
        },

        _setNoDataMessageAttr: function (/*String*/value) {
            // summary:
            //      Set text message for grid content list incase it has no data.
            // value: [String]
            //      No data message text
            // tags:
            //      protected

            this.noDataMessage = value;
            this.grid.set("noDataMessage", value);
        },

        _dndNodeCreator: function (/*dojo.data.Item*/item, hint) {
            // summary:
            //      Custom DnD avatar creator method
            // item: [dojo.data.Item]
            // hint: [String]
            // tags:
            //      private

            var dndTypes = TypeDescriptorManager.getAndConcatenateValues(item.typeIdentifier, "dndTypes");
            if (!dndTypes && this.dndTypes) {
                dndTypes = this.dndTypes;
            }

            return {
                "node": domConstruct.create("div").appendChild(document.createTextNode(item.name)),
                "type": dndTypes,
                "data": item
            };
        },

        getListSettings: function () {
            // summary:
            //      Initialization a list.
            // tags:
            //      protected, extension

            var menu = {
                hasMenu: !!this.contextMenu,
                settings: {
                    title: epi.resources.action.options
                }
            };

            // Init content list
            return lang.delegate(this._getBaseSettings(menu), {
                noDataMessage: this.noDataMessage,
                dndParams: {
                    copyOnly: true,
                    selfAccept: false,
                    accept: [],
                    creator: lang.hitch(this, this._dndNodeCreator)
                }
            });
        },

        setupEvents: function () {
            // summary:
            //      Initialization events on list.
            // tags:
            //      protected

            this.inherited(arguments);

            this.own(
                // Connect to create new item link when there's no children for the current parent.
                this.grid.on(".epi-createContent:click", lang.hitch(this, function (e) {
                    this.emit("createItemAction", {});
                })),

                aspect.around(this.grid, "insertRow", lang.hitch(this, this._aroundInsertRow))
            );
        },

        _onSelect: function (/*Event*/evt) {
            // summary:
            //      Emit selected event
            // evt: [Event]
            //      Select event of the grid
            // tags:
            //      private

            this.inherited(arguments);

            if (this.grid.selectionMode === "single") {
                this.emit("itemSelected", evt.rows[0].data);
            }
        },

        editContent: function (/*dojo.data.Item*/item) {
            // summary:
            //      Enable editing mode for the given content
            // item: [dojo.data.Item]
            //      Content that wanted to edit
            // tags:
            //      public

            // Do nothing if we do not found the given content in the grid
            if (!item || !this.grid.row(item).element) {
                return;
            }

            this.emit("itemAction", item);

            // After the selected content loaded, save its information
            this.set("editingItem", this.currentItem);
        },

        _onChangeContext: function (evt) {
            // summary:
            //      Go to content edit mode when change context event raised
            // evt: [Event]
            //      The click event that caused the change context.
            // tags:
            //      public

            this.editContent(this.grid.row(evt).data);
        },

        toggleCut: function (/*dojo.data.Item*/item, /*Boolean*/isCut) {
            // summary:
            //      Toggle cutting styles for the given item in the grid content list
            // item: [dojo.data.Item]
            // isCut: [Boolean]
            // tags:
            //      public

            var row;
            if (item) {
                row = this.grid.row(ContentReference.toContentReference(item.contentLink).id);
                if (row && row.element) {
                    domClass.toggle(row.element, "epi-opacity50", isCut);
                }
            }
        }

    });

});
},
'epi-cms/widget/FilesUploadDropZone':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-geometry",
// dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.uploadmultiplefiles.dropzone",
// template
    "dojo/text!./templates/FilesUploadDropZone.html"
],
function (
// dojo
    declare,
    lang,

    domClass,
    domGeometry,
// dijit
    _Widget,
    _TemplatedMixin,
// resources
    resources,
// template
    template
) {
    return declare([_Widget, _TemplatedMixin], {
        // summary:
        // tags:
        //      public

        res: resources, // Language resource for drop zone

        // Template for drop zone
        templateString: template,

        dragStartCssClass: "epi-dragStart", // Default drag start css class for drop zone when dragging over outside dom node
        dragOverCssClass: "epi-dragOver", // Default drag over css class for drop zone

        outsideDomNode: null, // Drop zone's outside dom node

        // Flag to indicate whether this drop zone should be enabled for dropping or not.
        enabled: true,

        postCreate: function () {
            // summary:
            //      Set initial values.
            // tags:
            //      protected

            this.inherited(arguments);

            if (this.outsideDomNode) {
                this.connect(this.outsideDomNode, "dragover", lang.hitch(this, this._onDragOverOutside));
                this.connect(this.outsideDomNode, "dragleave", lang.hitch(this, function (evt) {
                    this._onDragLeave(evt, this.outsideDomNode);
                }));
                this.connect(this.outsideDomNode, "dragend", lang.hitch(this, this._onDragLeave));
                this.connect(this.outsideDomNode, "drop", lang.hitch(this, this._onDragLeave));
            }

            this.connect(this.domNode, "dragover", lang.hitch(this, this._onDragOver));
            this.connect(this.domNode, "dragleave", lang.hitch(this, this._onDragLeave));
            this.connect(this.domNode, "dragend", lang.hitch(this, this._onDragLeave));
            this.connect(this.domNode, "drop", lang.hitch(this, this._onDrop));
        },

        _onDragOverOutside: function (evt) {
            // summary:
            //      Handle when dragging file(s) over outside drop zone
            //
            // tags:
            //      private

            if (!this.enabled) {
                return;
            }

            evt.preventDefault();
            domClass.add(this.domNode, this.dragStartCssClass);
        },

        _isHover: function (evt, domNode) {
            // summary:
            //      Checks if the mouse is hovering the input domNode.
            //
            // tags:
            //      private

            var divPos = domGeometry.position(domNode),
                mouseX = evt.clientX,
                mouseY = evt.clientY;
            return !(mouseX < divPos.x || mouseX > (divPos.x + divPos.w) ||
                mouseY < divPos.y || mouseY > (divPos.y + divPos.h));
        },

        _onDragOver: function (evt) {
            // summary:
            //      Handle when dragging file(s) over drop zone
            //
            // tags:
            //      private

            if (!this.enabled) {
                return;
            }

            evt.preventDefault();
            domClass.remove(this.domNode, this.dragStartCssClass);
            domClass.add(this.domNode, this.dragOverCssClass);
        },

        _onDragLeave: function (evt, domNode) {
            // summary:
            //      Handle when drag leaves file management
            //
            // tags:
            //      private

            if (!this.enabled) {
                return;
            }

            evt.preventDefault();
            if (!this._isHover(evt, domNode || this.domNode)) {
                this._removeAllCssClasses();
            }
        },

        onDrop: function (evt, files) {
            // summary:
            //      Trigger when some files dropped on the target
            // e: Event
            //      event object.
            // files: Array
            //      file list.
            // tags: callback
        },

        _onDrop: function (evt) {
            // summary:
            //      Handle when drop file(s) in drop zone
            //
            // tags:
            //      private

            if (!this.enabled) {
                return;
            }

            evt.preventDefault();
            this._removeAllCssClasses();
            this.onDrop(evt, evt.dataTransfer.files);
        },

        _removeAllCssClasses: function () {
            // summary:
            //      remove all added css classes
            //
            // tags:
            //      private

            domClass.remove(this.domNode, this.dragStartCssClass);
            domClass.remove(this.domNode, this.dragOverCssClass);
        }
    });
});
},
'url:epi-cms/widget/templates/FilesUploadDropZone.html':"﻿<div class=\"epi-filesUploadDropZone\">\r\n    <div>\r\n        <span data-dojo-attach-point=\"description\">${res.description}</span>\r\n    </div>\r\n</div>",
'url:epi-cms/widget/templates/HierarchicalList.html':"﻿<div class=\"epi-hierarchicalList\">\r\n    <div data-dojo-attach-point=\"container\"\r\n         data-dojo-type=\"dijit/layout/BorderContainer\"\r\n         data-dojo-props=\"gutters: false\">\r\n        <div class=\"epi-gadgetInnerToolbar\"\r\n             data-dojo-attach-point=\"searchBox\"\r\n             data-dojo-type=\"epi-cms/widget/SearchBox\"\r\n             data-dojo-props=\"region:'top', splitter: false, triggerContextChange: this.triggerContextChange\"\r\n             data-dojo-attach-event=\"onItemAction:_onSearchAction\"></div>\r\n        <div class=\"epi-secondaryGadgetContainer epi-gadgetTopContainer\"\r\n             data-dojo-attach-point=\"tree\"\r\n             data-dojo-type=\"epi-cms/widget/FolderTree\" \r\n             data-dojo-props=\"region:'center', splitter:false, model: this.model.treeStoreModel, showRoot: false, contextMenu: this.contextMenu\"></div>\r\n        <div data-dojo-attach-point=\"list\" class=\"epi-gadgetBottomContainer\"\r\n             data-dojo-type=\"epi-cms/widget/ContentList\"\r\n             data-dojo-props=\"region:'bottom', splitter:true, store: this.model.store, queryOptions: this.model.listQueryOptions, contextMenu: this.contextMenu, resources: this.res\">\r\n            <div data-dojo-attach-point=\"createContentArea\" class=\"epi-createContentContainer\">\r\n                <div class=\"epi-createContent\">\r\n                    <span data-dojo-attach-point=\"createContentAreaIcon\" class=\"dijitReset dijitInline dijitIcon\"></span>\r\n                    <span data-dojo-attach-point=\"createContentAreaText\" class=\"dijitReset dijitInline epi-createContentText\"></span>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>",
'url:epi-cms/widget/templates/AssetsDropZone.html':"﻿<div class=\"epi-assetsDropZone\">\r\n    <span class=\"dijitReset dijitInline epi-dropZoneText\">${res.dropzonedescription}</span>\r\n</div>\r\n",
'epi-cms/component/PageNavigationTree':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",

    "epi/dependency",

    "epi-cms/ApplicationSettings",
    "../core/ContentReference",
    "../command/NewContent",
    "./command/ViewTrash",
    "./ContentNavigationTree",

    "epi/i18n!epi/cms/nls/episerver.cms.components.createpage"
],

function (
    array,
    declare,
    lang,
    topic,
    when,

    dependency,

    ApplicationSettings,
    ContentReference,
    NewContentCommand,
    ViewTrashCommand,
    ContentNavigationTree,

    resCreatePage
) {

    return declare([ContentNavigationTree], {
        // summary:
        //    Main navigation for pages.
        //
        // description:
        //    Extends epi.cms.component.ContentNavigationTree with some customizations for pages.
        //
        // tags:
        //    public

        // gets propagated to dndSource, to be able to drop between nodes to sort.
        betweenThreshold: 5,
        
        // Expand the startpage
        expandExtraNodeItems: ApplicationSettings.startPage,

        checkAcceptance: function (source, nodes) {
            //Special handling for the page tree. We only accept internal dnd operations and don't have to check types since all content are pages.
            return source === this.tree.dndController;
        },

        _startupCommands: function () {
            // summary:
            //    Add command buttons to the Toolbar.
            //
            // tags:
            //    private

            this.inherited(arguments);

            this._createCommand = new NewContentCommand({
                order: 10,
                contentType: this.settings.containedTypes[0],
                iconClass: "epi-iconPlus",
                label: resCreatePage.command.label,
                resources: resCreatePage
            });

            this.commands = array.filter(this.commands, lang.hitch(this, function(command){
                return !(command instanceof NewContentCommand);
            }));

            this._viewTrashCommand = new ViewTrashCommand({ typeIdentifiers: this.typeIdentifiers });

            this.commands.push(this._createCommand);
            this.commands.push(this._viewTrashCommand);
        },

        getIconClass: function (/*dojo.data.Item*/item, /*Boolean*/opened) {
            // summary:
            //      Overridable function to return CSS class name to display icon,
            // item:
            //      The current contentdata.
            // opened:
            //      Indicate the node is expanded or not.
            // tags:
            //      extension
            var isRoot = array.some(this.model.roots, function(root) {
                return root == this.model.getIdentity(item);
            }, this);

            if (isRoot) {
                return "epi-iconObjectRoot";
            } else if (item.isStartPage) {
                return "epi-iconObjectStart";
            } else {
                return this.inherited(arguments);
            }
        }
    });
});
},
'epi-cms/component/ContentNavigationTree':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",

    "dojo/topic",
    "dojo/when",
// epi
    "epi/dependency",
    "epi/string",

    "epi/shell/ClipboardManager",
    "epi/shell/command/_WidgetCommandProviderMixin",
    "epi/shell/selection",
    "epi/shell/TypeDescriptorManager",

    "epi/shell/widget/dialog/Alert",
    "epi/shell/widget/dialog/Confirmation",

    "epi-cms/_ContentContextMixin",
    "epi-cms/_MultilingualMixin",
    "epi-cms/ApplicationSettings",

    "epi-cms/contentediting/PageShortcutTypeSupport",
    "epi-cms/command/ShowAllLanguages",
    "epi-cms/component/_ContentNavigationTreeNode",
    "epi-cms/component/ContentContextMenuCommandProvider",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/core/ContentReference",

    "epi-cms/widget/ContentTree",
    "epi/shell/widget/ContextMenu",

    "./command/_GlobalToolbarCommandProvider",
    "../command/CopyContent",
    "../command/CutContent",
    "../command/DeleteContent",
    "../command/PasteContent",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.createpage",
    "epi/i18n!epi/cms/nls/episerver.cms.components.pagetree"
],

function (
// dojo
    array,
    connect,
    declare,
    lang,

    domClass,

    topic,
    when,
// epi
    dependency,
    epistring,

    ClipboardManager,
    _WidgetCommandProviderMixin,
    Selection,
    TypeDescriptorManager,

    Alert,
    Confirmation,

    _ContentContextMixin,
    _MultilingualMixin,
    ApplicationSettings,

    PageShortcutTypeSupport,
    ShowAllLanguagesCommand,
    _ContentNavigationTreeNode,
    ContextMenuCommandProvider,
    ContentActionSupport,
    ContentReference,

    ContentTree,
    ContextMenu,

    _GlobalToolbarCommandProvider,
    CopyCommand,
    CutCommand,
    DeleteCommand,
    PasteCommand,
// resources
    resCreatePage,
    res
) {

    // module:
    //      epi-cms/component/ContentNavigationTree
    // summary:
    //      Light weight Page tree component.
    // description:
    //      Extends epi.cms.widget.PageTree to provide global messaging capability.
    // tags:
    //      public

    return declare([ContentTree, _ContentContextMixin, _WidgetCommandProviderMixin, _MultilingualMixin], {

        res: res,

        showAllLanguages: true,

        _separatorBeforeCssClass: "rowSeparatorBefore",
        _separatorAfterCssClass: "rowSeparatorAfter",

        _clipboardManager: null,
        _contextMenu: null,
        _contextMenuCommandProvider: null,

        _focusNode: null,

        // gets propagated to dndSource
        betweenThreshold: 0,

        contextMenuCommandProvider: ContextMenuCommandProvider,

        nodeConstructor: _ContentNavigationTreeNode,

        postMixInProperties: function () {
            this.inherited(arguments);

            this._clipboardManager = new ClipboardManager();

            this.selection = new Selection();


            //Create the context menu command provider
            this._contextMenuCommandProvider = new this.contextMenuCommandProvider({
                treeModel: this.model,
                clipboardManager: this._clipboardManager,
                repositoryKey: this.repositoryKey
            });
            this._startupCommands();

            this.model.roots = this.roots;
            this.model.notAllowToDelete = this.settings.preventDeletionFor;
            this.model.notAllowToCopy = this.settings.preventCopyingFor;
        },

        postCreate: function () {
            // summary:
            //    Post create initialization
            // tags:
            //    protected

            this.inherited(arguments);

            this.own(
                this.on("copyOrCut", lang.hitch(this, function (copy) {
                    copy ? this._copyCommand.execute() : this._cutCommand.execute();
                })),
                this.on("paste", lang.hitch(this, function () {
                    when(this._pasteCommand.execute(), lang.hitch(this, function () {
                        this.selectedNode.expand();
                    }));
                })),
                this.on("delete", lang.hitch(this, function () {
                    this._deleteCommand.canExecute ? this._deleteCommand.execute() : this._showNotificationMessage(this.res.cannotdelete);
                })),
                this.on("select", lang.hitch(this, this._onTreeNodeClicked))
            );

            this.connect(this, "onClick", "_onTreeNodeClicked");

            //TODO: Remove topic and replace with normal event?
            var resetSelection = lang.hitch(this, "_resetSelectionToLastSelected");
            this.subscribe("/epi/dnd/dropdata", resetSelection);
            this.subscribe("/dnd/cancel", resetSelection);
        },

        startup: function () {
            this.inherited(arguments);

            when(this.getCurrentContext(), lang.hitch(this, function (context) {
                this.contextChanged(context);
            }));
        },

        _preparePathNodes: function (paths) {
            // summary:
            //      Prepare steps before node selection in the tree
            // tags:
            //      protected, extension

            var self = this,
                parentNodes;

            array.some(paths, function (pathNode, index) {

                var nodes = self.getNodesByItem(pathNode),
                    noNodes = nodes.length === 1 && !nodes[0]; // No hits returns a single item array with the item set to undefined

                if (index > 0 && noNodes) {
                    array.forEach(parentNodes, function (parentNode) {
                        if (parentNode.state === "LOADED") {
                            // "Unset" to get it to refresh next time it is called
                            parentNode._loadDeferred = null;
                        }
                    });

                    return true;
                }

                parentNodes = nodes;

                return false;
            });
        },

        _resetSelectionToLastSelected: function () {
            if (!this._lastSelectedContentReference || !this.selectedItem) {
                return;
            }

            if (this.selectedItem.contentLink !== this._lastSelectedContentReference) {
                // reset when we our selection is not the last one loaded
                this.selectContent(this._lastSelectedContentReference);
            }
        },

        _startupCommands: function () {
            // summary:
            //    Add command buttons to Global Toolbar
            //
            // appInstance: instance of current application
            //
            // tags:
            //    private

            this._showLanguagesCommand = new ShowAllLanguagesCommand({ model: this });

            var commands = this._contextMenuCommandProvider.get("commands");

            array.some(commands, lang.hitch(this, function (command) {
                if (command instanceof CopyCommand) {
                    this._copyCommand = command;
                } else if (command instanceof CutCommand) {
                    this._cutCommand = command;
                } else if (command instanceof PasteCommand) {
                    this._pasteCommand = command;
                } else if (command instanceof DeleteCommand) {
                    this._deleteCommand = command;
                }
                if (this._deleteCommand && this._pasteCommand && this._copyCommand) {
                    return true;
                }
            }));

            this.commands = [
                this._showLanguagesCommand
            ].concat(commands);
        },

        _setShowAllLanguagesAttr: function (value) {
            this._set("showAllLanguages", value);
            this.model.set("showAllLanguages", value);
        },

        _onTreeNodeClicked: function (page, node, event) {
            // summary:
            //    Override onPageChange event
            //
            // page: Object
            //    The page object.
            //
            // tags:
            //    public

            when(this.getCurrentContext(), lang.hitch(this, function (currentContext) {
                var selectNew = currentContext ? ContentReference.compareIgnoreVersion(page.contentLink, currentContext.id) : true;

                var selectContent = function (sender) {
                    // get content type and content name, to pass to requestContentChange request
                    var requestedContent = {
                        typeName: TypeDescriptorManager.getResourceValue(page.typeIdentifier, "name"),
                        name: page.name
                    };

                    topic.publish("/epi/shell/context/request", { uri: page.uri }, {
                        sender: lang.mixin(sender, { requestedContent: requestedContent }),
                        forceContextChange: true
                    });
                };

                // If the new selection is not the same as old, go to the new immediately
                if (!selectNew) {
                    selectContent(this);
                    return;
                }

                if (this.selectContentThrottle) {
                    clearTimeout(this.selectContentThrottle);
                    this.selectContentThrottle = null;
                }

                // Set timeout to change context in case multiple clicks
                this.selectContentThrottle = setTimeout(selectContent, 300);
            }));
        },

        contentContextChanged: function (newContext, callerData) {
            // summary:
            //      Subcriptions to /epi/shell/context/changed topic to sync page tree selection
            // tags:
            //      private

            var contentReference = new ContentReference(newContext.id),
                reference = contentReference.createVersionUnspecificReference().toString(),
                wasteBasketId = ApplicationSettings.wastebasketPage.toString();

            this.inherited(arguments);

            // We don't show wastebasket int the trees right now
            if (reference === wasteBasketId) {
                return;
            }

            // Set selection data in order to ensure that its value always updated
            this.selection.set("data", this._getSelectionData(this.selectedItem));

            // keep track of which content was selected last
            this._lastSelectedContentReference = reference;

            //If the new selection is the same as the old, return and do not request a context change.
            if (callerData && callerData.sender === this && this.selectedItem && reference === this.selectedItem.contentLink) {
                this._updateGlobalToolbarButtons();
            }

            // If the new context is a supported type then select that type within the tree and update commands.
            if (this.isSupportedType(newContext.dataType)) {
                this.selectContent(reference, false, true).then(lang.hitch(this, "_updateGlobalToolbarButtons"));
            }
        },

        isSupportedType: function (dataType) {
            // summary:
            //      Check the supported type of data type selected.
            // dataType: [String]
            //      The type of data selected
            // tags:
            //      protected

            return this.tree.model.isSupportedType(dataType);
        },

        _getSelectionData: function (/*dojo.data.Item*/itemData) {
            // summary:
            //      Return selection data
            // tags:
            //      private

            return itemData ? [{ type: "epi.cms.contentdata", data: itemData }] : [];
        },

        _updateGlobalToolbarButtons: function (targetNode) {
            // sumary:
            //    Show/hide associated buttons (Copy/Cut/Paste/Move to Recycle Bin) with the current action
            //
            // tags:
            //    private

            var node = targetNode || this.get("selectedNode"),
                selected = node ? this._getSelectionData(node.item) : [];

            if (this._createCommand) {
                this._createCommand.set("model", node && node.item);
            }

            //Bind the item
            this._contextMenuCommandProvider.updateCommandModel(node && node.item);
            this.selection.set("data", selected);
        },

        contextChangeFailed: function (oldContext, requestContextParams, callerData) {
            // summary:
            //    Subcriptions to /epi/shell/context/requestfailed topic to sync page tree selection
            //
            // tags:
            //    protected

            this.inherited(arguments);

            if (oldContext) {
                // select old page link
                if (callerData && callerData.sender === this) {
                    this.selectContent(oldContext.contentLink);
                }
            }
        },

        _removeHighlightClass: function () {
            // summary:
            //      Remove highlight css class for current focus node
            // tags:
            //      private

            if (this._focusNode && this._focusNode != this.selectedNode && this._focusNode.rowNode) {
                domClass.remove(this._focusNode.rowNode, "dijitTreeRowSelected");
            }
        },

        _onContextMenuClose: function () {
            // summary:
            //      Handles context menu close event
            // tags:
            //      private

            this._removeHighlightClass();
        },

        _onContextMenuOpen: function () {
            // summary:
            //      Handles context menu open event
            // tags:
            //      private

            if (this._focusNode) {
                domClass.add(this._focusNode.rowNode, "dijitTreeRowSelected");
            }
        },

        _set_focusNodeAttr: function (value) {
            // summary:
            //      Set focus node function
            // tags:
            //      private

            this._removeHighlightClass();
            this._focusNode = value;
        },

        _showContextMenu: function (evt) {

            //Create the context menu if used for the first time
            if (!this._contextMenu) {
                this.own(
                    this._contextMenu = new ContextMenu({ leftClickToOpen: true, category: "context" }),
                    connect.connect(this._contextMenu, "onClose", this, "_onContextMenuClose"),
                    connect.connect(this._contextMenu, "onOpen", this, "_onContextMenuOpen")
                );
                this._contextMenu.addProvider(this._contextMenuCommandProvider);
                this._contextMenu.startup();
            }

            //Open the context menu
            this._contextMenu.scheduleOpen(evt.target, null, { x: evt.x, y: evt.y });
        },

        _createTreeNode: function () {
            // summary:
            //      Overridable function to make tree node draggable and droppable after creation
            // args: Object
            //      Tree node creation arguments
            // tags:
            //      extension

            var treeNode = this.inherited(arguments);

            // Remove the row separator after root's containerNode node.
            if (treeNode.item.contentLink == this.tree.model.rootPage) {
                var rowSeparatorNodes = array.filter(treeNode.domNode.children, function (childNode) {
                    return childNode.className == this._separatorAfterCssClass;
                }, this);
            }

            treeNode.on("onContextMenuClick", lang.hitch(this, function (node) {

                this._updateGlobalToolbarButtons(node.node);

                this.set("_focusNode", node.node);
                this._showContextMenu(node);
            }));

            return treeNode;
        },

        getIconClass: function (/*dojo.data.Item*/item, /*Boolean*/opened) {
            // summary:
            //      Overridable function to return CSS class name to display icon,
            // item: [dojo.data.Item]
            //      The current contentdata.
            // opened: [Boolean]
            //      Indicate the node is expanded or not.
            // tags:
            //      public, extension

            var inherited = this.inherited(arguments);

            if (!item || !item.properties || !item.properties.pageShortcutType) {
                return inherited;
            }

            var shortcutTypeIcon = "";

            switch (item.properties.pageShortcutType) {
                case PageShortcutTypeSupport.pageShortcutTypes.Shortcut:
                    shortcutTypeIcon = "epi-iconObjectInternalLink";
                    break;
                case PageShortcutTypeSupport.pageShortcutTypes.External:
                    shortcutTypeIcon = "epi-iconObjectExternalLink";
                    break;
                case PageShortcutTypeSupport.pageShortcutTypes.Inactive:
                    shortcutTypeIcon = "epi-iconObjectNoLink";
                    break;
                case PageShortcutTypeSupport.pageShortcutTypes.FetchData:
                    shortcutTypeIcon = !item.hasTemplate ? "epi-iconObjectContainerFetchContent" : "epi-iconObjectFetchContent";
                    break;
                default:
                    break;
            }

            return shortcutTypeIcon ? inherited + " " + shortcutTypeIcon : inherited;
        },

        enableDrop: function (node, isAllowed) {
            // summary:
            //     Sets whether this target is droppable or not
            // node: Object
            //     Target node to update its _droppable.
            // isAllowed: Boolean
            //     Flag to indicate whether this target is droppable or not.
            // tags: callback

            node._droppable = isAllowed;
        },

        _showNotificationMessage: function (message) {
            // summary:
            //      Show a alert message
            // message:
            //      The message to be displayed in the alert.
            // tags:
            //      private

            var dialog = new Alert({
                destroyOnHide: true,
                description: epistring.toHTML(message)
            });

            dialog.show();
        },

        _onNodeMouseEnter: function (/* Tree._TreeNode */node, evt) {
            // summary:
            //      Handles mouse enter event on a node
            // tags:
            //      private

            this.inherited(arguments);
            node.showContextMenu(true);
        },

        _onNodeMouseLeave: function (/* Tree._TreeNode */node, evt) {
            // summary:
            //      Handles mouse leave event on a node
            // tags:
            //      private

            this.inherited(arguments);
            node.showContextMenu(false);
        }

    });

});
},
'epi-cms/contentediting/PageShortcutTypeSupport':function(){
﻿define([], function () {
    var shortcutTypeSupport = {
        pageShortcutTypes: {
            Normal: 0,
            Shortcut: 1,
            External: 2,
            Inactive: 3,
            FetchData: 4
        }
    };
    return shortcutTypeSupport;
});
},
'epi-cms/command/ShowAllLanguages':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    "epi/dependency",
    "epi-cms/ApplicationSettings",
    "epi/shell/command/ToggleCommand",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.command"
],

function (
    declare,
    lang,
    when,

    dependency,
    ApplicationSettings,
    ToggleCommand,
    resources
) {

    // module:
    //      epi/cms/command/ShowAllLanguages
    // summary:
    //      A command that toggles whether all languages are shown.

    return declare([ToggleCommand], {

        // property: [public] String
        //      The name of the property on the model which this command will toggle.
        property: "showAllLanguages",

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "setting",
        
        // order: [readonly] Integer
        //      An ordering indication used when generating a ui for this command. 
        //      Commands with order indication will be placed before commands with no order indication.
        order: 50,

        _watchHandle: null,

        postscript: function() {
            this.inherited(arguments);

            this.currentContentLanguage = this.currentContentLanguage || ApplicationSettings.currentContentLanguage;

            this.store = this.store || dependency.resolve("epi.storeregistry").get("epi.cms.language");

            when(this.store.get(this.currentContentLanguage), lang.hitch(this, function(language){
                this.set("label", lang.replace(resources.showonlycontentin, [language.name]));
            }));
        },

        _execute: function () {
            // summary:
            //		Overidde base class, toggles the value of the given property on the model.
            // tags:
            //		protected

            // Toggles the active state
            this.set("active", !this.active);

            // If active state is true, we will show only contents in current language,
            // otherwise show contents in all languages
            this.model.set(this.property, !this.active);
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated.
            // tags:
            //      protected

            if (this.model && this.model._isSiteMultilingual) {
                when(this.model._isSiteMultilingual(), lang.hitch(this, function (value) {
                    this.set("canExecute", value);
                }));
            }
        }
    });
});
},
'epi-cms/component/_ContentNavigationTreeNode':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",

    "dojo/dom-attr",
    "dojo/dom-class",

    "dojo/Evented",
    "dojo/mouse",
    "dojo/on",

// template
    "dojo/text!./templates/_ContentNavigationTreeNode.html",

// epi
    "epi/datetime",
    "epi/dependency",
    "epi/string",

    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/Tooltip",

    "epi-cms/core/ContentReference",
    "epi-cms/widget/_ContentTreeNode",
    "epi-cms/widget/viewmodel/ContentStatusViewModel",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.pagetree",
    "epi/i18n!epi/cms/nls/episerver.shared.header"
],

function (
// dojo
    array,
    declare,
    event,
    lang,

    domAttr,
    domClass,

    Evented,
    mouse,
    on,

// template
    template,

// epi
    epiDate,
    dependency,
    epiString,

    _ModelBindingMixin,
    Tooltip,

    ContentReference,
    _ContentTreeNode,
    ContentStatusViewModel,
// resources
    res,
    headingResources
) {

    // summary:
    //      A customized treenode for page tree
    // tags:
    //      public

    return declare([_ContentTreeNode, _ModelBindingMixin, Evented], {
        templateString: template,
        res: res,

        // hasContextMenu: [bool]
        //      Flag used to not create context menu
        hasContextMenu: true,

        _pageLocked: 'epi-pt-accessRights',

        _pageBeingEdited: 'epi-pt-edited',

        _contextMenuClass: 'epi-iconContextMenu',

        // _iconNodeClass: [String]
        //      Custom icon for a node in the tree
        // tags:
        //      protected
        _iconNodeClass: '',

        // _iconNodeToolTip: Object
        //      Represents the tooltip for an icon node
        _iconNodeToolTip: undefined,

        _inUseTooltip: undefined,
        _selected: false,

        // _contentTypeStore: [Object]
        //      Represents the ContentType REST store to get data.
        _contentTypeStore: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            var registry = dependency.resolve("epi.storeregistry");

            this._contentTypeStore = registry.get("epi.cms.contenttype");
        },

        postCreate: function () {
            this.inherited(arguments);

            this.set("model", new ContentStatusViewModel({ contentStatus: this.item.status }));
        },

        modelBindingMap: {
            "statusIcon": ["statusIcon"],
            "statusMessage": ["statusMessage"]
        },

        _setStatusMessageAttr: function (/* String */message) {
            // summary:
            //      Set content status message
            // tags:
            //      private

            domAttr.set(this.iconNodeStatus, "title", epiString.toTooltipText(message));
        },

        _setStatusIconAttr: function (/* String */cssClasses) {
            // summary:
            //      Set content status icon CSS classes
            // tags:
            //      private

            if (!(cssClasses instanceof Array)) {
                return;
            }

            //remove everything
            domClass.remove(this.iconNodeStatus);

            domClass.add(this.iconNodeStatus, "dijitTreeIcon epi-extraIcon");
            array.forEach(cssClasses, function (cssClass) {
                domClass.add(this.iconNodeStatus, cssClass);
            }, this);
        },

        destroy: function () {
            this.inherited(arguments);

            this._destroyIconNodeTooltip();
        },

        setSelected: function (/*Boolean*/selected) {
            // summary:
            //      Override to show contex menu if the node is selected
            // tags:
            //      public

            this.inherited(arguments);
            if (this.hasContextMenu) {
                domClass.toggle(this.iconNodeMenu, this._contextMenuClass, this._selected = selected);
            }
        },

        showContextMenu: function (/* Boolean */show) {
            // summary:
            //      Toogle context menu icon
            // Remark:
            //      Do not use domClass.toggle because: we show the context menu using _onNodeMouseEnter event in the Tree
            //      but this event will be trigger twice (only in IE & FireFox) once the node is updated or reloaded.
            // tags:
            //      public

            if (!this._selected && this.hasContextMenu) {
                domClass.toggle(this.iconNodeMenu, this._contextMenuClass, show);
            }
        },

        _onClickIconNodeMenu: function (evt) {
            event.stop(evt);

            // Since we're stopping the event we're preventing the regular focus handling,
            // which means that the context menu won't have anything to restore focus to when closed
            this.labelNode.focus();
            this.emit("onContextMenuClick", { node: this, target: evt.target, x: evt.pageX, y: evt.pageY });
        },

        _onMouseDownIconNodeMenu: function (evt) {
            //Stop mouse down event when clicking on the context menu icon
            event.stop(evt);
        },

        _updateIndividualLayout: function () {
            this._updateAccessRightIcon();

            if (this.model) {
                this.model.set("contentStatus", this.item.status);
            }

            // Update tooltip
            this._createTooltip();
        },

        _updateAccessRightIcon: function () {
            // summary:
            //      Set access right and icon for the tree node
            // tags:
            //      private

            // Display lock icon if current user has no permission or only has "Read" permission
            if (this.item.accessMask === 0 || this.item.accessMask == 1) {
                domClass.add(this.iconNodeAccess, this._pageLocked);
                // Add tooltip to icon
                domAttr.set(this.iconNodeAccess, "title", this.res.tooltip.pagelocked);

                // Set default background for this type of nodes
                domClass.add(this.contentNode, "epi-treeReadOnly");
            }
            else if (this.item.inUseNotifications && this.item.inUseNotifications.length > 0) {
                // Display being edited icon
                // Only display this icon if user has change permission on page
                domClass.add(this.iconNodeAccess, this._pageBeingEdited);

                // create list of user names and dates
                var tooltipRows = [{ label: this.res.tooltip.beingedited }];

                array.forEach(this.item.inUseNotifications, function (inUseNotification) {
                    var date = epiDate.toUserFriendlyHtml(inUseNotification.created);
                    tooltipRows.push({ label: inUseNotification.userName + ", " + date, htmlEncode: false });
                }, this);

                this._populateIconNodeTooltip(tooltipRows, this.iconNodeAccess);
            }
            else {
                domClass.remove(this.iconNodeAccess, this._pageBeingEdited);
                domClass.remove(this.iconNodeAccess, this._pageLocked);
                domClass.remove(this.contentNode, "epi-treeReadOnly");

                this._destroyIconNodeTooltip();
            }
        },

        _createTooltip: function () {
            // summary:
            //      Create a tooltip for the tree node and icon node.
            // tags:
            //      private

            // Don't create a tooltip if this node isn't visible.
            if(this.indent < 0) {
                return;
            }

            //We create a content reference and use the id to hide the provider key for the user.
            var reference = new ContentReference(this.item.contentLink);
            var title = this.item.name +
                ", " + headingResources.id + ": " + reference.id +
                " (" + headingResources.type + ": " + this.item.contentTypeName +")";
            domAttr.set(this.labelNode, "title", title);
            domAttr.set(this.iconNode, "title", title);
        },

        _populateIconNodeTooltip: function (/* Array */tooltipRows, /* String | DomNode */nodeToConnect) {
            // summary:
            //      Create the tooltip for target icon node
            // tags:
            //      private

            if (!this._iconNodeToolTip) {
                this._iconNodeToolTip = new Tooltip({
                    position: ["after-centered", "below"]
                });
            }
            this._iconNodeToolTip.tooltipRows = tooltipRows;

            this.own(
                on(nodeToConnect, mouse.enter, lang.hitch(this, function () {
                    if (this._iconNodeToolTip) {
                        this._iconNodeToolTip.open(nodeToConnect);
                    }
                })),
                on(nodeToConnect, mouse.leave, lang.hitch(this, function () {
                    if (this._iconNodeToolTip) {
                        this._iconNodeToolTip.close();
                    }
                }))
            );
        },

        _destroyIconNodeTooltip: function () {
            // summary:
            //      Destroy the tooltip for icon node
            // tags:
            //      private

            if (this._iconNodeToolTip) {
                this._iconNodeToolTip.destroyRecursive();
                this._iconNodeToolTip = null;
            }
        }
    });
});
},
'url:epi-cms/component/templates/_ContentNavigationTreeNode.html':"﻿<div class=\"dijitTreeNode\" role=\"presentation\">\r\n    <div data-dojo-attach-point=\"rowNode\" class=\"dijitTreeRow dijitInline\" role=\"presentation\">\r\n        <div data-dojo-attach-point=\"indentNode\" class=\"dijitInline\"></div>\r\n        <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n            <span data-dojo-attach-point=\"expandoNode\" class=\"dijitTreeExpando\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"expandoNodeText\" class=\"dijitExpandoText\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-extraIconsContainer\" role=\"presentation\">\r\n                <span data-dojo-attach-point=\"iconNodeMenu\" class=\"epi-extraIcon epi-pt-contextMenu\" role=\"presentation\" data-dojo-attach-event=\"onmousedown:_onMouseDownIconNodeMenu, click: _onClickIconNodeMenu\" >&nbsp;</span>\r\n                <span data-dojo-attach-point=\"iconNodeStatus\" class=\"epi-extraIcon\" role=\"presentation\">&nbsp;</span>\r\n                <span data-dojo-attach-point=\"iconNodeAccess\" class=\"epi-extraIcon\" role=\"presentation\">&nbsp;</span>\r\n                <span data-dojo-attach-point=\"iconNodeLanguage\" class=\"epi-extraIcon epi-pt-currentLanguageMissing\" role=\"presentation\">&nbsp;</span>\r\n            </span>\r\n            <span data-dojo-attach-point=\"labelNode\" class=\"dijitTreeLabel\" role=\"treeitem\" tabindex=\"-1\" aria-selected=\"false\"></span>\r\n        </span>\r\n    </div>\r\n    <div data-dojo-attach-point=\"containerNode\" class=\"dijitTreeContainer\" role=\"presentation\" style=\"display: none;\"></div>\r\n</div>",
'epi/shell/widget/Tooltip':function(){
﻿define("epi/shell/widget/Tooltip", [
    "dojo/_base/declare",
    "dojo/string",

    "dojox/html/entities",
    "dojox/html/ellipsis",

    "dijit/Tooltip"
], function (
    declare,
    string,

    entities,
    ellipsis,

    Tooltip) {
    return declare( Tooltip, {
        showDelay: 600, // tooltip display timeout increased,

        // position: String[]
        //      List of positions to try to position tooltip
        position: ["after", "before", "below", "above"],

        // tooltipRows: [public] Array
        //      If property is set the lable will be overriden
        //      Accepts an array of {label:'', text:'', htmlEncode:false}
        tooltipRows: null,

        // tooltipRowTemplate: [public] String
        //      Detault row template tooltip added to tooltipRows
        tooltipRowTemplate: "<span>${label}</span>: ${text}",
        tooltipRowNoTextTemplate: "<span>${label}</span>",

        getContent: function() {
            //If there are any tooltip rows create a label using the tooltipRowTemplate
            if (this.tooltipRows) {
                var content = "<ul class='dijitInline dijitReset epi-tooltip-ellipsis'>";
                for (var i = 0; i < this.tooltipRows.length; i++) {
                    var row = this.tooltipRows[i];
                    if (!row.text) {
                        row.text = "";
                    }
                    if (row.htmlEncode === undefined || row.htmlEncode === true) {
                        row.label = entities.encode(row.label);
                        row.text = entities.encode(row.text);
                    }
                    if (!row.text) {
                        content += "<li class='dojoxEllipsis'>" + string.substitute(this.tooltipRowNoTextTemplate, row) + "</li>";
                    }
                    else {
                        content += "<li class='dojoxEllipsis'>" + string.substitute(this.tooltipRowTemplate, row) + "</li>";
                    }
                }
                content += "</ul>";

                return content;
            }

            return this.inherited(arguments);
        }
    });
});

},
'epi-cms/widget/viewmodel/ContentStatusViewModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/when",
    "dojo/promise/all",
    "dojo/Stateful",

// epi 
    "epi/dependency",
    "epi/shell/_StatefulGetterSetterMixin",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/shell/_ContextMixin",
    "epi-cms/ContentLanguageHelper",

// resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.versionstatus"
],
function (
// dojo
    array,
    declare,
    Deferred,
    lang,
    when,
    all,
    Stateful,

// epi
    dependency,
    _StatefulGetterSetterMixin,
    ContentActionSupport,
    _ContextMixin,
    ContentLanguageHelper, 

// resources
    versionStatusResources
) {
    // module:
    //      epi-cms/widget/viewmodel/ContentStatusViewModel
    // summary:
    //      ContentStatusViewModel
    // tags:
    //      public

    return declare([Stateful, _ContextMixin], {
        _contentStructureStore: null,

        // autoLoadStatus: [Boolean]
        //      Set it to true of the status information should be automatically loaded when the contentLink is set
        // tags:
        //      public
        autoLoadStatus: false,

        // statusIcon: [String]
        //      Store content status icon classes
        // tags:
        //      public
        statusIcon: null,

        // statusMessage: [Object]
        //      Store content status message.
        //      Can be [String] or [Array] data type.
        // tags:
        //      public
        statusMessage: null,

        constructor: function() {
             this._statusIconArray = [
            // Not created icon CSS classes
                    ["epi-statusIndicatorIcon", "epi-statusIndicator0"],
            // Rejected icon CSS classes
                    ["epi-statusIndicatorIcon", "epi-statusIndicator1"],
            // Checked-out icon CSS classes
                    ["epi-statusIndicatorIcon", "epi-statusIndicator2"],
            // Checked-in icon CSS classes
                    ["epi-statusIndicatorIcon", "epi-statusIndicator3"],
            // Published icon CSS classes
                    ["epi-statusIndicatorIcon", "epi-statusIndicator4"],
            // Previously published icon CSS classes
                    ["epi-statusIndicatorIcon", "epi-statusIndicator5"],
            // Delayed publish icon CSS classes
                    ["epi-statusIndicatorIcon", "epi-statusIndicator6"],
            // Expired icon CSS classes
                    ["epi-statusIndicatorIcon", "epi-statusIndicator7"]
                ];

            this._statusMessageArray = [
            // Not created message
                    versionStatusResources.notcreated,
            // Rejected message
                    versionStatusResources.rejected,
            // Checked-out message
                    versionStatusResources.checkedout,
            // Checked-in message
                    versionStatusResources.checkedin,
            // Published message
                    versionStatusResources.published,
            // Previously published message
                    versionStatusResources.previouslypublished,
            // Delayed publish message
                    versionStatusResources.delayedpublish,
            // Expired message
                    versionStatusResources.expired
                ];
        },

        postscript: function () {
            this.inherited(arguments);

            this._contentStructureStore = this._contentStructureStore || dependency.resolve("epi.storeregistry").get("epi.cms.content.light");
        },

        loadStatus: function() {
            // summary:
            //      Loads the status for the current contentLink
            // tags:
            //      public
            if (!this.contentLink) {
                return;
            }
            when(this.getCurrentContext(), lang.hitch(this, function(ctx) {
                //- Using refresh instead get function to load content link 
                //- Do not want use cache in this case
                when(this._contentStructureStore.refresh(this.contentLink), lang.hitch(this, function(contentInfo) {
                    if (contentInfo && contentInfo.status !== undefined) {
                        this.set("content", contentInfo);
                    }
                }));
            }));
        },

        _contentLinkSetter: function (/* String */contentLink) {
            // summary:
            //      Content Link setter
            // contentLink: [String]

            if (!contentLink) {
                return;
            }

            this.contentLink = contentLink;

            if(this.autoLoadStatus){
                this.loadStatus();
            }
        },

        _isDeletedGetter: function() {
            return this.get("content") && this.get("content").isDeleted;
        },

        _isTranslationNeededGetter: function() {
            return this.get("content") && this.get("content").missingLanguageBranch && this.get("content").missingLanguageBranch.isTranslationNeeded;
        },

        _missingLanguageBranchGetter: function() {
            return this.get("content") && this.get("content").missingLanguageBranch;
        },

        _contentSetter: function (content) {
            this.content = content;
            
            this.set("contentStatus", content.status);
        },

        _contentStatusSetter: function(status) {
            this.contentStatus = status;

            if(!status) {
                return;
            }

            this.set("statusIcon", this._statusIconArray[status]);

            when(this._getStatusMessage(), lang.hitch(this, function(message) {
                this.set("statusMessage", message);
            }));
        },

        _getStatusMessage: function () {
            // summary:
            //      Get content version status message.
            //      Override this function to customize content status message.
            // tags:
            //      protected

            //If the content is deleted return version not found
            if (this.get("isDeleted")) {
                return versionStatusResources.versionnotfound;
            }
            if (this.get("isTranslationNeeded")) {
                return ContentLanguageHelper.getMissingLanguageMessage(this.content);
            }

            if(this.get("isVisibleOnSite")){
                return null;
            }
            return this._statusMessageArray[this.get("contentStatus")];
        },

        _isVisibleOnSiteGetter: function () {
            // summary:
            //      Allow create additional information area or not.
            //      Based on content version status.
            // status: [Integer]
            //      Content status
            // tags:
            //      public

            var missingLanguageBranch = this.get("missingLanguageBranch");
            if (this.get("isDeleted") || missingLanguageBranch && missingLanguageBranch.reason == 6) {
                return false;
            }

            return this.get("contentStatus") === ContentActionSupport.versionStatus.Published;
        }
    });
});

},
'epi-cms/component/ContentContextMenuCommandProvider':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/array",
// epi
    "epi/shell/command/_CommandProviderMixin",

    "../command/CopyContent",
    "../command/CutContent",
    "../command/PasteContent",
    "../command/TranslateContent",
    "../command/DeleteContent",

    "../widget/CreateCommandsMixin",

    "epi/shell/selection"
],

function (
// dojo
    declare,
    array,
// epi
    _CommandProviderMixin,
    CopyCommand,
    CutCommand,
    PasteCommand,
    TranslateCommand,
    DeleteCommand,

    CreateCommandsMixin,

    Selection
) {

    // module:
    //      epi-cms/component/ContentContextMenuCommandProvider
    // summary:
    //      Command provider for content context menus
    // tags:
    //      public

    return declare([_CommandProviderMixin, CreateCommandsMixin], {

        // treeModel: [Object]
        //      Model use for the commands
        treeModel: null,

        clipboardManager: null,

        _settings: null,
        _newContentCommand: null,
        _translateContentCommand: null,

        constructor: function (params) {
            declare.safeMixin(this, params);
        },

        postscript: function () {
            this.inherited(arguments);

            //Create the commands
            this._settings = {
                category: "context",
                model: this.treeModel,
                clipboard: this.clipboardManager,
                selection: new Selection()
            };

            this._translateContentCommand = new TranslateCommand({ category: "context"});

            var createCommands = this.getCreateCommands(),
                commands = [];

            for (var key in createCommands) {
                commands.push(createCommands[key].command);
            }

            commands.push(
                this._translateContentCommand,
                new CutCommand(this._settings),
                new CopyCommand(this._settings),
                new PasteCommand(this._settings),
                new DeleteCommand(this._settings)
            );

            this.set("commands", commands);
        },

        updateCommandModel: function (model) {
            // summary:
            //      Updates the model for the commands.
            // tags:
            //      public

            array.forEach(this.get("commands"), function(command){
                if (command.isInstanceOf(this.createCommandClass) || command.popup){
                    command.set("model", model);
                }
            }, this);

            this._translateContentCommand.set("model", model);
            this._settings.selection.set("data", [{ type: "epi.cms.contentdata", data: model}]);
        }

    });

});
},
'epi-cms/component/RecentlyChanged':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",

    "epi",        
    "epi/dependency",

    "epi/shell/command/_WidgetCommandProviderMixin",
    "epi/shell/command/_Command",
    "epi/shell/command/ToggleCommand",
    "epi/shell/widget/layout/ComponentContainer",
    "epi/shell/widget/dialog/Alert",
    "epi/shell/widget/_FocusableMixin",

    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/core/ContentReference",
    "epi-cms/widget/_GridWidgetBase",
        
    "epi/i18n!epi/cms/nls/episerver.cms.components.recentlychanged"
],
function (
    declare,
    lang,
    
    epi,
    dependency,
    
    _WidgetCommandProviderMixin,
    _Command,
    ToggleCommand,
    ComponentContainer,
    Alert,
    _FocusableMixin,

    ContentActionSupport,
    ContentReference,
    _GridWidgetBase,

    resources
) {
    return declare([_GridWidgetBase, _WidgetCommandProviderMixin, _FocusableMixin], {
        // summary:
        //      This component will list the latest changed content for the web site.

        // _componentsController: [private] epi.shell.widget.Application
        _componentsController: null,

        onlyShowMyChanges: false,

        postMixInProperties: function () {
            // summary:
            //    Overridden to wrap the gridcontainer and add our toolbar after
            //
            // tags:
            //    protected
            this.storeKeyName = "epi.cms.content.search";
            this._componentsController = dependency.resolve("epi.shell.controller.Components");
            this.ignoreVersionWhenComparingLinks = false;
            this.inherited(arguments);
        },

        buildRendering: function () {
            // summary:
            //		Construct the UI for this widget with this.domNode initialized as a dgrid.
            // tags:
            //		protected

            this.inherited(arguments);

            var gridSettings = lang.mixin({
                columns: this._createGridColumns(),
                store: this.store,
                selectionMode: "single"
            }, this.defaultGridMixin);

            this.grid = new this._gridClass(gridSettings, this.domNode);
        },

        startup: function () {
            // summary:
            //      Overridden to connect a store to a DataGrid.

            if (this._started) {
                return;
            }

            this.inherited(arguments);

            var commands = [ 
                new ToggleCommand({
                    label: resources.showmychanges,
                    category: "setting",
                    model: this,
                    property: "onlyShowMyChanges"
            }),
               new _Command({
                   iconClass: "epi-iconReload",
                   label: epi.resources.action.refresh,
                    canExecute: true,
                    _execute: lang.hitch(this, function () {
                        this.grid.refresh();
                    })
            })];

            this.add("commands", commands);

            this.fetchData();
        },

        _setOnlyShowMyChangesAttr: function (value) {
            this._set("onlyShowMyChanges", value);
            if (this._started) {
                this._saveSettingComponent("onlyShowMyChanges", value);
            }
        },

        fetchData: function () {
            // summary:
            //		Updates the grid with the new data.
            // tags:
            //		private

            var query = this._getQuery();

            this.grid.set("query", query.query, query.options);
        },

        _getQuery: function () {
            return {
                query: { query: 'recentlychanged', onlyShowMyChanges: this.onlyShowMyChanges, keepversion: true },
                options: { ignore: ["query"], sort: [{ attribute: "saved", descending: true}] }
            };
        },

        _createGridColumns: function () {
            var columns = {
                name: {
                    label: epi.resources.header.name,
                    className: "epi-width50",
                    renderCell: lang.hitch(this, this._renderContentItem)
                },
                status: {
                    label: epi.resources.header.status,
                    renderCell: function (item, value, node, options) {
                        node.innerHTML = ContentActionSupport.getVersionStatus(value);
                    },
                    className: "epi-width15"
                },
                saved: {
                    label: epi.resources.header.saved,
                    formatter: this._localizeDate,
                    className: "epi-width25"
                }
            };

            if (!this.get("onlyShowMyChanges")) {
                columns.changedBy = {
                    label: epi.resources.header.by,
                    formatter: this._createUserFriendlyUsername,
                    className: "epi-width10"
                };
            }

            return columns;
        },

        _saveSettingComponent: function (type, value) {
            // summary:
            //		Save setting handle by component controller.
            // type: String
            //      The type of a setting.
            // value: value
            //      The value of a setting.
            // tags:
            //		private

            var item = this._componentsController.getComponentDefinition(this.id),
                query;

            if (item) {
                item.settings.onlyShowMyChanges = value;
                
                // save the settings 
                var saved = this._componentsController.saveComponent(item);
                saved.then(function(done) {

                }, function() {
                    // Show alert dialog on errorCallback
                    var dialog = new Alert({
                        description: resources.errormessage
                    });
                    dialog.show();
                });

                // Updated this way on purpose. Both set query and columns will trigger
                // a refresh of data leading to bad rendering behaviour of the grid.
                query = this._getQuery();
                this.grid.query = query.query;
                this.grid.queryOptions = query.options;
                this.grid.set("columns", this._createGridColumns());
            }
        },

        onContextChanged: function (context) {
            // summary:
            //      Selects the current context item if it exists in the grid.

            this.grid.clearSelection();

            var versionAgnosticLink = new ContentReference(context.id).createVersionUnspecificReference().toString();

            var row = this.grid.row(versionAgnosticLink);
            if (row) {
                this.grid.select(row);
            }
        }
    });
});
},
'epi-cms/component/SharedBlocks':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/on",
    "dojo/when",
// epi
    "epi-cms/widget/HierarchicalList",
    "epi-cms/component/SharedBlocksViewModel",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.createblock",
    "epi/i18n!epi/cms/nls/contenttypes.blockdata"
],

function (
// dojo
    array,
    declare,
    lang,

    on,
    when,
// epi
    HierarchicalList,
    SharedBlocksViewModel,
// resources
    componentResources,
    res
) {

    // module:
    //      epi-cms/component/SharedBlocks
    // summary:
    //      Shared blocks component
    // tags:
    //      public

    return declare([HierarchicalList], {

        // showCreateContentArea: [public] Boolean
        //      Flag to indicate this widget allowed to show create content area by default or not.
        showCreateContentArea: true,

        modelClassName: SharedBlocksViewModel,

        noDataMessage: componentResources.nocontent,

        // hierarchicalListClass: [readonly] String
        //      The CSS class to be used on the content list.
        hierarchicalListClass: "epi-blockList",

        // createContentIcon: [public] String
        //      The icon class to be used in the create content area of the list.
        createContentIcon: "epi-iconPlus",

        // createContentText: [public] String
        createContentText: res.create,

        postCreate: function () {

            this.inherited(arguments);

            // show/hide createContentArea only when grid refreshes
            this.own(
               this.list.grid.on("dgrid-refresh-complete", lang.hitch(this, function (/*Event*/evt) {
                   when(evt.results, lang.hitch(this, function (results) {
                       // hide the contentarea on grid refresh only if grid has any item at all. Otherwise use the canExecute 
                       var showCreateContentArea = results.length > 0 ? false : this.model.getCommand("newBlockDefault").get("canExecute");
                       this._toggleCreateContentArea(showCreateContentArea);
                   }));
               }))
            );
        },

        // =======================================================================
        // List setup

        _setupList: function () {

            this.inherited(arguments);

            var registry = this.model._commandRegistry,
                listWidget = this.list;

            this.own(
                on(listWidget, "copyOrCut", function copyOrCuthandler(copy) {
                    copy ? registry.copy.command.execute() : registry.cut.command.execute();
                }),
                on(listWidget, "delete", function () {
                    registry["delete"].command.execute();
                }),
                on(listWidget, "createItemAction", function () {
                    registry.newBlockDefault.command.execute();
                }),
                on(listWidget, "itemAction", function () {
                    registry.edit.command.execute();
                })
            );
        }

    });

});
},
'epi-cms/component/SharedBlocksViewModel':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
// epi
    "epi-cms/widget/ContextualContentForestStoreModel",
    "epi-cms/widget/viewmodel/HierarchicalListViewModel",

// command
    "epi-cms/command/NewContent",
    "epi-cms/command/ShowAllLanguages",

// resource
    "epi/i18n!epi/cms/nls/episerver.cms.components.createblock"
],

function (
// dojo
    declare,
    lang,
    when,
// epi
    ContextualContentForestStoreModel,
    HierarchicalListViewModel,

// command
    NewContentCommand,
    ShowAllLanguagesCommand,

// resource
    resCreateBlock
) {

    // module:
    //      epi-cms/component/SharedBlocksViewModel
    // summary:
    //      Handles search and tree to list browsing widgets.
    // tags:
    //      public

    return declare([HierarchicalListViewModel], {

        // treeStoreModelClass: [const] Function
        //      Class to use as model for the tree.
        treeStoreModelClass: ContextualContentForestStoreModel,

        _updateTreeContextCommandModels: function (model) {
            // summary:
            //      Update model of commands in case selected content is folder
            // tags:
            //      private

            this.inherited(arguments);

            var translateDelegate = lang.hitch(this.treeStoreModel, this.treeStoreModel.translate);
            this._commandRegistry.translate.command.set("model", model);
            this._commandRegistry.translate.command.set("executeDelegate", translateDelegate);

            this._commandRegistry.newBlockDefault.command.set("model", model);
        },

        _setupCommands: function () {
            // summary:
            //      Creates and registers the commands used.
            // tags:
            //      protected

            this.inherited(arguments);

            var customCommands = {
                newBlockDefault: {
                    command: new NewContentCommand({
                        contentType: "episerver.core.blockdata", // TODO: Take type indentifier from ShareBlock widget
                        iconClass: "epi-iconPlus",
                        label: resCreateBlock.command.label,
                        resources: resCreateBlock
                    })
                },
                allLanguages: {
                    command: new ShowAllLanguagesCommand({ model: this }),
                    order: 55
                }
            };

            this._commandRegistry = lang.mixin(this._commandRegistry, customCommands);

            this.pseudoContextualCommands.push(this._commandRegistry.newBlockDefault.command);
        }
    });
});
},
'epi-cms/component/SiteTree':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/when",
    "dojo/dom-style",
    "dijit/layout/_LayoutWidget",
    "dijit/Tooltip",
    "epi-cms/component/SiteTreeModel",
    "epi-cms/component/SiteTreeNode",
    "epi/dependency",
    "epi/shell/command/_WidgetCommandProviderMixin",
    "epi/shell/command/ToggleCommand",
    "epi/shell/widget/Tree",
    "epi/i18n!epi/cms/nls/episerver.cms.components.sitetree"
], function (
    declare,
    Deferred,
    lang,
    array,
    when,
    domStyle,
    _LayoutWidget,
    Tooltip,
    SiteTreeModel,
    SiteTreeNode,
    dependency,
    _WidgetCommandProviderMixin,
    ToggleCommand,
    Tree,
    resources
) {

    return declare([_LayoutWidget, _WidgetCommandProviderMixin], {

        profile: null,

        buildRendering: function () {
            this.inherited(arguments);

            // Set overflow to auto in order for the tree to be scrollable if this container is to small.
            domStyle.set(this.domNode, "overflow", "auto");
        },

        postCreate: function () {
            this.inherited(arguments);

            //Get the store and attach it to the model
            var registry = dependency.resolve("epi.storeregistry");
            var store = registry.get("epi.cms.sitestructure");

            this.profile = this.profile || dependency.resolve("epi.shell.Profile");

            var model = this._treeModel = new SiteTreeModel({store: store});

            //Create show all languages command
            var command = new ToggleCommand({
                category: "setting",
                label: resources.showalllanguages,
                model: model,
                property: "showAllLanguages"
            });

            this.commands.push(command);

            //Create the site and language tree
            this._tree = new Tree({
                model: model,
                showRoot: false,
                "class": "epi-simpleTree",
                persist: false,
                onClick: lang.hitch(this, function (item) {
                    if (!item.host || !item.languageId) {
                        // In case root node (another site in the sites tree) selected (mean that we do not have any information about host and language)
                        window.location.replace(item.editUrl);
                    } else {

                        var self = this;

                        // click on the language branch under a site (root node)
                        when(self.profile.setContentLanguage(item.languageId, item.host), function () {
                            // TECHNOTE: we try to keep the current viewing hostname if the editUrl and current url are sibling in the same (load balancing) site
                            // Example: {
                            //      siteUrl : http://site1,
                            //      hosts: ['site1', 'site1b']
                            //}
                            // if we are viewing site1b, and click on a languageBranch under siteUrl:http://site1, we still navigate to site1b (instead of go to http://site1)

                            var urlToNavigate = item.editUrl;
                            if (array.some(item.hosts, function (host) { return host === window.location.host; })) {
                                urlToNavigate = item.editUrl.replace(new RegExp(item.host, 'i'), window.location.host);    // use regex to replace only first occurence
                            }
                            
                            window.location.replace(urlToNavigate);
                        });
                    }
                }),
                _createTreeNode: function (args) {
                    return new SiteTreeNode(args);
                },
                _onNodeMouseEnter: function (node) {
                    if (node.item.isLanguageNode && !node.item.isAvailable) {
                        Tooltip.show(resources.notavailabletooltip, node.labelNode, ["after-centered", "below"]);
                    }
                },
                _onNodeMouseLeave: function (node) {
                    Tooltip.hide(node.labelNode);
                }
            });

            //Add the tree to the container
            this.addChild(this._tree);
        },

        layout: function(){
            this._tree.resize();
        },

        startup: function () {
            this.inherited(arguments);

            this._setTreePath();
        },

        _setTreePath: function () {
            Deferred.when(this._treeModel.getCurrentSite(), lang.hitch(this, function (config) {
                this._tree.set('path', ['root', config.currentSite, config.currentEditLanguageId]);
            }));
        }

    });
});

},
'epi-cms/component/SiteTreeNode':function(){
﻿define([
// dojo
    "dojo/dom-class",
// epi
    "epi-cms/widget/_ContentTreeNode"
],

// Review: Do we need proper documentation and unit tests?.
function (
// dojo
    domClass,
// epi
    _ContentTreeNode
) {

    return dojo.declare([_ContentTreeNode], {

        _updateItemClasses: function (item) {
            this.inherited(arguments);

            if (item.isLanguageNode && !item.isAvailable) {
                domClass.add(this.domNode, "epi-st-disabledRow");
            } else {
                domClass.remove(this.domNode, "epi-st-disabledRow");
            }

            if (!item.isLanguageNode) {
                domClass.add(this.iconNode, "epi-iconObjectStart");
            }
        }
    });

});
},
'epi-cms/component/Tasks':function(){
﻿define([
// Dojo
    "dojo",
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/topic",

// Dijit
    "dijit/form/Select",
    "dijit/_TemplatedMixin",
    "dijit/_Container",
    "dijit/layout/_LayoutWidget",
    "dijit/_WidgetsInTemplateMixin",

// EPi Framework
    "epi",

// EPi CMS
    "epi-cms/component/ContentQueryGrid", // Used in template
    "dojo/text!./templates/Tasks.html",
    "epi/i18n!epi/cms/nls/episerver.cms.components.tasks"
], function (
// Dojo
    dojo,
    declare,
    array,
    lang,
    domConstruct,
    domGeometry,
    topic,

// Dijit
    Select,
    _TemplatedMixin,
    _Container,
    _LayoutWidget,
    _WidgetsInTemplateMixin,

// EPi Framework
    epi,

// EPi CMS
    ContentQueryGrid,
    template,
    resources
) {

    return declare([_Container, _LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // summary: This component will list the latest changed pages for the web site.

        templateString: template,

        resources: resources,

        querySelection: null,

        _selectionChangedEventHandler: null,

        postCreate: function () {

            this.inherited(arguments);

            var options = array.map(this.queries, function (item) {
                return {
                    label: item.displayName,
                    value: item.name
                };
            }, this);

            this.querySelection = new Select({
                name: "QuerySelection",
                options: options
            });

            domConstruct.place(this.querySelection.domNode, this.reloadButton.domNode, 'before');

            //Set the initial query.
            this._reloadQuery();

            this.own(
                this.querySelection.on("change", lang.hitch(this, this._reloadQuery)),
                topic.subscribe("/epi/cms/action/refreshmytasks", lang.hitch(this, this._reloadQuery))
            );
        },

        resize: function (newSize) {
            // summary:
            //      Customize default resize method
            // newSize: object
            //      The new size of Task component
            // tags:
            //      Public

            this.inherited(arguments);

            this.contentQuery.resize(this._caculateContentQuerySize(newSize));
        },

        _caculateContentQuerySize: function (newSize) {
            // summary:
            //      Calculate the new Size of the Content Query
            // newSize: object
            //      The new size of Task component
            // tags:
            //      Private

            var toolbarSize = domGeometry.getMarginBox(this.toolbar);

            return { w: newSize.w, h: newSize.h - toolbarSize.h };
        },

        _reloadQuery: function () {
            var query = this.querySelection.get("value");
            array.some(this.queries, function (item, index) {
                if (item.name == query) {
                    this.contentQuery.set("ignoreVersionWhenComparingLinks", !item.versionSpecific);
                    return true;
                }
            }, this);
            this.contentQuery.set("queryName", query);
        }
    });
});

},
'dijit/form/Select':function(){
require({cache:{
'url:dijit/form/templates/Select.html':"<table class=\"dijit dijitReset dijitInline dijitLeft\"\n\tdata-dojo-attach-point=\"_buttonNode,tableNode,focusNode\" cellspacing='0' cellpadding='0'\n\trole=\"listbox\" aria-haspopup=\"true\"\n\t><tbody role=\"presentation\"><tr role=\"presentation\"\n\t\t><td class=\"dijitReset dijitStretch dijitButtonContents\" role=\"presentation\"\n\t\t\t><div class=\"dijitReset dijitInputField dijitButtonText\"  data-dojo-attach-point=\"containerNode,_popupStateNode\" role=\"presentation\"></div\n\t\t\t><div class=\"dijitReset dijitValidationContainer\"\n\t\t\t\t><input class=\"dijitReset dijitInputField dijitValidationIcon dijitValidationInner\" value=\"&#935; \" type=\"text\" tabIndex=\"-1\" readonly=\"readonly\" role=\"presentation\"\n\t\t\t/></div\n\t\t\t><input type=\"hidden\" ${!nameAttrSetting} data-dojo-attach-point=\"valueNode\" value=\"${value}\" aria-hidden=\"true\"\n\t\t/></td\n\t\t><td class=\"dijitReset dijitRight dijitButtonNode dijitArrowButton dijitDownArrowButton dijitArrowButtonContainer\"\n\t\t\tdata-dojo-attach-point=\"titleNode\" role=\"presentation\"\n\t\t\t><input class=\"dijitReset dijitInputField dijitArrowButtonInner\" value=\"&#9660; \" type=\"text\" tabIndex=\"-1\" readonly=\"readonly\" role=\"presentation\"\n\t\t\t\t${_buttonInputDisabled}\n\t\t/></td\n\t></tr></tbody\n></table>\n"}});
define("dijit/form/Select", [
	"dojo/_base/array", // array.forEach
	"dojo/_base/declare", // declare
	"dojo/dom-attr", // domAttr.set
	"dojo/dom-class", // domClass.add domClass.remove domClass.toggle
	"dojo/dom-geometry", // domGeometry.setMarginBox
	"dojo/_base/event", // event.stop
	"dojo/i18n", // i18n.getLocalization
	"dojo/_base/lang", // lang.hitch
	"dojo/sniff", // has("ie")
	"./_FormSelectWidget",
	"../_HasDropDown",
	"../Menu",
	"../MenuItem",
	"../MenuSeparator",
	"../Tooltip",
	"dojo/text!./templates/Select.html",
	"dojo/i18n!./nls/validate"
], function(array, declare, domAttr, domClass, domGeometry, event, i18n, lang, has,
			_FormSelectWidget, _HasDropDown, Menu, MenuItem, MenuSeparator, Tooltip, template){

// module:
//		dijit/form/Select


var _SelectMenu = declare("dijit.form._SelectMenu", Menu, {
	// summary:
	//		An internally-used menu for dropdown that allows us a vertical scrollbar

	// Override Menu.autoFocus setting so that opening a Select highlights the current value.
	autoFocus: true,

	buildRendering: function(){
		// summary:
		//		Stub in our own changes, so that our domNode is not a table
		//		otherwise, we won't respond correctly to heights/overflows
		this.inherited(arguments);
		var o = (this.menuTableNode = this.domNode);
		var n = (this.domNode = this.ownerDocument.createElement("div"));
		n.style.cssText = "overflow-x: hidden; overflow-y: scroll";
		if(o.parentNode){
			o.parentNode.replaceChild(n, o);
		}
		domClass.remove(o, "dijitMenuTable");
		n.className = o.className + " dijitSelectMenu";
		o.className = "dijitReset dijitMenuTable";
		o.setAttribute("role", "listbox");
		n.setAttribute("role", "presentation");
		n.appendChild(o);
	},

	postCreate: function(){
		// summary:
		//		stop mousemove from selecting text on IE to be consistent with other browsers

		this.inherited(arguments);

		this.connect(this.domNode, "onselectstart", event.stop);
	},


	focus: function(){
		// summary:
		//		Overridden so that the previously selected value will be focused instead of only the first item
		var	found = false,
			val = this.parentWidget.value;
		if(lang.isArray(val)){
			val = val[val.length-1];
		}
		if(val){ // if focus selected
			array.forEach(this.parentWidget._getChildren(), function(child){
				if(child.option && (val === child.option.value)){ // find menu item widget with this value
					found = true;
					this.focusChild(child, false); // focus previous selection
				}
			}, this);
		}
		if(!found){
			this.inherited(arguments); // focus first item by default
		}
	},

	resize: function(/*Object*/ mb){
		// summary:
		//		Overridden so that we are able to handle resizing our
		//		internal widget.  Note that this is not a "full" resize
		//		implementation - it only works correctly if you pass it a
		//		marginBox.
		//
		// mb: Object
		//		The margin box to set this dropdown to.
		if(mb){
			domGeometry.setMarginBox(this.domNode, mb);
			if("w" in mb){
				// We've explicitly set the wrapper <div>'s width, so set <table> width to match.
				// 100% is safer than a pixel value because there may be a scroll bar with
				// browser/OS specific width.
				this.menuTableNode.style.width = "100%";
			}
		}
	}
});

var Select = declare("dijit.form.Select", [_FormSelectWidget, _HasDropDown], {
	// summary:
	//		This is a "styleable" select box - it is basically a DropDownButton which
	//		can take a `<select>` as its input.

	baseClass: "dijitSelect dijitValidationTextBox",

	templateString: template,

	_buttonInputDisabled: has("ie") ? "disabled" : "", // allows IE to disallow focus, but Firefox cannot be disabled for mousedown events

	// required: Boolean
	//		Can be true or false, default is false.
	required: false,

	// state: [readonly] String
	//		"Incomplete" if this select is required but unset (i.e. blank value), "" otherwise
	state: "",

	// message: String
	//		Currently displayed error/prompt message
	message: "",

	// tooltipPosition: String[]
	//		See description of `dijit/Tooltip.defaultPosition` for details on this parameter.
	tooltipPosition: [],

	// emptyLabel: string
	//		What to display in an "empty" dropdown
	emptyLabel: "&#160;",	// &nbsp;

	// _isLoaded: Boolean
	//		Whether or not we have been loaded
	_isLoaded: false,

	// _childrenLoaded: Boolean
	//		Whether or not our children have been loaded
	_childrenLoaded: false,

	_fillContent: function(){
		// summary:
		//		Set the value to be the first, or the selected index
		this.inherited(arguments);
		// set value from selected option
		if(this.options.length && !this.value && this.srcNodeRef){
			var si = this.srcNodeRef.selectedIndex || 0; // || 0 needed for when srcNodeRef is not a SELECT
			this.value = this.options[si >= 0 ? si : 0].value;
		}
		// Create the dropDown widget
		this.dropDown = new _SelectMenu({ id: this.id + "_menu", parentWidget: this });
		domClass.add(this.dropDown.domNode, this.baseClass.replace(/\s+|$/g, "Menu "));
	},

	_getMenuItemForOption: function(/*_FormSelectWidget.__SelectOption*/ option){
		// summary:
		//		For the given option, return the menu item that should be
		//		used to display it.  This can be overridden as needed
		if(!option.value && !option.label){
			// We are a separator (no label set for it)
			return new MenuSeparator({ownerDocument: this.ownerDocument});
		}else{
			// Just a regular menu option
			var click = lang.hitch(this, "_setValueAttr", option);
			var item = new MenuItem({
				option: option,
				label: option.label || this.emptyLabel,
				onClick: click,
				ownerDocument: this.ownerDocument,
				dir: this.dir,
				disabled: option.disabled || false
			});
			item.focusNode.setAttribute("role", "option");
			return item;
		}
	},

	_addOptionItem: function(/*_FormSelectWidget.__SelectOption*/ option){
		// summary:
		//		For the given option, add an option to our dropdown.
		//		If the option doesn't have a value, then a separator is added
		//		in that place.
		if(this.dropDown){
			this.dropDown.addChild(this._getMenuItemForOption(option));
		}
	},

	_getChildren: function(){
		if(!this.dropDown){
			return [];
		}
		return this.dropDown.getChildren();
	},

	_loadChildren: function(/*Boolean*/ loadMenuItems){
		// summary:
		//		Resets the menu and the length attribute of the button - and
		//		ensures that the label is appropriately set.
		// loadMenuItems: Boolean
		//		actually loads the child menu items - we only do this when we are
		//		populating for showing the dropdown.

		if(loadMenuItems === true){
			// this.inherited destroys this.dropDown's child widgets (MenuItems).
			// Avoid this.dropDown (Menu widget) having a pointer to a destroyed widget (which will cause
			// issues later in _setSelected). (see #10296)
			if(this.dropDown){
				delete this.dropDown.focusedChild;
			}
			if(this.options.length){
				this.inherited(arguments);
			}else{
				// Drop down menu is blank but add one blank entry just so something appears on the screen
				// to let users know that they are no choices (mimicing native select behavior)
				array.forEach(this._getChildren(), function(child){ child.destroyRecursive(); });
				var item = new MenuItem({
					ownerDocument: this.ownerDocument,
					label: this.emptyLabel
				});
				this.dropDown.addChild(item);
			}
		}else{
			this._updateSelection();
		}

		this._isLoaded = false;
		this._childrenLoaded = true;

		if(!this._loadingStore){
			// Don't call this if we are loading - since we will handle it later
			this._setValueAttr(this.value, false);
		}
	},

	_refreshState: function(){
		if(this._started){
			this.validate(this.focused);
		}
	},

	startup: function(){
		this.inherited(arguments);
		this._refreshState(); // after all _set* methods have run
	},

	_setValueAttr: function(value){
		this.inherited(arguments);
		domAttr.set(this.valueNode, "value", this.get("value"));
		this._refreshState();	// to update this.state
	},

	_setDisabledAttr: function(/*Boolean*/ value){
		this.inherited(arguments);
		this._refreshState();	// to update this.state
	},

	_setRequiredAttr: function(/*Boolean*/ value){
		this._set("required", value);
		this.focusNode.setAttribute("aria-required", value);
		this._refreshState();	// to update this.state
	},

	_setOptionsAttr: function(/*Array*/ options){
		this._isLoaded = false;
		this._set('options', options);
	},

	_setDisplay: function(/*String*/ newDisplay){
		// summary:
		//		sets the display for the given value (or values)
		var lbl = newDisplay || this.emptyLabel;
		this.containerNode.innerHTML = '<span role="option" class="dijitReset dijitInline ' + this.baseClass.replace(/\s+|$/g, "Label ")+'">' + lbl + '</span>';
	},

	validate: function(/*Boolean*/ isFocused){
		// summary:
		//		Called by oninit, onblur, and onkeypress, and whenever required/disabled state changes
		// description:
		//		Show missing or invalid messages if appropriate, and highlight textbox field.
		//		Used when a select is initially set to no value and the user is required to
		//		set the value.

		var isValid = this.disabled || this.isValid(isFocused);
		this._set("state", isValid ? "" : (this._hasBeenBlurred ? "Error" : "Incomplete"));
		this.focusNode.setAttribute("aria-invalid", isValid ? "false" : "true");
		var message = isValid ? "" : this._missingMsg;
		if(message && this.focused && this._hasBeenBlurred){
			Tooltip.show(message, this.domNode, this.tooltipPosition, !this.isLeftToRight());
		}else{
			Tooltip.hide(this.domNode);
		}
		this._set("message", message);
		return isValid;
	},

	isValid: function(/*Boolean*/ /*===== isFocused =====*/){
		// summary:
		//		Whether or not this is a valid value.  The only way a Select
		//		can be invalid is when it's required but nothing is selected.
		return (!this.required || this.value === 0 || !(/^\s*$/.test(this.value || ""))); // handle value is null or undefined
	},

	reset: function(){
		// summary:
		//		Overridden so that the state will be cleared.
		this.inherited(arguments);
		Tooltip.hide(this.domNode);
		this._refreshState();	// to update this.state
	},

	postMixInProperties: function(){
		// summary:
		//		set the missing message
		this.inherited(arguments);
		this._missingMsg = i18n.getLocalization("dijit.form", "validate", this.lang).missingMessage;
	},

	postCreate: function(){
		// summary:
		//		stop mousemove from selecting text on IE to be consistent with other browsers

		this.inherited(arguments);
 
		this.connect(this.domNode, "onselectstart", event.stop);
		this.domNode.setAttribute("aria-expanded", "false");
		
		if(has("ie") < 9){
			// IE INPUT tag fontFamily has to be set directly using STYLE
			// the defer gives IE a chance to render the TextBox and to deal with font inheritance
			this.defer(function(){
				try{
					var s = domStyle.getComputedStyle(this.domNode); // can throw an exception if widget is immediately destroyed
					if(s){
						var ff = s.fontFamily;
						if(ff){
							var inputs = this.domNode.getElementsByTagName("INPUT");
							if(inputs){
								for(var i=0; i < inputs.length; i++){
									inputs[i].style.fontFamily = ff;
								}
							}
						}
					}
				}catch(e){/*when used in a Dialog, and this is called before the dialog is
				 shown, s.fontFamily would trigger "Invalid Argument" error.*/}
			});
		}
	},

	_setStyleAttr: function(/*String||Object*/ value){
		this.inherited(arguments);
		domClass.toggle(this.domNode, this.baseClass.replace(/\s+|$/g, "FixedWidth "), !!this.domNode.style.width);
	},

	isLoaded: function(){
		return this._isLoaded;
	},

	loadDropDown: function(/*Function*/ loadCallback){
		// summary:
		//		populates the menu
		this._loadChildren(true);
		this._isLoaded = true;
		loadCallback();
	},

	closeDropDown: function(){
		// overriding _HasDropDown.closeDropDown()
		this.inherited(arguments);

		if(this.dropDown && this.dropDown.menuTableNode){
			// Erase possible width: 100% setting from _SelectMenu.resize().
			// Leaving it would interfere with the next openDropDown() call, which
			// queries the natural size of the drop down.
			this.dropDown.menuTableNode.style.width = "";
		}
	},

	destroy: function(preserveDom){
		if(this.dropDown && !this.dropDown._destroyed){
			this.dropDown.destroyRecursive(preserveDom);
			delete this.dropDown;
		}
		this.inherited(arguments);
	},

	_onFocus: function(){
		this.validate(true);	// show tooltip if second focus of required tooltip, but no selection
		this.inherited(arguments);
	},

	_onBlur: function(){
		Tooltip.hide(this.domNode);
		this.inherited(arguments);
		this.validate(false);
	}
});

Select._Menu = _SelectMenu;	// for monkey patching

return Select;
});

},
'dijit/form/_FormSelectWidget':function(){
define("dijit/form/_FormSelectWidget", [
	"dojo/_base/array", // array.filter array.forEach array.map array.some
	"dojo/_base/Deferred",
	"dojo/aspect", // aspect.after
	"dojo/data/util/sorter", // util.sorter.createSortFunction
	"dojo/_base/declare", // declare
	"dojo/dom", // dom.setSelectable
	"dojo/dom-class", // domClass.toggle
	"dojo/_base/kernel",	// _scopeName
	"dojo/_base/lang", // lang.delegate lang.isArray lang.isObject lang.hitch
	"dojo/query", // query
	"dojo/when",
	"dojo/store/util/QueryResults",
	"./_FormValueWidget"
], function(array, Deferred, aspect, sorter, declare, dom, domClass, kernel, lang, query, when,
			QueryResults, _FormValueWidget){

// module:
//		dijit/form/_FormSelectWidget

/*=====
var __SelectOption = {
	// value: String
	//		The value of the option.  Setting to empty (or missing) will
	//		place a separator at that location
	// label: String
	//		The label for our option.  It can contain html tags.
	// selected: Boolean
	//		Whether or not we are a selected option
	// disabled: Boolean
	//		Whether or not this specific option is disabled
};
=====*/

var _FormSelectWidget = declare("dijit.form._FormSelectWidget", _FormValueWidget, {
	// summary:
	//		Extends _FormValueWidget in order to provide "select-specific"
	//		values - i.e., those values that are unique to `<select>` elements.
	//		This also provides the mechanism for reading the elements from
	//		a store, if desired.

	// multiple: [const] Boolean
	//		Whether or not we are multi-valued
	multiple: false,

	// options: __SelectOption[]
	//		The set of options for our select item.  Roughly corresponds to
	//		the html `<option>` tag.
	options: null,

	// store: dojo/store/api/Store
	//		A store to use for getting our list of options - rather than reading them
	//		from the `<option>` html tags.   Should support getIdentity().
	//		For back-compat store can also be a dojo/data/api/Identity.
	store: null,

	// query: object
	//		A query to use when fetching items from our store
	query: null,

	// queryOptions: object
	//		Query options to use when fetching from the store
	queryOptions: null,

	// labelAttr: String?
	//		The entries in the drop down list come from this attribute in the dojo.store items.
	//		If ``store`` is set, labelAttr must be set too, unless store is an old-style
	//		dojo.data store rather than a new dojo/store.
	labelAttr: "",

	// onFetch: Function
	//		A callback to do with an onFetch - but before any items are actually
	//		iterated over (i.e. to filter even further what you want to add)
	onFetch: null,

	// sortByLabel: Boolean
	//		Flag to sort the options returned from a store by the label of
	//		the store.
	sortByLabel: true,


	// loadChildrenOnOpen: Boolean
	//		By default loadChildren is called when the items are fetched from the
	//		store.  This property allows delaying loadChildren (and the creation
	//		of the options/menuitems) until the user clicks the button to open the
	//		dropdown.
	loadChildrenOnOpen: false,

	// onLoadDeferred: [readonly] dojo.Deferred
	//		This is the `dojo.Deferred` returned by setStore().
	//		Calling onLoadDeferred.then() registers your
	//		callback to be called only once, when the prior setStore completes.
	onLoadDeferred: null,

	getOptions: function(/*anything*/ valueOrIdx){
		// summary:
		//		Returns a given option (or options).
		// valueOrIdx:
		//		If passed in as a string, that string is used to look up the option
		//		in the array of options - based on the value property.
		//		(See dijit/form/_FormSelectWidget.__SelectOption).
		//
		//		If passed in a number, then the option with the given index (0-based)
		//		within this select will be returned.
		//
		//		If passed in a dijit/form/_FormSelectWidget.__SelectOption, the same option will be
		//		returned if and only if it exists within this select.
		//
		//		If passed an array, then an array will be returned with each element
		//		in the array being looked up.
		//
		//		If not passed a value, then all options will be returned
		//
		// returns:
		//		The option corresponding with the given value or index.  null
		//		is returned if any of the following are true:
		//
		//		- A string value is passed in which doesn't exist
		//		- An index is passed in which is outside the bounds of the array of options
		//		- A dijit/form/_FormSelectWidget.__SelectOption is passed in which is not a part of the select

		// NOTE: the compare for passing in a dijit/form/_FormSelectWidget.__SelectOption checks
		//		if the value property matches - NOT if the exact option exists
		// NOTE: if passing in an array, null elements will be placed in the returned
		//		array when a value is not found.
		var lookupValue = valueOrIdx, opts = this.options || [], l = opts.length;

		if(lookupValue === undefined){
			return opts; // __SelectOption[]
		}
		if(lang.isArray(lookupValue)){
			return array.map(lookupValue, "return this.getOptions(item);", this); // __SelectOption[]
		}
		if(lang.isObject(valueOrIdx)){
			// We were passed an option - so see if it's in our array (directly),
			// and if it's not, try and find it by value.
			if(!array.some(this.options, function(o, idx){
				if(o === lookupValue ||
					(o.value && o.value === lookupValue.value)){
					lookupValue = idx;
					return true;
				}
				return false;
			})){
				lookupValue = -1;
			}
		}
		if(typeof lookupValue == "string"){
			for(var i=0; i<l; i++){
				if(opts[i].value === lookupValue){
					lookupValue = i;
					break;
				}
			}
		}
		if(typeof lookupValue == "number" && lookupValue >= 0 && lookupValue < l){
			return this.options[lookupValue]; // __SelectOption
		}
		return null; // null
	},

	addOption: function(/*__SelectOption|__SelectOption[]*/ option){
		// summary:
		//		Adds an option or options to the end of the select.  If value
		//		of the option is empty or missing, a separator is created instead.
		//		Passing in an array of options will yield slightly better performance
		//		since the children are only loaded once.
		if(!lang.isArray(option)){ option = [option]; }
		array.forEach(option, function(i){
			if(i && lang.isObject(i)){
				this.options.push(i);
			}
		}, this);
		this._loadChildren();
	},

	removeOption: function(/*String|__SelectOption|Number|Array*/ valueOrIdx){
		// summary:
		//		Removes the given option or options.  You can remove by string
		//		(in which case the value is removed), number (in which case the
		//		index in the options array is removed), or select option (in
		//		which case, the select option with a matching value is removed).
		//		You can also pass in an array of those values for a slightly
		//		better performance since the children are only loaded once.
		if(!lang.isArray(valueOrIdx)){ valueOrIdx = [valueOrIdx]; }
		var oldOpts = this.getOptions(valueOrIdx);
		array.forEach(oldOpts, function(i){
			// We can get null back in our array - if our option was not found.  In
			// that case, we don't want to blow up...
			if(i){
				this.options = array.filter(this.options, function(node){
					return (node.value !== i.value || node.label !== i.label);
				});
				this._removeOptionItem(i);
			}
		}, this);
		this._loadChildren();
	},

	updateOption: function(/*__SelectOption|__SelectOption[]*/ newOption){
		// summary:
		//		Updates the values of the given option.  The option to update
		//		is matched based on the value of the entered option.  Passing
		//		in an array of new options will yield better performance since
		//		the children will only be loaded once.
		if(!lang.isArray(newOption)){ newOption = [newOption]; }
		array.forEach(newOption, function(i){
			var oldOpt = this.getOptions(i), k;
			if(oldOpt){
				for(k in i){ oldOpt[k] = i[k]; }
			}
		}, this);
		this._loadChildren();
	},

	setStore: function(store,
						selectedValue,
						fetchArgs){
		// summary:
		//		Sets the store you would like to use with this select widget.
		//		The selected value is the value of the new store to set.  This
		//		function returns the original store, in case you want to reuse
		//		it or something.
		// store: dojo/store/api/Store
		//		The dojo.store you would like to use - it MUST implement getIdentity()
		//		and MAY implement observe().
		//		For backwards-compatibility this can also be a data.data store, in which case
		//		it MUST implement dojo/data/api/Identity,
		//		and MAY implement dojo/data/api/Notification.
		// selectedValue: anything?
		//		The value that this widget should set itself to *after* the store
		//		has been loaded
		// fetchArgs: Object?
		//		Hash of parameters to set filter on store, etc.
		//
		//		- query: new value for Select.query,
		//		- queryOptions: new value for Select.queryOptions,
		//		- onFetch: callback function for each item in data (Deprecated)
		var oStore = this.store;
		fetchArgs = fetchArgs || {};

		if(oStore !== store){
			// Our store has changed, so cancel any listeners on old store (remove for 2.0)
			var h;
			while((h = this._notifyConnections.pop())){ h.remove(); }

			// For backwards-compatibility, accept dojo.data store in addition to dojo.store.store.  Remove in 2.0.
			if(!store.get){
				lang.mixin(store, {
					_oldAPI: true,
					get: function(id){
						// summary:
						//		Retrieves an object by it's identity. This will trigger a fetchItemByIdentity.
						//		Like dojo.store.DataStore.get() except returns native item.
						var deferred = new Deferred();
						this.fetchItemByIdentity({
							identity: id,
							onItem: function(object){
								deferred.resolve(object);
							},
							onError: function(error){
								deferred.reject(error);
							}
						});
						return deferred.promise;
					},
					query: function(query, options){
						// summary:
						//		Queries the store for objects.   Like dojo/store/DataStore.query()
						//		except returned Deferred contains array of native items.
						var deferred = new Deferred(function(){ if(fetchHandle.abort){ fetchHandle.abort(); } } );
						deferred.total = new Deferred();
						var fetchHandle = this.fetch(lang.mixin({
							query: query,
							onBegin: function(count){
								deferred.total.resolve(count);
							},
							onComplete: function(results){
								deferred.resolve(results);
							},
							onError: function(error){
								deferred.reject(error);
							}
						}, options));
						return new QueryResults(deferred);
					}
				});

				if(store.getFeatures()["dojo.data.api.Notification"]){
					this._notifyConnections = [
						aspect.after(store, "onNew", lang.hitch(this, "_onNewItem"), true),
						aspect.after(store, "onDelete", lang.hitch(this, "_onDeleteItem"), true),
						aspect.after(store, "onSet", lang.hitch(this, "_onSetItem"), true)
					];
				}
			}
			this._set("store", store);			// Our store has changed, so update our notifications
		}

		// Remove existing options (if there are any)
		if(this.options && this.options.length){
			this.removeOption(this.options);
		}

		// Cancel listener for updates to old store
		if(this._queryRes && this._queryRes.close){
			this._queryRes.close();
		}

		// If user has specified new query and query options along with this new store, then use them.
		if(fetchArgs.query){
			this._set("query", fetchArgs.query);
			this._set("queryOptions", fetchArgs.queryOptions);
		}

		// Add our new options
		if(store){
			this._loadingStore = true;
			this.onLoadDeferred = new Deferred();

			// Run query
			// Save result in this._queryRes so we can cancel the listeners we register below
			this._queryRes = store.query(this.query, this.queryOptions);
			when(this._queryRes, lang.hitch(this, function(items){

				if(this.sortByLabel && !fetchArgs.sort && items.length){
					if(items[0].getValue){
						// Old dojo.data API to access items, remove for 2.0
						items.sort(sorter.createSortFunction([{
							attribute: store.getLabelAttributes(items[0])[0]
						}], store));
					}else{
						var labelAttr = this.labelAttr;
						items.sort(function(a, b){
							return a[labelAttr] > b[labelAttr] ? 1 :  b[labelAttr] > a[labelAttr] ? -1 : 0;
						});
					}
				}

				if(fetchArgs.onFetch){
						items = fetchArgs.onFetch.call(this, items, fetchArgs);
				}

				// TODO: Add these guys as a batch, instead of separately
				array.forEach(items, function(i){
					this._addOptionForItem(i);
				}, this);

				// Register listener for store updates
				if(this._queryRes.observe){
					this._queryRes.observe(lang.hitch(this, function(object, deletedFrom, insertedInto){
						if(deletedFrom == insertedInto){
							this._onSetItem(object);
						}else{
							if(deletedFrom != -1){
								this._onDeleteItem(object);
							}
							if(insertedInto != -1){
								this._onNewItem(object);
							}
						}
					}), true);
				}

				// Set our value (which might be undefined), and then tweak
				// it to send a change event with the real value
				this._loadingStore = false;
				this.set("value", "_pendingValue" in this ? this._pendingValue : selectedValue);
				delete this._pendingValue;

				if(!this.loadChildrenOnOpen){
					this._loadChildren();
				}else{
					this._pseudoLoadChildren(items);
				}
				this.onLoadDeferred.resolve(true);
				this.onSetStore();
			}), function(err){
					console.error('dijit.form.Select: ' + err.toString());
					this.onLoadDeferred.reject(err);
			});
		}
		return oStore;	// dojo/data/api/Identity
	},

	// TODO: implement set() and watch() for store and query, although not sure how to handle
	// setting them individually rather than together (as in setStore() above)

	_setValueAttr: function(/*anything*/ newValue, /*Boolean?*/ priorityChange){
		// summary:
		//		set the value of the widget.
		//		If a string is passed, then we set our value from looking it up.
		if(!this._onChangeActive){ priorityChange = null; }
		if(this._loadingStore){
			// Our store is loading - so save our value, and we'll set it when
			// we're done
			this._pendingValue = newValue;
			return;
		}
		var opts = this.getOptions() || [];
		if(!lang.isArray(newValue)){
			newValue = [newValue];
		}
		array.forEach(newValue, function(i, idx){
			if(!lang.isObject(i)){
				i = i + "";
			}
			if(typeof i === "string"){
				newValue[idx] = array.filter(opts, function(node){
					return node.value === i;
				})[0] || {value: "", label: ""};
			}
		}, this);

		// Make sure some sane default is set
		newValue = array.filter(newValue, function(i){ return i && i.value; });
		if(!this.multiple && (!newValue[0] || !newValue[0].value) && opts.length){
			newValue[0] = opts[0];
		}
		array.forEach(opts, function(i){
			i.selected = array.some(newValue, function(v){ return v.value === i.value; });
		});
		var	val = array.map(newValue, function(i){ return i.value; }),
			disp = array.map(newValue, function(i){ return i.label; });

		if(typeof val == "undefined" || typeof val[0] == "undefined"){ return; } // not fully initialized yet or a failed value lookup
		this._setDisplay(this.multiple ? disp : disp[0]);
		this.inherited(arguments, [ this.multiple ? val : val[0], priorityChange ]);
		this._updateSelection();
	},

	_getDisplayedValueAttr: function(){
		// summary:
		//		returns the displayed value of the widget
		var val = this.get("value");
		if(!lang.isArray(val)){
			val = [val];
		}
		var ret = array.map(this.getOptions(val), function(v){
			if(v && "label" in v){
				return v.label;
			}else if(v){
				return v.value;
			}
			return null;
		}, this);
		return this.multiple ? ret : ret[0];
	},

	_loadChildren: function(){
		// summary:
		//		Loads the children represented by this widget's options.
		//		reset the menu to make it populatable on the next click
		if(this._loadingStore){ return; }
		array.forEach(this._getChildren(), function(child){
			child.destroyRecursive();
		});
		// Add each menu item
		array.forEach(this.options, this._addOptionItem, this);

		// Update states
		this._updateSelection();
	},

	_updateSelection: function(){
		// summary:
		//		Sets the "selected" class on the item for styling purposes
		this._set("value", this._getValueFromOpts());
		var val = this.value;
		if(!lang.isArray(val)){
			val = [val];
		}
		if(val && val[0]){
			array.forEach(this._getChildren(), function(child){
				var isSelected = array.some(val, function(v){
					return child.option && (v === child.option.value);
				});
				domClass.toggle(child.domNode, this.baseClass.replace(/\s+|$/g, "SelectedOption "), isSelected);
				child.domNode.setAttribute("aria-selected", isSelected ? "true" : "false");
			}, this);
		}
	},

	_getValueFromOpts: function(){
		// summary:
		//		Returns the value of the widget by reading the options for
		//		the selected flag
		var opts = this.getOptions() || [];
		if(!this.multiple && opts.length){
			// Mirror what a select does - choose the first one
			var opt = array.filter(opts, function(i){
				return i.selected;
			})[0];
			if(opt && opt.value){
				return opt.value;
			}else{
				opts[0].selected = true;
				return opts[0].value;
			}
		}else if(this.multiple){
			// Set value to be the sum of all selected
			return array.map(array.filter(opts, function(i){
				return i.selected;
			}), function(i){
				return i.value;
			}) || [];
		}
		return "";
	},

	// Internal functions to call when we have store notifications come in
	_onNewItem: function(/*item*/ item, /*Object?*/ parentInfo){
		if(!parentInfo || !parentInfo.parent){
			// Only add it if we are top-level
			this._addOptionForItem(item);
		}
	},
	_onDeleteItem: function(/*item*/ item){
		var store = this.store;
		this.removeOption(store.getIdentity(item));
	},
	_onSetItem: function(/*item*/ item){
		this.updateOption(this._getOptionObjForItem(item));
	},

	_getOptionObjForItem: function(item){
		// summary:
		//		Returns an option object based off the given item.  The "value"
		//		of the option item will be the identity of the item, the "label"
		//		of the option will be the label of the item.

		// remove getLabel() call for 2.0 (it's to support the old dojo.data API)
		var store = this.store,
			label = (this.labelAttr && this.labelAttr in item) ? item[this.labelAttr] : store.getLabel(item),
			value = (label ? store.getIdentity(item) : null);
		return {value: value, label: label, item: item}; // __SelectOption
	},

	_addOptionForItem: function(/*item*/ item){
		// summary:
		//		Creates (and adds) the option for the given item
		var store = this.store;
		if(store.isItemLoaded && !store.isItemLoaded(item)){
			// We are not loaded - so let's load it and add later.
			// Remove for 2.0 (it's the old dojo.data API)
			store.loadItem({item: item, onItem: function(i){
				this._addOptionForItem(i);
			},
			scope: this});
			return;
		}
		var newOpt = this._getOptionObjForItem(item);
		this.addOption(newOpt);
	},

	constructor: function(params /*===== , srcNodeRef =====*/){
		// summary:
		//		Create the widget.
		// params: Object|null
		//		Hash of initialization parameters for widget, including scalar values (like title, duration etc.)
		//		and functions, typically callbacks like onClick.
		//		The hash can contain any of the widget's properties, excluding read-only properties.
		// srcNodeRef: DOMNode|String?
		//		If a srcNodeRef (DOM node) is specified, replace srcNodeRef with my generated DOM tree

		//		Saves off our value, if we have an initial one set so we
		//		can use it if we have a store as well (see startup())
		this._oValue = (params || {}).value || null;
		this._notifyConnections = [];	// remove for 2.0
	},

	buildRendering: function(){
		this.inherited(arguments);
		dom.setSelectable(this.focusNode, false);
	},

	_fillContent: function(){
		// summary:
		//		Loads our options and sets up our dropdown correctly.  We
		//		don't want any content, so we don't call any inherit chain
		//		function.
		if(!this.options){
			this.options =
				this.srcNodeRef
				? query("> *", this.srcNodeRef).map(
					function(node){
						if(node.getAttribute("type") === "separator"){
							return { value: "", label: "", selected: false, disabled: false };
						}
						return {
							value: (node.getAttribute("data-" + kernel._scopeName + "-value") || node.getAttribute("value")),
							label: String(node.innerHTML),
							// FIXME: disabled and selected are not valid on complex markup children (which is why we're
							// looking for data-dojo-value above.  perhaps we should data-dojo-props="" this whole thing?)
							// decide before 1.6
							selected: node.getAttribute("selected") || false,
							disabled: node.getAttribute("disabled") || false
						};
					},
					this)
				: [];
		}
		if(!this.value){
			this._set("value", this._getValueFromOpts());
		}else if(this.multiple && typeof this.value == "string"){
			this._set("value", this.value.split(","));
		}
	},

	postCreate: function(){
		// summary:
		//		sets up our event handling that we need for functioning
		//		as a select
		this.inherited(arguments);

		// Make our event connections for updating state
		this.connect(this, "onChange", "_updateSelection");

		// moved from startup
		//		Connects in our store, if we have one defined
		var store = this.store;
		if(store && (store.getIdentity || store.getFeatures()["dojo.data.api.Identity"])){
			// Temporarily set our store to null so that it will get set
			// and connected appropriately
			this.store = null;
			this.setStore(store, this._oValue);
		}
	},

	startup: function(){
		// summary:
		this._loadChildren();
		this.inherited(arguments);
	},

	destroy: function(){
		// summary:
		//		Clean up our connections

		var h;
		while((h = this._notifyConnections.pop())){ h.remove(); }

		// Cancel listener for store updates
		if(this._queryRes && this._queryRes.close){
			this._queryRes.close();
		}

		this.inherited(arguments);
	},

	_addOptionItem: function(/*__SelectOption*/ /*===== option =====*/){
		// summary:
		//		User-overridable function which, for the given option, adds an
		//		item to the select.  If the option doesn't have a value, then a
		//		separator is added in that place.  Make sure to store the option
		//		in the created option widget.
	},

	_removeOptionItem: function(/*__SelectOption*/ /*===== option =====*/){
		// summary:
		//		User-overridable function which, for the given option, removes
		//		its item from the select.
	},

	_setDisplay: function(/*String or String[]*/ /*===== newDisplay =====*/){
		// summary:
		//		Overridable function which will set the display for the
		//		widget.  newDisplay is either a string (in the case of
		//		single selects) or array of strings (in the case of multi-selects)
	},

	_getChildren: function(){
		// summary:
		//		Overridable function to return the children that this widget contains.
		return [];
	},

	_getSelectedOptionsAttr: function(){
		// summary:
		//		hooks into this.attr to provide a mechanism for getting the
		//		option items for the current value of the widget.
		return this.getOptions(this.get("value"));
	},

	_pseudoLoadChildren: function(/*item[]*/ /*===== items =====*/){
		// summary:
		//		a function that will "fake" loading children, if needed, and
		//		if we have set to not load children until the widget opens.
		// items:
		//		An array of items that will be loaded, when needed
	},

	onSetStore: function(){
		// summary:
		//		a function that can be connected to in order to receive a
		//		notification that the store has finished loading and all options
		//		from that store are available
	}
});

/*=====
_FormSelectWidget.__SelectOption = __SelectOption;
=====*/

return _FormSelectWidget;

});

},
'dojo/data/util/sorter':function(){
define("dojo/data/util/sorter", ["../../_base/lang"], function(lang){
	// module:
	//		dojo/data/util/sorter
	// summary:
	//		TODOC

var sorter = {};
lang.setObject("dojo.data.util.sorter", sorter);

sorter.basicComparator = function(	/*anything*/ a,
													/*anything*/ b){
	// summary:
	//		Basic comparison function that compares if an item is greater or less than another item
	// description:
	//		returns 1 if a > b, -1 if a < b, 0 if equal.
	//		'null' values (null, undefined) are treated as larger values so that they're pushed to the end of the list.
	//		And compared to each other, null is equivalent to undefined.

	//null is a problematic compare, so if null, we set to undefined.
	//Makes the check logic simple, compact, and consistent
	//And (null == undefined) === true, so the check later against null
	//works for undefined and is less bytes.
	var r = -1;
	if(a === null){
		a = undefined;
	}
	if(b === null){
		b = undefined;
	}
	if(a == b){
		r = 0;
	}else if(a > b || a == null){
		r = 1;
	}
	return r; //int {-1,0,1}
};

sorter.createSortFunction = function(	/* attributes[] */sortSpec, /*dojo/data/api/Read*/ store){
	// summary:
	//		Helper function to generate the sorting function based off the list of sort attributes.
	// description:
	//		The sort function creation will look for a property on the store called 'comparatorMap'.  If it exists
	//		it will look in the mapping for comparisons function for the attributes.  If one is found, it will
	//		use it instead of the basic comparator, which is typically used for strings, ints, booleans, and dates.
	//		Returns the sorting function for this particular list of attributes and sorting directions.
	// sortSpec:
	//		A JS object that array that defines out what attribute names to sort on and whether it should be descenting or asending.
	//		The objects should be formatted as follows:
	// |	{
	// |		attribute: "attributeName-string" || attribute,
	// |		descending: true|false;   // Default is false.
	// |	}
	// store:
	//		The datastore object to look up item values from.

	var sortFunctions=[];

	function createSortFunction(attr, dir, comp, s){
		//Passing in comp and s (comparator and store), makes this
		//function much faster.
		return function(itemA, itemB){
			var a = s.getValue(itemA, attr);
			var b = s.getValue(itemB, attr);
			return dir * comp(a,b); //int
		};
	}
	var sortAttribute;
	var map = store.comparatorMap;
	var bc = sorter.basicComparator;
	for(var i = 0; i < sortSpec.length; i++){
		sortAttribute = sortSpec[i];
		var attr = sortAttribute.attribute;
		if(attr){
			var dir = (sortAttribute.descending) ? -1 : 1;
			var comp = bc;
			if(map){
				if(typeof attr !== "string" && ("toString" in attr)){
					 attr = attr.toString();
				}
				comp = map[attr] || bc;
			}
			sortFunctions.push(createSortFunction(attr,
				dir, comp, store));
		}
	}
	return function(rowA, rowB){
		var i=0;
		while(i < sortFunctions.length){
			var ret = sortFunctions[i++](rowA, rowB);
			if(ret !== 0){
				return ret;//int
			}
		}
		return 0; //int
	}; // Function
};

return sorter;
});

},
'url:dijit/form/templates/Select.html':"<table class=\"dijit dijitReset dijitInline dijitLeft\"\n\tdata-dojo-attach-point=\"_buttonNode,tableNode,focusNode\" cellspacing='0' cellpadding='0'\n\trole=\"listbox\" aria-haspopup=\"true\"\n\t><tbody role=\"presentation\"><tr role=\"presentation\"\n\t\t><td class=\"dijitReset dijitStretch dijitButtonContents\" role=\"presentation\"\n\t\t\t><div class=\"dijitReset dijitInputField dijitButtonText\"  data-dojo-attach-point=\"containerNode,_popupStateNode\" role=\"presentation\"></div\n\t\t\t><div class=\"dijitReset dijitValidationContainer\"\n\t\t\t\t><input class=\"dijitReset dijitInputField dijitValidationIcon dijitValidationInner\" value=\"&#935; \" type=\"text\" tabIndex=\"-1\" readonly=\"readonly\" role=\"presentation\"\n\t\t\t/></div\n\t\t\t><input type=\"hidden\" ${!nameAttrSetting} data-dojo-attach-point=\"valueNode\" value=\"${value}\" aria-hidden=\"true\"\n\t\t/></td\n\t\t><td class=\"dijitReset dijitRight dijitButtonNode dijitArrowButton dijitDownArrowButton dijitArrowButtonContainer\"\n\t\t\tdata-dojo-attach-point=\"titleNode\" role=\"presentation\"\n\t\t\t><input class=\"dijitReset dijitInputField dijitArrowButtonInner\" value=\"&#9660; \" type=\"text\" tabIndex=\"-1\" readonly=\"readonly\" role=\"presentation\"\n\t\t\t\t${_buttonInputDisabled}\n\t\t/></td\n\t></tr></tbody\n></table>\n",
'epi-cms/component/ContentQueryGrid':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    "dojo/aspect",
// epi-cms
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/widget/_GridWidgetBase"
],

function (
    declare,
    lang,
    when,

    aspect,
    // epi-cms
    ContentActionSupport,
    _GridWidgetBase
) {

    return declare([_GridWidgetBase], {
        // summary: This component will list the latest changed pages for the web site.

        // queryName: string
        //    The name of the content query used to fetch data for the grid.
        queryName: null,

        queryParameters: null,

        dndTypes: ['epi.cms.contentreference'],

        postMixInProperties: function () {
            // summary:
            //
            // tags:
            //    protected
            this.storeKeyName = "epi.cms.content.search";

            this.inherited(arguments);
        },

        buildRendering: function () {
            // summary:
            //		Construct the UI for this widget with this.domNode initialized as a dgrid.
            // tags:
            //		protected

            this.inherited(arguments);

            var gridSettings = lang.mixin({
                columns: {
                    name: {
                        renderCell: lang.hitch(this, this._renderContentItem)
                    },
                    status: {
                        className: "epi-width35",
                        renderCell: function (item, value, node, options) {
                            node.innerHTML = ContentActionSupport.getVersionStatus(value);
                        }
                    }
                },
                store: this.store,
                dndSourceType: this.dndTypes
            }, this.defaultGridMixin);

            this.grid = new this._gridClass(gridSettings, this.domNode);

            this.grid.set("showHeader", false);

            this.own(
                aspect.around(this.grid, "insertRow", lang.hitch(this, this._aroundInsertRow))
            );
        },

        fetchData: function () {

            when(this._getCurrentItem(), lang.hitch(this, function(currentItem) {
                this.set("currentItem", currentItem);
            }));

            this.grid.set("queryOptions", { ignore: ["query"], sort: [{ attribute: "name", descending: true }] });
            var queryParameters = this.queryParameters || {};
            queryParameters.query = this.queryName;
            this.grid.set("query", queryParameters);
        },

        _setQueryNameAttr: function (value) {
            this.queryName = value;
            this.fetchData();
        }
    });
});
},
'url:epi-cms/component/templates/Tasks.html':"﻿<div>\r\n    <div class=\"epi-gadgetInnerToolbar\" data-dojo-attach-point=\"toolbar\">\r\n        <div data-dojo-type=\"dijit/form/Button\" data-dojo-attach-point=\"reloadButton\" data-dojo-attach-event=\"onClick: _reloadQuery\"\r\n            class=\"epi-chromelessButton epi-iconReload epi-input-margin--left dijitInline dijitReset\">\r\n        </div>\r\n    </div>\r\n    <div data-dojo-type=\"epi-cms/component/ContentQueryGrid\" data-dojo-attach-point=\"contentQuery\">\r\n    </div>\r\n</div>\r\n",
'epi-cms/component/Trash':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/dom-construct",
// dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
// epi
    "epi/shell/widget/_FocusableMixin",
    "epi-cms/widget/Trash",
    "epi-cms/widget/viewmodel/TrashViewModel"
], function (
// dojo
    declare,
    domConstruct,
// dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
// epi
    _FocusableMixin,
    Trash,
    TrashViewModel
    ) {

    // module:
    //      epi-cms/component/Trash
    // summary:
    //      A component to display trash page.

    // Declare "epi-cms.component.Trash" in order to tell WidgetSwitcher create only one instance of this.
    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _FocusableMixin], {
        // summary:
        //      A component to display trash page.

        templateString: "<div class=\"epi-trashComponent\"><div data-dojo-type='epi-cms/widget/Trash' data-dojo-attach-point='trash'></div></div>",

        updateView: function (data) {
            // summary:
            //		This will be invoked by WidgetSwitcher when displaying Trash component.
            //      Implement this to refresh the model, to refresh data.
            // tags:
            //		public
            if (data) {
                this.trash.set("typeIdentifiers", data.typeIdentifiers);
            }

            if (this._trashModel) {
                this._trashModel.destroy();
            }

            this.trash.set("model", this._trashModel = new TrashViewModel());
        },

        destroy: function () {
            this._trashModel.destroy();

            this.inherited(arguments);
        }
    });
});
},
'epi-cms/widget/Trash':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/Evented",
    "dojo/_base/Deferred",

// Dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/TabContainer",
    "dijit/layout/ContentPane",
    "dijit/registry",

// EPi Framework
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/dialog/Alert",
    "epi/shell/command/withConfirmation",

// EPi
    "epi-cms/widget/TrashItemList",
    "epi-cms/widget/EmptyTrashMenu",
    "epi-cms/widget/TrashViewModelConfirmation",
    "epi-cms/widget/command/EmptyTrash",
    "epi-cms/widget/command/RestoreContent",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.trash",
    "dojo/text!./templates/Trash.html"
], function (
// Dojo
    array,
    declare,
    lang,
    domClass,
    domConstruct,
    Evented,
    Deferred,

// Dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    TabContainer,
    ContentPane,
    registry,

// EPi Framework
    _ModelBindingMixin,
    Alert,
    withConfirmation,

// EPi
    TrashItemList,
    EmptyTrashMenu,
    TrashViewModelConfirmation,
    EmptyTrashCommand,
    RestoreContentCommand,

// Resources
    resources,
    template
    ) {

    // module:
    //      epi-cms/widget/Trash
    // summary:
    //      A widget to display trash page.

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin, Evented], {

        resources: resources,

        templateString: template,

        _restoreContentCommand: null,

        typeIdentifiers: null,

        // Map property name in view model to a list of properties in this widget
        modelBindingMap: {
            "contentStore": ["store"],
            "queryOptions": ["queryOptions"],
            "actionResponse": ["actionResponse"],
            "trashes": ["trashes"]
        },

        postCreate: function () {
            this.inherited(arguments);

            // watch for tab change to get data
            this.tabContainer.watch("selectedChildWidget", lang.hitch(this, function (name, oldValue, newValue) {
                if (newValue.itemListId) {
                    var trashItemList = registry.byId(newValue.itemListId);
                    trashItemList.bindUserSelector(newValue.trash.deletedByUsers);
                }
                this.model.set("currentTrash", newValue.trash);
            }));

            // create a shared instance of Restore Content command, then watch for model updated to update model for that command.
            this._restoreContentCommand = new RestoreContentCommand({ model: this.model /* TrashViewModel */ });
            this.watch("model", lang.hitch(this, function () {
                this.model = TrashViewModelConfirmation(this.model);
                this._restoreContentCommand.set("model", this.model);
            }));

            this.on("itemClick", this._onItemClick); // listen for row clicked event of Trash Item List, to execute Restore Content Command.
            this.on("deletedByChange", this._onDeletedByChange); // when removed by select is changed, update the grid to reflect changes
        },

        _setTrashesAttr: function (trashes) {
            // summary:
            //		Builds Empty Trash button and Tab strip based on input trashes
            // tags:
            //		private

            // Remove all tab pane before adding new
            this.tabContainer.destroyDescendants();
            var listCommand = [];
            array.forEach(trashes, function (trash) {
                if (trash && trash.active) {
                    this._addTrash(trash); // add a Tab pane

                    var command = new EmptyTrashCommand({
                        label: trash.name,
                        tooltip: trash.name,
                        trashId: trash.wasteBasketLink,
                        model: this.model
                    });

                    listCommand.push(withConfirmation(command, null, {
                        title: resources.emptytrash.title,
                        description: this.model.getEmptyTrashConfirmMessage(trash.name),
                        onShow: lang.hitch(this, function () {
                            var trashItemList = this.tabContainer.selectedChildWidget.getChildren()[0];
                            trashItemList.clearSelection();
                        })
                    }));
                }
            }, this);

            // Update model for empty menu
            this.emptyTrashMenu.set("commands", listCommand);

            if(trashes && trashes.length === 1) {
                domClass.add(this.tabContainer.domNode, "hide-tablist");
            }

            this.tabContainer.startup();
            this.tabContainer.layout();
        },

        _addTrash: function (trash) {
            // summary:
            //		Adds tab panes to tab container for every trash
            // tags:
            //		private

            var _selectedItem = null;

            if (trash.active) { // add active trash only
                trash.isRequireLoad = true; // make sure trash data will be load on first load
                var item = new ContentPane({
                    title: trash.name, // TODO update the total item number, for example: Pages 1000+
                    trash: trash
                });
                this.tabContainer.addChild(item);
                if (this._isSelected(trash)) {
                    _selectedItem = item;
                }
            }
            if (_selectedItem) {
                this.tabContainer.selectChild(_selectedItem);
            }
        },

        _isSelected: function (trash) {
            var result = false;
            array.some(trash.typeIdentifiers, lang.hitch(this, function (feederType) {
                return array.some(this.typeIdentifiers, function (type) {
                    if (feederType == type) {
                        result = true;
                        return false; // return false to quite the loop, in case we find a match.
                    }
                });
            }));
            return result;
        },

        _setQueryOptionsAttr: function (queryOptions) {
            // summary:
            //		When query is set, use this query options to get content for current tab.
            // tags:
            //		private

            if (queryOptions) {
                var selectedTab = this.tabContainer.selectedChildWidget;
                if (selectedTab) {
                    var contentStore = this.get("store"),
                        trashItemListWidget = null;

                    if (selectedTab.itemListId) { // update itemList's store instead of creating new instance
                        trashItemListWidget = registry.byId(selectedTab.itemListId);
                        trashItemListWidget.set("queryOptions", queryOptions);
                    } else {
                        trashItemListWidget = new TrashItemList({ queryOptions: queryOptions, store: contentStore, model: this.model });

                        trashItemListWidget.on("itemClick", lang.hitch(this, function (row) {
                            this.emit("itemClick", row);
                        }));

                        trashItemListWidget.on("deletedByChange", lang.hitch(this, function (username) {
                            this.emit("deletedByChange", username);
                        }));

                        trashItemListWidget.on("searchBoxChange", lang.hitch(this, this._onSearchBoxChange));

                        selectedTab.set("content", trashItemListWidget);
                        selectedTab.itemListId = trashItemListWidget.id;
                    }

                    // Update user selector.
                    trashItemListWidget.updateRemovedBy(queryOptions);
                }
            }
        },

        _setActionResponseAttr: function (message) {
            // summary:
            //      Fired when execute action return response.
            // tags:
            //      private
            if(!message) {
                return;
            }

            this._showNotificationMessage(message);
        },

        _showNotificationMessage: function (message) {
            // summary:
            //     Show a alert message when get error response.
            // message:
            //     The message to be displayed in the alert.

            new Alert({
                destroyOnHide: true,
                description: message ? message : ""
            }).show();
        },

        _onItemClick: function (row) {
            // summary:
            //     Fired when a row of Trash Item list has been clicked.
            // row:
            //     Selected row.
            // tags:
            //      private

            if (row && row.data && this.model.get("currentTrash")) {
                // set current content to be restored
                this._restoreContentCommand.set("content", row.data);
                this._restoreContentCommand.execute();
            }
        },

        _onDeletedByChange: function (username) {
            // summary:
            //     Fired when an item of DeletedBy select is changed.
            // username:
            //     Username which will be used to filter.
            // tags:
            //      private

            var currentTrash = this.model.get("currentTrash");
            currentTrash.deletedBy = username;
            currentTrash.isRequireLoad = true;
            this.model.set("currentTrash", currentTrash);
        },

        _onSearchBoxChange: function (/* String */queryText) {
            // summary:
            //      Perform search when text changed in search box
            // tags:
            //      private

            var currentTrash = this.model.get("currentTrash");
            currentTrash.queryText = queryText;
            currentTrash.isRequireLoad = true;
            this.model.set("currentTrash", currentTrash);
        }
    });
});

},
'epi-cms/widget/TrashItemList':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/window",

    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style",

    "dojo/aspect",
    "dojo/keys",
    "dojo/Evented",
    "dojo/query",
    "dojo/html",
    "dojo/Stateful",
    "dojo/string",
    "dojo/when",
// Dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Select",

// Dojox
    "dojox/widget/Standby",

// DGrid
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    "dgrid/Keyboard",
    "dgrid/tree",
    "dgrid/extensions/ColumnResizer",
    "dgrid/util/mouse",
    "put-selector/put",

// EPi
    "epi",
    "epi/dependency",
    "epi/shell/dgrid/Formatter",
    "epi/shell/dgrid/util/misc",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/SearchBox",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/datetime",
    "epi/username",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.trash",
    "dojo/text!./templates/TrashItemList.html"
],

function (
// Dojo
    array,
    declare,
    lang,
    window,

    domClass,
    domConstruct,
    domGeometry,
    domStyle,

    aspect,
    keys,
    Evented,
    query,
    html,
    Stateful,
    string,
    when,
// Dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    Select,

// Dojox
    Standby,

// DGrid
    OnDemandGrid,
    DgridSelection,
    Keyboard,
    Tree,
    ColumnResizer,
    MouseUtil,
    put,

// EPi
    epi,
    dependency,
    Formatter,
    GridMiscUtil,
    TypeDescriptorManager,
    SearchBox,
    _ModelBindingMixin,
    epiDate,
    username,

// Resources
    resources,
    template
) {

    // module:
    //      epi-cms/widget/TrashItemList
    // summary:
    //      A widget to display content in trash for a specific trash.

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, Evented, Stateful, _ModelBindingMixin], {

        resources: resources,

        epi: epi,

        templateString: template,

        _grid: null,

        _observers: {},

        _setQueryOptionsAttr: function (queryOptions) {
            this._set("queryOptions", queryOptions);
            this._initialize();
        },

        updateRemovedBy: function (queryOptions) {
            // summary:
            //      Update user list in Removed by selector.
            // tags:
            //      protected

            var currentTrash = this.model.get("currentTrash");

            // Update when empty trash
            if (this.model.isEmptyTrash) {
                this.bindDefaultUserSelector();
                return;
            }

            var results = this.store.query({ referenceId: queryOptions.query.referenceId, query:"getblockrootchildren"});

            // Listen when store observe query to rebind user selector and update trashes.
            var listener = lang.hitch(this, function (item, removedFrom, insertedInto) {
                var providerName = currentTrash.isDefaultProvider ? "" : currentTrash.name;

                when(this.model.trashStore.query({ providerName: providerName }), lang.hitch(this, function (trash) {
                    if (trash) {
                        var deletedByUsers = trash.deletedByUsers;

                        // Update property of current trash
                        currentTrash.deletedByUsers = deletedByUsers;

                        // Rebind user selector
                        this.bindUserSelector(deletedByUsers);
                    }
                }));
            });
            var id = currentTrash.name,
                observer = this._observers[id];

            if (observer) {
                observer.cancel();
                delete this._observers[id];
            }

            // Observe the query result to update the parent node when have changes.
            this._observers[id] = results.observe(listener, true);
        },

        destroy: function () {
            // summary:
            //      Destroy the object.
            for (var id in this._observers) {
                this._observers[id].cancel();
                delete this._observers[id];
            }

            if (this._standby) {
                this._standby.destroyRecursive();
                this._standby = null;
            }

            if (this._grid) {
                this._grid.destroy();
                this._grid = null;
            }

            this.inherited(arguments);
        },

        clearSelection: function () {
            this._grid.clearSelection();
            // NOTE:
            // It is necessary to set the _lastSelected to null due a bug on the dgrid where
            // after deselecting a row it cannot be selected again. If the _lastSelected isn't
            // "clear", it will assume that the same row is selected and it will not apply all
            // styling (highlighted selected classes).
            // The bug report can be found here: https://github.com/SitePen/dgrid/issues/295
            this._grid._lastSelected = null;
        },

        postCreate: function () {
            this.inherited(arguments);

            this.bindUserSelector(this.model.get("currentTrash").deletedByUsers);

            this.searchBox.encodeSearchText = true;
            this.searchBox.on("searchBoxChange", lang.hitch(this, function (queryText) {
                this.emit("searchBoxChange", queryText);
            }));

            // Sets the "selected" class on the item for styling purposes
            // Overrides this function from "dijit/form/_FormSelectWidget" to setable blank value menu item to selected
            this.removedBy._updateSelection = function () {
                this._set("value", this._getValueFromOpts());
                var val = this.value;
                if (!lang.isArray(val)) {
                    val = [val];
                }

                array.forEach(this._getChildren(), function (child) {
                    var isSelected = array.some(val, function (v) {
                        return child.option && (v === child.option.value);
                    });
                    domClass.toggle(child.domNode, this.baseClass + "SelectedOption", isSelected);
                    child.domNode.setAttribute("aria-selected", isSelected);
                }, this);
            };
        },

        resize: function () {
            // summary:
            //      Resize this widget to the given dimensions.
            // tags:
            //      protected

            // make the grid 100% height
            if (this._grid) {
                var top = domGeometry.position(this._grid.domNode).y;
                var bodyHeight = domGeometry.position(window.body()).h;
                domStyle.set(this._grid.domNode, "height", (bodyHeight - top) + "px");
            }
        },

        _initialize: function () {
            // Enable/Disable search box by content provider search capability
            this.searchBox.set("disabled", !this.queryOptions.query.isSearchable);

            if (!this._grid) {
                this._grid = this._createGrid(this.store, this.queryOptions);
                domConstruct.place(this._grid.domNode, this.gridContainerNode);
            } else { // update _grid's store and query instead of creating new instance
                this._showStandby(true);
                if (this.queryOptions) {
                    this._grid.set("queryOptions", this.queryOptions.options);
                    this._grid.set("query", this.queryOptions.query);
                }
            }
            this.resize(); // grid data changed, so we need to update its height
        },

        bindDefaultUserSelector: function () {
            // summary:
            //      Bind default [Any] value to selection.
            // tags:
            //      protected

            // Turn off change notifications while we make all these changes
            this.removedBy._onChangeActive = false;

            this.removedBy.removeOption(this.removedBy.options);
            this.removedBy.addOption({ label: epi.resources.text.anyone, value: "" });

            // Turn on change notifications when we made all these changes
            this.removedBy._onChangeActive = true;
        },

        bindUserSelector: function (userList) {
            // summary:
            //      Bind waste basket users to selection.
            // tags:
            //      protected

            if (userList) {
                // Get current selected item.
                var currentSelected = this.removedBy.get("value");

                this.bindDefaultUserSelector();

                // Turn off change notifications while we make all these changes
                this.removedBy._onChangeActive = false;
                array.forEach(userList, function (userName) {
                    this.removedBy.addOption({ label: this._createUserFriendlyUsername(userName), value: userName });
                }, this);

                // Reset current value for RemovedBy
                this.removedBy.set("value", currentSelected);

                // Turn on change notifications when we made all these changes
                this.removedBy._onChangeActive = true;
            }
        },

        _createGrid: function (store, queryOptions) {
            // summary:
            //      Creates and returns grid for displaying content.
            // tags:
            //      private

            var gridClass = declare([OnDemandGrid, DgridSelection, Keyboard, Formatter, ColumnResizer]);
            var grid = new gridClass({
                store: store,
                columns: {
                    name: Tree({
                        field: "name",
                        label: epi.resources.header.name,
                        renderCell: lang.hitch(this, this._renderTreeNode)
                    }),
                    removedOn: {
                        field: "deleted",
                        label: epi.resources.header.removed,
                        formatters: [this._localizeDate, GridMiscUtil.ellipsis]
                    },
                    by: {
                        field: "deletedBy",
                        label: epi.resources.header.by,
                        formatters: [this._createUserFriendlyUsername, GridMiscUtil.ellipsis]
                    },
                    action: { // Restore menu
                        label: " ",
                        formatter: this._renderActionMenu,
                        sortable: false
                    }
                },
                minWidth: 100,
                noDataMessage: this._getNoDataMessage(),
                selectionMode: "single"

            });

            this._standby = new Standby({ target: grid.domNode, color: "#fff" }).placeAt(document.body);
            this._standby.startup();

            this.own(
                aspect.after(grid, "expand", function (target) {
                    var row = target.element ? target : grid.row(target),
                        container = query(row.element).parent()[0];

                    // In firefox, at the first time of expand in grid tree, container's height always smaller than its child.
                    // So that, on the first click to expand a node, nothing happenned.
                    // Clear container's height in order to make container take auto height in this case.
                    if (container) {
                        domStyle.set(container, "height", "");
                    }
                }, true)
            );

            aspect.after(grid, "_processScroll", lang.hitch(this, function () {
                this._showStandby(false);
            }));

            this._showStandby(true);

            // small hack here to remove noDataMessage when store has been notified that new content has been moved to Trash.
            // This should have been implemented in dgrid/List
            // TODO consider a better fix?
            aspect.before(grid, "adjustRowIndices", function (firstRow) {
                if (firstRow) {
                    array.forEach(query("div.dgrid-no-data", this.contentNode), function (div) {
                        html.set(div, "");
                    });
                }
            });

            aspect.around(grid, "insertRow", lang.hitch(this, this._aroundInsertRow));

            // Don't show collap/expand icon when searching
            aspect.before(grid, "renderArray", lang.hitch(this, function (results, beforeNode, options) {
                var querySearch = this.queryOptions.query;
                if (querySearch && querySearch.query === "searchdeletedcontent") {
                    results.map(function (object) {
                        if (object) {
                            object.hasChildren = false;
                        }
                    });
                }
            }));


            if (queryOptions) {
                grid.set("queryOptions", queryOptions.options);
                grid.set("query", queryOptions.query);
            }

            var mouseOverClass = 'epi-dgrid-mouseover';
            grid.on(MouseUtil.enterRow, function (evt) {
                domClass.add(this, mouseOverClass); // add mouse over css class when hover a row
            });
            grid.on(MouseUtil.leaveRow, function (evt) {
                domClass.remove(this, mouseOverClass); // remove mouse over css class
            });

            grid.on(".epi-gridAction:click", lang.hitch(this, function (evt) { // on restore action clicking
                var row = grid.row(evt);
                this.emit("itemClick", row);
            }));

            // Handle ENTER key event for the grid action cell
            grid.on(".dgrid-column-action:keydown", lang.hitch(this, function (e) {
                if (e.keyCode == keys.ENTER && !e.shiftKey && !e.altKey && !e.ctrlKey) {
                    var row = grid.row(e);
                    this.emit("itemClick", row);
                }
            }));

            return grid;
        },

        _renderTreeNode: function (object, data, td, options) {
            if (object && object.thumbnailUrl) {
                var image = domConstruct.create("img", {
                    src: object.thumbnailUrl + string.substitute("?${0}", [new Date().getTime()]),
                    "class": "epi-thumbnail"
                }, td);
                domConstruct.place(GridMiscUtil.ellipsis(GridMiscUtil.htmlEncode(data)), td);
            }
            else {
                var iconNodeClass = TypeDescriptorManager.getValue(object.typeIdentifier, "iconClass") || "epi-iconObjectPage";
                domConstruct.place(GridMiscUtil.icon(iconNodeClass + " epi-objectIcon", GridMiscUtil.ellipsis(GridMiscUtil.htmlEncode(data))), td);
            }
        },

        _renderActionMenu: function (value) {
            // summary:
            //      Returns HTML string, represents the action menu.
            // tags:
            //      private

            var data = {
                "title": resources.restore.tooltip,
                "label": resources.restore.label
            };

            return lang.replace("<a class=\"epi-gridAction epi-visibleLink\" title=\"{title}\">{label}</a>", data);
        },

        _localizeDate: function (value) {
            // summary:
            //      Returns localized, friendly date as string.
            // tags:
            //      private
            return epiDate.toUserFriendlyString(value);
        },

        _createUserFriendlyUsername: function (name) {
            // summary:
            //      Returns friendly user name as string.
            // tags:
            //      private
            return username.toUserFriendlyString(GridMiscUtil.htmlEncode(name));
        },

        _onDeletedByChange: function (newValue) {
            // summary:
            //      Callback when DeletedBy value is changed.
            // tags:
            //      private

            // When empty trash, don't need fire change event to avoid duplicate message.
            if (this.model.isEmptyTrash) {
                this.model.isEmptyTrash = false;
                return;
            }

            this.emit("deletedByChange", newValue);
        },

        _showStandby: function (visible) {
            // summary:
            //      Set standby visibility.
            // tags:
            //      private

            if (!this._standby) {
                return;
            }
            if (visible) {
                if (!this._standby.isVisible()) {
                    this._standby.show();
                }
            } else {
                this._standby.hide();
            }
        },

        _getNoDataMessage: function () {
            // summary:
            //      Get message in case have no data.
            // tags:
            //      private

            return '<span><span class="dijitReset dijitInline">' + resources.trashitemempty + '</span></span>';
        },

        _aroundInsertRow: function (original) {
            // summary:
            //      Called 'around' the insertRow method to add more class for current row.
            // tags:
            //      protected

            return lang.hitch(this, function (object, parent, beforeNode, i, options) {

                // Call original method
                var row = original.apply(this._grid, arguments);

                if (object && object.thumbnailUrl) {
                    domClass.add(row, "epi-mediaContent");
                }

                return row;
            });
        }

    });

});
},
'dgrid/tree':function(){
define([
	"dojo/_base/declare",
	"dojo/_base/array",
	"dojo/_base/Deferred",
	"dojo/query",
	"dojo/on",
	"dojo/aspect",
	"./util/has-css3",
	"./Grid",
	"dojo/has!touch?./util/touch",
	"put-selector/put"
], function(declare, arrayUtil, Deferred, querySelector, on, aspect, has, Grid, touchUtil, put){

function defaultRenderExpando(level, hasChildren, expanded, object){
	// summary:
	//		Provides default implementation for column.renderExpando.
	
	var dir = this.grid.isRTL ? "right" : "left",
		cls = ".dgrid-expando-icon",
		node;
	if(hasChildren){
		cls += ".ui-icon.ui-icon-triangle-1-" + (expanded ? "se" : "e");
	}
	node = put("div" + cls + "[style=margin-" + dir + ": " +
		(level * (this.indentWidth || 9)) + "px; float: " + dir + "]");
	node.innerHTML = "&nbsp;"; // for opera to space things properly
	return node;
}

function ontransitionend(event){
	var container = this,
		height = this.style.height;
	if(height){
		// After expansion, ensure display is correct;
		// after collapse, set display to none to improve performance
		this.style.display = height == "0px" ? "none" : "block";
	}
	
	// Reset height to be auto, so future height changes (from children
	// expansions, for example), will expand to the right height.
	if(event){
		// For browsers with CSS transition support, setting the height to
		// auto or "" will cause an animation to zero height for some
		// reason, so temporarily set the transition to be zero duration
		put(this, ".dgrid-tree-resetting");
		setTimeout(function(){
			// Turn off the zero duration transition after we have let it render
			put(container, "!dgrid-tree-resetting");
		});
	}
	// Now set the height to auto
	this.style.height = "";
}

function tree(column){
	// summary:
	//		Adds tree navigation capability to a column.
	
	var originalRenderCell = column.renderCell || Grid.defaultRenderCell;
	
	var currentLevel, // tracks last rendered item level (for aspected insertRow)
		clicked; // tracks row that was clicked (for expand dblclick event handling)
		
	if(!column){ column = {}; }
	
	column.shouldExpand = column.shouldExpand || function(row, level, previouslyExpanded){
		// summary:
		//		Function called after each row is inserted to determine whether
		//		expand(rowElement, true) should be automatically called.
		//		The default implementation re-expands any rows that were expanded
		//		the last time they were rendered (if applicable).
		
		return previouslyExpanded;
	};
	
	aspect.after(column, "init", function(){
		var grid = column.grid,
			colSelector = ".dgrid-content .dgrid-column-" + column.id,
			listeners = []; // to be removed when this column is destroyed
		
		if(!grid.store){
			throw new Error("dgrid tree column plugin requires a store to operate.");
		}
		
		if (!column.renderExpando){
			column.renderExpando = defaultRenderExpando;
		}
		
		// Set up the event listener once and use event delegation for better memory use.
		listeners.push(grid.on(
			column.expandOn || ".dgrid-expando-icon:click," + colSelector + ":dblclick," + colSelector + ":keydown",
			function(event){
				var row = grid.row(event);	
				if((!grid.store.mayHaveChildren || grid.store.mayHaveChildren(row.data)) &&
						(event.type != "keydown" || event.keyCode == 32) &&
						!(event.type == "dblclick" && clicked && clicked.count > 1 &&
							row.id == clicked.id && event.target.className.indexOf("dgrid-expando-icon") > -1)){
					grid.expand(row);
				}
				
				// If the expando icon was clicked, update clicked object to prevent
				// potential over-triggering on dblclick (all tested browsers but IE < 9).
				if(event.target.className.indexOf("dgrid-expando-icon") > -1){
					if(clicked && clicked.id == grid.row(event).id){
						clicked.count++;
					}else{
						clicked = {
							id: grid.row(event).id,
							count: 1
						};
					}
				}
			})
		);
		
		if(has("touch")){
			// Also listen on double-taps of the cell.
			listeners.push(grid.on(touchUtil.selector(colSelector, touchUtil.dbltap),
				function(){ grid.expand(this); }));
		}
		
		// Set up hash to store IDs of expanded rows
		if(!grid._expanded){ grid._expanded = {}; }
		
		listeners.push(aspect.after(grid, "insertRow", function(rowElement){
			// Auto-expand (shouldExpand) considerations
			var row = this.row(rowElement),
				expanded = column.shouldExpand(row, currentLevel, this._expanded[row.id]);
			
			if(expanded){ this.expand(rowElement, true, true); }
			return rowElement; // pass return value through
		}));
		
		listeners.push(aspect.before(grid, "removeRow", function(rowElement, justCleanup){
			var connected = rowElement.connected;
			if(connected){
				// if it has a connected expando node, we process the children
				querySelector(">.dgrid-row", connected).forEach(function(element){
					grid.removeRow(element, true);
				});
				// now remove the connected container node
				if(!justCleanup){
					put(connected, "!");
				}
			}
		}));
		
		if(column.collapseOnRefresh){
			// Clear out the _expanded hash on each call to cleanup
			// (which generally coincides with refreshes, as well as destroy).
			listeners.push(aspect.after(grid, "cleanup", function(){
				this._expanded = {};
			}));
		}
		
		grid._calcRowHeight = function(rowElement){
			// we override this method so we can provide row height measurements that
			// include the children of a row
			var connected = rowElement.connected;
			// if connected, need to consider this in the total row height
			return rowElement.offsetHeight + (connected ? connected.offsetHeight : 0); 
		};
		
		grid.expand = function(target, expand, noTransition){
			// summary:
			//		Expands the row corresponding to the given target.
			// target: Object
			//		Row object (or something resolvable to one) to expand/collapse.
			// expand: Boolean?
			//		If specified, designates whether to expand or collapse the row;
			//		if unspecified, toggles the current state.
			
			var row = target.element ? target : grid.row(target),
				hasTransitionend = has("transitionend");
			
			target = row.element;
			target = target.className.indexOf("dgrid-expando-icon") > -1 ? target :
				querySelector(".dgrid-expando-icon", target)[0];
			
			if(target && target.mayHaveChildren &&
					(noTransition || expand !== !!this._expanded[row.id])){
				// toggle or set expand/collapsed state based on optional 2nd argument
				var expanded = expand === undefined ? !this._expanded[row.id] : expand;
				
				// update the expando display
				put(target, ".ui-icon-triangle-1-" + (expanded ? "se" : "e") +
					"!ui-icon-triangle-1-" + (expanded ? "e" : "se"));
				
				var preloadNode = target.preloadNode,
					rowElement = row.element,
					container,
					containerStyle,
					scrollHeight,
					options;
				
				if(!preloadNode){
					// if the children have not been created, create a container, a preload node and do the 
					// query for the children
					container = rowElement.connected = put('div.dgrid-tree-container');//put(rowElement, '+...
					preloadNode = target.preloadNode = put(rowElement, '+', container, 'div.dgrid-preload');
					var query = function(options){
						return grid.store.getChildren(row.data, options);
					};
					query.level = target.level;
					if(column.allowDuplicates){
						// If allowDuplicates is specified, include parentId in options
						// in order to facilitate unique IDs for each occurrence of the
						// same item under multiple different parents.
						options = { parentId: row.id };
					}
					Deferred.when(
						grid.renderQuery ?
							grid._trackError(function(){
								return grid.renderQuery(query, preloadNode, options);
							}) :
							grid.renderArray(query(options), preloadNode, {query: query}),
						function(){
							// Expand once results are retrieved, if the row is still expanded.
							if(grid._expanded[row.id] && hasTransitionend){
								var scrollHeight = container.scrollHeight;
								container.style.height = scrollHeight ? scrollHeight + "px" : "auto";
							}
						}
					);
					
					if(hasTransitionend){
						on(container, hasTransitionend, ontransitionend);
					}else{
						ontransitionend.call(container);
					}
				}
				
				// Show or hide all the children.
				
				container = rowElement.connected;
				container.hidden = !expanded;
				containerStyle = container.style;
				
				// make sure it is visible so we can measure it
				if(!hasTransitionend || noTransition){
					containerStyle.display = expanded ? "block" : "none";
					containerStyle.height = "";
				}else{
					if(expanded){
						containerStyle.display = "block";
						scrollHeight = container.scrollHeight;
						containerStyle.height = "0px";
					}
					else{
						// if it will be hidden we need to be able to give a full height
						// without animating it, so it has the right starting point to animate to zero
						put(container, ".dgrid-tree-resetting");
						containerStyle.height = container.scrollHeight + "px";
					}
					// Perform a transition for the expand or collapse.
					setTimeout(function(){
						put(container, "!dgrid-tree-resetting");
						containerStyle.height =
							expanded ? (scrollHeight ? scrollHeight + "px" : "auto") : "0px";
					});
				}
				
				// Update _expanded map.
				if(expanded){
					this._expanded[row.id] = true;
				}else{
					delete this._expanded[row.id];
				}
			}
		}; // end function grid.expand
		
		// Set up a destroy function on column to tear down the listeners/aspects
		// established above if the grid's columns are redefined later.
		aspect.after(column, "destroy", function(){
			arrayUtil.forEach(listeners, function(l){ l.remove(); });
			// Delete methods we added/overrode on the instance.
			delete grid.expand;
			delete grid._calcRowHeight;
		});
	});
	
	column.renderCell = function(object, value, td, options){
		// summary:
		//		Renders a cell that can be expanded, creating more rows
		
		var grid = column.grid,
			level = Number(options && options.query && options.query.level) + 1,
			mayHaveChildren = !grid.store.mayHaveChildren || grid.store.mayHaveChildren(object),
			parentId = options.parentId,
			expando, node;
		
		level = currentLevel = isNaN(level) ? 0 : level;
		expando = column.renderExpando(level, mayHaveChildren,
			grid._expanded[(parentId ? parentId + "-" : "") + grid.store.getIdentity(object)], object);
		expando.level = level;
		expando.mayHaveChildren = mayHaveChildren;
		
		node = originalRenderCell.call(column, object, value, td, options);
		if(node && node.nodeType){
			put(td, expando);
			put(td, node);
		}else{
			td.insertBefore(expando, td.firstChild);
		}
	};
	return column;
}

tree.defaultRenderExpando = defaultRenderExpando;
return tree;
});

},
'dgrid/extensions/ColumnResizer':function(){
define(["dojo/_base/declare", "dojo/on", "dojo/query", "dojo/_base/lang", "dojo/dom", "dojo/dom-geometry", "dojo/has", "../util/misc", "put-selector/put", "dojo/_base/html", "xstyle/css!../css/extensions/ColumnResizer.css"],
function(declare, listen, query, lang, dom, geom, has, miscUtil, put){

function addRowSpan(table, span, startRow, column, id){
	// loop through the rows of the table and add this column's id to
	// the rows' column
	for(var i=1; i<span; i++){
		table[startRow+i][column] = id;
	}
}
function subRowAssoc(subRows){
	// Take a sub-row structure and output an object with key=>value pairs
	// The keys will be the column id's; the values will be the first-row column
	// that column's resizer should be associated with.

	var i = subRows.length,
		l = i,
		numCols = subRows[0].length,
		table = new Array(i);

	// create table-like structure in an array so it can be populated
	// with row-spans and col-spans
	while(i--){
		table[i] = new Array(numCols);
	}

	var associations = {};

	for(i=0; i<l; i++){
		var row = table[i],
			subRow = subRows[i];

		// j: counter for table columns
		// js: counter for subrow structure columns
		for(var j=0, js=0; j<numCols; j++){
			var cell = subRow[js], k;

			// if something already exists in the table (row-span), skip this
			// spot and go to the next
			if(typeof row[j] != "undefined"){
				continue;
			}
			row[j] = cell.id;

			if(cell.rowSpan && cell.rowSpan > 1){
				addRowSpan(table, cell.rowSpan, i, j, cell.id);
			}

			// colSpans are only applicable in the second or greater rows
			// and only if the colSpan is greater than 1
			if(i>0 && cell.colSpan && cell.colSpan > 1){
				for(k=1; k<cell.colSpan; k++){
					// increment j and assign the id since this is a span
					row[++j] = cell.id;
					if(cell.rowSpan && cell.rowSpan > 1){
						addRowSpan(table, cell.rowSpan, i, j, cell.id);
					}
				}
			}
			associations[cell.id] = subRows[0][j].id;
			js++;
		}
	}

	return associations;
}

function resizeColumnWidth(grid, colId, width, parentType){
	// don't react to widths <= 0, e.g. for hidden columns
	if(width <= 0){ return; }

	var column = grid.columns[colId],
		event = {
			grid: grid,
			columnId: colId,
			width: width,
			bubbles: true,
			cancelable: true
		},
		rule;
	
	if(parentType){
		event.parentType = parentType;
	}
	
	if(!grid._resizedColumns || listen.emit(grid.headerNode, "dgrid-columnresize", event)){
		// Update width on column object, then convert value for CSS
		if(width === "auto"){
			delete column.width;
		}else{
			column.width = width;
			width += "px";
		}
		
		rule = grid._columnSizes[colId];
		
		if(rule){
			// Modify existing, rather than deleting + adding
			rule.set("width", width);
		}else{
			// Use miscUtil function directly, since we clean these up ourselves anyway
			rule = miscUtil.addCssRule(
				"#" + miscUtil.escapeCssIdentifier(grid.domNode.id) + " .dgrid-column-" + colId, "width: " + width + ";");
		}

		// keep a reference for future removal
		grid._columnSizes[colId] = rule;
		grid.resize();
		return true;
	}
}

// Functions for shared resizer node

var resizerNode, // DOM node for resize indicator, reused between instances
	resizableCount = 0; // Number of ColumnResizer-enabled grid instances
var resizer = {
	// This object contains functions for manipulating the shared resizerNode
	create: function(){
		resizerNode = put("div.dgrid-column-resizer");
	},
	destroy: function(){
		put(resizerNode, "!");
		resizerNode = null;
	},
	show: function(grid){
		var pos = geom.position(grid.domNode, true);
		resizerNode.style.top = pos.y + "px";
		resizerNode.style.height = pos.h + "px";
		put(document.body, resizerNode);
	},
	move: function(x){
		resizerNode.style.left = x + "px";
	},
	hide: function(){
		resizerNode.parentNode.removeChild(resizerNode);
	}
};

return declare(null, {
	resizeNode: null,
	
	// minWidth: Number
	//		Minimum column width, in px.
	minWidth: 40,
	
	// adjustLastColumn: Boolean
	//		If true, adjusts the last column's width to "auto" at times where the
	//		browser would otherwise stretch all columns to span the grid.
	adjustLastColumn: true,
	
	_resizedColumns: false, // flag indicating if resizer has converted column widths to px
	
	buildRendering: function(){
		this.inherited(arguments);
		
		// Create resizerNode when first grid w/ ColumnResizer is created
		if(!resizableCount++){
			resizer.create();
		}
	},
	
	destroy: function(){
		this.inherited(arguments);
		
		// Remove any applied column size styles since we're tracking them directly
		for(var name in this._columnSizes){
			this._columnSizes[name].remove();
		}
		
		// If this is the last grid on the page with ColumnResizer, destroy the
		// shared resizerNode
		if(!--resizableCount){
			resizer.destroy();
		}
	},
	
	resizeColumnWidth: function(colId, width){
		// Summary:
		//      calls grid's styleColumn function to add a style for the column
		// colId: String
		//      column id
		// width: Integer
		//      new width of the column
		return resizeColumnWidth(this, colId, width);
	},
	
	configStructure: function(){
		var oldSizes = this._oldColumnSizes = lang.mixin({}, this._columnSizes), // shallow clone
			k;
		
		this._resizedColumns = false;
		this._columnSizes = {};
		
		this.inherited(arguments);
		
		// Remove old column styles that are no longer relevant; this is specifically
		// done *after* calling inherited so that _columnSizes will contain keys
		// for all columns in the new structure that were assigned widths.
		for(k in oldSizes){
			if(!(k in this._columnSizes)){
				oldSizes[k].remove();
			}
		}
		delete this._oldColumnSizes;
	},
	
	_configColumn: function(column){
		this.inherited(arguments);
		
		var colId = column.id,
			rule;
		
		if("width" in column){
			// Update or add a style rule for the specified width
			if((rule = this._oldColumnSizes[colId])){
				rule.set("width", column.width + "px");
			}else{
				rule = miscUtil.addCssRule(
					"#" + this.domNode.id + " .dgrid-column-" + colId, "width: " + column.width + "px;");
			}
			this._columnSizes[colId] = rule;
		}
	},
	
	renderHeader: function(){
		this.inherited(arguments);
		
		var grid = this;
		
		var assoc;
		if(this.columnSets && this.columnSets.length){
			var csi = this.columnSets.length;
			while(csi--){
				assoc = lang.mixin(assoc||{}, subRowAssoc(this.columnSets[csi]));
			}
		}else if(this.subRows && this.subRows.length > 1){
			assoc = subRowAssoc(this.subRows);
		}

		var colNodes = query(".dgrid-cell", grid.headerNode),
			i = colNodes.length;
		while(i--){
			var colNode = colNodes[i],
				id = colNode.columnId,
				col = grid.columns[id],
				childNodes = colNode.childNodes;

			if(!col || col.resizable === false){ continue; }

			var headerTextNode = put("div.dgrid-resize-header-container");
			colNode.contents = headerTextNode;

			// move all the children to the header text node
			while(childNodes.length > 0){
				put(headerTextNode, childNodes[0]);
			}

			put(colNode, headerTextNode, "div.dgrid-resize-handle.resizeNode-"+id).columnId = 
				assoc ? assoc[id] : id;
		}

		if(!grid.mouseMoveListen){
			// establish listeners for initiating, dragging, and finishing resize
			listen(grid.headerNode,
				".dgrid-resize-handle:mousedown" +
					(has("touch") ? ",.dgrid-resize-handle:touchstart" : ""),
				function(e){
					grid._resizeMouseDown(e, this);
					grid.mouseMoveListen.resume();
					grid.mouseUpListen.resume();
				}
			);
			grid._listeners.push(grid.mouseMoveListen = listen.pausable(document,
				"mousemove" + (has("touch") ? ",touchmove" : ""),
				miscUtil.throttleDelayed(function(e){ grid._updateResizerPosition(e); })
			));
			grid._listeners.push(grid.mouseUpListen = listen.pausable(document,
				"mouseup" + (has("touch") ? ",touchend" : ""),
				function(e){
					grid._resizeMouseUp(e);
					grid.mouseMoveListen.pause();
					grid.mouseUpListen.pause();
				}
			));
			// initially pause the move/up listeners until a drag happens
			grid.mouseMoveListen.pause();
			grid.mouseUpListen.pause();
		}
	}, // end renderHeader

	_resizeMouseDown: function(e, target){
		// Summary:
		//      called when mouse button is pressed on the header
		// e: Object
		//      mousedown event object
		
		// preventDefault actually seems to be enough to prevent browser selection
		// in all but IE < 9.  setSelectable works for those.
		e.preventDefault();
		dom.setSelectable(this.domNode, false);
		this._startX = this._getResizeMouseLocation(e); //position of the target
		
		this._targetCell = query(".dgrid-column-" + target.columnId, this.headerNode)[0];

		// Show resizerNode after initializing its x position
		this._updateResizerPosition(e);
		resizer.show(this);
	},
	_resizeMouseUp: function(e){
		// Summary:
		//      called when mouse button is released
		// e: Object
		//      mouseup event object
		
		var columnSizes = this._columnSizes,
			colNodes, colWidths, gridWidth;
		
		if(this.adjustLastColumn){
			// For some reason, total column width needs to be 1 less than this
			gridWidth = this.headerNode.clientWidth - 1;
		}
		
		//This is used to set all the column widths to a static size
		if(!this._resizedColumns){
			colNodes = query(".dgrid-cell", this.headerNode);
			
			if(this.columnSets && this.columnSets.length){
				colNodes = colNodes.filter(function(node){
					var idx = node.columnId.split("-");
					return idx[0] == "0" && !(node.columnId in columnSizes);
				});
			}else if(this.subRows && this.subRows.length > 1){
				colNodes = colNodes.filter(function(node){
					return node.columnId.charAt(0) == "0" && !(node.columnId in columnSizes);
				});
			}
			
			// Get a set of sizes before we start mutating, to avoid
			// weird disproportionate measures if the grid has set
			// column widths, but no full grid width set
			colWidths = colNodes.map(function(colNode){
				return colNode.offsetWidth;
			});
			
			// Set a baseline size for each column based on
			// its original measure
			colNodes.forEach(function(colNode, i){
				this.resizeColumnWidth(colNode.columnId, colWidths[i]);
			}, this);
			
			this._resizedColumns = true;
		}
		dom.setSelectable(this.domNode, true);
		
		var cell = this._targetCell,
			delta = this._getResizeMouseLocation(e) - this._startX, //final change in position of resizer
			newWidth = cell.offsetWidth + delta, //the new width after resize
			obj = this._getResizedColumnWidths(),//get current total column widths before resize
			totalWidth = obj.totalWidth,
			lastCol = obj.lastColId,
			lastColWidth = query(".dgrid-column-"+lastCol, this.headerNode)[0].offsetWidth;
		
		if(newWidth < this.minWidth){
			//enforce minimum widths
			newWidth = this.minWidth;
		}
		
		if(resizeColumnWidth(this, cell.columnId, newWidth, e.type)){
			if(cell.columnId != lastCol && this.adjustLastColumn){
				if(totalWidth + delta < gridWidth) {
					//need to set last column's width to auto
					resizeColumnWidth(this, lastCol, "auto", e.type);
				}else if(lastColWidth-delta <= this.minWidth) {
					//change last col width back to px, unless it is the last column itself being resized...
					resizeColumnWidth(this, lastCol, this.minWidth, e.type);
				}
			}
		}
		resizer.hide();
		
		// Clean up after the resize operation
		delete this._startX;
		delete this._targetCell;
	},
	
	_updateResizerPosition: function(e){
		// Summary:
		//      updates position of resizer bar as mouse moves
		// e: Object
		//      mousemove event object

		if(!this._targetCell){ return; } // Release event was already processed
		
		var mousePos = this._getResizeMouseLocation(e),
			delta = mousePos - this._startX, //change from where user clicked to where they drag
			width = this._targetCell.offsetWidth,
			left = mousePos;
		if(width + delta < this.minWidth){ 
			left = this._startX - (width - this.minWidth); 
		}
		resizer.move(left);
	},

	_getResizeMouseLocation: function(e){
		//Summary:
		//      returns position of mouse relative to the left edge
		// e: event object
		//      mouse move event object
		var posX = 0;
		if(e.pageX){
			posX = e.pageX;
		}else if(e.clientX){
			posX = e.clientX + document.body.scrollLeft +
				document.documentElement.scrollLeft;
		}
		return posX;
	},
	_getResizedColumnWidths: function (){
		//Summary:
		//      returns object containing new column width and column id
		var totalWidth = 0,
			colNodes = query(".dgrid-cell", this.headerNode);

		// For ColumnSets and subRows, only the top row of columns matters
		if(this.columnSets && this.columnSets.length){
			colNodes = colNodes.filter(function(node){
				var idx = node.columnId.split("-");
				return idx[1] == "0";
			});
		}else if(this.subRows && this.subRows.length > 1){
			colNodes = colNodes.filter(function(node){
				return node.columnId.charAt(0) == "0";
			});
		}

		var i = colNodes.length;
		if(!i){ return {}; }

		var lastColId = colNodes[i-1].columnId;

		while(i--){
			totalWidth += colNodes[i].offsetWidth;
		}
		return {totalWidth: totalWidth, lastColId: lastColId};
	}
});
});

},
'dgrid/util/mouse':function(){
define(["dojo/on", "dojo/dom", "dojo/query"], function(on, dom){
	function handler(selector, type){
		// summary:
		//		Creates a handler function usable as a simulated event to dojo/on,
		//		which fires only if the mouse is moving into or out of the node of
		//		interest indicated by the selector.
		//		This is similar, but not identical, to what dojo/mouse does.
		// selector: String
		//		Query selector for event delegation.
		// type: String
		//		Event to delegate on (mouseover or mouseout).
		
		return function(node, listener){
			return on(node, selector + ":" + type, function(evt){
				if(!dom.isDescendant(evt.relatedTarget, this)){
					return listener.call(this, evt);
				}
			});
		};
	}
	
	return {
		// Provide enter/leave events for rows, cells, and header cells.
		// (Header row is trivial since there's only one.)
		enterRow: handler(".dgrid-content .dgrid-row", "mouseover"),
		enterCell: handler(".dgrid-content .dgrid-cell", "mouseover"),
		enterHeaderCell: handler(".dgrid-header .dgrid-cell", "mouseover"),
		leaveRow: handler(".dgrid-content .dgrid-row", "mouseout"),
		leaveCell: handler(".dgrid-content .dgrid-cell", "mouseout"),
		leaveHeaderCell: handler(".dgrid-header .dgrid-cell", "mouseout"),
		
		// Also expose the handler function, so people can do what they want.
		createDelegatingHandler: handler
	};
});
},
'url:epi-cms/widget/templates/TrashItemList.html':"﻿<div>\r\n    <div class=\"epi-trashHeader clearfix\">\r\n        <div class=\"epi-gadgetInnerToolbar\" data-dojo-attach-point=\"searchBoxContainer\">\r\n            <div data-dojo-type=\"epi/shell/widget/SearchBox\" data-dojo-attach-point=\"searchBox\"></div>\r\n        </div>\r\n        <span class=\"epi-removedByContainer\">\r\n            <label for=\"removedBy_${id}\">${resources.removedby}</label>\r\n            <select data-dojo-type=\"dijit/form/Select\" data-dojo-attach-point=\"removedBy\" id=\"removedBy_${id}\" data-dojo-attach-event='onChange: _onDeletedByChange'>\r\n            </select>\r\n        </span>\r\n    </div>\r\n    <div data-dojo-attach-point=\"gridContainerNode\"></div>\r\n</div>",
'epi-cms/widget/EmptyTrashMenu':function(){
﻿define([
// Dojo
"dojo/_base/declare",

// Dijit
"dijit/layout/_LayoutWidget",

// EPi Framework
"epi/shell/command/builder/ButtonBuilder",
"epi/shell/command/builder/DropDownButtonBuilder",
"epi/shell/command/builder/MenuAssembler",

// Resources
"epi/i18n!epi/cms/nls/episerver.cms.components.trash"
],

function (
// Dojo
    declare,

// Dijit
    _LayoutWidget,

// EPi Framework
    ButtonBuilder,
    DropDownButtonBuilder,
    MenuAssembler,

// Resources
    resources
    ) {
    // module:
    //      epi-cms/widget/EmptyTrashMenu
    // summary:
    //      A widget to display empty trash button.

    return declare([_LayoutWidget], {
        resources: resources,

        _setCommandsAttr: function (commands) {
            // summary: 
            //      Set empty trash commands.
            // tags:
            //      private

            this._set("commands", commands);
            this._bindEmptyTrashMenu(commands);
        },

        _bindEmptyTrashMenu: function (commands) {
            // summary: 
            //      Bind empty button by empty provider commands with confirmation dialog.
            // tags:
            //      private

            // destroy all old button or menu commands
            this.destroyDescendants();

            if (!commands || commands.length < 1) {
                return;
            }

            var isDropDownButton = commands.length > 1;

            var emptyButton = null;
            //Assemble the menu or button for the available commands
            if (isDropDownButton) {
                emptyButton = new DropDownButtonBuilder({
                    settings: {
                        label: resources.emptytrash.title,
                        dropDownPosition: ["below-alt"] // align dropdown menu open on the left of the button
                    }
                });
            } else {
                emptyButton = new ButtonBuilder({
                    settings: {
                        label: resources.emptytrash.title
                    }
                });

                this.commands[0].label = resources.emptytrash.title;
            }

            new MenuAssembler({ configuration: [{ builder: emptyButton, target: this}], commandSource: this }).build();
        },

        getCommands: function () {
            // summary: 
            //      Get commands with confirmation.
            // tags:
            //      public

            return this.get("commands");
        }
    });
});

},
'epi-cms/widget/TrashViewModelConfirmation':function(){
﻿define([
// Dojo base
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/when",

// Epi Framework
    "epi/dependency",
    "epi/string",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/dialog/Dialog",
    "epi/shell/widget/dialog/Confirmation",
    "epi/shell/widget/dialog/Alert",

// Epi CMS
    "epi-cms/widget/ContentSelectorDialog",
    "epi-cms/contentediting/ContentActionSupport",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.trash"
], function (
// Dojo base
    array,
    declare,
    Deferred,
    lang,
    aspect,
    when,

// Epi Framework
    dependency,
    epistring,
    TypeDescriptorManager,
    Dialog,
    Confirmation,
    Alert,

// Epi CMS
    ContentSelectorDialog,
    ContentActionSupport,

// Resources
    resources
) {

    return function (model) {
        // summary:
        //      Attaches confirmation to the restore method of trash view model

        var _showConfirmation = function (title, description, parentLink) {
            // summary:
            //      Wrap epi.shell.widget.dialog.Confirmation for short type
            //      and return deferred object
            // description:
            //      String : Text to display on dialog
            // parentLink:
            //      Old parent link of specific content
            // tags:
            //		private

            var deferred = new Deferred();

            var dialog = new Confirmation({
                destroyOnHide: true,
                description: epistring.toHTML(description),
                title: epistring.toHTML(title),
                onAction: function (confirmed) {
                    confirmed ? deferred.resolve(parentLink) : deferred.cancel();
                }
            });
            dialog.show();

            return deferred;
        };

        var _showContentSelectorDialog = function (content, roots, description) {
            // summary:
            //      Show contentSelector dialog for User select new parent for content
            // content: [Object]
            //      The specific content
            // roots: [Object]
            //      Root of content provider
            // description: [String]
            //      The text show on title of dialog
            // tags:
            //		private

            var df = new Deferred(),
                dialogResources = resources.restore.dialog,
                containerTypes = TypeDescriptorManager.getValue(content.typeIdentifier, "containerTypes"),
                containedTypes = getContainedTypes(content),
                settings = {
                    showButtons: false,
                    roots: roots,
                    multiRootsMode: true,
                    canSelectOwnerContent: false,
                    allowedTypes: containerTypes || containedTypes,
                    selectedContentType: content.typeIdentifier
                };

            var pageSelector = new ContentSelectorDialog(settings);

            var dialog = new Dialog({
                title: epistring.toHTML(dialogResources.title),
                description: description || epistring.toHTML(dialogResources.description),
                confirmActionText: epistring.toHTML(resources.restore.label),
                content: pageSelector
            });

            var _setStateOkButton = function (value) {
                when(model.contentStore.query({ id: value }), function (selectedContent) {
                    dialog.onActionPropertyChanged({ name: "ok" }, "disabled", !selectedContent);
               });
            };

            // listen for onChange event to enable/disable OK button
            pageSelector.on("change", function (value) {
                if (value) {
                    _setStateOkButton(value);
                }
                else {
                    dialog.onActionPropertyChanged({ name: "ok" }, "disabled", true);
                }
            });

            dialog.on('execute', function () {
                df.resolve(pageSelector.get('value'));
            });
            dialog.on('onHide', function () {
                df.cancel();
            });
            dialog.show();
            // this need to be executed after show, in order to have reference to the button
            // make sure OK button will be disabled on load, since no page has been selected.
            pageSelector.onChange(null);

            return df;
        };

        var _isPermissionValid = function (content, parentContent) {
            // summary:
            //      Check permission of parent content and language permission for content
            // content: [Object]
            //      The content need to restore
            // parentContent: [Object]
            //      The destination parent content
            // tags:
            //      private

            var action = ContentActionSupport.action.Create,
                   createProviderCapability = ContentActionSupport.providerCapabilities.Create,
                   canExecute = parentContent && !(parentContent.isWastebasket || parentContent.isDeleted) &&  // Ensure a parent content is available and it isn't deleted
                               ContentActionSupport.isActionAvailable(parentContent, action, createProviderCapability, true, true);  // Ensure the create action is available to the user on parent node.

            if (!canExecute) {
                var dialog = new Alert({
                    description: epistring.toHTML(resources.restore.userdonothavepermission)
                });
                dialog.show();
                return false;
            }
            return true;
        };

        var _executeRestore = function (model, content, parentLink, isConfirmation, callbackMethod, description) {
            // summary:
            //      Execute restore content to parent
            // model: [Object]
            //      The model of module
            // content: [Object]
            //      The content need to restore
            // parentLink: [Object]
            //      The destination parent content
            // isConfirmation: [Boolean]
            //      The flag to indicator dialog will show
            // callbackMethod: [Function]
            //      The method will execute restore
            // description: [String]
            //      The text show on title of dialog
            // tags:
            //      private

            if (!callbackMethod || !model || !content) {
                return false;
            }
            if (isConfirmation && parentLink) {
                confirmation = _showConfirmation(resources.restore.label, resources.restore.confirmquestion, parentLink);
            }
            else {
                confirmation = _showContentSelectorDialog(content, getRoots(content), description);
            }
            when(confirmation, function (parentLink) {
                when(model.contentStore.get(parentLink), function (parentContent) {
                    if (!_isPermissionValid(content, parentContent)) {
                        return false;
                    }
                    return callbackMethod.apply(model, [content, parentLink]);
                });
            }, function () { return false; });
        };

        var getRoots = function(content) {
            var contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors");
            var roots = [];
            for(var key in contentRepositoryDescriptors) {
                contentRepositoryDescriptors[key].containedTypes.forEach(function(type) {
                    if(TypeDescriptorManager.isBaseTypeIdentifier(content.typeIdentifier, type)){
                        contentRepositoryDescriptors[key].roots.forEach(function(root) {
                            if(roots.indexOf(root) === -1) {
                                roots.push(root);
                            }
                        });
                    }
                });
            }

            return roots;
        };

        var getContainedTypes = function(content) {
            var contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors");
            var containedTypes = [];
            for (var key in contentRepositoryDescriptors) {
                contentRepositoryDescriptors[key].containedTypes.forEach(function(type) {
                    if (TypeDescriptorManager.isBaseTypeIdentifier(content.typeIdentifier, type)) {
                        containedTypes = containedTypes.concat(contentRepositoryDescriptors[key].containedTypes);
                    }
                });
            }

            return containedTypes;
        };

        aspect.around(model, "restore", function (originalMethod) {
            return function (deletingContent, targetLink) {
                var confirmation;

                return when(model.contentStore.query({ id: deletingContent.contentLink }),
                //Success callback
                    lang.hitch(this, function (content) {
                        var description = null;
                        var action = null;

                        if (content.hasOwnProperty("statusCode") && (content.statusCode === 401 || content.statusCode === 403)) {
                            description = epistring.toHTML(resources.restore.userdonothavepermission);
                        }

                        if (content.hasOwnProperty("isDeleted") && !content.isDeleted) {
                            description = epistring.toHTML(resources.restore.contentalreadyrestored);
                            action = function () {
                                model.updateTrash(model.get("currentTrash"));
                            };
                        }

                        if (description) {
                            var dialog = new Alert({
                                description: description,
                                onAction: action
                            });
                            dialog.show();
                            return false;
                        }

                        var currentTrash = model.get("currentTrash");
                        if (content.parentLink != currentTrash.wasteBasketLink) {
                            return when(_showContentSelectorDialog(content, getRoots(content)), function (parentLink) {
                                when(model.contentStore.get(parentLink), function (parentContent) {
                                    if (!_isPermissionValid(content, parentContent)) {
                                        return false;
                                    }
                                    return originalMethod.apply(model, [content, parentLink]);
                                });
                            }, function () { return false; });
                        }
                        else {
                            return when(model.getOldParent(content.contentLink), function (parentContent) {
                                // Restore to old parent of content, otherwise select new destination to restore
                                var parentLink = parentContent ? parentContent.contentLink : null;
                                _executeRestore(model, content, parentLink, parentLink != null, originalMethod);
                            });
                        }
                    }),
                //Error callback
                    lang.hitch(this, function (error) {
                        var dialog = new Alert({
                            description: epistring.toHTML(resources.restore.contentdeletedpermanently),
                            onAction: function () {
                                model.updateTrash(model.get("currentTrash"));
                            }
                        });
                        dialog.show();
                        return false;
                    })
                );
            };
        });

        return model;
    };
});

},
'epi-cms/widget/command/EmptyTrash':function(){
﻿define([
    "dojo/_base/declare",
    "epi/shell/command/_Command"
], function (
    declare,
    _Command
    ) {

    // module:
    //		epi/cms/widget/command/EmptyTrash
    // summary:
    //		A command that empty items in tab container in trash.

    return declare([_Command], {

        // label: [public] String
        //		The action text of the command to be used in visual elements.
        label: null,

        // tooltip: [public] String
        //		The action text of the command to be used in visual elements.
        tooltip: null,

        // trashId: [public] String
        //      The ID of specific trash to empty.
        trashId: null,

        _execute: function () {
            // summary:
            //		Executes this command; publishes a change view request to change to the view trash view.
            // tags:
            //		protected

            if (this.canExecute) {
                this.model.emptyTrash(this.trashId);
            }
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var canExecute = !!this.trashId;
            this.set("canExecute", canExecute);
        }
    });
});
},
'epi-cms/widget/command/RestoreContent':function(){
﻿define([
    "dojo/_base/declare",
    "epi/shell/command/_Command"
], function (
    declare,
    _Command
    ) {

    // module:
    //		epi/cms/widget/command/RestoreContent
    // summary:
    //		Represents a command to restore content in trash, which allows user to select a parent to restore content to.

    return declare([_Command], {
        // content: [public] Object
        //      Represents the current content to be restored.
        content: null,

        _execute: function () {
            // summary:
            //		Executes this command; publishes a change view request to change to the view trash view.
            // tags:
            //		protected

            if (this.canExecute && this.content) {
                this.model.restore(this.content);
            }
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var canExecute = !!this.model;
            this.set("canExecute", canExecute);
        }
    });
});
},
'url:epi-cms/widget/templates/Trash.html':"﻿<div class=\"epi-trash\">\r\n    <div class=\"epi-listingTopContainer\">\r\n        <h1 class=\"dijitInline\">${resources.heading}</h1>\r\n        <div class=\"epi-mediumButton epi-boldButton epi-emptyCommand\" data-dojo-attach-point=\"emptyTrashMenu\" data-dojo-type=\"epi-cms/widget/EmptyTrashMenu\"\r\n            data-dojo-props=\"title: '${resources.emptytrash.tooltip}'\"></div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"stackContainer\">\r\n        <div data-dojo-type=\"dijit/layout/TabContainer\" data-dojo-attach-point=\"tabContainer\" data-dojo-props=\"doLayout:false, useMenu:true, useSlider:false\"> <!-- doLayout=\"false\" for flexible height -->\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/widget/viewmodel/TrashViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/Stateful",
    "dojo/_base/json",

// EPi Framework
    "epi/epi",
    "epi/shell/_StatefulGetterSetterMixin",
    "epi/shell/TypeDescriptorManager",
    "epi/dependency",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.trash"
],

function (
// Dojo
    array,
    declare,
    Deferred,
    lang,
    topic,
    Stateful,
    json,

// EPi Framework
    epi,
    _StatefulGetterSetterMixin,
    TypeDescriptorManager,
    dependency,

// Resources
    resources
    ) {
    return declare([Stateful, _StatefulGetterSetterMixin], {
        // summary:
        //      The view model for trash component widget

        resources: resources,

        // trashes: [List]
        //      List of trash, including system and content provider's trash.
        trashes: null,

        // currentTrash: [Object]
        //      Current active trash to get content from.
        currentTrash: null,

        // queryOptions: [Object]
        //      Query options object, which contains query object and options object, to get content for a specific trash.
        queryOptions: null,

        // isEmptyTrash: [Boolean]
        //      State of Empty Trash action.
        isEmptyTrash: false,

        // storeRegistry: [Object]
        //      The store registry.
        storeRegistry: null,

        // contentStore: [Object]
        //      Represents the REST store to get data.
        contentStore: null,

        // contentStore: [Object]
        //      Represents the REST store to get trashes.
        trashStore: null,

        // showAllLanguages: [bool]
        //      Flag to indicate whether should we get all language for content in trash.
        showAllLanguages: true,

        // _contentRepositoryDescriptors: [Object]
        //      Contains settings for different content repositories, like root and contained types.
        _contentRepositoryDescriptors: null,

        postscript: function () {
            this.inherited(arguments);

            this.storeRegistry = dependency.resolve("epi.storeregistry");

            this.contentStore = this.contentStore || this._getStore();
            this.trashStore = this.trashStore || this.storeRegistry.get("epi.cms.wastebasket");

            this._contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors");

            if (!this.trashes) {
                this._createTrashes();
            }
        },

        destroy: function () {
            epi.removeDelegateAspects(this.contentStore);
        },

        _getStore: function () {
            var store = this.storeRegistry.get("epi.cms.content.light"),
                model = this;
            var hierarchicalStore = epi.delegate(store, {
                // the Tree plugin for dGrid needs these 2 functions to be available in store:
                getChildren: function (parent, options) {
                    var currentTrash = model.get("currentTrash"),
                        queryOptions = model._createQueryOptions(currentTrash);

                    lang.mixin(queryOptions.query, { referenceId: parent.contentLink });
                    return this.query(queryOptions.query, queryOptions.options);
                },

                mayHaveChildren: function (parent) {
                    return parent.hasChildren;
                }
            }, ["notify"]);

            return hierarchicalStore;
        },

        _createTrashes: function () {
            Deferred.when(this.trashStore.query(), lang.hitch(this, function (trashes) {
                this.set("trashes", lang.clone(trashes));
            }));
        },

        _setCurrentTrashAttr: function(trash) {
            // summary:
            //      Sets current trash
            // tags:
            //      private
            this._set("currentTrash", trash);

            if (trash.isRequireLoad) {
                this.updateTrash(trash);
                trash.isRequireLoad = false;
            }
        },

        getEmptyTrashConfirmMessage: function(trashName) {
            // summary:
            //      Get the empty trash confirm message
            // trashName: String
            //      The name of the trash to append to the confirm message if there are more than one provider
            // tags:
            //      public
            var confirmMessage = resources.emptytrash.singleproviderdescription;

            if (this.trashes.length > 1) {
                confirmMessage = resources.emptytrash.description.replace("{0}", trashName);
            }

            return confirmMessage;
        },

        updateTrash: function (trash) {
            // summary: 
            //      Process active trash only, otherwise return empty list.
            // tags:
            //      public

            if (trash && trash.active) {
                this.set("queryOptions", this._createQueryOptions(trash)); // ask widget to update UI, by using this query
            } else {
                this.set("queryOptions", null);
            }
        },

        _createQueryOptions: function (trash) {
            // summary: 
            //      Creates a query options object from input trash.
            // tags:
            //      private

            var query = { referenceId: trash.wasteBasketLink, query: "getchildren" };
            var options = { ignore: ["query"], comparers: this._createComparers() };

            if (this.showAllLanguages) {
                lang.mixin(query, { allLanguages: this.showAllLanguages });
                options.ignore.push("allLanguages");
            }

            if (trash.deletedBy) {
                lang.mixin(query, { deletedBy: trash.deletedBy });
            }

            if (trash.isSearchable) {
                lang.mixin(query, { isSearchable: trash.isSearchable });
                options.ignore.push("isSearchable");
            }

            if (trash.queryText) {
                lang.mixin(query, { query: "searchdeletedcontent" });
                lang.mixin(query, { matchProvider: true });
                lang.mixin(query, { queryText: trash.queryText });
            }

            return { query: query, options: options };
        },

        _createComparers: function () {
            // summary: 
            //      Creates a comparer which check type identifier, to be used in CustomQueryEngine to filter content by type identifier.
            // tags:
            //      private

            return {
                "referenceId": function (required, object) {
                    return required === object.parentLink;
                }
            };
        },

        emptyTrash: function (trashId) {
            // summary:
            //		Delete all items from a specific trash.
            // tags:
            //		public

            if (trashId) {
                Deferred.when(this.trashStore.executeMethod("Empty", trashId), lang.hitch(this, function (response) {
                    // Get all trashes that have specific trash id.
                    var trashes = array.filter(this.get("trashes"), function (trash) { return trash && trash.wasteBasketLink === trashId; });
                    // loop through all affected trashes, turn the isRequireLoad flag to true
                    array.forEach(trashes, function (trash) {
                        trash.deletedByUsers = [];
                        trash.isRequireLoad = true;
                        trash.deletedByUsers = [];
                    });
                    this.isEmptyTrash = true;
                    topic.publish("/epi/cms/trash/empty", response.extraInformation);

                    // let's refresh the data of current trash now 
                    if (this.currentTrash.wasteBasketLink === trashId) {
                        this.set("currentTrash", this.currentTrash);
                    }

                    // ask UI to show alert message if needed
                }), lang.hitch(this, function (response) {
                    if (response.status === 403) {
                        this.set("actionResponse", resources.emptytrash.accessdenied);
                    }
                }
                ));
            }
        },

        restore: function (sourceContent, targetLink) {
            // summary:
            //		Restore content from a specific trash to specific content.
            //  source: Content
            //      The content source to restore
            // targetLink: ContentLink
            //      The target link to restore
            // tags:
            //		public

            if (sourceContent && sourceContent.contentLink && sourceContent.isDeleted && targetLink) {
                Deferred.when(this.contentStore.move(sourceContent.contentLink, { targetId: targetLink }), lang.hitch(this, function (response) {
                    if (response) {
                        //TODO: We shouldn't have to do a refresh here
                        this.contentStore.refresh(sourceContent.contentLink);
                        // Refresh parent in order to show expand/collapse icon correctly
                        // and then refresh current trash.
                        if (sourceContent.parentLink != this.currentTrash.wasteBasketLink) {
                            this.contentStore.refresh(sourceContent.parentLink).then(lang.hitch(this, function () {
                                this.updateTrash(this.currentTrash);
                            }));
                        }

                        //TODO: This is just pure luck that it works, we should wait for the prommise to resolve
                        var destination = this.contentStore.get(targetLink);
                        if (destination && !destination.hasChildren) {
                            this.contentStore.refresh(targetLink).then(function (newParent) {
                                topic.publish("/epi/cms/contentdata/restored", newParent);
                            });
                        }
                    }
                }), lang.hitch(this, function (response) {
                    this.set("actionResponse", response.xhr ? json.fromJson(response.xhr.responseText) : resources.restore.error);
                }));
            }
        },

        getOldParent: function (contentLink) {
            // summary:
            //		Get old parent of specific contentLink.
            // tags:
            //		public

            var df = new Deferred();
            Deferred.when(this.contentStore.query({ referenceId: contentLink, query: 'getrestorepoint', allLanguages: true }), function (parentContent) {
                var parent = parentContent && lang.isArray(parentContent) && parentContent.length > 0 ? parentContent[0] : null;
                df.resolve(parent);
            });

            return df;
        }
    });
});


},
'epi-cms/component/Versions':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/on",
    "dojo/string",
    "dojo/topic",
    "dojo/when",
    "dojox/html/entities",

// DGrid
    "dgrid/OnDemandGrid",
    "dgrid/Selection",

// EPi Framework
    "epi",
    "epi/dependency",
    "epi/username",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/command/_WidgetCommandProviderMixin",
    "epi/shell/command/withConfirmation",
    "epi/shell/widget/_FocusableMixin",
    "epi/shell/widget/Tooltip",
    "epi/shell/widget/dialog/Alert",
    "epi/shell/widget/dialog/Confirmation",

// EPi CMS
    "epi-cms/_MultilingualMixin",
    "epi-cms/ApplicationSettings",
    "epi-cms/core/ContentReference",
    "epi-cms/component/command/DeleteVersion",
    "epi-cms/component/command/DeleteLanguageBranch",
    "epi-cms/component/command/SetCommonDraft",
    "epi-cms/command/ShowAllLanguages",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/widget/_GridWidgetBase",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.versions"

], function (
// Dojo
    array,
    declare,
    lang,
    connect,
    aspect,
    domClass,
    on,
    string,
    topic,
    when,
    entities,

// DGrid
    OnDemandGrid,
    Selection,

// EPi Framework
    epi,
    dependency,
    username,
    TypeDescriptorManager,
    _WidgetCommandProviderMixin,
    withConfirmation,
    _FocusableMixin,
    Tooltip,
    Alert,
    Confirmation,

// EPi CMS
    _MultilingualMixin,
    ApplicationSettings,
    ContentReference,
    DeleteVersion,
    DeleteLanguageBranch,
    SetCommonDraft,
    ShowAllLanguagesCommand,
    ContentActionSupport,
    _GridWidgetBase,

// Resources
    resources
) {

    // module:
    //		epi-cms/component/Versions
    // summary:
    //		This component will list all versions of a content item.
    return declare([_GridWidgetBase, _WidgetCommandProviderMixin, _FocusableMixin, _MultilingualMixin], {

        // showAllLanguages: [readonly] Boolean
        //		Flag which indicates whether to show all languages. Value is true if all languages should be shown; otherwise false.
        showAllLanguages: true,

        // isMultilingual:  Boolean
        //		Flag which indicates whether the Show All Languages command should be enabled or disabled, based on Read access right and the number of available languages.
        isMultilingual: false,

        _tooltips: [],
        postMixInProperties: function () {
            // summary:
            //		Called after constructor parameters have been mixed-in; sets default values for parameters that have not been initialized.
            // tags:
            //		protected

            this._commonDrafts = {};

            this.storeKeyName = "epi.cms.contentversion";
            this.ignoreVersionWhenComparingLinks = false;

            this.inherited(arguments);

            this._currentContentLanguage = ApplicationSettings.currentContentLanguage;
            this.connect(this.store, "onItemChanged", "_onItemChanged");

            var registry = dependency.resolve("epi.storeregistry");
            this._contentStore = registry.get("epi.cms.contentdata");
        },

        buildRendering: function () {
            // summary:
            //		Construct the UI for this widget with this.domNode initialized as a dgrid.
            // tags:
            //		protected

            this.inherited(arguments);

            var customGridClass = declare([OnDemandGrid, Selection]);
            this.grid = new customGridClass({
                columns: {
                    language: { label: epi.resources.header.language },
                    statusName: {
                        label: epi.resources.header.status,
                        renderCell: function (item, value, node, options) {
                            var html = item.statusName;
                            if (item.isCommonDraft) {
                                html = '<span class="dijitReset dijitInline dijitIcon epi-iconPrimary epi-floatRight"></span>' + item.statusName;
                            }
                            node.innerHTML = html;
                        }
                    },
                    savedDate: {
                        label: epi.resources.header.saved,
                        formatter: this._localizeDate
                    },
                    savedBy: {
                        label: epi.resources.header.by,
                        formatter: this._createUserFriendlyUsername
                    }
                },
                store: this.store,
                selectionMode: "single",
                selectionEvents: "click,dgrid-cellfocusin",
                sort: [{ attribute: "savedDate", descending: true }]
            }, this.domNode);
        },

        postCreate: function () {
            this.add("commands", new ShowAllLanguagesCommand({ model: this }));

            this._commonDraftCommand = new SetCommonDraft();
            this._deleteVersionCommand = new DeleteVersion();
            this._deleteLanguageBranchCommand = new DeleteLanguageBranch();

            this.own(aspect.after(this._commonDraftCommand, "execute", lang.hitch(this, function (deferred) {
                    deferred.then(null, lang.hitch(this, this._onSetCommonDraftFailure));
                })),
                // Refresh after delete successfully
                aspect.after(this._deleteVersionCommand, "execute", lang.hitch(this, function (deferred) {
                    deferred.then(lang.hitch(this, this._onDeleteVersionSuccess), lang.hitch(this, this._onDeleteVersionFailure));
                })),
                aspect.after(this._deleteLanguageBranchCommand, "execute", lang.hitch(this, function (deferred) {
                    deferred.then(lang.hitch(this, this._onDeleteVersionSuccess), lang.hitch(this, this._onDeleteVersionFailure));
            })));

            this.add("commands", this._commonDraftCommand);
            this.add("commands", withConfirmation(this._deleteVersionCommand, null, {
                title: resources.deletemenuitemtitle,
                heading: resources.deleteversion.note,
                description: resources.deleteversion.confirmquestion
            }));

            this._deleteLanguageBranchSettings = {
                cancelActionText: epi.resources.action.cancel,
                setFocusOnConfirmButton: false
            };
            this.add("commands", withConfirmation(this._deleteLanguageBranchCommand, null, this._deleteLanguageBranchSettings));
        },

        startup: function () {
            // summary: Overridden to connect a store to a DataGrid.

            if (this._started) {
                return;
            }

            this.inherited(arguments);

            this.own(aspect.around(this.grid, "renderRow", lang.hitch(this, this._aroundRenderRow)));

            this._toggleLanguage(this.showAllLanguages);
            this.fetchData();
        },

        _setShowAllLanguagesAttr: function (value) {
            this._set("showAllLanguages", value);
            this._toggleFilterByLanguage(value);
        },

        destroy: function () {
            this.inherited(arguments);
            this._destroyTooltips();
        },

        _onItemChanged: function () {
            // summary:
            //      Fetches new data when an item is changed in the store.
            // tags:
            //      private

            //We force a new get when a value has changed in the store, otherwise we might have several commondrafts
            this.fetchData();
        },

        fetchData: function () {
            // summary:
            //		Updates the grid with the new data.
            // tags:
            //		private

            when(this.getCurrentContent(), lang.hitch(this, function (item) {
                if (!item) {
                    return;
                }
                this._destroyTooltips();

                if (item.accessMask && !ContentActionSupport.hasAccess(item.accessMask, ContentActionSupport.accessLevel.Edit) ||
                    item.providerCapabilityMask && !ContentActionSupport.hasProviderCapability(item.providerCapabilityMask, ContentActionSupport.providerCapabilities.Edit)) {
                    this._showErrorMessage(epi.resources.messages.nopermissiontoviewdata);
                    this.set("isMultilingual", false); // disable Show All Language command since user does not have access right to view data
                    this._updateMenu(item);
                    return;
                }
                var query = { contentLink: item.contentLink };
                if (!this._allLanguages) {
                    query.language = this._currentContentLanguage;
                }
                this.grid.set("query", query);

                // enable Show All Language command
                this.set("isMultilingual", true);
            }));
        },

        _destroyTooltips: function () {
            // summary:
            //  destroy all tooltips
            array.forEach(this._tooltips, function (tooltip) {
                tooltip.destroyRecursive();
            });
            this._tooltips = [];
        },

        _aroundRenderRow: function (original) {
            // summary:
            //		Called 'around' the renderRow method in order to add a class which indicates published state.
            // tags:
            //		private

            return lang.hitch(this, function (item) {
                // If item is a common draft add it to the hash map.
                if (item.isCommonDraft) {
                    var common = this._commonDrafts[item.language];
                    if (common && common != item.contentLink) {
                        this._removeCommonDraft(common);
                    }
                    this._commonDrafts[item.language] = item.contentLink;
                }

                // Call original method
                var row = original.apply(this.grid, arguments);

                // Add state specific classes
                domClass.toggle(row, "dgrid-row-published", item.status === ContentActionSupport.versionStatus.Published);

                // Create the tooltip for this item row.
                this._createTooltip(item, row);

                return row;
            });
        },

        _onSelect: function (e) {
            var item = e.rows[0].data;

            this._updateMenu(item);

            this.inherited(arguments);
        },

        _updateMenu: function (item) {
            this._commonDraftCommand.set("model", item);
            this._deleteVersionCommand.set("model", item);

            when(this._contentStore.get(item.contentLink), lang.hitch(this, function (content) {
                if (content && content.currentLanguageBranch) {
                    var heading = lang.replace(resources.deletelanguagebranch.label, [content.currentLanguageBranch.name]),
                        description = TypeDescriptorManager.getResourceValue(content.typeIdentifier, "deletelanguagebranchdescription");

                    lang.mixin(this._deleteLanguageBranchSettings, {
                        confirmActionText: heading,
                        description: lang.replace(description, [entities.encode(content.name), content.currentLanguageBranch.name]),
                        title: heading
                    });
                    this._deleteLanguageBranchCommand.set("label", heading);
                }

                this._deleteLanguageBranchCommand.set("model", content);
            }));
        },

        _showNotificationMessage: function (notification) {
            // summary:
            //     Show a notification message
            // notification:
            //     The notification message
            var dialog = new Alert({
                title: resources.notificationtitle,
                description: notification
            });
            dialog.show();
        },

        _selectCommonDraftVersion: function (uri) {
            // summary:
            //      Selects the published page version ins the list.
            // tags:
            //      private

            var contextParameters = { uri: uri };
            topic.publish("/epi/shell/context/request", contextParameters, { sender: null });
        },

        _onDeleteVersionSuccess: function () {
            // summary:
            //      Update the current context and display notification.
            // tags:
            //      private

            var contentLink = new ContentReference(this.grid.get("query").contentLink);

            this._selectCommonDraftVersion("epi.cms.contentdata:///" + contentLink.createVersionUnspecificReference().toString());
        },

        _onDeleteVersionFailure: function (response) {
            // summary:
            //      Display alert with the delete failure message.
            // tags:
            //      private

            //If the user clicks cancel in the confirmation dialog we will end up here
            if (!response || !response.status) {
                return;
            }
            else if (response.status === 403) {
                this._showNotificationMessage(resources.deleteversion.cannotdeletepublished);
            } else {
                this._showNotificationMessage(resources.deleteversion.cannotdelete);
            }
        },

        _onSetCommonDraftFailure: function () {
            // summary:
            //      Display notification in the UI of failure.
            // tags:
            //      private

            this._showNotificationMessage(resources.setcommondraft.failuremessage);
        },

        _removeCommonDraft: function (reference) {
            // Refresh the previous common draft item, as it might be changed on the server side.
            if (reference) {
                var item = this.grid.row(reference).data;
                if (item) {
                    item.isCommonDraft = false;
                }
            }
        },

        _toggleFilterByLanguage: function (showAll) {
            // summary:
            //      handles filterByLanguage event.
            // tags:
            //      private
            // sender:
            //      the page version widget that triggers the filterByLanguage event

            when(this.getCurrentContext(), lang.hitch(this, function (currentContext) {
                var query = { contentLink: currentContext.id };

                if (!showAll) {
                    query.language = this._currentContentLanguage;
                }

                this._toggleLanguage(showAll);
                this.grid.set("query", query);

                this._allLanguages = showAll;
            }));
        },

        _toggleLanguage: function (visible) {
            // summary:
            //		Toggles the visibility of the language column.
            // tags:
            //		private

            var value = visible ? "table-cell" : "none";

            this.grid.styleColumn("language", string.substitute("display:${0};", [value]));
        },

        _createTooltip: function (item, row) {
            // summary:
            //    Binds the mouseover and mouseout events to show and hide a tooltip for the row item.
            // tags:
            //    private

            var tooltipRows = [
                {
                    label: epi.resources.header.language,
                    text: epi.resources.language[item.language]
                },
                {
                    label: epi.resources.header.name,
                    text: item.name
                },
                {
                    label: epi.resources.header.status,
                    text: ContentActionSupport.getVersionStatus(item.status)
                },
                {
                    label: resources.saved,
                    text: this._localizeDate(item.savedDate),
                    htmlEncode: false
                },
                {
                    label: resources.by,
                    text: username.toUserFriendlyString(item.savedBy, null, true)
                }
            ];

            var tooltip = new Tooltip({
                connectId: row,
                tooltipRows: tooltipRows
            });
            this._tooltips.push(tooltip);
        }
    });
});

},
'epi-cms/component/command/DeleteVersion':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/dependency",
    "epi/i18n!epi/cms/nls/episerver.cms.components.versions",
    "epi/shell/command/_Command"
], function (declare, lang, when, ApplicationSettings, ContentActionSupport, dependency, resources, _Command) {

    // module:
    //		epi-cms/component/command/DeleteVersion
    // summary:
    //		A command which deletes the current version when executed.

    return declare([_Command], {

        // label: [public] String
        //		The action text of the command to be used in visual elements.
        label: resources.deletemenuitemtitle,

        // iconClass: [public] String
        //		The icon class of the command to be used in visual elements.
        iconClass: "epi-iconTrash",

        // category: [readonly] String
        //		A category which provides a hint about how the command could be displayed.
        category: "context",

        postscript: function () {
            // summary:
            //		Constructs the object and sets up the reference to the content data and version stores.
            // tags:
            //		public

            this.inherited(arguments);

            this.storeRegistry = this.storeRegistry || dependency.resolve("epi.storeregistry");

            this._content = this.storeRegistry.get("epi.cms.contentdata");
            this._versions = this.storeRegistry.get("epi.cms.contentversion");
        },

        _execute: function () {
            // summary:
            //		Executes this command assuming canExecute has been checked.
            // tags:
            //		protected

            return this._versions.remove(this.model.contentLink);
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            if (ApplicationSettings.disableVersionDeletion) {
                this.set("isAvailable", false);
                return;
            }


            this.set("isAvailable", true);

            if (!this.model.allowToDelete) {
                this.set("canExecute", false);
                return;
            }

            when(this._content.get(this.model.contentLink), lang.hitch(this, function (content) {

                var action = ContentActionSupport.action,
                hasSufficientAccessRight = content && ContentActionSupport.isActionAvailable(content, action.Delete);

                this.set("canExecute", hasSufficientAccessRight);
            }));
        }
    });
});
},
'epi-cms/component/command/DeleteLanguageBranch':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "epi/dependency",
    "epi/shell/command/_Command",
    "epi-cms/_MultilingualMixin",
    "epi-cms/ApplicationSettings",
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentActionSupport"
], function (
    declare,
    lang,
    when,
    dependency,
    _Command,
    _MultilingualMixin,
    ApplicationSettings,
    ContentReference,
    ContentActionSupport
) {

    // module:
    //		epi/cms/component/command/DeleteLanguageBranch
    // summary:
    //		A command which deletes all versions belonging to a language branch when executed.

    return declare([_Command, _MultilingualMixin], {

        // label: [public] String
        //		The action text of the command to be used in visual elements.
        label: "",

        // iconClass: [public] String
        //		The icon class of the command to be used in visual elements.
        iconClass: "",

        // category: [readonly] String
        //		A category which provides a hint about how the command could be displayed.
        category: "context",

        postscript: function () {
            // summary:
            //		Constructs the object and sets up the reference to the content data and version stores.
            // tags:
            //		public

            this.inherited(arguments);

            this.storeRegistry = this.storeRegistry || dependency.resolve("epi.storeregistry");

            this._versions = this.storeRegistry.get("epi.cms.contentversion");
            this._structure = this.storeRegistry.get("epi.cms.content.light");
        },

        _execute: function () {
            // summary:
            //		Executes this command assuming canExecute has been checked.
            // tags:
            //		protected

            var reference = ContentReference.toContentReference(this.model.contentLink);

            return when(this._versions.remove(reference, { deleteLanguageBranch: true }), lang.hitch(this, function () {
                // TODO: Make sure all stores that can have deleted version gets notitifed.
                return this._structure.refresh(reference.id);
            }));
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var model = this.model,

                isAvailable = !!(model && model.currentLanguageBranch && model.capabilities.deleteLanguageBranch &&
                    !ApplicationSettings.disableVersionDeletion),

                canExecute = isAvailable && !model.currentLanguageBranch.isMasterLanguage &&
                    ContentActionSupport.isActionAvailable(model, ContentActionSupport.action.Delete);

            this.set("canExecute", canExecute);
            this.set("isAvailable", isAvailable);
        }
    });
});

},
'epi-cms/component/command/SetCommonDraft':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/contentediting/ContentActionSupport",
    "epi/dependency",
    "epi/i18n!epi/cms/nls/episerver.cms.components.versions",
    "epi/shell/command/_Command"
], function (declare, ContentActionSupport, dependency, resources, _Command) {

    // module:
    //		epi/cms/component/command/SetCommonDraft
    // summary:
    //		A command which sets the current version as the common draft when executed.

    return declare([_Command], {

        // label: [public] String
        //		The action text of the command to be used in visual elements.
        label: resources.setcommondraftitemtitle,

        // iconClass: [public] String
        //		The icon class of the command to be used in visual elements.
        iconClass: "epi-iconPrimary",

        // category: [readonly] String
        //		A category which provides a hint about how the command could be displayed.
        category: "context",

        constructor: function () {
            // summary:
            //		Constructs the object and sets up the reference to the content version store.
            // tags:
            //		public

            var registry = dependency.resolve("epi.storeregistry");
            this.store = registry.get("epi.cms.contentversion");
        },

        _execute: function () {
            // summary:
            //		Executes this command assuming canExecute has been checked.
            // tags:
            //		protected

            var self = this;

            //Patch the object in the store
            return this.store.patch({ isCommonDraft: true, contentLink: this.model.contentLink }, { id:this.model.contentLink })
                .then(function(item){
                    return self.store.patchCache(item);
                });
        },

        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            var model = this.model,
                status = ContentActionSupport.versionStatus,
                canExecute = model && !model.isCommonDraft && (model.status == status.CheckedOut || model.status == status.Rejected);

            this.set("canExecute", canExecute);
        }
    });
});
},
'epi-cms/contentediting/_Renderer':function(){
﻿define([
"epi",
"dojo"],

function (epi, dojo) {

    return dojo.declare(null, {
        // summary:
        //    Base class for rendering a content block.
        // tags:
        //    abstract

        constructor: function (params) {
            dojo.mixin(this, params);
        },

        render: function (contentLink, propertyName, propertyValue, renderSettings) {
            // summary:
            //    Render a content block using render manager's implementation or its own implementation
            //
            // value: String
            //    The node value.
            //
            // tags:
            //    public, abstract

            throw new Error("Abstract method _render must be overridden in a derived class");
        }
    });

});
},
'epi-cms/contentediting/ContentDetails':function(){
﻿define([
// Dojo
    "dojo",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/url",
    "dojo/_base/window",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/on",
    "dojo/topic",

// Dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "dijit/_WidgetsInTemplateMixin",

// EPi
    "epi",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/command/builder/MenuBuilder",
    "epi/shell/command/builder/MenuAssembler",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.contentdetails",
    "dojo/text!./templates/ContentDetails.html"

], function (
// Dojo
    dojo,
    array,
    declare,
    lang,
    url,
    win,
    domStyle,
    domConstruct,
    on,
    topic,

// Dijit
    _TemplatedMixin,
    _WidgetBase,
    _WidgetsInTemplateMixin,

// EPi
    epi,
    _ModelBindingMixin,
    MenuBuilder,
    MenuAssembler,

// Resources
    res,
    template
) {

    // module:
    //		epi-cms/contentediting/ContentDetails
    // summary:
    //		Displays extra information about the page. This information includes
    //		page type, ID, created date, changed date and who made the changes.

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {

        // templateString: [protected] String
        //		A string that represents the widget template.
        templateString: template,

        // Attributes and mappings
        _setContentTypeNameAttr: { node: "typeNode", type: "innerHTML" },

        _setContentIdAttr: { node: "idNode", type: "innerHTML" },

        _setExistingLanguagesAttr: function (languages) {
            this.languagesNode.innerHTML = "";

            // Create text or link elements base on language information.
            array.forEach(languages, function (item, idx) {
                var elm, isLast = idx === languages.length - 1;
                if (item.isCurrentLanguage) {
                    elm = domConstruct.create("span", {
                        innerHTML: item.urlSegment
                    });
                } else {
                    var url = new dojo._Url(window.top.location.href);
                    elm = domConstruct.create("a", {
                        innerHTML: item.urlSegment,
                        href: [url.scheme, "://", url.authority, url.path, "?language=", item.text, "#context=epi.cms.contentdata:///", item.contentLink].join(""),
                        "class": "epi-visibleLink"
                    });
                }
                domConstruct.place(elm, this.languagesNode);

                if (!isLast) {
                    domConstruct.place(win.doc.createTextNode(", "), this.languagesNode);
                }
            }, this);
        },

        _setVisibleToAttr: function(visibleToEveryOne) { 
            this.visibleToNode.innerHTML = visibleToEveryOne ? res.visibleto.everyone : res.visibleto.restricted;
        },

        _setManageAccessRightsVisibleAttr: function (value) {
            domStyle.set(this.manageAccessRightsButton.domNode, "display", value ? "" : "none");
        },

        // resources: [readonly] Object
        //		The localization resource for the label headers.
        resources: null,

        modelBindingMap: {
            "contentTypeName": ["contentTypeName"],
            "contentId": ["contentId"],
            "existingLanguages": ["existingLanguages"],
            "visibleToEveryOne": ["visibleTo"]
        },

        _menuAssembler: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            this.resources = dojo.mixin({}, epi.resources.action, res);
        },

        postCreate: function () {
            this.inherited(arguments);

            var builder = new MenuBuilder();
            this._menuAssembler = new MenuAssembler({ configuration: [{ builder: builder, target: this.additionalActionsMenu }], commandSource: this.model });

            this.dropdownButton.set("title", this.resources.toolsbutton.tooltip);
        },

        destroy: function () {
            if (this._menuAssembler) {
                this._menuAssembler.destroy();
            }

            this.inherited(arguments);

            if (this.model) {
                this.model.destroy();
            }
        },

        _setModelAttr: function (value) {

            this.inherited(arguments);

            if (this._menuAssembler) {
                this._menuAssembler.set("commandSource", this.model);
            }

            if (this.model && this.model.accessRightsCommand) {
                this.own(this.model.accessRightsCommand.watch("canExecute", lang.hitch(this, function () {
                    // Manage links visibility
                    this.set("manageAccessRightsVisible", this.model.accessRightsCommand.canExecute);
                })));
            }
        },

        _onManageAccessRightsClick: function () {
            if (this.model && this.model.accessRightsCommand) {
                this.model.accessRightsCommand.execute();
            }
        }
    });
});

},
'url:epi-cms/contentediting/templates/ContentDetails.html':"﻿<div class=\"epi-containerLayout\">\r\n    <ul>\r\n        <li class=\"epi-formsRow\">\r\n            <label>${resources.visibleto.title}</label>\r\n            <div class=\"epi-formsWidgetWrapper\">\r\n                <span data-dojo-attach-point=\"visibleToNode\" class=\"dijitInline\"></span>\r\n                <div data-dojo-type=\"dijit/form/Button\" data-dojo-attach-point=\"manageAccessRightsButton\" data-dojo-attach-event=\"onClick: _onManageAccessRightsClick\" class=\"epi-chromelessButton epi-chromelessLinkButton epi-functionLink epi-valign--top\">${resources.manage}</div>\r\n            </div>\r\n        </li>\r\n        <li class=\"epi-formsRow\">\r\n            <label>${resources.existinglanguages}</label>\r\n            <div class=\"epi-formsWidgetWrapper\">\r\n                <span data-dojo-attach-point=\"languagesNode\" class=\"dijitInline\"></span>\r\n            </div>\r\n        </li>\r\n        <li class=\"epi-formsRow\">\r\n            <label>${resources.idandtypename}</label> \r\n            <div class=\"epi-formsWidgetWrapper\">\r\n                <span data-dojo-attach-point=\"idNode\" class=\"dijitInline\"></span>, <span data-dojo-attach-point=\"typeNode\" class=\"dijitInline\"></span>\r\n            </div>\r\n        </li>\r\n        <li class=\"epi-formsRow\">\r\n            <label></label>\r\n            <div class=\"epi-formsWidgetWrapper\">\r\n                <div data-dojo-attach-point=\"dropdownButton\" data-dojo-type=\"dijit/form/DropDownButton\" class=\"dijit dijitReset dijitInline epi-mediumButton\">\r\n                    <span>${resources.toolsbutton.label}</span>\r\n                    <div data-dojo-type=\"dijit/DropDownMenu\" data-dojo-attach-point=\"additionalActionsMenu\"></div>\r\n                </div>\r\n            </div>\r\n        </li>\r\n    </ul>\r\n</div>",
'epi-cms/contentediting/CreateContent':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/topic",
    "dojo/when",

// dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

    "dijit/form/ValidationTextBox",

    "dijit/layout/_LayoutWidget",
    "dijit/layout/BorderContainer",
    "dijit/layout/ContentPane",
    "dijit/layout/StackContainer",

// epi
    "epi/dependency",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/dialog/Dialog",

    "epi-cms/contentediting/NewContentNameInputDialog",

    "epi-cms/contentediting/viewmodel/CreateContentViewModel",

    "epi-cms/widget/ContentTypeList",
    "epi-cms/widget/PropertiesForm",
    "epi-cms/widget/Breadcrumb",
    "epi-cms/widget/BreadcrumbCurrentItem",

// resources
    "dojo/text!./templates/CreateContent.html",
    "epi/i18n!epi/nls/episerver.shared"
],

function (
// dojo
    declare,
    lang,
    aspect,
    domStyle,
    domClass,
    topic,
    when,

// dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

    ValidationTextBox,

    _LayoutWidget,
    BorderContainer,
    ContentPane,
    StackContainer,

// epi
    dependency,
    _ModelBindingMixin,
    Dialog,

    NewContentNameInputDialog,

    CreateContentViewModel,

    ContentTypeList,
    PropertiesForm,
    BreadCrumbs,
    BreadcrumbCurrentItem,

// resources
    template,
    sharedResources
) {

    // module:
    //      epi-cms/contentediting/CreateContent
    // summary:
    //      A stack container that acts as a content creation wizard.
    // description:
    //      A wizard-like widget that is responsible for showing the widget for
    //      selecting a content type, then determines whether content editing or the
    //      mandatory fields editor is displayed.
    // tags:
    //      public

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin], {

        templateString: template,
        sharedResources: sharedResources,

        modelType: CreateContentViewModel,

        // _contextService: [private] epi/shell/ContextService
        _contextService: null,

        // _beingSuspended: [private] boolean
        //      Indicate that the component is being suspended and another view component is being requested.
        _beingSuspended: null,

        modelBindingMap: {
            "parent": ["parent"],
            "requestedType": ["requestedType"],
            "metadata": ["metadata"],
            "isContentTypeSelected": ["isContentTypeSelected"],

            "headingText": ["headingText"],
            "createAsLocalAssetHelpText": ["createAsLocalAssetHelpText"],
            "contentName": ["contentName"],
            "wizardStep": ["wizardStep"],
            "showAllProperties": ["showAllProperties"],
            "createAsLocalAsset": ["createAsLocalAsset"],

            "seamlessTopPanel": ["seamlessTopPanel"],
            "namePanelIsVisible": ["namePanelIsVisible"],
            "headingPanelIsVisible": ["headingPanelIsVisible"],
            "saveButtonIsVisible": ["saveButtonIsVisible"],
            "saveButtonDisabled": ["saveButtonDisabled"],
            "showCurrentNodeOnBreadcrumb": ["showCurrentNodeOnBreadcrumb"],
            "notificationContext": ["notificationContext"],
            "actualParentLink": ["actualParentLink"],
            "propertyFilter": ["propertyFilter"]
        },

        // Setters
        _setParentAttr: function (parent) {
            // summary:
            //      set parent attribute
            // tags:
            //      private

            if (parent) {
                this.toolbar.setItemProperty("currentcontent", "currentItemInfo", {
                    name: parent.name,
                    dataType: parent.typeIdentifier
                });
            }
        },

        _setPropertyFilterAttr: function (propertyFilter) {
            // summary:
            //      Set the property filter used when building the property form
            // tags:
            //      private

            this._set("propertyFilter", propertyFilter);
            this.propertiesForm.propertyFilter = propertyFilter;
        },

        _setRequestedTypeAttr: function (requestType) {
            // summary:
            //      set requested type attribute
            // tags:
            //      private

            this.contentTypeList.set("requestedType", requestType);
        },

        _setMetadataAttr: function (metadata) {
            // summary:
            //      set metadata attribute
            // tags:
            //      private

            if (metadata) {
                this.propertiesForm.set("metadata", metadata);
            }
        },

        _setHeadingTextAttr: function (headingText) {
            // summary:
            //      set heading text attribute
            // tags:
            //      private

            this.headingTextNode.innerHTML = this.subHeadingTextNode.innerHTML = headingText;
        },

        _setCreateAsLocalAssetAttr: function (/*Boolean*/createAsLocalAsset) {
            // summary:
            //      Reset breadcrumb in case createAsLocalAsset had updated its value
            // createAsLocalAsset: [Boolean]
            //      TRUE if a new content will be create as a local asset
            // tags:
            //      private

            this._set("createAsLocalAsset", createAsLocalAsset);

            var parent = this.model.get("parent");
            if (parent) {
                this.toolbar.setItemProperty("breadcrumbs", "contentLink", createAsLocalAsset && this.model.canChangeLocalAssetName ? parent.assetsFolderLink : parent.contentLink);
            }
        },

        _setCreateAsLocalAssetHelpTextAttr: {
            // summary:
            //      set sub heading's help text
            // tags:
            //      private

            node: "subHeadingDescNode",
            type: "innerHTML"
        },

        _setContentNameAttr: function (contentName) {
            // summary:
            //      set content name attribute
            // tags:
            //      private

            this.nameTextBox.set("value", contentName);
        },

        _setWizardStepAttr: function (wizardStep) {
            // summary:
            //      set wizard step attribute
            // tags:
            //      private

            // NOTE: this check should probably be done in the viewmodel, but we have no
            // value there that tells us how many wizard steps are available. This check
            // ensures we don't try to select outside the bounds

            var children;
            var child;

            if (wizardStep < 0 || wizardStep === this.wizardStep) {
                return;
            }

            children = this.stackContainer.getChildren();

            if (wizardStep < children.length) {

                child = children[wizardStep];

                this.stackContainer.selectChild(child);
                this._set("wizardStep", wizardStep);
            }
        },

        _setShowAllPropertiesAttr: function (showAllProperties) {
            // summary:
            //      set show all properties attribute
            // tags:
            //      private

            this._set("showAllProperties", showAllProperties);
            this.propertiesForm.set("showAllProperties", showAllProperties);
        },

        _setSeamlessTopPanelAttr: function (value) {
            // summary:
            //      set whether the top panel should show seamlessly.
            // tags:
            //      private

            domClass.toggle(this.topPanel.domNode, "epi-listingTopContainer", value);
        },

        _setNamePanelIsVisibleAttr: function (isVisible) {
            // summary:
            //      set name panel visibility
            // tags:
            //      private

            domStyle.set(this.namePanel, "display", isVisible ? "" : "none");
        },

        _setHeadingPanelIsVisibleAttr: function (isVisible) {
            // summary:
            //      set heading panel visibility
            // description:
            //      If the heading panel is visible, the sub heading panel will be invisible and vice versa.
            // tags:
            //      private

            domStyle.set(this.headingPanel, "display", isVisible ? "" : "none");
            domStyle.set(this.subHeadingPanel, "display", isVisible ? "none" : "");
        },

        _setSaveButtonIsVisibleAttr: function (isVisible) {
            // summary:
            //      set save button visibility
            // tags:
            //      private

            this.toolbar.setItemVisibility("saveButton", isVisible);
        },

        _setSaveButtonDisabledAttr: function (disabled) {
            // summary:
            //      set save button visibility
            // tags:
            //      private

            this.toolbar.setItemProperty("saveButton", "disabled", disabled);
        },

        _setShowCurrentNodeOnBreadcrumbAttr: function (show) {
            // summary:
            //      set whether the breadcrumd should display the current content node.
            // description:
            //      If the current content node is displayed, content name label in the heading is not and vice versa
            // tags:
            //      private

            this.toolbar.setItemProperty("breadcrumbs", "showCurrentNode", show);
            this.toolbar.setItemVisibility("currentcontent", !show);
        },

        _setNotificationContextAttr: function (context) {
            // summary:
            //      set context on the notification center
            // context: Object
            //      The notification context
            // tags:
            //      private

            this.toolbar.setItemProperty("notificationCenter", "notificationContext", context);
        },

        _setActualParentLinkAttr: function (parentLink) {
            // summary:
            //      set actual parent link
            // tags:
            //      private

            this.contentTypeList.set("parentLink", parentLink);
        },

        _setContentTypeNameAttr: {
            type: "innerHTML",
            node: "contentTypeNameNode"
        },

        postMixInProperties: function () {
            // summary:
            //      Post properties mixin handler.
            // description:
            //		Set up model and resource for template binding.
            // tags:
            //		protected

            this.inherited(arguments);

            this.model = new this.modelType();

            this.own(this.model.on("saveSuccess", lang.hitch(this, this._onSaveSuccess)));
            this.own(this.model.on("saveError", lang.hitch(this, this._onSaveError)));
            this.own(this.model.on("invalidContentName", lang.hitch(this, this._onInvalidContentName)));
        },

        postCreate: function () {
            // summary:
            //		Post widget creation handler.
            // description:
            //      Set up local toolbar
            // tags:
            //		protected

            this.inherited(arguments);

            this._contextService = this._contextService || dependency.resolve("epi.shell.ContextService");

            this._setupToolbar();
        },

        layout: function () {
            // summary:
            //      Layout the widget
            // description:
            //      Set the widget's size to the top layout container
            // tags:
            //    protected

            if (this._started) {
                this.layoutContainer.resize(this._containerContentBox || this._contentBox);
                domClass.add(this.stackContainer.domNode, "epi-animation-node-reset");
            }
        },

        updateView: function (data) {
            // summary:
            //      Update the current view with new data from the main widget switcher.
            // data: Object
            //      The settings data.
            // tags:
            //    public

            this.view = data.view;
            this._setCreateMode();
            this._beingSuspended = false;

            // TODO: Incorporate content type list with model and use data binding.
            this.set("contentTypeName", "");

            when(this.model.update(data), lang.hitch(this, function () {
                this.layout();
            }), function (err) {
                console.log(err);
            });
        },

        _onSaveSuccess: function (result) {
            // summary:
            //    Handle save success event from the model.
            //
            // tags:
            //    private

            this._clearCreateMode();

            this._beingSuspended = true;

            if (result.changeContext) {
                this._changeContext(result.newContentLink);
            } else {
                this._backToCurrentContext();
            }

            if (this.createAsLocalAsset === true) {
                topic.publish("/epi/cms/action/createlocalasset");
            }
        },

        _onSaveError: function () {
            // summary:
            //    Handle save error event from the model.
            //
            // tags:
            //    private

            this._clearCreateMode();

            topic.publish("/epi/cms/action/showerror");
        },

        _onInvalidContentName: function (defaultName) {
            // summary:
            //    Handle invalid content name event from the model.
            //
            // tags:
            //    private

            var contentNameInput = new NewContentNameInputDialog({ defaultContentName: defaultName });

            var dialog = new Dialog({
                defaultActionsVisible: false,
                content: contentNameInput,
                title: contentNameInput.title,
                destroyOnHide: true
            });

            this.own(
                aspect.after(dialog, "onExecute", lang.hitch(this, function () {
                    var name = contentNameInput.get("value");
                    if (name === defaultName) {
                        this.model.set("ignoreDefaultNameWarning", true);
                    }
                    this.model.set("contentName", name);
                    this.model.save();
                }), true),

                aspect.after(dialog, "onCancel", lang.hitch(this, function () {
                    if (this.contentTypeList.shouldSkipContentTypeSelection) {
                        this._cancel();
                    } else {
                        this.model.set("isContentTypeSelected", false);
                    }
                }), true)
            );

            dialog.show();
        },

        _onContentTypeSelected: function (item) {
            // summary:
            //    Handle content type selected event from the content type list widget.
            //
            // tags:
            //    private

            if (!this.isContentTypeSelected) {
                this.model.set("contentTypeId", item.id);
                
                this.set("contentTypeName", item.name);
            }
        },

        _onPropertyValidStateChange: function (property, error) {
            // summary:
            //      Handle property validity change event from the properties form widget.
            // property: String
            //      The property name
            // error: String
            //      The error message
            // tags:
            //    private

            if (error) {
                this.model.addInvalidProperty(property, error);
            } else {
                this.model.removeInvalidProperty(property);
            }
        },

        _onContentNameChange: function (name) {
            // summary:
            //    Handle change event from the content name textbox.
            //
            // tags:
            //    private

            this.model.set("contentName", name);
        },

        _onSave: function () {
            // summary:
            //    Handle action of the save button.
            //
            // tags:
            //    private

            if (this._beingSuspended) {
                return;
            }

            // Kick off the client validation. Validation result will be handled by the model later on.
            this.propertiesForm.validate();

            this.model.set("properties", this.propertiesForm.get("value"));
            this.model.save();
        },

        _onCancel: function () {
            // summary:
            //    Handle action of the cancel button.
            //
            // tags:
            //    private

            this._cancel();
        },

        _cancel: function () {
            this._clearCreateMode();

            this.model.cancel();
            this._backToCurrentContext();
        },

        _setupToolbar: function () {
            // summary:
            //    Set up the local toolbar.
            //
            // tags:
            //    private

            var toolbarGroups = [
            {
                name: "leading",
                type: "toolbargroup",
                settings: { region: "leading" }
            },
            {
                name: "trailing",
                type: "toolbargroup",
                settings: { region: "trailing" }
            }];

            var toolbarButtons = [
            {
                parent: "leading",
                name: "breadcrumbs",
                widgetType: "epi-cms/widget/Breadcrumb",
                settings: { showCurrentNode: false }
            },
            {
                parent: "leading",
                name: "currentcontent",
                widgetType: "epi-cms/widget/BreadcrumbCurrentItem"
            },
            {
                parent: "trailing",
                name: "notificationCenter",
                widgetType: "epi-cms/widget/NotificationStatusBar"
            },
            {
                parent: "trailing",
                name: "saveButton",
                title: sharedResources.action.create,
                label: sharedResources.action.create,
                type: "button",
                action: lang.hitch(this, this._onSave),
                settings: { "class": "epi-boldButton Salt" }
            },
            {
                parent: "trailing",
                name: "cancelButton",
                title: sharedResources.action.cancel,
                label: sharedResources.action.cancel,
                type: "button",
                action: lang.hitch(this, this._onCancel),
                settings: { "class": "epi-boldButton" }
            }];

            when(this.toolbar.add(toolbarGroups), lang.hitch(this, function () {
                this.toolbar.add(toolbarButtons);
            }));
        },

        _changeContext: function (contentLink) {
            // summary:
            //    Redirect the newly created content to editmode.
            //
            // contentLink:
            //    The content link.
            //
            // tags:
            //    private

            topic.publish("/epi/shell/context/request", {
                uri: "epi.cms.contentdata:///" + contentLink
            }, {
                sender: this,
                viewName: this.view,
                forceContextChange: true
            });
        },

        _backToCurrentContext: function () {
            // summary:
            //    Get back to the default main widget of the current context.
            //
            // tags:
            //    private

            topic.publish("/epi/shell/action/changeview/back");
        },

        _setCreateMode: function () {
            // summary:
            //      Set create new content state for current mode
            // tags:
            //      private

            lang.mixin(this._contextService.currentContext, {
                "currentMode": "create"
            });

            topic.publish("/epi/cms/action/togglecreatemode", true);
        },

        _clearCreateMode: function () {
            // summary:
            //      Clear create new content state for current mode
            // tags:
            //      private

            domClass.remove(this.stackContainer.domNode, "epi-animation-node-reset");

            lang.mixin(this._contextService.currentContext, {
                "currentMode": undefined
            });

            topic.publish("/epi/cms/action/togglecreatemode", false);
        }

    });

});
},
'epi-cms/contentediting/NewContentNameInputDialog':function(){
﻿define([

// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",

// Dijit
    "dijit/_CssStateMixin",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/TextBox",

// EPi Framework
    "epi",
    "epi/shell/widget/dialog/_DialogContentMixin",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/_ActionProviderWidget",
    
// Template
    "dojo/text!./templates/NewContentNameInputDialog.html",

// Resource
    "epi/i18n!epi/cms/nls/episerver.cms.widget.newcontentnamedialog"
],
function (

// Dojo
    declare,
    lang,
    domStyle,

// Dijit
    _CssStateMixin,
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _TextBox,

// EPi Framework
    epi,
    _DialogContentMixin,
    _ModelBindingMixin,
    _ActionProviderWidget,
    
// Template
    template,

// Resource
    res
) {
    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _ActionProviderWidget, _DialogContentMixin, _CssStateMixin], {

        templateString: template,

        res: res,

        defaultContentName: null,

        message: null,

        title: null,

        nameLabel: epi.resources.header.name, 

        _setMessageAttr: { node: "messageNode", type: "innerHTML" },

        postMixInProperties: function () {
            this.inherited(arguments);
            this.message = lang.replace(this.res.warningtext, {
                defaultname: this.defaultContentName
            });
            this._set("message", this.message);
            this.title = res.title;
        },

        postCreate: function () {
            this.inherited(arguments);
            this.contentNameTextbox.set("value", this.defaultContentName);

            this.contentNameTextbox.on("focus", function () {
                this.focusNode.select();
            });

            this.contentNameTextbox.on("keyup", lang.hitch(this, function (evt) {

                var isValid = this.contentNameTextbox.isValid();

                if (evt.keyCode == dojo.keys.ENTER && isValid) {
                    this.executeDialog();
                }
            }));

            this.contentNameTextbox.focus();
        },

        _getValueAttr: function () {
            return this.contentNameTextbox.get("value");
        },

        getActions: function () {
            // summary:
            //      Overridden from _ActionProvider to get the select current content action added to the containing widget 
            //
            // returns:
            //      An array contining a select page action definition, if it is not a shared block

            this._actions = [
                {
                    name: "ok",
                    label: epi.resources.action.ok,
                    settings: { type: "button", "class": "Salt" },
                    action: lang.hitch(this, function () {
                        if (this.contentNameTextbox.isValid()) {
                            this.executeDialog();
                        } else {
                            this.contentNameTextbox.focus();
                        }
                    })
                },
                {
                    name: "cancel",
                    label: epi.resources.action.cancel,
                    settings: { type: "button" },
                    action: lang.hitch(this, function () {
                        this.cancelDialog();
                    })
                }
            ];

            return this._actions;
        }
    });
});
},
'url:epi-cms/contentediting/templates/NewContentNameInputDialog.html':"﻿<div class=\"epi-formContainer\">\r\n    <div data-dojo-attach-point=\"messageNode\"></div>\r\n    <br />\r\n    <div>\r\n        <label data-dojo-attach-point=\"contentNameLabelNode\">${nameLabel}</label>\r\n        <input type=\"text\" size=\"40\" maxlength=\"255\"  data-dojo-attach-point=\"contentNameTextbox\" data-dojo-type=\"dijit/form/ValidationTextBox\"\r\n                data-dojo-props=\"required: true, trim:true\"\r\n                missingMessage: \"${res.errormessage.missingmessage}\" />\r\n    </div>\r\n</div>",
'epi-cms/contentediting/viewmodel/CreateContentViewModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/json",

    "dojo/Stateful",
    "dojo/string",
    "dojo/when",
    "dojo/Evented",

// epi
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentEditingValidator",

// resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.requiredproperties"
],

function (
// dojo
    array,
    declare,
    lang,
    json,

    Stateful,
    string,
    when,
    Evented,

// epi
    dependency,
    TypeDescriptorManager,
    ContentReference,
    ContentEditingValidator,

// resources
    reqPropsResources
) {

    // module:
    //      epi-cms/contentediting/CreateContentViewModel
    // summary:
    //      View model of epi-cms/contentediting/CreateContent component.
    // tags:
    //      public

    return declare([Stateful, Evented], {
        // =======================================================================
        // Private stuffs
        // =======================================================================

        // _topLevelContainerType: String
        //      The default top level container type used in properties form.
        _topLevelContainerType: "epi/shell/layout/SimpleContainer",

        // _groupContainerType: String
        //      The default group container type used in properties form.
        _groupContainerType: "epi-cms/layout/CreateContentGroupContainer",

        // =======================================================================
        // Dependencies
        // =======================================================================

        // contentDataStore: epi/shell/RestStore
        //      The content data store instance.
        contentDataStore: null,

        // metadataManager: epi/shell/MetadataManager
        //      The metadata manager instance.
        metadataManager: null,

        // typeIdentifierManager: epi/shell/TypeIdentifierManager
        //      The type identifier manager instance.
        typeIdentifierManager: null,

        // validator: epi-cms/contentediting/ContentEditingValidator
        //      The content editing validator instance.
        validator: null,

        // =======================================================================
        // Data model properties
        // =======================================================================

        // parent: Content
        //      The parent content on which the new content is created.
        parent: null,

        // contentTypeId: Number
        //      The content type id of which the new content is created.
        contentTypeId: null,

        // requestedType: String
        //      The type indentifier of created content. This is used for filtering available content types.
        requestedType: null,

        // createAsLocalAsset: Boolean
        //      Indicates that the content is created as local asset which means it will be attached to the parent content's asset folder.
        createAsLocalAsset: null,

        // canChangeLocalAssetName: [public] Boolean
        //      Indicates that the content is created as local asset from a pseudo contextual folder can change its default name or not.
        canChangeLocalAssetName: null,

        // addToDestination: Delegate
        //      A delagate object which contains a save method. The method will be executed after the content is successfully created.
        addToDestination: null,

        // =======================================================================
        // View model properties
        // =======================================================================

        // wizardStep: Number
        //      Keeps track the current step of the creation wizard. 0 means selecting content type while 1 means collecting properties value.
        wizardStep: 0,

        // startWizardStep: [protected] Number
        //      Which step to start with 
        startWizardStep: 0,

        // contentName: String
        //      Name of the content being created. This is initialized from the resource bundle and bound to the name text box in the widget.
        contentName: null,

        // ignoreDefaultNameWarning: Boolean
        //      Indicates that name checking should be ignored.
        ignoreDefaultNameWarning: null,

        // properties: Collection
        //      The properties collection used to create new content.
        properties: null,

        // headingText: String
        //      Heading text which is displayed on the top of the toolbar. This is set according to the current request type.
        headingText: null,

        // createAsLocalAssetHelpText: Boolean
        //      Helper text that displayed in the sub header
        createAsLocalAssetHelpText: null,

        // namePanelIsVisible: Boolean
        //      Indicate that the name panel is visible. If the content is created as local asset, name panel should not be visible
        namePanelIsVisible: null,

        // headingPanelIsVisible: Boolean
        //      Indicates that the heading panel is visible. Similar to the name panel, heading panel is not visible when the content is created as local asset. 
        //      In that case, a more detail heading is displayed inside the content type selection list or properties form.
        headingPanelIsVisible: null,

        // seamlessTopPanel: Boolean
        //      Indicates that the top panel should show seamlessly.
        seamlessTopPanel: null,

        // saveButtonIsVisible: Boolean
        //      Indicate that the save button should be visible, normally in the last step.
        saveButtonIsVisible: null,

        // saveButtonDisabled: Boolean
        //      Indicate that the save button should be disabled, when saving is on going.
        saveButtonDisabled: null,

        // showAllProperties: Boolean
        //      Indicates that it should show all properties for user to enter initial value, normally when content is created as local asset.
        showAllProperties: null,

        // showCurrentNodeOnBreadcrumb: Boolean
        //      Indicates that the breadcrumb should show current content node.
        showCurrentNodeOnBreadcrumb: null,

        // actualParentLink: String
        //      Link of the parent beneath which the content is created. It could be the given parent or the given parent's local asset folder.
        actualParentLink: null,

        // metadata: Object
        //      The metadata object of the content being created.
        metadata: null,

        // =======================================================================
        // Public methods
        // =======================================================================

        postscript: function () {
            // summary:
            //      Initializes internal objects and state after constructed.
            // description:
            //      Obtains content data store and metadata manager instances from dependency manager.
            // tags:
            //      protected

            this.inherited(arguments);

            if (!this.contentDataStore) {
                var registry = dependency.resolve("epi.storeregistry");
                this.contentDataStore = registry.get("epi.cms.contentdata");
            }

            this.metadataManager = this.metadataManager || dependency.resolve("epi.shell.MetadataManager");

            // Could the dependency handle non-singleton objects?
            this.validator = this.validator || new ContentEditingValidator({ contextTypeName: "epi.cms.contentdata" });

            this.set("propertyFilter", lang.hitch(this, this._propertyFilter));
        },

        update: function (settings) {
            // summary:
            //      Update the component with new settings.
            // description:
            //      Taking settings from the ones who request the Create content component. 
            //      The supported settings are: requestedType, parent, createAsLocalAsset, addToDestination, contentTypeId. They will be mixed to the current instance.
            // settings: Object
            //      The settings object.
            // tags:
            //      protected

            // Reset view properties
            this.set("ignoreDefaultNameWarning", false);
            this.set("properties", null);
            this.set("saveButtonIsVisible", false);
            this.set("wizardStep", this.startWizardStep);
            this.set("isContentTypeSelected", false);

            // Copy data properties from topic sender
            if (settings) {
                array.forEach(["requestedType", "parent", "canChangeLocalAssetName", "createAsLocalAsset", "addToDestination", "contentTypeId"], function (property) {
                    this.set(property, settings[property]);
                }, this);
            }

            // Setup the validator
            if (this.parent) {
                var notificationContextId = this.parent.contentLink + "_new_content"; // A pseudo context id for the content that not yet created.
                this.validator.clearErrorsBySource();
                this.validator.setContextId(notificationContextId);

                this.set("notificationContext", { contextTypeName: "epi.cms.contentdata", contextId: notificationContextId });
            }
        },

        save: function () {
            // summary:
            //      Save the content and finish the wizard.
            // description:
            //      save() will validate the content name if ignoreDefaultNameWarning is not set. By then "invalidContentName" might be emitted.
            //      If data validation is fine, the new content object will be put on the content data store. 
            //      On success, "saveSuccess" event is emitted, otherwise "saveError" is emitted.
            // tags:
            //      public

            this.set("saveButtonDisabled", true);

            // Validate content name
            if (!this.ignoreDefaultNameWarning && (this.canChangeLocalAssetName || !this.createAsLocalAsset) && (!this.contentName || this.contentName === "" || this.contentName === this.defaultName)) {
                this._emitSaveEvent("invalidContentName", this.contentName);
                return;
            }

            // Ask the validator to do properties validation and/or other global validation
            this.validator.clearErrorsBySource(this.validator.validationSource.server);
            when(this.validator.validate(), lang.hitch(this, function (hasErrors) {
                if (hasErrors) {
                    this._emitSaveEvent("validationError");
                    return;
                }

                // Build the content object
                var content = this.buildContentObject();

                // Put the new content into content data store
                this.contentDataStore.put(content).then(lang.hitch(this, this._saveSuccessHandler), lang.hitch(this, this._saveErrorHandler));
            }), lang.hitch(this, function () {
                this._emitSaveEvent("validationError");
            }));
        },

        _emitSaveEvent: function (eventName, params) {
            this.set("saveButtonDisabled", false);
            this.emit(eventName, params);
        },

        cancel: function () {
            // summary:
            //      Cancel operation and finish the wizard
            // tags:
            //      Public

            this.addToDestination && (typeof this.addToDestination.cancel === "function") && this.addToDestination.cancel();
        },

        _propertyFilter: function (ownerMetadata, propertyMetadata) {
            // summary:
            //      Filter out meta properties which are not supposed to have value on creation.
            // tags:
            //      private

            var isNotInSpecialGroup = propertyMetadata.originalGroupName !== "EPiServerCMS_SettingsPanel" && propertyMetadata.originalGroupName !== "Advanced";
            var required = this._isRequiredProperty(ownerMetadata, propertyMetadata);

            if (this.showAllProperties) {
                // show properties which do not belong to a special groups at all OR belong to special groups but required
                return isNotInSpecialGroup || required;
            } else {
                // only show properties from "required" group
                return required;
            }
        },

        _saveSuccessHandler: function (contentLink) {
            // summary:
            //      Save success handler
            // contentLink: String
            //      The newly created content's link
            // tags:
            //      private

            var ref = new ContentReference(contentLink),
                versionAgnosticRef = ref.createVersionUnspecificReference(),
                changeToNewContext = lang.hitch(this, function (/*String*/targetLink) {
                    this._emitSaveEvent("saveSuccess", {
                        newContentLink: targetLink,
                        changeContext: true
                    });
                });

            when(this.contentDataStore.refresh(contentLink), lang.hitch(this, function (newContent) {
                if (this.addToDestination) {
                    this.addToDestination.save({
                        contentLink: versionAgnosticRef.toString(),
                        name: newContent.name,
                        typeIdentifier: this.requestedType
                    });

                    // Keep the current context
                    this._emitSaveEvent("saveSuccess", {
                        changeContext: false
                    });

                } else {
                    // Change to new context
                    changeToNewContext(versionAgnosticRef.toString());
                }
            }));
        },

        _saveErrorHandler: function (err) {
            // summary:
            //      Save error handler
            // err: Object
            //      The error object.
            // tags:
            //      private

            // err is actually the xhr error, as for now the rest store doesn't pre handle errors.
            if (err && err.responseText) {
                // received a list of problems

                // NOTE: Do not copy this code since it's not a good practice to handle error. We are finding a pattern to handle server errors in a nicer manner, perhaps inside the rest store.
                var validationErrors = json.fromJson(err.responseText);

                array.forEach(validationErrors, function (item) {
                    if (item.propertyName) {
                        this.validator.setPropertyErrors(item.propertyName, [{
                            severity: item.severity,
                            errorMessage: item.errorMessage
                        }], this.validator.validationSource.server);
                    } else {
                        this.validator.setGlobalErrors([{
                            severity: item.severity,
                            errorMessage: item.errorMessage
                        }], this.validator.validationSource.server);
                    }
                }, this);

            } else if (err) {
                // general error
                this.validator.setGlobalErrors([{
                    severity: this.validator.severity.error,
                    errorMessage: err.message
                }], this.validator.validationSource.server);
            }

            this._emitSaveEvent("saveError", err);
        },

        buildContentObject: function () {
            // summary:
            //      Build up the content object to create from model properties.
            // tags:
            //      protected

            return {
                name: (!this.createAsLocalAsset || this.canChangeLocalAssetName) ? string.trim(this.contentName + "") : null,
                parentLink: this.parent ? this.parent.contentLink : null,
                contentTypeId: this.contentTypeId,
                properties: this.properties,
                createAsLocalAsset: this.createAsLocalAsset
            };
        },

        addInvalidProperty: function (propertyName, errorMessage) {
            // summary:
            //      State that a property has become invalid after client validation.
            // propertyName: String
            //      The property name.
            // errorMessage: String
            //      The error message.
            // tags:
            //		public

            this.validator.setPropertyErrors(propertyName, [{
                severity: this.validator.severity.error,
                errorMessage: errorMessage
            }], this.validator.validationSource.client);
        },

        removeInvalidProperty: function (propertyName) {
            // summary:
            //      State that a property is no more invalid after client validation.
            // propertyName: String
            //      The property name.
            // tags:
            //		public

            this.validator.clearPropertyErrors(propertyName);
        },

        // =======================================================================
        // Property setters
        // =======================================================================

        _contentTypeIdSetter: function (contentTypeId) {
            // summary:
            //      Set content type id.
            // description:
            //      After the value is set, metadata is also updated. If it is neccessary to enter properties, the wizard is stepped forward, otherwise save is executed.
            // contentTypeId: Number
            //      The value.
            // tags:
            //		private

            this.contentTypeId = contentTypeId;

            if (contentTypeId && this.parent) {
                this.set("isContentTypeSelected", true);

                when(this._getMetadata(this.parent.contentLink, contentTypeId), lang.hitch(this, function (metadata) {
                    if (!this.canChangeLocalAssetName || this._hasRequiredProperties(metadata)) {
                        metadata = this._regroupProperties(metadata);
                        this.set("metadata", metadata);
                        this.set("wizardStep", 1);
                        this.set("saveButtonIsVisible", true);
                    } else {
                        this.save();
                    }
                }));
            }
        },

        _canChangeLocalAssetNameSetter: function (/*Boolean*/canChangeLocalAssetName) {
            // summary:
            //      Set canChangeLocalAssetName option.
            // canChangeLocalAssetName: Boolean
            //      The value.
            // tags:
            //      private

            this.canChangeLocalAssetName = canChangeLocalAssetName == null ? true : canChangeLocalAssetName;
        },

        _createAsLocalAssetSetter: function (createAsLocalAsset) {
            // summary:
            //      Set createAsLocalAsset option.
            // createAsLocalAsset: Boolean
            //      The value.
            // tags:
            //      private

            var enabled = this.canChangeLocalAssetName || !createAsLocalAsset;

            this.set("namePanelIsVisible", enabled);
            this.set("headingPanelIsVisible", enabled);
            this.set("showAllProperties", !this.canChangeLocalAssetName);
            this.set("showCurrentNodeOnBreadcrumb", enabled);
            this.set("seamlessTopPanel", enabled);

            if (this.parent) {
                this.set("actualParentLink", createAsLocalAsset ? this.parent.assetsFolderLink : this.parent.contentLink);
            }

            this.createAsLocalAsset = createAsLocalAsset;
        },

        _parentSetter: function (parent) {
            this.parent = parent;

            var typeIdentifier = this.parent.typeIdentifier,
                requestedTypeName = TypeDescriptorManager.getResourceValue(this.requestedType, "name"),
                parentTypeName = TypeDescriptorManager.getResourceValue(typeIdentifier, "name"),
                createAsLocalAssetHelpText = TypeDescriptorManager.getResourceValue(typeIdentifier, "createaslocalassethelptext");

            if (requestedTypeName && parentTypeName) {
                createAsLocalAssetHelpText = lang.replace(createAsLocalAssetHelpText, [requestedTypeName.toLowerCase(), parentTypeName.toLowerCase()]);
            }

            this.set("createAsLocalAssetHelpText", createAsLocalAssetHelpText);
        },

        _requestedTypeSetter: function (requestedType) {
            // summary:
            //      Set requested type.
            // description:
            //      After the value is set, heading text and content name are also updated.
            // requestedType: String
            //      The value.
            // tags:
            //		private

            var headingText = TypeDescriptorManager.getResourceValue(requestedType, "create"),
                defaultName = TypeDescriptorManager.getResourceValue(requestedType, "newitemdefaultname");

            this.defaultName = defaultName;

            this.set("headingText", headingText);
            this.set("contentName", defaultName);

            this.requestedType = requestedType;
        },

        // =======================================================================
        // Private methods
        // =======================================================================

        _hasRequiredProperties: function (metadata) {
            // summary:
            //      Checks if the metadata object contains any required property.
            // metadata: Object
            //      The metadata object.
            // tags:
            //		private

            return array.some(metadata.properties, function (property) {
                return this._isRequiredProperty(metadata, property);
            }, this);
        },

        _isRequired: function (property) {
            // summary:
            //      Checks if the given property is required.
            // property: Object
            //      The metadata property.
            // tags:
            //      protected, extension

            return property.settings && property.settings.required;
        },

        _isRequiredProperty: function (metadata, property) {
            // summary:
            //      Checks if the given property is required.
            // description:
            //      A property is considered to be required if is required or it contains required sub properties.
            //      It should also have no value set, is visible, and is not the icontent_name property which is entered outside the properties form.
            // metadata: Object
            //      The metadata object.
            // property: Object
            //      The metadata property.
            // tags:
            //		private

            var isNotSet = !property.additionalValues.hasValue;

            var isShownForEdit = property.showForEdit && array.every(metadata.groups, function (group) {
                // Every group must be either not the property's original group or have displayui true
                return (group.name !== property.groupName && group.name !== property.originalGroupName) || group.displayUI;
            });

            var hasRequiredChildProperties = array.some(property.properties, function (childProperty) {
                return this._isRequiredProperty(property, childProperty);
            }, this);

            return (this._isRequired(property) || hasRequiredChildProperties) && isNotSet && isShownForEdit && (property.name !== "icontent_name");
        },

        _regroupProperties: function (metadata) {
            // summary:
            //		Regroup properties into required and additional property groups.
            // metadata: Object
            //      The metadata object.
            // tags:
            //		private

            metadata = lang.clone(metadata);

            metadata.layoutType = this._topLevelContainerType;

            array.forEach(metadata.properties, function (prop) {
                var isMandatory = this._isRequiredProperty(metadata, prop);
                prop.originalGroupName = prop.groupName;
                prop.groupName = isMandatory ? "required" : "additional";
            }, this);

            metadata.groups = [
                {
                    name: "required",
                    displayUI: true,
                    title: reqPropsResources.groups.required,
                    uiType: this._groupContainerType
                },
                {
                    name: "additional",
                    displayUI: true,
                    title: reqPropsResources.groups.additional,
                    uiType: this._groupContainerType
                }
            ];

            return metadata;
        },

        _getMetadata: function (parentLink, contentTypeId) {
            // summary:
            //      Get the metadata for the newly created content.
            // parentLink: String
            //      The parent content link.
            // contentTypeId: Number
            //      The content type id.
            // tags:
            //      private

            return this.metadataManager.getMetadataForType('EPiServer.Core.ContentData', {
                parentLink: parentLink,
                contentTypeId: contentTypeId
            });
        }

    });

});
},
'epi-cms/contentediting/ContentEditingValidator':function(){
﻿define([
    "dojo",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "dojo/store/Memory",

    "dojo/Stateful",

    "epi/dependency"
],
function (
        dojo,
        array,
        declare,
        Deferred,
        lang,
        connect,
        Memory,

        Stateful,

        dependency
        ) {

    return declare([Stateful], {

        // contextTypeName: String
        //      Name of context type used to partitioning messages in message service
        contextTypeName: "",

        // contextId: Object
        //      Id of context used to partitioning messages in message service
        contextId: null,

        messageService: null,
        _isBlocking: false,

        // isValid: Boolean
        //      Indicates if this validator is valid without any validation errors (no error or warn messages)
        isValid: true,

        // hasErrors: Boolean
        //      Indicates if there are any errors (only errors, warn not included)
        hasErrors: false,

        _storeId: 0,
        _store: null,

        // NOTE: this maps to server side enum
        severity: {
            "none": 0,
            "info": 1,
            "warn": 2,
            "error": 3
        },

        validationSource: {
            "server": 1,
            "client": 2
        },

        // hash map for levels
        _errorLevels: {},

        constructor: function (params) {
            declare.safeMixin(this, params);
        },

        postscript: function () {
            this.inherited(arguments);

            // map error types to hash map for levels
            for (var p in this.severity) {
                var enumValue = this.severity[p];
                this._errorLevels[enumValue] = p;
            }

            this.messageService = this.messageService || dependency.resolve("epi.shell.MessageService");

            // create new store
            this._store = new Memory({
                idAttribute: "id",
                data: []
            });
        },

        setContextId: function (contextId) {

            var oldContextId = this.contextId;
            this.contextId = contextId;

            // update new context to items in messageservice
            var items = this.messageService.query({ contextTypeName: this.contextTypeName, contextId: oldContextId });
            items.forEach(lang.hitch(this, function (item) {
                item.contextId = this.contextId;
                this.messageService.put(item);
            }));
        },

        clearPropertyErrors: function (propertyName, source) {

            // must have a property name
            if (!propertyName) {
                return;
            }

            // removes all error for a specific property
            this._clearErrors(propertyName, source);
        },

        setPropertyErrors: function (propertyName, errorMessages, source) {

            // must have a property name
            if (!propertyName) {
                return;
            }

            // sets property errors for a specific property
            this._setErrors(errorMessages, propertyName, source);
        },

        clearGlobalErrors: function (source) {
            // removes all global errors 
            this._clearErrors(null, source);
        },

        clearErrorsBySource: function (source) {
            // removes all errors for a source type
            this._clearErrors(undefined, source);
        },

        setGlobalErrors: function (errorMessages, source) {
            // sets property errors for a specific property
            this._setErrors(errorMessages, null, source);
        },

        _clearErrors: function (propertyName, source) {
            var query;

            if (propertyName) {
                query = { "propertyName": propertyName };
            } else if (propertyName === null) {
                query = { "global": true };
            } else {
                query = {};
            }

            // if source is given then use it
            if (source) {
                query.source = source;
            }

            var items = this._store.query(query);
            items.forEach(lang.hitch(this, function (item) {
                this.messageService.remove({ id: item.messageId });
                this._store.remove(item.id);
            }));

            this._updateFlags();
        },

        _setErrors: function (errorMessages, propertyName, source) {
            this._clearErrors(propertyName, source);
            array.forEach(errorMessages, function (item) {
                this._putStoreItem(item, propertyName, source);
            }, this);

            this._updateFlags();
        },

        _putStoreItem: function (item, propertyName, source) {
            // puts an item in validation store

            var severityName = "";

            // get type name
            if (this._errorLevels[item.severity]) {
                severityName = this._errorLevels[item.severity];
            }

            var messageId = this.messageService.put(severityName, item.errorMessage, this.contextTypeName, this.contextId);

            var storeItem = {
                "id": this._storeId++,
                "item": item,
                "severity": item.severity,
                "messageId": messageId
            };

            // property or global?
            if (propertyName) {
                storeItem.propertyName = propertyName;
            } else {
                storeItem.global = true;
            }

            if (source !== undefined) {
                storeItem.source = source;
            }

            return this._store.put(storeItem);
        },

        _updateFlags: function () {
            // update isValid property
            var errorItems = this._store.query({ "severity": this.severity.error });
            var warnItems = this._store.query({ "severity": this.severity.warn });
            var isValid = errorItems.length === 0 && warnItems.length === 0;
            var hasErrors = errorItems.length > 0;
            this.set("isValid", isValid);
            this.set("hasErrors", hasErrors);
        },

        validate: function () {
            // summary:
            //      Queries message service by error type and warning type to indicates content is valid or not
            // tags:
            //      public

            var error = this.severity.error,
                warning = this.severity.warn,
                deferred = new Deferred();

            Deferred.when(
                this._validate(error),
                function (hasServerSideErrors) {
                    if (hasServerSideErrors) {
                        // defaults behaviour: show notification tooltipdialog when has any error(s)
                        connect.publish("/epi/cms/action/showerror");
                    }
                    deferred.resolve(hasServerSideErrors);
                },
                function () {
                    // defaults behaviour: show notification tooltipdialog when has any error(s)
                    connect.publish("/epi/cms/action/showerror");
                    deferred.reject();
                }
            );

            return deferred;
        },

        _validate: function (severity) {
            // summary:
            //      Queries message service by error type to indicates content is valid or not
            // severity: Enum
            //      Type of error
            // tags:
            //      Private

            var deferred = new Deferred();

            if (!this._isBlocking) {
                Deferred.when(this._store.query({ "severity": severity }), lang.hitch(this, function (errorMessages) {

                    var clientSideErrors = array.filter(errorMessages, function (item) {
                        return item.source == this.validationSource.client;
                    }, this);

                    var hasClientSideErrors = clientSideErrors.length > 0;
                    var hasServerSideErrors = errorMessages.length > clientSideErrors.length;

                    if (hasClientSideErrors) {
                        deferred.reject();
                    } else {
                        deferred.resolve(hasServerSideErrors);
                    }
                }));
            }

            return deferred;
        }
    });
});

},
'epi-cms/widget/ContentTypeList':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",

    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/when",

// dijit
    "dijit/layout/_LayoutWidget",
// epi
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/widget/ContentTypeGroup",

    "epi/i18n!epi/cms/nls/episerver.cms.widget.contenttypelist"
],

function (
// dojo
    array,
    declare,
    lang,

    domClass,

    Deferred,
    all,
    when,
// dijit
    _LayoutWidget,
// epi
    dependency,
    TypeDescriptorManager,
    ContentTypeGroup,

    i18n
) {

    // module:
    //      epi-cms/widget/ContentTypeList
    // summary:
    //      A list of suggested and available content types for content creation.
    // description:
    //      Displays a list of suggested and available content types for content creation.
    // tags:
    //      public

    return declare([_LayoutWidget], {

        // store: [readonly] dojo.store
        //      Underlying store which will be queried for data to display.
        store: null,

        // parentLink: [public] String
        //      Link to parent content which the new content will be created beneath.
        parentLink: null,

        // groups: [public] Object
        //      Named value object containing the current content type groups.
        groups: null,

        // requestedType: [public] String
        //      Specify the content type to be shown on the list.
        requestedType: null,

        // shouldSkipContentTypeSelection: [public] Boolean
        //      Indicate that we have only 1 available type, so type selection can be skipped.
        shouldSkipContentTypeSelection: null,

        postMixInProperties: function () {
            // summary:
            //      Initiates the store if none has been mixed in.
            // tags:
            //      protected

            this.inherited(arguments);

            this.groups = {};

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.contenttype");
            }
        },

        buildRendering: function () {
            // summary:
            //      Construct the base UI with suggested content types.
            // tags:
            //      protected

            this.inherited(arguments);

            var suggested = new ContentTypeGroup();
            this.connect(suggested, "onSelect", function (item) { this.onContentTypeSelected(item); });
            this.addChild(suggested);
            this._suggestedContentTypes = suggested;
        },

        refresh: function () {
            // summary:
            //      Refresh the content and rendered view of the list.
            // tags:
            //      public

            // Clear any existing data first to stop flickering in the UI.
            this.clear();

            this._setupWidgetTemplate();

            when(all({
                types: this._getSuggestedContentTypes(this.requestedType),
                groups: this._groupContentTypes()
            }), lang.hitch(this, function (result) {
                var types = result.types,
                    groups = result.groups,
                    grouped = groups.grouped,
                    contentTypes = groups.contentTypes;

                // Setup the suggested content types.
                if (types.length <= 0) {
                    // Hide suggested content types only
                    this._suggestedContentTypes.setVisibility(false);
                } else {
                    // Setup the suggested content types.
                    domClass.add(this._suggestedContentTypes.titleNode, "epi-ribbonHeaderSpecial");
                    this._suggestedContentTypes.set("title", this._suggestedTypesTitle);
                    this._suggestedContentTypes.set("contentTypes", types);
                    this._suggestedContentTypes.setVisibility(true);
                }

                // Clear and load the available content types sorted into groups.
                var key, group;

                // Update remaining groups with new content types.
                for (key in grouped) {
                    group = this._getOrCreateGroup(key);
                    group.set("contentTypes", grouped[key]);
                }

                if (contentTypes instanceof Array && contentTypes.length === 1) {
                    // If we have 1 child only, hide all
                    this.setVisibility(false);

                    this.set("shouldSkipContentTypeSelection", true);

                    // Automatically select page type in case only one page type is allowed under the selected container.
                    this.onContentTypeSelected(contentTypes[0]);
                } else {
                    this.set("shouldSkipContentTypeSelection", false);
                }
            }));
        },

        setVisibility: function (display) {
            // summary:
            //      The common method to show / hide this widget
            // display: Boolean
            //      The flag to show or hide.
            // tags:
            //      pubic

            this.getChildren().forEach(function (group) {
                group.setVisibility(display);
            }, this);
        },

        _setupWidgetTemplate: function () {
            this._suggestedTypesTitle = TypeDescriptorManager.getResourceValue(this.requestedType, "suggestedtypes");
            this._otherTypesTitle = TypeDescriptorManager.getResourceValue(this.requestedType, "othertypes");
        },

        clear: function () {
            // summary:
            //      Removes all the content types groups from the current view, except for
            //      suggested content types which will only have it's children removed.
            // tags:
            //      public

            this._suggestedContentTypes.clear();

            for (var key in this.groups) {
                this.groups[key].destroyRecursive();
                delete this.groups[key];
            }
        },

        _getOrCreateGroup: function (name) {
            var group = this.groups[name];
            if (!group) {
                group = new ContentTypeGroup({ title: name });
                this.connect(group, "onSelect", function (item) { this.onContentTypeSelected(item); });
                this.addChild(group);
                this.groups[name] = group;
            }

            return group;
        },

        _getAvailableContentTypes: function (type) {
            // summary:
            //      Query for available content types based on the type.
            // tags:
            //      private

            return this.store.query({
                query: "getavailablecontenttypes",
                parentReference: this.parentLink,
                requestedTypes: [type]
            });
        },

        _getSuggestedContentTypes: function (type) {
            // summary:
            //      Query for suggested content types based on the parent page.
            // tags:
            //      private

            return this.store.query({
                query: "getsuggestedcontenttypes",
                parentReference: this.parentLink,
                requestedTypes: [type]
            });
        },

        _groupContentTypes: function () {
            // summary:
            //      Group the available content types.
            // tags:
            //      private

            var grouped = {},
                deferred = new Deferred(),
                otherGroupType = this._otherTypesTitle;

            when(this._getAvailableContentTypes(this.requestedType), lang.hitch(this, function (available) {
                var count = available.length;
                array.forEach(available, function (item) {
                    when(item, function (type) {
                        var groupName = type.groupName || otherGroupType,
                            group = grouped[groupName] || [];

                        group.push(type);
                        grouped[groupName] = group;
                        count--;
                        if (count === 0) {
                            deferred.resolve({ grouped: grouped, contentTypes: available });
                        }
                    });
                });
            }));

            return deferred;
        },

        _setParentLinkAttr: function (value) {
            this._set("parentLink", value);

            if (this.requestedType) {
                this.refresh();
            }
        },

        _setRequestedTypeAttr: function (value) {
            this._set("requestedType", value);
        },

        onContentTypeSelected: function (/*===== item =====*/) {
            // summary:
            //      Event raised when a content type widget on the list
            //      is clicked.
            // tags:
            //      callback
        }

    });

});
},
'epi-cms/widget/ContentTypeGroup':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojo/text!./templates/ContentTypeGroup.html",
    
    "dijit/_TemplatedMixin",
    "dijit/layout/_LayoutWidget",
    
    "epi-cms/widget/ContentType",
    "dojo/keys",
    "dijit/_KeyNavContainer"
], function (declare, lang, array, domStyle, template, _TemplatedMixin, _LayoutWidget, ContentType, keys, _KeyNavContainer) {

    // module:
    //		epi-cms/widget/ContentTypeGroup
    // summary:
    //		Displays a group of content types under a common heading.

    return declare([_LayoutWidget, _TemplatedMixin, _KeyNavContainer], {
        // summary:
        //		Displays a group of content types under a common heading.

        // title: [public] String
        //		The title for the content type group.
        title: "",

        // contentTypes: [public] Array
        //		Collection of content types that are displayed in the group.
        contentTypes: null,

        // templateString: [protected] String
        //		A string that represents the widget template.
        templateString: template,

        buildRendering: function () {
            // summary:
            //		Construct the UI with the initial content types
            // tags:
            //		protected

            this.inherited(arguments);
        },

        postCreate: function () {
            this.inherited(arguments);

            this.render();

            this.connectKeyNavHandlers(
				this.isLeftToRight() ? [keys.LEFT_ARROW, keys.UP_ARROW] : [keys.RIGHT_ARROW, keys.DOWN_ARROW],
				this.isLeftToRight() ? [keys.RIGHT_ARROW, keys.DOWN_ARROW] : [keys.LEFT_ARROW, keys.UP_ARROW]
			);
        },

        render: function () {
            // summary:
            //		Render the group with the current content types. This will
            //		destroy the current view if it exists.
            // tags:
            //		public

            this.clear();
            array.forEach(this.contentTypes, function (type) {
                var child = new ContentType({ contentType: type });
                this.connect(child, "onSelect", this.onSelect);
                this.addChild(child);
            }, this);
        },

        clear: function () {
            // summary:
            //		Destroys the current view.
            // tags:
            //		public

            array.forEach(this.getChildren(), function (child) {
                this.removeChild(child);
                child.destroyRecursive();
            }, this);
        },

        _setTitleAttr: { node: "titleNode", type: "innerText" },

        _setContentTypesAttr: function (value) {
            this._set("contentTypes", value);
            if (this._created) {
                this.render();
            }
        },

        onSelect: function (/*===== item =====*/) {
            // summary:
            //		Callback that is executed when an item in this
            //		group is selected.
            // tags:
            //		callback
        },

        setVisibility: function (display) {
            // summary:
            //    Set the group's visibility
            //
            // display:
            //    Flag states if the group will be shown or not.
            //
            // tags:
            //    public
            var value = (display ? "block" : "none");
            domStyle.set(this.domNode, "display", value);
        }
    });
});

},
'url:epi-cms/widget/templates/ContentTypeGroup.html':"﻿<div class=\"epi-listingContainer\" data-dojo-attach-point=\"focusNode\" tabIndex=\"${tabIndex}\">\r\n    <h2 data-dojo-attach-point=\"titleNode\" class=\"epi-ribbonHeader\"></h2>\r\n    <ul data-dojo-attach-point=\"containerNode\" class=\"epi-advancedListing\"></ul>\r\n</div>",
'epi-cms/widget/ContentType':function(){
﻿define([
    "dojo",
    "dojo/dom-class",
    "dojo/string",
    
    "dijit/focus",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    
    "epi/i18n!epi/cms/nls/episerver.cms.widget.pagetype",
    "dojo/text!./templates/ContentType.html"
], function (dojo, domClass, string, focus, _Widget, _TemplatedMixin, i18n, template) {

    // module:
    //		epi-cms/widget/ContentType
    // summary:
    //		A widget that represents the content type.

    return dojo.declare([_Widget, _TemplatedMixin], {
        // summary:
        //		Widget for displaying content type information.

        // templateString: [protected] String
        //		The widget template.
        templateString: template,

        // contentType: [public] Object
        //		The content type to be displayed.
        contentType: null,

        // iconTemplate: [public] String
        //		The template used when an icon image is provided.
        iconTemplate: '<img src="${0}" alt="${1}" class="epi-preview" />',

        // emptyIconTemplate: [public] String
        //		The template used when no icon image is provided.
        emptyIconTemplate: string.substitute('<div class="epi-noPreviewIcon"><span class="epi-noPreview">${0}</span></div>', [i18n.nopreview]),

        buildRendering: function () {
            // summary:
            //		Construct the UI with the initial content type.
            // tags:
            //		protected

            this.inherited(arguments);

            this.connect(this.domNode, "onclick", this._onClick);
            this.render();
        },

        render: function () {
            // summary:
            //		Render the content type information.
            // tags:
            //		public

            var type = this.contentType;
            if (type) {
                this.set("name", type.localizedName);
                this.set("description", type.localizedDescription || i18n.nodescription);
                this.set("icon", type.imagePath);
            }
        },

        _setContentTypeAttr: function (value) {
            this._set("contentType", value);
            if (this._created) {
                this.render();
            }
        },

        _setNameAttr: { node: "nameNode", type: "innerText" },

        _setDescriptionAttr: { node: "descriptionNode", type: "innerText" },

        _setIconAttr: function (value) {
            this._set("icon", value);
            this.iconNode.innerHTML = value ? string.substitute(this.iconTemplate, [value, this.name]) : this.emptyIconTemplate;
        },

        focus: function () {
            this.inherited(arguments);

            domClass.add(this.focusNode, "epi-advancedListingItemActive");

            focus.focus(this.focusNode);
        },

        _onBlur: function () {
            this.inherited(arguments);

            domClass.remove(this.focusNode, "epi-advancedListingItemActive");
        },

        _onKeyPress: function (e) {
            //Fire click when pressing the enter/space key
            if (e.keyCode === 13 || e.keyCode === 32) {
                this.onSelect(this.contentType);
            }
        },

        _onClick: function () {
            // summary:
            //    Raised when the widget is clicked.
            //
            // tags:
            //   private

            this.onSelect(this.contentType);
        },

        _onMouseOver: function () {
            domClass.add(this.focusNode, "epi-advancedListingItemActive");
        },
        _onMouseOut: function () {
            domClass.remove(this.focusNode, "epi-advancedListingItemActive");
        },
        
        onSelect:function (item) {
            // summary:
            //    Raised when the content type is selected.
            //
            // item:
            //    The content type.
            //
            // tags:
            //   public event
        }
    });
});
},
'url:epi-cms/widget/templates/ContentType.html':"﻿<li class=\"clearfix\" data-dojo-attach-event=\"onkeypress:_onKeyPress, onmouseover:_onMouseOver, onmouseout:_onMouseOut\" data-dojo-attach-point=\"focusNode\">\r\n    <div class=\"epi-browserWindow\"><div class=\"epi-browserWindowContent\" data-dojo-attach-point=\"iconNode\">${emptyIconTemplate}</div></div>\r\n    <h3 data-dojo-attach-point=\"nameNode\"></h3>\r\n    <p data-dojo-attach-point=\"descriptionNode\"></p>\r\n</li>",
'epi-cms/widget/PropertiesForm':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/when",

    "dijit/layout/_LayoutWidget",

    "epi/shell/widget/FormContainer"
], function (
    array,
    declare,
    lang,

    when,

    _LayoutWidget,

    FormContainer) {

    // summary:
    //      Required properties form used in create content component
    return declare([_LayoutWidget], {
        // metadata: Object
        //      Metadata of the selected content type
        metadata: null,

        // showAllProperties: Boolean
        //      Indicate that the form should display all properties
        showAllProperties: false,

        // propertyFiter: Function
        //      Filter used to show/hide properties displayed in the form
        propertyFilter: null,

        _setMetadataAttr: function (value) {
            this._set("metadata", value);
            this._setupForm();
        },

        _setupForm: function () {
            // summary:
            //		Setup form container after the widget is created.
            // tags:
            //		private

            if (this._form) {
                this._form.destroy();
            }

            this._form = new FormContainer({
                metadata: this.metadata,
                doLayout: false,
                propertyFilter: lang.hitch(this, this.propertyFilter)
            });

            this.connect(this._form, "onFieldCreated", function (fieldName, widget) {
                this.own(widget.watch("state", lang.hitch(this, function (name, oldValue, value) {
                    if (oldValue === "Error" && value !== "Error") {
                        this.onPropertyValidStateChange(fieldName);
                    }
                    else if (oldValue !== "Error" && value === "Error") {
                        this.onPropertyValidStateChange(fieldName, widget.getErrorMessage());
                    }
                })));
            });

            this._form.placeAt(this.domNode);

            this.own(this._form);
        },
        
        validate: function () {
            // summary:
            //		Validate the properties.
            // tags:
            //		public

            return this._form.validate();
        },

        onPropertyValidStateChange: function (propertyName, errorMessage) {
            // summary:
            //      Fired when a property become invalid or is valid again.
            // propertyName: String
            //      The property name
            // errorMessage: String
            //      The error message if any.
            // tags:
            //      public, callback
        },

        _getValueAttr: function () {
            // summary:
            //		Get properties form value.
            // tags:
            //		protected

            return this._form.get("value");
        }
    });
});
},
'epi-cms/widget/BreadcrumbCurrentItem':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/dom-class",
    "dojo/Evented",
    "dojo/topic",
    "dojo/dom-construct",

    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",

    "epi/string",

    "epi/shell/TypeDescriptorManager",

    "dojo/text!./templates/BreadcrumbCurrentItem.html"
],

function (
    declare,
    domClass,
    Evented,
    topic,
    domConstruct,

    _TemplatedMixin,
    _WidgetBase,

    epiString,

    TypeDescriptorManager,

    template
) {

    return declare([_WidgetBase, _TemplatedMixin], {

        templateString: template,

        // _currentIconClass: [String]
        //      The private variable to safe class of current context
        _currentIconClass: null,

        _setCurrentItemInfoAttr: function (/* context */value) {
            // summary:
            //   The context for a content.
            //
            // value:
            //    The current item info object, containing name and dataType.
            //
            // tags:
            //    private

            if (!value) {
                return;
            }

            this.heading.innerHTML = epiString.encodeForWebString(value.name);

            if (value.dataType) {
                var currentIconClass = TypeDescriptorManager.getValue(value.dataType, "iconClass");
                if (currentIconClass && currentIconClass !== this._currentIconClass) {

                    // Remove current class and then add new class
                    domClass.remove(this.iconNode, this._currentIconClass);
                    domClass.add(this.iconNode, currentIconClass);
                    this._currentIconClass = currentIconClass;
                }
            }
        }
    });
});
},
'url:epi-cms/widget/templates/BreadcrumbCurrentItem.html':"﻿<div>\r\n    <div class=\"epi-breadCrumbs-title-wrapper\"><span data-dojo-attach-point=\"iconNode\" class=\"dijitInline dijitIcon epi-breadCrumbsCurrentItem-icon\"></span><h1 data-dojo-attach-point=\"heading\" class=\"epi-breadcrumbContentItem dojoxEllipsis\"></h1></div>\r\n</div>",
'url:epi-cms/contentediting/templates/CreateContent.html':"﻿<div class=\"epi-createContent\">\r\n    <div data-dojo-attach-point=\"layoutContainer\" data-dojo-type=\"dijit/layout/BorderContainer\" data-dojo-props=\"gutters: false, livesplitters: false\">\r\n        <div class=\"epi-static-node\" data-dojo-attach-point=\"topPanel\" data-dojo-type=\"dijit/layout/ContentPane\" data-dojo-props=\"region:'top'\">\r\n            <div data-dojo-attach-point=\"headingPanel\">\r\n                <h1><span data-dojo-attach-point=\"headingTextNode\"></span>:&nbsp;<span data-dojo-attach-point=\"contentTypeNameNode\"></span></h1>\r\n            </div>\r\n            <div data-dojo-attach-point=\"toolbar\" class=\"epi-localToolbar epi-viewHeaderContainer\" data-dojo-type=\"epi/shell/widget/ToolbarSet\" data-dojo-props=\"region:'top'\"></div>\r\n            <div data-dojo-attach-point=\"namePanel\">\r\n                <label>${sharedResources.header.name}</label>\r\n                <input data-dojo-attach-point=\"nameTextBox\" data-dojo-type=\"dijit/form/ValidationTextBox\" data-dojo-attach-event=\"onChange: _onContentNameChange\" maxlength=\"255\" />\r\n            </div>\r\n        </div>\r\n        <div class=\"epi-newContentContainer epi-animation-node\" data-dojo-attach-point=\"stackContainer\" data-dojo-type=\"dijit/layout/StackContainer\" data-dojo-props=\"region: 'center'\">\r\n            <div data-dojo-attach-point=\"contentTypeList\" data-dojo-type=\"epi-cms/widget/ContentTypeList\" data-dojo-attach-event=\"onContentTypeSelected: _onContentTypeSelected\">\r\n                <div data-dojo-attach-point='subHeadingPanel' class=\"push-padding--left\">\r\n                    <h1 data-dojo-attach-point=\"subHeadingTextNode\"></h1>\r\n                    <p data-dojo-attach-point=\"subHeadingDescNode\"></p>\r\n                </div>\r\n            </div>\r\n            <div data-dojo-attach-point=\"propertiesForm\" data-dojo-type=\"epi-cms/widget/PropertiesForm\" data-dojo-attach-event=\"onPropertyValidStateChange: _onPropertyValidStateChange\">\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>",
'epi-cms/contentediting/CreateLanguageBranch':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
// epi
    "epi-cms/contentediting/CreateContent",
    "epi-cms/contentediting/viewmodel/CreateLanguageBranchViewModel"
],

function (
// dojo
    declare,
    lang,
// epi
    CreateContent,
    CreateLanguageBranchViewModel
) {

    // module:
    //      epi-cms/contentediting/CreateLanguageBranch
    // summary:
    //      Widget for language branch creation.
    // tags:
    //      public

    return declare([CreateContent], {

        modelType: CreateLanguageBranchViewModel,

        _setCreateMode: function () {
            // summary:
            //      Set create new content state for current mode
            // tags:
            //      protected, extension

            lang.mixin(this._contextService.currentContext, {
                "currentMode": "translate"
            });
        }

    });

});
},
'epi-cms/contentediting/viewmodel/CreateLanguageBranchViewModel':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

// epi
    "epi-cms/contentediting/viewmodel/CreateContentViewModel"
],

function (
// dojo
    declare,
    lang,
    when,

// epi
    CreateContentViewModel
) {

    // module:
    //    epi-cms/contentediting/viewmodel/CreateLanguageBranchViewModel
    // summary:
    //      View model of epi-cms/contentediting/CreateLanguageBranch component.
    // tags:
    //      public

    return declare([CreateContentViewModel], {

        // languageBranch: String
        //      Language branch on which the new content is created.
        languageBranch: null,

        // masterLanguageVersionId: String
        //      Content link of the master language version.
        masterLanguageVersionId: null,

        postscript: function () {

            // always start with second step
            this.wizardStep = 1;
            this.startWizardStep = 1;

            this.inherited(arguments);
        },

        update: function (settings) {
            // summary:
            //      Update the component with new settings.
            // description:
            //      Override the base to set other properties (languageBranch, masterLanguageVersionId, contentName) with values provided by the component settings requested.
            // settings: Object
            //      The settings object.
            // tags:
            //      public

            var masterContent = settings.contentData;
            var languageBranch = settings.languageBranch;

            return when(this.contentDataStore.get(masterContent.parentLink), lang.hitch(this, function (parent) {
                var baseResult = CreateContentViewModel.prototype.update.apply(this, [{
                    requestedType: masterContent.typeIdentifier,
                    parent: parent,
                    contentTypeId: masterContent.contentTypeID
                }]);

                this.set("languageBranch", languageBranch);
                this.set("masterLanguageVersionId", masterContent.contentLink);
                this.set("contentName", masterContent.name);

                return baseResult;
            }));
        },

        _isRequired: function (property) {
            // summary:
            //      Checks if the given property is required.
            // property: Object
            //      The metadata property.
            // tags:
            //      protected, extension

            return this.inherited(arguments) && (!this.languageBranch || property.settings.isLanguageSpecific === true);
        },

        buildContentObject: function () {
            // summary:
            //      Build up the content object to create from model properties.
            // description:
            //      Override to set languageBranch and masterLanguageVersionId on the result.
            // tags:
            //      protected

            var content = this.inherited(arguments);

            lang.mixin(content, {
                languageBranch: this.languageBranch,
                masterLanguageVersionId: this.masterLanguageVersionId
            });

            return content;
        }

    });

});
},
'epi-cms/contentediting/DateTimeNowEditor':function(){
﻿define([
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/text!./templates/DateTimeNowEditor.html",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/Tooltip",
    "epi/shell/widget/_ValueRequiredMixin",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.datetimenow"
], function (connect, declare, lang, domConstruct, templateString, _Widget, _TemplatedMixin, _WidgetsInTemplateMixin, Tooltip, _ValueRequiredMixin, resources) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _ValueRequiredMixin], {

        templateString: templateString,

        value: null,

        resources: resources,

        _selectorWatchHandle: null,

        postCreate: function () {
            this.inherited(arguments);

            this._selectorWatchHandle = this.dateTimeSelector.watch("value", lang.hitch(this, function (value, oldValue, newValue) {
                this.onChange(newValue);
            }));
        },

        onChange: function (newValue) {
            // summary:
            //      Callback method for updating the editor wrapper.
            // tags:
            //      callback
            this.validate();
        },

        validate: function () {
            var isValid = this.inherited(arguments);
            if (isValid) {
                var value = this.get("value");
                isValid = this.disabled || !value || !this.minimumValue || value > this.minimumValue;
                this._set("state", isValid ? "" : "Error");
                if (isValid) {
                    Tooltip.hide(this.domNode);
                } else {
                    Tooltip.show(this.minimumValueMessage, this.domNode);
                }
            }
            return isValid;
        },

        _setValueAttr: function (value) {
            this.dateTimeSelector.set("value", value);
            this._set("value", value); //for the value required mixin
        },

        _getValueAttr: function () {
            return this.dateTimeSelector.get("value");
        },

        _onExpireNowClick: function () {
            this.set("value", new Date());
        },

        destroy: function () {
            if (this._selectorWatchHandle) {
                this._selectorWatchHandle.unwatch();
            }
            Tooltip.hide(this.domNode);
        }
    });
});
},
'url:epi-cms/contentediting/templates/DateTimeNowEditor.html':"﻿<div class=\"dijitInline dijitInputContainer\">\r\n    <div data-dojo-type=\"epi/shell/widget/DateTimeSelectorDropDown\" data-dojo-attach-point=\"dateTimeSelector\"></div\r\n    ><a class=\"epi-visibleLink\" style=\"padding-left:10px\" data-dojo-attach-event=\"onclick:_onExpireNowClick\">${resources.now}</a>\r\n</div>",
'epi-cms/contentediting/DialogEditorWrapper':function(){
﻿define([
"epi",
"dojo",
"epi-cms/contentediting/_EditorWrapperBase",
"epi/shell/widget/dialog/Dialog"],

function (epi, dojo, _EditorWrapperBase, Dialog) {

    return dojo.declare([_EditorWrapperBase], {
        // summary:
        //		Base Dialog Editor wrapper. Create property editor in a dialog. Provides positioning, sizing functions.

        // closeOnChange: [public] Boolean
        //    Denote if the dialog should be closed on change
        closeOnChange: true,

        // closeOnChange: [public] Boolean
        //    Denote if the dialog should show its Ok and Cancel buttons
        showButtons: false,

        _dialog: null,

        buildRendering: function () {
            this.inherited(arguments);

            if (!this.editorWidget) {
                // Create editor widget
                dojo["require"](this.editorWidgetType); // Written this way on purpose to fool the build system.
                var cls = dojo.getObject(this.editorWidgetType);
                var editorParams = this.editorParams || {};

                if ("displayedValue" in cls.prototype || "value" in cls.prototype) {
                    editorParams["displayedValue" in cls.prototype ? "displayedValue" : "value"] = this.value;
                }

                this.editorWidget = new cls(editorParams);
            }

            var ew = this.editorWidget;

            // Create dialog and set content
            var dialog = new Dialog({
                content: ew,
                title: this.propertyDisplayName,
                defaultActionsVisible: this.showButtons,
                contentClass: "epi-dialog-fullWidth"
            });

            // ESC and TAB could cancel and save.  Note that edit widgets do a stopEvent() on ESC key (to
            // prevent Dialog from closing when the user just wants to revert the value in the edit widget),
            // so this is the only way we can see the key press event.
            this.connect(ew, "onKeyPress", this._onKeyPress);
            this.connect(ew, "onCancel", this._onCancel);
            this.connect(ew, "onResize", dojo.hitch(this, function () {
                this._dialog.resize();
            }));

            if ("intermediateChanges" in ew) {
                // If an editor widget publishes intermediate changes we want to get notified about them.
                ew.set("intermediateChanges", true);
            }
            this.connect(ew, "onChange", "_onChange");

            this.connect(dialog, "onHide", this._onHide);
            this.connect(dialog, "onCancel", this._onCancel);
            this._dialog = dialog;
        },

        destroy: function () {
            this._dialog.destroyRecursive();
            this.inherited(arguments);
        },

        _onKeyPress: function (e) {
            // summary:
            //		Handler for keypress in the edit box in autoSave mode.
            // description:
            //		For autoSave widgets, if Esc/Enter, call cancel/save.
            // tags:
            //		private

            if (this.editing) {

                if (e.altKey || e.ctrlKey) { return; }
                // If Enter/Esc pressed, treat as save/cancel.
                if (e.keyCode == dojo.keys.ESCAPE) {
                    dojo.stopEvent(e);
                    this.cancel(); // sets editing=false which short-circuits _onBlur processing
                } else if (e.keyCode == dojo.keys.ENTER && e.target.tagName == "INPUT") {

                    dojo.stopEvent(e);
                    this._stopEdit();
                }

                // _onBlur will handle TAB automatically by allowing
                // the TAB to change focus before we mess with the DOM: #6227
                // Expounding by request:
                // The current focus is on the edit widget input field.
                // save() will hide and destroy this widget.
                // We want the focus to jump from the currently hidden
                // displayNode, but since it's hidden, it's impossible to
                // unhide it, focus it, and then have the browser focus
                // away from it to the next focusable element since each
                // of these events is asynchronous and the focus-to-next-element
                // is already queued.
                // So we allow the browser time to unqueue the move-focus event
                // before we do all the hide/show stuff.
            }
        },

        _onCancel: function () {
            this.cancel();

            // reset editor value
            this.editorWidget.set("value", this.value);

            if (this._dialog.open) {
                this._dialog.hide();
            }
        },

        _onChange: function () {
            this.inherited(arguments);

            if (this.closeOnChange) {
                this._stopEdit();
            }
        },

        _onHide: function () {
            if (this.editing) {
                this._stopEdit();
            }
        },

        startEdit: function () {
            this.inherited(arguments);
            this._dialog.show();
        },

        _stopEdit: function () {
            this.inherited(arguments);

            if (this._dialog.open) {
                this._dialog.hide();
            }
        },

        _setTitleAttr: function (title) {

            if (this._dialog) {
                this._dialog.set("title", title);
            }

            this._set("title", title);
        }
    });

});
},
'epi-cms/contentediting/_EditorWrapperBase':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dijit/_Widget",

    "epi/epi"
],

function (
    declare,
    lang,

    _Widget,
    epi
) {
    return declare([_Widget], {
        // summary:
        //		Base class for all editor wrappers.

        // wrapperType: [public] String
        //    Editor wrapper type name
        wrapperType: "",

        // editorWidgetType: [public] String
        //    Editor widget type
        editorWidgetType: null,

        // editorParams: [public] Null|Object
        //    Editor widget's parameters
        editorParams: null,

        // editing: Boolean
        editing: false,

        // disabled: Boolean
        disabled: false,

        // blockDisplayNode: DomNode
        //		The node for the editable block
        blockDisplayNode: null,

        // editorWidget: dijit._Widget|Object
        //		The editor for the value
        editorWidget: null,

        // isModified: Bool
        //		Indicates if we have triggered any saves while we edited value
        isModified: false,

        // _resetValue: [private] String|Object
        //      The value when as a string we started to edit
        _resetValue: null,

        // _lastSavedValue: [private] Object
        //      The last saved value
        _lastSavedValue: null,

        // _createdEditor: [private] Bool
        //      Set to true if we created our editor and must destroy it
        _createdEditor: false,

        propertyName: "",
        propertyDisplayName: "",

        // overlayItem: Overlay item
        //      Property overlay layer
        overlayItem: null,

        // isOverlayDisabled: Boolean
        //      Flags that used to disable overlay (or not) when the editor wrapper is running.
        isOverlayDisabled: false,

        // isUndoDisabled: Boolean
        //      Flags that used to disable undo when the editor wrapper is running.
        isUndoDisabled: false,

        // hasInlineEditor: Boolean
        //      A value indicating if the wrapped editor is editing inline, i.e. On-Page-Editing. 
        //      False by default.
        hasInlineEditor: false,

        // contentModel: dojo.Stateful
        //     The content model to observe changes
        contentModel: null,

        onStartEdit: function (sender, data) {
            // summary:
            //		Set this handler to be notified when editing is started.
            //
            // sender:
            //      The wrapper which triggered this event
            //
            // tags:
            //		callback
        },

        onValueChange: function (sender, value, oldValue) {
            // summary:
            //    Triggered when the an undo step is added.
            //
            // sender:
            //      The wrapper which triggered this event
            //
            // value: String|Object
            //      The value
            // oldValue: String|Object
            //      The old value
            //
            // tags:
            //      public callback
        },

        onCancel: function (sender) {
            // summary:
            //		Set this handler to be notified when editing is cancelled.
            //
            // sender:
            //      The wrapper which triggered this event
            //
            // tags:
            //		callback
        },

        onStopEdit: function (sender, value, oldValue) {
            // summary:
            //		Set this handler to be notified when editing is finished.
            // tags:
            //		callback
        },

        postCreate: function () {
            this.inherited(arguments);

            this._contentModelWatchHandle = this.contentModel.watch(this.propertyName, lang.hitch(this, "contentModelChanged"));
        },

        destroy: function () {
            this._contentModelWatchHandle.unwatch();

            if (this._createdEditor && this.editorWidget) {
                this.editorWidget.destroyRecursive();
            }

            if (this.editorWidget) {
                this.editorWidget.parent = null;
            }

            this.blockDisplayNode = this.overlayItem = this.editorWidget = null;

            this.inherited(arguments);
        },

        contentModelChanged: function (name, oldValue, value) {
            // Only set the value when we are editing
            if (!this.editing) {
                this.set("value", value);
            }
        },

        startEdit: function (additionParams) {
            this._startEdit(additionParams);
        },

        _startEdit: function (additionParams) {
            lang.mixin(this.editorParams, additionParams);

            // Implemented by sub class
            this.set("editing", true);

            // reset value
            this.set("isModified", false);

            // store old value
            this._lastSavedValue = this._resetValue = lang.clone(this.getEditorValue());

            // Cause validation to ensure the widget shows the latest validation messages
            this.isValid();

            this.onStartEdit(this, this.editorParams);
        },

        _stopEdit: function (implicitExit) {
            // Implemented by sub class
            this.set("editing", false);
            this._removeEditingFeatures();

            this.onStopEdit(this, this.getEditorValue(), this._resetValue, implicitExit);
        },

        cancel: function () {
            // force reset of value

            if (this.isModified) {
                // If property is modified then do a final save with the reset value.
                this.save(this._resetValue);
            } else {
                // Else set the value in the wrapper to the reset value.
                this.set("value", this._resetValue);
            }

            this.set("editing", false);
            this._removeEditingFeatures();

            this.onCancel(this);
        },

        save: function (/*String|Object*/val) {
            // keep track that save has been done
            this.set("value", val);
            this.set("isModified", true);
            this.onValueChange(this, val, this._lastSavedValue);
            this._lastSavedValue = lang.clone(val);
        },

        hasBeenEdited: function () {
            return this.editing && (!epi.areEqual(this.getEditorValue(), this._resetValue));
        },

        hasPendingChanges: function () {
            return this.editing && (!epi.areEqual(this.getEditorValue(), this._lastSavedValue));
        },

        tryToStopEditing: function (implicitExit) {
            // summary:
            //		Try to stop editing, if the value has changed, editing is stopped
            //      otherwise editing is cancelled
            // tags:
            //		public

            if (this.editing) {
                if (this.isValid()) {
                    if (this.hasBeenEdited()) {
                        if (this.hasPendingChanges()) {
                            this.save(this.getEditorValue());
                        }
                        this._stopEdit(implicitExit);
                    } else {
                        this.cancel(implicitExit);
                    }
                } else {
                    this._onTryToStopWithInvalidValue();
                }
            }
        },

        _removeEditingFeatures: function () {
            // summary:
            //		This is should be implemented by sub class, it's purpose is to
            //      restore state as it was before editing was started.
            // tags:
            //		protected
        },

        _onTryToStopWithInvalidValue: function () {
            // summary:
            //      do nothing, implemented by sub class
            // tags:
            //		protected
            //
        },

        _onEditorKeyPress: function (e) {
            // summary:
            //		Handler for keypress in editor.
            // description:
            //		For autoSave widgets, if Esc/Enter, call cancel/save.
            // tags:
            //		protected

            if (this.editing) {
                if (e.altKey || e.ctrlKey) { return; }
                // If Enter/Esc pressed, treat as save/cancel.
                if (e.keyCode == dojo.keys.ESCAPE) {
                    dojo.stopEvent(e);
                    this.cancel(); // sets editing=false which short-circuits _onBlur processing
                } else if (e.keyCode == dojo.keys.ENTER && e.target.tagName == "INPUT") {
                    dojo.stopEvent(e);

                    // stop editing
                    this.tryToStopEditing(false);
                }

                // _onBlur will handle TAB automatically by allowing
                // the TAB to change focus before we mess with the DOM: #6227
                // Expounding by request:
                //	The current focus is on the edit widget input field.
                //	save() will hide and destroy this widget.
                //	We want the focus to jump from the currently hidden
                //	displayNode, but since it's hidden, it's impossible to
                //	unhide it, focus it, and then have the browser focus
                //	away from it to the next focusable element since each
                //	of these events is asynchronous and the focus-to-next-element
                //	is already queued.
                //	So we allow the browser time to unqueue the move-focus event
                //	before we do all the hide/show stuff.
            }
        },

        _onChange: function (val) {
            if (this.editing && this.isValid() && this.hasPendingChanges()) {
                this.save(val);
            }
        },

        getEditorWidget: function () {
            return this.editorWidget;
        },

        getEditorValue: function () {
            // summary:
            //		Return the [display] value of the edit widget
            var ew = this.editorWidget;

            if (ew) {
                return ew.get("value");
            }
            return null;
        },

        setEditorValue: function (val) {
            // summary:
            //		Set the [display] value of the edit widget
            var ew = this.editorWidget;

            if (ew && !epi.areEqual(val, ew.get("value"))) {
                ew.set("value", val);
            }
        },

        _setValueAttr: function (value) {
            this.setEditorValue(value);

            // Get the value back as the editor will return it
            this._set("value", this.getEditorValue() || value);
        },

        isValid: function () {
            // summary:
            //		User overridable function returning a Boolean to indicate
            //		if the Save button should be enabled or not - usually due to invalid conditions
            // tags:
            //		extension
            return (
                this.editorWidget && this.editorWidget.isValid
                ? this.editorWidget.isValid()
                : true
            );
        },

        focus: function () {
            // summary:
            //		Focus the edit widget.
            // tags:
            //		protected

            this.editorWidget.focus();
            setTimeout(lang.hitch(this, function () {
                if (this.editorWidget.focusNode && this.editorWidget.focusNode.tagName == "INPUT") {
                    dijit.selectInputText(this.editorWidget.focusNode);
                }
            }), 0);
        }
    });
});
},
'epi-cms/contentediting/EditActionPanel':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-attr",

    "dijit/_CssStateMixin",
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/DropDownButton",

    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/PublishMenu",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/string",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel",
    "dojo/text!./templates/EditActionPanel.html"
],

function (
    declare,
    lang,
    domStyle,
    domClass,
    domAttr,

    _CssStateMixin,
    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,
    DropDownButton,

    ContentActionSupport,
    PublishMenu,
    _ModelBindingMixin,
    string,

    res,
    template
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _CssStateMixin, _ModelBindingMixin], {

        templateString: template,

        commonRes: epi.resources,

        // baseClass: [protected] String
        //		Root CSS class of the widget.
        baseClass: "epi-statusIndicator",

        // Declare view model binding
        modelBindingMap: {
            "state": ["state"],
            "statusText": ["statusText"],
            "visible": ["visible"],
            "buttonText": ["buttonText"],
            "nonEditableIndicator": ["nonEditableIndicator"],
            "statusIcon": ["statusIcon"],
            "publishMenuViewModel": ["publishMenuViewModel"],
            "additionalClass": ["additionalClass"],
            "expanded": ["expanded"]
        },

        // statusText: [protected] String
        //      Content status text.
        _setStatusTextAttr: function(statusText) {
            this._set("statusText", statusText);

            this._setStatusNodeText(statusText);
        },

        _setStatusNodeText: function (/*String*/ statusText) {
            // summary: 
            //      Updates the content status indication with the supplied text
            // tags: private

            this.statusTextNode.innerHTML = statusText;

            domAttr.set(this.stateNode, "title", !this.expanded ? string.stripHtmlTags(statusText) : "");
        },

        // buttonText: [protected] String
        //      Publish button label.
        _setButtonTextAttr: function (val) {
            this.dropDownButton.set("label", val);
        },

        // visible: [protected] Boolean
        //      Visibility of the widget.
        _setVisibleAttr: function (val) {
            domStyle.set(this.domNode, "visibility", val ? "visible" : "hidden");
        },

        _setExpandedAttr: function(expanded) {
            this._set("expanded", expanded);

            this._setStatusNodeText(this.statusText);
        },

        // nonEditableIndicator: [protected] Boolean
        //      Visibility of the noneditable indicator.
        _setNonEditableIndicatorAttr: function (val) {
            if (val) {
                domClass.add(this.statusNonEditableIcon, "epi-iconPenDisabled");
            } else {
                domClass.remove(this.statusNonEditableIcon, "epi-iconPenDisabled");
            }
        },

        // statusIcon: [protected] String
        //      Content status icon.
        _setStatusIconAttr: function (val) {
            domStyle.set(this.statusTextIcon, "class", "dijitInline dijitReset dijitIcon " + val);
        },

        _setAdditionalClassAttr: function (val) {
            // remove
            var currentAdditionalClass = this.get("additionalClass");
            if (currentAdditionalClass) {
                domClass.remove(this.stateNode, currentAdditionalClass);
            }
            // add new
            this._set("additionalClass", val);
            domClass.add(this.stateNode, val);
        },

        focus: function () {
            // summary: 
            //      Set focus on the widget
            // description: 
            //      The dropdown menu will be the one takes focus when the widget become focused.

            this.dropDownButton.focus();
        },

        _setPublishMenuViewModelAttr: function (val) {
            this.dropDownMenu.set("model", val);
        },

        postCreate: function () {
            this.inherited(arguments);

            // align dropdown menu open on the left of the button
            this.dropDownButton.dropDownPosition = ["below-alt"];
        }
    });
});
},
'epi-cms/contentediting/PublishMenu':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/html",
    "dojo/on",
    "dojo/sniff",
    "dojo/Stateful",
    "dojo/when",

// Dijit
    "dijit/DropDownMenu",
    "dijit/_KeyNavContainer",
    "dijit/_WidgetsInTemplateMixin",

// EPi Framework
    "epi",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/command/builder/MenuBuilder",
    "epi/shell/Downloader",

// EPi CMS
    "epi-cms/contentediting/ContentActionSupport",

// Resources
    "dojo/text!./templates/PublishMenu.html",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel.publishactionmenu"
],

function (
// Dojo
    array,
    declare,
    event,
    lang,
    domStyle,
    domAttr,
    domClass,
    domGeometry,
    html,
    on,
    sniff,
    Stateful,
    when,

// Dijit
    DropDownMenu,
    _KeyNavContainer,
    _WidgetsInTemplateMixin,

// EPi Framework
    epi,
    TypeDescriptorManager,
    _ModelBindingMixin,
    MenuBuilder,
    Downloader,

// EPi CMS
    ContentActionSupport,

// Resources
    template,
    res
) {
    return declare([DropDownMenu, _WidgetsInTemplateMixin, _ModelBindingMixin], {
        templateString: template,
        res: res,

        _menuBuilder: null,

        // Binding properties
        commands: null,
        mainButtonCommand: null,

        postMixInProperties: function () {
            this._menuBuilder = new MenuBuilder();
        },

        // Binding map
        modelBindingMap: {
            "commands": ["commands"],
            "mainButtonCommand": ["mainButtonCommand"],

            "mainButtonSectionVisible": ["mainButtonSectionVisible"],

            "lastChangeStatus": ["lastChangeStatus"],

            "topInfoSectionVisible": ["topInfoSectionVisible"],

            "publishInfoSectionVisible": ["publishInfoSectionVisible"],
            "lastPublishedTitle": ["lastPublishedTitle"],
            "lastPublishedTitleVisible": ["lastPublishedTitleVisible"],
            "lastPublishedText": ["lastPublishedText"],
            "lastPublishedViewLinkVisible": ["lastPublishedViewLinkVisible"],
            "lastPublishedViewLinkHref": ["lastPublishedViewLinkHref"],

            "additionalInfoSectionVisible": ["additionalInfoSectionVisible"],
            "additionalInfoText": ["additionalInfoText"],

            "typeIdentifier": ["typeIdentifier"]
        },

        _setCommandsAttr: function (commands) {
            // Move focus away from current menu item, which may be removed after command executed.
            this.focusedChild = null;

            //Remove all children first
            var children = this.getChildren();
            array.forEach(children, function (item) {
                this.removeChild(item);
            }, this);
            this.destroyDescendants();

            this._addCommandsToMenu(commands);

            // Set focus on the main button or the first focusable item.
            this.focusFirstChild();
        },

        _setMainButtonCommandAttr: function (command) {
            this._set("mainButtonCommand", command);
            if (command) {
                this.mainButton.set("label", command.label);
                this.mainButton.set("disabled", !command.get("canExecute"));
                domClass.remove(this.mainButton.domNode, "epi-loading");

                if (this._addedMainButtonClass) {
                    domClass.remove(this.mainButton.domNode, this._addedMainButtonClass);
                }

                if (command.options && command.options.mainButtonClass) {
                    this._addedMainButtonClass = command.options.mainButtonClass;
                    domClass.add(this.mainButton.domNode, this._addedMainButtonClass);
                }
            }
        },

        _setMainButtonSectionVisibleAttr: function (visible) {
            domStyle.set(this.mainButtonSection, "display", visible ? "" : "none");

            // When hiding the main button section, we have to also hide the main button. Otherwise it is still focusable.
            domStyle.set(this.mainButton.domNode, "display", visible ? "" : "none");
        },

        _setLastChangeStatusAttr: {
            node: "lastChangeStatusNode",
            type: "innerHTML"
        },

        _setTopInfoSectionVisibleAttr: function (visible) {
            domStyle.set(this.topInfoSection, "display", visible ? "" : "none");
        },

        _setPublishInfoSectionVisibleAttr: function (visible) {
            domStyle.set(this.publishInfoSection, "display", visible ? "" : "none");
        },

        _setLastPublishedTitleAttr: {
            node: "lastPublishedTitleNode",
            type: "innerHTML"
        },

        _setLastPublishedTitleVisibleAttr: function (visible) {
            domStyle.set(this.lastPublishedTitleNode, "display", visible ? "" : "none");
        },

        _setLastPublishedTextAttr: {
            node: "lastPublishedTextNode",
            type: "innerHTML"
        },

        _setLastPublishedViewLinkVisibleAttr: function (visible) {
            domStyle.set(this.lastPublishedViewLinkNode, "display", visible ? "" : "none");
        },

        _setLastPublishedViewLinkHrefAttr: function (value) {
            domAttr.set(this.lastPublishedViewLinkNode, "href", value);
        },

        _setAdditionalInfoSectionVisibleAttr: function (visible) {
            domStyle.set(this.additionalInfoSection, "display", visible ? "" : "none");
        },

        _setAdditionalInfoTextAttr: {
            node: "additionalInfoNode",
            type: "innerHTML"
        },

        _setTypeIdentifierAttr: function (/*String*/typeIdentifier) {

            var contentData = this.model && this.model.dataModel && this.model.dataModel.contentData,
                isDowloadLinkAvaiable = contentData && contentData.downloadUrl,
                typeShouldActAsAsset = typeIdentifier && TypeDescriptorManager.getValue(typeIdentifier, "actAsAnAsset");

            if (!typeShouldActAsAsset || !isDowloadLinkAvaiable) {
                // Restore default view
                domAttr.set(this.lastPublishedViewLinkNode, "title", res.lastpublishedviewlinktooltip);
                html.set(this.lastPublishedViewLinkNode, res.view);

                // Clear event handler
                if (this._downloadClickHandler) {
                    this._downloadClickHandler.remove();
                    this._downloadClickHandler = null;
                }
                return;
            }

            domAttr.set(this.lastPublishedViewLinkNode, "title", res.download);
            html.set(this.lastPublishedViewLinkNode, res.download);

            // Listen on click event to start download by Downloader
            if (!this._downloadClickHandler) {
                this.own(this._downloadClickHandler = on(this.lastPublishedViewLinkNode, "click", lang.hitch(this, function (e) {
                    event.stop(e);

                    // Should re-calculate to get correct contentData because event listense is added one time
                    // and used for multiple time (for different kinds of content).
                    var contentData = this.model && this.model.dataModel && this.model.dataModel.contentData,
                        url = contentData && contentData.downloadUrl,
                        name = contentData.name;

                    Downloader.download(url, name);
                })));
            }
        },

        postCreate: function () {
            this.inherited(arguments);

            // The main button should behave like a normal menu item.
            // When focused item is the main button and user close the menu, these functions which are not implemented in dijit.form.Button will be called.
            // So we supply dummy ones.
            this.mainButton._setSelected = this.mainButton._onUnhover = function () { };
        },

        onOpen: function () {
            this.model.set("isOpen", true);
            this.inherited(arguments);
        },

        onClose: function () {
            this.model.set("isOpen", false);
            this.inherited(arguments);
        },

        _setModelAttr: function () {
            this.inherited(arguments);

            // No need to do a destroyByKey as _ModelBindingMixin
            this.ownByKey(this.model, this.connect(this.model, "onCommandsChanged", "onCommandsChanged"));
        },

        onCommandsChanged: function (name, removed, added) {
            // summary:
            //		Callback when available commands have been changed.
            // tags:
            //		public

            if (removed) {
                this._removeCommandsFromMenu(lang.isArray(removed) ? removed : [removed]);
            }
            if (added) {
                this._addCommandsToMenu(lang.isArray(added) ? added : [added]);
            }
        },

        _addCommandsToMenu: function (commands) {
            // summary:
            //		Transforms the commands into widgets and adds them to the toolbar.
            // tags:
            //		private

            array.forEach(commands, function (command) {
                if (command !== this.model.mainButtonCommand) {
                    this._menuBuilder.create(command, this);
                }
            }, this);
        },

        _removeCommandsFromMenu: function (commands) {
            // summary:
            //		Removes the commands from the toolbar.
            // tags:
            //		private

            var children = this.menu.getChildren();

            array.forEach(commands, function (command) {
                for (var i = children.length - 1; i >= 0; i--) {
                    var item = children[i];
                    if (item._command == command) {
                        this.removeChild(item);
                        break;
                    }
                }
            }, this);
        },

        _onMainButtonClick: function () {
            if (this.mainButtonCommand) {
                this.mainButton.set("label", this.mainButtonCommand.executingLabel);
                domClass.add(this.mainButton.domNode, "epi-loading");

                var resetMainButton = lang.hitch(this, function (failure) {
                    if (failure || this.mainButtonCommand.options && this.mainButtonCommand.options.resetLabelAfterExecution) {
                        this.mainButton.set("label", this.mainButtonCommand.label);
                    }
                    domClass.remove(this.mainButton.domNode, "epi-loading");

                    if (this.mainButtonCommand.options && !this.mainButtonCommand.options.keepMenuOpen) {
                        this.onExecute();
                    }
                }),
                setLastExecutedCommand = lang.hitch(this, function () {
                    this.model.set("lastExecutedCommand", this.mainButtonCommand);
                });

                when(this.mainButtonCommand.execute(), function () {
                    return when(resetMainButton(false), setLastExecutedCommand);
                }, function () {
                    return resetMainButton();
                });
            }
        },

        focusFirstChild: function () {
            // summary:
            //		Focus the first focusable child in the container.
            // tags:
            //		protected

            if (this.mainButton.isFocusable()) {
                return this.focusChild(this.mainButton);
            } else {
                return this.inherited(arguments);
            }
        },

        focusNext: function () {
            // summary:
            //		Focus the next widget
            // tags:
            //		protected

            var lastFocusableMenuItem = this._getLastFocusableChild();
            if (!this.focusedChild.focused) {
                return this.focusChild(this._getFirstFocusableChild());
            } else if (this.focusedChild === lastFocusableMenuItem) {
                this.focusedChild._setSelected(false);
                return domStyle.get(this.mainButton.domNode, "display") === "none" ?
                    this.lastPublishedViewLinkNode.focus() : this.focusChild(this.mainButton);
            } else if (this.focusedChild === this.mainButton) {
                return this.lastPublishedViewLinkNode.focus();
            } else {
                return this.inherited(arguments);
            }
        },

        focusPrev: function () {
            // summary:
            //		Focus the next widget
            // tags:
            //		protected

            var firstFocusableMenuItem = this._getFirstFocusableChild();
            if (!this.focusedChild.focused) {
                return domStyle.get(this.mainButton.domNode, "display") === "none" ?
                    this.focusChild(this._getLastFocusableChild()) : this.focusChild(this.mainButton);
            } else if (this.focusedChild === firstFocusableMenuItem) {
                this.focusedChild._setSelected(false);
                return this.lastPublishedViewLinkNode.focus();
            } else {
                return this.inherited(arguments);
            }
        },

        resize: function (marginBox) {
            // summary:
            //      Resize action menu fit to large of main button or menu item
            // tags:
            //      Protected

            // Get dom geometry
            var selfMargin = domGeometry.getMarginBox(this.domNode),
                topPadding = domGeometry.getPadExtents(this.topInfoSection),
                mainButtonMargin = domGeometry.getMarginBox(this.mainButton.containerNode),
                menuMargin = domGeometry.getMarginBox(this.containerNode);

            // Get max width of domNode, main button and menu item
            var maxWidth = Math.max(mainButtonMargin.w + topPadding.l + topPadding.r, selfMargin.w);
            maxWidth = Math.max(menuMargin.w, maxWidth);

            marginBox.w = maxWidth;
            domGeometry.setMarginBox(this.domNode, marginBox);
        }
    });
});

},
'url:epi-cms/contentediting/templates/PublishMenu.html':"﻿<div class=\"epi-invertedTooltip epi-publishActionMenu\" role=\"menu\" tabIndex=\"${tabIndex}\" data-dojo-attach-event=\"onkeypress:_onKeyPress\" >\r\n    <div class=\"epi-tooltipDialogTop\" data-dojo-attach-point=\"topInfoSection\">\r\n        <ul>\r\n            <li data-dojo-attach-point=\"lastChangeStatusNode\" class=\"epi-lastchangeStatus\"></li>\r\n            <li data-dojo-attach-point=\"mainButtonSection\">\r\n                <button data-dojo-type=\"dijit/form/Button\" data-dojo-attach-point=\"mainButton\" data-dojo-attach-event=\"onClick: _onMainButtonClick\" class=\"epi-fullWidthButton\"></button>\r\n            </li>            \r\n        </ul>          \r\n        <div data-dojo-attach-point=\"lastPublishedIcon\" class=\"dijitTooltipConnector\"></div>\r\n    </div>\r\n    <div class=\"epi-tooltipDialogInfo\"data-dojo-attach-point=\"publishInfoSection\">\r\n        <ul>\r\n            <li data-dojo-attach-point=\"lastPublishedTitleNode\"></li>\r\n            <li>\r\n                <span data-dojo-attach-point=\"lastPublishedTextNode\"></span>\r\n            </li>\r\n            <li>\r\n                <a href=\"#\" title=\"${res.lastpublishedviewlinktooltip}\" data-dojo-attach-point=\"lastPublishedViewLinkNode\">${res.view}</a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n    <div class=\"epi-tooltipDialogInfo\" data-dojo-attach-point=\"additionalInfoSection\">\r\n        <ul>\r\n            <li data-dojo-attach-point=\"additionalInfoNode\"></li>\r\n        </ul>\r\n    </div>\r\n    <table class=\"dijitReset epi-tooltipDialogMenu epi-menuInverted\" cellspacing=\"0\">\r\n\t    <tbody data-dojo-attach-point=\"containerNode\" ></tbody>\r\n    </table>\r\n</div>\r\n",
'url:epi-cms/contentediting/templates/EditActionPanel.html':"﻿<div style=\"display: inline-block\">\r\n    <div class=\"dijitInline dijitReset\" data-dojo-attach-point=\"stateNode\">\r\n        <span data-dojo-attach-point=\"statusNonEditableIcon\" class=\"dijitInline dijitReset dijitIcon\">&nbsp;</span>\r\n        <span class=\"epi-statusContainer dijitInline dijitReset\">\r\n            <span data-dojo-attach-point=\"statusTextIcon\" class=\"dijitInline dijitReset dijitIcon\"></span>\r\n            <span data-dojo-attach-point=\"statusTextNode\" class=\"epi-statusText\"></span>\r\n        </span><span class=\"epi-statusArrow dijitInline dijitReset\"></span><!-- These need to be on the same line because of stupid. -->\r\n    </div>\r\n\r\n\r\n\r\n    <div data-dojo-attach-point=\"dropDownButton\" data-dojo-type=\"dijit/form/DropDownButton\"\r\n        data-dojo-props=\"label: '${commonRes.action.publish}', 'class': 'epi-mediumButton epi-boldButton'\">\r\n        <div data-dojo-attach-point=\"dropDownMenu\" data-dojo-type=\"epi-cms/contentediting/PublishMenu\"></div>\r\n    </div>\r\n</div>",
'epi-cms/contentediting/EditingBase':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/event",
    "dojo/_base/json",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/date/stamp",
    "dojo/dom-attr",
    "dojo/on",
    "dojo/query",
    "dojo/topic",
    "dojo/when",

// Dijit
    "dijit/_Widget",

// EPi Framework
    "epi/dependency",
    "epi/datetime",
    "epi/string",
    "epi/Url",
    "epi/shell/DestroyableByKey",

// EPi CMS
    "epi-cms/contentediting/_View",
    "epi-cms/contentediting/AutoSaveButton",
    "epi-cms/contentediting/MappingManager",
    "epi-cms/contentediting/RenderManager",
    "epi-cms/contentediting/UpdateController",
    "epi-cms/widget/overlay/overlayFactory",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting"
],

function (
// Dojo
    array,
    connect,
    declare,
    Deferred,
    dojoEvent,
    json,
    lang,

    aspect,
    date,
    domAttr,
    on,
    query,
    topic,
    when,

// Dijit
    _Widget,

// EPi Framework
    dependency,
    epiDate,
    epiString,
    Url,
    DestroyableByKey,

// EPi CMS
    _View,
    AutoSaveButton,
    MappingManager,
    RenderManager,
    UpdateController,
    overlayFactory,

// Resources
    res
) {
    return declare([_View, DestroyableByKey], {
        // toolbar: [epi.cms.contentediting.widget.EditToolbar]
        //      Edit toolbar intance.
        toolbar: null,

        // editorFactory: [epi-cms.contentediting.EditorFactory]
        //      Editor factory instance.
        editorFactory: null,

        // syncInterval: [Number]
        //      Set to positive number for auto save every millis.
        syncInterval: 10000,

        // activePropertyOnStartup: [String]
        //      Property to be set as active when edit view has done setting up.
        activePropertyOnStartup: null,

        // createOverlays: [Boolean]
        //      Indicate that the overlays should be created.
        createOverlays: true,

        _renderManager: null,

        _mappingManager: null,

        _activeEditorWrapper: null,

        _autoSaveButton: null,

        _reloadRequiredProperty: null,

        _eventHandlers: null,

        constructor: function () {
            this.defaultQueryParameters = {
                epieditmode: true
            };
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            this.editorFactory = this.editorFactory || dependency.resolve('epi.cms.contentediting.EditorFactory');

            this._mappingManager = new MappingManager();

            this._eventHandlers = [];
        },

        postCreate: function () {
            this.inherited(arguments);

            if (this.syncInterval > 0) {
                this._syncIntervalId = window.setInterval(lang.hitch(this, "_save"), this.syncInterval);
            }

            this.subscribe("/epi/cms/action/save", this._save);
            this.subscribe("/epi/cms/action/undo", this._undo);
            this.subscribe("/epi/cms/action/redo", this._redo);
            this.subscribe("/epi/cms/action/disableundoredoactions", this._toggleUndoRedoActions);
        },

        destroy: function () {
            this._unwatchViewModelHandles();
            this._stopActiveEditorWrapper();

            if (this._renderManager) {
                this._renderManager.destroy();
            }

            if (this._autoSaveButton) {
                this._autoSaveButton.destroyRecursive();
            }

            this._mappingManager.clear();

            if (this.toolbar) {
                this.toolbar = null;
            }

            if (this._syncIntervalId) {
                clearInterval(this._syncIntervalId);
            }

            this.inherited(arguments);
        },

        _setCommandEnabled: function (toolbarItemName, enabled) {
            if (this.toolbar) {
                this.toolbar.setItemProperty(toolbarItemName, "disabled", !enabled);
            }
        },

        onContentLinkSyncChange: function () {
            this.inherited(arguments);
            this._setButtonState();
        },

        _setViewModelAttr: function (viewModel) {
            if (viewModel === this.viewModel) {
                return;
            }

            this.inherited(arguments);

            //Disconnect all eventhandlers
            this.destroyByKey("viewModel");

            //Listen to onSuspend and stop editing the property and reset active editor
            this.ownByKey("viewModel", connect.connect(this.viewModel, "onContentChange", this, this._stopActiveEditorWrapper));

            // Listen on onSetActiveProperty event so can react when active property is about to set on ContentViewModel
            this.ownByKey("viewModel", connect.connect(this.viewModel, "onSetActiveProperty", this, this.onSetActiveProperty));

            this.ownByKey("viewModel", topic.subscribe("/dnd/start", lang.hitch(this.viewModel, "beginOperation")));
            this.ownByKey("viewModel", topic.subscribe("/dnd/stop", lang.hitch(this, function () {
                // If we have an active editor do not end the operation
                if (this._activeEditorWrapper) {
                    return;
                }
                this.viewModel.endOperation();
            })));
        },

        _stopActiveEditorWrapper: function () {
            if (this._activeEditorWrapper != null) {
                when(this._activeEditorWrapper.tryToStopEditing(), lang.hitch(this, function () {
                    this._activeEditorWrapper = null;
                }));
            }
        },

        onSetActiveProperty: function (property) {
            // summary:
            //      Triggered when active property is set on the current content view model.
            // property: [String]
            //      The property name.
            // tag:
            //      public, callback.

            var mapping = this._mappingManager.findOne("propertyName", property);
            if (mapping) {
                if (mapping.wrapper) {
                    mapping.wrapper.startEdit();
                } else if (mapping.overlayItem) {
                    this._onOverlayItemClick(mapping.overlayItem);
                }
            }
        },

        onPreviewReady: function (viewModel, doc) {
            // summary:
            //      Triggered when preview is ready.
            // viewModel: [epi.cms.contentediting.ContentViewModel]
            //      The content view model.
            // doc: [Document]
            //      The preview document.
            // tag:
            //      public, callback.

            if (viewModel != this.viewModel) {
                this.set("viewModel", viewModel);
                this.setupEditMode(doc);
            } else if (viewModel) {
                this.remapEditMode(doc);
            }
        },

        _setButtonState: function () {
            this._setCommandEnabled("reverttopublished", this.viewModel && !this.viewModel.contentData.isPendingPublish);
        },

        setupEditMode: function (doc) {
            // summary:
            //      Setup all neccessary stuffs for edit mode.
            // tag:
            //      protected

            this.viewModel.getContentModelAndMetadata().then(
                lang.hitch(this, function () {
                    // reset
                    this._mappingManager.clear();
                    this._renderManager = new RenderManager();

                    // create toolbar
                    if (this.toolbar && !this._autoSaveButton) {
                        this._autoSaveButton = new AutoSaveButton({
                            button: this.toolbar._getWidget("autosave")
                        });
                    }

                    this.own(aspect.after(this._autoSaveButton, "onLayoutChanged", lang.hitch(this, function () {
                        this.mainLayoutContainer.layout();
                    })));
                    this._autoSaveButton.set("model", this.viewModel);

                    var updateUndoRedo = lang.hitch(this, function () {
                        this._toggleUndoRedoActions(this.viewModel.hasUndoSteps, this.viewModel.hasRedoSteps);
                    });

                    this.viewModel.resetNotifications();

                    // remove existing handles
                    this._unwatchViewModelHandles();

                    this._viewModelHandles = [
                        this.viewModel.watch("hasUndoSteps", updateUndoRedo),
                        this.viewModel.watch("hasRedoSteps", updateUndoRedo)
                    ];

                    // Get initial values
                    updateUndoRedo();

                    this.onReadySetupEditMode(doc);

                    //reset Publish button
                    this._setButtonState();

                    this.onPrepareOverlayComplete();
                })
            );
        },

        remapEditMode: function (doc) {
            // summary:
            //      Re configure edit mode after the preview context changed.
            // tag:
            //      protected

            this.viewModel.getMetadataThenUpdateModel().then(lang.hitch(this, function () {
                this._renderManager.resume();

                // When loading blocks that required reload, wait for blocks rendered then remap update controller
                if (doc) {
                    setTimeout(lang.hitch(this, function () {
                        this._remapUpdateControllers(doc);
                        this.onPrepareOverlayComplete();
                        this._toggleUndoRedoActions(this.viewModel.hasUndoSteps, this.viewModel.hasRedoSteps);

                        this._autoSaveButton.set("model", this.viewModel);
                    }), 1);
                }
            }));
        },

        _unwatchViewModelHandles: function () {
            if (this._viewModelHandles) {
                array.forEach(this._viewModelHandles, function (handle) { handle.unwatch(); });
                this._viewModelHandles = null;
            }
        },

        onReadySetupEditMode: function (doc) {
            // summary:
            //    Edit mode is ready for setting up.
            //
            // description:
            //    Setup editable blocks. Override to do extra setup, for example: set up form editing.
            //
            // propertyMetadataMap: Object
            //    Property metadata hashmap.
            //
            // tags:
            //    protected

            this._createUpdateControllers(doc);
        },

        onSetupEditModeComplete: function () {
            // summary:
            //      Triggered when edit mode is successfully set up.
            // remark:
            //      Should be fired by concrete edit view when it finishes preparations.
            // tag:
            //      public, callback.

            // Set active property if exists.
            if (this.activePropertyOnStartup) {
                this.onSetActiveProperty(this.activePropertyOnStartup);
                this.activePropertyOnStartup = null;
            }
        },

        _getPropertyNodes: function (doc) {
            var allNodes = query("[data-epi-property-name]", doc);
            var nestedNodes = query("[data-epi-property-name] [data-epi-property-name]", doc);

            return array.filter(allNodes, function (node) {
                // return the nodes that are not nested
                return nestedNodes.indexOf(node) === -1;
            });
        },

        _getEditableNodes: function (doc) {
            // summary:
            //    Create the editable blocks and wire up events.
            //
            // tags:
            //    private

            // Cannot inspect document, assume that we have no editable node.
            if (!doc || !this.viewModel.canChangeContent()) {
                return [];
            }

            var nodes = this._getPropertyNodes(doc);
            var result = [];

            array.forEach(nodes, function (node) {
                var propertyNodeName = epiString.pascalToCamel(domAttr.get(node, 'data-epi-property-name'));
                var propertyMetadata = this.viewModel.getPropertyMetaData(propertyNodeName);

                // Skip this property if we don't have metadata,
                // i.e. the template rendered a node we won't find in the model
                if (!propertyMetadata) {
                    return;
                }

                // Get the real property name from metadata, since the page property name may be the legacy name (e.g. pageName -> icontent_name)
                var propertyName = epiString.pascalToCamel(propertyMetadata.name);

                var propertyDisplayName = domAttr.get(node, 'data-epi-property-display-name');
                if (propertyDisplayName) {
                    propertyMetadata = lang.delegate(propertyMetadata, { displayName: propertyDisplayName });
                }

                if (propertyMetadata != null && propertyMetadata.showForEdit) {
                    // Extract block information from the data attributes
                    // add to result array

                    var renderSettings = {
                        cacheResults: true,
                        rerenderOnCancel: false,
                        propertyRenderSettings: domAttr.get(node, 'data-epi-property-rendersettings') || undefined,
                        useMvc: domAttr.has(node, 'data-epi-use-mvc') ? domAttr.get(node, 'data-epi-use-mvc').toLowerCase() === 'true' : false
                    };
                    renderSettings = lang.mixin(renderSettings, propertyMetadata.additionalValues.renderSettings);

                    var editorParams = domAttr.has(node, 'data-epi-property-editorsettings') ?
                                                json.fromJson(domAttr.get(node, 'data-epi-property-editorsettings')) : null;

                    var overlayParams = domAttr.has(node, 'data-epi-property-overlaysettings') ?
                                                json.fromJson(domAttr.get(node, 'data-epi-property-overlaysettings')) : null;

                    overlayParams = lang.mixin(overlayParams, propertyMetadata.overlaySettings);

                    result.push({
                        node: node,
                        disabled: (domAttr.get(node, 'data-epi-disabled') == "true"),
                        useOverlay: (domAttr.get(node, 'data-epi-useoverlay') == "true"),
                        overlayZIndex: parseInt(domAttr.get(node, 'data-epi-overlay-z-index'), 10) || 0,
                        property: {
                            name: propertyName,
                            contentLink: this.viewModel.contentLink,
                            contentModel: this.viewModel.contentModel,
                            type: domAttr.get(node, 'data-epi-property-type'),
                            wrapperType: domAttr.get(node, 'data-epi-property-edittype'),
                            editorParams: editorParams,
                            overlayParams: overlayParams,
                            editorWidgetType: domAttr.get(node, 'data-epi-property-editor'),
                            renderSettings: renderSettings,
                            rendererClass: (domAttr.get(node, 'data-epi-property-render') === 'client') ? 'epi.cms.contentediting.ClientRenderer' : propertyMetadata.customEditorSettings.rendererClass,
                            metadata: propertyMetadata,
                            propertyNodeName: propertyNodeName
                        }
                    });
                }
            }, this);

            // sort editable nodes depending on z-index-hint
            result.sort(function (a, b) {
                // use reverse index, higher values later in array
                if (a.overlayZIndex < b.overlayZIndex) {
                    return -1;
                } else if (a.overlayZIndex > b.overlayZIndex) {
                    return 1;
                } else {
                    return 0;
                }
            });

            return result;
        },

        _createUpdateControllers: function (doc) {
            // summary:
            //    Create the editable blocks and wire up events.
            //
            // doc: Document
            //    Document where to get editable blocks.
            //
            // tags:
            //    private

            //Create a full page update controller
            var fullpageUpdateController = this._createFullPageUpdateController(doc);
            if (fullpageUpdateController) {
                this._connectUpdateControllerAndOverlayEvents(fullpageUpdateController, null);
                this._mappingManager.add({
                    updateController: fullpageUpdateController
                });
            }

            //Create update controllers for nodes
            var editableNodes = this._getEditableNodes(doc);
            array.forEach(editableNodes, function (editableNode) {
                var property = editableNode.property;
                var nodeHTML = editableNode.node.innerHTML;
                var updateController = this._createNodeUpdateController(editableNode);

                when(this._createNodeOverlay(editableNode), lang.hitch(this, function (overlayItem) {
                    this._connectUpdateControllerAndOverlayEvents(updateController, overlayItem);
                    // create mapping
                    this._mappingManager.add({
                        blockPropertyInfo: property,
                        node: editableNode.node,
                        updateController: updateController,
                        overlayItem: overlayItem
                    });
                }));

                //Cache the block's initial rendering.
                this._renderManager.cacheRender(property.name, property.renderSettings, this.viewModel.getProperty(property.name), nodeHTML);
            }, this);
        },

        _createNodeOverlay: function (editableNode) {
            // summary:
            //      Change to use dojo/Deferred because of overlayFactory now use this way

            var deferred = new Deferred();

            // Don't create overlay
            if (!this.createOverlays) {
                deferred.resolve(null);
                return deferred;
            }

            when(overlayFactory.create(editableNode), lang.hitch(this, function (overlayItem) {
                this.overlay.addChild(overlayItem);
                deferred.resolve(overlayItem);
            }));

            return deferred;
        },

        _createNodeUpdateController: function (editableNode) {
            var property = editableNode.property;
            var metadata = property.metadata;

            // Create block
            var updateController = new UpdateController({
                displayName: metadata.displayName,
                renderManager: this._renderManager,
                contentModel: property.contentModel,
                contentLink: property.contentLink,
                modelPropertyName: property.name,
                nodePropertyName: property.propertyNodeName,
                renderSettings: property.renderSettings,
                rendererClass: property.rendererClass,
                displayNode: editableNode.node
            });

            return updateController;
        },

        _createFullPageUpdateController: function (doc) {
            var fullreloadProperties = [];

            // Get full page reload properties from template
            if (doc) {
                var metaTags = query("input[data-epi-full-refresh-property-names][type='hidden']", doc);
                array.forEach(metaTags, function (tag) {
                    array.forEach(domAttr.get(tag, "data-epi-full-refresh-property-names").split(","), function (propertyName) {
                        if (!array.some(fullreloadProperties, function (p) { return p === propertyName; })) {
                            fullreloadProperties.push(epiString.pascalToCamel(propertyName));
                        }
                    });
                });
            }

            // Get full page reload properties from metadata
            array.forEach(this.viewModel.metadata.properties, function (property) {
                if (property.additionalValues["reloadOnChange"] === true) {
                    fullreloadProperties.push(epiString.pascalToCamel(property.name));
                }
            });

            if (!fullreloadProperties.length) {
                return null;
            }
            //create a full page update controller
            var pageUpdateController = new UpdateController({
                displayName: "",
                renderManager: this._renderManager,
                contentModel: this.viewModel.contentModel,
                modelPropertyName: fullreloadProperties,
                renderSettings: { isFullReload: true }
            });

            return pageUpdateController;
        },

        _remapUpdateControllers: function (doc) {
            var editableNodes = this._getEditableNodes(doc);

            // Remap update controller that connected to old nodes. Also remove the old fullpage update controller
            var unmappedNodes = this._mappingManager.remap(editableNodes);

            //Create new update controllers for nodes that was newly added
            array.forEach(unmappedNodes, function (editableNode) {
                var property = editableNode.property;
                var updateController = this._createNodeUpdateController(editableNode);

                // update mapping
                var mappings = this._mappingManager.find(function (m) {
                    return (m.updateController === undefined || m.updateController === null) && (m.propertyName.indexOf(property.name) === 0);
                });

                when(this._createNodeOverlay(editableNode), lang.hitch(this, function (overlayItem) {
                    this._connectUpdateControllerAndOverlayEvents(updateController, overlayItem);
                    if (mappings && mappings.length) {
                        this._mappingManager.update(mappings[0], {
                            updateController: updateController,
                            overlayItem: overlayItem,
                            node: editableNode.node
                        });
                    }
                    else {
                        this._mappingManager.add({
                            blockPropertyInfo: property,
                            node: editableNode.node,
                            updateController: updateController,
                            overlayItem: overlayItem
                        });
                    }
                }));

                //Cache the block's initial rendering.
                this._renderManager.cacheRender(property.name, property.renderSettings, this.viewModel.getProperty(property.name), editableNode.node.innerHTML);
            }, this);

            // Recreate new fullpage update controller
            var fullpageUpdateController = this._createFullPageUpdateController(doc);
            if (fullpageUpdateController) {
                this._connectUpdateControllerAndOverlayEvents(fullpageUpdateController, null);
                this._mappingManager.add({
                    updateController: fullpageUpdateController
                });
            }
        },

        _connectUpdateControllerAndOverlayEvents: function (updateController, overlayItem) {
            if (updateController) {
                this.connect(updateController, "onReloadRequired", this._onBlockReloadRequired);
                this.connect(updateController, "onRender", this._onBlockRender);
            }
            if (overlayItem) {
                this.connect(overlayItem, "onClick", this._onOverlayItemClick);
                this.connect(overlayItem, "onValueChange", function (value) {
                    this._onOverlayValueChange(overlayItem, value);
                });
            }
        },

        _getEditor: function (/*Object*/overlayItem) {
            // summary:
            //      Get wrapper editor
            // overlayItem:
            //      Current overlay item that accepting drop
            // tags:
            //      private

            var mapping = this._mappingManager.findOne("overlayItem", overlayItem);

            return (mapping.wrapper && mapping.wrapper.editorWidget) ? mapping.wrapper.editorWidget : null;
        },

        onEditorWrapperCreated: function (/*Object*/editorWrapper) {
            // summary:
            //      Triggered when the active editor wrapper created.
            //
            // editorWrapper:
            //      The created editor wrapper
            //
            // tags:
            //    public, callback
        },

        _onOverlayItemClick: function (overlayItem, e) {
            // Force the event to stop
            if (e) {
                dojoEvent.stop(e);
            }

            var mapping = this._mappingManager.findOne("overlayItem", overlayItem);

            var property = mapping.blockPropertyInfo;
            var val = this.viewModel.getProperty(mapping.propertyName);

            var value = lang.clone(val, true);

            var wrapper;

            var wrapperCreated = lang.hitch(this, function (wrapper) {
                // store wrapper if we want to reuse it
                mapping.wrapper = wrapper;
                this._activeEditorWrapper = wrapper;

                topic.publish("/epi/layout/pinnable/propertyEditor/show", null);

                // TODO: force a save for legacy properties? or close open currentWrapper
                // if saving: use deferred to not open this wrapper until save is done

                array.forEach(this._mappingManager.find(), function (m) {
                    if (m.overlayItem) {
                        m.overlayItem.set("active", false);
                    }
                });

                mapping.overlayItem.set("active", true);

                // start editing
                var editorParams = { value: value, parent: wrapper };
                wrapper.startEdit(editorParams);

                this.overlay.set("readOnly", wrapper.isOverlayDisabled);
                this.viewModel.set("disableUndo", wrapper.isUndoDisabled);
            });

            if (mapping.wrapper) {
                wrapper = mapping.wrapper;
                if (wrapper && wrapper.editorWidget && !wrapper.editorWidget.overlayItem) {
                    wrapper.editorWidget.overlayItem = overlayItem;
                }
                wrapper.set("blockDisplayNode", mapping.node);

                wrapperCreated(wrapper);
            } else {
                // create new wrapper
                when(this._createEditorWrapper(property, overlayItem, mapping.node, value), lang.hitch(this, function (wrapper) {
                    wrapperCreated(wrapper);
                    this.onEditorWrapperCreated(wrapper); 
                }));
            }
        },

        _createEditorWrapper: function (property, overlayItem, node, value) {
            // summary:
            //		Create editor wrapper for property in template.
            // description:
            //      By default, editor wrappers are created using EditorFactory. Override to implement custom creation, for example: FormEditing creates FormEditorWrapper all the times
            // tags:
            //		protected
            var def = new Deferred(),
                options = { overlayItem: overlayItem };

            when(this.editorFactory.createEditor(property, node, value, options), lang.hitch(this, function (wrapper) {
                this.connect(wrapper, "onValueChange", "_onWrapperValueChange");
                this.connect(wrapper, "onCancel", "_onWrapperCancel");
                this.connect(wrapper, "onStopEdit", "_onWrapperStopEdit");

                def.resolve(wrapper);
            }), def.reject);

            return def;
        },

        _onBlockReloadRequired: function (updateController) {
            // clear and suspend render manager after the watch handlers finished
            var rm = this._renderManager;
            setTimeout(function () {
                rm.suspend();
                rm.clear();
            }, 1);

            this._reloadRequiredProperty = updateController.modelPropertyName;

            this._reloadPropertyPreview();
        },

        _onBlockRender: function (updateController) {
            var mapping = this._mappingManager.findOne("updateController", updateController);

            if (mapping && mapping.overlayItem) {
                mapping.overlayItem.refresh();
            }
        },

        _saveEditorChanges: function (/*Object*/overlayItem, /*Object*/data) {
            // summary:
            //      Update active editor widget value
            // overlayItem:
            //      Current overlay item that accepting drop
            // data:
            //      Array of objects
            // tags:
            //      private

            var editor = this._getEditor(overlayItem);
            if (editor && !editor.overlayItem) {
                editor.overlayItem = overlayItem;
            }
            if (editor && editor.saveChanges) {
                editor.saveChanges(editor, data);
            }
        },

        _onOverlayValueChange: function (overlayItem, data) {
            // summary:
            //      Handler for single or multiple property changes
            // overlayItem: Object
            //      Current overlay item that accepting drop
            // data: Object || Array
            //      The properties to change n format {propertyName: "myName", value: propertyValue}
            // tags:
            //      Private

            this._saveEditorChanges(overlayItem, data.value);

            this.viewModel.setProperty(data.propertyName, data.value);
        },

        _onWrapperValueChange: function (wrapper, value, oldValue) {
            var mapping = this._mappingManager.findOne("wrapper", wrapper),
                propertyName = mapping.propertyName;
                // If this change from dnd then it will saved when "/dnd/stop"

            if (mapping.overlayItem) {
                mapping.overlayItem.set("updated", true);
            }

            // Begin an operation if not already started
            this.viewModel.beginOperation();

            // Save the property
            this.viewModel.setProperty(propertyName, value, oldValue);
        },

        _onWrapperStopEdit: function (wrapper, value, oldValue, implicitExit) {
            var mapping = this._mappingManager.findOne("wrapper", wrapper);

            // End the ongoing operation, commit the value
            this.viewModel.endOperation();
            this._save();

            if (mapping.overlayItem) {
                mapping.overlayItem.set("active", false);
            }

            this._activeEditorWrapper = null;
            this.overlay.set("readOnly", false);
            this.viewModel.set("disableUndo", false);
        },

        _onWrapperCancel: function (wrapper, implicitExit) {
            // Abort the current operation
            this.viewModel.abortOperation();

            var mapping = this._mappingManager.findOne("wrapper", wrapper);
            var updateController = mapping.updateController;

            // force rerender on block if it has rerenderOnCancel
            if (updateController && updateController.renderSettings && updateController.renderSettings.rerenderOnCancel) {
                updateController.render();
            }

            if (wrapper.get("isModified")) {
                // force a save onValueChanged has been called for this editable block
                this._save();
            }

            if (mapping.overlayItem) {
                mapping.overlayItem.set("active", false);
            }

            this._activeEditorWrapper = null;
            this.overlay.set("readOnly", false);
            this.viewModel.set("disableUndo", false);
        },

        _undo: function () {
            // summary:
            //    Undo changes
            //
            // tags:
            //    private

            setTimeout(lang.hitch(this, function () {
                this.viewModel.undo();
            }), 0);
        },

        _redo: function () {
            // summary:
            //   Redo the changes
            //
            // tags:
            //    private

            setTimeout(lang.hitch(this, function () {
                this.viewModel.redo();
            }), 0);
        },

        _toggleUndoRedoActions: function (hasUndoSteps, hasRedoSteps) {
            // summary:
            //   Disable Undo & Redo actions when selecting Schedule for Publish or Ready to Publish
            //
            // tags:
            //    private

            this._setCommandEnabled("undo", !!hasUndoSteps);
            this._setCommandEnabled("redo", !!hasRedoSteps);
        },

        _save: function () {
            // summary:
            //   Force a save on sync service
            //
            // tags:
            //    private

            if (!this.viewModel || !this.viewModel.hasPendingChanges) {
                return;
            }

            when(this.viewModel.save(), lang.hitch(this, this._reloadPropertyPreview));
        },

        _reloadPropertyPreview: function () {
            // summary:
            //   Reload preview of the property if needs
            //
            // tags:
            //    private

            if (!this.viewModel.isSaved) {
                this._save();
                return;
            }

            var isIntermediateChange = this._activeEditorWrapper && (this._activeEditorWrapper.propertyName === this._reloadRequiredProperty);

            var isEditingInline =  this._activeEditorWrapper && this._activeEditorWrapper.hasInlineEditor;

            // Do a full page reload for intermediate changes when not editing inline
            if (this._reloadRequiredProperty && !(isIntermediateChange && isEditingInline)) {
                this._toggleUndoRedoActions(false, false);
                this.onReloadRequired();
                this._reloadRequiredProperty = null;
            }
        }
    });
});
},
'epi-cms/contentediting/_View':function(){
﻿define([
"epi",
"dojo",
"dijit/_Widget",
"epi/Url"],

function (epi, dojo, _Widget, Url) {

    return dojo.declare([_Widget], {

        // iframeWithOverlay: [protected] epi.shell.widget.IframeWithOverlay
        //      The IframeWithOverlay widget
        iframeWithOverlay: null,

        overlay: null,

        // iFrame: [protected] epi.shell.widget.Iframe
        //      The iframe widget
        iFrame: null,

        // layoutContainer: [protected] Object
        //      The layout container
        layoutContainer: null,

        // contextTypeName: String
        //      Type name for the context we can handle
        contextTypeName: null,

        // viewModel: [protected] Object
        //      The content view model.
        viewModel: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            if (this.iframeWithOverlay) {
                this.iFrame = this.iframeWithOverlay.iframe;
                this.overlay = this.iframeWithOverlay.overlay;
            }

            this._viewConnections = [];
        },

        _setViewModelAttr: function (viewModel) {
            this._set("viewModel", viewModel);
        },

        _setIframeWithOverlayAttr: function (value) {
            this._set("iframeWithOverlay", value);
            this.iFrame = this.iframeWithOverlay.iframe;
            this.overlay = this.iframeWithOverlay.overlay;
        },

        onPreviewReady: function (viewModel, doc) {
            // summary:
            //  Event raised when a new document is loading in the inner iframe.
            //  Override or connect to to handle the situation when the preview is loaded.
            // remark:
            //  The corresponding context is succesfully loaded and ready to use.
            //  Be very carefull when call inherited on this method. 
            //  Because it has nothing to setup, overlay ready event is raised immediately which is not true in other view.
            //
            // url: string 
            //  url of the frame source
            // tag: callback, public

            this.set("viewModel", viewModel);
            this.onPrepareOverlayComplete();
        },

        onPrepareOverlayComplete: function () {
            // summary:
            //    Overlay preparation is complete
            //
            // tags:
            //    callback
        },

        onContentLinkSyncChange: function () {
            // summary:
            //  Called when the current content link changed. For example: edit a published common draft.
            //
            // tag: callback, public
        },

        onReloadRequired: function () {
            // summary:
            //  Event raised when the view require to be reloaded.
            //
            // tag: callback, public
        },

        // reloadParameters: [public] Object
        //      Indicates that the preview need to be reloaded.
        _setReloadRequiredAttr: function (value) {
            this._set("reloadRequired", value);
        }
    });

});

},
'epi-cms/contentediting/AutoSaveButton':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/string",
    "dijit/_WidgetBase",
    "epi/datetime",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons.autosave"
], function (
    array,
    connect,
    declare,
    lang,
    domClass,
    domStyle,
    string,
    _WidgetBase,
    epiDate, 
    res) {

    var ButtonStates = { Saving: 0, Offline: 1, Saved: 2 };

    return declare([_WidgetBase], {

        _state: null,

        button: undefined,

        lastSaved: undefined,

        model: null,

        _currentlySavingClass: 'epi-autosave-saving',
        _errorClass: 'epi-autosave-error',
        _savedClass: 'epi-autosave-saved',
        _hoverClass: 'epi-autosave-hover',

        _modelHandles: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            this._modelHandles = [];
        },

        postCreate: function () {
            this.inherited(arguments);

            if (!this.button) {
                return;
            }

            this.connect(this.button.domNode, "onmouseover", this._addHoverClass);
            this.connect(this.button.domNode, "onmouseout", this._removeHoverClass);
        },

        destroy: function () {
            // disconnect existing observers and events
            array.forEach(this._modelHandles, function (handle) { handle.unwatch(); });
            this.inherited(arguments);
        },

        _setModelAttr: function (model) {

            // disconnect existing observers and events
            array.forEach(this._modelHandles, function (handle) { handle.unwatch(); });

            this._set("model", model);

            // connect events
            if (model) {
                this._modelHandles = [
                    model.watch("isOnline", lang.hitch(this, "_isOnlineChanged")),
                    model.watch("lastSaved", lang.hitch(this, "_lastSavedChanged")),
                    model.watch("isSaved", lang.hitch(this, "_isSavedChanged")),
                    model.watch("isSaving", lang.hitch(this, "_isSavingChanged")),
                    model.watch("hasErrors", lang.hitch(this, "_hasErrorsChanged")),
                    model.watch("disableUndo", lang.hitch(this, this._disableUndo))
                ];

                this.set("lastSaved", model.lastSaved);

                if (this.lastSaved) {
                    this.updateButton();
                } else {
                    this._setVisibility(false);
                }
            }

        },

        _setLastSavedAttr: function (lastSaved) {
            this._set("lastSaved", lastSaved);
            this.updateLastSaveTime();
        },

        _disableUndo: function(propertyName, oldValue, value){
            this._isUndoDisabled = value;
            
            // Update the button status
            this.updateButton();
        },

        _isOnlineChanged: function (name, oldVal, newVal) {

            if (newVal === oldVal) {
                return;
            }

            if (newVal) {
                this.revertToLastAutoSaveTime();
            } else {
                this.showOfflineStatus();
            }
        },

        _lastSavedChanged: function (name, oldVal, newVal) {
            this.set("lastSaved", newVal);
        },

        _isSavedChanged: function (name, wasSaved, isSaved) {
            if (isSaved) {
                this.updateLastSaveTime();
            }
        },

        _isSavingChanged: function (name, wasSaving, isSaving) {

            if (isSaving) {
                this.showSavingStatus();
            } else {
                if (!this.model.isSaved) {
                    this.revertToLastAutoSaveTime();
                }
            }
        },

        _hasErrorsChanged: function (name, valueBefore, valueNow) {
            if (valueBefore === valueNow) {
                return;
            }

            if (!valueNow) {
                this.revertToLastAutoSaveTime();
            } else {
                // publish event to show error on NotificationStatusBar
                connect.publish("/epi/cms/action/showerror");
            }
        },

        _animateSaving: function () {
            domClass.replace(this.button.domNode, this._currentlySavingClass, [this._errorClass, this._savedClass]);
            this._removeHoverClass();
        },

        _animateOffline: function () {
            domClass.replace(this.button.domNode, this._errorClass, [this._currentlySavingClass, this._savedClass]);
            this._removeHoverClass();
        },

        _animateSaved: function () {
            domClass.replace(this.button.domNode, this._savedClass, [this._currentlySavingClass, this._errorClass]);
            this._removeHoverClass();
        },

        _addHoverClass: function () {
            // summary:
            //    Show border and background for the widget
            // tags:
            //    private

            if (this._state == null || this._state == ButtonStates.Saving || this._hasDropDownOpen()) {
                return;
            }
            if (this._state == ButtonStates.Saved) {
                domClass.add(this.button.domNode, this._hoverClass);
            }

        },

        _removeHoverClass: function () {
            // summary:
            //    Hide border and background for widget
            // tags:
            //    private

            if (!this._hasDropDownOpen()) {
                domClass.remove(this.button.domNode, this._hoverClass);
            }
        },

        _updateState: function (text) {
            // summary:
            //      - Change label of button
            //      - Set disabled or not for button
            // tages:
            //      private

            this.button.set("label", text);
            this.button.set("disabled", this._isUndoDisabled || this._state != ButtonStates.Saved);
            this._setVisibility(true);
        },

        _setVisibility: function (visible) {
            if (visible !== this._visible) {
                this._visible = visible;

                if (this.button) {
                    domStyle.set(this.button.domNode, { display: visible ? '' : 'none' });
                    this.button.set("itemVisibility", visible && !this.button.disabled);
                    if (this.button.isInNarrowToolbar) {
                        this.onLayoutChanged();
                    }
                }
            }
        },

        onLayoutChanged: function () {
            // summary:
            //      Notify layout change when the button is toggled on or off.
            // tags:
            //      public, callback
        },

        _hasDropDownOpen: function () {
            // summary:
            //      - Check button items are expanded or not
            // tags:
            //      private

            return this.button._popupStateNode ? domClass.contains(this.button._popupStateNode, "dijitHasDropDownOpen") : false;
        },

        revertToLastAutoSaveTime: function () {
            // summary:
            //      show time of the last successful saving or blank if there wasn't one

            if (this.lastSaved === undefined) {
                this._setVisibility(false);
                return;
            }

            this.updateLastSaveTime();
        },

        updateLastSaveTime: function () {
            // summary:
            //      Update the last auto save time

            if (!this.lastSaved) {
                return;
            }

            if (!this.model.isOnline) {
                return;
            }

            // Only change the time of last save when saving successful
            setTimeout(lang.hitch(this, function () {
                if(this.model.isOnline) {
                    this.updateButton();
                    this._animateSaved();
                }
            }), 1000);
        },

        showSavingStatus: function () {
            // summary:
            //  Show saving status

            this._state = ButtonStates.Saving;
            this._updateState(res.savinglabel);
            this._animateSaving();
        },

        showOfflineStatus: function () {
            // summary:
            //      show offline message when cannot save to server

            this._state = ButtonStates.Offline;
            this._updateState(res.offlinelabel);
            this._animateOffline();
        },

        updateButton: function () {
            // If there is no lastSaved, e.g. user's already published the content but due to annimation
            // this method in invoked after the content has been reloaded, autosave button should be hidden.
            // In case the content has been moved to trash, autosave button should be hidden, too.
            if (!this.lastSaved || (this.model.contentData && this.model.contentData.isDeleted)) {
                this._setVisibility(false);
                return;
            }
            this._state = ButtonStates.Saved;
            var template = '<span class="dijitReset dijitInline clearfix">${autosavelabel} ${timestamp}</span>&nbsp;<span class="epi-inlineButtonLink">${undolabel}</span>';
            var replaceMap = {
                autosavelabel: res.autosavelabel,
                undolabel: this.model.undoManager.get("hasUndoSteps") && !this._isUndoDisabled ? res.undolabel : "", //if undo is disabled hide the "Undo" text
                timestamp: epiDate.toUserFriendlyHtml(this.lastSaved, null, true)
            };
            this._updateState(string.substitute(template, replaceMap));
        }
    });
});

},
'epi-cms/contentediting/MappingManager':function(){
﻿define([
"dojo/_base/declare",
"dojo/_base/lang",
"dojo/_base/array",
"dojo/_base/json",
"dojo/_base/connect",
"dojo/dom-attr",
"dojox/encoding/digests/SHA1"],

function (declare, lang, array, json, connect, domAttr, SHA1) {
    // module:
    //		epi-cms/contentediting/MappingManager
    // summary:
    //		The mapping manager for editing stuffs.

    return declare(null, {
        // summary:
        //		Keeps track of relationship among editable blocks, overlay items, property info, and edit wrappers.

        _mappings: null,

        domUtils: null,

        attrNames: [
                "data-epi-property-name",
                "data-epi-property-display-names",
                "data-epi-property-customsettings-customtag",
                "data-epi-use-mvc",
                "data-epi-disabled",
                "data-epi-useoverlay",
                "data-epi-overlay-z-index",
                "data-epi-property-type",
                "data-epi-property-edittype",
                "data-epi-property-editorsetting",
                "data-epi-property-editor",
                "data-epi-property-render"],

        constructor: function () {
            // summary:
            //      Constructor.
            //
            // tags:
            //		public

            this._mappings = [];
            this.domUtils = domAttr;
        },

        clear: function () {
            // summary:
            //      Destroy all items in mappings.
            //
            // tags:
            //		public

            var mapping;

            try {
                while (mapping = this._mappings.pop()) {

                    for (var prop in mapping) {

                        if (mapping[prop]) {
                            if (prop !== "node") {

                                if (lang.isFunction(mapping[prop].destroyRecursive)) {
                                    mapping[prop].destroyRecursive();
                                } else if (lang.isFunction(mapping[prop].destroy)) {
                                    mapping[prop].destroy();
                                }

                            }

                            mapping[prop] = null;
                        }
                    }
                }
            } catch (ex) { }
        },

        _calculateNodeHash: function (node) {
            // summary:
            //		Calculate hash value for a dom node based on data-epi attributes.
            //
            // node: DomNode
            //      The dom node
            //
            // return: SHA1 hash string.
            //
            // tags:
            //		private

            if (!node) {
                return "";
            }
            var attrs = array.map(this.attrNames, dojo.hitch(this, function (n) { return this.domUtils.get(node, n) || ""; }));

            return SHA1(json.toJson(attrs));
        },

        update: function (mapping, patch) {
            // summary:
            //      Update a mapping item.
            //
            // mapping: Object
            //      The mapping item.
            //
            // patch: Object
            //      The properties to update.
            //
            // tags:
            //		public

            lang.mixin(mapping, patch);
            if (patch.node) {
                mapping.nodeHash = this._calculateNodeHash(patch.node);
            }
        },

        add: function (item) {
            // summary:
            //      Add a mapping item.
            //
            // item: Object
            //      The mapping item.
            //
            // tags:
            //		public

            if (item.node) {
                item.nodeHash = this._calculateNodeHash(item.node);
            }
            if (item.blockPropertyInfo && !item.propertyName) {
                item.propertyName = item.blockPropertyInfo.name;
            }

            this._mappings.push(item);
        },

        _tryRemapNode: function (item, editableNode) {
            // summary:
            //      Try to remap an editable node to a mapping item.
            //
            // item: Object
            //      The mapping item.
            //
            // editableNode: Object
            //      The editable node info object.
            //
            // bodyNode: DomNode
            //      Reference to the page's body.
            //
            // returns: Object
            //      | success: true or false.
            //      | mappedNode: the node that is successfully mapped.
            //
            // tags:
            //		private

            if (this._calculateNodeHash(editableNode.node) === item.nodeHash) {
                item.node = editableNode.node;
                item.updateController.displayNode = editableNode.node;
                item.updateController.checkEmptyHtml();
                if (item.overlayItem) {
                    // reset the disabled flag, it's set to false when using iframe for preview
                    item.overlayItem.set("disabled", false);
                    item.overlayItem.set("sourceItemNode", editableNode.node);
                    item.overlayItem.refresh();
                }

                return {
                    success: true,
                    mappedNode: editableNode
                };
            }

            return {
                success: false
            };
        },

        remap: function (editableNodes) {
            // summary:
            //      Remap a list of editable nodes to the mapping items.
            //
            // editableNodes: Array
            //      The mapping item list.
            //
            // returns: Array
            //      List of unmapped node.
            //
            // tags:
            //		private

            var unmappedNodes = [], emptyMappingItems = [];

            array.forEach(editableNodes, function (editableNode) { unmappedNodes.push(editableNode); });

            //Try remap the old editable blocks, and delete the blocks which are not found on the page anymore
            array.forEach(this._mappings, lang.hitch(this, function (item) {
                if (!item.updateController) {
                    return;
                }

                var mappedNode = null;
                var haveMapped = array.some(unmappedNodes, lang.hitch(this, function (editableNode) {
                    var result = this._tryRemapNode(item, editableNode);
                    mappedNode = mappedNode || result.mappedNode;
                    return result.success;
                }));

                if (haveMapped) {
                    if (mappedNode) {
                        unmappedNodes.splice(array.indexOf(unmappedNodes, mappedNode), 1);
                    }
                } else {
                    //delete block
                    item.updateController.destroy();
                    delete item.updateController;

                    //delete overlay item
                    if (item.overlayItem) {
                        item.overlayItem.destroy();
                        delete item.overlayItem;
                    }

                    delete item.node;
                    delete item.nodeHash;
                }

                if (this._isEmpty(item)) {
                    emptyMappingItems.push(item);
                }
            }));

            var emptyItem;
            while (emptyItem = emptyMappingItems.pop()) {
                this._mappings.splice(array.indexOf(this._mappings, emptyItem), 1);
            }

            return unmappedNodes;
        },

        _isEmpty: function (mapping) {
            for (var fieldName in mapping) {
                if (mapping.hasOwnProperty(fieldName)) {
                    return false;
                }
            }
            return true;
        },

        findOne: function (fieldName, value) {
            // summary:
            //      Returns first mapping that has a field with the value.
            //
            // fieldName: String
            //      The field name.
            //
            // value: Object|Variant
            //      The search value.
            //
            // returns: the first match item.
            //
            // tags: public

            var mapping;

            array.some(this._mappings, function (m) {
                if (m[fieldName] === value) {
                    mapping = m;
                    return true;
                }
            });

            return mapping;
        },

        find: function () {
            // summary: 
            //      Returns all mappings that has a field with the value
            //
            // arguments: Array
            //      Can either be a filter function or field name and search value.
            //      If there is no argument provided, returns all mappings.
            //
            // returns: the match items.
            //
            // tags: public

            var filter;
            if (arguments[0] === undefined) {
                return this._mappings;
            }
            else if (lang.isFunction(arguments[0])) {
                filter = arguments[0];
            }
            else {
                var fieldName = arguments[0], value = arguments[1];
                filter = function (m) {
                    return m[fieldName] === value;
                };
            }

            return array.filter(this._mappings, filter);
        }
    });
});

},
'dojox/encoding/digests/SHA1':function(){
define("dojox/encoding/digests/SHA1", ["./_base"], function(dxd){

/*
 * A port of Paul Johnstone's SHA1 implementation
 *
 * Version 2.1a Copyright Paul Johnston 2000 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for details.
 *
 * Dojo port by Tom Trenka
 */

	var chrsz=8,	//	change to 16 for unicode.
		mask=(1<<chrsz)-1;

	function R(n,c){ return (n<<c)|(n>>>(32-c)); }
	function FT(t,b,c,d){
		if(t<20){ return (b&c)|((~b)&d); }
		if(t<40){ return b^c^d; }
		if(t<60){ return (b&c)|(b&d)|(c&d); }
		return b^c^d;
	}
	function KT(t){ return (t<20)?1518500249:(t<40)?1859775393:(t<60)?-1894007588:-899497514; }

	function core(x,len){
		x[len>>5]|=0x80<<(24-len%32);
		x[((len+64>>9)<<4)+15]=len;

		var w=new Array(80), a=1732584193, b=-271733879, c=-1732584194, d=271733878, e=-1009589776;
		for(var i=0; i<x.length; i+=16){
			var olda=a, oldb=b, oldc=c, oldd=d, olde=e;
			for(var j=0;j<80;j++){
				if(j<16){ w[j]=x[i+j]; }
				else { w[j]=R(w[j-3]^w[j-8]^w[j-14]^w[j-16],1); }
				var t = dxd.addWords(dxd.addWords(R(a,5),FT(j,b,c,d)),dxd.addWords(dxd.addWords(e,w[j]),KT(j)));
				e=d; d=c; c=R(b,30); b=a; a=t;
			}
			a=dxd.addWords(a,olda);
			b=dxd.addWords(b,oldb);
			c=dxd.addWords(c,oldc);
			d=dxd.addWords(d,oldd);
			e=dxd.addWords(e,olde);
		}
		return [a, b, c, d, e];
	}

	function hmac(data, key){
		var wa=toWord(key);
		if(wa.length>16){ wa=core(wa, key.length*chrsz); }

		var ipad=new Array(16), opad=new Array(16);
		for(var i=0;i<16;i++){
			ipad[i]=wa[i]^0x36363636;
			opad[i]=wa[i]^0x5c5c5c5c;
		}

		var hash=core(ipad.concat(toWord(data)),512+data.length*chrsz);
		return core(opad.concat(hash), 512+160);
	}

	function toWord(s){
		var wa=[];
		for(var i=0, l=s.length*chrsz; i<l; i+=chrsz){
			wa[i>>5]|=(s.charCodeAt(i/chrsz)&mask)<<(32-chrsz-i%32);
		}
		return wa;	//	word[]
	}

	function toHex(wa){
		//	slightly different than the common one.
		var h="0123456789abcdef", s=[];
		for(var i=0, l=wa.length*4; i<l; i++){
			s.push(h.charAt((wa[i>>2]>>((3-i%4)*8+4))&0xF), h.charAt((wa[i>>2]>>((3-i%4)*8))&0xF));
		}
		return s.join("");	//	string
	}

	function _toString(wa){
		var s=[];
		for(var i=0, l=wa.length*32; i<l; i+=chrsz){
			s.push(String.fromCharCode((wa[i>>5]>>>(32-chrsz-i%32))&mask));
		}
		return s.join("");	//	string
	}

	function toBase64(/* word[] */wa){
		// summary:
		//		convert an array of words to base64 encoding, should be more efficient
		//		than using dojox.encoding.base64
		var p="=", tab="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", s=[];
		for(var i=0, l=wa.length*4; i<l; i+=3){
			var t=(((wa[i>>2]>>8*(3-i%4))&0xFF)<<16)|(((wa[i+1>>2]>>8*(3-(i+1)%4))&0xFF)<<8)|((wa[i+2>>2]>>8*(3-(i+2)%4))&0xFF);
			for(var j=0; j<4; j++){
				if(i*8+j*6>wa.length*32){
					s.push(p);
				} else {
					s.push(tab.charAt((t>>6*(3-j))&0x3F));
				}
			}
		}
		return s.join("");	//	string
	};

	//	public function
	dxd.SHA1=function(/* String */data, /* dojox.encoding.digests.outputTypes? */outputType){
		// summary:
		//		Computes the SHA1 digest of the data, and returns the result according to output type.
		var out=outputType||dxd.outputTypes.Base64;
		var wa=core(toWord(data), data.length*chrsz);
		switch(out){
			case dxd.outputTypes.Raw:{
				return wa;	//	word[]
			}
			case dxd.outputTypes.Hex:{
				return toHex(wa);	//	string
			}
			case dxd.outputTypes.String:{
				return _toString(wa);	//	string
			}
			default:{
				return toBase64(wa);	//	string
			}
		}
	}

	//	make this private, for later use with a generic HMAC calculator.
	dxd.SHA1._hmac=function(/* string */data, /* string */key, /* dojox.encoding.digests.outputTypes? */outputType){
		// summary:
		//		computes the digest of data, and returns the result according to type outputType
		var out=outputType || dxd.outputTypes.Base64;
		var wa=hmac(data, key);
		switch(out){
			case dxd.outputTypes.Raw:{
				return wa;	//	word[]
			}
			case dxd.outputTypes.Hex:{
				return toHex(wa);	//	string
			}
			case dxd.outputTypes.String:{
				return _toString(wa);	//	string
			}
			default:{
				return toBase64(wa);	//	string
			}
		}
	};

	return dxd.SHA1;
});

},
'dojox/encoding/digests/_base':function(){
define("dojox/encoding/digests/_base", ["dojo/_base/lang"], function(lang){
	var d = lang.getObject("dojox.encoding.digests", true);

	//TODO: see if it makes sense to meld this into one with the
	//	crypto base enums
	d.outputTypes={
		// summary:
		//		Enumeration for input and output encodings.
		Base64:0, Hex:1, String:2, Raw:3
	};

	//	word-based addition
	d.addWords=function(/* word */a, /* word */b){
		// summary:
		//		add a pair of words together with rollover
		var l=(a&0xFFFF)+(b&0xFFFF);
		var m=(a>>16)+(b>>16)+(l>>16);
		return (m<<16)|(l&0xFFFF);	//	word
	};

	//	word-based conversion method, for efficiency sake;
	//	most digests operate on words, and this should be faster
	//	than the encoding version (which works on bytes).
	var chrsz=8;	//	16 for Unicode
	var mask=(1<<chrsz)-1;

	d.stringToWord=function(/* string */s){
		// summary:
		//		convert a string to a word array
		var wa=[];
		for(var i=0, l=s.length*chrsz; i<l; i+=chrsz){
			wa[i>>5]|=(s.charCodeAt(i/chrsz)&mask)<<(i%32);
		}
		return wa;	//	word[]
	};

	d.wordToString=function(/* word[] */wa){
		// summary:
		//		convert an array of words to a string
		var s=[];
		for(var i=0, l=wa.length*32; i<l; i+=chrsz){
			s.push(String.fromCharCode((wa[i>>5]>>>(i%32))&mask));
		}
		return s.join("");	//	string
	};

	d.wordToHex=function(/* word[] */wa){
		// summary:
		//		convert an array of words to a hex tab
		var h="0123456789abcdef", s=[];
		for(var i=0, l=wa.length*4; i<l; i++){
			s.push(h.charAt((wa[i>>2]>>((i%4)*8+4))&0xF)+h.charAt((wa[i>>2]>>((i%4)*8))&0xF));
		}
		return s.join("");	//	string
	};

	d.wordToBase64=function(/* word[] */wa){
		// summary:
		//		convert an array of words to base64 encoding, should be more efficient
		//		than using dojox.encoding.base64
		var p="=", tab="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", s=[];
		for(var i=0, l=wa.length*4; i<l; i+=3){
			var t=(((wa[i>>2]>>8*(i%4))&0xFF)<<16)|(((wa[i+1>>2]>>8*((i+1)%4))&0xFF)<<8)|((wa[i+2>>2]>>8*((i+2)%4))&0xFF);
			for(var j=0; j<4; j++){
				if(i*8+j*6>wa.length*32){
					s.push(p);
				} else {
					s.push(tab.charAt((t>>6*(3-j))&0x3F));
				}
			}
		}
		return s.join("");	//	string
	};

	return d;
});

},
'epi-cms/contentediting/RenderManager':function(){
﻿define([
"dojo",
"dojo/_base/declare",
"dojo/_base/lang",
"dojo/_base/Deferred",
"dojo/_base/json",
"dojo/_base/array",
"epi",
"epi/dependency",
"epi/string",
"epi/datetime",
"dojox/encoding/digests/SHA1",
"dojo/Stateful",

"epi-cms/contentediting/PropertyRenderer"
],

function (dojo, declare, lang, Deferred, json, array, epi, dependency, epiString, epiDateTime, SHA1, Stateful, PropertyRenderer) {

    return declare([Stateful], {
        // summary:
        //    This class manages content blocks server rendering. It provides a cache to avoid redundant server calls.
        // tags:
        //    public

        // _cache: [private] Object
        //    The internal render cache
        _cache: null,
        _queue: null,

        // defaultRenderer: Object
        //      Instance of the default renderer class
        defaultRenderer: null,

        // _rendererPool: Hashtable
        //      Cache of renderer objects
        _rendererPool: {},

        // rendering: Boolean
        //      Set to true while we're rendering items
        rendering: false,

        // processQueueOnRenderValue: Boolean
        //      Set this to true to start rendering automatically after calling renderValue
        processQueueOnRenderValue: true,

        // numberOfItemsInQueue: Number
        //      Number of items queued to be rendered
        numberOfItemsInQueue: 0,

        // numberOfItemsRendering: Number
        //      Number of items being rendered
        numberOfItemsRendering: 0,

        // concurrentProcessedItems: Number
        //      Maximum number of items that can be rendered at the same time
        concurrentProcessedItems: 2,

        // processInterval: Number
        //      How often (in milliseconds) should we check the queue to see if there's any items to be rendered
        processInterval: 200,

        // _processIntervalId: [private] Number
        //      Id of the interval to check queue, will only be set if any rendering has occurred
        _processIntervalId: 0,

        // _itemsBeingRendered: [private] Hashmap
        //      Hashmap with items being rendered
        _itemsBeingRendered: null,

        // viewSettingsManager: [private] epi.cms.contentediting.ViewSettingsManager
        //      The ViewSettingsManager is used to get a currently selected visitor group.
        viewSettingsManager: null,

        _viewSettingsToCopy: ['visitorgroup'],

        constructor: function (params) {
            this._cache = {};
            this._queue = [];
            this._itemsBeingRendered = {};
            lang.mixin(this, params);

            this.defaultRenderer = this.defaultRenderer || new PropertyRenderer();
        },

        postscript: function () {
            // Listen changed visitor group, to apply visitor group.
            this.viewSettingsManager = this.viewSettingsManager || dependency.resolve("epi.viewsettingsmanager");
        },

        destroy: function () {
            // stop queue
            this._stopRenderingInterval();

            // set flag
            this._isDestroyed = true;

            // clear cache
            for (var i in this._cache) {
                delete this._cache[i];
            }
            // clear itemsbeing rendered
            for (var j in this._itemsBeingRendered) {
                delete this._itemsBeingRendered[j];
            }

            this._cache = null;
            this._itemsBeingRendered = null;
            this._queue = null;

            this.inherited(arguments);
        },

        _getRenderer: function (rendererClassName) {
            var def = new Deferred();
            if (rendererClassName) {
                if (this._rendererPool[rendererClassName]) {
                    return this._rendererPool[rendererClassName];
                }
                else {
                    var widgetType = epiString.slashName(rendererClassName);
                    require([widgetType], function (renderer) {
                        def.resolve(new renderer());
                    });
                }
            } else {
                return this.defaultRenderer;
            }
            return def;
        },

        renderValue: function (contentLink, propertyName, value, renderSettings, rendererClassName) {
            // summary:
            //    Get block render for a content model's node, supplying its value.
            //
            // contentLink: Object|String
            //    The id of the content on which the property is rendered.
            //
            // propertyName: String
            //    Name of the property to render
            //
            // value: String
            //    The node value.
            //
            // rendererClassName: String
            //    Name of renderer class which takes care of render the given value to html.
            //
            // renderSettings: Object
            //    Render setting
            //
            // returns:
            //	  A dojo.Deferred object which results the render
            //
            // tags:
            //    public

            var def;

            if (this._isSuspending) {
                def = new Deferred();
                def.cancel();
                return def;
            }

            value = epiDateTime.transformDate(value);

            renderSettings = this.cloneAndCompleteRenderSettings(renderSettings || {});

            // Firstly, try getting from cache
            var renderedContent = this._get(propertyName, renderSettings, value);

            if (renderedContent) {
                def = new Deferred();
                def.resolve(renderedContent);
            } else {
                if (renderSettings && renderSettings.isFullReload) {
                    def = new Deferred();
                    def.resolve({ doReload: true });
                }
                else {
                    def = new Deferred();
                    Deferred.when(this._getRenderer(rendererClassName), lang.hitch(this, function (renderer) {
                        if (!renderer) {
                            renderer = this.defaultRenderer;
                        }

                        Deferred.when(this._queueItem(renderer, contentLink, propertyName, renderSettings, value), function (result) {
                            def.resolve(result);
                        });

                        if (this.processQueueOnRenderValue && !this._isSuspending) {
                            this._startRenderingInterval();
                        }

                    }));
                }
            }

            return def;
        },

        cloneAndCompleteRenderSettings: function (renderSettings) {
            // summary:
            //    Clones the supplied renderSettings and adds settings from the ViewSettingsManager.
            //
            // returns:
            //    The cloned and updated renderSettings.
            //
            // tags:
            //    public

            renderSettings.propertyRenderSettings = renderSettings.propertyRenderSettings || "";

            var renderSettingsClone = lang.clone(renderSettings);

            if (this.viewSettingsManager.get("enabled")) {
                array.forEach(this.viewSettingsManager.getRenderingViewSettings(), lang.hitch(this, function (viewSetting) {
                    if (viewSetting.get("enabled")) {
                        var settingValue = this.viewSettingsManager.getSettingProperty(viewSetting.key);
                        if (settingValue) {
                            this.updateRenderSettings(renderSettingsClone, settingValue, viewSetting.key, viewSetting.isTagItem);
                        }
                    }
                }));
            }

            return renderSettingsClone;
        },

        updateRenderSettings: function (/*String*/renderSettings, /*String*/newItem, /*String*/key, /*Boolean*/isTagItem) {
            // summary:
            //    Add new items to the renderSettings.
            //
            // renderSettings:
            //    The property render settings.
            //
            // newItem:
            //    The item that will be added to the property.
            //
            // key:
            //    The name of the property that will be updated.
            //
            // isTagItem:
            //    Flag indicating where the new item will be added if it's true
            //    the item will be added to the renderSettings.propertyRenderSettings.tag,
            //    otherwise it will be added directly as a property on the renderSettings object.
            //
            // returns:
            //    The updated setting as a string.
            //
            // tags:
            //    public
            var itemlist = [],
                newitemlist = [],
                itemsString = "",
                propertyName = (isTagItem ? "tag" : key),
                replaceItem = !isTagItem,
                data = null;

            if (isTagItem) {
                renderSettings.propertyRenderSettings = renderSettings.propertyRenderSettings || "";
                data = (renderSettings.propertyRenderSettings ? dojo.fromJson(renderSettings.propertyRenderSettings) : {});
            }
            else {
                data = (renderSettings ? renderSettings : {});
            }

            if (!data[propertyName] || replaceItem) {
                // in case there isn't any tag defined.
                itemsString = newItem;
            } else {
                // there're tags already configured.
                itemlist = data[propertyName].split(",");

                array.forEach(itemlist, function (item, idx) {
                    item = lang.trim(item);
                    if (item.toLowerCase() != newItem.toLowerCase()) {
                        newitemlist.push(item);
                    }
                });
                // add the new tag to the array.
                newitemlist.push(newItem);
                itemsString = newitemlist.join(", ");
            }

            // update the settings object.
            data[propertyName] = itemsString;

            if (isTagItem) {
                renderSettings.propertyRenderSettings = dojo.toJson(data);
            }
        },

        processQueue: function () {
            // summary:
            //    Process the queue.
            //

            if (this._isSuspending) {
                return;
            }
            if (this._queue.length === 0) {
                // queue is empty, stop processing queue
                this._stopRenderingInterval();
                return;
            }

            if (this.numberOfItemsRendering >= this.concurrentProcessedItems) {
                // we're already rendering max number of items
                return;
            }

            // add as many items as needed to rendering pool
            var nextItemToProcessIndex = this._nextItemToProcessIndex();

            while (nextItemToProcessIndex >= 0 && this.numberOfItemsRendering < this.concurrentProcessedItems) {

                this._processItemInQueue(nextItemToProcessIndex);

                // Find next item to process
                nextItemToProcessIndex = this._nextItemToProcessIndex();
            }
        },

        suspend: function () {
            // summary:
            //    Suspend the render manager.
            //
            // remarks:
            //    Ongoing rendering items will be canceled. Queueing items will be deleted and adding items will be temporary rejected.
            //    Used when the preview need to be reloaded.

            if (this._isSuspending) {
                return;
            }

            // set flag
            this._isSuspending = true;
            this._stopRenderingInterval();
        },

        clear: function () {
            //cancel ongoing
            this.set("numberOfItemsRendering", 0);
            for (var key in this._itemsBeingRendered) {
                this._itemsBeingRendered[key].deferred.cancel();
                delete this._itemsBeingRendered[key];
            }
            this._itemsBeingRendered = {};

            //empty queue
            this.set("numberOfItemsInQueue", 0);
            for (var i = this._queue.length - 1; i >= 0; i--) {
                delete this._queue[i];
            }
            this._queue = [];
        },

        resume: function () {
            // summary:
            //    Resume render manager.
            //
            // remarks:
            //    Used when the preview has done reloading.
            //    The render queue was reset before so the render manager will start over fresh.

            if (!this._isSuspending) {
                return;
            }

            // set flag
            this._isSuspending = false;
            this._startRenderingInterval();
        },

        _nextItemToProcessIndex: function () {

            // take first item if items in queue exists
            var index = -1;

            var i = 0;

            while (i < this._queue.length && index == -1) {

                // get item
                var item = this._queue[i];

                // get the key
                var key = this._getRenderHash(item.propertyName, item.renderSettings);

                // if the key is not in the items being rendered, we found our next item
                if (!(key in this._itemsBeingRendered)) {
                    index = i;
                }

                i++;
            }

            return index;
        },

        _processItemInQueue: function (index) {
            // take item
            var item = this._queue.splice(index, 1)[0];

            // increase value of items being rendered
            this.set("numberOfItemsRendering", this.numberOfItemsRendering + 1);

            // update number of items
            this.set("numberOfItemsInQueue", this._queue.length);

            // get the key
            var key = this._getRenderHash(item.propertyName, item.renderSettings);

            // put the item in our hashmap
            this._itemsBeingRendered[key] = item;

            // we're rendering
            this.set("rendering", true);

            var onSuccess = lang.hitch(this, function (result) {

                // check if destroy() was called before callback was fired
                if (this._isDestroyed) {
                    item.deferred.cancel();
                    return;
                }

                // cache value if it is successful
                if (result && result.innerHtml) {
                    this._put(item.propertyName, item.renderSettings, item.value, { doReload: result.doReload, innerHtml: result.innerHtml });
                }

                // remove this item from the items being rendered
                delete this._itemsBeingRendered[key];

                // decrease value of items being rendered
                this.set("numberOfItemsRendering", this.numberOfItemsRendering - 1);

                this.set("rendering", false);

                // resolve rendering deferreds
                item.deferred.resolve(result);
            });

            var onFailure = lang.hitch(this, function (err) {
                // TODO: error handling for server error

                // check if destroy() was called before callback was fired
                if (this._isDestroyed) {
                    item.deferred.cancel();
                    return;
                }

                // remove this item from the items being rendered
                delete this._itemsBeingRendered[key];

                // decrease value of items being rendered
                this.set("numberOfItemsRendering", this.numberOfItemsRendering - 1);

                this.set("rendering", false);

                // reject rendering deferreds
                item.deferred.reject(err);
            });

            Deferred.when(item.renderer.render(item.contentLink, item.propertyName, item.value, item.renderSettings), onSuccess, onFailure);
        },

        cacheRender: function (propertyName, renderSettings, value, content) {
            // summary:
            //    Explicitly update the internal cache with the rendered content for a block.
            //
            // propertyName: String
            //    The content model node. It can be property or sub property.
            //
            // value: String|Object
            //    The value to render.
            //
            // content: String
            //    The rendered content.
            //
            // tags:
            //    public

            data = {
                innerHtml: content,
                doReload: false
            };

            this._put(propertyName, renderSettings, value, data);
        },

        _queueItem: function (renderer, contentLink, propertyName, renderSettings, value) {
            // summary:
            //      Add or update rendering item

            var key = this._getRenderHash(propertyName, renderSettings);
            var deferred;

            var itemBeingRendered = this._itemsBeingRendered[key];

            if (itemBeingRendered && !itemBeingRendered.deferred.fired && itemBeingRendered.value === value) {
                // The current property is being rendered, return that deferred
                // the deferred should always have fired set to false
                deferred = itemBeingRendered.deferred;
            } else {
                var index = this._queueIndex(renderer, contentLink, propertyName, renderSettings, value);

                if (index < 0) {
                    deferred = new Deferred();

                    // queue item
                    this._queue.push({
                        contentLink: contentLink,
                        renderer: renderer,
                        propertyName: propertyName,
                        renderSettings: renderSettings,
                        renderSettingsString: json.toJson(renderSettings),
                        value: value,
                        deferred: deferred
                    });

                    // update number of items in queue
                    this.set("numberOfItemsInQueue", this._queue.length);
                } else {

                    // it doesn't matter which item we update
                    // update it with new values
                    var item = this._queue[index];

                    // updating with a new renderer could cause errors, ie having two properties on the same
                    // content with same settings, but with different renderers
                    item.contentLink = contentLink;
                    item.renderer = renderer;
                    item.value = value;

                    deferred = item.deferred;
                }
            }

            return deferred;
        },

        _startRenderingInterval: function () {
            if (!this._processIntervalId) {

                // trigger immediate first call
                this.processQueue();

                // create interval
                this._processIntervalId = setInterval(lang.hitch(this, function () {
                    this.processQueue();
                }), this.processInterval);
            }

        },

        _stopRenderingInterval: function () {

            if (this._processIntervalId) {
                clearInterval(this._processIntervalId);
                this._processIntervalId = 0;
            }

            // reset flag
            this.set("rendering", false);
        },


        _getRenderHash: function (propertyName, renderSettings) {
            return SHA1(json.toJson({ p: propertyName, r: renderSettings }));
        },


        _queueIndex: function (renderer, contentLink, propertyName, renderSettings, value) {

            var index = -1;
            var renderSettingsString = json.toJson(renderSettings);

            // find index of item in queue
            array.some(this._queue, function (item, i) {
                if ((item.propertyName === propertyName) && (item.renderSettingsString == renderSettingsString)) {
                    index = i;
                    return true;
                }
            });

            return index;
        },

        _put: function (propertyName, renderSettings, value, data) {
            // summary:
            //    Store the rendered content for a value in the internal cache object
            //
            // propertyName: String
            //    Name of the cached block
            //
            // value: String|Object
            //    The raw value of the object to fetch
            //
            // value: String
            //    The rendered content to put in cache
            //
            // tags:
            //    private

            if (!renderSettings.cacheResults) {
                return;
            }

            var valueHash = this._getCacheHash(propertyName, renderSettings, value);
            if (!this._cache) {
                // Initial internal render cache
                this._cache = {};
            }
            this._cache[valueHash] = { data: data };
        },

        _get: function (propertyName, renderSettings, value) {
            // summary:
            //    Retreive the rendered content for a value from the internal cache
            //
            // propertyName: String
            //    Name of the cached block
            //
            // value: String|Object
            //    The raw value of the object to fetch
            //
            // returns:
            //    The content as a string or undefined if no cached content exists.
            //
            // tags:
            //    private

            var valueHash = this._getCacheHash(propertyName, renderSettings, value);
            var cacheObject = this._cache[valueHash];
            return (cacheObject ? cacheObject.data : undefined);
        },

        _getCacheHash: function (propertyName, renderSettings, value) {
            // summary:
            //    Calculates a hash of the supplied value
            //
            // tags:
            //    private

            // In case the value is an object we serialize before calculating the hash.
            return SHA1(json.toJson({ p: propertyName, r: renderSettings, v: value }));
        }
    });

});

},
'epi-cms/contentediting/PropertyRenderer':function(){
﻿define([
"dojo/_base/json",
"dojo/_base/declare",
"epi",
"epi/dependency",
"epi/shell/XhrWrapper",
"epi-cms/contentediting/_Renderer",
"epi-cms/core/ContentReference",
"epi/routes",
"dojo/string"],

function (json, declare, epi, dependency, XhrWrapper, _Renderer, ContentReference, routes, string) {

    return declare([_Renderer], {
        // summary:
        //    Server side property renderer. Returns the mark-up generated by rendering a property on the server side.
        // tags:
        //    public

        _routes: routes,

        // xhrHandler: [private] Object
        //  The xhr implementation to use when requesting data. Defaults to epi.shell.XhrWrapper
        _xhrHandler: null,

        // Profile: [private] Object
        //  The current profile.
        _profile: null,

        constructor: function () {
            if (!this._routes) {
                this._routes = epi.routes;
            }
            if (!this._xhrHandler) {
                this._xhrHandler = new XhrWrapper();
            }

            this._profile = this._profile || dependency.resolve("epi.shell.Profile");
        },

        render: function (contentLink, propertyName, propertyValue, renderSettings) {
            // summary:
            //    Get the content rendered by the server for an editable block.
            //
            // contentLink: object
            //    The content containing the update property
            //
            // propertyName: String
            //    The updated property name.
            //
            // propertyValue: String
            //    The updated raw value of the property.
            //
            // returns:
            //    A deferred
            //
            // tags:
            //    public


            var reference = ContentReference.toContentReference(contentLink);

            var url = null;
            if (renderSettings.useMvc) {
                url = this._routes.getActionPath({
                    moduleArea: "CMS",
                    controller: "PropertyRender",
                    action: "Render",
                    epieditmode:true,
                    visitorgroupsByID: renderSettings.visitorgroup,
                    epslanguage: this._profile ? this._profile.contentLanguage : "" // in order to render the property (content) in correct language
                });
            }
            else {

                url = this._routes.getActionPath({
                    moduleArea: "LegacyCMS",
                    path: "edit/RenderProperty.aspx",
                    id: reference.toString(),
                    epieditmode: true,
                    visitorgroupsByID: renderSettings.visitorgroup,
                    epslanguage: this._profile ? this._profile.contentLanguage : "" // in order to render the property (content) in correct language
                });
            }

            var postData = {
                propertyName: propertyName,
                propertyValue: json.toJson(propertyValue),
                id: reference.toString(), // The default model binder in MVC needs the id to be part of the posted data.
                renderSettings: ""
            };

            if (renderSettings && renderSettings.propertyRenderSettings) {
                postData.renderSettings = renderSettings.propertyRenderSettings;
            }


            return this._xhrHandler.xhrPost({
                url: url,
                handleAs: "json",
                content: postData
            }); //Deferred
        }
    });
});
},
'epi-cms/contentediting/UpdateController':function(){
﻿define([
"dojo",
"dojo/_base/array",
"dojo/_base/declare",
"dojo/_base/lang",
"dojo/dom-class",
"dojo/dom-style",
"dojo/dom-geometry",
"dojo/dom-attr",
"dijit"],

function (
    dojo,
    array,
    declare,
    lang,
    domClass,
    domStyle,
    domGeometry,
    domAttr,
    dijit) {

    return declare(null, {

        _showEmptyNode: true,
        _hasEmptyHtml: false,

        // emptyValue: String
        //		Template to display empty value
        emptyValue: "&nbsp;",

        // minWidth: Number
        //      Use this width for the displayNode when then node has a zero width
        minWidth: 18,

        // minHeight: Number
        //      Use this height for the displayNode when then node has a zero height
        minHeight: 14,

        // displayNode: DomNode
        //		The source node
        displayNode: null,

        // model: dojo.Stateful
        //		A model to update
        contentModel: null,

        // contentLink: String
        //      The content link to update
        contentLink: null,

        // modelPropertyName: String
        //		Name of the property in model to observe
        modelPropertyName: null,

        // nodePropertyName: String
        //		Name of the property in the rendered page
        nodePropertyName: null,

        // renderManager: [public] epi.cms.contentediting._Renderer
        //      The render manager
        renderManager: null,

        // displayName: String
        //		A display name for this block
        displayName: null,

        // renderSettings: Object
        //		A display name for this block
        renderSettings: null,

        // rendererClass: String
        //		A display name for this block
        rendererClass: null,

        constructor: function (settings) {
            dojo.mixin(this, settings);
        },

        postscript: function () {
            // watch model
            if (this.contentModel) {
                this._modelWatchHandle = [];
                dojo.forEach(dojo.isArray(this.modelPropertyName) ? this.modelPropertyName : [this.modelPropertyName], dojo.hitch(this, function (propertyName) {
                    this._modelWatchHandle.push(this.contentModel.watch(propertyName, dojo.hitch(this, this._renderNode)));
                }));
            }

            this.checkEmptyHtml();
        },

        destroy: function () {
            // detach watch handle
            dojo.forEach(this._modelWatchHandle, function (handle) {
                handle.unwatch();
            });

            dojo.disconnect(this._renderDisplayNodeConnect);

            // Clear node in other frame to prevent nasty issues with dojo caching unloaded documents
            delete this.srcNodeRef;
            delete this.displayNode;

            this.inherited(arguments);
        },

        onReloadRequired: function (sender) {
            // summary:
            //		Set this handler to be notified when the block requires a full reload of the web page to be rerenderd.
            // tags:
            //		callback

        },

        onRender: function (block) {
            // summary:
            //		Set this handler to be notified when the block renders
            // tags:
            //		callback

        },

        _renderNode: function (propertyName, oldValue, value) {

            var contentLink = this.contentLink;
            var renderSettings = this.renderSettings;
            var rendererClass = this.rendererClass;
            var renderPropertyName = this.nodePropertyName || this.modelPropertyName;

            var def = this.renderManager.renderValue(contentLink, renderPropertyName, value, renderSettings, rendererClass);

            // Did we get a new deferred?
            if (def !== this._lastRenderDeferred) {

                // Store value
                this._lastRenderDeferred = def;

                dojo.when(def, dojo.hitch(this, function (result) {

                    // update node if we have a last deferred, this because cached rendering can
                    // be resolved faster than server rendered values. The last rendered deferred
                    // will be the one to update the node the last time.
                    if (this._lastRenderDeferred) {

                        if (result.doReload !== undefined && result.doReload) {
                            this.onReloadRequired(this);
                        } else if (dojo.isString(result)) {
                            this._updateRendering(result);
                        } else if (result.innerHtml !== undefined) {
                            this._updateRendering(result.innerHtml, result.attributes);
                        } else if (result.error !== undefined) {
                            this._handleValidationError(result.error);
                        }

                        if (def == this._lastRenderDeferred) {
                            this._lastRenderDeferred = null;
                        }
                    }
                }));
            }
        },

        _isEmptyHtml: function (displayNode) {

            // TODO: check for other types of nodes
            // TODO: use property descriptor to know which properties can have content (or not have inner content)
            var html = "";

            if (!displayNode) {
                return false;
            }

            if (displayNode.tagName == "IMG") {
                html = dojo.attr(displayNode, "src") || "";
            }
            else {
                html = displayNode.innerHTML;
            }

            // strip scripts tag from html. The regex pattern is borrowed from jquery.
            html = html.replace(/<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi, "");

            // This won't handle empty <br> in html
            return (typeof html == "string") && (html.replace(/\s*/g, "").length === 0);
        },

        checkEmptyHtml: function () {

            var isEmpty;

            if (!this._showEmptyNode) {
                return;
            }

            isEmpty = this._isEmptyHtml(this.displayNode);

            if (isEmpty) {
                this.displayNode.innerHTML = dojo.string.substitute(this.emptyValue, this);
            }

            this._ensureSize();
        },

        _ensureSize: function () {
            try {
                this._clearComputedStyle();
                this._computeStyle();
            } catch (e) {
                // Probably failed because displayNode is not set yet
                console.warn("Could not get or set domStyle for displayNode", e);
            }
        },

        _clearComputedStyle: function () {

            var originalStyle = this._originalStyle;

            if (originalStyle) {

                // Reset any previous width and height styling, ie get the height for the content of the displaynode
                for (var prop in originalStyle) {

                    if (originalStyle.hasOwnProperty(prop)) {
                        domStyle.set(this.displayNode, prop, this._originalStyle[prop]);
                    }
                }

                this._originalStyle = null;
            }
        },

        _computeStyle: function () {
            if (!this.displayNode) {
                return;
            }
            var computedStyle = domStyle.get(this.displayNode),
                originalStyle = {
                    "minWidth": domStyle.toPixelValue(this.displayNode, computedStyle.minWidth),
                    "minHeight": domStyle.toPixelValue(this.displayNode, computedStyle.minHeight),
                    "display": computedStyle.display
                },
                styleToApply = { },
                setMinHeight = originalStyle.minHeight === 0,
                setMinWidth = originalStyle.minWidth === 0,
                setDisplay = originalStyle.display === "inline",
                marginBox = domGeometry.getMarginBox(this.displayNode, computedStyle);

            // Check if the node is smaller than desired, either from page cssClass/style or our min settings
            if (marginBox.h < (setMinHeight ? this.minHeight : originalStyle.minHeight) ||
                marginBox.w < (setMinWidth ? this.minWidth : originalStyle.minWidth)) {

                if (setMinHeight) {
                    styleToApply.minHeight = this.minHeight + "px";
                }
                if (setMinWidth) {
                    styleToApply.minWidth = this.minWidth + "px";
                }
                if (setDisplay) {
                    styleToApply.display = "inline-block";
                }

                if (setDisplay || setMinHeight || setMinWidth) {

                    this._originalStyle = originalStyle;
                    domStyle.set(this.displayNode, styleToApply);
                }
            }
        },

        _updateRendering: function (innerHtml, attributes) {
            // summary:
            //		Callback when rendering has new html.
            // innerHtml: String
            //		The inner html for the node.
            // attributes: Dictionary
            //      The attributes for the outer node that should be set.
            // tags:
            //		private

            this.displayNode.innerHTML = innerHtml;

            if (attributes) {
                array.forEach(attributes, lang.hitch(this, function (attribute) {
                    this._updateAttribute(attribute);
                }));
            }

            this._hasEmptyHtml = this._isEmptyHtml(this.displayNode);
            if (this._hasEmptyHtml) {
                this.checkEmptyHtml();
                if (!this._showEmptyNode) {
                    domStyle.set(this.displayNode, "display", "none");
                }
            } else {
                // node has value, make sure it's not displayed too small
                // it probably has some html, but it could be with empty
                // innerHTML and then there width or height will be zero

                if (this._showEmptyNode) {
                    this._ensureSize();
                }
            }
            this.onRender(this);
        },

        _updateAttribute: function (attribute) {
            // summary:
            //		Update attribute for the display node.
            // attribute: Object
            //      The attribute for the outer node that should be set.
            // tags:
            //		private

            if (attribute.name.toLowerCase() == "class") {
                // Need to keep existing css style
                domClass.add(this.displayNode, attribute.value);
            } else {
                domAttr.set(this.displayNode, attribute.name, attribute.value);
            }
        },

        _handleValidationError: function (message) {
            // summary:
            //		Callback when rendering has new html.
            // html: String
            //		Focus on the display mode text
            // tags:
            //		private

            console.log(message + ': "' + this.contentModel.get(this.modelPropertyName) + '"');
        },

        render: function () {
            var val = this.contentModel.get(this.modelPropertyName);
            this._renderNode(this.modelPropertyName, val, val);
        },

        focus: function () {
            // TODO: focus overlay?
            dijit.focus(this.displayNode);
        },

        setShowEmptyNode: function (val) {
            this._showEmptyNode = val;

            if (this._hasEmptyHtml) {
                this._updateRendering("");
            }
        }
    });

});

},
'epi-cms/widget/overlay/overlayFactory':function(){
﻿define([
// Dojo
    "dojo/_base/lang",
    "dojo/_base/Deferred",

// EPi Framework
    "epi/string",

    "epi-cms/widget/overlay/Property"
    ],

    function (
// Dojo
    lang,
    Deferred,

// EPi Framework
    epiString
) {

        return {

            defaultType: "epi-cms/widget/overlay/Property",

            create: function (editableNode) {
                var createOverlayDeferred = new Deferred();
                var customType = editableNode.property.metadata.overlaySettings && editableNode.property.metadata.overlaySettings.customType;

                var property = editableNode.property,
                    overlayType = epiString.slashName(customType || this.defaultType);

                require([overlayType], lang.hitch(this, function (overlayClass) {
                    var settings = lang.mixin(
                        {
                            name: property.name,
                            contentModel: property.contentModel,
                            displayName: property.metadata.displayName,
                            disabled: editableNode.disabled,
                            sourceItemNode: editableNode.node
                        },
                        property.overlayParams);

                    var overlay = new overlayClass(settings);
                    createOverlayDeferred.resolve(overlay);
                }));

                return createOverlayDeferred;
            }
        };
    }
);
},
'epi-cms/widget/overlay/Property':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

// EPi Framework
    "epi/string",
    "epi/shell/widget/overlay/Item"

],

    function (
    // Dojo
    declare,
    lang,

    // EPi Framework
    epiString,
    Item
) {
        return declare([Item], {

            onValueChange: function (values/* Array || object*/) {
                // summary:
                //      Event to notify that this and possibly other properties
                //      has changed their values
                // values: Object  ||[Object]
                //      The property values that has changed. {propertyName: "propertyName", value: value}
                // tags:
                //      Public callback
            },

            _getRightProperty: function () {
                var propertyName = this.name;
                if (this.dndTargetPropertyName) {
                    propertyName += ("." + epiString.pascalToCamel(this.dndTargetPropertyName));
                }
                return propertyName;
            },

            onDrop: function (target, value) {

                // If we have a mapping dropdata to child property
                // then set drop data to this
                // REMARK: This's just a simple case, handling one specified property, this doesn't support recursive or duplicate child property
                var propertyName = this._getRightProperty();
                this.onValueChange({
                    propertyName: propertyName,
                    value: value
                });
            }
        });
    });

},
'epi-cms/contentediting/editors/CheckBoxListEditor':function(){
﻿define([

// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/on",

// Dijit
    "dijit/focus",
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/form/CheckBox",

// EPi
    "epi/shell/widget/_ValueRequiredMixin"
], function (

// Dojo
    array,
    declare,
    lang,
    domConstruct,
    on,

// Dijit
    focusUtil,
    _TemplatedMixin,
    _Widget,
    CheckBox,

// EPi 
    _ValueRequiredMixin

) {

    return declare([_Widget, _TemplatedMixin, _ValueRequiredMixin], {

        templateString: '<div class="dijit dijitReset dijitInline"></div>',

        baseClass: "epi-checkBoxList",
               
        valueIsCsv: true,
        
        valueIsInclusive: true,

        value: null,
        
        constructor: function () {
            this._checkboxes = [];
            this._labelClickHandles = [];
        },

        buildRendering: function () {
            this.inherited(arguments);

            array.forEach(this.selections, this._addCheckBoxForItem, this);
        },

        destroy: function () {
            var checkbox;
            while (checkbox = this._checkboxes.pop()) {
                checkbox.destroyRecursive();
            }

            var labelClickHandle;
            while (labelClickHandle = this._labelClickHandles.pop()) {
                labelClickHandle.remove();
            }

            this.inherited(arguments);
        },

        focus: function () {
            // summary:
            //		Focus the widget.

            try {
                if (this._checkboxes.length > 0) {
                    focusUtil.focus(this._checkboxes[0].domNode);
                }
            }
            catch (e) { /*quiet*/ }
        },

        onChange: function (/*===== newValue =====*/) {
            // summary:
            //		Callback when this widget's value is changed.
            // tags:
            //		callback
        },

        onBlur: function () {
            // summary:
            //		Callback when this widget loses focus.
            // tags:
            //		callback
        },

        onFocus: function () {
            // summary:
            //		Callback when this widget gains focus.
            // tags:
            //		callback
        },

        _calculateValue: function () {
            var values = [];
            var storeChecked = this.valueIsInclusive;
            array.forEach(this._checkboxes, function (checkbox) {
                if (storeChecked === checkbox.checked) {
                    values.push(checkbox.value);
                }
            });

            this._set("value", this.valueIsCsv ? values.join(",") : values);
        },

        _setValueAttr: function (value) {
            this._set("value", value);
            
            var values = [];
            if (value) {
                values = this.valueIsCsv ? value.split(",") : value;
            }
            var checkValues = this.valueIsInclusive;

            array.forEach(this._checkboxes, function (checkbox) {
                checkbox.set("checked", checkValues === array.some(values, function(v) { return v === checkbox.value; }));
            });
        },

        _onBlur: function () {
            this.inherited(arguments);
            this.onBlur();
        },

        _addCheckBoxForItem: function (item) {
            // Create a container for the label and checkbox.
            var container = domConstruct.create("span", null, this.domNode);

            // Add the checkbox to the container.
            var checkbox = new CheckBox({ value: item.value });
            checkbox.placeAt(container);

            checkbox.on("change", lang.hitch(this, function () {
                this._calculateValue();
                this.onChange(this.value);
            }));
            checkbox.on("focus", lang.hitch(this, function () {
                this._set("focused", true);
                this.onFocus();
            }));
            checkbox.on("blur", lang.hitch(this, function () {
                this._set("focused", false);
                this._onBlur();
            }));

            checkbox.set("readOnly", !!this.readOnly);

            this._checkboxes.push(checkbox);

            // Add a label for the checkbox
            var label = domConstruct.create("label", { "for": checkbox.id, innerHTML: item.text }, container);
            this._labelClickHandles.push(on(label, "click", lang.hitch(this, function () {
                focusUtil.focus(checkbox.domNode);
            })));
        }
    });
});
},
'epi-cms/contentediting/editors/CollectionEditor':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/json",
    "dojo/on",
    "dojo/Stateful",
    "dojo/when",

// dijit
    "dijit/_TemplatedMixin",
    "dijit/_Widget",

// dgrid
    "dgrid/Keyboard",
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    "dgrid/extensions/ColumnResizer",
    "dgrid/extensions/ColumnReorder",
    "put-selector/put",

// epi shell
    "epi/shell/command/builder/ButtonBuilder",
    "epi/shell/dgrid/Formatter",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/FormContainer",
    "epi/string",
    "epi/shell/command/withConfirmation",

// epi cms
    "epi-cms/contentediting/editors/model/CollectionEditorModel",
    "epi-cms/contentediting/editors/model/CollectionEditorItemModel",
    "epi-cms/contentediting/_EditorWrapperBase",
    "epi-cms/dgrid/DnD",
    "epi-cms/dgrid/formatters",
    "epi-cms/dgrid/WithContextMenu",
    "epi-cms/contentediting/editors/DefaultGridAssembler",
    "./_AddItemDialogMixin",

// resources
    "dojo/text!./templates/CollectionEditor.html",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.collectioneditor"
],
function (
// dojo
    array,
    declare,
    lang,

    aspect,
    domConstruct,
    domClass,
    json,
    on,
    Stateful,
    when,

// dijit
    _TemplatedMixin,
    _Widget,

// dgrid
    Keyboard,
    OnDemandGrid,
    Selection,
    ColumnResizer,
    ColumnReorder,
    put,

// epi shell
    ButtonBuilder,
    Formatter,
    _ModelBindingMixin,
    FormContainer,
    epiString,
    withConfirmation,

// epi cms
    CollectionEditorModel,
    CollectionEditorItemModel,
    _EditorWrapperBase,
    DnD,
    formatters,
    WithContextMenu,
    DefaultGridAssembler,
    _AddItemDialogMixin,

// resources
    template,
    resources
) {
    return declare([_Widget, _TemplatedMixin, _ModelBindingMixin, _AddItemDialogMixin], {
        // templateString: String
        //      The widget's template.
        templateString: template,

        // multiple: Boolean
        //      Indicates that the widget's value is array-like.
        multiple: true,

        // baseClass: String
        //      The widget's base css class.
        baseClass: "epi-collection-editor",

        // value: Array
        //      The widget's value.
        value: null,

        // model: epi-cms/contentediting/editors/CollectionEditor
        //      The widget's model.
        model: null,

        // modelType: Function
        //      The widget's model class. By default it is epi-cms/contentediting/editors/model/CollectionEditorModel
        modelType: CollectionEditorModel,

        // itemType: String
        //      The collection item type on the server. This is used to retrieve item metadata.
        itemType: null,

        // generateColumn: Boolean
        //      Indicates that grid columns definition should be generated from item type's metadata.
        generateColumns: true,

        // excludedColumns: Array
        //      List of columns those are excluded from generated columns
        excludedColumns: null,

        // includedColumns: Array
        //      List of columns which are configured to assemble the grid.
        includedColumns: null,

        // gridType: Function
        //      The grid class. By default it is OnDemandGrid with Formatter, Selection, Keyboard, and DnD supports.
        gridType: declare([OnDemandGrid, Formatter, Selection, Keyboard, DnD, ColumnResizer, ColumnReorder, WithContextMenu]),

        // gridAssemblerType: Function
        //      The grid assembler class.
        gridAssemblerType: DefaultGridAssembler,

        // gridSettings: Object
        //      The grid settings.
        gridSettings: null,

        // itemModelType: Function
        //      Item Model constructor. Default is epi-cms/contentediting/editors/model/CollectionEditorItemModel.
        itemModelType: null,

        // itemEditorType: Function
        //      The item editor class. By default, it is FormContainer
        itemEditorType: FormContainer,

        // useFullWidth: Boolean
        //      Specifies that this widget should be rendered in full width.
        useFullWidth: true,

        _noDataMessage: '<span><span class="dijitReset dijitInline">' + resources.noitems + '</span></span>',

        _currentProviderHandler: null,

        postMixInProperties: function () {
            // summary:
            //      Post mix in properties initialization.
            // description:
            //      Fullfills properties that needed to start up the widget.
            // tags:
            //      protected

            this.inherited(arguments);

            this.itemModelType = this.itemModelType || CollectionEditorItemModel;

            // Create model
            this.model = this.model || new this.modelType({
                itemType: this.itemType,
                itemModelType: this.itemModelType,
                data: this.value,
                availableCommands: this.commands
            });

            // Connect to model events
            this.own(on(this.model, "itemsChanged", lang.hitch(this, this._onItemsChanged)));

            // Initialize grid settings
            this.gridSettings = lang.mixin(this.gridSettings || {}, { noDataMessage: this._noDataMessage });

            // Disable gridDnd if the grid is readOnly for instance when another user is editing current page.
            if (this.readOnly) {
                this.allowedDndTypes = [];
                this.gridSettings.dndDisabled = true;
            }

            this.gridSettings.dndParams = {
                copyOnly: true,
                accept: this.allowedDndTypes || [],
                creator: lang.hitch(this, this._dndNodeCreator)
            };
        },

        postCreate: function () {
            // summary:
            //      Post create initialization.
            // description:
            //      Setup related components.
            // tags:
            //      protected

            this.inherited(arguments);

            // When the model is initialized, setup the grid
            when(this.model.initialize(), lang.hitch(this, function () {
                this._setupGrid();
            }));
        },

        onChange: function (value) {
            // summary:
            //      Triggered when the widget's value changes.
            // tags:
            //      public, callback
        },

        _setValueAttr: function (value) {
            // summary:
            //      Value setter.
            // description:
            //      Push value to the model to be its data.
            //  tags:
            //      private

            this._set("value", value);

            if (this.model) {
                this.model.set("data", value);
            }
        },

        _dndNodeCreator: function (/*Object*/item, /*Object*/hint) {
            // summary:
            //      Custom DnD avatar creator method
            //  tags:
            //      private

            var dndTypes = this.allowedDndTypes,
                node = domConstruct.create("div").appendChild(document.createTextNode(item.text));

            return {
                "node": node,
                "type": dndTypes,
                "data": item
            };
        },

        _setupGrid: function () {
            // summary:
            //      Set up the grid.
            // tags:
            //      private

            // Ontain columns definition
            var columns = this._getGridDefinition();

            // Create grid assembler
            var gridAssembler = new this.gridAssemblerType({
                gridType: this.gridType,
                gridSettings: this.gridSettings,
                columnDefinitions: columns,
                listCommands: this.readOnly ? [] : this.model.getListCommands(),
                itemCommandsFactory: lang.hitch(this, function (item, category) {
                    return this.readOnly ? [] : this.model.getItemCommands(item, this.commands, category);
                })
            });

            // Build the grid.
            this.own(this.grid = gridAssembler.build(this.gridNode, this.commandTargetNode));

            //style Grid
            domClass.add(this.gridNode, "epi-plain-grid-modal epi-plain-grid--margin-bottom epi-plain-grid--cell-borders");

            // Setup dnd
            if (!this.gridSettings.dndDisabled) {
                this._setupDnD();
            }

            var items = this.model.get("items");
            this.grid.renderArray(items);

            if (!items || items.length <= 0) {
                this._renderNoDataMessage();
            }

            this.own(this.grid.on(".dgrid-row:click", lang.hitch(this, this.onGridRowClick)));

            this.own(this.grid.on(".dgrid-row:dblclick", lang.hitch(this, this.onGridRowDblClick)));
        },

        _setupDnD: function () {
            // summary:
            //      Set up the dnd on the grid.
            // tags:
            //      private

            this.own(aspect.after(this.grid.dndSource, "onDropData", lang.hitch(this, this.onDndDrop), true));
        },

       onDndDrop: function(dndData, source, nodes, copy) {
                var i;

                // internal move
                if (this.grid.dndSource === source) {
                    for (i = 0; i < nodes.length; i++) {
                        this.model.moveItem(
                            this.grid.dndSource.getItem(nodes[i].id).data,
                            this.grid.dndSource.current != null ?
                                this.grid.dndSource.getItem(this.grid.dndSource.current.id).data :
                                null,
                            this.grid.dndSource.before
                        );
                    }
                    // external drop
                } else {
                    // Set focus to mark start editing
                    // make sure editor will be marked as start-editing immediately by invoking onDropping
                    // to fix an issue in IE9, which was caused by the race condition,
                    // which would lead to a problem of auto save.
                    this.onDropping && this.onDropping();
                    this.onFocus();

                    for (i = 0; i < dndData.length; i++) {
                        this._addItem(dndData[i]);

                        // Remove from source?
                        // TODO: Simplify
                        if (source && source.grid && source.grid.consumer && source.grid.consumer !== this) {
                            source.grid.consumer.model.removeItem(this.grid.dndSource.getItem(nodes[i].id).data);
                        }
                    }
                }
        },

        _addItem: function (item) {
           when(this._dndGetItemData(item), lang.hitch(this, function (itemData) {
               this.model.addItem(
                   itemData,
                   this.grid.dndSource.current != null ?
                       this.grid.dndSource.getItem(this.grid.dndSource.current.id).data :
                       null,
                   this.grid.dndSource.before
               );
           }));
        },

        _dndGetItemData: function (item) {
            return item.data;
        },

        _getGridDefinition: function () {
            // summary:
            //      Returns grid's columns definition.
            // tags:
            //      private

            var columns = this.generateColumns ?
                this.model.generateColumnsDefinition(this.excludedColumns) : // If auto generate is on, ask model to compute columns definition.
                this.includedColumns || {}; // Otherwise, use configured ones.

            return this.model.generateFormatters(columns);
        },

        _onGridRowSelect: function(e){
            // summary:
            //      Makes sure the right commands are available in the context menu when selecting a row in the grid.
            // tags:
            //      private

            if (!this.grid.itemCommandProviderMap){
                return;
            }
            if (this._currentProviderHandler){
                this._currentProviderHandler.removeProvider();
            }
            var item = this.grid.row(e).data;
            this._currentProviderHandler = this.grid.contextMenu.addProvider(this.grid.itemCommandProviderMap[json.stringify(item)]);
        },

        onGridRowClick: function (e) {
            // summary:
            //      Makes sure the right commands are available in the context menu when selecting a row in the grid.
            // tags:
            //      protected
            this._onGridRowSelect(e);
        },

        onGridRowDblClick: function (e) {
            // summary:
            //      Makes sure the right commands are available in the context menu when selecting a row in the grid.
            // tags:
            //      protected
            var item = {
                model: this.grid.row(e).data
            };
            this.model.editItemDelegate(item);
        },

        _getDialogConfirmActionText: function(){
            return this.gridSettings.confirmActionText ? this.gridSettings.confirmActionText : this.inherited(arguments);
        },

        onExecuteDialog: function () {
            var item = this._itemEditor.get("value");

            if (this._editingItemIndex !== undefined) {
                this.model.saveItem(item, this._editingItemIndex);
            } else {
                this.model.addItem(item);
            }
        },

        _onItemsChanged: function (items) {
            // summary:
            //      The model's itemsChanged event handler.
            // items: Array
            //      The items list (Note that it is an item model instance, not the raw data item).
            // tags:
            //      private

            // If grid is created, rerender.
            if (this.grid) {
                for (var item in this.grid.itemCommandProviderMap) {
                    delete this.grid.itemCommandProviderMap[item];
                }
                this.grid.refresh();
                this.grid.renderArray(items);

                if (!items || items.length <= 0) {
                    this._renderNoDataMessage();
                }
            }

            // Set value and trigger change event
            var value = this.model.get("data"); // Get raw data which is unwrapped from item models.
            this._set("value", value);

            if (!this.readOnly) { // disable auto save if read only is true
                    this.onChange(value);
                }
        },

        _renderNoDataMessage: function() {
            this.grid.noDataNode = put(this.grid.contentNode, "div.dgrid-no-data");
            this.grid.noDataNode.innerHTML = this.grid.noDataMessage;
        },

        _onBlur: function () {
            // summary:
            //      Override base (_HasChildDialogMixin) to check that if the context menu is showing then continue keep focus on editor.
            // tags:
            //      protected override
            if (this.grid.contextMenu && this.grid.contextMenu.isShowingNow) {
                return;
            }
            this.inherited(arguments);
        }
    });
});
},
'dgrid/extensions/ColumnReorder':function(){
define([
	"dojo/_base/lang",
	"dojo/_base/declare",
	"dojo/_base/array",
	"dojo/on",
	"dojo/query",
	"dojo/dnd/Source",
	"put-selector/put",
	"xstyle/css!../css/extensions/ColumnReorder.css"
], function(lang, declare, arrayUtil, on, query, DndSource, put){
	var dndTypeRx = /(\d+)(?:-(\d+))?$/; // used to determine subrow from dndType
	
	// The following 2 functions are used by onDropInternal logic for
	// retrieving/modifying a given subRow.  The `match` variable in each is
	// expected to be the result of executing dndTypeRx on a subRow ID.
	
	function getMatchingSubRow(grid, match) {
		var hasColumnSets = match[2],
			rowOrSet = grid[hasColumnSets ? "columnSets" : "subRows"][match[1]];
		
		return hasColumnSets ? rowOrSet[match[2]] : rowOrSet;
	}
	
	function setMatchingSubRow(grid, match, subRow) {
		if(match[2]){
			grid.columnSets[match[1]][match[2]] = subRow;
		}else{
			grid.subRows[match[1]] = subRow;
		}
	}

	// Builds a prefix for a dndtype value based on a grid id.
	function makeDndTypePrefix(gridId) {
		return "dgrid-" + gridId + '-';
	}

	// Removes the grid id prefix from a dndtype value.  This allows the grid id to contain
	// a dash-number suffix.  This works only if a column is dropped on the grid from which it
	// originated.  Otherwise, a dash-number suffix will cause the regex to match on the wrong values.
	function stripIdPrefix(gridId, dndtype) {
		return dndtype.slice(makeDndTypePrefix(gridId).length);
	}
	
	var ColumnDndSource = declare(DndSource, {
		// summary:
		//		Custom dojo/dnd source extension configured specifically for
		//		dgrid column reordering.
		
		copyState: function(){ return false; }, // never copy
		
		checkAcceptance: function(source, nodes){
			return source == this; // self-accept only
		},
		
		_legalMouseDown: function(evt){
			// Overridden to prevent blocking ColumnResizer resize handles.
			return evt.target.className.indexOf("dgrid-resize-handle") > -1 ? false :
				this.inherited(arguments);
		},
		
		onDropInternal: function(nodes){
			var grid = this.grid,
				match = dndTypeRx.exec(stripIdPrefix(grid.id, nodes[0].getAttribute("dndType"))),
				structureProperty = match[2] ? "columnSets" : "subRows",
				oldSubRow = getMatchingSubRow(grid, match),
				columns = grid.columns;
			
			// First, allow original DnD logic to place node in new location.
			this.inherited(arguments);
			
			if(!match){ return; }
			
			// Then, iterate through the header cells in their new order,
			// to populate a new row array to assign as a new sub-row to the grid.
			// (Wait until the next turn to avoid errors in Opera.)
			setTimeout(function(){
				var newSubRow = arrayUtil.map(nodes[0].parentNode.childNodes, function(col) {
						return columns[col.columnId];
					}),
					eventObject;
				
				setMatchingSubRow(grid, match, newSubRow);
				
				eventObject = {
					grid: grid,
					subRow: newSubRow,
					column: columns[nodes[0].columnId],
					bubbles: true,
					cancelable: true,
					// Set parentType to indicate this is the result of user interaction.
					parentType: "dnd"
				};
				// Set columnSets or subRows depending on which the grid is using.
				eventObject[structureProperty] = grid[structureProperty];
				
				// Emit a custom event which passes the new structure.
				// Allow calling preventDefault() to cancel the reorder operation.
				if(on.emit(grid.domNode, "dgrid-columnreorder", eventObject)){
					// Event was not canceled - force processing of modified structure.
					grid.set(structureProperty, grid[structureProperty]);
				}else{
					// Event was canceled - revert the structure and re-render the header
					// (since the inherited logic invoked above will have shifted cells).
					setMatchingSubRow(grid, match, oldSubRow);
					grid.renderHeader();
					// After re-rendering the header, re-apply the sort arrow if needed.
					if (this._sort && this._sort.length){
						this.updateSortArrow(this._sort);
					}
				}
			}, 0);
		}
	});
	
	var ColumnReorder = declare(null, {
		// summary:
		//		Extension allowing reordering of columns in a grid via drag'n'drop.
		//		Reordering of columns within the same subrow or columnset is also
		//		supported; between different ones is not.
		
		// columnDndConstructor: Function
		//		Constructor to call for instantiating DnD sources within the grid's
		//		header.
		columnDndConstructor: ColumnDndSource,
		
		_initSubRowDnd: function(subRow, dndType){
			// summary:
			//		Initializes a dojo/dnd source for one subrow of a grid;
			//		this could be its only subrow, one of several, or a subrow within a
			//		columnset.
			
			var dndParent, c, len, col, th;
			
			for(c = 0, len = subRow.length; c < len; c++){
				col = subRow[c];
				if(col.reorderable === false){ continue; }
				
				th = col.headerNode;
				if(th.tagName != "TH"){ th = th.parentNode; } // from IE < 8 padding
				// Add dojoDndItem class, and a dndType unique to this subrow.
				put(th, ".dojoDndItem[dndType=" + dndType + "]");
				
				if(!dndParent){ dndParent = th.parentNode; }
			}
			
			if(dndParent){ // (if dndParent wasn't set, no columns are draggable!)
				this._columnDndSources.push(new this.columnDndConstructor(dndParent, {
					horizontal: true,
					grid: this
				}));
			}
		},
		
		renderHeader: function(){
			var dndTypePrefix = makeDndTypePrefix(this.id),
				csLength, cs;
			
			this.inherited(arguments);
			
			// After header is rendered, set up a dnd source on each of its subrows.
			
			this._columnDndSources = [];
			
			if(this.columnSets){
				// Iterate columnsets->subrows->columns.
				for(cs = 0, csLength = this.columnSets.length; cs < csLength; cs++){
					arrayUtil.forEach(this.columnSets[cs], function(subRow, sr){
						this._initSubRowDnd(subRow, dndTypePrefix + cs + "-" + sr);
					}, this);
				}
			}else{
				// Iterate subrows->columns.
				arrayUtil.forEach(this.subRows, function(subRow, sr){
					this._initSubRowDnd(subRow, dndTypePrefix + sr);
				}, this);
			}
		},
		
		_destroyColumns: function(){
			if(this._columnDndSources){
				// Destroy old dnd sources.
				arrayUtil.forEach(this._columnDndSources, function(source){
					source.destroy();
				});
			}
			
			this.inherited(arguments);
		}
	});
	
	ColumnReorder.ColumnDndSource = ColumnDndSource;
	return ColumnReorder;
});

},
'epi-cms/contentediting/editors/model/CollectionEditorModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/Evented",
    "dojo/Stateful",
    "dojo/when",
    "dojo/promise/all",

    "dijit/Destroyable",

    "dojox/mvc/StatefulArray",

    "epi/dependency",
    "epi/string",
    "epi/shell/command/DelegateCommand",

    "epi-cms/contentediting/editors/model/CollectionEditorItemModel",
    "epi-cms/dgrid/formatters",

    "epi/i18n!epi/nls/episerver.shared"
],
function (
    array,
    declare,
    lang,

    aspect,
    Deferred,
    Evented,
    Stateful,
    when,
    all,

    Destroyable,

    StatefulArray,

    dependency,
    epiString,
    DelegateCommand,

    CollectionEditorItemModel,
    formatters,

    sharedResources
) {
    // module:
    //      epi-cms/contentediting/editors/model/CollectionEditorModel
    // summary:
    //      Model class for collection editor.

    var commandMask = {
        none: 0, add: 1, edit: 2, remove: 4, moveUp: 8, moveDown: 16
    };

    var CollectionEditorModel = declare([Stateful, Evented, Destroyable], {
        // data: Object[]
        //      The raw data collection.
        data: null,

        // itemType: String
        //      Server item type, which is used to retrieve item's metadata
        itemType: null,

        // itemModelType: Fuction
        //      Item Model constructor. Default is epi-cms/contentediting/editors/model/CollectionEditorItemModel.
        itemModelType: null,

        // itemMetadata: Object
        //      The item's metadata.
        itemMetadata: null,

        // metadataManager: Object
        //      The metadata manager reference.
        metadataManager: null,

        //  availableCommands: Object
        //      The available commands.
        availableCommands: null,

        // _itemModels: dojox/mvc/StatefulArray
        //      The item models array
        _itemModels: null,

        // _itemsUnchanged: Boolean
        //      Indicate that the items are unchanged (only order is changed)
        _itemsUnchanged: false,

        postscript: function () {
            // summary:
            //      Post script initialization.
            // description:
            //      Set default values.

            this.inherited(arguments);

            this.metadataManager = this.metadataManager || dependency.resolve("epi.shell.MetadataManager");

            this.itemModelType = this.itemModelType || CollectionEditorItemModel;
        },

        initialize: function () {
            // summary:
            //      Initialize the model.
            // return:
            //      A promise which resolves when initialization is done.
            // tags:
            //      public

            // Retrieve metadata and init data when finished.
            return when(this.metadataManager.getMetadataForType(this.itemType), lang.hitch(this, function (metadata) {
                // TODO: Don't retrieve metadata if we don't use it to generate columns
                this.set("itemMetadata", metadata);

                return this._initData();
            }));
        },

        _initData: function () {
            // summary:
            //      Initialize data.
            // return:
            //     A promise which resolves when all the data items are set up.
            // tags:
            //      private

            // Create a stateful array to hold item models.
            this._itemModels = new StatefulArray([]);
            aspect.before(this._itemModels, "sort", lang.hitch(this, function () {
                // Turn on flag
                this._itemsUnchanged = true;
            }, true));

            // Watch the item models for change.
            this.own(this._itemModels.watchElements(lang.hitch(this, function () {
                if (!this._itemsUnchanged) {
                    this.emit("itemsChanged", this.get("items"));
                }
                // Reset flag Sortorder
                this._itemsUnchanged = false;
            })));

            // Create initializer for each item.
            var itemInitializers = array.map(this.data, function (item) {
                var itemModel = new this.itemModelType();
                return when(itemModel.fromItemData(item), function () {
                    return itemModel;
                });
            }, this);

            // Perform item initialization.
            return when(all(itemInitializers), lang.hitch(this, function (itemModels) {
                // Add the created ones to the item models list.
                this._itemModels.splice.apply(this._itemModels, [0, this._itemModels.length].concat(itemModels));
            }));
        },

        getListCommands: function (availableCommands) {
            // summary:
            //      Return list level commands.
            // availableCommands:
            //      The available commands bitmask. This value is Not needed to be passed since it's set up when the model is created.
            // tags:
            //      public

            return [
                new DelegateCommand({
                    name: "add",
                    tooltip: sharedResources.action.add,
                    iconClass: "epi-iconPlus",
                    canExecute: true,
                    isAvailable: this._commandIsAvailable(commandMask.add, availableCommands),
                    delegate: lang.hitch(this, this.addItemDelegate)
                })
            ];
        },

        getItemCommands: function (item, availableCommands, category) {
            // summary:
            //      Return item level commands.
            // item:
            //      The item
            // availableCommands:
            //      The available commands bitmask. This value is Not needed to be passed since it's set up when the model is created.
            // category:
            //      The category
            // tags:
            //      public

            return [
                new DelegateCommand({
                    name: "edit",
                    category: category,
                    label: sharedResources.action.edit,
                    iconClass: "epi-iconPen",
                    model: item,
                    canExecute: true,
                    isAvailable: this._commandIsAvailable(commandMask.edit, availableCommands),
                    delegate: lang.hitch(this, this.editItemDelegate)
                }),


                new DelegateCommand({
                    name: "moveUp",
                    category: category,
                    label: sharedResources.action.moveup,
                    iconClass: "epi-iconUp",
                    model: item,
                    canExecute: this._itemModels.indexOf(item) > 0,
                    isAvailable: this._commandIsAvailable(commandMask.moveUp, availableCommands),
                    delegate: lang.hitch(this, this.moveItemUpDelegate)
                }),

                new DelegateCommand({
                    name: "moveDown",
                    category: category,
                    label: sharedResources.action.movedown,
                    iconClass: "epi-iconDown",
                    model: item,
                    canExecute: this._itemModels.indexOf(item) < this._itemModels.length - 1,
                    isAvailable: this._commandIsAvailable(commandMask.moveDown, availableCommands),
                    delegate: lang.hitch(this, this.moveItemDownDelegate)
                }),

                new DelegateCommand({
                    name: "remove",
                    category: category,
                    label: sharedResources.action.remove,
                    iconClass: "epi-iconTrash",
                    model: item,
                    canExecute: true,
                    isAvailable: this._commandIsAvailable(commandMask.remove, availableCommands),
                    delegate: lang.hitch(this, this.removeItemDelegate)
                })
            ];
        },

        _commandIsAvailable: function (command, availableCommands) {
            // summary:
            //      Test if the command is available according to the bitmask.
            // command:
            //      The command.
            // availableCommands:
            //      The available commands bitmask. Not needed to be passed since it's set up when the model is created.
            // tags:
            //      private

            availableCommands = availableCommands || this.availableCommands;

            return !!(command & availableCommands);
        },

        generateColumnsDefinition: function (excludedColumns) {
            // summary:
            //      Generate columns definition from item type's metadata.
            // excludedColumns:
            //      The columns which are excluded.
            // tags:
            //      public

            var columnDefinitions = {};

            array.forEach(array.filter(this.itemMetadata.properties, function (property) {
                // filter exlcuded properties
                return array.every(excludedColumns, function (col) {
                    return col !== property.name;
                });
            }), function (property) {
                var columnName = epiString.pascalToCamel(property.name);

                columnDefinitions[columnName] = {
                    // TODO: More options?
                    label: property.displayName
                };
            });

            return columnDefinitions;
        },

        generateFormatters: function (columnDefinitions) {
            // summary:
            //      Generate formatters for the specified column definitions.
            // columnDefinitions:
            //      The definition for the columns that should get the generated formatters.
            // tags:
            //      public

            for (var columnName in columnDefinitions) {
                array.some(this.itemMetadata.properties, function(property){
                    if (columnName == epiString.pascalToCamel(property.name)){
                        this._setTypeFormatter(property, columnDefinitions[columnName]);
                        this._setSelectionFactoryFormatter(property, columnDefinitions[columnName]);
                        this._setWrappingFormatter(columnDefinitions[columnName]);
                        return true;
                    }
                }, this);
            }
            return columnDefinitions;
        },

        _typeFormatterMap: {
            "System.DateTime": formatters.localizedDate,
            "System.Boolean": formatters.friendlyBoolean
        },

        _wrappingFormatterMap: {
            "SecondaryText": function(formatter) {
                if (formatter) {
                    return function(value) {
                        return formatters.secondaryText(formatter(value), true);
                    };
                }

                return function (value) {
                    return formatters.secondaryText(value);
                };
            },
            "VisibleLink": function(formatter) {
                if (formatter) {
                    return function (value) {
                        return formatters.visibleLink(formatter(value), true);
                    };
                }

                return function (value) {
                    return formatters.visibleLink(value);
                };
            }
        },

        _setTypeFormatter: function(property, columnDefinition){

            for(var typeName in this._typeFormatterMap){
                //nullable types in model type forces this "strange" check for type
                if (property.modelType.indexOf(typeName) > -1) {
                    columnDefinition.formatter = this._typeFormatterMap[typeName];
                    break;
                }
            }
        },

        _setSelectionFactoryFormatter: function (property, columnDefinition) {

            if (property.selections && property.selections.length > 0) {
                var selections = property.selections;

                if (columnDefinition) {
                    columnDefinition.formatter = function (value) {
                        var valueText = value;

                        selections.forEach(function (selection) {
                            if (selection.value === value) {
                                valueText = selection.text;
                            }
                        });

                        return valueText;
                    };
                }
            }
        },

        _setWrappingFormatter: function (columnDefinition) {

            // summary:
            //      Sets the formatter on the column definition by using a wrapping formatter, if a wrapping formatter exists for the column definition.
            // columnDefinitions:
            //      The definition for the columns that should get the generated formatters.
            // tags:
            //      private
            if (columnDefinition.wrappingFormatter && this._wrappingFormatterMap[columnDefinition.wrappingFormatter]) {
                columnDefinition.formatter = this._wrappingFormatterMap[columnDefinition.wrappingFormatter](columnDefinition.formatter);
            }
        },

        //----------------------------------------------------------------------------------
        // Command delagate methods
        //----------------------------------------------------------------------------------
        addItemDelegate: function () {
            // summary:
            //      execute delegate for add command.
            // tags:
            //      protected

            this.emit("toggleItemEditor", null);
        },

        editItemDelegate: function (cmd) {
            // summary:
            //      execute delegate for edit command.
            // tags:
            //      protected
            if (this._commandIsAvailable(commandMask.edit, this.availableCommands)) {

                var item = cmd.model;
                var index = this._itemModels.indexOf(item);

                this.emit("toggleItemEditor", item, index);
            }
        },

        removeItemDelegate: function (cmd) {
            // summary:
            //      execute delegate for remove command.
            // tags:
            //      protected

            this.removeItem(cmd.model);
        },

        moveItemUpDelegate: function (cmd) {
            // summary:
            //      execute delegate for move up command.
            // tags:
            //      protected

            var item = cmd.model;
            var index = this._itemModels.indexOf(item);
            var refIndex = index - 1;

            if (refIndex >= 0) {
                this.moveItem(item, this._itemModels[refIndex], true);
            }
        },

        moveItemDownDelegate: function (cmd) {
            // summary:
            //      execute delegate for move down command.
            // tags:
            //      protected

            var item = cmd.model;
            var index = this._itemModels.indexOf(item);
            var refIndex = index + 1;

            if (refIndex < this._itemModels.length) {
                this.moveItem(item, this._itemModels[refIndex], false);
            }
        },

        //----------------------------------------------------------------------------------
        // Model manipulation API methods
        //----------------------------------------------------------------------------------
        saveItem: function (item, index) {
            // summary:
            //      Save an item.
            // item: Object
            //      The item raw data
            // index: Number
            //      The item index
            // tags:
            //      public

            var itemModel = new this.itemModelType();

            return when(itemModel.fromItemData(item), lang.hitch(this, function () {
                this._itemModels.splice(index, 1, itemModel);
            }));
        },

        addItem: function (item, refItem, before) {
            // summary:
            //      Add new item.
            // item: Object
            //      The item raw data
            // refItem: Object
            //      The reference item (item model instance)
            // before: Boolean
            //      Indicates that the new item should be added before the reference item.
            // tags:
            //      public

            var itemModel = new this.itemModelType();

            return when(itemModel.fromItemData(item), lang.hitch(this, function () {
                var refIndex;
                if (!refItem) {
                    // If we have no reference item, put new item to the end (Add from item editor case)
                    refIndex = this._itemModels.length;
                } else {
                    // Drop from external source
                    refIndex = this._itemModels.indexOf(refItem);

                    if (!before) {
                        refIndex++;
                    }
                }

                this._itemModels.splice(refIndex, 0, itemModel);
            }));
        },

        moveItem: function (item, refItem, before) {
            // summary:
            //      Move an item.
            // item: Object
            //      The item model instance
            // refItem: Object
            //      The reference item (item model instance)
            // before: Boolean
            //      Indicates that the new item should be moved before the reference item.
            // tags:
            //      public

            // Indicate that is still moving
            this._itemsUnchanged = true;

            var itemIndex = this._itemModels.indexOf(item);

            // Remove item
            this._itemModels.splice(itemIndex, 1);

            // Get ref index
            var refIndex = this._itemModels.indexOf(refItem);
            var targetIndex = before ? refIndex : refIndex + 1;
            //are we moving the same item? use itemIndex since refIndex will be -1;
            targetIndex = item == refItem ? itemIndex : targetIndex;

            this._itemModels.splice(targetIndex, 0, item);
        },

        removeItem: function (item) {
            // summary:
            //      Remove an item.
            // item: Object
            //      The item model instance
            // tags:
            //      public

            var index = this._itemModels.indexOf(item);
            this._itemModels.splice(index, 1);
        },

        //----------------------------------------------------------------------------------
        // Property accessors
        //----------------------------------------------------------------------------------

        _dataSetter: function (value) {
            // summary:
            //      Set data property.
            // tags:
            //      private

            this.data = value;
            this._initData();
        },

        _dataGetter: function () {
            // summary:
            //      Get data property.
            // tags:
            //      private

            return array.map(this._itemModels, function (itemModel) {
                return itemModel.toItemData();
            }, this);
        },

        _itemsGetter: function () {
            // summary:
            //      Get items property.
            // tags:
            //      private

            return this._itemModels;
        }
    });

    // commandMask: [internal, static] Object
    //      Command mask enum.
    CollectionEditorModel.commandMask = commandMask;

    return CollectionEditorModel;
});

},
'dojox/mvc/StatefulArray':function(){
define("dojox/mvc/StatefulArray", [
	"dojo/_base/lang",
	"dojo/Stateful"
], function(lang, Stateful){
	function update(/*dojox/mvc/StatefulArray*/ a){
		// summary:
		//		Set all array elements as stateful so that watch function runs.
		// a: dojox/mvc/StatefulArray
		//		The array.

		// Notify change of elements.
		if(a._watchElementCallbacks){
			a._watchElementCallbacks();
		}

		return a; // dojox/mvc/StatefulArray
	}

	var StatefulArray = function(/*Anything[]*/ a){
		// summary:
		//		An inheritance of native JavaScript array, that adds dojo/Stateful capability.
		// description:
		//		Supported methods are:
		//
		//		- pop() - Stateful update is done for the removed element, as well as the length.
		//		- push() - Stateful update is done for the added element, as well as the length.
		//		- reverse() - Stateful update is done for the elements.
		//		- shift() - Stateful update is done for the removed element, as well as the length.
		//		- sort() - Stateful update is done for the elements.
		//		- splice() - Stateful update is done for the removed/added elements, as well as the length. Returns an instance of StatefulArray instead of the native array.
		//		- unshift() - Stateful update is done for the added element, as well as the length.
		//		- concat() - Returns an instance of StatefulArray instead of the native Array.
		//		- join() - The length as well as the elements are obtained via stateful getters, instead of direct access.
		//		- slice() - The length as well as the elements are obtained via stateful getters, instead of direct access.
		//		- Setting an element to this array via set() - Stateful update is done for the new element as well as the new length.
		//		- Setting a length to this array via set() - Stateful update is done for the removed/added elements as well as the new length.

		var array = lang._toArray(a);
		var ctor = StatefulArray;
		ctor._meta = {bases: [Stateful]}; // For isInstanceOf()
		array.constructor = ctor;
		return lang.mixin(array, {
			pop: function(){
				return this.splice(this.get("length") - 1, 1)[0];
			},
			push: function(){
				this.splice.apply(this, [this.get("length"), 0].concat(lang._toArray(arguments)));
				return this.get("length");
			},
			reverse: function(){
				return update([].reverse.apply(this, lang._toArray(arguments)));
			},
			shift: function(){
				return this.splice(0, 1)[0];
			},
			sort: function(){
				return update([].sort.apply(this, lang._toArray(arguments)));
			},
			splice: function(/*Number*/ idx, /*Number*/ n){
				// summary:
				//		Removes and then adds some elements to an array.
				//		Updates the removed/added elements, as well as the length, as stateful.
				// idx: Number
				//		The index where removal/addition should be done.
				// n: Number
				//		How many elements to be removed at idx.
				// varargs: Anything[]
				//		The elements to be added to idx.
				// returns: dojox/mvc/StatefulArray
				//		The removed elements.

				var l = this.get("length");

				idx += idx < 0 ? l : 0;

				var p = Math.min(idx, l),
				 removals = this.slice(idx, idx + n),
				 adds = lang._toArray(arguments).slice(2);

				// Do the modification in a native manner except for setting additions
				[].splice.apply(this, [idx, n].concat(new Array(adds.length)));

				// Set additions in a stateful manner
				for(var i = 0; i < adds.length; i++){
					this.set(p + i, adds[i]);
				}

				// Notify change of elements.
				if(this._watchElementCallbacks){
					this._watchElementCallbacks(idx, removals, adds);
				}

				// Notify change of length.
				// Not calling the setter for "length" though, given removal/addition of array automatically changes the length.
				if(this._watchCallbacks){
					this._watchCallbacks("length", l, l - removals.length + adds.length);
				}

				return removals; // dojox/mvc/StatefulArray
			},
			unshift: function(){
				this.splice.apply(this, [0, 0].concat(lang._toArray(arguments)));
				return this.get("length");
			},
			concat: function(/*Array*/ a){
				return new StatefulArray([].concat(this).concat(a));
			},
			join: function(/*String*/ sep){
				// summary:
				//		Returns a string joining string elements in a, with a separator.
				// sep: String
				//		The separator.

				var list = [];
				for(var l = this.get("length"), i = 0; i < l; i++){
					list.push(this.get(i));
				}
				return list.join(sep); // String
			},
			slice: function(/*Number*/ start, /*Number*/ end){
				// summary:
				//		Returns partial elements of an array.
				// start: Number
				//		The index to begin with.
				// end: Number
				//		The index to end at. (a[end] won't be picked up)

				var l = this.get("length");

				start += start < 0 ? l : 0;
				end = (end === void 0 ? l : end) + (end < 0 ? l : 0);

				var slice = [];
				for(var i = start || 0; i < Math.min(end, this.get("length")); i++){
					slice.push(this.get(i));
				}
				return new StatefulArray(slice); // dojox/mvc/StatefuArray
			},
			watchElements: function(/*Function*/ callback){
				// summary:
				//		Watch for change in array elements.
				// callback: Function
				//		The callback function, which should take: The array index, the removed elements, and the added elements.

				var callbacks = this._watchElementCallbacks, _self = this;
				if(!callbacks){
					callbacks = this._watchElementCallbacks = function(idx, removals, adds){
						for(var list = [].concat(callbacks.list), i = 0; i < list.length; i++){
							list[i].call(_self, idx, removals, adds);
						}
					};
					callbacks.list = [];
				}

				callbacks.list.push(callback);

				var h = {};
				h.unwatch = h.remove = function(){
					for(var list = callbacks.list, i = 0; i < list.length; i++){
						if(list[i] == callback){
							list.splice(i, 1);
							break;
						}
					}
				}; 
				return h; // dojo/handle
			}
		}, Stateful.prototype, {
			set: function(/*Number|String*/ name, /*Anything*/ value){
				// summary:
				//		Sets a new value to an array.
				// name: Number|String
				//		The property name.
				// value: Anything
				//		The new value.

				if(name == "length"){
					var old = this.get("length");
					if(old < value){
						this.splice.apply(this, [old, 0].concat(new Array(value - old)));
					}else if(value > old){
						this.splice.apply(this, [value, old - value]);
					}
					return this;
				}else{
					var oldLength = this.length;
					Stateful.prototype.set.call(this, name, value);
					if(oldLength != this.length){
						Stateful.prototype.set.call(this, "length", this.length);
					}
					return this;
				}
			}
		});
	};

	return lang.setObject("dojox.mvc.StatefulArray", StatefulArray);
});

},
'epi/shell/command/DelegateCommand':function(){
﻿define("epi/shell/command/DelegateCommand", [
    "dojo/_base/declare",
    "epi/shell/command/_Command"
], function (declare, _Command) {

    // module:
    //		epi/shell/command/DelegateCommand
    // summary:
    //		A command implementation which can delegate execution to an external model.

    return declare([_Command], {

        // delegate: Function
        //      The delegate method.
        delegate: null,

        _execute: function () {
            // summary:
            //      Execute the command
            // tags:
            //      protected

            // Execute the delagate. Alter the arguments to send this instance as the first parameter.
            return this.delegate ? this.delegate.apply(this, [this].concat(arguments)) : null;
        }
    });
});
},
'epi-cms/contentediting/editors/model/CollectionEditorItemModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful"
], function (
// Dojo
    declare,
    lang,
    Stateful
) {
    // module: 
    //      epi-cms/contentediting/editors/model/CollectionEditorItemModel.
    // summary:
    //      Item model class for collection editor.

    return declare([Stateful], {
        // _itemData: Object
        //      The original item
        _itemData: null,


        // name: String
        //      Item name. Used for item's dnd creator.
        name: null,

        fromItemData: function (itemData) {
            // summary:
            //      Create item model object from raw item data.
            // itemData: Object
            //      The raw item data.
            // tags:
            //      public

            lang.mixin(this, itemData);

            this._itemData = itemData;
            this.name = this.name || this._itemData.toString();
        },

        toItemData: function () {
            // summary:
            //      Unwrap item model and return raw item data.
            // tags:
            //      public

            var result = {};

            for (var property in this._itemData) {
                if (this._itemData.hasOwnProperty(property)) {
                    result[property] = this.get(property);
                }
            }

            return result;
        }
    });
});
},
'epi-cms/contentediting/editors/DefaultGridAssembler':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/json",
    "dojo/Stateful",

// epi shell
    "epi/shell/command/builder/ButtonBuilder",
    "epi/shell/command/withConfirmation",

// epi cms
    "epi-cms/dgrid/formatters"

],
function (
   // dojo
    array,
    declare,
    lang,

    json,
    Stateful,

// epi shell
    ButtonBuilder,
    withConfirmation,
    formatters
) {


    // module:
    //      epi-cmd/contentediting/editors/CollectionEditor.
    // summary:
    //      Editor widget for collection like value.

    // Base grid assembler
    var _GridAssembler = declare([], {
        // gridType: Function
        //      The grid constructor.
        gridType: null,

        // gridSettings: Object
        //      The grid settings.
        gridSettings: null,

        // columnDefinitions: Array|Object
        //      The grid's column definition.
        columnDefinitions: null,

        // listCommands: Array<Command>
        //      The list level commands.
        listCommands: null,

        // itemCommandFactory: Array<Command>
        //      The item level commands.
        itemCommandsFactory: null,

        // summary:
        //      Construct _GridAssembler object.
        // params: Object
        //      The parameters.
        constructor: function (params) {
            lang.mixin(this, params);
        },

        // summary:
        //      Build the grid from given parameters.
        // gridNode: DomNode
        //      The dom node where the grid is created on.
        // listCommandNode: DomNode
        //      The dom node where the list command is created on.
        // tags:
        //      public, abstract
        build: function (gridNode, listCommandNode) {
        },

        // summary:
        //      Instantiate a dgid object.
        // gridType: Function
        //      The grid constructor.
        // gridSettings: Object
        //      The grid settings.
        // columnDefinitions: Array|Object
        //      The grid's columns definition.
        // node: DomNode
        //      The dom node where the grid is created on.
        // tags:
        //      protected
        instantiateGrid: function (gridType, gridSettings, columnDefinitions, node) {
            return new gridType(lang.mixin(gridSettings, {
                columns: columnDefinitions,
                className: "epi-plain-grid"
            }), node);
        }
    });

return declare([_GridAssembler], {

    itemCommandProviderMap: null,

    constructor: function () {
        this.itemCommandProviderMap = {};
    },

    build: function (gridNode, listCommandNode) {
        // summary:
        //      Build the grid from given parameters.
        // gridNode: DomNode
        //      The dom node where the grid is created on.
        // listCommandNode: DomNode
        //      The dom node where the list command is created on.
        // tags:
        //      public, abstract

        // add an action column
        this.columnDefinitions["_epiGrid_Action"] = {
            renderHeaderCell: function () { }, // no header
            renderCell: lang.hitch(this, function (item, value, node, options) {
                var commands = this._getItemCommands(item);
                this.itemCommandProviderMap[json.stringify(item)] = new Stateful({
                    commands: commands
                });
                this.renderActionMenu(item, node, commands);
            }),
            className: "epi-columnNarrow",
            sortable: false
        };

        var grid = this.instantiateGrid(this.gridType, this.gridSettings, this.columnDefinitions, gridNode);
        grid.itemCommandProviderMap = this.itemCommandProviderMap;

        this._setupCommands(this.listCommands, listCommandNode);

        return grid;
    },

    renderActionMenu: function (item, node, commands) {

        node.innerHTML = commands && commands.length > 0 ?
            formatters.menu({
                title: epi.resources.action.options
            }) : ""; //if there are no commands, dont render any context menu
    },

    _getItemCommands: function (item) {
        var commands = this.itemCommandsFactory(item, "context");
        array.some(commands, function (command) {
            if (command.name == "remove" && this.gridSettings.useDeleteWithConfirmation) {
                command = withConfirmation(command, null, {
                    title: this.gridSettings.deleteConfirmationTitle,
                    description: this.gridSettings.deleteConfirmationMessage
                });
                return true;
            }
        }, this);
        return commands;
    },

    _setupCommands: function (commands, target) {
        // summary:
        //      Setup UI for commands on the target.
        // tags:
        //      private

        var builder = this.getListCommandBuilder();
        array.forEach(commands, function (command) {
            builder.create(command, target);
        }, this);
    },

    getListCommandBuilder: function(){
        return new ButtonBuilder({ settings: { showLabel: true } });
    }
});

});
},
'epi-cms/contentediting/editors/_AddItemDialogMixin':function(){
﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    // epi
    "epi/shell/widget/_ValueRequiredMixin",
    "epi/shell/widget/dialog/Dialog",
    // epi-cms
    "../../widget/_HasChildDialogMixin",
    // resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.collectioneditor",
    "epi/i18n!epi/nls/episerver.shared"
], function(
    // dojo
    declare,
    lang,
    on,
    // epi
    _ValueRequiredMixin,
    Dialog,
    // epi-cms
    _HasChildDialogMixin,
    // resources
    resources,
    sharedResources
){
    return declare([_ValueRequiredMixin, _HasChildDialogMixin], {

        // itemEditorType: Function
        //      The item editor class.
        itemEditorType: null,

        _itemEditor: null,

        _dialog: null,

        // Set autofocus to false to prevent the validate the require fields when opening dialog.
        dialogParams: null,

        _editingItemIndex: null,

        postCreate: function(){
            this.inherited(arguments);

            // Connect to model events
            this.own(on(this.model, "toggleItemEditor", lang.hitch(this, this._onToggleItemEditor)));
        },

        _onToggleItemEditor: function (item, index) {
            // summary:
            //      The model's toggleItemEditor event handler.
            // item: Object
            //      The item to edit (Note that it is an item model instance, not the raw data item). If null, open item editor to create new item.
            // tags:
            //      private

            this._setupItemEditor();

            // Set data to item editor. (NOTE: Consider item model or raw data???)
            this._itemEditor.set("value", item);
            this._editingItemIndex = index;

            // Show the dialog.
            this.isShowingChildDialog = true;
            this._dialog.show();

            this._setDialogConfirmActionText(item);
            this._setDialogTitle(item);

            // Set confirm action status when showing dialog
            this._setDialogConfirmActionStatus(item);
        },

        _setupItemEditor: function () {
            // summary:
            //      Returns grid's columns definition.
            // tags:
            //      private

            // Create item editor
            this._itemEditor = this._createItemEditor();
            this.own(
               // Create dialog
               this._dialog = new Dialog(lang.mixin(
                {
                    title: this._getDialogTitleText(),
                    content: this._itemEditor,
                    destroyOnHide: true
                }, this.dialogParams))
            );
            // the dialog will own all events so they get destroyed when the dialog is destroyed
            this._dialog.own(
                this._itemEditor,
                this.connect(this._itemEditor, "onChange", "_setDialogConfirmActionStatus"),

                // Connect to dialog events
                on(this._dialog, "execute", lang.hitch(this, function () {
                    if (this.validate()) {
                        this.onExecuteDialog();
                    }
                })),
                on(this._dialog, "hide", lang.hitch(this, this._onCancelDialog))
            );
        },

        _createItemEditor: function(){
            return new this.itemEditorType({ metadata: this.model.get("itemMetadata"), doLayout: false });
        },

        _setDialogTitle: function(existingItem){
            this._dialog.set("title", this._getDialogTitleText(existingItem));
        },

        _getDialogTitleText: function(existingItem){
            return resources.title;
        },

        _onCancelDialog: function () {
            this.isShowingChildDialog = false;
            this.onCancelDialog();
        },

        onExecuteDialog: function () {
            // summary:
            //      Callback for when the dialog is executed
        },

        onCancelDialog: function () {
            // summary:
            //      Callback for when the dialog is cancelled
        },

        _setDialogConfirmActionText: function(existingItem){
            this._dialog.onActionPropertyChanged({ name: this._dialog._okButtonName }, "label", this._getDialogConfirmActionText(existingItem));
        },

        _getDialogConfirmActionText: function(existingItem){
            return existingItem ? sharedResources.action.ok : sharedResources.action.add;
        },

        _setDialogConfirmActionStatus: function (item) {
            this._dialog.onActionPropertyChanged({ name: this._dialog._okButtonName }, "disabled", !item || item === "");
        }
    });

});


},
'epi-cms/widget/_HasChildDialogMixin':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom",
    "dijit/_FocusMixin",
    "dijit/popup"
], function (
    declare,
    lang,
    aspect,
    dom,
    _FocusMixin,
    popup
    ) {

    return declare([_FocusMixin], {
        // summary:
        //    Base class for all EPiServer CMS property editor controls.
        // tags:
        //    public

        // isShowingChildDialog: [public] Boolean
        //    Indicates whether a child dialog window is currently being displayed.
        isShowingChildDialog: false,

        // _openedChildDialog: [private] Widget
        //      A reference to the currently open child dialog
        _openedChildDialog: null,

        // _waitingForFocus: [private] Boolean
        //      A flag indicating that the child dialog has been closed and we're waiting for a focus on this widget
        _waitingForFocus:false,

        startup: function () {
            if (!this._started) {
                this.own(
                    aspect.before(popup, "open", lang.hitch(this, "_onPopupOpen"), true),
                    aspect.after(popup, "close", lang.hitch(this, "_onPopupClosed"), true)
                );
            }

            this.inherited(arguments);
        },

        _onPopupOpen: function(openArgs) {
            // summary:
            //      Called before a popup is opened.
            //      Checks id the popup is opened for a descendant of
            var popup = openArgs.popup;

            // currentTarget is the node clicked to open a pop-up menu
            var target = popup && popup.currentTarget;

            // if the popup is a opened for a descendant node, then it's opened for this widget
            // and we're entering "prevent blur" mode.
            if (target && dom.isDescendant(target, this.domNode)) {
                this._openedChildDialog = popup;
                this.isShowingChildDialog = true;
            }
        },

        _onPopupClosed: function(popup) {
            // summary:
            //      Called when a popup dialog has been closed
            if (this._openedChildDialog === popup) {
                this._openedChildDialog = null;
                this.isShowingChildDialog = false;

                // If the popup is closed by a click on this widget we get a focus call,
                // but when focus is lost to a widget which isn't a child of ours we need to explicitly
                // call _onBlur since we've prevented the original blur call when the pop-up was opened.
                // If we're still waiting for a focus call when _waitForFocus executes we've lost focus
                // to an element which is not descendant.
                this._waitingForFocus = true;
                setTimeout(lang.hitch(this, "_waitForFocus"), 0);
            }
        },

        _waitForFocus:function() {
            // Pop-up was closed and we should have received focus by now if we are the new focus target.
            if (this._waitingForFocus) {
                this._waitingForFocus = false;
                this._onBlur();
            }
        },

        _onBlur: function () {
            // summary:
            //		This is where widgets do processing for when they stop being active,
            //		such as changing CSS classes.  See onBlur() for more details.
            // tags:
            //		protected

            if (this.isShowingChildDialog) {
                return;
            }

            this.inherited(arguments);
        },

        _onFocus: function () {
			// summary:
			//		This is where widgets do processing for when they are active,
			//		such as changing CSS classes.  See onFocus() for more details.
			// tags:
			//		protected

            this._waitingForFocus = false;

            if (this.isShowingChildDialog) {
                return;
            }

            this.inherited(arguments);
        }
    });
});

},
'url:epi-cms/contentediting/editors/templates/CollectionEditor.html':"﻿<div class=\"dijitInline\" style=\"width:100%;\">\r\n    <div data-dojo-attach-point=\"commandTargetNode\"></div>\r\n    <div data-dojo-attach-point=\"gridNode\"></div>\r\n</div>",
'epi-cms/contentediting/editors/ContentAreaEditor':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-style",
    "dojo/Deferred",
    "dojo/on",
    "dojo/topic",
    "dojo/when",

//Dijit
    "dijit/registry",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_CssStateMixin",
    "dijit/_WidgetsInTemplateMixin",

// EPi Framework
    "epi/dependency",
    "epi/shell/dnd/Target",
    "epi/shell/command/_CommandProviderMixin",

//EPi CMS
    "./_ContentAreaTree",
    "./_ContentAreaTreeModel",
    "./_TextWithActionLinksMixin",
    "epi-cms/_ContentContextMixin",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/viewmodel/ContentAreaViewModel",
    "epi/shell/widget/ContextMenu",
    "epi/shell/widget/_ValueRequiredMixin",
    "epi-cms/widget/overlay/Block",
    "epi-cms/widget/command/CreateContentFromSelector",

    "epi-cms/widget/_HasChildDialogMixin",

    "epi-cms/contentediting/command/BlockRemove",
    "epi-cms/contentediting/command/BlockEdit",
    "epi-cms/contentediting/command/MoveToPrevious",
    "epi-cms/contentediting/command/MoveToNext",
    "epi-cms/contentediting/command/MoveOutsideGroup",
    "epi-cms/contentediting/command/Personalize",
    "epi-cms/contentediting/command/SelectDisplayOption",

// Resources
    "dojo/text!./templates/ContentAreaEditor.html",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea"
],
function (

// Dojo
    declare,
    lang,
    aspect,
    domStyle,
    Deferred,
    on,
    topic,
    when,

// Dijit
    registry,
    _WidgetBase,
    _TemplatedMixin,
    _CssStateMixin,
    _WidgetsInTemplateMixin,

// EPi Framework
    dependency,
    Target,
    _CommandProviderMixin,

// CMS
    _ContentAreaTree,
    _ContentAreaTreeModel,
    _TextWithActionLinksMixin,
    _ContentContextMixin,
    ContentActionSupport,
    ContentAreaViewModel,

    ContextMenu,
    _ValueRequiredMixin,
    BlockOverlay,
    CreateContentFromSelector,

    _HasChildDialogMixin,

    RemoveCommand,
    EditCommand,
    MoveToPrevious,
    MoveToNext,
    MoveOutsideGroup,
    Personalize,
    SelectDisplayOption,

// Resources
    template,
    resources
) {

    return declare([
        _WidgetBase,
        _TemplatedMixin,
        _WidgetsInTemplateMixin,
        _CssStateMixin,
        _ValueRequiredMixin,
        _ContentContextMixin,
        _CommandProviderMixin,
        _HasChildDialogMixin,
        _TextWithActionLinksMixin], {
        // summary:
        //      Editor for ContentArea to be able to edit my content area property in forms mode
        //      This should be a simple, non WYSIWYG listing of the inner content blocks with possibilities to add, remove and rearrange the content.

        // baseClass: [public] String
        //    The widget's base CSS class.
        baseClass: "epi-content-area-editor",

        // res: Json object
        //      Language resource
        res: resources,

        // templateString: String
        //      UI template for content area editor
        templateString: template,

        // value: String
        //      Value of the content area
        value: null,

        // multiple: Boolean
        //  Value must be true, otherwise dijit.Form will trea the value as an object instead of an array
        multiple: true,

        // parent: Object
        //      Editor wrapper object containe the editor
        parent: null,

        // overlayItem: Object
        //      Source overlay of the content area in on page edit mode
        overlayItem: null,

        // model: Object
        //      Content area editor view model
        model: null,

        // intermediateChanges: Boolean
        //      Inherited from editor interface
        intermediateChanges: true,

        // editMode: String
        //      Flags to detect page edit mode (On page edit or Form edit mode or Create content mode)
        editMode: "onpageedit",

        // _contextService: [private] epi/shell/ContextService
        _contextService: null,

        // _preventOnBlur: [private] Boolean
        //      When set, the onBlur event is prevented.
        _preventOnBlur: false,

        _dndTarget: null,

        constructor: function() {
            this.allowedDndTypes = [];
        },

        onChange: function (value) {
            // summary:
            //    Called when the value in the widget changes.
            // tags:
            //    public callback
        },

        _handleModelChange: function (value) {
            // summary:
            //    Called when the value in the model changes.
            // tags:
            //    public callback

            this.validate();
            this.onChange(value);
        },

        _onBlur: function () {
            // summary:
            //      Override base to prevent the onBlur from being called when the _preventOnBlur flag is set.
            // tags:
            //      protected override

            if (this._preventOnBlur) {
                return;
            }
            this.inherited(arguments);
        },

        focus: function() {
            // summary:
            //    Focus the tree if there is a value, else focus the create block text.
            // tags:
            //    public
            if(this.model.get("value").length > 0) {
                this._focusManager.focus(this.treeNode);
            } else {
                this.textWithLinks.focus();
            }
        },

        postMixInProperties: function(){
            this.inherited(arguments);

            // NOTE: Check for this._commands to allow for mocking the commands without breaking _CommandProviderMixin.
            this.commands = this._commands || [
                new EditCommand(),
                new SelectDisplayOption(),
                new Personalize({ category: null }),
                new MoveOutsideGroup(),
                new MoveToPrevious(),
                new MoveToNext(),
                new RemoveCommand()
            ];

            //Create the view model
            this.model = new ContentAreaViewModel();
            this.own(this.model);

            this.own(this.model.watch("selectedItem", lang.hitch(this, function(name, oldValue, newValue){
                //Update the commands with the selected block
                this.updateCommandModel(newValue);
            })));

            this.own(on(this.model, "changed", lang.hitch(this, function() {

                if(!this._started || this._supressValueChanged){
                    return;
                }

                this._set("value", this.model.get("value"));

                //Call to the handle model change with the new value
                this._handleModelChange(this.value);
            })));
        },

        postCreate: function () {
            this.inherited(arguments);

            this.set("emptyMessage", resources.emptymessage);

            if (this.parent && this.overlayItem) {
                this.connect(this.parent, "onStartEdit", function() {
                    this._selectFromOverlay(this.overlayItem.model);
                });
            }

            this.own(topic.subscribe("/dnd/start", lang.hitch(this, this._startDrag)));
        },

        buildRendering: function () {
            this.inherited(arguments);

            this._contextService = this._contextService || dependency.resolve("epi.shell.ContextService");

            this.contextMenu = new ContextMenu();
            this.contextMenu.addProvider(this);

            this.own(this.contextMenu);

            this.setupActionLinks(this.actionsContainer);

             //Create the tree
            this.tree = new _ContentAreaTree({
                accept: this.allowedDndTypes,
                contextMenu: this.contextMenu,
                model: new _ContentAreaTreeModel({model: this.model})
            }, this.treeNode);

            this.own(this.tree);

            this._dndTarget = new Target(this.actionsContainer, {
                accept: this.allowedDndTypes,
                isSource: false,
                alwaysCopy: false,
                insertNodes: function(){}
            });

            this.own(aspect.after(this._dndTarget, "onDropData", lang.hitch(this, function(dndData, source, nodes, copy) {
                var model = dndData[0].data;

                this.model.modify(lang.hitch(this, function() {
                    this.model.addChild(model);
                }));

            }), true));
        },

        startup: function () {
            this.inherited(arguments);

            this.tree.startup();
            this.contextMenu.startup();
        },

        isCreateLinkVisible: function () {
            // summary:
            //      Overidden mixin class, depend on currentMode will show/not create link
            // tags:
            //      protected
            var promise = new Deferred();
            var context = this._contextService && this._contextService.currentContext;

            //TODO: Move to the view model, duplicated in ContentArea. Don't dare changing at this point in time
            when(this.getCurrentContent(), function(contentData) {
                // Hide the create link if the content is not resourceable or we are in create mode.
                var allowedMode = true;
                if (context)
                {
                    allowedMode = context.capabilities.resourceable &&
                        !(context.currentMode === "create" || context.currentMode === "translate");
                }
                var hasCreatePermission = ContentActionSupport.isActionAvailable(contentData, ContentActionSupport.action.Create, ContentActionSupport.providerCapabilities.Create, true);
                promise.resolve(!!(allowedMode && hasCreatePermission));
            });

            return promise.promise;
        },

        executeAction: function (actionName) {
            // summary:
            //      Overridden mixin class executing click actions from textWithLinks widget
            // actionName: [String]
            //      Action name of link on content area
            // tags:
            //      public

            if (actionName === "createnewblock") {
                // HACK: Preventing the onBlur from being executed so the editor wrapper keeps this editor in editing state
                this._preventOnBlur = true;
                var command = new CreateContentFromSelector({
                    creatingTypeIdentifier: "episerver.core.blockdata",
                    createAsLocalAsset: true,
                    canChangeLocalAssetName: false
                });

                command.set("model", {
                    save: lang.hitch(this, function (block) {
                        this._preventOnBlur = false;
                        var value = lang.clone(this.get("value"), true) || [];
                        value.push(block);
                        this.set("value", value);
                        this.onChange(value);

                        // Now call onBlur since it's been prevented using the _preventOnBlur flag.
                        this.onBlur();
                    }),
                    cancel: lang.hitch(this, function () {
                        this._preventOnBlur = false;
                    })
                });
                command.execute();
            }
        },

        isValid: function () {
            // summary:
            //    Check if widget's value is valid.
            // isFocused:
            //    Indicate that the widget is being focused.
            // tags:
            //    protected
            return (!this.required || this.model.get("value").length > 0);
        },

         _setReadOnlyAttr: function (readOnly) {
            this._set("readOnly", readOnly);

            // hide actions when readonly
            domStyle.set(this.actionsContainer, "display", readOnly ? "none" : "");

            if (this._source) {
                this._source.isSource = !this.readOnly;
            }

            if(this.model) {
                this.model.set("readOnly", readOnly);
            }

            this.tree.set("readOnly", readOnly);
        },

        _checkAcceptance: function (source, nodes) {
            // summary:
            //      Customize checkAcceptance func
            // source: Object
            //      The source which provides items
            // nodes: Array
            //      The list of transferred items

            return this.readOnly ? false : this._source.defaultCheckAcceptance(source, nodes);
        },

        _setValueAttr: function (value) {

            this._set("value", value || []);

            //Reset the selection in the tree before we change the value on the model
            this.tree.set("selectedItems", null);

            this._supressValueChanged = true;
            this.model.set("value", value);
            this._supressValueChanged = false;
        },

        _selectFromOverlay: function(overlayModel) {
            var child = overlayModel && overlayModel.selectedItem && overlayModel.selectedItem.serialize(),
                model = this.model,
                path = ["root"];

            // exit if there is no overlay model to select item
            if(!child) {
                return;
            }

            if(child.contentGroup) {
                model = model.getChild({ name: child.contentGroup });
                path.push(model.id);
            }
            model = model.getChild(child);
            if(!model) {
                return;
            }

            path.push(model.id);

            model.set("selected", true);
            model.set("ensurePersonalization", overlayModel.selectedItem.ensurePersonalization);

            // TODO: move this selection into tree instead
            this.tree.set("path", path);

        },

        _startDrag: function (source, nodes, copy) {

            // close the editor when user start draging Block from BlockArea
            //TODO: This widget should not call a method on the parent
            var widget = registry.getEnclosingWidget(nodes[0]);
            if (widget.isInstanceOf(BlockOverlay) && this.parent.cancel) {
                // We set isModified to false (default value) because always synchronize value
                // between OPE and Editor
                this.parent.set("isModified", false);
                this.parent.cancel();
            }
        }
    });
});
},
'epi-cms/contentediting/editors/_ContentAreaTree':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/aspect",
    "dojo/_base/event",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dijit/registry",

    "epi/dependency",
    "epi/shell/conversion/ObjectConverterRegistry",
    "epi/shell/dnd/tree/dndSource",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/Tree",

    "epi-cms/contentediting/viewmodel/ContentBlockViewModel",
    "epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel",

    "./_BlockTreeNode",
    "./_GroupTreeNode"
    ], function(
        declare,
        aspect,
        event,
        array,
        lang,
        domClass,
        registry,

        dependency,
        ObjectConverterRegistry,
        dndSource,
        TypeDescriptorManager,
        Tree,

        ContentBlockViewModel,
        PersonalizedGroupViewModel,
        _BlockTreeNode,
        _GroupTreeNode
        ) {

    return declare([Tree], {
        showRoot: false,
        dndController: dndSource,
        betweenThreshold: 8,

        postMixInProperties: function(){
            this.inherited(arguments);

            this.dndParams.push("accept");
            this.accept.push("personalizationarea");
        },

        postCreate: function() {
            this.inherited(arguments);

            domClass.add(this.domNode, "epi-tree-mngr");

            this.own(aspect.after(this.dndController ,"onDndItemRemoved", lang.hitch(this, function(dndData) {
                if(dndData[0] && dndData[0].data) {
                    this.model.deleteItem(dndData[0].data);
                }
            }), true));

            this.own(aspect.after(this, "_onItemChildrenChange", lang.hitch(this, function(parent, children){
                array.forEach(children, function(child){
                    var childNode = this._itemNodesMap[this.model.getIdentity(child)];

                    //Auto-expand the node
                    if(child.expandOnAdd) {
                        this._expandNode(childNode[0]);
                    }
                    
                    //If the child does not have any roles auto show the personalization selector
                    //TODO: What happens if there are more children that does not have any roles??
                    if(child.contentGroup && child.ensurePersonalization && child.hasAnyRoles && !child.hasAnyRoles()) {
                        childNode[0].showPersonalizationSelector();
                    }
                }, this);
            }), true));
        },

        _setReadOnlyAttr: function(readOnly) {
            this._set("readOnly", readOnly);

            if(this.dndController) {
                this.dndController.isSource = !readOnly;
            }
        },

        getItemType: function (item) {
            // summary:
            //      Resolve the type for each item. Called by the dnd source.

            if (!item.typeIdentifier) {
                if (item.contentGroup !== undefined) {
                    //Since personalization items does not have a typeIdentifier we return a hardcoded type.
                    return ["personalizationarea"];
                }
                else {
                    return null;
                }
            }

            return this.accept;
        },

        checkItemAcceptance: function (targetNode, source, position, copy) {
            if(this.tree.readOnly) {
                return false;
            }

            var targetTreeNode = registry.getEnclosingWidget(targetNode);
            var target = targetTreeNode.item;

            var accepts = true;
            source.forInSelectedItems(function(item) {
                accepts = this.tree.model.checkItemAcceptance(target, item.data.item, position);
            }, this);

            return accepts;
        },

        _onNodeMouseEnter: function (node) {
            node.set("mouseHover", true);
        },

        _onNodeMouseLeave: function (node) {
            node.set("mouseHover", false);
        },

        _createTreeNode: function (model) {
            var node;
            if (model.item instanceof PersonalizedGroupViewModel) {
                node = new _GroupTreeNode(model);
            } else if (model.item instanceof ContentBlockViewModel) {
                node = new _BlockTreeNode(model);
            }
            else {
                node = this.inherited(arguments);
            }

            //Set the context menu and the dndData for the node
            node.set("contextMenu", this.contextMenu);
            node.set("dndData", model.item);
            return node;
        },
        onClick: function(item, node, e) {

            //Auto expand/collapse the group tree node
            if(node instanceof _GroupTreeNode) {
                if(node.isExpanded){
                    this._collapseNode(node);
                } else {

                    this._expandNode(node);
                }
            }
        }
    });
});
},
'epi-cms/contentediting/viewmodel/ContentBlockViewModel':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/string",
    "dojo/topic",
    "dojo/Deferred",
    "dojo/when",
    "dojo/promise/all",

    "dojox/html/entities",

    "epi",
    "epi/dependency",

    "./_ViewModelMixin",
    "epi-cms/widget/viewmodel/ContentStatusViewModel",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.personalize"

], function (
    declare,
    array,
    lang,
    string,
    topic,
    Deferred,
    when,
    all,

    entities,

    epi,
    dependency, 
    _ViewModelMixin,
    ContentStatusViewModel,
    resources
) {

    // module:
    //      epi-cms/contentediting/viewmodel/ContentBlockViewModel
    // summary:
    //      The view model for a content block.
    return declare([ContentStatusViewModel, _ViewModelMixin], {

        // label: [public] String
        //      The label used when displaying the block
        label: null,

        // store: [public] Visitor gruroup store
        //      The Visitor Groups store
        store: null,

        // hasSiblings: [public] Boolean
        //      Is true if the block has any siblings
        hasSiblings: true,

        // isVisible: [public] Boolean
        //      If the block could be seen it is true
        isVisible: true,

        // settings: [public] Object
        //      Settings object for the model
        settings: {
            // displayOptionsAttributeName: [public] String
            //      The name of the display options attribute put in the DOM
            displayOptionsAttributeName: "data-epi-content-display-option",
            
            // contentGroupAttributeName: [public] String
            //      The name of the content group attribute
            contentGroupAttributeName: "data-contentgroup"
        },

	/*=====

        // roles: [public] String
        //      Localized string of the role identities
        roles: null,

        =====*/

        constructor: function () {
            this.roleIdentities = this.roleIdentities || [];
            this._notExistRoleIdentities = this._notExistRoleIdentities || [];
            this.attributes = {};
        },

        postscript: function() {
            this.inherited(arguments);
            
            if(!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.visitorgroup");
            }

            this.set("label", this.name);
            this._reloadRoles();
        },

        serialize: function() {
            return {
                contentGroup: this.contentGroup,
                contentLink: this.contentLink,
                name: this.name,
                roleIdentities: this.roleIdentities,
                typeIdentifier: this.typeIdentifier,
                attributes: this.attributes
            };
        },

        equals: function(item) {
            // summary:
            //      Returns true if this content block is the same as the given item at a property level.
            // tag:
            //      public
            for(var prop in item) {
                if(!epi.areEqual(this[prop], item[prop])) {
                    return false;
                }
            }
            return true;
        },

        isRoleSelected: function(roleId) {
            // summary:
            //      Returns true if the roles is selected
            // roleId: Guid
            //      The id of the role to check
            // tag:
            //      public

            if(!this.roleIdentities) {
                return false;
            }

            return this.roleIdentities.indexOf(roleId) > -1;
        },

        hasAnyRoles: function () {
            // summary:
            //      Returns true if there are any selected roles
            // tags:
            //      public
            if(!this.roleIdentities) {
                return false;
            }

            return this.roleIdentities.length > 0;
        },

        moveNext: function() {
            // summary:
            //      Move this instance to the next index in the parents child list
            // tags:
            //      internal
            var index = this.parent.indexOf(this);
            this.parent.modify(function(){
                this.parent.move(this, index + 1);
            }, this);
        },

        movePrevious: function() {
            // summary:
            //      Move this instance to the previous index in the parents child list
            // tags:
            //      internal
            var index = this.parent.indexOf(this);
            this.parent.modify(function(){
                this.parent.move(this, index - 1);
            }, this);
        },

        moveOutsideGroup: function() {
            // summary:
            //      If the block is inside a gruop move it outside
            // tags:
            //      internal
            
            if(!this.contentGroup) {
                return;
            }

            this.parent.modify(function(){
                this.parent.moveOutsideGroup(this);
            }, this);
        },

        remove: function() {
            // summary:
            //      Removes the block from the parent
            // tags:
            //      internal
            this.parent.modify(function(){
                this.parent.removeChild(this);
            }, this);
        },

        personalize: function() {
            // summary:
            //      Personalizes the block
            // tags:
            //      internal

            this.parent.modify(function() {
                this.parent.personalize(this);
            }, this);
        },

        selectRole: function(roleId, select) {
            // summary:
            //      Selects or unselects the role depending on the select param
            //  roleId: Guid
            //      The role id to select/unselect
            //  select: Boolean
            //      True of false depending on if the role should be selected or unselected
            this.roleIdentities = this.roleIdentities || [];

            var index = array.indexOf(this.roleIdentities, roleId);

            if (index >= 0) {
                if (!select) {
                    this.roleIdentities.splice(index, 1);
                }
            }
            else if (select) {
                this.roleIdentities.push(roleId);
            }

            //  Filter role identities exclude id was no longer exists
            if (this._notExistRoleIdentities.length > 0) {
                this.roleIdentities = array.filter(this.roleIdentities, lang.hitch(this, function (item, i) {
                    return this._notExistRoleIdentities.indexOf(item) < 0;
                }));
            }

            //Set the roleIdenties again to emit a change event
            this.set("roleIdentities", this.roleIdentities);
        },

        resetRoleIdentities: function() {
             // summary:
            //      Resets the role identities for the block
            // tags:
            //      public
            
            this.set("visible", true);
            this.set("roleIdentities", null);
        },

        _displayOptionSetter: function (option) {
            // summary:
            //      Sets the display options attribute on the attribute list
            // tags:
            //      public
            this.attributes[this.settings.displayOptionsAttributeName] = option;
        },

        _displayOptionGetter: function () {
            // summary:
            //      Gets the display options attribute from the attribute list
            // tags:
            //      public
            return this.attributes[this.settings.displayOptionsAttributeName];
        },

        _roleIdentitiesSetter: function(roleIdentities) {
            this.roleIdentities = roleIdentities || [];
            this._notExistRoleIdentities = [];

            this._reloadRoles();
        },

        _parentSetter: function(parent) {
            this.parent = parent;

            this.set("contentGroup", this.parent.name);
        },

        _contentGroupSetter: function(contentGroup) {
            this.contentGroup = contentGroup;

            this.attributes[this.settings.contentGroupAttributeName] = contentGroup;

            this._reloadRoles();
        },

        _reloadRoles: function() {
            if(!this.store) {
                return;
            }
            
            var def = new Deferred();

            var defs = array.map(this.roleIdentities, function (id) {
                return when(this.store.get(id), function (visitorGroup) {
                    return visitorGroup;
                },lang.hitch(this, function (e) {
                    if (e.status === 404) {
                        var index = array.indexOf(this._notExistRoleIdentities, id);
                        if (index < 0) {
                            this._notExistRoleIdentities.push(id);
                        }
                    }
                }));
            }, this);

            all(defs).then(lang.hitch(this, function(roles){
                this.set("roles", roles);
                def.resolve(roles);
            }), function (e) {
                def.reject(e);
            });

            return def;
        },

        _hasSiblingsSetter: function(hasSiblings) {
            this.hasSiblings = hasSiblings;

            this._updateRolesString();
        },

        _selectedSetter: function(selected) {
            this.selected = selected;

            if(selected) {
                this.emit("selected", this);
            }
        },

        _updateRolesString: function() {
            if(!this.contentGroup || this.roles === undefined) {
                this.set("rolesString", "");
                
                return;
            }

            if (this._notExistRoleIdentities.length > 0) {
                this.set("rolesString", resources.groupcannotsees);
                return;
            }

            if(!this.hasAnyRoles()) {
                if(this.hasSiblings) {
                    this.set("rolesString", resources.everyoneelsesee);    
                }
                else {
                    this.set("rolesString", resources.everyonesees);
                }

                return;
            }

            var namesCommaList = array.map(this.roles, function (r) { return "<em>" + entities.encode(r.name) + "</em>"; }).sort().join(", ");
            var names = namesCommaList.replace(/, (?=[^,]+$)/, " " + resources.groupsand); // an extra space cause resource trims leading whitespace 

            var rolesString = "";
            if(this.roles.length > 1) {
                rolesString = lang.replace(resources.groupssee, { groupNames: names });
            }else {
                rolesString = lang.replace(resources.groupsees, { groupName: names });
            }

            this.set("rolesString", rolesString);
        },

        _rolesSetter: function(roles) {
            this.roles = roles;

            this._updateRolesString();
        }
    });
});
},
'epi-cms/contentediting/viewmodel/_ViewModelMixin':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/Stateful",
    "dojo/Evented",
    "dijit/Destroyable"
], function(array, declare, Stateful, Evented, Destroyable) {
    //TODO: Rename to _ViewModel

    // module:
    //      epi-cms/contentediting/viewmodel/_ViewModelMixin
    // summary:
    //
    return declare([Stateful, Evented, Destroyable], {

        modify: function(callback, scope, emitChanged) {
            // summary:
            //      Method used to wrap several changes in one "operation"
            //      When the callback has been executed the "changed" event will be emitted
            //
            // callback: function
            //      Function to execute
            //
            // scope: Object?
            //      The scope that the callback should be executed in
            //
            // emitChanged: Boolean?
            //      Whether the "changed" event should be emitted after the changes have been applied. 
            //      Default is true.

            this._isBeingModified = true;
            if(scope) {
                callback.apply(scope);
            } else {
                callback();
            }
            this._isBeingModified = false;

            if (emitChanged || emitChanged === undefined) {
                this.emit("changed");
            }
        },

        emit: function(type, event) {

            if(type === "changed" && this._isBeingModified) {
                return;
            }

            this.inherited(arguments);
        }
    });
});
},
'epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel':function(){
define([
    // General application modules
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    // Parent class
    "epi-cms/contentediting/viewmodel/_ContainerViewModel",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.personalize"
], function(array, declare, lang, _ContainerViewModel, resources) {

    // module:
    //      epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel
    // summary:
    //      The view model for a personalized group.
    return declare([_ContainerViewModel], {

        // name: [public] String
        //      The name of the personalized group.
        name: null,

        // name: [public] String
        //      The label used when displaying the group
        label: resources.grouplabel,

        addChild: function(child, index) {
            // summary:
            //      Adds a child to the view model at the given index or at the end of the collection.
            // child: Object
            //      The child to be added.
            // index: Number?
            //      The index where to the child will be inserted.
            // tag:
            //      public

            // Add new child first instead of last when no index is given
            this.inherited(arguments, [child, index || 0]);

            // Propagate all selection and changed events from children.
            this._handles[child.id] = [
                child.on("selected", lang.hitch(this, "emit", "selected", child)),
                child.on("changed", lang.hitch(this, "emit", "changed"))
            ];
        },

        serialize: function() {
            // summary:
            //      Serialize the view model's children to an array.
            // tag:
            //      public
            return array.map(this.getChildren(), function(child) {
                return child.serialize();
            });
        },

        equals: function(item) {
            // summary:
            //      Returns true if this groups name is the same as the name on the given item.
            // tag:
            //      public
            return this.name === item.name;
        },

        moveNext: function() {
            // summary:
            //      Move this instance to the next index in the parents child list
            // tags:
            //      internal

            var index = this.parent.indexOf(this);
            this.parent.modify(function () {
                this.parent.move(this, index + 1);
            }, this);
        },

        moveOutsideGroup: function(child) {
            this.parent.moveOutsideGroup(child);
        },

        movePrevious: function() {
            // summary:
            //      Move this instance to the previous index in the parents child list
            // tags:
            //      internal

            var index = this.parent.indexOf(this);
            this.parent.modify(function() {
                this.parent.move(this, index - 1);
            }, this);
        },

        remove: function() {
             // summary:
            //      Removes the group from the parent
            // tags:
            //      internal

            this.parent.modify(lang.hitch(this, function(){
                this.parent.removeChild(this);
            }));
        },

        _hash: function(child) {
            // summary:
            //      Creates a hash for the given child.
            // tag:
            //      protected
            return child.contentLink + "_" + Date.now();
        },

        _selectedSetter: function(selected) {
            this.selected = selected;
            if(selected) {
                this.emit("selected", this);
            }
        },

        _visibleGetter: function() {
            return array.some(this._data, function(item) {
                return item.get("visible");
            });
        }
    });
});
},
'epi-cms/contentediting/viewmodel/_ContainerViewModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "./_ViewModelMixin"
], function(array, declare, _ViewModelMixin) {

    // module:
    //      epi-cms/contentediting/viewmodel/_ContainerViewModel
    // summary:
    //
    return declare([_ViewModelMixin], {

        constructor: function() {
            this._data = [];
            this._handles = {};
        },

        addChild: function(child, index) {
            // summary:
            //      Adds a child to the view model at the given index or at the end of the collection.
            // child: Object
            //      The child to be added.
            // index: Number?
            //      The index where to the child will be inserted.
            // tag:
            //      public
            
            child.set("parent", this);
            child.set("readOnly", this.readOnly);
            
            if (!child.id) {
                // Set the id property to the contentLink or group name so that we have unique children.
                child.id = this._hash(child);
            }

            if(typeof index == "number") {
                this._data.splice(index, 0, child);
            } else {
                this._data.push(child);
            }

            this._emitChildrenChanged();
        },

        getChild: function(item) {
            // summary:
            //      Get the first child whose properties match the properties on the given item.
            // tag:
            //      public
            var children = this._data;
 
            for(var i = children.length - 1; i >= 0; i--) {
                if(children[i].equals(item)) {
                    return children[i];
                }
            }

            return null;
        },

        getChildById: function (id) {
            //TODO: Consider removing this
            var children = this._data;
 
            for(var i = children.length - 1; i >= 0; i--) {
                if(children[i].id === id) {
                    return children[i];
                }
            }

            return null;
        },

        getChildByIndex: function (index) {
            // summary:
            //      Return the indexed child.
            // tag:
            //      public
            return this._data[index];
        },

        getChildren: function() {
            // summary:
            //      Get the children of the view model.
            // tag:
            //      public
            return this._data;
        },

        removeChild: function(child, recursive) {
            // summary:
            //      Remove a child from the view model.
            // tag:
            //      public
            var index = this.indexOf(child),
                handles = this._handles[child.id];

            if(index < 0 && recursive) {
                array.forEach(this.getChildren(), function(item) {
                    if(typeof item.removeChild === "function") {
                        item.removeChild(child, recursive);
                    }
                });
                return;
            }else if(index < 0) {
                return;
            }

            if(handles) {
                array.forEach(handles, function(handle){
                    handle.remove();
                });
                delete this._handles[child.id];
            }

            this._data.splice(index, 1);

            this._emitChildrenChanged();
        },

        move: function(child, index) {
            // summary:
            //      Moves the child to a specific index
            // child: Object
            //      The child to be moved.
            // index: Number
            //      The index where to the child will be moved to.
            // tag:
            //      public
            var sourceIndex = this.indexOf(child);

            // Remove the child
            this._data.splice(sourceIndex, 1);

            // Insert it again at the new index
            this._data.splice(index, 0, child);

            this._emitChildrenChanged();
        },

        indexOf: function(child) {
            // summary:
            //      Returns the index of the child in the list of children
            // child: Object
            //      The child to find the index for
            return this._data.indexOf(child);
        },

        _hash: function(child) {
            // summary:
            //      Creates a hash for the given child.
            // tag:
            //      abstract
        },

        _readOnlySetter: function(readOnly) {
            this.readOnly = readOnly;

            array.forEach(this.getChildren(), function(child) {
                child.set("readOnly", readOnly);
            }, this);
        },

        _emitChildrenChanged: function(sender) {
            // summary:
            //      Emits children changed event
            // sender: Object?
            //      The sender
            // tags:
            //      protected, internal

            var length = this._data.length;
            array.forEach(this._data, function(child, index) {
                child.set("canMoveNext", index < (length - 1));
                child.set("canMovePrevious", index > 0 && index <= (length - 1));
                child.set("hasSiblings", length > 1);
            });

            this.set("count", length || 0);
            
            this.emit("childrenChanged", sender ? sender : this);
        }
    });
});
},
'epi-cms/contentediting/editors/_BlockTreeNode':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/keys",

    "dojo/dom-class",

    "dijit/Tree",
    "dijit/focus",
    "dijit/_HasDropDown",

    "epi-cms/widget/PersonalizationSelector",

    "epi-cms/dgrid/formatters",

    "./_ContentAreaTreeNodeMixin",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.blockcontextmenu",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.personalize",
    "dojo/text!./templates/_BlockTreeNode.html"
], function(declare, lang, keys, domClass, Tree, focusUtil, _HasDropDown, PersonalizationSelector, formatters, _ContentAreaTreeNodeMixin, tooltip, resources, template){

    return declare([Tree._TreeNode, _ContentAreaTreeNodeMixin, _HasDropDown], {
        templateString: template,

        _contextMenuClass: 'epi-iconContextMenu',
        isExpandable: false,
        dropDownPosition: ["before"],
        resources: lang.mixin(tooltip, resources),

        buildRendering: function() {
            this.inherited(arguments);

            this.dropDown = new PersonalizationSelector({ model: this.item });
            this.own(this.dropDown);
            this.aroundNode = this.domNode;
            this.set("readOnly", this.item.readOnly);

            domClass.add(this.domNode, "epi-tree-mngr--block");

            var node = this.rolesNode;

            // Get the icon from the type descriptor
            var icon = formatters.contentIcon(this.item.typeIdentifier);
            domClass.add(this.iconNode, icon);

            node.innerHTML = this.item.get("rolesString");
            this.own(this.item.watch("rolesString", lang.hitch(this, function(property, oldValue, newValue) {
                node.innerHTML = newValue;
            })));

            this.own(this.item.watch("readOnly", lang.hitch(this, function() {
                this.set("readOnly", this.item.readOnly);
            })));
        },

        setSelected: function(selected, internalSelect) {
            this.inherited(arguments);

            this.item.set("selected", selected);

            domClass.toggle(this.iconNodeMenu, this._contextMenuClass, selected);
        },

        showPersonalizationSelector: function () {
            if(this.readOnly) {
                return;
            }

            this.item.set("ensurePersonalization", false);

            focusUtil.focus(this.labelNode);

            this.loadAndOpenDropDown();
        },

        focus: function() {
            // summary:
            //      We need this method because _HasDropDown calls focus when toggling the dropdown
            this.labelNode.focus();
        },

        _onKey: function(/*Event*/ e) {
            // summary:
            //      We need to override the default behaviour otherwise the dropdown will popup
            //      when we click the downarrow on the tree node
            if(this.dropDown && this._opened && e.keyCode == keys.ESCAPE) {
                this.closeDropDown();
            }
        },

        _onKeyUp: function(){

        }
    });
});
},
'epi-cms/widget/PersonalizationSelector':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    "dojo/when",
    "dojox/html/entities",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/CheckedMenuItem",
    "epi/dependency",
    "epi/shell/_StatefulGetterSetterMixin",
    // Resouces
    "dojo/text!./templates/PersonalizationSelector.html",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.personalize",
    // Widgets used in template
    "dijit/Menu",
    "epi/shell/widget/RadioMenuItem"
], function(
    array,
    declare,
    lang,
    Stateful,
    when,
    entities,
    _WidgetBase,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    CheckedMenuItem,
    dependency,
    _StatefulGetterSetterMixin,
    // Resouces
    template,
    resources
) {

    return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {

        templateString: template,

        model: null,

        resources: resources,

        postMixInProperties: function() {
            this.inherited(arguments);

            if(!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.visitorgroup");
            }
        },

        postCreate: function() {
            this.inherited(arguments);

            this.own(
                this.rdEveryone.on("change", lang.hitch(this, "restoreDefault")),
                this.model.watch("roleIdentities", lang.hitch(this, function () {
                    if (!this.rdEveryone.checked && this.model.roleIdentities && this.model.roleIdentities.length === 0) {
                        this.restoreDefault();
                    }
                }))
            );

            //Query the store for all groups
            when(this.store.query(), lang.hitch(this, function(groups){
                if(!this._destroyed) {
                    this.set("visitorGroups", groups);
                }
            }));
        },

        restoreDefault: function() {
            array.forEach(this.visitorGroupsMenu.getChildren(), function (item) {
                item.set("checked", false);
            });

            this.rdEveryone.set("checked", true);
            this.model.set("roleIdentities", null);
        },

        _setVisitorGroupsAttr: function(groups) {
            this._set("visitorGroups", groups);

            if(!this.model.hasAnyRoles()) {
                this.rdEveryone.set("checked", true);
            }

            array.forEach(groups, function(group) {

                var item = new CheckedMenuItem({
                    label: entities.encode(group.name),
                    visitorgroupId: group.id,
                    checked: this.model.isRoleSelected(group.id)
                });

                this.own(item.watch("checked", lang.hitch(this, function(property, oldValue, newValue){
                    this.model.selectRole(group.id, newValue);

                    this.rdEveryone.set("checked", !this.model.hasAnyRoles());
                })));

                this.visitorGroupsMenu.addChild(item);
            }, this);
        }
    });
});
},
'url:epi-cms/widget/templates/PersonalizationSelector.html':"﻿<div>\r\n    <div class=\"epi-dijitTooltipContainer\">\r\n        <div class=\"epi-invertedTooltip\">\r\n            <div class=\"epi-tooltipDialogTop\">\r\n                <span data-dojo-attach-point=\"header\">${resources.whocansee}</span>\r\n                <div data-dojo-attach-point=\"lastPublishedIcon\" class=\"dijitTooltipConnector\"></div>\r\n            </div>\r\n        </div>\r\n        <div class=\"epi-tooltipDialogContent--max-height\">\r\n            <div data-dojo-type=\"dijit/Menu\" data-dojo-attach-point=\"visitorGroupsMenu\" style=\"width:100%\"></div>\r\n            <div class=\"epi-menuSeparator\" tabindex=\"-1\"></div>\r\n            <div data-dojo-type=\"dijit/Menu\" data-dojo-attach-point=\"filterOptionsMenu\" style=\"width:100%\">\r\n                <div data-dojo-attach-point=\"rdEveryone\" data-dojo-type=\"epi/shell/widget/RadioMenuItem\" data-dojo-props=\"label:'${resources.everyone}', value: ''\"></div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>",
'epi-cms/contentediting/editors/_ContentAreaTreeNodeMixin':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dijit/focus",
    "dojo/_base/event",
    "dojo/dom-class"
    ],
    function (declare, lang, on, focusUtil, event, domClass) {

    // module:
    //      epi-cms/contentediting/editors/_ContentAreaTreeNodeMixin
    // summary:
    //      Common functionality used by the _BlockTreeNode and _GroupTreeNode
    // tags:
    //      protected, internal

    return declare([], {

        destroy: function() {
            this._unBindContextMenu();

            this.inherited(arguments);
        },

        postCreate: function() {
            this.inherited(arguments);

            // Need the focus set on the label before opening the context menu,
            // otherwise focus is lost if the menu is closed using escape
            this.own(on(this.iconNodeMenu, "click", lang.hitch(this.labelNode, this.labelNode.focus)));
        },

        _unBindContextMenu: function() {
            if(this.contextMenu) {
                this.contextMenu.unBindDomNode(this.iconNodeMenu);
            }
        },

        _setContextMenuAttr: function(contextMenu) {
            this._unBindContextMenu();

            this._set("contextMenu", contextMenu);
            this.contextMenu.bindDomNode(this.iconNodeMenu);
        },

        _setMouseHoverAttr: function (hover) {
            this._set("hover", hover);

            if(this.item.get("selected")){
                return;
            }
            domClass.toggle(this.iconNodeMenu, this._contextMenuClass, this.hover);
        }
    });
});
},
'url:epi-cms/contentediting/editors/templates/_BlockTreeNode.html':"﻿<div class=\"dijitTreeNode\" role=\"presentation\">\r\n    <div class=\"epi-tree-mngr--node-wrapper\" data-dojo-attach-point=\"rowNode\">\r\n        <span data-dojo-attach-point=\"rolesNode, _buttonNode\" class=\"epi-tree-mngr--view-settings\"></span>\r\n        <div class=\"dijitTreeRow dijitInline\" role=\"presentation\">\r\n            <div data-dojo-attach-point=\"indentNode\" class=\"dijitInline\"></div>\r\n            <span data-dojo-attach-point=\"expandoNode\" class=\"dijitTreeExpando\"></span>\r\n            <span data-dojo-attach-point=\"expandoNodeText\" class=\"dijitExpandoText\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n                <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-extraIconsContainer\" role=\"presentation\">\r\n                    <span data-dojo-attach-point=\"iconNodeMenu\" class=\"epi-extraIcon epi-pt-contextMenu\" title=\"${resources.settingstooltip}\" role=\"presentation\">&nbsp;</span>\r\n                </span>\r\n                <img src=\"${_blankGif}\" alt=\"\" data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon\" role=\"presentation\"/>\r\n                <span data-dojo-attach-point=\"labelNode\" class=\"dijitTreeLabel\" role=\"treeitem\" tabindex=\"-1\" aria-selected=\"false\"></span>\r\n\r\n            </span>\r\n        </div>\r\n        <div data-dojo-attach-point=\"containerNode\" class=\"dijitTreeContainer\" role=\"presentation\" style=\"display: none;\"></div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/editors/_GroupTreeNode':function(){
﻿define([
    "dojo/aspect",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-style",

    "dijit/Tree",

    "./_ContentAreaTreeNodeMixin",

    "dojo/text!./templates/_GroupTreeNode.html",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea"

], function (aspect, array, declare, lang, domClass, domStyle, Tree, _ContentAreaTreeNodeMixin, template, resources) {
    
    return declare([Tree._TreeNode, _ContentAreaTreeNodeMixin], {
        
        templateString: template,

        _contextMenuClass: 'epi-iconContextMenu',

        resources: resources,

        buildRendering: function() {
            this.inherited(arguments);
            
            domClass.remove(this.iconNode, "dijitFolderClosed");
            
            this.own(aspect.after(this, "expand", lang.hitch(this, function(deferred){
                deferred.then(lang.hitch(this, function () {
                    // Seems the deferred is sometimes resolved after the tree has been destroyed
                    if (this._destroyed)
                    {
                        return;
                    }

                    domClass.add(this.domNode, "epi-treeNodeOpen");

                    array.forEach(this.getChildren(), function(childNode) {
                        var child = childNode.item;

                        //If the child does not have any roles auto show the personalization selector
                        //TODO: What happens if there are more children that does not have any roles??
                        if (child.contentGroup && child.ensurePersonalization && child.hasAnyRoles && !child.hasAnyRoles()) {
                            child.set("ensurePersonalization", false);
                            childNode.showPersonalizationSelector();
                        }
                    }, this);
                }));

                return deferred;
            })));

            this.own(aspect.after(this, "collapse", lang.hitch(this, function (deferred) {
                deferred.then(lang.hitch(this, function() {
                    domClass.remove(this.domNode, "epi-treeNodeOpen");
                }));

                return deferred;
            })));

            this.own(this.item.watch("readOnly", lang.hitch(this, function(){
                this._toggleDropMoreMessageNode();
            })));
        },

        postCreate: function() {
            this.inherited(arguments);

            this.own(this.item.watch("count", lang.hitch(this, function (property, oldValue, newValue) {
                this.set("count", newValue);
            })));

            // copy initial value from model
            if (this.item) {
                this.set("count", this.item.count);
            }
        },

        setSelected: function (selected) {
            this.inherited(arguments);

            this.item.set("selected", selected);
            
            domClass.remove(this.rowNode, "dijitTreeRowSelected");
            domClass.toggle(this.domNode, "dijitTreeRowSelected", selected);
        },

        _setCountAttr: function(count) {
            this._set("count", count);

            this._toggleDropMoreMessageNode();
        },

        _toggleDropMoreMessageNode: function () {
            domStyle.set(this.dropMoreMessageNode, "display", !this.item.readOnly && this.count === 1 ? "" : "none");
        }
    });
});
},
'url:epi-cms/contentediting/editors/templates/_GroupTreeNode.html':"﻿<div class=\"dijitTreeNode epi-tree-mngr--group\" role=\"presentation\" data-dojo-attach-point=\"rowNode\">\r\n    <div class=\"dijitTreeRow dijitInline epi-tree-mngr--group-header\" role=\"presentation\">\r\n        <div data-dojo-attach-point=\"indentNode\" class=\"dijitInline\"></div>\r\n        <img src=\"${_blankGif}\" alt=\"\" data-dojo-attach-point=\"expandoNode\" class=\"dijitTreeExpando\" role=\"presentation\"/>\r\n        <span data-dojo-attach-point=\"expandoNodeText\" class=\"dijitExpandoText\" role=\"presentation\"></span>\r\n        <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n            <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-extraIconsContainer\" role=\"presentation\">\r\n                <span data-dojo-attach-point=\"iconNodeMenu\" class=\"epi-extraIcon epi-pt-contextMenu\" role=\"presentation\">&nbsp;</span>\r\n            </span>\r\n            <img src=\"${_blankGif}\" alt=\"\" data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon epi-iconUsers\" role=\"presentation\"/>\r\n            <span data-dojo-attach-point=\"labelNode\" class=\"dijitTreeLabel\" role=\"treeitem\" tabindex=\"-1\" aria-selected=\"false\"></span>\r\n        </span>\r\n    </div>\r\n    <hr />\r\n    <span data-dojo-attach-point=\"dropMoreMessageNode\" class=\"epi-tip epi-tip--block\">${resources.groupdropmoremessage}</span>\r\n    <div data-dojo-attach-point=\"containerNode\" class=\"dijitTreeContainer\" role=\"presentation\" style=\"display: none;\"></div>\r\n</div>\r\n",
'epi-cms/contentediting/editors/_ContentAreaTreeModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/tree/model",

    "epi-cms/contentediting/viewmodel/ContentBlockViewModel",
    "epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel"
    ], function(
        array,
        declare,
        lang,
        TreeModel,

        ContentBlockViewModel,
        PersonalizedGroupViewModel) {

    return declare([TreeModel], {
        model: null,
        root: {
            id: "root",
            name: "root"
        },

        constructor: function(params) {
            declare.safeMixin(this, params);
        },

        pasteItem: function(childItem, oldParentItem, newParentItem, bCopy, insertIndex, before) {
            // summary:
            //      Move or copy an item from one parent item to another.
            //      Used in drag & drop.
            //      If oldParentItem is specified and bCopy is false, childItem is removed from oldParentItem.
            //      If newParentItem is specified, childItem is attached to newParentItem.
            // childItem: Item
            // oldParentItem: Item
            // newParentItem: Item
            // bCopy: Boolean
            // insertIndex: int?
            //      Allows to insert the new item as the n'th child of `parent`.
            // before: Item?
            //      Insert the new item as the previous sibling of this item.  `before` must be a child of `parent`.
            // tags:
            //      extension
            var oldParent = oldParentItem.id === "root" ? this.model : this.model.getChildById(oldParentItem.id);

            var child = oldParent.getChildById(childItem.id);

            var newParent = newParentItem.id === "root" ? this.model : this.model.getChildById(newParentItem.id);

            if(child instanceof ContentBlockViewModel && !child.hasAnyRoles()) {
                child.set("ensurePersonalization", true);
            }

            if(oldParent === newParent) {
                this.model.modify(function() {
                    newParent.move(child, insertIndex);
                });

                return;
            }

            this.model.modify(function() {
                oldParent.removeChild(child);
                newParent.addChild(child, insertIndex);
            });
        },

        deleteItem: function(item) {
            this.model.modify(lang.hitch(this, function() {
                this.model.removeChild(item, true);
            }));
        },

        newItem: function (args, parent, insertIndex, before) {
            if(args.dndData && args.dndData.data) {
                var parentModel = parent.id === "root" ? this.model : this.model.getChildById(parent.id);

                var item = args.dndData.data;
                if(!(item instanceof ContentBlockViewModel) && !(item instanceof PersonalizedGroupViewModel)){
                    item = new ContentBlockViewModel(item);
                }

                item.set("ensurePersonalization", true);

                this.model.modify(function() {
                    parentModel.addChild(item, insertIndex);
                });
            }
        },

        checkItemAcceptance: function(target, item, position) {
            if(position === "over") {
                if(!(target instanceof PersonalizedGroupViewModel)) {
                    return false;
                }

                if(!(item instanceof ContentBlockViewModel)) {
                    return false;
                }
            }

            if(target instanceof ContentBlockViewModel && item instanceof PersonalizedGroupViewModel && target.contentGroup) {
                return false;
            }

            return true;
        },

        getRoot: function(onItem) {
            onItem(this.root);
        },

        getLabel: function(item) {
            return item.label;
        },

        mayHaveChildren: function(item) {
            if(typeof item.getChildren == "function" || item.id === "root") {
                return true;
            }

            return false;
        },

        getIdentity: function(item) {
            return item.id;
        },

        getChildren: function(parentItem, onComplete) {
            var children;

            if(parentItem.id === "root") {
                children = this.model.getChildren();
                onComplete(children);

                this.model.on("childrenChanged", lang.hitch(this, function(index, removals, adds) {
                    this.onChildrenChange(this.root, this.model.getChildren());
                }));
            } else {
                var model = this.model.getChildById(parentItem.id);
                if(model && typeof model.getChildren == "function") {
                    children = model.getChildren();
                    onComplete(children);

                    model.on("childrenChanged", lang.hitch(this, function(index, removals, adds) {
                        this.onChildrenChange(parentItem, model.getChildren());
                    }));

                } else {
                    onComplete([]);
                }

            }
        }
    });
});
},
'dijit/tree/model':function(){
define("dijit/tree/model", ["dojo/_base/declare"], function(declare){

return declare(
	"dijit.tree.model",
	null,
{
	// summary:
	//		Contract for any data provider object for the tree.
	// description:
	//		Tree passes in values to the constructor to specify the callbacks.
	//		"item" is typically a dojo/data/Item but it's just a black box so
	//		it could be anything.
	//
	//		This (like `dojo/data/api/Read`) is just documentation, and not meant to be used.

	destroy: function(){
		// summary:
		//		Destroys this object, releasing connections to the store
		// tags:
		//		extension
	},

	// =======================================================================
	// Methods for traversing hierarchy

	getRoot: function(onItem){
		// summary:
		//		Calls onItem with the root item for the tree, possibly a fabricated item.
		//		Throws exception on error.
		// tags:
		//		extension
	},

	mayHaveChildren: function(item){
		// summary:
		//		Tells if an item has or may have children.  Implementing logic here
		//		avoids showing +/- expando icon for nodes that we know don't have children.
		//		(For efficiency reasons we may not want to check if an element actually
		//		has children until user clicks the expando node)
		// item: dojo/data/Item
		// tags:
		//		extension
	},

	getChildren: function(parentItem, onComplete){
		// summary:
		//		Calls onComplete() with array of child items of given parent item, all loaded.
		//		Throws exception on error.
		// parentItem: dojo/data/Item
		// onComplete: function(items)
		// tags:
		//		extension
	},

	// =======================================================================
	// Inspecting items

	isItem: function(something){
		// summary:
		//		Returns true if *something* is an item and came from this model instance.
		//		Returns false if *something* is a literal, an item from another model instance,
		//		or is any object other than an item.
		// tags:
		//		extension
	},

	fetchItemByIdentity: function(keywordArgs){
		// summary:
		//		Given the identity of an item, this method returns the item that has
		//		that identity through the onItem callback.  Conforming implementations
		//		should return null if there is no item with the given identity.
		//		Implementations of fetchItemByIdentity() may sometimes return an item
		//		from a local cache and may sometimes fetch an item from a remote server.
		// tags:
		//		extension
	},

	getIdentity: function(item){
		// summary:
		//		Returns identity for an item
		// tags:
		//		extension
	},

	getLabel: function(item){
		// summary:
		//		Get the label for an item
		// tags:
		//		extension
	},

	// =======================================================================
	// Write interface

	newItem: function(args, parent, insertIndex, before){
		// summary:
		//		Creates a new item.   See `dojo/data/api/Write` for details on args.
		// args: dijit/tree/dndSource.__Item
		// parent: Item
		// insertIndex: int?
		//		Allows to insert the new item as the n'th child of `parent`.
		// before: Item?
		//		Insert the new item as the previous sibling of this item.  `before` must be a child of `parent`.
		// tags:
		//		extension
	},

	pasteItem: function(childItem, oldParentItem, newParentItem, bCopy, insertIndex, before){
		// summary:
		//		Move or copy an item from one parent item to another.
		//		Used in drag & drop.
		//		If oldParentItem is specified and bCopy is false, childItem is removed from oldParentItem.
		//		If newParentItem is specified, childItem is attached to newParentItem.
		// childItem: Item
		// oldParentItem: Item
		// newParentItem: Item
		// bCopy: Boolean
		// insertIndex: int?
		//		Allows to insert the new item as the n'th child of `parent`.
		// before: Item?
		//		Insert the new item as the previous sibling of this item.  `before` must be a child of `parent`.
		// tags:
		//		extension
	},

	// =======================================================================
	// Callbacks

	onChange: function(item){
		// summary:
		//		Callback whenever an item has changed, so that Tree
		//		can update the label, icon, etc.   Note that changes
		//		to an item's children or parent(s) will trigger an
		//		onChildrenChange() so you can ignore those changes here.
		// item: dojo/data/Item
		// tags:
		//		callback
	},

	onChildrenChange: function(parent, newChildrenList){
		// summary:
		//		Callback to do notifications about new, updated, or deleted items.
		// parent: dojo/data/Item
		// newChildrenList: dojo/data/Item[]
		// tags:
		//		callback
	}
});

});
},
'epi-cms/contentediting/editors/_TextWithActionLinksMixin':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/on",
    "dojo/when",

// EPi Framework
    "epi/shell/widget/TextWithActionLinks",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.overlay.blockarea"
],

function (
    declare,
    lang,
    Deferred,
    on,
    when,

// EPi Framework
    TextWithActionLinks,

// Resources
    resource
) {

    // summary:
    //      Handles action links
    // tags:
    //      public

    return declare(null, {

        // textWithLinks: [Object]
        //      The text with link area 
        textWithLinks: null,

        // actionsResource: [Object]
        //      The resource of actions link
        actionsResource: resource,
        
        isCreateLinkVisible: function () {
            // summary:
            //      Determines whether the "create" link in the action area is visible.
            //      Defaults to true, meaning that the link is shown.
            // returns:
            //      Promise|Boolean
            // tags:
            //      protected

            return true;
        },

        getTemplateString: function () {
            // summary:
            //      Them template string to build actions area
            // tags:
            //      protected

            var deferred = new Deferred();
            var actionResources = this.actionsResource.emptyactions;

            when(this.isCreateLinkVisible(), function(showCreateLink) {

                var templateString = showCreateLink ? actionResources.template : actionResources.templatewithoutcreate;

                deferred.resolve({
                    templateString: templateString,
                    actions: actionResources.actions
                });

            });

            return deferred.promise;
        },

        setupActionLinks: function (/*Object*/container) {
            // summary:
            //      Initial new text with action links of content area, and
            //      depend on context are create will show template without create, otherwise
            // container: [Object]
            //      The container will put text with links 
            // tags:
            //      public

            when(this.getTemplateString(), lang.hitch(this, function(template) {

                if (!template) {
                    return;
                }

                this.textWithLinks = new TextWithActionLinks({
                    contentString: template.templateString,
                    namedActions: template.actions
                });

                this.own(on(this.textWithLinks, "onActionClick", lang.hitch(this, this.executeAction)));
                if (container) {
                    this.textWithLinks.placeAt(container);
                }
            }));
        },

        executeAction: function (/*String*/actionName) {
            // summary:
            //      Called when action link clicked
            // tags:
            //      public

            //Override this method to implement custom actions.
        }
    });
});
},
'epi/shell/widget/TextWithActionLinks':function(){
﻿define("epi/shell/widget/TextWithActionLinks", [
	"dojo/_base/array",
	"dojo/_base/declare",
	"dojo/_base/event",
	"dojo/_base/lang",
	"dojo/Evented",
	"dojo/on",
	"dojo/query",

	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
    "dijit/focus",

    "dojox/html/entities"
], function (
    array,
	declare,
	event,
	lang,
	Evented,
	on,
    query,

    _WidgetBase,
	_TemplatedMixin,
    focusUtil, 

    entities
) {
    return declare([_WidgetBase, _TemplatedMixin, Evented], {

        tagName: "span",

        templateString: "<{0}>{1}</{0}>",

        contentString: "",

        namedActions: null, // { actionName1: "<actionDisplayName1>", actionName2: "<actionDisplayName2>" }
        _actionMap: null,

        _eventHandlers: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            this._actionMap = [];
            this._eventHandlers = [];
            var fragments = {};
            var contentString = this.contentString;
            var namedAction;
            var id = 0;

            // replace template string with action names to create links
            if (this.namedActions) {

                for (var actionName in this.namedActions) {
                    namedAction = entities.encode(this.namedActions[actionName]);
                    fragments[actionName] = '<a class="epi-visibleLink" href="#" data-dojo-attach-point="action' + (id++) + '">' + namedAction + '</a>';
                    this._actionMap.push(actionName);
                }

                contentString = lang.replace(contentString, fragments);
            }

            this.templateString = lang.replace(this.templateString, [this.tagName, contentString]);
        },

        postCreate: function () {
            this.inherited(arguments);

            // bind events
            array.forEach(this._actionMap, function (actionName, id) {

                var link = this["action" + id];

                if (link) {

                    var handler = on(link, "click", (function (context, actionName) {
                        return function (evt) {
                            event.stop(evt);
                            context.emit("onActionClick", actionName);
                        };
                    })(this, actionName));

                    this._eventHandlers.push(handler);
                }
            }, this);
        },

        destroy: function () {

            array.forEach(this._eventHandlers, function (handler) {
                handler.remove();
            }, this);
            this._eventHandlers = null;

            this.inherited(arguments);

        },

        focus: function () {
            var links = query("a", this.domNode);

            if (links.length > 0) {
                focusUtil.focus(links[0]);
            }
        }
    });
});
},
'epi-cms/contentediting/viewmodel/ContentAreaViewModel':function(){
define([
    // General application modules
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/uuid/generateRandomUuid",
    "epi-cms/contentediting/viewmodel/ContentBlockViewModel",
    "epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel",
    // Parent class
    "epi-cms/contentediting/viewmodel/_ContainerViewModel"
], function(array, declare, lang, generateRandomUuid, ContentBlockViewModel, PersonalizedGroupViewModel, _ContainerViewModel) {

    // module:
    //      epi-cms/contentediting/viewmodel/ContentAreaViewModel
    // summary:
    //      The view model for the content area when editing in on-page mode and forms mode.
    return declare([_ContainerViewModel], {

        /*=====

        // value: [public] Array
        //      The value of the content area property.
        value: null,

        =====*/

        // selectedItem: [public] Object
        //      The model for the selected content.
        selectedItem: null,

        addChild: function(child /*=====, index =====*/) {
            // summary:
            //      Adds a child to the view model at the given index or at the end of the collection.
            // child: Object
            //      The child to be added.
            // index: Number?
            //      The index where to the child will be inserted.
            // tag:
            //      public

            //TODO: make this code more generic
            // and merge with _transformValueToModels
            if(!(child instanceof ContentBlockViewModel) && !(child instanceof PersonalizedGroupViewModel)) {
                var model = new ContentBlockViewModel(child);

                this.own(model.watch("roleIdentities",lang.hitch(this, function() {
                    this.emit("changed");
                })));

                // If the model has a content group add it to the groups view model.
                if(model.contentGroup) {
                    child = this._groups[model.contentGroup];

                    if(!child) {
                        // Create the group if it doesn't exist and add it to the data.
                        child = this._createGroup(model.contentGroup);
                    }

                    child.addChild(model);
                } else {
                    // Else add the model directly to the data for this view model.
                    child = model;
                }
            }else {
                child.set("contentGroup", null);

                if(child instanceof PersonalizedGroupViewModel) {
                    this.own(child.on("childrenChanged", lang.hitch(this, function(){

                        //Propagate changes of the group
                        this._emitChildrenChanged(child);

                        //If there are no more children, remove the group
                        if(child.getChildren().length === 0) {
                            this.removeChild(child);
                        }
                    })));
                } else if(child instanceof ContentBlockViewModel) {
                    child.resetRoleIdentities();
                }
            }

            // Propagate changed event from the child to the content area.
            this.own(child.on("changed", lang.hitch(this, function() {
                this.emit("changed");
            })));

            this.inherited(arguments);

            this._handles[child.id] = child.on("selected", lang.hitch(this, "set", "selectedItem"));
        },

        moveVisible: function(child, moveToNext) {
            // summary:
            //      Moves the child to a specific index based on visiblity of children.
            // tag:
            //      public
            var children = array.filter(this.getChildren(), function(item) {
                    return item.get("visible");
                }),
                delta = moveToNext ? 1 : -1, // Delta indicating if this is a move next or move previous.
                target = array.indexOf(children, child) + delta, // The target visible index to move to.
                index = this.indexOf(children[target]); // The actual index of the target in the model.

            this.modify(lang.hitch(this, function() {
                this.move(child, index);
            }));
        },

        moveOutsideGroup: function(child) {
            // summary:
            //      Move the child out from the group
            // child: Object
            //      The child to move
            //
            if(!child.contentGroup) {
                console.debug("The child does not belong to any group", child);

                return;
            }

            var group = this.getChild({ name: child.contentGroup }),
                index = this.indexOf(group);

            this.modify(lang.hitch(this, function() {
                //Remove the child from the group but do not emit the change event
                group.removeChild(child);

                //Add the child to this model
                this.addChild(child, index);
            }));
        },

        personalize: function (child) {
            // summary:
            //      Personalizes the child
            // child: ContentBlockViewModel
            //      The block to personalize
            // tags:
            //      internal

            // Remove the item from the model.
            var index = this.indexOf(child);
            this.removeChild(child);

            // Create a new personalized group and add the item to it.
            var group = new PersonalizedGroupViewModel({ name: "group_" + Date.now(), expandOnAdd: true });
            child.set("ensurePersonalization", true);
            group.addChild(child);

            // Add the group to the model.
            this.addChild(group, index);
        },

        _valueGetter: function() {
            var value = [];
            array.forEach(this.getChildren(), function(child) {
                value = value.concat(child.serialize());
            });
            return value;
        },

        _valueSetter: function (value) {
            this._transformValueToModels(value);
        },

        _selectedItemSetter: function(value) {
            if(this.selectedItem) {
                this.selectedItem.set("selected", false);
            }
            this.selectedItem = value;
        },

        _transformValueToModels: function(value) {
            // summary:
            //      Transforms the current value into a tree representation using observable stores.
            // tag:
            //      private

            // Remove the existing children since we are recreating all the data.
            this.modify(function() {
                var children = this.getChildren();
                for(var i = children.length - 1; i >= 0; i--) {
                    this.removeChild(children[i]);
                }

                // Clear the groups since we are recreating all the data.
                this._groups = {};

                array.forEach(value, function(child) {
                    var model = new ContentBlockViewModel(child);
                    this.own(model.watch("roleIdentities",lang.hitch(this, function() {
                        this.emit("changed");
                    })));

                    // If the model has a content group add it to the groups view model.
                    if(model.contentGroup) {
                        var group = this._groups[model.contentGroup];

                        if(!group) {
                            // Create the group if it doesn't exist and add it to the data.
                            group = this._createGroup(model.contentGroup);
                            this.addChild(group);
                        }

                        // Add the child at the end
                        group.addChild(model, group.getChildren().length);
                    } else {
                        // Else add the model directly to the data for this view model.
                        this.addChild(model);
                    }
                }, this);
            }, this, false);
        },

        _createGroup: function(name) {
            // summary:
            //      Creates the group with the given name and adds it to the groups map.
            // tag:
            //      private
            var group = new PersonalizedGroupViewModel({
                name: name
            });

            this._groups[name] = group;

            return group;
        },

        _hash: function(child) {
            // summary:
            //      Creates a hash for the given child.
            // tag:
            //      protected
            return (child.contentLink || child.name) + "_" + generateRandomUuid();
        }
    });
});
},
'dojox/uuid/generateRandomUuid':function(){
define("dojox/uuid/generateRandomUuid", ['./_base'], function(){

dojox.uuid.generateRandomUuid = function(){
	// summary:
	//		This function generates random UUIDs, meaning "version 4" UUIDs.
	// description:
	//		A typical generated value would be something like this:
	//		"3b12f1df-5232-4804-897e-917bf397618a"
	//
	//		For more information about random UUIDs, see sections 4.4 and
	//		4.5 of RFC 4122: http://tools.ietf.org/html/rfc4122#section-4.4
	//
	//		This generator function is designed to be small and fast,
	//		but not necessarily good.
	//
	//		Small: This generator has a small footprint. Once comments are
	//		stripped, it's only about 25 lines of code, and it doesn't
	//		dojo.require() any other modules.
	//
	//		Fast: This generator can generate lots of new UUIDs fairly quickly
	//		(at least, more quickly than the other dojo UUID generators).
	//
	//		Not necessarily good: We use Math.random() as our source
	//		of randomness, which may or may not provide much randomness.
	// examples:
	//		var string = dojox.uuid.generateRandomUuid();
	var HEX_RADIX = 16;

	function _generateRandomEightCharacterHexString(){
		// Make random32bitNumber be a randomly generated floating point number
		// between 0 and (4,294,967,296 - 1), inclusive.
		var random32bitNumber = Math.floor( (Math.random() % 1) * Math.pow(2, 32) );
		var eightCharacterHexString = random32bitNumber.toString(HEX_RADIX);
		while(eightCharacterHexString.length < 8){
			eightCharacterHexString = "0" + eightCharacterHexString;
		}
		return eightCharacterHexString; // for example: "3B12F1DF"
	}

	var hyphen = "-";
	var versionCodeForRandomlyGeneratedUuids = "4"; // 8 == binary2hex("0100")
	var variantCodeForDCEUuids = "8"; // 8 == binary2hex("1000")
	var a = _generateRandomEightCharacterHexString();
	var b = _generateRandomEightCharacterHexString();
	b = b.substring(0, 4) + hyphen + versionCodeForRandomlyGeneratedUuids + b.substring(5, 8);
	var c = _generateRandomEightCharacterHexString();
	c = variantCodeForDCEUuids + c.substring(1, 4) + hyphen + c.substring(4, 8);
	var d = _generateRandomEightCharacterHexString();
	var returnValue = a + hyphen + b + hyphen + c + d;
	returnValue = returnValue.toLowerCase();
	return returnValue; // String
};

return dojox.uuid.generateRandomUuid;

});

},
'dojox/uuid/_base':function(){
define("dojox/uuid/_base", ['dojo/_base/kernel', 'dojo/_base/lang'], function(dojo){

dojo.getObject("uuid", true, dojox);

// Public constants:
dojox.uuid.NIL_UUID = "00000000-0000-0000-0000-000000000000";
dojox.uuid.version = {
	//	Enumeration for the different UUID versions.
	UNKNOWN: 0,
	TIME_BASED: 1,
	DCE_SECURITY: 2,
	NAME_BASED_MD5: 3,
	RANDOM: 4,
	NAME_BASED_SHA1: 5 };
dojox.uuid.variant = {
	//	Enumeration for the different UUID variants.
	NCS: "0",
	DCE: "10",
	MICROSOFT: "110",
	UNKNOWN: "111" };

dojox.uuid.assert = function(/*Boolean*/ booleanValue, /*String?*/ message){
	// summary:
	//		Throws an exception if the assertion fails.
	// description:
	//		If the asserted condition is true, this method does nothing. If the
	//		condition is false, we throw an error with a error message.
	// booleanValue: Must be true for the assertion to succeed.
	// message: A string describing the assertion.
	// throws: Throws an Error if 'booleanValue' is false.
	if(!booleanValue){
		if(!message){
			message = "An assert statement failed.\n" +
			"The method dojox.uuid.assert() was called with a 'false' value.\n";
		}
		throw new Error(message);
	}
};

dojox.uuid.generateNilUuid = function(){
	// summary:
	//		This function returns the Nil UUID: "00000000-0000-0000-0000-000000000000".
	// description:
	//		The Nil UUID is described in section 4.1.7 of
	//		RFC 4122: http://tools.ietf.org/html/rfc4122#section-4.1.7
	// examples:
	//		var string = dojox.uuid.generateNilUuid();
	return dojox.uuid.NIL_UUID; // String
};

dojox.uuid.isValid = function(/*String*/ uuidString){
	// summary:
	//		Returns true if the UUID was initialized with a valid value.
	uuidString = uuidString.toString();
	var valid = (dojo.isString(uuidString) &&
		(uuidString.length == 36) &&
		(uuidString == uuidString.toLowerCase()));
	if(valid){
		var arrayOfParts = uuidString.split("-");
		valid = ((arrayOfParts.length == 5) &&
			(arrayOfParts[0].length == 8) &&
			(arrayOfParts[1].length == 4) &&
			(arrayOfParts[2].length == 4) &&
			(arrayOfParts[3].length == 4) &&
			(arrayOfParts[4].length == 12));
		var HEX_RADIX = 16;
		for (var i in arrayOfParts) {
			var part = arrayOfParts[i];
			var integer = parseInt(part, HEX_RADIX);
			valid = valid && isFinite(integer);
		}
	}
	return valid; // boolean
};

dojox.uuid.getVariant = function(/*String*/ uuidString){
	// summary:
	//		Returns a variant code that indicates what type of UUID this is.
	//		Returns one of the enumerated dojox.uuid.variant values.
	// example:
	//		var variant = dojox.uuid.getVariant("3b12f1df-5232-4804-897e-917bf397618a");
	//		dojox.uuid.assert(variant == dojox.uuid.variant.DCE);
	// example:
	//	|	"3b12f1df-5232-4804-897e-917bf397618a"
	//	|                   ^
	//	|                   |
	//	|       (variant "10__" == DCE)
	if(!dojox.uuid._ourVariantLookupTable){
		var variant = dojox.uuid.variant;
		var lookupTable = [];

		lookupTable[0x0] = variant.NCS;       // 0000
		lookupTable[0x1] = variant.NCS;       // 0001
		lookupTable[0x2] = variant.NCS;       // 0010
		lookupTable[0x3] = variant.NCS;       // 0011

		lookupTable[0x4] = variant.NCS;       // 0100
		lookupTable[0x5] = variant.NCS;       // 0101
		lookupTable[0x6] = variant.NCS;       // 0110
		lookupTable[0x7] = variant.NCS;       // 0111

		lookupTable[0x8] = variant.DCE;       // 1000
		lookupTable[0x9] = variant.DCE;       // 1001
		lookupTable[0xA] = variant.DCE;       // 1010
		lookupTable[0xB] = variant.DCE;       // 1011

		lookupTable[0xC] = variant.MICROSOFT; // 1100
		lookupTable[0xD] = variant.MICROSOFT; // 1101
		lookupTable[0xE] = variant.UNKNOWN;   // 1110
		lookupTable[0xF] = variant.UNKNOWN;   // 1111
		
		dojox.uuid._ourVariantLookupTable = lookupTable;
	}

	uuidString = uuidString.toString();
	var variantCharacter = uuidString.charAt(19);
	var HEX_RADIX = 16;
	var variantNumber = parseInt(variantCharacter, HEX_RADIX);
	dojox.uuid.assert((variantNumber >= 0) && (variantNumber <= 16));
	return dojox.uuid._ourVariantLookupTable[variantNumber]; // dojox.uuid.variant
};

dojox.uuid.getVersion = function(/*String*/ uuidString){
	// summary:
	//		Returns a version number that indicates what type of UUID this is.
	//		Returns one of the enumerated dojox.uuid.version values.
	// example:
	//		var version = dojox.uuid.getVersion("b4308fb0-86cd-11da-a72b-0800200c9a66");
	//		dojox.uuid.assert(version == dojox.uuid.version.TIME_BASED);
	// exceptions:
	//		Throws an Error if this is not a DCE Variant UUID.
	var errorMessage = "dojox.uuid.getVersion() was not passed a DCE Variant UUID.";
	dojox.uuid.assert(dojox.uuid.getVariant(uuidString) == dojox.uuid.variant.DCE, errorMessage);
	uuidString = uuidString.toString();
	
		// "b4308fb0-86cd-11da-a72b-0800200c9a66"
		//			      ^
		//			      |
		//		 (version 1 == TIME_BASED)
	var versionCharacter = uuidString.charAt(14);
	var HEX_RADIX = 16;
	var versionNumber = parseInt(versionCharacter, HEX_RADIX);
	return versionNumber; // dojox.uuid.version
};

dojox.uuid.getNode = function(/*String*/ uuidString){
	// summary:
	//		If this is a version 1 UUID (a time-based UUID), getNode() returns a
	//		12-character string with the "node" or "pseudonode" portion of the UUID,
	//		which is the rightmost 12 characters.
	// exceptions:
	//		Throws an Error if this is not a version 1 UUID.
	var errorMessage = "dojox.uuid.getNode() was not passed a TIME_BASED UUID.";
	dojox.uuid.assert(dojox.uuid.getVersion(uuidString) == dojox.uuid.version.TIME_BASED, errorMessage);

	uuidString = uuidString.toString();
	var arrayOfStrings = uuidString.split('-');
	var nodeString = arrayOfStrings[4];
	return nodeString; // String (a 12-character string, which will look something like "917bf397618a")
};

dojox.uuid.getTimestamp = function(/*String*/ uuidString, /*String?*/ returnType){
	// summary:
	//		If this is a version 1 UUID (a time-based UUID), this method returns
	//		the timestamp value encoded in the UUID.  The caller can ask for the
	//		timestamp to be returned either as a JavaScript Date object or as a
	//		15-character string of hex digits.
	// returnType:
	//		Any of these five values: "string", String, "hex", "date", Date
	// returns:
	//		Returns the timestamp value as a JavaScript Date object or a 15-character string of hex digits.
	// examples:
	//		var uuidString = "b4308fb0-86cd-11da-a72b-0800200c9a66";
	//		var date, string, hexString;
	//		date   = dojox.uuid.getTimestamp(uuidString);         // returns a JavaScript Date
	//		date   = dojox.uuid.getTimestamp(uuidString, Date);     //
	//		string = dojox.uuid.getTimestamp(uuidString, String);   // "Mon, 16 Jan 2006 20:21:41 GMT"
	//		hexString = dojox.uuid.getTimestamp(uuidString, "hex"); // "1da86cdb4308fb0"
	// exceptions:
	//		Throws an Error if this is not a version 1 UUID.
	var errorMessage = "dojox.uuid.getTimestamp() was not passed a TIME_BASED UUID.";
	dojox.uuid.assert(dojox.uuid.getVersion(uuidString) == dojox.uuid.version.TIME_BASED, errorMessage);
	
	uuidString = uuidString.toString();
	if(!returnType){returnType = null};
	switch(returnType){
		case "string":
		case String:
			return dojox.uuid.getTimestamp(uuidString, Date).toUTCString(); // String (e.g. "Mon, 16 Jan 2006 20:21:41 GMT")
			break;
		case "hex":
			// Return a 15-character string of hex digits containing the
			// timestamp for this UUID, with the high-order bits first.
			var arrayOfStrings = uuidString.split('-');
			var hexTimeLow = arrayOfStrings[0];
			var hexTimeMid = arrayOfStrings[1];
			var hexTimeHigh = arrayOfStrings[2];
		
			// Chop off the leading "1" character, which is the UUID
			// version number for time-based UUIDs.
			hexTimeHigh = hexTimeHigh.slice(1);
		
			var timestampAsHexString = hexTimeHigh + hexTimeMid + hexTimeLow;
			dojox.uuid.assert(timestampAsHexString.length == 15);
			return timestampAsHexString; // String (e.g. "1da86cdb4308fb0")
			break;
		case null: // no returnType was specified, so default to Date
		case "date":
		case Date:
			// Return a JavaScript Date object.
			var GREGORIAN_CHANGE_OFFSET_IN_HOURS = 3394248;
			var HEX_RADIX = 16;
		
			var arrayOfParts = uuidString.split('-');
			var timeLow = parseInt(arrayOfParts[0], HEX_RADIX);
			var timeMid = parseInt(arrayOfParts[1], HEX_RADIX);
			var timeHigh = parseInt(arrayOfParts[2], HEX_RADIX);
			var hundredNanosecondIntervalsSince1582 = timeHigh & 0x0FFF;
			hundredNanosecondIntervalsSince1582 <<= 16;
			hundredNanosecondIntervalsSince1582 += timeMid;
			// What we really want to do next is shift left 32 bits, but the
			// result will be too big to fit in an int, so we'll multiply by 2^32,
			// and the result will be a floating point approximation.
			hundredNanosecondIntervalsSince1582 *= 0x100000000;
			hundredNanosecondIntervalsSince1582 += timeLow;
			var millisecondsSince1582 = hundredNanosecondIntervalsSince1582 / 10000;
		
			// Again, this will be a floating point approximation.
			// We can make things exact later if we need to.
			var secondsPerHour = 60 * 60;
			var hoursBetween1582and1970 = GREGORIAN_CHANGE_OFFSET_IN_HOURS;
			var secondsBetween1582and1970 = hoursBetween1582and1970 * secondsPerHour;
			var millisecondsBetween1582and1970 = secondsBetween1582and1970 * 1000;
			var millisecondsSince1970 = millisecondsSince1582 - millisecondsBetween1582and1970;
		
			var timestampAsDate = new Date(millisecondsSince1970);
			return timestampAsDate; // Date
			break;
		default:
			// we got passed something other than a valid returnType
			dojox.uuid.assert(false, "dojox.uuid.getTimestamp was not passed a valid returnType: " + returnType);
			break;
	}
};

return dojox.uuid;

});

},
'epi-cms/widget/overlay/Block':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/on",
    "dojo/when",

    // Parent classes
    "epi/shell/widget/overlay/_Base",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "epi-cms/widget/overlay/_OverlayItemInfoMixin",
    "epi-cms/contentediting/command/ContentAreaCommands",
    "epi-cms/ContentLanguageHelper",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.blockcontextmenu",
    "dojo/text!../templates/Block.html",
    // Widgets used in template
    "dijit/form/DropDownButton",
    "epi/shell/widget/ContextMenu"
], function (
    // General application modules
    declare,
    event,
    lang,
    domClass,
    domStyle,
    on,
    when,

    // Parent classes
    _Base,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _OverlayItemInfoMixin,
    ContentAreaCommands,
    ContentLanguageHelper,

    // Resources
    resources,
    template
) {

    return declare([_Base, _TemplatedMixin, _WidgetsInTemplateMixin, _OverlayItemInfoMixin], {
        // summary:
        //    The block widget is used together with the BlockArea widget to show the
        //    position of the different blocks for a ContentAreaProperty.
        // tags:
        //    public

        // templateString: [public] String
        templateString: template,

        res: resources,

        _setMissingRendererAttr: function(value) {
            domClass.toggle(this.domNode, "epi-overlay-item-missing-renderer", value);
        },

        buildRendering: function() {
            this.inherited(arguments);

            domStyle.set(this.personalizedIcon, "display", this.viewModel.contentGroup ? "" : "none");
        },

        postCreate: function() {
            // summary:
            //      Initialize widgets
            // tags:
            //      protected
            this.inherited(arguments);

            this._injectDynamicStyles();

            // Make command provider is injected
            this.commandProvider = this.commandProvider || new ContentAreaCommands({ model: this.viewModel });

            this.own(this.viewModel.watch("statusMessage", lang.hitch(this, function(propertyName, oldValue, newValue){
                when(ContentLanguageHelper.getMissingLanguageMessage(this.viewModel.content), lang.hitch(this, function (message) {
                    domStyle.set(this.warningIcon, "display", message ? "" : "none");
                }));
                //Show/Hide the icons container
                domStyle.set(this.iconsContainer, "display", this.viewModel.contentGroup || newValue ? "" : "none");
            })));

            this.viewModel.loadStatus();

            this.contextMenu.addProvider(this.commandProvider);

            if (this.blockInfo && this.blockInfo.missingrenderer) {
                this.set("missingRenderer", this.blockInfo.missingrenderer);
            }

            this.own(
                on(this.domNode, "click", lang.hitch(this.viewModel, "set", "selected", true)),
                on(this.settingsButton, "click", lang.hitch(this, "_onContextMenuClick")),
                on(this.domNode, "mouseout", lang.hitch(this, function (e) {
                    if (this.contextMenu && this.contextMenu.isShowingNow) {
                        event.stop(e);
                    }
                }))
            );
        },

        _injectDynamicStyles: function() {
            // summary:
            //      Inject dynamic styles for original dom node
            // tags:
            //      private
            var node = this.sourceItemNode,
                display = domStyle.get(node, "display"),
                suffix = /inline|inline-block/.test(display) ? "-inline" : "";

            domClass.add(node, "epi-injected-minSize" + suffix);
        },

        _onContextMenuClick: function() {
            // Set the viewmodel to the command provider again
            this.commandProvider.set("model", this.viewModel);

            this.viewModel.set("selected", true);
            // Return false to cause prevent default in dijit/form/_ButtonMixin
            return false;
        }
    });
});
},
'epi-cms/widget/overlay/_OverlayItemInfoMixin':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/on",
    "dojo/when",
    "dojo/mouse",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/overlay/OverlayItemInfo",
    "epi-cms/widget/viewmodel/ContentStatusViewModel"
], function (declare, lang, domConstruct, on, when, mouse, TypeDescriptorManager, OverlayItemInfo, ContentStatusViewModel) {

    // module:
    //      epi-cms/widget/overlay/_OverlayItemInfoMixin
        // summary:
    //      A mixin for overlays that adds an information layer containing an icon and message.
    return declare(null, {

        // disableTooltip: [Boolean]
        //      Flag to indicate disable overlay information tooltip when starting drag.
        disableTooltip: false,

        // useIconOnBlock: [Boolean]
        //      Flag to indicate always show/not overlay and icon of block.
        useIconOnBlock: false,
        postCreate: function () {
            this.own(this.viewModel.watch("contentStatus", lang.hitch(this, "_setupIcon")));

            this.own(this.viewModel.watch("statusMessage", lang.hitch(this, function(propertyName, oldValue, newValue){
                this.set("statusMessage", newValue);
            })));

            // Subcrible global dnd events to toggle state of disableTooltip.
            this.subscribe("/dnd/start", lang.hitch(this, function() {
                if(!this.disableTooltip) {
                    this._set("disableTooltip", true);

                    // Make sure close current tooltip if it showed.
                    this._showStatusMessage(false);
                }
            }));
            this.subscribe("/dnd/cancel", lang.hitch(this, function() {
                this._set("disableTooltip", false);
            }));
            this.subscribe("/dnd/drop", lang.hitch(this, function() {
                this._set("disableTooltip", false);
            }));

            // Connect onmouseenter/onmouseleave events in order to show/hide additional information
            var node = this.get("containerDomNode");
            if(node) {
                this.own(on(node, mouse.enter, lang.hitch(this, function () {
                    this._showStatusMessage(!this.get("disableTooltip"));
                })));

                this.own(on(node, mouse.leave, lang.hitch(this, function () {
                    this._showStatusMessage(false);
                })));
            }

            this.inherited(arguments);
        },

        destroy: function() {
            if(this._overlayItemInfo) {
                this._overlayItemInfo.destroyRecursive();
                this._overlayItemInfo = null;
            }

            this.inherited(arguments);
        },

        _setStatusIconAttr: function( /* String */ iconCSSClasses) {
            // summary:
            //      Apply CSS class for content status icon.
            // iconCSSClasses: [String]
            //      List of CSS class for content status icon
            // tags:
            //      private
            var overlayItemInfo = this.get("overlayItemInfo");

            if(!overlayItemInfo) {
                return;
            }

            overlayItemInfo.set("statusIcon", iconCSSClasses);
        },

        _setStatusMessageAttr: function( /* Object */ message) {
            // summary:
            //      Set content status message
            // message: [Object]
            //      Content status message object. Can be String data type or Array data type.
            // tags:
            //      private
            var overlayItemInfo = this.get("overlayItemInfo");

            if(!overlayItemInfo) {
                return;
            }

            overlayItemInfo.set("statusMessage", message);
        },

        _getContainerDomNodeAttr: function() {
            // summary:
            //      Get container DOM node.
            // tags:
            //      private
            return this.containerDomNode || this.domNode;
        },

        _getOverlayItemInfoAttr: function() {
            // summary:
            //      Get overlay item information widget
            // tags:
            //      private
            if(!this._overlayItemInfo) {
                // Setup overlay item information widget
                this._overlayItemInfo = new OverlayItemInfo();

                domConstruct.place(this._overlayItemInfo.domNode, this.get("containerDomNode"));
            }

            return this._overlayItemInfo;
        },

        _setupIcon: function () {

            var overlayItemInfo,
                useIconOnBlock,
                iconClass,
                description;

            overlayItemInfo = this.get("overlayItemInfo");
            overlayItemInfo.set("class", !this.viewModel.get("isVisibleOnSite") ? "epi-overlay-content-invisible" : "");

            // Get typeIdentifier of content first and if null then get of viewmodel. 
            var typeIdentifier = (this.viewModel.content && this.viewModel.content.typeIdentifier) || this.viewModel.typeIdentifier;

            if (this.viewModel.get("isVisibleOnSite") && typeIdentifier) {
                useIconOnBlock = TypeDescriptorManager.getValue(typeIdentifier, "useIconOnBlock");
                iconClass = TypeDescriptorManager.getValue(typeIdentifier, "iconClass");
                description = TypeDescriptorManager.getValue(typeIdentifier, "description");

                if (useIconOnBlock) {
                    overlayItemInfo.set("class", "epi-overlay-content-info");
                    this.set("useIconOnBlock", true);
                    this.set("statusIcon", iconClass);
                    this.set("statusMessage", description);
                }
            }
        },

        _showStatusMessage: function( /* Boolean */ visible) {
            // summary:
            //      Set availibility to display additional information.
            // visible: [Boolean]
            //      Indicated that show additional information if true
            // tags:
            //      private
            if(this._overlayItemInfo) {
                this._overlayItemInfo.showStatusMessage(visible);
            }
        }
    });
});
},
'epi/shell/widget/overlay/OverlayItemInfo':function(){
require({cache:{
'url:epi/shell/widget/overlay/templates/OverlayItemInfo.html':"﻿<span class=\"epi-overlay-content\">\r\n    <span data-dojo-attach-point=\"highlightArea\" class=\"epi-overlay-content-highlight-area\"></span>\r\n</span>"}});
﻿define("epi/shell/widget/overlay/OverlayItemInfo", [
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
// dijit
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
// dojox
    "dojox/html/entities",
// epi
    "epi/string",
    "epi/shell/widget/Tooltip",
// template
    "dojo/text!./templates/OverlayItemInfo.html"
],
function (
// dojo
    array,
    declare,
    lang,

    domClass,
    domConstruct,
    domStyle,
// dijit
    _WidgetBase,
    _TemplatedMixin,
// dojox
    htmlEntities,
// epi
    epiString,
    Tooltip,
// template
    template
) {
    return declare([_WidgetBase, _TemplatedMixin], {
        // summary:
        //      Widget that used to display information for an overlay item
        // tags:
        //      public

        templateString: template,

        postCreate: function () {
            this.inherited(arguments);

            // Setup default settings
            this.showStatusMessage(false);
        },

        destroy: function () {
            this.inherited(arguments);
            this._destroyTooltip();
        },

        showStatusMessage: function (/* Boolean */visible) {
            // summary:
            //      Toggle display of opacity layer
            // visible: [Boolean]
            //      Indicates additional information tooltip will be shown or not
            // tags:
            //      public

            if (this._tooltip) {
                visible ? this._tooltip.open(this.domNode) : this._tooltip.close();
            }
        },

        _setStatusIconAttr: function (/*Object*/ iconCssClass) {
            // summary:
            //      Set icon class of overlay item info
            // iconCssClass: [Object]
            //      The icon css class name
            // tags:
            //      private

            var isArray = lang.isArray(iconCssClass);
            if (isArray) {
                // Loop through array and add css class
                array.forEach(iconCssClass, function (cssClass) {
                    domClass.add(this.highlightArea, cssClass);
                }, this);
            }
            else {
                domClass.add(this.highlightArea, iconCssClass);
            }
        },

        _setStatusMessageAttr: function (/* Object */message) {
            // summary:
            //      Additional information about the content could be accessible in a tooltip
            // message: [Object]
            //      Tooltip content in multiple lines format
            //      Line format: { label: "label string", text: "text string", htmlEncode: true/false }
            // tags:
            //      private

            if (!message) {
                return;
            }

            var isArray = lang.isArray(message);

            if (this._tooltip) {
                if (isArray) {
                    this._tooltip.tooltipRows = message;
                } else {
                    this._tooltip.label = htmlEntities.encode(message);
                }
            } else {
                var messageContainer = domConstruct.create("div",
                    {
                        "class": "epi-overlay-content-tooltip",
                        innerHTML: epiString.toHTML(htmlEntities.encode(message))
                    }),
                    properties = isArray ? { tooltipRows: message} : { label: messageContainer.outerHTML };

                this._tooltip = new Tooltip(properties);
            }
        },

        _destroyTooltip: function () {
            // summary:
            //      Destroy tooltip
            // tags:
            //      private

            if (this._tooltip) {
                this._tooltip.destroyRecursive();
                this._tooltip = null;
            }
        }
    });
});
},
'url:epi/shell/widget/overlay/templates/OverlayItemInfo.html':"﻿<span class=\"epi-overlay-content\">\r\n    <span data-dojo-attach-point=\"highlightArea\" class=\"epi-overlay-content-highlight-area\"></span>\r\n</span>",
'epi-cms/contentediting/command/ContentAreaCommands':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/Stateful",
    "./BlockRemove",
    "./BlockEdit",
    "./MoveVisibleToPrevious",
    "./MoveVisibleToNext",
    "./Personalize",
    "./SelectDisplayOption"
], function(array, declare, Stateful, Remove, Edit, MoveVisibleToPrevious, MoveVisibleToNext, Personalize, SelectDisplayOption) {

    return declare([Stateful], {

        commands: null,

        constructor: function() {
            this.commands = [
                new Edit(),
                new SelectDisplayOption(),
                new Personalize(),
                new MoveVisibleToPrevious(),
                new MoveVisibleToNext(),
                new Remove()
            ];
        },

        _modelSetter: function(model) {
            this.model = model;

            array.forEach(this.commands, function(command) {
                command.set("model", model);
            });
        }
    });
});
},
'epi-cms/contentediting/command/BlockRemove':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "epi",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand"
], function(declare, epi, _ContentAreaCommand) {

    return declare([_ContentAreaCommand], {

        name: "remove",

        label: epi.resources.action.remove,

        tooltip: epi.resources.action.remove,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconTrash",

        _execute: function() {
            // summary:
            //      Removes the content item.
            // tags:
            //      protected
            this.model.remove();
        },

        _onModelValueChange: function() {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected
            this.set("canExecute", !!this.model && !this.model.get("readOnly"));
        }
    });
});

},
'epi-cms/contentediting/command/_ContentAreaCommand':function(){
define([
    // General application modules
    "dojo/_base/declare",
    "dojo/_base/lang",
    // Parent class
    "epi/shell/command/_Command"
], function(declare, lang, _Command) {

    // module:
    //      epi-cms/contentediting/command/_ContentAreaCommand
    // summary:
    //      Base class for content area commands that execute on selected content item on the model.
    return declare([_Command], {

        _onModelChange: function() {
            // summary:
            //      Watches the model for changes to the current content after the model has been updated.
            // tags:
            //      protected
            var model = this.model;

            if(this._handles) {
                // Remove any exisiting handles.
                for(var i = 0; i<this._handles.length; i++) {
                    this._handles[i].remove();
                }
            }

            this._handles = [];

            if(!model) {
                this.set("canExecute", false);
                return;
            }

            this._watch("readOnly", function() {
                this._onModelValueChange();
            }, this);

            this._onModelValueChange();
        },

        _watch: function(property, callback, scope) {
            // summary:
            //      Attach a watch handler to the model
            // property: [String]
            //      The name of the property to watch
            // callback: [function]
            //      The function to execute when the property changed
            // scope: [Object]
            //      The scope in which the callback should be executed

            if(scope) {
                this._handles.push(this.model.watch(property, lang.hitch(scope, callback)));
            } else {
                this._handles.push(this.model.watch(property, callback));
            }
        },

        _getItem: function () {
            // summary:
            //      Get the selected content model, based on its group
            // tags:
            //      protected

            return this.model.contentGroup ? this.model.parent : this.model;
        },

        _getContainer: function () {
            // summary:
            //      Get the selected content parent model
            // tags:
            //      protected

            var getContainer = function(item) {
                if(item.parent) {
                    return getContainer(item.parent);
                }
                return item;
            };

            return getContainer(this.model);
        },

        _onModelValueChange: function() {
            // summary:
            //      Updates canExecute after the current model value has changed. Subclasses should override this method.
            // tags:
            //      protected
        }
    });
});
},
'epi-cms/contentediting/command/BlockEdit':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",
    "epi",
    "epi/dependency",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand",
    "epi-cms/contentediting/ContentActionSupport",
        "epi/i18n!epi/cms/nls/episerver.shared.action"
], function (declare, lang, topic, when, epi, dependency, _ContentAreaCommand, ContentActionSupport, actionStrings) {

    // module:
    //      epi-cms/contentediting/command/BlockEdit
    // description:
    //      Edit/View command for the Block component
    // tags:
    //      public
    return declare([_ContentAreaCommand], {
        
        name: "edit",

        label: epi.resources.action.edit,

        tooltip: epi.resources.action.edit,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconPen",

        // category: [readonly] String
        //      A category which hints that this item should be displayed with a separator.
        category: "menuWithSeparator",

        constructor: function() {
            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;
            var registry = dependency.resolve("epi.storeregistry");
            this._store = registry.get("epi.cms.content.light");
        },

        _execute: function() {
            // summary:
            //      Change the context to edit the block.
            // tags:
            //      protected
            var contentLink = this.model.contentLink;
            topic.publish("/epi/shell/context/request", {
                uri: "epi.cms.contentdata:///" + contentLink
            }, {});
        },

        _onModelValueChange: function() {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected
            var item = this.model;

            if(!item || !item.contentLink) {
                this.set("canExecute", false);
                return;
            }

            var result = item && this._store.get(item.contentLink);
            
            // if the accessMask is available then display the label accordingly. (i.e either "View" or "Edit")
            when(result, lang.hitch(this, function (content) {
                this.set("canExecute", content && !content.isDeleted);
                if (content && content.accessMask) {
                    if (this.contentActionSupport.hasAccess(content.accessMask, this.contentActionSupport.accessLevel[this.contentActionSupport.action.Edit])) {
                        this.set("label", actionStrings.edit);
                        this.set("iconClass", "epi-iconPen");
                    }
                    else {
                        this.set("label", actionStrings.view);
                        this.set("iconClass", "epi-iconSearch");
                    }
                }
            }));
        }
    });
});
},
'epi-cms/contentediting/command/MoveVisibleToPrevious':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    // Parent class
    "epi-cms/contentediting/command/MoveToPrevious"
], function(array, declare, MoveToPrevious) {

    // module:
    //      epi-cms/contentediting/command/MoveVisibleToPrevious
    // summary:
    //      Moves the selected content block after the previous visible sibling. If the selected content block
    //      is within a group the group is moved instead.
    return declare([MoveToPrevious], {

        _execute: function() {
            // summary:
            //      Moves the block after the next sibling; this could be abother block or a visitor group.
            // tags:
            //      protected

            this._getContainer().moveVisible(this._getItem(), false);
        },

        _onModelChange: function() {
            this.inherited(arguments);

            this._watch("visible", function() {
                this._onModelValueChange();
            }, this);
        },

        _onModelValueChange: function() {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected
            var children = array.filter(this._getContainer().getChildren(), function(child) {
                    return child.get("visible");
                }),
                index = array.indexOf(children, this._getItem());

            // Can execute if the index of the item is greater than the first index.
            this.set("canExecute", index > 0);
        }
    });
});
},
'epi-cms/contentediting/command/MoveToPrevious':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "epi",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand"
], function(declare, epi, _ContentAreaCommand) {

    // module:
    //      epi-cms/contentediting/command/MoveToPrevious
    // summary:
    //      Moves the selected content block after the previous sibling.
    return declare([_ContentAreaCommand], {

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: epi.resources.action.moveup,

        // tooltip: [public] String
        //      The description text of the command to be used in visual elements.
        tooltip: epi.resources.action.moveup,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconUp",

        _execute: function() {
            // summary:
            //      Moves the block before the previous sibling; this could be abother block or a visitor group.
            // tags:
            //      protected
            this.model.movePrevious();
        },
        
        _onModelChange: function() {
            this.inherited(arguments);

            this._watch("canMovePrevious", function() {
                this._onModelValueChange();
            }, this);
        },

        _onModelValueChange: function() {
            this.set("canExecute", this.model.get("canMovePrevious") && !this.model.get("readOnly"));
        }
    });
});
},
'epi-cms/contentediting/command/MoveVisibleToNext':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    // Parent class
    "epi-cms/contentediting/command/MoveToNext"
], function(array, declare, MoveToNext) {

    // module:
    //      epi-cms/contentediting/command/MoveVisibleToNext
    // summary:
    //      Moves the selected content block after the next visible sibling. If the selected content block
    //      is within a group the group is moved instead.
    return declare([MoveToNext], {

        _execute: function() {
            // summary:
            //      Moves the block after the next sibling; this could be abother block or a visitor group.
            // tags:
            //      protected

            this._getContainer().moveVisible(this._getItem(), true);
        },

        _onModelChange: function() {
            this.inherited(arguments);

            this._watch("visible", function() {
                this._onModelValueChange();
            }, this);
        },

        _onModelValueChange: function() {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected
            var children = array.filter(this._getContainer().getChildren(), function(child) {
                    return child.get("visible");
                }),
                index = array.indexOf(children, this._getItem());

            // Can execute if the index of the item is less than the last index.
            this.set("canExecute", index != -1 && index < children.length - 1);
        }
    });
});
},
'epi-cms/contentediting/command/MoveToNext':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "epi",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand"
], function(declare, epi, _ContentAreaCommand) {

    // module:
    //      epi-cms/contentediting/command/MoveToNext
    // summary:
    //      Moves the selected content block after the next sibling.
    return declare([_ContentAreaCommand], {

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: epi.resources.action.movedown,

        // tooltip: [public] String
        //      The description text of the command to be used in visual elements.
        tooltip: epi.resources.action.movedown,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconDown",

        // category: [readonly] String
        //      Indicates that this command should created with a separator.
        category: "menuWithSeparator",

        _execute: function() {
            // summary:
            //      Moves the block after the next sibling; this could be abother block or a visitor group.
            // tags:
            //      protected

            this.model.moveNext();
        },

        _onModelChange: function() {
            this.inherited(arguments);

            // Watch the new model for changes
            this._watch("canMoveNext", function() {
                this._onModelValueChange();
            }, this);
        },
        
        _onModelValueChange: function() {
            this.set("canExecute", this.model.get("canMoveNext") && !this.model.get("readOnly"));
        }
    });
});
},
'epi-cms/contentediting/command/Personalize':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "epi-cms/contentediting/viewmodel/PersonalizedGroupViewModel",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.personalize"
], function(declare, PersonalizedGroupViewModel, _ContentAreaCommand, resources) {

    return declare([_ContentAreaCommand], {

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: resources.label,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconUsers",

        // category: [readonly] String
        //      A category which hints that this item should be displayed with a separator.
        category: "menuWithSeparator",

        _execute: function() {
            // summary:
            //      Opens the personalization dialog and adds the selected item to a visitor group if necessary.
            // tags:
            //      protected
            if(!this.model.contentGroup) {
                this.model.personalize();
            }
        },

        _onModelValueChange: function() {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected
            this.set("canExecute", !!this.model && this.model.contentLink && !this.model.contentGroup && !this.model.get("readOnly"));
        }
    });
});
},
'epi-cms/contentediting/command/SelectDisplayOption':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    "epi/dependency",

    "epi-cms/contentediting/command/_ContentAreaCommand",
    "epi-cms/contentediting/viewmodel/ContentBlockViewModel",

    "epi-cms/widget/DisplayOptionSelector",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.displayoptions"
], function (declare, lang, when, dependency, _ContentAreaCommand, ContentBlockViewModel, DisplayOptionSelector, resources) {

    return declare([_ContentAreaCommand], {

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: resources.label,

        // category: [readonly] String
        //      A category which hints that this item should be displayed as an popup menu.
        category: "popup",

        _labelAutomatic: lang.replace(resources.label, [resources.automatic]),

        constructor: function () {
            this.popup = new DisplayOptionSelector();
        },

        postscript: function () {
            this.inherited(arguments);

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.displayoptions");
            }

            when(this.store.get(), lang.hitch(this, function (options) {
                // Reset command's available property in order to reset dom's display property of the given node
                this._setCommandAvailable(options);

                this.popup.set("displayOptions", options);
            }));
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected

            this.inherited(arguments);

            var options = this.popup.displayOptions,
                selectedOption = this.model.get("displayOption"),
                isAvailable = options && options.length > 0;

            isAvailable = isAvailable && (this.model instanceof ContentBlockViewModel);

            this._setCommandAvailable(options);

            if (!isAvailable) {
                this.set("label", this._labelAutomatic);
                return;
            }

            this.popup.set("model", this.model);

            if (!selectedOption) {
                this.set("label", this._labelAutomatic);
            } else {
                this._setLabel(selectedOption);
            }

            this._watch("displayOption", function (property, oldValue, newValue) {
                if (!newValue) {
                    this.set("label", this._labelAutomatic);
                } else {
                    this._setLabel(newValue);
                }
            }, this);
        },

        _setCommandAvailable: function (/*Array*/displayOptions) {
            // summary:
            //      Set command available
            // displayOptions: [Array]
            //      Collection of a content display mode
            // tags:
            //      private

            this.set("isAvailable", displayOptions && displayOptions.length > 0 && this.model instanceof ContentBlockViewModel);
        },

        _setLabel: function (displayOption) {
            when(this.store.get(displayOption), lang.hitch(this, function (option) {
                this.set("label", lang.replace(resources.label, [option.name]));

            }), lang.hitch(this, function (error) {

                console.log("Could not get the option for: ", newValue, error);

                this.set("label", this._labelAutomatic);
            }));
        },

        _onModelValueChange: function () {
            this.set("canExecute", !!this.model && this.model.contentLink && !this.model.get("readOnly"));
        }
    });
});
},
'epi-cms/widget/DisplayOptionSelector':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

    "dijit/MenuSeparator",

    "epi-cms/widget/SelectorMenuBase",

    // Resouces
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.displayoptions",

    // Widgets used in template
    "epi/shell/widget/RadioMenuItem"
], function(
    array,
    declare,
    lang,
    when,

    MenuSeparator,

    SelectorMenuBase,

    // Resouces
    resources,

    RadioMenuItem
) {

    // module:
    //      epi-cms/widget/DisplayOptionSelector
    // summary:
    //      Used for selecting display options for a block in a content area
    return declare([SelectorMenuBase], {

        // model: [public] epi-cms.contentediting.viewmodel.ContentBlockViewModel
        //      View model for the selector
        model: null,

        // _resources: [private] Object
        //      Resource object used in the template
        headingText: resources.title,

        _rdAutomatic: null,
        _separator: null,

        postCreate: function() {
            // summary:
            //      Create the selector template and query for display options

            this.inherited(arguments);

            this.own(this._rdAutomatic = new RadioMenuItem({ label: resources.automatic, value: "" }));
            this.addChild(this._rdAutomatic);
            this._rdAutomatic.on("change", lang.hitch(this, this._restoreDefault));

            this.own(this._separator = new MenuSeparator({ baseClass: "epi-menuSeparator" }));
            this.addChild(this._separator);
        },

        _restoreDefault: function () {
            this.model.modify(function() {
                this.model.set("displayOption", null);
            }, this);
        },

        _setModelAttr: function(model) {
            this._set("model", model);

            this._setup();
        },

        _setDisplayOptionsAttr: function(displayOptions) {
            this._set("displayOptions", displayOptions);

            this._setup();
        },

        _setup: function(){

            if(!this.model || !this.displayOptions) {
                return;
            }

            //Destroy the old menu items
            this._removeMenuItems();

            var selectedDisplayOption = this.model.get("displayOption");

            array.forEach(this.displayOptions, function(displayOption) {

                var item = new RadioMenuItem({
                    label: displayOption.name,
                    iconClass: displayOption.iconClass,
                    displayOptionId: displayOption.id,
                    checked: selectedDisplayOption === displayOption.id
                });

                this.own(item.watch("checked", lang.hitch(this, function(property, oldValue, newValue) {
                    if (!newValue) {
                        return;
                    }
                    //Modify the model
                    this.model.modify(function(){
                        this.model.set("displayOption", displayOption.id);
                    }, this);

                    this._rdAutomatic.set("checked", false);
                })));

                this.addChild(item);
            }, this);

            this._rdAutomatic.set("checked", !selectedDisplayOption);
        },

        _removeMenuItems: function () {
            var items = this.getChildren();
            items.forEach(function (item) {
                if (item === this._rdAutomatic || item == this._separator) {
                    return;
                }
                this.removeChild(item);
                item.destroy();
            }, this);
        }
    });
});
},
'epi-cms/widget/SelectorMenuBase':function(){
﻿define([
    "dojo/_base/declare",
	"dojo/keys",
    "dijit/_MenuBase",
    "dojo/text!./templates/SelectorMenuBase.html"
], function (
    declare,
    keys,
    _MenuBase,
    template) {

    // module:
    //      epi-cms/widget/SelectorMenuBase
    // summary:
    //      Base widget for selector menus

    return declare([_MenuBase], {

        // templateString: String
        //      The template string.
        templateString: template,

        // headingText: String
        //      The heading text.
        headingText: null,

        postCreate: function () {
            // summary:
            //      Connect key navigation handlers.

            this.inherited(arguments);

            this.connectKeyNavHandlers([keys.UP_ARROW], [keys.DOWN_ARROW]);
        }
    });
});
},
'url:epi-cms/widget/templates/SelectorMenuBase.html':"﻿<div class=\"epi-DropDownMenu\">\r\n    <div class=\"epi-dijitTooltipContainer\">\r\n        <div class=\"epi-invertedTooltip\">\r\n            <div class=\"epi-tooltipDialogTop\">\r\n                <span>${headingText}</span>\r\n                <div class=\"dijitTooltipConnector\"></div>\r\n            </div>\r\n        </div>\r\n        <div class=\"epi-tooltipDialogContent--max-height\">\r\n            <table class=\"dijitReset dijitMenu epi-tooltipDialogMenu epi-menuInverted epi-mediumMenuItem\" style=\"width: 100%\" cellspacing=\"0\">\r\n\t            <tbody data-dojo-attach-point=\"containerNode\" ></tbody>\r\n            </table>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'url:epi-cms/widget/templates/Block.html':"﻿<div class=\"dojoDndItem epi-overlay-block\">\r\n    <div data-dojo-attach-point=\"containerDomNode\"></div>\r\n    <span class=\"epi-personalized\" data-dojo-attach-point=\"iconsContainer\">\r\n        <span class=\"epi-overlayControls epi-mediumButton \">\r\n            <span class=\"dijitReset dijitInline dijitIcon epi-iconWarning\" data-dojo-attach-point=\"warningIcon\"></span>\r\n            <span class=\"dijitReset dijitInline dijitIcon epi-iconUsers\" data-dojo-attach-point=\"personalizedIcon\"></span>\r\n        </span>\r\n    </span>\r\n    <button class=\"epi-chromelessButton epi-overlayControls epi-settingsButton epi-mediumButton\" data-dojo-attach-point=\"settingsButton\" data-dojo-type=\"dijit/form/DropDownButton\" data-dojo-props=\"showLabel:false, title:'${res.settingstooltip}', iconClass:'epi-iconContextMenu'\">\r\n        <div data-dojo-attach-point=\"contextMenu\" data-dojo-type=\"epi/shell/widget/ContextMenu\"></div>\r\n    </button>\r\n</div>",
'epi-cms/contentediting/command/MoveOutsideGroup':function(){
﻿define([
    // General application modules
    "dojo/_base/declare",
    // Parent class
    "epi-cms/contentediting/command/_ContentAreaCommand",
        
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.contentarea.personalize"
], function (declare, _ContentAreaCommand, resource) {

    // module:
    //      epi-cms/contentediting/command/MoveOutsideGroup
    // summary:
    //      Moves the selected content block outside the group if it belongs to a group
    return declare([_ContentAreaCommand], {

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: resource.moveoutsidegroup,

        // tooltip: [public] String
        //      The description text of the command to be used in visual elements.
        tooltip: resource.moveoutsidegroup,

        // iconClass: [readonly] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "",

        // category: [readonly] String
        //      Indicates that this command should created with a separator.
        category: "menuWithSeparator",

        _execute: function () {
            // summary:
            //      Moves the block after the next sibling; this could be abother block or a visitor group.
            // tags:
            //      protected

            this.model.moveOutsideGroup();
        },

        _onModelValueChange: function () {
            // summary:
            //      Updates canExecute after the model value has changed.
            // tags:
            //      protected

            this.set("canExecute", this.model.contentGroup && !this.model.get("readOnly"));
        }
    });
});
},
'url:epi-cms/contentediting/editors/templates/ContentAreaEditor.html':"﻿<div class=\"dijitInline\">\r\n    <div data-dojo-attach-point=\"treeNode\"></div>\r\n    <div data-dojo-attach-point=\"actionsContainer\" class=\"epi-content-area-actionscontainer\"></div>            \r\n</div>",
'epi-cms/contentediting/editors/ItemCollectionEditor':function(){
﻿define([
// Dojo
    "dojo/_base/array",                                                         // got some array extension methods
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/event",                                                         // used to stop event
    "dojo/aspect",                                                              // used to listen event from model
    "dojo/dom-class",                                                           // used to add/remove dom class
    "dojo/dom-construct",                                                       // used to create dom elem
    "dojo/dom-style",                                                           // used to show or not the action's container
    "dojo/dom-geometry",                                                        // used to get dom position
    "dojo/keys",                                                                // used to detect key to open context menu
    "dojo/on",                                                                  // used to listen event
    "dojo/query",                                                               // used to select dome
    "dojo/topic",                                                               // used to publish global event
    "dojo/when",                                                                // used to work with potential assynchronous calls

// Dijit
    "dijit/_TemplatedMixin",                                                    // mixin into me
    "dijit/_WidgetsInTemplateMixin",                                            // mixin into me
    "dijit/layout/_LayoutWidget",                                               // inherited directly

// EPi Framework
    "epi/shell/dgrid/Formatter",                                                // mixin into grid class
    "epi/shell/dnd/Target",                                                     // used to create an drop zone in actionContainer area
    "epi/shell/widget/_ValueRequiredMixin",                                     // mixin into me
    "epi/shell/widget/ContextMenu",                                             // used to create context menu
    "epi/shell/TypeDescriptorManager",

// EPi CMS
    "dgrid/Keyboard",                                                           // mixin into grid class
    "dgrid/OnDemandList",                                                       // mixin into grid class
    "dgrid/Selection",                                                          // mixin into grid class
    "epi-cms/dgrid/formatters",                                                 // used to format grid's item display name
    "epi-cms/dgrid/DnD",                                                        // mixin into grid class
    "epi-cms/extension/events",                                                 // used to get default events
    "epi-cms/contentediting/command/NewItem",                                   // used to create new item
    "epi-cms/contentediting/viewmodel/ItemCollectionViewModel",                 // editor view model
    "epi-cms/contentediting/command/ItemCollectionCommands",                    // context menu
    "epi-cms/widget/_HasChildDialogMixin",                                      // mixin into me
    "./_TextWithActionLinksMixin",

// Resources
    "dojo/text!./templates/ItemCollectionEditor.html",                          // editor template
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editors.itemcollection"  // language resources

], function (
// Dojo
    array,
    declare,
    lang,
    event,
    aspect,
    domClass,
    domConstruct,
    domStyle,
    domGeometry,
    keys,
    on,
    query,
    topic,
    when,

// Dijit
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _LayoutWidget,

// EPi Framework
    Formatter,
    Target,
    _ValueRequiredMixin,
    ContextMenu,
    TypeDescriptorManager,

// EPi CMS
    Keyboard,
    OnDemandList,
    Selection,
    formatters,
    DnD,
    events,
    NewItemCommand,
    ItemCollectionViewModel,
    ItemCollectionCommands,
    _HasChildDialogMixin,
    _TextWithActionLinksMixin,

// Resources
    template,
    resources

) {

    return declare([
        _LayoutWidget,                                                          // for base functionalities
        _TemplatedMixin, _WidgetsInTemplateMixin,                               // for base functionalities
        _ValueRequiredMixin,                                                    // for styling
        _HasChildDialogMixin,                                                   // for open dialog to create/edit an item
        _TextWithActionLinksMixin
    ], {
        // summary:
        //      The new editor for property link collection.
        // module:
        //      "epi-cms/contentediting/editors/ItemCollectionEditor"
        // description:
        //      That supports:
        //          - Collection item name automatically ellipsed
        //          - Sorting list of link items through drag n drop
        //          - Sorting list of link items through context menu
        //          - Create new link
        //          - Edit a link
        //          - Remove a link
        //          - Drag n drop of pages and media
        // tags:
        //    public

        // baseClass: [public] String
        //    The widget's base CSS class.
        baseClass: "epi-item-collection-editor",
        
        // multiple: [proteced] Boolean
        //      used by formmixin to determine whether to inject value as an array or single item
        //      return true
        multiple: true,

        // res: [protected] Json object
        //      Language resource
        res: resources,

        // actionsResource: [Object]
        //      The language resource for actions link
        actionsResource: resources,
        
        // templateString: [protected] String
        //      UI template for the editor
        templateString: template,

        // value: [protected] String
        //      Value of the property (link collection)
        value: null,

        // model: [public] ItemCollectionViewModel
        //      The view model of this edtior.
        model: null,

        // contextMenu: [public] ContextMenu instance
        //      Context menu for each grid's item.
        contextMenu: null,

        // gird: [public] dgrid instance.
        //      The dgrid instance
        grid: null,

        // commandProviderClass: [public] String
        //      The command's namespace can be injected from inheritance or caller.
        commandProviderClass: ItemCollectionCommands,

        // newItemCommand: [public] Command
        //      The command is used to create new item.
        //      That called when user click on new link at textWithLinks widget.
        _newItemCommand: null,

        // _gridClass: [private] Grid class
        //      The grid class to create new grid instance.
        _gridClass: declare([OnDemandList, Formatter, Selection, DnD, Keyboard]),

        // _mouseOverClass: [private] CSS class
        //      Used to show context menu when mouse hover a row
        _mouseOverClass: "epi-dgrid-mouseover",

        // actionsVisible: Boolean
        //      The flag to show/not actions container area
        actionsVisible: true,

        // customTypeIdentifier: [public] String
        //      If set, will be propagated as the dnd type for all items in the collection
        customTypeIdentifier: null,

        onChange: function (value) {
            // summary:
            //      Event raised when model value change or item's sort order changed
            // value:
            //      The link collection value
            // tags:
            //      public callback
        },

        postMixInProperties: function() {

            this.inherited(arguments);

            this.setupAllowedTypes();
        },

        postCreate: function () {
            this.inherited(arguments);

            this.set("model", new ItemCollectionViewModel(this.value,
            {
                itemModelType: this.itemModelType,
                readOnly: this.readOnly
            }));

            this.setupCommands();
            this.setupList();
            this.setupActionContainer();
            this.setupEvents();
        },

        startup: function () {
            this.inherited(arguments);
            this.contextMenu.startup();
        },

        setupActionContainer: function () {
            // summary:
            //      Initialization a actions container.
            // tags:
            //      protected

            this.own(
                // Setup dndTarget and store it.
                this._dndTarget = new Target(this.actionsContainer, {
                    accept: this.get("allowedDndTypes"),
                    isSource: false,
                    alwaysCopy: false,
                    insertNodes: function () { }
                })
            );

            this.setupActionLinks(this.actionsContainer);

            this._displayActionsContainer();
        },

        setupCommands: function () {
            // summary
            //      Initialization commands
            // tags:
            //      protected

            // Make command provider is injected
            this.contextMenu = this.contextMenu || new ContextMenu(),
            this.commandProvider = this.commandProvider || new this.commandProviderClass({ model: this.model, commandOptions: this.commandOptions }),
            this.contextMenu.addProvider(this.commandProvider),

            this.own(
                this.contextMenu,
                this.commandProvider,

                // Create new item command, store to reuse.
                this._newItemCommand = new NewItemCommand({
                    "model": this.model,
                    "dialogContentParams": this.commandOptions ? this.commandOptions.dialogContentParams : {}
                }));
        },

        setupList: function () {
            // summary:
            //      Initialization a list.
            // tags:
            //      protected

            var menu = { hasMenu: !!this.contextMenu, settings: { title: this.res ? this.res.menutooltip : "" } },

                linkAssembler = function (data, object, row) {
                    return "<div class='epi-rowIcon'><span class='dijitInline dijitIcon epi-iconLink epi-objectIcon'></span></div>" + data;
                },
                // Init grid
                settings = {
                    selectionMode: "single",
                    selectionEvents: "click,dgrid-cellfocusin",
                    formatters: [formatters.contentItemFactory("text", "title", "typeIdentifier", menu), linkAssembler],
                    dndParams: {
                        copyOnly: true,
                        accept: this.get("allowedDndTypes"),
                        creator: lang.hitch(this, this._dndNodeCreator)
                    },
                    dndSourceTypes: this.customTypeIdentifier ? [this.customTypeIdentifier] : [],
                    consumer: this
                },

                getDndType = function(object) {
                    var types = TypeDescriptorManager.getAndConcatenateValues(this.dndSourceTypes, "dndTypes");

                    if (types.length === 0) {
                        types = this.dndSourceTypes;
                    }
                    return types;
                };

            if (this.customTypeIdentifier) {
                settings._getDndType = getDndType;
            }

            this.own(this.grid = new this._gridClass(settings, this.itemsContainer));
            this.grid.set("showHeader", false);
            this.grid.renderArray(this.model.get("data"));
            this.grid.startup();
        },

        setupEvents: function () {
            // summary:
            //      Initialization events on list.
            // tags:
            //      protected

            var self = this,
                selector = on.selector;

            this.own(
                // Automatic re-focus when selectedItem is changed.
                self.model.on("selectedItem", lang.hitch(this, this.focus)),
                // Sometime model initialization slower than, so we should listen on "initCompleted" then re-render grid ui
                self.model.on("initCompleted", lang.hitch(this, this._renderUI)),
                // When mouse is over a row, show the context menu node
                self.grid.on(selector(".dgrid-row", events.mouse.enter), function (e) {
                    domClass.add(self, self._mouseOverClass);
                }),
                // When mouse is out of an unselected row, hide the context menu node
                self.grid.on(selector(".dgrid-row", events.mouse.leave), function (e) {
                    domClass.remove(self, self._mouseOverClass);
                }),
                // Handle row click/selection event
                self.grid.on("dgrid-select", function(e) {
                    self.model.set("selectedItem", e.rows[0].data);
                    self.commandProvider.set("model", self.model);
                }),

                // Listen keyboard event to delete grid's row item
                self.grid.on(selector(".dgrid-row", events.keys.del), function (e) {
                    self.model.remove();
                }),

                // Listen keyboard event to open context menu
                self.grid.on(selector(".dgrid-row", events.keys.shiftf10), function (e) {
                    self._showContextMenu(e);
                }),
                self.grid.on(selector(".dgrid-row", events.contextmenu), function (e) {
                    var item = self.grid.row(e).data;
                    self.model.set("selectedItem", item);
                    self.select(item);
                    self._showContextMenu(e);
                }),
                // Open context menu when click on the context menu icon in row
                self.grid.on(".epi-iconContextMenu:click", function(e) {
                    self.contextMenu.scheduleOpen(self, null, { x: e.pageX, y: e.pageY });
                }),
                // Self handler checkAcceptance on grid
                aspect.around(self.grid.dndSource, "checkAcceptance", function(defaultCheckAcceptance) {
                    return function(source, nodes) {
                        return !self.readOnly && defaultCheckAcceptance.apply(self.grid.dndSource, arguments);
                    };
                }),

                aspect.after(self.grid.dndSource, "onDropData", function (dndData, source, nodes, copy) {

                    var i;

                    // internal move
                    if (self.grid.dndSource === source) {
                        for (i = 0; i < nodes.length; i++) {
                            self.model.moveTo(
                                self.grid.dndSource.getItem(nodes[i].id).data,
                                self.grid.dndSource.current != null ? self.grid.dndSource.getItem(self.grid.dndSource.current.id).data : null,
                                self.grid.dndSource.before);
                        }
                        // external drop
                    } else {
                        var item;
                        for (i = 0; i < dndData.length; i++) {

                            //Need to resolve the data since it might be a deferred.
                            when(dndData[i].data, lang.hitch(this, function (resolvedItem) {
                                self.model.addTo(
                                resolvedItem,
                                    self.grid.dndSource.current != null ?
                                        this.grid.dndSource.getItem(self.grid.dndSource.current.id).data :
                                    null,
                                    self.grid.dndSource.before);

                                if (source && source.grid && source.grid.consumer && source.grid.consumer !== self) {
                                    source.grid.consumer.model.set("selectedItem", resolvedItem);
                                    source.grid.consumer.model.remove();
                                }
                            }));
                        }
                    }
                }, true),

                // Overide base method from grid to set selected item
                aspect.around(self.grid, "insertRow", lang.hitch(self, self._aroundInsertRow)),

                // Handle model value changed
                this.model.on("changed", lang.hitch(this, function () {
                    this.onChange(this.value = this.model.get("value") || []);
                    this._renderUI();
                    this.focus();
                })),

                // Listen to the grid at onDndStart method to override state
                aspect.after(this.grid.dndSource, "onDndStart", lang.hitch(this, function (source, nodes, copy) {
                    var dndSource = this.grid.dndSource,
                        accepted = dndSource.accept && dndSource.checkAcceptance(source, nodes);

                    domClass[accepted ? "remove" : "add"](this.container, "dojoDndTargetDisabled");
                }), true),

                // Listen dnd event on drop zone
                aspect.after(this._dndTarget, "onDropData", lang.hitch(this, function (dndData, source, nodes, copy) {
                    var item;
                    for (var i = 0; i < dndData.length; i++) {
                        //Need to resolve the data since it might be a deferred.
                        when(dndData[i].data, lang.hitch(this, function (resolvedItem) {
                            this.model.addTo(resolvedItem, null, false);

                            if (source && source.grid && source.grid.consumer && source.grid.consumer !== this) {
                                source.grid.consumer.model.set("selectedItem", resolvedItem);
                                source.grid.consumer.model.remove();
                            }
                        }));
                    }
                }), true)
            );

            // Listen on command to change state
            var commands = this.commandProvider.commands.concat(this._newItemCommand);
            commands.forEach(function (command) {
                this.own(
                    aspect.after(command, "onDialogOpen", function () {
                        self.set("isShowingChildDialog", true);
                        self.validate();
                    }),
                    aspect.after(command, "onDialogHideComplete", function () {
                        self.set("isShowingChildDialog", false);
                        self.focus();
                    })
                );
            }, this);
        },

        executeAction: function (actionName) {
            // summary:
            //      Overidden mixin class, listen acion clicked on textWithLinks widget
            // actionName: [String]
            //      Action name of link on content area
            // tags:
            //      public

            if (actionName === "createnewitem") {
                // Execute create new link command here
                if (this._newItemCommand) {
                    this._newItemCommand.execute();
                }
            }
        },

        setupAllowedTypes: function() {
            // summary:
            //      Setup the allowed types for drag and drop
            // tags:
            //      Public

            var converterKey = this.itemConverterKey;

            this.allowedDndTypes = this.allowedDndTypes || [];

            if (converterKey) {
                this.allowedDndTypes = this.allowedDndTypes.map(function (type) {
                    return type + "." + converterKey;
                });
            }

            if (this.customTypeIdentifier) {
                this.allowedDndTypes.unshift(this.customTypeIdentifier);
            }
        },

        focus: function () {
            // summary:
            //      Focus the container if there is a value and
            //      focus the grid if we already have a model and set selected item,
            //      else focus the textWithLinks widget.
            // tags:
            //    public

            if (this.value && this.value.length > 0) {
                this._focusManager.focus(this.container);

                if (this.model) {
                    var selectedItem = this.model.get("selectedItem"),
                        selectedItemIndex = this.model.getItemIndex(selectedItem);
                    if (selectedItem) {
                        this.grid && this.grid.focus(this.grid.row(selectedItemIndex).element);
                    }
                }
            } else {
                this.textWithLinks.focus();
            }
        },

        select: function (item) {
            // summary:
            //      Set selected item on dgrid
            // item: Object
            //      The selected object
            // tags:
            //      protected

            this.grid.clearSelection();
            if (item) {
                this.grid.select(this.model.getItemIndex(item));
            }
        },

        isValid: function () {
            // summary:
            //    Check if widget's value is valid.
            // isFocused:
            //    Indicate that the widget is being focused.
            // tags:
            //    protected

            return (!this.required || (this.model && this.model.get("value").length > 0));
        },

        _onBlur: function() {
            // summary:
            //      Override base (_HasChildDialogMixin) to check that the context menu is showing or not.
            // tags:
            //      protected override

            if (this.contextMenu && this.contextMenu.isShowingNow) {
                return;
            }
            this.inherited(arguments);
        },

        _setValueAttr: function (/*Object*/val) {
            // summary:
            //      The set value method
            // tags:
            //      public override

            this._set("value", val);
            // Reset value to an empty array
            if (!val || !(val instanceof Array)) {
                this._set("value", []);
            }

            if (this._started) {
                this.model ? this.model.set("data", this.value) : (this.model = new ItemCollectionViewModel(this.value, { readOnly: this.readOnly }));
                this._renderUI();
            }
        },

        _setReadOnlyAttr: function (/*Boolean*/readOnly) {
            // summary:
            //      Overwrite readonly property
            // tags:
            //      Protected

            this._set("readOnly", readOnly);

            // Hide actions container area if is readOnly
            this._displayActionsContainer();

            if (this.model) {
                this.model.set("readOnly", readOnly);
            }
        },

        _dndNodeCreator: function (/*Object*/item, /*Object*/hint) {
            // summary:
            //      Custom DnD avatar creator method
            //  tags:
            //      Protected

            var dndTypes = this.allowedDndTypes,
                node = domConstruct.create("div").appendChild(document.createTextNode(item.text));

            if (item.typeIdentifier) {
                dndTypes = TypeDescriptorManager.getAndConcatenateValues(item.typeIdentifier, "dndTypes");
            }

            return {
                "node": node,
                "type": dndTypes,
                "data": item
            };
        },

        _aroundInsertRow: function (/*Object*/original) {
            // summary:
            //      Called 'around' the insertRow method to fix the grids less than perfect selection.
            // tags:
            //      private

            return lang.hitch(this, function (object, parent, beforeNode, i, options) {

                // Call original method
                var row = original.apply(this.grid, arguments);

                var currentItem = this.model.get("selectedItem");
                if (currentItem && currentItem.id === object.id) {
                    this.select(currentItem);
                }

                return row;
            });
        },

        _renderUI: function () {
            // summary:
            //      The common method to update grid ui and set selected item.
            // tags:
            //      private

            this.grid.refresh();
            this.grid.renderArray(this.model.get("data"));
        },

        _showContextMenu: function (e) {
            // summary:
            //      Show context menu when keydown (shift+F10 or contextMenu key on windows)
            // e: Object
            //      Keyboard event
            // tags:
            //      private

            var selectedItem = this.model.get("selectedItem"),
                selectedItemIndex = this.model.getItemIndex(selectedItem);
            if (selectedItem) {
                event.stop(e);
                this.contextMenu.scheduleOpen(this, null, domGeometry.position(query(".epi-iconContextMenu", this.grid.row(selectedItemIndex).element)[0], true));
            }
        },

        _displayActionsContainer: function () {
            // summary:
            //      Show/not actions container area
            // tags:
            //      private

            // Hide actions when readonly or set not visible
            domStyle.set(this.actionsContainer, "display", this.readOnly || !this.actionsVisible ? "none" : "");
        }
    });
});
},
'epi-cms/extension/events':function(){
﻿define([
// Dojo
    "dojo/_base/lang",
    "dojo/keys",                                            // used to detect keyboard event
    "dojo/mouse",                                           // used to detect mouse event
    "dojo/on"                                               // used to query dom by query string inside this.domNode

], function (
// Dojo
    lang,
    keys,
    mouse,
    on

) {
    // =======================================================================
    // Helper method
    //
    function isDeleteKey(e) { return e.keyCode === keys.DELETE; }
    function isShiftKey(e) { return e.shiftKey; }
    function isF10(e) { return e.keyCode == keys.F10; }
    function isShiftF10(e) { return isShiftKey(e) && isF10(e); }
    function isMouseEvent(e) {
        return mouse.isLeft(e) || mouse.isMiddle(e) || mouse.isRight(e);
    }

    // =======================================================================
    // Common function to create a customize event
    //
    function eventHandler(type, selectHandler) {
        var handler = function (node, listener) {
            return on(node, type, function (evt) {
                if (selectHandler) {
                    return selectHandler(evt, listener);
                }
                return listener.call(this, evt);
            });
        };

        return handler;
    }

    // summary:
    //      An static class that add default events (keyboard/mouse) for common uses.
    // module:
    //      "epi-cms/extension/events"
    // tags:
    //      public

    var events = {

        // Support this for more convenient
        selector: on.selector,

        // =======================================================================
        // Both keyboard and mouse events
        //

        contextmenu: eventHandler("contextmenu", function (e, listener) {
            // summary:
            //      Shortcut way to listen context menu event
            // tags:
            //      public event

            listener.call(this, e);
        }),

        // =======================================================================
        // Keyboard events
        //

        keys: {
            shiftf10: eventHandler("keydown", function (e, listener) {
                // summary:
                //      Shortcut way to listen shift-f10 keydown event
                // tags:
                //      public event

                if (isShiftF10(e)) {
                    listener.call(this, e);
                }
            }),

            del: eventHandler("keydown", function (e, listener) {
                // summary:
                //      Shortcut way to listen delete keydown event
                // tags:
                //      public event

                if (isDeleteKey(e)) {
                    listener.call(this, e);
                }
            }),

            contextmenu: eventHandler("contextmenu", function (e, listener) {
                // summary:
                //      Shortcut way to listen context menu keydown event
                // tags:
                //      public event

                if (isMouseEvent(e)) { return; }
                listener.call(this, e);
            })
        },

        // =======================================================================
        // Mouse events
        //

        mouse: lang.mixin({
            contextmenu: eventHandler("contextmenu", function (e, listener) {
                // summary:
                //      Shortcut way to listen context menu event by right click
                // tags:
                //      public event

                if (isMouseEvent(e)) { listener.call(this, e); }
            })
        }, mouse)
    };
    return events;
});

},
'epi-cms/contentediting/command/NewItem':function(){
﻿define([
// Dojo
    "dojo/_base/declare",

// EPi Framework
    "epi/shell/command/_Command",                                                   // mixed into me

// EPi CMS
    "epi-cms/contentediting/command/_CommandWithDialogMixin",                       // mixed into me
    "epi-cms/widget/LinkEditor"
], function (
// Dojo
    declare,

// EPi Framework
    _Command,

// EPi CMS
    _CommandWithDialogMixin,
    LinkEditor
) {

    return declare([_Command, _CommandWithDialogMixin], {

        // dialogContentClass: [public] Class
        //      The widget class that will be created and placed as dialog's content
        dialogContentClass: LinkEditor,

        // dialogContentParams: [public] Object
        //      The parameters for create new instance of dialogContentClass.
        dialogContentParams: null,

        // defaultActionsVisible: [public] Bool
        //      .Flag which indicates whether the default confirm and cancel
        //		actions should be visible. This can only be set in the constructor.
        defaultActionsVisible: false,

        _execute: function () {
            // summary:
            //      Overwrite base clase, change the context to edit the block.
            // tags:
            //      protected
            this.set("value", null); // Create new item dialog without value

            this.showDialog();
        },

        _onModelChange: function () {
            // summary:
            //      Overwrite base class, updates canExecute after the model has changed.
            // tags:
            //      protected

            if (!this.model) {
                this.set("canExecute", false);
                return;
            }

            this.set("canExecute", true);
        },

        onDialogExecute: function () {
            // summary:
            //      Process value returned from dialog after it's executed.

            this.inherited(arguments);

            if (this.dialogContent) {
                this.value = this.dialogContent.get("value");
            }

            if (this.model) {
                this.model.addTo(this.value, null, null);
            }
        }
    });
});
},
'epi-cms/contentediting/command/_CommandWithDialogMixin':function(){
﻿define([
// Dojo
    "dojo/_base/array",                                                         // used to loop through array
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",                                                              // used to listen event from Dialog
    "dojo/when",

// Dijit
    "dijit/Destroyable",                                                        // mixed into me

// EPi Framework
    "epi/shell/widget/dialog/Dialog",                                           // used to create dialog

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.editlink",                        // used to get default title (common)
    "epi/i18n!epi/nls/episerver.shared"
], function (
// Dojo
    array,
    declare,
    lang,
    aspect,
    when,

// Dijit
    Destroyable,

// EPi Framework
    Dialog,

// Resources
    resouce,
    sharedResources
) {
    return declare([Destroyable], {
        // summary:
        //      The base class for all edit commands wanna use dialog as an editor.
        //      <see cref = "epi-cms/contentediting/command/ItemEdit.js" />
        // module:
        //      "epi-cms/contentediting/command/_CommandWithDialogMixin"
        // description:
        //      That supports:
        //          - Create a dialog
        //          - Interface to update value
        // tags:
        //    public

        // res: [public] Object
        //      Json language resouce object used to get default title when insert/edit item.
        res: resouce,

        // title: [public] String
        //      The dialog's title.
        title: null,

        // destroyOnHide: [public] flag
        //      Destroy dialog on hide or not.
        destroyOnHide: true,

        // dialogClass: [public] String
        //      The css class for dialog.
        //      Default value is "epi-dialog-portrait".
        dialogClass: "epi-dialog-portrait",

        // dialogContentClass: [public] Class
        //      The widget class that will be created and placed as dialog's content
        dialogContentClass: null,

        // dialogParams: [public] Object
        //      The parameters for create new instance of dialog.
        dialogParams: null,

        // dialogContentParams: [public] Object
        //      The parameters for create new instance of dialogContentClass.
        dialogContentParams: null,

        // dialogContent: [public] Object
        //      The instance of dialogContentClass will be stored by this prop.
        dialogContent: null,

        // defaultActionsVisible: [public] Bool
        //      .Flag which indicates whether the default confirm and cancel
        //		actions should be visible. This can only be set in the constructor.
        defaultActionsVisible: true,

        // confirmActionText: [public] String
        //      Label to be displayed for the confirm (positive) action.
        confirmActionText: sharedResources.action.ok,

        // cancelActionText: [public] String
        //      Label to be displayed for the cancel (negative) action.
        cancelActionText: sharedResources.action.cancel,

        // value: [public] Object
        //      The value of item that being edited.
        value: null,

        // value: [protected] Object
        //      The dialog.
        _dialog: null,

        _getTitle: function() {
            // summary:
            //      Customize base get method for title prop.
            // tags:
            //      protected override

            return this.title || lang.replace(this.value ? this.res.title.template.edit : this.res.title.template.create, this.res.title.action);
        },

        onDialogOpen: function () {
            // summary:
            //      Trigerred when dialog is opened.
            // tags:
            //      public virtual
        },

        onDialogExecute: function () {
            // summary:
            //      Process value returned from dialog after it's executed.
            //      It should be implemented from delivery
            // tags:
            //      public virtual
        },

        onDialogCancel: function () {
            // summary:
            //      Process value when dialog after it's hidden.
            //      It should be implemented from delivery
            // tags:
            //      public virtual
        },

        onDialogHideComplete: function() {
            // summary:
            //      Trigerred when dialog is closed.
            // tags:
            //      public virtual
        },

        showDialog: function () {
            // summary:
            //      Create and show dialog
            // tags:
            //    protected

            if(this.dialogContent) {
                this.dialogContent.destroy();
                this.dialogContent = null;
            }
            this.dialogContent = new this.dialogContentClass(this.dialogContentParams);

            this._dialog = new Dialog(lang.mixin({
                title: this._getTitle(),
                dialogClass: this.dialogClass,
                content: this.dialogContent,
                destroyOnHide: this.destroyOnHide,
                defaultActionsVisible: this.defaultActionsVisible,
                confirmActionText: this.confirmActionText,
                cancelActionText: this.cancelActionText
            }, this.dialogParams));

            this._dialog.startup();

            //Set the value when the provider/consumer has been initialized
            this.dialogContent.set("value", this.value);

            this.own(
                this.dialogContent,
                aspect.after(this._dialog, "onExecute", lang.hitch(this, this.onDialogExecute), true),
                aspect.after(this._dialog, "onCancel", lang.hitch(this, this.onDialogCancel), true),
                aspect.after(this._dialog, "onHide", lang.hitch(this, this.onDialogHideComplete), true),
                this._dialog.watch("open", lang.hitch(this, function (name, oldValue, newValue) {
                    if (!newValue) { return; }
                    this.onDialogOpen();
                }))
            );

            this._dialog.show();
        }
    });
});

},
'epi-cms/widget/LinkEditor':function(){
﻿define([
//dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class",
//dijit
    "dijit/_CssStateMixin",
//epi
    "epi",
    "epi/dependency",
    "epi/shell/widget/dialog/_DialogContentMixin",
    "epi/shell/widget/FormContainer",
    "epi/shell/widget/_ActionProviderWidget",
    "epi/shell/widget/_ModelBindingMixin",
// EPi CMS
    "epi-cms/widget/viewmodel/LinkEditorViewModel"
],
function (
//dojo
    array,
    declare,
    lang,
    domStyle,
    domClass,
//dijit
    _CssStateMixin,
//epi
    epi,
    dependency,
    _DialogContentMixin,
    FormContainer,
    _ActionProviderWidget,
    _ModelBindingMixin,
// EPi CMS
    LinkEditorViewModel
) {
    return declare([FormContainer, _ActionProviderWidget, _DialogContentMixin, _CssStateMixin, _ModelBindingMixin], {
        // module:
        //		epi-cms/widget/LinkEditor
        // summary:
        //    The dialog to insert or edit a link item.
        // tags:
        //    public

        _metadataManager: null,

        // modelClassName: [public] Class
        //      Represents the model class name that will be used for this widget.
        modelClassName: LinkEditorViewModel,

        // hiddenFields: Array
        //      The list of fields will be hidden from editing.
        hiddenFields: [],

        postMixInProperties: function () {
            // summary:
            //		Initialize properties
            // tags:
            //    protected
            this.inherited(arguments);

            this.doLayout = false;

            this._metadataManager = this._metadataManager || dependency.resolve("epi.shell.MetadataManager");

            if (!this.model && this.modelClassName) {
                var modelClass = declare(this.modelClassName);
                this.model = new modelClass();
            }

            this._actions = [
                {
                    name: "ok",
                    label: epi.resources.action.ok,
                    settings: { type: "button", "class": "Salt" },
                    action: lang.hitch(this, function () {
                        if (this.validate()) {
                            this.executeDialog({ action: "ok" });
                        }
                    })
                },
                {
                    name: "delete",
                    label: epi.resources.action.deletelabel,
                    settings: { type: "button", disabled: true }, // Default disable Delete button until the value is valid
                    action: lang.hitch(this, function () {
                        // if we return the null object, FormContainer will ignore of setting its value.
                        // So we need to return the object with empty properties, in order to clear data.
                        array.forEach(this.form._getDescendantFormWidgets(), function (widget) {
                            widget.set("value", "");
                        }, this);
                        this.executeDialog({ action: "delete" });
                    })
                },
                {
                    name: "cancel",
                    label: epi.resources.action.cancel,
                    settings: { type: "button" },
                    action: lang.hitch(this, function () {
                        this.cancelDialog();
                    })
                }
            ];
        },

        postCreate: function () {
            if (this.modelType) {
                this.metadata = this._metadataManager.getMetadataForType(this.modelType);
            }

            this.inherited(arguments);
        },

        _setValueAttr: function (value) {
            // summary:
            //    Set selected href.
            // tags:
            //    private
            this.inherited(arguments);
            this._handleActions(value);
        },

        onFormCreated: function (widget) {
            array.forEach(this.form._getDescendantFormWidgets(), function (widget) {
                if (this.hiddenFields && this.hiddenFields.indexOf(widget.name) > -1) {
                    var parent = this._getAncestorNode(widget.domNode, "epi-formsRow");
                    domStyle.set(parent, { display: "none" });
                    widget.set("required", false); // disable required validation for hidden field
                }
            }, this);

            // Set state of delete button when form created
            this._handleActions(this.value);
        },

        _handleActions: function (value) {
            if (this.hasAction("delete")) {
                this.setActionProperty("delete", "disabled", this.model._isEmptyObject(value));
            }
        },



        getFormWidget: function (widgetName) {
            // Summary
            //      Gets form widget by name.
            // widgetName: String
            //      Name of the form widget to get.
            // tag
            //      Public

            var widgets = array.filter(this.form._getDescendantFormWidgets(), function (widget) {
                return widget && widget.name === widgetName;
            }, this);

            return widgets ? widgets[0] : null;
        },

        _getAncestorNode: function (node, classAttr) {
            // Summary
            //      Get ancestor node which has class classAttr
            // node: DomNode
            //      The domNode which need to get ancestor.
            // classAttr: String
            //      The class attribute.
            // tag
            //      Private

            var parentNode = node ? node.parentNode : null;
            if (!parentNode) {
                return null;
            }

            if (!domClass.contains(parentNode, classAttr)) {
                return this._getAncestorNode(parentNode, classAttr);
            }

            return parentNode;
        },

        getActions: function () {
            // summary:
            //      Overridden from _ActionProvider to get the select current content action added to the containing widget
            //
            // returns:
            //      An array containing a select page action definition, if it is not a shared block
            return this._actions;
        },


        isValidValue: function () {
            // Summary
            //      Indicator that value of widgets which set required are valid
            // tag
            //      Public
            return array.every(this.form._getDescendantFormWidgets(), function (widget) {
                return widget.get("required") ? !!widget.get("value") : true;
            });
        }
    });
});
},
'epi-cms/widget/viewmodel/LinkEditorViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/io-query",
    "dojo/topic",
    "dojo/Stateful",
    "dojo/when",

// EPi Framework
    "epi/shell/_StatefulGetterSetterMixin",
    "epi/dependency"
],

function (
// Dojo
    array,
    declare,
    Deferred,
    lang,
    ioQuery,
    topic,
    Stateful,
    when,

// EPi Framework
    _StatefulGetterSetterMixin,
    dependency
    ) {
    return declare([Stateful, _StatefulGetterSetterMixin], {
        // module:
        //		epi-cms/widget/viewmodel/LinkEditorViewModel
        // summary:
        //    Represents the view model for LinkEditor
        // tags:
        //    public

        _isEmptyObject: function (obj) {
            // Summary
            //      Check empty object
            // obj: object
            //      The object which need to check for empty.
            // tag
            //      Private

            for (var i in obj) {
                if (obj[i] && obj[i] !== "") {
                    return false;
                }
            }
            return true;
        }
    });
});


},
'epi-cms/contentediting/viewmodel/ItemCollectionViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/array",                                                                 // utility
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/when",

// EPi Framework
    "epi/dependency",                                                                   // used to get some dependent widget
    "epi/string",                                                                       // used to convert namespace from "." to "/"

// EPi CMS
    "epi-cms/contentediting/viewmodel/LinkItemModel",                                   // item's model
    "epi-cms/contentediting/viewmodel/_ViewModelMixin"                                  // mixed into me

], function (
// Dojo
    array,
    declare,
    lang,
    Deferred,
    all,
    when,

// EPi Framework
    dependency,
    epiString,

// EPi CMS
    //LinkItemModel,
    _ViewModelMixin

) {
    return declare([_ViewModelMixin], {
        // summary:
        //      The link collection editor view model.
        // module:
        //      "epi-cms/contentediting/viewmodel/ItemCollectionViewModel"
        // description:
        //      That supports: Move next/previous/remove logic
        // tags:
        //    public

        // _instanceId: [private] String
        //      The identity for each instance.
        _instanceId: null,

        // _autoId: [private] Number
        //      The item's index
        _autoId: 0,

        // _selectedItem: [private] Object
        //      The current selected item.
        _selectedItem: null,

        // _data: [private] Array
        //      Array of <itemModelClass> that represent for the editor value
        _data: null,

        // itemModelClass: [public] Class
        //      The item's class got from itemModelType.
        itemModelClass: null,

        // itemModelType: [public] String
        //      The item model's class name can be injected from inheritance or caller.
        itemModelType: null,

        constructor: function (/*Object[]*/data, /*Object*/options) {
            // summary:
            //      Create new instance of ItemCollectionViewModel
            //      Parse original data to <itemModelClass>
            // data: Array
            //      The value of link collection property
            // options: Object
            //      Parameters to inject some argument from caller.
            //      For instance: itemModelClass

            declare.safeMixin(this, options);
        },

        postscript: function (data) {
            
            var modelType = epiString.slashName(this.itemModelType);
            
            require([modelType], lang.hitch(this, function (modelClass) {
                this.itemModelClass = modelClass;
                this._instanceId = new Date().getTime();
                this._init(data);
            }));
        },

        moveNext: function () {
            // summary:
            //      The method used in "MoveToNext" command
            // tags:
            //      public

            this._move(1) && this.emit("changed");
        },

        movePrevious: function () {
            // summary:
            //      The method used in "MoveToPrevious" command
            // tags:
            //      public

            this._move(-1) && this.emit("changed");
        },

        remove: function () {
            // summary:
            //      The method used in "BlockRemove" command
            // tags:
            //      public

            if (!this.get("canEdit")) {
                return;
            }

            var index = this.getItemIndex(this._selectedItem);
            this._data.splice(index, 1);

            var len = this._data.length;
            this.set("selectedItem", this._data[index >= len ? len - 1 : index] || null);

            this.emit("changed");
        },

        addTo: function (/*Object*/newItem, /*Object*/item, /*Boolean*/before) {
            // summary:
            //      The method used when drag and drop item into LinkCollectionEdtior
            // tags:
            //      public

            if (!newItem) { return false; }

            if (this.getItemIndex(newItem) >= 0) {
                this.moveTo(newItem, null, false);
                this.emit("changed");
            } else {
                var self = this;
                when(self._createItemModel(newItem), function (model) {
                    if (!item) {
                        self._data.push(model);
                    } else {
                        // insert newItem to selected index rely on item's index
                        var targetIndex = self.getItemIndex(item) + (before ? 0 : 1);
                        self._data.splice(targetIndex, 0, model);
                    }

                    self.emit("changed", { uiChanged: false });
                });
            }
        },

        moveTo: function (/*Object*/selectedItem, /*Object*/item, /*Boolean*/before) {
            // summary:
            //      The method used when drag and drop selected item to reorder
            // tags:
            //      public

            if (!selectedItem && !this._selectedItem) { return false; }

            // set new selected item if drag another
            this.set("selectedItem", selectedItem || this._selectedItem);

            var sourceIndex = this.getItemIndex(this._selectedItem);
            // remove selected item first
            this._data.splice(sourceIndex, 1);

            // insert selectedItem to new index, if new index not exist then set to last index
            var targetIndex = (item ? this.getItemIndex(item) : (this._data.length - 1)) + (before ? 0 : 1);
            this._data.splice(targetIndex, 0, this._selectedItem);

            this.emit("changed");
        },

        updateItemData: function (/*Object*/ item) {
            // summary:
            //      Provides a consistant way to update the model.
            // value: Object
            //      The new data of selected item
            // tags:
            //      private

            var index = this.getItemIndex(this._selectedItem);
            if (index < 0) { return; }

            var self = this;
            when(self._createItemModel(item), function (model) {
                self._selectedItem = self._data[index] = model;
                self.emit("changed");
            });
        },

        swap: function (/*Object*/sourceIndex, /*Object*/targetIndex) {
            // summary:
            //      Swap 2 items by index
            // sourceIndex: Number
            //      Position (index) of 1st item
            // targetIndex: Number
            //      Position (index) of 2nd item
            // tags:
            //      private
            
            if (!this._data[sourceIndex] || !this._data[targetIndex]) { return false; }

            var temp = this._data[sourceIndex];
            this._data[sourceIndex] = this._data[targetIndex];
            this._data[targetIndex] = temp;

            return true;
        },

        getItemIndex: function (/*Object*/item) {
            // summary:
            //      Get item index in the data array
            // item: Object
            //      The item data

            var index = -1;
            if (!item || !(item instanceof this.itemModelClass) ) { return index; }

            this._data.some(function (i, o) {
                if (i.id === item.id) {
                    index = o;
                    return true;
                }

                return false;
            }, this);

            return index;
        },

        _init: function (data) {
            // summary:
            //      Initialize the mode
            // data: Array
            //      The native array data

            var self = this,
                itemDfds;

            this.set("selectedItem", null);

            if (!(data instanceof Array)) {
                this._data = [];
            } else {
                itemDfds = data.map(function (item) {
                    return this._createItemModel(item);
                }, this);

                all(itemDfds).then(function (results) {
                    self._data = results;
                    self.emit("initCompleted");
                });
            }
        },

        _generateItemId: function () {
            // summary:
            //      Create new item identity.
            // tags:
            //      private

            return this._instanceId + "_" + this._autoId++;
        },

        _createItemModel: function (/*Object*/ item) {
            // summary:
            //      Create new link item model
            // item: Object
            //      The object's data to work with.
            // tags:
            //      private

            var modelClass = this.itemModelClass,
                id = { id: this._generateItemId() },
                model,
                dfd = new Deferred();
            
            // Return item directly if it is mine.
            if (this.getItemIndex(item) >= 0) {
                return item;
            }

            if (item instanceof modelClass) {
                model = lang.mixin(lang.clone(item), id);
            } else {
                model = new modelClass(lang.mixin(lang.clone(item), id));
            }

            when(model.parse(true), function () {
                dfd.resolve(model);
            });

            return dfd;
        },

        _move: function (/*Number*/direction) {
            // summary:
            //      The generic method used for "moveNext" or "movePrevious" methods.
            // direction: Number
            //      Can be "1" or "-1" represent for "next" or "previous" action
            // tags:
            //      private

            var index = this.getItemIndex(this._selectedItem);
            if (index < 0) { return false; }

            return this.swap(index, index + direction);
        },

        _canMoveNextGetter: function () {
            // summary:
            //      Override the get('canMoveNext') method that used in command

            var index = this.getItemIndex(this._selectedItem);
            return !!(this._selectedItem && index >= 0 && index < (this._data.length - 1));
        },

        _canMovePreviousGetter: function () {
            // summary:
            //      Override the get('canMovePrevious') method that used in command

            var index = this.getItemIndex(this._selectedItem);
            return !!(this._selectedItem && index > 0 && index <= (this._data.length - 1));
        },
        
        _canEditGetter: function () {
            // summary:
            //      The method used in "canEdit" link item command
            // tags:
            //      public

            return !this.readOnly && !!this._selectedItem;
        },

        _valueGetter: function() {
            // summary:
            //      Override base "get('value')" method to return array of serialized data.
            // tags:
            //      public override

            return this._data.map(function (item) {
                return item.serialize();
            }, this);
        },

        _dataGetter: function () {
            // summary:
            //      Override base "get('data')" method to return array of serialized data.
            // tags:
            //      public override

            return this._data || [];
        },

        _dataSetter: function (data) {
            // summary:
            //      Override base "set('data')" method to init data of this model.
            // tags:
            //      public override

            this._init(data);
        },

        _selectedItemGetter: function () {
            // summary:
            //      Override base "get('selectedItem')" method to return selected item.
            // tags:
            //      public override

            return this._selectedItem;
        },

        _selectedItemSetter: function (value) {
            // summary:
            //      Override base "set('selectedItem')" method to set selected item.
            // tags:
            //      public override

            this._selectedItem = value;
        }
    });
});
},
'epi-cms/contentediting/viewmodel/LinkItemModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",                                                                        // used to make a method become asynchronous
    "dojo/when",                                                                            // used to wait an asynchronous request

// EPi Framework
    "epi/Url",                                                                              // used to build a public url

// EPi CMS
    "epi-cms/contentediting/viewmodel/CollectionItemModel",                                 // mixed into me
    "epi-cms/core/PermanentLinkHelper"                                                      // used to get content by permanent link

], function (

// Dojo
    declare,
    lang,
    Deferred,
    when,

// EPi Framework
    Url,

// EPi CMS
    CollectionItemModel,
    PermanentLinkHelper

) {

    return declare([CollectionItemModel], {
        // summary:
        //      The link item view model.
        // module:
        //      "epi-cms/contentediting/viewmodel/LinkItemModel"
        // description:
        //      That supports: Customize link item's data
        // tags:
        //    public

        titleKey: "publicUrl",

        // publicUrl: [public] String
        //      The public url of this item
        publicUrl: null,

        // permanentUrl: [pubilc] String
        //      The permanent url of this item. That prop equal to href prop
        //      If the item parsed from an converted item, should update href prop by this.
        permanentUrl: null,

        // _defaultDataStoreName: [protected virtual] String
        //      Default data store name to get from registry, if store is null.
        _defaultDataStoreName: "epi.cms.content.light",

        serialize: function () {
            // summary:
            //      Serialize data to be accepted by server
            // tags:
            //      public override

            return {
                attributes: this.attributes,
                text: this.text,
                href: this.href || this.url,
                target: this.target || null,
                title: this.title || "",
                publicUrl : this.publicUrl,
                typeIdentifier: this.typeIdentifier || ""
            };
        },

        _buildPublicUrl: function(/*String*/url) {
            // summary:
            //      The common method used to build full url.
            // tags:
            //      private

            var returnUrl = new Url(url);
            if (!returnUrl.scheme) {
                returnUrl = new Url("", {
                    "scheme": window.location.protocol,
                    "authority": window.location.hostname,
                    "path": url
                });

            }
            return returnUrl.toString();
        },

        _publicUrlGetter: function () {
            // summary:
            //      Customize get method to return correct a public url.
            // tags:
            //      protected override

            return this._buildPublicUrl(this.publicUrl || this.url || this.href);
        },

        _permanentUrlSetter: function(/*String*/value) {
            // summary:
            //      Customize default set method for permanentUrl prop.
            // tags:
            //      protected override

            this.href = this.permanentUrl = value;
        },

        _onTryUpdateItemModel: function () {
            // summary:
            //      Callback method that called when we need updated item's model
            // data: [Object]
            //      The data returned from store
            // tags:
            //      protected override

            // Try get content from href (assumption that href is permanent link)
            if (!this.typeIdentifier) {
                return when(PermanentLinkHelper.getContent(this.href), lang.hitch(this, function (contents) {
                    if (contents && contents.length > 0) {
                        this._parseFromContent(contents[0]);
                    }
                }));
            }
        },

        _parseFromContent: function (content) {
            // summary:
            //      Parse a link item model from contentdata
            // content: [Object]
            //      An structure store content data model
            // tags:
            //      private

            if (content) {
                this.typeIdentifier = content.typeIdentifier;
                this.publicUrl = this._buildPublicUrl(content.publicUrl);
            }
        }
    });
});
},
'epi-cms/contentediting/viewmodel/CollectionItemModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",                                                                        // used to make a method become asynchronous
    "dojo/when",                                                                            // used to wait an asynchronous request

// EPi CMS
    "epi-cms/contentediting/viewmodel/_ViewModelMixin"                                      // mixed into me

], function (

// Dojo
    declare,
    lang,
    Deferred,
    when,

// EPi CMS
    _ViewModelMixin

) {

    return declare([_ViewModelMixin], {
        // summary:
        //      The item view model.
        // module:
        //      "epi-cms/contentediting/viewmodel/CollectionItemModel"
        // description:
        //      That is a base class for all collection item models.
        //      <see cref = "epi-cms/contentediting/viewmodel/LinkItemModel" />
        // tags:
        //    public

        // id: [public] Number
        //      The identifier of this.
        id: null,

        // nameKey: [public] String
        //      Property name for the text value.
        textKey: "text",
        
        // titleKey: [public] String
        //      Property name for the title value.
        titleKey: null,
        
        // iconTypeKey: [public] String
        //      Property name for the IconType value.
        iconTypeKey: "typeIdentifier",

        // typeIdentifier: [public] String
        //      The item's content type.
        typeIdentifier: null,
        
        serialize: function () {
            // summary:
            //      Serialize data to be accepted by server that should be implemented by deliver class
            // tags:
            //      public abstract
        },
        
        parse: function (/*Boolean*/ tryUpdateItem) {
            // summary:
            //      User can be dnd some kind of data, so we need an generic method to process allover.
            //      That should be implemented by deliver class
            // tryUpdateItem: [Boolean]
            //      The flag to indicate that should try update item or not.
            // tags:
            //      pubic virtual

            if (tryUpdateItem) {
                return this._onTryUpdateItemModel();
            }

            return null;
        },

        _onTryUpdateItemModel: function () {
            // summary:
            //      Callback method that called when we need updated item's model
            // tags:
            //      protected abstract
        },

        _getPropertyValue: function (/*String*/keyName, /*String*/propName) {
            // summary:
            //      The common method to get property value by key name.
            // tags:
            //      private

            // Avoid recursive loop.
            if (keyName === propName) {
                return this[keyName];
            }
            return this.get(keyName);
        },

        _nameGetter: function () {
            return this._getPropertyValue(this.textKey, "name");
        },

        _textGetter: function () {
            return this._getPropertyValue(this.textKey, "text");
        },

        _titleGetter: function () {
            return this._getPropertyValue(this.titleKey, "title") || this._getPropertyValue(this.textKey, "title");
        },

        _iconTypeIdentifierGetter: function () {
            return this._getPropertyValue(this.iconTypeKey, "iconTypeIdentifier");
        }
    });
});
},
'epi-cms/contentediting/command/ItemCollectionCommands':function(){
﻿define([
    "dojo/_base/declare",
    "./BlockRemove",
    "./ItemEdit",
    "./MoveToPrevious",
    "./MoveToNext",
    "./ContentAreaCommands"
], function (declare, Remove, Edit, MoveToPrevious, MoveToNext, ContentAreaCommands) {

    return declare([ContentAreaCommands], {
        // summary:
        //      The commands for context menu of editor, 
        //      and use as class for commandProviderClass
        // module:
        //      "epi-cms/contentediting/command/ItemCollectionCommands"
        // description:
        //      That include:
        //          - Edit command
        //          - Move previous command
        //          - Move next command
        //          - Remove command
        // tags:
        //      Public

        constructor: function (/*Object*/options) {
            // summary:
            //      Overwrite base class
            // tags:
            //      protected

            var commandOptions = options ? options.commandOptions : {};
            this.commands = [
                new Edit(commandOptions),
                new MoveToPrevious(commandOptions),
                new MoveToNext(commandOptions),
                new Remove(commandOptions)
            ];
        }
    });
});
},
'epi-cms/contentediting/command/ItemEdit':function(){
﻿define([
// Dojo
    "dojo/_base/declare",

// EPi CMS
    "epi-cms/contentediting/command/BlockEdit",                                     // mixed into me
    "epi-cms/contentediting/command/_CommandWithDialogMixin",                       // mixed into me
    "epi-cms/widget/LinkEditor"
], function (
// Dojo
    declare,

// EPi CMS
    BlockEdit,
    _CommandWithDialogMixin,
    LinkEditor
) {

    return declare([BlockEdit, _CommandWithDialogMixin], {

        // dialogContentClass: [public] Class
        //      The widget class that will be created and placed as dialog's content
        dialogContentClass: LinkEditor,

        // dialogContentParams: [public] Object
        //      The parameters for create new instance of dialogContentClass.
        dialogContentParams: null,

        // defaultActionsVisible: [public] Bool
        //      .Flag which indicates whether the default confirm and cancel
        //		actions should be visible. This can only be set in the constructor.
        defaultActionsVisible: false,

        _execute: function () {
            // summary:
            //      Overwrite base clase, change the context to edit the block.
            // tags:
            //      protected

            this.showDialog();
        },

        _onModelValueChange: function () {
            // summary:
            //      Overwrite base class, updates canExecute after the model value has changed.
            // tags:
            //      protected

            if (!this.model) {
                this.set("canExecute", false);
                return;
            }

            this.set("value", this.model.get("selectedItem"));
            this.set("canExecute", this.model.get("canEdit"));
        },

        onDialogExecute: function (/*Object*/actionParams) {
            // summary:
            //      Process value returned from dialog after it's executed.
            // action: [String]
            //      Which action corespondent with? ("ok" or "delete")
            //      See "epi-cms/widget/LinkEditor" module for more detail.
            // tags:
            //      protected override

            this.inherited(arguments);

            if (this.dialogContent) {
                this.value = this.dialogContent.get("value");
            }

            if (this.model) {
                if (actionParams && actionParams.action === "delete") {
                    this.model.remove();
                } else {
                    this.model.updateItemData(this.value);
                }
            }
        }
    });
});
},
'url:epi-cms/contentediting/editors/templates/ItemCollectionEditor.html':"﻿<div class=\"dijitInline\">\r\n    <!-- To reuse styling of content area we wrap into a div that include content area class -->\r\n    <div class=\"epi-content-area-editor\" data-dojo-attach-point=\"container\">\r\n        <div data-dojo-attach-point=\"itemsContainer\"></div>\r\n        <div data-dojo-attach-point=\"actionsContainer\" class=\"epi-content-area-actionscontainer\"></div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/editors/PreviewableDateTimeEditor':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/dom-construct",

    "epi/datetime",
    "epi/shell/widget/DateTimeSelectorDropDown",
    "epi-cms/contentediting/editors/_PreviewableEditor"

], function (
    declare,
    domConstruct,

    epiDate,
    DateTimeSelectorDropDown,
    _PreviewableEditor
) {
    return declare([_PreviewableEditor], {
        required: false,

        // controlParams: Array
        //      Properties to copy from this widget into the wrapped control
        controlParams: ["required"],

        buildRendering: function () {
            this.control = new DateTimeSelectorDropDown({ datePackage: null });
            this.inherited(arguments);
        },

        onChange: function (val) {
            this.set("labelValue", epiDate.toUserFriendlyHtml(val));
        }
    });
});
},
'epi-cms/contentediting/editors/_PreviewableEditor':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/event",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",

    "dijit",
    "dijit/_CssStateMixin",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/ValidationTextBox",

    "epi",

    "dojo/text!./templates/_PreviewableEditor.html",
    "dojox/html/entities"

], function (
    array,
    event,
    declare,
    lang,
    on,
    domClass,
    domConstruct,
    domStyle,

    dijit,
    _CssStateMixin,
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    ValidationTextBox,

    epi,

    template,
    entities
) {

    return declare([_Widget, _CssStateMixin, _TemplatedMixin, _WidgetsInTemplateMixin], {

        value: null,

        changeLabel: epi.resources.action.change,

        templateString: template,

        control: null,

        // controlParams: Array
        //      Properties to copy from this widget into the wrapped control
        controlParams: [],

        // state: [readonly] String
        //		Shows current state (ie, validation result) of input (""=Normal, Incomplete, or Error).
        state: "",

        _setLabelValueAttr: {
            node: "labelNode",
            type: "innerHTML"
        },

        _setIsEmptyAttr: function (isEmpty) {
            this._set("isEmpty", isEmpty);
            if (isEmpty) {
                domClass.add(this.domNode, "epi-state-empty");
            } else {
                domClass.remove(this.domNode, "epi-state-empty");
            }
        },

        _setValueAttr: function (value) {
            this._set("value", value);
            this.control.set("value", value);
            this.set("labelValue", typeof (value) == "string" ? entities.encode(value) : value);
            this.set("isEmpty", !value);
        },

        onChange: function (val) {

        },

        buildRendering: function () {
            this.inherited(arguments);

            // Create default TextBox for input Node
            if (!this.control) {
                this.control = new ValidationTextBox();
                this.own(this.control);
            }

            this.control.placeAt(this.domNode, "first");
        },

        postCreate: function () {
            this.inherited(arguments);

            this._setDisplay(false);

            // connect events
            this.connect(this.labelNode, "onclick", this._onChangeNodeClick);
            this.connect(this.changeNode, "onclick", this._onChangeNodeClick);
            this.connect(this.control, "onChange", this._onControlChange);
            this.connect(this.control, "onBlur", this._onControlBlur);

            // always copy state value from control
            this.own(this.control.watch("state", lang.hitch(this, function (name, old, value) {
                this.set("state", value);
            })));

            // validate first time
            this.control.validate();

            this.set("state", this.control.state);

            // propagate value from this to the textbox
            array.forEach(this.controlParams, function (property) {
                this.control.set(property, this.get(property));
            }, this);
        },

        onBlur: function () {
            this._setDisplay(false);
        },

        _setDisplay: function (showControl) {
            // Validation input data before hidden textbox
            if (!showControl && !this.validate()) {
                return;
            }

            this.showControl = showControl;
            domStyle.set(this.labelNode, "display", showControl ? "none" : "");
            domStyle.set(this.control.domNode, "display", showControl ? "" : "none");

            if (!this.readOnly) {
                domStyle.set(this.changeNode, "display", showControl ? "none" : "");
            }
        },

        focus: function () {
            if (this.showControl) {
                this.control.focus();
            } else {
                this.changeNode.focus();
            }
        },

        _onControlChange: function (value) {
            this._set("value", value);
            this.set("labelValue", typeof (value) == "string" ? entities.encode(value) : value);
            this.set("isEmpty", !value);
            this.onChange(value);
        },

        _onControlBlur: function () {
            this._setDisplay(false);
        },

        _onChangeNodeClick: function (e) {
            event.stop(e);
            this._setDisplay(true && !this.readOnly);
            dijit.selectInputText(this.control.focusNode);
        },

        _setReadOnlyAttr: function (readOnly) {
            this._set("readOnly", readOnly);

            domStyle.set(this.changeNode, "display", this.readOnly ? "none" : "");
            this.readOnly && this._setDisplay(false);
        },

        validate: function () {
            return this.control.validate();
        },

        isValid: function () {
            return this.control.isValid();
        },

        getErrorMessage: function () {
            // summary
            //      Get error message from the control
            //  tags
            //      Public

            return this.control.getErrorMessage();
        }
    });
});
},
'url:epi-cms/contentediting/editors/templates/_PreviewableEditor.html':"﻿<div class=\"dijitReset dijitInline epi-previewableTextBox-wrapper\">\r\n    <span data-dojo-attach-point=\"labelNode\" class=\"epi-previewableTextBox-text dojoxEllipsis dijitInline\"></span>\r\n    <a href=\"#\" data-dojo-attach-point=\"changeNode, focusNode\" class=\"epi-functionLink\">${changeLabel}</a>\r\n</div>\r\n",
'epi-cms/contentediting/editors/PreviewableTextEditor':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/dom-construct",

    "dijit/form/ValidationTextBox",
    "epi-cms/contentediting/editors/_PreviewableEditor"
], function (
    array,
    declare,
    domConstruct,

    ValidationTextBox,
    _PreviewableEditor
) {
    return declare([_PreviewableEditor], {

        required: false,

        intermediateChanges: false,
        
        // controlParams: Array
        //      Properties to copy from this widget into the wrapped control
        controlParams: ["intermediateChanges", "regExp", "required", "invalidMessage"],

        _getRegExpAttr: function () {
            return this.regExp || "";
        }
    });
});
},
'epi-cms/contentediting/editors/SelectionEditor':function(){
﻿define([

// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/on",

// Dijit
    "dijit/form/Select",
    "dijit/MenuItem",
    "dijit/MenuSeparator",

// EPi
    "epi/shell/layout/_LayoutWidget",
    "epi/shell/widget/_ValueRequiredMixin"
],
function (

// Dojo
    array,
    declare,
    lang,
    domClass,
    on,

// Dijit
    Select,
    MenuItem,
    MenuSeparator,

// EPi
    _LayoutWidget,
    _ValueRequiredMixin
) {

    return declare([_LayoutWidget, Select, _ValueRequiredMixin], {

        actualValue: null,

        value: null,

        // To limit height to available space in viewport
        maxHeight: -1,

        postMixInProperties: function () {
            // summary:
            //		Set options based on the selections passed through.

            this.inherited(arguments);

            this.set("selections", this.selections);

            this.actualValue = this.value;
        },

        _setSelectionsAttr: function (newSelections) {

            this.set("options", array.map(newSelections, function (item) {
                return {
                    label: item.text,
                    value: item.value,
                    selected: (item.value == this.value) || (!item.value && !this.value)
                };
            }, this));
        },

        postCreate: function () {
            this.inherited(arguments);

            on(this, "change", lang.hitch(this, function () {
                if (!this.disabled) {
                    this.validate();
                }
                this.onLayoutChanged();
            }));
        },

        _getMenuItemForOption: function (option) {
            // summary:
            //		For the given option, return the menu item that should be used to display it.

            if (option.type == "separator") {
                return new MenuSeparator();
            } else {
                var click = lang.hitch(this, "_setValueAttr", option);
                var item = new MenuItem({
                    option: option,
                    label: option.label || this.emptyLabel,
                    onClick: click,
                    disabled: option.disabled || false
                });
                item.focusNode.setAttribute("role", "listitem");
                return item;
            }
        },

        _getValueFromOpts: function () {
            // summary:
            //		Returns the value of the widget by reading the options for the selected flag.

            var options = this.getOptions() || [];

            if (!this.multiple && options.length) {
                // Mirror what a select does - choose the first one
                var option = array.filter(options, function (i) { return i.selected; })[0];
                if (option && option.value !== undefined) {
                    return option.value;
                } else {
                    return null;
                }
            } else if (this.multiple) {
                // Set value to be the sum of all selected
                return array.map(array.filter(options, function (i) {
                    return i.selected;
                }), function (i) {
                    return i.value;
                }) || [];
            }
            return "";
        },

        _setValueAttr: function (value, priorityChange) {
            // summary:
            //		Set the value of the widget.
            //		If a non-object is passed, then we set our value from looking it up.

            var options = this.getOptions() || [];

            if (value === null || typeof value != "object") {
                value = array.filter(options, function (i) { return (i.value == value) || (!i.value && !value); });
            }

            // Convert item to an array if needed.
            if (!lang.isArray(value)) {
                value = [value];
            }

            if (this._onChangeActive) {
                var actual = value[0] ? value[0].value : null;

                this._pendingOnChange = this.actualValue !== actual;
                this.actualValue = actual;
            }

            array.forEach(options, function (i) {
                i.selected = array.some(value, function (v) { return v.value === i.value; });
            });

            var val = array.map(value, function (i) { return i.value; }),
                disp = array.map(value, function (i) { return i.label; });

            this._set("value", this.multiple ? val : val[0]);
            this._setDisplay(this.multiple ? disp : disp[0]);
            this._updateSelection();
            this._handleOnChange(this.value, priorityChange);
        },

        _updateSelection: function () {
            // summary:
            //		Sets the "selected" class on the item for styling purposes.

            this._set("value", this._getValueFromOpts());
            var value = this.value;

            if (value !== undefined) {
                if (!lang.isArray(value)) {
                    value = [value];
                }
                array.forEach(this._getChildren(), function (child) {
                    var isSelected = array.some(value, function (v) {
                        return child.option && (v === child.option.value);
                    });
                    child.domNode.setAttribute("aria-selected", isSelected);
                }, this);
            }
        },

        validator: function (/*Object*/value, /*Object?*/ flags) {
            // summary:
            //      Validate the value is match with this selection value type.
            // tags:
            //      public abtract
        }
    });
});
},
'epi-cms/contentediting/editors/ShortcutEditor':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",

// dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Button",

//epi cms
    "epi", //Used for the manage button label
    "epi/shell/widget/dialog/Dialog",
    "epi-cms/contentediting/ShortcutDialog",
    "../viewmodel/ShortcutDialogViewModel",
    "../../widget/_HasChildDialogMixin",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.shortcutblockeditor",
    "epi/i18n!epi/nls/episerver.shared"

], function (
// dojo
    declare,
    lang,
    domClass,
    domStyle,

//dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    Button,

//epi cms
    epi,
    Dialog,
    ShortcutDialog,
    ShortcutDialogViewModel,
    _HasChildDialogMixin,
    resources,
    sharedResources) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _HasChildDialogMixin], {

        templateString: '<div><span data-dojo-attach-point="shortcutTypeNameNode" class="dijitInline"></span> <div data-dojo-attach-point="button" data-dojo-type="dijit/form/Button" data-dojo-attach-event="onClick:_showDialog" >${resources.action.manage}</div></div>',

        resources: epi.resources,
        value: null,
        contentLink: null,
        metadata: null,

        watchHandlers: null,


        postCreate: function () {
            this.inherited(arguments);

            domClass.add(this.button.domNode, "epi-chromelessButton epi-chromelessLinkButton epi-functionLink");
        },

        destroy: function () {
            if (this.button) {
                this.button.destroyRecursive();
            }

            this.inherited(arguments);
        },

        onChange: function (value) {
            // summary:
            //		Callback method for updating the editor wrapper.
            // tags:
            //		callback
        },

        _showDialog: function() {
            var content = new ShortcutDialog({
                metadata: this.metadata,
                contentLink: this.contentLink,
                value: this.value,
                model: new ShortcutDialogViewModel({
                    contentLink: this.contentLink,
                    contentName: this.contentName,
                    value: this.value })
            });

            var dialog = new Dialog({
                destroyOnHide: true,
                defaultActionsVisible: false,
                confirmActionText: sharedResources.action.save,
                content: content,
                title: resources.dialogtitle
            });
            
            dialog.connect(dialog, "onExecute", lang.hitch(this, function(value){
                this.set("value", content.get("value"));
                this.onChange(content.get("value"));
            }));
            dialog.connect(dialog, "onHide", lang.hitch(this, function(){
                this.isShowingChildDialog = false;
            }));
            this.isShowingChildDialog = true;
            dialog.show();
        },

        _setShortcutTypeNameAttr: {
            node: "shortcutTypeNameNode",
            type: "innerHTML"
        },

        _setReadOnlyAttr: function (value) {
            this._set("readOnly", value);

            domStyle.set(this.button.domNode, "display", value ? "none" : "");
        },

        _setValueAttr: function (value) {
            this._set("value", value);
            this.set("ShortcutTypeName", value && value.pageShortcutTypeName ? value.pageShortcutTypeName : "");
        }
    });
});

},
'epi-cms/contentediting/ShortcutDialog':function(){
﻿define([

// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/html",

// Dijit
    "dijit/_CssStateMixin",

// EPi CMS
    "epi-cms/widget/Breadcrumb",

// EPi Framework
    "epi/shell/widget/dialog/_DialogContentMixin",
    "epi/shell/widget/FormContainer",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/_ActionProviderWidget",

// Template
    "dojo/text!./templates/ShortcutDialog.html",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.shortcutblockeditor",
    "epi/i18n!epi/nls/episerver.shared"
],
function (

// Dojo
    declare,
    lang,
    domStyle,
    domClass,
    html,

// Dijit
    _CssStateMixin,

// EPi CMS
    Breadcrumb,

// EPi Framework
    _DialogContentMixin,
    FormContainer,
    _ModelBindingMixin,
    _ActionProviderWidget,

// Template
    template,

// Resources
    res,
    sharedResources) {

    // module:
    //       epi-cms/contentediting/ShortcutDialog
    // summary:
    //      Dialog used to modify edit content shortcuts
    // tags:
    //      internal
    return declare([FormContainer, _ActionProviderWidget, _DialogContentMixin, _CssStateMixin, _ModelBindingMixin], {

        // templateString: String
        //      The template of widget
        templateString: template,

        // contentLink: String
        //      The content link id
        contentLink: null,

        // contentName: String
        //      The content name
        contentName: null,

        baseClass: "epi-statusIndicator",

        // _externalLinkWidget: Object
        //      The external link widget
        _externalLinkWidget: null,

        // _shortcutLinkWidget: Object
        //      The shortcut link widget
        _shortcutLinkWidget: null,

        // _shortcutTypeWidget: Object
        //      The shortcut type widget
        _shortcutTypeWidget: null,

        // _targetFrameWidget: Object
        //      The target frame widget
        _targetFrameWidget: null,

        //  _switchLinkTypeFirstRunDone: Boolean
        //     Indicate whether we ever have chosen the external link
        _switchLinkTypeFirstRunDone: false,

        modelBindingMap: {
            "contentLink": ["contentLink"],
            "contentName": ["contentName"],
            "enableSaveButton": ["enableSaveButton"],
            "enableShortcutLink": ["enableShortcutLink"],
            "enableExternalLink": ["enableExternalLink"],
            "clearExternalLink": ["clearExternalLink"],
            "enableOpenIn": ["enableOpenIn"]
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            // This form container is used inside a dialog without any size constraints because the dialog allow its content to overflow.
            // Therefore, we should not layout the form's top layout container.
            this.doLayout = false;
        },

        _setContentLinkAttr: function (value) {
            this.breadcrumb.set("contentLink", value);
        },

        _setContentNameAttr: {
            node: "contentNameNode",
            type: "innerHTML"
        },

        _setEnableSaveButtonAttr: function (value) {
            // summary
            //      Disable/Enable save button
            // tag
            //      Private

            if (this._actions && this._actions.length) {
                this.setActionProperty("save", "disabled", !value);
            }
        },

        _setEnableShortcutLinkAttr: function (value) {
            // Summary
            //      Disable/Enable validation of shortcut link
            //      Reset state of widget
            //      Show/hide shortcut link widget
            // value: Boolean
            //      If this is true, shortcut link  will be show, enable validation, otherwise it hidden
            // tag
            //      Private

            if (this._shortcutLinkWidget) {
                this._shortcutLinkWidget.set("required", value);
                // Set state of textbox to normal
                this._shortcutLinkWidget.set("state", "");
                var formRowNode = this._getAncestorNode(this._shortcutLinkWidget.domNode, "epi-formsRow");
                if (formRowNode) {
                    domStyle.set(formRowNode, "display", value ? "" : "none");
                }
            }
        },

        _setEnableExternalLinkAttr: function (value) {
            // Summary
            //      Disable/Enable validation of textbox
            //      Reset state of textbox
            //      Show/hide external link widget
            // value: Boolean
            //      If this is true, external link will be show, enable validation, otherwise it hidden
            // tag
            //      Private

            if (this._externalLinkWidget) {
                this._externalLinkWidget.set("required", value);
                this._externalLinkWidget.set("disabled", !value);
                // Set state of textbox to normal
                this._externalLinkWidget._set("state", "");

                var formRowNode = this._getAncestorNode(this._externalLinkWidget.domNode, "epi-formsRow");
                if (formRowNode) {
                    domStyle.set(formRowNode, "display", value ? "" : "none");
                }
            }
        },

        _setEnableOpenInAttr: function(value) {
            if(this._targetFrameWidget) {
                
                var formRowNode = this._getAncestorNode(this._targetFrameWidget.domNode, "epi-formsRow");
                if (formRowNode) {
                    domStyle.set(formRowNode, "display", value ? "" : "none");
                }
            }
        },

        _getAncestorNode: function (node, classAttr) {
            // Summary
            //      Get ancestor node which has class classAttr
            // node: DomNode
            //      The domNode which need to get ancestor.
            // classAttr: String
            //      The class attribute.
            // tag
            //      Private

            var parentNode = node ? node.parentNode : null;
            if (!parentNode) {
                return null;
            }

            if (!domClass.contains(parentNode, classAttr)) {
                return this._getAncestorNode(parentNode, classAttr);
            }

            return parentNode;
        },

        _setClearExternalLinkAttr: function (value) {
            // summary
            //      Clear text and reset state of external link textbox
            //  tag
            //      Private

            if (this._externalLinkWidget && value && !this._switchLinkTypeFirstRunDone) {
                // We need to clear the input textbox for external link the first time we chose external link.
                // If the page is saved with external link chosen however, we do not wish to clear the input textbox.
                this._externalLinkWidget.reset();
                this._switchLinkTypeFirstRunDone = true;
            }
        },

        onFieldCreated: function (fieldName, widget) {
            // summary:
            //     Raised when a field editor widget is created.
            // description:
            //     Override the FormContainer method to catch and keep reference to externalLink, shortcutLink and shortcutType widget
            // fieldName: String
            //     The field name
            // widget: dijit._Widget
            //     The widget
            // tag:
            //     callback

            switch (fieldName) {
                case "pageLinkURL":
                    this._externalLinkWidget = widget;
                    this._externalLinkWidget.set("invalidMessage", res.protocolwarning);
                    this._externalLinkWidget.set("acceptUrl", true);
                    this._externalLinkWidget.set("acceptMailAddress", true);
                    // Make sure that the string starts with a protocol, this regexp is copied from EPiServer.UrlBuilder.
                    this._externalLinkWidget.set("regExp", "^[a-z][a-z\\d+-.]*:.*");
                    this.connect(this._externalLinkWidget.domNode, "onkeyup", lang.hitch(this, function (evt) {
                        // Enable save button when user start typing
                        this.model.set("enableSaveButton", true);
                    }));
                    break;

                case "pageShortcutLink":
                    this._shortcutLinkWidget = widget;
                    this._shortcutLinkWidget.set("contentLink", this.model.get("contentLink"));
                    break;

                case "pageShortcutType":
                    this._shortcutTypeWidget = widget;
                    break;

                case "pageTargetFrame":
                    this._targetFrameWidget = widget;
                    break;

                default:
                    break;
            }
        },

        onChange: function (value) {
            this.inherited(arguments);
            this.model.set("intermediateValue", lang.mixin(value, { "pageShortcutTypeName": this._shortcutTypeWidget ? this._shortcutTypeWidget.get("displayedValue") : "" }));
        },

        _getValueAttr: function () {
            //We need to override getValue because the FormContainer returns the values in the form
            //But this dialog values that is not visible in the form
            
            return this.model.get("intermediateValue");
        },

        getActions: function () {
            // summary:
            //      Overridden from _ActionProvider to get the select current content action added to the containing widget
            //
            // returns:
            //      An array contining a select page action definition, if it is not a shared block

            this._actions = [
                {
                    name: "save",
                    label: sharedResources.action.save,
                    settings: { type: "button", disabled: true, "class": "Salt" },
                    action: lang.hitch(this, function () {
                        if (this.validate()) {
                            this.executeDialog();
                        } else {
                            this.model.set("enableSaveButton", false);
                        }
                    })
                },
                {
                    name: "cancel",
                    label: sharedResources.action.cancel,
                    settings: { type: "button" },
                    action: lang.hitch(this, function () {
                        this.cancelDialog();
                    })
                }
            ];

            return this._actions;
        }
    });
});

},
'url:epi-cms/contentediting/templates/ShortcutDialog.html':"﻿<div class=\"epi-formContainer\">\r\n    <div data-dojo-type=\"epi-cms/widget/Breadcrumb\" data-dojo-attach-point=\"breadcrumb\" data-dojo-props=\"showCurrentNode: false\"></div>\r\n    <h1 data-dojo-attach-point=\"contentNameNode\" class=\"epi-breadCrumbsCurrentItem dijitInline dojoxEllipsis\"></h1>\r\n    <div data-dojo-type=\"dijit/form/Form\" class=\"epi-formArea\" data-dojo-attach-point=\"form\"></div>\r\n</div>",
'epi-cms/contentediting/viewmodel/ShortcutDialogViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/Stateful",
    "dojo/string",

//EPi
    "epi-cms/contentediting/PageShortcutTypeSupport",
    "epi/epi",
    "epi/shell/_StatefulGetterSetterMixin"
],

function (
// Dojo
    declare,
    Stateful,
    dojoString,

// EPi
    PageShortcutTypeSupport,
    epi,
    _StatefulGetterSetterMixin
    ) {

    // module:
    //       epi-cms/contentediting/viewmodel/ShortcutDialogViewModel
    // summary:
    //      View model used by epi-cms/contentediting/ShortcutDialog
    // tags:
    //      internal
    return declare([Stateful, _StatefulGetterSetterMixin], {

        // value: [public] Object
        //      The value
        value: null,

        // intermediateValue: [public] Object
        //      Changes to the model are stored on this property
        intermediateValue: null,

        // savedValue: [public] Object
        //      Initial value
        savedValue: null,

        // contentLink: [public] String
        //      The content link id
        contentLink: null,

        // contentName: [public] String
        //      The name for the content
        contentName: null,

        // enableSaveButton: [public] Boolean
        //      Determines if the save button should be enabled
        enableSaveButton: null,

        // enableShortcutLink: [public] Boolean
        //      Determines if should be possible to set the shortcut link
        enableShortcutLink: null,

        // enableExternalLink: [public] Boolean
        //      Determines if should be possible to set an external link
        enableExternalLink: null,

        // enableOpenIn: [public] Boolean
        //      Determines if should be possible to select the target frame for a link
        enableOpenIn: true,

        postscript: function () {
            this.inherited(arguments);

            this.set("savedValue", this.value);
        },

        _setIntermediateValueAttr: function (value) {
            // summary:
            //  Set the intermediate value for the model
            // tags:
            //      public

            this._set("intermediateValue", value);
            this.set("enableSaveButton", !epi.areEqual(this.intermediateValue, this.savedValue));
            this.set("enableShortcutLink", value && (value.pageShortcutType == PageShortcutTypeSupport.pageShortcutTypes.Shortcut || value.pageShortcutType == PageShortcutTypeSupport.pageShortcutTypes.FetchData) ? true : false);
            this.set("enableExternalLink", value && value.pageShortcutType == PageShortcutTypeSupport.pageShortcutTypes.External ? true : false);
            this.set("clearExternalLink", value && value.pageShortcutType == PageShortcutTypeSupport.pageShortcutTypes.External && this.savedValue.pageShortcutType != PageShortcutTypeSupport.pageShortcutTypes.External ? true : false);

            this.set("enableOpenIn", value && !(value.pageShortcutType === PageShortcutTypeSupport.pageShortcutTypes.FetchData 
                || value.pageShortcutType === PageShortcutTypeSupport.pageShortcutTypes.Inactive
                || value.pageShortcutType === PageShortcutTypeSupport.pageShortcutTypes.Normal));
        },

        _setSavedValueAttr: function (value) {
            // summary:
            //      Sets the saved value
            // tags:
            //      public

            this._set("savedValue", value);
            this.set("enableSaveButton", false);
        },

        save: function () {
            // summary:
            //      Stores the value in the 'savedValue' property
            // tags:
            //      public
            this.set("savedValue", this.intermediateValue);
        }
    });
});
},
'epi-cms/contentediting/editors/TinyMCEEditor':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/config",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/window",

    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-construct",

    "dojo/Deferred",
    "dojo/keys",
    "dojo/on",
    "dojo/when",
// dojox
    "dojox/html/entities",
// dijit
    "dijit/_TemplatedMixin",
    "dijit/focus",
// epi
    "epi/dependency",
    "epi/routes",

    "epi/shell/conversion/ObjectConverterRegistry",
    "epi/shell/dnd/Target",
    "epi/shell/layout/_LayoutWidget",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/_ValueRequiredMixin",

    "epi-cms/widget/_DndStateMixin",
    "epi-cms/widget/_HasChildDialogMixin",
    "epi-cms/widget/_UserResizable",
    "epi/shell/widget/dialog/Alert",
// templates
    "dojo/text!./templates/TinyMCEEditor.html",
// resources
    "epi/i18n!epi/cms/nls/tinymce",
    "epi/i18n!epi/cms/nls/episerver.tinymce"
],

function (
// dojo
    array,
    config,
    declare,
    lang,
    win,

    domStyle,
    domClass,
    domConstruct,

    Deferred,
    keys,
    on,
    when,
// dojox
    htmlEntities,
// dijit
    _TemplatedMixin,
    focusUtil,
// epi
    dependency,
    epiRoutes,

    ObjectConverterRegistry,
    Target,
    _LayoutWidget,
    TypeDescriptorManager,
    _ValueRequiredMixin,

    _DndStateMixin,
    _HasChildDialogMixin,
    _UserResizable,
    Alert,
// templates
    template,
// resources
    oldResources,
    resources
) {

    // module:
    //      epi-cms/contentediting/editors/TinyMCEEditor
    // summary:
    //    Widget for the tinyMCE editor.
    // tags:
    //    public

    return declare([_LayoutWidget, _TemplatedMixin, _HasChildDialogMixin, _UserResizable, _ValueRequiredMixin, _DndStateMixin], {

        // baseClass: [public] String
        //    The widget's base CSS class.
        baseClass: "epiTinyMCEEditor",

        // width: [public] Number
        //    The editor width.
        width: null,

        // height: [public] Number
        //    The editor height.
        height: null,

        // value: [public] String
        //    The editor content.
        value: null,

        // intermediateChanges: Boolean
        //		Fires onChange for each value change or only on demand
        intermediateChanges: true,

        // templateString: [protected] String
        //    Template for the widget.
        templateString: template,

        // settings: [public] object
        //    The editor settings.
        settings: null,

        // dirtyCheckInterval: [public] Integer
        //    How often should the widget check if it is dirty and raise onChange event, in milliseconds. The value is by default set to 2000 ms
        dirtyCheckInterval: 2000,

        // autoResizable: [public] Boolean
        //    States if the editor can be resized while text is added.
        autoResizable: false,

        // isResized: [public] Boolean
        //    Indicates if the widget has been already resized on its initialization.
        isResized: false,

        tinymceRendered: null,

        dropTarget: null,

        // readOnly: [public] Boolean
        //    Denotes that the editor is read only.
        readOnly: false,

        // _dirtyCheckTimeout: [private] timeout
        //    Used for storing the dirty check timeout reference when dirtyCheckInterval is set.
        _dirtyCheckTimeout: null,

        constructor: function (params) {
            lang.mixin(this, params);
            this.tinymceRendered = new Deferred();
        },

        postMixInProperties: function () {
            if (this.autoResizable) {
                this.height = 0;
            }
        },

        postCreate: function () {
            // summary:
            //    Load the tinyMCE dependencies and initialize the editor.
            //
            // tags:
            //    protected

            this.dropTarget = new Target(this.dndOverlay, {
                accept: this.allowedDndTypes,
                createItemOnDrop: false,
                readOnly: this.readOnly
            });

            this.connect(this.dropTarget, "onDropData", "onDropData");
            this.connect(this.dndOverlay, "onmousemove", "_onOverlayMouseMove");

            this.inherited(arguments);
        },

        startup: function () {

            this.inherited(arguments);

            if (!window.tinymce) {
                require(["tinymce/tiny_mce_src"], lang.hitch(this, function () {
                    //set the global nls resources
                    var res = lang.mixin({}, oldResources, resources);
                    tinymce.addI18n({ en: res });

                    // Manually load legacy plugins
                    when(this._loadLegacyPlugins(), lang.hitch(this, function () {
                        this._initTinyMCE();
                    }));
                }));
            } else {
                this._initTinyMCE();
            }
        },

        destroy: function () {
            // summary:
            //    Destroy tinymce widget.
            //
            // tags:
            //    protected

            if(this._destroyed) {
                return;
            }
            
            this._cancelDirtyCheckInterval();
            
            var ed = this.getEditor();
            tinymce.remove(ed);

            this.inherited(arguments);
        },

        _loadLegacyPlugins: function () {
            // summary:
            //    Load legacy plugins from Util.
            //
            // tags:
            //    private

            var dfd = new Deferred();

            this.legacyPlugins.forEach(function (plugin) {
                var url = epiRoutes.getActionPath({
                    moduleArea: "Util",
                    path: "Editor/tinymce/plugins/" + plugin + "/" + (config.isDebug ? "editor_plugin_src.js" : "editor_plugin.js")
                });

                // Queue a plugin to load.
                tinymce.PluginManager.load(plugin, url);
            });

            // Load the whole queue.
            tinymce.ScriptLoader.loadQueue(function () {
                // Unfortunately, tinymce would silently fail if something went wrong.
                dfd.resolve();
            });

            return dfd;
        },

        canAccept: function () {
            return !domClass.contains(this.dndOverlay, "dojoDndTargetDisabled");
        },

        _onDndStart: function () {
            domStyle.set(this.dndOverlay, "display", "block");
            this.inherited(arguments);
        },

        _onDndCancel: function () {
            domStyle.set(this.dndOverlay, "display", "none");
            this.inherited(arguments);
        },

        _onDndDrop: function () {
            domStyle.set(this.dndOverlay, "display", "none");
            this.inherited(arguments);
        },

        _onOverlayMouseMove: function (evt) {
            this._dragPosition = { x: evt.pageX, y: evt.pageY };
        },

        onDropData: function (dndData, source, nodes, copy) {
            //summary:
            //    Handle drop data event.
            //
            // dndData:
            //    Dnd data extracted from the dragging items which have the same data type to the current target
            //
            // source:
            //    The dnd source.
            //
            // nodes:
            //    The dragging nodes.
            //
            // copy:
            //    Denote that the drag is copy.
            //
            // tags:
            //    private

            var dropItem = dndData ? (dndData.length ? dndData[0] : dndData) : null;

            if (!dropItem) {
                return;
            }
            
            // invoke the onDropping required by SideBySideWrapper and other widgets listening on onDropping 
            if (this.onDropping) {
                this.onDropping();
            }
            
            this._dropDataProcessor(dropItem);
        },

        _dropDataProcessor: function (dropItem) {
            when(dropItem.data, lang.hitch(this, function (model) {

                // TODO: move this to tinymce plugins instead. could be one which will be called to execute content
                // and one which knows how to insert the specific content

                // TODO: calculate drop position relative to tiny editor, send this to the plugin so it
                // could handle content depending on where the drop was done

                var self = this,
                    type = dropItem.type,
                    ed = this.getEditor();

                function insertLink(url) {
                    ed.focus();
                    ed.execCommand("CreateLink", false, url);
                }

                function insertHtml(html) {
                    ed.focus();
                    if (ed.execCommand('mceInsertContent', false, html)) {
                        self._onChange(ed.getContent());
                    }
                }

                function createLink(data) {
                    if (!ed.selection.isCollapsed()) {
                        insertLink(data.url);
                    } else {
                        var strTemplate = "<a href=\"{0}\" title=\"{1}\">{1}</a>";
                        insertHtml(lang.replace(strTemplate, [data.url, htmlEntities.encode(data.text)]));
                    }
                }

                function createImage(data) {
                    var strTemplate = "<img alt=\"{alt}\" src=\"{src}\" width=\"{width}\" height=\"{height}\" />";

                    var imgPreviewNode = domConstruct.create("img", {
                        src: data.previewUrl || data.url,
                        style: { display: "none;" }
                    }, win.body(), "last");

                    on.once(imgPreviewNode, "load", function () {
                        insertHtml(lang.replace(strTemplate, this));
                        // destroy temporary image preview dom node.
                        domConstruct.destroy(imgPreviewNode);
                    });
                }

                if (type && type.indexOf("link") !== -1) {
                    createLink(model);

                }
                else if (type && type.indexOf("fileurl") !== -1) {
                    createImage(model);
                }

                var typeId = model.typeIdentifier;

                var editorDropBehaviour = TypeDescriptorManager.getValue(typeId, "editorDropBehaviour");

                if (editorDropBehaviour) {

                    if (editorDropBehaviour === 1) {
                        //Default: Create a content object
                        var html = '<div data-contentlink="' + model.contentLink + '" data-classid="36f4349b-8093-492b-b616-05d8964e4c89" class="mceNonEditable epi-contentfragment">' + model.name + '</div>';
                        insertHtml(html);
                        return;
                    }

                    var converter, baseTypes = TypeDescriptorManager.getInheritanceChain(typeId);

                    for (var i = 0; i < baseTypes.length; i++) {
                        var basetype = baseTypes[i];
                        converter = ObjectConverterRegistry.getConverter(basetype, basetype + ".link");
                        if (converter) {
                            break;
                        }
                    }

                    if (!converter) {
                        return;
                    }

                    when(converter.convert(typeId, typeId + ".link", model), lang.hitch(this, function (data) {

                        if (!data.url) {
                            //If the page does not have a public url we do nothing.
                            var dialog = new Alert({
                                description: resources.notabletocreatelinkforpage
                            });
                            dialog.show();
                            this.own(dialog);
                        }
                        else {
                            switch (editorDropBehaviour) {
                                case 2://Link
                                    createLink(data);
                                    break;
                                case 3://Image
                                    createImage(data);
                                    break;
                            }
                        }
                    }));
                }
            }));

            domStyle.set(this.dndOverlay, { "display": "none" });
        },

        focus: function () {
            // Set focus on the current editor.
            //
            // tags:
            //    public

            var ed = this.getEditor();
            if (ed != null) {
                this._focused = true;
                ed._gainedFocus = true;
                when(this.tinymceRendered, lang.hitch(this, function () {
                    tinymce.execCommand('mceFocus', false, this.editorFrame.id);
                }));
            }
        },

        validate: function () {
            // summary:
            //      Overridden to sync latest content from tinyMCE before doing validation.

            return this.inherited(arguments);
        },

        getEditor: function () {
            // summary:
            //    Return an editor instance.
            //
            // tags:
            //    public
            //
            // returns:
            //    A instance of the current editor.

            return (typeof tinymce !== "undefined" && tinymce != null ? tinymce.get(this.editorFrame.id) : null);
        },

        getEditorDOM: function () {
            // summary:
            //      Get active editor DOM object
            // tags:
            //      public

            return tinymce.DOM;
        },

        resizeEditor: function () {
            // summary:
            //    Resize the editor area.
            //
            // description:
            //   Resize the editor area when the autoResizable flag is set to true.
            //   This function is executed only one time and it is called on the
            //   timyMCE's onSetContent event.
            //
            // tags:
            //    public

            var ed = this.getEditor(),
                autoresize_min_height = 0,
                autoresize_max_height = (tinymce.isIE ? document.body.clientHeight : window.innerHeight) - 200,
                autoresize_max_width = (tinymce.isIE ? document.body.clientWidth : window.innerWidth) - 200,
                d = ed.getDoc(),
                b = d.body,
                DOM = tinymce.DOM,
                resizeHeight = this.height,
                resizeWidth = this.width,
                myHeight,
                myWidth;

            myHeight = b.scrollHeight;
            myWidth = b.scrollWidth;

            // don't make it smaller than the minimum height
            if (myHeight > autoresize_min_height) {
                resizeHeight = myHeight;
            }

            // Don't make it bigger than the maximum height
            if (myHeight > autoresize_max_height) {
                resizeHeight = autoresize_max_height;
            }

            if (myWidth > autoresize_max_width) {
                resizeWidth = autoresize_max_width;
            }

            // Resize content element
            DOM.setStyle(ed.contentWindow.frameElement, 'height', resizeHeight + 80 + 'px');
            if (ed.getBody().scrollWidth != ed.getBody().offsetWidth) {
                var padding = 20;
                if (resizeHeight == autoresize_max_height) {
                    padding = 30;
                }

                DOM.setStyle(ed.contentWindow.frameElement, 'width', ed.getBody().scrollWidth + padding + 'px');
            }

            this.isResized = true;
        },

        _setValueAttr: function (newValue) {
            //summary:
            //    Value's setter
            //
            // tags:
            //    protected

            var emptyValue = (newValue === null || newValue === undefined);

            // Store the raw value so we can return it if we have no changes
            this._emptyRawValue = emptyValue;
            this._rawValue = newValue;

            this.value = newValue;
            if (emptyValue) {
                this.value = '';
            }

            var doSetContent = function (t) {
                var editor = t.getEditor();
                if (editor != null) {
                    editor.setContent(t.value);
                }
                //validation will take place after setting content to the editor is done, to avoid long events chain
                this._started && setTimeout(lang.hitch(t, t.validate), 0);
            };

            when(this.tinymceRendered, lang.hitch(this, function () {
                doSetContent(this);
            }));

        },

        _getValueAttr: function () {
            //summary:
            //    Value's getter
            //
            // tags:
            //    protected

            return this._emptyRawValue ? this._rawValue : this.value;
        },

        _updateTinySettings: function () {

            this.settings = lang.mixin(this.settings, {
                mode: "exact",
                width: this.width,
                height: this.height,
                relative_urls: false,
                elements: this.editorFrame.id,
                readonly: this.readOnly
            });
        },

        _initTinyMCE: function () {
            // summary:
            //    Initialize the tinyMCE and create a new editor instance.
            //
            // tags:
            //   private

            this._updateTinySettings();

            if (this.legacyPlugins && this.legacyPlugins.length > 0) {
                // Add legacy plugins back to list, so tinymce can initialize them
                this.settings.plugins = this.settings.plugins + "," + this.legacyPlugins.join(",");
            }

            this.editorFrame.value = this.value || "";

            // initialize the editor with the default settings.
            if (typeof tinymce !== "undefined") {
                tinymce.dom.Event.domLoaded = true;

                this._setupHandle = tinymce.onAddEditor.add(lang.hitch(this, this._setupEditorEventHandling));
                tinymce.init(this.settings);

                this._startDirtyCheckInterval();
            } else {
                console.error("Couldn't initialize the editor");
            }
        },

        _isFullScreen: function (ed) {
            return ed.editorId === "mce_fullscreen";
        },

        _onPostRender: function (ed) {
            // summary:
            //    Some additional initialization on post render.
            //
            // ed:
            //    Instance of the current editor.
            //
            // tags:
            //    private

            //if resolve has not been called before
            if (this.tinymceRendered.fired !== 0) {
                this.tinymceRendered.resolve();

                //register iframe
                this.own(focusUtil.registerIframe(ed.contentWindow.frameElement));

                this._handlePopupMenu(ed);
                this._handlePopupWindow(ed);
            }
        },

        _handlePopupWindow: function (ed) {
            // summary:
            //    Keep track of popup window showing/hiding to prevent unexpected blur event on widget's container.
            //
            // ed:
            //    Instance of the current editor.
            //
            // tags:
            //    private

            ed.windowManager.onOpen.add(lang.hitch(this, function () {
                this.isShowingChildDialog = true;
            }));

            ed.windowManager.onClose.add(lang.hitch(this, function () {
                //gain focus
                this.focus();

                this.isShowingChildDialog = this._isFullScreen(ed);

                // Attribute changes won't trigger the onChange but we record them and set _hasPendingChanges
                if (!this.isShowingChildDialog && this._hasPendingChanges) {
                    this._onChange(ed.getContent());
                }
            }));
        },

        _handlePopupMenu: function (ed) {
            // summary:
            //    Keep track of popup menu showing/hiding to prevent unexpected blur event on widget's container.
            //
            // ed:
            //    Instance of the current editor.
            //
            // tags:
            //    private

            var control;
            for (var i in ed.controlManager.controls) {
                //loop through the controls
                control = ed.controlManager.controls[i];

                //check if the control has a popup
                if (control.onRenderMenu) {
                    //hook in onrendermenu event
                    control.onRenderMenu.add(lang.hitch(this, function (parent, menu) {

                        //set isShowingChildDialog on when show menu
                        menu.onShowMenu.add(lang.hitch(this, function () {
                            this.isShowingChildDialog = true;
                        }));

                        //set isShowingChildDialog off when hide menu
                        menu.onHideMenu.add(lang.hitch(this, function () {
                            this.isShowingChildDialog = this._isFullScreen(ed);
                        }));
                    }));
                }
            }
        },

        _setupEditorEventHandling: function (manager, ed) {
            // summary:
            //    Hook up to the tinyMCE events.
            //
            // ed:
            //    Instance of the current editor.
            //
            // tags:
            //    private

            // Check if the event was by the correct instance.
            if (ed.id !== this.editorFrame.id) {
                return;
            }

            tinymce.onAddEditor.remove(this._setupHandle);

            ed.onInit.add(lang.hitch(this, function () {
                // Add event handler on editor selection after its initialized
                if (ed && ed.selection) {
                    ed.selection.onSetContent.add(lang.hitch(this, function (selection, args) {
                        var isSet = args.set;
                        // If new content is set to current selection, raise event to save it!
                        if (isSet) {
                            this._onChange(ed.getContent());
                        }
                    }));
                }
            }));

            ed.onSetContent.add(lang.hitch(this, function (ed, e) {
                this.onSetContent(ed);
            }));

            ed.onPostRender.add(lang.hitch(this, function (ed, e) {
                this._onPostRender(ed);
            }));

            ed.onKeyUp.add(lang.hitch(this, function (ed, e) {
                this.onKeyUp(ed, e);
            }));

            ed.onChange.add(lang.hitch(this, function (ed, e) {
                this._onChange(ed.getContent());
            }));

            ed.onRemove.add(lang.hitch(this, function (ed) {
                this.onEditorRemoved(ed);
            }));

            ed.onRedo.add(lang.hitch(this, function (ed, level) {
                this.onRedo(ed, level);
            }));

            ed.onUndo.add(lang.hitch(this, function (ed, level) {
                this.onUndo(ed, level);
            }));

            ed.onBeforeExecCommand.add(lang.hitch(this, function (ed, cmd, ui, val, a) {
                if (cmd === "mceFullScreen") {
                    // About to toggle fullscreen
                    this.isShowingChildDialog = !this._isFullScreen(ed);
                }
            }));
        },

        // events.

        onSetContent: function (/*Object*/ed) {
            // summary:
            //    Raised when the content is set to the editor.
            //
            // ed:
            //    The editor instance.
            //
            // tags:
            //    callback public

            //Check hasPendingChanges everytime set content for tiny mce editor,
            //except the first time(when isResized = false)
            if (this.isResized) {
                this._hasPendingChanges = this.value != ed.getContent() || this._hasPendingChanges;
            }

            if (this.autoResizable) {
                //Editor's iframe may not be ready at the first time content is set, resize should be done after a while.
                //tinymce initialize the iframe in a timeout, we don't know when it happens, so a long enough timeout is neccessary in this case.
                setTimeout(lang.hitch(this, function () {
                    this.resizeEditor();
                }), 200);
            } else {
                if (!this.isResized) {
                    this.isResized = true;
                }
            }

            this.onLayoutChanged();
        },

        onEditorRemoved: function (/*Object*/ed) {
            // summary:
            //    Raised when a instance of the editor is removed.
            //
            // ed:
            //    The editor instance.
            //
            // tags:
            //    callback public

        },

        _isMetaKey: function (/*Object*/e) {
            // summary:
            //    Check if the key pressed is a metakey.
            //
            // e:
            //    The keyboard event.
            //
            // tags:
            //    private
            //
            // returns:
            //    Return true if the key pressed is a metakey, otherwise return false.

            if (e.keyCode == keys.CTRL || e.keyCode == keys.ALT || e.keyCode == keys.SHIFT || e.keyCode == keys.META) {
                return true; //Boolean
            }

            return false; //Boolean
        },

        onKeyUp: function (/*Object*/editor, /*Object*/e) {
            // summary:
            //    Raised when a keyboard key is released on the editor.
            //
            // editor:
            //    The editor instance.
            //
            // e:
            //    The event object.
            //
            // tags:
            //    callback public

            if (editor) {
                if (!tinymce.VK.metaKeyPressed(e) && !this._isMetaKey(e)) {
                    this._hasPendingChanges = editor.undoManager.typing;
                }
            }
        },

        _onChange: function (val) {
            // summary:
            //    Raised when the editor's content is changed.
            //
            // val:
            //    The editor's changed value
            //
            // tags:
            //    callback public

            this.value = val;

            // value has been changed, at least in the tiny editor, we should no longer
            // return the empty raw value
            this._emptyRawValue = false;

            if (this.validate()) {
                this._hasPendingChanges = false;
                this.onChange(this.value);
            }
        },

        onChange: function (val) {
            // summary
        },

        _stopEditing: function () {
            // summary:
            //      Stop editor editing function
            // tags:
            //      protected

            this._focused = false;

            // This is common way to hide a validation popup in dojo
            this.displayMessage(null);

            var ed = this.getEditor();

            if (ed && ed.undoManager && ed.undoManager.typing) {
                ed.undoManager.typing = 0;
                ed.undoManager.add();
            }

            if (this._hasPendingChanges) {
                var val = ed.getContent();
                if (!this.intermediateChanges) {
                    this._onChange(val);
                } else {
                    this.value = val;
                    this._emptyRawValue = false;
                }
            }
        },

        _onBlur: function () {
            // summary:
            //    Hide validation pop up and set focused flag off.
            //
            // tags:
            //    private

            this._stopEditing();

            this.inherited(arguments);
        },

        _cancelDirtyCheckInterval: function () {
            // summary:
            //      Stop any running intervalled dirty check
            // tags:
            //      private

            if (this._dirtyCheckTimeout) {
                clearTimeout(this._dirtyCheckTimeout);
                this._dirtyCheckTimeout = null;
            }
        },

        _startDirtyCheckInterval: function () {
            // summary:
            //      Calls _dirtyCheck and schedules a new one according to the dirtyCheckInterval flag
            // tags:
            //      private

            if (this._destroyed || !this.intermediateChanges) {
                return;
            }

            this._cancelDirtyCheckInterval();

            this._dirtyCheck();

            this._dirtyCheckTimeout = setTimeout(lang.hitch(this, this._startDirtyCheckInterval), this.dirtyCheckInterval);
        },

        _dirtyCheck: function () {
            // summary:
            //    Check if the editor is dirty and raise onChange event.
            //
            // tags:
            //    private

            var ed = this.getEditor();
            if (ed) {
                if (this._hasPendingChanges) {
                    this._onChange(ed.getContent());
                }
            }
        },

        onRedo: function (/*Object*/ed, level) {
            // summary:
            //    Raised by the redo event.
            //
            // ed:
            //    The editor instance.
            //
            // tags:
            //    callback public
            this._hasPendingChanges = true;
        },

        onUndo: function (/*Object*/ed, level) {
            // summary:
            //    Raised undo event.
            //
            // ed:
            //    The editor instance.
            //
            // tags:
            //    callback public
            this._hasPendingChanges = true;
        }

    });

});
},
'epi-cms/widget/_DndStateMixin':function(){
﻿define([
// Dojo
    "dojo",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/Deferred",
    "dojo/aspect",
    "dojo/dom-class"
], function (
// Dojo
    dojo,
    array,
    declare,
    lang,
    Deferred,
    aspect,
    domClass
) {
    return declare([], {

        // baseDndStateClass: String
        //      CSS base class for dnd state.
        baseDndStateClass: "epi-dropTarget",

        // dndStateClass: String
        //      CSS class for current state
        dndStateClass: null,

        // dropTarget: Target
        //      An instance of Target class
        dropTarget: null,

        // _aspectAfterHandler: Object
        //      Return object from aspect after method.
        _aspectAfterHandler: null,

        postCreate: function () {
            this.subscribe("/dnd/start", "_onDndStart");
            this.subscribe("/dnd/cancel", "_onDndCancel");
            this.subscribe("/dnd/drop", "_onDndDrop");

            if (this.dropTarget) {
                this._aspectAfterHandler = aspect.after(this.dropTarget, "onDndStart", lang.hitch(this, "_onAfterDndStart"));
            }
        },

        _getDndStateClassAttr: function () {
            var suffix = this.canAccept() ? "Enabled" : "Disabled";
            this.dndStateClass = this.baseDndStateClass + suffix;
            return this.dndStateClass;
        },

        canAccept: function () {
            return false;
        },

        _onDndStart: function () {
            // Only excecute when mixin widget has not any target
            if (!this.dropTarget) {
                domClass.add(this.domNode, this.get("DndStateClass"));
            }
        },

        _onAfterDndStart: function () {
            domClass.add(this.domNode, this.get("DndStateClass"));
        },

        _onDndCancel: function () {
            domClass.remove(this.domNode, this.dndStateClass);
        },

        _onDndDrop: function () {
            domClass.remove(this.domNode, this.dndStateClass);
        },

        destroy: function () {
            this.inherited(arguments);
            if (this._aspectAfterHandler) {
                this._aspectAfterHandler.remove();
                this._aspectAfterHandler = null;
            }
        }
    });
});
},
'epi-cms/widget/_UserResizable':function(){
﻿define([
"epi",
"dojo"],

function (epi, dojo) {

    return dojo.declare(null, {
        // summary:
        //    Mix in that provides container notification methods for user resizable widget.
        // tags:
        //    public

        onResizeStart: function () {
            // summary:
            //    Raised when user start resizing the widget.
            //
        },

        onResizeStop: function () {
            // summary:
            //    Raised when user stop resizing the widget.
            //
        }
    });
});
},
'url:epi-cms/contentediting/editors/templates/TinyMCEEditor.html':"﻿<div id=\"widget_${id}\">\r\n    <div style=\"display: inline-block\" data-dojo-attach-point=\"stateNode, tooltipNode\">\r\n        <textarea data-dojo-attach-point=\"editorFrame\" id=\"${id}_editorFrame\" style=\"border: none;\"></textarea>\r\n    </div>\r\n    <div data-dojo-attach-point=\"dndOverlay\" style=\"background: rgba(0, 0, 0, 0.01); position: absolute; left: 0; top: 0; right: 0; bottom: 0; display: none\"></div>\r\n</div>\r\n",
'epi-cms/contentediting/editors/TinyMCEInlineEditor':function(){
﻿define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/dom-style",

    "dojo/aspect",
    "dojo/on",
    "dojo/sniff",
// EPi
    "epi/string",
    "epi-cms/contentediting/_HasFloatingComponent",
    "epi-cms/contentediting/editors/TinyMCEEditor",
// Template
    "dojo/text!./templates/TinyMCEInlineEditor.html"
],

function (
// Dojo
    array,
    declare,
    lang,

    dom,
    domClass,
    domGeometry,
    domStyle,

    aspect,
    on,
    sniff,
// EPi
    epiString,
    _HasFloatingComponent,
    TinyMCEEditor,
// Template
    template
) {

    // module:
    //      epi-cms/contentediting/editors/TinyMCEInlineEditor
    // summary:
    //      Widget for the tinyMCE inline editor.
    // description:
    //      This editor widget implemented "epi-cms.contentediting._HasFloatingComponent",
    //          in order to exposes information about an external component (it's tinymc editor external toolbar in this case).
    //      An editor wrapper that implemented "epi-cms.contentediting._FloatingComponentEditorWrapperMixin",
    //          will uses this exposed information to position the external component.
    // tags:
    //      public

    return declare([_HasFloatingComponent, TinyMCEEditor], {

        // baseClass: [public] String
        //      The widget's base CSS class.
        baseClass: "epiTinyMCEInlineEditor",

        // autoResizable: [public] Boolean
        //      States if the editor can be resized while text is added.
        autoResizable: true,

        // templateString: [protected] String
        //      Template for the widget.
        templateString: template,

        // inlineSettings: [public] object
        //      The inline editor settings.
        inlineSettings: null,

        // supportCustomDnd: [public] Boolean
        //      Indicates that the current editor had custom Dnd handler or not
        supportCustomDnd: true,

        // _lastRng: [private] DOM Range
        //      The last selection to restore after.
        _lastRng: null,

        // _maxCheckRenderedTime: [private] Integer
        //      Maximum times of checking the editor toolbar is fully rendered or not.
        _maxCheckRenderedTime: 10,

        _editorIframe: null,

        // =======================================================================
        // Public events

        onEditorBlur: function (/*Event*/evt) {
            // summary:
            //      Stop editing when click outside editor but inside its viewport
            // evt: [Event]
            //      onmousedown event
            // tags:
            //      public

            this._stopEditing();
        },

        onEditorResizing: function (/*Object*/resizeInfo) {
            // summary:
            //      Stub to do something when the current editor on resizing progress
            // resizeInfo: [Object]
            //      Object that provides resize information to editor wrapper
            // tags:
            //      public
        },

        onEditorResized: function (/*Function*/callbackFunction) {
            // summary:
            //      Stub to do something when the current editor finished its resizing process
            // tags:
            //      public
        },

        // =======================================================================
        // Public functions

        isEditing: function () {
            // summary:
            //      Check the current editor widget is on editing or not
            // tags:
            //      public

            return this.domNode && domStyle.get(this.domNode, "display").toLowerCase() !== "none";
        },

        // =======================================================================
        // Overrides public functions

        startup: function () {

            this._checkingTime = 0;

            if (this._started) {
                return;
            }

            this.inherited(arguments);

            if (!this.ready) {
                return;
            }

            this.own(
                this.watch("state", lang.hitch(this, function (name, oldValue, newValue) {
                    on.emit(this.domNode, "editorstatechanged", newValue);
                }))
            );
        },

        destroy: function () {

            this._clearLocalDefers();

            this._externalToolbar = this._toolbarSizeBox = this._toolbarRelativeContainer = this._toolbarRefContainer = null;
            this._latestButtonIds = this._editorIframe = this._toolbarFinishRender = null;

            this._lastRng = null;

            this.inherited(arguments);
        },

        focus: function () {
            // summary:
            //      Set focus on the current editor.
            // tags:
            //      public, extension

            this.inherited(arguments);

            var editor = this.getEditor();
            if (!editor) {
                return;
            }

            // Do focus when mouse down event is fired on overlayItem
            editor.selection.setRng(this._lastRng || editor.selection.getRng());

            this.resizeEditor();
        },

        resizeEditor: function () {
            // summary:
            //      Resizes the editor area.
            // tags:
            //      public, extension

            // Don't do a resize if the editor isn't visible as height will calculate to zero.
            // Instead call onEditorResized to update subscribers and return.
            if (domStyle.get(this.containerNode, "display") == "none") {
                this.onEditorResized();
                return;
            }

            var editor = this.getEditor(),
                style = { "height": "auto" },
                editorIframe = this._getEditorIframe();

            domStyle.set(editorIframe, style);

            // Update height
            style.height = editor.getBody().parentNode.scrollHeight + "px";

            this.onEditorResizing({ "style": style });

            domStyle.set(editorIframe, style);

            this.onEditorResized(lang.hitch(this, this._floatToolbar));

            this.isResized = true;
        },

        // =======================================================================
        // Protected overrides functions

        _onBlur: function () {
            // summary:
            //      Disable default onblur event
            // tags:
            //      protected, extension

            // Disable onblur event
        },

        _updateTinySettings: function () {
            this.inherited(arguments);

            this.settings.width = this.settings.height = "100%";
            this.settings = lang.mixin(this.settings, this.inlineSettings);
        },

        _setupEditorEventHandling: function (manager, editor) {
            // summary:
            //      Hook up to the tinyMCE events.
            // manager: Object
            //      TinyMce editor Manager
            // editor:
            //      Current editor.
            // tags:
            //      private, extension

            this.inherited(arguments);

            this._disableSetTopStyle();

            this._appendEditorResizeHandler(editor);
            this._appendEditorFloatToolbarHandler(editor);

            // IE doesn't keep the last selection
            sniff("ie") && editor.onNodeChange.add(lang.hitch(this, function (activeEditor) {
                this._lastRng = activeEditor.selection.getRng();
            }));
        },

        _clearLocalDefers: function () {
            // summary:
            //      Clear all registered local defers
            // tags:
            //      protected, extension

            this._deferToolbarFullSize && this._deferToolbarFullSize.remove();
            this._deferOnKeyUp && this._deferOnKeyUp.remove();
        },

        // =======================================================================
        // Private functions

        _appendEditorResizeHandler: function (/*Object*/editor) {
            // summary:
            //      Append editor resizing process for appropriate editor events
            // editor: [Object]
            //      Active tinymc editor
            // tags:
            //      private

            var hitchedResize = lang.hitch(this, this.resizeEditor);

            // Add appropriate listeners for resizing content area
            editor.onChange.add(hitchedResize);
            editor.onSetContent.add(hitchedResize);
            editor.onPaste.add(hitchedResize);
            editor.onPostRender.add(hitchedResize);

            editor.onKeyUp.add(lang.hitch(this, function () {
                // Delay a time around onKeyUp fired, mean that we need to wait user finished his/her input text by typed on the keyboard
                this._clearLocalDefers();
                this._deferOnKeyUp = this.defer(hitchedResize, 10);
            }));

            editor.onInit.add(lang.hitch(this, function (ed) {
                // Remove body class "epi-inline" if editor mode is full screen
                if (this._isFullScreen(ed)) {
                    domClass.remove(ed.getBody(), this.settings.body_class);
                }
            }));
        },

        _appendEditorFloatToolbarHandler: function (/*Object*/editor) {
            // summary:
            //      Append editor float toolbar process for appropriate editor events
            // editor: [Object]
            //      Active tinymc editor
            // tags:
            //      private

            // Show external toolbar
            editor.onInit.add(lang.hitch(this, this._showEditorToolbar));

            editor.onActivate.add(lang.hitch(this, this._floatToolbar));
            editor.onMouseUp.add(lang.hitch(this, this._floatToolbar));
        },

        _showEditorToolbar: function (/*tinymce.Editor*/activeEditor) {
            // summary:
            //      Show the editor's external toolbar
            // activeEditor: [Object] tinymce.Editor
            //      Current active TinyMC editor object
            // tags:
            //      private

            if (!activeEditor) {
                return;
            }

            this.focus();
            activeEditor.dom.show(this._getExternalToolbar());
            this._floatToolbar();
        },

        _disableSetTopStyle: function () {
            // summary:
            //      Disable setting top position for the editor external toolbar
            //      By default, when settings external toolbar in TinyMC editor version 3.x,
            //      it always set to top position of the editor content.
            //      So that, in order to make smoothly scrolling the external toolbar belong to viewport scroller,
            //      we need to disable the default settings from editor each time onMouseUp event fired.
            // tags:
            //      private

            this.own(
                aspect.before(this.getEditorDOM(), "setStyle", lang.hitch(this, function (n, na, v) {
                    if (n == this._getExternalToolbar() && na === "top") {
                        return [];
                    }

                    return;
                }))
            );
        },

        _floatToolbar: function () {
            // summary:
            //      Calculate top position of toolbar
            // tags:
            //      private

            this._clearLocalDefers();

            if (!this._getExternalToolbar()) {
                return;
            }

            // Recursive call to get the really full width of the toolbar to position it correctly
            if (!this._isToolbarRendered()) {
                this._deferToolbarFullSize = this.defer(this._floatToolbar, 100);

                return;
            }

            // Call exposed event of the _HasFloatingComponent mixin in order to float the external toolbar
            this.onComponentFloat(this._getComponentFloatInfo());
        },

        _getComponentFloatInfo: function () {
            // summary:
            //      Build component information for floating
            // returns: [Object]
            //      Object's required properties:
            //          componentInfo: [Object]
            //              component: [DOM]
            //                  The external floating component
            //              componentSizeBox: [DOM]
            //                  The target node that provides external floating component size
            //              relativeContainer: [DOM]
            //                  The relative container of the external floating component
            //              refContainer: [DOM]
            //                  The root container for the both external floating component and its relative container
            //          floatingInfo: [Object]
            //              refreshPosition: [Boolean]
            // tags:
            //      private

            return {
                "componentInfo": {
                    "component": this._getExternalToolbar(),
                    "componentSizeBox": lang.hitch(this, function () {
                        return this._toolbarSizeBox || (this._toolbarSizeBox = dom.byId(this.editorFrame.id + "_tblext"));
                    })(),
                    "relativeContainer": lang.hitch(this, function () {
                        return this._toolbarRelativeContainer || (this._toolbarRelativeContainer = this._getExternalToolbar().parentNode);
                    })(),
                    "refContainer": lang.hitch(this, function () {
                        return this._toolbarRefContainer || (this._toolbarRefContainer = dom.byId(this.editorFrame.id + "_parent"));
                    })()
                },
                "floatingInfo": {
                    "refreshPosition": false
                }
            };
        },

        _isToolbarRendered: function () {
            // summary:
            //      Check the current editor toolbar is fully rendered or not.
            //      The validation based on checking the position of the latest button on each toolbar row.
            // remarks:
            //      Workaround solution. Need find a better solution later.
            // tags:
            //      private

            if (this._checkingTime > this._maxCheckRenderedTime) {
                return true;
            }

            this._checkingTime++;

            var buttonElement = null,
                buttonWidth = 0;

            return this._toolbarFinishRender || (this._toolbarFinishRender = this._getToolbarLatestButtonIds().every(function (buttonId) {
                buttonElement = dom.byId(this.editorFrame.id + "_" + buttonId);
                buttonWidth = buttonElement && domGeometry.position(buttonElement).w;
                return buttonWidth !== 0;
            }, this));
        },

        _getToolbarLatestButtonIds: function () {
            // summary:
            //      Get latest button on each toolbar row
            // tags:
            //      private

            if (this._latestButtonIds) {
                return this._latestButtonIds;
            }

            this._latestButtonIds = [];

            var latestButtonId = null;
            for (var property in this.settings) {
                if (property.toLowerCase().indexOf("theme_advanced_button") != -1) {
                    latestButtonId = this.settings[property].split(",").pop();
                    if (!epiString.isNullOrEmpty(latestButtonId)) {
                        this._latestButtonIds.push(latestButtonId);
                    }
                }
            }

            return this._latestButtonIds;
        },

        _getExternalToolbar: function () {
            // summary:
            //      Get the current editor external toolbar
            // returns: [DOM]
            // tags:
            //      private

            return this._externalToolbar || (this._externalToolbar = dom.byId(this.editorFrame.id + "_external"));
        },

        _getEditorIframe: function () {
            // summary:
            //      Get editor iframe DOM node
            // returns: [DOM]
            // tags:
            //      private

            return this._editorIframe || (this._editorIframe = dom.byId(this.editorFrame.id + "_ifr"));
        }

    });

});
},
'epi-cms/contentediting/_HasFloatingComponent':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-geometry",
    "dojo/dom-style"
],

function (
// dojo
    declare,
    lang,

    domGeometry,
    domStyle
) {

    // module:
    //      epi-cms/contentediting/_HasFloatingComponent
    // summary:
    //      An interface for a component that wants to floating its child based on its child relative container
    // tags:
    //      public

    return declare(null, {

        // componentGutter: [public] Integer
        //      The external component's gutter
        componentGutter: 7,

        // _floatingComponentSize: [private] Object
        //      Object's properties:
        //          height: [Integer]
        //          width: [Integer]
        //      Scrolling information of the component
        _floatingComponentSize: null,

        // _floatingComponent: [private] DOM
        //      The DOM that will be position
        _floatingComponent: null,

        // _floatingComponentSizeBox: [private] DOM
        //      The DOM used to get the size
        _floatingComponentSizeBox: null,

        // _floatingRelativeContainer: [private] DOM
        //      The DOM used as an anchor for the floating component
        _floatingRelativeContainer: null,

        // _floatingRefContainer: [private] DOM
        //      The DOM used as the root container of the floating component and its relative container
        _floatingRefContainer: null,

        // =======================================================================
        // Public events

        onComponentFloat: function (/*Object*/componentFloatInfo) {
            // summary:
            // componentFloatInfo: [Object]
            //      Object's properties:
            //          component: [DOM]
            //          componentSizeBox: [DOM]
            //          relativeContainer: [DOM]
            //          refContainer: [DOM]
            // tags:
            //      public, callback

            this._floatingComponent = componentFloatInfo.componentInfo.component;
            this._floatingComponentSizeBox = componentFloatInfo.componentInfo.componentSizeBox;
            this._floatingRelativeContainer = componentFloatInfo.componentInfo.relativeContainer;
            this._floatingRefContainer = componentFloatInfo.componentInfo.refContainer;
        },

        // =======================================================================
        // Public functions

        getComponentInfo: function () {
            // summary:
            //      Get the external component related information
            // returns: [Object]
            //      Object's properties:
            //          component: [DOM]
            //          componentSize: [Object]
            //          relativeContainer: [DOM]
            //          refContainer: [DOM]
            // tags:
            //      public

            return {
                "component": this._floatingComponent,
                "componentSize": this._getFloatingComponentSize(),
                "relativeContainer": this._floatingRelativeContainer,
                "refContainer": this._floatingRefContainer
            };
        },

        // =======================================================================
        // Overrides public functions

        destroy: function () {

            this._floatingComponentSizeBox = this._floatingComponent = this._floatingRelativeContainer = this._floatingRefContainer = null;
            this._floatingComponentSize = null;

            this.inherited(arguments);
        },

        // =======================================================================
        // Private functions

        _getFloatingComponentSize: function () {
            // summary:
            //      Get scroll information for the external editor toolbar
            // returns: [Object]
            //      Object's properties:
            //          height: [Integer]
            //          width: [Integer]
            // tags:
            //      private

            if (this._floatingComponentSize) {
                return this._floatingComponentSize;
            }

            var floatingComponentSize = domGeometry.getMarginBox(this._floatingComponentSizeBox);

            return this._floatingComponentSize = {
                "height": parseInt(floatingComponentSize.h, 10) + this.componentGutter,
                "width": parseInt(floatingComponentSize.w, 10)
            };
        }

    });

});
},
'url:epi-cms/contentediting/editors/templates/TinyMCEInlineEditor.html':"﻿<div id=\"widget_${id}\" style=\"position: relative; overflow: visible;\">\r\n    <div data-dojo-attach-point=\"stateNode, tooltipNode\">\r\n        <textarea data-dojo-attach-point=\"editorFrame\" id=\"${id}_editorFrame\" style=\"border: none; visibility: hidden; position: absolute; top:0; left:0; bottom:0; right:0;\"></textarea>\r\n    </div>\r\n    <div data-dojo-attach-point=\"dndOverlay\" style=\"background: rgba(0, 0, 0, 0.01); position: absolute; left: 0; top: 0; right: 0; bottom: 0; display: none\"></div>\r\n</div>\r\n",
'epi-cms/contentediting/EditToolbar':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/DeferredList",
    "dojo/dom-class",
    "dojo/topic",
    "dojo/when",

    "dojox/html/ellipsis",

// EPi Framework
    "epi",
    "epi/dependency",
    "epi/shell/widget/ToolbarSet",
    "epi/shell/command/withConfirmation",

// EPi CMS
    "epi-cms/contentediting/command/Editing",
    "epi-cms/contentediting/viewmodel/EditActionPanelViewModel",

    "epi-cms/contentediting/StandardToolbar",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.toolbar.buttons",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel.publishactionmenu",
// Used by the toolbar
    "epi-cms/widget/NotificationStatusBar",
    "epi-cms/contentediting/EditActionPanel"
], function (
// Dojo
    declare,
    lang,
    array,
    DeferredList,
    domClass,
    topic,
    when,

    ellipsis,

// EPi Framework
    epi,
    dependency,
    ToolbarSet,
    withConfirmation,

// EPi CMS
    EditingCommands,
    EditActionPanelViewModel,

    StandardToolbar,

// Resources
    res,
    actionRes
) {

    return declare([StandardToolbar], {
        // summary: A component providing a preview iframe.

        res: res,

        _editActionViewModel: null, //FIXME: This will be a part of the upcoming EditToolbarViewModel.
        _commands: null,

        // _revertToPublished: [withConfirmation]
        //      Wraps the revertToPublishCommand within a confirmation command
        //  tags:
        //      private
        _revertToPublished: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            this._commands = EditingCommands;

            //Wrap the command inside a confirmation dialog
            this._revertToPublished = withConfirmation(this._commands.revertToPublished, null, {
                title: actionRes.reverttopublishconfirmation.dialogtitle,
                heading: actionRes.reverttopublishconfirmation.confirmquestion,
                description: actionRes.reverttopublishconfirmation.description
            });

            this._commands.revertToPublished.watch("canExecute", lang.hitch(this, function () {
                this.setItemProperty(this._commands.revertToPublished.name, "disabled", !this._commands.revertToPublished.canExecute);
            }));

            this._editActionViewModel = new EditActionPanelViewModel();
            this.own(this._editActionViewModel);
        },

        resize: function (changeSize) {
            this.inherited(arguments);
            if (changeSize) {
                domClass.toggle(this.domNode, "epi-editToolbarNarrow", changeSize.w < 620);
                domClass.toggle(this.domNode, "epi-editToolbarMedium", changeSize.w >= 620 && changeSize.w < 1000);

                this._editActionViewModel.set("expanded", changeSize.w >= 1000);

                this.setItemProperty("autosave", "isInNarrowToolbar", changeSize.w < 1000);
            }
        },

        setupChildren: function () {
            var toolbarItems = [
            {
                parent: "center",
                name: "autosave",
                label: this.res.autosave.savinglabel,
                type: "dropdown",
                settings: { "class": "epi-autosave-hidden" }
            },
            {
                parent: "autosave",
                name: "undo",
                title: this.res.undo.title,
                label: epi.resources.action.undo,
                type: "menuitem",
                iconClass: "epi-iconUndo",
                settings: { disabled: true, showLabel: false },
                action: function () {
                    topic.publish("/epi/cms/action/undo", []);
                }
            },
            {
                parent: "autosave",
                name: "redo",
                title: this.res.redo.title,
                label: epi.resources.action.redo,
                type: "menuitem",
                iconClass: "epi-iconRedo",
                settings: { disabled: true, showLabel: false },
                action: function () {
                    topic.publish("/epi/cms/action/redo", []);
                }
            },
            {
                parent: "autosave",
                name: "reverttopublished",
                title: this._commands.revertToPublished.tooltip,
                label: this._commands.revertToPublished.label,
                type: "menuitem",
                iconClass: "epi-iconRevert",
                settings: { separate: true },
                action: lang.hitch(this, function () {
                    this._revertToPublished.execute();
                })
            },
            {
                parent: "trailing",
                name: "notifications",
                widgetType: "epi-cms/widget/NotificationStatusBar"
            },
            {
                name: "editactionpanel",
                label: epi.resources.action.publish,
                parent: "trailing",
                widgetType: "epi-cms/contentediting/EditActionPanel",
                settings: {
                    model: this._editActionViewModel
                }
            },
            {
                parent: "trailing",
                name: "editmodeswitch",
                title: this.res.formedit.title,
                label: this.res.formedit.label,
                widgetType: "dijit/form/ToggleButton",
                iconClass: "epi-iconForms",
                settings: { showLabel: false, "class": "epi-mediumButton epi-modeButton" },
                action: function () {
                    // This action may tear the current view down, including the button it self.
                    // Therefore it should be done when the event chain finished.
                    if (this.get("state") === "Loading") {
                        return;
                    }

                    this.set("state", "Loading");
                    setTimeout(function () {
                        topic.publish("/epi/cms/action/switcheditmode");
                    }, 0);
                }
            }];

            return when(this.inherited(arguments), lang.hitch(this, function () {
                return this.add(toolbarItems);
            }));
        },

        _setContentViewModelAttr: function (value) {
            this._set("contentViewModel", value);

            when(this.isSetup(), lang.hitch(this, function () {
                this._updateToolbarItemsModel(value);
            }));
        },

        _updateToolbarItemsModel: function (contentViewModel) {
            // View mode changes, hide saving button
            this.setItemProperty("autosave", "label", "");
            //The autosave button has epi-autosave-hidden class in order to be hidden when the toolbar is being rendered
            //here we change class for it to be shown
            this.setItemProperty("autosave", "class", "epi-autoSaveButton epi-disabledDropdownArrow");

            var contentData = contentViewModel.contentData;

            this.setItemProperty("notifications", "notificationContext", { contextTypeName: "epi.cms.contentdata", contextId: contentData.contentLink });

            var editModesSwitchTitle = "",
                editModesSwitchLabel = "";

            if (contentViewModel.viewName === "formedit") {
                this.setItemProperty("editmodeswitch", "checked", true);
                editModesSwitchTitle = this.res.onpageedit.title;
                editModesSwitchLabel = this.res.onpageedit.label;
            }
            else {
                this.setItemProperty("editmodeswitch", "checked", false);
                editModesSwitchTitle = this.res.formedit.title;
                editModesSwitchLabel = this.res.formedit.label;
            }

            this.setItemProperty("editmodeswitch", "title", editModesSwitchTitle);
            this.setItemProperty("editmodeswitch", "label", editModesSwitchLabel);

            var hasCustomViews = this._hasCustomViews(this.viewConfigurations.availableViews);
            var hasBuiltInViews = this._hasBuiltInViews(this.viewConfigurations.availableViews);
            this.setItemVisibility("editmodeswitch", !hasCustomViews && hasBuiltInViews && contentData.hasTemplate);
            this.setItemVisibility("viewselect", hasCustomViews);

            this._editActionViewModel.set("dataModel", contentViewModel);
        },

        _hasCustomViews: function (availableViews) {
            return array.filter(availableViews, function (view) {
                return !view.hideFromViewMenu && view.key !== "onpageedit" && view.key !== "formedit";
            }).length;
        },

        _hasBuiltInViews: function (availableViews) {
            // summary:
            //      Determines whether both on-page edit and all properties edit are available views.
            // tags:
            //      private
            return array.filter(availableViews, function (view) {
                return view.key == "onpageedit" || view.key == "formedit";
            }).length == 2;
        }
    });
});

},
'epi-cms/contentediting/viewmodel/EditActionPanelViewModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    "dojo/string",

    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/viewmodel/_ContentViewModelObserver",
    "epi-cms/contentediting/viewmodel/PublishMenuViewModel",

    "epi/datetime",
    "epi/dependency",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel"
],

function (
    array,
    declare,
    lang,
    Stateful,
    dojoString,

    ContentActionSupport,
    _ContentViewModelObserver,
    PublishMenuViewModel,

    datetime,
    dependency,

    res
) {

    return declare([_ContentViewModelObserver], {
        // public view model properties
        state: null,
        buttonText: null,
        statusText: null,
        statusIcon: null,
        additionalClass: null,
        nonEditableIndicator: null,
        visible: null,
        publishMenuViewModel: null,

        inUseNotificationManager: null,

        // Skip child model creation. Used in test environment.
        skipChildModels: false,

        // Private stuffs
        _virtualStatusEnum: {
            NotCreated: 0,
            NotPublishedYet: 1,
            NoChangeToPublish: 2,
            ChangesToPublish: 3,
            ReadyToPublish: 4,
            ScheduledPublish: 5,
            Published: 6,
            PreviouslyPublished: 7,
            Expired: 8,
            InUse: 9,
            Deleted: 10
        },
        _virtualStatusCssState: [],
        _virtualStatusLocalization: [],
        _statusIcon: [],

        _watchers: null,
        _statusMap: {},


        postscript: function () {
            //set up resources
            this.res = this.res || res;

            this.inherited(arguments);

            this.inUseNotificationManager = this.inUseNotificationManager || dependency.resolve("epi.cms.contentediting.inUseNotificationManager");

            // build up virtual status state, localization, and icon
            if (this._virtualStatusCssState.length === 0) {
                for (var status in this._virtualStatusEnum) {
                    this._virtualStatusCssState.push(status);
                    this._virtualStatusLocalization.push(this.res["status"][status.toLowerCase()]);
                }

                this._statusMap[ContentActionSupport.versionStatus.CheckedOut] = this._virtualStatusEnum.NotPublishedYet;
                this._statusMap[ContentActionSupport.versionStatus.CheckedIn] = this._virtualStatusEnum.ReadyToPublish;
                this._statusMap[ContentActionSupport.versionStatus.Rejected] = this._virtualStatusEnum.ChangesToPublish;
                this._statusMap[ContentActionSupport.versionStatus.DelayedPublish] = this._virtualStatusEnum.ScheduledPublish;
                this._statusMap[ContentActionSupport.versionStatus.Published] = this._virtualStatusEnum.Published;
                this._statusMap[ContentActionSupport.versionStatus.PreviouslyPublished] = this._virtualStatusEnum.PreviouslyPublished;
                this._statusMap[ContentActionSupport.versionStatus.Expired] = this._virtualStatusEnum.Expired;

                this._statusIcon[ContentActionSupport.versionStatus.DelayedPublish] = "epi-iconClock";
                this._statusIcon[ContentActionSupport.versionStatus.Rejected] = "epi-iconStop";
            }

            //create child models
            if (!this.skipChildModels) {
                this.publishMenuViewModel = new PublishMenuViewModel({
                    inUseNotificationManager: this.inUseNotificationManager
                });
            }  
        },

        destroy: function () {
            if (this.publishMenuViewModel) {
                this.publishMenuViewModel.destroy();
            }
            this.inherited(arguments);
        },

        _setDataModelAttr: function (value) {
            this.inherited(arguments);
            if (this.publishMenuViewModel) {
                this.publishMenuViewModel.set("dataModel", value);
            }
        },

        onDataModelChange: function (name, oldValue, value) {
            var contentData = this.dataModel.contentData,
                virtualStatus = this._getVirtualStatus(contentData);

            this.set("state", this._virtualStatusCssState[virtualStatus]);

            this.set("additionalClass", virtualStatus === this._virtualStatusEnum.ChangesToPublish ? "animated8 shake" : "");

            this._setStatusText(virtualStatus, contentData);

            this.set("buttonText", this._getButtonText(virtualStatus, contentData));

            this.set("statusIcon", this._statusIcon[contentData.versionStatus] || "");

            var contentEditable = this.dataModel.canChangeContent(ContentActionSupport.action.Edit);

            this.set("nonEditableIndicator", !contentEditable);

            this.set("visible", !contentData.isWastebasket);
        },

        _setStatusText: function (virtualStatus, contentData) {
            if (contentData.status === ContentActionSupport.versionStatus.DelayedPublish) {
                this.set("statusText", dojoString.substitute(this._virtualStatusLocalization[virtualStatus],
                    [datetime.toUserFriendlyHtml(contentData.properties.iversionable_startpublish)]));
            }
            else if (virtualStatus === this._virtualStatusEnum.InUse) {
                var userList = this.inUseNotificationManager.getOtherUsersInUseNotifications(contentData.inUseNotifications);
                this.set("statusText", dojoString.substitute(this._virtualStatusLocalization[virtualStatus], [userList.join(",")]));
            }
            else {
                this.set("statusText", this._virtualStatusLocalization[virtualStatus]);
            }
        },

        _getButtonText: function (virtualStatus, contentData) {
            if ((virtualStatus == this._virtualStatusEnum.NotPublishedYet ||
                virtualStatus == this._virtualStatusEnum.ChangesToPublish ||
                virtualStatus == this._virtualStatusEnum.ReadyToPublish) &&
                this.dataModel.canChangeContent(ContentActionSupport.action.Publish)) {

                return this.res.buttonlabel.publish;
            }
            else {
                return this.res.buttonlabel.option;
            }
        },

        _getVirtualStatus: function (contentData) {
            if (contentData.isDeleted) {
                return this._virtualStatusEnum.Deleted;
            }

            var ignoreFlag, originallyEditable, hasInUseNotificationWarning;

            // Temporarily ignore inuse notification warning to check original editable status
            ignoreFlag = this.inUseNotificationManager.ignoreOthersNotifications;
            this.inUseNotificationManager.ignoreOthersNotifications = true;
            originallyEditable = this.dataModel.canChangeContent();
            this.inUseNotificationManager.ignoreOthersNotifications = ignoreFlag;

            hasInUseNotificationWarning = this.inUseNotificationManager.hasInUseNotificationWarning(contentData.inUseNotifications);

            if (hasInUseNotificationWarning && originallyEditable) {
                return this._virtualStatusEnum.InUse;
            }

            if (contentData.isCommonDraft) {
                if (contentData.status === ContentActionSupport.versionStatus.Published) {
                    return this._virtualStatusEnum.NoChangeToPublish;
                }
                if (contentData.status === ContentActionSupport.versionStatus.CheckedOut) {
                    return contentData.isMasterVersion ? this._virtualStatusEnum.NotPublishedYet : this._virtualStatusEnum.ChangesToPublish;
                }
            }

            return this._statusMap[contentData.status];
        }
    });
});
},
'epi-cms/contentediting/viewmodel/_ContentViewModelObserver':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/Stateful",
    "epi/shell/_StatefulGetterSetterMixin"
    ],

function (
    declare,
    array,
    lang,
    Stateful,
    _StatefulGetterSetterMixin) {

    return declare([Stateful, _StatefulGetterSetterMixin], {
        // contentViewModel: [public] epi.cms.contentediting.ContentViewModel
        dataModel: null,

        _watchers: null,

        destroy: function () {
            this._unbindDataModel();
        },

        _bindDataModel: function () {
            this._watchers.push(this.dataModel.watch("status", lang.hitch(this, this.onDataModelChange)));
            this._watchers.push(this.dataModel.watch("contentData", lang.hitch(this, this.onDataModelChange)));
        },

        _unbindDataModel: function () {
            array.forEach(this._watchers, function (w) { w.unwatch(); });
            this._watchers = [];
        },

        _setDataModelAttr: function (value) {
            this._unbindDataModel();
            this._set("dataModel", value);
            this.onDataModelChange();
            this._bindDataModel();
        },

        onDataModelChange: function (name, oldValue, value) {
            // when data model changes, update view model properties accordingly.
        }

    });
});

},
'epi-cms/contentediting/viewmodel/PublishMenuViewModel':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "epi",
    "epi/datetime",
    "epi/dependency",
    "epi/username",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/viewmodel/_ContentViewModelObserver",
    "epi/shell/command/_CommandConsumerMixin",
    "epi/shell/command/_GlobalCommandProviderMixin",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.editactionpanel.publishactionmenu"
    ],

function (
    declare,
    lang,
    epi,
    epiDate,
    dependency,
    username,
    ContentActionSupport,
    _ContentViewModelObserver,
    _CommandConsumerMixin,
    _GlobalCommandProviderMixin,
    res
    ) {

    return declare([_ContentViewModelObserver, _CommandConsumerMixin, _GlobalCommandProviderMixin], {
        commandKey: "epi.cms.publishmenu",

        contentActionSupport: null,
        inUseNotificationManager: null,

        _currentUser: null,

        // Declare view model properties
        // ---------------------------------------------------------------------

        commands: null,
        mainButtonCommand: null,
        lastExecutedCommand: null,

        mainButtonSectionVisible: null,

        lastChangeStatus: null,

        topInfoSectionVisible: null,

        publishInfoSectionVisible: null,
        lastPublishedText: null,
        lastPublishedViewLinkVisible: null,
        lastPublishedViewLinkHref: null,

        additionalInfoSectionVisible: null,
        additionalInfoText: null,

        isOpen: null,

        typeIdentifier: null,

        // Methods
        // ---------------------------------------------------------------------
        postscript: function () {
            this.inherited(arguments);

            this.res = this.res || res;
            this.contentActionSupport = this.contentActionSupport || ContentActionSupport;
            this.initializeCommandProviders();
        },

        _setDataModelAttr: function (value) {
            this.updateCommandModel(value);
            this.inherited(arguments);
        },

        _setIsOpenAttr: function (value) {
            if (value) {
                this.set("lastChangeStatus", this._getLastChangeStatus(this.dataModel.contentData));
            }
        },

        onDataModelChange: function (name, oldValue, value) {
            // when data model changes, update view model properties accordingly.
            var contentData = this.dataModel.contentData,
                contentHasPublishedVersion = (contentData.publishedBy !== null && contentData.publishedBy !== undefined);

            // Update commands
            this._updateCommands();

            // Update other properties
            // -----------------------------------------------------------------------------

            this.set("lastChangeStatus", this._getLastChangeStatus(contentData));

            // Top info section should be invisible if there is no main command and content is non-commondraft published version.
            this.set("topInfoSectionVisible", this._getTopInfoSectionVisible(contentData));

            this.set("publishInfoSectionVisible", this._getPublishInfoSectionVisible(contentData));
            this.set("lastPublishedTitle", this._getLastPublishedTitle(contentData));
            this.set("lastPublishedTitleVisible", contentHasPublishedVersion);
            this.set("lastPublishedText", this._getLastPublishedText(contentData));
            this.set("lastPublishedViewLinkVisible", this._getLastPublishedViewLinkVisible(contentData, contentHasPublishedVersion));
            this.set("lastPublishedViewLinkHref", contentData.publicUrl);

            this.set("typeIdentifier", contentData.typeIdentifier);

            this._setAdditionalInfo(contentData);
        },

        _updateCommands: function () {
            var commands = this.getCommands(),
                mainCommand = null;
            dojo.forEach(commands, dojo.hitch(this, function (command) {
                if (command.canExecute &&
                    command.options && command.options.isMain && command.options.priority && (!mainCommand || mainCommand.options.priority < command.options.priority)) {

                    mainCommand = command;
                }
            }));

            this.set("mainButtonCommand", mainCommand);
            this.set("commands", commands);
            this.set("mainButtonSectionVisible", mainCommand !== null);
        },

        _getTopInfoSectionVisible: function (contentData) {
            return this.mainButtonCommand || !((contentData.status === ContentActionSupport.versionStatus.Published ||
                contentData.status === ContentActionSupport.versionStatus.Expired) && !contentData.isCommonDraft);
        },

        _getPublishInfoSectionVisible: function (contentData) {
            // REMARK: Make it possible to do this in a plugin

            var hasInUseNotificationWarning = this.inUseNotificationManager.hasInUseNotificationWarning(contentData.inUseNotifications),
                originallyEditable = this._isOriginallyEditable();

            return !(hasInUseNotificationWarning && originallyEditable);
        },

        _getLastPublishedViewLinkVisible: function (contentData, contentHasPublishedVersion) {
            return contentHasPublishedVersion && !!contentData.publicUrl;
        },

        _getLastChangeStatus: function (contentData) {
            if (this.lastExecutedCommand && this.lastExecutedCommand.options && this.lastExecutedCommand.options.successStatus) {
                var successStatus = this.lastExecutedCommand.options.successStatus;
                this.lastExecutedCommand = this.mainButtonCommand;
                return successStatus;
            }

            if (contentData.missingLanguageBranch && contentData.missingLanguageBranch.isTranslationNeeded) {
                return lang.replace(this.res.nottranslated, {
                    languageName: epi.resources.language[contentData.missingLanguageBranch.languageId],
                    languageId: contentData.missingLanguageBranch.languageId
                });
            }

            if (contentData.status == ContentActionSupport.versionStatus.Published ||
                contentData.status == ContentActionSupport.versionStatus.Expired) {
                return this.res.notmodifiedsincelastpublish;
            }

            if (contentData.status == ContentActionSupport.versionStatus.PreviouslyPublished) {
                return this._getTemplatedText(this.res.previouslypublished, contentData.versionCreatedBy, contentData.versionCreatedTime);
            }

            if (contentData.status == ContentActionSupport.versionStatus.CheckedIn) {
                return this._getTemplatedText(this.res.pendingapproval, contentData.versionCreatedBy, contentData.versionCreatedTime);
            }

            return this._getTemplatedText(this.res.lastchangestatus, contentData.changedBy, contentData.saved);
        },

        _getLastPublishedTitle: function (contentData) {
            return contentData.status === ContentActionSupport.versionStatus.PreviouslyPublished ?
                this.res.currentlypublished : this.res.lastpublishedby;
        },

        _getLastPublishedText: function (contentData) {
            return (contentData.publishedBy === null || contentData.publishedBy === undefined) ?
                this.res.notpublishedbefore :
                this._getTemplatedText(this.res.publishedtime, contentData.publishedBy, contentData.lastPublished, true);
        },

        _setAdditionalInfo: function (contentData) {
            // REMARK: Make it possible to do this in a plugin

            var hasInUseNotificationWarning = this.inUseNotificationManager.hasInUseNotificationWarning(contentData.inUseNotifications),
                originallyEditable = this._isOriginallyEditable(),
                visible = hasInUseNotificationWarning && originallyEditable;

            this.set("additionalInfoSectionVisible", visible);

            if (visible) {
                var userList = this.inUseNotificationManager.getOtherUsersInUseNotifications(contentData.inUseNotifications);
                this.set("additionalInfoText", this._getTemplatedText(this.res.inusewarning, userList.join(",")));
            }
        },

        _isOriginallyEditable: function () {
            // Temporarily ignore inuse notification warning to check original editable status
            var ignoreFlag = this.inUseNotificationManager.ignoreOthersNotifications;
            this.inUseNotificationManager.ignoreOthersNotifications = true;

            var originallyEditable = this.dataModel.canChangeContent();

            this.inUseNotificationManager.ignoreOthersNotifications = ignoreFlag;

            return originallyEditable;
        },

        _getFriendlyUsername: function (name, capitalizeUsername) {
            // summary:
            //      Get friendly username: if the username to be displayed is the same
            //      as the current username, this will returns "you"
            // name:
            //      the username to be displayed
            // capitalizeUsername:
            //      If the first character should always be displayed with upper case.
            // tag:
            //      private

            return username.toUserFriendlyHtml(name, null, capitalizeUsername);
        },

        _getTemplatedText: function (template, username, datetime, capitalizeUsername) {
            // summary:
            //      Return text represent last update time
            // tag:
            //      private

            var date = epiDate.deserialize(datetime);

            return dojo.replace(template, {
                username: this._getFriendlyUsername(username, capitalizeUsername),
                time: epiDate.toUserFriendlyHtml(date),
                timepassed: epiDate.timePassed(date)
            });
        }
    });
});

},
'epi-cms/contentediting/StandardToolbar':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/when",
    "dijit/form/DropDownButton",
    "epi/shell/layout/ToolbarContainer",
    "epi/shell/widget/ToolbarLabel",
    "epi/shell/widget/ToolbarSet",
    "epi-cms/widget/Breadcrumb",
    "epi-cms/widget/BreadcrumbCurrentItem",
    "epi-cms/widget/ViewSelectorDropDownButton"
], function (declare, lang, all, when, DropDownButton, ToolbarContainer, ToolbarLabel, ToolbarSet, Breadcrumb, BreadcrumbCurrentItem, ViewSelectorDropDownButton) {

    return declare([ToolbarSet], {

        // currentContext: [public] Object
        //      An object with the current context information.
        currentContext: null,

        // availableViews: [public] Array
        //      List of available views.
        availableViews: null,

        // viewName: [public] String
        //      The current view name.
        viewName: null,

        // _setupPromise: [private] String
        //      The setup children promise.
        _setupPromise: null,

        buildRendering: function() {
            // summary:
            //      Constructs the toolbar container and starts the children setup process.
            // tags:
            //      protected

            this.inherited(arguments);

            // Setup the children items in the toolbar.
            when(this._setupPromise = this.setupChildren(), lang.hitch(this, function () {
            // Update the toolbar items with the current model.
            this.updateChildren();
            }));
        },

        isSetup: function () {
            // summary:
            //      Wait for setup to finish.
            // tags:
            //      protected

            return this._setupPromise;
        },

        setupChildren: function() {
            // summary:
            //      Setup the items in the toolbar. Inheriting classes should extend this to add more items to the toolbar.
            // tags:
            //      protected

            var toolbarGroups = [
            {
                name: "leading",
                type: "toolbargroup",
                settings: { region: "leading" }
            },
            {
                name: "center",
                type: "toolbargroup",
                settings: { region: "center" }
            },
            {
                name: "trailing",
                type: "toolbargroup",
                settings: { region: "trailing" }
            }];

            var toolbarItems = [
            {
                parent: "leading",
                name: "breadcrumbs",
                widgetType: "epi-cms/widget/Breadcrumb",
                settings: {
                    displayAsText: false,
                    showCurrentNode: false
                }
            },
            {
                parent: "trailing",
                name: "viewselect",
                widgetType: "epi-cms/widget/ViewSelectorDropDownButton",
                settings: {
                    showLabel: false,
                    "class": "epi-mediumButton epi-trailingContainer"
                }
            },
            {
                parent: "leading",
                name: "currentcontent",
                widgetType: "epi-cms/widget/BreadcrumbCurrentItem"
            }];

            return when(this.add(toolbarGroups), lang.hitch(this, function () {
                return this.add(toolbarItems);
            }));
        },

        updateChildren: function() {
            // summary:
            //      Update the toolbar items. This method is called on startup and whenever the current context is set.
            // tags:
            //      protected

            var context = this.currentContext,
                contentLink = context && context.id;

            this.setItemProperty("breadcrumbs", "contentLink", contentLink);
            this.setItemProperty("viewselect", "viewConfigurations", this.viewConfigurations);
            if (context) {
                this.setItemProperty("currentcontent", "currentItemInfo", {
                    name: context.name,
                    dataType: context.dataType
                });
            }
        },

        update: function(data) {
            // summary:
            //      Update the toolbar with new data.
            // data:
            //      Toolbar data model. Expected properties are: currentContext and viewConfigurations
            // tags:
            //      public

            if (!data) {
                return;
            }

            this.currentContext = data.currentContext;
            this.viewConfigurations = data.viewConfigurations;

            when(this.isSetup(), lang.hitch(this, function () {
                this.updateChildren();
            }));
        }
    });
});
},
'epi-cms/widget/ViewSelectorDropDownButton':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/form/DropDownButton",
    "epi-cms/widget/ViewSelector",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.viewselector"
], function (
    array,
    declare,
    lang,
    DropDownButton,
    ViewSelector,
    resources) {

    return declare([DropDownButton], {

        buildRendering: function () {
            // summary:
            //      Constructs the toolbar container and starts the children setup process.
            // tags:
            //      protected

            this.inherited(arguments);
            this.set("title", resources.title);
            this.own(this.dropDown = new ViewSelector());
        },

        _setViewConfigurationsAttr: function (value) {
            // summary:
            //      Set view configurations attribute.
            // tags:
            //      protected

            if (!value) {
                return;
            }

            // Update the button's icon using the current view's icon
            array.some(value.availableViews, lang.hitch(this, function (view) {
                if (view.key === value.viewName) {
                    this.set("iconClass", view.iconClass);
                    return true;
                }
            }));

            this.dropDown.set("viewConfigurations", value);
        }
    });
});
},
'epi-cms/widget/ViewSelector':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",

    // dijit
    "dijit/MenuSeparator",

    // Resouces
    "epi/i18n!epi/cms/nls/episerver.cms.widget.viewselector",

    // Widgets used in template
    "epi-cms/widget/SelectorMenuBase",
    "epi/shell/widget/CheckedMenuItem"
], function (
    array,
    declare,
    lang,
    topic,
    when,

    // dijit
    MenuSeparator,

    // Resouces
    resources,

    SelectorMenuBase,
    CheckedMenuItem
) {
    // module:
    //      epi-cms/widget/DisplayOptionSelector
    // summary:
    //      Used for selecting display options for a block in a content area
    return declare([SelectorMenuBase], {
        // viewConfigurations: [protected] Object
        //      The view configurations
        viewConfigurations: null,

        headingText: resources.title,

        _setViewConfigurationsAttr: function (value) {
            // summary:
            //      Set view configurations attribute.
            // tags:
            //      protected

            this._set("viewConfigurations", value);

            this._setup();
        },

        onExecute: function () {
            // summary:
            //	    Triggered when a menu item selected.
            // tag:
            //		public, callback
        },

        onCancel: function () {
            // summary:
            //	    Triggered when the menu closed.
            // tag:
            //		public, callback
        },

        _setup: function () {
            if (!this.viewConfigurations) {
                return;
            }

            // Remove the old menu items
            array.forEach(this.getChildren(), lang.hitch(this, this.removeChild));

            var currentView = this.viewConfigurations.viewName,
                availableViews = this.viewConfigurations.availableViews;

            var lastCategory = "";
            array.forEach(availableViews, function (view) {
                if (view.hideFromViewMenu) {
                    return;
                }

                var category = view.category || "";
                if (category != lastCategory) {
                    this.addChild(new MenuSeparator({ baseClass: "epi-menuSeparator" }));
                }
                lastCategory = category;

                var item = new CheckedMenuItem({
                    label: view.name,
                    title: view.description,
                    iconClass: view.iconClass,
                    checked: view.key === currentView,
                    onClick: lang.hitch(this, function () {
                        this.onExecute();
                        item.set("checked", !item.checked); // we dont want to switch checked state on this item when clicking it.
                        if (currentView == "view"){
                            topic.publish("/epi/cms/action/disablepreview");
                        }
                        topic.publish("/epi/shell/action/changeview", view.key, null, null);
                    })
                });

                this.addChild(item);
            }, this);
        }
    });
});
},
'epi/shell/widget/CheckedMenuItem':function(){
require({cache:{
'url:epi/shell/widget/templates/CheckedMenuItem.html':"﻿<tr class=\"dijitReset dijitMenuItem\" data-dojo-attach-point=\"focusNode\" role=\"menuitemcheckbox\" tabIndex=\"-1\">\r\n\t<td class=\"dijitReset dijitMenuItemIconCell\" role=\"presentation\">\r\n\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitMenuItemIcon dijitCheckedMenuItemIcon\"/>\r\n\t\t<img src=\"${_blankGif}\" data-dojo-attach-point=\"iconNode\"/>\r\n\t\t<span class=\"dijitCheckedMenuItemIconChar\">&#10003;</span>\r\n\t</td>\r\n\t<td class=\"dijitReset dijitMenuItemLabel\" colspan=\"2\" data-dojo-attach-point=\"containerNode,labelNode\"></td>\r\n\t<td class=\"dijitReset dijitMenuItemAccelKey\" style=\"display: none\" data-dojo-attach-point=\"accelKeyNode\"></td>\r\n\t<td class=\"dijitReset dijitMenuArrowCell\" role=\"presentation\">&#160;</td>\r\n</tr>\r\n"}});
﻿define("epi/shell/widget/CheckedMenuItem", [
	"dojo/_base/declare", // declare
	"dijit/CheckedMenuItem",
    "dojo/text!./templates/CheckedMenuItem.html"
], function (declare, CheckedMenuItem, template) {

    // module:
    //		epi/shell/widget/CheckedMenuItem

    return declare(CheckedMenuItem, {
        // summary:
        //		A checkbox-like menu item for toggling on and off

        // templateString: String
        //      The widget template string.
        templateString: template
    });
});

},
'url:epi/shell/widget/templates/CheckedMenuItem.html':"﻿<tr class=\"dijitReset dijitMenuItem\" data-dojo-attach-point=\"focusNode\" role=\"menuitemcheckbox\" tabIndex=\"-1\">\r\n\t<td class=\"dijitReset dijitMenuItemIconCell\" role=\"presentation\">\r\n\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitMenuItemIcon dijitCheckedMenuItemIcon\"/>\r\n\t\t<img src=\"${_blankGif}\" data-dojo-attach-point=\"iconNode\"/>\r\n\t\t<span class=\"dijitCheckedMenuItemIconChar\">&#10003;</span>\r\n\t</td>\r\n\t<td class=\"dijitReset dijitMenuItemLabel\" colspan=\"2\" data-dojo-attach-point=\"containerNode,labelNode\"></td>\r\n\t<td class=\"dijitReset dijitMenuItemAccelKey\" style=\"display: none\" data-dojo-attach-point=\"accelKeyNode\"></td>\r\n\t<td class=\"dijitReset dijitMenuArrowCell\" role=\"presentation\">&#160;</td>\r\n</tr>\r\n",
'epi-cms/widget/NotificationStatusBar':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/keys",

// dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/BorderContainer",

// dojox
    "dojox/html/entities",

// epi
    "epi/dependency",
    "epi-cms/widget/NotificationStatusZone",
    "epi-cms/widget/TooltipDialog",

// resources
    "dojo/text!./templates/NotificationStatusBar.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.statusbar.notificationstatus"
],

function (
// dojo
    array,
    declare,
    event,
    lang,
    domClass,
    keys,

// dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    BorderContainer,

// dojox
    entities,

// epi
    dependency,
    NotificationStatusZone,
    TooltipDialog,

// resources
    template,
    nlsNotificationstatus
) {
    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin], {

        res: nlsNotificationstatus,

        templateString: template,

        _itemTemplate: "<li>{message}</li>",

        _notificationTooltipDialogCssClass: 'epi-notificationToolipDialog epi-notificationToolipDialogCompact',

        _dimmedOutCssClass: 'epi-notificationIcon-DimmedOut',

        _notificationErrorClass: 'epi-notificationIcon-Error',

        _notificationWarningClass: 'epi-notificationIcon-Warning',

        _notificationNoteClass: 'epi-notificationIcon-Note',

        _totalNotifications: 0,

        messageContext: null,

        _tooltipDialog: null,

        messageService: null,

        _observeHandle: null,

        zoneContainer: null,

        // notificationContext: [public] Object
        //		The notificationContext for which information will be displayed.
        notificationContext: null,

        baseClass: "epi-notificationIcon",

        postMixInProperties: function () {

            this.inherited(arguments);

            this.messageService = this.messageService || dependency.resolve("epi.shell.MessageService");
        },

        postCreate: function () {
            // summary:
            //    Inits notification status bar.
            // tags:
            //    public

            this.inherited(arguments);

            this._tooltipDialog = new TooltipDialog({
                connectorMargin: 47,
                hideOnBlur: true,
                content: this.zoneLayoutNode
            });

            this._buildIconBlock();

            // Css class for notification status bar, overrides connector top styles
            domClass.add(this._tooltipDialog.domNode, this._notificationTooltipDialogCssClass);

            this.connect(this.domNode, 'onclick', lang.hitch(this, this._show));
            this.connect(this.domNode, "onkeypress", lang.hitch(this, this._onKeyPress));
            this.connect(this.closeIcon, 'onclick', lang.hitch(this, this._hideTooltip));
        },

        update: function (/*Object*/newMessageContext) {
            // summary:
            //    Updates notification context with the new context
            // newMessageContext:
            //    Query to find message belong to.
            // tags:
            //    public

            this._hideTooltip();
            this.messageContext = newMessageContext;
            this._listenMessagePool();
            this._updateUI();
        },

        destroy: function () {
            // summary:
            //    Destroy this widget, removes handler event used, ready for GC
            //
            // tags:
            //    public

            this._unListenMessagePool();
            this.inherited(arguments);
        },

        focus: function () {
            // summary: 
            //      Set focus on the widget.
            // tags:
            //      public

            this.domNode.focus(); // No focusNode
        },

        show: function () {
            // summary:
            //    Show tooltip for the widget, force show from other widget (i.e: StatusBar)
            // tags:
            //    public
            this._keepShowing = true;
            this._showTooltip();
        },

        getMessages: function (messageType) {
            // summary:
            //    Gets messages from message service pool
            // tags:
            //    private

            var query = (messageType) ? lang.mixin({ typeName: messageType }, this.messageContext) : this.messageContext;
            return this.messageService.query(query);
        },

        _onKeyPress: function (evt) {
            if (evt.keyCode === keys.ENTER) {
                this._show();
            }
        },

        _listenMessagePool: function () {
            // summary:
            //    Listens change on current page in Message Services
            //    Server in case validate on Edit
            // tags:
            //    private
            this._unListenMessagePool();
            this._observeHandle = this.messageService.observe(this.messageContext, lang.hitch(this, function () {
                this._updateUI();
            }));
        },

        _unListenMessagePool: function () {
            // summary:
            //    Cancels listen change on current page in Message Services
            // tags:
            //    private

            if (this._observeHandle) {
                this._observeHandle.cancel();
                delete this._observeHandle;
            }
        },

        _updateNotificationZone: function (zone, itemTemplate, items) {
            if (items && items.length > 0) {
                array.forEach(items, function (item) {
                    zone.addRow(lang.replace(itemTemplate, { message: entities.encode(item.message) }), "last");
                });
                zone.show();
            } else {
                zone.hide();
            }
        },

        _updateUI: function () {
            // summary:
            //    Re-renders the UI of widget.
            // tags:
            //    private

            // empty zone content
            this.errorZone.empty();
            this.warningZone.empty();
            this.infoZone.empty();

            // Get notification types to be updated
            var errors = this.getMessages("error");
            var warnings = this.getMessages("warn");
            var information = this.getMessages("info");

            this._totalNotifications = errors.length + warnings.length + information.length;

            this._buildIconBlock();

            // update "error" zone
            this._updateNotificationZone(this.errorZone, this._itemTemplate, errors);
            // update "warning" zone
            this._updateNotificationZone(this.warningZone, this._itemTemplate, warnings);
            // update "note" zone
            this._updateNotificationZone(this.infoZone, this._itemTemplate, information);

            this._updateIconStatus(errors.length, warnings.length, information.length);
        },

        _buildIconBlock: function () {
            // summary:
            //    Setup status bar notification icon
            // tags:
            //    private

            this.domNode.innerHTML = this._totalNotifications;

            if (this._totalNotifications === 0) {
                domClass.add(this.domNode, this._dimmedOutCssClass);
                domClass.remove(this.domNode, this._notificationNoteClass);
                domClass.remove(this.domNode, this._notificationWarningClass);
                domClass.remove(this.domNode, this._notificationErrorClass);
                this._hideTooltip();
            } else {
                domClass.remove(this.domNode, this._dimmedOutCssClass);
            }
        },

        _updateIconStatus: function (errors, warnings, information) {
            // Set class on notification badge
            if (errors) {
                domClass.add(this.domNode, this._notificationErrorClass);
                domClass.remove(this.domNode, this._notificationNoteClass);
                domClass.remove(this.domNode, this._notificationWarningClass);
            } else if (warnings) {
                domClass.add(this.domNode, this._notificationWarningClass);
                domClass.remove(this.domNode, this._notificationNoteClass);
            } else if (information) {
                domClass.add(this.domNode, this._notificationNoteClass);
            }
        },

        _setNotificationContextAttr: function (value) {
            this._set("notificationContext", value);
            this.update(value);
        },

        _show: function (e) {
            // summary:
            //    Show tooltip for the widget
            // tags:
            //    private

            if (e) {
                event.stop(e);
            }

            this._showTooltip();
        },

        _showTooltip: function () {
            // summary:
            //    Show tooltip for the widget
            // tags:
            //    private

            if (this._totalNotifications === 0) {
                return;
            }

            this._tooltipDialog.showTooltipDialog(this.domNode, ['below-alt']);
        },

        _hideTooltip: function () {
            // summary:
            //    Hide tooltip for widget
            // tags:
            //    private

            this._tooltipDialog.hideTooltipDialog();
        }
    });
});
},
'epi-cms/widget/NotificationStatusZone':function(){
﻿define([
"dojo",
"dojo/_base/declare",
"dijit/_Widget",
"dijit/_TemplatedMixin"
],
function (dojo, declare, _Widget, _TemplatedMixin) {
    // summary: This widget only use for [epi/cms/widget/NotificationStatusBar]
    return declare([_Widget, _TemplatedMixin], {
        templateString: '\
            <div>\
                <div class="epi-dijitTooltipNotificationBlock epi-dijitTooltipBlock${TypeName}" data-dojo-attach-point="Zone">\
                    <span class="epi-notificationTypeTitle"><span class="dijitIcon dijitInline epi-dijitTooltip${TypeName}Icon"></span>${title}</span>\
                    <ul data-dojo-attach-point="contentContainer"></ul>\
                </div>\
            </div>',
        title: "", // String: Title of the zone
        type: "", // String: Type of the zone,
        TypeName: "", // String: Name of Type of the zone with title casing

        _hiddenCssClass: 'epi-dijitTooltipBlockHidden',

        postMixInProperties: function () {
            this.TypeName = this.type.charAt(0).toUpperCase() + this.type.slice(1);
        },

        empty: function () {
            // summary:
            //    Clears content of the area.
            // tags:
            //    public
            dojo.empty(this.contentContainer);
        },

        addRow: function (itemHTML, position) {
            // summary:
            //    Adds new row to area content.
            // itemHTML: String
            //    HTML string of row will be added to area
            // position: String
            //    Position of row was added ("begin", "last")
            // tags:
            //    public
            dojo.place(itemHTML, this.contentContainer, position);
        },

        show: function () {
            // summary:
            //    Shows the area content.
            // tags:
            //    public
            dojo.removeClass(this.Zone, this._hiddenCssClass);
        },

        hide: function () {
            // summary:
            //    Hides the area content.
            // tags:
            //    public
            dojo.addClass(this.Zone, this._hiddenCssClass);
        }
    });
});
},
'epi-cms/widget/TooltipDialog':function(){
﻿define([
"dojo",
"dojo/number",
"dijit",
"dijit/TooltipDialog",
"dijit/_Widget",
"dijit/_TemplatedMixin",
"dojo/text!./templates/TooltipDialog.html"
],

function (dojo, number, dijit, TooltipDialog, _Widget, _TemplatedMixin, template) {
    return dojo.declare([TooltipDialog], {
        templateString: template,

        connectorMargin: 25, // Changable margin (left or right) for tooltip dialog connector
        _defaultConnectorMargin: 25, // Default margin (left or right) for tooltip dialog connector

        hideOnBlur: false,

        _isFirstShow: false,

        _beforeCssClass: 'epi-dijitTooltipBefore', // Customized css class for before orient
        _afterCssClass: 'epi-dijitTooltipAfter', // Customized css class for after orient

        _pos: 0,
        _defaultConnectorRight: 0, // Default margin right for tooltip dialog connector, will be set on the first tooltip show
        _defaultConnectorLeft: 0, // Default margin left for tooltip dialog connector, will be set on the first tooltip show

        _wrapperPosX: 0,
        _availableSpace: 0,
        _right: 0,
        _left: 0,

        onBlur: function () {
            this.inherited(arguments);

            if (this.hideOnBlur) {
                this.hideTooltipDialog();
            }
        },

        postCreate: function () {
            // summary:
            //    Inits tooltip dialog
            // tags:
            //    public

            this.inherited(arguments);

            // Set the default value for connector margin (left or right)
            if (!this.connectorMargin || !number.parse(this.connectorMargin) || this.connectorMargin === "" || this.connectorMargin < this._defaultConnectorMargin) {
                this.connectorMargin = this._defaultConnectorMargin;
            }
        },

        showTooltipDialog: function (target, orient) {
            // summary:
            //    Simply show tooltip dialog like dijit tooltip
            // tags:
            //    public

            dijit.popup.open({
                popup: this,
                around: target,
                orient: orient
            });

            if (this.hideOnBlur) {
                this.focus();
            }
        },

        hideTooltipDialog: function () {
            // summary:
            //    Simply hide tooltip dialog like dijit tooltip
            // tags:
            //    public

            dijit.popup.close(this);
        },

        onOpen: function (pos) {
            // summary:
            //    Overrides from dijit TooltipDialog
            // tags:
            //    extended

            this._pos = pos; // Save position object to use on _onShow()
            this.inherited(arguments);
        },

        _onShow: function () {
            // summary:
            //    Overrides from ContentPane
            // tags:
            //    extended

            this._setDefaultValues();
            this._updatePositions();

            this.inherited(arguments);
        },

        _setDefaultValues: function () {
            // summary:
            //    Sets default values
            // tags:
            //    private

            // Set default connector right and left margins on first show
            if (!this._isFirstShow) {
                this._defaultConnectorRight = this._getConnectorSpace('right') || this._defaultConnectorMargin;
                this._defaultConnectorLeft = this._getConnectorSpace('left') || this._defaultConnectorMargin;
                this._isFirstShow = true;
            }

            this._wrapperPosX = number.parse(this._pos.x); // Get position x of the tooltip dialog wrapper tag
            this._availableSpace = dojo.body().clientWidth; // Get full visible width of browser

            // Set position of tooltip connector to center vertical of around node
            if (this._pos.aroundCorner == 'MR' || this._pos.aroundCorner == 'ML') {
                var positionTop = number.round((this._pos.h - this.connectorNode.clientHeight) / 2);
                dojo.style(this.connectorNode, 'top', this._getNumberInPx(positionTop));
            }
        },

        _updatePositions: function () {
            // summary:
            //    Updates positions of tooltip dialog's connector and tooltip dialog
            // tags:
            //    private

            switch (this._pos.aroundCorner) {
                // Top right or bottom right of around node (by set above or below in orient)   
                case 'TR':
                case 'BR':
                    // Calculates to set connector node point to center horizontal of around node
                    this._calculateConnectorMarginRight();
                    this._calculateAvailableSpaceLeft();
                    this._updateAlignedRightPositions();
                    break;
                // Top left or bottom left of around node (by set above or below in orient)   
                case 'TL':
                case 'BL':
                    // Calculates to set connector node point to center horizontal of around node
                    this._calculateConnectorMarginLeft();
                    this._calculateAvailableSpaceRight();
                    this._updateAlignedLeftPositions();
                    break;
                // Middle right of around node (by set after in orient)   
                case 'MR':
                    dojo.addClass(this.domNode, this._afterCssClass);
                    break;
                // Middle left of around node (by set before in orient)   
                case 'ML':
                    dojo.addClass(this.domNode, this._beforeCssClass);
                    break;
                default:
                    break;
            }
        },

        _updateAlignedRightPositions: function () {
            // summary:
            //    Updates positions of tooltip dialog's connector and tooltip dialog when it aligned right around node
            // tags:
            //    private

            if (this._availableSpace >= this.connectorMargin) {
                dojo.style(this.connectorNode, 'right', this._getNumberInPx(this.connectorMargin));
                dojo.style(this._popupWrapper, 'left', this._getNumberInPx(this._wrapperPosX + (this.connectorMargin - this._right)));
            } else {
                dojo.style(this.connectorNode, 'right', this._getNumberInPx(this._defaultConnectorRight));
                dojo.style(this._popupWrapper, 'left', this._getNumberInPx(this._wrapperPosX - (this._right - this._defaultConnectorRight)));
            }
        },

        _updateAlignedLeftPositions: function () {
            // summary:
            //    Updates positions of tooltip dialog's connector and tooltip dialog when it aligned left around node
            // tags:
            //    private

            if (this._availableSpace >= this.connectorMargin) {
                dojo.style(this.connectorNode, 'left', this._getNumberInPx(this.connectorMargin));
                dojo.style(this._popupWrapper, 'left', this._getNumberInPx(this._wrapperPosX + (this.connectorMargin - this._left)));
            } else {
                dojo.style(this.connectorNode, 'left', this._getNumberInPx(this._defaultConnectorLeft));
                dojo.style(this._popupWrapper, 'left', this._getNumberInPx(this._wrapperPosX - (this._left - this._defaultConnectorLeft)));
            }
        },

        _calculateAvailableSpaceRight: function () {
            // summary:
            //    Calculates available space on right when tooltip dialog aligned left around node
            // tags:
            //    private

            this._wrapperPosX -= this._left + this._getCenterHorizontalAroundNode();
            this._availableSpace -= (this._wrapperPosX + this._pos.w);
        },

        _calculateAvailableSpaceLeft: function () {
            // summary:
            //    Calculates available space on left when tooltip dialog aligned right around node
            // tags:
            //    private

            this._wrapperPosX += this._right + this._getCenterHorizontalAroundNode();
            this._availableSpace -= (this._wrapperPosX + this._pos.w);
        },

        _calculateConnectorMarginRight: function () {
            // summary:
            //    Calculates margin right of the connector
            // tags:
            //    private

            this._right = this._getConnectorSpace('right');
            if (this._right < this.connectorMargin) {
                this._right = this.connectorMargin;
            }
        },

        _calculateConnectorMarginLeft: function () {
            // summary:
            //    Calculates margin left of the connector
            // tags:
            //    private

            this._left = this._getConnectorSpace('left');
            if (this._left < this.connectorMargin) {
                this._left = this.connectorMargin;
            }
        },

        _getConnectorSpace: function (position) {
            // summary:
            //    Gets connector margin (left or right)
            // position:
            //    Css position: left or right
            // tags:
            //    private

            if (!position) {
                return 0;
            }

            if (position == 'right' || position == 'left') {
                var positionValue = dojo.style(this.connectorNode, position);
                if (!positionValue) {
                    return 0;
                }
                var patterns = /(px|em|%)/ig;
                return number.parse(positionValue) || number.parse(positionValue.replace(patterns, ''));
            }

            return 0;
        },

        _getNumberInPx: function (number) {
            // summary:
            //    Gets number in pixel format
            // number:
            //    Integer number
            // tags:
            //    private

            return number + 'px';
        },

        _getCenterHorizontalAroundNode: function () {
            // summary:
            //    Gets number of the center horizontal of tooltip dialog around node
            // tags:
            //    private

            return number.round((number.parse(this.connectorNode.clientWidth) - number.parse(this._pos.aroundNodePos.w)) / 2);
        }
    });
});
},
'url:epi-cms/widget/templates/TooltipDialog.html':"﻿<div class=\"epi-dijitTooltipDialog\" role=\"presentation\" tabindex=\"-1\">\r\n    <div class=\"dijitTooltipContainer epi-dijitTooltipContainer\" role=\"presentation\">\r\n        <div class=\"dijitTooltipContents dijitTooltipFocusNode epi-dijitTooltipContents\" data-dojo-attach-point=\"containerNode\" role=\"dialog\"></div>\r\n    </div>\r\n    <div class=\"dijitTooltipConnector epi-dijitTooltipConnector\" data-dojo-attach-point=\"connectorNode\" role=\"presentation\"></div>\r\n</div>",
'url:epi-cms/widget/templates/NotificationStatusBar.html':"﻿<div>\r\n    <div class=\"epi-dijitTooltipTitleBar\">\r\n        <span class=\"epi-dijitTooltipTitle\">${res.title}</span>\r\n        <span class=\"epi-closeButton dijitDialogCloseIcon\" data-dojo-attach-point=\"closeIcon\" title=\"${res.title}\" role=\"button\"></span>\r\n    </div>\r\n    <div class=\"epi-dijitTooltipContent\" data-dojo-attach-point=\"zoneLayoutNode\">\r\n        <div data-dojo-attach-point=\"zoneContainer\">\r\n            <div data-dojo-type=\"epi-cms/widget/NotificationStatusZone\" data-dojo-attach-point=\"errorZone\" data-dojo-props=\"title: '${res.errortitle}', type: 'error'\"></div>\r\n            <div data-dojo-type=\"epi-cms/widget/NotificationStatusZone\" data-dojo-attach-point=\"warningZone\" data-dojo-props=\"title: '${res.warningtitle}', type: 'warning'\"></div>\r\n            <div data-dojo-type=\"epi-cms/widget/NotificationStatusZone\" data-dojo-attach-point=\"infoZone\"  data-dojo-props=\"title: '${res.notetitle}', type: 'note'\"></div>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/FloatingEditorWrapper':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-geometry",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/has",
    "dojo/when",
// epi
    "epi/dependency",
    "epi/string",

    "epi/shell/widget/dialog/LightWeight",

    "epi-cms/contentediting/OverlayBasedEditorWrapper"
],

function (
// dojo
    array,
    declare,
    lang,

    domGeometry,

    aspect,
    Deferred,
    has,
    when,
// epi
    dependency,
    epiString,

    LightWeightDialog,

    OverlayBasedEditorWrapper
) {

    // module:
    //      epi-cms/contentediting/FlyoutEditorWrapper
    // summary:
    //      A lightweight dialog used for displaying property editors. This dialog doesn't contain any
    //      buttons, instead it will close when a user clicks on the overlay outside the dialog.
    // tags:
    //      public

    return declare([OverlayBasedEditorWrapper], {

        // formContainerWidgetType: String
        //      Special editor widget type
        formContainerWidgetType: "epi/shell/widget/FormContainer",

        destroy: function () {
            this._removeEditingFeatures();
            this._destroyDialog();
            this.inherited(arguments);
        },

        startEdit: function (params) {
            // summary:
            //    Start editing and show the dialog.
            // tags:
            //    public

            lang.mixin(this.editorParams, params);

            var self = this,
                def = new Deferred();

            self._destroyDialog();

            when(self._setupDialog(), function () {
                self._dialog.show();

                self.own(
                    aspect.after(self._dialog, "onAfterShow", function () {
                        self._startEdit(params);
                        self._onTryToStopWithInvalidValue();
                        def.resolve();
                    })
                );
            });

            return def;
        },

        _createDialog: function (/*Object*/editor) {
            // summary:
            //      Create dialog
            // editor:
            //      Editor object
            // tags:
            //      protected

            return new LightWeightDialog({
                title: this.propertyDisplayName,
                content: editor,
                duration: 350,
                snapToNode: this.blockDisplayNode,
                positioner: dependency.resolve("epi.shell.layout.PositioningUtility")
            });
        },

        _setupDialog: function () {
            var _formWidgets = {};

            //Define form's field created event handler.
            var onFieldCreatedHandler = function (fieldName, widget) {
                _formWidgets[fieldName] = widget;
            };

            //Define form's form created event handler.
            var onFormCreatedHandler = lang.hitch(this, function (formContainer) {
                // set parent for each child widget
                for (var fieldName in _formWidgets) {
                    var widget = _formWidgets[fieldName];
                    widget.set("parent", this);
                    if (widget.stopEditOnBlur === true) {
                        this.connect(widget, "onBlur", this.onStopEdit);
                    }
                }

                _formWidgets = null;
            });

            var editorParams = lang.mixin({ intermediateChanges: true }, this.editorParams);

            // Add event only when editor type is FormContainer
            if (this.editorWidgetType === this.formContainerWidgetType) {
                lang.mixin(editorParams, {
                    onFieldCreated: onFieldCreatedHandler,
                    onFormCreated: onFormCreatedHandler
                });
            }

            var def = new Deferred();

            //Change . to /
            var widgetType = epiString.slashName(this.editorWidgetType);

            // Create editor widget
            require([widgetType], lang.hitch(this, function (editorClass) {
                var editor = new editorClass(editorParams);
                this.editorWidget = editor;

                // Create dialog and set content
                var dialog = this._createDialog(editor);

                this._handlers = [
                    this.connect(dialog, "onButtonClose", this._onButtonClose),
                    this.connect(dialog, "onCancel", this._onDialogCancel),
                    this.connect(dialog.doneButtonNode, "onClick", this._onButtonClose),
                    this.connect(editor, "onChange", this._onChange),
                    this.connect(editor, "onKeyPress", "_onEditorKeyPress")
                ];
                this._dialog = dialog;

                // start editor if we created it
                if (this._createdEditor && this.editorWidget.startup) {
                    this.editorWidget.startup();
                }

                def.resolve();
            }));

            return def;
        },

        _onDialogCancel: function () {
            this.cancel();
        },

        _destroyDialog: function () {
            array.forEach(this._handlers, function (handle) { handle.remove(); });

            if (this._dialog) {
                this._dialog.destroy();
                this._dialog = null;
            }

            if (this.editorWidget) {
                this.editorWidget.destroy();
                this.editorWidget = null;
            }
        },

        _removeEditingFeatures: function () {
            if (this._dialog.open) {
                this._dialog.hide();
            }
        },

        _onTryToStopWithInvalidValue: function () {
            // force the editor to show any validation message
            // trigger a blur for the widget and then refocus it
            // this is a workaround to get any validation feedback
            // from widgets that only displays validation message when 
            // input fields are blurred
            dijit.focus(this._dialog.titleNode);

            if (this.editorWidget.focus) {
                this.editorWidget.focus();
            }
        },

        _onButtonClose: function () {
            // summary:
            //    Stop editing when the dialog is hidden.
            // tags:
            //    private

            if (!this.editorWidget.isShowingChildDialog) {
                this.tryToStopEditing(false);
            }
        }

    });

});
},
'epi/shell/widget/dialog/LightWeight':function(){
require({cache:{
'url:epi/shell/widget/dialog/templates/LightWeight.html':"﻿<div class=\"epi-lfw-dialog dijitDialog\" role=\"dialog\" aria-labelledby=\"${id}_title\">\r\n    <div data-dojo-attach-point=\"titleBar\" class=\"dijitDialogTitleBar\">\r\n        <span data-dojo-attach-point=\"titleNode\" class=\"dijitDialogTitle\" id=\"${id}_title\"></span>\r\n         <span data-dojo-attach-point=\"closeButtonNode\" class=\"dijitDialogCloseIcon\" data-dojo-attach-event=\"ondijitclick: onButtonClose\" title=\"${buttonCloseText}\" role=\"button\" tabIndex=\"-1\">\r\n            <span data-dojo-attach-point=\"closeText\" class=\"closeText\" title=\"${buttonCloseText}\">x</span>\r\n        </span>\r\n    </div>\r\n    <div class=\"dijitDialogPaneContent\">\r\n        <div data-dojo-attach-point=\"containerNode\" class=\"dijitDialogPaneContentArea\" data-dojo-attach-event=\"onclick:_onContainerNodeClick\"></div>\r\n        <div data-dojo-attach-point=\"buttonContainerNode\" class=\"dijitDialogPaneActionBar clearfix\">\r\n            <button data-dojo-attach-point=\"doneButtonNode\" data-dojo-type=\"dijit/form/Button\" type=\"button\">${buttonDoneText}</button>\r\n        </div>\r\n    </div>\r\n</div>\r\n"}});
﻿define("epi/shell/widget/dialog/LightWeight", [
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-style",

    "dijit/_WidgetsInTemplateMixin",

    "dijit/focus",
    "dijit/Dialog",
    "dijit/DialogUnderlay",
    
    
    "epi/shell/widget/dialog/_DialogMixin",
    
    "dojo/text!./templates/LightWeight.html"
],
function (
    declare,
    lang,

    domStyle,

    _WidgetsInTemplateMixin,
    
    focus,
    Dialog,
    DialogUnderlay,

    _DialogMixin,

    template
) {

    return declare([Dialog, _DialogMixin, _WidgetsInTemplateMixin], {
        // summary:
        //		A lightweight dialog Widget
        //
        // description:
        //		Pops up a modeless lightweight dialog window

        // templateString: [protected] String
        //		A string that represents the widget template.
        templateString: template,

        // buttonCloseText: [protected] String
        //      Text to be displayed on the 'close' button
        buttonCloseText: epi.resources.action.close,

        // buttonDoneText: [protected] String
        //      Text to be displayed on the 'done' button
        buttonDoneText: epi.resources.action.done,

        // buttonLearnMoreText: [protected] String
        //      Text to be displayed on the 'learnmore' button
        buttonLearnMoreText: epi.resources.action.learnmore,

        // useGlassUnderlay: [public] Boolean
        //    Denotes that a glass underlay should be used. This underlay is not the global dijit._underlay which is designed for modal dialogs only.
        useGlassUnderlay: false,

        // _glassUnderlay: [public] dijit.DialogUnderlay
        //    Underlay object. dijit.Dialog use a single global underlay which is not fully transparent for all dialog layers. 
        //    This lightweight dialog maintains a different underlay to avoid messing up dijit's dialog stack.
        _glassUnderlay: null,

        "class": "epi-lfw-dialog",

        // snapToNode: [public] domNode
        //    The DomNode to snap to when doing positioning.
        snapToNode: null,

        // positioner: [public] epi.shell.layout.PositioningUtility
        //    Utility used to determine the correct position to display this dialog.
        positioner: null,

        destroy: function () {
            // summary:
            //		Destroy dialog

            //delete used underlay
            if (this._glassUnderlay) {
                this._glassUnderlay.destroyRecursive();
                delete this._glassUnderlay;
            }

            this.inherited(arguments);
        },

        show: function () {
            // summary:
            //		Display the dialog
            // returns: dojo.Deferred
            //		Deferred object that resolves when the display animation is complete

            return this.inherited(arguments).then(lang.hitch(this, this._onAfterShow));
        },

        _size: function () {
            this.inherited(arguments);

            // Optional property. Check null before using
            if (this.positioner) {
                this._relativePosition = this.positioner.findPosition(this.domNode, { snapTo: this.snapToNode });
            }
        },

        resize: function () {
            this._size();
            this._position();
        },

        _onAfterShow: function () {
            // summary:
            //		Additional work after dialog is shown.

            if (this.content && this.content.focus) {
                this.content.focus();
            }

            if (this.useGlassUnderlay) {
                this._createUnderlay();
            }
            else {
                //No glass underlay created when showing up, we use a temporary underlay to avoid lag when moving/resizing.
                //Handle moving
                if (this._moveable && !this._attachedMoveEvents) {
                    this.connect(this._moveable, 'onMoveStart', lang.hitch(this, this._createUnderlay));
                    this.connect(this._moveable, 'onMoveStop', lang.hitch(this, this._removeUnderlay));
                    this._attachedMoveEvents = true;
                }

                //Handle content resizing
                if (this.content && this.content.onResizeStart && this.content.onResizeStop && !this._attachedContentResizeEvents) {
                    this.connect(this.content, 'onResizeStart', lang.hitch(this, this._createUnderlay));
                    this.connect(this.content, 'onResizeStop', lang.hitch(this, this._removeUnderlay));
                    this._attachedContentResizeEvents = true;
                }
            }

            this.onAfterShow();
        },

        _createUnderlay: function () {
            // summary:
            //		Handle move start event.
            // description:
            //      Show a transparent underlay to prevent lagging when drag over the underneath iframe.

            if (this._glassUnderlay) {
                this._glassUnderlay.show();
            }
            else {
                this._glassUnderlay = new DialogUnderlay();
                this._glassUnderlay.show();

                // Set z-index a bit under the dialog
                var zIndex = domStyle.get(this.domNode, 'zIndex');
                domStyle.set(this._glassUnderlay.domNode, 'zIndex', zIndex - 1);

                //Make it transparent
                domStyle.set(this._glassUnderlay.domNode, 'filter', 'alpha(opacity=0)');
                domStyle.set(this._glassUnderlay.domNode, 'opacity', '0');
            }
        },

        _removeUnderlay: function () {
            // summary:
            //		Handle move stop event.
            // description:
            //      Hide the transparent underlay.

            this._glassUnderlay.hide();
        },

        _onContainerNodeClick: function (e) {
            //If we inside the dialog, set the focus to the first focusable item
            if (e.target === this.containerNode) {
                this._getFocusItems();
                this._firstFocusItem && focus.focus(this._firstFocusItem);
            }
        },

        onButtonClose: function () {

        },

        onAfterShow: function () {
            // summary:
            //    Fired on after show.
            //
            // tags:
            //    public, callback
        },

        onAfterHide: function () {
            // summary:
            //    Fired on hide.
            //
            // tags:
            //    public, callback
        },

        hide: function () {
            // summary:
            //		Hide the dialog
            // returns: dojo.Deferred
            //		Deferred object that resolves when the hide animation is complete

            return this.inherited(arguments).then(lang.hitch(this, this._onAfterHide));
        },

        _onAfterHide: function () {
            if (this.useGlassUnderlay) {
                this._removeUnderlay();
            }

            this.onAfterHide();
        },

        layout: function () {
            // summary:
            //		Position the Dialog and the underlay
            // tags:
            //		private

            if (this._glassUnderlay && domStyle.get(this._glassUnderlay.domNode, "display") != "none") {
                // Calling layout of the underlay sets display, and since show() calls layout we can ignore it if it's not shown
                this._glassUnderlay.layout();
            }

            //Adjust other dijit underlay display state, since Dialog.layout always set the modal Dialog's underlay to visible.
            var dijitUnderlayDisplay = dijit._underlay ? domStyle.get(dijit._underlay.domNode, 'display') : null;

            this.inherited(arguments);

            if (dijit._underlay) {
                domStyle.set(dijit._underlay.domNode, 'display', dijitUnderlayDisplay);
            }
        }
    });
});
},
'url:epi/shell/widget/dialog/templates/LightWeight.html':"﻿<div class=\"epi-lfw-dialog dijitDialog\" role=\"dialog\" aria-labelledby=\"${id}_title\">\r\n    <div data-dojo-attach-point=\"titleBar\" class=\"dijitDialogTitleBar\">\r\n        <span data-dojo-attach-point=\"titleNode\" class=\"dijitDialogTitle\" id=\"${id}_title\"></span>\r\n         <span data-dojo-attach-point=\"closeButtonNode\" class=\"dijitDialogCloseIcon\" data-dojo-attach-event=\"ondijitclick: onButtonClose\" title=\"${buttonCloseText}\" role=\"button\" tabIndex=\"-1\">\r\n            <span data-dojo-attach-point=\"closeText\" class=\"closeText\" title=\"${buttonCloseText}\">x</span>\r\n        </span>\r\n    </div>\r\n    <div class=\"dijitDialogPaneContent\">\r\n        <div data-dojo-attach-point=\"containerNode\" class=\"dijitDialogPaneContentArea\" data-dojo-attach-event=\"onclick:_onContainerNodeClick\"></div>\r\n        <div data-dojo-attach-point=\"buttonContainerNode\" class=\"dijitDialogPaneActionBar clearfix\">\r\n            <button data-dojo-attach-point=\"doneButtonNode\" data-dojo-type=\"dijit/form/Button\" type=\"button\">${buttonDoneText}</button>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
'epi-cms/contentediting/OverlayBasedEditorWrapper':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/on",
// epi
    "epi/shell/widget/IframeWithOverlay",
    "epi-cms/contentediting/_EditorWrapperBase"
],

function (
// dojo
    declare,
    lang,

    on,
// epi
    IframeWithOverlay,
    _EditorWrapperBase
) {

    // module:
    //      epi-cms/contentediting/_OverlayBasedEditorWrapper
    // summary:
    //      Based editor wrapper for the overlay relying editor widget type
    // tags:
    //      public

    return declare([_EditorWrapperBase], {

        postCreate: function () {

            this.inherited(arguments);

            this.own(
                on(this.get("iframeWithOverlay").iframe, "mousedown", lang.hitch(this, this._onViewportClick))
            );
        },

        destroy: function () {

            this._iframeWithOverlay = null;

            this.inherited(arguments);
        },

        _onViewportClick: function (/*Event*/evt) {
            // summary:
            // evt: [Event]
            //      onmousedown event
            // tags:
            //      protected, extension

        },

        _onEditorResize: function (/*Object*/resizeInfo) {
            // summary:
            //      Stub to do somethings on editor resizing process
            // resizeInfo: [Object]
            //      Resize information
            // tags:
            //      protected
        },

        _onEditorResizeFinished: function (/*Function*/callbackFunction) {
            // summary:
            //      Stub to do somethings after editor finished its resize function
            // callbackFunction: [Function]
            //      Function will be call after finish resizing process
            // tags:
            //      protected
        },

        _getOverlayItemAttr: function () {
            // summary:
            //      Get editing overlay item object
            // tags:
            //      protected

            return this.overlayItem || this.editorParams.overlayItem;
        },

        _getIframeWithOverlayAttr: function () {
            // summary:
            //      Get the viewport ("epi/shell/widget/IframeWithOverlay") object
            // tags:
            //      protected

            if (this._iframeWithOverlay) {
                return this._iframeWithOverlay;
            }

            var iframeWithOverlay = null,
                widget = this.overlayItem;

            while (widget) {
                if (widget instanceof IframeWithOverlay) {
                    iframeWithOverlay = widget;
                    break;
                }

                widget = widget.getParent();
            }

            return this._iframeWithOverlay = iframeWithOverlay;
        }

    });

});
},
'epi-cms/contentediting/FlyoutEditorWrapper':function(){
﻿define([
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/dom-style",

    "dojo/number",

    "epi/shell/widget/IframeWithOverlay",
    "epi/shell/widget/dialog/LightWeight",
    "epi-cms/contentediting/FloatingEditorWrapper"
],

function (
    connect,
    declare,
    lang,

    domClass,
    domGeom,
    domStyle,

    number,

    IframeWithOverlay,
    Dialog,
    FloatingEditorWrapper
) {

    return declare([FloatingEditorWrapper], {
        // summary:
        //    A lightweight right-floating dialog used for displaying property editors.

        _eventHandlers: null,

        // _overlayContainer: [protected] epi.shell.widget.overlay.Container widget
        _overlayContainer: null,

        // isOverlayDisabled: Boolean
        //      Override base value to disable overlay when editing.
        isOverlayDisabled: true,

        // isUndoDisabled: Boolean
        //      Override base value to disable undo when editing.
        isUndoDisabled: true,

        constructor: function () {
            this._eventHandlers = [];
        },

        _createDialog: function (/*Object*/editor) {
            // summary:
            //      Overrided to create floating dialog and return it
            // editor:
            //      Editor object
            // tags:
            //      protected

            var dialogResize = function (changeSize) {
                if (!this.open || !changeSize) {
                    return;
                }

                this._containerNodeCS = this._containerNodeCS || domStyle.getComputedStyle(this.containerNode);

                //Calculate the height of the chrome
                if (!this._dialogChromeSize) {
                    this._chromeHeight = domGeom.getMarginBox(this.domNode).h - domGeom.getMarginBox(this.containerNode).h;
                }

                domGeom.setMarginBox(this.containerNode, { h: changeSize.h - this._chromeHeight }, this._containerNodeCS);
                domStyle.set(this.domNode, { top: changeSize.t + 'px', left: changeSize.l + 'px' });
            };

            var dialog = new Dialog({
                title: this.propertyDisplayName,
                content: editor,
                duration: 350,
                draggable: false,
                closeIconVisible: false,
                region: "trailing",
                resize: dialogResize,
                overlayItem: this.overlayItem,
                _position: function () { },
                _size: function () { }
            });
            domClass.add(dialog.domNode, "epi-floatingEditorWrapperDialog");

            // Place dialog inside IframeWithOverlay widget as last child.
            dialog.placeAt(this.get("iframeWithOverlay"));
            domStyle.set(dialog.domNode, { top: '-10000px' });

            return dialog;
        },

        _onViewportClick: function (/*Event*/evt) {
            // summary:
            //      Stop editing when click outside editor but in viewport
            // evt: [Event]
            //      onmousedown event
            // tags:
            //      protected, extension
           
            this.tryToStopEditing(false);
        },

        _removeEditingFeatures: function () {
            this.inherited(arguments);

            this._disconnectLocal(this._eventHandlers);

        },

        _disconnectLocal: function (targetArray) {
            if (lang.isArray(targetArray)) {
                var listener;
                while (listener = targetArray.pop()) {
                    connect.disconnect(listener);
                }
            }
        }

    });

});
},
'epi-cms/contentediting/FormEditing':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/dom-class",

    "dijit/layout/ContentPane",

    "epi-cms/contentediting/_FormEditingMixin",
    "epi-cms/contentediting/_ValidationMixin",
    "epi-cms/contentediting/EditingBase"
],

function (
    declare,
    domClass,

    ContentPane,

    _FormEditingMixin,
    _ValidationMixin,
    EditingBase
) {
    return declare([EditingBase, _FormEditingMixin, _ValidationMixin], {
        // summary:
        //		Form editing controller.

        // createOverlays: [Boolean]
        //      Indicate that the overlays should be created.
        createOverlays: false,

        // selectFormOnCreation: Boolean
        //      Indicate that the form should be set as selected child after being added to edit layout.
        selectFormOnCreation: true,

        placeForm: function (form) {
            // summary:
            //		Setup the edit form.
            // tags:
            //		protected

            form.set("transitionMode", "reveal");
            form.set("fitContainer", true);

            this.editLayoutContainer.addChild(form, 0);
        },

        removeForm: function (form) {
            // summary:
            //		Remove the edit form.
            // tags:
            //		protected

            this.editLayoutContainer.leftOver = form;

            // HACK: Fix for SH7.1 RTM
            // Eventhough the iframe with overlay would become visible when OPE completely loaded, we need to make it visible a little bit earlier 
            // because setting up overlays would fail on FF if the underneath iframe is invisible
            // This workaround is due to a timing problem that overlay is set up at the same time with form, and often finish before.
            // At the moment, it is difficult to have overlay setup to wait for form setup because EditingBase has no idea about form.
            // These things should be refactor after the RTM. (single edit view with mixins instead of OPE and FE).
            // Related work item: #95682
            domClass.replace(this.iframeWithOverlay.domNode, "dijitVisible", "dijitHidden");

            return false;
        }
    });
});

},
'epi-cms/contentediting/_FormEditingMixin':function(){
define([
// Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",

// EPi
    "epi-cms/contentediting/SideBySideEditorWrapper",
    "epi/shell/widget/FormContainer"
],

function (
    array,
    declare,
    lang,
    when,

    SideBySideEditorWrapper,
    FormContainer
) {
    return declare(null, {
        // summary:
        //		Form editing controller.

        _form: null,

        _formWidgets: null,

        // canHandleLeftOver: Boolean
        //      Indicate that the view can handle "left over" on the edit layout container.
        canHandleLeftOver: true,

        // selectFormOnCreation: Boolean
        //      Indicate that the form should be set as selected child after being added to edit layout.
        selectFormOnCreation: false,

        // formSettings: Object
        //      Settings used when creating form.
        formSettings: null,

        // connectOverlayItemsToFormWidgets: Boolean
        //      Denote if we want to connect overlay items to form widgets, which means user can click on overlay item to start edit on form. 
        //      Should be set to true on side by side editing.
        connectOverlayItemsToFormWidgets: false,

        _formConnects: null,

        destroy: function () {
            // summary:
            //		Destroy the widget.
            // tags:
            //		protected

            // Do not use own because Destroyable destroys owned things before destroy method is called.
            // As a result, we cannot remove the form from edit layout.
            this._removeAndDestroyForm();

            // remove all widgets
            this._formWidgets = null;

            this.inherited(arguments);
        },

        _removeAndDestroyForm: function () {
            // summary:
            //		Check if a form exists so remove from edit layout and destroy it.
            // tags:
            //		private

            if (this._form) {
                if (this.removeForm(this._form)) {
                    this._form.destroy();
                    this._form = null;
                }

                var connect;
                while (connect = this._formConnects.pop()) {
                    this.disconnect(connect);
                    connect = null;
                }
                this._formConnects = null;
                this._form = null;
            }

            for (var p in this._formWidgets) {
                this._formWidgets[p] = null;
            }
        },

        _setupForm: function () {
            // summary:
            //		Setup the edit form.
            // tags:
            //		private

            this._formWidgets = {};

            // Create Form container
            // Note: We don't need to set a model to the formContainer since a value
            //       will be set by the editor wrapper.
            this._form = new FormContainer(lang.mixin({
                readOnly: !this.viewModel.canChangeContent(),
                metadata: this.viewModel.metadata,
                baseClass: "epi-cmsEditingForm"
            }, this.formSettings));

            this._formConnects = [];
            this._formConnects.push(this.connect(this._form, "onFieldCreated", this.onFieldCreated));
            this._formConnects.push(this.connect(this._form, "onGroupCreated", this.onGroupCreated));
            this._formConnects.push(this.connect(this._form, "onFormCreated", this.onFormCreated));

            this.placeForm(this._form);
            this._formPlaced = true;
            this._finishFormCreation();
        },

        _createFormEditorWrappers: function () {
            // summary:
            //		Create editor wrappers for form widgets.
            // formContainer: epi.shell.widget.FormContainer
            //     The form container.
            // tags:
            //		private

            for (var fieldName in this._formWidgets) {

                var property = {
                    name: fieldName,
                    metadata: this.viewModel.getPropertyMetaData(fieldName)
                };

                var value = lang.clone(this.viewModel.getProperty(property.name));

                var wrapper = new SideBySideEditorWrapper({
                    property: property,
                    propertyName: fieldName,
                    value: value,
                    editorWidget: this._formWidgets[fieldName],
                    contentModel: this.viewModel.contentModel,
                    // TODO: Remove the operation dependency when editor wrappers can raise change notifications without being in editable state
                    operation: this.viewModel._operation 
                });
                wrapper.editorWidget.set("parent", wrapper);
                wrapper.editorWidget.set("editMode", "formedit");

                this.connect(wrapper, "onValueChange", "_onWrapperValueChange");
                this.connect(wrapper, "onCancel", "_onWrapperCancel");
                this.connect(wrapper, "onStopEdit", "_onWrapperStopEdit");

                // Create mapping between property and form editor wrapper
                this._createMapping(fieldName, wrapper);

                property = null;
                value = null;
                wrapper = null;
            }
        },

        _createMapping: function (fieldName, wrapper) {
            // summary:
            //		Connect editor wraper to property rendering in template.
            // fieldName: String
            //      The property name.
            // wrapper: epi.cms.contentediting._EditorWrapperBase
            //      The editor wrapper
            // tags:
            //		private

            var names = fieldName.split(".");
            var foundAnyBlock = false;

            if (this.connectOverlayItemsToFormWidgets) {
                while (names.length > 0) {
                    var propertyName = names.join(".");
    
                    var mappings = this._mappingManager.find("propertyName", propertyName);
                    array.forEach(mappings, function (mapping) {
                        foundAnyBlock = true;
                        mapping.propertyName = fieldName;
                        mapping.wrapper = mapping.wrapper || wrapper;
                    });
    
                    names.pop();
                }
            }

            if (!foundAnyBlock) {
                // create empty mapping
                this._mappingManager.add({
                    propertyName: fieldName,
                    wrapper: wrapper
                });
            }
        },

        placeForm: function (form) {
            // summary:
            //		Place edit form into container.
            // tags:
            //		protected, abstract

        },

        removeForm: function (form) {
            // summary:
            //		Remove edit form from container.
            // tags:
            //		protected, abstract
            // returns:
            //      false if the form is set as leftover, otherwise if form is removed and ready to destroy: true
        },

        onFieldCreated: function (fieldName, widget) {
            // summary:
            //		Triggerred when a field created.
            // tags:
            //		public, callback

            this._formWidgets[fieldName] = widget;

            if (this._addStateWatch) {
                this._addStateWatch(widget);
            }
        },

        onGroupCreated: function (groupName, widget) {
            // summary:
            //		Triggerred when a group created.
            // tags:
            //		public, callback

            if (widget.contentViewModel !== undefined) {
                widget.set("contentViewModel", this.viewModel);
            }
        },

        onFormCreated: function (form) {
            // summary:
            //		Triggerred when the whole form created.
            // tags:
            //		public, callback


            this._formCreated = true;
            this._finishFormCreation();
        },

        _finishFormCreation: function () {
            if (this._formPlaced && this._formCreated) {
                when(this.selectFormOnCreation ? this.editLayoutContainer.selectChild(this._form) : null, lang.hitch(this, this._removeLeftOver));
                this.toolbar.setItemProperty("editmodeswitch", "state", "");

                this._createFormEditorWrappers(this._form);
                this.onSetupEditModeComplete();
            }        
        },

        _removeLeftOver: function () {
            if (this.editLayoutContainer.leftOver) {
                var leftOverIsSelected = this.editLayoutContainer.selectedChildWidget === this.editLayoutContainer.leftOver;
                when(leftOverIsSelected ? this.editLayoutContainer.selectChild(this.iframeWithOverlay) : null, lang.hitch(this, function () {
                            this.editLayoutContainer.removeChild(this.editLayoutContainer.leftOver);
                            this.editLayoutContainer.leftOver.destroyRecursive();
                            this.editLayoutContainer.leftOver = null;
                }));
            }
        },

        onReadySetupEditMode: function () {
            // summary:
            //		Finish edit mode setting up.
            // description:
            //      Create editor wrappers for form widgets so it can update the model
            // tags:
            //		public, callback

            this.inherited(arguments);

            // Remove the old form if there exists
            this._removeAndDestroyForm();

            // Setup new form
            this._setupForm();
        },

        remapEditMode: function () {
            // summary: 
            //      Re configure edit mode after the preview context changed.
            // tag: 
            //      public

            this.inherited(arguments);
            this._form && this._form.set("readOnly", !this.viewModel.canChangeContent());
        }
    });
});

},
'epi-cms/contentediting/SideBySideEditorWrapper':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/window",
    "epi-cms/contentediting/_EditorWrapperBase"
], function (declare, lang, window, _EditorWrapperBase) {

    return declare([_EditorWrapperBase], {
        // summary:
        //		This editor wrapper connects editor widgets in side-form to the system

        _grabFocusOnStartEdit: true,

        postCreate: function () {
            // summary:
            //		Post create initialization.
            // tags:
            //		protected

            this.inherited(arguments);
            if (this.editorWidget) {
                this.connect(this.editorWidget, "onChange", "_onChange");

                this.connect(this.editorWidget, "onFocus", lang.hitch(this, function () {
                    // Since we try stop edit in a timeout, we must start the next edit in a time out, too. That would preserve the calling order
                    setTimeout(lang.hitch(this, function () {
                        this._tryToStartEditing(false);
                    }), 0);
                }));

                this.connect(this.editorWidget, "onBlur", lang.hitch(this, function () {
                    // In form widgets onBlur event is raised before the last value change got updated. Therefore, at this point, editor widget's value is not up to date.
                    // This small timeout is for waiting for that change event to finish
                    setTimeout(lang.hitch(this, function () {
                        this.tryToStopEditing(true);
                    }), 0);
                }));

                this.connect(this.editorWidget, "onDropping", lang.hitch(this, function () {
                    this._tryToStartEditing(true);
                }));
            }
        },

        contentModelChanged: function (name, oldValue, value) {
            // Always uptate the editor
            this.set("value", value);
        },


        _tryToStartEditing: function (grabFocus) {
            if (this.editing) {
                return;
            }

            this._grabFocusOnStartEdit = grabFocus;
            this.startEdit();
            this._grabFocusOnStartEdit = true;
        },

        _onChange: function (val) {
            // When using set value attribute, change shouldn't be propagated
            if (this._preventChangeEvent) {
                return;
            }

            var savedState = this.editing;

            // When this change is inside a DnD operation and not in "editing" state.
            if (this.operation && this.operation.inProgress && !this.editing) {
                this.editing = true;
            }
            this.inherited(arguments);

            this.editing = savedState;
        },

        _setValueAttr: function (value) {
            // Make sure no change events is propagated when setting the value
            this._preventChangeEvent = true;
            this.inherited(arguments);
            this._preventChangeEvent = false;
        },

        startEdit: function () {
            // summary:
            //		Start editing.
            // tags:
            //		public

            if (this._grabFocusOnStartEdit) {
                this.editorWidget.focus();
                // scrolls a node into view, similar to node.scrollIntoView() but working around browser quirks
                window.scrollIntoView(this.editorWidget.domNode);
            }

            this.inherited(arguments);
        },

        stopEdit: function (implicitExit) {
            // summary:
            //		Stop editing.
            // tags:
            //		public

            this.set("value", this.getEditorValue());
            this.inherited(arguments);
        }
    });

});
},
'epi-cms/contentediting/_ValidationMixin':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang"
],

function (
    array,
    declare,
    lang
) {

    // summary:
    //      Handles validation stuffs
    // tags:
    //      public

    return declare(null, {

        _watchHandles: null,

        constructor: function () {
            this._watchHandles = [];
        },

        destroy: function () {
            array.forEach(this._watchHandles, function (handle) {
                handle.unwatch();
            });
            this._watchHandles = null;

            this.inherited(arguments);
        },

        _addStateWatch: function (/*Object*/widget) {
            var propertyName = widget.get("name"),
                viewModel = this.viewModel;

            var update = function () {
                var state = widget.get("state");
                if (state !== "Error") {
                    viewModel.validator.clearPropertyErrors(propertyName, viewModel.validator.validationSource.client);
                } else if (state === "Error") {
                    var errorMessage = widget.get("message");
                        errorMessage === "" && (errorMessage = widget.getErrorMessage());
                    viewModel.validator.setPropertyErrors(
                        propertyName, [{
                            "severity": viewModel.validator.severity.error,
                            "errorMessage": errorMessage
                        }],
                        viewModel.validator.validationSource.client
                    );
                }
            };

            this._watchHandles.push(widget.watch("state", update));
            this._watchHandles.push(widget.watch("message", update));
        }
    });
});
},
'epi-cms/contentediting/InlineEditorWrapper':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",

    "dojo/dom-style",

    "dojo/Deferred",
    "dojo/on",
    "dojo/when",
// epi
    "epi/string",
    "epi-cms/contentediting/OverlayBasedEditorWrapper"
],

function (
// dojo
    array,
    declare,
    event,
    lang,

    domStyle,

    Deferred,
    on,
    when,
// epi
    stringUtil,
    OverlayBasedEditorWrapper
) {

    // module:
    //      epi-cms/contentediting/InlineEditorWrapper
    // summary:
    //      Widget that wraps a editor for inline property editing.
    // tags:
    //      public

    return declare([OverlayBasedEditorWrapper], {

        // width: [public] String
        //      The witdh to use for the editor
        width: "100%",

        // hasInlineEditor: Boolean
        //      A value indicating if the wrapped editor is editing inline, i.e. On-Page-Editing.
        //      True by default.
        hasInlineEditor: true,

        matchStyle: false,

        destroy: function () {

            this._removeEditingFeatures();
            this._removeLocalHandlers();

            this._blockDisplayNodeOpacity = null;

            this.inherited(arguments);
        },

        _onViewportClick: function (/*Event*/evt) {
            // summary:
            //      Process after onmousedown event fired on the viewport
            // evt: [Event]
            //      onmousedown event
            // tags:
            //      protected, extension

            this._stopEditorEditing(evt);
        },

        _stopEditorEditing: function (evt) {
            // evt: [Event]
            //      Can be onunload or onmousedown
            // tags:
            //      private

            var editorWidget = this.getEditorWidget();
            if (!editorWidget || !editorWidget.isEditing()) {
                return;
            }

            editorWidget.onEditorBlur(evt);
            this.tryToStopEditing(true);
        },

        _getOrCreateEditor: function () {
            if (this._createdEditor) {
                return this.editorWidget;
            }

            var deferred = new Deferred();

            var moduleName = stringUtil.slashName(this.editorWidgetType),
                params = lang.mixin(this.editorParams, {
                    value: this.value
                });

            if (this.matchStyle) {
                params.style = this._computeStyling();
            }

            require([moduleName], lang.hitch(this, function (Editor) {
                var editorWidget = this.editorWidget = new Editor(params);

                editorWidget.placeAt(this.get("overlayItem").domNode);

                this.own(
                    on(editorWidget.domNode, "editorstatechanged", lang.hitch(this, this._onEditorStateChanged))
                );

                this._handlers = [
                    this.connect(editorWidget, "onClick", event.stop),
                    this.connect(editorWidget, "onEditorResizing", this._onEditorResizing),
                    this.connect(editorWidget, "onEditorResized", this._onEditorResized)
                ];

                this._handlers.push(this.connect(editorWidget, "onChange", "_onEditorChange"));

                // ESC and TAB should cancel and save.  Note that edit widgets do a stopEvent() on ESC key (to
                // prevent Dialog from closing when the user just wants to revert the value in the edit widget),
                // so this is the only way we can see the key press event.
                this._handlers.push(this.connect(editorWidget, "onKeyPress", "_onEditorKeyPress"));

                this._createdEditor = true;

                deferred.resolve(editorWidget);
            }));

            return deferred;
        },

        _computeStyling: function () {

            var srcStyle = domStyle.getComputedStyle(this.blockDisplayNode),
                editStyle = "line-height:" + srcStyle.lineHeight + ";",
                destStyle = domStyle.getComputedStyle(this.domNode);

            ["Weight", "Family", "Size", "Style"].forEach(function (prop) {
                var textStyle = srcStyle["font" + prop],
                    wrapperStyle = destStyle["font" + prop];
                if (wrapperStyle != textStyle) {
                    editStyle += "font-" + prop + ":" + srcStyle["font" + prop] + ";";
                }
            }, this);

            var width = this.width;
            if (width == "100%") {
                // block mode
                editStyle += "width:100%;";
            } else {
                // inline-block mode
                editStyle += "width:" + (width + (Number(width) == width ? "px" : "")) + ";";
            }

            editStyle += "position: absolute; left: 0px; top: 0px;";

            return editStyle;
        },

        _onEditorChange: function (value) {
            this._onChange(value);
        },

        _onEditorResizing: function (/*Object*/resizeInfo) {
            // summary:
            //      Stub to do something when the current editor on resizing progress
            // resizeInfo: [Object]
            //      Object that provides resize information to editor wrapper
            // tags:
            //      protected, extension
        },

        _onEditorResized: function (/*Function*/callbackFunction) {
            // summary:
            //      Stub to do something when the current editor finished its resizing process
            // tags:
            //      protected, extension
        },

        _onEditorStateChanged: function (/*String*/inputValue) {
            // summary:
            //      Delegate validation state to the current editing overlay item
            // inputValue: [String]
            //      Validation state string value
            // tags:
            //      private

            var overlayItem = this.get("overlayItem");
            overlayItem && overlayItem.set("error", inputValue === "Error");
        },

        startEdit: function () {
            var inherited = this.getInherited(arguments);

            when(this._getOrCreateEditor(), lang.hitch(this, function (editorWidget) {
                this._blockDisplayNodeOpacity = domStyle.get(this.blockDisplayNode, "opacity");

                domStyle.set(editorWidget.domNode, { "display": "" });
                domStyle.set(this.blockDisplayNode, { "opacity": 0.5 });

                inherited.apply(this);

                this.focus();
            }));
        },

        _removeLocalHandlers: function () {
            // summary:
            //      Remove all local handlers
            // tags:
            //      private

            (this._handlers instanceof Array && this._handlers.length > 0) && this._handlers.forEach(function (handle) {
                handle.remove();
            });
        },

        _removeEditingFeatures: function () {
            // summary:
            //      Its purpose is to restore state as it was before editing was started.
            // tags:
            //      protected, extension

            (this.blockDisplayNode && this._blockDisplayNodeOpacity) && domStyle.set(this.blockDisplayNode, { "opacity": this._blockDisplayNodeOpacity });
            (this.editorWidget && this.editorWidget.domNode) && domStyle.set(this.editorWidget.domNode, "display", "none");
        },

        _toggleSupportCustomDnd: function (/*Boolean*/customDnd) {
            // summary:
            //      We should passively connect to onDropData event since overlayItem can be setup dndTarget.
            //      If not, we never get dnd data from overlayItem.
            // customDnd: [Boolean]
            // tags:
            //      protected

            var overlayItem = this.get("overlayItem");
            if (!overlayItem) {
                return;
            }

            var editorWidget = this.getEditorWidget();
            if (!editorWidget || !editorWidget.supportCustomDnd) {
                return;
            }

            if (customDnd === true) {
                overlayItem.transferDndControlTo(editorWidget);
                editorWidget._onDropDataHandler || (editorWidget._onDropDataHandler = editorWidget.connect(overlayItem, "onDropData",
                        lang.hitch(editorWidget, function (dndData, source, nodes, copy) {
                            editorWidget.onDropData(dndData, source, nodes, copy);
                        })
                    ));

                return;
            }

            overlayItem.transferDndControlTo(overlayItem);
            editorWidget._onDropDataHandler && editorWidget.disconnect(editorWidget._onDropDataHandler);
            editorWidget._onDropDataHandler = null;
        },

        _toggleOverlayItemZIndex: function (/*Boolean*/increase) {
            // summary:
            //      Toggle increase/decrease z-index of the current editing overlay item in order to make it have higher indexed
            // increase: [Boolean]
            //      TRUE to increase, otherwise decrease
            // tags:
            //      protected

            var overlayItem = this.get("overlayItem");
            if (!overlayItem || !overlayItem.item) {
                return;
            }

            var currentZIndex = parseInt(domStyle.get(overlayItem.item, "zIndex"), 10);

            domStyle.set(overlayItem.item, {
                "zIndex": increase === true ? ++currentZIndex : --currentZIndex
            });
        }

    });

});
},
'epi-cms/contentediting/NotificationBar':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/_base/array",
    "dojo/on",

// Dijit
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_Container",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/Evented",
    "dijit/form/Button",

// Dojox
    "dojox/html/ellipsis",

//Resources
    "dojo/text!./templates/NotificationBar.html",
    "dojo/text!./templates/NotificationBarItem.html"

], function (
    declare,
    lang,
    domClass,
    domStyle,
    domConstruct,
    array,
    on,

    _TemplatedMixin,
    _Widget,
    _Container,
    _WidgetsInTemplateMixin,
    Evented,
    Button,

    ellipsis,

    template,
    notificationBarItemTemplate) {

    var NotificationBarItem = declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, Evented], {
        templateString: notificationBarItemTemplate,
        item: null,
        viewModel: null,

        postCreate: function () {
            this.inherited(arguments);

            if (this.item.content) {
                this._addContent(this.item);
            }

            this._addCommands(this.item);
        },


        _onClose: function (e) {
            e.preventDefault();

            this.emit("close", this);
        },

        _addContent: function (item) {
            //If it's a string, add it to innerHTML
            if (lang.isString(item.content)) {
                this.textContainer.innerHTML = this.item.content;
            } else { //if its not a string, its assumed to be a dom object.
                domConstruct.place(this.item.content, this.textContainer);
            }
        },

        _addCommands: function (item) {
            if (lang.isArray(this.item.commands)) { //check if it has any commands
                array.forEach(this.item.commands, lang.hitch(this, function (command) {
                    this._addButtonForCommand(command);
                }));
            }
        },

        _addButtonForCommand: function (command) {
            var button = new Button({
                label: command.label,
                title: command.tooltip,
                iconClass: command.iconClass
            });

            if (command.cssClass) {
                domClass.add(button.domNode, command.cssClass);
            }

            button.set("disabled", !command.canExecute);

            button.on("click", function () {
                command.execute();
            });
            
            this.own(command.watch("canExecute", lang.hitch(this, function () {
                button.set("disabled", !command.canExecute);
            })));

            if (command.category === "leftAligned") {
                button.placeAt(this.contentContainer, "first");
            } else {
                button.placeAt(this.buttonContainer, "first");
            }

            this.own(button);
        }
    });

    var NotificationBar = declare([_Widget, _Container, _TemplatedMixin, _WidgetsInTemplateMixin, Evented], {
        templateString: template,

        noBorderClass: "epi-notificationBarWithoutBorder",

        clear: function () {
            this._hideIfEmpty();

            array.forEach(this.getChildren(), function (widget) {
                this.removeChild(widget);
                widget.destroy();
                widget = null;
            }, this);

            this.emit("notificationsChanged");
        },

        destroy: function () {
            this.destroyDescendants();

            this.inherited(arguments);
        },

        add: function (notification) {
            //  summary:
            //    Adds a notification to the notification bar. 
            //
            //  description:  
            //      Notification can be either just text or an object containing content and commands. If it contains an array of commands
            //      the commands will be added as buttons. 

            var notificationBarItem = new NotificationBarItem({ item: notification });

            on(notificationBarItem, "close", lang.hitch(this, "_onCloseNotification"));

            this.addChild(notificationBarItem);

            this._hideIfEmpty();

            this.emit("notificationsChanged");
        },

        remove: function (notification) {
            array.forEach(this.getChildren(), lang.hitch(this, function (childWidget) {
                if (childWidget.item && childWidget.item == notification) {
                    this._onCloseNotification(childWidget);
                }
            }));

            this._hideIfEmpty();
        },

        _onCloseNotification: function (item) {
            this.removeChild(item);

            item.destroy();
            item = null;

            this._hideIfEmpty();

            this.emit("notificationsChanged");
        },

        _hideIfEmpty: function () {

            var show = this.getChildren().length > 0;

            domClass.toggle(this.domNode, this.noBorderClass, !show);

            domStyle.set(this.domNode, "display", show ? "" : "none");
        }
    });

    return NotificationBar;
});

},
'url:epi-cms/contentediting/templates/NotificationBar.html':"﻿<div class=\"epi-notificationBar\">\r\n    <div data-dojo-attach-point=\"containerNode\"></div>\r\n</div>",
'url:epi-cms/contentediting/templates/NotificationBarItem.html':"﻿<div class=\"epi-notificationBarItem\">\r\n    <div class=\"epi-notificationBarText\" data-dojo-attach-point=\"contentContainer\">\r\n        <p data-dojo-attach-point=\"textContainer\"></p>\r\n    </div>\r\n    <div class=\"epi-notificationBarButtonContainer\" data-dojo-attach-point=\"buttonContainer\">\r\n        <button data-dojo-type=\"dijit/form/Button\" class=\"epi-chromelessButton\" data-dojo-props=\"iconClass:'epi-iconClose', showLabel:false\" data-dojo-attach-event=\"onClick:_onClose\"></button>\r\n    </div>\r\n</div>",
'epi-cms/contentediting/OnPageEditing':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/when",

    "epi/shell/gesture/ScrollPullDown",
    "epi-cms/contentediting/_FormEditingMixin",
    "epi-cms/contentediting/_ValidationMixin",
    "epi-cms/contentediting/EditingBase"
],

function (
    declare,
    lang,
    aspect,
    when,

    ScrollPullDown,
    _FormEditingMixin,
    _ValidationMixin,
    EditingBase
) {

    return declare([EditingBase, _FormEditingMixin, _ValidationMixin], {
        _iframeConnects: null,

        postMixInProperties: function () {
            this.inherited(arguments);

            this.formSettings = {
                doLayout: false,
                baseClass: "epi-cmsEditingForm epi-cmsEditingFormOpe",
                propertyFilter: function (parent, property) {
                    return property.groupName === "EPiServerCMS_SettingsPanel";
                }
            };
        },

        destroy: function () {
            this._removePullDownGesture();
            this.inherited(arguments);
        },

        onEditorWrapperCreated: function (editorWrapper) {
            // summary:
            //      Triggered when the active editor wrapper created.
            //
            // editorWrapper:
            //      The created editor wrapper
            //
            // tags:
            //    public, override, callback

            if (editorWrapper && editorWrapper.editorWidget) {
                var editorWidget = editorWrapper.editorWidget;

                if (editorWidget.onFieldCreated) {
                    this.connect(editorWidget, "onFieldCreated", function (fieldName, widget) {
                        this._addStateWatch(widget);
                    });
                } else {
                    editorWidget.set("name", editorWrapper.get("propertyName"));
                    this._addStateWatch(editorWidget);
                }

                // Make sure content is validated when editorWidget is ready
                editorWidget.validate && editorWidget.validate();
            }
        },

        onSetActiveProperty: function (property) {
            // summary:
            //      Triggered when active property is set on the current content view model.
            //  remark:
            //      Check if property mapping doesn't exist, request switch edit mode to end up in Form Editing, where all the properties are available,
            // property: [String]
            //      The property name.
            // tag:
            //      public, override, callback.

            var mapping = this._mappingManager.findOne("propertyName", property);
            if (!mapping) {
                dojo.publish("/epi/cms/action/switcheditmode", [null, { activePropertyOnStartup: property}]);
            } else {
                this.inherited(arguments);
            }
        },

        _onOverlayItemClick: function (overlayItem, e) {
            var editorWrapper = this._activeEditorWrapper;
            
            if (editorWrapper) {
                // If there is an active editor try to stop editing.
                editorWrapper.tryToStopEditing();
                
                // If still in an editing state after trying to stop then return since we don't want to open another editor before this is closed.
                // Or if clicking on overlay item of the same property, do not open another editor.
                if (editorWrapper.editing || overlayItem.name === editorWrapper.overlayItem.name) {
                    return;
                }
            }

            this.inherited(arguments);
        },

        placeForm: function (form) {
            // summary:
            //		Setup the edit form.
            // tags:
            //		protected

             //Put edit form on the top region of the layout container.
             //It need not to be wrapped in a content pane because of its fixed size and responsiveness.

            form.set("fitContainer", false);
            form.set("transitionMode", "slideIn");

            this.editLayoutContainer.addChild(form, 0);

            this._setupPullDownGesture(form);
        },

        _setupPullDownGesture: function (form) {
            // summary:
            //		Setup pulldown gesture on the form (settings panel).
            // tags:
            //		private

            var opeController = this;

            // Create pull down gesture
            this._pullDownGesture = ScrollPullDown(opeController.iframeWithOverlay.previewContainer, {
                isShown: false,

                show: function () {
                    this.isShown = null; // transiting state
                    when(opeController.editLayoutContainer.selectChild(form), lang.hitch(this, function () {
                        // success
                        this.isShown = true;
                        opeController.iframeWithOverlay.onViewportPullDown();
                    }), lang.hitch(this, function () {
                        // failed
                        this.isShown = false;
                        opeController.iframeWithOverlay.onViewportPullDown();
                    }));
                },

                hide: function () {
                    this.isShown = null; // transiting state
                    when(opeController.editLayoutContainer.selectChild(opeController.iframeWithOverlay), lang.hitch(this, function () {
                        // success
                        this.isShown = false;
                        opeController.iframeWithOverlay.onViewportPullDown();
                    }), lang.hitch(this, function () {
                        // failed
                        this.isShown = true;
                        opeController.iframeWithOverlay.onViewportPullDown();
                    }));
                }
            });

            // Listen to wheel events on the pull-down panel so it's hidden when we scroll down with the pointer over it
            this._pullDownGesture.addMouseWheelListener(form.domNode);

            // Need to listen to mouse wheel events inside the iframed document in IE and Firefox
            if (opeController.iframeWithOverlay.iframe.isInspectable()) {
                this._setupIframeMouseWheelListeners();
            }
        },

        _setupIframeMouseWheelListeners: function () {
                var frameDocumentListener = this._pullDownGesture.addMouseWheelListener(this.iframeWithOverlay.iframe.getDocument());

            this._iframeConnects = [];
            this._iframeConnects.push(this.connect(this.iframeWithOverlay.iframe, "onLoad", function () {
                    frameDocumentListener = this._pullDownGesture.addMouseWheelListener(this.iframeWithOverlay.iframe.getDocument());
            }));

            this._iframeConnects.push(this.connect(this.iframeWithOverlay.iframe, "onUnload", function () {
                    frameDocumentListener && frameDocumentListener.remove();
            }));
        },

        _teardownIframeMouseWheelListeners: function () {
            if (this._iframeConnects) {
                var c;
                while (c = this._iframeConnects.pop()) {
                    this.disconnect(c);
                }
                c = null;
                this._iframeConnects = null;
            }
        },

        _removePullDownGesture: function () {
            this._teardownIframeMouseWheelListeners();

            if (this._pullDownGesture) {
                this._pullDownGesture.destroy();
                this._pullDownGesture = null;
            }
        },

        removeForm: function (form) {
            // summary:
            //		Remove edit form from container.
            // tags:
            //		protected

            // Destroy pull down gesture.
            this._removePullDownGesture();

            this.editLayoutContainer.leftOver = form;
            return false;
        }
    });
});
},
'epi/shell/gesture/ScrollPullDown':function(){
﻿define("epi/shell/gesture/ScrollPullDown", [
"dojo/_base/declare",
"dojo/_base/event",
"dojo/_base/lang",
"dojo/mouse",
"dojo/on",
"dijit/Destroyable"],
function (
    declare,
    event,
    lang,
    mouse,
    on,
    Destroyable) {

    return declare([Destroyable], {
        // summary:
        //  Class for listening to mouse wheel movements and call show and hide delegate based on 
        //  the current scroll position of a monitored target. The class is used for to identify 
        //  when to show or hide a pull-down menu based on scroll wheel movement.
        //  If the scrolling is at the top of the scrollTarget (see contructor arguments) when 
        //  indicates a positive wheelDelta, the the show delegate is omitted. If the show delegate has been 
        //  called when a mouse wheel event indicates a negative wheelDelta then the hide delegate is called. 

        _delegate: null,

        _scrollTarget: null,
        _isScrolling: false,
        _pullDownInertia: 100,

        // Timeout references
        _ts: null,
        _tb: null,

        destroy: function () {
            this._delegate = null;
        },

        constructor: function (/*DOMNode*/scrollTarget, /*Object*/delegate) {
            // summary:
            //  Set up a new instance monitoring a specific dom node
            //
            // scrollTarget:
            //  A node with scrolling enabled and whose scrollTop value must be 0 for the show event to be emitted
            // delegate:
            //  An object that contains show, hide methods and isShown property.

            this._delegate = delegate;

            this._scrollTarget = scrollTarget;
            this.addMouseWheelListener(scrollTarget);
        },

        addMouseWheelListener: function (/*DOMNode*/target) {
            // summary:
            //  Add a mouse wheel delegate to the supplied target.
            //
            // returns:
            //  An delegate handle on which you can call remove to detach the delegate.

            if (target) {
                return this.own(on(target, mouse.wheel, lang.hitch(this, this._onMouseWheel)))[0];
            } 

        },

        _blockShowEvent: function () {
            // summary:
            //  Used for blocking the show event while scrolling continously. We don't want the event
            //  emitted as a part of scrolling to the top of the page. 
            //  Requires _pullDownInertia ms of grace time between wheel events once the top is reached.
            //
            // tags: private

            if (this._scrollTarget.scrollTop > 0) {
                this._isScrolling = true;
            }

            this._ts && clearTimeout(this._ts);
            this._ts = setTimeout(lang.hitch(this, function () { this._isScrolling = false; }), this._pullDownInertia);

            return this._isScrolling;
        },

        _initiateScrollBlock: function () {
            // summary:
            //  Sets a flag indicating that the mouse whhel event should be blocked while continously emitted

            this._scrollBlock = true;
        },

        _blockScrollEvent: function() {
            // summary:
            //  Returns true if the scroll event should be blocked, and resets the timeout used for 
            //  adding resistance between scrolling of the _scrollTarget and showing/hiding the pull-down menu.

            this._tb && clearTimeout(this._tb);
            this._tb = setTimeout(lang.hitch(this, function () { this._scrollBlock = false; }), this._pullDownInertia);

            // Block scrolling if the pull-down menu is opening or hiding; or the blocking timeout hasn't expired
            return (this._delegate.isShown == null) || this._scrollBlock;
        },



        _raiseShow: function (evt) {
            // summary:
            //  Calls the show delegate. The delegate is only called once for each show/transiting/hide cycle

            // The hide delegate should be called when _isShown === false (obviously not shown)
            if (this._delegate.isShown === false) {
                event.stop(evt);
                this._delegate.show();
                this._initiateScrollBlock();
            }
        },

        _raiseHide: function (evt) {
            // summary:
            //  Calls the hide delegate. The delegate is only called once for each show/transiting/hide cycle

            // The hide delegate should be called when _isShown === true (obviously shown)
            if (this._delegate.isShown === true) {
                event.stop(evt);
                this._delegate.hide();
                this._initiateScrollBlock();
            }
        },

        _onMouseWheel: function (evt) {

            if (!evt.wheelDelta) {
                // Even if the event has no wheel direction we update the scroll block timeout
                this._blockScrollEvent();
                return;
            }

            if (this._blockScrollEvent()) {
                // When hiding (scrolling down while shown) we don't wan't the connected scroll target to scroll.
                event.stop(evt);
                return;
            }

            if (evt.wheelDelta < 0 || (this._delegate.isShown && this._scrollTarget.scrollTop > 0)) {
                // Scrolling down or scrolling when we're in shown state
                this._raiseHide(evt);
            } else if (!this._blockShowEvent()) {
                this._raiseShow(evt);
            }
        }

    });

});
},
'epi-cms/contentediting/PageDataController':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-style",

    "dojo/Deferred",
    "dojo/promise/all",
    "dojo/topic",
    "dojo/when",
// dijit
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",

    "dijit/layout/BorderContainer", // used in template
// epi
    "epi/dependency",
    "epi/string",
    "epi/Url",

    "epi/shell/layout/CardContainer",
    "epi/shell/widget/IframeWithOverlay", // used in template

    "epi-cms/_ContentContextMixin",

    "epi-cms/contentediting/ContentReferencesNotification",
    "epi-cms/contentediting/ContentViewModel",
    "epi-cms/contentediting/EditToolbar", // used in template
    "epi-cms/contentediting/ExpirationNotification",
    "epi-cms/contentediting/LanguageNotification",
    "epi-cms/contentediting/NotificationBar", // used in template
    "epi-cms/contentediting/ShortcutNotification",
    "epi-cms/contentediting/ViewSettingsNotification",
    "epi-cms/contentediting/WorkflowTaskNotification",

    "epi-cms/contentediting/command/Editing",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting",
    "dojo/text!./templates/PageDataController.html"
],

function (
// dojo
    array,
    declare,
    lang,

    domClass,
    domStyle,

    Deferred,
    all,
    topic,
    when,
// dijit
    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,

    BorderContainer, // used in template
// epi
    dependency,
    epiString,
    Url,

    CardContainer,
    IframeWithOverlay, // used in template

    _ContentContextMixin,

    ContentReferencesNotification,
    ContentViewModel,
    EditToolbar, // used in template
    ExpirationNotification,
    LanguageNotification,
    NotificationBar, // used in template
    ShortcutNotification,
    ViewSettingsNotification,
    WorkflowTaskNotification,

    EditingCommands,
// resources
    res,
    template
) {

    // summary:
    //      This component will list all versions of a cms page.
    // tags:
    //      public

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _ContentContextMixin], {
        templateString: template,

        // contextTypeName: String
        //      Type name for the context we can handle
        contextTypeName: "epi.cms.contentdata",

        pendingNotificationTimeOutId: null, // holds the timeout handler when pending the notifcation

        isActive: true,

        // defaultEditCssRules: Array
        //      The CSS rules to inject when we're editing
        defaultEditCssRules: [
            { selector: ".epi-injected-minSize", css: "min-height: 30px;" },
            { selector: ".epi-injected-minSize-inline", css: "min-height: 30px; min-width: 100px; display: inline-block !important;" },
            { selector: "[contenteditable=true]:focus", css: "outline: 3px #b4c600 solid;" }
        ],

        _currentViewComponent: null,
        _viewModels: null,
        _notificationHandlerId: null,
        _messageService: null,

        _editingCommands: null,
        _currentViewModel: null,
        _pageDataStore: null,

        // _contentReferencesNotification: ContentReferencesNotification
        //      Notification for content references
        _contentReferencesNotification: null,

        // _shortcutNotification: ShortcutNotification
        //      Notification for shortcut
        _shortcutNotification: null,

        // _languageNotification: LanguageNotification
        //      Notification for language
        _languageNotification: null,

        // _expirationNotification: ExpirationNotification
        //      Notification for expiration
        _expirationNotification: null,

        // _workflowTaskNotification: WorkflowTaskNotification
        //      Notification for workflow task
        _workflowTaskNotification: null,

        _availableViews: null,

        _previewQueryParameters: null,
        _viewSettingsManager: null,
        _inUseNotificationManager: null,

        _showOverlay: true,

        postMixInProperties: function () {
            this.inherited(arguments);

            var registry = dependency.resolve("epi.storeregistry");

            //resolve _viewSettingsManager
            this._viewSettingsManager = dependency.resolve("epi.viewsettingsmanager");

            // get dependency properties
            this._messageService = this._messageService || dependency.resolve("epi.shell.MessageService");
            this._profile = this._profile || dependency.resolve("epi.shell.Profile");
            this._pageDataStore = registry.get("epi.cms.contentdata");

            this._editingCommands = EditingCommands;

            // create new data for views to persist
            if (!this._viewModels) {
                this._viewModels = [];
            }

            this._inUseNotificationManager = this.inUseNotificationManager || dependency.resolve("epi.cms.contentediting.inUseNotificationManager");

            this._contentReferencesNotification = new ContentReferencesNotification();
            this._languageNotification = new LanguageNotification();
            this._expirationNotification = new ExpirationNotification();
            this._shortcutNotification = new ShortcutNotification();
            this._viewSettingsNotification = new ViewSettingsNotification();
            this._workflowTaskNotification = new WorkflowTaskNotification();
        },

        postCreate: function () {
            this.inherited(arguments);

            this.subscribe("/epi/cms/action/switcheditmode", lang.hitch(this, this._switchEditMode));

            // connect to context service
            var cs = dependency.resolve("epi.shell.ContextService");
            this._interceptorHandle = cs.registerRequestInterceptor(lang.hitch(this, this._interceptRequestContext));

            this.notificationBar.on("notificationsChanged", lang.hitch(this, function () {
                this.mainLayoutContainer.layout();
            }));

            this.own(
                this._contentReferencesNotification.watch("notification", lang.hitch(this, this._contentReferencesNotificationWatchHandler)),
                this._languageNotification.watch("notification", lang.hitch(this, this._defaultNotificationWatchHandler)),
                this._expirationNotification.watch("notification", lang.hitch(this, this._defaultNotificationWatchHandler)),
                this._shortcutNotification.watch("notification", lang.hitch(this, this._shortcutNotificationWatchHandler)),
                this._viewSettingsNotification.watch("notification", lang.hitch(this, this._defaultNotificationWatchHandler)),
                this._workflowTaskNotification.watch("notification", lang.hitch(this, this._workflowTaskNotificationWatchHandler))
            );
        },

        startup: function () {

            if (this._started) { return; }

            this.inherited(arguments);

            var url = new Url(window.location.href),
                startView = url.getQueryParameterValue("view");

            this.iFrame = this.iframeWithOverlay.iframe;

            this.connect(this.iFrame, "onLoad", "_iFrameLoaded");
            this.connect(this.iFrame, "onUnload", "_iFrameUnLoaded");

            domClass.add(this.toolbar.domNode, "epi-localToolbar epi-viewHeaderContainer");

            this._injectCssRules();

            when(this.getCurrentContext(), lang.hitch(this, function (context) {
                this.contextChanged(context);
            }));
        },

        _defaultNotificationWatchHandler: function (/*String*/name, /*Object*/oldValue, /*Object*/newValue) {
            // summary:
            //      Add/remove notification to/from notification bar
            // tags:
            //      private

            if (oldValue) {
                this.notificationBar.remove(oldValue);
            }

            if (newValue && newValue.content) {
                this.notificationBar.add(newValue);
            }
        },

        _shortcutNotificationWatchHandler: function (/*String*/name, /*Object*/oldValue, /*Object*/newValue) {
            // summary:
            //      Shortcut notification watch handler
            //      Add/remove notification to/from notification bar if any changes in shortcut notification
            // tags:
            //      private

            this._defaultNotificationWatchHandler(name, oldValue, newValue);
            this._showOverlay = ShortcutNotification.LinkTypes[newValue.shortcutType] !== "fetchdata";
        },

        _contentReferencesNotificationWatchHandler: function (/*String*/name, /*Object*/oldValue, /*Object*/newValue) {
            // summary:
            //      Content references notification watch handler
            //      Add/remove notification to/from notification bar if any changes in content references notification
            // tags:
            //      private

            this._defaultNotificationWatchHandler(name, oldValue, newValue);
            this.notificationBar.set("viewModel", this._currentViewModel.contentData);
        },

        _workflowTaskNotificationWatchHandler: function (/*String*/name, /*Object*/oldValue, /*Object*/newValue) {
            // summary:
            //      Workflow task notification watch handler.
            //      Add/remove notification to/from notification bar if any changes in workflow task notification
            // tags:
            //      private

            if (oldValue instanceof Array) {
                array.forEach(oldValue, function (oldNotification) {
                    this.notificationBar.remove(oldNotification);
                }, this);
            }

            if (newValue instanceof Array) {
                array.forEach(newValue, function (newNotification) {
                    this.notificationBar.add(newNotification);
                }, this);
            }
        },

        _switchEditMode: function (switchToPrevious, viewParams) {
            var newView,
                currentView = this._currentViewModel.viewName,
                reloadUrl = null,
                previewView = "view",
                onPageEditView = "onpageedit",
                allPropertiesView = "formedit";

            if (currentView === previewView) {
                topic.publish("/epi/cms/action/disablepreview");
            }
            if (currentView === allPropertiesView) {
                newView = onPageEditView;

                // whenever display onPageEdit view, let the iframe reload content in order to render overlay
                reloadUrl = this._getPreviewUrl(this._currentContentContext, newView);
            } else {
                newView = allPropertiesView;
            }

            this._ensurePreviewReady(this.setView(newView, viewParams), reloadUrl, true);
        },

        destroy: function () {
            this._interceptorHandle.remove();
            this._destroyCurrentViewComponent();
            this._viewModels = null;
            this.inherited(arguments);
        },

        _iFrameLoaded: function (url, triggeredExternally) {
            // summary:
            //  Event handler when a new document has been loaded into the inner iframe.
            //
            // url: string
            //  url of the frame source
            //
            // triggeredExternally: Boolean
            //  True when the load was initiated by an external context change, as opposed to a click on a linck inside the iframe.

            if (!!url && !triggeredExternally) {

                // Iframe is reloaded when user clicks on a link in preview iframe.
                // set dirty flag

                // request a context change
                this._requestContextChangeByUrl(url, true, true);
            }
        },

        _iFrameUnLoaded: function (url) {
            //Disable the overlay before loading the new view
            this.iframeWithOverlay.overlay.set("enabled", false);
        },

        _destroyCurrentViewComponent: function () {

            if (this._currentViewComponentReloadRequireHandle) {
                this._currentViewComponentReloadRequireHandle.remove();
                this._currentViewComponentReloadRequireHandle = null;
            }

            if (this._currentViewComponent) {
                this._currentViewComponent.destroyRecursive();
                this._currentViewComponent = null;
            }
        },

        _getViewModelIndex: function (id) {

            var index = -1;

            array.some(this._viewModels, function (item, idx) {
                if (item.contentLink == id) {
                    index = idx;
                    return true;
                }
            });

            return index;
        },

        _getViewModel: function (id) {

            var index = this._getViewModelIndex(id);

            if (index >= 0) {
                return this._viewModels[index];
            } else {
                return null;
            }
        },

        _removeViewModel: function (id) {

            var index = this._getViewModelIndex(id);

            if (index >= 0) {

                // remove from list
                var viewModel = this._viewModels.splice(index, 1)[0];

                viewModel.clear();
            }
        },

        _createViewModel: function (contentData, ctx) {

            var viewModel = new ContentViewModel({ contentLink: contentData.contentLink, contextTypeName: this.contextTypeName });
            viewModel.set("contentData", contentData);
            viewModel.set("languageContext", ctx.languageContext);

            this._viewModels.push(viewModel);

            return viewModel;
        },

        contentContextUpdated: function (ctx, callerData) {
            // summary:
            //    Called when the currently loaded content updated.
            // tags:
            //    protected

            var contentLink = ctx.id;
            this._pageDataStore.refresh(contentLink).then(lang.hitch(this, function (contentData) {
                if (this._currentViewModel) {
                    this._updateContentViewModel(contentData, ctx.languageContext);
                    this._refreshModel(contentData, ctx);
                }
            }));
        },

        updateView: function (callerData, ctx, additionalParams) {
            if (callerData && callerData.skipUpdateView) {
                return;
            }

            // Hide our self when content is
            if (additionalParams && additionalParams.widgetResumed) {
                domStyle.set(this.domNode, "visibility", "hidden");
            }


            if (callerData && callerData.contextIdSyncChange) {
                //We need to refresh content data when content link change on sync.
                this._pageDataStore.refresh(ctx.id).then(lang.hitch(this, function (contentData) {
                    this._updateContentViewModel(contentData, ctx.languageContext);
                    this._currentViewComponent.onContentLinkSyncChange();

                    this._refreshModel(contentData, ctx);
                }));
            } else {
                this._previousEditMode = null;

                if (this._currentViewModel) {
                    this._currentViewModel.suspend();
                }

                var viewName;

                if (callerData && callerData.viewName) {
                    if (callerData.availableViews) {
                        // receive the available views list from widget switcher
                        // convert to hashtable for easier looking up.
                        this._availableViewsLookup = {};
                        array.forEach(callerData.availableViews, lang.hitch(this, function (availableView) {
                            this._availableViewsLookup[availableView.key] = availableView;
                        }));
                    }
                    viewName = callerData.viewName;
                }

                this.toolbar.update({
                    currentContext: ctx,
                    viewConfigurations: {
                        availableViews: callerData.availableViews,
                        viewName: callerData.viewName
                    }
                });

                if (this._currentViewComponent && this._currentViewComponent.isSticky) {
                    viewName = this._currentViewModel.viewName;
                }

                // reload iframe whenever context change was not triggered by the preview
                var reloadUrl = this._getPreviewUrl(ctx, viewName);

                this._ensurePreviewReady(this._loadContentDataAndSetView(ctx.id, viewName, ctx), reloadUrl);
            }
        },

        _getPreviewUrl: function(context, viewName) {
            // summary:
            //      Gets the URL for the preview based on the requested view.
            // tags:
            //      private

            return (viewName === "view" && context.previewUrl) ? context.previewUrl : context.editablePreviewUrl; // String
        },

        _ensurePreviewReady: function (action, reloadUrl, forceReload) {
            // summary:
            //      Perform an action and reload preview iframe if needed.
            //      Raise OnPreviewReady event on the current view component when both are finished.

            var waitList = [];

            if (action) {
                waitList.push(action);
            }

            if (reloadUrl !== null && reloadUrl !== undefined) {
                waitList.push(this._changeUrl(reloadUrl, forceReload));
            }

            all(waitList).then(
                lang.hitch(this, function () {
                    var doc = this.iframeWithOverlay.iframe.getDocument();
                    // wait for the setup of the overlay to become ready(update the overlay items needed) which will happen async in onPreviewReady
                    var handle = this.connect(this._currentViewComponent, "onPrepareOverlayComplete", function () {
                        this.disconnect(handle);
                        handle = null;
                        this.iframeWithOverlay.overlay.set("enabled", this._showOverlay && this.iframeWithOverlay.iframe.isInspectable());
                        this.iframeWithOverlay.layout(true);
                    });

                    // Make sure we're visible
                    domStyle.set(this.domNode, "visibility", "visible");

                    this._viewSettingsManager.onPreviewReady(this.iframeWithOverlay);
                    this._currentViewComponent.onPreviewReady(this._currentViewModel, doc);

                    this._viewSettingsNotification.set("invokeActionValue", { viewModel: this._currentViewModel, viewSetting: this._viewSettingsManager });
                })
            );
        },

        _loadContentDataAndSetView: function (contentLink, viewName, ctx) {
            var def = new Deferred();

            // When we're editing data it will get already the fresh data from the server.
            when(this._pageDataStore.refresh(contentLink), lang.hitch(this, function (contentData) {
                if (!contentData) {
                    return;
                }

                this._currentViewModel = this._getViewModel(contentData.contentLink);

                this.notificationBar.clear();

                // create a new viewModel if empty
                if (!this._currentViewModel) {
                    this._currentViewModel = this._createViewModel(contentData, ctx);
                } else {
                    // Always set the currentPage property since it might have been updated.
                    this._updateContentViewModel(contentData, ctx.languageContext);
                }

                this._currentViewModel.set("viewLanguage", this._viewSettingsManager.get("enabled") ? this._viewSettingsManager.getSettingProperty("viewlanguage") : null);

                this._refreshModel(contentData, ctx);

                when(this.setView(viewName), function () { def.resolve(); }, function () { def.cancel(); });
            }), function () { def.reject(); });

            return def;
        },

        _updateContentViewModel: function (contentData, languageContext) {
            this._currentViewModel.wakeUp();
            this._currentViewModel.set("contentData", contentData);
            this._currentViewModel.set("languageContext", languageContext);
        },

        _refreshModel: function (contentData, context) {
            // summary:
            //      Sets the updated model on all the commands and notifications.

            // NOTE: This method should be the target of some serious PageDataController refactoring.
            var model = this._currentViewModel;
            if (model) {
                // Update the toolbars model
                this.toolbar.set("contentViewModel", model);

                // Set view model to the extensions first
                this._inUseNotificationManager.updateCommandModel(model);

                // Push the new content to the commands
                this._editingCommands.set("model", model);

                // Update notifications
                this._contentReferencesNotification.set("invokeActionValue", model.contentData);
                this._languageNotification.set("invokeActionValue", context);
                this._shortcutNotification.set("invokeActionValue", model);
                this._workflowTaskNotification.set("invokeActionValue", model.contentData);
                this._expirationNotification.set("invokeActionValue", model);
            }
        },

        itemChanged: function (id, item) {
            // summary:
            //		Notification event when an item has been patched or reloaded.
            // object: id
            //		The id of the updated item.
            // object: item
            //		The updated item.
            // tags:
            //		public


        },

        setView: function (viewName, viewParams) {
            // summary:
            //      Set and load current view handler.
            // viewName: String
            //      Alias name of view handler class. Known views are: view, onpageedit, formedit, readonly.
            // viewParams: Object
            //      Parameters to be mixed in view handler on creation.
            // tag:
            //      public

            var def = new Deferred();

            // Quick fix for the content that do not have template and default view is ope or the ope is not avaiable.
            // The proper fix will come after 7.5 release when we have strong type representation for system pages and content type which have no template.
            if (viewName === "onpageedit" && (!this._currentViewModel.contentData.hasTemplate || !(viewName in this._availableViewsLookup))) {
                viewName = "formedit";
            }

            // exit if it's the current view or view is unknown
            if (viewName && !(viewName in this._availableViewsLookup)) {
                return;
            }

            var onResolved = lang.hitch(this, function () {
                when(this._setView(viewName, viewParams), function () { def.resolve(); }, function () { def.cancel(); });
            });

            var onRejected = lang.hitch(this, function () {
                topic.publish("/epi/cms/action/showerror");
                def.cancel();
            });

            when(this._savePendingChanges(), onResolved, onRejected);

            return def;
        },

        _setView: function (viewName, viewParams) {
            var def = new Deferred(),
                component = this._currentViewComponent,
                reuseCurrentViewComponent = component && component.viewModel && component.viewModel.viewName === viewName;

            // Never resuse at this moment
            reuseCurrentViewComponent = false;

            if (reuseCurrentViewComponent) {
                this._currentViewModel.viewName = viewName;
                this.toolbar.set("contentViewModel", this._currentViewModel);
                def.resolve();
            } else {
                // Create and load a new view


                // destroy current view
                this._destroyCurrentViewComponent();

                var widgetType = epiString.slashName(this._availableViewsLookup[viewName].viewType);

                require([widgetType], lang.hitch(this, function (widgetClass) {
                    // create new instance
                    this._currentViewComponent = new widgetClass(lang.mixin({
                        mainLayoutContainer: this.mainLayoutContainer,
                        editLayoutContainer: this.editLayoutContainer,
                        iframeWithOverlay: this.iframeWithOverlay,
                        contextTypeName: this.contextTypeName,
                        toolbar: this.toolbar
                    }, viewParams));

                    this._currentViewComponentReloadRequireHandle = this.connect(this._currentViewComponent, "onReloadRequired", this._onViewRequireReload);

                    this._currentViewComponent.startup();

                    this._currentViewModel.viewName = viewName;
                    this.toolbar.set("contentViewModel", this._currentViewModel);

                    // NOTE: The leftover is kept on the editLayoutContainer for the sake of a better feeling when switching between ope and form.
                    // Other views rather than ones that implement _FormEditingMixin may have no idea about it. Therefore, the controller should be responsible for a cleanup.
                    // For the long run, to avoid the left over things, form editing and ope should be combined into one view.
                    if (this.editLayoutContainer.leftOver && !this._currentViewComponent.canHandleLeftOver) {
                        when(this.editLayoutContainer.selectedChildWidget === this.editLayoutContainer.leftOver ? this.editLayoutContainer.selectChild(this.iframeWithOverlay) : null,
                            lang.hitch(this, function () {
                                this.editLayoutContainer.removeChild(this.editLayoutContainer.leftOver);
                                this.editLayoutContainer.leftOver.destroyRecursive();
                                this.editLayoutContainer.leftOver = null;
                            })
                        );
                    }

                    def.resolve();
                }));
            }

            return def;
        },

        _onViewRequireReload: function () {
            var previewUrl = this._getPreviewUrl(this._currentContentContext, this._currentViewModel.viewName);
            this._ensurePreviewReady(null, previewUrl, true);
        },

        resize: function (size) {
            // summary:
            //    Call this to resize a widget, or after its size has changed.
            // tags:
            //    public
            this.inherited(arguments);

            this.mainLayoutContainer.resize(size);
        },

        onShow: function () {
            // summary:
            //    Called by container widgets when showing this widget.
            this.iframeWithOverlay.overlay.set("enabled", this._showOverlay);
        },

        onHide: function () {
            // summary:
            //    Called by container widgets when hiding this widget.
            this.iframeWithOverlay.overlay.set("enabled", false);
        },

        _clearNotifications: function () {
            // summary:
            //    clear all notifications.
            // tags:
            //    private

            if (this._currentViewModel && this._currentViewModel.validator) {
                this._currentViewModel.validator.clear();
            }
        },

        _requestContextChangeByUrl: function (url, forceContextChange, suppressFailure, params, mixWithExistingParams) {
            var newUrl = new Url(url, params, mixWithExistingParams),
                contextParameters = { url: newUrl.toString() },
                callerData = {
                    sender: this,
                    forceContextChange: forceContextChange,
                    suppressFailure: suppressFailure,
                    viewName: this._currentViewModel && this._currentViewModel.viewName
                };

            topic.publish("/epi/shell/context/request", contextParameters, callerData);
        },

        _changeUrl: function (url, forceReload) {
            var previewParams = lang.mixin(this._previewQueryParameters, this._viewSettingsManager.get("previewParams"));

            // we want a reload even if its a same url in order to render all kind of contents (i.e videos)
            return this.iframeWithOverlay.iframe.load(url, { query: previewParams }, true, forceReload);
        },

        _interceptRequestContext: function (newContextParams, callerData) {
            // intercept all context requests so we can resolve any pending changes before context changes

            if (!(callerData && callerData.sender && callerData.sender === this)) {
                // a new context request, resolve pending changes
                return this._savePendingChanges();
            } else {
                var def = new Deferred();
                def.resolve();
                return def;
            }
        },

        _savePendingChanges: function () {
            if (this._currentViewModel && !this._currentViewModel.isSaved) {
                // resolve pending changes first
                return this._currentViewModel.save();
            } else {
                // resolve imediately
                var def = new Deferred();
                def.resolve();
                return def;
            }
        },

        savePendingChanges: function () {
            return this._savePendingChanges();
        },

        _injectCssRules: function () {
            this.iFrame.addCssRules(this.defaultEditCssRules);
        }

    });

});

},
'epi/shell/layout/CardContainer':function(){
﻿define("epi/shell/layout/CardContainer", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/fx",

    "dojo/aspect",
    "dojo/has",
    "dojo/on",

    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-geometry",

    "dojo/Deferred",
    "dojo/when",

    "dijit/_TemplatedMixin",
    "dijit/layout/StackContainer",

    "dgrid/util/has-css3"
], 
function (
    declare,
    lang,
    fx,

    aspect,
    has,
    on,

    domClass,
    domStyle,
    domGeometry,

    Deferred,
    when,

    _TemplatedMixin,
    StackContainer,
    
    hasCss3) {

    return declare([StackContainer, _TemplatedMixin], {
        // summary:
        //      Layout container that organize pages like set of cards. 
        //      Selected page is transitted using animation.

        // doLayout: Boolean
        //      Override StackContainer.doLayout. Should always be false. In CardContainer, each page decides whether it wants to do layout.
        doLayout: false,

        // transitionClass: String
        //      Css class use to perform page transition.
        transitionClass: "epi-transition",

        // transitionDirection: String
        //      Page transition direction. Available values are "vertical" and "horizontal". 
        //      Invalid values are considered to be "vertical".
        transitionDirection: "vertical",

        // baseClass: String
        //      Widget's base css class.
        baseClass: "epi-cardContainer",

        // templateString: String
        //      Widget's template string.
        templateString: "<div><div class='dijitContainer' style='position: relative;' data-dojo-attach-point='containerNode'></div></div>",

        layout: function () {
            // summary:
            //		Layout the contained pages.
            // description:
            //      Stack container set size on all pages depend on the container's doLayout property. Card container let the page design if it want to do layout.
            // tags:
            //		protected extension

            var child = this.selectedChildWidget;

            var children = this.getChildren(), topPage = children[children.length - 1];

            if (child && child.resize) {
                // If the page want to fit in container?
                if (child.fitContainer) {
                    child.resize(this._containerContentBox || this._contentBox);
                } else {
                    child.resize();
                }
            }

            // If current page does not fit the container, set the top page to visible and lay it out.
            if (child !== topPage && !child.fitContainer) {
                domClass.replace(topPage.domNode, "dijitVisible", "dijitHidden");
                if (topPage && topPage !== child && topPage.resize) {
                    if (topPage.fitContainer) {
                        topPage.resize(this._containerContentBox || this._contentBox);
                    } else {
                        topPage.resize();
                    }
                }
            }
        },

        addChild: function (child, insertIndex) {
            // summary:
            //		Makes the given widget a child of this widget.
            // description:
            //		Inserts specified child widget's dom node as a child of this widget's
            //		container node, and possibly does other processing (such as layout).
            //
            //		Functionality is undefined if this widget contains anything besides
            //		a list of child widgets (ie, if it contains arbitrary non-widget HTML).

            if (this._started) {
                var children = this.getChildren(), topPage = children[children.length - 1];
                if (insertIndex >= children.length) {
                    domClass.replace(topPage.domNode, "dijitHidden", "dijitVisible");
                }
            }

            this.inherited(arguments);
        },

        _transition: function (newPage, oldPage /*===== ,  animate =====*/) {
            // summary:
            //		Hide the old widget and display the new widget.
            // newPage: Node|dijit/_WidgetBase
            //		The newly selected widget.
            // oldPage: Node|dijit/_WidgetBase
            //		The previously selected widget.
            // animate: Boolean
            //		Used by AccordionContainer to turn on/off slide effect.
            // tags:
            //		protected extension

            var children = this.getChildren(),
                topPage = children[children.length - 1];

            if (!oldPage || oldPage._destroyed) {
                return;
            }

            // Show the top page if it is invisible, to start transition
            if (oldPage.fitContainer && oldPage !== topPage) {
                domClass.replace(topPage.domNode, "dijitVisible", "dijitHidden");
            }

            return when(newPage === topPage ? this._hideTransition(oldPage, topPage) : null, lang.hitch(this, function (n) {
                var currentOffset = 0;
                if (oldPage && !oldPage._destroyed && oldPage !== topPage) {
                    currentOffset = domGeometry.getMarginBox(oldPage.domNode).h;
                    this._hideChild(oldPage);
                }

                if (!newPage || newPage._destroyed) {
                    return;
                }

                this._showChild(newPage);

                // Size the new widget, in case this is the first time it's being shown,
                // or I have been resized since the last time it was shown.
                // Note that page must be visible for resizing to work.
                if (newPage.resize) {
                    if (newPage.fitContainer) {
                        newPage.resize(this._containerContentBox || this._contentBox);
                    } else {
                        // the child should pick it's own size but we still need to call resize()
                        // (with no arguments) to let the widget lay itself out
                        newPage.resize(null);
                    }

                    // Animate the last page down, making an effect like that we are opening the new page.                    
                    return when(this._showTransition(newPage, topPage, currentOffset), function () {
                        // Hide the top page if the current page already take all the container's size. This is to prevent tab into the top page and scroll it into view
                        if (newPage.fitContainer && newPage !== topPage) {
                            domClass.replace(topPage.domNode, "dijitHidden", "dijitVisible");
                        }
                    });
                } else {
                    return;
                }
            }));
        },

        _hideTransition: function (oldPage, topPage) {
            // summary:
            //      Override to perform closing transition before hiding a page.
            // oldPage: Node|dijit._WidgetBase
            //      The old page which is about to hide.
            // topPage: Node|dijit._WidgetBase
            //      The top page.
            // tags:
            //      protected

            return this._doTransition(oldPage, topPage, false);
        },

        _showTransition: function (newPage, topPage, currentOffset) {
            // summary:
            //      Override to perform opening transition after showing a page.
            // newPage: Node|dijit._WidgetBase
            //      The new page which has just been shown.
            // topPage: Node|dijit._WidgetBase
            //      The top page.
            // currentOffset: Number
            //      Current offset of the topPage, from which animation starts.
            // tags:
            //      protected

            return this._doTransition(newPage, topPage, true, currentOffset);
        },

        _doTransition: function (page, topPage, opening, currentOffset) {
            // summary:
            //      Perform opening or closing transition.
            // page: Node|dijit._WidgetBase
            //      The current page.
            // topPage: Node|dijit._WidgetBase
            //      The top page.
            // opening: Boolean
            //      Indicate that the current page is being opened.
            // currentOffset: Number
            //      Current offset of the topPage, from which animation starts. Use on opening only.
            // tags:
            //      private

            // Animate the last page down/up, making an effect like that we are opening/closing the new page.
            if (page !== topPage) {
                var marginBox = domGeometry.getMarginBox(page.domNode),
                    animationNode = this._getAnimationNode(page, topPage);

                var property = this.transitionDirection === "vertical" ? "top" : "left",
                    size = this.transitionDirection === "vertical" ? marginBox.h : marginBox.w;
                from = opening ? -(size - currentOffset) + "px" : "0px",
                to = opening ? "0px" : -size + "px",
                restore = !opening;

                return this._animate(animationNode, property, from, to, restore);
            }
        },

        _getAnimationNode: function (page, topPage) {
            // summary:
            //      Get the node on which the transition effect is performed.
            // description:
            //      If the page's transitionMode was 'slideIn', the containerNode would be animated. Otherwise would be the last page.
            //      Used for default transition implementation only.
            // page: Node|dijit._WidgetBase
            //      The current page.
            // topPage: Node|dijit._WidgetBase
            //      The top page.
            // tags:
            //      private

            return page.transitionMode === "slideIn" ? this.containerNode : "reveal" ? topPage.domNode : null;
        },

        _animate: function (node, property, from, to, restore) {
            // summary:
            //      Animate a node using css transition.
            // node: Node
            //      The node to be animated.
            // property: String
            //      Css property used in animation.
            // from: String|Number
            //      Start value.
            // to: String|Number
            //      End value
            // restore: Boolean
            //      Indicate that it should restore the start value after animation.
            // tags:
            //      private

            var dfd = new Deferred();

            if (node && has("css-transitions")) {
                domStyle.set(node, property, from);

                // Observed on IE 10 that we must wait for a little while before touching the node, setting transition related properties or events. 
                // Otherwise, we don't get transitionend fired.
                setTimeout(lang.hitch(this, function () {
                    domClass.add(node, this.transitionClass);

                    var handle = on(node, has("transitionend"), lang.hitch(this, function () {
                        handle.remove();

                        domClass.remove(node, this.transitionClass);
                        if (restore) {
                            domStyle.set(node, property, from);
                        }

                        dfd.resolve();
                    }));

                    setTimeout(function () {
                        domStyle.set(node, property, to);
                    }, 1);
                }), 1);
            } else {
                dfd.resolve();
            }

            return dfd.promise;
        }
    });
});

},
'epi-cms/contentediting/ContentReferencesNotification':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/dom-construct",
    "dojo/on",
    "dojo/when",
// epi
    "epi",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/contentediting/_ContentEditingNotification",
    "epi-cms/command/BackCommand",
    "epi-cms/widget/sharedContentDialogHandler",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.notificationbar"
],

function (
// dojo
    array,
    declare,
    event,
    domConstruct,
    on,
    when,
// epi
    epi,
    TypeDescriptorManager,
    _ContentEditingNotification,
    BackCommand,
    sharedContentDialogHandler,
// resources
    resources
) {

    return declare([_ContentEditingNotification], {

        // _backCommand: BackCommand
        _backCommand: null,

        constructor: function (params) {

            this._backCommand = new BackCommand();
        },

        postscript: function () {
            this._storeName = "epi.cms.contentreferences";

            this.inherited(arguments);
        },

        _executeAction: function (/*Object*/value) {
            // summary:
            //      Get content reference
            // tags:
            //      protected, extension

            var typeShouldActAsAsset = TypeDescriptorManager.getValue(value.typeIdentifier, "actAsAnAsset");
            if (!typeShouldActAsAsset) {
                return false;
            }

            return this._store.get(value.contentLink);
        },

        _onExecuteSuccess: function (/*Object*/references) {
            // summary:
            //      Set notification(s) when executed success
            // tags:
            //      protected

            if (!references) {
                return;
            }

            var notificationText = domConstruct.create("div");
            if (references.length > 0) {
                notificationText.innerHTML += resources.affect;

                var referencesText = references.length + ' ' + (references.length === 1 ? epi.resources.text.item : epi.resources.text.items),
                    self = this,
                    referenceslink = domConstruct.create("a", { href: "#", innerHTML: referencesText, title: resources.referencestooltip }, notificationText);

                //TODO: Make sure that we remove the handler when item is deleted.
                on(referenceslink, "click", function (evt) {
                    event.stop(evt);
                    self._showReferenceDialog();
                });
            }
            else {
                notificationText.innerHTML += epi.resources.messages.notinuse;
            }

            //to update canExecute on command :'(
            this._backCommand.set("model", {});

            this._setNotification({
                content: notificationText,
                commands: [this._backCommand]
            });
        },

        _showReferenceDialog: function () {
            sharedContentDialogHandler({
                contentData: this.get("invokeActionValue"),
                showToolbar: true,
                mode: sharedContentDialogHandler.mode.show
            });
        }

    });

});
},
'epi-cms/contentediting/_ContentEditingNotification':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/Stateful",
    "dojo/when",
// epi
    "epi/dependency"
],

function (
// dojo
    declare,
    lang,

    Stateful,
    when,
// epi
    dependency
) {

    // summary:
    //      Base class for content editing notification
    // tags:
    //      protected

    return declare([Stateful], {

        // invokeActionValue: [public] Object
        //      Data that used to fire action on the store when its value changed
        invokeActionValue: null,

        // notification: [public] Object|Array
        //      Notification object format: { content: "notification message", commands: [] }
        notification: null,

        // _storeName: [protected] String
        //      Name of the store
        _storeName: null,

        // _store: [protected] dojo.store.api.Store
        //      Notification store
        _store: null,

        // _invokeActionProperty: [protected] String
        //      Property name that used to fire action on the store
        _invokeActionProperty: "invokeActionValue",

        postscript: function () {
            this.inherited(arguments);

            this._setupStore();
            this.watch(this._invokeActionProperty, lang.hitch(this, this._invokeActionPropertyWatchHandler));
        },

        _setupStore: function () {
            // summary:
            //      Setup store if the concreate class need it
            // tags:
            //      private

            if (!this._store && this._storeName) {
                var registry = dependency.resolve("epi.storeregistry");
                this._store = registry.get(this._storeName);
            }
        },

        _executeAction: function (/*Object*/value) {
            // summary:
            //      Perform action on the store
            // tags:
            //      protected, extension

            return value;
        },

        _onExecuteSuccess: function () {
            // summary:
            //      Perform action(s) when store's function executed success
            // tags:
            //      protected, extension
        },

        _onExecuteFailed: function () {
            // summary:
            //      Perform action(s) when store's function executed fail 
            // tags:
            //      protected, extension
        },

        _invokeActionPropertyWatchHandler: function (/*String*/name, /*Object*/oldValue, /*Object*/value) {
            // summary:
            //      Call store's function when the given property have changed
            // tags:
            //      private

            if (value == null) {
                return;
            }

            when(this._executeAction(value), lang.hitch(this, this._onExecuteSuccess), lang.hitch(this, this._onExecuteFailed));
        },

        _setNotification: function (/*Object|Array*/notification) {
            // summary:
            //      Stub to set notification
            // notification:
            //      Notification object format: { content: "notification message", commands: [] }
            // tags:
            //      protected

            this.set("notification", notification);
        }

    });

});
},
'epi-cms/command/BackCommand':function(){
﻿define([
    "dojo/_base/declare",

    "dojo/topic",

    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/i18n!epi/cms/nls/episerver.cms.command"
],
function (
    declare,

    topic,

    dependency,
    _Command,
    resources
) {
    return declare([_Command], {
        label: resources.backtoprevious,

        tooltip: resources.backtoprevious,

        category: "leftAligned",

        iconClass: "epi-iconLeft",

        cssClass: "epi-chromelessButton epi-visibleLink",

        _previousContent: null,

        postscript: function () {
            this.inherited(arguments);
            this.contextHistory = this.contextHistory || dependency.resolve("epi.cms.BackContextHistory");
        },

        _execute: function () {
            topic.publish("/epi/shell/context/request", { uri: this._previousContent.uri }, { trigger: "back", sender: this });
        },

        _onModelChange: function () {
            this._previousContent = this.contextHistory.getPrevious();
            this.set("canExecute", this._previousContent != null);
        }
    });
});
},
'epi-cms/contentediting/ContentViewModel':function(){
﻿define([
    // Dojo
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/when",
    "dojo/Stateful",
    "dijit/Destroyable",

    // EPi Framework
    "epi/dependency",
    "epi/datetime",
    "epi/string",
    "epi/shell/UndoManager",
    "epi/shell/conversion/ObjectConverterRegistry",
    "epi/shell/widget/dialog/Alert",
    "epi/shell/Stateful",

    // EPi CMS
    "../ApplicationSettings",
    "./ContentActionSupport",
    "./ContentEditingValidator",
    "./ContentModelServerSync",
    "./Operation",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting",
    "epi/i18n!epi/cms/nls/episerver.cms.components.versions"
],


function (
// Dojo
    array,
    connect,
    declare,
    Deferred,
    lang,
    on,
    when,
    Stateful,
    Destroyable,

// EPi Framework
    dependency,
    epiDate,
    epiString,
    UndoManager,
    ObjectConverterRegistry,
    Alert,
    EpiStateful,

// EPi CMS
    ApplicationSettings,
    ContentActionSupport,
    ContentEditingValidator,
    ContentModelServerSync,
    Operation,

// Resources
    res,
    resVersions
) {

    return declare([Stateful, Destroyable], {

        // PUBLIC
        contentModel: null,

        metadata: null,

        syncService: null,

        editorFactory: null,

        syncInterval: 10000,

        validator: null,

        contentDataStore: null,

        profileHandler: null,

        languageContext: null,

        // PRIVATE
        _converterRegistry: null,

        _contentVersionStore: null,

        _syncRetryTimeout: 60000,

        undoManager: null,

        contextTypeName: "",

        contentLink: null,

        contentData: null,

        viewName: null,

        isCreatingNewVersion: false,

        hasUndoSteps: false,
        hasRedoSteps: false,
        isValid: true,
        hasPendingChanges: false,
        lastSaved: null,
        isSaved: true,
        isSaving: false,
        isOnline: true,
        hasErrors: false,
        isChangingContentStatus: false,

        _isSuspended: false,

        constructor: function () {
        },

        postscript: function () {
            this.inherited(arguments);

            // resolve dependency variables
            this.profileHandler = this.profileHandler || dependency.resolve('epi.shell.Profile');
            this.metadataManager = this.metadataManager || dependency.resolve('epi.shell.MetadataManager');

            this.currentContentLanguage = this.currentContentLanguage || ApplicationSettings.currentContentLanguage;
            this.contentDataStore = this.contentDataStore || dependency.resolve("epi.storeregistry").get("epi.cms.contentdata");

            if(!this._contentVersionStore) {
                this._contentVersionStore = dependency.resolve("epi.storeregistry").get("epi.cms.contentversion");
            }

            this.undoManager = this.undoManager || new UndoManager();
            this.validator = this.validator || new ContentEditingValidator({ contextId: this.contentLink, contextTypeName: this.contextTypeName });

            if (!this.syncService) {
                this._createSyncService();
            }

            // observe and copy these properties to this object
            var updater = lang.hitch(this, function (name, oldVal, newVal) { this.set(name, newVal); });

            this._operation = new Operation();

            this.own(
                this.syncService.watch("hasPendingChanges", updater),
                this.validator.watch("isValid", updater),
                this.validator.watch("hasErrors", updater),
                this.undoManager.watch("hasUndoSteps", updater),
                this.undoManager.watch("hasRedoSteps", updater),
                on(this._operation, "commit", lang.hitch(this, this._commitChanges))
            );
        },

        setActiveProperty: function (name) {
            // summary:
            //      Set property to active, which would bring up property's editor.
            // name: [String]
            //      Property name. Can also be "dot notation" name if it is sub property of a block property.
            // tag:
            //      public

            this.onSetActiveProperty(name);
        },

        suspend: function () {
            // summary:
            //  Suspends the editing for this view model.

            this._isSuspended = true;

            this.onContentChange();
            this.onSuspend();
        },

        onSuspend: function () {
            // summary:
            //  Raise onSuspend current view model
        },

        wakeUp: function () {
            // summary:
            //  Wake the suspended content view model up.

            this._isSuspended = false;
        },

        destroy: function () {

            this.clear();

            this.inherited(arguments);
        },


        clear: function () {
            this.undoManager.clear();
        },

        _createSyncService: function () {
            // summary:
            //  Creates and returns a new sync service instance.

            var syncService = new ContentModelServerSync({
                contentLink: this.contentLink,
                contentDataStore: this.contentDataStore
            });

            this.syncService = syncService;
        },

        connectLocal: function (targetArray, obj, evt, listener) {
            if (!lang.isArray(targetArray)) {
                throw Error("First argument to connectLocal must be an Array");
            }

            return targetArray.push(connect.connect(obj, evt, this, listener));
        },

        disconnectLocal: function (targetArray) {
            if (lang.isArray(targetArray)) {
                var listener;
                while (listener = targetArray.pop()) {
                    connect.disconnect(listener);
                }
            }
        },

        resetNotifications: function () {
            this.validator.clearErrorsBySource(this.validator.validationSource.client);
        },

        beginOperation: function () {
            // summary: 
            //      Start a multi property operation where all property changes are should be handled as one undo step.

            this._operation.begin();
        },

        endOperation: function () {
            // summary: 
            //      End a multi property operation, creating an undo step.

            this._operation.end();
        },

        abortOperation: function () {
            // summary:
            //      Abort an ongoing multi property operation.

            this._operation.abort();
        },

        getProperty: function (propertyName) {
            return this.contentModel.get(propertyName);
        },

        setProperty: function (propertyName, value, oldValue) {
            this._setModelProperty(propertyName, value, oldValue);
        },

        publishProperty: function (propertyName, value) {
            // sync change to syncservice
            this.syncService.publishProperty(propertyName, value).then(lang.hitch(this, function () {

                // Update model
                this.contentModel.set(propertyName, value);
                // updata data store
                this._patchContentDataStore(this.contentData.contentLink, propertyName, null, value);

                when(this.contentDataStore.refresh(this.contentData.contentLink), lang.hitch(this, function (contentData) {
                    this.set("contentData", contentData);
                }));
            }));
        },

        _commitChanges: function (/*Array*/ properties) {
            // summary:
            //  Schedules the supplied properties to the server and creates ONE undo step for the changes

            var inverseProperties = array.map(properties, function (item) {
                return {
                    propertyName: item.propertyName,
                    value: item.oldValue,
                    oldValue: item.value
                };
            });

            this.undoManager.createStep(this, this._saveProperties, [inverseProperties], 'Edit properties');
        },

        _saveProperties: function (properties) {
            // summary: 
            //  Updates the model with an array of properties as one "unit" causing one undo step.
            //  Primaryly used as undo/redo callback

            this.beginOperation();

            array.forEach(properties, function(p) {
                this._setModelProperty(p.propertyName, p.value, p.oldValue);
            }, this);

            this.endOperation();
        },

        _setModelProperty: function (propertyName, value, oldValue) {
            // summary:
            //  Sets a property value on the content model and adds a save operation to the internal operation object

            this.set("isSaved", false);

            this._operation.save({
                propertyName: propertyName,
                value: value,
                oldValue: oldValue || this.contentModel.get(propertyName)
            });

            this.contentModel.set(propertyName, value);

            // Add the property to the sync queue
            this.syncService.scheduleForSync(propertyName, value);

            this.onPropertyEdited(propertyName, value);
        },

        onPropertyEdited: function (propertyName, value) {
            // summary:
            //      Called when a property has been edited.
            //
            // propertyName: String
            //      Name of the property
            //
            // value: String|Object
            //      The new value
            //
            // tags:
            //      public
        },

        _onSynchronizeSuccess: function (contentLink, properties, results) {
            // summary:
            //    Handler when a property has been successfully synchronized
            // contentLink:
            //      The contentLink
            // properties:
            //      Properties synchronized

            array.forEach(properties, lang.hitch(this, function (property) {
                this.validator.clearPropertyErrors(property.name, this.validator.validationSource.server);
                // updata data store
                this._patchContentDataStore(contentLink, property.name, null, property.value);
            }));

            this.validator.setGlobalErrors(results.validationErrors, this.validator.validationSource.server);
        },


        _onSynchronizeFailure: function (contentLink, properties, message, results) {
            // summary:
            //      Handler a property couldn't be synchronized due to server rejecting the data, for
            //      instance if data isn't valid
            // contentLink:
            //      The contentLink
            // properties:
            //      Properties
            // message:
            //      A message why it couldn't update
            // results:
            //      The results of the update including any global validation errors.
            // tags:
            //      private

            array.forEach(properties, function (property) {
                if ("successful" in property) {
                    if (property.successful) {
                        this.validator.clearPropertyErrors(property.name, this.validator.validationSource.server);
                    }
                    else {
                        this.validator.setPropertyErrors(property.name, [{ "errorMessage": property.validationErrors, severity: this.validator.severity.error}], this.validator.validationSource.server);
                    }
                } else {
                    // Keep everything as they are, we didn't get any response with error messages
                }
            },
                this);

            //If we have a result set the global validation errors
            if (results) {
                if (results.validationErrors) {
                    this.validator.setGlobalErrors(results.validationErrors, this.validator.validationSource.server);
                } else {
                    this.validator.clearGlobalErrors(this.validator.validationSource.server);
                }
            }
        },

        _contentLinkChanged: function (oldContentLink, newContentLink) {

            // store the latest newContentLink, could have changed during sync, ie when first changing a property
            this.contentLink = newContentLink;

            this.syncService.contentLink = newContentLink;

            // propagate new contentlink
            this.validator.setContextId(newContentLink);

            if (!this._isSuspended) {
                // note that our view component, OPE or form must check if we're the sender?
                // or just skip when a content link changed
                var contextParameters = { uri: "epi.cms.contentdata:///" + newContentLink };
                connect.publish("/epi/shell/context/request", [contextParameters, { sender: this, contextIdSyncChange: true, trigger: "internal" }]);
            }
        },

        ensureWritableVersion: function () {
            // summary:
            //      Ensures that we are editing a writable version
            //
            //  tags:
            //      private

            var contentLink = this.contentLink;

            if (!this.contentData.isNewVersionRequired) {
                return contentLink;
            }

            this.isCreatingNewVersion = true;

            var def = new Deferred();

            // TODO: handle reject of creating new version
            when(this._contentVersionStore.put({ originalContentLink: contentLink }), lang.hitch(this, function (newVersion) {

                //Load the new version
                this._contentLinkChanged(contentLink, newVersion.contentLink);

                this.isCreatingNewVersion = false;

                def.resolve(newVersion);
            }), lang.hitch(this, function () {

                this.isCreatingNewVersion = false;
                def.reject();
            }));

            return def;
        },

        validate: function () {
            // summary:
            //      Validate the model
            //
            //  tags:
            //      public

            var def;
            if (!this.validator) {
                def = new Deferred();
                def.resolve();
            }
            else {
                def = this.validator.validate();
            }

            return def;
        },

        revertToPublished: function () {
            // summary
            //      Revert to published version
            // tags
            //      Public

            var contentLink = this.contentLink;

            when(this._contentVersionStore.remove(contentLink),
                lang.hitch(this, function () {
                    this._loadPublishedVersion(contentLink);
                }),
                lang.hitch(this, function (error) {
                    var errorMessage;
                    if (error.status === 403) {
                        // This version already published
                        errorMessage = resVersions.deleteversion.cannotdeletepublished;
                    }
                    else if (error.status === 404) {
                        // This version does not exist
                        errorMessage = res.versionstatus.versionnotfound;
                    }
                    if (errorMessage) {
                        this.dialog = new Alert({
                            description: errorMessage,
                            onAction: lang.hitch(this, function () {
                                this._loadPublishedVersion(contentLink);
                            })
                        });
                        this.dialog.show();
                    }
                })
            );
        },

        _loadPublishedVersion: function (contentLink) {
            // summary
            //      Get published version and reload
            // tags
            //      Private
            when(this._contentVersionStore.query({ contentLink: contentLink, language: this.languageContext ? this.languageContext.language : "", query: 'getpublishedversion' }),
                        lang.hitch(this, function (result) {
                            if (result !== null) {
                                var contextParameters = { uri: "epi.cms.contentdata:///" + result.contentLink, context: this };
                                connect.publish("/epi/shell/context/request", [contextParameters, { sender: this, trigger: "internal"}]);
                            }
                        }));
        },

        createDraft: function () {

            var contentLink = this.contentLink;
            var status = this.contentData.status;
            var versionStatus = ContentActionSupport.versionStatus;
            var setCommonDraft = status === versionStatus.DelayedPublish;

            return when(this._contentVersionStore.put({ originalContentLink: contentLink, isCommonDraft: setCommonDraft }), lang.hitch(this, function (newVersion) {
                var contextParameters = { uri: "epi.cms.contentdata:///" + newVersion.contentLink, context: this };
                connect.publish("/epi/shell/context/request", [contextParameters, { sender: this}]);
            }));

        },

        editCommonDraft: function () {
            // summary
            //      Get common draft version and reload
            // tags
            //      Public
            var contentLink = this.contentLink;

            return when(this._contentVersionStore.query({ contentLink: contentLink, query: "getcommondraftversion" }), lang.hitch(this, function (commonDraftVersion) {
                var contextParameters = { uri: "epi.cms.contentdata:///" + commonDraftVersion.contentLink, context: this };
                connect.publish("/epi/shell/context/request", [contextParameters, { sender: this}]);
            }));
        },

        _populateContentModel: function (data, metadata) {
            var props = {},
                converterType,
                converter;

            for (var propertyName in data) {
                var propertyMetadata = metadata.getPropertyMetadata(propertyName);
                var propertyValue = data[propertyName];
                if (propertyMetadata.hasSubProperties()) {
                    props[propertyName] = this._populateContentModel(propertyValue, propertyMetadata);
                }
                else {
                    // default
                    props[propertyName] = propertyValue;

                    // check for converter
                    converterType = propertyMetadata.customEditorSettings.converter;
                    if (converterType) {
                        converter = ObjectConverterRegistry.getConverter(converterType, "runtimeType");
                        if (converter) {
                            // bind converted value instead
                            props[propertyName] = converter.convert(converterType, "runtimeType", propertyValue);
                        }
                    }
                }
            }
            return props;
        },

        getPropertyMetaData: function (propertyName) {
            // summary:
            //      Return metadata of a property.
            //
            // propertyName: [String]
            //      The property name
            //
            // return: [Object|Deferred]
            //      Returns the metadata object if content metadata has already resolved.
            //      Otherwise returns a deferred which resolves to the property metadata when content metadata is loaded.
            //
            // tag:
            //      public

            if (this.metadata) {
                return this.metadata.getPropertyMetadata(propertyName);
            } else {
                var connectHandles = [],
                    def = new Deferred();

                this.connectLocal(connectHandles, this, "onMetadataResolve", function (success) {
                    if (success) {
                        def.resolve(this.metadata.getPropertyMetadata(propertyName));
                    } else {
                        def.reject();
                    }

                    this.disconnectLocal(connectHandles);
                });

                return def;
            }
        },

        getContentModelAndMetadata: function () {
            var def = new Deferred();

            when(
                this.metadataManager.getMetadataForType('EPiServer.Core.ContentData', { contentLink: this.contentLink }),

                lang.hitch(this, function (metadata) {

                    this.set("metadata", metadata);

                    var contentModel = this.createContentModelObject(metadata);
                    this.set("contentModel", contentModel);

                    this.onMetadataResolve(true);
                    def.resolve();
                }),

                lang.hitch(this, function () {
                    this.onMetadataResolve(false);
                    def.reject();
                })
            );

            return def;
        },

        onMetadataResolve: function (success) {
            // summary:
            //      Fired when content metadata resolves or fails to load.
            //
            // success: [Boolean]
            //      true if metadata is successfully loaded, otherwise false.
            //
            // tag:
            //      public, callback
        },

        getMetadataThenUpdateModel: function () {
            var def = new Deferred();

            when(
                this.metadataManager.getMetadataForType('EPiServer.Core.ContentData', { contentLink: this.contentLink }),

                lang.hitch(this, function (metadata) {

                    this.set("metadata", metadata);

                    var contentModel = this.createContentModelObject(metadata);
                    this.set("contentModel", lang.mixin(this.contentModel, contentModel));

                    def.resolve();
                }),

                function () {
                    def.reject();
                }
            );

            return def;
        },

        createContentModelObject: function(metadata) {
            // summary: 
            //      Create 

            var populatedModelData = this._populateContentModel(this.contentData.properties, metadata);
            var contentModel = new EpiStateful();

            // set model values after constructor, this is because the populated 
            // model data is unsafe and could include reserved word 'preamble'
            contentModel.set(populatedModelData);

            return contentModel;
        },

        save: function () {
            if (!this.isOnline) {
                var def = new Deferred();

                def.resolve(true);

                return def;
            }
            return this._save();
        },

        _save: function () {
            var def = new Deferred(),
                onSuccess = lang.hitch(this, function (result) {
                    if (result) {
                        if (result.successful) {
                            this._onSynchronizeSuccess(result.contentLink, result.properties, result);
                        } else {
                            this._onSynchronizeFailure(result.contentLink, result.properties, result.validationErrors, result);
                        }
                        if (result && result.hasContentLinkChanged) {
                            this._contentLinkChanged(result.contentLink, result.oldContentLink);
                        }
                    }

                    this.set("isOnline", true);
                    this.set("lastSaved", new Date());
                    this.set("isSaving", false);
                    this.set("isSaved", true);

                    def.resolve(true);
                }),
                onError = lang.hitch(this, function (result) {

                    this.set("hasErrors", true);
                    this.set("isSaving", false);
                    this.set("isSaved", false);
                    this.set("isOnline", false);

                    if (result) {
                        //If we do not have any newer change to the property, schedule a new sync for them
                        array.forEach(result.properties, lang.hitch(this, function (property) {
                            if (!this.syncService.pendingSync(property.name)) {
                                this.syncService.scheduleForSync(property.name, property.value);
                            }
                        }));
                    }

                    setTimeout(lang.hitch(this, function () {
                        this.set("isOnline", true);
                        this._save();
                    }), this._syncRetryTimeout);

                    def.reject(result);
                });

            //Make sure that we have a version that we can make changes to
            if (this.isCreatingNewVersion || !this.hasPendingChanges) {
                onSuccess();
            } else {
                
                when(this.ensureWritableVersion(), lang.hitch(this, function () {

                            this.set("isSaving", true);

                            when(this.syncService.save(), onSuccess, onError);
                }), onError);
            }
            return def;
        },

        undo: function () {
            this.undoManager.undo();
        },

        redo: function () {
            this.undoManager.redo();
        },

        _patchContentDataStore: function (contentLink, propertyName, oldValue, newValue) {
            // summary:
            //      Updates the named named property in the current content data store with value in newValue

            var properties = {};

            lang.setObject(propertyName, newValue, properties);

            return this.contentDataStore.patchCache({
                contentLink: contentLink,
                changedBy: this.profileHandler.userName,
                saved: epiDate.serialize(new Date()),
                properties: properties
            });
        },

        changeContentStatus: function (status) {
            var contentLink = this.contentLink;
            var def = new Deferred();

            // This will notify other content that we are in changing state.
            this.set("isChangingContentStatus", true);

            var onSuccess = lang.hitch(this, function (result) {
                var success = result && result.success;
                var validator = this.validator;
                if (success) {
                    // Set lastSaved to null after publishing, ready to publish and Schedule to publish the content
                    if (status == ContentActionSupport.action.Publish
                        || status == ContentActionSupport.action.CheckIn
                        || status == (ContentActionSupport.saveAction.CheckIn | ContentActionSupport.saveAction.DelayedPublish | ContentActionSupport.saveAction.ForceCurrentVersion)) {
                        this.set("lastSaved", null);
                    }
                    if (validator) {
                        validator.clearGlobalErrors(validator.validationSource.server);
                    }
                    def.resolve({ id: result.id, oldId: contentLink });
                } else {
                    if (result && result.validationErrors) {
                        // add to validator
                        if (validator) {
                            validator.setGlobalErrors(result.validationErrors, validator.validationSource.server);
                            validator.validate();
                        }

                        // reject with empty value, we took care of the validations errors
                        def.reject(null);
                    } else {
                        def.reject((result && result.errorMessage) ? result.errorMessage : res.publish.error);
                    }
                }

                this.set("isChangingContentStatus", false);
            });

            var onError = lang.hitch(this, function (result) {
                connect.publish("/epi/cms/action/showerror"); //TODO: Copy from PageDataController to make the system working as before. But, why we need it!!!
                def.reject((result && result.errorMessage) ? result.errorMessage : res.publish.error);

                this.set("isChangingContentStatus", false);
            });

            this.onContentChange();

            // Validate, save pending change, then execute changestatus server method.
            when(this.validate(), lang.hitch(this, function () {
                when(this.save(), lang.hitch(this, function () {
                    when(this.contentDataStore.executeMethod("ChangeStatus", this.contentLink, { action: status }), onSuccess, onError);
                }), onError);
            }), onError);

            return def;
        },

        onContentChange: function () {
            // summary:
            //      Raised before making changes that will eventually change content
            // tag:
            //      callback
        },

        hasEditAccess: function () {
            // summary:
            //      Check if current user has access right to edit the content
            return ContentActionSupport.hasAccess(this.contentData.accessMask, ContentActionSupport.accessLevel.Edit);
        },

        hasAccess: function (action) {
            // summary:
            //      Check if current user has access on the active content using the given action.
            // remark:
            //      This method cannot be overriden by plugins. Use when we need to check core conditions only.

            // languageContext is null if the content or content provider does not have multi language support
            // in this case allow editing matter which language is active
            var canEditLanguage = !this.languageContext || !this.languageContext.isTranslationNeeded;
            return canEditLanguage && ContentActionSupport.isActionAvailable(this.contentData, action || ContentActionSupport.action.Edit, ContentActionSupport.providerCapabilities.Edit);
        },

        canTranslateContent: function () {

            if(this.viewLanguage && this.languageContext && this.viewLanguage != this.currentContentLanguage) {
                return false;
            }

            return true;
        },

        canChangeContent: function (action) {
            // summary:
            //      Check if current user can change on the active content using the given action.
            // remark:
            //      This method is designed to be be overriden by plugins. Use when we need to check all core and plugins' conditions.
            return this.canEditCurrentLanguage() && this.hasAccess(action);
        },

        canEditCurrentLanguage: function() {
            // summary:
            //      Check if the current content language can be edited in the current language context.
            // tags:
            //      public
            if (!this.languageContext) {
                return true;
            }

            return this.languageContext.language == this.currentContentLanguage;
        }
    });
});

},
'epi-cms/contentediting/ContentModelServerSync':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/Stateful",

    "epi/datetime",
    "epi/string"
],

function (
    array,
    declare,
    Deferred,
    json,
    lang,
    Stateful,

    epiDateTime,
    epiString) {

    return declare([Stateful], {
        // summary:
        // tags:
        //    public

        // _queue: [private] Array
        //      The queue of updates to send
        _queue: null,

        // _isSynchronizing: [private] Boolean
        //      Set to true while we're synchronizing
        _isSynchronizing: false,

        // hasPendingChanges: Boolean
        hasPendingChanges: false,

        // contentLink: String
        //      Reference to the content this sync service instance is saving changes to
        contentLink: null,

        // contentDataStore: RestStore
        //      Reference to the content data store
        contentDataStore: null,

        // processInterval: Number
        //      How often (in milliseconds) should we check the queue to see if there's any items to be synced
        processInterval: 200,

        // _processIntervalId: [private] Number
        //      Id of the interval to check queue, will only be set when save() has been called
        _processIntervalId: 0,

        _saveDeferred: null,

        _publish: false,

        constructor: function (params) {
            // summary:
            //      init array
            // tags:
            //      private

            lang.mixin(this, params);

            // init queue
            this._queue = [];
        },

        scheduleForSync: function (/*String*/propertyName, /*String|Object*/value) {
            // summary:
            //      Put property update in queue
            // propertyName:
            //      Name of the property
            // value:
            //      The value of the property
            // tags:
            //      public

            if (value === undefined) {
                return;
            }

            this.set("hasPendingChanges", true);
            value = epiDateTime.transformDate(value);

            var index = this._propertyIndexInQueue(propertyName);

            if (index < 0) {
                // add item to queue
                this._queue.push({
                    name: propertyName,
                    value: value
                });
            } else {
                // update item value
                this._queue[index].value = value;
            }
        },

        publishProperty: function (propertyName, value) {
            //TODO: Shouldn't the this._published be pushed to the methods instead as private member?
            this._publish = true;
            this.scheduleForSync(propertyName, value);
            return this._synchronizeItem(true);
        },

        _propertyIndexInQueue: function (/*String*/propertyName) {

            var index = -1;

            // find item in queue
            array.some(this._queue, function (item, i) {
                if (item.name === propertyName) {
                    index = i;
                    return true;
                }
            });

            return index;
        },

        save: function () {
            // summary:
            //      Save updates to server
            // tags:
            //      public

            return this._startSynchronizeInterval();
        },

        _startSynchronizeInterval: function () {

            if (this._processIntervalId > 0) {
                return this._saveDeferred;
            }

            var fn = lang.hitch(this, function () {
                return this._synchronizeItem();
            });

            // trigger immediate first call
            var def = fn();

            // create interval
            if (this.processInterval >= 0) {
                this._processIntervalId = setInterval(fn, this.processInterval);
            }

            return def;
        },

        _stopSynchronizeInterval: function () {

            if (this._processIntervalId) {
                clearInterval(this._processIntervalId);
                this._processIntervalId = 0;
            }

        },

        _synchronizeItem: function () {
            // summary:
            //      Save updates to server
            // tags:
            //      private

            if (this._isSynchronizing) {
                return this._saveDeferred;
            }

            if (this._queue.length === 0) {
                return this._saveDeferred;
            }

            if (!this._saveDeferred) {
                this._saveDeferred = new Deferred();
            }

            this._isSynchronizing = true;

            //Copy the queue
            var items = this._queue;
            this._queue = [];

            var syncContentLink = this.contentLink;

            // Success callback
            var onSuccess = lang.hitch(this, function (result) {

                var successful = true;
                var defResult = {
                };

                if (result) {
                    //Convert the propery names to camel case
                    array.forEach(result.properties, lang.hitch(this, function (property) {
                        property.name = epiString.pascalToCamel(property.name);
                    }));

                    var savedLink = result.savedContentLink;

                    //Create def result object
                    defResult = lang.mixin({
                        successful: false,
                        contentLink: successful ? result.savedContentLink : syncContentLink,
                        hasContentLinkChanged: result.savedContentLink && savedLink != this.contentLink
                    }, result);


                    if (savedLink && savedLink != this.contentLink) {
                        // If the server saved to another version than we anticipated
                        defResult.oldContentLink = this.contentLink;
                        this.contentLink = savedLink;
                    }

                } else {
                    successful = false;
                }

                this._isSynchronizing = false;

                if (this._queue.length === 0) {
                    this._stopSynchronizeInterval();

                    // reset flags
                    this.set("hasPendingChanges", false);

                    var def = this._saveDeferred;
                    this._saveDeferred = null;

                    if (successful) {
                        def.resolve(defResult);
                    } else {
                        def.reject({
                            contentLink: syncContentLink,
                            properties: items,
                            error: "Unexpected result returned from the server."
                        });
                    }
                }
            });

            // Failure callback
            var onError = lang.hitch(this, function (error) {

                var defResult = {
                    contentLink: syncContentLink,
                    properties: items,
                    error: error
                };

                this._isSynchronizing = false;

                if (this._queue.length === 0) {

                    var def = this._saveDeferred;
                    this._saveDeferred = null;

                    this._stopSynchronizeInterval();

                    this.set("hasPendingChanges", false);

                    def.reject(defResult);
                }
            });

            Deferred.when(this._saveProperties(items), onSuccess, onError);

            return this._saveDeferred;
        },

        pendingSync: function (propertyName) {
            // summary:
            //      Check if there is any pending synchronization for the property with propertyName
            //
            // propertyName: String
            //      The name of the property to check for
            //
            // returns:
            //      True if there are pending synchronizations, otherwise False
            // tags:
            //      public
            return this._propertyIndexInQueue(propertyName) !== -1;
        },

        _saveProperties: function (items) {
            // summary:
            //    Validate property value with server.
            //
            // propertyName: String
            //    The updated property name.
            //
            // propertyValue: String
            //    The property value.
            //
            // timestamp: String
            //    The client timestamp.
            //
            // returns:
            //	  A deferred
            //
            // tags:
            //    public

            var contentLink = this.contentLink;
            var properties = {};
            array.forEach(items, lang.hitch(this, function (item) {
                properties[item.name] = json.toJson(item.value);
            }));

            var patchData = {
                id: contentLink,
                properties: properties,
                publishChanges: this._publish
            };
            //reset publish state so we dont publish every time.
            this._publish = false;
            return this.contentDataStore.patch(patchData, { id: patchData.id });
        }
    });
});

},
'epi-cms/contentediting/Operation':function(){
define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Evented",
    "dojo/Stateful"
], function (array, declare, lang, Evented, Stateful) {

    // module:
    //      epi-cms/contentediting/Operation
    // summary:
    //      This class represents a single operation. The default state commits save directly; otherwise it can run in a
    //      transaction-like state allowing for multiple data saves which will then be committed as a single operation.
    return declare([Stateful, Evented], {

        // inProgress: [public] Boolean
        //      Flag indicating if there is an operation in progress.
        inProgress: false,

        // changes: [public] Array
        //      Array of changes associated with the current operation.
        changes: null,

        constructor: function() {
            this.changes = [];
        },

        begin: function() {
            // summary:
            //      Begins a new operation. If there is an operation already is progress this does nothing.
            // tags:
            //      public

            this.set("inProgress", true);
        },

        save: function(/* Object */ data) {
            // summary:
            //      Saves the data to the current active operation otherwise raises a commit event with the data.
            // tags:
            //      public

            if (this.inProgress) {
                // Remove any existing change for the property, but copy the oldValue property to the new data
                this.changes = array.filter(this.changes, function (change) {
                    if (change.propertyName === data.propertyName) {
                        data.oldValue = change.oldValue;
                        return false;
                    }
                    return true;
                });

                this.changes.push(data);

                return;
            }

            // Normalize the data to an array.
            if(!lang.isArray(data)) {
                data = [data];
            }

            this.emit("commit", data);
        },

        end: function() {
            // summary:
            //      Ends the current operation and raises a commit event with the accumulated data.
            // tags:
            //      public
            this.set("inProgress", false);

            if (this.changes.length > 0){
                this.save(this.changes);
            }

            this.changes = [];
        },

        abort: function () {
            // summary:
            //      Ends the current operation and raises an abort event with the accumulated data.
            // tags:
            //      public            

            this.set("inProgress", false);
            this.changes = [];
        }
    });
});
},
'epi-cms/contentediting/ExpirationNotification':function(){
﻿define([
// dojo
    "dojo/_base/declare",

    "dojo/string",
// epi
    "epi/datetime",
    "epi/dependency",

    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/_ContentEditingNotification",

    "epi/i18n!epi/cms/nls/episerver.cms.widget.expirationeditor",
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.versionstatus"
],

function (
// dojo
    declare,

    string,
// epi
    epiDatetime,
    dependency,

    ApplicationSettings,
    _ContentEditingNotification,

    expirationeditorResources,
    versionstatusResources
) {

    // module:
    //		epi-cms/contentediting/ExpirationNotification
    // summary:
    //      Provides notifications for content that has an expiration set.
    // tags:
    //      public

    return declare([_ContentEditingNotification], {

        postscript: function () {
            this.inherited(arguments);

            this._notificationPeriod = ApplicationSettings.expirationNotificationPeriod;
            
            this._setupCommands();
        },

        _executeAction: function (/*Object*/context) {
            // summary:
            //      Updates the contentData for the notification with the latest model.
            // tags:
            //      protected, extension

            return context.contentData.properties.iversionable_expire;
        },

        _onExecuteSuccess: function (expireBlock) {
            // summary:
            //      Checks is the content data has an expired data and updates the notification property.

            var serverTime = epiDatetime.serverTime();
            
            var stopPublish = expireBlock ? expireBlock.stopPublish : null,
                expiration = new Date(stopPublish);

            var text = null;
            if (stopPublish && epiDatetime.isDateValid(expiration)) {
                if (new Date(serverTime.getTime() + this._notificationPeriod * 1000) > expiration) {
                    text = expiration < serverTime
                        ? versionstatusResources.expired
                        : string.substitute(expirationeditorResources.expiretimetext, [epiDatetime.timeToGo(expiration)]);
                }
            }
            if (!text) {
                this._setNotification(null); //clear notification
            } else {
                this._setNotification({ content: text, commands: [this._editingCommands.manageExpiration] });
            }
        },

        _viewModelValueHandler: null,

        _setupCommands: function () {
            if (!this._editingCommands) {
                this._editingCommands = dependency.resolve("epi.cms.contentEditing.command.Editing");
            }

            if (this._commandsWatchHandler) {
                this._commandsWatchHandler.unwatch();
            }

            var self = this;
            var handle = null;
            self._commandsWatchHandler = this._editingCommands.manageExpiration.watch("viewModel", function (name, oldViewModel, viewModel) {

                // remove the old observer
                if (self._viewModelValueHandler) {
                    self._viewModelValueHandler.unwatch();
                }

                self._viewModelValueHandler = viewModel.watch("value", function (name, oldValue, value) {
                    self._onExecuteSuccess(value);
                });
            });
        }

    });

});

},
'epi-cms/contentediting/LanguageNotification':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/url",

    "dojo/dom-construct",

// epi
    "epi/dependency",
// epi CMS
    "epi-cms/ApplicationSettings",
    "epi-cms/contentediting/_ContentEditingNotification",
    "epi-cms/contentediting/command/Editing",

    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.languagenotification"
],

function (
// dojo
    declare,
    lang,
    array,
    Url,

    domConstruct,

// epi
    dependency,

// epi CMS
    ApplicationSettings,
    _ContentEditingNotification,
    EditingCommands,

    resources
) {

    // summary:
    //      Language notification
    // description:
    //      Show notification for language on a related page
    // tags:
    //      public

    return declare([_ContentEditingNotification], {

        _onExecuteSuccess: function (/*Object*/context) {
            // summary:
            //      Set notification(s) when executed success
            // tags:
            //      protected

            if (!context.languageContext) {
                return;
            }

            var store = dependency.resolve("epi.storeregistry").get("epi.cms.language");

            store.query().then(lang.hitch(this, function(languages){
                languageResource = {};
                array.forEach(languages, function(language){
                    languageResource[language.languageId] = language.name;
                }, this);

                var content = context.languageContext.warning;
                var currentContentLanguage = ApplicationSettings.currentContentLanguage;
                var languageContext = context.languageContext;

                var switchToLanguage;
                if(currentContentLanguage != languageContext.preferredLanguage && languageContext.isTranslationNeeded) {
                    content = lang.replace(resources.nottranslatedswitchto,[languageResource[languageContext.language], languageResource[languageContext.preferredLanguage]]);
                    switchToLanguage = languageContext.preferredLanguage;
                } else if(currentContentLanguage != languageContext.language && !languageContext.isTranslationNeeded) {
                    content = lang.replace(resources.workinginwrongsite,[languageResource[currentContentLanguage], languageResource[languageContext.language]]);
                    switchToLanguage = languageContext.language;
                }

                 if (!content) {
                    //clear old language notification
                    this._setNotification(null);

                    return;
                }

                var html = domConstruct.create("div", {innerHTML: content});

                if(switchToLanguage) {
                    var url = new Url(window.top.location.href);
                    var text = lang.replace(resources.switchto, [languageResource[switchToLanguage]]);
                    
                    var link = domConstruct.create("a", {
                        href: [url.scheme, "://", url.authority, url.path, "?language=", switchToLanguage, "#context=", context.versionAgnosticUri].join(""),
                        innerHTML: text, 
                        title: text}, html);
                }

                this._setNotification({
                    content: html,
                    //If the the content requires a translation and the current content language is the same as the requested language we can show the command
                    commands: languageContext.isTranslationNeeded && currentContentLanguage == languageContext.preferredLanguage ? [EditingCommands.translate] : []
                });

            }));
        }
    });

});
},
'epi-cms/contentediting/ShortcutNotification':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
// epi
    "epi/string",

    "epi-cms/contentediting/_ContentEditingNotification",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.shortcutnotification"
],

function (
// dojo
    declare,
    lang,
// epi
    epiString,

    _ContentEditingNotification,
// resources
    resources
) {

    // linkTypes should match the EPiserver.Core.LinkTypes enum
    var linkTypes = ["normal",
                    "shortcut",
                    "external",
                    "inactive",
                    "fetchdata"];

    // summary:
    //      Helper class to translate pageShortcutTypes 
    //      into warning notifications for the notification bar.
    // tags:
    //      public

    var ShortcutNotification = declare([_ContentEditingNotification], {

        // contentData: Object
        //      The contentdata object to provide pageShortcutType messages for
        contentData: null,

        postscript: function () {
            this.inherited(arguments);

            this.watch("contentData", lang.hitch(this, this._contentDataWatchHandler));
        },

        _onExecuteSuccess: function (/*Object*/value) {
            // summary:
            //      Update notification
            // tags:
            //      protected

            if (this._viewModelWatch) {
                this._viewModelWatch.unwatch();
            }

            this._viewModelWatch = value.watch("contentModel", lang.hitch(this, function (name, oldModel, newModel) {
                if (this._contentModelWatch) {
                    this._contentModelWatch.unwatch();
                }

                this._contentModelWatch = newModel.watch("iversionable_shortcut", lang.hitch(this, function (name, oldValue, newValue) {
                    this._updateNotification(newValue && newValue.pageShortcutType);
                }));
            }));

            this.set("contentData", value.contentData);
        },

        _contentDataWatchHandler: function (/*String*/name, /*Object*/oldValue, /*Object*/value) {
            // summary:
            //      Update notification
            // tags:
            //      private

            if (value && value.capabilities && value.capabilities.isPage) {
                this._updateNotification(value.properties.pageShortcutType);
            }
        },

        _updateNotification: function (shortcutType) {
            // summary:
            //      Maps the shortcutType enum value to a tranlated message
            // shortcutType: Number 
            //      The value to set a message for
            // tags:
            //      private

            var shortcutName,
                message = null;

            if (shortcutType > 0) {
                shortcutName = linkTypes[shortcutType];
                message = epiString.toHTML(resources[shortcutName]);
            }

            this._setNotification({ shortcutType: shortcutType, content: message });
        }
    });

    ShortcutNotification.LinkTypes = linkTypes;

    return ShortcutNotification;

});
},
'epi-cms/contentediting/ViewSettingsNotification':function(){
﻿define([
// dojo
    "dojo/_base/declare",
// epi
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/_ContentEditingNotification",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.viewsettingsnotification"
],

function (
// dojo
    declare,
// epi
    ContentActionSupport,
    _ContentEditingNotification,
// resources
    resources
) {

    // summary:
    //      Show visitorgroup notification into warning notifications for the notification bar.
    // tags:
    //      public

    return declare([_ContentEditingNotification], {

        _onExecuteSuccess: function (/*Object*/value) {
            // summary:
            //      Set notification(s) when executed success
            // tags: 
            //      protected

            var isReadOnlyUser = value.viewModel.contentData && value.viewModel.contentData.accessMask <= ContentActionSupport.accessLevel.Read,
                setNotification = isReadOnlyUser && value.viewSetting.get("enabled") && value.viewSetting.hasVisitorGroup();

            this._setNotification(setNotification ? { content: resources.visitorgroups.noaccessright} : null);
        }

    });

});
},
'epi-cms/contentediting/WorkflowTaskNotification':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
// dojox
    "dojox/html/entities",
// epi
    "epi/datetime",
    "epi/string",

    "epi-cms/contentediting/_ContentEditingNotification",
    "epi-cms/contentediting/command/WorkflowTask",
// resources
    "epi/i18n!epi/ui/nls/personalization.task"
],

function (
// dojo
    array,
    declare,
    lang,
    topic,
// dojox
    htmlEntities,
// epi
    epiDateTime,
    epiString,

    _ContentEditingNotification,
    WorkflowTask,
// resources
    resources
) {

    // summary:
    //      Workflow task notification
    // description:
    //      Show notification for workflow task on a related page
    // tags:
    //      public

    return declare([_ContentEditingNotification], {

        // _contentData: Object
        //      The content data regarding to the workflow task
        _contentData: null,

        taskStatus: [
            "statusnotstarted", // The tast has not started yet
            "statusinprogress", // The task is in progress
            "statuscompleted", // The task has been completed
            "statusrejected" // The task has been rejected.
        ],

        constructor: function () {
            this._storeName = "epi.cms.workflowtask";

            this.inherited(arguments);
        },

        _executeAction: function (/*Object*/content) {
            // summary:
            //      Get related workflow task(s) from its store
            // tags:
            //      protected, extension

            this._contentData = content;
            return this._store.query({ id: content.contentLink });
        },

        _onExecuteSuccess: function (/*Array*/tasks) {
            // summary:
            //      Set notification(s) when executed success from store call
            // tags:
            //      protected

            var notifications = [];
            array.forEach(tasks, function (task) {
                notifications.push({
                    content: epiString.toHTML(this._renderMessage(task)),
                    commands: [new WorkflowTask({ model: { contentData: this._contentData, task: task } })]
                });
            }, this);

            // Update workflow task notification(s)
            this._setNotification(notifications);

            // Publish event to update MyTasks component if tasks is empty
            if (!tasks || tasks.length === 0) {
                topic.publish("/epi/cms/action/refreshmytasks");
            }

        },

        _renderMessage: function (/*Object*/task) {
            // summary:
            //      Render notification content description text that based on the given task information
            //      Message formats: "{task.status}, due date {task.dueDate}, {task.subject}"
            // tags:
            //      private

            var message = "";

            // Get the given task subject text
            message += task.subject && task.subject.length > 0 ? htmlEntities.encode(task.subject) : "-";

            // Get the given task due date text
            message += task.dueDate ? lang.replace(", {0} {1}", [resources.duedate.toLowerCase(), epiDateTime.toUserFriendlyString(task.dueDate)]) : "";

            // Get the given task status text
            message += ", " + resources[this.taskStatus[task.status]];

            return message;
        }

    });

});
},
'epi-cms/contentediting/command/WorkflowTask':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-class",

    "dojo/io-query",
// epi
    "epi",
    "epi-cms/contentediting/command/_LegacyDialogCommandBase",
    "epi-cms/core/ContentReference",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.command.workflowtask"
], function (
// dojo
    declare,
    lang,

    domAttr,
    domClass,

    ioQuery,
// epi
    epi,
    _LegacyDialogCommandBase,
    ContentReference,

// resources
    resources
) {

    // summary:
    //      Workflow task view command
    // tags:
    //      public

    return declare([_LegacyDialogCommandBase], {

        label: resources.label,
        tooltip: resources.tooltip,
        cssClass: "epi-chromelessButton epi-visibleLink",

        dialogPath: "Edit/WorkflowTask.aspx",
        raiseCloseEvent: true,

        getDialogParams: function () {
            var self = this;
            return {
                dialogTitle: resources.title, // Set custom title for the legacy dialog
                legacyButtonQuery: "div span.epi-cmsButton", // Custom query to get the legacy buttons
                // Custom handler for mapping dialog buttons process
                onMapDialogButton: function (/*DOM*/legacyButton) {
                    return self._mapDialogButtons(legacyButton);
                },
                // Custom handler to close the legacy dialog after its content changed
                onLoad: function (/*Object*/wrapper) {
                    self._closeLegacyDialogOnRedirect(wrapper, this);
                },
                destroyOnHide: true,
                showCloseButton: true
            };
        },

        getRouteParams: function () {
            // summary:
            //      Overridden to mixin parameters to open the correct task from our model

            return lang.mixin(this.inherited(arguments), {
                "id": this.getContentReference(true),
                task: this.model.task.taskId
            });
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute and isAvailable after the model has been updated.
            // tags:
            //      protected

            var model = this.model;
            var canExecute = !!(model && model.contentData && !model.contentData.isDeleted && model.task && model.task.taskId);
            this.set("canExecute", canExecute);
        },

        _isCancelButton: function (/*DOM*/legacyButton) {
            // summary:
            //      Verify the given DOM node is a legacy "Cancel" button or not
            // tags:
            //      private

            return legacyButton && domClass.contains(legacyButton, "epi-cmsButton-Cancel");
        },

        _mapDialogButtons: function (/*DOM*/legacyButton) {
            // summary:
            //      Verify if the given button can map to dialog button or not
            // tags:
            //      private

            // Verify this button should map or not
            return !(this._isCancelButton(legacyButton) || domClass.contains(legacyButton, "epi-cmsButton-ViewMode"));
        },

        _closeLegacyDialogOnRedirect: function (/*Object*/wrapper, /*Object*/dialog) {
            // summary:
            //      Close legacy dialog if it loaded the container page without any parameters
            // tags:
            //      private

            var uri = wrapper.containerIframe.contentWindow.location.href, // Get loaded uri
                query = uri.substring(uri.indexOf("?") + 1, uri.length), // Get query string from the given uri
                queryObject = ioQuery.queryToObject(query); // Convert query string to object
            // Verify if the dialog redirected to the container page that not contains the indicated parameters, close the dialog.
            if (!queryObject || !(queryObject.task)) {
                dialog.hide();
            }
        }
    });

});
},
'url:epi-cms/contentediting/templates/PageDataController.html':"﻿<div style=\"width: 100%; height: 100%;\">\r\n    <div data-dojo-attach-point=\"mainLayoutContainer\" data-dojo-type=\"dijit/layout/BorderContainer\" data-dojo-props=\"gutters: false, livesplitters: false\" style=\"width: 100%; height: 100%\">\r\n        <div data-dojo-attach-point=\"toolbar\" data-dojo-type=\"epi-cms/contentediting/EditToolbar\" data-dojo-props=\"region:'top'\"></div>\r\n        <div data-dojo-attach-point=\"notificationBar\" data-dojo-type=\"epi-cms/contentediting/NotificationBar\" data-dojo-props=\"region:'top'\"></div>\r\n        <div data-dojo-attach-point=\"editLayoutContainer\" data-dojo-type=\"epi/shell/layout/CardContainer\" data-dojo-props=\"region: 'center'\">\r\n            <div data-dojo-attach-point=\"iframeWithOverlay\" data-dojo-type=\"epi/shell/widget/IframeWithOverlay\" data-dojo-props=\"fitContainer: true\">\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>",
'epi-cms/contentediting/SettingsPanel':function(){
﻿define([
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/_base/array",
        "dojo/_base/Deferred",
        "dojo/when",
        "dojo/dom-geometry",
        "dijit/_Container",
        "dijit/_TemplatedMixin",
        "dijit/_WidgetsInTemplateMixin",
        "dijit/layout/_LayoutWidget",
        "dijit/layout/BorderContainer",
        "epi/shell/layout/SimpleContainer",
        "dojo/text!./templates/SettingsPanel.html"
    ],
    function(
        declare,
        lang,
        array,
        Deferred,
        when,
        domGeometry,
        _Container,
        _TemplatedMixin,
        _WidgetsInTemplateMixin,
        _LayoutWidget,
        BorderContainer,
        SimpleContainer,
        template) {

        return declare([_LayoutWidget, _Container, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // summary:
        //    Base class for rendering a content block.
        // tags:
        //    abstract

            templateString: template,
            
            contentViewModel: null,

            detailsWidgetIdentifier: "epi-cms/contentediting/ContentDetails",

            detailsModelIdentifier: "epi-cms/contentediting/viewmodel/ContentDetailsViewModel",
            
            detailsWidgetProperties: null,
            
            _contentDetailsDef: null,
            
            _contentDetailsModelDef: null,

            buildRendering: function () {
                this.inherited(arguments);
                
                // Load details widget class and its model class async
                var widgetIdentifier = this.detailsWidgetIdentifier;
                var modelIdentifier = this.detailsModelIdentifier;
                var widgetDef = new Deferred();
                var modelDef = new Deferred();

                require([widgetIdentifier, modelIdentifier], lang.hitch(this, function (widgetClass, modelClass) {

                    var widget = new widgetClass({}, this.contentDetails);
                    this.own(widget);

                    var model = new modelClass();
                    this.own(model); 

                    widget.set("model", model);

                    // If the widget constructor takes time to load, we might have missed the startup, so better call it manually.
                    widget.startup();

                    this.contentDetails = widget;
                    widgetDef.resolve(widget);
                    modelDef.resolve(model);
                }));

                this._contentDetailsDef = widgetDef;
                this._contentDetailsModelDef = modelDef;
            },

            _setContentViewModelAttr: function(contentViewModel) {
                this._set("contentViewModel", contentViewModel);

                // When the model is created, change its datamodel
                when(this._contentDetailsModelDef, function (model) {
                    model.set("dataModel", contentViewModel);
                });
            },
            
            addChild: function (w) {
                // Check settings if this property should be blaced in the contentDetails widget
                if (this.detailsWidgetProperties) {
                    var matches = array.filter(this.detailsWidgetProperties, function (item) { return item.propertyName == w.name; });
                    if (matches.length > 0) {
                        when(this._contentDetailsDef, lang.hitch(this, function(contentDetails) {
                            contentDetails.addChild(w, matches[0].options);
                        }));

                        return;
                    }
                }
                
                // Default: Place in property widget container
                this.widgetContainer.addChild(w);
            }
        });
    });
},
'url:epi-cms/contentediting/templates/SettingsPanel.html':"﻿<div class=\"epi-documentHeader\">\r\n    <div data-dojo-type=\"epi/shell/layout/SimpleContainer\" data-dojo-attach-point=\"widgetContainer\"></div>\r\n    <div data-dojo-attach-point=\"contentDetails\"></div>\r\n</div>",
'epi-cms/contentediting/ValidationTextboxWithWarning':function(){
﻿define([
    "dojo/_base/declare",
    "dojox/validate/regexp",

    "dijit/form/ValidationTextBox"

], function (declare, regexp, ValidationTextBox) {

    return declare([ValidationTextBox], {

        // regExpForWarning: [extension protected] String
        //		regular expression string used to validate the input when typing
        regExpForWarning: null,

        // acceptUrl: boolean
        //      If this is true, user can input an url to the textbox e.g. http://, https://, ftp://
        acceptUrl: false,

        // acceptMailAddress: boolean
        //      If this is true, user can input an email address like mailto:username@mail.com
        acceptMailAddress: false,

        _refreshState: function () {
            // summary:
            //      Overrides ValidationTextbox._refreshState()
            // tags:
            //      private
            if (!this._created) {
                return;
            }
            this.focused ? this._validateWhenTyping() : this.validate(false);
        },

        _isValidWhenTyping: function () {
            // summary:
            //      Validate the value when typing
            // tags:
            //      private

            var value = this.textbox.value;
            return (this.acceptUrl && (new RegExp(regexp.url({ scheme: true }))).test(value))
                        || (this.acceptMailAddress && (new RegExp("mailto\\:" + regexp.emailAddress())).test(value))
                        || (this.regExpForWarning && (new RegExp("^(?:" + this.regExpForWarning + ")" + (this.required ? "" : "?") + "$")).test(value));
        },

        _validateWhenTyping: function () {
            // summary:
            //		Validate the value when typing and show hint(promptMessage) for user if neccessary
            // tags:
            //		private

            var message = "";
            var isValid = this.disabled || this.isValid(true);
            if (isValid) { this._maskValidSubsetError = true; }
            var isEmpty = this._isEmpty(this.textbox.value);
            var isValidSubset = !isValid && this._isValidSubset();
            this._set("state", isValid ? (this._isValidWhenTyping() ? "" : "Incomplete") :
                                       (((isEmpty || isValidSubset) && this._maskValidSubsetError) ? "Incomplete" : "Error"));
            this.focusNode.setAttribute("aria-invalid", isValid ? "false" : "true");

            if (this.state == "Error") {
                this._maskValidSubsetError = isValidSubset; // we want the error to show up after a blur and refocus
                message = this.getErrorMessage(true);
            } else if (this.state == "Incomplete") {
                message = this.getPromptMessage(true); // show the prompt whenever the value is not yet complete
                this._maskValidSubsetError = !this._hasBeenBlurred; // no Incomplete warnings while focused
            } else if (isEmpty) {
                message = this.getPromptMessage(true); // show the prompt whenever there's no error and no text
            }
            this.set("message", message);

            return isValid;
        }
    });
});
},
'dojox/validate/regexp':function(){
define("dojox/validate/regexp", ["dojo/_base/lang", "dojo/regexp", "dojox/main"], 
  function(lang, regexp, dojox){

var dxregexp = lang.getObject("validate.regexp", true, dojox);
dxregexp = dojox.validate.regexp = {
	
	ipAddress: function(flags){
		// summary:
		//		Builds a RE that matches an IP Address
		// description:
		//		Supports 5 formats for IPv4: dotted decimal, dotted hex, dotted octal, decimal and hexadecimal.
		//		Supports 2 formats for Ipv6.
		// flags: Object?
		//		All flags are boolean with default = true.
		//
		//		- flags.allowDottedDecimal  Example, 207.142.131.235.  No zero padding.
		//		- flags.allowDottedHex  Example, 0x18.0x11.0x9b.0x28.  Case insensitive.  Zero padding allowed.
		//		- flags.allowDottedOctal  Example, 0030.0021.0233.0050.  Zero padding allowed.
		//		- flags.allowDecimal  Example, 3482223595.  A decimal number between 0-4294967295.
		//		- flags.allowHex  Example, 0xCF8E83EB.  Hexadecimal number between 0x0-0xFFFFFFFF.
		//		  Case insensitive.  Zero padding allowed.
		//		- flags.allowIPv6   IPv6 address written as eight groups of four hexadecimal digits.
		
		//	FIXME: ipv6 can be written multiple ways IIRC
		//		- flags.allowHybrid   IPv6 address written as six groups of four hexadecimal digits
		//		-   followed by the usual 4 dotted decimal digit notation of IPv4. x:x:x:x:x:x:d.d.d.d

		// assign default values to missing paramters
		flags = (typeof flags == "object") ? flags : {};
		if(typeof flags.allowDottedDecimal != "boolean"){ flags.allowDottedDecimal = true; }
		if(typeof flags.allowDottedHex != "boolean"){ flags.allowDottedHex = true; }
		if(typeof flags.allowDottedOctal != "boolean"){ flags.allowDottedOctal = true; }
		if(typeof flags.allowDecimal != "boolean"){ flags.allowDecimal = true; }
		if(typeof flags.allowHex != "boolean"){ flags.allowHex = true; }
		if(typeof flags.allowIPv6 != "boolean"){ flags.allowIPv6 = true; }
		if(typeof flags.allowHybrid != "boolean"){ flags.allowHybrid = true; }

		// decimal-dotted IP address RE.
		var dottedDecimalRE =
			// Each number is between 0-255.  Zero padding is not allowed.
			"((\\d|[1-9]\\d|1\\d\\d|2[0-4]\\d|25[0-5])\\.){3}(\\d|[1-9]\\d|1\\d\\d|2[0-4]\\d|25[0-5])";

		// dotted hex IP address RE.  Each number is between 0x0-0xff.  Zero padding is allowed, e.g. 0x00.
		var dottedHexRE = "(0[xX]0*[\\da-fA-F]?[\\da-fA-F]\\.){3}0[xX]0*[\\da-fA-F]?[\\da-fA-F]";

		// dotted octal IP address RE.  Each number is between 0000-0377.
		// Zero padding is allowed, but each number must have at least 4 characters.
		var dottedOctalRE = "(0+[0-3][0-7][0-7]\\.){3}0+[0-3][0-7][0-7]";

		// decimal IP address RE.  A decimal number between 0-4294967295.
		var decimalRE =  "(0|[1-9]\\d{0,8}|[1-3]\\d{9}|4[01]\\d{8}|42[0-8]\\d{7}|429[0-3]\\d{6}|" +
			"4294[0-8]\\d{5}|42949[0-5]\\d{4}|429496[0-6]\\d{3}|4294967[01]\\d{2}|42949672[0-8]\\d|429496729[0-5])";

		// hexadecimal IP address RE.
		// A hexadecimal number between 0x0-0xFFFFFFFF. Case insensitive.  Zero padding is allowed.
		var hexRE = "0[xX]0*[\\da-fA-F]{1,8}";

		// IPv6 address RE.
		// The format is written as eight groups of four hexadecimal digits, x:x:x:x:x:x:x:x,
		// where x is between 0000-ffff. Zero padding is optional. Case insensitive.
		var ipv6RE = "([\\da-fA-F]{1,4}\\:){7}[\\da-fA-F]{1,4}";

		// IPv6/IPv4 Hybrid address RE.
		// The format is written as six groups of four hexadecimal digits,
		// followed by the 4 dotted decimal IPv4 format. x:x:x:x:x:x:d.d.d.d
		var hybridRE = "([\\da-fA-F]{1,4}\\:){6}" +
			"((\\d|[1-9]\\d|1\\d\\d|2[0-4]\\d|25[0-5])\\.){3}(\\d|[1-9]\\d|1\\d\\d|2[0-4]\\d|25[0-5])";

		// Build IP Address RE
		var a = [];
		if(flags.allowDottedDecimal){ a.push(dottedDecimalRE); }
		if(flags.allowDottedHex){ a.push(dottedHexRE); }
		if(flags.allowDottedOctal){ a.push(dottedOctalRE); }
		if(flags.allowDecimal){ a.push(decimalRE); }
		if(flags.allowHex){ a.push(hexRE); }
		if(flags.allowIPv6){ a.push(ipv6RE); }
		if(flags.allowHybrid){ a.push(hybridRE); }

		var ipAddressRE = "";
		if(a.length > 0){
			ipAddressRE = "(" + a.join("|") + ")";
		}
		return ipAddressRE; // String
	},

	host: function(flags){
		// summary:
		//		Builds a RE that matches a host
		// description:
		//		A host is a named host (A-z0-9_- but not starting with -), a domain name or an IP address, possibly followed by a port number.
		// flags: Object?
		//		- flags.allowNamed Allow a named host for local networks. Default is false.
		//		- flags.allowIP  Allow an IP address for hostname.  Default is true.
		//		- flags.allowLocal  Allow the host to be "localhost".  Default is false.
		//		- flags.allowPort  Allow a port number to be present.  Default is true.
		//		- flags in regexp.ipAddress can be applied.

		// assign default values to missing paramters
		flags = (typeof flags == "object") ? flags : {};

		if(typeof flags.allowIP != "boolean"){ flags.allowIP = true; }
		if(typeof flags.allowLocal != "boolean"){ flags.allowLocal = false; }
		if(typeof flags.allowPort != "boolean"){ flags.allowPort = true; }
		if(typeof flags.allowNamed != "boolean"){ flags.allowNamed = false; }

		//TODO: support unicode hostnames?
		// Domain name labels can not end with a dash.
		var domainLabelRE = "(?:[\\da-zA-Z](?:[-\\da-zA-Z]{0,61}[\\da-zA-Z])?)";
		var domainNameRE = "(?:[a-zA-Z](?:[-\\da-zA-Z]{0,6}[\\da-zA-Z])?)"; // restricted version to allow backwards compatibility with allowLocal, allowIP

		// port number RE
		var portRE = flags.allowPort ? "(\\:\\d+)?" : "";

		// build host RE
		var hostNameRE = "((?:" + domainLabelRE + "\\.)+" + domainNameRE + "\\.?)";
		if(flags.allowIP){ hostNameRE += "|" +  dxregexp.ipAddress(flags); }
		if(flags.allowLocal){ hostNameRE += "|localhost"; }
		if(flags.allowNamed){ hostNameRE += "|^[^-][a-zA-Z0-9_-]*"; }
		return "(" + hostNameRE + ")" + portRE; // String

	},

	url: function(flags){
		// summary:
		//		Builds a regular expression that matches a URL
		// flags: Object?
		//		- flags.scheme  Can be true, false, or [true, false].
		//		-   This means: required, not allowed, or match either one.
		//		- flags in regexp.host can be applied.
		//		- flags in regexp.ipAddress can be applied.

		// assign default values to missing paramters
		flags = (typeof flags == "object") ? flags : {};
		if(!("scheme" in flags)){ flags.scheme = [true, false]; }

		// Scheme RE
		var protocolRE = regexp.buildGroupRE(flags.scheme,
			function(q){ if(q){ return "(https?|ftps?)\\://"; } return ""; }
		);

		// Path and query and anchor RE
		var pathRE = "(/(?:[^?#\\s/]+/)*(?:[^?#\\s/]+(?:\\?[^?#\\s/]*)?(?:#[A-Za-z][\\w.:-]*)?)?)?";

		return protocolRE + dxregexp.host(flags) + pathRE;
	},

	emailAddress: function(flags){
		// summary:
		//		Builds a regular expression that matches an email address
		// flags: Object?
		//		- flags.allowCruft  Allow address like `<mailto:foo@yahoo.com>`.  Default is false.
		//		- flags in regexp.host can be applied.
		//		- flags in regexp.ipAddress can be applied.

		// assign default values to missing paramters
		flags = (typeof flags == "object") ? flags : {};
		if (typeof flags.allowCruft != "boolean") { flags.allowCruft = false; }
		flags.allowPort = false; // invalid in email addresses

		// user name RE per rfc5322
		var usernameRE = "([!#-'*+\\-\\/-9=?A-Z^-~]+[.])*[!#-'*+\\-\\/-9=?A-Z^-~]+";

		// build emailAddress RE
		var emailAddressRE = usernameRE + "@" + dxregexp.host(flags);

		// Allow email addresses with cruft
		if ( flags.allowCruft ) {
			emailAddressRE = "<?(mailto\\:)?" + emailAddressRE + ">?";
		}

		return emailAddressRE; // String
	},

	emailAddressList: function(flags){
		// summary:
		//		Builds a regular expression that matches a list of email addresses.
		// flags: Object?
		//		- flags.listSeparator  The character used to separate email addresses.  Default is ";", ",", "\n" or " ".
		//		- flags in regexp.emailAddress can be applied.
		//		- flags in regexp.host can be applied.
		//		- flags in regexp.ipAddress can be applied.

		// assign default values to missing paramters
		flags = (typeof flags == "object") ? flags : {};
		if(typeof flags.listSeparator != "string"){ flags.listSeparator = "\\s;,"; }

		// build a RE for an Email Address List
		var emailAddressRE = dxregexp.emailAddress(flags);
		var emailAddressListRE = "(" + emailAddressRE + "\\s*[" + flags.listSeparator + "]\\s*)*" +
			emailAddressRE + "\\s*[" + flags.listSeparator + "]?\\s*";

		return emailAddressListRE; // String
	},
	
	numberFormat: function(flags){
		// summary:
		//		Builds a regular expression to match any sort of number based format
		// description:
		//		Use this method for phone numbers, social security numbers, zip-codes, etc.
		//		The RE can match one format or one of multiple formats.
		//
		//		Format:
		//
		//		- #        Stands for a digit, 0-9.
		//		- ?        Stands for an optional digit, 0-9 or nothing.
		//		- All other characters must appear literally in the expression.
		//
		// example:
		//		- "(###) ###-####"		-    ->   (510) 542-9742
		//		- "(###) ###-#### x#???" ->   (510) 542-9742 x153
		//		- "###-##-####"		- 		-   ->   506-82-1089		-    i.e. social security number
		//		- "#####-####"		- 		-    ->   98225-1649		- 		- i.e. zip code
		//
		// flags:  Object?
		//		- flags.format  A string or an Array of strings for multiple formats.

		// assign default values to missing paramters
		flags = (typeof flags == "object") ? flags : {};
		if(typeof flags.format == "undefined"){ flags.format = "###-###-####"; }

		// Converts a number format to RE.
		var digitRE = function(format){
			// escape all special characters, except '?'
			return regexp.escapeString(format, "?")
				// Now replace '?' with Regular Expression
				.replace(/\?/g, "\\d?")
				// replace # with Regular Expression
				.replace(/#/g, "\\d")
			;
		};

		// build RE for multiple number formats
		return regexp.buildGroupRE(flags.format, digitRE); //String
	},
	
	ca: {

		postalCode: function(){
			// summary:
			//		String regular Express to match Canadain Postal Codes
			return "([A-Z][0-9][A-Z] [0-9][A-Z][0-9])";
		},

		province: function(){
			// summary:
			//		a regular expression to match Canadian Province Abbreviations
			return "(AB|BC|MB|NB|NL|NS|NT|NU|ON|PE|QC|SK|YT)";
		}

	},
	
	us:{
		state: function(flags){
			// summary:
			//		A regular expression to match US state and territory abbreviations
			// flags: Object?
			//		- flags.allowTerritories  Allow Guam, Puerto Rico, etc.  Default is true.
			//		- flags.allowMilitary  Allow military 'states', e.g. Armed Forces Europe (AE).  Default is true.

			// assign default values to missing parameters
			flags = (typeof flags == "object") ? flags : {};
			if(typeof flags.allowTerritories != "boolean"){ flags.allowTerritories = true; }
			if(typeof flags.allowMilitary != "boolean"){ flags.allowMilitary = true; }

			// state RE
			var statesRE =
				"AL|AK|AZ|AR|CA|CO|CT|DE|DC|FL|GA|HI|ID|IL|IN|IA|KS|KY|LA|ME|MD|MA|MI|MN|MS|MO|MT|" +
				"NE|NV|NH|NJ|NM|NY|NC|ND|OH|OK|OR|PA|RI|SC|SD|TN|TX|UT|VT|VA|WA|WV|WI|WY";

			// territories RE
			var territoriesRE = "AS|FM|GU|MH|MP|PW|PR|VI";

			// military states RE
			var militaryRE = "AA|AE|AP";

			// Build states and territories RE
			if(flags.allowTerritories){ statesRE += "|" + territoriesRE; }
			if(flags.allowMilitary){ statesRE += "|" + militaryRE; }

			return "(" + statesRE + ")"; // String
		}

	}
	
};

return dxregexp;

});

},
'dojox/main':function(){
define("dojox/main", ["dojo/_base/kernel"], function(dojo) {
	// module:
	//		dojox/main

	/*=====
	return {
		// summary:
		//		The dojox package main module; dojox package is somewhat unusual in that the main module currently just provides an empty object.
		//		Apps should require modules from the dojox packages directly, rather than loading this module.
	};
	=====*/

	return dojo.dojox;
});
},
'epi-cms/contentediting/viewmodel/ContentDetailsViewModel':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

// EPi Framework
    "epi",
    "epi/datetime",
    "epi/dependency",
    "epi/username",
    "epi-cms/contentediting/command/AccessRights",
    "epi-cms/contentediting/command/LanguageSettings",
    "epi-cms/contentediting/command/DynamicProperties",
    "epi/shell/command/_CommandConsumerMixin",
    "epi/shell/command/_GlobalCommandProviderMixin",

// EPi CMS
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/viewmodel/_ContentViewModelObserver"
],

function (
    array,
    declare,
    lang,

// EPi Framework
    epi,
    datetime,
    dependency,
    username,
    AccessRightsCmd,
    LanguageSettingsCmd,
    DynamicPropertiesCmd,
    _CommandConsumerMixin,
    _GlobalCommandProviderMixin,

// EPi CMS
    ContentActionSupport,
    ContentReference,
    _ContentViewModelObserver) {

    return declare([_ContentViewModelObserver, _CommandConsumerMixin, _GlobalCommandProviderMixin], {
        commandKey: "epi.cms.contentdetailsmenu",

        res: null,

        contentTypeName: null,
        contentId: null,
        visibleToEveryOne: null,
        existingLanguages: null,

        accessRightsCommand: null,
        languageSettingsCommand: null,
        dynamicPropertiesCommand: null,
        expirationCommand: null,

        constructor: function (params) {
            declare.safeMixin(this, params);
        },

        postscript: function () {
            this.initializeCommandProviders();
            this.accessRightsCommand = new AccessRightsCmd();
            this.languageSettingsCommand = new LanguageSettingsCmd();
            this.dynamicPropertiesCommand = new DynamicPropertiesCmd();
            if (!this.expirationCommand){
                //we use the global expiration command as the same command is used in expiration notification.
                var editingCommands = dependency.resolve("epi.cms.contentEditing.command.Editing");
                this.expirationCommand = editingCommands.manageExpiration;
            }

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.contenttype");
            }

            this.inherited(arguments);
        },

        destroy: function() {
            this.accessRightsCommand.destroy();
            this.languageSettingsCommand.destroy();
            this.dynamicPropertiesCommand.destroy();
            this.inherited(arguments);
        },

        _setDataModelAttr: function (value) {
            this.updateCommandModel(value);

            this.accessRightsCommand.set("model", value);
            this.languageSettingsCommand.set("model", value);
            this.dynamicPropertiesCommand.set("model", value);

            this.inherited(arguments);
        },

        onDataModelChange: function (name, oldValue, value) {
            var contentData = this.dataModel.contentData,
                contentRef = new ContentReference(contentData.contentLink);

            this.set("contentId", contentRef.id);

            this.set("existingLanguages", array.map(contentData.existingLanguageBranches, function (item) {
                return {
                    text: item.languageId,
                    urlSegment: item.urlSegment,
                    isCurrentLanguage: contentData.currentLanguageBranch && item.languageId === contentData.currentLanguageBranch.languageId,
                    contentLink: new ContentReference(item.commonDraftLink).createVersionUnspecificReference().toString()
                };
            }));

            this.set("visibleToEveryOne", contentData.visibleToEveryOne);

            dojo.when(this.store.get(contentData.contentTypeID), dojo.hitch(this, function (type) {
                this.set("contentTypeName", type.localizedName);
            }));

            this.set("commands", this.getCommands());
        },

        getCommands: function () {
            var commands = this.inherited(arguments);

            return [this.dynamicPropertiesCommand, this.languageSettingsCommand, this.expirationCommand].concat(commands);
        }
    });
});

},
'epi-cms/contentediting/command/AccessRights':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_LegacyDialogCommandBase",

//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.contentdetails.command.accessrights"
],

function (declare, ContentActionSupport, _LegacyDialogCommandBase, resources) {

    return declare([_LegacyDialogCommandBase], {
        // summary:
        //      Toggles permanent in use notification on/off.

        name: "AccessRights",
        label: resources.label,
        tooltip: resources.tooltip,

        dialogPath: "Edit/EditSecurity.aspx",
        raiseCloseEvent: true,

        _onModelChange: function () {
            // summary:
            //		Updates canExecute and isAvailable after the model has been updated.
            // tags:
            //		protected

            var contentData = this.model.contentData,
                hasAdminAccess = ContentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel.Administer),
                canChangeContent = this.model.canChangeContent();

            this.set("canExecute", contentData.capabilities.securable && hasAdminAccess && canChangeContent);
        }
    });
});
},
'epi-cms/contentediting/command/LanguageSettings':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_LegacyDialogCommandBase",

//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.contentdetails.command.languagesettings"
],

function (declare, ContentActionSupport, _LegacyDialogCommandBase, resources) {

    return declare([_LegacyDialogCommandBase], {
        // summary:
        //      Toggles permanent in use notification on/off.

        name: "LanguageSettings",
        label: resources.label,
        tooltip: resources.tooltip,

        dialogPath: "Edit/LanguageSettings.aspx",
        raiseCloseEvent: true,

        _onModelChange: function () {
            // summary:
            //		Updates canExecute and isAvailable after the model has been updated.
            // tags:
            //		protected

            var contentData = this.model.contentData,
                hasAdminAccess = ContentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel.Administer),
                canChangeContent = this.model.canChangeContent();

            this.set("canExecute", contentData.capabilities.languageSettings && hasAdminAccess && canChangeContent);
        }
    });
});
},
'epi-cms/contentediting/command/DynamicProperties':function(){
﻿define([
    "dojo/_base/declare",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/command/_LegacyDialogCommandBase",

//Resources
    "epi/i18n!epi/cms/nls/episerver.cms.contentediting.contentdetails.command.dynamicproperties"
],

function (declare, ContentActionSupport, _LegacyDialogCommandBase, resources) {

    return declare([_LegacyDialogCommandBase], {
        // summary:
        //      Toggles permanent in use notification on/off.

        label: resources.label,
        tooltip: resources.tooltip,

        dialogPath: "Edit/EditDynProp.aspx",
        raiseCloseEvent: false,

        _onModelChange: function () {
            // summary:
            //		Updates canExecute and isAvailable after the model has been updated.
            // tags:
            //		protected

            var contentData = this.model.contentData,
                hasAdminAccess = ContentActionSupport.hasAccess(contentData.accessMask, ContentActionSupport.accessLevel.Administer),
                canChangeContent = this.model.canChangeContent();

            this.set("canExecute", contentData.capabilities.dynamicProperties && hasAdminAccess && canChangeContent);
        }
    });
});
},
'epi-cms/conversion/PropertyContentAreaConverter':function(){
﻿define([
    "dojo/_base/declare"
],
    function (declare) {

        return declare(null, {
            // summary:
            //    Converts propertyContentArea. Checks if the data is located in the _unparsedString
            //    
            //
            // tags:
            //    public

            sourceDataType: "epi.cms.propertycontentarea",
            targetDataType: "runtimeType",

            registerDefaultConverters: function (/*Object*/registry) {
                // summary:
                //    Registers the type conversions that this class supports to the given registry.
                //
                // registry: Object
                //    The converter registry to add mappings to.
                registry.registerConverter(this.sourceDataType, this.targetDataType, this);
            },

            convert: function (/*String*/sourceDataType, /*String*/targetDataType, /*Object*/data) {
                // summary:
                //    Converts data between two types.
                //
                // sourceDataType: String
                //    The source data type.
                //
                // targetDataType: String
                //    The target data type.
                //
                // converter: Object
                //    The class that performs the actual conversion.
                // tags:
                //    public

                if (sourceDataType === this.sourceDataType && targetDataType === this.targetDataType) {
                    return data ? data._unparsedString : data;
                }

                return null;
            }
        });
    }
);
},
'epi-cms/layout/CreateContentGroupContainer':function(){
﻿define([
    "dojo/_base/declare",
    "dojo/dom-construct",
    "epi/shell/layout/SimpleContainer"
], function (
    declare,
    domConstruct,
    SimpleContainer) {

    return declare([SimpleContainer], {
        // summary:
        //     Group container that have a title.

        templateString: "<div class='epi-containerLayout clearfix'>\
                            <div class='epi-formsHeaderContainer'>\
                                <h2>${title}</h2>\
                            </div>\
                            <ul data-dojo-attach-point='containerNode'></ul>\
                        </div>"
    });
});
},
'epi-cms/layout/EditLayoutContainer':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/dom-construct",
    "dijit/layout/TabContainer",
    "dijit/registry",
    "dojo/text!./templates/EditLayoutContainer.html"
], function (
    array,
    declare,
    domConstruct,
    TabContainer,
    registry,
    template
) {

    return declare([TabContainer], {
        // summary:
        //     Widget that contains a group form items widgets, aimed to apply the html formatting specific to a group

        templateString: template,

        postMixInProperties: function () {
            this.inherited(arguments);

            // This container does not allow doing layout children and only support top tabs because we use relative position when laying out.
            // The reason behind is that absolute position make the container zero height when it is laid out without size constraints.
            this.doLayout = false;
            this.tabPosition = "top";
        },

        addChild: function (widget, index) {
            // summary:
            //     Add a child o the container.
            // widget: dijit._Widget
            //     The widget to add
            // index: Number
            //     The position
            // tag:
            //     public

            if (widget.region === "top") {
                domConstruct.place(widget.domNode, this.topPaneContainerNode);

                // If I've been started but the child widget hasn't been started,
                // start it now.  Make sure to do this after widget has been
                // inserted into the DOM tree, so it can see that it's being controlled by me,
                // so it doesn't try to size itself.
                if (this._started && !widget._started) {
                    widget.startup();
                }

            } else {
                this.inherited(arguments);
            }
        },

        removeChild: function (widget) {
            // Overrides _Container.removeChild() to do layout

            if (widget.region === "top") {
                // Return if we are being destroyed
                if (this._descendantsBeingDestroyed) { return; }

                // Otherwise, do layout again
                if (this._started) {
                    this.layout();
                }
            } else {
                this.inherited(arguments);
            }
        },

        getChildren: function () {
            var children = this.topPaneContainerNode ? registry.findWidgets(this.topPaneContainerNode) : [];
            return children.concat(this.inherited(arguments));
        },

        layout: function () {
            // Overrides TabContainer.layout().
            // Configure the content pane to take up all the space except for where the tabs and the top panel are.

            if (!this._contentBox || typeof (this._contentBox.l) == "undefined") { return; }

            // layout the top panel first
            var topPaneContents = registry.findWidgets(this.topPaneContainerNode);
            array.forEach(topPaneContents, function (widget) {
                widget.resize();
            });

            return this.inherited(arguments);
        },

        selectChild: function (widget) {
            // summary:
            //     Select child widget or group.
            // widget: dijit._Widget
            //     The child widget or group
            // tag:
            //     public

            if (widget.region === "top") {
                return;
            } else {
                return this.inherited(arguments);
            }
        }
    });
});
},
'url:epi-cms/layout/templates/EditLayoutContainer.html':"﻿<div class=\"dijitTabContainer\">\r\n    <div data-dojo-attach-point=\"topPaneContainerNode\"></div>\r\n\t<div class=\"dijitTabListWrapper\" data-dojo-attach-point=\"tablistNode\"></div>\r\n\t<div data-dojo-attach-point=\"tablistSpacer\" class=\"dijitTabSpacer ${baseClass}-spacer\"></div>\r\n\t<div class=\"dijitTabPaneWrapper ${baseClass}-container\" data-dojo-attach-point=\"containerNode\"></div>\r\n</div>\r\n",
'epi-cms/legacy/LegacyFormEditor':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

// Dijit
    "dijit/focus",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Button",

// EPi Framework
    "epi/dependency",
    "epi/shell/widget/dialog/Dialog",

// EPi CMS
    "epi-cms/widget/_HasChildDialogMixin",
    "epi/shell/widget/_ValueRequiredMixin",
    "epi-cms/legacy/EditPropertyWidget",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.legacy.legacyformeditor"
], function (
// Dojo
    declare,
    lang,

// Dijit
    focusManager,
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    Button,

// EPi Framework
    dependency,
    Dialog,

// EPi CMS
    _HasChildDialogMixin,
    _ValueRequiredMixin,
    EditPropertyWidget,

// Resources
    res
) {
    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _HasChildDialogMixin, _ValueRequiredMixin], {

        localization: res,

        // destroyOnHide: Boolean
        //      Flag to indicates that we should destroy when dialog hide or not
        destroyOnHide: false,

        // editorWidgetClass: Object
        //      Injected editor class
        editorWidgetClass: EditPropertyWidget,

        // templateString: [protected] String
        //    Template for the widget.
        templateString: '\
            <div class="dijit dijitReset dijitInline dijitLeft epi-legacyFormEditor">\
                <div data-dojo-type="dijit/form/Button" data-dojo-attach-point="openButton" data-dojo-attach-event="onClick: openEditor" data-dojo-props="label:\'${localization.helptext}\'"></div>\
            </div>',

        editorWidget: null,
        value: null,
        multiple: false,

        // contentLink: [pubic] String
        //      Content reference of the content being edited.
        //      Either contentLink or contentTypeId need to be set.
        contentLink: null,

        // contentTypeId: [pubic] Number
        //      Content type id of the content being edited.
        //      Either contentLink or contentTypeId need to be set.
        contentTypeId: null,

        // contentLanguage: [pubic] String
        //      The content language.
        contentLanguage: null,

        // propertyName: [pubic] String
        //      The property name.
        propertyName: null,

        _dialog: null,

        onChange: function () {
            // summary:
            //    Triggered when the cancel button is clicked.
            //
            // tags:
            //    public callback
        },

        postCreate: function () {
            this.inherited(arguments);
            lang.mixin(this.params, { contentLink: this.contentLink });
        },

        buildRendering: function () {
            this.inherited(arguments);

            if (this.output) {
                this.output.set("disabled", true);
            }
        },

        destroy: function () {
            if (this._dialog) {
                this._dialog.destroyRecursive();
            }
            this.inherited(arguments);
        },

        _setReadOnlyAttr: function (value) {
            this._set("readOnly", value);

            this.openButton.set("disabled", value);
        },

        _setValueAttr: function (value) {
            this._set("value", value);

            this.setDisplayValue(value);
        },

        _getValueAttr: function (value) {
            if (this.editorWidget) {
                this._set("value", this.editorWidget.get("value", value));
            }
            return this.value;
        },

        _onChange: function () {
            var value = this.editorWidget.get('value');
            this.onChange(value);

            if (this._dialog && this._dialog.open) {
                this._dialog.hide();
            }

            this.setDisplayValue(value);
        },

        _onCancel: function () {
            this._dialog.hide();
        },

        _onDialogHide: function () {
            this.isShowingChildDialog = false;
        },

        openEditor: function () {

            this.isShowingChildDialog = true;

            if (!this._dialog || this.destroyOnHide) {
                this._createDialog();
            }

            //Reset the edit property widget, force it reload to match the new value
            this.editorWidget.set("value", this.value);

            this._dialog.show();
        },

        _createDialog: function () {
            // Create editor widget
            var editorClass = this.editorWidgetClass;
            this.editorWidget = new editorClass(this.params);

            // Create dialog and set content
            this._dialog = new Dialog({
                destroyOnHide: this.destroyOnHide,
                content: this.editorWidget,
                title: this.editorWidget.title || this.label,
                defaultActionsVisible: false,
                dialogClass: "",
                contentClass: "epi-dialog-fullWidth"
            });

            // ESC and TAB could cancel and save.  Note that edit widgets do a stopEvent() on ESC key (to
            // prevent Dialog from closing when the user just wants to revert the value in the edit widget),
            // so this is the only way we can see the key press event.
            this.connect(this.editorWidget, "onResize", lang.hitch(this, function () {
                this._dialog.resize();
            }));

            this.connect(this.editorWidget, "onChange", "_onChange");
            this.connect(this.editorWidget, "onCancel", "_onCancel");
            this.connect(this._dialog, "onHide", "_onDialogHide");
        },

        setDisplayValue: function (value) {
            //Override to display something meaningful to user

            if (this.output) {
                this.output.set("value", this.localization.helptext);
            }
        },

        focus: function () {
            // summary:
            //		Put focus on the edit button.
            this.openButton.focus();
        }
    });
});

},
'epi-cms/legacy/EditPropertyWidget':function(){
﻿define([
"epi",
"dojo",
"dijit",
"dojo/i18n",
"dojo/string",
"dojox/html/entities",
"epi-cms/contentediting/RenderManager",
"epi-cms/legacy/LegacyDialogWrapper",
"epi/routes"],

function (epi, dojo, dijit, i18n, dojoString, dojoxEntities, RenderManager, LegacyDialogWrapper, routes) {

    return dojo.declare([LegacyDialogWrapper], {
        // summary:
        //	   Webform editor for a CMS property. 
        //     Extend the epi.cms.legacy.LegacyDialogWrapper to be a value widget, specific for EditProperty dialog

        editorFeatures: null,

        value: "",

        // contentLink: [public] String
        //      Content reference of the content being edited.
        //      Either contentLink or contentTypeId need to be set.
        contentLink: null,

        // contentTypeId: [public] Number
        //      Content type id of the content being edited.
        //      Either contentLink or contentTypeId need to be set.
        contentTypeId: null,

        // contentLanguage: [public] String
        //      The content language.
        contentLanguage: null,

        // propertyName: [public] String
        //      The property name.
        propertyName: null,

        // fullName: [public] String
        //      Fully qualified property name. E.g. MainTeaser.MyBlock.Name
        fullName: null,

        _reloadOnNextEdit: false,

        onChange: function (newValue) {
            // summary:
            //    Triggered when the value is changed
            //
            // newValue: Object
            //    The newly changed value
            //
            // tags:
            //    public callback
        },

        postMixInProperties: function () {
            // summary:
            //	   Initialize epi.cms.legacy.LegacyDialogWrapper's parameters to be specific to EditProperty dialog.

            this.features = dojo.mixin({ width: 400, height: 30 }, this.editorFeatures); // initial size

            this.autoFit = true;

            this.connect(this, "onCallback", "_onCallback");

            this.inherited(arguments);
        },

        startup: function () {
            // summary: 
            //      Overridden to set the url based on the current page context
            this.inherited(arguments);

            var routeParams = {
                moduleArea: "LegacyCMS",
                path: "edit/EditProperty.aspx",
                epslanguage: this.contentLanguage,
                propertyname: this.fullName
            };

            dojo.mixin(routeParams, this.contentLink ? {
                id: this.contentLink
            } : {
                contentTypeId: this.contentTypeId,
                parentLink: this.parentLink
            });

            this.set("url", routes.getActionPath(routeParams));
        },

        _setUrlAttr: function (url) {
            // If we rely on saved property value, the editor will not display updated value until the sync service has done its job.
            // Therefore, we need to POST the current value to server. (GET is not suitable since url length is limited to 2048 characters)
            // Override Url setter to be able to load the edit property dialog using POST.

            //set current Url
            this._currentUrl = url;

            //using dojox.html.entities to html encode the value
            var value = dojoxEntities.encode(dojo.toJson(this.value));
            //Create a post form
            var postForm = dojoString.substitute('<html><body><form method="post" action="${0}" ><input type="hidden" name="value" value="${1}" /></form></body></html>', [url, value]);
            this.containerIframe.contentDocument.write(postForm);

            //Submit
            this.containerIframe.contentDocument.forms[0].submit();
        },

        _onCallback: function (result) {

            // deserialize value
            var newStringValue = result.value;
            var newValue = dojo.fromJson(newStringValue);

            if (this._oldStringValue === undefined) {
                this._oldStringValue = dojo.toJson(this.value);
            }

            if (newStringValue !== this._oldStringValue) {
                this._oldStringValue = dojo.toJson(newValue);
                this.value = newValue;
                this.onChange(newValue);
            }
            else {
                this.onCancel();
            }
        },

        resize: function () {
            this.inherited(arguments);
            if (this._reloadOnNextEdit) {
                this._reloadOnNextEdit = false;
                this._reloadUrl(true);
            }
        },

        _setValueAttr: function (value) {
            //summary:
            //    Value's setter. Reload the src in the container iframe if value is not equal.
            //
            // value: String
            //    Value to be set.
            //
            // tags:
            //    private

            this._set("value", value);
            if (this._started) {
                this._reloadOnNextEdit = true;
            }
        }
    });

});

},
'epi-cms/legacy/LegacyDialogWrapper':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/sniff",
    "dojo/aspect",
    "dojo/on",
    "dojo/topic",

    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style",

    "dojo/has",
    "dojo/query",
    "dojo/string",
    "dojo/when",
// dijit
    "dijit/_Contained",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",

    "dijit/a11y",
    "dijit/focus",
    "dijit/form/Button",
    "dijit/layout/_LayoutWidget",
// epi
    "epi/Url",

    "epi/shell/widget/_ActionProviderWidget",

    "epi-cms/legacy/_LegacyDialogObject",
    "epi-cms/legacy/LegacyDialogPopup",
    "epi/i18n!epi/cms/nls/episerver.shared.action"
],

function (
// dojo
    array,
    declare,
    lang,
    sniff,
    aspect,
    on,
    topic,

    domAttr,
    domClass,
    domConstruct,
    domGeometry,
    domStyle,

    has,
    query,
    dojoString,
    when,
// dijit
    _Contained,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,

    a11y,
    focusManager,
    Button,
    _LayoutWidget,
// epi
    Url,

    _ActionProviderWidget,

    _LegacyDialogObject,
    LegacyDialogPopup,
    resources
) {

    return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ActionProviderWidget, _Contained], {

        // url: [public] String
        //    Legacy dialog's url.
        _currentUrl: null,

        // dialogArguments: [public] Object
        //    Legacy dialog's arguments.
        dialogArguments: null,

        // callbackArguments: [public] Object
        //    Legacy dialog's callback arguments.
        callbackArguments: null,

        // features: [public] Object
        //    Popup window features. Some (width, height) will be used to style the iframe. The others will be ignored.
        features: null,

        // autoFit: [public] Boolean
        //    Specify if the dialog should be resized to fit its inner content.
        autoFit: false,

        // showCloseButton: [public] Boolean
        //    When set to true, a trailing close button is added when the buttons mapped from the wrapped dialog have been added.
        showCloseButton: false,

        // _isIframeInitialLoad: [private] Boolean
        //    Value keeping track of inital iFrame load.
        _isIframeInitialLoad: true,

        // _iframeFocusRegistration: [private]
        //    For keeping track of sub frame focus registration
        _iframeFocusRegistration: null,

        // _scrollbarWidth: [private]
        //    Backing field for _getScrollbarWidth()
        _scrollbarWidth: null,

        // _iframeHandles: [private]
        //      Handles connected inside the iframe that should be removed when the iframe is unloaded
        _iframeHandles: null,

        // templateString: [protected] String
        //    Template for the widget.
        templateString: '\
        <div style="position: relative;" tabindex="0">\
            <iframe data-dojo-attach-point="containerIframe" tabindex="-1" frameborder="0" style="border: none; position: absolute, top:0, left: 0;" src="about:blank" ></iframe>\
        </div>',

        // _mappedButtons: [private] object
        //      Hash of the buttons mapped from the inner dialog to the outer toolbar
        _mappedButtons: null,

        postMixInProperties: function () {
            // summary:
            //    Ensure neccessary features are properly set.
            //
            // tags:
            //    public

            this.inherited(arguments);

            this._isIframeInitialLoad = true;
            this._iframeHandles = [];
            this.features = lang.mixin({ width: 320, height: 240 }, this.features);
        },

        postCreate: function () {
            // summary:
            //    Do some post create initialization. Show or hide cancel button according to setting
            //
            // tags:
            //    public

            this.inherited(arguments);

            //create a legacy dialog object
            this._legacyDialog = this._createLegacyDialogObject(lang.hitch(this, function () {
                this.onCallback.apply(this, arguments);
            }), this.callbackArguments, this.dialogArguments, window);

            // Set width and height of this widget to whatever's specified in this.features
            this._resetIframeContainerSize();
        },

        startup: function () {
            // summary:
            //    Start the wrapper widget up.
            //
            // tags:
            //    public

            this.inherited(arguments);

            //inject fake dialog utility methods to iframe onload
            if (this.containerIframe.attachEvent) {
                // Can't use connect when listening to the load event of iframes
                // http://bugs.dojotoolkit.org/ticket/9609
                this.containerIframe.attachEvent("onload", lang.hitch(this, this._onIframeLoad));
            } else {
                this.connect(this.containerIframe, "onload", lang.hitch(this, this._onIframeLoad));
            }
        },

        resize: function () {
            this.inherited(arguments);
            if (this._started) {
                // Propagate the size of our domNode to the iframe when we're resized, 
                // the domNode size has already been set by the Dialog
                this._setIframeSizeFromDomNode();
            }
        },

        _setUrlAttr: function (value) {
            var url = value || "about:blank";
            this._currentUrl = url;
            domAttr.set(this.containerIframe, "src", url);
        },

        onCallback: function (returnValue) {
            // summary:
            //    Handler for the legacy dialog's callback.
            //
            // returnValue: Object
            //     return value from the wrapped dialog
            //
            // tags:
            //    public callback
        },

        onLoad: function () {
            // summary:
            //    Triggered when the dialog is successfully loaded.
            //
            // tags:
            //    public callback
        },

        onCancel: function () {
            // summary:
            //    Triggered when the cancel button is clicked.
            //
            // tags:
            //    public callback
        },

        onMapDialogButton: function (/*DOM*/button) {
            // summary:
            //      Called when a button inside a legacy dialog is mapped into the dialog chrome. 
            //      Override this method to control whether a button is mapped or not
            // returns:
            //      true to mape the button; otherwise false.
            // tags:
            //      public, callback

            return true;
        },

        onBeforePerformAction: function (action) {
            // summary:
            //    Called before the legacy dialog perform an action.
            //
            // tags:
            //    public
        },

        getLegacyDialog: function () {
            // summary:
            //    Get legacy dialog object.
            //
            // tags:
            //    public

            return this._legacyDialog;
        },

        _focusIframeContent: function () {
            // summary:
            //      Sets focus to the first focusable element inside the iframe
            // tags:
            //      private

            var frameWin = this.containerIframe.contentWindow,
                doc = frameWin && frameWin.document,
                focusElem = (doc && a11y.getFirstInTabbingOrder(doc)) || this.containerIframe;

            focusManager.focus(focusElem);
        },

        _onIframeLoad: function () {
            // summary:
            //    Load handler for container iframe.
            //
            // tags:
            //    private

            // When we open an legacy page in dojo legacy wrapper, after saving, on some button (e.g.: SaveButton), we need to close the dialog wrapper.
            // We subscribe to /IsInLegacyWrapper/NeedToBeCloseOnLoad topic, then simulate click on Cancel button to safety close the dialog
            this.own(topic.subscribe('/IsInLegacyWrapper/NeedToBeCloseOnLoad', lang.hitch(this, function (message) {
                this.onCancel();
            })));

            // If not IE, Register the iframe for dijit focus tracking
            // TODO: In some particular situations, focus manager could break focusing by mouse in iframe. 
            // Potential reason might be the mousedown hanler which focus manager attached on iframe's body.
            // Not to register iframe would create a few problems, which are considered as KNOWN ISSUES:
            //  1) Can't automatically have focus on the first element inside iframe
            //  2) Don't get onBlur event on LegacyDialogWrapper widget
            //  3) When having focus inside iframe, focus manager reports curNode and activeStack as null.
            if (!has("ie")) {
                this._iframeFocusRegistration = focusManager.registerIframe(this.containerIframe);
            }

            this._focusIframeContent();

            this._overrideLegacyDialogUtilities();

            var iFrameWin = this.containerIframe.contentWindow;

            this._iframeHandles.push(on(iFrameWin, "unload", lang.hitch(this, this._removeIframeHandles)));

            // Aspect the SetEnabled method of the toolbutton support. Since this method is called to enable and disable 
            // buttons in the legacy UI, we update the state of our mapped buttons when this method is called
            if (iFrameWin.EPi && iFrameWin.EPi.ToolButton) {
                this._iframeHandles.push(aspect.after(iFrameWin.EPi.ToolButton, "SetEnabled", lang.hitch(this, this._toolButtonChanged), true));
            }

            // Dialogs not using EPi.ToolButton, i.e. tinyMCE dialogs use ButonChanged to notify about button state changes
            this._iframeHandles.push(aspect.after(this._legacyDialog, "ButtonChanged", lang.hitch(this, this._toolButtonChanged), true));

            this._mapDialogButtons();
            
            this._setTitle();

            // Add more class to overwrite max-width property of epi-ContentContainer class
            var containerNode = query(".epi-contentContainer", this.containerIframe.contentWindow.document)[0];
            if (containerNode) {
                domClass.add(containerNode, "epi-legacyDialog");
            }

            if (this.autoFit) {
                this._calculateAndSetContentSize();
            }

            // Need to call resize twice to get the dialog properly positioned when it's loaded
            // The first resize calculates the correct width and height, but positions the dialog outside of 
            // the viewport if the viewport is smaller than the requested size.
            this.onResize();
            this.onResize();

            //trigger load event
            if (this.onLoad) {
                this.onLoad.apply(this, arguments);
            }

            this._isIframeInitialLoad = false;
        },

        _removeIframeHandles: function () {
            // summary:
            //      Called when the iframe unloads to remove any handles connected inside the iframe.

            array.forEach(this._iframeHandles, function (handle) {
                handle.remove();
            });
            this._iframeHandles = [];
            this._mappedButtons = null;
        },

        _setTitle: function () {
            // summary:
            //    Set dialog title.
            //
            // tags:
            //    private

            if (this.dialogTitle) {
                this.title = this.dialogTitle;
                return;
            }

            var title = query("title", this.containerIframe.contentWindow.document)[0];
            if (title) {
                this.title = dojoString.trim(title.innerHTML); // trim to avoid Chrome bug (Chrome take \t \n from innerHTML and make the title ugly)
            }
        },

        _getScrollbarWidth: function () {
            // summary:
            //      Calculates and returns the width of scrollbars in an off-screen div
            // tags:
            //      private

            if (this._scrollbarWidth === null) {
                var d = domConstruct.create("div", {
                    style: "position:absolute; top:-2000; left:-2000; width:100px; height:100px; overflow:scroll"
                }, document.body);
                this._scrollbarWidth = d.offsetWidth - d.clientWidth;
                domConstruct.destroy(d);
            }

            return this._scrollbarWidth;
        },

        _boxToStyle: function (size) {
            // summary:
            //  Convert a dojo bounding width/height to style options

            return {
                width: size.w + "px",
                height: size.h + "px"
            };
        },

        _setIframeSizeFromDomNode: function () {
            // summary:
            //      Copies the width and height of the domNode to the iframe.
            //      If the dialog is too big for the viewport a maximum size is set on our domNode, 
            //      and if a requested size has been set on domNode it's restored if we get more space.
            // tags:
            //      private

            domStyle.set(this.containerIframe, this._boxToStyle(domGeometry.getContentBox(this.domNode)));
        },

        _setContentSize: function (size) {
            // summary:
            //      Set size on our domNode and the contained iframe
            // tags:
            //      private

            domStyle.set(this.domNode, this._boxToStyle(size));
            this._setIframeSizeFromDomNode();
        },

        _calculateAndSetContentSize: function (isInitialLoad) {
            // summary:
            //  Get the "best fit" width and height of the content in the iframe and set our size accordingly.

            function getSize(doc, dir) {

                if (doc && doc.body && doc.documentElement) {

                    return Math.max(
                        doc.documentElement["client" + dir],
                        doc.documentElement["scroll" + dir],
                        doc.documentElement["offset" + dir],
                        doc.body["scroll" + dir],
                        doc.body["offset" + dir]
                    );
                }

                return 0;
            }

            var iframeDoc = null;
            try {
                // Can't handle X-site scripting errors
                iframeDoc = this.containerIframe.contentWindow.document;
            } catch (e) {
                return;
            }

            // If we're scaling the dialog according to the size of the contained document 
            // we also make an effort to prevent both vertical and horizontal scrollbars.
            // The scroll check will almost always be true the first load, since we've 
            // squezed the iframe into the default dialog size, but for subsequent reloads, 
            // i.e. post backs, the scroll check will work more according to expectations 
            var hasVerticalScroll = (iframeDoc.documentElement.scrollHeight - iframeDoc.documentElement.clientHeight) > 0,
                scrollCompensation = hasVerticalScroll && this.autoFit ? this._getScrollbarWidth() : 0,
                contentBox = {
                    w: getSize(iframeDoc, "Width") + scrollCompensation,
                    h: getSize(iframeDoc, "Height")
                };

            this._setContentSize(contentBox);
        },

        _resetIframeContainerSize: function () {
            this._setContentSize({ w: this.features.width, h: this.features.height });
        },

        _showNode: function (/*DOM*/domNode, /*Boolean*/show) {
            // summary:
            //      Show or hide the given DOM node
            // tags:
            //      private

            if (!domNode) {
                return;
            }

            domStyle.set(domNode, "display", show ? "" : "none");
        },

        _toolButtonChanged: function (/*string|DOMNode*/legacyButton, /*Boolean*/enabled) {
            // summary:
            //      Update the enabled state of mapped buttons when the button state inside the iframe changes
            // legacyButton:
            //      Id of the leagcy button node or the button node itself.
            // enabled:
            //      Whether the button should be set as enadled or not (disabled)

            // In case legacyButton is a string we use the same method as in 
            // EPi.ToolButton.SetEnabled() to get hold of the DOM node.
            if (typeof legacyButton === "string") {
                var legacyEPi = lang.getObject("containerIframe.contentWindow.EPi", false, this);
                legacyButton = legacyEPi && legacyEPi._GetDomObject && legacyEPi._GetDomObject(legacyButton);
            }
            if (legacyButton) {
                if (this.hasAction(legacyButton.id)) {
                    this.setActionProperty(legacyButton.id, "disabled", legacyButton.disabled);
                    this.setActionProperty(legacyButton.id, "visible", legacyButton.style.display != "none");
                    this.setActionProperty(legacyButton.id, "label", legacyButton.value || legacyButton.innerHTML);
                }
                var mappedButton = this._mappedButtons[legacyButton.id];
                if (mappedButton) {
                    this._showNode(mappedButton.containerNode, false);
                }
            }
        },

        _mapDialogButtons: function () {
            // summary:
            //    Map legacy dialog's buttons to dojo buttons.
            // 
            // tags:
            //    private

            var dialogButtons = query(this.legacyButtonQuery || "[data-epi-dialog-button]", this.containerIframe.contentWindow.document); // Find all mappable buttons

            // If there are old actions added (post back), they're stale and must be removed
            this.removeActions(this.getActions());

            this._mappedButtons = {};

            array.forEach(dialogButtons, function (containerNode) {
                var mapType = domAttr.get(containerNode, "data-epi-dialog-button"),
                    functionNode = null;

                switch (mapType) {
                    case "functioner":
                        // The actual input element inside a ToolButton, handled when dealing with the container
                        return;
                    case "container":
                        // Found a ToolButton container. Locate the input element inside
                        functionNode = query('[data-epi-dialog-button="functioner"]', containerNode)[0];
                        break;
                    default:
                        // An ordinary input
                        if (containerNode.tagName == "INPUT") {
                            functionNode = containerNode;
                            // But if it's wrapped in a span with the epi-cmsButton class it's a CMS ToolButton
                            if (domClass.contains(functionNode.parentNode, "epi-cmsButton")) {
                                containerNode = functionNode.parentNode;
                            }
                        } else {
                            functionNode = query("INPUT", containerNode)[0];
                        }
                        
                        break;
                }

                this._mappedButtons[functionNode.id] = {
                    containerNode: containerNode,
                    functionNode: functionNode
                };

                this._showNode(containerNode, false);

                when(this.onMapDialogButton(functionNode), lang.hitch(this, function (shouldMapButton) {
                    if (shouldMapButton) {
                        var label = functionNode.tagName == "INPUT" ? functionNode.value : functionNode.innerHTML,
                            title = functionNode.tagName == "INPUT" ? domAttr.get(functionNode, "title") : functionNode.innerHTML,
                            action = {
                                name: functionNode.id,
                                label: label,
                                disabled: functionNode.disabled,
                                title: title,
                                action: lang.hitch(this, function () {
                                    this.onBeforePerformAction(/*Object*/action, /*DOM*/functionNode);
                                    functionNode.click();
                                })
                            };

                        this.addActions(action);
                    }
                }));
            }, this);

            if (this.showCloseButton) {
                this.addActions({
                    name: "close",
                    label: resources.close,
                    action: lang.hitch(this, this.onCancel)
                });
            }
        },

        _overrideLegacyDialogUtilities: function () {
            // summary:
            //    Overrides legacy dialog utility methods to make it fit with iframed dialogs.
            // 
            // tags:
            //    private

            var iFrameWin = this.containerIframe.contentWindow;

            if (!iFrameWin.EPi) {
                iFrameWin.EPi = {};
            }

            iFrameWin.EPi.CreateDialog = lang.hitch(this, this._createLegacyDialogFnc);
            iFrameWin.EPi.GetDialog = lang.hitch(this, this._getLegacyDialogFnc);
        },

        _getLegacyDialogFnc: function (win) {
            // Tiny MCE runs in a different window context therefore the win param is supplied 
            // to get the dialog from the window hosting the actual dialog 
            if (win) {
                return win.EPi.GetDialog();
            }
            return this._legacyDialog;
        },

        _createLegacyDialogFnc: function (url, callbackMethod, callbackArguments, dialogArguments, features, opener) {
            // summary:
            //    Function to replace the old dialog API.
            // 
            // url: String                   
            //    Path to the file to open in a dialog, required.
            //
            // callbackMethod: Function
            //    Method to call when closing the dialog, optional.
            //
            // callbackArguments: Variant
            //    Variant that specifies the arguments to use in the callbackMethod method, when returning/closing the dialog.
            //
            // dialogArguments: Variant
            //    Variant that specifies the arguments to use when displaying the document. Use this parameter to pass a value of any type, including an array of values. 
            //    The dialog loaded can extract the values passed by the caller from the dialogArguments property of the EPiDialog object.
            //
            // features: Object
            //    Optional. Object that specifies the dialog position and size.
            //    Example: {width:300, height:200}
            //    The following values are valid by default:width:intWidth|sWidth, height:intHeight|sHeight, left: intLeft|sLeft, top: intTop|sTop
            //    Default is width:510, height:500. Position is centered in opening window.
            //
            // tags:
            //    private

            var dialog = new LegacyDialogPopup({
                url: url,
                destroyOnHide: true,
                dialogArguments: dialogArguments,
                callbackArguments: callbackArguments,
                features: features
            });

            dialog.on("Callback", lang.hitch(this, function () {
                if (callbackMethod) {
                    callbackMethod.apply(this, arguments);
                }
            }));

            //show it
            dialog.show();

            return dialog.legacyDialogObject;
        },

        _createLegacyDialogObject: function (callbackMethod, callbackArguments, dialogArguments, opener) {
            // summary:
            //    Create legacy dialog object and register the container iframe as the fake popup window.
            // 
            // callbackMethod: Function
            //    
            //
            // callbackArguments: Object
            //    
            //
            // dialogArguments: Object
            //    
            //
            // opener: Window
            //    
            //
            // tags:
            //    private

            var obj = new _LegacyDialogObject({
                callbackMethod: callbackMethod,
                callbackArguments: callbackArguments,
                dialogArguments: dialogArguments,
                _opener: opener ? opener.top : window.top
            });

            // TODO: Need to review and remove _dialog.
            try {
                obj._dialog = this.containerIframe.contentWindow; //Fake the popup window
            }
            catch (e) {
                obj._dialog = null;
            }

            return obj;
        },

        _reloadUrl: function (isInitialLoad) {
            // summary:
            //    Reload the src on the container iframe.
            // 
            // tags:
            //    protected

            this._isIframeInitialLoad = isInitialLoad;
            if (this._isIframeInitialLoad) {
                this._resetIframeContainerSize();
            }

            //Add a random parameter to prevent cache
            var url = new Url(this._currentUrl);
            lang.mixin(url.query, { "epi.preventCache": new Date().valueOf() });

            this.set("url", url.toString());
        },

        cleanup: function () {
            var iFrameWin = this.containerIframe.contentWindow;

            // Break the circular reference: iFrameWin -> EPi -> GetDialog -> this(scope on hitch) -> _legacyDialog -> _dialog === iFrameWin
            iFrameWin.EPi.CreateDialog = null;
            iFrameWin.EPi.GetDialog = null;

            if (this._legacyDialog && !this._legacyDialog.IsCleaned()) {
                this._legacyDialog.Cleanup();
            }
        },

        destroy: function () {
            this.cleanup();

            if (this._iframeFocusRegistration) {
                this._iframeFocusRegistration.remove();
                this._iframeFocusRegistration = null;
            }

            this.inherited(arguments);
        }

    });

});
},
'epi-cms/legacy/_LegacyDialogObject':function(){
﻿define(["dojo/_base/declare", "dojo/_base/kernel"], function (declare, kernel) {

    return declare(null, {
        // summary: Simulate the Dialog object from old UI.
        //
        // tags:
        //    private

        // properties
        _dialog: null,

        // constructor
        constructor: function (params) {
            //TODO: Use dojo.mixin

            this.callbackMethod = params.callbackMethod || null;
            this.callbackArguments = params.callbackArguments || null;
            this.dialogArguments = params.dialogArguments || null;
            this._opener = (params.opener ? params.opener.top : window.top);

            // If another dialog calls code in main window (TinyMCE) we want the _opener reference to be that dialog window.
            while (this._opener.EPiOpenedDialog && this._opener.EPiOpenedDialog._dialog) {
                this._opener = this._opener.EPiOpenedDialog._dialog;
            }
            this._opener.EPiOpenedDialog = this;
        },

        Close: function (returnValue) {
            // summary:
            //    Close the dialog
            //
            // returnValue:
            //    value passed to callback method on return
            //
            // tags:
            //    public

            // When the dialog is closing call the callbackMethod function (if specified) to do whatever it is supposed to with the result of the dialog.
            if (typeof (this.callbackMethod) == "function") {
                (this.callbackMethod).call(this, returnValue, this.callbackArguments);
            }
        },

        ButtonChanged: function (button) {
            // summary:
            //    Notify that there are some button changed
            //
            // button:
            //    The button which changes
            //
            // tags:
            //    public
        },

        Cleanup: function () {
            var message;
            // If we have a _dialog this dialog object has opened a window and we have to clean things up.
            if (this._dialog != null) {
            }

            this._CleanDialog();

            if (this._opener) {
                this._opener.EPiOpenedDialog = null;
            }
            delete this._opener;

            this.callbackMethod = null;
            this.callbackArguments = null;

            delete this.callbackMethod;
            delete this.callbackArguments;

            this._cleaned = true;
        },

        IsCleaned: function () {
            return this._cleaned;
        },

        // Clean up properties of this dialog
        _CleanDialog: function () {
            // summary:
            //    Clean up opened dialog information from global scope.
            //
            // tags:
            //    private

            for (var prop in this) {
                if (prop != "callbackMethod" && prop != "callbackArguments" && prop != "_opener") {
                    this[prop] = null;
                    delete this[prop];
                }
            }
        }
    });

});
},
'epi-cms/widget/CategorySelector':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/promise/all",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/query",

    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Button",
    "dijit/Tooltip",

    "dojox/html/entities",

    "epi-cms/widget/_HasChildDialogMixin",
    "epi-cms/widget/CategorySelectorDialog",
    "epi/shell/widget/_ValueRequiredMixin",
    "epi/dependency",
    "epi/epi",
    "epi/shell/widget/dialog/Dialog",

    "dojo/text!./templates/CategorySelector.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.CategorySelector"
],

function (
    array,
    declare,
    lang,
    all,
    domAttr,
    domClass,
    domConstruct,
    domStyle,
    query,

    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,
    Button,
    Tooltip,

    entities,

    _HasChildDialogMixin,
    CategorySelectorDialog,
    _ValueRequiredMixin,
    dependency,
    epi,
    Dialog,

    template,
res) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _HasChildDialogMixin, _ValueRequiredMixin], {

        templateString: template,

        localization: res,
        //this widget wants a value that is an array
        multiple: true,

        value: null,

        store: null,
        _categories: null,
        _categoriesParentsName: {},

        onChange: function (value) {
            // summary:
            //    Fired when value is changed.
            //
            // value:
            //    The value
            // tags:
            //    public, callback
        },

        postMixInProperties: function () {
            // summary:
            //      Initialize properties
            // tags:
            //      protected

            this.inherited(arguments);

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.category");
            }
        },
        
        destroyDescendants: function () {
            if (this._tooltip) {
                this._tooltip.destroy();
                delete this._tooltip;
            }
            this.inherited(arguments);
        },

        _setValueAttr: function (value) {
            //summary:
            //    Value's setter.
            //
            // value: array of categories.
            //    Value to be set.
            //
            // tags:
            //    protected

            if (!lang.isArray(value)) {
                value = [value];
            }
            var filteredValue = array.filter(value, function (v) { return !!v; });
            this._setValueAndFireOnChange(filteredValue);

            if (filteredValue.length > 0) {
                this._set("value", filteredValue);
            } else {
                this._set("value", null);
            }

            this._started && this.validate();
        },

        _setValueAndFireOnChange: function (value) {
            // Compare arrays
            if (epi.areEqual(this._categories, value)) {
                return;
            }

            this._categories = value;
            this.onChange(this._categories);
            this._updateDisplayNode();
        },

        _getValueAttr: function () {
            //summary:
            //    Value's getter
            // tags:
            //    protected

            return this._categories;
        },

        _setReadOnlyAttr: function (value) {
            this._set("readOnly", value);


            domStyle.set(this.button.domNode, "display", value ? "none" : "");
            domClass.toggle(this.domNode, "dijitReadOnly", value);
        },

        focus: function () {
            this.button.focus();
        },

        _createCategoryButton: function (category) {
            //summary:
            //    create category button.
            //
            // categoryId: category id.

            // categoryName: category name.
            //
            // tags:
            //    private


            //
            // TODO: create a widget for item with a template instead of creating dom nodes
            //

            //don't add a button if it's already added.
            if (query("div[data-epi-category-id=" + category.id + "]", this.categoriesGroupContainer).length !== 0) {
                return;
            }

            var containerDiv = domConstruct.create('div', { 'class': 'dijitReset dijitLeft dijitInputField dijitInputContainer epi-categoryButton' });
            var buttonWrapperDiv = domConstruct.create('div', { 'class': 'dijitInline epi-resourceName' });
            var categoryNameDiv = domConstruct.create('div', { 'class': 'dojoxEllipsis', innerHTML: entities.encode(category.description) });
            domConstruct.place(categoryNameDiv, buttonWrapperDiv);

            domConstruct.place(buttonWrapperDiv, containerDiv);
            // create tooltip for the div
            this._tooltip = new Tooltip({
                connectId: categoryNameDiv,
                label: entities.encode(this._getCategoryPath(category))
            });


            var removeButtonDiv = domConstruct.create('div', { 'class': 'epi-removeButton', innerHTML: '&nbsp;' });
            domAttr.set(removeButtonDiv, 'data-epi-category-id', category.id);
            var eventName = removeButtonDiv.onClick ? 'onClick' : 'onclick';

            if (!this.readOnly) {
                this.connect(removeButtonDiv, eventName, lang.hitch(this, this._onRemoveClick));
                domConstruct.place(removeButtonDiv, buttonWrapperDiv);
            } else {
                domConstruct.place(domConstruct.create("span", { innerHTML: "&nbsp;" }), buttonWrapperDiv);
            }

            domConstruct.place(containerDiv, this.categoriesGroupContainer);
        },

        _getCategoryPath: function (category) {
            //summary:
            //    Return the path to a category excluding root.
            //category: 
            //    the category
            // tags:
            //    private

            if (!category.parentsNameCollection || category.parentsNameCollection.length == 1) {
                return '';
            }

            // The parentsNameCollection contains categories on the path to a category including the root category 
            // and that category node itself (e.g.: [Root,BlogRoot,Javascript]). On the UI, the Root is not shown, 
            // so the path to a category starts from 2nd level of the tree (e.g.: BlogRoot/Javascript).
            var path = category.parentsNameCollection[1];
            for (i = 2; i < category.parentsNameCollection.length; i++) {
                path = path + '/' + category.parentsNameCollection[i];
            }

            return path;
        },

        _createNoCategoriesChosenSpan: function () {
            //summary:
            //    create no categories chosen span.
            //tag:
            //      private

            this.categoriesGroupContainer.innerHTML = '';
            domConstruct.create('span', { innerHTML: this.localization.nocategorieschosen }, this.categoriesGroupContainer);
        },

        _updateDisplayNode: function () {
            //summary:
            //    update category group.
            //
            // tags:
            //    private

            this.categoriesGroupContainer.innerHTML = '';

            if (!this._categories || this._categories.length === 0) {
                this._createNoCategoriesChosenSpan();
                return;
            }

            this._categoriesParentsName = {};

            var dfdList = [];
            this._categories.forEach(function (categoryId) {
                dfdList.push(this.store.refresh(categoryId));
            }, this);


            all(dfdList).then(lang.hitch(this, function (categories) {
                categories.forEach(function (category) {
                    if (category && category.visible) {
                        this._categoriesParentsName[category.id] = category.parentsNameCollection;
                        this._createCategoryButton(category);
                    } else {
                        var categoryIndex = this._categories.indexOf(category.id);
                        if (categoryIndex != -1) {
                            this._categories.splice(categoryIndex, 1);
                        }
                    }

                    // Create no categories chosen span if haven't any category in list.
                    if (this._categories.length === 0) {
                        this._createNoCategoriesChosenSpan();
                    }
                }, this);

            }));
        },

        _onRemoveClick: function (arg) {
            //summary:
            //    handles remove click event.
            //
            // arg: event argument .
            //
            // tags:
            //    private

            if (!this._categories) {
                return;
            }

            var categoryId = parseInt(domAttr.get(arg.target, 'data-epi-category-id'), 10);
            var categoryIndex = this._categories.indexOf(categoryId);
            if (categoryIndex == -1) {
                return;
            }

            var remainingCategories = lang.clone(this._categories);
            remainingCategories.splice(categoryIndex, 1);
            this.set('value', remainingCategories);
        },

        _getCategoriesParentsNameClone: function () {
            //summary:
            //    get a clone of categoriesPath.
            // tags:
            //    private

            var categoriesParentsNameClone = {};
            array.forEach(this._categories, lang.hitch(this, function (categoryId) {
                categoriesParentsNameClone[categoryId] = this._categoriesParentsName[categoryId];
            }));

            return categoriesParentsNameClone;
        },

        _onShow: function () {
            //summary:
            //    Handle onShow dialog event.
            // tags:
            //    private

            // the original categories need to keep to support cancel case, so a clone of categories need to pass to category selector dialog.
            this.categorySelectorDialog.set("value", lang.clone(this._categories));
            this.categorySelectorDialog.set("selectedCategoriesData", this._getCategoriesParentsNameClone());

            this.isShowingChildDialog = true;
            this.categorySelectorDialog.onShow();
        },

        _onExecute: function () {
            //summary:
            //    Handle dialog close
            // tags:
            //    private

            var categoriesSelected = this.categorySelectorDialog.get('value');

            this.set('value', categoriesSelected);
        },

        _isEmptyArray: function (array) {
            // summary:
            //      Validate empty of array
            // tag:
            //      private
            return !array || array.length === 0;
        },

        _onDialogHide: function () {
            //summary:
            //    Handle dialog close
            // tags:
            //    private
            this.focus();
            this.isShowingChildDialog = false;
        },

        _createDialog: function () {
            // summary:
            //		Create page tree dialog
            // tags:
            //    protected

            this.categorySelectorDialog = new CategorySelectorDialog({
                rootCategory: this.root
            });

            this.dialog = new Dialog({
                title: this.localization.popuptitle,
                content: this.categorySelectorDialog,
                dialogClass: "epi-dialog-portrait"
            });

            this.connect(this.dialog, 'onExecute', '_onExecute');
            this.connect(this.dialog, 'onShow', '_onShow');
            this.connect(this.dialog, 'onHide', '_onDialogHide');

            this.dialog.startup();
        },

        _onButtonClick: function () {
            //summary:
            //    Handle add category button click
            // tags:
            //    private

            if (!this.dialog) {
                this._createDialog();
            }

            this.dialog.show(true);
        }
    });
});

},
'epi-cms/widget/CategorySelectorDialog':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",

    "dijit/form/Button",

    "epi",
    "epi/dependency",
    "epi-cms/widget/CategoryTree"
],

function (
    array,
    declare,
    lang,

    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,

    Button,

    epi,
    dependency,
    CategoryTree
) {

    // summary:
    //      Category selector widget.
    //      Used for editing PropertyCategory properties in flyout editor.
    // tags:
    //      public

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin], {

        // templateString: [protected] String
        //      Widget's template string.
        templateString: "<div class=\"epi-categorySelectorDialog\"> \
                            <div data-dojo-attach-point=\"categoryTree\" data-dojo-type=\"epi-cms/widget/CategoryTree\" data-dojo-props=\"rootCategory: ${rootCategory}\"></div> \
                        </div>",

        // selectedCategoriesData: [Object] public
        //      Object that contains necessary selected categories information
        selectedCategoriesData: null,

        // _selectedCategoryIds: [Array] private
        //      Array of selected category identities
        _selectedCategoryIds: null,

        rootCategory: null,

        onShow: function () {
            // summary:
            //      handles onShow dialog event.
            // tags:
            //      public

            if (!this._selectedCategoryIds && !this.categoryTree) {
                return;
            }

            this.categoryTree.set("selectedNodeIds", this._selectedCategoryIds);
            this.categoryTree.set("selectedNodeData", this.selectedCategoriesData);
        },

        _setValueAttr: function (value) {
            // summary:
            //      Value's setter.
            // value: String
            //      Value to be set.
            // tags:
            //      private

            this._selectedCategoryIds = value;

            if (!this._selectedCategoryIds) {
                this._selectedCategoryIds = [];
            }
        },

        _getValueAttr: function () {
            // summary:
            //      Value's getter
            // tags:
            //      private

            return this.categoryTree.get("selectedNodeIds");
        }
    });

});
},
'epi-cms/widget/CategoryTree':function(){
﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dijit/Tree",

    "epi",
    "epi-cms/widget/_CategoryTreeNode",
    "epi-cms/widget/CategoryTreeStoreModel"
],

function (
    array,
    declare,
    lang,

    Tree,

    epi,
    _CategoryTreeNode,
    CategoryTreeStoreModel
) {

    // summary:
    //      The EPiServer Category tree.
    //      The page tree shows the EPiServer Category  page tree using a REST store to fetch the data.
    // tags:
    //      public

    return declare([Tree], {

        // Hide the root node.
        showRoot: false,

        // selectedNodeIds: [Array] public
        //      Array of selected node identies
        selectedNodeIds: null,

        // selectedNodeData: [Object] public
        //      Object that hold all necessary information about selected nodes
        selectedNodeData: null,
        
        constructor: function() {
            this.selectedNodeIds = [];
            this.selectedNodeData = {};
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            if (!this.model) {
                this.model = new CategoryTreeStoreModel({rootCategory: this.rootCategory});
                this.persist = false;
            }
        },

        postCreate: function () {
            this.inherited(arguments);

            this.connect(this, "onOpen", lang.hitch(this, this._onNodeOpen));
            this.connect(this, "onClose", lang.hitch(this, this._onNodeClose));

            this.watch("selectedNodeData", lang.hitch(this, this._loadSelectedNodes));
        },

        startup: function () {
            this.inherited(arguments);

            // Disabling multiselect in tree
            this.dndController.singular = true;
        },

        buildNodeFromTemplate: function (args) {
            // summary:
            //      Build tree node from the given template.
            // args: Object
            //      Tree node creation arguments
            // tags:
            //      extension

            return new _CategoryTreeNode(args);
        },

        getNodeById: function (categoryId) {
            // summary:
            //      get the tree node by category id.
            // categoryId:
            //      the category id.
            // tags:
            //      public

            var nodes = this.getNodesByItem(categoryId.toString());
            if (!nodes) {
                return null;
            }

            return nodes[0];
        },

        _getTotalSelectedNodes: function (/*Object*/parentNode, /*Array*/selectedNodeIds, /*Object*/selectedData) {
            // summary:
            //      Get total selected child nodes under the given collapsed parent node
            // parentNode:
            //      Parent tree node that we want to display total selected child items (contains selected child nodes or not)
            // selectedNodeIds:
            //      Selected child node identities
            // selectedData:
            //      Selected child node data (object that contains selected child node identities and its parent names
            // tags:
            //      private

            if (!parentNode || !parentNode.item || !parentNode.item.hasChildren ||
                !lang.isArray(selectedNodeIds) || selectedNodeIds.length === 0 ||
                !selectedData) {
                return 0;
            }

            var totalItems = 0,
                targetArray = [], compareArray = [],
                parentsNameCollection = lang.clone(parentNode.item.parentsNameCollection);

            var removeSelectedItem = function (targetArray) {
                if (lang.isArray(targetArray) && targetArray.length > 0) {
                    targetArray.pop();
                }
            };

            parentsNameCollection[parentsNameCollection.length - 1] = parentNode.item.name;

            array.forEach(selectedNodeIds, function (selectedNodeId) {

                targetArray = lang.clone(selectedData[selectedNodeId]);
                // Remove selected node from selected path
                removeSelectedItem(targetArray);

                // Ensure we count correct in case the selected nodes that have the same name, but in other levels
                compareArray = lang.clone(targetArray);
                lang.mixin(compareArray, parentsNameCollection);

                if (lang.isArray(targetArray) && epi.areEqual(targetArray, compareArray)) {
                    totalItems++;
                }
            }, this);

            return totalItems;
        },

        _setTotalSelectedNodes: function (/*Tree._TreeNode*/parentNode) {
            // summary:
            //      Set total selected nodes recurisvely
            // tags:
            //      private

            if (parentNode) {
                parentNode.set("totalSelectedNodes", this._getTotalSelectedNodes(parentNode, this.selectedNodeIds, this.selectedNodeData));

                array.forEach(parentNode.getChildren(), function (childNode) {
                    if (childNode && childNode.item && childNode.item.hasChildren) {
                        if (childNode.isExpanded) {
                            this._setTotalSelectedNodes(childNode);
                        } else {
                            childNode.set("totalSelectedNodes", this._getTotalSelectedNodes(childNode, this.selectedNodeIds, this.selectedNodeData));
                        }
                    }
                }, this);
            }
        },

        _loadSelectedNodes: function () {
            // summary:
            //      Set selected nodes when the first time this tree show
            // tags:
            //      private

            this.expandChildrenDeferred.then(lang.hitch(this, function () {
                this.set("toggleSelectNodes", this.rootNode, this.selectedNodeIds);
                this._setTotalSelectedNodes(this.rootNode);
            }));
        },

        _onNodeCreated: function (node) {
            // summary:
            //      onNodeCreated event.
            // node:
            //      the tree node.
            // tags:
            //      private

            node.set("totalSelectedNodes", this._getTotalSelectedNodes(node, this.selectedNodeIds, this.selectedNodeData));
        },

        _onNodeSelectChanged: function (checked, item) {
            // summary:
            //      onNodeSelectChanged event.
            // checked:
            //      true if the check box is checked,otherwise false.
            // item:
            //      the tree node item.
            // tags:
            //      private

            if (!this.getNodeById(item.id)) {
                return;
            }

            var index = this.selectedNodeIds.indexOf(item.id),
                exist = index != -1;

            if (checked && !exist) {
                this.selectedNodeIds.push(item.id);
                this.selectedNodeData[item.id] = item.parentsNameCollection;
            }

            if (!checked && exist) {
                this.selectedNodeIds.splice(index, 1);
                this.selectedNodeData[item.id] = {};
            }
        },

        _onNodeOpen: function (item, node) {
            // summary:
            //      handles node expanded event.
            // treeNode:
            //      the tree node.
            // item:
            //      the tree node item.
            // tags:
            //      private

            this.set("toggleSelectNodes", node, this.selectedNodeIds);
            this._setTotalSelectedNodes(node);
        },

        _onNodeClose: function (item, node) {
            // summary:
            //      handles node closed event.
            // treeNode:
            //      the tree node.
            // item:
            //      the tree node item.
            // tags:
            //      private

            this._setTotalSelectedNodes(node);
        },

        _setToggleSelectNodesAttr: function (/*Object*/parentNode, /*Array*/toggleNodeIds) {
            // summary:
            //      Set selected for the given nodes in tree
            // tags:
            //      private

            if (!parentNode || !lang.isArray(toggleNodeIds)) {
                return;
            }

            var checked = false;
            array.forEach(parentNode.getChildren(), function (childNode) {
                if (childNode) {
                    checked = toggleNodeIds.indexOf(childNode.item.id) != -1;
                    childNode.set("checked", checked);

                    if (childNode.hasChildren()) {
                        this.set("toggleSelectNodes", childNode, toggleNodeIds);
                    }
                }
            }, this);
        },

        _createTreeNode: function (/*Object*/args) {
            // summary:
            //      Overridable function to create tree node.
            // args: Object
            //      Tree node creation arguments
            // tags:
            //      extension

            var node = this.buildNodeFromTemplate(args);
            node.connect(node, "onNodeSelectChanged", lang.hitch(this, function (checked, item) {
                this._onNodeSelectChanged(checked, item);
            }));

            this._onNodeCreated(node);

            return node;
        }
    });

});
},
'epi-cms/widget/_CategoryTreeNode':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/keys",

    "dojo/text!./templates/_CategoryTreeNode.html",
// dijit
    "dijit/_TemplatedMixin",
    "dijit/form/CheckBox",
// epi
    "epi",
    "epi-cms/widget/_ContentTreeNode"
],

function (
// dojo
    declare,
    lang,

    domClass,
    domConstruct,
    keys,

    template,
// dijit
    _TemplatedMixin,
    CheckBox,
// epi
    epi,
    _ContentTreeNode
) {

    // summary:
    //      A customized treenode for page tree
    //      Redefine template string. Use <a> tag to be able to drag in IE
    // tags:
    //      public

    return declare([_ContentTreeNode, _TemplatedMixin], {

        templateString: template,

        _checkbox: null,

        // checked: [Boolean] public
        //      Indicate that the current node is checked or not
        checked: false,

        postCreate: function () {
            // summary:
            //      Place checkbox into the tree node after node created.
            // tags:
            //      protected

            this.inherited(arguments);

            domClass.add(this.iconNode, "dijitHidden");

            this._checkbox = this._createCheckbox();
        },

        _createCheckbox: function () {
            // summary:
            //      Create checkbox for the tree node.
            // tags:
            //      private

            if (!this.item.selectable) {
                return;
            }

            var container = domConstruct.create("span", {
                "class": "epi-checkboxNode dijitTreeExpando"
            });

            var checkbox = new CheckBox({
                name: "checkboxCategory",
                value: this.item.id,
                tabIndex: -1,
                checked: false,
                onChange: lang.hitch(this, function (checked) {
                    this.onNodeSelectChanged(checked, this.item);
                })
            });

            checkbox.placeAt(container);
            domConstruct.place(container, this.expandoNode, "after");

            return checkbox;
        },

        onNodeSelectChanged: function (checked, item) {
            // summary:
            //      on checkbox clicked event.
            // tags:
            //      public callback
        },

        _onLabelClick: function () {
            // summary:
            //      clicking the label toggles the checkbox
            // tags:
            //      private

            if (!this._checkbox) {
                return;
            }

            this.set("checked", !this._checkbox.checked);
        },

        _onLabelKeyUp: function (evt) {
            // summary:
            //      pressing a key on the label toggles the checkbox
            // tags:
            //      private

            if (evt.keyCode == keys.SPACE || evt.keyCode == keys.ENTER) {
                this._onLabelClick();
            }
        },

        _setCheckedAttr: function (checked) {
            // summary:
            //      Check/UnCheck the node.
            // tag:
            //      public

            if (!this._checkbox) {
                return;
            }

            this._set("checked", checked);
            this._checkbox.set("checked", checked);
        },

        _setTotalSelectedNodesAttr: function (/*Int*/totalItems) {
            // summary:
            //      update label of the tree node.
            // totalItems:
            //      Total selected child nodes
            // tag:
            //      public

            var originalLabel = this.tree.model.getLabel(this.item),
                addTotal = !this.isExpanded && totalItems > 0;

            this.labelNode.innerHTML = addTotal ? originalLabel + " (" + totalItems + ")" : originalLabel;
        }
    });

});
},
'url:epi-cms/widget/templates/_CategoryTreeNode.html':"﻿<div class=\"dijitTreeNode epi-categoryTreeNode\" role=\"presentation\">\r\n    <a href=\"#\" tabIndex=\"-1\" data-dojo-attach-point=\"rowNode\" class=\"dijitTreeRow\" role=\"presentation\">\r\n        <div data-dojo-attach-point=\"indentNode\" class=\"dijitInline\"></div>\r\n        <span data-dojo-attach-point=\"contentNode\" class=\"dijitTreeContent\" role=\"presentation\">\r\n            <span data-dojo-attach-point=\"expandoNode\" class=\"dijitTreeExpando\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"expandoNodeText\" class=\"dijitExpandoText\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"iconNode\" class=\"dijitIcon dijitTreeIcon\" role=\"presentation\"></span>\r\n            <span data-dojo-attach-point=\"labelNode\" class=\"dijitTreeLabel epi-categoryTreeLabel\" role=\"treeitem\"\r\n                  tabindex=\"-1\" aria-selected=\"false\" data-dojo-attach-event=\"onclick:_onLabelClick, keyup:_onLabelKeyUp\">\r\n            </span>\r\n        </span>\r\n    </a>\r\n    <div data-dojo-attach-point=\"containerNode\" class=\"dijitTreeContainer\" role=\"presentation\" style=\"display: none;\"></div>\r\n</div>",
'epi-cms/widget/CategoryTreeStoreModel':function(){
﻿define([
    "dojo",
    "epi/dependency",
    "epi/routes"
], function (dojo, dependency, routes) {

    // module:
    //      epi-cms/widget/CategoryTreeStoreModel

    return dojo.declare( null, {
        // summary:
        //      store model for category tree.

        // store: [protected] dojo.store.api.Store
        //      Underlying store that will be queried for category tree items.
        store: null,

        // rootCategory: [protected]
        //      Store root category id.
        rootCategory: undefined,

        constructor: function (args) {

            dojo.mixin(this, args);

            if (!this.store) {
                var registry = dependency.resolve("epi.storeregistry");
                this.store = registry.get("epi.cms.category");
            }
        },

        // =======================================================================
        // Methods for traversing hierarchy

        getRoot: function (onItem) {
            // summary:
            //      Calls onItem with the root item for the tree, possibly a fabricated item.

            dojo.when(this.store.get(this.rootCategory), onItem);
        },

        mayHaveChildren: function (item) {
            // summary:
            //      Tells if an item has or may have children.  Implementing logic here
            //      avoids showing +/- expando icon for nodes that we know don't have children.
            //      (For efficiency reasons we may not want to check if an element actually
            //      has children until user clicks the expando node)

            return item.hasChildren;
        },

        getChildren: function (parentItem, onComplete) {
            // summary:
            //      Calls onComplete() with array of child items of given parent item, all loaded.

            var id = this.getIdentity(parentItem),
                results = this.store.query({ id: id, query: "getchildren" });

            results.then(function (children) {
                parentItem.children = children;
                onComplete(children);
            });
        },

        // =======================================================================
        // Inspecting items

        getIdentity: function (item) {
            // summary:
            //      Returns identity for an item

            return this.store.getIdentity(item);
        },

        getLabel: function (item) {
            // summary:
            //      Get the label for an item

            return item.description;
        }
    });
});
},
'url:epi-cms/widget/templates/CategorySelector.html':"﻿<div class=\"dijitReset dijitInputField dijitInputContainer dijitInline epi-resourceInputContainer epi-categorySelector\" id=\"widget_${id}\">\r\n    <div data-dojo-attach-point=\"categoriesGroupContainer\" class=\"dijit dijitReset dijitInline dijitInlineTable dijitLeft dijitTextBox displayNode epi-categoriesGroup\">\r\n    </div> \r\n    <div data-dojo-type=\"dijit/form/Button\" data-dojo-attach-event=\"onClick: _onButtonClick\" data-dojo-attach-point=\"button\" class=\"epi-categoriesSelectorButton\" data-dojo-props=\"label:'+'\"></div>\r\n</div>",
'epi-cms/widget/ContentSelector':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/Deferred",
    "dojo/dom-class",
    "dojo/dom-style",

    "dojo/NodeList-manipulate",
    "dojo/query",
    "dojo/string",
    "dojo/when",

// dijit,
    "dijit/_CssStateMixin",
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",

    "dijit/focus",
    "dijit/form/Button",

// epi.shell
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/widget/_ValueRequiredMixin",
    "epi/shell/widget/dialog/Dialog",

// epi.cms
    "epi-cms/core/ContentReference",
    "epi-cms/core/PermanentLinkHelper",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/widget/_Droppable",
    "epi-cms/widget/_HasClearButton",
    "epi-cms/widget/_HasChildDialogMixin",
    "epi-cms/widget/ContentSelectorDialog",

// resources
    "dojo/text!./templates/ContentSelector.html",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.contentselector"
],

function (
// dojo
    array,
    declare,
    lang,

    Deferred,
    domClass,
    domStyle,

    NodeListManipulate,
    query,
    stringUtil,
    when,

// dijit
    _CssStateMixin,
    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,

    focusManager,
    Button,

// epi.shell
    dependency,
    TypeDescriptorManager,
    _ValueRequiredMixin,
    Dialog,

// epi.cms
    ContentReference,
    PermanentLinkHelper,
    ContentActionSupport,
    _Droppable,
    _HasClearButton,
    _HasChildDialogMixin,
    ContentSelectorDialog,

// resources
    template,
    localization
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _CssStateMixin, _HasClearButton, _HasChildDialogMixin, _Droppable, _ValueRequiredMixin], {

        templateString: template,

        roots: null,

        value: null,

        // required: Boolean
        //		User is required to enter data into this field.
        required: false,

        // missingMessage: [public] String
        //    Message which is displayed when required is true and value is empty.
        missingMessage: localization.requiredmessage,

        // tooltipPosition: String[]
        //		See description of `dijit.Tooltip.defaultPosition` for details on this parameter.
        tooltipPosition: [],

        // contentLink: [pubic] String
        //      Content reference of the content being edited.
        contentLink: null,

        permanentLink: null,

        // canSelectOwnerContent: [public] Boolean
        //      Indicates whether the owner content that is being edited can be selected
        canSelectOwnerContent: false,

        // accessLevel: [public] Enum
        //      The access right level for the content node can be selected
        accessLevel: ContentActionSupport.accessLevel.Read,

        // showAllLanguages: Boolean
        //      Flags to indicate that the content tree should show all content in multiple languages or not.
        showAllLanguages: true,

        _setSelectedContentNameAttr: function (value) {
            query(this.selectedContentNameNode).text(value);
        },

        _setDisabledAttr: function (value) {
            this.inherited(arguments);
            this.button.set("disabled", value);
            this._set("disabled", value);
        },

        _setSelectedContentLinkAttr: { node: "selectedContentLinkNode", type: "innerHTML" },

        postMixInProperties: function () {
            // summary:
            //		Initialize properties
            // tags:
            //    protected

            this.inherited(arguments);

            var registry = dependency.resolve("epi.storeregistry");
            this._store = registry.get("epi.cms.content.light");

            if (!this.roots) {
                var contentRepositoryDescriptors = this.contentRepositoryDescriptors || dependency.resolve("epi.cms.contentRepositoryDescriptors");
                var settings = contentRepositoryDescriptors[this.repositoryKey];
                this.roots = settings.roots;
            }

            //Create the name attribute for the hidden input if provided
            this.nameAttrSetting = this.name ? ('name="' + this.name.replace(/"/g, "&quot;") + '"') : '';
        },

        postCreate: function () {
            // summary:
            //      Overridden to initialize ui elements when no value is set.

            this.inherited(arguments);

            if (!this.value) {
                this._updateDisplayNode(null);
            }
        },

        _setReadOnlyAttr: function (value) {
            this._set("readOnly", value);

            domStyle.set(this.button.domNode, "display", value ? "none" : "");
            domStyle.set(this.clearButton, "display", value ? "none" : "");
            domClass.toggle(this.domNode, "dijitReadOnly", value);
        },

        _setValueAttr: function (value) {
            //summary:
            //    Value's setter.
            //
            // value: String
            //    Value to be set.
            //
            // tags:
            //    protected

            this._setValueAndFireOnChange(value);
        },

        _getDialog: function () {
            // summary:
            //		Create page tree dialog
            // tags:
            //    protected

            // Verifies that the dialog instance and its dom node existings or not
            if (this.dialog && this.dialog.domNode) {
                return this.dialog;
            }

            var title = localization.title;
            if (this.allowedTypes && this.allowedTypes.length === 1) {
                var name = TypeDescriptorManager.getResourceValue(this.allowedTypes[0], "name");
                if (name) {
                    title = stringUtil.substitute(localization.format, [name]);
                }
            }

            this.contentSelectorDialog = new ContentSelectorDialog({
                canSelectOwnerContent: this.canSelectOwnerContent,
                showButtons: false,
                roots: this.roots,
                allowedTypes: this.allowedTypes,
                showAllLanguages: this.showAllLanguages
            });

            this.dialog = new Dialog({
                title: title,
                dialogClass: "epi-dialog-portrait",
                content: this.contentSelectorDialog,
                destroyOnHide: true
            });

            this.connect(this.contentSelectorDialog, "onChange", "_setDialogButtonState");
            this.connect(this.dialog, 'onExecute', '_onDialogExecute');
            this.connect(this.dialog, 'onHide', '_onDialogHide');

            return this.dialog;
        },

        _isContentAllowed: function (contentTypeIdentifier) {
            // Summary:
            //    Checks whether the given content type belongs to the any of the allowedTypes/parent type or not
            //
            // contentTypeIdentifier: String
            //    The content type identifier
            //
            // tags:
            //    Private

            var allowed = array.indexOf(this.allowedTypes, contentTypeIdentifier) !== -1;

            if (!allowed) {
                //If it's not a direct match, check if the type inherits an accepted type.
                allowed = array.some(this.allowedTypes, function (type) {
                    return TypeDescriptorManager.isBaseTypeIdentifier(contentTypeIdentifier, type);
                });
            }

            return allowed;
        },

        _onButtonClick: function () {
            // Summary:
            //    Handle pick button click
            // tags:
            //    private

            when(this._getContentData(this.contentLink), lang.hitch(this, function (content) {

                // if the current content is any of allowedTypes then allow to select it
                this.canSelectOwnerContent = content && this._isContentAllowed(content.typeIdentifier);
                var dialog = this._getDialog();
                this.isShowingChildDialog = true;

                var valueAsContentReference;
                if (this.value) {
                    valueAsContentReference = this._convertValueToContentReference(this.value);
                }

                if (valueAsContentReference) {
                    valueAsContentReference = valueAsContentReference.createVersionUnspecificReference().toString();
                }

                this.contentSelectorDialog.set("value", valueAsContentReference);
                dialog.show();
            }));
        },

        _onDialogExecute: function () {
            //summary:
            //    Handle dialog close
            // tags:
            //    private

            var value = this.contentSelectorDialog.get('value');
            this._setValueAndFireOnChange(value);
        },

        _convertValueToContentReference: function (value) {
            //summary:
            //
            // tags:
            //    private
            return new ContentReference(value);
        },

        _onDialogHide: function () {
            this.isShowingChildDialog = false;
        },

        _setValueAndFireOnChange: function (value) {
            //summary:
            //    Gets the content data by selected value, updates the view and calls onChange if value was changed
            // tags:
            //    private

            var contentLink = value === '-' ? this.contentLink : value;

            this.set("permanentLink", null);

            when(this._getContentData(contentLink), lang.hitch(this, function (content) {

                var hasChange = this.value !== contentLink;

                this.value = contentLink;
                this.input.value = this.value;
                this._started && this.validate();
                this._updateDisplayNode(content);

                if (hasChange) {
                    this.onChange(contentLink);
                }

                if (content) {
                    this.set("permanentLink", PermanentLinkHelper.toPermanentLink(content));
                }
            }));
        },

        _getContentData: function (contentLink) {
            //summary:
            //    Loads the content data from the store
            // tags:
            //    private

            if (!contentLink) {
                return null;
            }
            return this._store.get(contentLink);
        },

        _getValueAttr: function () {
            //summary:
            //    Value's getter
            // tags:
            //    protected

            return this.value;
        },

        _onFocus: function () {
            // summary:
            //		This is where widgets do processing for when they start being active,
            //		such as changing CSS classes.  See onFocus() for more details.
            // tags:
            //		protected

            if (this.get("disabled")) {
                return;
            }
            this.inherited(arguments);
            this.validate();
        },


        _onBlur: function () {
            // summary:
            //		This is where widgets do processing for when they stop being active,
            //		such as changing CSS classes.  See onBlur() for more details.
            // tags:
            //		protected

            if (this.get("disabled")) {
                return;
            }
            this.inherited(arguments);
            this.validate();
        },

        focus: function () {
            // summary:
            //       Put focus on this widget
            // tags:
            //      public

            if (!this.button.disabled && this.button.focusNode && this.button.focusNode.focus) {
                try {
                    focusManager.focus(this.button.focusNode);
                } catch (e) {
                    /*squelch errors from hidden nodes*/
                }
            }
        },

        onChange: function (value) {
            // summary:
            //    Fired when value is changed.
            //
            // value:
            //    The value
            // tags:
            //    public, callback
        },

        _updateDisplayNode: function (content) {
            //summary:
            //    Update widget's display text
            // tags:
            //    protected

            if (content) {
                domClass.remove(this.domNode, 'epi-noValue');
                domClass.remove(this.resourceName, 'dijitPlaceHolder');

                this.set("selectedContentName", content.name);
                this.set("selectedContentLink", new ContentReference(content.contentLink).id);
            }
            else {
                domClass.add(this.domNode, 'epi-noValue');
                domClass.add(this.resourceName, 'dijitPlaceHolder');

                this.set("selectedContentName", localization.helptext);
                this.set("selectedContentLink", "");
            }
        },

        reset: function () {
            this.set("value", null);
        },

        _setDialogButtonState: function (contentLink) {
            // summary:
            //    Set state of dialog button.
            //
            // tags:
            //    protected

            var self = this;

            if (!contentLink) {
                return;
            }

            when(self._store.get(contentLink), function (content) {
                self.dialog.definitionConsumer.setItemProperty(self.dialog._okButtonName, "disabled", !ContentActionSupport.hasAccess(content.accessMask, self.accessLevel));
            });
        }
    });
});
},
'epi-cms/widget/_Droppable':function(){
﻿define([
"dojo/_base/declare",
"dojo/_base/lang",
"dojo/when",
"epi/shell/dnd/Target"],
function (declare, lang, when, Target) {
    return declare(null, {
        // summary:
        //    Mixin for widgets that are droppable.
        // tags:
        //    public

        // dropAreaNode: [protected] DomNode
        //      The dom node where user can drop
        dropAreaNode: null,

        // allowedDndTypes: [protected] Array
        //      List of data types that this widget can handle
        allowedDndTypes: null,

        postCreate: function () {
            // summary:
            //		Initialize child widgets
            // tags:
            //    protected

            this.inherited(arguments);

            //create drop target
            var dropTarget = this.own(new Target(this.dropAreaNode, {
                accept: this.allowedDndTypes,
                createItemOnDrop: false,
                readOnly: this.readOnly,
                skipForm: true
            }))[0];

            this.connect(dropTarget, "onDropData", "_onDropData");
        },

        onDropping: function () {
            // summary:
            //    Triggered when something is dropping onto the widget.
            //
            // tags:
            //    public callback
        },

        onDrop: function () {
            // summary:
            //    Triggered when something has been dropped onto the widget.
            //
            // tags:
            //    public callback
        },

        _onDropData: function (dndData, source, nodes, copy) {
            //summary:
            //    Handle drop data event.
            //
            // dndData:
            //    Dnd data extracted from the dragging items which have the same data type to the current target
            //
            // source:
            //    The dnd source.
            //
            // nodes:
            //    The dragging nodes.
            //
            // copy:
            //    Denote that the drag is copy.
            //
            // tags:
            //    private

            var dropItem = dndData ? (dndData.length ? dndData[0] : dndData) : null;

            if (dropItem) {
                this.onDropping();

                when(dropItem.data, lang.hitch(this, function (resolvedValue) {
                    var value;
                    if (this.dndSourcePropertyName) {
                        value = resolvedValue[this.dndSourcePropertyName];
                    }
                    else {
                        value = resolvedValue;
                    }
                    this.set("value", value);
                    this.onDrop();
                }));
            }
        }
    });
});
},
'epi-cms/widget/_HasClearButton':function(){
﻿define([
"epi",
"dojo",
"dijit"],
function (epi, dojo, dijit) {
    return dojo.declare(null, {
        // summary:
        //    Mixin for widgets that need child dialog ability.
        // tags:
        //    public

        postCreate: function () {
            // summary:
            //		Initialize child widgets
            // tags:
            //    protected

            this.inherited(arguments);

            var eventName = this.clearButton.onClick ? 'onClick' : 'onclick';

            dojo.connect(this.clearButton, eventName, dojo.hitch(this, this.clearValue));
        },

        clearValue: function () {
            // summary:
            //		Do clear value
            // tags:
            //    protected
            if (this.readOnly) {
                return;
            }
            var value = this.getEmptyValue();
            this.set('value', value);
        },

        getEmptyValue: function () {
            // summary:
            //		Gets widget's empty value.
            // description:
            //      Returns null by default. Override this method to change widget's empty value.
            // tags:
            //    protected

            return null;
        }
    });
});
},
'url:epi-cms/widget/templates/ContentSelector.html':"﻿<div class=\"dijitReset dijitInputField dijitInputContainer dijitInline epi-resourceInputContainer\" id=\"widget_${id}\">\r\n    <div data-dojo-attach-point=\"displayNode, dropAreaNode, stateNode\" class=\"dijit dijitReset dijitInline dijitInlineTable dijitLeft dijitTextBox displayNode\">\r\n        <div class=\"dijitReset dijitLeft dijitInputField dijitInputContainer\">\r\n            <div data-dojo-attach-point=\"clearButton\" class=\"epi-clearButton\">&nbsp;</div>\r\n            <div data-dojo-attach-point=\"resourceName\" class=\"dijitInline epi-resourceName dojoxEllipsis\"/>\r\n                <span data-dojo-attach-point=\"selectedContentNameNode\"></span> <span data-dojo-attach-point=\"selectedContentLinkNode\"></span>\r\n            </div>\r\n        </div>\r\n    </div>\r\n    <input type=\"hidden\" ${!nameAttrSetting} value=\"${value}\" data-dojo-attach-point=\"input\"/>\r\n    <div data-dojo-type=\"dijit/form/Button\" data-dojo-attach-event=\"onClick: _onButtonClick\" data-dojo-attach-point=\"button\" data-dojo-props=\"label:'...'\"></div>\r\n</div>",
'epi-cms/widget/HyperLinkSelector':function(){
﻿define([
//dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/Deferred",

    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/when",
    "dojo/DeferredList",
//dijit
    "dijit/_Widget",
//epi
    "epi/string",
    "epi/shell/widget/_ModelBindingMixin",
    "epi-cms/widget/_HyperLinkFieldItem",
    "epi-cms/widget/viewmodel/HyperLinkSelectorViewModel"
],
function (
//dojo
    array,
    declare,
    lang,
    Deferred,

    domStyle,
    domConstruct,
    when,
    DeferredList,
//dijit
    _Widget,
//epi
    epiString,
    _ModelBindingMixin,
    _HyperLinkFieldItem,
    HyperLinkSelectorViewModel
    ) {
    return declare([_Widget, _ModelBindingMixin], {
        // module:
        //		epi-cms/widget/HyperLinkSelector
        // summary:
        //    Represents the selector for all hyper link, for example: page, media, 3rd party providers.
        // tags:
        //    public

        value: null,

        _dfCreateWidget: null,

        modelClassName: HyperLinkSelectorViewModel,

        modelBindingMap: {
            "wrapperSettings": ["wrapperSettings"],
            "selectedWrapper": ["selectedWrapper"]
        },

        postMixInProperties: function () {
            this.inherited(arguments);

            if (!this.model && this.modelClassName) {
                var modelClass = declare(this.modelClassName);
                this.model = new modelClass({ providers: this.providers });
            }
        },

        _setSelectedWrapperAttr: function (target) {
            // summary:
            //    Disabled all wrappers, enabled selected.
            // tags:
            //    private
            if (!target) {
                return;
            }

            array.forEach(this.wrappers, function (wrapper) {
                wrapper.set("selected", false);
                if (wrapper.inputWidget) {
                    wrapper.inputWidget.set("state", "");
                }
            });

            if (target.inputWidget) {
                target.set("selected", true); // mark this widget as selected/enabled
            }
        },

        _setWrapperSettingsAttr: function (settings) {
            var wrappers = [];
            array.forEach(settings, lang.hitch(this, function (setting) {
                setting.groupname += this.id;
                var wrapper = new _HyperLinkFieldItem(setting);

                if (setting.invisible) {
                    domStyle.set(wrapper.domNode, { display: "none" });
                }

                wrapper.on("radioButtonChange", lang.hitch(this, function () {
                    this.set("selectedWrapper", wrapper);
                    wrapper.focus();
                }));
                wrappers.push(wrapper);
            }));

            this.set("wrappers", wrappers);
        },

        _setWrappersAttr: function (wrappers) {
            this._set("wrappers", wrappers);

            // Reset deferred list
            if (this._dfCreateWidget) {
                this._dfCreateWidget.cancel();
                this._dfCreateWidget = null;
            }

            var deferredList = [],
                addChild = lang.hitch(this, function (ctor, wrapper) {
                var child = new ctor(wrapper.settings);
                wrapper.addChild(child);
                // set required after creating wrapper's child.
                wrapper.set("required", this.required);
            });

            array.forEach(wrappers, function (wrapper) {
                var df = new Deferred();
                deferredList.push(df);

                var ctor = lang.getObject(wrapper.widgetType);
                if (!ctor) {
                    require([epiString.slashName(wrapper.widgetType)], function (ctor) {
                        addChild(ctor, wrapper);
                        df.resolve();
                    });
                } else {
                    addChild(ctor, wrapper);
                    df.resolve();
                }
            });

            this._dfCreateWidget = new DeferredList(deferredList);

            when(this._dfCreateWidget, lang.hitch(this, function (results) {
                array.forEach(wrappers, function (wrapper) {
                    domConstruct.place(wrapper.domNode, this.domNode);
                }, this);

                this.onSelectorsCreated(this);

                if (this.value) { // make sure the created widget has value
                    this._setValueForWidgets(this.value);
                } else if (this.wrappers && this.wrappers.length > 0) {
                    // if hasn't value then set the first wrapper as default selected
                    this.wrappers[0].set("selected", true);
                }
            }));
        },

        onSelectorsCreated: function (widget) {
            // summary:
            //    Raise when finish constructing hyperlinkSelector.
            // tags:
            //    public
        },

        _getSelectedWrapper: function () {
            // summary:
            //    Get selected widget.
            // tags:
            //    private
            return array.filter(this.wrappers, function (wrapper) {
                return (wrapper.inputWidget && wrapper.get("selected"));
            })[0];
        },

        _getValueAttr: function () {
            // summary:
            //    Get selected href.
            // tags:
            //    private
            var selectedWrapper = this._getSelectedWrapper();
            if (selectedWrapper) {
                if (selectedWrapper.inputWidget && selectedWrapper.settings.isContentLink) {
                    this.value = selectedWrapper.inputWidget.get("permanentLink");
                } else
                    this.value = selectedWrapper.get("value");
            }
            return this.value;
        },

        _setValueAttr: function (value) {
            // summary:
            //    Set selected href.
            // tags:
            //    private
            this._set("value", value);
            this._setValueForWidgets(value);
        },

        _setValueForWidgets: function (value) {
            // Reset wrappers value to default
            array.forEach(this.wrappers, function (wrapper) {
                wrapper.set("value", null);
            });

            if (!value) {
                return;
            }

            when(this.model.getContentData(value), lang.hitch(this, function (content) {
                if (content) { // dynamic link (pages, media, products)
                    array.every(this.wrappers, function (wrapper) {
                        if (wrapper && wrapper.settings.isContentLink) {
                            if (array.some(wrapper.settings.allowedTypes, lang.hitch(this, function (baseType) {
                                return this.model.isBaseTypeIdentifier(content.typeIdentifier, baseType);
                            }))) {
                                wrapper.set("value", content.contentLink);

                                var showAllLanguages = content.missingLanguageBranch && content.missingLanguageBranch.isTranslationNeeded;
                                wrapper.set("showAllLanguages", showAllLanguages);

                                this.set("selectedWrapper", wrapper);
                                return false; // break the loop
                            }
                        }
                        return true; // continue the loop
                    }, this);
                } else { // static link (email, external links)
                    array.every(this.wrappers, function (wrapper) {
                        if (wrapper && !wrapper.settings.isContentLink) {
                            var widget = wrapper.inputWidget;
                            if (widget && widget.validator(value, widget.constraints)) {
                                wrapper.set("value", value);
                                this.set("selectedWrapper", wrapper);
                                return false; // break the loop
                            }
                        }
                        return true; // continue the loop
                    }, this);
                }
            }));
        },

        validate: function () {
            // summary:
            //    Validation value of Href.
            // tags:
            //    public
            var selectedWrapper = this._getSelectedWrapper();
            return selectedWrapper ? selectedWrapper.validate() : false;
        },

        focus: function () {
            // summary:
            //    TODOC
            // tags:
            //    public
            var selectedWrapper = this._getSelectedWrapper();

            if (selectedWrapper) {
                selectedWrapper.focus();
            }
        },

        reset: function () {
            this.set("value", null);
        }
    });
});

},
'epi-cms/widget/_HyperLinkFieldItem':function(){
﻿define([
//dojo
    "dojo/_base/declare",
//dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_Container",
    "dijit/_Contained",
//resources
    "dojo/text!./templates/_HyperLinkFieldItem.html"
],
function (
//dojo
    declare,
//dijit
    _Widget,
    _TemplatedMixin,
    _Container,
    _Contained,
//resources
    template
    ) {
    return declare([_Widget, _Container, _Contained, _TemplatedMixin], {
        templateString: template,

        // Represents widget to input link value
        inputWidget: null,

        // Settings for child widget
        settings: [],

        _onRadioButtonChange: function (evt) {
            this.onRadioButtonChange(this, evt);
        },

        onRadioButtonChange: function (target, evt) {
            // trigger radio button change value event
        },

        addChild: function (child) {
            this.inputWidget = child;

            this.inherited(arguments);
        },

        validate: function () {
            return this.inputWidget ? this.inputWidget.validate() : false;
        },

        _setValueAttr: function (value) {
            if (this.inputWidget) {
                this.inputWidget.set("value", value);
            }
        },

        _getValueAttr: function () {
            return this.inputWidget.get("value");
        },

        _setRequiredAttr: function (val) {
            if (this.inputWidget) {
                this.inputWidget.set("required", val);
            }
        },

        _setSelectedAttr: function (value) {
            if (this.inputWidget) {
                this.inputWidget.set("disabled", !value);
                this.radioNode.checked = value;
            }
        },

        _getSelectedAttr: function () {
            return this.radioNode.checked;
        },

        _setShowAllLanguagesAttr: function (val) {
            if (this.inputWidget) {
                this.inputWidget.set("showAllLanguages", val);
            }
        },

        focus: function () {
            if (this.inputWidget) {
                this.inputWidget.focus();
            }
        }
    });
});
},
'url:epi-cms/widget/templates/_HyperLinkFieldItem.html':"﻿<div class='epi-formsRow epi-hyperLink'>\r\n    <input type='radio' name='${groupname}' id='${id}_${name}' value='${name}' data-dojo-type='dijit.form.RadioButton' data-dojo-attach-event='onchange:_onRadioButtonChange' data-dojo-attach-point='radioNode'/>\r\n    <label for='${id}_${name}'>${displayName}</label>\r\n    <div class='epi-formsWidgetWrapper' data-dojo-attach-point='containerNode'></div>\r\n</div>",
'epi-cms/widget/viewmodel/HyperLinkSelectorViewModel':function(){
﻿define([
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    "dojo/io-query",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/when",
//epi
    "epi/string",
    "epi/shell/TypeDescriptorManager",
    "epi/shell/_StatefulGetterSetterMixin",
    "epi-cms/core/PermanentLinkHelper"

], function (
// dojo
    array,
    declare,
    lang,
    Stateful,
    ioQuery,
    domStyle,
    domConstruct,
    when,
//epi
    epiString,
    TypeDescriptorManager,
    _StatefulGetterSetterMixin,
    PermanentLinkHelper

) {
    // module:
    //		epi-cms/widget/viewmodel/HyperLinkSelectorViewModel

    return declare([Stateful, _StatefulGetterSetterMixin], {
        // summary:
        //		Represents the view model for HyperLinkSelector widget.

        _setProvidersAttr: function (providers) {
            var wrapperSettings = [];

            array.forEach(providers, lang.hitch(this, function (provider) {
                wrapperSettings.push({
                    name: provider.name,
                    displayName: provider.displayName ? provider.displayName : provider.name,
                    title: provider.title ? provider.title : "",
                    groupname: "hyperLink_",
                    widgetType: provider.widgetType,
                    invisible: provider.invisible,
                    settings: {
                        roots: provider.roots,
                        allowedTypes: provider.linkableTypes,
                        isContentLink: (provider.linkableTypes && provider.linkableTypes.length > 0),
                        allowedDndTypes: [],
                        disabled: true, // Disable all link input as default
                        value: null
                    }
                });
            }));

            this.set("wrapperSettings", wrapperSettings);
        },

        getContentData: function (value) {
            if (value) {
                return PermanentLinkHelper.getContent(value, { "allLanguages": true });
            }

            return null;
        },

        isBaseTypeIdentifier: function (type, base) {
            return TypeDescriptorManager.isBaseTypeIdentifier(type, base);
        }
    });
});
},
'epi-cms/widget/overlay/ContentArea':function(){
﻿define([
    // Dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/Deferred",
    "dojo/dnd/Manager",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/json",
    "dojo/on",
    "dojo/query",
    "dojo/when",

    // Dijit
    "dijit/_Container",
    "dijit/registry",

    // EPi Framework
    "epi/dependency",
    "epi/shell/widget/overlay/Item",
    "epi/shell/dnd/Source",
    "epi/shell/dnd/_MarkerSource",

    // EPi CMS
    "epi-cms/widget/overlay/Block",
    "epi-cms/contentediting/editors/ContentBlockEditor",
    "epi-cms/widget/command/CreateContentFromSelector",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/contentediting/viewmodel/ContentAreaViewModel",
    "epi-cms/contentediting/viewmodel/ContentBlockViewModel",
    "epi-cms/contentediting/editors/_TextWithActionLinksMixin",

    // Resources
    "dojo/text!../templates/ContentArea.html"
], function(
    // Dojo
    array,
    declare,
    lang,
    aspect,
    Deferred,
    dndManager,
    domAttr,
    domConstruct,
    domGeometry,
    domStyle,
    json,
    on,
    query,
    when,

    // Dijit
    _Container,
    registry,

    // EPi Framework
    dependency,
    Item,
    Source,
    _MarkerSource,

    // EPi CMS
    Block,
    ContentBlockEditor,
    CreateContentFromSelector,
    ContentActionSupport,
    ContentAreaViewModel,
    ContentBlockViewModel,
    _TextWithActionLinksMixin,

    // Resources
    template
) {

    return declare([Item, _Container, _TextWithActionLinksMixin], {

        // templateString: [protected] String
        //      A string that represents the widget template.
        templateString: template,

        // layout: [public] String
        //      Used to indicate in which direction drag and drop should function; vertical or horizontal.
        layout: "",

        // defaultWatchKey: [public] String
        //      Used to kind of default handler when children change for all area.
        defaultWatchKey: "",

        allowedDndTypes: null,

        // blockClass: [public] Class
        //      Used to inject block overlay class.
        blockClass: Block,

        // modelClass: [public] Class
        //      Used to inject model for this.
        modelClass: ContentAreaViewModel,
        
        dndSourceClass: declare([Source, _MarkerSource]),

        // dndSourceSettings: [public] Json object
        //      Used to inject settings for dnd source.
        dndSourceSettings: null,
        
        _supressValueChanged: false,
        
        constructor: function() {
            this._watches = {};
        },

        postMixInProperties: function() {
            // summary:
            //      Create the view model if it doesn't exist and update the view model with the current value of this property.
            // tags:
            //      protected
            this.inherited(arguments);

            if(!this.model) {
                this.model = new this.modelClass();
            }

            // Must copy the values, otherwise updates are done to the values inside the content model, 
            // circumventing the undo function. 
            // Shouldn't be done here, but since we only have the content model there's really no other solution.
            this.model.set("value", lang.clone(this.contentModel.get(this.name)));

            // Since we're copying the values we must also listen to changes, since we no longer have 
            // references to the backing data.
            this.contentModel.watch(this.name, lang.hitch(this, function (name, oldValue, value) {
                if (epi.areEqual(value, this.model.get("value")))
                {
                    return;
                }
                this.refresh();
            }));

            this._pendingPersonalizations = [];

            this._contentStore = this._contentStore || dependency.resolve("epi.storeregistry").get("epi.cms.contentdata");

            this._ownerContentLink = this.contentModel.get("icontent_contentlink");
        },

        buildRendering: function() {
            this.inherited(arguments);

            this.setupActionLinks(this.actionsNodeControls);
        },

        postCreate: function() {
            // summary:
            //      Configure the drag and drop direction and synchronize the visible content blocks with the view model.
            // tags:
            //      protected
            this.inherited(arguments);

            this.own(on(this.model, "changed", lang.hitch(this, function () {

                if (!this._started || this._supressValueChanged) {
                    return;
                }

                this._onChildrenChanged();

                if (this._pendingPersonalizations.length > 0) { 
                    this._pendingPersonalizations = [];

                    // TODO: refactor this, trigger an activate/select event or watch to force a start edit
                    this.onClick(this);
                }
            })));

            this._setupDirectionality();

            this._setupBlocks();
        },

        destroy: function() {

            this.inherited(arguments);

            // Destroy all the current blocks and reset the map.
            for (var i in this._watches) {
                this._watches[i].remove();
            }
            this._watches = {};

            this._source.destroy();

            if (this.textWithLinks) {
                this.textWithLinks.destroy();
                this.textWithLinks = null;
            }
        },


        isCreateLinkVisible: function() {
            // summary:
            //      Overridden to hide the "create block" link when user doesn't have permission to create new blocks in the local assets folder.

            //TODO: Move to the model, duplicated in ContentAreaEditor. Don't dare changing at this point in time

            var promise = new Deferred();
            when(this._contentStore.get(this._ownerContentLink), function(contentData) {
                var canCreate = ContentActionSupport.isActionAvailable(contentData, ContentActionSupport.action.Create, ContentActionSupport.providerCapabilities.Create, true);
                promise.resolve(canCreate);
            });
            return promise.promise;
        },

        _setHasChildrenAttr: function(value) {
            this._set("hasChildren", value);
        },

        _getMinHeightAttr: function() {
            return domStyle.get(this.sourceItemNode, "minHeight");
        },

        onValueChange: function(values) {
            // summary:
            //      Event to notify that this and possibly other properties
            //      has changed their values
            // values: Object || [Object]
            //      The property values that has changed. {propertyName: "propertyName", value: value}
            // tags:
            //      public callback
        },

        updatePosition: function(position) {
            // summary:
            //      Override of the base implementation to include positioning
            //      of the blocks
            //
            // position: Object
            //      the coordinates to set the position to

            if(!this.canUpdatePosition()) {
                return false;
            }

            // first size this to match source node
            var result = this.inherited(arguments),
                currentActionNodeHeight,
                actionNodeHeight,
                originalMinHeight,
                sourceNodeHeight;

            if(this.hasChildren) {
                // update position of blocks
                this._setupDirectionality();
                this._positionBlocks();
            } 

            // get min height before we reset it
            originalMinHeight = this.get("minHeight");

            // reset min height on source node
            domStyle.set(this.sourceItemNode, "minHeight", "");

            // NOTE: this assumes there's a width, but maybe not a height
            currentActionNodeHeight = Math.floor(domGeometry.position(this.actionsNodeControls, false).h);
            actionNodeHeight = currentActionNodeHeight > 0 ? currentActionNodeHeight : this.get("actionNodeHeight") || 0;
            sourceNodeHeight = Math.floor(domGeometry.position(this.sourceItemNode, false).h);

            // actionNode has not taken it's height yet, no need to resize anything, abort.
            if (actionNodeHeight === 0) {
                this._clearPosition();
                return result;
            }

            actionNodeHeight && (this.set("actionNodeHeight", actionNodeHeight));

            // set a min height
            domStyle.set(this.sourceItemNode, "minHeight", (sourceNodeHeight + actionNodeHeight) + "px");
            domStyle.set(this.actionsNodeControls, "marginTop", (sourceNodeHeight) + "px");

            // if we got here, return false, this is considered to be no resize of dom node
            if (originalMinHeight === sourceNodeHeight + actionNodeHeight) {
                return result;
            }

            // if we get here we consider it as a resizse
            return true;
        },

        refresh: function() {
            // summary:
            //      Recreate block overlay item for the current content area.
            // tag:
            //      public
            this._actionNodeHeight = null;

            // Destroy all the child blocks and clear the drag and drop items from the source.
            this.destroyDescendants();
            this._source.clearItems();
            if(this._source.anchor) {
                domConstruct.destroy(this._source.anchor);
            }

            // Destroy all the current blocks and reset the map.
            for(var i in this._watches) {
                this._watches[i].remove();
            }
            this._watches = {};

            this._supressValueChanged = true;

            // Update model to the latest value and recreate the blocks from the DOM.
            this.model.set("value", lang.clone(this.contentModel.get(this.name)));
            this._setupBlocks();

            this.inherited(arguments);

            this._supressValueChanged = false;
        },

        _setupDnd: function() {
            // summary:
            //      Overrides the default implementation creating a suitable source for the BlockArea
            // tags:
            //      private

            var settings = lang.mixin({
                _skipStartup: true,
                creator: lang.hitch(this, "_creator"),
                copyOnly: false,
                alwaysCopy: false,
                dropParent: this.containerNode,
                type: this.allowedDndTypes,
                accept: this.allowedDndTypes,
                singular: true,
                propertyName: this.name
            }, this.dndSourceSettings || {});
            
            this._source = new this.dndSourceClass(this.domNode, settings);

            this._source.defaultCheckAcceptance = this._source.checkAcceptance;
            this._source.checkAcceptance = lang.hitch(this, this._checkAcceptance),

            this.own(aspect.after(this._source, "onDropData", lang.hitch(this, "_onDrop"), true));
            this.own(aspect.before(this._source, "delItem", lang.hitch(this, "_onDndItemRemoved"), true));
        },

        _creator: function(item) {
            // summary:
            //      Customizes dnd item creation
            // tags:
            //      protected
            var node = domConstruct.create("div"),
                itemData;

            if(typeof item.getNormalizedData == "function") {
                itemData = item.getNormalizedData();
            }

            itemData = itemData ? itemData.data : item;

            return {
                node: node,
                type: this.allowedDndTypes,
                data: itemData
            };
        },

        _setupBlocks: function() {
            // Summary:
            //      Creates and positions the blocks.
            var blocks = this._getBlockNodes();

            array.forEach(blocks, this._createBlock, this);

            this.set("hasChildren", blocks.length > 0);
        },

        _createBlock: function(node, index) {
            // summary:
            //      Creates a single block.

            var id = domAttr.get(node, "data-epi-block-id"),
                info = json.parse(domAttr.get(node, "data-epi-block-personalization")),
                contentGroup = info ? info.contentGroup : this.defaultWatchKey,
                model = this.model;

            // Get the view model for the item's group.
            if(contentGroup) {
                model = model.getChild({ name: contentGroup });
            }

            // Get the view model for the item.
            var indexChild = model && model.getChildByIndex(index);
            if(!indexChild || indexChild.contentLink !== id) {
                // Happens when we're notified about model updates, but the markup hasn't 
                // been refreshed yet so the block info grabbed from dom doesn't match the model.
                // Should sort itself out once new markup arrives.
                return;
            }

            // TODO: Pass context menu through instead of provider.
            var block = new this.blockClass({
                disabled: this.disabled,
                viewModel: indexChild,
                sourceItemNode: node
            });

            this.addChild(block);
            
            this._watches["block_" + id + "_ensurePersonalization"] = indexChild.watch("ensurePersonalization", lang.hitch(this, function (propertyName, oldValue, newValue) {

                var index = array.indexOf(this._pendingPersonalizations, indexChild);

                if (newValue) {

                    // add if it doesn't exist
                    if (index < 0) {
                        this._pendingPersonalizations.push(indexChild);
                    }
                } else {
                    // remove if exists
                    if (index > 0) {
                        this._pendingPersonalizations.splice(index, 1);
                    }
                }

            }));

            // Mark the block's model as visible.
            indexChild.set("visible", true);

            // Add the block's node to the drag and drop souce.

            this._source.setItem(block.domNode.id, {
                name: indexChild.name,
                data: indexChild,
                type: this.allowedDndTypes
            });
        },

        _onChildrenChanged: function() {

            this.onValueChange({
                propertyName: this.name,
                value: this.model.get("value")
            });
        },

        _positionBlocks: function() {
            // Summary:
            //      Centralized position logic for all blocks within the
            //      area. It is done here since we need to nudge them a
            //      bit to cover the entire area even if the position method disagrees.
            var widgets = this.getChildren(),
                positions = [],
                position = this.get("position");

            array.forEach(widgets, function(widget, i) {

                var widgetPos, siblingPos, posDiff;

                if(!positions[i]) {
                    positions[i] = domGeometry.position(widget.sourceItemNode, false);
                }

                widgetPos = positions[i];
                widgetPos.x -= position.x;
                widgetPos.y -= position.y;

                widget.resize(widgetPos);

            }, this);

        },

        _checkAcceptance: function(source, nodes) {
            // summary:
            //      Customize checkAcceptance func
            // source: Object
            //      The source which provides items
            // nodes: Array
            //      The list of transferred items
            if(this.readOnly) {
                return false;
            }
            var widget = registry.getEnclosingWidget(nodes[0]);
            if(widget.isInstanceOf(ContentBlockEditor)) {
                return false;
            }

            return this._source.defaultCheckAcceptance(source, nodes);
        },

        _getBlockNodes: function() {

            var allBlockNodes = query("[data-epi-block-id]", this.sourceItemNode);
            var nestedBlockNodes = query("[data-epi-block-id] [data-epi-block-id]", this.sourceItemNode);

            return array.filter(allBlockNodes, function(node) {
                // return the blocks that are not nested
                return nestedBlockNodes.indexOf(node) === -1;
            });
        },

        _setupDirectionality: function() {
            // summary:
            //      Iterates over the sourceItemNodes children checking if any is floating.
            // tags:
            //      private
            var horizontal;

            if(/vertical|horizontal/.test(this.layout)) {
                horizontal = this.layout === "horizontal";
            } else {
                horizontal = array.some(this._getBlockNodes(), function(node) {
                    var style = domStyle.getComputedStyle(node),
                        floating = /left|right/.test(style.cssFloat),
                        inline = /inline|inline-block/.test(style.display);

                    return floating || inline;
                });
            }

            this._source.setHorizontal(horizontal);
        },

        executeAction: function (actionName) {
            // summary:
            //      Overidden mixin class, listen acion clicked on textWithLinks widget
            // actionName: [String]
            //      Action name of link on content area
            // tags:
            //      public

            if (actionName === "createnewblock") {

                // TODO: destroy and dereference command when done
                var command = new CreateContentFromSelector({
                    creatingTypeIdentifier: "episerver.core.blockdata",
                    createAsLocalAsset: true,
                    canChangeLocalAssetName: false,
                    treatAsSecondaryView: true
                });

                command.set("model", {
                    save: lang.hitch(this, function (block) {
                        var value = lang.clone(this.model.get("value"), true) || [];
                        value.push(block);

                        this.onValueChange({
                            propertyName: this._source.propertyName,
                            value: value
                        });
                    })
                });

                command.execute();

            } else {
                this.inherited(arguments);
            }
        },
        
        _onDrop: function(data, source, nodes, isCopy) {
            // summary:
            //      onDrop handler for the source
            // data:
            //      Data extracted from the dragged items.
            // source:
            //      The source that the drag event originated from.
            // nodes:
            //      The nodes being dragged.
            // isCopy:
            //      Flag indicating whether the drag is a copy. False indicates a move.
            // tags:
            //      protected
            var model = this.model,
                target = this._source;

            // If the drag source item and drag target item are the same node then return since
            // we don't want to move if the node is dropped on itself.
            if(target.anchor === target.targetAnchor) {
                return;
            }

            // Calculate the visual index of the target.
            var index = array.indexOf(target.getAllNodes(), target.targetAnchor) + (target.before ? -1 : 1),
                children = array.filter(model.getChildren(), function(child) {
                    return child.get("visible");
                });
            
            // Calculate the actual index in the model to move to.
            index = model.indexOf(children[index - 1]) + 1;
            
            // Normalize the data to an array.
            if(!lang.isArray(data)) {
                data = [data];
            }

            // If the drag and drop event originated from ourself and is a move, then
            // we need to remove the item before we add them again at the new index.
            if(target == source && !isCopy) {
                model.modify(function () {
                    array.forEach(data, function (item, i) {
                        var data = item.data;

                        // If the item is in a group then move the group instead.
                        if (data.contentGroup) {
                            data = model.getChild({ name: data.contentGroup });
                        }

                        model.move(data, index + i);
                    });
                });
            } else {
                model.modify(function () {
                    array.forEach(data, function (item, i) {
                        var block = new ContentBlockViewModel(item.data);
                        model.addChild(block, index + i);
                    });
                });
            }
        },

        _onDndItemRemoved: function(key) {
            // summary:
            //      Called when item are dragged out of the source and dropped in another target.
            // tags:
            //      protected

            // Normalize the data to an array.
            var data = this._source.getItem(key);

            if(!lang.isArray(data)) {
                data = [data];
            }

            // Remove each item from the model.
            this.model.modify(function () {
                array.forEach(data, function (item) {
                    this.model.removeChild(item.data);
                }, this);
            }, this);
        }
    });
});
},
'epi/shell/dnd/_MarkerSource':function(){
﻿define("epi/shell/dnd/_MarkerSource", [
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/dnd/Manager",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style"
    ],
    function (
        array,
        declare,
        Manager,
        domClass,
        domConstruct,
        domGeom,
        domStyle
        ) {

        return declare(null, {
            // summary:
            //    Use as a mixin with a dnd Source to enable an absolutely positioned marker 
            //    and extra css classes for the sibling nodes when hovering over a target item
            //    during drag and drop operations.

            _markerNode: null,

            // markerTemplateString: String
            //      The html template for the marker
            markerTemplateString: '<div class="dojoDndItem-marker"><div class="epi-dndDropMarker"></div></div>',

            // markerDelay: Number
            //      The amount of time in milliseconds to delay the switch between marker positions
            markerDelay: 150,

            // markOnlyAllowedDropLocations: Boolean
            //      If set to true only positions where a drop will occur is be highlighted  
            markOnlyAllowedDropLocations: false,

            _calculatedCurrent: false,

            destroy: function () {
                // summary:
                //		prepares the object to be garbage-collected
                this.inherited(arguments);

                this.targetAnchorSibling = null;
                if (this._markerNode) {
                    domConstruct.destroy(this._markerNode);
                    this._markerNode = null;
                }
            },

            setHorizontal: function (horizontal) {
                // summary:
                //		Changes the direction for drop markers
                // horizontal: Boolean
                //		true for horizontal direction, false for vertical
                
                domClass.toggle(this.node, "dojoDndHorizontal", horizontal);
                this.horizontal = horizontal;
            },

            onMouseOver: function (e) {
                // summary:
                //		event processor for onmouseover
                // e: Event
                //		mouse event

                this.inherited(arguments);
                this._calculatedCurrent = false;
            },

            onMouseMove: function (e) {
                // summary:
                //		event processor for onmousemove
                // e: Event
                //		mouse event

                if (this.isDragging && this.targetState == "Disabled") { return; }
                dojo.dnd.Source.superclass.onMouseMove.call(this, e);
                var m = Manager.manager();

                if (!this.isDragging) {
                    if (this.mouseDown && this.isSource &&
					(Math.abs(e.pageX - this._lastX) > this.delay || Math.abs(e.pageY - this._lastY) > this.delay)) {
                        var nodes = this.getSelectedNodes();
                        if (nodes.length) {
                            m.startDrag(this, nodes, this.copyState(dojo.isCopyKey(e), true));
                        }
                    }
                }

                if (this.isDragging) {
                    // calculate before/after
                    var before = false;

                    if (this.current && !this._calculatedCurrent) {
                        if (!this.targetBox || this.targetAnchor != this.current) {
                            this.targetBox = domGeom.position(this.current, true);
                        }
                        if (this.horizontal) {
                            before = (e.pageX - this.targetBox.x) < (this.targetBox.w / 2);
                        } else {
                            before = (e.pageY - this.targetBox.y) < (this.targetBox.h / 2);
                        }
                    } else {
                        before = this._calculateCurrent({ x: e.pageX, y: e.pageY });
                    }

                    if (this.current != this.targetAnchor || before != this.before) {
                        this._markTargetAnchor(before);
                        m.canDrop(!this.current || m.source != this || !this.markOnlyAllowedDropLocations || !(this.current.id in this.selection));
                    }
                }
            },

            _calculateCurrent: function (point) {
                // summary:
                //      Finds the closest dnd item in the collection and sets it to this.current.   
                //      Use to locate where to drop when not having a current item i.e not hovering over any.
                //
                //  point: Object {x: 0, y:0}
                //      The anchor point for the calculation. Most likely the current mouse position

                var points = [],
                    current,
                    minDistance;

                function calcDistance(startPoint, endPoint) {

                    function square(value) {
                        return value * value;
                    }

                    return Math.sqrt(square(startPoint.x - endPoint.x) + square(startPoint.y - endPoint.y));
                }

                this.getAllNodes().forEach(function (node) {

                    var pos = domGeom.position(node);
                    pos.x2 = pos.x + pos.w;
                    pos.xCentered = pos.x + pos.w / 2;
                    pos.y2 = pos.y + pos.h;
                    pos.yCentered = pos.y + pos.h / 2;

                    if (this.horizontal) {
                        // put measuring points in middle of left and right side 
                        points.push({ node: node, before: true, x: pos.x, y: pos.yCentered },
                                      { node: node, before: false, x: pos.x2, y: pos.yCentered });
                    } else {
                        // put measuring points in centered top and bottom
                        points.push({ node: node, before: true, x: pos.xCentered, y: pos.y },
                                      { node: node, before: false, x: pos.xCentered, y: pos.y2 });
                    }
                }, this);

                // Brute force distance check. Betting on few points to compare, and a simple
                // point to point calculation instead of checking the full segments for the closest point
                array.forEach(points, function (value) {
                    value.distance = calcDistance(point, value);

                    if (!current || value.distance < minDistance) {
                        current = value;
                        minDistance = value.distance;
                    }
                }, this);

                if (current) {
                    this.current = current.node;
                    this._calculatedCurrent = true;

                    return current.before;
                }

                return false;
            },

            _markTargetAnchor: function (before) {
                // summary:
                //		assigns a class to the current target anchor based on state
                //
                // state: Boolean
                //		insert before, if true, after otherwise

                var targetNotInSelection = true,
                    siblingNotInSelection = true;

                if (this.current === this.targetAnchor && this.before === before) {
                    return;
                }

                // Remove the previous set classes
                if (this.targetAnchor) {
                    this._removeItemClass(this.targetAnchor, this.before ? "Before" : "After");
                }
                if (this.targetAnchorSibling) {
                    this._removeItemClass(this.targetAnchorSibling, !this.before ? "Before" : "After");
                }

                this.targetAnchor = this.current;
                this.targetBox = null;
                this.before = before;

                // Add the new classes
                if (this.targetAnchor) {

                    this.targetAnchorSibling = before ? this.targetAnchor.previousSibling
                                                      : this.targetAnchor.nextSibling;

                    // Verify that the sibling is a node that we are interested in
                    if (!(this.targetAnchorSibling &&
                          this.targetAnchorSibling.nodeType === 1 &&
                          domClass.contains(this.targetAnchorSibling, "dojoDndItem"))) {

                        this.targetAnchorSibling = null;
                    }

                    if (this.markOnlyAllowedDropLocations) {
                        targetNotInSelection = !(this.targetAnchor.id in this.selection);
                        siblingNotInSelection = !this.targetAnchorSibling || !(this.targetAnchorSibling.id in this.selection);
                    }
                    if (targetNotInSelection && siblingNotInSelection) {
                        this._addItemClass(this.targetAnchor, this.before ? "Before" : "After");
                    }

                    if (this.targetAnchorSibling && targetNotInSelection && siblingNotInSelection) {
                        this._addItemClass(this.targetAnchorSibling, !this.before ? "Before" : "After");
                    }

                    this._positionMarker(targetNotInSelection && siblingNotInSelection);


                } else {
                    this._positionMarker(false);
                }
            },

            _unmarkTargetAnchor: function () {
                // summary:
                //		removes a class of the current target anchor based on state

                if (this.targetAnchor) {
                    this._removeItemClass(this.targetAnchor, this.before ? "Before" : "After");
                }
                if (this.targetAnchorSibling) {
                    this._removeItemClass(this.targetAnchorSibling, !this.before ? "Before" : "After");
                }

                this._positionMarker(false);

                this.targetAnchor = this.targetAnchorSibling = this.targetBox = null;
                this.before = true;
            },

            _positionMarker: function (enable) {

                var markerNode = this._markerNode,
                    anchorPos,
                    siblingAnchorPos,
                    boxPos,
                    style,
                    top,
                    left,
                    height,
                    gap = -1;

                if (enable) {

                    anchorPos = domGeom.position(this.targetAnchor, false);
                    siblingAnchorPos = this.targetAnchorSibling ? domGeom.position(this.targetAnchorSibling, false) : { h: 0, w: 0 };
                    boxPos = domGeom.position(this.node, false);

                    if (this.horizontal) {

                        if (this.before) {

                            left = anchorPos.x - boxPos.x;

                            // Check if we have a gap between siblings and in that case adjust for it
                            if (this.targetAnchorSibling) {
                                gap = (anchorPos.x - siblingAnchorPos.x - siblingAnchorPos.w) / 2;
                            }
                            if (gap >= 0) {
                                left -= gap;
                            }
                        } else {

                            left = anchorPos.x + anchorPos.w - boxPos.x;

                            // Check if we have a gap between siblings and in that case adjust for it
                            if (this.targetAnchorSibling) {
                                gap = (siblingAnchorPos.x - anchorPos.x - anchorPos.w) / 2;
                            }
                            if (gap >= 0) {
                                left += gap;
                            }
                        }

                        // if we have a sibling in adjacent location take the biggest width
                        // to avoid the markers size changing when moving between them
                        height = gap >= 0 ? Math.max(anchorPos.h, siblingAnchorPos.h) : anchorPos.h;

                        style = {
                            display: "block",
                            top: anchorPos.y - boxPos.y + "px",
                            left: left + "px",
                            height: height + "px"
                        };

                    } else {
                        if (this.before) {

                            top = anchorPos.y - boxPos.y;

                            // Check if we have a gap between siblings and in that case adjust for it
                            if (this.targetAnchorSibling) {
                                gap = (anchorPos.y - siblingAnchorPos.y - siblingAnchorPos.h) / 2;
                            }
                            if (gap >= 0) {
                                top -= gap;
                            }
                        } else {

                            top = anchorPos.y + anchorPos.h - boxPos.y;

                            // Check if we have a gap between siblings and in that case adjust for it
                            if (this.targetAnchorSibling) {
                                gap = (siblingAnchorPos.x - anchorPos.x - anchorPos.w) / 2;
                            }
                            if (gap >= 0) {
                                top -= gap;
                            }
                        }

                        // if we have a sibling in adjacent location take the biggest width
                        // to avoid the markers size changing when moving between them
                        width = gap >= 0 ? Math.max(anchorPos.w, siblingAnchorPos.w) : anchorPos.w;

                        style = {
                            display: "block",
                            top: top + "px",
                            width: width + "px"
                        };
                    }

                } else {
                    style = {
                        display: "none"
                    };
                }

                if (!markerNode) {
                    markerNode = this._markerNode = domConstruct.place(this.markerTemplateString, this.node);
                    domStyle.set(markerNode, style);
                } else {
                    setTimeout(function () { domStyle.set(markerNode, style); }, this.markerDelay);
                }
            }
        });
    });
},
'epi-cms/contentediting/editors/ContentBlockEditor':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/event",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/html",
    "dojo/NodeList-dom",
    "dojo/query",

//Dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/popup",

// Dojox
    "dojox/html/ellipsis",

// EPi Framework
    "epi/shell/widget/_ModelBindingMixin",

// EPi CMS
    "epi-cms/contentediting/editors/ContentBlockEditorViewModel",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.blockcontextmenu",

    "dojo/text!./templates/ContentBlockEditor.html",

    "dojo/NodeList-manipulate"

],
    function (

    // Dojo
    declare,
    Deferred,
    event,
    domAttr,
    domClass,
    domStyle,
    html,
    NodeList,
    query,

    // Dijit
    _Widget,
    _TemplatedMixin,
    pm,

    // Dojox
    ellipsis,

    // EPi Framework
    _ModelBindingMixin,

    //EPi
    ContentBlockEditorViewModel,

    //Resources
    res,

    template
    ) {

        return declare([_Widget, _TemplatedMixin, _ModelBindingMixin], {
            // summary:
            //      The editor for an content.

            // templateString: String
            //      UI template for content editor
            templateString: template,

            // model: Object
            //      Content block editor view model
            model: null,

            contextMenu: null,

            isDraggable: true,

            modelBindingMap: {
                "contentLink": ["contentLink"],
                "name": ["name"],
                "contentGroup": ["contentGroup"],
                "roleIdentities": ["roleIdentities"],
                "selected": ["selected"]
            },

            _setSelectedAttr: function (isSelected) {
                this.inherited(arguments);

                domClass.toggle(this.itemNode, "epi-content-block-editor-node-selected", isSelected);
                domStyle.set(this.iconNodeMenu, "visibility", isSelected ? "visible" : "hidden");
            },

            _setNameAttr: function (value) {
                this.inherited(arguments);

                query(this.labelNode).text(value);
                domAttr.set(this.iconNodeMenu, "title", res.settingstooltip);
            },

            postMixInProperties: function () {
                this.inherited(arguments);
                this.model = this.model || new ContentBlockEditorViewModel(this.modelData);
            },

            _setIsDraggableAttr: function(isDraggable) {
                this._set("isDraggable", isDraggable);

                if(this.isDraggable) {
                    domClass.add(this.domNode, "dojoDndItem");
                }
                else{
                    domClass.remove(this.domNode, "dojoDndItem");
                }
            },

            _onClick: function (evt) {
                event.stop(evt);
                this.contextMenu && pm.close(this.contextMenu);

                this.model.set("selected", !this.model.selected);
            },

            _onContextMenu: function (evt) {
                // summary:
                //      Handler onclick event on iconNodeMenu to show context menu manually.
                // tags:
                //      Private

                event.stop(evt);
                this.contextMenu && this.contextMenu.scheduleOpen(evt.target, null, { x: evt.pageX, y: evt.pageY });
            }
        });
    });

},
'epi-cms/contentediting/editors/ContentBlockEditorViewModel':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",

// EPi
    "epi-cms/widget/viewmodel/ContentStatusViewModel"
],
    function (

    // Dojo
    declare,
    lang,
    Stateful,

    // EPi
    ContentStatusViewModel

    ) {

        return declare([Stateful, ContentStatusViewModel], {

            contentLink: "",
            contentGroup: "",
            roleIdentities: null,

            selected: false,
            name: "",
            index: 0,

            getValue: function () {
                return {
                    contentLink: this.contentLink,
                    name: this.name,
                    contentGroup: this.contentGroup,
                    roleIdentities: this.roleIdentities
                };
            }
        });
    });
},
'url:epi-cms/contentediting/editors/templates/ContentBlockEditor.html':"﻿<div class=\"epi-content-block-editor\">\r\n    <a href=\"#\" data-dojo-attach-point=\"itemNode\" style=\"display: block;\" data-dojo-attach-event=\"onclick:_onClick\">\r\n        <span data-dojo-attach-point=\"contentNode\" class=\"epi-content-block-node\">\r\n            <span data-dojo-attach-point=\"labelNode\" class=\"dojoxEllipsis\"></span>\r\n            <span data-dojo-attach-point=\"extraIconsContainer\" class=\"epi-floatRight\">\r\n                <span data-dojo-attach-point=\"iconNodeMenu\" class=\"epi-iconContextMenu\" style=\"visibility: hidden;\" data-dojo-attach-event=\"onclick:_onContextMenu\"></span>\r\n            </span>\r\n        </span>\r\n    </a>\r\n</div>",
'url:epi-cms/widget/templates/ContentArea.html':"﻿<div class=\"epi-overlay-blockarea\">\r\n\t<div class=\"epi-overlay-item-container\">\r\n\t\t<div class=\"epi-overlay-bracket\"></div>\r\n\t</div>\r\n\t<div data-dojo-attach-point=\"containerNode\" class=\"epi-overlay-blockarea-container\"></div>\r\n\t<div data-dojo-attach-point=\"actionsNode\" class=\"epi-overlay-blockarea-actionscontainer\">\r\n\t\t<div data-dojo-attach-point=\"actionsNodeControls\" class=\"epi-overlay-blockarea-actions\"></div>\r\n\t</div>\r\n</div>",
'epi-cms/widget/overlay/ItemCollection':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

// EPi CMS
    "epi-cms/contentediting/viewmodel/ItemCollectionViewModel",                         // the injected model class
    "epi-cms/widget/overlay/Property",                                                  // mixin into me

// EPi Framework
    "epi/string"                                                                        // used to convert namespace from "." to "/"

], function (
// Dojo
    declare,
    lang,

// EPi CMS
    ItemCollectionViewModel,
    Property,

// EPi Framework
    epiString
) {
    return declare([Property], {
        // summary:
        //      The new overlay item for property link collection.
        // module:
        //      "epi-cms/widget/overlay/ItemCollection"
        // description:
        //      Drag and drop page/media to create new link (at the bottom)
        // tags:
        //    public

        // modelType: [public] String
        //      Used to inject model for this.
        modelType: "epi-cms/contentediting/viewmodel/ItemCollectionViewModel",

        // model: [public] Object
        //      Instance of modelClass
        model: null,

        postMixInProperties: function () {
            // summary:
            //      Create the view model if it doesn't exist.
            // tags:
            //      protected

            this.inherited(arguments);

            this._setupAllowedTypes();
            this._setupModel(this.contentModel.get(this.name));
            
            this.own(this.contentModel.watch(this.name, lang.hitch(this, function(name, oldValue, newValue) {
                this.model.set("data", newValue);
            })));
        },

        onDrop: function (target, value) {
            // summary:
            //      Handles onDrop and add new value to model then raise onValueChange event to save this.
            // target: [Object]
            //      The dnd target.
            // value: [Object || Array]
            //      The dnd data.
            // tags:
            //      private

            // Add new value to model at the bottom
            this.model.addTo(value, null, false);
        },

        _setupModel: function (/*Object*/data) {
            // summary:
            //      setup the viewmodel with latest value
            // tag:
            //      public

            var modelType = epiString.slashName(this.modelType);
            
            require([modelType], lang.hitch(this, function (modelClass) {
                
                this.model = new modelClass(data, this.modelParams);
                
                this.own(
                    // Handle model value changed
                    this.model.on("changed", lang.hitch(this, function (result) {
                        // Raise event to save this
                        this.onValueChange({
                            propertyName: this.name,
                            value: this.model.get("value")
                        });
                    }))
                );
            }));
        },
        
        _setupAllowedTypes: function() {
            // summary:
            //      Setup the allowed types for drag and drop
            // tags:
            //      Protected

            var converterKey = this.modelParams.itemConverterKey,
                customTypeIdentifier = this.modelParams.customTypeIdentifier;

            this.allowedDndTypes = this.allowedDndTypes || [];
            
            if (converterKey) {
                this.allowedDndTypes = this.allowedDndTypes.map(function (type) {
                    return type + "." + converterKey;
                });
            }
            
            if (customTypeIdentifier) {
                this.allowedDndTypes.unshift(customTypeIdentifier);
            }
        }

    });
});

},
'epi-cms/widget/ReadOnlyDateTimeEditor':function(){
﻿define([
    "dojo/_base/declare",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "epi/datetime",
    "dojo/text!./templates/ReadOnlyDateTimeEditor.html"
], function (
    declare,
    _Widget,
    _TemplatedMixin,
    epiDate,
    template
) {
    return declare([_Widget, _TemplatedMixin], {
        
        templateString: template,
        value: null,

        _setValueAttr: function (value) {
            this._set("value", value);
            if (value) {
                this.valueNode.innerHTML = epiDate.toUserFriendlyHtml(value);
            }
        }
    });
});
},
'url:epi-cms/widget/templates/ReadOnlyDateTimeEditor.html':"﻿<div class=\"dijit dijitReset dijitInline dijitLeft\" data-dojo-attach-point=\"valueNode\"></div>",
'epi-cms/widget/UrlContentSelector':function(){
﻿define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",

    "dojo/when",

// EPi Framework
    "epi/Url",

// EPi CMS
    "epi-cms/core/ContentReference",
    "epi-cms/core/PermanentLinkHelper",
    "epi-cms/widget/ContentSelector"
], function (
// Dojo
    declare,
    Deferred,
    lang,

    when,

// EPi Framework
    Url,

// EPi CMS
    ContentReference,
    PermanentLinkHelper,
    ContentSelector) {

    return declare([ContentSelector], {
        // _contentData: Object
        //      Content data which is related to the url value.
        _contentData: null,

        // Flag to indicate whether the value has been initilized or not. 
        // _setValue will not trigger onChange if this property evaluated to false
        _isValueInitilized: false,

        _setValueAndFireOnChange: function (value) {
            //summary:
            //    Sets the value and trigger onChange only if the value has been initilized and not the same value.
            // tags:
            //    private

            var isModified;

            if (!value) {
                this._updateDisplayNode(null);
                isModified = this.value !== value;
                this.value = value;
                this._contentData = null;

                if (isModified && this._isValueInitilized) {
                    this.onChange(value);
                }

                this._started && this.validate();
                this._isValueInitilized = true;

                return;
            }

            when(this._getContentByPermanentLink(value), lang.hitch(this, function (content) {

                this._updateDisplayNode(content);

                // We need to recreate the internal format before saving the data.
                var urlFormatValue = PermanentLinkHelper.toPermanentLink(content);
                this._started && this.validate();

                isModified = !epi.areEqual(this.value, urlFormatValue);
                this.value = urlFormatValue;

                if (this._isValueInitilized && isModified) {
                    this.onChange(urlFormatValue);
                }

                this._isValueInitilized = true;

            }));
        },

        _convertValueToContentReference: function (value) {
            // summary:
            //      Creates a ContentReference from the internal value.
            // tags:
            //      private

            if (this._contentData) {
                return new ContentReference(this._contentData.contentLink);
            }

            return null;
        },

        _getContentByPermanentLink: function (/*String*/value) {
            // summary:
            //      Get content which is related to the permanent link value.
            // tags:
            //      private

            if (epi.areEqual(this.value, value) && this._contentData) {
                return this._contentData;
            }

            return when(PermanentLinkHelper.getContent(value, { "allLanguages": true }), lang.hitch(this, function (content) {
                this._contentData = content;
                return content;
            }));
        }
    });
});
},
'epi-cms/widget/UrlSelector':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/when",
     "dojo/aspect",

// EPi Framework
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/widget/dialog/Dialog",
// EPi CMS
    "epi-cms/widget/LinkEditor",
    "epi-cms/widget/_SelectorBase",
    "epi-cms/core/PermanentLinkHelper",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.editlink"
],
function (
// dojo
    declare,
    lang,
    domClass,
    domStyle,
    when,
    aspect,

// EPi Framework
    _ModelBindingMixin,
     Dialog,
// EPi CMS
    LinkEditor,
    _SelectorBase,
    PermanentLinkHelper,
    res
    ) {

    return declare([_SelectorBase, _ModelBindingMixin], {
        // module:
        //		epi-cms/widget/UrlSelector
        // summary:
        //    Represents the widget to edit PropertyURL.
        // tags:
        //    public

        resource: res,

        // LinkHelper to retrieve the link info
        linkHelper: PermanentLinkHelper,

        postMixInProperties: function () {
            this.inherited(arguments);

            if (!this.model && this.modelClassName) {
                var modelClass = declare(this.modelClassName);
                this.model = new modelClass();
            }
        },

        onChange: function (value) {
            // summary:
            //		Callback method for updating the editor wrapper.
            // tags:
            //		callback
        },

        isValid: function () {
            // summary:
            //    Check if widget's value is valid.
            // tags:
            //    protected

            return (!this.required || (!this.get("isEmpty"))); // Not required or have some value.
        },

        _onDialogShow: function () {
            //summary:
            //    Handle onShow dialog event.
            // tags:
            //    protected

            this.inherited(arguments);

            // we set the value to LinkEditor with obj.href format
            this.dialogContent.set("value", { href: this.get("value") });

        },

        _onDialogExecute: function () {
            //summary:
            //    Handle dialog close through executing OK, Cancel, Delete commands
            // tags:
            //    protected

            // we need to get value back from LinkEditor
            var linkObj = this.dialogContent.get('value');

            // we're only interested in link
            this.set('value', linkObj.href);
        },

        _getDialog: function () {
            // summary:
            //		Create Link Editor dialog
            // tags:
            //    protected

            this.dialogContent = new LinkEditor({
                modelType: this.metadata.additionalValues["modelType"],
                hiddenFields: ["text", "title", "target"]
            });

            this.own(this.dialogContent);

            return new Dialog({
                title: this._getTitle(),
                dialogClass: "epi-dialog-portrait",
                content: this.dialogContent,
                destroyOnHide: false,
                defaultActionsVisible: false
            });

        },

        _updateDisplayNode: function (value) {
            //summary:
            //    Update widget's display text
            // tags:
            //    protected

            if (value) {
                domClass.remove(this.domNode, 'epi-noValue');
                domClass.remove(this.resourceName, 'dijitPlaceHolder');

                this.set("selectedContentName", value.name);
            } else {
                domClass.add(this.domNode, 'epi-noValue');
                domClass.add(this.resourceName, 'dijitPlaceHolder');

                this.set("selectedContentName", "");
            }
        },

        _setValueAttr: function (/* String*/ value) {
            //summary:
            //    Value's setter.
            //
            // value: [String]
            //    A string as link value
            //    Value to be set.
            //
            // tags:
            //  protected

            if (!value) {
                this.set("isEmpty", true);

                this._setValueAndFireOnChange(null);
                return;
            }

            this.set("isEmpty", false);
            this._setValueAndFireOnChange(value);
        },

        _setValueAndFireOnChange: function (/* String */ value) {
            //summary:
            //    Sets the value internally and fires onChange if the value differes than the current value
            //
            // value: [String]
            //    A string as link value
            //    Value to be set.
            //
            // tags:
            //  private

            var currentLink = this.get("value");
            this._set("value", value);

            // detect whether to invoke onChange or not
            var trigerOnChange = true;

            if (!currentLink && !value) {
                trigerOnChange = false;
            } else if (value && value === currentLink) {
                trigerOnChange = false;
            }

            if (trigerOnChange) {
                this.onChange(value);
            }

            // update the displayNode with link name
            if (value) {
                this._getLinkName(value, lang.hitch(this, this._updateDisplayNode));
            } else {
                this._updateDisplayNode(null);
            }

        },

        _getLinkName: function (/* String */ value, /* Function */ callback) {
            // summary:
            //      Retrieves the name of given link value. If name not found then returns back the same provided value
            //
            // value: [String]
            //    A string as link value
            //
            // callback: [String]
            //    Callback function
            // tags:
            //      private

            when(this.linkHelper.getContent(value, { "allLanguages": true }), lang.hitch(this, function (content) {
                var result = { name: content ? content.name : value };
                callback(result);
            }));
        },

        _getTitle: function () {
            // summary:
            //      Customize base get method for title prop.
            // tags:
            //      protected 

            return lang.replace(this.value ? this.resource.title.template.edit : this.resource.title.template.create, this.resource.title.action);
        }
    });
});
},
'epi-cms/widget/_SelectorBase':function(){
﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

    "dojo/aspect",
    "dojo/Deferred",
    "dojo/dom-class",
    "dojo/dom-style",

    "dojo/query",
    "dojo/when",

// dijit,
    "dijit/_CssStateMixin",
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",

// epi.shell
    "epi/dependency",
    "epi/i18n",
    "epi/shell/widget/_ValueRequiredMixin",

// epi.cms
    "epi-cms/widget/_Droppable",
    "epi-cms/widget/_HasClearButton",
    "epi-cms/widget/_HasChildDialogMixin",

// resources
    "dojo/text!./templates/_SelectorBase.html"
],

function (
// dojo
    declare,
    lang,

    aspect,
    Deferred,
    domClass,
    domStyle,

    query,
    when,

// dijit
    _CssStateMixin,
    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,

// epi.shell
    dependency,
    i18n,
    _ValueRequiredMixin,

// epi.cms
    _Droppable,
    _HasClearButton,
    _HasChildDialogMixin,

// resources
    template
) {
    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _CssStateMixin, _HasClearButton, _HasChildDialogMixin, _Droppable, _ValueRequiredMixin], {
        // module:
        //		epi-cms/widget/_SelectorBase
        // summary:
        //    Represents base class for item selector widget (a textbox and a browse button).
        // tags:
        //    public

        templateString: template,

        roots: null,

        value: null,

        // required: Boolean
        //		User is required to enter data into this field.
        required: false,

        // missingMessage: [public] String
        //    Message which is displayed when required is true and value is empty.
        missingMessage: '',

        // tooltipPosition: String[]
        //		See description of `dijit.Tooltip.defaultPosition` for details on this parameter.
        tooltipPosition: [],

        // canSelectOwnerContent: [public] Boolean
        //      Indicates whether the owner content that is being edited can be selected
        canSelectOwnerContent: false,

        contentRepositoryDescriptors: null,

        allowedDndTypes: [],

        _setSelectedContentNameAttr: function (value) {
            query(this.selectedContentNameNode).text(value);
        },

        _setSelectedContentLinkAttr: { node: "selectedContentLinkNode", type: "innerHTML" },

        postCreate: function () {
            // summary:
            //      Post create initialization.
            // description:
            //      Setup related components.
            // tags:
            //      protected

            this.inherited(arguments);

            // After dnd into widget
            this.own(aspect.after(this, "onDrop", lang.hitch(this, this.focus)));
        },

        postMixInProperties: function () {
            // summary:
            //		Initialize properties
            // tags:
            //    protected

            this.inherited(arguments);

            if (!this.contentRepositoryDescriptors) {
                this.contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors");
            }

            if (!this.roots && this.repositoryKey) {
                var settings = this.contentRepositoryDescriptors[this.repositoryKey];
                this.roots = settings.roots;
            }
        },

        _setReadOnlyAttr: function (value) {
            this._set("readOnly", value);

            domStyle.set(this.button.domNode, "display", value ? "none" : "");
            domStyle.set(this.clearButton, "display", value ? "none" : "");
            domClass.toggle(this.domNode, "dijitReadOnly", value);
        },

        _setValueAttr: function (value) {
            //summary:
            //    Value's setter.
            //
            // value: String
            //    Value to be set.
            //
            // tags:
            //    protected

            this.value = value;
        },

        _getDialog: function () {
            // summary:
            //		Create page tree dialog. Need override
            // tags:
            //    protected
        },

        _onButtonClick: function () {
            //summary:
            //    Handle pick button click. Need override
            // tags:
            //    protected

            if (!this.dialog) {
                this.dialog = this._getDialog();
                this.dialog.startup();

                this.own(aspect.after(this.dialog, 'onExecute', lang.hitch(this, this._onDialogExecute)));
                this.own(aspect.after(this.dialog, 'onShow', lang.hitch(this, this._onDialogShow)));
                this.own(aspect.after(this.dialog, 'onHide', lang.hitch(this, this._onDialogHide)));
                this.own(this.dialog);
            }

            this.dialog.show();
        },

        _onDialogShow: function () {
            //summary:
            //    Handle onShow dialog event.
            // tags:
            //    protected

            this.isShowingChildDialog = true;
        },

        _onDialogExecute: function () {
            //summary:
            //    Handle dialog close. Need override
            // tags:
            //    protected
        },

        _onDialogHide: function () {
            //summary:
            //    Handle dialog hide. Need override
            // tags:
            //    protected

            this.isShowingChildDialog = false;
        },

        _getValueAttr: function () {
            //summary:
            //    Value's getter
            // tags:
            //    protected

            return this.value;
        },

        _onBlur: function () {
            // summary:
            //		This is where widgets do processing for when they stop being active,
            //		such as changing CSS classes.  See onBlur() for more details.
            // tags:
            //		protected

            this.inherited(arguments);

            this.validate();
        },

        focus: function () {
            this.button.focus();
        },

        onChange: function (value) {
            // summary:
            //    Fired when value is changed.
            //
            // value:
            //    The value
            // tags:
            //    public, callback
        },

        _updateDisplayNode: function (content) {
            //summary:
            //    Update widget's display text. Need override
            // tags:
            //    protected
        },

        _setDialogButtonState: function (contentLink) {
            // summary:
            //    Set state of dialog button.
            //
            // tags:
            //    protected
        }
    });
});
},
'url:epi-cms/widget/templates/_SelectorBase.html':"﻿<div data-dojo-attach-point=\"inputContainer\" class=\"dijitReset dijitInputField dijitInputContainer dijitInline epi-resourceInputContainer\" id=\"widget_${id}\">\r\n    <div data-dojo-attach-point=\"displayNode, dropAreaNode, stateNode\" class=\"dijit dijitReset dijitInline dijitInlineTable dijitLeft dijitTextBox displayNode\">\r\n        <div class=\"dijitReset dijitLeft dijitInputField dijitInputContainer\">\r\n            <div data-dojo-attach-point=\"clearButton\" class=\"epi-clearButton\">&nbsp;</div>\r\n            <div data-dojo-attach-point=\"resourceName\" class=\"dijitInline epi-resourceName dojoxEllipsis\"/>\r\n                <span data-dojo-attach-point=\"selectedContentNameNode\"></span> <span data-dojo-attach-point=\"selectedContentLinkNode\"></span>\r\n            </div>\r\n        </div>\r\n    </div>\r\n    <div data-dojo-type=\"dijit/form/Button\" data-dojo-attach-event=\"onClick: _onButtonClick\" data-dojo-attach-point=\"button\" data-dojo-props=\"label:'...'\"></div>\r\n</div>",
'epi-cms/widget/XFormEditor':function(){
﻿define([

// Dojo
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/_base/Deferred",
    "dojo/when",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/query",
    "dojo/html",

// Dijit
    "dijit/focus",
    "dijit/form/Button",

// EPi Framework
    "epi/shell/widget/dialog/Dialog",
    "epi/dependency",

// EPi CMS
    "epi-cms/legacy/LegacyFormEditor",
    "epi-cms/_ContentContextMixin",
    "epi-cms/legacy/LegacyDialogPopup",
    "epi/routes",
    "epi-cms/widget/XFormPropertyWidget",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.legacy.legacyformeditor",
    "epi/i18n!epi/cms/nls/episerver.cms.widget.xformeditor"

], function (

// Dojo
    declare,
    event,
    lang,
    Deferred,
    when,
    domClass,
    domStyle,
    domConstruct,
    query,
    html,

// Dijit
    focusManager,
    Button,

// EPi Framework
    Dialog,
    dependency,

// EPi CMS
    LegacyFormEditor,
    _ContentContextMixin,
    LegacyDialogPopup,
    routes,
    XFormPropertyWidget,

// Resources
    res,
    xformRes

) {
    return declare([LegacyFormEditor, _ContentContextMixin], {

        // localization: Object
        //      Mixin resource for LegacyFormEditor and XFormEditor
        localization: lang.mixin(res, xformRes),

        // destroyOnHide: Boolean
        //      Inherited doc
        destroyOnHide: true,

        // editorWidgetClass: Object
        //      Injected editor class
        editorWidgetClass: XFormPropertyWidget,

        // store: [Object]
        //      Represents the REST store to get data.
        store: null,

        // stopEditOnBlur: [private] Boolean
        //      Flag to indicates that should be save data when fire event onBlur.
        stopEditOnBlur: true,

        // templateString: [protected] String
        //    Template for the widget.
        templateString: '\
            <div class="dijit dijitReset dijitInline dijitLeft epi-xFormEditor">\
                <div data-dojo-attach-point="output" data-dojo-type="dijit/form/TextBox" value="${localization.helptext}"></div>\
                <div data-dojo-type="dijit/form/Button" data-dojo-attach-point="openButton" data-dojo-attach-event="onClick: openEditor" data-dojo-props="label:\'${localization.buttonlabel}\'"></div>\
                <a href="#" data-dojo-attach-point="viewDataLink" data-dojo-attach-event="click: _openViewDataDialog" title="${localization.viewdata.tooltip}" class="disabled">${localization.viewdata.text}</a>\
            </div>',

        postMixInProperties: function () {
            this.inherited(arguments);

            var registry = dependency.resolve("epi.storeregistry");
            this.store = this.store || registry.get("epi.cms.xform");
        },

        openEditor: function () {
            // summary
            //      Overwrite base method to start editing 
            // tag
            //      public

            this.inherited(arguments);

            this.onFocus();
        },

        _createDialog: function () {
            // summary:
            //      Create editor dialog on first init
            // tags:
            //      Private

            if (this.contentLink) {
                lang.mixin(this.params, { "contentLink": this.contentLink });
            } else {
                when(this.getCurrentContext(), lang.hitch(this, function (context) {
                    lang.mixin(this.params, { "contentLink": context.id });
                }));
            }

            this.inherited(arguments);
        },

        _openViewDataDialog: function (evt) {
            // summary:
            //      Handle click event on view data link
            // evt: Object event
            //      On click event
            // tags:
            //      Private

            event.stop(evt);

            if (domClass.contains(this.viewDataLink, "disabled")) {
                return;
            }

            this._showFormDataDialog("Edit/XFormViewData.aspx", this.contentLink, this.value);
        },

        _onCancel: function () {
            // summary
            //      Overwrite event when dialog close
            // tags
            //      private
            this.inherited(arguments);

            // Always check form existed or not
            this.setDisplayValue(this.value);
        },

        _onDialogCancel: function () {
            // summary
            //      Overwrite event when dialog close
            // tags
            //      private
            this.inherited(arguments);

            // Always check form existed or not
            this.setDisplayValue(this.value);
        },

        _showFormDataDialog: function (path, contentLink, formId) {
            // summary
            //      Create new instance legacy dialog
            // tags
            //      private
            var route = routes.getActionPath({
                id: contentLink,
                path: path,
                moduleArea: "LegacyCMS",
                IsInLegacyWrapper: true,
                formid: formId
            }),
                dialog = new LegacyDialogPopup({
                    url: route,
                    dialogArguments: window.document,
                    showCancelButton: true,
                    features: { width: 750, height: 300 },
                    autoFit: true,
                    showLoadingOverlay: false
                });

            this.connect(dialog, "onLoad", function (loadedDocument) {

                if (!loadedDocument) {
                    return;
                }

                // The forms title indicator
                var h1 = query('h1[class="EP-prefix"]', loadedDocument.containerIframe.contentDocument.body);
                domConstruct.create("span", { innerHTML: this.localization.viewdata.forms + " >" }, h1.parent()[0], "first");

                // Hide drop down control, the select form
                var selectForm = query('select[id$="SelectForm"]', loadedDocument.containerIframe.contentDocument.body);
                if (selectForm) {
                    domStyle.set(selectForm.parent()[0], "display", "none");
                }

                // Hide checkbox control, show from all pages
                var showAllPages = query('input[type="checkbox"][id$="ShowResultFromAllPages"]', loadedDocument.containerIframe.contentDocument.body);
                if (showAllPages) {
                    domStyle.set(showAllPages.parent()[0], "display", "none");
                }
            });
            dialog.show();
        },

        setDisplayValue: function (value) {
            // summary:
            //  Update UI, include:
            //      + Set input value
            //      + Update view data link (display/hidden)
            // value: String
            //      New form id (GUID) or empty string
            // tags:
            //      Public


            // Set value to input box
            if (!value) {
                this.output.set("value", this.localization.helptext);
                // Hide view data link
                domClass.add(this.viewDataLink, "disabled");
                return;
            }

            Deferred.when(this.store.query({ id: value }), lang.hitch(this, function (formData) {

                if (formData && formData.name) {
                    this.output.set("value", formData.name);
                    // Show view data link
                    this.contentLink && domClass.remove(this.viewDataLink, "disabled");
                } else {
                    this.set("value", null);
                }

                this.onBlur();
            }));
        }
    });
});

},
'epi-cms/widget/XFormPropertyWidget':function(){
﻿define([

// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",

// EPi Framework
    "epi/epi",
    "epi/routes",

// EPi CMS
    "epi-cms/legacy/LegacyDialogWrapper",
    "epi-cms/core/ContentReference",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.xformeditor"

], function (

// Dojo
    declare,
    lang,

// EPi Framework
    epi,
    routes,

// EPi CMS
    LegacyDialogWrapper,
    ContentReference,

// Resources
    res

) {
    return declare([LegacyDialogWrapper], {
        // summary:
        //	   Webform editor for a CMS property. 
        //     Extend the epi.cms.legacy.LegacyDialogWrapper to be a value widget, specific for EditProperty dialog

        // title: String
        //      Title of the slect form dialog 
        title: res.selectform,

        onChange: function (newValue) {
            // summary:
            //    Triggered when the value is changed
            //
            // newValue: Object
            //    The newly changed value
            //
            // tags:
            //    public callback
        },

        postMixInProperties: function () {
            // summary:
            //	   Initialize epi.cms.legacy.LegacyDialogWrapper's parameters to be specific to XFormProperty dialog.

            this.features = lang.mixin({ width: 800, height: 400 }, this.editorFeatures); // initial size

            this.autoFit = true;

            this.connect(this, "onCallback", "_onCallback");

            this.inherited(arguments);
        },

        startup: function () {
            // summary: 
            //      Overridden to set the url based on the current page context

            this.inherited(arguments);

            this.set("url", this._buildIframeUrl());
        },

        onCancel: function () {
            // summary:
            //      Event is raised when user cancel editor
            // tags:
            //      Public callback
        },

        _buildIframeUrl: function () {
            // summary:
            //      Utilities function to build Url for iframe
            // tags:
            //      Private

            var routeParams = {
                moduleArea: "LegacyCMS",
                path: "edit/XFormSelect.aspx",
                epslanguage: this.contentLanguage,
                propertyname: this.fullName
            };

            lang.mixin(routeParams, {
                "pageId": new ContentReference(this.contentLink).createVersionUnspecificReference().id,
                "form": this.value ? this.value : ""
            });

            return routes.getActionPath(routeParams);
        },

        _onCallback: function (result) {
            // summary:
            //      Handle response event on web form view
            // result: Object
            //      Return data from web form view, it will:
            //          + Null if user chose <no form> action
            //          + Empty if user chose <cancel> action
            // tags:
            //      Private

            var newValue = result ? result.id : null;

            // Fire onchange if user change value only
            if (!epi.areEqual(this.value, newValue) && result !== null) {
                this.value = newValue;
                this.onChange(newValue);
            }
            else {
                this.onCancel();
            }
        }
    });
});

},
'*now':function(r){r(['dojo/i18n!*preload*epi-cms/nls/widgets*["ar","ca","cs","da","de","el","en-gb","en-us","es-es","fi-fi","fr-fr","he-il","hu","it-it","ja-jp","ko-kr","nl-nl","nb","pl","pt-br","pt-pt","ru","sk","sl","sv","th","tr","zh-tw","zh-cn","ROOT"]']);}
}});
﻿/* Dummy file to trick the AMD loader when running debug mode */